#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 10
#define STATE_COUNT 2952
#define SYMBOL_COUNT 298
#define ALIAS_COUNT 8
#define TOKEN_COUNT 140
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 35
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_type = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_if = 19,
  anon_sym_else = 20,
  anon_sym_switch = 21,
  anon_sym_for = 22,
  anon_sym_LPAREN = 23,
  anon_sym_RPAREN = 24,
  anon_sym_await = 25,
  anon_sym_in = 26,
  anon_sym_of = 27,
  anon_sym_while = 28,
  anon_sym_do = 29,
  anon_sym_try = 30,
  anon_sym_with = 31,
  anon_sym_break = 32,
  anon_sym_continue = 33,
  anon_sym_debugger = 34,
  anon_sym_return = 35,
  anon_sym_throw = 36,
  anon_sym_SEMI = 37,
  anon_sym_COLON = 38,
  anon_sym_case = 39,
  anon_sym_catch = 40,
  anon_sym_finally = 41,
  anon_sym_yield = 42,
  anon_sym_LBRACK = 43,
  anon_sym_RBRACK = 44,
  anon_sym_LT = 45,
  anon_sym_GT = 46,
  anon_sym_SLASH = 47,
  anon_sym_DOT = 48,
  anon_sym_class = 49,
  anon_sym_async = 50,
  anon_sym_function = 51,
  anon_sym_EQ_GT = 52,
  anon_sym_new = 53,
  anon_sym_PLUS_EQ = 54,
  anon_sym_DASH_EQ = 55,
  anon_sym_STAR_EQ = 56,
  anon_sym_SLASH_EQ = 57,
  anon_sym_PERCENT_EQ = 58,
  anon_sym_CARET_EQ = 59,
  anon_sym_AMP_EQ = 60,
  anon_sym_PIPE_EQ = 61,
  anon_sym_GT_GT_EQ = 62,
  anon_sym_GT_GT_GT_EQ = 63,
  anon_sym_LT_LT_EQ = 64,
  anon_sym_STAR_STAR_EQ = 65,
  anon_sym_DOT_DOT_DOT = 66,
  anon_sym_QMARK = 67,
  anon_sym_AMP_AMP = 68,
  anon_sym_PIPE_PIPE = 69,
  anon_sym_GT_GT = 70,
  anon_sym_GT_GT_GT = 71,
  anon_sym_LT_LT = 72,
  anon_sym_AMP = 73,
  anon_sym_CARET = 74,
  anon_sym_PIPE = 75,
  anon_sym_PLUS = 76,
  anon_sym_DASH = 77,
  anon_sym_PERCENT = 78,
  anon_sym_STAR_STAR = 79,
  anon_sym_LT_EQ = 80,
  anon_sym_EQ_EQ = 81,
  anon_sym_EQ_EQ_EQ = 82,
  anon_sym_BANG_EQ = 83,
  anon_sym_BANG_EQ_EQ = 84,
  anon_sym_GT_EQ = 85,
  anon_sym_instanceof = 86,
  anon_sym_BANG = 87,
  anon_sym_TILDE = 88,
  anon_sym_void = 89,
  anon_sym_delete = 90,
  anon_sym_PLUS_PLUS = 91,
  anon_sym_DASH_DASH = 92,
  anon_sym_DQUOTE = 93,
  aux_sym_string_token1 = 94,
  anon_sym_SQUOTE = 95,
  aux_sym_string_token2 = 96,
  sym_escape_sequence = 97,
  sym_comment = 98,
  anon_sym_BQUOTE = 99,
  anon_sym_DOLLAR_LBRACE = 100,
  anon_sym_SLASH2 = 101,
  sym_regex_pattern = 102,
  sym_regex_flags = 103,
  sym_number = 104,
  anon_sym_target = 105,
  sym_this = 106,
  sym_super = 107,
  sym_true = 108,
  sym_false = 109,
  sym_null = 110,
  sym_undefined = 111,
  anon_sym_AT = 112,
  anon_sym_static = 113,
  anon_sym_abstract = 114,
  anon_sym_get = 115,
  anon_sym_set = 116,
  anon_sym_declare = 117,
  anon_sym_public = 118,
  anon_sym_private = 119,
  anon_sym_protected = 120,
  anon_sym_module = 121,
  anon_sym_any = 122,
  anon_sym_number = 123,
  anon_sym_boolean = 124,
  anon_sym_string = 125,
  anon_sym_symbol = 126,
  anon_sym_require = 127,
  anon_sym_implements = 128,
  anon_sym_global = 129,
  anon_sym_interface = 130,
  anon_sym_extends = 131,
  anon_sym_enum = 132,
  sym_readonly = 133,
  anon_sym_is = 134,
  anon_sym_keyof = 135,
  anon_sym_LBRACE_PIPE = 136,
  anon_sym_PIPE_RBRACE = 137,
  sym__automatic_semicolon = 138,
  sym__template_chars = 139,
  sym_program = 140,
  sym_export_statement = 141,
  sym_export_clause = 142,
  sym__import_export_specifier = 143,
  sym__declaration = 144,
  sym_import = 145,
  sym_import_statement = 146,
  sym_import_clause = 147,
  sym__from_clause = 148,
  sym_namespace_import = 149,
  sym_named_imports = 150,
  sym_expression_statement = 151,
  sym_variable_declaration = 152,
  sym_lexical_declaration = 153,
  sym_variable_declarator = 154,
  sym_statement_block = 155,
  sym_if_statement = 156,
  sym_switch_statement = 157,
  sym_for_statement = 158,
  sym_for_in_statement = 159,
  sym__for_header = 160,
  sym_while_statement = 161,
  sym_do_statement = 162,
  sym_try_statement = 163,
  sym_with_statement = 164,
  sym_break_statement = 165,
  sym_continue_statement = 166,
  sym_debugger_statement = 167,
  sym_return_statement = 168,
  sym_throw_statement = 169,
  sym_empty_statement = 170,
  sym_labeled_statement = 171,
  sym_switch_body = 172,
  sym_switch_case = 173,
  sym_switch_default = 174,
  sym_catch_clause = 175,
  sym_finally_clause = 176,
  sym_parenthesized_expression = 177,
  sym__expression = 178,
  sym_yield_expression = 179,
  sym_object = 180,
  sym_assignment_pattern = 181,
  sym_array = 182,
  sym_nested_identifier = 183,
  sym_class = 184,
  sym_class_declaration = 185,
  sym_class_heritage = 186,
  sym_function = 187,
  sym_function_declaration = 188,
  sym_generator_function = 189,
  sym_generator_function_declaration = 190,
  sym_arrow_function = 191,
  sym__call_signature = 192,
  sym_call_expression = 193,
  sym_new_expression = 194,
  sym_await_expression = 195,
  sym_member_expression = 196,
  sym_subscript_expression = 197,
  sym_assignment_expression = 198,
  sym_augmented_assignment_expression = 199,
  sym__initializer = 200,
  sym_spread_element = 201,
  sym_ternary_expression = 202,
  sym_binary_expression = 203,
  sym_unary_expression = 204,
  sym_update_expression = 205,
  sym_sequence_expression = 206,
  sym_string = 207,
  sym_template_string = 208,
  sym_template_substitution = 209,
  sym_regex = 210,
  sym_meta_property = 211,
  sym_arguments = 212,
  sym_decorator = 213,
  sym_decorator_member_expression = 214,
  sym_decorator_call_expression = 215,
  sym_class_body = 216,
  sym_public_field_definition = 217,
  sym_formal_parameters = 218,
  sym_rest_parameter = 219,
  sym_method_definition = 220,
  sym_pair = 221,
  sym__property_name = 222,
  sym_computed_property_name = 223,
  sym_non_null_expression = 224,
  sym_method_signature = 225,
  sym_abstract_method_signature = 226,
  sym_function_signature = 227,
  sym_type_assertion = 228,
  sym_as_expression = 229,
  sym_import_require_clause = 230,
  sym_implements_clause = 231,
  sym_ambient_declaration = 232,
  sym_abstract_class_declaration = 233,
  sym_module = 234,
  sym_internal_module = 235,
  sym__module = 236,
  sym_import_alias = 237,
  sym_nested_type_identifier = 238,
  sym_interface_declaration = 239,
  sym_extends_clause = 240,
  sym_enum_declaration = 241,
  sym_enum_body = 242,
  sym_enum_assignment = 243,
  sym_type_alias_declaration = 244,
  sym_accessibility_modifier = 245,
  sym_required_parameter = 246,
  sym_optional_parameter = 247,
  sym__parameter_name = 248,
  sym_type_annotation = 249,
  sym__type = 250,
  sym_constructor_type = 251,
  sym__primary_type = 252,
  sym_generic_type = 253,
  sym_type_predicate = 254,
  sym_type_query = 255,
  sym_index_type_query = 256,
  sym_lookup_type = 257,
  sym_mapped_type_clause = 258,
  sym_literal_type = 259,
  sym__number = 260,
  sym_existential_type = 261,
  sym_flow_maybe_type = 262,
  sym_parenthesized_type = 263,
  sym_predefined_type = 264,
  sym_type_arguments = 265,
  sym_object_type = 266,
  sym_call_signature = 267,
  sym_property_signature = 268,
  sym_type_parameters = 269,
  sym_type_parameter = 270,
  sym_default_type = 271,
  sym_constraint = 272,
  sym_construct_signature = 273,
  sym_index_signature = 274,
  sym_array_type = 275,
  sym_tuple_type = 276,
  sym_union_type = 277,
  sym_intersection_type = 278,
  sym_function_type = 279,
  aux_sym_program_repeat1 = 280,
  aux_sym_export_statement_repeat1 = 281,
  aux_sym_export_clause_repeat1 = 282,
  aux_sym_named_imports_repeat1 = 283,
  aux_sym_variable_declaration_repeat1 = 284,
  aux_sym_switch_body_repeat1 = 285,
  aux_sym_object_repeat1 = 286,
  aux_sym_array_repeat1 = 287,
  aux_sym_string_repeat1 = 288,
  aux_sym_string_repeat2 = 289,
  aux_sym_template_string_repeat1 = 290,
  aux_sym_class_body_repeat1 = 291,
  aux_sym_formal_parameters_repeat1 = 292,
  aux_sym_implements_clause_repeat1 = 293,
  aux_sym_extends_clause_repeat1 = 294,
  aux_sym_enum_body_repeat1 = 295,
  aux_sym_object_type_repeat1 = 296,
  aux_sym_type_parameters_repeat1 = 297,
  alias_sym_array_pattern = 298,
  alias_sym_export_specifier = 299,
  alias_sym_import_specifier = 300,
  alias_sym_object_pattern = 301,
  alias_sym_property_identifier = 302,
  alias_sym_shorthand_property_identifier = 303,
  alias_sym_statement_identifier = 304,
  alias_sym_type_identifier = 305,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_require] = "require",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_enum] = "enum",
  [sym_readonly] = "readonly",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "_import_export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_clause] = "extends_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_type_annotation] = "type_annotation",
  [sym__type] = "_type",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_export_specifier] = "export_specifier",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_condition = 6,
  field_consequence = 7,
  field_constructor = 8,
  field_declaration = 9,
  field_decorator = 10,
  field_finalizer = 11,
  field_flags = 12,
  field_function = 13,
  field_handler = 14,
  field_increment = 15,
  field_index = 16,
  field_initializer = 17,
  field_key = 18,
  field_label = 19,
  field_left = 20,
  field_module = 21,
  field_name = 22,
  field_object = 23,
  field_operator = 24,
  field_parameter = 25,
  field_parameters = 26,
  field_pattern = 27,
  field_property = 28,
  field_return_type = 29,
  field_right = 30,
  field_source = 31,
  field_type = 32,
  field_type_arguments = 33,
  field_type_parameters = 34,
  field_value = 35,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 3, .length = 1},
  [10] = {.index = 3, .length = 1},
  [13] = {.index = 8, .length = 1},
  [15] = {.index = 9, .length = 1},
  [16] = {.index = 9, .length = 1},
  [17] = {.index = 10, .length = 2},
  [19] = {.index = 12, .length = 2},
  [20] = {.index = 14, .length = 2},
  [21] = {.index = 16, .length = 2},
  [22] = {.index = 18, .length = 2},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 1},
  [25] = {.index = 23, .length = 2},
  [26] = {.index = 25, .length = 2},
  [27] = {.index = 27, .length = 2},
  [29] = {.index = 29, .length = 2},
  [30] = {.index = 31, .length = 2},
  [31] = {.index = 29, .length = 2},
  [32] = {.index = 31, .length = 2},
  [33] = {.index = 29, .length = 2},
  [34] = {.index = 31, .length = 2},
  [35] = {.index = 33, .length = 2},
  [36] = {.index = 35, .length = 2},
  [37] = {.index = 37, .length = 3},
  [40] = {.index = 40, .length = 1},
  [41] = {.index = 41, .length = 2},
  [42] = {.index = 43, .length = 2},
  [43] = {.index = 45, .length = 2},
  [44] = {.index = 47, .length = 2},
  [45] = {.index = 49, .length = 1},
  [46] = {.index = 50, .length = 3},
  [48] = {.index = 53, .length = 1},
  [49] = {.index = 54, .length = 2},
  [50] = {.index = 56, .length = 1},
  [51] = {.index = 57, .length = 2},
  [52] = {.index = 59, .length = 4},
  [53] = {.index = 63, .length = 2},
  [54] = {.index = 63, .length = 2},
  [55] = {.index = 20, .length = 2},
  [56] = {.index = 23, .length = 2},
  [57] = {.index = 25, .length = 2},
  [58] = {.index = 65, .length = 3},
  [59] = {.index = 10, .length = 2},
  [60] = {.index = 54, .length = 2},
  [61] = {.index = 68, .length = 3},
  [62] = {.index = 20, .length = 2},
  [63] = {.index = 20, .length = 2},
  [64] = {.index = 71, .length = 4},
  [65] = {.index = 75, .length = 3},
  [66] = {.index = 78, .length = 2},
  [67] = {.index = 80, .length = 1},
  [68] = {.index = 81, .length = 1},
  [69] = {.index = 82, .length = 1},
  [70] = {.index = 83, .length = 1},
  [71] = {.index = 84, .length = 2},
  [72] = {.index = 20, .length = 2},
  [73] = {.index = 86, .length = 2},
  [74] = {.index = 88, .length = 5},
  [75] = {.index = 84, .length = 2},
  [76] = {.index = 93, .length = 1},
  [77] = {.index = 94, .length = 3},
  [78] = {.index = 94, .length = 3},
  [79] = {.index = 94, .length = 3},
  [80] = {.index = 97, .length = 2},
  [81] = {.index = 99, .length = 3},
  [85] = {.index = 102, .length = 1},
  [86] = {.index = 103, .length = 3},
  [87] = {.index = 106, .length = 4},
  [88] = {.index = 110, .length = 2},
  [89] = {.index = 112, .length = 2},
  [90] = {.index = 114, .length = 2},
  [91] = {.index = 116, .length = 3},
  [92] = {.index = 119, .length = 2},
  [93] = {.index = 121, .length = 2},
  [94] = {.index = 123, .length = 4},
  [95] = {.index = 121, .length = 2},
  [96] = {.index = 127, .length = 4},
  [97] = {.index = 131, .length = 4},
  [98] = {.index = 135, .length = 5},
  [99] = {.index = 140, .length = 2},
  [100] = {.index = 97, .length = 2},
  [101] = {.index = 142, .length = 3},
  [102] = {.index = 145, .length = 2},
  [103] = {.index = 147, .length = 3},
  [104] = {.index = 150, .length = 2},
  [105] = {.index = 152, .length = 5},
  [106] = {.index = 157, .length = 2},
  [107] = {.index = 159, .length = 1},
  [108] = {.index = 160, .length = 3},
  [109] = {.index = 163, .length = 1},
  [110] = {.index = 164, .length = 1},
  [111] = {.index = 165, .length = 1},
  [112] = {.index = 166, .length = 2},
  [113] = {.index = 168, .length = 1},
  [114] = {.index = 169, .length = 2},
  [115] = {.index = 171, .length = 4},
  [116] = {.index = 175, .length = 2},
  [117] = {.index = 177, .length = 2},
  [118] = {.index = 179, .length = 2},
  [119] = {.index = 181, .length = 3},
  [120] = {.index = 184, .length = 4},
  [121] = {.index = 188, .length = 4},
  [122] = {.index = 192, .length = 5},
  [123] = {.index = 197, .length = 2},
  [124] = {.index = 199, .length = 3},
  [125] = {.index = 202, .length = 3},
  [126] = {.index = 205, .length = 2},
  [127] = {.index = 207, .length = 3},
  [128] = {.index = 210, .length = 4},
  [129] = {.index = 214, .length = 3},
  [130] = {.index = 217, .length = 2},
  [131] = {.index = 219, .length = 5},
  [132] = {.index = 224, .length = 3},
  [133] = {.index = 227, .length = 2},
  [134] = {.index = 227, .length = 2},
  [135] = {.index = 229, .length = 3},
  [136] = {.index = 227, .length = 2},
  [137] = {.index = 227, .length = 2},
  [138] = {.index = 232, .length = 2},
  [139] = {.index = 234, .length = 4},
  [140] = {.index = 238, .length = 2},
  [141] = {.index = 240, .length = 2},
  [142] = {.index = 242, .length = 1},
  [143] = {.index = 243, .length = 2},
  [144] = {.index = 245, .length = 2},
  [145] = {.index = 247, .length = 3},
  [146] = {.index = 250, .length = 3},
  [147] = {.index = 253, .length = 5},
  [148] = {.index = 258, .length = 3},
  [150] = {.index = 261, .length = 4},
  [151] = {.index = 265, .length = 5},
  [152] = {.index = 270, .length = 2},
  [153] = {.index = 270, .length = 2},
  [154] = {.index = 270, .length = 2},
  [155] = {.index = 270, .length = 2},
  [156] = {.index = 272, .length = 4},
  [157] = {.index = 276, .length = 2},
  [158] = {.index = 276, .length = 2},
  [159] = {.index = 276, .length = 2},
  [160] = {.index = 278, .length = 4},
  [161] = {.index = 282, .length = 4},
  [162] = {.index = 286, .length = 2},
  [163] = {.index = 288, .length = 2},
  [164] = {.index = 290, .length = 2},
  [165] = {.index = 292, .length = 3},
  [166] = {.index = 295, .length = 3},
  [167] = {.index = 298, .length = 2},
  [168] = {.index = 300, .length = 5},
  [169] = {.index = 305, .length = 5},
  [170] = {.index = 310, .length = 4},
  [171] = {.index = 314, .length = 4},
  [172] = {.index = 318, .length = 2},
  [173] = {.index = 320, .length = 3},
  [174] = {.index = 323, .length = 2},
  [175] = {.index = 325, .length = 3},
  [176] = {.index = 328, .length = 5},
  [177] = {.index = 333, .length = 5},
  [178] = {.index = 338, .length = 4},
  [179] = {.index = 342, .length = 4},
  [180] = {.index = 346, .length = 3},
  [181] = {.index = 349, .length = 5},
  [182] = {.index = 354, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_body, 1},
  [9] =
    {field_constructor, 1},
  [10] =
    {field_arguments, 1},
    {field_function, 0},
  [12] =
    {field_argument, 0},
    {field_operator, 1},
  [14] =
    {field_parameters, 0},
    {field_return_type, 1},
  [16] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [18] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [20] =
    {field_left, 0},
    {field_right, 2},
  [22] =
    {field_label, 0},
  [23] =
    {field_object, 0},
    {field_property, 2},
  [25] =
    {field_body, 2},
    {field_parameter, 0},
  [27] =
    {field_body, 1},
    {field_name, 0},
  [29] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [31] =
    {field_name, 0},
    {field_type, 1},
  [33] =
    {field_condition, 1},
    {field_consequence, 2},
  [35] =
    {field_body, 2},
    {field_value, 1},
  [37] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [40] =
    {field_value, 1, .inherited = true},
  [41] =
    {field_body, 2},
    {field_condition, 1},
  [43] =
    {field_body, 1},
    {field_handler, 2},
  [45] =
    {field_body, 1},
    {field_finalizer, 2},
  [47] =
    {field_body, 2},
    {field_object, 1},
  [49] =
    {field_label, 1},
  [50] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [53] =
    {field_pattern, 1},
  [54] =
    {field_body, 2},
    {field_name, 1},
  [56] =
    {field_body, 2},
  [57] =
    {field_body, 2},
    {field_type_parameters, 1},
  [59] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [63] =
    {field_arguments, 2},
    {field_constructor, 1},
  [65] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [68] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [71] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [75] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [78] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [80] =
    {field_source, 1},
  [81] =
    {field_source, 2, .inherited = true},
  [82] =
    {field_value, 2},
  [83] =
    {field_name, 1},
  [84] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [86] =
    {field_key, 0},
    {field_value, 2},
  [88] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [93] =
    {field_value, 1},
  [94] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [97] =
    {field_body, 3},
    {field_name, 2},
  [99] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [102] =
    {field_value, 2, .inherited = true},
  [103] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [106] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [110] =
    {field_module, 0},
    {field_name, 2},
  [112] =
    {field_flags, 3},
    {field_pattern, 1},
  [114] =
    {field_body, 3},
    {field_name, 1},
  [116] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [119] =
    {field_body, 3},
    {field_type_parameters, 1},
  [121] =
    {field_body, 3},
    {field_parameter, 1},
  [123] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [127] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [131] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [135] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [140] =
    {field_index, 2},
    {field_object, 0},
  [142] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [145] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [147] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [150] =
    {field_alias, 2},
    {field_name, 0},
  [152] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [157] =
    {field_name, 1},
    {field_value, 3},
  [159] =
    {field_source, 3, .inherited = true},
  [160] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [163] =
    {field_decorator, 1, .inherited = true},
  [164] =
    {field_decorator, 2, .inherited = true},
  [165] =
    {field_value, 3, .inherited = true},
  [166] =
    {field_body, 1},
    {field_condition, 3},
  [168] =
    {field_name, 2},
  [169] =
    {field_name, 1},
    {field_type, 2},
  [171] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [175] =
    {field_name, 0},
    {field_type, 2},
  [177] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [179] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [181] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [184] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [188] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [192] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [197] =
    {field_body, 4},
    {field_name, 2},
  [199] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [202] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [205] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [207] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [210] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [214] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [217] =
    {field_alias, 3},
    {field_name, 1},
  [219] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [224] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [227] =
    {field_left, 1},
    {field_right, 3},
  [229] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [232] =
    {field_decorator, 1, .inherited = true},
    {field_decorator, 3, .inherited = true},
  [234] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [238] =
    {field_name, 2},
    {field_type, 3},
  [240] =
    {field_name, 1},
    {field_type, 3},
  [242] =
    {field_name, 3},
  [243] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [245] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [247] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [250] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [253] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [258] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [261] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [265] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [270] =
    {field_left, 2},
    {field_right, 4},
  [272] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [276] =
    {field_body, 4},
    {field_parameter, 2},
  [278] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [282] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [286] =
    {field_name, 2},
    {field_type, 4},
  [288] =
    {field_name, 3},
    {field_type, 4},
  [290] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [292] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [295] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [298] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [300] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [305] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [310] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [314] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [318] =
    {field_name, 3},
    {field_type, 5},
  [320] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [323] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [325] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [328] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [333] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [338] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [342] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [346] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [349] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [354] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
};

static TSSymbol ts_alias_sequences[183][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [9] = {
    [0] = alias_sym_object_pattern,
  },
  [10] = {
    [0] = alias_sym_array_pattern,
  },
  [11] = {
    [0] = alias_sym_object_pattern,
  },
  [12] = {
    [0] = alias_sym_array_pattern,
  },
  [14] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [1] = sym_identifier,
  },
  [18] = {
    [1] = sym_identifier,
  },
  [23] = {
    [0] = sym_identifier,
  },
  [24] = {
    [0] = alias_sym_statement_identifier,
  },
  [25] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [26] = {
    [0] = sym_identifier,
  },
  [28] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [31] = {
    [0] = alias_sym_object_pattern,
  },
  [32] = {
    [0] = alias_sym_object_pattern,
  },
  [33] = {
    [0] = alias_sym_array_pattern,
  },
  [34] = {
    [0] = alias_sym_array_pattern,
  },
  [38] = {
    [1] = alias_sym_object_pattern,
  },
  [39] = {
    [1] = alias_sym_array_pattern,
  },
  [45] = {
    [1] = alias_sym_statement_identifier,
  },
  [47] = {
    [1] = alias_sym_type_identifier,
  },
  [49] = {
    [1] = alias_sym_type_identifier,
  },
  [53] = {
    [1] = sym_identifier,
  },
  [56] = {
    [2] = alias_sym_property_identifier,
  },
  [59] = {
    [0] = sym_identifier,
  },
  [62] = {
    [0] = alias_sym_object_pattern,
  },
  [63] = {
    [0] = alias_sym_array_pattern,
  },
  [71] = {
    [1] = alias_sym_export_specifier,
  },
  [72] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [75] = {
    [1] = alias_sym_import_specifier,
  },
  [78] = {
    [0] = alias_sym_object_pattern,
  },
  [79] = {
    [0] = alias_sym_array_pattern,
  },
  [82] = {
    [2] = sym_identifier,
  },
  [83] = {
    [2] = alias_sym_object_pattern,
  },
  [84] = {
    [2] = alias_sym_array_pattern,
  },
  [88] = {
    [2] = alias_sym_type_identifier,
  },
  [90] = {
    [1] = alias_sym_type_identifier,
  },
  [91] = {
    [1] = alias_sym_type_identifier,
  },
  [93] = {
    [1] = sym_identifier,
  },
  [100] = {
    [2] = alias_sym_type_identifier,
  },
  [101] = {
    [2] = alias_sym_type_identifier,
  },
  [106] = {
    [1] = alias_sym_type_identifier,
  },
  [119] = {
    [1] = alias_sym_type_identifier,
  },
  [123] = {
    [2] = alias_sym_type_identifier,
  },
  [124] = {
    [2] = alias_sym_type_identifier,
  },
  [127] = {
    [2] = alias_sym_type_identifier,
  },
  [128] = {
    [2] = alias_sym_type_identifier,
  },
  [132] = {
    [1] = alias_sym_type_identifier,
  },
  [133] = {
    [1] = sym_identifier,
  },
  [136] = {
    [1] = alias_sym_object_pattern,
  },
  [137] = {
    [1] = alias_sym_array_pattern,
  },
  [148] = {
    [2] = alias_sym_type_identifier,
  },
  [149] = {
    [3] = alias_sym_property_identifier,
  },
  [150] = {
    [2] = alias_sym_type_identifier,
  },
  [152] = {
    [2] = sym_identifier,
  },
  [154] = {
    [2] = alias_sym_object_pattern,
  },
  [155] = {
    [2] = alias_sym_array_pattern,
  },
  [158] = {
    [2] = alias_sym_object_pattern,
  },
  [159] = {
    [2] = alias_sym_array_pattern,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0) ADVANCE(64);
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '#') ADVANCE(16);
      if (lookahead == '$') ADVANCE(185);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(171);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(32);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0) ADVANCE(186);
      END_STATE();
    case 1:
      if (lookahead == 0) ADVANCE(64);
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '#') ADVANCE(16);
      if (lookahead == '$') ADVANCE(185);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0) ADVANCE(186);
      END_STATE();
    case 2:
      if (lookahead == 0) ADVANCE(64);
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(118);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(186);
      END_STATE();
    case 3:
      if (lookahead == 0) ADVANCE(64);
      if (lookahead == '!') ADVANCE(142);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '#') ADVANCE(16);
      if (lookahead == '&') ADVANCE(115);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '=') ADVANCE(70);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(186);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(23)
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '/') ADVANCE(156);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(159);
      if (lookahead != 0) ADVANCE(160);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(155);
      if (lookahead == '\r') ADVANCE(162);
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(166);
      if (lookahead != 0) ADVANCE(161);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(20)
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == '\\') ADVANCE(7);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(152);
      if (lookahead != 0) ADVANCE(153);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(148);
      if (lookahead == '\r') ADVANCE(163);
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(166);
      if (lookahead != 0) ADVANCE(161);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(29)
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(172);
      if (lookahead != 0) ADVANCE(173);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(186);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(121);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(186);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(118);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != ';') ADVANCE(186);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(118);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(186);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(118);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(186);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '^') ADVANCE(118);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(15)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(186);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '^') ADVANCE(118);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(15)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(186);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(65);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(142);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '&') ADVANCE(115);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(120);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(186);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '&') ADVANCE(115);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(126);
      if (lookahead == '-') ADVANCE(129);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(171);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(186);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '&') ADVANCE(115);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(126);
      if (lookahead == '-') ADVANCE(129);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(186);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      END_STATE();
    case 21:
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(22)
      END_STATE();
    case 22:
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(22)
      END_STATE();
    case 23:
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(23)
      END_STATE();
    case 24:
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(168);
      END_STATE();
    case 25:
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(167);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == '*') ADVANCE(25);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 28:
      if (lookahead == '.') ADVANCE(105);
      END_STATE();
    case 29:
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(29)
      END_STATE();
    case 30:
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 31:
      if (lookahead == '\\') ADVANCE(62);
      if (lookahead == ']') ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(31);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(36);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(166);
      if (lookahead != 0) ADVANCE(161);
      END_STATE();
    case 33:
      if (lookahead == 'u') ADVANCE(37);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(166);
      if (lookahead != 0) ADVANCE(161);
      END_STATE();
    case 35:
      if (lookahead == '{') ADVANCE(170);
      END_STATE();
    case 36:
      if (lookahead == '{') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 37:
      if (lookahead == '{') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 38:
      if (lookahead == '{') ADVANCE(56);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 39:
      if (lookahead == '}') ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '}') ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 41:
      if (lookahead == '}') ADVANCE(164);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 42:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 43:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(178);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(179);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(177);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(181);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(186);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(161);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(180);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(164);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(57);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(59);
      END_STATE();
    case 62:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(31);
      END_STATE();
    case 63:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(173);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(135);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(134);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(137);
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(188);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(114);
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(113);
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(141);
      if (lookahead == '>') ADVANCE(109);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(141);
      if (lookahead == '>') ADVANCE(110);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(168);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(168);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(112);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(111);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(107);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(107);
      if (lookahead == '=') ADVANCE(99);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '|') ADVANCE(108);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '|') ADVANCE(108);
      if (lookahead == '}') ADVANCE(189);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(108);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(108);
      if (lookahead == '}') ADVANCE(189);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(189);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(145);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(145);
      if (lookahead == '=') ADVANCE(93);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(146);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(138);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(139);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(151);
      if (lookahead == '/') ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(150);
      if (lookahead == '/') ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(151);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(150);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(158);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(157);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(158);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(158);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(155);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(148);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(186);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(161);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(165);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(168);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(168);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(173);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(173);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(33);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(186);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == '0') ADVANCE(181);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(43);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(44);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(51);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(175);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (lookahead == '_') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(175);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(180);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(181);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (lookahead == '_') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '{') ADVANCE(170);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(186);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(186);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      if (lookahead == 'w') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      if (lookahead == 'y') ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(69);
      if (lookahead == 'i') ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(73);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(74);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(78);
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(82);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'f') ADVANCE(84);
      if (lookahead == 'l') ADVANCE(85);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(86);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(87);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(88);
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(93);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(97);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(98);
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(102);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(103);
      END_STATE();
    case 51:
      if (lookahead == 'w') ADVANCE(104);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(105);
      if (lookahead == 'm') ADVANCE(106);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(107);
      if (lookahead == 'o') ADVANCE(108);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(109);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'q') ADVANCE(111);
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(113);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(114);
      if (lookahead == 'r') ADVANCE(115);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(116);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 61:
      if (lookahead == 'm') ADVANCE(118);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(120);
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(122);
      if (lookahead == 'y') ADVANCE(123);
      END_STATE();
    case 65:
      if (lookahead == 'p') ADVANCE(124);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(125);
      END_STATE();
    case 67:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 74:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(133);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 77:
      if (lookahead == 'a') ADVANCE(135);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 79:
      if (lookahead == 'c') ADVANCE(137);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 81:
      if (lookahead == 's') ADVANCE(139);
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 82:
      if (lookahead == 'u') ADVANCE(141);
      END_STATE();
    case 83:
      if (lookahead == 'l') ADVANCE(142);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(143);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 87:
      if (lookahead == 'm') ADVANCE(146);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 90:
      if (lookahead == 's') ADVANCE(149);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(150);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 93:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 94:
      if (lookahead == 'c') ADVANCE(152);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 96:
      if (lookahead == 'b') ADVANCE(153);
      END_STATE();
    case 97:
      if (lookahead == 'l') ADVANCE(154);
      if (lookahead == 'o') ADVANCE(155);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(156);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 100:
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 102:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 105:
      if (lookahead == 'l') ADVANCE(161);
      END_STATE();
    case 106:
      if (lookahead == 'b') ADVANCE(162);
      END_STATE();
    case 107:
      if (lookahead == 'v') ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 109:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 110:
      if (lookahead == 'd') ADVANCE(166);
      END_STATE();
    case 111:
      if (lookahead == 'u') ADVANCE(167);
      END_STATE();
    case 112:
      if (lookahead == 'u') ADVANCE(168);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 115:
      if (lookahead == 'i') ADVANCE(170);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(172);
      END_STATE();
    case 118:
      if (lookahead == 'b') ADVANCE(173);
      END_STATE();
    case 119:
      if (lookahead == 'g') ADVANCE(174);
      END_STATE();
    case 120:
      if (lookahead == 's') ADVANCE(175);
      END_STATE();
    case 121:
      if (lookahead == 'o') ADVANCE(176);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 127:
      if (lookahead == 'd') ADVANCE(180);
      END_STATE();
    case 128:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 129:
      if (lookahead == 'h') ADVANCE(182);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 131:
      if (lookahead == 'r') ADVANCE(184);
      END_STATE();
    case 132:
      if (lookahead == 'c') ADVANCE(185);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(186);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 135:
      if (lookahead == 'k') ADVANCE(188);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 137:
      if (lookahead == 'h') ADVANCE(189);
      END_STATE();
    case 138:
      if (lookahead == 's') ADVANCE(190);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 140:
      if (lookahead == 'i') ADVANCE(192);
      END_STATE();
    case 141:
      if (lookahead == 'g') ADVANCE(193);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 143:
      if (lookahead == 'u') ADVANCE(195);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(197);
      END_STATE();
    case 148:
      if (lookahead == 'n') ADVANCE(198);
      END_STATE();
    case 149:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 150:
      if (lookahead == 'l') ADVANCE(200);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 152:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 153:
      if (lookahead == 'a') ADVANCE(202);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 157:
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 158:
      if (lookahead == 'f') ADVANCE(207);
      END_STATE();
    case 159:
      if (lookahead == 'l') ADVANCE(208);
      END_STATE();
    case 160:
      if (lookahead == 's') ADVANCE(209);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 162:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(211);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(212);
      END_STATE();
    case 165:
      if (lookahead == 'i') ADVANCE(213);
      END_STATE();
    case 166:
      if (lookahead == 'o') ADVANCE(214);
      END_STATE();
    case 167:
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 168:
      if (lookahead == 'r') ADVANCE(216);
      END_STATE();
    case 169:
      if (lookahead == 'i') ADVANCE(217);
      END_STATE();
    case 170:
      if (lookahead == 'n') ADVANCE(218);
      END_STATE();
    case 171:
      if (lookahead == 'r') ADVANCE(219);
      END_STATE();
    case 172:
      if (lookahead == 'c') ADVANCE(220);
      END_STATE();
    case 173:
      if (lookahead == 'o') ADVANCE(221);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 176:
      if (lookahead == 'w') ADVANCE(223);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(224);
      END_STATE();
    case 179:
      if (lookahead == 'f') ADVANCE(225);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 181:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 183:
      if (lookahead == 'd') ADVANCE(227);
      END_STATE();
    case 184:
      if (lookahead == 'a') ADVANCE(228);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 187:
      if (lookahead == 'a') ADVANCE(229);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 192:
      if (lookahead == 'n') ADVANCE(230);
      END_STATE();
    case 193:
      if (lookahead == 'g') ADVANCE(231);
      END_STATE();
    case 194:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 195:
      if (lookahead == 'l') ADVANCE(233);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 198:
      if (lookahead == 'd') ADVANCE(236);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(237);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(238);
      END_STATE();
    case 202:
      if (lookahead == 'l') ADVANCE(239);
      END_STATE();
    case 203:
      if (lookahead == 'm') ADVANCE(240);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 205:
      if (lookahead == 'n') ADVANCE(242);
      END_STATE();
    case 206:
      if (lookahead == 'f') ADVANCE(243);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 208:
      if (lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 209:
      if (lookahead == 'p') ADVANCE(245);
      END_STATE();
    case 210:
      if (lookahead == 'r') ADVANCE(246);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(247);
      END_STATE();
    case 212:
      if (lookahead == 'c') ADVANCE(248);
      END_STATE();
    case 213:
      if (lookahead == 'c') ADVANCE(249);
      END_STATE();
    case 214:
      if (lookahead == 'n') ADVANCE(250);
      END_STATE();
    case 215:
      if (lookahead == 'r') ADVANCE(251);
      END_STATE();
    case 216:
      if (lookahead == 'n') ADVANCE(252);
      END_STATE();
    case 217:
      if (lookahead == 'c') ADVANCE(253);
      END_STATE();
    case 218:
      if (lookahead == 'g') ADVANCE(254);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 220:
      if (lookahead == 'h') ADVANCE(255);
      END_STATE();
    case 221:
      if (lookahead == 'l') ADVANCE(256);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 224:
      if (lookahead == 'f') ADVANCE(258);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(260);
      END_STATE();
    case 229:
      if (lookahead == 'n') ADVANCE(261);
      END_STATE();
    case 230:
      if (lookahead == 'u') ADVANCE(262);
      END_STATE();
    case 231:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 236:
      if (lookahead == 's') ADVANCE(266);
      END_STATE();
    case 237:
      if (lookahead == 'y') ADVANCE(267);
      END_STATE();
    case 238:
      if (lookahead == 'o') ADVANCE(268);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 240:
      if (lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 242:
      if (lookahead == 'c') ADVANCE(270);
      END_STATE();
    case 243:
      if (lookahead == 'a') ADVANCE(271);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 245:
      if (lookahead == 'a') ADVANCE(272);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 248:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 250:
      if (lookahead == 'l') ADVANCE(275);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(276);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 259:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 260:
      if (lookahead == 't') ADVANCE(278);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(279);
      END_STATE();
    case 263:
      if (lookahead == 'r') ADVANCE(280);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 268:
      if (lookahead == 'n') ADVANCE(281);
      END_STATE();
    case 269:
      if (lookahead == 'n') ADVANCE(282);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(283);
      END_STATE();
    case 271:
      if (lookahead == 'c') ADVANCE(284);
      END_STATE();
    case 272:
      if (lookahead == 'c') ADVANCE(285);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 275:
      if (lookahead == 'y') ADVANCE(287);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 277:
      if (lookahead == 'e') ADVANCE(288);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(289);
      END_STATE();
    case 283:
      if (lookahead == 'o') ADVANCE(290);
      END_STATE();
    case 284:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(292);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(293);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 288:
      if (lookahead == 'd') ADVANCE(294);
      END_STATE();
    case 289:
      if (lookahead == 's') ADVANCE(295);
      END_STATE();
    case 290:
      if (lookahead == 'f') ADVANCE(296);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 3},
  [2] = {.lex_state = 3},
  [3] = {.lex_state = 3},
  [4] = {.lex_state = 3},
  [5] = {.lex_state = 3},
  [6] = {.lex_state = 3},
  [7] = {.lex_state = 3},
  [8] = {.lex_state = 3},
  [9] = {.lex_state = 3},
  [10] = {.lex_state = 3},
  [11] = {.lex_state = 3},
  [12] = {.lex_state = 3},
  [13] = {.lex_state = 3},
  [14] = {.lex_state = 3},
  [15] = {.lex_state = 3},
  [16] = {.lex_state = 3},
  [17] = {.lex_state = 3},
  [18] = {.lex_state = 3},
  [19] = {.lex_state = 3},
  [20] = {.lex_state = 3},
  [21] = {.lex_state = 3},
  [22] = {.lex_state = 3},
  [23] = {.lex_state = 3},
  [24] = {.lex_state = 3},
  [25] = {.lex_state = 3},
  [26] = {.lex_state = 3},
  [27] = {.lex_state = 3},
  [28] = {.lex_state = 3},
  [29] = {.lex_state = 3},
  [30] = {.lex_state = 3},
  [31] = {.lex_state = 3},
  [32] = {.lex_state = 3},
  [33] = {.lex_state = 3},
  [34] = {.lex_state = 3},
  [35] = {.lex_state = 3},
  [36] = {.lex_state = 3},
  [37] = {.lex_state = 3},
  [38] = {.lex_state = 3},
  [39] = {.lex_state = 3},
  [40] = {.lex_state = 3},
  [41] = {.lex_state = 3},
  [42] = {.lex_state = 3},
  [43] = {.lex_state = 3},
  [44] = {.lex_state = 3},
  [45] = {.lex_state = 3},
  [46] = {.lex_state = 3},
  [47] = {.lex_state = 3},
  [48] = {.lex_state = 3},
  [49] = {.lex_state = 3},
  [50] = {.lex_state = 9, .external_lex_state = 2},
  [51] = {.lex_state = 9, .external_lex_state = 2},
  [52] = {.lex_state = 9},
  [53] = {.lex_state = 9, .external_lex_state = 2},
  [54] = {.lex_state = 9},
  [55] = {.lex_state = 9, .external_lex_state = 2},
  [56] = {.lex_state = 9},
  [57] = {.lex_state = 9, .external_lex_state = 2},
  [58] = {.lex_state = 9, .external_lex_state = 2},
  [59] = {.lex_state = 9, .external_lex_state = 2},
  [60] = {.lex_state = 9, .external_lex_state = 2},
  [61] = {.lex_state = 9, .external_lex_state = 2},
  [62] = {.lex_state = 9, .external_lex_state = 2},
  [63] = {.lex_state = 9},
  [64] = {.lex_state = 9},
  [65] = {.lex_state = 9, .external_lex_state = 2},
  [66] = {.lex_state = 9},
  [67] = {.lex_state = 9, .external_lex_state = 2},
  [68] = {.lex_state = 9},
  [69] = {.lex_state = 9},
  [70] = {.lex_state = 9},
  [71] = {.lex_state = 10},
  [72] = {.lex_state = 9},
  [73] = {.lex_state = 10},
  [74] = {.lex_state = 9},
  [75] = {.lex_state = 9, .external_lex_state = 2},
  [76] = {.lex_state = 9},
  [77] = {.lex_state = 9},
  [78] = {.lex_state = 9},
  [79] = {.lex_state = 9},
  [80] = {.lex_state = 10},
  [81] = {.lex_state = 9},
  [82] = {.lex_state = 9},
  [83] = {.lex_state = 17},
  [84] = {.lex_state = 17},
  [85] = {.lex_state = 17},
  [86] = {.lex_state = 17},
  [87] = {.lex_state = 17},
  [88] = {.lex_state = 17},
  [89] = {.lex_state = 17},
  [90] = {.lex_state = 17},
  [91] = {.lex_state = 17},
  [92] = {.lex_state = 17},
  [93] = {.lex_state = 17},
  [94] = {.lex_state = 17},
  [95] = {.lex_state = 2},
  [96] = {.lex_state = 17},
  [97] = {.lex_state = 17},
  [98] = {.lex_state = 17},
  [99] = {.lex_state = 2, .external_lex_state = 2},
  [100] = {.lex_state = 11},
  [101] = {.lex_state = 2},
  [102] = {.lex_state = 2},
  [103] = {.lex_state = 2, .external_lex_state = 2},
  [104] = {.lex_state = 2, .external_lex_state = 2},
  [105] = {.lex_state = 2, .external_lex_state = 2},
  [106] = {.lex_state = 2, .external_lex_state = 2},
  [107] = {.lex_state = 2, .external_lex_state = 2},
  [108] = {.lex_state = 2, .external_lex_state = 2},
  [109] = {.lex_state = 2, .external_lex_state = 2},
  [110] = {.lex_state = 2, .external_lex_state = 2},
  [111] = {.lex_state = 2, .external_lex_state = 2},
  [112] = {.lex_state = 2, .external_lex_state = 2},
  [113] = {.lex_state = 2, .external_lex_state = 2},
  [114] = {.lex_state = 2, .external_lex_state = 2},
  [115] = {.lex_state = 2, .external_lex_state = 2},
  [116] = {.lex_state = 2, .external_lex_state = 2},
  [117] = {.lex_state = 2, .external_lex_state = 2},
  [118] = {.lex_state = 2, .external_lex_state = 2},
  [119] = {.lex_state = 2, .external_lex_state = 2},
  [120] = {.lex_state = 2, .external_lex_state = 2},
  [121] = {.lex_state = 2, .external_lex_state = 2},
  [122] = {.lex_state = 2, .external_lex_state = 2},
  [123] = {.lex_state = 2, .external_lex_state = 2},
  [124] = {.lex_state = 2, .external_lex_state = 2},
  [125] = {.lex_state = 2, .external_lex_state = 2},
  [126] = {.lex_state = 2, .external_lex_state = 2},
  [127] = {.lex_state = 2, .external_lex_state = 2},
  [128] = {.lex_state = 2, .external_lex_state = 2},
  [129] = {.lex_state = 2, .external_lex_state = 2},
  [130] = {.lex_state = 2, .external_lex_state = 2},
  [131] = {.lex_state = 3},
  [132] = {.lex_state = 3},
  [133] = {.lex_state = 3},
  [134] = {.lex_state = 3},
  [135] = {.lex_state = 3},
  [136] = {.lex_state = 3},
  [137] = {.lex_state = 3},
  [138] = {.lex_state = 3},
  [139] = {.lex_state = 3},
  [140] = {.lex_state = 3},
  [141] = {.lex_state = 3},
  [142] = {.lex_state = 3},
  [143] = {.lex_state = 3},
  [144] = {.lex_state = 3},
  [145] = {.lex_state = 3},
  [146] = {.lex_state = 3},
  [147] = {.lex_state = 3},
  [148] = {.lex_state = 9, .external_lex_state = 2},
  [149] = {.lex_state = 3},
  [150] = {.lex_state = 9, .external_lex_state = 2},
  [151] = {.lex_state = 3},
  [152] = {.lex_state = 9, .external_lex_state = 2},
  [153] = {.lex_state = 3},
  [154] = {.lex_state = 3},
  [155] = {.lex_state = 3},
  [156] = {.lex_state = 3, .external_lex_state = 2},
  [157] = {.lex_state = 3},
  [158] = {.lex_state = 3},
  [159] = {.lex_state = 9, .external_lex_state = 2},
  [160] = {.lex_state = 9, .external_lex_state = 2},
  [161] = {.lex_state = 9, .external_lex_state = 2},
  [162] = {.lex_state = 9, .external_lex_state = 2},
  [163] = {.lex_state = 3},
  [164] = {.lex_state = 9, .external_lex_state = 2},
  [165] = {.lex_state = 3},
  [166] = {.lex_state = 3},
  [167] = {.lex_state = 3},
  [168] = {.lex_state = 3},
  [169] = {.lex_state = 3},
  [170] = {.lex_state = 3},
  [171] = {.lex_state = 3},
  [172] = {.lex_state = 3},
  [173] = {.lex_state = 3},
  [174] = {.lex_state = 3},
  [175] = {.lex_state = 3},
  [176] = {.lex_state = 3},
  [177] = {.lex_state = 3},
  [178] = {.lex_state = 3},
  [179] = {.lex_state = 3},
  [180] = {.lex_state = 3},
  [181] = {.lex_state = 3},
  [182] = {.lex_state = 3},
  [183] = {.lex_state = 3},
  [184] = {.lex_state = 3},
  [185] = {.lex_state = 3},
  [186] = {.lex_state = 3},
  [187] = {.lex_state = 3},
  [188] = {.lex_state = 3},
  [189] = {.lex_state = 3},
  [190] = {.lex_state = 3},
  [191] = {.lex_state = 3},
  [192] = {.lex_state = 3},
  [193] = {.lex_state = 3},
  [194] = {.lex_state = 3},
  [195] = {.lex_state = 3},
  [196] = {.lex_state = 3},
  [197] = {.lex_state = 3},
  [198] = {.lex_state = 3},
  [199] = {.lex_state = 3},
  [200] = {.lex_state = 3},
  [201] = {.lex_state = 3},
  [202] = {.lex_state = 3},
  [203] = {.lex_state = 3},
  [204] = {.lex_state = 3},
  [205] = {.lex_state = 3},
  [206] = {.lex_state = 3},
  [207] = {.lex_state = 3},
  [208] = {.lex_state = 3},
  [209] = {.lex_state = 3},
  [210] = {.lex_state = 3},
  [211] = {.lex_state = 3},
  [212] = {.lex_state = 3},
  [213] = {.lex_state = 3},
  [214] = {.lex_state = 3},
  [215] = {.lex_state = 3},
  [216] = {.lex_state = 3},
  [217] = {.lex_state = 3},
  [218] = {.lex_state = 3},
  [219] = {.lex_state = 3},
  [220] = {.lex_state = 3},
  [221] = {.lex_state = 3},
  [222] = {.lex_state = 3},
  [223] = {.lex_state = 3},
  [224] = {.lex_state = 3},
  [225] = {.lex_state = 3},
  [226] = {.lex_state = 3},
  [227] = {.lex_state = 3},
  [228] = {.lex_state = 3},
  [229] = {.lex_state = 3},
  [230] = {.lex_state = 3},
  [231] = {.lex_state = 3},
  [232] = {.lex_state = 3},
  [233] = {.lex_state = 3},
  [234] = {.lex_state = 3},
  [235] = {.lex_state = 3},
  [236] = {.lex_state = 3},
  [237] = {.lex_state = 3},
  [238] = {.lex_state = 3},
  [239] = {.lex_state = 3},
  [240] = {.lex_state = 3},
  [241] = {.lex_state = 3},
  [242] = {.lex_state = 3},
  [243] = {.lex_state = 3},
  [244] = {.lex_state = 3},
  [245] = {.lex_state = 3},
  [246] = {.lex_state = 3},
  [247] = {.lex_state = 3},
  [248] = {.lex_state = 3},
  [249] = {.lex_state = 3},
  [250] = {.lex_state = 3},
  [251] = {.lex_state = 3},
  [252] = {.lex_state = 3},
  [253] = {.lex_state = 3},
  [254] = {.lex_state = 3},
  [255] = {.lex_state = 3},
  [256] = {.lex_state = 3},
  [257] = {.lex_state = 3},
  [258] = {.lex_state = 3},
  [259] = {.lex_state = 3},
  [260] = {.lex_state = 3},
  [261] = {.lex_state = 3},
  [262] = {.lex_state = 3},
  [263] = {.lex_state = 3},
  [264] = {.lex_state = 3},
  [265] = {.lex_state = 3},
  [266] = {.lex_state = 3},
  [267] = {.lex_state = 3},
  [268] = {.lex_state = 3},
  [269] = {.lex_state = 3},
  [270] = {.lex_state = 3},
  [271] = {.lex_state = 3},
  [272] = {.lex_state = 3},
  [273] = {.lex_state = 3},
  [274] = {.lex_state = 3},
  [275] = {.lex_state = 3},
  [276] = {.lex_state = 3},
  [277] = {.lex_state = 3},
  [278] = {.lex_state = 3},
  [279] = {.lex_state = 3},
  [280] = {.lex_state = 3},
  [281] = {.lex_state = 3},
  [282] = {.lex_state = 3},
  [283] = {.lex_state = 3},
  [284] = {.lex_state = 3},
  [285] = {.lex_state = 3},
  [286] = {.lex_state = 3},
  [287] = {.lex_state = 3},
  [288] = {.lex_state = 3},
  [289] = {.lex_state = 3},
  [290] = {.lex_state = 3},
  [291] = {.lex_state = 3},
  [292] = {.lex_state = 3},
  [293] = {.lex_state = 3},
  [294] = {.lex_state = 3},
  [295] = {.lex_state = 3},
  [296] = {.lex_state = 3},
  [297] = {.lex_state = 3},
  [298] = {.lex_state = 3},
  [299] = {.lex_state = 3},
  [300] = {.lex_state = 3},
  [301] = {.lex_state = 3},
  [302] = {.lex_state = 3},
  [303] = {.lex_state = 3},
  [304] = {.lex_state = 3},
  [305] = {.lex_state = 3},
  [306] = {.lex_state = 3},
  [307] = {.lex_state = 3},
  [308] = {.lex_state = 3},
  [309] = {.lex_state = 3},
  [310] = {.lex_state = 3},
  [311] = {.lex_state = 3},
  [312] = {.lex_state = 3},
  [313] = {.lex_state = 3},
  [314] = {.lex_state = 3},
  [315] = {.lex_state = 3},
  [316] = {.lex_state = 3},
  [317] = {.lex_state = 3},
  [318] = {.lex_state = 3},
  [319] = {.lex_state = 3},
  [320] = {.lex_state = 3},
  [321] = {.lex_state = 3},
  [322] = {.lex_state = 3},
  [323] = {.lex_state = 3},
  [324] = {.lex_state = 3},
  [325] = {.lex_state = 3},
  [326] = {.lex_state = 9, .external_lex_state = 2},
  [327] = {.lex_state = 3},
  [328] = {.lex_state = 3},
  [329] = {.lex_state = 3},
  [330] = {.lex_state = 3},
  [331] = {.lex_state = 3},
  [332] = {.lex_state = 3},
  [333] = {.lex_state = 3},
  [334] = {.lex_state = 3},
  [335] = {.lex_state = 3},
  [336] = {.lex_state = 3},
  [337] = {.lex_state = 3},
  [338] = {.lex_state = 3},
  [339] = {.lex_state = 3},
  [340] = {.lex_state = 3},
  [341] = {.lex_state = 3},
  [342] = {.lex_state = 3},
  [343] = {.lex_state = 3},
  [344] = {.lex_state = 3},
  [345] = {.lex_state = 3},
  [346] = {.lex_state = 3},
  [347] = {.lex_state = 3},
  [348] = {.lex_state = 3},
  [349] = {.lex_state = 3},
  [350] = {.lex_state = 3},
  [351] = {.lex_state = 3},
  [352] = {.lex_state = 3},
  [353] = {.lex_state = 3},
  [354] = {.lex_state = 3},
  [355] = {.lex_state = 3},
  [356] = {.lex_state = 3},
  [357] = {.lex_state = 3},
  [358] = {.lex_state = 3},
  [359] = {.lex_state = 3},
  [360] = {.lex_state = 3},
  [361] = {.lex_state = 3},
  [362] = {.lex_state = 3},
  [363] = {.lex_state = 3},
  [364] = {.lex_state = 3},
  [365] = {.lex_state = 3},
  [366] = {.lex_state = 3},
  [367] = {.lex_state = 3},
  [368] = {.lex_state = 3},
  [369] = {.lex_state = 3},
  [370] = {.lex_state = 3},
  [371] = {.lex_state = 3},
  [372] = {.lex_state = 3},
  [373] = {.lex_state = 3},
  [374] = {.lex_state = 3},
  [375] = {.lex_state = 3},
  [376] = {.lex_state = 3},
  [377] = {.lex_state = 3},
  [378] = {.lex_state = 9, .external_lex_state = 2},
  [379] = {.lex_state = 3},
  [380] = {.lex_state = 3},
  [381] = {.lex_state = 3},
  [382] = {.lex_state = 3},
  [383] = {.lex_state = 3},
  [384] = {.lex_state = 3},
  [385] = {.lex_state = 3},
  [386] = {.lex_state = 3},
  [387] = {.lex_state = 3},
  [388] = {.lex_state = 3},
  [389] = {.lex_state = 3},
  [390] = {.lex_state = 3},
  [391] = {.lex_state = 3},
  [392] = {.lex_state = 3},
  [393] = {.lex_state = 3},
  [394] = {.lex_state = 3},
  [395] = {.lex_state = 3},
  [396] = {.lex_state = 3},
  [397] = {.lex_state = 3},
  [398] = {.lex_state = 3},
  [399] = {.lex_state = 3},
  [400] = {.lex_state = 3},
  [401] = {.lex_state = 3},
  [402] = {.lex_state = 3},
  [403] = {.lex_state = 3},
  [404] = {.lex_state = 3},
  [405] = {.lex_state = 3},
  [406] = {.lex_state = 3},
  [407] = {.lex_state = 3},
  [408] = {.lex_state = 3},
  [409] = {.lex_state = 3},
  [410] = {.lex_state = 3},
  [411] = {.lex_state = 3},
  [412] = {.lex_state = 9, .external_lex_state = 2},
  [413] = {.lex_state = 3},
  [414] = {.lex_state = 3},
  [415] = {.lex_state = 9, .external_lex_state = 2},
  [416] = {.lex_state = 3},
  [417] = {.lex_state = 3},
  [418] = {.lex_state = 3},
  [419] = {.lex_state = 9, .external_lex_state = 2},
  [420] = {.lex_state = 3},
  [421] = {.lex_state = 3},
  [422] = {.lex_state = 3},
  [423] = {.lex_state = 3},
  [424] = {.lex_state = 3},
  [425] = {.lex_state = 3},
  [426] = {.lex_state = 3},
  [427] = {.lex_state = 3},
  [428] = {.lex_state = 3},
  [429] = {.lex_state = 3},
  [430] = {.lex_state = 3},
  [431] = {.lex_state = 3},
  [432] = {.lex_state = 3},
  [433] = {.lex_state = 3},
  [434] = {.lex_state = 3},
  [435] = {.lex_state = 3},
  [436] = {.lex_state = 3},
  [437] = {.lex_state = 3},
  [438] = {.lex_state = 3},
  [439] = {.lex_state = 3},
  [440] = {.lex_state = 3},
  [441] = {.lex_state = 3},
  [442] = {.lex_state = 9, .external_lex_state = 2},
  [443] = {.lex_state = 9, .external_lex_state = 2},
  [444] = {.lex_state = 9, .external_lex_state = 2},
  [445] = {.lex_state = 9, .external_lex_state = 2},
  [446] = {.lex_state = 3},
  [447] = {.lex_state = 9, .external_lex_state = 2},
  [448] = {.lex_state = 9, .external_lex_state = 2},
  [449] = {.lex_state = 18},
  [450] = {.lex_state = 3, .external_lex_state = 2},
  [451] = {.lex_state = 18},
  [452] = {.lex_state = 3},
  [453] = {.lex_state = 18},
  [454] = {.lex_state = 18},
  [455] = {.lex_state = 18},
  [456] = {.lex_state = 3, .external_lex_state = 2},
  [457] = {.lex_state = 3},
  [458] = {.lex_state = 9, .external_lex_state = 2},
  [459] = {.lex_state = 9, .external_lex_state = 2},
  [460] = {.lex_state = 9, .external_lex_state = 2},
  [461] = {.lex_state = 3},
  [462] = {.lex_state = 9},
  [463] = {.lex_state = 3},
  [464] = {.lex_state = 3},
  [465] = {.lex_state = 9},
  [466] = {.lex_state = 9, .external_lex_state = 2},
  [467] = {.lex_state = 3},
  [468] = {.lex_state = 3},
  [469] = {.lex_state = 3},
  [470] = {.lex_state = 3},
  [471] = {.lex_state = 3},
  [472] = {.lex_state = 3},
  [473] = {.lex_state = 3},
  [474] = {.lex_state = 3, .external_lex_state = 2},
  [475] = {.lex_state = 3},
  [476] = {.lex_state = 3, .external_lex_state = 2},
  [477] = {.lex_state = 3, .external_lex_state = 2},
  [478] = {.lex_state = 9, .external_lex_state = 2},
  [479] = {.lex_state = 10},
  [480] = {.lex_state = 3, .external_lex_state = 2},
  [481] = {.lex_state = 3, .external_lex_state = 2},
  [482] = {.lex_state = 9, .external_lex_state = 2},
  [483] = {.lex_state = 3, .external_lex_state = 2},
  [484] = {.lex_state = 3, .external_lex_state = 2},
  [485] = {.lex_state = 3},
  [486] = {.lex_state = 3, .external_lex_state = 2},
  [487] = {.lex_state = 3, .external_lex_state = 2},
  [488] = {.lex_state = 3, .external_lex_state = 2},
  [489] = {.lex_state = 3, .external_lex_state = 2},
  [490] = {.lex_state = 3},
  [491] = {.lex_state = 3, .external_lex_state = 2},
  [492] = {.lex_state = 3, .external_lex_state = 2},
  [493] = {.lex_state = 3, .external_lex_state = 2},
  [494] = {.lex_state = 9, .external_lex_state = 2},
  [495] = {.lex_state = 3, .external_lex_state = 2},
  [496] = {.lex_state = 3, .external_lex_state = 2},
  [497] = {.lex_state = 3},
  [498] = {.lex_state = 3, .external_lex_state = 2},
  [499] = {.lex_state = 3},
  [500] = {.lex_state = 9},
  [501] = {.lex_state = 3},
  [502] = {.lex_state = 3},
  [503] = {.lex_state = 9, .external_lex_state = 2},
  [504] = {.lex_state = 3, .external_lex_state = 2},
  [505] = {.lex_state = 3},
  [506] = {.lex_state = 3},
  [507] = {.lex_state = 3},
  [508] = {.lex_state = 3},
  [509] = {.lex_state = 3},
  [510] = {.lex_state = 3},
  [511] = {.lex_state = 9},
  [512] = {.lex_state = 3},
  [513] = {.lex_state = 3},
  [514] = {.lex_state = 3},
  [515] = {.lex_state = 3},
  [516] = {.lex_state = 9},
  [517] = {.lex_state = 3},
  [518] = {.lex_state = 3},
  [519] = {.lex_state = 3},
  [520] = {.lex_state = 3},
  [521] = {.lex_state = 3},
  [522] = {.lex_state = 3},
  [523] = {.lex_state = 3},
  [524] = {.lex_state = 3},
  [525] = {.lex_state = 3},
  [526] = {.lex_state = 3},
  [527] = {.lex_state = 3},
  [528] = {.lex_state = 3},
  [529] = {.lex_state = 3},
  [530] = {.lex_state = 9},
  [531] = {.lex_state = 3},
  [532] = {.lex_state = 3},
  [533] = {.lex_state = 3},
  [534] = {.lex_state = 3},
  [535] = {.lex_state = 3},
  [536] = {.lex_state = 3},
  [537] = {.lex_state = 3},
  [538] = {.lex_state = 3},
  [539] = {.lex_state = 3},
  [540] = {.lex_state = 3},
  [541] = {.lex_state = 3},
  [542] = {.lex_state = 3},
  [543] = {.lex_state = 3},
  [544] = {.lex_state = 3},
  [545] = {.lex_state = 3},
  [546] = {.lex_state = 9},
  [547] = {.lex_state = 3},
  [548] = {.lex_state = 3},
  [549] = {.lex_state = 3},
  [550] = {.lex_state = 10},
  [551] = {.lex_state = 3},
  [552] = {.lex_state = 9, .external_lex_state = 2},
  [553] = {.lex_state = 3},
  [554] = {.lex_state = 3},
  [555] = {.lex_state = 3},
  [556] = {.lex_state = 3},
  [557] = {.lex_state = 3},
  [558] = {.lex_state = 3},
  [559] = {.lex_state = 3},
  [560] = {.lex_state = 3},
  [561] = {.lex_state = 3},
  [562] = {.lex_state = 3},
  [563] = {.lex_state = 3},
  [564] = {.lex_state = 3},
  [565] = {.lex_state = 3},
  [566] = {.lex_state = 3},
  [567] = {.lex_state = 3},
  [568] = {.lex_state = 3},
  [569] = {.lex_state = 3},
  [570] = {.lex_state = 3},
  [571] = {.lex_state = 3},
  [572] = {.lex_state = 3},
  [573] = {.lex_state = 3},
  [574] = {.lex_state = 3},
  [575] = {.lex_state = 3},
  [576] = {.lex_state = 3},
  [577] = {.lex_state = 3},
  [578] = {.lex_state = 3},
  [579] = {.lex_state = 3},
  [580] = {.lex_state = 9},
  [581] = {.lex_state = 3},
  [582] = {.lex_state = 3},
  [583] = {.lex_state = 3},
  [584] = {.lex_state = 3},
  [585] = {.lex_state = 3},
  [586] = {.lex_state = 3},
  [587] = {.lex_state = 3},
  [588] = {.lex_state = 9},
  [589] = {.lex_state = 9},
  [590] = {.lex_state = 9},
  [591] = {.lex_state = 9},
  [592] = {.lex_state = 9, .external_lex_state = 2},
  [593] = {.lex_state = 9},
  [594] = {.lex_state = 9},
  [595] = {.lex_state = 3},
  [596] = {.lex_state = 3},
  [597] = {.lex_state = 3},
  [598] = {.lex_state = 3},
  [599] = {.lex_state = 3},
  [600] = {.lex_state = 3},
  [601] = {.lex_state = 3},
  [602] = {.lex_state = 3},
  [603] = {.lex_state = 3},
  [604] = {.lex_state = 3},
  [605] = {.lex_state = 9, .external_lex_state = 2},
  [606] = {.lex_state = 9, .external_lex_state = 2},
  [607] = {.lex_state = 9, .external_lex_state = 2},
  [608] = {.lex_state = 9, .external_lex_state = 2},
  [609] = {.lex_state = 9},
  [610] = {.lex_state = 9, .external_lex_state = 2},
  [611] = {.lex_state = 9, .external_lex_state = 2},
  [612] = {.lex_state = 9, .external_lex_state = 2},
  [613] = {.lex_state = 9},
  [614] = {.lex_state = 3},
  [615] = {.lex_state = 3},
  [616] = {.lex_state = 9},
  [617] = {.lex_state = 3},
  [618] = {.lex_state = 9, .external_lex_state = 2},
  [619] = {.lex_state = 3},
  [620] = {.lex_state = 9, .external_lex_state = 2},
  [621] = {.lex_state = 3},
  [622] = {.lex_state = 9, .external_lex_state = 2},
  [623] = {.lex_state = 3},
  [624] = {.lex_state = 9, .external_lex_state = 2},
  [625] = {.lex_state = 3},
  [626] = {.lex_state = 9, .external_lex_state = 2},
  [627] = {.lex_state = 9, .external_lex_state = 2},
  [628] = {.lex_state = 10},
  [629] = {.lex_state = 9},
  [630] = {.lex_state = 9},
  [631] = {.lex_state = 9, .external_lex_state = 2},
  [632] = {.lex_state = 9},
  [633] = {.lex_state = 9},
  [634] = {.lex_state = 9},
  [635] = {.lex_state = 10},
  [636] = {.lex_state = 9},
  [637] = {.lex_state = 9, .external_lex_state = 2},
  [638] = {.lex_state = 9},
  [639] = {.lex_state = 3},
  [640] = {.lex_state = 9, .external_lex_state = 2},
  [641] = {.lex_state = 9},
  [642] = {.lex_state = 3},
  [643] = {.lex_state = 9},
  [644] = {.lex_state = 18},
  [645] = {.lex_state = 9, .external_lex_state = 2},
  [646] = {.lex_state = 9},
  [647] = {.lex_state = 9},
  [648] = {.lex_state = 9, .external_lex_state = 2},
  [649] = {.lex_state = 18},
  [650] = {.lex_state = 18},
  [651] = {.lex_state = 9},
  [652] = {.lex_state = 9},
  [653] = {.lex_state = 9, .external_lex_state = 2},
  [654] = {.lex_state = 9, .external_lex_state = 2},
  [655] = {.lex_state = 18},
  [656] = {.lex_state = 9},
  [657] = {.lex_state = 9},
  [658] = {.lex_state = 9},
  [659] = {.lex_state = 9, .external_lex_state = 2},
  [660] = {.lex_state = 9, .external_lex_state = 2},
  [661] = {.lex_state = 18},
  [662] = {.lex_state = 18},
  [663] = {.lex_state = 9},
  [664] = {.lex_state = 18},
  [665] = {.lex_state = 9, .external_lex_state = 2},
  [666] = {.lex_state = 18},
  [667] = {.lex_state = 18},
  [668] = {.lex_state = 9},
  [669] = {.lex_state = 18},
  [670] = {.lex_state = 18},
  [671] = {.lex_state = 9},
  [672] = {.lex_state = 18},
  [673] = {.lex_state = 9},
  [674] = {.lex_state = 18},
  [675] = {.lex_state = 9, .external_lex_state = 2},
  [676] = {.lex_state = 9, .external_lex_state = 2},
  [677] = {.lex_state = 18},
  [678] = {.lex_state = 18},
  [679] = {.lex_state = 9},
  [680] = {.lex_state = 18},
  [681] = {.lex_state = 9, .external_lex_state = 2},
  [682] = {.lex_state = 9, .external_lex_state = 2},
  [683] = {.lex_state = 18},
  [684] = {.lex_state = 18},
  [685] = {.lex_state = 18},
  [686] = {.lex_state = 18},
  [687] = {.lex_state = 18},
  [688] = {.lex_state = 18},
  [689] = {.lex_state = 18},
  [690] = {.lex_state = 18},
  [691] = {.lex_state = 18},
  [692] = {.lex_state = 18},
  [693] = {.lex_state = 9, .external_lex_state = 2},
  [694] = {.lex_state = 18},
  [695] = {.lex_state = 18},
  [696] = {.lex_state = 9},
  [697] = {.lex_state = 18},
  [698] = {.lex_state = 18},
  [699] = {.lex_state = 18},
  [700] = {.lex_state = 18},
  [701] = {.lex_state = 18},
  [702] = {.lex_state = 18},
  [703] = {.lex_state = 18},
  [704] = {.lex_state = 18},
  [705] = {.lex_state = 18},
  [706] = {.lex_state = 18},
  [707] = {.lex_state = 18},
  [708] = {.lex_state = 18},
  [709] = {.lex_state = 18},
  [710] = {.lex_state = 18},
  [711] = {.lex_state = 18},
  [712] = {.lex_state = 18},
  [713] = {.lex_state = 18},
  [714] = {.lex_state = 18},
  [715] = {.lex_state = 18},
  [716] = {.lex_state = 18},
  [717] = {.lex_state = 18},
  [718] = {.lex_state = 18},
  [719] = {.lex_state = 18},
  [720] = {.lex_state = 18},
  [721] = {.lex_state = 18},
  [722] = {.lex_state = 18},
  [723] = {.lex_state = 18},
  [724] = {.lex_state = 9, .external_lex_state = 2},
  [725] = {.lex_state = 18},
  [726] = {.lex_state = 18},
  [727] = {.lex_state = 18},
  [728] = {.lex_state = 18},
  [729] = {.lex_state = 18},
  [730] = {.lex_state = 18},
  [731] = {.lex_state = 9},
  [732] = {.lex_state = 10},
  [733] = {.lex_state = 18},
  [734] = {.lex_state = 18},
  [735] = {.lex_state = 18},
  [736] = {.lex_state = 18},
  [737] = {.lex_state = 18},
  [738] = {.lex_state = 18},
  [739] = {.lex_state = 18},
  [740] = {.lex_state = 18},
  [741] = {.lex_state = 18},
  [742] = {.lex_state = 18},
  [743] = {.lex_state = 18},
  [744] = {.lex_state = 18},
  [745] = {.lex_state = 18},
  [746] = {.lex_state = 18},
  [747] = {.lex_state = 18},
  [748] = {.lex_state = 18},
  [749] = {.lex_state = 18},
  [750] = {.lex_state = 18},
  [751] = {.lex_state = 18},
  [752] = {.lex_state = 18},
  [753] = {.lex_state = 18},
  [754] = {.lex_state = 9},
  [755] = {.lex_state = 9},
  [756] = {.lex_state = 18},
  [757] = {.lex_state = 18},
  [758] = {.lex_state = 9, .external_lex_state = 2},
  [759] = {.lex_state = 9, .external_lex_state = 2},
  [760] = {.lex_state = 18},
  [761] = {.lex_state = 18},
  [762] = {.lex_state = 18},
  [763] = {.lex_state = 9},
  [764] = {.lex_state = 18},
  [765] = {.lex_state = 18},
  [766] = {.lex_state = 18},
  [767] = {.lex_state = 9, .external_lex_state = 2},
  [768] = {.lex_state = 18},
  [769] = {.lex_state = 18},
  [770] = {.lex_state = 18},
  [771] = {.lex_state = 18},
  [772] = {.lex_state = 18},
  [773] = {.lex_state = 9},
  [774] = {.lex_state = 10},
  [775] = {.lex_state = 18},
  [776] = {.lex_state = 18},
  [777] = {.lex_state = 18},
  [778] = {.lex_state = 18},
  [779] = {.lex_state = 18},
  [780] = {.lex_state = 18},
  [781] = {.lex_state = 18},
  [782] = {.lex_state = 18},
  [783] = {.lex_state = 9},
  [784] = {.lex_state = 9, .external_lex_state = 2},
  [785] = {.lex_state = 9},
  [786] = {.lex_state = 9, .external_lex_state = 2},
  [787] = {.lex_state = 18},
  [788] = {.lex_state = 18},
  [789] = {.lex_state = 18},
  [790] = {.lex_state = 18},
  [791] = {.lex_state = 18},
  [792] = {.lex_state = 18},
  [793] = {.lex_state = 18},
  [794] = {.lex_state = 18},
  [795] = {.lex_state = 18},
  [796] = {.lex_state = 9, .external_lex_state = 2},
  [797] = {.lex_state = 9, .external_lex_state = 2},
  [798] = {.lex_state = 9},
  [799] = {.lex_state = 9, .external_lex_state = 2},
  [800] = {.lex_state = 9, .external_lex_state = 2},
  [801] = {.lex_state = 9, .external_lex_state = 2},
  [802] = {.lex_state = 10},
  [803] = {.lex_state = 9},
  [804] = {.lex_state = 9, .external_lex_state = 2},
  [805] = {.lex_state = 9, .external_lex_state = 2},
  [806] = {.lex_state = 9, .external_lex_state = 2},
  [807] = {.lex_state = 9, .external_lex_state = 2},
  [808] = {.lex_state = 9},
  [809] = {.lex_state = 9, .external_lex_state = 2},
  [810] = {.lex_state = 9, .external_lex_state = 2},
  [811] = {.lex_state = 9, .external_lex_state = 2},
  [812] = {.lex_state = 9, .external_lex_state = 2},
  [813] = {.lex_state = 9, .external_lex_state = 2},
  [814] = {.lex_state = 9, .external_lex_state = 2},
  [815] = {.lex_state = 10},
  [816] = {.lex_state = 10},
  [817] = {.lex_state = 9, .external_lex_state = 2},
  [818] = {.lex_state = 9, .external_lex_state = 2},
  [819] = {.lex_state = 9, .external_lex_state = 2},
  [820] = {.lex_state = 9},
  [821] = {.lex_state = 9, .external_lex_state = 2},
  [822] = {.lex_state = 9, .external_lex_state = 2},
  [823] = {.lex_state = 9},
  [824] = {.lex_state = 9},
  [825] = {.lex_state = 9, .external_lex_state = 2},
  [826] = {.lex_state = 9},
  [827] = {.lex_state = 10},
  [828] = {.lex_state = 10},
  [829] = {.lex_state = 10},
  [830] = {.lex_state = 9, .external_lex_state = 2},
  [831] = {.lex_state = 9, .external_lex_state = 2},
  [832] = {.lex_state = 9, .external_lex_state = 2},
  [833] = {.lex_state = 9},
  [834] = {.lex_state = 9},
  [835] = {.lex_state = 9},
  [836] = {.lex_state = 9, .external_lex_state = 2},
  [837] = {.lex_state = 9},
  [838] = {.lex_state = 9},
  [839] = {.lex_state = 9},
  [840] = {.lex_state = 9},
  [841] = {.lex_state = 10},
  [842] = {.lex_state = 9, .external_lex_state = 2},
  [843] = {.lex_state = 9},
  [844] = {.lex_state = 9, .external_lex_state = 2},
  [845] = {.lex_state = 9},
  [846] = {.lex_state = 9},
  [847] = {.lex_state = 9, .external_lex_state = 2},
  [848] = {.lex_state = 9, .external_lex_state = 2},
  [849] = {.lex_state = 9},
  [850] = {.lex_state = 9},
  [851] = {.lex_state = 9},
  [852] = {.lex_state = 10},
  [853] = {.lex_state = 9},
  [854] = {.lex_state = 9},
  [855] = {.lex_state = 10},
  [856] = {.lex_state = 9, .external_lex_state = 2},
  [857] = {.lex_state = 9},
  [858] = {.lex_state = 9},
  [859] = {.lex_state = 9, .external_lex_state = 2},
  [860] = {.lex_state = 10},
  [861] = {.lex_state = 9},
  [862] = {.lex_state = 9},
  [863] = {.lex_state = 9},
  [864] = {.lex_state = 9},
  [865] = {.lex_state = 10},
  [866] = {.lex_state = 9},
  [867] = {.lex_state = 10},
  [868] = {.lex_state = 9},
  [869] = {.lex_state = 9, .external_lex_state = 2},
  [870] = {.lex_state = 9},
  [871] = {.lex_state = 9},
  [872] = {.lex_state = 10},
  [873] = {.lex_state = 9},
  [874] = {.lex_state = 9, .external_lex_state = 2},
  [875] = {.lex_state = 10},
  [876] = {.lex_state = 9},
  [877] = {.lex_state = 10},
  [878] = {.lex_state = 10},
  [879] = {.lex_state = 10},
  [880] = {.lex_state = 10},
  [881] = {.lex_state = 9},
  [882] = {.lex_state = 9},
  [883] = {.lex_state = 3, .external_lex_state = 2},
  [884] = {.lex_state = 9},
  [885] = {.lex_state = 3},
  [886] = {.lex_state = 9},
  [887] = {.lex_state = 3, .external_lex_state = 2},
  [888] = {.lex_state = 9},
  [889] = {.lex_state = 3},
  [890] = {.lex_state = 3},
  [891] = {.lex_state = 3},
  [892] = {.lex_state = 3},
  [893] = {.lex_state = 3, .external_lex_state = 2},
  [894] = {.lex_state = 9},
  [895] = {.lex_state = 9},
  [896] = {.lex_state = 9, .external_lex_state = 2},
  [897] = {.lex_state = 3, .external_lex_state = 2},
  [898] = {.lex_state = 3, .external_lex_state = 2},
  [899] = {.lex_state = 9},
  [900] = {.lex_state = 9},
  [901] = {.lex_state = 2, .external_lex_state = 2},
  [902] = {.lex_state = 3},
  [903] = {.lex_state = 3},
  [904] = {.lex_state = 3},
  [905] = {.lex_state = 3},
  [906] = {.lex_state = 3},
  [907] = {.lex_state = 3},
  [908] = {.lex_state = 3},
  [909] = {.lex_state = 3},
  [910] = {.lex_state = 3},
  [911] = {.lex_state = 3},
  [912] = {.lex_state = 3},
  [913] = {.lex_state = 3},
  [914] = {.lex_state = 3},
  [915] = {.lex_state = 3},
  [916] = {.lex_state = 3},
  [917] = {.lex_state = 3},
  [918] = {.lex_state = 3},
  [919] = {.lex_state = 3},
  [920] = {.lex_state = 3},
  [921] = {.lex_state = 3},
  [922] = {.lex_state = 3},
  [923] = {.lex_state = 2},
  [924] = {.lex_state = 2},
  [925] = {.lex_state = 2},
  [926] = {.lex_state = 2},
  [927] = {.lex_state = 2},
  [928] = {.lex_state = 2},
  [929] = {.lex_state = 2},
  [930] = {.lex_state = 2},
  [931] = {.lex_state = 2},
  [932] = {.lex_state = 2},
  [933] = {.lex_state = 2},
  [934] = {.lex_state = 2, .external_lex_state = 2},
  [935] = {.lex_state = 2},
  [936] = {.lex_state = 2, .external_lex_state = 2},
  [937] = {.lex_state = 2},
  [938] = {.lex_state = 2, .external_lex_state = 2},
  [939] = {.lex_state = 2},
  [940] = {.lex_state = 2},
  [941] = {.lex_state = 2},
  [942] = {.lex_state = 2},
  [943] = {.lex_state = 2},
  [944] = {.lex_state = 2},
  [945] = {.lex_state = 2},
  [946] = {.lex_state = 2},
  [947] = {.lex_state = 2, .external_lex_state = 2},
  [948] = {.lex_state = 2},
  [949] = {.lex_state = 2},
  [950] = {.lex_state = 2},
  [951] = {.lex_state = 2},
  [952] = {.lex_state = 2},
  [953] = {.lex_state = 2, .external_lex_state = 2},
  [954] = {.lex_state = 18},
  [955] = {.lex_state = 2},
  [956] = {.lex_state = 2},
  [957] = {.lex_state = 2},
  [958] = {.lex_state = 2},
  [959] = {.lex_state = 2},
  [960] = {.lex_state = 18},
  [961] = {.lex_state = 2},
  [962] = {.lex_state = 2},
  [963] = {.lex_state = 2},
  [964] = {.lex_state = 2},
  [965] = {.lex_state = 2},
  [966] = {.lex_state = 2},
  [967] = {.lex_state = 2},
  [968] = {.lex_state = 2},
  [969] = {.lex_state = 2},
  [970] = {.lex_state = 18},
  [971] = {.lex_state = 2},
  [972] = {.lex_state = 2},
  [973] = {.lex_state = 18},
  [974] = {.lex_state = 2},
  [975] = {.lex_state = 18},
  [976] = {.lex_state = 2},
  [977] = {.lex_state = 2},
  [978] = {.lex_state = 2},
  [979] = {.lex_state = 2},
  [980] = {.lex_state = 2},
  [981] = {.lex_state = 2, .external_lex_state = 2},
  [982] = {.lex_state = 2},
  [983] = {.lex_state = 2},
  [984] = {.lex_state = 2},
  [985] = {.lex_state = 2},
  [986] = {.lex_state = 2},
  [987] = {.lex_state = 2},
  [988] = {.lex_state = 2},
  [989] = {.lex_state = 2, .external_lex_state = 2},
  [990] = {.lex_state = 2},
  [991] = {.lex_state = 18},
  [992] = {.lex_state = 18},
  [993] = {.lex_state = 2, .external_lex_state = 2},
  [994] = {.lex_state = 2, .external_lex_state = 2},
  [995] = {.lex_state = 2, .external_lex_state = 2},
  [996] = {.lex_state = 2},
  [997] = {.lex_state = 11},
  [998] = {.lex_state = 2, .external_lex_state = 2},
  [999] = {.lex_state = 2, .external_lex_state = 2},
  [1000] = {.lex_state = 2, .external_lex_state = 2},
  [1001] = {.lex_state = 2},
  [1002] = {.lex_state = 2, .external_lex_state = 2},
  [1003] = {.lex_state = 2, .external_lex_state = 2},
  [1004] = {.lex_state = 2, .external_lex_state = 2},
  [1005] = {.lex_state = 2, .external_lex_state = 2},
  [1006] = {.lex_state = 2, .external_lex_state = 2},
  [1007] = {.lex_state = 2, .external_lex_state = 2},
  [1008] = {.lex_state = 2},
  [1009] = {.lex_state = 2},
  [1010] = {.lex_state = 2},
  [1011] = {.lex_state = 2, .external_lex_state = 2},
  [1012] = {.lex_state = 2, .external_lex_state = 2},
  [1013] = {.lex_state = 2},
  [1014] = {.lex_state = 2, .external_lex_state = 2},
  [1015] = {.lex_state = 2, .external_lex_state = 2},
  [1016] = {.lex_state = 2, .external_lex_state = 2},
  [1017] = {.lex_state = 2, .external_lex_state = 2},
  [1018] = {.lex_state = 2, .external_lex_state = 2},
  [1019] = {.lex_state = 2},
  [1020] = {.lex_state = 3},
  [1021] = {.lex_state = 2},
  [1022] = {.lex_state = 2},
  [1023] = {.lex_state = 2},
  [1024] = {.lex_state = 2, .external_lex_state = 2},
  [1025] = {.lex_state = 2, .external_lex_state = 2},
  [1026] = {.lex_state = 2},
  [1027] = {.lex_state = 2},
  [1028] = {.lex_state = 2, .external_lex_state = 2},
  [1029] = {.lex_state = 2},
  [1030] = {.lex_state = 2, .external_lex_state = 2},
  [1031] = {.lex_state = 2, .external_lex_state = 2},
  [1032] = {.lex_state = 2},
  [1033] = {.lex_state = 2},
  [1034] = {.lex_state = 2},
  [1035] = {.lex_state = 2, .external_lex_state = 2},
  [1036] = {.lex_state = 2, .external_lex_state = 2},
  [1037] = {.lex_state = 2},
  [1038] = {.lex_state = 2},
  [1039] = {.lex_state = 2},
  [1040] = {.lex_state = 2, .external_lex_state = 2},
  [1041] = {.lex_state = 2},
  [1042] = {.lex_state = 2, .external_lex_state = 2},
  [1043] = {.lex_state = 2, .external_lex_state = 2},
  [1044] = {.lex_state = 2},
  [1045] = {.lex_state = 2},
  [1046] = {.lex_state = 2},
  [1047] = {.lex_state = 2},
  [1048] = {.lex_state = 2},
  [1049] = {.lex_state = 2},
  [1050] = {.lex_state = 2},
  [1051] = {.lex_state = 2, .external_lex_state = 2},
  [1052] = {.lex_state = 2},
  [1053] = {.lex_state = 2, .external_lex_state = 2},
  [1054] = {.lex_state = 2},
  [1055] = {.lex_state = 2},
  [1056] = {.lex_state = 2},
  [1057] = {.lex_state = 2, .external_lex_state = 2},
  [1058] = {.lex_state = 2, .external_lex_state = 2},
  [1059] = {.lex_state = 2},
  [1060] = {.lex_state = 2},
  [1061] = {.lex_state = 2},
  [1062] = {.lex_state = 2},
  [1063] = {.lex_state = 2, .external_lex_state = 2},
  [1064] = {.lex_state = 2, .external_lex_state = 2},
  [1065] = {.lex_state = 2},
  [1066] = {.lex_state = 2},
  [1067] = {.lex_state = 3},
  [1068] = {.lex_state = 2},
  [1069] = {.lex_state = 2},
  [1070] = {.lex_state = 2, .external_lex_state = 2},
  [1071] = {.lex_state = 2},
  [1072] = {.lex_state = 2, .external_lex_state = 2},
  [1073] = {.lex_state = 2, .external_lex_state = 2},
  [1074] = {.lex_state = 2},
  [1075] = {.lex_state = 11},
  [1076] = {.lex_state = 2},
  [1077] = {.lex_state = 2},
  [1078] = {.lex_state = 2},
  [1079] = {.lex_state = 2},
  [1080] = {.lex_state = 2},
  [1081] = {.lex_state = 2},
  [1082] = {.lex_state = 2},
  [1083] = {.lex_state = 2},
  [1084] = {.lex_state = 2},
  [1085] = {.lex_state = 2, .external_lex_state = 2},
  [1086] = {.lex_state = 2, .external_lex_state = 2},
  [1087] = {.lex_state = 2, .external_lex_state = 2},
  [1088] = {.lex_state = 2},
  [1089] = {.lex_state = 2, .external_lex_state = 2},
  [1090] = {.lex_state = 2, .external_lex_state = 2},
  [1091] = {.lex_state = 2},
  [1092] = {.lex_state = 2},
  [1093] = {.lex_state = 2},
  [1094] = {.lex_state = 2, .external_lex_state = 2},
  [1095] = {.lex_state = 2, .external_lex_state = 2},
  [1096] = {.lex_state = 2},
  [1097] = {.lex_state = 2, .external_lex_state = 2},
  [1098] = {.lex_state = 2},
  [1099] = {.lex_state = 2},
  [1100] = {.lex_state = 2},
  [1101] = {.lex_state = 2},
  [1102] = {.lex_state = 11},
  [1103] = {.lex_state = 2},
  [1104] = {.lex_state = 2},
  [1105] = {.lex_state = 11},
  [1106] = {.lex_state = 2},
  [1107] = {.lex_state = 2},
  [1108] = {.lex_state = 2},
  [1109] = {.lex_state = 2},
  [1110] = {.lex_state = 2},
  [1111] = {.lex_state = 2, .external_lex_state = 2},
  [1112] = {.lex_state = 2},
  [1113] = {.lex_state = 2},
  [1114] = {.lex_state = 2},
  [1115] = {.lex_state = 2},
  [1116] = {.lex_state = 2},
  [1117] = {.lex_state = 2, .external_lex_state = 2},
  [1118] = {.lex_state = 2},
  [1119] = {.lex_state = 3},
  [1120] = {.lex_state = 2},
  [1121] = {.lex_state = 2},
  [1122] = {.lex_state = 2},
  [1123] = {.lex_state = 2},
  [1124] = {.lex_state = 2, .external_lex_state = 2},
  [1125] = {.lex_state = 2},
  [1126] = {.lex_state = 2},
  [1127] = {.lex_state = 2},
  [1128] = {.lex_state = 2},
  [1129] = {.lex_state = 2},
  [1130] = {.lex_state = 2},
  [1131] = {.lex_state = 2},
  [1132] = {.lex_state = 2},
  [1133] = {.lex_state = 2, .external_lex_state = 2},
  [1134] = {.lex_state = 2},
  [1135] = {.lex_state = 3},
  [1136] = {.lex_state = 11},
  [1137] = {.lex_state = 3, .external_lex_state = 2},
  [1138] = {.lex_state = 12},
  [1139] = {.lex_state = 2},
  [1140] = {.lex_state = 11},
  [1141] = {.lex_state = 2, .external_lex_state = 2},
  [1142] = {.lex_state = 2},
  [1143] = {.lex_state = 2},
  [1144] = {.lex_state = 2},
  [1145] = {.lex_state = 3, .external_lex_state = 2},
  [1146] = {.lex_state = 2},
  [1147] = {.lex_state = 2, .external_lex_state = 2},
  [1148] = {.lex_state = 11},
  [1149] = {.lex_state = 2},
  [1150] = {.lex_state = 11},
  [1151] = {.lex_state = 3},
  [1152] = {.lex_state = 2, .external_lex_state = 2},
  [1153] = {.lex_state = 2},
  [1154] = {.lex_state = 2, .external_lex_state = 2},
  [1155] = {.lex_state = 2},
  [1156] = {.lex_state = 2},
  [1157] = {.lex_state = 11},
  [1158] = {.lex_state = 11},
  [1159] = {.lex_state = 11},
  [1160] = {.lex_state = 3},
  [1161] = {.lex_state = 11},
  [1162] = {.lex_state = 11},
  [1163] = {.lex_state = 11},
  [1164] = {.lex_state = 11},
  [1165] = {.lex_state = 2, .external_lex_state = 2},
  [1166] = {.lex_state = 2},
  [1167] = {.lex_state = 11},
  [1168] = {.lex_state = 2},
  [1169] = {.lex_state = 11},
  [1170] = {.lex_state = 3},
  [1171] = {.lex_state = 2},
  [1172] = {.lex_state = 11},
  [1173] = {.lex_state = 2},
  [1174] = {.lex_state = 2},
  [1175] = {.lex_state = 2},
  [1176] = {.lex_state = 2},
  [1177] = {.lex_state = 11},
  [1178] = {.lex_state = 2},
  [1179] = {.lex_state = 11},
  [1180] = {.lex_state = 2, .external_lex_state = 2},
  [1181] = {.lex_state = 11},
  [1182] = {.lex_state = 3},
  [1183] = {.lex_state = 2, .external_lex_state = 2},
  [1184] = {.lex_state = 2},
  [1185] = {.lex_state = 11},
  [1186] = {.lex_state = 2},
  [1187] = {.lex_state = 3},
  [1188] = {.lex_state = 11},
  [1189] = {.lex_state = 2},
  [1190] = {.lex_state = 2, .external_lex_state = 2},
  [1191] = {.lex_state = 2},
  [1192] = {.lex_state = 3},
  [1193] = {.lex_state = 2},
  [1194] = {.lex_state = 3},
  [1195] = {.lex_state = 2, .external_lex_state = 2},
  [1196] = {.lex_state = 3},
  [1197] = {.lex_state = 3, .external_lex_state = 2},
  [1198] = {.lex_state = 2, .external_lex_state = 2},
  [1199] = {.lex_state = 2, .external_lex_state = 2},
  [1200] = {.lex_state = 2},
  [1201] = {.lex_state = 3},
  [1202] = {.lex_state = 2, .external_lex_state = 2},
  [1203] = {.lex_state = 2},
  [1204] = {.lex_state = 2},
  [1205] = {.lex_state = 2},
  [1206] = {.lex_state = 2},
  [1207] = {.lex_state = 2},
  [1208] = {.lex_state = 2, .external_lex_state = 2},
  [1209] = {.lex_state = 2, .external_lex_state = 2},
  [1210] = {.lex_state = 2},
  [1211] = {.lex_state = 2},
  [1212] = {.lex_state = 2},
  [1213] = {.lex_state = 3},
  [1214] = {.lex_state = 2, .external_lex_state = 2},
  [1215] = {.lex_state = 2, .external_lex_state = 2},
  [1216] = {.lex_state = 2, .external_lex_state = 2},
  [1217] = {.lex_state = 11},
  [1218] = {.lex_state = 2},
  [1219] = {.lex_state = 11},
  [1220] = {.lex_state = 11},
  [1221] = {.lex_state = 11},
  [1222] = {.lex_state = 11},
  [1223] = {.lex_state = 3},
  [1224] = {.lex_state = 2},
  [1225] = {.lex_state = 2},
  [1226] = {.lex_state = 2},
  [1227] = {.lex_state = 11},
  [1228] = {.lex_state = 11},
  [1229] = {.lex_state = 2},
  [1230] = {.lex_state = 2},
  [1231] = {.lex_state = 2},
  [1232] = {.lex_state = 2},
  [1233] = {.lex_state = 3},
  [1234] = {.lex_state = 11},
  [1235] = {.lex_state = 3},
  [1236] = {.lex_state = 11},
  [1237] = {.lex_state = 2},
  [1238] = {.lex_state = 11},
  [1239] = {.lex_state = 11},
  [1240] = {.lex_state = 11},
  [1241] = {.lex_state = 2},
  [1242] = {.lex_state = 2},
  [1243] = {.lex_state = 2, .external_lex_state = 2},
  [1244] = {.lex_state = 2},
  [1245] = {.lex_state = 2},
  [1246] = {.lex_state = 2, .external_lex_state = 2},
  [1247] = {.lex_state = 2},
  [1248] = {.lex_state = 2},
  [1249] = {.lex_state = 2, .external_lex_state = 2},
  [1250] = {.lex_state = 2, .external_lex_state = 2},
  [1251] = {.lex_state = 2},
  [1252] = {.lex_state = 2, .external_lex_state = 2},
  [1253] = {.lex_state = 2, .external_lex_state = 2},
  [1254] = {.lex_state = 3, .external_lex_state = 2},
  [1255] = {.lex_state = 2, .external_lex_state = 2},
  [1256] = {.lex_state = 2, .external_lex_state = 2},
  [1257] = {.lex_state = 2},
  [1258] = {.lex_state = 2},
  [1259] = {.lex_state = 2},
  [1260] = {.lex_state = 2},
  [1261] = {.lex_state = 11, .external_lex_state = 2},
  [1262] = {.lex_state = 11},
  [1263] = {.lex_state = 2},
  [1264] = {.lex_state = 11},
  [1265] = {.lex_state = 2, .external_lex_state = 2},
  [1266] = {.lex_state = 2},
  [1267] = {.lex_state = 2},
  [1268] = {.lex_state = 11},
  [1269] = {.lex_state = 2, .external_lex_state = 2},
  [1270] = {.lex_state = 2, .external_lex_state = 2},
  [1271] = {.lex_state = 2},
  [1272] = {.lex_state = 2},
  [1273] = {.lex_state = 2},
  [1274] = {.lex_state = 2},
  [1275] = {.lex_state = 2},
  [1276] = {.lex_state = 2},
  [1277] = {.lex_state = 2},
  [1278] = {.lex_state = 2, .external_lex_state = 2},
  [1279] = {.lex_state = 2},
  [1280] = {.lex_state = 2, .external_lex_state = 2},
  [1281] = {.lex_state = 2},
  [1282] = {.lex_state = 2, .external_lex_state = 2},
  [1283] = {.lex_state = 2},
  [1284] = {.lex_state = 2, .external_lex_state = 2},
  [1285] = {.lex_state = 2, .external_lex_state = 2},
  [1286] = {.lex_state = 2},
  [1287] = {.lex_state = 2, .external_lex_state = 2},
  [1288] = {.lex_state = 2},
  [1289] = {.lex_state = 3, .external_lex_state = 2},
  [1290] = {.lex_state = 2, .external_lex_state = 2},
  [1291] = {.lex_state = 2},
  [1292] = {.lex_state = 2},
  [1293] = {.lex_state = 2},
  [1294] = {.lex_state = 2},
  [1295] = {.lex_state = 2, .external_lex_state = 2},
  [1296] = {.lex_state = 2, .external_lex_state = 2},
  [1297] = {.lex_state = 2},
  [1298] = {.lex_state = 2},
  [1299] = {.lex_state = 2, .external_lex_state = 2},
  [1300] = {.lex_state = 2, .external_lex_state = 2},
  [1301] = {.lex_state = 2},
  [1302] = {.lex_state = 2, .external_lex_state = 2},
  [1303] = {.lex_state = 2, .external_lex_state = 2},
  [1304] = {.lex_state = 2},
  [1305] = {.lex_state = 2},
  [1306] = {.lex_state = 2, .external_lex_state = 2},
  [1307] = {.lex_state = 11},
  [1308] = {.lex_state = 2, .external_lex_state = 2},
  [1309] = {.lex_state = 2},
  [1310] = {.lex_state = 2, .external_lex_state = 2},
  [1311] = {.lex_state = 2, .external_lex_state = 2},
  [1312] = {.lex_state = 2, .external_lex_state = 2},
  [1313] = {.lex_state = 2, .external_lex_state = 2},
  [1314] = {.lex_state = 2, .external_lex_state = 2},
  [1315] = {.lex_state = 2},
  [1316] = {.lex_state = 2, .external_lex_state = 2},
  [1317] = {.lex_state = 2},
  [1318] = {.lex_state = 2, .external_lex_state = 2},
  [1319] = {.lex_state = 2},
  [1320] = {.lex_state = 2},
  [1321] = {.lex_state = 12, .external_lex_state = 2},
  [1322] = {.lex_state = 2},
  [1323] = {.lex_state = 2, .external_lex_state = 2},
  [1324] = {.lex_state = 2},
  [1325] = {.lex_state = 2},
  [1326] = {.lex_state = 2, .external_lex_state = 2},
  [1327] = {.lex_state = 2, .external_lex_state = 2},
  [1328] = {.lex_state = 2, .external_lex_state = 2},
  [1329] = {.lex_state = 2},
  [1330] = {.lex_state = 2, .external_lex_state = 2},
  [1331] = {.lex_state = 2},
  [1332] = {.lex_state = 2},
  [1333] = {.lex_state = 2},
  [1334] = {.lex_state = 2, .external_lex_state = 2},
  [1335] = {.lex_state = 2, .external_lex_state = 2},
  [1336] = {.lex_state = 2, .external_lex_state = 2},
  [1337] = {.lex_state = 2, .external_lex_state = 2},
  [1338] = {.lex_state = 2, .external_lex_state = 2},
  [1339] = {.lex_state = 2, .external_lex_state = 2},
  [1340] = {.lex_state = 2},
  [1341] = {.lex_state = 2},
  [1342] = {.lex_state = 2, .external_lex_state = 2},
  [1343] = {.lex_state = 2, .external_lex_state = 2},
  [1344] = {.lex_state = 2, .external_lex_state = 2},
  [1345] = {.lex_state = 2},
  [1346] = {.lex_state = 2, .external_lex_state = 2},
  [1347] = {.lex_state = 2, .external_lex_state = 2},
  [1348] = {.lex_state = 2, .external_lex_state = 2},
  [1349] = {.lex_state = 2, .external_lex_state = 2},
  [1350] = {.lex_state = 2},
  [1351] = {.lex_state = 2, .external_lex_state = 2},
  [1352] = {.lex_state = 2, .external_lex_state = 2},
  [1353] = {.lex_state = 2, .external_lex_state = 2},
  [1354] = {.lex_state = 2, .external_lex_state = 2},
  [1355] = {.lex_state = 3, .external_lex_state = 2},
  [1356] = {.lex_state = 3, .external_lex_state = 2},
  [1357] = {.lex_state = 2, .external_lex_state = 2},
  [1358] = {.lex_state = 2, .external_lex_state = 2},
  [1359] = {.lex_state = 2, .external_lex_state = 2},
  [1360] = {.lex_state = 2},
  [1361] = {.lex_state = 2, .external_lex_state = 2},
  [1362] = {.lex_state = 2, .external_lex_state = 2},
  [1363] = {.lex_state = 2},
  [1364] = {.lex_state = 2},
  [1365] = {.lex_state = 3, .external_lex_state = 2},
  [1366] = {.lex_state = 3, .external_lex_state = 2},
  [1367] = {.lex_state = 2, .external_lex_state = 2},
  [1368] = {.lex_state = 3, .external_lex_state = 2},
  [1369] = {.lex_state = 2, .external_lex_state = 2},
  [1370] = {.lex_state = 11},
  [1371] = {.lex_state = 2, .external_lex_state = 2},
  [1372] = {.lex_state = 2, .external_lex_state = 2},
  [1373] = {.lex_state = 2, .external_lex_state = 2},
  [1374] = {.lex_state = 11, .external_lex_state = 2},
  [1375] = {.lex_state = 2, .external_lex_state = 2},
  [1376] = {.lex_state = 2},
  [1377] = {.lex_state = 2, .external_lex_state = 2},
  [1378] = {.lex_state = 2, .external_lex_state = 2},
  [1379] = {.lex_state = 2, .external_lex_state = 2},
  [1380] = {.lex_state = 2, .external_lex_state = 2},
  [1381] = {.lex_state = 3, .external_lex_state = 2},
  [1382] = {.lex_state = 2, .external_lex_state = 2},
  [1383] = {.lex_state = 2, .external_lex_state = 2},
  [1384] = {.lex_state = 2, .external_lex_state = 2},
  [1385] = {.lex_state = 11},
  [1386] = {.lex_state = 2, .external_lex_state = 2},
  [1387] = {.lex_state = 2, .external_lex_state = 2},
  [1388] = {.lex_state = 2, .external_lex_state = 2},
  [1389] = {.lex_state = 2, .external_lex_state = 2},
  [1390] = {.lex_state = 2, .external_lex_state = 2},
  [1391] = {.lex_state = 2, .external_lex_state = 2},
  [1392] = {.lex_state = 2, .external_lex_state = 2},
  [1393] = {.lex_state = 2},
  [1394] = {.lex_state = 2},
  [1395] = {.lex_state = 2},
  [1396] = {.lex_state = 2, .external_lex_state = 2},
  [1397] = {.lex_state = 2, .external_lex_state = 2},
  [1398] = {.lex_state = 11, .external_lex_state = 2},
  [1399] = {.lex_state = 2},
  [1400] = {.lex_state = 2, .external_lex_state = 2},
  [1401] = {.lex_state = 2},
  [1402] = {.lex_state = 2},
  [1403] = {.lex_state = 2},
  [1404] = {.lex_state = 12},
  [1405] = {.lex_state = 2, .external_lex_state = 2},
  [1406] = {.lex_state = 11},
  [1407] = {.lex_state = 11},
  [1408] = {.lex_state = 2, .external_lex_state = 2},
  [1409] = {.lex_state = 2, .external_lex_state = 2},
  [1410] = {.lex_state = 2, .external_lex_state = 2},
  [1411] = {.lex_state = 2},
  [1412] = {.lex_state = 2, .external_lex_state = 2},
  [1413] = {.lex_state = 2, .external_lex_state = 2},
  [1414] = {.lex_state = 2, .external_lex_state = 2},
  [1415] = {.lex_state = 2, .external_lex_state = 2},
  [1416] = {.lex_state = 2, .external_lex_state = 2},
  [1417] = {.lex_state = 2, .external_lex_state = 2},
  [1418] = {.lex_state = 2, .external_lex_state = 2},
  [1419] = {.lex_state = 2},
  [1420] = {.lex_state = 2, .external_lex_state = 2},
  [1421] = {.lex_state = 2, .external_lex_state = 2},
  [1422] = {.lex_state = 2, .external_lex_state = 2},
  [1423] = {.lex_state = 2, .external_lex_state = 2},
  [1424] = {.lex_state = 2, .external_lex_state = 2},
  [1425] = {.lex_state = 2, .external_lex_state = 2},
  [1426] = {.lex_state = 2, .external_lex_state = 2},
  [1427] = {.lex_state = 2, .external_lex_state = 2},
  [1428] = {.lex_state = 2, .external_lex_state = 2},
  [1429] = {.lex_state = 2, .external_lex_state = 2},
  [1430] = {.lex_state = 2, .external_lex_state = 2},
  [1431] = {.lex_state = 2, .external_lex_state = 2},
  [1432] = {.lex_state = 2},
  [1433] = {.lex_state = 3, .external_lex_state = 2},
  [1434] = {.lex_state = 3, .external_lex_state = 2},
  [1435] = {.lex_state = 11},
  [1436] = {.lex_state = 11},
  [1437] = {.lex_state = 2},
  [1438] = {.lex_state = 11},
  [1439] = {.lex_state = 2, .external_lex_state = 2},
  [1440] = {.lex_state = 3, .external_lex_state = 2},
  [1441] = {.lex_state = 2, .external_lex_state = 2},
  [1442] = {.lex_state = 2, .external_lex_state = 2},
  [1443] = {.lex_state = 14},
  [1444] = {.lex_state = 11},
  [1445] = {.lex_state = 2, .external_lex_state = 2},
  [1446] = {.lex_state = 2, .external_lex_state = 2},
  [1447] = {.lex_state = 2, .external_lex_state = 2},
  [1448] = {.lex_state = 11},
  [1449] = {.lex_state = 11},
  [1450] = {.lex_state = 11},
  [1451] = {.lex_state = 3, .external_lex_state = 2},
  [1452] = {.lex_state = 3, .external_lex_state = 2},
  [1453] = {.lex_state = 2, .external_lex_state = 2},
  [1454] = {.lex_state = 2, .external_lex_state = 2},
  [1455] = {.lex_state = 2, .external_lex_state = 2},
  [1456] = {.lex_state = 2, .external_lex_state = 2},
  [1457] = {.lex_state = 2, .external_lex_state = 2},
  [1458] = {.lex_state = 2},
  [1459] = {.lex_state = 11},
  [1460] = {.lex_state = 2},
  [1461] = {.lex_state = 11},
  [1462] = {.lex_state = 2},
  [1463] = {.lex_state = 11},
  [1464] = {.lex_state = 11},
  [1465] = {.lex_state = 2, .external_lex_state = 2},
  [1466] = {.lex_state = 2, .external_lex_state = 2},
  [1467] = {.lex_state = 2, .external_lex_state = 2},
  [1468] = {.lex_state = 2, .external_lex_state = 2},
  [1469] = {.lex_state = 2, .external_lex_state = 2},
  [1470] = {.lex_state = 2, .external_lex_state = 2},
  [1471] = {.lex_state = 2, .external_lex_state = 2},
  [1472] = {.lex_state = 2, .external_lex_state = 2},
  [1473] = {.lex_state = 2, .external_lex_state = 2},
  [1474] = {.lex_state = 2, .external_lex_state = 2},
  [1475] = {.lex_state = 3, .external_lex_state = 2},
  [1476] = {.lex_state = 2, .external_lex_state = 2},
  [1477] = {.lex_state = 2},
  [1478] = {.lex_state = 2, .external_lex_state = 2},
  [1479] = {.lex_state = 2, .external_lex_state = 2},
  [1480] = {.lex_state = 2, .external_lex_state = 2},
  [1481] = {.lex_state = 2, .external_lex_state = 2},
  [1482] = {.lex_state = 2, .external_lex_state = 2},
  [1483] = {.lex_state = 2, .external_lex_state = 2},
  [1484] = {.lex_state = 2, .external_lex_state = 2},
  [1485] = {.lex_state = 2},
  [1486] = {.lex_state = 2, .external_lex_state = 2},
  [1487] = {.lex_state = 2, .external_lex_state = 2},
  [1488] = {.lex_state = 2, .external_lex_state = 2},
  [1489] = {.lex_state = 2, .external_lex_state = 2},
  [1490] = {.lex_state = 2, .external_lex_state = 2},
  [1491] = {.lex_state = 2},
  [1492] = {.lex_state = 2},
  [1493] = {.lex_state = 11},
  [1494] = {.lex_state = 2},
  [1495] = {.lex_state = 3, .external_lex_state = 2},
  [1496] = {.lex_state = 2},
  [1497] = {.lex_state = 3},
  [1498] = {.lex_state = 3, .external_lex_state = 2},
  [1499] = {.lex_state = 3, .external_lex_state = 2},
  [1500] = {.lex_state = 11},
  [1501] = {.lex_state = 3, .external_lex_state = 2},
  [1502] = {.lex_state = 11},
  [1503] = {.lex_state = 11},
  [1504] = {.lex_state = 11},
  [1505] = {.lex_state = 11},
  [1506] = {.lex_state = 11},
  [1507] = {.lex_state = 11},
  [1508] = {.lex_state = 11},
  [1509] = {.lex_state = 11},
  [1510] = {.lex_state = 11},
  [1511] = {.lex_state = 11},
  [1512] = {.lex_state = 11},
  [1513] = {.lex_state = 2},
  [1514] = {.lex_state = 11},
  [1515] = {.lex_state = 11},
  [1516] = {.lex_state = 11},
  [1517] = {.lex_state = 11},
  [1518] = {.lex_state = 11},
  [1519] = {.lex_state = 2},
  [1520] = {.lex_state = 2},
  [1521] = {.lex_state = 2},
  [1522] = {.lex_state = 11},
  [1523] = {.lex_state = 11},
  [1524] = {.lex_state = 11},
  [1525] = {.lex_state = 11},
  [1526] = {.lex_state = 11},
  [1527] = {.lex_state = 11},
  [1528] = {.lex_state = 3},
  [1529] = {.lex_state = 2, .external_lex_state = 2},
  [1530] = {.lex_state = 2},
  [1531] = {.lex_state = 11},
  [1532] = {.lex_state = 11},
  [1533] = {.lex_state = 11},
  [1534] = {.lex_state = 11},
  [1535] = {.lex_state = 11},
  [1536] = {.lex_state = 11},
  [1537] = {.lex_state = 11},
  [1538] = {.lex_state = 11},
  [1539] = {.lex_state = 11},
  [1540] = {.lex_state = 11},
  [1541] = {.lex_state = 2},
  [1542] = {.lex_state = 11},
  [1543] = {.lex_state = 11},
  [1544] = {.lex_state = 11},
  [1545] = {.lex_state = 11},
  [1546] = {.lex_state = 11},
  [1547] = {.lex_state = 2},
  [1548] = {.lex_state = 2},
  [1549] = {.lex_state = 2},
  [1550] = {.lex_state = 11},
  [1551] = {.lex_state = 11},
  [1552] = {.lex_state = 11},
  [1553] = {.lex_state = 2, .external_lex_state = 2},
  [1554] = {.lex_state = 2},
  [1555] = {.lex_state = 3, .external_lex_state = 2},
  [1556] = {.lex_state = 2},
  [1557] = {.lex_state = 3, .external_lex_state = 2},
  [1558] = {.lex_state = 11},
  [1559] = {.lex_state = 11},
  [1560] = {.lex_state = 11},
  [1561] = {.lex_state = 11},
  [1562] = {.lex_state = 11},
  [1563] = {.lex_state = 11},
  [1564] = {.lex_state = 11},
  [1565] = {.lex_state = 11},
  [1566] = {.lex_state = 11},
  [1567] = {.lex_state = 11},
  [1568] = {.lex_state = 11},
  [1569] = {.lex_state = 2},
  [1570] = {.lex_state = 11},
  [1571] = {.lex_state = 11},
  [1572] = {.lex_state = 11},
  [1573] = {.lex_state = 3, .external_lex_state = 2},
  [1574] = {.lex_state = 11},
  [1575] = {.lex_state = 11},
  [1576] = {.lex_state = 11},
  [1577] = {.lex_state = 11},
  [1578] = {.lex_state = 3, .external_lex_state = 2},
  [1579] = {.lex_state = 11},
  [1580] = {.lex_state = 3, .external_lex_state = 2},
  [1581] = {.lex_state = 11},
  [1582] = {.lex_state = 3, .external_lex_state = 2},
  [1583] = {.lex_state = 3, .external_lex_state = 2},
  [1584] = {.lex_state = 3, .external_lex_state = 2},
  [1585] = {.lex_state = 2},
  [1586] = {.lex_state = 11},
  [1587] = {.lex_state = 2},
  [1588] = {.lex_state = 2},
  [1589] = {.lex_state = 2},
  [1590] = {.lex_state = 2, .external_lex_state = 2},
  [1591] = {.lex_state = 11},
  [1592] = {.lex_state = 2, .external_lex_state = 2},
  [1593] = {.lex_state = 11},
  [1594] = {.lex_state = 11},
  [1595] = {.lex_state = 11},
  [1596] = {.lex_state = 11},
  [1597] = {.lex_state = 2},
  [1598] = {.lex_state = 11},
  [1599] = {.lex_state = 11},
  [1600] = {.lex_state = 11},
  [1601] = {.lex_state = 11},
  [1602] = {.lex_state = 11},
  [1603] = {.lex_state = 11},
  [1604] = {.lex_state = 11},
  [1605] = {.lex_state = 11},
  [1606] = {.lex_state = 3, .external_lex_state = 2},
  [1607] = {.lex_state = 3, .external_lex_state = 2},
  [1608] = {.lex_state = 3},
  [1609] = {.lex_state = 11},
  [1610] = {.lex_state = 11},
  [1611] = {.lex_state = 11},
  [1612] = {.lex_state = 11},
  [1613] = {.lex_state = 11},
  [1614] = {.lex_state = 11},
  [1615] = {.lex_state = 11},
  [1616] = {.lex_state = 11},
  [1617] = {.lex_state = 11},
  [1618] = {.lex_state = 11},
  [1619] = {.lex_state = 11},
  [1620] = {.lex_state = 3, .external_lex_state = 2},
  [1621] = {.lex_state = 11},
  [1622] = {.lex_state = 11},
  [1623] = {.lex_state = 2},
  [1624] = {.lex_state = 3, .external_lex_state = 2},
  [1625] = {.lex_state = 3},
  [1626] = {.lex_state = 3},
  [1627] = {.lex_state = 2},
  [1628] = {.lex_state = 2},
  [1629] = {.lex_state = 3, .external_lex_state = 2},
  [1630] = {.lex_state = 3},
  [1631] = {.lex_state = 2},
  [1632] = {.lex_state = 2},
  [1633] = {.lex_state = 3},
  [1634] = {.lex_state = 3, .external_lex_state = 2},
  [1635] = {.lex_state = 3, .external_lex_state = 2},
  [1636] = {.lex_state = 3, .external_lex_state = 2},
  [1637] = {.lex_state = 3},
  [1638] = {.lex_state = 3, .external_lex_state = 2},
  [1639] = {.lex_state = 3},
  [1640] = {.lex_state = 3, .external_lex_state = 2},
  [1641] = {.lex_state = 3},
  [1642] = {.lex_state = 3},
  [1643] = {.lex_state = 3},
  [1644] = {.lex_state = 3, .external_lex_state = 2},
  [1645] = {.lex_state = 3, .external_lex_state = 2},
  [1646] = {.lex_state = 3},
  [1647] = {.lex_state = 3, .external_lex_state = 2},
  [1648] = {.lex_state = 3},
  [1649] = {.lex_state = 3, .external_lex_state = 2},
  [1650] = {.lex_state = 3, .external_lex_state = 2},
  [1651] = {.lex_state = 3, .external_lex_state = 2},
  [1652] = {.lex_state = 3, .external_lex_state = 2},
  [1653] = {.lex_state = 3},
  [1654] = {.lex_state = 2},
  [1655] = {.lex_state = 3},
  [1656] = {.lex_state = 2},
  [1657] = {.lex_state = 3},
  [1658] = {.lex_state = 3},
  [1659] = {.lex_state = 3},
  [1660] = {.lex_state = 3},
  [1661] = {.lex_state = 3},
  [1662] = {.lex_state = 3},
  [1663] = {.lex_state = 3},
  [1664] = {.lex_state = 3},
  [1665] = {.lex_state = 3},
  [1666] = {.lex_state = 3},
  [1667] = {.lex_state = 3},
  [1668] = {.lex_state = 3},
  [1669] = {.lex_state = 3},
  [1670] = {.lex_state = 3},
  [1671] = {.lex_state = 3},
  [1672] = {.lex_state = 3},
  [1673] = {.lex_state = 3},
  [1674] = {.lex_state = 3},
  [1675] = {.lex_state = 3},
  [1676] = {.lex_state = 3},
  [1677] = {.lex_state = 3},
  [1678] = {.lex_state = 3},
  [1679] = {.lex_state = 3},
  [1680] = {.lex_state = 3},
  [1681] = {.lex_state = 3},
  [1682] = {.lex_state = 3},
  [1683] = {.lex_state = 3},
  [1684] = {.lex_state = 3},
  [1685] = {.lex_state = 3},
  [1686] = {.lex_state = 3},
  [1687] = {.lex_state = 3, .external_lex_state = 2},
  [1688] = {.lex_state = 3},
  [1689] = {.lex_state = 3, .external_lex_state = 2},
  [1690] = {.lex_state = 3, .external_lex_state = 2},
  [1691] = {.lex_state = 3, .external_lex_state = 2},
  [1692] = {.lex_state = 3, .external_lex_state = 2},
  [1693] = {.lex_state = 3, .external_lex_state = 2},
  [1694] = {.lex_state = 3, .external_lex_state = 2},
  [1695] = {.lex_state = 3, .external_lex_state = 2},
  [1696] = {.lex_state = 3, .external_lex_state = 2},
  [1697] = {.lex_state = 3, .external_lex_state = 2},
  [1698] = {.lex_state = 3, .external_lex_state = 2},
  [1699] = {.lex_state = 3, .external_lex_state = 2},
  [1700] = {.lex_state = 3},
  [1701] = {.lex_state = 3, .external_lex_state = 2},
  [1702] = {.lex_state = 3, .external_lex_state = 2},
  [1703] = {.lex_state = 3, .external_lex_state = 2},
  [1704] = {.lex_state = 3, .external_lex_state = 2},
  [1705] = {.lex_state = 3, .external_lex_state = 2},
  [1706] = {.lex_state = 3},
  [1707] = {.lex_state = 3},
  [1708] = {.lex_state = 3},
  [1709] = {.lex_state = 3},
  [1710] = {.lex_state = 3},
  [1711] = {.lex_state = 3},
  [1712] = {.lex_state = 3},
  [1713] = {.lex_state = 3},
  [1714] = {.lex_state = 3},
  [1715] = {.lex_state = 3},
  [1716] = {.lex_state = 3},
  [1717] = {.lex_state = 3},
  [1718] = {.lex_state = 3},
  [1719] = {.lex_state = 3},
  [1720] = {.lex_state = 3},
  [1721] = {.lex_state = 3},
  [1722] = {.lex_state = 3},
  [1723] = {.lex_state = 3},
  [1724] = {.lex_state = 3},
  [1725] = {.lex_state = 3},
  [1726] = {.lex_state = 3},
  [1727] = {.lex_state = 3},
  [1728] = {.lex_state = 3},
  [1729] = {.lex_state = 3},
  [1730] = {.lex_state = 3},
  [1731] = {.lex_state = 3},
  [1732] = {.lex_state = 3},
  [1733] = {.lex_state = 3},
  [1734] = {.lex_state = 3},
  [1735] = {.lex_state = 3},
  [1736] = {.lex_state = 3},
  [1737] = {.lex_state = 3},
  [1738] = {.lex_state = 3},
  [1739] = {.lex_state = 3},
  [1740] = {.lex_state = 3},
  [1741] = {.lex_state = 3},
  [1742] = {.lex_state = 3},
  [1743] = {.lex_state = 3},
  [1744] = {.lex_state = 3},
  [1745] = {.lex_state = 3},
  [1746] = {.lex_state = 3},
  [1747] = {.lex_state = 3},
  [1748] = {.lex_state = 3},
  [1749] = {.lex_state = 3},
  [1750] = {.lex_state = 3},
  [1751] = {.lex_state = 3},
  [1752] = {.lex_state = 3},
  [1753] = {.lex_state = 3},
  [1754] = {.lex_state = 3},
  [1755] = {.lex_state = 3},
  [1756] = {.lex_state = 3},
  [1757] = {.lex_state = 3},
  [1758] = {.lex_state = 3},
  [1759] = {.lex_state = 3},
  [1760] = {.lex_state = 3},
  [1761] = {.lex_state = 3},
  [1762] = {.lex_state = 3},
  [1763] = {.lex_state = 3},
  [1764] = {.lex_state = 3},
  [1765] = {.lex_state = 3},
  [1766] = {.lex_state = 3},
  [1767] = {.lex_state = 3},
  [1768] = {.lex_state = 3},
  [1769] = {.lex_state = 3},
  [1770] = {.lex_state = 3},
  [1771] = {.lex_state = 3},
  [1772] = {.lex_state = 3},
  [1773] = {.lex_state = 3},
  [1774] = {.lex_state = 3},
  [1775] = {.lex_state = 3},
  [1776] = {.lex_state = 3},
  [1777] = {.lex_state = 3},
  [1778] = {.lex_state = 3},
  [1779] = {.lex_state = 3},
  [1780] = {.lex_state = 3},
  [1781] = {.lex_state = 3},
  [1782] = {.lex_state = 3},
  [1783] = {.lex_state = 3},
  [1784] = {.lex_state = 3, .external_lex_state = 2},
  [1785] = {.lex_state = 3, .external_lex_state = 2},
  [1786] = {.lex_state = 3, .external_lex_state = 2},
  [1787] = {.lex_state = 3, .external_lex_state = 2},
  [1788] = {.lex_state = 3, .external_lex_state = 2},
  [1789] = {.lex_state = 3, .external_lex_state = 2},
  [1790] = {.lex_state = 3},
  [1791] = {.lex_state = 3, .external_lex_state = 2},
  [1792] = {.lex_state = 3, .external_lex_state = 2},
  [1793] = {.lex_state = 3, .external_lex_state = 2},
  [1794] = {.lex_state = 3},
  [1795] = {.lex_state = 3, .external_lex_state = 2},
  [1796] = {.lex_state = 3, .external_lex_state = 2},
  [1797] = {.lex_state = 3, .external_lex_state = 2},
  [1798] = {.lex_state = 3, .external_lex_state = 2},
  [1799] = {.lex_state = 3, .external_lex_state = 2},
  [1800] = {.lex_state = 3, .external_lex_state = 2},
  [1801] = {.lex_state = 3, .external_lex_state = 2},
  [1802] = {.lex_state = 3, .external_lex_state = 2},
  [1803] = {.lex_state = 3, .external_lex_state = 2},
  [1804] = {.lex_state = 3, .external_lex_state = 2},
  [1805] = {.lex_state = 3, .external_lex_state = 2},
  [1806] = {.lex_state = 3, .external_lex_state = 2},
  [1807] = {.lex_state = 3},
  [1808] = {.lex_state = 3, .external_lex_state = 2},
  [1809] = {.lex_state = 3, .external_lex_state = 2},
  [1810] = {.lex_state = 3, .external_lex_state = 2},
  [1811] = {.lex_state = 3, .external_lex_state = 2},
  [1812] = {.lex_state = 3, .external_lex_state = 2},
  [1813] = {.lex_state = 3, .external_lex_state = 2},
  [1814] = {.lex_state = 3},
  [1815] = {.lex_state = 3},
  [1816] = {.lex_state = 3, .external_lex_state = 2},
  [1817] = {.lex_state = 3, .external_lex_state = 2},
  [1818] = {.lex_state = 3, .external_lex_state = 2},
  [1819] = {.lex_state = 3},
  [1820] = {.lex_state = 3, .external_lex_state = 2},
  [1821] = {.lex_state = 3},
  [1822] = {.lex_state = 3},
  [1823] = {.lex_state = 3, .external_lex_state = 2},
  [1824] = {.lex_state = 3, .external_lex_state = 2},
  [1825] = {.lex_state = 3, .external_lex_state = 2},
  [1826] = {.lex_state = 3, .external_lex_state = 2},
  [1827] = {.lex_state = 3, .external_lex_state = 2},
  [1828] = {.lex_state = 3, .external_lex_state = 2},
  [1829] = {.lex_state = 3, .external_lex_state = 2},
  [1830] = {.lex_state = 3, .external_lex_state = 2},
  [1831] = {.lex_state = 3, .external_lex_state = 2},
  [1832] = {.lex_state = 3, .external_lex_state = 2},
  [1833] = {.lex_state = 3, .external_lex_state = 2},
  [1834] = {.lex_state = 3, .external_lex_state = 2},
  [1835] = {.lex_state = 3},
  [1836] = {.lex_state = 3},
  [1837] = {.lex_state = 3, .external_lex_state = 2},
  [1838] = {.lex_state = 3, .external_lex_state = 2},
  [1839] = {.lex_state = 3, .external_lex_state = 2},
  [1840] = {.lex_state = 3, .external_lex_state = 2},
  [1841] = {.lex_state = 3, .external_lex_state = 2},
  [1842] = {.lex_state = 3, .external_lex_state = 2},
  [1843] = {.lex_state = 3},
  [1844] = {.lex_state = 3, .external_lex_state = 2},
  [1845] = {.lex_state = 3, .external_lex_state = 2},
  [1846] = {.lex_state = 3, .external_lex_state = 2},
  [1847] = {.lex_state = 3},
  [1848] = {.lex_state = 3, .external_lex_state = 2},
  [1849] = {.lex_state = 3, .external_lex_state = 2},
  [1850] = {.lex_state = 3},
  [1851] = {.lex_state = 3, .external_lex_state = 2},
  [1852] = {.lex_state = 3},
  [1853] = {.lex_state = 3},
  [1854] = {.lex_state = 3, .external_lex_state = 2},
  [1855] = {.lex_state = 3, .external_lex_state = 2},
  [1856] = {.lex_state = 3, .external_lex_state = 2},
  [1857] = {.lex_state = 3},
  [1858] = {.lex_state = 3, .external_lex_state = 2},
  [1859] = {.lex_state = 3},
  [1860] = {.lex_state = 3, .external_lex_state = 2},
  [1861] = {.lex_state = 3, .external_lex_state = 2},
  [1862] = {.lex_state = 3, .external_lex_state = 2},
  [1863] = {.lex_state = 3, .external_lex_state = 2},
  [1864] = {.lex_state = 3, .external_lex_state = 2},
  [1865] = {.lex_state = 3, .external_lex_state = 2},
  [1866] = {.lex_state = 3, .external_lex_state = 2},
  [1867] = {.lex_state = 3, .external_lex_state = 2},
  [1868] = {.lex_state = 3, .external_lex_state = 2},
  [1869] = {.lex_state = 3, .external_lex_state = 2},
  [1870] = {.lex_state = 3, .external_lex_state = 2},
  [1871] = {.lex_state = 3},
  [1872] = {.lex_state = 3, .external_lex_state = 2},
  [1873] = {.lex_state = 3},
  [1874] = {.lex_state = 3, .external_lex_state = 2},
  [1875] = {.lex_state = 3, .external_lex_state = 2},
  [1876] = {.lex_state = 3, .external_lex_state = 2},
  [1877] = {.lex_state = 3},
  [1878] = {.lex_state = 3},
  [1879] = {.lex_state = 3, .external_lex_state = 2},
  [1880] = {.lex_state = 3},
  [1881] = {.lex_state = 3},
  [1882] = {.lex_state = 3},
  [1883] = {.lex_state = 3},
  [1884] = {.lex_state = 3},
  [1885] = {.lex_state = 3},
  [1886] = {.lex_state = 3},
  [1887] = {.lex_state = 3},
  [1888] = {.lex_state = 3, .external_lex_state = 2},
  [1889] = {.lex_state = 3},
  [1890] = {.lex_state = 3},
  [1891] = {.lex_state = 3},
  [1892] = {.lex_state = 3, .external_lex_state = 2},
  [1893] = {.lex_state = 3},
  [1894] = {.lex_state = 3},
  [1895] = {.lex_state = 3},
  [1896] = {.lex_state = 3},
  [1897] = {.lex_state = 3},
  [1898] = {.lex_state = 3},
  [1899] = {.lex_state = 3},
  [1900] = {.lex_state = 3},
  [1901] = {.lex_state = 3},
  [1902] = {.lex_state = 3},
  [1903] = {.lex_state = 3, .external_lex_state = 2},
  [1904] = {.lex_state = 3, .external_lex_state = 2},
  [1905] = {.lex_state = 3},
  [1906] = {.lex_state = 3, .external_lex_state = 2},
  [1907] = {.lex_state = 3},
  [1908] = {.lex_state = 3},
  [1909] = {.lex_state = 3},
  [1910] = {.lex_state = 3},
  [1911] = {.lex_state = 3, .external_lex_state = 2},
  [1912] = {.lex_state = 3, .external_lex_state = 2},
  [1913] = {.lex_state = 3},
  [1914] = {.lex_state = 3},
  [1915] = {.lex_state = 3},
  [1916] = {.lex_state = 17},
  [1917] = {.lex_state = 3, .external_lex_state = 2},
  [1918] = {.lex_state = 0, .external_lex_state = 2},
  [1919] = {.lex_state = 3},
  [1920] = {.lex_state = 3},
  [1921] = {.lex_state = 3},
  [1922] = {.lex_state = 3},
  [1923] = {.lex_state = 0, .external_lex_state = 2},
  [1924] = {.lex_state = 3},
  [1925] = {.lex_state = 3},
  [1926] = {.lex_state = 3},
  [1927] = {.lex_state = 3},
  [1928] = {.lex_state = 3, .external_lex_state = 2},
  [1929] = {.lex_state = 3, .external_lex_state = 2},
  [1930] = {.lex_state = 0, .external_lex_state = 2},
  [1931] = {.lex_state = 3},
  [1932] = {.lex_state = 3, .external_lex_state = 2},
  [1933] = {.lex_state = 3},
  [1934] = {.lex_state = 3, .external_lex_state = 2},
  [1935] = {.lex_state = 3},
  [1936] = {.lex_state = 3},
  [1937] = {.lex_state = 3},
  [1938] = {.lex_state = 3},
  [1939] = {.lex_state = 3, .external_lex_state = 2},
  [1940] = {.lex_state = 3, .external_lex_state = 2},
  [1941] = {.lex_state = 0, .external_lex_state = 2},
  [1942] = {.lex_state = 3},
  [1943] = {.lex_state = 3, .external_lex_state = 2},
  [1944] = {.lex_state = 3},
  [1945] = {.lex_state = 0, .external_lex_state = 2},
  [1946] = {.lex_state = 3},
  [1947] = {.lex_state = 3},
  [1948] = {.lex_state = 3, .external_lex_state = 2},
  [1949] = {.lex_state = 0, .external_lex_state = 2},
  [1950] = {.lex_state = 3, .external_lex_state = 2},
  [1951] = {.lex_state = 3},
  [1952] = {.lex_state = 3},
  [1953] = {.lex_state = 3, .external_lex_state = 2},
  [1954] = {.lex_state = 3},
  [1955] = {.lex_state = 3, .external_lex_state = 2},
  [1956] = {.lex_state = 17},
  [1957] = {.lex_state = 3, .external_lex_state = 2},
  [1958] = {.lex_state = 3, .external_lex_state = 2},
  [1959] = {.lex_state = 3},
  [1960] = {.lex_state = 3, .external_lex_state = 2},
  [1961] = {.lex_state = 3, .external_lex_state = 2},
  [1962] = {.lex_state = 3},
  [1963] = {.lex_state = 3},
  [1964] = {.lex_state = 3},
  [1965] = {.lex_state = 3},
  [1966] = {.lex_state = 3},
  [1967] = {.lex_state = 3},
  [1968] = {.lex_state = 3},
  [1969] = {.lex_state = 3},
  [1970] = {.lex_state = 3},
  [1971] = {.lex_state = 3},
  [1972] = {.lex_state = 0, .external_lex_state = 2},
  [1973] = {.lex_state = 3},
  [1974] = {.lex_state = 3},
  [1975] = {.lex_state = 0},
  [1976] = {.lex_state = 3},
  [1977] = {.lex_state = 0, .external_lex_state = 2},
  [1978] = {.lex_state = 3, .external_lex_state = 2},
  [1979] = {.lex_state = 3},
  [1980] = {.lex_state = 3},
  [1981] = {.lex_state = 0, .external_lex_state = 2},
  [1982] = {.lex_state = 3},
  [1983] = {.lex_state = 3},
  [1984] = {.lex_state = 3},
  [1985] = {.lex_state = 3, .external_lex_state = 2},
  [1986] = {.lex_state = 3},
  [1987] = {.lex_state = 0, .external_lex_state = 2},
  [1988] = {.lex_state = 3},
  [1989] = {.lex_state = 21, .external_lex_state = 3},
  [1990] = {.lex_state = 3},
  [1991] = {.lex_state = 21, .external_lex_state = 3},
  [1992] = {.lex_state = 3},
  [1993] = {.lex_state = 3},
  [1994] = {.lex_state = 3},
  [1995] = {.lex_state = 3},
  [1996] = {.lex_state = 0, .external_lex_state = 2},
  [1997] = {.lex_state = 3},
  [1998] = {.lex_state = 3},
  [1999] = {.lex_state = 0, .external_lex_state = 2},
  [2000] = {.lex_state = 3},
  [2001] = {.lex_state = 3},
  [2002] = {.lex_state = 3},
  [2003] = {.lex_state = 21, .external_lex_state = 3},
  [2004] = {.lex_state = 3},
  [2005] = {.lex_state = 3},
  [2006] = {.lex_state = 0, .external_lex_state = 2},
  [2007] = {.lex_state = 3, .external_lex_state = 2},
  [2008] = {.lex_state = 3},
  [2009] = {.lex_state = 3},
  [2010] = {.lex_state = 3},
  [2011] = {.lex_state = 3},
  [2012] = {.lex_state = 3},
  [2013] = {.lex_state = 3},
  [2014] = {.lex_state = 3},
  [2015] = {.lex_state = 3},
  [2016] = {.lex_state = 0, .external_lex_state = 2},
  [2017] = {.lex_state = 0, .external_lex_state = 2},
  [2018] = {.lex_state = 21, .external_lex_state = 3},
  [2019] = {.lex_state = 0, .external_lex_state = 2},
  [2020] = {.lex_state = 21, .external_lex_state = 3},
  [2021] = {.lex_state = 3},
  [2022] = {.lex_state = 0, .external_lex_state = 2},
  [2023] = {.lex_state = 3},
  [2024] = {.lex_state = 3},
  [2025] = {.lex_state = 0, .external_lex_state = 2},
  [2026] = {.lex_state = 3},
  [2027] = {.lex_state = 3},
  [2028] = {.lex_state = 3},
  [2029] = {.lex_state = 3},
  [2030] = {.lex_state = 0, .external_lex_state = 2},
  [2031] = {.lex_state = 0, .external_lex_state = 2},
  [2032] = {.lex_state = 3},
  [2033] = {.lex_state = 0, .external_lex_state = 2},
  [2034] = {.lex_state = 3},
  [2035] = {.lex_state = 3},
  [2036] = {.lex_state = 3},
  [2037] = {.lex_state = 3},
  [2038] = {.lex_state = 3},
  [2039] = {.lex_state = 3},
  [2040] = {.lex_state = 0, .external_lex_state = 2},
  [2041] = {.lex_state = 3},
  [2042] = {.lex_state = 3},
  [2043] = {.lex_state = 3},
  [2044] = {.lex_state = 17},
  [2045] = {.lex_state = 3},
  [2046] = {.lex_state = 0, .external_lex_state = 2},
  [2047] = {.lex_state = 3},
  [2048] = {.lex_state = 21, .external_lex_state = 3},
  [2049] = {.lex_state = 3},
  [2050] = {.lex_state = 3},
  [2051] = {.lex_state = 0, .external_lex_state = 2},
  [2052] = {.lex_state = 3},
  [2053] = {.lex_state = 0, .external_lex_state = 2},
  [2054] = {.lex_state = 3},
  [2055] = {.lex_state = 0, .external_lex_state = 2},
  [2056] = {.lex_state = 3},
  [2057] = {.lex_state = 21, .external_lex_state = 3},
  [2058] = {.lex_state = 3, .external_lex_state = 2},
  [2059] = {.lex_state = 0, .external_lex_state = 2},
  [2060] = {.lex_state = 3},
  [2061] = {.lex_state = 0, .external_lex_state = 2},
  [2062] = {.lex_state = 0},
  [2063] = {.lex_state = 3},
  [2064] = {.lex_state = 3},
  [2065] = {.lex_state = 3},
  [2066] = {.lex_state = 3},
  [2067] = {.lex_state = 3},
  [2068] = {.lex_state = 3},
  [2069] = {.lex_state = 0, .external_lex_state = 2},
  [2070] = {.lex_state = 3},
  [2071] = {.lex_state = 0, .external_lex_state = 2},
  [2072] = {.lex_state = 0, .external_lex_state = 2},
  [2073] = {.lex_state = 3, .external_lex_state = 2},
  [2074] = {.lex_state = 0, .external_lex_state = 2},
  [2075] = {.lex_state = 0},
  [2076] = {.lex_state = 0, .external_lex_state = 2},
  [2077] = {.lex_state = 0, .external_lex_state = 2},
  [2078] = {.lex_state = 0, .external_lex_state = 2},
  [2079] = {.lex_state = 3},
  [2080] = {.lex_state = 3},
  [2081] = {.lex_state = 0},
  [2082] = {.lex_state = 0, .external_lex_state = 2},
  [2083] = {.lex_state = 3},
  [2084] = {.lex_state = 0},
  [2085] = {.lex_state = 0},
  [2086] = {.lex_state = 0},
  [2087] = {.lex_state = 3},
  [2088] = {.lex_state = 0},
  [2089] = {.lex_state = 0, .external_lex_state = 2},
  [2090] = {.lex_state = 0, .external_lex_state = 2},
  [2091] = {.lex_state = 0},
  [2092] = {.lex_state = 0},
  [2093] = {.lex_state = 0},
  [2094] = {.lex_state = 3},
  [2095] = {.lex_state = 0},
  [2096] = {.lex_state = 0, .external_lex_state = 2},
  [2097] = {.lex_state = 0},
  [2098] = {.lex_state = 0, .external_lex_state = 2},
  [2099] = {.lex_state = 3},
  [2100] = {.lex_state = 0, .external_lex_state = 2},
  [2101] = {.lex_state = 3},
  [2102] = {.lex_state = 0, .external_lex_state = 2},
  [2103] = {.lex_state = 3},
  [2104] = {.lex_state = 0, .external_lex_state = 2},
  [2105] = {.lex_state = 3, .external_lex_state = 2},
  [2106] = {.lex_state = 0, .external_lex_state = 2},
  [2107] = {.lex_state = 0, .external_lex_state = 2},
  [2108] = {.lex_state = 3},
  [2109] = {.lex_state = 0, .external_lex_state = 2},
  [2110] = {.lex_state = 3, .external_lex_state = 2},
  [2111] = {.lex_state = 3},
  [2112] = {.lex_state = 3, .external_lex_state = 2},
  [2113] = {.lex_state = 3},
  [2114] = {.lex_state = 0, .external_lex_state = 2},
  [2115] = {.lex_state = 0, .external_lex_state = 2},
  [2116] = {.lex_state = 0, .external_lex_state = 2},
  [2117] = {.lex_state = 0, .external_lex_state = 2},
  [2118] = {.lex_state = 3},
  [2119] = {.lex_state = 3, .external_lex_state = 2},
  [2120] = {.lex_state = 3},
  [2121] = {.lex_state = 3},
  [2122] = {.lex_state = 3},
  [2123] = {.lex_state = 3},
  [2124] = {.lex_state = 3},
  [2125] = {.lex_state = 0, .external_lex_state = 2},
  [2126] = {.lex_state = 3, .external_lex_state = 2},
  [2127] = {.lex_state = 3},
  [2128] = {.lex_state = 3},
  [2129] = {.lex_state = 0, .external_lex_state = 2},
  [2130] = {.lex_state = 0, .external_lex_state = 2},
  [2131] = {.lex_state = 0, .external_lex_state = 2},
  [2132] = {.lex_state = 3, .external_lex_state = 2},
  [2133] = {.lex_state = 0, .external_lex_state = 2},
  [2134] = {.lex_state = 0, .external_lex_state = 2},
  [2135] = {.lex_state = 0, .external_lex_state = 2},
  [2136] = {.lex_state = 3},
  [2137] = {.lex_state = 3},
  [2138] = {.lex_state = 0, .external_lex_state = 2},
  [2139] = {.lex_state = 3},
  [2140] = {.lex_state = 0, .external_lex_state = 2},
  [2141] = {.lex_state = 0, .external_lex_state = 2},
  [2142] = {.lex_state = 3},
  [2143] = {.lex_state = 0, .external_lex_state = 2},
  [2144] = {.lex_state = 3, .external_lex_state = 2},
  [2145] = {.lex_state = 3},
  [2146] = {.lex_state = 0, .external_lex_state = 2},
  [2147] = {.lex_state = 0, .external_lex_state = 2},
  [2148] = {.lex_state = 3},
  [2149] = {.lex_state = 10},
  [2150] = {.lex_state = 0, .external_lex_state = 2},
  [2151] = {.lex_state = 0, .external_lex_state = 2},
  [2152] = {.lex_state = 3},
  [2153] = {.lex_state = 3},
  [2154] = {.lex_state = 0, .external_lex_state = 2},
  [2155] = {.lex_state = 0, .external_lex_state = 2},
  [2156] = {.lex_state = 0, .external_lex_state = 2},
  [2157] = {.lex_state = 3, .external_lex_state = 2},
  [2158] = {.lex_state = 3},
  [2159] = {.lex_state = 3},
  [2160] = {.lex_state = 3},
  [2161] = {.lex_state = 3},
  [2162] = {.lex_state = 3},
  [2163] = {.lex_state = 0, .external_lex_state = 2},
  [2164] = {.lex_state = 3, .external_lex_state = 2},
  [2165] = {.lex_state = 3},
  [2166] = {.lex_state = 3},
  [2167] = {.lex_state = 0, .external_lex_state = 2},
  [2168] = {.lex_state = 0, .external_lex_state = 2},
  [2169] = {.lex_state = 0, .external_lex_state = 2},
  [2170] = {.lex_state = 3},
  [2171] = {.lex_state = 0, .external_lex_state = 2},
  [2172] = {.lex_state = 3},
  [2173] = {.lex_state = 0, .external_lex_state = 2},
  [2174] = {.lex_state = 0, .external_lex_state = 2},
  [2175] = {.lex_state = 0, .external_lex_state = 2},
  [2176] = {.lex_state = 0, .external_lex_state = 2},
  [2177] = {.lex_state = 3},
  [2178] = {.lex_state = 3},
  [2179] = {.lex_state = 3},
  [2180] = {.lex_state = 3},
  [2181] = {.lex_state = 0, .external_lex_state = 2},
  [2182] = {.lex_state = 0, .external_lex_state = 2},
  [2183] = {.lex_state = 3},
  [2184] = {.lex_state = 3},
  [2185] = {.lex_state = 0, .external_lex_state = 2},
  [2186] = {.lex_state = 3},
  [2187] = {.lex_state = 0, .external_lex_state = 2},
  [2188] = {.lex_state = 3},
  [2189] = {.lex_state = 3},
  [2190] = {.lex_state = 0, .external_lex_state = 2},
  [2191] = {.lex_state = 0, .external_lex_state = 2},
  [2192] = {.lex_state = 0, .external_lex_state = 2},
  [2193] = {.lex_state = 3},
  [2194] = {.lex_state = 3},
  [2195] = {.lex_state = 0, .external_lex_state = 2},
  [2196] = {.lex_state = 3},
  [2197] = {.lex_state = 0, .external_lex_state = 2},
  [2198] = {.lex_state = 3},
  [2199] = {.lex_state = 0, .external_lex_state = 2},
  [2200] = {.lex_state = 3},
  [2201] = {.lex_state = 0, .external_lex_state = 2},
  [2202] = {.lex_state = 3},
  [2203] = {.lex_state = 0, .external_lex_state = 2},
  [2204] = {.lex_state = 3},
  [2205] = {.lex_state = 3},
  [2206] = {.lex_state = 0, .external_lex_state = 2},
  [2207] = {.lex_state = 3},
  [2208] = {.lex_state = 0, .external_lex_state = 2},
  [2209] = {.lex_state = 3},
  [2210] = {.lex_state = 0},
  [2211] = {.lex_state = 3},
  [2212] = {.lex_state = 3},
  [2213] = {.lex_state = 3},
  [2214] = {.lex_state = 3},
  [2215] = {.lex_state = 3},
  [2216] = {.lex_state = 0, .external_lex_state = 2},
  [2217] = {.lex_state = 3},
  [2218] = {.lex_state = 17},
  [2219] = {.lex_state = 0, .external_lex_state = 2},
  [2220] = {.lex_state = 3},
  [2221] = {.lex_state = 0, .external_lex_state = 2},
  [2222] = {.lex_state = 0, .external_lex_state = 2},
  [2223] = {.lex_state = 0, .external_lex_state = 2},
  [2224] = {.lex_state = 3},
  [2225] = {.lex_state = 3},
  [2226] = {.lex_state = 0, .external_lex_state = 2},
  [2227] = {.lex_state = 3},
  [2228] = {.lex_state = 0, .external_lex_state = 2},
  [2229] = {.lex_state = 3, .external_lex_state = 2},
  [2230] = {.lex_state = 3},
  [2231] = {.lex_state = 0, .external_lex_state = 2},
  [2232] = {.lex_state = 3},
  [2233] = {.lex_state = 0, .external_lex_state = 2},
  [2234] = {.lex_state = 0, .external_lex_state = 2},
  [2235] = {.lex_state = 0, .external_lex_state = 2},
  [2236] = {.lex_state = 0, .external_lex_state = 2},
  [2237] = {.lex_state = 3},
  [2238] = {.lex_state = 3},
  [2239] = {.lex_state = 0, .external_lex_state = 2},
  [2240] = {.lex_state = 3},
  [2241] = {.lex_state = 0, .external_lex_state = 2},
  [2242] = {.lex_state = 0, .external_lex_state = 2},
  [2243] = {.lex_state = 3},
  [2244] = {.lex_state = 0, .external_lex_state = 2},
  [2245] = {.lex_state = 3},
  [2246] = {.lex_state = 3},
  [2247] = {.lex_state = 3},
  [2248] = {.lex_state = 0, .external_lex_state = 2},
  [2249] = {.lex_state = 0, .external_lex_state = 2},
  [2250] = {.lex_state = 3},
  [2251] = {.lex_state = 0, .external_lex_state = 2},
  [2252] = {.lex_state = 3},
  [2253] = {.lex_state = 0, .external_lex_state = 2},
  [2254] = {.lex_state = 17},
  [2255] = {.lex_state = 3},
  [2256] = {.lex_state = 3},
  [2257] = {.lex_state = 10},
  [2258] = {.lex_state = 0, .external_lex_state = 2},
  [2259] = {.lex_state = 3},
  [2260] = {.lex_state = 0, .external_lex_state = 2},
  [2261] = {.lex_state = 0},
  [2262] = {.lex_state = 0, .external_lex_state = 2},
  [2263] = {.lex_state = 0, .external_lex_state = 2},
  [2264] = {.lex_state = 0, .external_lex_state = 2},
  [2265] = {.lex_state = 0, .external_lex_state = 2},
  [2266] = {.lex_state = 3, .external_lex_state = 2},
  [2267] = {.lex_state = 3},
  [2268] = {.lex_state = 3},
  [2269] = {.lex_state = 3, .external_lex_state = 2},
  [2270] = {.lex_state = 3, .external_lex_state = 2},
  [2271] = {.lex_state = 0, .external_lex_state = 2},
  [2272] = {.lex_state = 3},
  [2273] = {.lex_state = 4},
  [2274] = {.lex_state = 6},
  [2275] = {.lex_state = 6},
  [2276] = {.lex_state = 4},
  [2277] = {.lex_state = 3},
  [2278] = {.lex_state = 3},
  [2279] = {.lex_state = 3},
  [2280] = {.lex_state = 3},
  [2281] = {.lex_state = 0},
  [2282] = {.lex_state = 0},
  [2283] = {.lex_state = 0},
  [2284] = {.lex_state = 0},
  [2285] = {.lex_state = 4},
  [2286] = {.lex_state = 0, .external_lex_state = 2},
  [2287] = {.lex_state = 0},
  [2288] = {.lex_state = 4},
  [2289] = {.lex_state = 6},
  [2290] = {.lex_state = 0},
  [2291] = {.lex_state = 3},
  [2292] = {.lex_state = 6},
  [2293] = {.lex_state = 6},
  [2294] = {.lex_state = 4},
  [2295] = {.lex_state = 21, .external_lex_state = 3},
  [2296] = {.lex_state = 4},
  [2297] = {.lex_state = 3, .external_lex_state = 2},
  [2298] = {.lex_state = 3, .external_lex_state = 2},
  [2299] = {.lex_state = 6},
  [2300] = {.lex_state = 3},
  [2301] = {.lex_state = 0},
  [2302] = {.lex_state = 3},
  [2303] = {.lex_state = 3},
  [2304] = {.lex_state = 3},
  [2305] = {.lex_state = 4},
  [2306] = {.lex_state = 3},
  [2307] = {.lex_state = 0, .external_lex_state = 2},
  [2308] = {.lex_state = 3, .external_lex_state = 2},
  [2309] = {.lex_state = 0, .external_lex_state = 2},
  [2310] = {.lex_state = 3},
  [2311] = {.lex_state = 4},
  [2312] = {.lex_state = 6},
  [2313] = {.lex_state = 3},
  [2314] = {.lex_state = 3, .external_lex_state = 2},
  [2315] = {.lex_state = 4},
  [2316] = {.lex_state = 0, .external_lex_state = 2},
  [2317] = {.lex_state = 6},
  [2318] = {.lex_state = 3},
  [2319] = {.lex_state = 4},
  [2320] = {.lex_state = 6},
  [2321] = {.lex_state = 0},
  [2322] = {.lex_state = 6},
  [2323] = {.lex_state = 4},
  [2324] = {.lex_state = 3, .external_lex_state = 2},
  [2325] = {.lex_state = 3},
  [2326] = {.lex_state = 3},
  [2327] = {.lex_state = 0, .external_lex_state = 2},
  [2328] = {.lex_state = 0},
  [2329] = {.lex_state = 0},
  [2330] = {.lex_state = 3, .external_lex_state = 2},
  [2331] = {.lex_state = 3},
  [2332] = {.lex_state = 0, .external_lex_state = 2},
  [2333] = {.lex_state = 3},
  [2334] = {.lex_state = 3},
  [2335] = {.lex_state = 3},
  [2336] = {.lex_state = 6},
  [2337] = {.lex_state = 4},
  [2338] = {.lex_state = 3, .external_lex_state = 2},
  [2339] = {.lex_state = 0},
  [2340] = {.lex_state = 3},
  [2341] = {.lex_state = 3},
  [2342] = {.lex_state = 0},
  [2343] = {.lex_state = 3, .external_lex_state = 2},
  [2344] = {.lex_state = 0, .external_lex_state = 2},
  [2345] = {.lex_state = 0, .external_lex_state = 2},
  [2346] = {.lex_state = 3},
  [2347] = {.lex_state = 4},
  [2348] = {.lex_state = 3, .external_lex_state = 2},
  [2349] = {.lex_state = 3},
  [2350] = {.lex_state = 3},
  [2351] = {.lex_state = 0},
  [2352] = {.lex_state = 3},
  [2353] = {.lex_state = 3, .external_lex_state = 2},
  [2354] = {.lex_state = 3, .external_lex_state = 2},
  [2355] = {.lex_state = 3},
  [2356] = {.lex_state = 3},
  [2357] = {.lex_state = 6},
  [2358] = {.lex_state = 3, .external_lex_state = 2},
  [2359] = {.lex_state = 3, .external_lex_state = 2},
  [2360] = {.lex_state = 3},
  [2361] = {.lex_state = 6},
  [2362] = {.lex_state = 3, .external_lex_state = 2},
  [2363] = {.lex_state = 0},
  [2364] = {.lex_state = 3},
  [2365] = {.lex_state = 0},
  [2366] = {.lex_state = 0},
  [2367] = {.lex_state = 0},
  [2368] = {.lex_state = 0},
  [2369] = {.lex_state = 0},
  [2370] = {.lex_state = 3},
  [2371] = {.lex_state = 3},
  [2372] = {.lex_state = 3},
  [2373] = {.lex_state = 0},
  [2374] = {.lex_state = 0},
  [2375] = {.lex_state = 3},
  [2376] = {.lex_state = 3, .external_lex_state = 2},
  [2377] = {.lex_state = 3},
  [2378] = {.lex_state = 3},
  [2379] = {.lex_state = 3},
  [2380] = {.lex_state = 0},
  [2381] = {.lex_state = 0},
  [2382] = {.lex_state = 0},
  [2383] = {.lex_state = 0},
  [2384] = {.lex_state = 0},
  [2385] = {.lex_state = 3},
  [2386] = {.lex_state = 0},
  [2387] = {.lex_state = 0, .external_lex_state = 2},
  [2388] = {.lex_state = 0, .external_lex_state = 2},
  [2389] = {.lex_state = 0},
  [2390] = {.lex_state = 0},
  [2391] = {.lex_state = 0},
  [2392] = {.lex_state = 0},
  [2393] = {.lex_state = 0, .external_lex_state = 2},
  [2394] = {.lex_state = 3},
  [2395] = {.lex_state = 0},
  [2396] = {.lex_state = 0},
  [2397] = {.lex_state = 3, .external_lex_state = 2},
  [2398] = {.lex_state = 0},
  [2399] = {.lex_state = 0},
  [2400] = {.lex_state = 0, .external_lex_state = 2},
  [2401] = {.lex_state = 0},
  [2402] = {.lex_state = 0, .external_lex_state = 2},
  [2403] = {.lex_state = 0, .external_lex_state = 2},
  [2404] = {.lex_state = 10},
  [2405] = {.lex_state = 0},
  [2406] = {.lex_state = 0, .external_lex_state = 2},
  [2407] = {.lex_state = 0, .external_lex_state = 2},
  [2408] = {.lex_state = 0, .external_lex_state = 2},
  [2409] = {.lex_state = 0, .external_lex_state = 2},
  [2410] = {.lex_state = 3},
  [2411] = {.lex_state = 0, .external_lex_state = 2},
  [2412] = {.lex_state = 0},
  [2413] = {.lex_state = 0},
  [2414] = {.lex_state = 0, .external_lex_state = 2},
  [2415] = {.lex_state = 0},
  [2416] = {.lex_state = 0, .external_lex_state = 2},
  [2417] = {.lex_state = 0},
  [2418] = {.lex_state = 3},
  [2419] = {.lex_state = 0, .external_lex_state = 2},
  [2420] = {.lex_state = 0, .external_lex_state = 2},
  [2421] = {.lex_state = 0},
  [2422] = {.lex_state = 0, .external_lex_state = 2},
  [2423] = {.lex_state = 3},
  [2424] = {.lex_state = 0},
  [2425] = {.lex_state = 3},
  [2426] = {.lex_state = 10},
  [2427] = {.lex_state = 3},
  [2428] = {.lex_state = 0},
  [2429] = {.lex_state = 3},
  [2430] = {.lex_state = 0, .external_lex_state = 2},
  [2431] = {.lex_state = 0, .external_lex_state = 2},
  [2432] = {.lex_state = 3},
  [2433] = {.lex_state = 3},
  [2434] = {.lex_state = 3},
  [2435] = {.lex_state = 0, .external_lex_state = 2},
  [2436] = {.lex_state = 3},
  [2437] = {.lex_state = 3},
  [2438] = {.lex_state = 3},
  [2439] = {.lex_state = 0},
  [2440] = {.lex_state = 0, .external_lex_state = 2},
  [2441] = {.lex_state = 3},
  [2442] = {.lex_state = 0},
  [2443] = {.lex_state = 3},
  [2444] = {.lex_state = 0},
  [2445] = {.lex_state = 0, .external_lex_state = 2},
  [2446] = {.lex_state = 0},
  [2447] = {.lex_state = 3},
  [2448] = {.lex_state = 0},
  [2449] = {.lex_state = 0, .external_lex_state = 2},
  [2450] = {.lex_state = 0, .external_lex_state = 2},
  [2451] = {.lex_state = 3},
  [2452] = {.lex_state = 0, .external_lex_state = 2},
  [2453] = {.lex_state = 0},
  [2454] = {.lex_state = 3},
  [2455] = {.lex_state = 0, .external_lex_state = 2},
  [2456] = {.lex_state = 0},
  [2457] = {.lex_state = 3},
  [2458] = {.lex_state = 0},
  [2459] = {.lex_state = 0},
  [2460] = {.lex_state = 3},
  [2461] = {.lex_state = 0},
  [2462] = {.lex_state = 0},
  [2463] = {.lex_state = 0},
  [2464] = {.lex_state = 0},
  [2465] = {.lex_state = 0},
  [2466] = {.lex_state = 3},
  [2467] = {.lex_state = 0},
  [2468] = {.lex_state = 3},
  [2469] = {.lex_state = 0},
  [2470] = {.lex_state = 10},
  [2471] = {.lex_state = 0},
  [2472] = {.lex_state = 0},
  [2473] = {.lex_state = 3},
  [2474] = {.lex_state = 0},
  [2475] = {.lex_state = 3, .external_lex_state = 2},
  [2476] = {.lex_state = 0},
  [2477] = {.lex_state = 3},
  [2478] = {.lex_state = 0, .external_lex_state = 2},
  [2479] = {.lex_state = 3},
  [2480] = {.lex_state = 0},
  [2481] = {.lex_state = 0},
  [2482] = {.lex_state = 3},
  [2483] = {.lex_state = 3},
  [2484] = {.lex_state = 0},
  [2485] = {.lex_state = 0},
  [2486] = {.lex_state = 0},
  [2487] = {.lex_state = 3},
  [2488] = {.lex_state = 3},
  [2489] = {.lex_state = 0},
  [2490] = {.lex_state = 0},
  [2491] = {.lex_state = 3},
  [2492] = {.lex_state = 0},
  [2493] = {.lex_state = 0, .external_lex_state = 2},
  [2494] = {.lex_state = 0},
  [2495] = {.lex_state = 0, .external_lex_state = 2},
  [2496] = {.lex_state = 3},
  [2497] = {.lex_state = 0, .external_lex_state = 2},
  [2498] = {.lex_state = 0},
  [2499] = {.lex_state = 0},
  [2500] = {.lex_state = 0, .external_lex_state = 2},
  [2501] = {.lex_state = 0},
  [2502] = {.lex_state = 0},
  [2503] = {.lex_state = 0, .external_lex_state = 2},
  [2504] = {.lex_state = 0},
  [2505] = {.lex_state = 0},
  [2506] = {.lex_state = 3},
  [2507] = {.lex_state = 3, .external_lex_state = 2},
  [2508] = {.lex_state = 3},
  [2509] = {.lex_state = 3, .external_lex_state = 2},
  [2510] = {.lex_state = 0},
  [2511] = {.lex_state = 3, .external_lex_state = 2},
  [2512] = {.lex_state = 3},
  [2513] = {.lex_state = 3, .external_lex_state = 2},
  [2514] = {.lex_state = 0},
  [2515] = {.lex_state = 0},
  [2516] = {.lex_state = 0},
  [2517] = {.lex_state = 0},
  [2518] = {.lex_state = 0},
  [2519] = {.lex_state = 0},
  [2520] = {.lex_state = 0},
  [2521] = {.lex_state = 3},
  [2522] = {.lex_state = 3},
  [2523] = {.lex_state = 0},
  [2524] = {.lex_state = 3},
  [2525] = {.lex_state = 3},
  [2526] = {.lex_state = 0, .external_lex_state = 2},
  [2527] = {.lex_state = 3},
  [2528] = {.lex_state = 0},
  [2529] = {.lex_state = 3},
  [2530] = {.lex_state = 3},
  [2531] = {.lex_state = 3},
  [2532] = {.lex_state = 3},
  [2533] = {.lex_state = 0},
  [2534] = {.lex_state = 3},
  [2535] = {.lex_state = 0},
  [2536] = {.lex_state = 0},
  [2537] = {.lex_state = 3},
  [2538] = {.lex_state = 3},
  [2539] = {.lex_state = 0},
  [2540] = {.lex_state = 0},
  [2541] = {.lex_state = 3},
  [2542] = {.lex_state = 0},
  [2543] = {.lex_state = 3},
  [2544] = {.lex_state = 3},
  [2545] = {.lex_state = 0, .external_lex_state = 2},
  [2546] = {.lex_state = 0, .external_lex_state = 2},
  [2547] = {.lex_state = 3},
  [2548] = {.lex_state = 0},
  [2549] = {.lex_state = 0, .external_lex_state = 2},
  [2550] = {.lex_state = 3},
  [2551] = {.lex_state = 0},
  [2552] = {.lex_state = 3},
  [2553] = {.lex_state = 0},
  [2554] = {.lex_state = 3},
  [2555] = {.lex_state = 3},
  [2556] = {.lex_state = 3},
  [2557] = {.lex_state = 3},
  [2558] = {.lex_state = 3},
  [2559] = {.lex_state = 0},
  [2560] = {.lex_state = 0},
  [2561] = {.lex_state = 0},
  [2562] = {.lex_state = 0},
  [2563] = {.lex_state = 3},
  [2564] = {.lex_state = 3},
  [2565] = {.lex_state = 0},
  [2566] = {.lex_state = 0},
  [2567] = {.lex_state = 3},
  [2568] = {.lex_state = 0, .external_lex_state = 2},
  [2569] = {.lex_state = 3},
  [2570] = {.lex_state = 0, .external_lex_state = 2},
  [2571] = {.lex_state = 0},
  [2572] = {.lex_state = 3},
  [2573] = {.lex_state = 3},
  [2574] = {.lex_state = 0},
  [2575] = {.lex_state = 3},
  [2576] = {.lex_state = 0},
  [2577] = {.lex_state = 0},
  [2578] = {.lex_state = 0, .external_lex_state = 2},
  [2579] = {.lex_state = 3},
  [2580] = {.lex_state = 3},
  [2581] = {.lex_state = 3},
  [2582] = {.lex_state = 3},
  [2583] = {.lex_state = 3},
  [2584] = {.lex_state = 3},
  [2585] = {.lex_state = 3},
  [2586] = {.lex_state = 0},
  [2587] = {.lex_state = 3},
  [2588] = {.lex_state = 3},
  [2589] = {.lex_state = 0, .external_lex_state = 2},
  [2590] = {.lex_state = 3},
  [2591] = {.lex_state = 0},
  [2592] = {.lex_state = 0},
  [2593] = {.lex_state = 0},
  [2594] = {.lex_state = 0},
  [2595] = {.lex_state = 3},
  [2596] = {.lex_state = 0},
  [2597] = {.lex_state = 3},
  [2598] = {.lex_state = 0},
  [2599] = {.lex_state = 3},
  [2600] = {.lex_state = 3},
  [2601] = {.lex_state = 0},
  [2602] = {.lex_state = 0},
  [2603] = {.lex_state = 0},
  [2604] = {.lex_state = 0},
  [2605] = {.lex_state = 3},
  [2606] = {.lex_state = 0},
  [2607] = {.lex_state = 3},
  [2608] = {.lex_state = 0},
  [2609] = {.lex_state = 3},
  [2610] = {.lex_state = 0},
  [2611] = {.lex_state = 0},
  [2612] = {.lex_state = 3},
  [2613] = {.lex_state = 3},
  [2614] = {.lex_state = 3},
  [2615] = {.lex_state = 3},
  [2616] = {.lex_state = 3},
  [2617] = {.lex_state = 3},
  [2618] = {.lex_state = 3},
  [2619] = {.lex_state = 0},
  [2620] = {.lex_state = 3},
  [2621] = {.lex_state = 3},
  [2622] = {.lex_state = 3},
  [2623] = {.lex_state = 3},
  [2624] = {.lex_state = 3},
  [2625] = {.lex_state = 3},
  [2626] = {.lex_state = 3},
  [2627] = {.lex_state = 0},
  [2628] = {.lex_state = 3},
  [2629] = {.lex_state = 3},
  [2630] = {.lex_state = 3},
  [2631] = {.lex_state = 0},
  [2632] = {.lex_state = 3},
  [2633] = {.lex_state = 0},
  [2634] = {.lex_state = 3},
  [2635] = {.lex_state = 3},
  [2636] = {.lex_state = 3},
  [2637] = {.lex_state = 3},
  [2638] = {.lex_state = 3},
  [2639] = {.lex_state = 0},
  [2640] = {.lex_state = 3},
  [2641] = {.lex_state = 3},
  [2642] = {.lex_state = 3},
  [2643] = {.lex_state = 0},
  [2644] = {.lex_state = 3},
  [2645] = {.lex_state = 3},
  [2646] = {.lex_state = 3},
  [2647] = {.lex_state = 0},
  [2648] = {.lex_state = 3},
  [2649] = {.lex_state = 3},
  [2650] = {.lex_state = 0, .external_lex_state = 2},
  [2651] = {.lex_state = 3},
  [2652] = {.lex_state = 3},
  [2653] = {.lex_state = 3},
  [2654] = {.lex_state = 3},
  [2655] = {.lex_state = 3},
  [2656] = {.lex_state = 3},
  [2657] = {.lex_state = 3},
  [2658] = {.lex_state = 3},
  [2659] = {.lex_state = 0},
  [2660] = {.lex_state = 3},
  [2661] = {.lex_state = 0},
  [2662] = {.lex_state = 3},
  [2663] = {.lex_state = 3},
  [2664] = {.lex_state = 3},
  [2665] = {.lex_state = 0},
  [2666] = {.lex_state = 3},
  [2667] = {.lex_state = 3},
  [2668] = {.lex_state = 3},
  [2669] = {.lex_state = 3},
  [2670] = {.lex_state = 3},
  [2671] = {.lex_state = 3},
  [2672] = {.lex_state = 3},
  [2673] = {.lex_state = 3},
  [2674] = {.lex_state = 3},
  [2675] = {.lex_state = 3},
  [2676] = {.lex_state = 3},
  [2677] = {.lex_state = 3},
  [2678] = {.lex_state = 3},
  [2679] = {.lex_state = 3},
  [2680] = {.lex_state = 3},
  [2681] = {.lex_state = 3},
  [2682] = {.lex_state = 3},
  [2683] = {.lex_state = 3},
  [2684] = {.lex_state = 3},
  [2685] = {.lex_state = 0},
  [2686] = {.lex_state = 3},
  [2687] = {.lex_state = 0},
  [2688] = {.lex_state = 3},
  [2689] = {.lex_state = 3},
  [2690] = {.lex_state = 3},
  [2691] = {.lex_state = 0, .external_lex_state = 2},
  [2692] = {.lex_state = 0},
  [2693] = {.lex_state = 3},
  [2694] = {.lex_state = 3},
  [2695] = {.lex_state = 3},
  [2696] = {.lex_state = 0},
  [2697] = {.lex_state = 3},
  [2698] = {.lex_state = 3},
  [2699] = {.lex_state = 3},
  [2700] = {.lex_state = 0},
  [2701] = {.lex_state = 3},
  [2702] = {.lex_state = 3},
  [2703] = {.lex_state = 3},
  [2704] = {.lex_state = 0, .external_lex_state = 2},
  [2705] = {.lex_state = 3},
  [2706] = {.lex_state = 3},
  [2707] = {.lex_state = 3},
  [2708] = {.lex_state = 0},
  [2709] = {.lex_state = 0},
  [2710] = {.lex_state = 3},
  [2711] = {.lex_state = 0},
  [2712] = {.lex_state = 3},
  [2713] = {.lex_state = 3},
  [2714] = {.lex_state = 0},
  [2715] = {.lex_state = 3},
  [2716] = {.lex_state = 3},
  [2717] = {.lex_state = 3},
  [2718] = {.lex_state = 0},
  [2719] = {.lex_state = 0, .external_lex_state = 2},
  [2720] = {.lex_state = 0},
  [2721] = {.lex_state = 0},
  [2722] = {.lex_state = 3},
  [2723] = {.lex_state = 3},
  [2724] = {.lex_state = 3},
  [2725] = {.lex_state = 3},
  [2726] = {.lex_state = 3},
  [2727] = {.lex_state = 0},
  [2728] = {.lex_state = 0, .external_lex_state = 2},
  [2729] = {.lex_state = 3},
  [2730] = {.lex_state = 0, .external_lex_state = 2},
  [2731] = {.lex_state = 0, .external_lex_state = 2},
  [2732] = {.lex_state = 0, .external_lex_state = 2},
  [2733] = {.lex_state = 0, .external_lex_state = 2},
  [2734] = {.lex_state = 0, .external_lex_state = 2},
  [2735] = {.lex_state = 0},
  [2736] = {.lex_state = 0},
  [2737] = {.lex_state = 3},
  [2738] = {.lex_state = 3},
  [2739] = {.lex_state = 0},
  [2740] = {.lex_state = 0},
  [2741] = {.lex_state = 0},
  [2742] = {.lex_state = 3},
  [2743] = {.lex_state = 0},
  [2744] = {.lex_state = 0},
  [2745] = {.lex_state = 3},
  [2746] = {.lex_state = 0},
  [2747] = {.lex_state = 0},
  [2748] = {.lex_state = 0},
  [2749] = {.lex_state = 0},
  [2750] = {.lex_state = 3},
  [2751] = {.lex_state = 0},
  [2752] = {.lex_state = 0},
  [2753] = {.lex_state = 0},
  [2754] = {.lex_state = 3},
  [2755] = {.lex_state = 0},
  [2756] = {.lex_state = 0},
  [2757] = {.lex_state = 0},
  [2758] = {.lex_state = 0},
  [2759] = {.lex_state = 0},
  [2760] = {.lex_state = 0},
  [2761] = {.lex_state = 3},
  [2762] = {.lex_state = 3},
  [2763] = {.lex_state = 3},
  [2764] = {.lex_state = 0},
  [2765] = {.lex_state = 0},
  [2766] = {.lex_state = 0},
  [2767] = {.lex_state = 0},
  [2768] = {.lex_state = 3},
  [2769] = {.lex_state = 8},
  [2770] = {.lex_state = 3},
  [2771] = {.lex_state = 3},
  [2772] = {.lex_state = 18},
  [2773] = {.lex_state = 0},
  [2774] = {.lex_state = 18},
  [2775] = {.lex_state = 3},
  [2776] = {.lex_state = 3},
  [2777] = {.lex_state = 0},
  [2778] = {.lex_state = 0},
  [2779] = {.lex_state = 3},
  [2780] = {.lex_state = 0},
  [2781] = {.lex_state = 3},
  [2782] = {.lex_state = 3},
  [2783] = {.lex_state = 3},
  [2784] = {.lex_state = 0},
  [2785] = {.lex_state = 3},
  [2786] = {.lex_state = 3},
  [2787] = {.lex_state = 0},
  [2788] = {.lex_state = 3},
  [2789] = {.lex_state = 0},
  [2790] = {.lex_state = 0},
  [2791] = {.lex_state = 0},
  [2792] = {.lex_state = 3},
  [2793] = {.lex_state = 0},
  [2794] = {.lex_state = 0},
  [2795] = {.lex_state = 3},
  [2796] = {.lex_state = 0},
  [2797] = {.lex_state = 3},
  [2798] = {.lex_state = 0},
  [2799] = {.lex_state = 0},
  [2800] = {.lex_state = 3},
  [2801] = {.lex_state = 3},
  [2802] = {.lex_state = 0},
  [2803] = {.lex_state = 0},
  [2804] = {.lex_state = 0},
  [2805] = {.lex_state = 3},
  [2806] = {.lex_state = 0},
  [2807] = {.lex_state = 3},
  [2808] = {.lex_state = 0},
  [2809] = {.lex_state = 0},
  [2810] = {.lex_state = 3},
  [2811] = {.lex_state = 3},
  [2812] = {.lex_state = 3},
  [2813] = {.lex_state = 3},
  [2814] = {.lex_state = 0},
  [2815] = {.lex_state = 0},
  [2816] = {.lex_state = 3},
  [2817] = {.lex_state = 3},
  [2818] = {.lex_state = 0},
  [2819] = {.lex_state = 3},
  [2820] = {.lex_state = 0},
  [2821] = {.lex_state = 3},
  [2822] = {.lex_state = 0},
  [2823] = {.lex_state = 3},
  [2824] = {.lex_state = 0},
  [2825] = {.lex_state = 0},
  [2826] = {.lex_state = 0},
  [2827] = {.lex_state = 3},
  [2828] = {.lex_state = 3},
  [2829] = {.lex_state = 3},
  [2830] = {.lex_state = 0},
  [2831] = {.lex_state = 0},
  [2832] = {.lex_state = 0},
  [2833] = {.lex_state = 0},
  [2834] = {.lex_state = 0},
  [2835] = {.lex_state = 0},
  [2836] = {.lex_state = 0},
  [2837] = {.lex_state = 8},
  [2838] = {.lex_state = 0},
  [2839] = {.lex_state = 0},
  [2840] = {.lex_state = 0},
  [2841] = {.lex_state = 0},
  [2842] = {.lex_state = 18},
  [2843] = {.lex_state = 0},
  [2844] = {.lex_state = 3},
  [2845] = {.lex_state = 3},
  [2846] = {.lex_state = 3},
  [2847] = {.lex_state = 3},
  [2848] = {.lex_state = 0},
  [2849] = {.lex_state = 0},
  [2850] = {.lex_state = 3},
  [2851] = {.lex_state = 3},
  [2852] = {.lex_state = 3},
  [2853] = {.lex_state = 0},
  [2854] = {.lex_state = 0},
  [2855] = {.lex_state = 0},
  [2856] = {.lex_state = 3},
  [2857] = {.lex_state = 0},
  [2858] = {.lex_state = 3},
  [2859] = {.lex_state = 0},
  [2860] = {.lex_state = 3},
  [2861] = {.lex_state = 3},
  [2862] = {.lex_state = 3},
  [2863] = {.lex_state = 0},
  [2864] = {.lex_state = 3},
  [2865] = {.lex_state = 3},
  [2866] = {.lex_state = 3},
  [2867] = {.lex_state = 0},
  [2868] = {.lex_state = 0},
  [2869] = {.lex_state = 3},
  [2870] = {.lex_state = 3},
  [2871] = {.lex_state = 3},
  [2872] = {.lex_state = 3},
  [2873] = {.lex_state = 3},
  [2874] = {.lex_state = 0},
  [2875] = {.lex_state = 0},
  [2876] = {.lex_state = 3},
  [2877] = {.lex_state = 3},
  [2878] = {.lex_state = 0},
  [2879] = {.lex_state = 3},
  [2880] = {.lex_state = 3},
  [2881] = {.lex_state = 18},
  [2882] = {.lex_state = 0},
  [2883] = {.lex_state = 0},
  [2884] = {.lex_state = 0},
  [2885] = {.lex_state = 0},
  [2886] = {.lex_state = 3},
  [2887] = {.lex_state = 3},
  [2888] = {.lex_state = 3},
  [2889] = {.lex_state = 0},
  [2890] = {.lex_state = 0},
  [2891] = {.lex_state = 0},
  [2892] = {.lex_state = 0},
  [2893] = {.lex_state = 0},
  [2894] = {.lex_state = 0},
  [2895] = {.lex_state = 3},
  [2896] = {.lex_state = 3},
  [2897] = {.lex_state = 8},
  [2898] = {.lex_state = 3},
  [2899] = {.lex_state = 0},
  [2900] = {.lex_state = 0},
  [2901] = {.lex_state = 3},
  [2902] = {.lex_state = 3},
  [2903] = {.lex_state = 3},
  [2904] = {.lex_state = 0},
  [2905] = {.lex_state = 0},
  [2906] = {.lex_state = 3},
  [2907] = {.lex_state = 0},
  [2908] = {.lex_state = 3},
  [2909] = {.lex_state = 0},
  [2910] = {.lex_state = 0},
  [2911] = {.lex_state = 0},
  [2912] = {.lex_state = 0},
  [2913] = {.lex_state = 0},
  [2914] = {.lex_state = 3},
  [2915] = {.lex_state = 3},
  [2916] = {.lex_state = 3},
  [2917] = {.lex_state = 3},
  [2918] = {.lex_state = 3},
  [2919] = {.lex_state = 3},
  [2920] = {.lex_state = 3},
  [2921] = {.lex_state = 3},
  [2922] = {.lex_state = 3},
  [2923] = {.lex_state = 3},
  [2924] = {.lex_state = 8},
  [2925] = {.lex_state = 0},
  [2926] = {.lex_state = 0},
  [2927] = {.lex_state = 3},
  [2928] = {.lex_state = 0},
  [2929] = {.lex_state = 3},
  [2930] = {.lex_state = 0},
  [2931] = {.lex_state = 0},
  [2932] = {.lex_state = 3},
  [2933] = {.lex_state = 0},
  [2934] = {.lex_state = 3},
  [2935] = {.lex_state = 3},
  [2936] = {.lex_state = 0},
  [2937] = {.lex_state = 0},
  [2938] = {.lex_state = 3},
  [2939] = {.lex_state = 3},
  [2940] = {.lex_state = 3},
  [2941] = {.lex_state = 3},
  [2942] = {.lex_state = 3},
  [2943] = {.lex_state = 0},
  [2944] = {.lex_state = 0},
  [2945] = {.lex_state = 0},
  [2946] = {.lex_state = 0},
  [2947] = {.lex_state = 3},
  [2948] = {.lex_state = 3},
  [2949] = {.lex_state = 3},
  [2950] = {.lex_state = 3},
  [2951] = {.lex_state = 3},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
};

static bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [3] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(2900),
    [sym_export_statement] = STATE(19),
    [sym__declaration] = STATE(19),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(19),
    [sym_lexical_declaration] = STATE(19),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(19),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(19),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(19),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(19),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(19),
    [sym_abstract_class_declaration] = STATE(19),
    [sym_module] = STATE(19),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(19),
    [sym_interface_declaration] = STATE(19),
    [sym_enum_declaration] = STATE(19),
    [sym_type_alias_declaration] = STATE(19),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [2] = {
    [sym_export_statement] = STATE(22),
    [sym__declaration] = STATE(22),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(22),
    [sym_lexical_declaration] = STATE(22),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1441),
    [sym_assignment_pattern] = STATE(2374),
    [sym_array] = STATE(1442),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(22),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(22),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(22),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_spread_element] = STATE(2374),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1439),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_method_definition] = STATE(2374),
    [sym_pair] = STATE(2374),
    [sym__property_name] = STATE(1980),
    [sym_computed_property_name] = STATE(1980),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(22),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(22),
    [sym_abstract_class_declaration] = STATE(22),
    [sym_module] = STATE(22),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(22),
    [sym_interface_declaration] = STATE(22),
    [sym_enum_declaration] = STATE(22),
    [sym_type_alias_declaration] = STATE(22),
    [sym_accessibility_modifier] = STATE(1726),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [aux_sym_object_repeat1] = STATE(2516),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(119),
    [anon_sym_type] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(125),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(129),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(135),
    [anon_sym_set] = ACTIONS(135),
    [anon_sym_declare] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_module] = ACTIONS(141),
    [anon_sym_any] = ACTIONS(143),
    [anon_sym_number] = ACTIONS(143),
    [anon_sym_boolean] = ACTIONS(143),
    [anon_sym_string] = ACTIONS(143),
    [anon_sym_symbol] = ACTIONS(143),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [3] = {
    [sym_export_statement] = STATE(30),
    [sym__declaration] = STATE(30),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_variable_declaration] = STATE(30),
    [sym_lexical_declaration] = STATE(30),
    [sym_statement_block] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_for_in_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_debugger_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_throw_statement] = STATE(30),
    [sym_empty_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1441),
    [sym_assignment_pattern] = STATE(2374),
    [sym_array] = STATE(1442),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(30),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(30),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(30),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_spread_element] = STATE(2374),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1439),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_method_definition] = STATE(2374),
    [sym_pair] = STATE(2374),
    [sym__property_name] = STATE(1980),
    [sym_computed_property_name] = STATE(1980),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(30),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(30),
    [sym_abstract_class_declaration] = STATE(30),
    [sym_module] = STATE(30),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(30),
    [sym_interface_declaration] = STATE(30),
    [sym_enum_declaration] = STATE(30),
    [sym_type_alias_declaration] = STATE(30),
    [sym_accessibility_modifier] = STATE(1726),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(30),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [aux_sym_object_repeat1] = STATE(2516),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(147),
    [anon_sym_type] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(125),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(129),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(135),
    [anon_sym_set] = ACTIONS(135),
    [anon_sym_declare] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_module] = ACTIONS(141),
    [anon_sym_any] = ACTIONS(143),
    [anon_sym_number] = ACTIONS(143),
    [anon_sym_boolean] = ACTIONS(143),
    [anon_sym_string] = ACTIONS(143),
    [anon_sym_symbol] = ACTIONS(143),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [4] = {
    [sym_export_statement] = STATE(30),
    [sym__declaration] = STATE(30),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_variable_declaration] = STATE(30),
    [sym_lexical_declaration] = STATE(30),
    [sym_statement_block] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_for_in_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_debugger_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_throw_statement] = STATE(30),
    [sym_empty_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1441),
    [sym_assignment_pattern] = STATE(2374),
    [sym_array] = STATE(1442),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(30),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(30),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(30),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_spread_element] = STATE(2374),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1439),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_method_definition] = STATE(2374),
    [sym_pair] = STATE(2374),
    [sym__property_name] = STATE(1980),
    [sym_computed_property_name] = STATE(1980),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(30),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(30),
    [sym_abstract_class_declaration] = STATE(30),
    [sym_module] = STATE(30),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(30),
    [sym_interface_declaration] = STATE(30),
    [sym_enum_declaration] = STATE(30),
    [sym_type_alias_declaration] = STATE(30),
    [sym_accessibility_modifier] = STATE(1726),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(30),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [aux_sym_object_repeat1] = STATE(2516),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(125),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(129),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(135),
    [anon_sym_set] = ACTIONS(135),
    [anon_sym_declare] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_module] = ACTIONS(141),
    [anon_sym_any] = ACTIONS(143),
    [anon_sym_number] = ACTIONS(143),
    [anon_sym_boolean] = ACTIONS(143),
    [anon_sym_string] = ACTIONS(143),
    [anon_sym_symbol] = ACTIONS(143),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [5] = {
    [sym_export_statement] = STATE(29),
    [sym__declaration] = STATE(29),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_variable_declaration] = STATE(29),
    [sym_lexical_declaration] = STATE(29),
    [sym_statement_block] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_for_in_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_with_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_debugger_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_throw_statement] = STATE(29),
    [sym_empty_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1441),
    [sym_assignment_pattern] = STATE(2396),
    [sym_array] = STATE(1442),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(29),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(29),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(29),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_spread_element] = STATE(2396),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1439),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_method_definition] = STATE(2396),
    [sym_pair] = STATE(2396),
    [sym__property_name] = STATE(1980),
    [sym_computed_property_name] = STATE(1980),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(29),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(29),
    [sym_abstract_class_declaration] = STATE(29),
    [sym_module] = STATE(29),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(29),
    [sym_interface_declaration] = STATE(29),
    [sym_enum_declaration] = STATE(29),
    [sym_type_alias_declaration] = STATE(29),
    [sym_accessibility_modifier] = STATE(1726),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(29),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [aux_sym_object_repeat1] = STATE(2398),
    [sym_identifier] = ACTIONS(151),
    [anon_sym_export] = ACTIONS(153),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(157),
    [anon_sym_type] = ACTIONS(159),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(161),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(165),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(167),
    [anon_sym_declare] = ACTIONS(169),
    [anon_sym_public] = ACTIONS(171),
    [anon_sym_private] = ACTIONS(171),
    [anon_sym_protected] = ACTIONS(171),
    [anon_sym_module] = ACTIONS(173),
    [anon_sym_any] = ACTIONS(175),
    [anon_sym_number] = ACTIONS(175),
    [anon_sym_boolean] = ACTIONS(175),
    [anon_sym_string] = ACTIONS(175),
    [anon_sym_symbol] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [6] = {
    [sym_export_statement] = STATE(21),
    [sym__declaration] = STATE(21),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(21),
    [sym_lexical_declaration] = STATE(21),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1441),
    [sym_assignment_pattern] = STATE(2462),
    [sym_array] = STATE(1442),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(21),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(21),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(21),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_spread_element] = STATE(2462),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1439),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_method_definition] = STATE(2462),
    [sym_pair] = STATE(2462),
    [sym__property_name] = STATE(1980),
    [sym_computed_property_name] = STATE(1980),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(21),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(21),
    [sym_abstract_class_declaration] = STATE(21),
    [sym_module] = STATE(21),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(21),
    [sym_interface_declaration] = STATE(21),
    [sym_enum_declaration] = STATE(21),
    [sym_type_alias_declaration] = STATE(21),
    [sym_accessibility_modifier] = STATE(1726),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [aux_sym_object_repeat1] = STATE(2453),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_export] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(181),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_type] = ACTIONS(185),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(187),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(189),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(191),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(193),
    [anon_sym_set] = ACTIONS(193),
    [anon_sym_declare] = ACTIONS(195),
    [anon_sym_public] = ACTIONS(197),
    [anon_sym_private] = ACTIONS(197),
    [anon_sym_protected] = ACTIONS(197),
    [anon_sym_module] = ACTIONS(199),
    [anon_sym_any] = ACTIONS(201),
    [anon_sym_number] = ACTIONS(201),
    [anon_sym_boolean] = ACTIONS(201),
    [anon_sym_string] = ACTIONS(201),
    [anon_sym_symbol] = ACTIONS(201),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [7] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [ts_builtin_sym_end] = ACTIONS(203),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_export] = ACTIONS(208),
    [anon_sym_default] = ACTIONS(211),
    [anon_sym_namespace] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(216),
    [anon_sym_RBRACE] = ACTIONS(203),
    [anon_sym_type] = ACTIONS(219),
    [anon_sym_typeof] = ACTIONS(222),
    [anon_sym_import] = ACTIONS(225),
    [anon_sym_var] = ACTIONS(228),
    [anon_sym_let] = ACTIONS(231),
    [anon_sym_const] = ACTIONS(234),
    [anon_sym_if] = ACTIONS(237),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_for] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_await] = ACTIONS(249),
    [anon_sym_while] = ACTIONS(252),
    [anon_sym_do] = ACTIONS(255),
    [anon_sym_try] = ACTIONS(258),
    [anon_sym_with] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(264),
    [anon_sym_continue] = ACTIONS(267),
    [anon_sym_debugger] = ACTIONS(270),
    [anon_sym_return] = ACTIONS(273),
    [anon_sym_throw] = ACTIONS(276),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_case] = ACTIONS(211),
    [anon_sym_yield] = ACTIONS(282),
    [anon_sym_LBRACK] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(288),
    [anon_sym_SLASH] = ACTIONS(291),
    [anon_sym_class] = ACTIONS(294),
    [anon_sym_async] = ACTIONS(297),
    [anon_sym_function] = ACTIONS(300),
    [anon_sym_new] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(306),
    [anon_sym_DASH] = ACTIONS(306),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_void] = ACTIONS(312),
    [anon_sym_delete] = ACTIONS(222),
    [anon_sym_PLUS_PLUS] = ACTIONS(315),
    [anon_sym_DASH_DASH] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(318),
    [anon_sym_SQUOTE] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(324),
    [sym_number] = ACTIONS(327),
    [sym_this] = ACTIONS(330),
    [sym_super] = ACTIONS(333),
    [sym_true] = ACTIONS(330),
    [sym_false] = ACTIONS(330),
    [sym_null] = ACTIONS(330),
    [sym_undefined] = ACTIONS(330),
    [anon_sym_AT] = ACTIONS(336),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(342),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(345),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(348),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_interface] = ACTIONS(351),
    [anon_sym_enum] = ACTIONS(354),
  },
  [8] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(357),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(359),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(357),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [9] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(361),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(361),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [10] = {
    [sym_export_statement] = STATE(9),
    [sym__declaration] = STATE(9),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(9),
    [sym_lexical_declaration] = STATE(9),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(9),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(9),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(9),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(9),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(9),
    [sym_abstract_class_declaration] = STATE(9),
    [sym_module] = STATE(9),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(9),
    [sym_interface_declaration] = STATE(9),
    [sym_enum_declaration] = STATE(9),
    [sym_type_alias_declaration] = STATE(9),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(367),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [11] = {
    [sym_export_statement] = STATE(8),
    [sym__declaration] = STATE(8),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(8),
    [sym_expression_statement] = STATE(8),
    [sym_variable_declaration] = STATE(8),
    [sym_lexical_declaration] = STATE(8),
    [sym_statement_block] = STATE(8),
    [sym_if_statement] = STATE(8),
    [sym_switch_statement] = STATE(8),
    [sym_for_statement] = STATE(8),
    [sym_for_in_statement] = STATE(8),
    [sym_while_statement] = STATE(8),
    [sym_do_statement] = STATE(8),
    [sym_try_statement] = STATE(8),
    [sym_with_statement] = STATE(8),
    [sym_break_statement] = STATE(8),
    [sym_continue_statement] = STATE(8),
    [sym_debugger_statement] = STATE(8),
    [sym_return_statement] = STATE(8),
    [sym_throw_statement] = STATE(8),
    [sym_empty_statement] = STATE(8),
    [sym_labeled_statement] = STATE(8),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(8),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(8),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(8),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(8),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(8),
    [sym_abstract_class_declaration] = STATE(8),
    [sym_module] = STATE(8),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(8),
    [sym_interface_declaration] = STATE(8),
    [sym_enum_declaration] = STATE(8),
    [sym_type_alias_declaration] = STATE(8),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(8),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(369),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [12] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(373),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [13] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [14] = {
    [sym_export_statement] = STATE(25),
    [sym__declaration] = STATE(25),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(25),
    [sym_lexical_declaration] = STATE(25),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(25),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(25),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(25),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(25),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(25),
    [sym_abstract_class_declaration] = STATE(25),
    [sym_module] = STATE(25),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(25),
    [sym_interface_declaration] = STATE(25),
    [sym_enum_declaration] = STATE(25),
    [sym_type_alias_declaration] = STATE(25),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(377),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [15] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(12),
    [sym_lexical_declaration] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(12),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(12),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(12),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(12),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(12),
    [sym_abstract_class_declaration] = STATE(12),
    [sym_module] = STATE(12),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(12),
    [sym_interface_declaration] = STATE(12),
    [sym_enum_declaration] = STATE(12),
    [sym_type_alias_declaration] = STATE(12),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [16] = {
    [sym_export_statement] = STATE(21),
    [sym__declaration] = STATE(21),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(21),
    [sym_lexical_declaration] = STATE(21),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(21),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(21),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(21),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(21),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(21),
    [sym_abstract_class_declaration] = STATE(21),
    [sym_module] = STATE(21),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(21),
    [sym_interface_declaration] = STATE(21),
    [sym_enum_declaration] = STATE(21),
    [sym_type_alias_declaration] = STATE(21),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(381),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [17] = {
    [sym_export_statement] = STATE(13),
    [sym__declaration] = STATE(13),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_variable_declaration] = STATE(13),
    [sym_lexical_declaration] = STATE(13),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_debugger_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(13),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(13),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(13),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(13),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(13),
    [sym_abstract_class_declaration] = STATE(13),
    [sym_module] = STATE(13),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(13),
    [sym_interface_declaration] = STATE(13),
    [sym_enum_declaration] = STATE(13),
    [sym_type_alias_declaration] = STATE(13),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [18] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [ts_builtin_sym_end] = ACTIONS(385),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [19] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [20] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [21] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [22] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(393),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [23] = {
    [sym_export_statement] = STATE(22),
    [sym__declaration] = STATE(22),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(22),
    [sym_lexical_declaration] = STATE(22),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(22),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(22),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(22),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(22),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(22),
    [sym_abstract_class_declaration] = STATE(22),
    [sym_module] = STATE(22),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(22),
    [sym_interface_declaration] = STATE(22),
    [sym_enum_declaration] = STATE(22),
    [sym_type_alias_declaration] = STATE(22),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [24] = {
    [sym_export_statement] = STATE(29),
    [sym__declaration] = STATE(29),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_variable_declaration] = STATE(29),
    [sym_lexical_declaration] = STATE(29),
    [sym_statement_block] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_for_in_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_with_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_debugger_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_throw_statement] = STATE(29),
    [sym_empty_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(29),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(29),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(29),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(29),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(29),
    [sym_abstract_class_declaration] = STATE(29),
    [sym_module] = STATE(29),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(29),
    [sym_interface_declaration] = STATE(29),
    [sym_enum_declaration] = STATE(29),
    [sym_type_alias_declaration] = STATE(29),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(29),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(395),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [25] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [26] = {
    [sym_export_statement] = STATE(20),
    [sym__declaration] = STATE(20),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(20),
    [sym_lexical_declaration] = STATE(20),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(20),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(20),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(20),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(20),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(20),
    [sym_abstract_class_declaration] = STATE(20),
    [sym_module] = STATE(20),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(20),
    [sym_interface_declaration] = STATE(20),
    [sym_enum_declaration] = STATE(20),
    [sym_type_alias_declaration] = STATE(20),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [27] = {
    [sym_export_statement] = STATE(30),
    [sym__declaration] = STATE(30),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_variable_declaration] = STATE(30),
    [sym_lexical_declaration] = STATE(30),
    [sym_statement_block] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_for_in_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_debugger_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_throw_statement] = STATE(30),
    [sym_empty_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(30),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(30),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(30),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(30),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(30),
    [sym_abstract_class_declaration] = STATE(30),
    [sym_module] = STATE(30),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(30),
    [sym_interface_declaration] = STATE(30),
    [sym_enum_declaration] = STATE(30),
    [sym_type_alias_declaration] = STATE(30),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(30),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(401),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [28] = {
    [sym_export_statement] = STATE(18),
    [sym__declaration] = STATE(18),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(18),
    [sym_lexical_declaration] = STATE(18),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(18),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(18),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(18),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(18),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(18),
    [sym_abstract_class_declaration] = STATE(18),
    [sym_module] = STATE(18),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(18),
    [sym_interface_declaration] = STATE(18),
    [sym_enum_declaration] = STATE(18),
    [sym_type_alias_declaration] = STATE(18),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [29] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [30] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(405),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [31] = {
    [sym_export_statement] = STATE(555),
    [sym__declaration] = STATE(555),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(555),
    [sym_expression_statement] = STATE(555),
    [sym_variable_declaration] = STATE(555),
    [sym_lexical_declaration] = STATE(555),
    [sym_statement_block] = STATE(555),
    [sym_if_statement] = STATE(555),
    [sym_switch_statement] = STATE(555),
    [sym_for_statement] = STATE(555),
    [sym_for_in_statement] = STATE(555),
    [sym_while_statement] = STATE(555),
    [sym_do_statement] = STATE(555),
    [sym_try_statement] = STATE(555),
    [sym_with_statement] = STATE(555),
    [sym_break_statement] = STATE(555),
    [sym_continue_statement] = STATE(555),
    [sym_debugger_statement] = STATE(555),
    [sym_return_statement] = STATE(555),
    [sym_throw_statement] = STATE(555),
    [sym_empty_statement] = STATE(555),
    [sym_labeled_statement] = STATE(555),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(555),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(555),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(555),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(555),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(555),
    [sym_abstract_class_declaration] = STATE(555),
    [sym_module] = STATE(555),
    [sym_internal_module] = STATE(1255),
    [sym_import_alias] = STATE(555),
    [sym_interface_declaration] = STATE(555),
    [sym_enum_declaration] = STATE(555),
    [sym_type_alias_declaration] = STATE(555),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2152),
    [sym_identifier] = ACTIONS(407),
    [anon_sym_export] = ACTIONS(409),
    [anon_sym_namespace] = ACTIONS(411),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_type] = ACTIONS(415),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(423),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(425),
    [anon_sym_async] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(431),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(433),
    [anon_sym_abstract] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(433),
    [anon_sym_set] = ACTIONS(433),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(433),
    [anon_sym_private] = ACTIONS(433),
    [anon_sym_protected] = ACTIONS(433),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(433),
    [anon_sym_number] = ACTIONS(433),
    [anon_sym_boolean] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_symbol] = ACTIONS(433),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [32] = {
    [sym_export_statement] = STATE(531),
    [sym__declaration] = STATE(531),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(531),
    [sym_expression_statement] = STATE(531),
    [sym_variable_declaration] = STATE(531),
    [sym_lexical_declaration] = STATE(531),
    [sym_statement_block] = STATE(531),
    [sym_if_statement] = STATE(531),
    [sym_switch_statement] = STATE(531),
    [sym_for_statement] = STATE(531),
    [sym_for_in_statement] = STATE(531),
    [sym_while_statement] = STATE(531),
    [sym_do_statement] = STATE(531),
    [sym_try_statement] = STATE(531),
    [sym_with_statement] = STATE(531),
    [sym_break_statement] = STATE(531),
    [sym_continue_statement] = STATE(531),
    [sym_debugger_statement] = STATE(531),
    [sym_return_statement] = STATE(531),
    [sym_throw_statement] = STATE(531),
    [sym_empty_statement] = STATE(531),
    [sym_labeled_statement] = STATE(531),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(531),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(531),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(531),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(531),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(531),
    [sym_abstract_class_declaration] = STATE(531),
    [sym_module] = STATE(531),
    [sym_internal_module] = STATE(1255),
    [sym_import_alias] = STATE(531),
    [sym_interface_declaration] = STATE(531),
    [sym_enum_declaration] = STATE(531),
    [sym_type_alias_declaration] = STATE(531),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2152),
    [sym_identifier] = ACTIONS(407),
    [anon_sym_export] = ACTIONS(409),
    [anon_sym_namespace] = ACTIONS(411),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_type] = ACTIONS(415),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(423),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(425),
    [anon_sym_async] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(431),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(433),
    [anon_sym_abstract] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(433),
    [anon_sym_set] = ACTIONS(433),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(433),
    [anon_sym_private] = ACTIONS(433),
    [anon_sym_protected] = ACTIONS(433),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(433),
    [anon_sym_number] = ACTIONS(433),
    [anon_sym_boolean] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_symbol] = ACTIONS(433),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [33] = {
    [sym_export_statement] = STATE(523),
    [sym__declaration] = STATE(523),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(523),
    [sym_expression_statement] = STATE(523),
    [sym_variable_declaration] = STATE(523),
    [sym_lexical_declaration] = STATE(523),
    [sym_statement_block] = STATE(523),
    [sym_if_statement] = STATE(523),
    [sym_switch_statement] = STATE(523),
    [sym_for_statement] = STATE(523),
    [sym_for_in_statement] = STATE(523),
    [sym_while_statement] = STATE(523),
    [sym_do_statement] = STATE(523),
    [sym_try_statement] = STATE(523),
    [sym_with_statement] = STATE(523),
    [sym_break_statement] = STATE(523),
    [sym_continue_statement] = STATE(523),
    [sym_debugger_statement] = STATE(523),
    [sym_return_statement] = STATE(523),
    [sym_throw_statement] = STATE(523),
    [sym_empty_statement] = STATE(523),
    [sym_labeled_statement] = STATE(523),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(523),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(523),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(523),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(523),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(523),
    [sym_abstract_class_declaration] = STATE(523),
    [sym_module] = STATE(523),
    [sym_internal_module] = STATE(1255),
    [sym_import_alias] = STATE(523),
    [sym_interface_declaration] = STATE(523),
    [sym_enum_declaration] = STATE(523),
    [sym_type_alias_declaration] = STATE(523),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2152),
    [sym_identifier] = ACTIONS(407),
    [anon_sym_export] = ACTIONS(409),
    [anon_sym_namespace] = ACTIONS(411),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_type] = ACTIONS(415),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(423),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(425),
    [anon_sym_async] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(431),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(433),
    [anon_sym_abstract] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(433),
    [anon_sym_set] = ACTIONS(433),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(433),
    [anon_sym_private] = ACTIONS(433),
    [anon_sym_protected] = ACTIONS(433),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(433),
    [anon_sym_number] = ACTIONS(433),
    [anon_sym_boolean] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_symbol] = ACTIONS(433),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [34] = {
    [sym_export_statement] = STATE(2640),
    [sym__declaration] = STATE(2640),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(2640),
    [sym_expression_statement] = STATE(2640),
    [sym_variable_declaration] = STATE(2640),
    [sym_lexical_declaration] = STATE(2640),
    [sym_statement_block] = STATE(2640),
    [sym_if_statement] = STATE(2640),
    [sym_switch_statement] = STATE(2640),
    [sym_for_statement] = STATE(2640),
    [sym_for_in_statement] = STATE(2640),
    [sym_while_statement] = STATE(2640),
    [sym_do_statement] = STATE(2640),
    [sym_try_statement] = STATE(2640),
    [sym_with_statement] = STATE(2640),
    [sym_break_statement] = STATE(2640),
    [sym_continue_statement] = STATE(2640),
    [sym_debugger_statement] = STATE(2640),
    [sym_return_statement] = STATE(2640),
    [sym_throw_statement] = STATE(2640),
    [sym_empty_statement] = STATE(2640),
    [sym_labeled_statement] = STATE(2640),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(2640),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(2640),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(2640),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(2640),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(2640),
    [sym_abstract_class_declaration] = STATE(2640),
    [sym_module] = STATE(2640),
    [sym_internal_module] = STATE(1255),
    [sym_import_alias] = STATE(2640),
    [sym_interface_declaration] = STATE(2640),
    [sym_enum_declaration] = STATE(2640),
    [sym_type_alias_declaration] = STATE(2640),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2152),
    [sym_identifier] = ACTIONS(407),
    [anon_sym_export] = ACTIONS(409),
    [anon_sym_namespace] = ACTIONS(411),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_type] = ACTIONS(415),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(423),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(425),
    [anon_sym_async] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(431),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(433),
    [anon_sym_abstract] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(433),
    [anon_sym_set] = ACTIONS(433),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(433),
    [anon_sym_private] = ACTIONS(433),
    [anon_sym_protected] = ACTIONS(433),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(433),
    [anon_sym_number] = ACTIONS(433),
    [anon_sym_boolean] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_symbol] = ACTIONS(433),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [35] = {
    [sym_export_statement] = STATE(529),
    [sym__declaration] = STATE(529),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(529),
    [sym_expression_statement] = STATE(529),
    [sym_variable_declaration] = STATE(529),
    [sym_lexical_declaration] = STATE(529),
    [sym_statement_block] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_switch_statement] = STATE(529),
    [sym_for_statement] = STATE(529),
    [sym_for_in_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_do_statement] = STATE(529),
    [sym_try_statement] = STATE(529),
    [sym_with_statement] = STATE(529),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(529),
    [sym_debugger_statement] = STATE(529),
    [sym_return_statement] = STATE(529),
    [sym_throw_statement] = STATE(529),
    [sym_empty_statement] = STATE(529),
    [sym_labeled_statement] = STATE(529),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(529),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(529),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(529),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(529),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(529),
    [sym_abstract_class_declaration] = STATE(529),
    [sym_module] = STATE(529),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(529),
    [sym_interface_declaration] = STATE(529),
    [sym_enum_declaration] = STATE(529),
    [sym_type_alias_declaration] = STATE(529),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [36] = {
    [sym_export_statement] = STATE(587),
    [sym__declaration] = STATE(587),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(587),
    [sym_expression_statement] = STATE(587),
    [sym_variable_declaration] = STATE(587),
    [sym_lexical_declaration] = STATE(587),
    [sym_statement_block] = STATE(587),
    [sym_if_statement] = STATE(587),
    [sym_switch_statement] = STATE(587),
    [sym_for_statement] = STATE(587),
    [sym_for_in_statement] = STATE(587),
    [sym_while_statement] = STATE(587),
    [sym_do_statement] = STATE(587),
    [sym_try_statement] = STATE(587),
    [sym_with_statement] = STATE(587),
    [sym_break_statement] = STATE(587),
    [sym_continue_statement] = STATE(587),
    [sym_debugger_statement] = STATE(587),
    [sym_return_statement] = STATE(587),
    [sym_throw_statement] = STATE(587),
    [sym_empty_statement] = STATE(587),
    [sym_labeled_statement] = STATE(587),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(587),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(587),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(587),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(587),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(587),
    [sym_abstract_class_declaration] = STATE(587),
    [sym_module] = STATE(587),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(587),
    [sym_interface_declaration] = STATE(587),
    [sym_enum_declaration] = STATE(587),
    [sym_type_alias_declaration] = STATE(587),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [37] = {
    [sym_export_statement] = STATE(518),
    [sym__declaration] = STATE(518),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(518),
    [sym_expression_statement] = STATE(518),
    [sym_variable_declaration] = STATE(518),
    [sym_lexical_declaration] = STATE(518),
    [sym_statement_block] = STATE(518),
    [sym_if_statement] = STATE(518),
    [sym_switch_statement] = STATE(518),
    [sym_for_statement] = STATE(518),
    [sym_for_in_statement] = STATE(518),
    [sym_while_statement] = STATE(518),
    [sym_do_statement] = STATE(518),
    [sym_try_statement] = STATE(518),
    [sym_with_statement] = STATE(518),
    [sym_break_statement] = STATE(518),
    [sym_continue_statement] = STATE(518),
    [sym_debugger_statement] = STATE(518),
    [sym_return_statement] = STATE(518),
    [sym_throw_statement] = STATE(518),
    [sym_empty_statement] = STATE(518),
    [sym_labeled_statement] = STATE(518),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(518),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(518),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(518),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(518),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(518),
    [sym_abstract_class_declaration] = STATE(518),
    [sym_module] = STATE(518),
    [sym_internal_module] = STATE(1255),
    [sym_import_alias] = STATE(518),
    [sym_interface_declaration] = STATE(518),
    [sym_enum_declaration] = STATE(518),
    [sym_type_alias_declaration] = STATE(518),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2152),
    [sym_identifier] = ACTIONS(407),
    [anon_sym_export] = ACTIONS(409),
    [anon_sym_namespace] = ACTIONS(411),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_type] = ACTIONS(415),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(423),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(425),
    [anon_sym_async] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(431),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(433),
    [anon_sym_abstract] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(433),
    [anon_sym_set] = ACTIONS(433),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(433),
    [anon_sym_private] = ACTIONS(433),
    [anon_sym_protected] = ACTIONS(433),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(433),
    [anon_sym_number] = ACTIONS(433),
    [anon_sym_boolean] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_symbol] = ACTIONS(433),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [38] = {
    [sym_export_statement] = STATE(587),
    [sym__declaration] = STATE(587),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(587),
    [sym_expression_statement] = STATE(587),
    [sym_variable_declaration] = STATE(587),
    [sym_lexical_declaration] = STATE(587),
    [sym_statement_block] = STATE(587),
    [sym_if_statement] = STATE(587),
    [sym_switch_statement] = STATE(587),
    [sym_for_statement] = STATE(587),
    [sym_for_in_statement] = STATE(587),
    [sym_while_statement] = STATE(587),
    [sym_do_statement] = STATE(587),
    [sym_try_statement] = STATE(587),
    [sym_with_statement] = STATE(587),
    [sym_break_statement] = STATE(587),
    [sym_continue_statement] = STATE(587),
    [sym_debugger_statement] = STATE(587),
    [sym_return_statement] = STATE(587),
    [sym_throw_statement] = STATE(587),
    [sym_empty_statement] = STATE(587),
    [sym_labeled_statement] = STATE(587),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(587),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(587),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(587),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(587),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(587),
    [sym_abstract_class_declaration] = STATE(587),
    [sym_module] = STATE(587),
    [sym_internal_module] = STATE(1255),
    [sym_import_alias] = STATE(587),
    [sym_interface_declaration] = STATE(587),
    [sym_enum_declaration] = STATE(587),
    [sym_type_alias_declaration] = STATE(587),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2152),
    [sym_identifier] = ACTIONS(407),
    [anon_sym_export] = ACTIONS(409),
    [anon_sym_namespace] = ACTIONS(411),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_type] = ACTIONS(415),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(423),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(425),
    [anon_sym_async] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(431),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(433),
    [anon_sym_abstract] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(433),
    [anon_sym_set] = ACTIONS(433),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(433),
    [anon_sym_private] = ACTIONS(433),
    [anon_sym_protected] = ACTIONS(433),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(433),
    [anon_sym_number] = ACTIONS(433),
    [anon_sym_boolean] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_symbol] = ACTIONS(433),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [39] = {
    [sym_export_statement] = STATE(583),
    [sym__declaration] = STATE(583),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(583),
    [sym_expression_statement] = STATE(583),
    [sym_variable_declaration] = STATE(583),
    [sym_lexical_declaration] = STATE(583),
    [sym_statement_block] = STATE(583),
    [sym_if_statement] = STATE(583),
    [sym_switch_statement] = STATE(583),
    [sym_for_statement] = STATE(583),
    [sym_for_in_statement] = STATE(583),
    [sym_while_statement] = STATE(583),
    [sym_do_statement] = STATE(583),
    [sym_try_statement] = STATE(583),
    [sym_with_statement] = STATE(583),
    [sym_break_statement] = STATE(583),
    [sym_continue_statement] = STATE(583),
    [sym_debugger_statement] = STATE(583),
    [sym_return_statement] = STATE(583),
    [sym_throw_statement] = STATE(583),
    [sym_empty_statement] = STATE(583),
    [sym_labeled_statement] = STATE(583),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(583),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(583),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(583),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(583),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(583),
    [sym_abstract_class_declaration] = STATE(583),
    [sym_module] = STATE(583),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(583),
    [sym_interface_declaration] = STATE(583),
    [sym_enum_declaration] = STATE(583),
    [sym_type_alias_declaration] = STATE(583),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [40] = {
    [sym_export_statement] = STATE(531),
    [sym__declaration] = STATE(531),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(531),
    [sym_expression_statement] = STATE(531),
    [sym_variable_declaration] = STATE(531),
    [sym_lexical_declaration] = STATE(531),
    [sym_statement_block] = STATE(531),
    [sym_if_statement] = STATE(531),
    [sym_switch_statement] = STATE(531),
    [sym_for_statement] = STATE(531),
    [sym_for_in_statement] = STATE(531),
    [sym_while_statement] = STATE(531),
    [sym_do_statement] = STATE(531),
    [sym_try_statement] = STATE(531),
    [sym_with_statement] = STATE(531),
    [sym_break_statement] = STATE(531),
    [sym_continue_statement] = STATE(531),
    [sym_debugger_statement] = STATE(531),
    [sym_return_statement] = STATE(531),
    [sym_throw_statement] = STATE(531),
    [sym_empty_statement] = STATE(531),
    [sym_labeled_statement] = STATE(531),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(531),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(531),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(531),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(531),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(531),
    [sym_abstract_class_declaration] = STATE(531),
    [sym_module] = STATE(531),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(531),
    [sym_interface_declaration] = STATE(531),
    [sym_enum_declaration] = STATE(531),
    [sym_type_alias_declaration] = STATE(531),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [41] = {
    [sym_export_statement] = STATE(583),
    [sym__declaration] = STATE(583),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(583),
    [sym_expression_statement] = STATE(583),
    [sym_variable_declaration] = STATE(583),
    [sym_lexical_declaration] = STATE(583),
    [sym_statement_block] = STATE(583),
    [sym_if_statement] = STATE(583),
    [sym_switch_statement] = STATE(583),
    [sym_for_statement] = STATE(583),
    [sym_for_in_statement] = STATE(583),
    [sym_while_statement] = STATE(583),
    [sym_do_statement] = STATE(583),
    [sym_try_statement] = STATE(583),
    [sym_with_statement] = STATE(583),
    [sym_break_statement] = STATE(583),
    [sym_continue_statement] = STATE(583),
    [sym_debugger_statement] = STATE(583),
    [sym_return_statement] = STATE(583),
    [sym_throw_statement] = STATE(583),
    [sym_empty_statement] = STATE(583),
    [sym_labeled_statement] = STATE(583),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(583),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(583),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(583),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(583),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(583),
    [sym_abstract_class_declaration] = STATE(583),
    [sym_module] = STATE(583),
    [sym_internal_module] = STATE(1255),
    [sym_import_alias] = STATE(583),
    [sym_interface_declaration] = STATE(583),
    [sym_enum_declaration] = STATE(583),
    [sym_type_alias_declaration] = STATE(583),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2152),
    [sym_identifier] = ACTIONS(407),
    [anon_sym_export] = ACTIONS(409),
    [anon_sym_namespace] = ACTIONS(411),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_type] = ACTIONS(415),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(423),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(425),
    [anon_sym_async] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(431),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(433),
    [anon_sym_abstract] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(433),
    [anon_sym_set] = ACTIONS(433),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(433),
    [anon_sym_private] = ACTIONS(433),
    [anon_sym_protected] = ACTIONS(433),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(433),
    [anon_sym_number] = ACTIONS(433),
    [anon_sym_boolean] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_symbol] = ACTIONS(433),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [42] = {
    [sym_export_statement] = STATE(532),
    [sym__declaration] = STATE(532),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(532),
    [sym_expression_statement] = STATE(532),
    [sym_variable_declaration] = STATE(532),
    [sym_lexical_declaration] = STATE(532),
    [sym_statement_block] = STATE(532),
    [sym_if_statement] = STATE(532),
    [sym_switch_statement] = STATE(532),
    [sym_for_statement] = STATE(532),
    [sym_for_in_statement] = STATE(532),
    [sym_while_statement] = STATE(532),
    [sym_do_statement] = STATE(532),
    [sym_try_statement] = STATE(532),
    [sym_with_statement] = STATE(532),
    [sym_break_statement] = STATE(532),
    [sym_continue_statement] = STATE(532),
    [sym_debugger_statement] = STATE(532),
    [sym_return_statement] = STATE(532),
    [sym_throw_statement] = STATE(532),
    [sym_empty_statement] = STATE(532),
    [sym_labeled_statement] = STATE(532),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(532),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(532),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(532),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(532),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(532),
    [sym_abstract_class_declaration] = STATE(532),
    [sym_module] = STATE(532),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(532),
    [sym_interface_declaration] = STATE(532),
    [sym_enum_declaration] = STATE(532),
    [sym_type_alias_declaration] = STATE(532),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [43] = {
    [sym_export_statement] = STATE(521),
    [sym__declaration] = STATE(521),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(521),
    [sym_expression_statement] = STATE(521),
    [sym_variable_declaration] = STATE(521),
    [sym_lexical_declaration] = STATE(521),
    [sym_statement_block] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_switch_statement] = STATE(521),
    [sym_for_statement] = STATE(521),
    [sym_for_in_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_do_statement] = STATE(521),
    [sym_try_statement] = STATE(521),
    [sym_with_statement] = STATE(521),
    [sym_break_statement] = STATE(521),
    [sym_continue_statement] = STATE(521),
    [sym_debugger_statement] = STATE(521),
    [sym_return_statement] = STATE(521),
    [sym_throw_statement] = STATE(521),
    [sym_empty_statement] = STATE(521),
    [sym_labeled_statement] = STATE(521),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(521),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(521),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(521),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(521),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(521),
    [sym_abstract_class_declaration] = STATE(521),
    [sym_module] = STATE(521),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(521),
    [sym_interface_declaration] = STATE(521),
    [sym_enum_declaration] = STATE(521),
    [sym_type_alias_declaration] = STATE(521),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [44] = {
    [sym_export_statement] = STATE(555),
    [sym__declaration] = STATE(555),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(555),
    [sym_expression_statement] = STATE(555),
    [sym_variable_declaration] = STATE(555),
    [sym_lexical_declaration] = STATE(555),
    [sym_statement_block] = STATE(555),
    [sym_if_statement] = STATE(555),
    [sym_switch_statement] = STATE(555),
    [sym_for_statement] = STATE(555),
    [sym_for_in_statement] = STATE(555),
    [sym_while_statement] = STATE(555),
    [sym_do_statement] = STATE(555),
    [sym_try_statement] = STATE(555),
    [sym_with_statement] = STATE(555),
    [sym_break_statement] = STATE(555),
    [sym_continue_statement] = STATE(555),
    [sym_debugger_statement] = STATE(555),
    [sym_return_statement] = STATE(555),
    [sym_throw_statement] = STATE(555),
    [sym_empty_statement] = STATE(555),
    [sym_labeled_statement] = STATE(555),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(555),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(555),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(555),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(555),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(555),
    [sym_abstract_class_declaration] = STATE(555),
    [sym_module] = STATE(555),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(555),
    [sym_interface_declaration] = STATE(555),
    [sym_enum_declaration] = STATE(555),
    [sym_type_alias_declaration] = STATE(555),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [45] = {
    [sym_export_statement] = STATE(2775),
    [sym__declaration] = STATE(2775),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(2775),
    [sym_expression_statement] = STATE(2775),
    [sym_variable_declaration] = STATE(2775),
    [sym_lexical_declaration] = STATE(2775),
    [sym_statement_block] = STATE(2775),
    [sym_if_statement] = STATE(2775),
    [sym_switch_statement] = STATE(2775),
    [sym_for_statement] = STATE(2775),
    [sym_for_in_statement] = STATE(2775),
    [sym_while_statement] = STATE(2775),
    [sym_do_statement] = STATE(2775),
    [sym_try_statement] = STATE(2775),
    [sym_with_statement] = STATE(2775),
    [sym_break_statement] = STATE(2775),
    [sym_continue_statement] = STATE(2775),
    [sym_debugger_statement] = STATE(2775),
    [sym_return_statement] = STATE(2775),
    [sym_throw_statement] = STATE(2775),
    [sym_empty_statement] = STATE(2775),
    [sym_labeled_statement] = STATE(2775),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(2775),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(2775),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(2775),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(2775),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(2775),
    [sym_abstract_class_declaration] = STATE(2775),
    [sym_module] = STATE(2775),
    [sym_internal_module] = STATE(1255),
    [sym_import_alias] = STATE(2775),
    [sym_interface_declaration] = STATE(2775),
    [sym_enum_declaration] = STATE(2775),
    [sym_type_alias_declaration] = STATE(2775),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2152),
    [sym_identifier] = ACTIONS(407),
    [anon_sym_export] = ACTIONS(409),
    [anon_sym_namespace] = ACTIONS(411),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_type] = ACTIONS(415),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(423),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(425),
    [anon_sym_async] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(431),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(433),
    [anon_sym_abstract] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(433),
    [anon_sym_set] = ACTIONS(433),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(433),
    [anon_sym_private] = ACTIONS(433),
    [anon_sym_protected] = ACTIONS(433),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(433),
    [anon_sym_number] = ACTIONS(433),
    [anon_sym_boolean] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_symbol] = ACTIONS(433),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [46] = {
    [sym_export_statement] = STATE(521),
    [sym__declaration] = STATE(521),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(521),
    [sym_expression_statement] = STATE(521),
    [sym_variable_declaration] = STATE(521),
    [sym_lexical_declaration] = STATE(521),
    [sym_statement_block] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_switch_statement] = STATE(521),
    [sym_for_statement] = STATE(521),
    [sym_for_in_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_do_statement] = STATE(521),
    [sym_try_statement] = STATE(521),
    [sym_with_statement] = STATE(521),
    [sym_break_statement] = STATE(521),
    [sym_continue_statement] = STATE(521),
    [sym_debugger_statement] = STATE(521),
    [sym_return_statement] = STATE(521),
    [sym_throw_statement] = STATE(521),
    [sym_empty_statement] = STATE(521),
    [sym_labeled_statement] = STATE(521),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(521),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(521),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(521),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(521),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(521),
    [sym_abstract_class_declaration] = STATE(521),
    [sym_module] = STATE(521),
    [sym_internal_module] = STATE(1255),
    [sym_import_alias] = STATE(521),
    [sym_interface_declaration] = STATE(521),
    [sym_enum_declaration] = STATE(521),
    [sym_type_alias_declaration] = STATE(521),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2152),
    [sym_identifier] = ACTIONS(407),
    [anon_sym_export] = ACTIONS(409),
    [anon_sym_namespace] = ACTIONS(411),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_type] = ACTIONS(415),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(423),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(425),
    [anon_sym_async] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(431),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(433),
    [anon_sym_abstract] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(433),
    [anon_sym_set] = ACTIONS(433),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(433),
    [anon_sym_private] = ACTIONS(433),
    [anon_sym_protected] = ACTIONS(433),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(433),
    [anon_sym_number] = ACTIONS(433),
    [anon_sym_boolean] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_symbol] = ACTIONS(433),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [47] = {
    [sym_export_statement] = STATE(532),
    [sym__declaration] = STATE(532),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(532),
    [sym_expression_statement] = STATE(532),
    [sym_variable_declaration] = STATE(532),
    [sym_lexical_declaration] = STATE(532),
    [sym_statement_block] = STATE(532),
    [sym_if_statement] = STATE(532),
    [sym_switch_statement] = STATE(532),
    [sym_for_statement] = STATE(532),
    [sym_for_in_statement] = STATE(532),
    [sym_while_statement] = STATE(532),
    [sym_do_statement] = STATE(532),
    [sym_try_statement] = STATE(532),
    [sym_with_statement] = STATE(532),
    [sym_break_statement] = STATE(532),
    [sym_continue_statement] = STATE(532),
    [sym_debugger_statement] = STATE(532),
    [sym_return_statement] = STATE(532),
    [sym_throw_statement] = STATE(532),
    [sym_empty_statement] = STATE(532),
    [sym_labeled_statement] = STATE(532),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(532),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(532),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(532),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(532),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(532),
    [sym_abstract_class_declaration] = STATE(532),
    [sym_module] = STATE(532),
    [sym_internal_module] = STATE(1255),
    [sym_import_alias] = STATE(532),
    [sym_interface_declaration] = STATE(532),
    [sym_enum_declaration] = STATE(532),
    [sym_type_alias_declaration] = STATE(532),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2152),
    [sym_identifier] = ACTIONS(407),
    [anon_sym_export] = ACTIONS(409),
    [anon_sym_namespace] = ACTIONS(411),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_type] = ACTIONS(415),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(423),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(425),
    [anon_sym_async] = ACTIONS(427),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(431),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(433),
    [anon_sym_abstract] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(433),
    [anon_sym_set] = ACTIONS(433),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(433),
    [anon_sym_private] = ACTIONS(433),
    [anon_sym_protected] = ACTIONS(433),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(433),
    [anon_sym_number] = ACTIONS(433),
    [anon_sym_boolean] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_symbol] = ACTIONS(433),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [48] = {
    [sym_export_statement] = STATE(518),
    [sym__declaration] = STATE(518),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(518),
    [sym_expression_statement] = STATE(518),
    [sym_variable_declaration] = STATE(518),
    [sym_lexical_declaration] = STATE(518),
    [sym_statement_block] = STATE(518),
    [sym_if_statement] = STATE(518),
    [sym_switch_statement] = STATE(518),
    [sym_for_statement] = STATE(518),
    [sym_for_in_statement] = STATE(518),
    [sym_while_statement] = STATE(518),
    [sym_do_statement] = STATE(518),
    [sym_try_statement] = STATE(518),
    [sym_with_statement] = STATE(518),
    [sym_break_statement] = STATE(518),
    [sym_continue_statement] = STATE(518),
    [sym_debugger_statement] = STATE(518),
    [sym_return_statement] = STATE(518),
    [sym_throw_statement] = STATE(518),
    [sym_empty_statement] = STATE(518),
    [sym_labeled_statement] = STATE(518),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(518),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(518),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(518),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(518),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(518),
    [sym_abstract_class_declaration] = STATE(518),
    [sym_module] = STATE(518),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(518),
    [sym_interface_declaration] = STATE(518),
    [sym_enum_declaration] = STATE(518),
    [sym_type_alias_declaration] = STATE(518),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [49] = {
    [sym_export_statement] = STATE(523),
    [sym__declaration] = STATE(523),
    [sym_import] = STATE(1202),
    [sym_import_statement] = STATE(523),
    [sym_expression_statement] = STATE(523),
    [sym_variable_declaration] = STATE(523),
    [sym_lexical_declaration] = STATE(523),
    [sym_statement_block] = STATE(523),
    [sym_if_statement] = STATE(523),
    [sym_switch_statement] = STATE(523),
    [sym_for_statement] = STATE(523),
    [sym_for_in_statement] = STATE(523),
    [sym_while_statement] = STATE(523),
    [sym_do_statement] = STATE(523),
    [sym_try_statement] = STATE(523),
    [sym_with_statement] = STATE(523),
    [sym_break_statement] = STATE(523),
    [sym_continue_statement] = STATE(523),
    [sym_debugger_statement] = STATE(523),
    [sym_return_statement] = STATE(523),
    [sym_throw_statement] = STATE(523),
    [sym_empty_statement] = STATE(523),
    [sym_labeled_statement] = STATE(523),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_class_declaration] = STATE(523),
    [sym_function] = STATE(1025),
    [sym_function_declaration] = STATE(523),
    [sym_generator_function] = STATE(1202),
    [sym_generator_function_declaration] = STATE(523),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_function_signature] = STATE(523),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_ambient_declaration] = STATE(523),
    [sym_abstract_class_declaration] = STATE(523),
    [sym_module] = STATE(523),
    [sym_internal_module] = STATE(126),
    [sym_import_alias] = STATE(523),
    [sym_interface_declaration] = STATE(523),
    [sym_enum_declaration] = STATE(523),
    [sym_type_alias_declaration] = STATE(523),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [50] = {
    [sym_import] = STATE(1097),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1097),
    [sym_yield_expression] = STATE(1097),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1097),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1097),
    [sym_arrow_function] = STATE(1097),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1097),
    [sym_new_expression] = STATE(1097),
    [sym_await_expression] = STATE(1097),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1097),
    [sym_augmented_assignment_expression] = STATE(1097),
    [sym_ternary_expression] = STATE(1097),
    [sym_binary_expression] = STATE(1097),
    [sym_unary_expression] = STATE(1097),
    [sym_update_expression] = STATE(1097),
    [sym_string] = STATE(1097),
    [sym_template_string] = STATE(1097),
    [sym_regex] = STATE(1097),
    [sym_meta_property] = STATE(1097),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1097),
    [sym_type_assertion] = STATE(1097),
    [sym_as_expression] = STATE(1097),
    [sym_internal_module] = STATE(1097),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [51] = {
    [sym_import] = STATE(1097),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1097),
    [sym_yield_expression] = STATE(1097),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1097),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1097),
    [sym_arrow_function] = STATE(1097),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1097),
    [sym_new_expression] = STATE(1097),
    [sym_await_expression] = STATE(1097),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1097),
    [sym_augmented_assignment_expression] = STATE(1097),
    [sym_ternary_expression] = STATE(1097),
    [sym_binary_expression] = STATE(1097),
    [sym_unary_expression] = STATE(1097),
    [sym_update_expression] = STATE(1097),
    [sym_string] = STATE(1097),
    [sym_template_string] = STATE(1097),
    [sym_regex] = STATE(1097),
    [sym_meta_property] = STATE(1097),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1097),
    [sym_type_assertion] = STATE(1097),
    [sym_as_expression] = STATE(1097),
    [sym_internal_module] = STATE(1097),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [52] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_arguments] = STATE(1032),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1245),
    [sym_type_assertion] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_RPAREN] = ACTIONS(501),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_COLON] = ACTIONS(501),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [53] = {
    [sym_import] = STATE(1097),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1097),
    [sym_yield_expression] = STATE(1097),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1097),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1097),
    [sym_arrow_function] = STATE(1097),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1097),
    [sym_new_expression] = STATE(1097),
    [sym_await_expression] = STATE(1097),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1097),
    [sym_augmented_assignment_expression] = STATE(1097),
    [sym_ternary_expression] = STATE(1097),
    [sym_binary_expression] = STATE(1097),
    [sym_unary_expression] = STATE(1097),
    [sym_update_expression] = STATE(1097),
    [sym_string] = STATE(1097),
    [sym_template_string] = STATE(1097),
    [sym_regex] = STATE(1097),
    [sym_meta_property] = STATE(1097),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1097),
    [sym_type_assertion] = STATE(1097),
    [sym_as_expression] = STATE(1097),
    [sym_internal_module] = STATE(1097),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [54] = {
    [sym_import] = STATE(982),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(982),
    [sym_yield_expression] = STATE(982),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(982),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(982),
    [sym_arrow_function] = STATE(982),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(982),
    [sym_new_expression] = STATE(982),
    [sym_await_expression] = STATE(982),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(982),
    [sym_augmented_assignment_expression] = STATE(982),
    [sym_ternary_expression] = STATE(982),
    [sym_binary_expression] = STATE(982),
    [sym_unary_expression] = STATE(982),
    [sym_update_expression] = STATE(982),
    [sym_string] = STATE(982),
    [sym_template_string] = STATE(982),
    [sym_regex] = STATE(982),
    [sym_meta_property] = STATE(982),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(982),
    [sym_type_assertion] = STATE(982),
    [sym_as_expression] = STATE(982),
    [sym_internal_module] = STATE(982),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(579),
    [sym_this] = ACTIONS(581),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_null] = ACTIONS(581),
    [sym_undefined] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [55] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_arguments] = STATE(1428),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1245),
    [sym_type_assertion] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym__automatic_semicolon] = ACTIONS(501),
  },
  [56] = {
    [sym_import] = STATE(982),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(982),
    [sym_yield_expression] = STATE(982),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(982),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(982),
    [sym_arrow_function] = STATE(982),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(982),
    [sym_new_expression] = STATE(982),
    [sym_await_expression] = STATE(982),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(982),
    [sym_augmented_assignment_expression] = STATE(982),
    [sym_ternary_expression] = STATE(982),
    [sym_binary_expression] = STATE(982),
    [sym_unary_expression] = STATE(982),
    [sym_update_expression] = STATE(982),
    [sym_string] = STATE(982),
    [sym_template_string] = STATE(982),
    [sym_regex] = STATE(982),
    [sym_meta_property] = STATE(982),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(982),
    [sym_type_assertion] = STATE(982),
    [sym_as_expression] = STATE(982),
    [sym_internal_module] = STATE(982),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(586),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(579),
    [sym_this] = ACTIONS(581),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_null] = ACTIONS(581),
    [sym_undefined] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [57] = {
    [sym_import] = STATE(982),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(982),
    [sym_yield_expression] = STATE(982),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(982),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(982),
    [sym_arrow_function] = STATE(982),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(982),
    [sym_new_expression] = STATE(982),
    [sym_await_expression] = STATE(982),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(982),
    [sym_augmented_assignment_expression] = STATE(982),
    [sym_ternary_expression] = STATE(982),
    [sym_binary_expression] = STATE(982),
    [sym_unary_expression] = STATE(982),
    [sym_update_expression] = STATE(982),
    [sym_string] = STATE(982),
    [sym_template_string] = STATE(982),
    [sym_regex] = STATE(982),
    [sym_meta_property] = STATE(982),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(982),
    [sym_type_assertion] = STATE(982),
    [sym_as_expression] = STATE(982),
    [sym_internal_module] = STATE(982),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(583),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(579),
    [sym_this] = ACTIONS(581),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_null] = ACTIONS(581),
    [sym_undefined] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [anon_sym_PIPE_RBRACE] = ACTIONS(589),
    [sym__automatic_semicolon] = ACTIONS(589),
  },
  [58] = {
    [sym_import] = STATE(1097),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1097),
    [sym_yield_expression] = STATE(1097),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1097),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1097),
    [sym_arrow_function] = STATE(1097),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1097),
    [sym_new_expression] = STATE(1097),
    [sym_await_expression] = STATE(1097),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1097),
    [sym_augmented_assignment_expression] = STATE(1097),
    [sym_ternary_expression] = STATE(1097),
    [sym_binary_expression] = STATE(1097),
    [sym_unary_expression] = STATE(1097),
    [sym_update_expression] = STATE(1097),
    [sym_string] = STATE(1097),
    [sym_template_string] = STATE(1097),
    [sym_regex] = STATE(1097),
    [sym_meta_property] = STATE(1097),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1097),
    [sym_type_assertion] = STATE(1097),
    [sym_as_expression] = STATE(1097),
    [sym_internal_module] = STATE(1097),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [59] = {
    [sym_import] = STATE(1097),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1097),
    [sym_yield_expression] = STATE(1097),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1097),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1097),
    [sym_arrow_function] = STATE(1097),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1097),
    [sym_new_expression] = STATE(1097),
    [sym_await_expression] = STATE(1097),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1097),
    [sym_augmented_assignment_expression] = STATE(1097),
    [sym_ternary_expression] = STATE(1097),
    [sym_binary_expression] = STATE(1097),
    [sym_unary_expression] = STATE(1097),
    [sym_update_expression] = STATE(1097),
    [sym_string] = STATE(1097),
    [sym_template_string] = STATE(1097),
    [sym_regex] = STATE(1097),
    [sym_meta_property] = STATE(1097),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1097),
    [sym_type_assertion] = STATE(1097),
    [sym_as_expression] = STATE(1097),
    [sym_internal_module] = STATE(1097),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [60] = {
    [sym_import] = STATE(1097),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1097),
    [sym_yield_expression] = STATE(1097),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1097),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1097),
    [sym_arrow_function] = STATE(1097),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1097),
    [sym_new_expression] = STATE(1097),
    [sym_await_expression] = STATE(1097),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1097),
    [sym_augmented_assignment_expression] = STATE(1097),
    [sym_ternary_expression] = STATE(1097),
    [sym_binary_expression] = STATE(1097),
    [sym_unary_expression] = STATE(1097),
    [sym_update_expression] = STATE(1097),
    [sym_string] = STATE(1097),
    [sym_template_string] = STATE(1097),
    [sym_regex] = STATE(1097),
    [sym_meta_property] = STATE(1097),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1097),
    [sym_type_assertion] = STATE(1097),
    [sym_as_expression] = STATE(1097),
    [sym_internal_module] = STATE(1097),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(586),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [61] = {
    [sym_import] = STATE(1097),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1097),
    [sym_yield_expression] = STATE(1097),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1097),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1097),
    [sym_arrow_function] = STATE(1097),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1097),
    [sym_new_expression] = STATE(1097),
    [sym_await_expression] = STATE(1097),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1097),
    [sym_augmented_assignment_expression] = STATE(1097),
    [sym_ternary_expression] = STATE(1097),
    [sym_binary_expression] = STATE(1097),
    [sym_unary_expression] = STATE(1097),
    [sym_update_expression] = STATE(1097),
    [sym_string] = STATE(1097),
    [sym_template_string] = STATE(1097),
    [sym_regex] = STATE(1097),
    [sym_meta_property] = STATE(1097),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1097),
    [sym_type_assertion] = STATE(1097),
    [sym_as_expression] = STATE(1097),
    [sym_internal_module] = STATE(1097),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [62] = {
    [sym_import] = STATE(1097),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1097),
    [sym_yield_expression] = STATE(1097),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1097),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1097),
    [sym_arrow_function] = STATE(1097),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1097),
    [sym_new_expression] = STATE(1097),
    [sym_await_expression] = STATE(1097),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1097),
    [sym_augmented_assignment_expression] = STATE(1097),
    [sym_ternary_expression] = STATE(1097),
    [sym_binary_expression] = STATE(1097),
    [sym_unary_expression] = STATE(1097),
    [sym_update_expression] = STATE(1097),
    [sym_string] = STATE(1097),
    [sym_template_string] = STATE(1097),
    [sym_regex] = STATE(1097),
    [sym_meta_property] = STATE(1097),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1097),
    [sym_type_assertion] = STATE(1097),
    [sym_as_expression] = STATE(1097),
    [sym_internal_module] = STATE(1097),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [63] = {
    [sym_import] = STATE(982),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(982),
    [sym_yield_expression] = STATE(982),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(982),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(982),
    [sym_arrow_function] = STATE(982),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(982),
    [sym_new_expression] = STATE(982),
    [sym_await_expression] = STATE(982),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(982),
    [sym_augmented_assignment_expression] = STATE(982),
    [sym_ternary_expression] = STATE(982),
    [sym_binary_expression] = STATE(982),
    [sym_unary_expression] = STATE(982),
    [sym_update_expression] = STATE(982),
    [sym_string] = STATE(982),
    [sym_template_string] = STATE(982),
    [sym_regex] = STATE(982),
    [sym_meta_property] = STATE(982),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(982),
    [sym_type_assertion] = STATE(982),
    [sym_as_expression] = STATE(982),
    [sym_internal_module] = STATE(982),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(608),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(579),
    [sym_this] = ACTIONS(581),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_null] = ACTIONS(581),
    [sym_undefined] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [64] = {
    [sym_import] = STATE(982),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(982),
    [sym_yield_expression] = STATE(982),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(982),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(982),
    [sym_arrow_function] = STATE(982),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(982),
    [sym_new_expression] = STATE(982),
    [sym_await_expression] = STATE(982),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(982),
    [sym_augmented_assignment_expression] = STATE(982),
    [sym_ternary_expression] = STATE(982),
    [sym_binary_expression] = STATE(982),
    [sym_unary_expression] = STATE(982),
    [sym_update_expression] = STATE(982),
    [sym_string] = STATE(982),
    [sym_template_string] = STATE(982),
    [sym_regex] = STATE(982),
    [sym_meta_property] = STATE(982),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(982),
    [sym_type_assertion] = STATE(982),
    [sym_as_expression] = STATE(982),
    [sym_internal_module] = STATE(982),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(579),
    [sym_this] = ACTIONS(581),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_null] = ACTIONS(581),
    [sym_undefined] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [65] = {
    [sym_import] = STATE(1253),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1253),
    [sym_yield_expression] = STATE(1253),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1253),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1253),
    [sym_arrow_function] = STATE(1253),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1253),
    [sym_new_expression] = STATE(1253),
    [sym_await_expression] = STATE(1253),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1253),
    [sym_augmented_assignment_expression] = STATE(1253),
    [sym_ternary_expression] = STATE(1253),
    [sym_binary_expression] = STATE(1253),
    [sym_unary_expression] = STATE(1253),
    [sym_update_expression] = STATE(1253),
    [sym_string] = STATE(1253),
    [sym_template_string] = STATE(1253),
    [sym_regex] = STATE(1253),
    [sym_meta_property] = STATE(1253),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1253),
    [sym_type_assertion] = STATE(1253),
    [sym_as_expression] = STATE(1253),
    [sym_internal_module] = STATE(1253),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(614),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(586),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS_EQ] = ACTIONS(630),
    [anon_sym_DASH_EQ] = ACTIONS(630),
    [anon_sym_STAR_EQ] = ACTIONS(630),
    [anon_sym_SLASH_EQ] = ACTIONS(630),
    [anon_sym_PERCENT_EQ] = ACTIONS(630),
    [anon_sym_CARET_EQ] = ACTIONS(630),
    [anon_sym_AMP_EQ] = ACTIONS(630),
    [anon_sym_PIPE_EQ] = ACTIONS(630),
    [anon_sym_GT_GT_EQ] = ACTIONS(630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(630),
    [anon_sym_LT_LT_EQ] = ACTIONS(630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(630),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(634),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(642),
    [sym_this] = ACTIONS(644),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(644),
    [sym_false] = ACTIONS(644),
    [sym_null] = ACTIONS(644),
    [sym_undefined] = ACTIONS(644),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [66] = {
    [sym_import] = STATE(982),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(982),
    [sym_yield_expression] = STATE(982),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(982),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(982),
    [sym_arrow_function] = STATE(982),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(982),
    [sym_new_expression] = STATE(982),
    [sym_await_expression] = STATE(982),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(982),
    [sym_augmented_assignment_expression] = STATE(982),
    [sym_ternary_expression] = STATE(982),
    [sym_binary_expression] = STATE(982),
    [sym_unary_expression] = STATE(982),
    [sym_update_expression] = STATE(982),
    [sym_string] = STATE(982),
    [sym_template_string] = STATE(982),
    [sym_regex] = STATE(982),
    [sym_meta_property] = STATE(982),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(982),
    [sym_type_assertion] = STATE(982),
    [sym_as_expression] = STATE(982),
    [sym_internal_module] = STATE(982),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(646),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(579),
    [sym_this] = ACTIONS(581),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_null] = ACTIONS(581),
    [sym_undefined] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [67] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_arguments] = STATE(1428),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1245),
    [sym_type_assertion] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym__automatic_semicolon] = ACTIONS(501),
  },
  [68] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_arguments] = STATE(1032),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1245),
    [sym_type_assertion] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(648),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [anon_sym_implements] = ACTIONS(493),
  },
  [69] = {
    [sym_import] = STATE(982),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(982),
    [sym_yield_expression] = STATE(982),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(982),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(982),
    [sym_arrow_function] = STATE(982),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(982),
    [sym_new_expression] = STATE(982),
    [sym_await_expression] = STATE(982),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(982),
    [sym_augmented_assignment_expression] = STATE(982),
    [sym_ternary_expression] = STATE(982),
    [sym_binary_expression] = STATE(982),
    [sym_unary_expression] = STATE(982),
    [sym_update_expression] = STATE(982),
    [sym_string] = STATE(982),
    [sym_template_string] = STATE(982),
    [sym_regex] = STATE(982),
    [sym_meta_property] = STATE(982),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(982),
    [sym_type_assertion] = STATE(982),
    [sym_as_expression] = STATE(982),
    [sym_internal_module] = STATE(982),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(579),
    [sym_this] = ACTIONS(581),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_null] = ACTIONS(581),
    [sym_undefined] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [70] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1245),
    [sym_type_assertion] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(586),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(658),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [71] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_arguments] = STATE(1518),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1245),
    [sym_type_assertion] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(493),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(664),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [anon_sym_LBRACE_PIPE] = ACTIONS(501),
  },
  [72] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_arguments] = STATE(1032),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1245),
    [sym_type_assertion] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_COLON] = ACTIONS(501),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [73] = {
    [sym_import] = STATE(1179),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1179),
    [sym_yield_expression] = STATE(1179),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1179),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1179),
    [sym_arrow_function] = STATE(1179),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1179),
    [sym_new_expression] = STATE(1179),
    [sym_await_expression] = STATE(1179),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1179),
    [sym_augmented_assignment_expression] = STATE(1179),
    [sym_ternary_expression] = STATE(1179),
    [sym_binary_expression] = STATE(1179),
    [sym_unary_expression] = STATE(1179),
    [sym_update_expression] = STATE(1179),
    [sym_string] = STATE(1179),
    [sym_template_string] = STATE(1179),
    [sym_regex] = STATE(1179),
    [sym_meta_property] = STATE(1179),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1179),
    [sym_type_assertion] = STATE(1179),
    [sym_as_expression] = STATE(1179),
    [sym_internal_module] = STATE(1179),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(674),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_DOT] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_EQ_GT] = ACTIONS(664),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS_EQ] = ACTIONS(698),
    [anon_sym_DASH_EQ] = ACTIONS(698),
    [anon_sym_STAR_EQ] = ACTIONS(698),
    [anon_sym_SLASH_EQ] = ACTIONS(698),
    [anon_sym_PERCENT_EQ] = ACTIONS(698),
    [anon_sym_CARET_EQ] = ACTIONS(698),
    [anon_sym_AMP_EQ] = ACTIONS(698),
    [anon_sym_PIPE_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_LT_LT_EQ] = ACTIONS(698),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(698),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(702),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(716),
    [sym_this] = ACTIONS(718),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(718),
    [sym_false] = ACTIONS(718),
    [sym_null] = ACTIONS(718),
    [sym_undefined] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [74] = {
    [sym_import] = STATE(982),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(982),
    [sym_yield_expression] = STATE(982),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(982),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(982),
    [sym_arrow_function] = STATE(982),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(982),
    [sym_new_expression] = STATE(982),
    [sym_await_expression] = STATE(982),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(982),
    [sym_augmented_assignment_expression] = STATE(982),
    [sym_ternary_expression] = STATE(982),
    [sym_binary_expression] = STATE(982),
    [sym_unary_expression] = STATE(982),
    [sym_update_expression] = STATE(982),
    [sym_string] = STATE(982),
    [sym_template_string] = STATE(982),
    [sym_regex] = STATE(982),
    [sym_meta_property] = STATE(982),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(982),
    [sym_type_assertion] = STATE(982),
    [sym_as_expression] = STATE(982),
    [sym_internal_module] = STATE(982),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(579),
    [sym_this] = ACTIONS(581),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_null] = ACTIONS(581),
    [sym_undefined] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [75] = {
    [sym_import] = STATE(1253),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1253),
    [sym_yield_expression] = STATE(1253),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1253),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1253),
    [sym_arrow_function] = STATE(1253),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1253),
    [sym_new_expression] = STATE(1253),
    [sym_await_expression] = STATE(1253),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1253),
    [sym_augmented_assignment_expression] = STATE(1253),
    [sym_ternary_expression] = STATE(1253),
    [sym_binary_expression] = STATE(1253),
    [sym_unary_expression] = STATE(1253),
    [sym_update_expression] = STATE(1253),
    [sym_string] = STATE(1253),
    [sym_template_string] = STATE(1253),
    [sym_regex] = STATE(1253),
    [sym_meta_property] = STATE(1253),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1253),
    [sym_type_assertion] = STATE(1253),
    [sym_as_expression] = STATE(1253),
    [sym_internal_module] = STATE(1253),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(614),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS_EQ] = ACTIONS(630),
    [anon_sym_DASH_EQ] = ACTIONS(630),
    [anon_sym_STAR_EQ] = ACTIONS(630),
    [anon_sym_SLASH_EQ] = ACTIONS(630),
    [anon_sym_PERCENT_EQ] = ACTIONS(630),
    [anon_sym_CARET_EQ] = ACTIONS(630),
    [anon_sym_AMP_EQ] = ACTIONS(630),
    [anon_sym_PIPE_EQ] = ACTIONS(630),
    [anon_sym_GT_GT_EQ] = ACTIONS(630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(630),
    [anon_sym_LT_LT_EQ] = ACTIONS(630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(630),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(634),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(642),
    [sym_this] = ACTIONS(644),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(644),
    [sym_false] = ACTIONS(644),
    [sym_null] = ACTIONS(644),
    [sym_undefined] = ACTIONS(644),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [76] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1245),
    [sym_type_assertion] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(646),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(658),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [77] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1245),
    [sym_type_assertion] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(658),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [78] = {
    [sym_import] = STATE(1153),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1153),
    [sym_yield_expression] = STATE(1153),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1153),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1153),
    [sym_arrow_function] = STATE(1153),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1153),
    [sym_new_expression] = STATE(1153),
    [sym_await_expression] = STATE(1153),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1153),
    [sym_augmented_assignment_expression] = STATE(1153),
    [sym_ternary_expression] = STATE(1153),
    [sym_binary_expression] = STATE(1153),
    [sym_unary_expression] = STATE(1153),
    [sym_update_expression] = STATE(1153),
    [sym_string] = STATE(1153),
    [sym_template_string] = STATE(1153),
    [sym_regex] = STATE(1153),
    [sym_meta_property] = STATE(1153),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1153),
    [sym_type_assertion] = STATE(1153),
    [sym_as_expression] = STATE(1153),
    [sym_internal_module] = STATE(1153),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(648),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS_EQ] = ACTIONS(742),
    [anon_sym_DASH_EQ] = ACTIONS(742),
    [anon_sym_STAR_EQ] = ACTIONS(742),
    [anon_sym_SLASH_EQ] = ACTIONS(742),
    [anon_sym_PERCENT_EQ] = ACTIONS(742),
    [anon_sym_CARET_EQ] = ACTIONS(742),
    [anon_sym_AMP_EQ] = ACTIONS(742),
    [anon_sym_PIPE_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_LT_EQ] = ACTIONS(742),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(754),
    [sym_this] = ACTIONS(756),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(756),
    [sym_false] = ACTIONS(756),
    [sym_null] = ACTIONS(756),
    [sym_undefined] = ACTIONS(756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [anon_sym_implements] = ACTIONS(445),
  },
  [79] = {
    [sym_import] = STATE(1153),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1153),
    [sym_yield_expression] = STATE(1153),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1153),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1153),
    [sym_arrow_function] = STATE(1153),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1153),
    [sym_new_expression] = STATE(1153),
    [sym_await_expression] = STATE(1153),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1153),
    [sym_augmented_assignment_expression] = STATE(1153),
    [sym_ternary_expression] = STATE(1153),
    [sym_binary_expression] = STATE(1153),
    [sym_unary_expression] = STATE(1153),
    [sym_update_expression] = STATE(1153),
    [sym_string] = STATE(1153),
    [sym_template_string] = STATE(1153),
    [sym_regex] = STATE(1153),
    [sym_meta_property] = STATE(1153),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1153),
    [sym_type_assertion] = STATE(1153),
    [sym_as_expression] = STATE(1153),
    [sym_internal_module] = STATE(1153),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(586),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(648),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS_EQ] = ACTIONS(742),
    [anon_sym_DASH_EQ] = ACTIONS(742),
    [anon_sym_STAR_EQ] = ACTIONS(742),
    [anon_sym_SLASH_EQ] = ACTIONS(742),
    [anon_sym_PERCENT_EQ] = ACTIONS(742),
    [anon_sym_CARET_EQ] = ACTIONS(742),
    [anon_sym_AMP_EQ] = ACTIONS(742),
    [anon_sym_PIPE_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_LT_EQ] = ACTIONS(742),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(754),
    [sym_this] = ACTIONS(756),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(756),
    [sym_false] = ACTIONS(756),
    [sym_null] = ACTIONS(756),
    [sym_undefined] = ACTIONS(756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [anon_sym_implements] = ACTIONS(445),
  },
  [80] = {
    [sym_import] = STATE(1179),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1179),
    [sym_yield_expression] = STATE(1179),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1179),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1179),
    [sym_arrow_function] = STATE(1179),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1179),
    [sym_new_expression] = STATE(1179),
    [sym_await_expression] = STATE(1179),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1179),
    [sym_augmented_assignment_expression] = STATE(1179),
    [sym_ternary_expression] = STATE(1179),
    [sym_binary_expression] = STATE(1179),
    [sym_unary_expression] = STATE(1179),
    [sym_update_expression] = STATE(1179),
    [sym_string] = STATE(1179),
    [sym_template_string] = STATE(1179),
    [sym_regex] = STATE(1179),
    [sym_meta_property] = STATE(1179),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1179),
    [sym_type_assertion] = STATE(1179),
    [sym_as_expression] = STATE(1179),
    [sym_internal_module] = STATE(1179),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(674),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(586),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_DOT] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_EQ_GT] = ACTIONS(664),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS_EQ] = ACTIONS(698),
    [anon_sym_DASH_EQ] = ACTIONS(698),
    [anon_sym_STAR_EQ] = ACTIONS(698),
    [anon_sym_SLASH_EQ] = ACTIONS(698),
    [anon_sym_PERCENT_EQ] = ACTIONS(698),
    [anon_sym_CARET_EQ] = ACTIONS(698),
    [anon_sym_AMP_EQ] = ACTIONS(698),
    [anon_sym_PIPE_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_LT_LT_EQ] = ACTIONS(698),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(698),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(702),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(716),
    [sym_this] = ACTIONS(718),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(718),
    [sym_false] = ACTIONS(718),
    [sym_null] = ACTIONS(718),
    [sym_undefined] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [81] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1245),
    [sym_type_assertion] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(758),
    [anon_sym_of] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(658),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [82] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1245),
    [sym_type_assertion] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(658),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [83] = {
    [sym_import] = STATE(1033),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1033),
    [sym_yield_expression] = STATE(1033),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1462),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(1033),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1033),
    [sym_arrow_function] = STATE(1033),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1033),
    [sym_new_expression] = STATE(1033),
    [sym_await_expression] = STATE(1033),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1033),
    [sym_augmented_assignment_expression] = STATE(1033),
    [sym_ternary_expression] = STATE(1033),
    [sym_binary_expression] = STATE(1033),
    [sym_unary_expression] = STATE(1033),
    [sym_update_expression] = STATE(1033),
    [sym_sequence_expression] = STATE(2831),
    [sym_string] = STATE(1554),
    [sym_template_string] = STATE(1033),
    [sym_regex] = STATE(1033),
    [sym_meta_property] = STATE(1033),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2514),
    [sym_rest_parameter] = STATE(2459),
    [sym_non_null_expression] = STATE(1033),
    [sym_type_assertion] = STATE(1033),
    [sym_as_expression] = STATE(1033),
    [sym_internal_module] = STATE(1033),
    [sym_nested_type_identifier] = STATE(1794),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2459),
    [sym_optional_parameter] = STATE(2459),
    [sym__parameter_name] = STATE(1975),
    [sym__type] = STATE(2437),
    [sym_constructor_type] = STATE(2437),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_type_arguments] = STATE(379),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2721),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2437),
    [sym_intersection_type] = STATE(2437),
    [sym_function_type] = STATE(2437),
    [aux_sym_export_statement_repeat1] = STATE(1642),
    [sym_identifier] = ACTIONS(763),
    [anon_sym_export] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(773),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(795),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(797),
    [sym_this] = ACTIONS(799),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(801),
    [sym_false] = ACTIONS(801),
    [sym_null] = ACTIONS(803),
    [sym_undefined] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(765),
    [anon_sym_get] = ACTIONS(765),
    [anon_sym_set] = ACTIONS(765),
    [anon_sym_declare] = ACTIONS(765),
    [anon_sym_public] = ACTIONS(807),
    [anon_sym_private] = ACTIONS(807),
    [anon_sym_protected] = ACTIONS(807),
    [anon_sym_module] = ACTIONS(765),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
    [sym_readonly] = ACTIONS(811),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [84] = {
    [sym_import] = STATE(1108),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1108),
    [sym_yield_expression] = STATE(1108),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1462),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(1108),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1108),
    [sym_arrow_function] = STATE(1108),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1108),
    [sym_new_expression] = STATE(1108),
    [sym_await_expression] = STATE(1108),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1108),
    [sym_augmented_assignment_expression] = STATE(1108),
    [sym_ternary_expression] = STATE(1108),
    [sym_binary_expression] = STATE(1108),
    [sym_unary_expression] = STATE(1108),
    [sym_update_expression] = STATE(1108),
    [sym_sequence_expression] = STATE(2796),
    [sym_string] = STATE(1554),
    [sym_template_string] = STATE(1108),
    [sym_regex] = STATE(1108),
    [sym_meta_property] = STATE(1108),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2514),
    [sym_rest_parameter] = STATE(2459),
    [sym_non_null_expression] = STATE(1108),
    [sym_type_assertion] = STATE(1108),
    [sym_as_expression] = STATE(1108),
    [sym_internal_module] = STATE(1108),
    [sym_nested_type_identifier] = STATE(1794),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2459),
    [sym_optional_parameter] = STATE(2459),
    [sym__parameter_name] = STATE(1975),
    [sym__type] = STATE(2437),
    [sym_constructor_type] = STATE(2437),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_type_arguments] = STATE(379),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2721),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2437),
    [sym_intersection_type] = STATE(2437),
    [sym_function_type] = STATE(2437),
    [aux_sym_export_statement_repeat1] = STATE(1642),
    [sym_identifier] = ACTIONS(763),
    [anon_sym_export] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(773),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(795),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(797),
    [sym_this] = ACTIONS(799),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(801),
    [sym_false] = ACTIONS(801),
    [sym_null] = ACTIONS(817),
    [sym_undefined] = ACTIONS(817),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(765),
    [anon_sym_get] = ACTIONS(765),
    [anon_sym_set] = ACTIONS(765),
    [anon_sym_declare] = ACTIONS(765),
    [anon_sym_public] = ACTIONS(807),
    [anon_sym_private] = ACTIONS(807),
    [anon_sym_protected] = ACTIONS(807),
    [anon_sym_module] = ACTIONS(765),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
    [sym_readonly] = ACTIONS(811),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [85] = {
    [sym_import] = STATE(1114),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1114),
    [sym_yield_expression] = STATE(1114),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1462),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(1114),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1114),
    [sym_arrow_function] = STATE(1114),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1114),
    [sym_new_expression] = STATE(1114),
    [sym_await_expression] = STATE(1114),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1114),
    [sym_augmented_assignment_expression] = STATE(1114),
    [sym_ternary_expression] = STATE(1114),
    [sym_binary_expression] = STATE(1114),
    [sym_unary_expression] = STATE(1114),
    [sym_update_expression] = STATE(1114),
    [sym_sequence_expression] = STATE(2748),
    [sym_string] = STATE(1554),
    [sym_template_string] = STATE(1114),
    [sym_regex] = STATE(1114),
    [sym_meta_property] = STATE(1114),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2514),
    [sym_rest_parameter] = STATE(2459),
    [sym_non_null_expression] = STATE(1114),
    [sym_type_assertion] = STATE(1114),
    [sym_as_expression] = STATE(1114),
    [sym_internal_module] = STATE(1114),
    [sym_nested_type_identifier] = STATE(1794),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2459),
    [sym_optional_parameter] = STATE(2459),
    [sym__parameter_name] = STATE(1975),
    [sym__type] = STATE(2437),
    [sym_constructor_type] = STATE(2437),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_type_arguments] = STATE(379),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2721),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2437),
    [sym_intersection_type] = STATE(2437),
    [sym_function_type] = STATE(2437),
    [aux_sym_export_statement_repeat1] = STATE(1642),
    [sym_identifier] = ACTIONS(763),
    [anon_sym_export] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(773),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(795),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(797),
    [sym_this] = ACTIONS(799),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(801),
    [sym_false] = ACTIONS(801),
    [sym_null] = ACTIONS(819),
    [sym_undefined] = ACTIONS(819),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(765),
    [anon_sym_get] = ACTIONS(765),
    [anon_sym_set] = ACTIONS(765),
    [anon_sym_declare] = ACTIONS(765),
    [anon_sym_public] = ACTIONS(807),
    [anon_sym_private] = ACTIONS(807),
    [anon_sym_protected] = ACTIONS(807),
    [anon_sym_module] = ACTIONS(765),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
    [sym_readonly] = ACTIONS(811),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [86] = {
    [sym_import] = STATE(1114),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1114),
    [sym_yield_expression] = STATE(1114),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1462),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(1114),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1114),
    [sym_arrow_function] = STATE(1114),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1114),
    [sym_new_expression] = STATE(1114),
    [sym_await_expression] = STATE(1114),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1114),
    [sym_augmented_assignment_expression] = STATE(1114),
    [sym_ternary_expression] = STATE(1114),
    [sym_binary_expression] = STATE(1114),
    [sym_unary_expression] = STATE(1114),
    [sym_update_expression] = STATE(1114),
    [sym_sequence_expression] = STATE(2748),
    [sym_string] = STATE(1554),
    [sym_template_string] = STATE(1114),
    [sym_regex] = STATE(1114),
    [sym_meta_property] = STATE(1114),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2514),
    [sym_rest_parameter] = STATE(2459),
    [sym_non_null_expression] = STATE(1114),
    [sym_type_assertion] = STATE(1114),
    [sym_as_expression] = STATE(1114),
    [sym_internal_module] = STATE(1114),
    [sym_nested_type_identifier] = STATE(1794),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2459),
    [sym_optional_parameter] = STATE(2459),
    [sym__parameter_name] = STATE(1975),
    [sym__type] = STATE(2372),
    [sym_constructor_type] = STATE(2372),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_type_arguments] = STATE(379),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2721),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2372),
    [sym_intersection_type] = STATE(2372),
    [sym_function_type] = STATE(2372),
    [aux_sym_export_statement_repeat1] = STATE(1642),
    [sym_identifier] = ACTIONS(763),
    [anon_sym_export] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(773),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(795),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(797),
    [sym_this] = ACTIONS(799),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(801),
    [sym_false] = ACTIONS(801),
    [sym_null] = ACTIONS(819),
    [sym_undefined] = ACTIONS(819),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(765),
    [anon_sym_get] = ACTIONS(765),
    [anon_sym_set] = ACTIONS(765),
    [anon_sym_declare] = ACTIONS(765),
    [anon_sym_public] = ACTIONS(807),
    [anon_sym_private] = ACTIONS(807),
    [anon_sym_protected] = ACTIONS(807),
    [anon_sym_module] = ACTIONS(765),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
    [sym_readonly] = ACTIONS(811),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [87] = {
    [sym_import] = STATE(1189),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1189),
    [sym_yield_expression] = STATE(1189),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(1189),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1189),
    [sym_arrow_function] = STATE(1189),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1189),
    [sym_new_expression] = STATE(1189),
    [sym_await_expression] = STATE(1189),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1189),
    [sym_augmented_assignment_expression] = STATE(1189),
    [sym_spread_element] = STATE(2505),
    [sym_ternary_expression] = STATE(1189),
    [sym_binary_expression] = STATE(1189),
    [sym_unary_expression] = STATE(1189),
    [sym_update_expression] = STATE(1189),
    [sym_string] = STATE(1632),
    [sym_template_string] = STATE(1189),
    [sym_regex] = STATE(1189),
    [sym_meta_property] = STATE(1189),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2514),
    [sym_non_null_expression] = STATE(1189),
    [sym_type_assertion] = STATE(1189),
    [sym_as_expression] = STATE(1189),
    [sym_internal_module] = STATE(1189),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2186),
    [sym_constructor_type] = STATE(2186),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_type_arguments] = STATE(379),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2721),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2186),
    [sym_intersection_type] = STATE(2186),
    [sym_function_type] = STATE(2186),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [aux_sym_array_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(821),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(823),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(827),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_RBRACK] = ACTIONS(829),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(835),
    [sym_this] = ACTIONS(837),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_null] = ACTIONS(841),
    [sym_undefined] = ACTIONS(841),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(843),
    [anon_sym_number] = ACTIONS(843),
    [anon_sym_boolean] = ACTIONS(843),
    [anon_sym_string] = ACTIONS(843),
    [anon_sym_symbol] = ACTIONS(843),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [88] = {
    [sym_import] = STATE(1189),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1189),
    [sym_yield_expression] = STATE(1189),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(1189),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1189),
    [sym_arrow_function] = STATE(1189),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1189),
    [sym_new_expression] = STATE(1189),
    [sym_await_expression] = STATE(1189),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1189),
    [sym_augmented_assignment_expression] = STATE(1189),
    [sym_spread_element] = STATE(2505),
    [sym_ternary_expression] = STATE(1189),
    [sym_binary_expression] = STATE(1189),
    [sym_unary_expression] = STATE(1189),
    [sym_update_expression] = STATE(1189),
    [sym_string] = STATE(1632),
    [sym_template_string] = STATE(1189),
    [sym_regex] = STATE(1189),
    [sym_meta_property] = STATE(1189),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2514),
    [sym_non_null_expression] = STATE(1189),
    [sym_type_assertion] = STATE(1189),
    [sym_as_expression] = STATE(1189),
    [sym_internal_module] = STATE(1189),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2204),
    [sym_constructor_type] = STATE(2204),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_type_arguments] = STATE(379),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2721),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2204),
    [sym_intersection_type] = STATE(2204),
    [sym_function_type] = STATE(2204),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [aux_sym_array_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(821),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(823),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(827),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_RBRACK] = ACTIONS(829),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(835),
    [sym_this] = ACTIONS(837),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_null] = ACTIONS(841),
    [sym_undefined] = ACTIONS(841),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(843),
    [anon_sym_number] = ACTIONS(843),
    [anon_sym_boolean] = ACTIONS(843),
    [anon_sym_string] = ACTIONS(843),
    [anon_sym_symbol] = ACTIONS(843),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [89] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1168),
    [sym_yield_expression] = STATE(1168),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1168),
    [sym_await_expression] = STATE(1168),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1168),
    [sym_augmented_assignment_expression] = STATE(1168),
    [sym_spread_element] = STATE(2444),
    [sym_ternary_expression] = STATE(1168),
    [sym_binary_expression] = STATE(1168),
    [sym_unary_expression] = STATE(1168),
    [sym_update_expression] = STATE(1168),
    [sym_string] = STATE(1632),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2514),
    [sym_non_null_expression] = STATE(1168),
    [sym_type_assertion] = STATE(1168),
    [sym_as_expression] = STATE(1168),
    [sym_internal_module] = STATE(1168),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2186),
    [sym_constructor_type] = STATE(2186),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_type_arguments] = STATE(379),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2721),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2186),
    [sym_intersection_type] = STATE(2186),
    [sym_function_type] = STATE(2186),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [aux_sym_array_repeat1] = STATE(2439),
    [sym_identifier] = ACTIONS(821),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(823),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(827),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_RBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(835),
    [sym_this] = ACTIONS(837),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_null] = ACTIONS(847),
    [sym_undefined] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(843),
    [anon_sym_number] = ACTIONS(843),
    [anon_sym_boolean] = ACTIONS(843),
    [anon_sym_string] = ACTIONS(843),
    [anon_sym_symbol] = ACTIONS(843),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [90] = {
    [sym_import] = STATE(1224),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(1224),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1224),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_spread_element] = STATE(2520),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_string] = STATE(1632),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2514),
    [sym_non_null_expression] = STATE(1224),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_internal_module] = STATE(1224),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2186),
    [sym_constructor_type] = STATE(2186),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_type_arguments] = STATE(379),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2721),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2186),
    [sym_intersection_type] = STATE(2186),
    [sym_function_type] = STATE(2186),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [aux_sym_array_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(821),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(823),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(827),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_RBRACK] = ACTIONS(849),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(835),
    [sym_this] = ACTIONS(837),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_null] = ACTIONS(851),
    [sym_undefined] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(843),
    [anon_sym_number] = ACTIONS(843),
    [anon_sym_boolean] = ACTIONS(843),
    [anon_sym_string] = ACTIONS(843),
    [anon_sym_symbol] = ACTIONS(843),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [91] = {
    [sym_import] = STATE(1343),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1343),
    [sym_yield_expression] = STATE(1343),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(1343),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1343),
    [sym_arrow_function] = STATE(1343),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1343),
    [sym_new_expression] = STATE(1343),
    [sym_await_expression] = STATE(1343),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1343),
    [sym_augmented_assignment_expression] = STATE(1343),
    [sym_ternary_expression] = STATE(1343),
    [sym_binary_expression] = STATE(1343),
    [sym_unary_expression] = STATE(1343),
    [sym_update_expression] = STATE(1343),
    [sym_string] = STATE(1529),
    [sym_template_string] = STATE(1343),
    [sym_regex] = STATE(1343),
    [sym_meta_property] = STATE(1343),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2514),
    [sym_non_null_expression] = STATE(1343),
    [sym_type_assertion] = STATE(1343),
    [sym_as_expression] = STATE(1343),
    [sym_internal_module] = STATE(1343),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2256),
    [sym_constructor_type] = STATE(2256),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_type_arguments] = STATE(334),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2721),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2256),
    [sym_intersection_type] = STATE(2256),
    [sym_function_type] = STATE(2256),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(853),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(857),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(863),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(867),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(869),
    [sym_this] = ACTIONS(871),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(873),
    [sym_false] = ACTIONS(873),
    [sym_null] = ACTIONS(875),
    [sym_undefined] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(877),
    [anon_sym_number] = ACTIONS(877),
    [anon_sym_boolean] = ACTIONS(877),
    [anon_sym_string] = ACTIONS(877),
    [anon_sym_symbol] = ACTIONS(877),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [92] = {
    [sym_import] = STATE(1164),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1164),
    [sym_yield_expression] = STATE(1164),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(1164),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1164),
    [sym_arrow_function] = STATE(1164),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1164),
    [sym_new_expression] = STATE(1164),
    [sym_await_expression] = STATE(1164),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1164),
    [sym_augmented_assignment_expression] = STATE(1164),
    [sym_ternary_expression] = STATE(1164),
    [sym_binary_expression] = STATE(1164),
    [sym_unary_expression] = STATE(1164),
    [sym_update_expression] = STATE(1164),
    [sym_string] = STATE(1507),
    [sym_template_string] = STATE(1164),
    [sym_regex] = STATE(1164),
    [sym_meta_property] = STATE(1164),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2514),
    [sym_non_null_expression] = STATE(1164),
    [sym_type_assertion] = STATE(1164),
    [sym_as_expression] = STATE(1164),
    [sym_internal_module] = STATE(1164),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2256),
    [sym_constructor_type] = STATE(2256),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_type_arguments] = STATE(368),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2721),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2256),
    [sym_intersection_type] = STATE(2256),
    [sym_function_type] = STATE(2256),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(883),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(895),
    [sym_this] = ACTIONS(897),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(899),
    [sym_false] = ACTIONS(899),
    [sym_null] = ACTIONS(901),
    [sym_undefined] = ACTIONS(901),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(903),
    [anon_sym_number] = ACTIONS(903),
    [anon_sym_boolean] = ACTIONS(903),
    [anon_sym_string] = ACTIONS(903),
    [anon_sym_symbol] = ACTIONS(903),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [93] = {
    [sym_import] = STATE(978),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(978),
    [sym_yield_expression] = STATE(978),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(978),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(978),
    [sym_arrow_function] = STATE(978),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(978),
    [sym_new_expression] = STATE(978),
    [sym_await_expression] = STATE(978),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(978),
    [sym_augmented_assignment_expression] = STATE(978),
    [sym_ternary_expression] = STATE(978),
    [sym_binary_expression] = STATE(978),
    [sym_unary_expression] = STATE(978),
    [sym_update_expression] = STATE(978),
    [sym_string] = STATE(1054),
    [sym_template_string] = STATE(978),
    [sym_regex] = STATE(978),
    [sym_meta_property] = STATE(978),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2514),
    [sym_non_null_expression] = STATE(978),
    [sym_type_assertion] = STATE(978),
    [sym_as_expression] = STATE(978),
    [sym_internal_module] = STATE(978),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2256),
    [sym_constructor_type] = STATE(2256),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_type_arguments] = STATE(379),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2721),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2256),
    [sym_intersection_type] = STATE(2256),
    [sym_function_type] = STATE(2256),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(909),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(915),
    [sym_this] = ACTIONS(917),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_null] = ACTIONS(921),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(923),
    [anon_sym_number] = ACTIONS(923),
    [anon_sym_boolean] = ACTIONS(923),
    [anon_sym_string] = ACTIONS(923),
    [anon_sym_symbol] = ACTIONS(923),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [94] = {
    [sym_import] = STATE(1018),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1018),
    [sym_yield_expression] = STATE(1018),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(1018),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1018),
    [sym_arrow_function] = STATE(1018),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1018),
    [sym_new_expression] = STATE(1018),
    [sym_await_expression] = STATE(1018),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1018),
    [sym_augmented_assignment_expression] = STATE(1018),
    [sym_ternary_expression] = STATE(1018),
    [sym_binary_expression] = STATE(1018),
    [sym_unary_expression] = STATE(1018),
    [sym_update_expression] = STATE(1018),
    [sym_string] = STATE(1413),
    [sym_template_string] = STATE(1018),
    [sym_regex] = STATE(1018),
    [sym_meta_property] = STATE(1018),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2514),
    [sym_non_null_expression] = STATE(1018),
    [sym_type_assertion] = STATE(1018),
    [sym_as_expression] = STATE(1018),
    [sym_internal_module] = STATE(1018),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2256),
    [sym_constructor_type] = STATE(2256),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_type_arguments] = STATE(339),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2721),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2256),
    [sym_intersection_type] = STATE(2256),
    [sym_function_type] = STATE(2256),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(925),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(929),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(931),
    [anon_sym_DASH] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(933),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(935),
    [sym_this] = ACTIONS(937),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(939),
    [sym_false] = ACTIONS(939),
    [sym_null] = ACTIONS(941),
    [sym_undefined] = ACTIONS(941),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [95] = {
    [sym_import] = STATE(952),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(952),
    [sym_yield_expression] = STATE(952),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(952),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(952),
    [sym_arrow_function] = STATE(952),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(952),
    [sym_new_expression] = STATE(952),
    [sym_await_expression] = STATE(952),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(952),
    [sym_augmented_assignment_expression] = STATE(952),
    [sym_ternary_expression] = STATE(952),
    [sym_binary_expression] = STATE(952),
    [sym_unary_expression] = STATE(952),
    [sym_update_expression] = STATE(952),
    [sym_string] = STATE(952),
    [sym_template_string] = STATE(952),
    [sym_regex] = STATE(952),
    [sym_meta_property] = STATE(952),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(952),
    [sym_as_expression] = STATE(952),
    [sym_internal_module] = STATE(952),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(945),
    [anon_sym_as] = ACTIONS(947),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(949),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(949),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_in] = ACTIONS(947),
    [anon_sym_COLON] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(949),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(947),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(949),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_GT_GT_GT] = ACTIONS(949),
    [anon_sym_LT_LT] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(949),
    [anon_sym_STAR_STAR] = ACTIONS(949),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_EQ_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(949),
    [anon_sym_instanceof] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(951),
    [sym_this] = ACTIONS(953),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(953),
    [sym_false] = ACTIONS(953),
    [sym_null] = ACTIONS(953),
    [sym_undefined] = ACTIONS(953),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [96] = {
    [sym_import] = STATE(1258),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1258),
    [sym_yield_expression] = STATE(1258),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(1258),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1258),
    [sym_arrow_function] = STATE(1258),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1258),
    [sym_new_expression] = STATE(1258),
    [sym_await_expression] = STATE(1258),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1258),
    [sym_augmented_assignment_expression] = STATE(1258),
    [sym_ternary_expression] = STATE(1258),
    [sym_binary_expression] = STATE(1258),
    [sym_unary_expression] = STATE(1258),
    [sym_update_expression] = STATE(1258),
    [sym_string] = STATE(1589),
    [sym_template_string] = STATE(1258),
    [sym_regex] = STATE(1258),
    [sym_meta_property] = STATE(1258),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2514),
    [sym_non_null_expression] = STATE(1258),
    [sym_type_assertion] = STATE(1258),
    [sym_as_expression] = STATE(1258),
    [sym_internal_module] = STATE(1258),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2256),
    [sym_constructor_type] = STATE(2256),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_type_arguments] = STATE(290),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2721),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2256),
    [sym_intersection_type] = STATE(2256),
    [sym_function_type] = STATE(2256),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(955),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(957),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(959),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_DASH] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(963),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(965),
    [sym_this] = ACTIONS(967),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(969),
    [sym_false] = ACTIONS(969),
    [sym_null] = ACTIONS(971),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(973),
    [anon_sym_number] = ACTIONS(973),
    [anon_sym_boolean] = ACTIONS(973),
    [anon_sym_string] = ACTIONS(973),
    [anon_sym_symbol] = ACTIONS(973),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [97] = {
    [sym_import] = STATE(1360),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1360),
    [sym_yield_expression] = STATE(1360),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(1360),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1360),
    [sym_arrow_function] = STATE(1360),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1360),
    [sym_new_expression] = STATE(1360),
    [sym_await_expression] = STATE(1360),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1360),
    [sym_augmented_assignment_expression] = STATE(1360),
    [sym_ternary_expression] = STATE(1360),
    [sym_binary_expression] = STATE(1360),
    [sym_unary_expression] = STATE(1360),
    [sym_update_expression] = STATE(1360),
    [sym_string] = STATE(1269),
    [sym_template_string] = STATE(1360),
    [sym_regex] = STATE(1360),
    [sym_meta_property] = STATE(1360),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2401),
    [sym_non_null_expression] = STATE(1360),
    [sym_type_assertion] = STATE(1360),
    [sym_as_expression] = STATE(1360),
    [sym_internal_module] = STATE(1360),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(1888),
    [sym_constructor_type] = STATE(1888),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_type_arguments] = STATE(379),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2574),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(1888),
    [sym_intersection_type] = STATE(1888),
    [sym_function_type] = STATE(1888),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(975),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(981),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(987),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(997),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(999),
    [sym_this] = ACTIONS(1001),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1003),
    [sym_false] = ACTIONS(1003),
    [sym_null] = ACTIONS(1005),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(1007),
    [anon_sym_number] = ACTIONS(1007),
    [anon_sym_boolean] = ACTIONS(1007),
    [anon_sym_string] = ACTIONS(1007),
    [anon_sym_symbol] = ACTIONS(1007),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [98] = {
    [sym_import] = STATE(1142),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1142),
    [sym_yield_expression] = STATE(1142),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(1142),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1142),
    [sym_arrow_function] = STATE(1142),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1142),
    [sym_new_expression] = STATE(1142),
    [sym_await_expression] = STATE(1142),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1142),
    [sym_augmented_assignment_expression] = STATE(1142),
    [sym_ternary_expression] = STATE(1142),
    [sym_binary_expression] = STATE(1142),
    [sym_unary_expression] = STATE(1142),
    [sym_update_expression] = STATE(1142),
    [sym_string] = STATE(1054),
    [sym_template_string] = STATE(1142),
    [sym_regex] = STATE(1142),
    [sym_meta_property] = STATE(1142),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2514),
    [sym_non_null_expression] = STATE(1142),
    [sym_type_assertion] = STATE(1142),
    [sym_as_expression] = STATE(1142),
    [sym_internal_module] = STATE(1142),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2256),
    [sym_constructor_type] = STATE(2256),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_type_arguments] = STATE(291),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2721),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2256),
    [sym_intersection_type] = STATE(2256),
    [sym_function_type] = STATE(2256),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1013),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(1015),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(1017),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(915),
    [sym_this] = ACTIONS(917),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_null] = ACTIONS(1023),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(1025),
    [anon_sym_number] = ACTIONS(1025),
    [anon_sym_boolean] = ACTIONS(1025),
    [anon_sym_string] = ACTIONS(1025),
    [anon_sym_symbol] = ACTIONS(1025),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [99] = {
    [sym_import] = STATE(1058),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1058),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1058),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1058),
    [sym_arrow_function] = STATE(1058),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1058),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(1058),
    [sym_template_string] = STATE(1058),
    [sym_regex] = STATE(1058),
    [sym_meta_property] = STATE(1058),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_internal_module] = STATE(1058),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(947),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(949),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(947),
    [anon_sym_SEMI] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(947),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(949),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_GT_GT_GT] = ACTIONS(949),
    [anon_sym_LT_LT] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(949),
    [anon_sym_STAR_STAR] = ACTIONS(949),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_EQ_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(949),
    [anon_sym_instanceof] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1029),
    [sym_this] = ACTIONS(1031),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1031),
    [sym_false] = ACTIONS(1031),
    [sym_null] = ACTIONS(1031),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(949),
  },
  [100] = {
    [sym_import] = STATE(1185),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1185),
    [sym_yield_expression] = STATE(1185),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1185),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1185),
    [sym_arrow_function] = STATE(1185),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1185),
    [sym_new_expression] = STATE(1185),
    [sym_await_expression] = STATE(1185),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1185),
    [sym_augmented_assignment_expression] = STATE(1185),
    [sym_ternary_expression] = STATE(1185),
    [sym_binary_expression] = STATE(1185),
    [sym_unary_expression] = STATE(1185),
    [sym_update_expression] = STATE(1185),
    [sym_string] = STATE(1185),
    [sym_template_string] = STATE(1185),
    [sym_regex] = STATE(1185),
    [sym_meta_property] = STATE(1185),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1185),
    [sym_type_assertion] = STATE(1185),
    [sym_as_expression] = STATE(1185),
    [sym_internal_module] = STATE(1185),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(1033),
    [anon_sym_as] = ACTIONS(947),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(674),
    [anon_sym_COMMA] = ACTIONS(949),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_in] = ACTIONS(947),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(947),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(949),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_GT_GT_GT] = ACTIONS(949),
    [anon_sym_LT_LT] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(949),
    [anon_sym_STAR_STAR] = ACTIONS(949),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_EQ_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(949),
    [anon_sym_instanceof] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(702),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1035),
    [sym_this] = ACTIONS(1037),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1037),
    [sym_false] = ACTIONS(1037),
    [sym_null] = ACTIONS(1037),
    [sym_undefined] = ACTIONS(1037),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [anon_sym_LBRACE_PIPE] = ACTIONS(949),
  },
  [101] = {
    [sym_import] = STATE(1267),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1267),
    [sym_yield_expression] = STATE(1267),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1267),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1267),
    [sym_arrow_function] = STATE(1267),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1267),
    [sym_new_expression] = STATE(1267),
    [sym_await_expression] = STATE(1267),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1267),
    [sym_augmented_assignment_expression] = STATE(1267),
    [sym_ternary_expression] = STATE(1267),
    [sym_binary_expression] = STATE(1267),
    [sym_unary_expression] = STATE(1267),
    [sym_update_expression] = STATE(1267),
    [sym_string] = STATE(1267),
    [sym_template_string] = STATE(1267),
    [sym_regex] = STATE(1267),
    [sym_meta_property] = STATE(1267),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1267),
    [sym_type_assertion] = STATE(1267),
    [sym_as_expression] = STATE(1267),
    [sym_internal_module] = STATE(1267),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(1039),
    [anon_sym_as] = ACTIONS(947),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(947),
    [anon_sym_COLON] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(949),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(947),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(949),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_GT_GT_GT] = ACTIONS(949),
    [anon_sym_LT_LT] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_PERCENT] = ACTIONS(949),
    [anon_sym_STAR_STAR] = ACTIONS(949),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_EQ_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(949),
    [anon_sym_instanceof] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(658),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1041),
    [sym_this] = ACTIONS(1043),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1043),
    [sym_false] = ACTIONS(1043),
    [sym_null] = ACTIONS(1043),
    [sym_undefined] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [102] = {
    [sym_import] = STATE(1156),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1156),
    [sym_yield_expression] = STATE(1156),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1156),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1156),
    [sym_arrow_function] = STATE(1156),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1156),
    [sym_new_expression] = STATE(1156),
    [sym_await_expression] = STATE(1156),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1156),
    [sym_augmented_assignment_expression] = STATE(1156),
    [sym_ternary_expression] = STATE(1156),
    [sym_binary_expression] = STATE(1156),
    [sym_unary_expression] = STATE(1156),
    [sym_update_expression] = STATE(1156),
    [sym_string] = STATE(1156),
    [sym_template_string] = STATE(1156),
    [sym_regex] = STATE(1156),
    [sym_meta_property] = STATE(1156),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1156),
    [sym_type_assertion] = STATE(1156),
    [sym_as_expression] = STATE(1156),
    [sym_internal_module] = STATE(1156),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_as] = ACTIONS(947),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(949),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_in] = ACTIONS(947),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(947),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(949),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_GT_GT_GT] = ACTIONS(949),
    [anon_sym_LT_LT] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_PERCENT] = ACTIONS(949),
    [anon_sym_STAR_STAR] = ACTIONS(949),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_EQ_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(949),
    [anon_sym_instanceof] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1047),
    [sym_this] = ACTIONS(1049),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1049),
    [sym_false] = ACTIONS(1049),
    [sym_null] = ACTIONS(1049),
    [sym_undefined] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [anon_sym_implements] = ACTIONS(947),
  },
  [103] = {
    [sym_import] = STATE(1249),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1249),
    [sym_yield_expression] = STATE(1249),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1249),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1249),
    [sym_arrow_function] = STATE(1249),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1249),
    [sym_new_expression] = STATE(1249),
    [sym_await_expression] = STATE(1249),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1249),
    [sym_augmented_assignment_expression] = STATE(1249),
    [sym_ternary_expression] = STATE(1249),
    [sym_binary_expression] = STATE(1249),
    [sym_unary_expression] = STATE(1249),
    [sym_update_expression] = STATE(1249),
    [sym_string] = STATE(1249),
    [sym_template_string] = STATE(1249),
    [sym_regex] = STATE(1249),
    [sym_meta_property] = STATE(1249),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1249),
    [sym_type_assertion] = STATE(1249),
    [sym_as_expression] = STATE(1249),
    [sym_internal_module] = STATE(1249),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_STAR] = ACTIONS(1051),
    [anon_sym_as] = ACTIONS(947),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_in] = ACTIONS(947),
    [anon_sym_SEMI] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(947),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(949),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_GT_GT_GT] = ACTIONS(949),
    [anon_sym_LT_LT] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_PERCENT] = ACTIONS(949),
    [anon_sym_STAR_STAR] = ACTIONS(949),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_EQ_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(949),
    [anon_sym_instanceof] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(634),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1053),
    [sym_this] = ACTIONS(1055),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1055),
    [sym_false] = ACTIONS(1055),
    [sym_null] = ACTIONS(1055),
    [sym_undefined] = ACTIONS(1055),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
    [sym__automatic_semicolon] = ACTIONS(949),
  },
  [104] = {
    [ts_builtin_sym_end] = ACTIONS(1057),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(1059),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_default] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(1059),
    [anon_sym_namespace] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_type] = ACTIONS(1059),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(1059),
    [anon_sym_var] = ACTIONS(1059),
    [anon_sym_let] = ACTIONS(1059),
    [anon_sym_const] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_else] = ACTIONS(1059),
    [anon_sym_switch] = ACTIONS(1059),
    [anon_sym_for] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_await] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_do] = ACTIONS(1059),
    [anon_sym_try] = ACTIONS(1059),
    [anon_sym_with] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1059),
    [anon_sym_continue] = ACTIONS(1059),
    [anon_sym_debugger] = ACTIONS(1059),
    [anon_sym_return] = ACTIONS(1059),
    [anon_sym_throw] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1057),
    [anon_sym_case] = ACTIONS(1059),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1059),
    [anon_sym_DOT] = ACTIONS(1059),
    [anon_sym_class] = ACTIONS(1059),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_function] = ACTIONS(1059),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_GT_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_PERCENT] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1059),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_instanceof] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1057),
    [anon_sym_DASH_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_SQUOTE] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [sym_number] = ACTIONS(1057),
    [sym_this] = ACTIONS(1059),
    [sym_super] = ACTIONS(1059),
    [sym_true] = ACTIONS(1059),
    [sym_false] = ACTIONS(1059),
    [sym_null] = ACTIONS(1059),
    [sym_undefined] = ACTIONS(1059),
    [anon_sym_AT] = ACTIONS(1057),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_abstract] = ACTIONS(1059),
    [anon_sym_get] = ACTIONS(1059),
    [anon_sym_set] = ACTIONS(1059),
    [anon_sym_declare] = ACTIONS(1059),
    [anon_sym_public] = ACTIONS(1059),
    [anon_sym_private] = ACTIONS(1059),
    [anon_sym_protected] = ACTIONS(1059),
    [anon_sym_module] = ACTIONS(1059),
    [anon_sym_any] = ACTIONS(1059),
    [anon_sym_number] = ACTIONS(1059),
    [anon_sym_boolean] = ACTIONS(1059),
    [anon_sym_string] = ACTIONS(1059),
    [anon_sym_symbol] = ACTIONS(1059),
    [anon_sym_interface] = ACTIONS(1059),
    [anon_sym_enum] = ACTIONS(1059),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1057),
    [sym__automatic_semicolon] = ACTIONS(1057),
  },
  [105] = {
    [ts_builtin_sym_end] = ACTIONS(1061),
    [sym_identifier] = ACTIONS(1063),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_default] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1065),
    [anon_sym_namespace] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_import] = ACTIONS(1063),
    [anon_sym_var] = ACTIONS(1063),
    [anon_sym_let] = ACTIONS(1063),
    [anon_sym_const] = ACTIONS(1063),
    [anon_sym_if] = ACTIONS(1063),
    [anon_sym_else] = ACTIONS(1063),
    [anon_sym_switch] = ACTIONS(1063),
    [anon_sym_for] = ACTIONS(1063),
    [anon_sym_LPAREN] = ACTIONS(1061),
    [anon_sym_await] = ACTIONS(1063),
    [anon_sym_in] = ACTIONS(1065),
    [anon_sym_while] = ACTIONS(1063),
    [anon_sym_do] = ACTIONS(1063),
    [anon_sym_try] = ACTIONS(1063),
    [anon_sym_with] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1063),
    [anon_sym_continue] = ACTIONS(1063),
    [anon_sym_debugger] = ACTIONS(1063),
    [anon_sym_return] = ACTIONS(1063),
    [anon_sym_throw] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_case] = ACTIONS(1063),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1063),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_class] = ACTIONS(1063),
    [anon_sym_async] = ACTIONS(1063),
    [anon_sym_function] = ACTIONS(1063),
    [anon_sym_new] = ACTIONS(1063),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1065),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_TILDE] = ACTIONS(1061),
    [anon_sym_void] = ACTIONS(1063),
    [anon_sym_delete] = ACTIONS(1063),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [anon_sym_SQUOTE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [sym_number] = ACTIONS(1061),
    [sym_this] = ACTIONS(1063),
    [sym_super] = ACTIONS(1063),
    [sym_true] = ACTIONS(1063),
    [sym_false] = ACTIONS(1063),
    [sym_null] = ACTIONS(1063),
    [sym_undefined] = ACTIONS(1063),
    [anon_sym_AT] = ACTIONS(1061),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_abstract] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
    [anon_sym_interface] = ACTIONS(1063),
    [anon_sym_enum] = ACTIONS(1063),
    [sym__automatic_semicolon] = ACTIONS(1069),
  },
  [106] = {
    [sym_statement_block] = STATE(108),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [anon_sym_export] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(1073),
    [anon_sym_default] = ACTIONS(1073),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(1073),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_type] = ACTIONS(1073),
    [anon_sym_typeof] = ACTIONS(1073),
    [anon_sym_import] = ACTIONS(1073),
    [anon_sym_var] = ACTIONS(1073),
    [anon_sym_let] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1073),
    [anon_sym_if] = ACTIONS(1073),
    [anon_sym_else] = ACTIONS(1073),
    [anon_sym_switch] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1073),
    [anon_sym_do] = ACTIONS(1073),
    [anon_sym_try] = ACTIONS(1073),
    [anon_sym_with] = ACTIONS(1073),
    [anon_sym_break] = ACTIONS(1073),
    [anon_sym_continue] = ACTIONS(1073),
    [anon_sym_debugger] = ACTIONS(1073),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_throw] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1073),
    [anon_sym_function] = ACTIONS(1073),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_STAR_STAR] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1071),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1073),
    [anon_sym_delete] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [sym_number] = ACTIONS(1071),
    [sym_this] = ACTIONS(1073),
    [sym_super] = ACTIONS(1073),
    [sym_true] = ACTIONS(1073),
    [sym_false] = ACTIONS(1073),
    [sym_null] = ACTIONS(1073),
    [sym_undefined] = ACTIONS(1073),
    [anon_sym_AT] = ACTIONS(1071),
    [anon_sym_static] = ACTIONS(1073),
    [anon_sym_abstract] = ACTIONS(1073),
    [anon_sym_get] = ACTIONS(1073),
    [anon_sym_set] = ACTIONS(1073),
    [anon_sym_declare] = ACTIONS(1073),
    [anon_sym_public] = ACTIONS(1073),
    [anon_sym_private] = ACTIONS(1073),
    [anon_sym_protected] = ACTIONS(1073),
    [anon_sym_module] = ACTIONS(1073),
    [anon_sym_any] = ACTIONS(1073),
    [anon_sym_number] = ACTIONS(1073),
    [anon_sym_boolean] = ACTIONS(1073),
    [anon_sym_string] = ACTIONS(1073),
    [anon_sym_symbol] = ACTIONS(1073),
    [anon_sym_interface] = ACTIONS(1073),
    [anon_sym_enum] = ACTIONS(1073),
    [sym__automatic_semicolon] = ACTIONS(1071),
  },
  [107] = {
    [ts_builtin_sym_end] = ACTIONS(1077),
    [sym_identifier] = ACTIONS(1079),
    [anon_sym_export] = ACTIONS(1079),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_default] = ACTIONS(1079),
    [anon_sym_as] = ACTIONS(1079),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1077),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_type] = ACTIONS(1079),
    [anon_sym_typeof] = ACTIONS(1079),
    [anon_sym_import] = ACTIONS(1079),
    [anon_sym_var] = ACTIONS(1079),
    [anon_sym_let] = ACTIONS(1079),
    [anon_sym_const] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1079),
    [anon_sym_switch] = ACTIONS(1079),
    [anon_sym_for] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_in] = ACTIONS(1079),
    [anon_sym_while] = ACTIONS(1079),
    [anon_sym_do] = ACTIONS(1079),
    [anon_sym_try] = ACTIONS(1079),
    [anon_sym_with] = ACTIONS(1079),
    [anon_sym_break] = ACTIONS(1079),
    [anon_sym_continue] = ACTIONS(1079),
    [anon_sym_debugger] = ACTIONS(1079),
    [anon_sym_return] = ACTIONS(1079),
    [anon_sym_throw] = ACTIONS(1079),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_case] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_SLASH] = ACTIONS(1079),
    [anon_sym_DOT] = ACTIONS(1079),
    [anon_sym_class] = ACTIONS(1079),
    [anon_sym_async] = ACTIONS(1079),
    [anon_sym_function] = ACTIONS(1079),
    [anon_sym_new] = ACTIONS(1079),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(1079),
    [anon_sym_DASH] = ACTIONS(1079),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1079),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_TILDE] = ACTIONS(1077),
    [anon_sym_void] = ACTIONS(1079),
    [anon_sym_delete] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1077),
    [anon_sym_SQUOTE] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [sym_number] = ACTIONS(1077),
    [sym_this] = ACTIONS(1079),
    [sym_super] = ACTIONS(1079),
    [sym_true] = ACTIONS(1079),
    [sym_false] = ACTIONS(1079),
    [sym_null] = ACTIONS(1079),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1079),
    [anon_sym_abstract] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(1079),
    [anon_sym_set] = ACTIONS(1079),
    [anon_sym_declare] = ACTIONS(1079),
    [anon_sym_public] = ACTIONS(1079),
    [anon_sym_private] = ACTIONS(1079),
    [anon_sym_protected] = ACTIONS(1079),
    [anon_sym_module] = ACTIONS(1079),
    [anon_sym_any] = ACTIONS(1079),
    [anon_sym_number] = ACTIONS(1079),
    [anon_sym_boolean] = ACTIONS(1079),
    [anon_sym_string] = ACTIONS(1079),
    [anon_sym_symbol] = ACTIONS(1079),
    [anon_sym_interface] = ACTIONS(1079),
    [anon_sym_enum] = ACTIONS(1079),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1077),
    [sym__automatic_semicolon] = ACTIONS(1077),
  },
  [108] = {
    [ts_builtin_sym_end] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(1083),
    [anon_sym_as] = ACTIONS(1083),
    [anon_sym_namespace] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1083),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_import] = ACTIONS(1083),
    [anon_sym_var] = ACTIONS(1083),
    [anon_sym_let] = ACTIONS(1083),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_if] = ACTIONS(1083),
    [anon_sym_else] = ACTIONS(1083),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_for] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_while] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_try] = ACTIONS(1083),
    [anon_sym_with] = ACTIONS(1083),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_continue] = ACTIONS(1083),
    [anon_sym_debugger] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1083),
    [anon_sym_throw] = ACTIONS(1083),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_case] = ACTIONS(1083),
    [anon_sym_yield] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(1083),
    [anon_sym_class] = ACTIONS(1083),
    [anon_sym_async] = ACTIONS(1083),
    [anon_sym_function] = ACTIONS(1083),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1081),
    [anon_sym_STAR_STAR] = ACTIONS(1081),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_void] = ACTIONS(1083),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_DQUOTE] = ACTIONS(1081),
    [anon_sym_SQUOTE] = ACTIONS(1081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_number] = ACTIONS(1081),
    [sym_this] = ACTIONS(1083),
    [sym_super] = ACTIONS(1083),
    [sym_true] = ACTIONS(1083),
    [sym_false] = ACTIONS(1083),
    [sym_null] = ACTIONS(1083),
    [sym_undefined] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(1081),
    [anon_sym_static] = ACTIONS(1083),
    [anon_sym_abstract] = ACTIONS(1083),
    [anon_sym_get] = ACTIONS(1083),
    [anon_sym_set] = ACTIONS(1083),
    [anon_sym_declare] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1083),
    [anon_sym_private] = ACTIONS(1083),
    [anon_sym_protected] = ACTIONS(1083),
    [anon_sym_module] = ACTIONS(1083),
    [anon_sym_any] = ACTIONS(1083),
    [anon_sym_number] = ACTIONS(1083),
    [anon_sym_boolean] = ACTIONS(1083),
    [anon_sym_string] = ACTIONS(1083),
    [anon_sym_symbol] = ACTIONS(1083),
    [anon_sym_interface] = ACTIONS(1083),
    [anon_sym_enum] = ACTIONS(1083),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1081),
    [sym__automatic_semicolon] = ACTIONS(1081),
  },
  [109] = {
    [sym_statement_block] = STATE(108),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [anon_sym_export] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(1073),
    [anon_sym_default] = ACTIONS(1073),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(1073),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_type] = ACTIONS(1073),
    [anon_sym_typeof] = ACTIONS(1073),
    [anon_sym_import] = ACTIONS(1073),
    [anon_sym_var] = ACTIONS(1073),
    [anon_sym_let] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1073),
    [anon_sym_if] = ACTIONS(1073),
    [anon_sym_else] = ACTIONS(1073),
    [anon_sym_switch] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1073),
    [anon_sym_do] = ACTIONS(1073),
    [anon_sym_try] = ACTIONS(1073),
    [anon_sym_with] = ACTIONS(1073),
    [anon_sym_break] = ACTIONS(1073),
    [anon_sym_continue] = ACTIONS(1073),
    [anon_sym_debugger] = ACTIONS(1073),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_throw] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(1085),
    [anon_sym_class] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1073),
    [anon_sym_function] = ACTIONS(1073),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_STAR_STAR] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1071),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1073),
    [anon_sym_delete] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [sym_number] = ACTIONS(1071),
    [sym_this] = ACTIONS(1073),
    [sym_super] = ACTIONS(1073),
    [sym_true] = ACTIONS(1073),
    [sym_false] = ACTIONS(1073),
    [sym_null] = ACTIONS(1073),
    [sym_undefined] = ACTIONS(1073),
    [anon_sym_AT] = ACTIONS(1071),
    [anon_sym_static] = ACTIONS(1073),
    [anon_sym_abstract] = ACTIONS(1073),
    [anon_sym_get] = ACTIONS(1073),
    [anon_sym_set] = ACTIONS(1073),
    [anon_sym_declare] = ACTIONS(1073),
    [anon_sym_public] = ACTIONS(1073),
    [anon_sym_private] = ACTIONS(1073),
    [anon_sym_protected] = ACTIONS(1073),
    [anon_sym_module] = ACTIONS(1073),
    [anon_sym_any] = ACTIONS(1073),
    [anon_sym_number] = ACTIONS(1073),
    [anon_sym_boolean] = ACTIONS(1073),
    [anon_sym_string] = ACTIONS(1073),
    [anon_sym_symbol] = ACTIONS(1073),
    [anon_sym_interface] = ACTIONS(1073),
    [anon_sym_enum] = ACTIONS(1073),
    [sym__automatic_semicolon] = ACTIONS(1071),
  },
  [110] = {
    [ts_builtin_sym_end] = ACTIONS(1087),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_default] = ACTIONS(1089),
    [anon_sym_as] = ACTIONS(1091),
    [anon_sym_namespace] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1087),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_type] = ACTIONS(1089),
    [anon_sym_typeof] = ACTIONS(1089),
    [anon_sym_import] = ACTIONS(1089),
    [anon_sym_var] = ACTIONS(1089),
    [anon_sym_let] = ACTIONS(1089),
    [anon_sym_const] = ACTIONS(1089),
    [anon_sym_if] = ACTIONS(1089),
    [anon_sym_else] = ACTIONS(1089),
    [anon_sym_switch] = ACTIONS(1089),
    [anon_sym_for] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_await] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(1089),
    [anon_sym_try] = ACTIONS(1089),
    [anon_sym_with] = ACTIONS(1089),
    [anon_sym_break] = ACTIONS(1089),
    [anon_sym_continue] = ACTIONS(1089),
    [anon_sym_debugger] = ACTIONS(1089),
    [anon_sym_return] = ACTIONS(1089),
    [anon_sym_throw] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_case] = ACTIONS(1089),
    [anon_sym_yield] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1089),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_new] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1089),
    [anon_sym_DASH] = ACTIONS(1089),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1093),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_instanceof] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1089),
    [anon_sym_delete] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_SQUOTE] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [sym_number] = ACTIONS(1087),
    [sym_this] = ACTIONS(1089),
    [sym_super] = ACTIONS(1089),
    [sym_true] = ACTIONS(1089),
    [sym_false] = ACTIONS(1089),
    [sym_null] = ACTIONS(1089),
    [sym_undefined] = ACTIONS(1089),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_static] = ACTIONS(1089),
    [anon_sym_abstract] = ACTIONS(1089),
    [anon_sym_get] = ACTIONS(1089),
    [anon_sym_set] = ACTIONS(1089),
    [anon_sym_declare] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1089),
    [anon_sym_private] = ACTIONS(1089),
    [anon_sym_protected] = ACTIONS(1089),
    [anon_sym_module] = ACTIONS(1089),
    [anon_sym_any] = ACTIONS(1089),
    [anon_sym_number] = ACTIONS(1089),
    [anon_sym_boolean] = ACTIONS(1089),
    [anon_sym_string] = ACTIONS(1089),
    [anon_sym_symbol] = ACTIONS(1089),
    [anon_sym_interface] = ACTIONS(1089),
    [anon_sym_enum] = ACTIONS(1089),
    [sym__automatic_semicolon] = ACTIONS(1095),
  },
  [111] = {
    [ts_builtin_sym_end] = ACTIONS(1097),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_default] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(1099),
    [anon_sym_namespace] = ACTIONS(1099),
    [anon_sym_LBRACE] = ACTIONS(1097),
    [anon_sym_COMMA] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1099),
    [anon_sym_var] = ACTIONS(1099),
    [anon_sym_let] = ACTIONS(1099),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_if] = ACTIONS(1099),
    [anon_sym_else] = ACTIONS(1099),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_await] = ACTIONS(1099),
    [anon_sym_in] = ACTIONS(1099),
    [anon_sym_while] = ACTIONS(1099),
    [anon_sym_do] = ACTIONS(1099),
    [anon_sym_try] = ACTIONS(1099),
    [anon_sym_with] = ACTIONS(1099),
    [anon_sym_break] = ACTIONS(1099),
    [anon_sym_continue] = ACTIONS(1099),
    [anon_sym_debugger] = ACTIONS(1099),
    [anon_sym_return] = ACTIONS(1099),
    [anon_sym_throw] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_case] = ACTIONS(1099),
    [anon_sym_yield] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(1099),
    [anon_sym_DOT] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1099),
    [anon_sym_function] = ACTIONS(1099),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_GT_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_PERCENT] = ACTIONS(1097),
    [anon_sym_STAR_STAR] = ACTIONS(1097),
    [anon_sym_LT_EQ] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1097),
    [anon_sym_BANG_EQ] = ACTIONS(1099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1097),
    [anon_sym_instanceof] = ACTIONS(1099),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_void] = ACTIONS(1099),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [sym_number] = ACTIONS(1097),
    [sym_this] = ACTIONS(1099),
    [sym_super] = ACTIONS(1099),
    [sym_true] = ACTIONS(1099),
    [sym_false] = ACTIONS(1099),
    [sym_null] = ACTIONS(1099),
    [sym_undefined] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1097),
    [anon_sym_static] = ACTIONS(1099),
    [anon_sym_abstract] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(1099),
    [anon_sym_set] = ACTIONS(1099),
    [anon_sym_declare] = ACTIONS(1099),
    [anon_sym_public] = ACTIONS(1099),
    [anon_sym_private] = ACTIONS(1099),
    [anon_sym_protected] = ACTIONS(1099),
    [anon_sym_module] = ACTIONS(1099),
    [anon_sym_any] = ACTIONS(1099),
    [anon_sym_number] = ACTIONS(1099),
    [anon_sym_boolean] = ACTIONS(1099),
    [anon_sym_string] = ACTIONS(1099),
    [anon_sym_symbol] = ACTIONS(1099),
    [anon_sym_interface] = ACTIONS(1099),
    [anon_sym_enum] = ACTIONS(1099),
    [sym__automatic_semicolon] = ACTIONS(1097),
  },
  [112] = {
    [ts_builtin_sym_end] = ACTIONS(1101),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1103),
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_as] = ACTIONS(1105),
    [anon_sym_namespace] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(1101),
    [anon_sym_type] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1103),
    [anon_sym_import] = ACTIONS(1103),
    [anon_sym_var] = ACTIONS(1103),
    [anon_sym_let] = ACTIONS(1103),
    [anon_sym_const] = ACTIONS(1103),
    [anon_sym_if] = ACTIONS(1103),
    [anon_sym_else] = ACTIONS(1103),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_for] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_in] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(1103),
    [anon_sym_do] = ACTIONS(1103),
    [anon_sym_try] = ACTIONS(1103),
    [anon_sym_with] = ACTIONS(1103),
    [anon_sym_break] = ACTIONS(1103),
    [anon_sym_continue] = ACTIONS(1103),
    [anon_sym_debugger] = ACTIONS(1103),
    [anon_sym_return] = ACTIONS(1103),
    [anon_sym_throw] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_case] = ACTIONS(1103),
    [anon_sym_yield] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_SLASH] = ACTIONS(1103),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_class] = ACTIONS(1103),
    [anon_sym_async] = ACTIONS(1103),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1103),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_GT_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_PERCENT] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1107),
    [anon_sym_LT_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1107),
    [anon_sym_GT_EQ] = ACTIONS(1107),
    [anon_sym_instanceof] = ACTIONS(1105),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_TILDE] = ACTIONS(1101),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_PLUS_PLUS] = ACTIONS(1101),
    [anon_sym_DASH_DASH] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_SQUOTE] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [sym_number] = ACTIONS(1101),
    [sym_this] = ACTIONS(1103),
    [sym_super] = ACTIONS(1103),
    [sym_true] = ACTIONS(1103),
    [sym_false] = ACTIONS(1103),
    [sym_null] = ACTIONS(1103),
    [sym_undefined] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(1101),
    [anon_sym_static] = ACTIONS(1103),
    [anon_sym_abstract] = ACTIONS(1103),
    [anon_sym_get] = ACTIONS(1103),
    [anon_sym_set] = ACTIONS(1103),
    [anon_sym_declare] = ACTIONS(1103),
    [anon_sym_public] = ACTIONS(1103),
    [anon_sym_private] = ACTIONS(1103),
    [anon_sym_protected] = ACTIONS(1103),
    [anon_sym_module] = ACTIONS(1103),
    [anon_sym_any] = ACTIONS(1103),
    [anon_sym_number] = ACTIONS(1103),
    [anon_sym_boolean] = ACTIONS(1103),
    [anon_sym_string] = ACTIONS(1103),
    [anon_sym_symbol] = ACTIONS(1103),
    [anon_sym_interface] = ACTIONS(1103),
    [anon_sym_enum] = ACTIONS(1103),
    [sym__automatic_semicolon] = ACTIONS(1109),
  },
  [113] = {
    [ts_builtin_sym_end] = ACTIONS(1111),
    [sym_identifier] = ACTIONS(1113),
    [anon_sym_export] = ACTIONS(1113),
    [anon_sym_STAR] = ACTIONS(1113),
    [anon_sym_default] = ACTIONS(1113),
    [anon_sym_as] = ACTIONS(1113),
    [anon_sym_namespace] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_COMMA] = ACTIONS(1111),
    [anon_sym_RBRACE] = ACTIONS(1111),
    [anon_sym_type] = ACTIONS(1113),
    [anon_sym_typeof] = ACTIONS(1113),
    [anon_sym_import] = ACTIONS(1113),
    [anon_sym_var] = ACTIONS(1113),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_const] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(1113),
    [anon_sym_else] = ACTIONS(1113),
    [anon_sym_switch] = ACTIONS(1113),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_await] = ACTIONS(1113),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1113),
    [anon_sym_do] = ACTIONS(1113),
    [anon_sym_try] = ACTIONS(1113),
    [anon_sym_with] = ACTIONS(1113),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1113),
    [anon_sym_debugger] = ACTIONS(1113),
    [anon_sym_return] = ACTIONS(1113),
    [anon_sym_throw] = ACTIONS(1113),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_case] = ACTIONS(1113),
    [anon_sym_yield] = ACTIONS(1113),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1113),
    [anon_sym_GT] = ACTIONS(1113),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_DOT] = ACTIONS(1113),
    [anon_sym_class] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(1113),
    [anon_sym_new] = ACTIONS(1113),
    [anon_sym_QMARK] = ACTIONS(1111),
    [anon_sym_AMP_AMP] = ACTIONS(1111),
    [anon_sym_PIPE_PIPE] = ACTIONS(1111),
    [anon_sym_GT_GT] = ACTIONS(1113),
    [anon_sym_GT_GT_GT] = ACTIONS(1111),
    [anon_sym_LT_LT] = ACTIONS(1111),
    [anon_sym_AMP] = ACTIONS(1113),
    [anon_sym_CARET] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1113),
    [anon_sym_PLUS] = ACTIONS(1113),
    [anon_sym_DASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1111),
    [anon_sym_STAR_STAR] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_EQ_EQ] = ACTIONS(1113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ] = ACTIONS(1113),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1111),
    [anon_sym_instanceof] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1113),
    [anon_sym_TILDE] = ACTIONS(1111),
    [anon_sym_void] = ACTIONS(1113),
    [anon_sym_delete] = ACTIONS(1113),
    [anon_sym_PLUS_PLUS] = ACTIONS(1111),
    [anon_sym_DASH_DASH] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(1111),
    [anon_sym_SQUOTE] = ACTIONS(1111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(1111),
    [sym_this] = ACTIONS(1113),
    [sym_super] = ACTIONS(1113),
    [sym_true] = ACTIONS(1113),
    [sym_false] = ACTIONS(1113),
    [sym_null] = ACTIONS(1113),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym_static] = ACTIONS(1113),
    [anon_sym_abstract] = ACTIONS(1113),
    [anon_sym_get] = ACTIONS(1113),
    [anon_sym_set] = ACTIONS(1113),
    [anon_sym_declare] = ACTIONS(1113),
    [anon_sym_public] = ACTIONS(1113),
    [anon_sym_private] = ACTIONS(1113),
    [anon_sym_protected] = ACTIONS(1113),
    [anon_sym_module] = ACTIONS(1113),
    [anon_sym_any] = ACTIONS(1113),
    [anon_sym_number] = ACTIONS(1113),
    [anon_sym_boolean] = ACTIONS(1113),
    [anon_sym_string] = ACTIONS(1113),
    [anon_sym_symbol] = ACTIONS(1113),
    [anon_sym_interface] = ACTIONS(1113),
    [anon_sym_enum] = ACTIONS(1113),
    [sym__automatic_semicolon] = ACTIONS(1111),
  },
  [114] = {
    [ts_builtin_sym_end] = ACTIONS(1115),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_export] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1117),
    [anon_sym_default] = ACTIONS(1117),
    [anon_sym_as] = ACTIONS(1117),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1115),
    [anon_sym_type] = ACTIONS(1117),
    [anon_sym_typeof] = ACTIONS(1117),
    [anon_sym_import] = ACTIONS(1117),
    [anon_sym_var] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_const] = ACTIONS(1117),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_else] = ACTIONS(1117),
    [anon_sym_switch] = ACTIONS(1117),
    [anon_sym_for] = ACTIONS(1117),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_await] = ACTIONS(1117),
    [anon_sym_in] = ACTIONS(1117),
    [anon_sym_while] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1117),
    [anon_sym_with] = ACTIONS(1117),
    [anon_sym_break] = ACTIONS(1117),
    [anon_sym_continue] = ACTIONS(1117),
    [anon_sym_debugger] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1117),
    [anon_sym_throw] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1115),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_yield] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_SLASH] = ACTIONS(1117),
    [anon_sym_DOT] = ACTIONS(1117),
    [anon_sym_class] = ACTIONS(1117),
    [anon_sym_async] = ACTIONS(1117),
    [anon_sym_function] = ACTIONS(1117),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_QMARK] = ACTIONS(1115),
    [anon_sym_AMP_AMP] = ACTIONS(1115),
    [anon_sym_PIPE_PIPE] = ACTIONS(1115),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_GT_GT_GT] = ACTIONS(1115),
    [anon_sym_LT_LT] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1117),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_PIPE] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_PERCENT] = ACTIONS(1115),
    [anon_sym_STAR_STAR] = ACTIONS(1115),
    [anon_sym_LT_EQ] = ACTIONS(1115),
    [anon_sym_EQ_EQ] = ACTIONS(1117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1115),
    [anon_sym_BANG_EQ] = ACTIONS(1117),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1115),
    [anon_sym_instanceof] = ACTIONS(1117),
    [anon_sym_BANG] = ACTIONS(1117),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_void] = ACTIONS(1117),
    [anon_sym_delete] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [sym_number] = ACTIONS(1115),
    [sym_this] = ACTIONS(1117),
    [sym_super] = ACTIONS(1117),
    [sym_true] = ACTIONS(1117),
    [sym_false] = ACTIONS(1117),
    [sym_null] = ACTIONS(1117),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(1115),
    [anon_sym_static] = ACTIONS(1117),
    [anon_sym_abstract] = ACTIONS(1117),
    [anon_sym_get] = ACTIONS(1117),
    [anon_sym_set] = ACTIONS(1117),
    [anon_sym_declare] = ACTIONS(1117),
    [anon_sym_public] = ACTIONS(1117),
    [anon_sym_private] = ACTIONS(1117),
    [anon_sym_protected] = ACTIONS(1117),
    [anon_sym_module] = ACTIONS(1117),
    [anon_sym_any] = ACTIONS(1117),
    [anon_sym_number] = ACTIONS(1117),
    [anon_sym_boolean] = ACTIONS(1117),
    [anon_sym_string] = ACTIONS(1117),
    [anon_sym_symbol] = ACTIONS(1117),
    [anon_sym_interface] = ACTIONS(1117),
    [anon_sym_enum] = ACTIONS(1117),
    [sym__automatic_semicolon] = ACTIONS(1115),
  },
  [115] = {
    [ts_builtin_sym_end] = ACTIONS(1061),
    [sym_identifier] = ACTIONS(1063),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_default] = ACTIONS(1063),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_import] = ACTIONS(1063),
    [anon_sym_var] = ACTIONS(1063),
    [anon_sym_let] = ACTIONS(1063),
    [anon_sym_const] = ACTIONS(1063),
    [anon_sym_if] = ACTIONS(1063),
    [anon_sym_else] = ACTIONS(1063),
    [anon_sym_switch] = ACTIONS(1063),
    [anon_sym_for] = ACTIONS(1063),
    [anon_sym_LPAREN] = ACTIONS(1061),
    [anon_sym_await] = ACTIONS(1063),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_while] = ACTIONS(1063),
    [anon_sym_do] = ACTIONS(1063),
    [anon_sym_try] = ACTIONS(1063),
    [anon_sym_with] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1063),
    [anon_sym_continue] = ACTIONS(1063),
    [anon_sym_debugger] = ACTIONS(1063),
    [anon_sym_return] = ACTIONS(1063),
    [anon_sym_throw] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_case] = ACTIONS(1063),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(1063),
    [anon_sym_DOT] = ACTIONS(1063),
    [anon_sym_class] = ACTIONS(1063),
    [anon_sym_async] = ACTIONS(1063),
    [anon_sym_function] = ACTIONS(1063),
    [anon_sym_new] = ACTIONS(1063),
    [anon_sym_QMARK] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_GT_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_PERCENT] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1061),
    [anon_sym_GT_EQ] = ACTIONS(1061),
    [anon_sym_instanceof] = ACTIONS(1063),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_TILDE] = ACTIONS(1061),
    [anon_sym_void] = ACTIONS(1063),
    [anon_sym_delete] = ACTIONS(1063),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [anon_sym_SQUOTE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [sym_number] = ACTIONS(1061),
    [sym_this] = ACTIONS(1063),
    [sym_super] = ACTIONS(1063),
    [sym_true] = ACTIONS(1063),
    [sym_false] = ACTIONS(1063),
    [sym_null] = ACTIONS(1063),
    [sym_undefined] = ACTIONS(1063),
    [anon_sym_AT] = ACTIONS(1061),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_abstract] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
    [anon_sym_interface] = ACTIONS(1063),
    [anon_sym_enum] = ACTIONS(1063),
    [sym__automatic_semicolon] = ACTIONS(1119),
  },
  [116] = {
    [ts_builtin_sym_end] = ACTIONS(1121),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1125),
    [anon_sym_default] = ACTIONS(1123),
    [anon_sym_as] = ACTIONS(1125),
    [anon_sym_namespace] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_RBRACE] = ACTIONS(1121),
    [anon_sym_type] = ACTIONS(1123),
    [anon_sym_typeof] = ACTIONS(1123),
    [anon_sym_import] = ACTIONS(1123),
    [anon_sym_var] = ACTIONS(1123),
    [anon_sym_let] = ACTIONS(1123),
    [anon_sym_const] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1123),
    [anon_sym_else] = ACTIONS(1123),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_for] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_await] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_while] = ACTIONS(1123),
    [anon_sym_do] = ACTIONS(1123),
    [anon_sym_try] = ACTIONS(1123),
    [anon_sym_with] = ACTIONS(1123),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_continue] = ACTIONS(1123),
    [anon_sym_debugger] = ACTIONS(1123),
    [anon_sym_return] = ACTIONS(1123),
    [anon_sym_throw] = ACTIONS(1123),
    [anon_sym_SEMI] = ACTIONS(1121),
    [anon_sym_case] = ACTIONS(1123),
    [anon_sym_yield] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_GT] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1123),
    [anon_sym_DOT] = ACTIONS(1125),
    [anon_sym_class] = ACTIONS(1123),
    [anon_sym_async] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1123),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_GT_GT] = ACTIONS(1125),
    [anon_sym_GT_GT_GT] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_CARET] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1125),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_PERCENT] = ACTIONS(1127),
    [anon_sym_STAR_STAR] = ACTIONS(1127),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_instanceof] = ACTIONS(1125),
    [anon_sym_BANG] = ACTIONS(1123),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_void] = ACTIONS(1123),
    [anon_sym_delete] = ACTIONS(1123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_DQUOTE] = ACTIONS(1121),
    [anon_sym_SQUOTE] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1121),
    [sym_number] = ACTIONS(1121),
    [sym_this] = ACTIONS(1123),
    [sym_super] = ACTIONS(1123),
    [sym_true] = ACTIONS(1123),
    [sym_false] = ACTIONS(1123),
    [sym_null] = ACTIONS(1123),
    [sym_undefined] = ACTIONS(1123),
    [anon_sym_AT] = ACTIONS(1121),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_abstract] = ACTIONS(1123),
    [anon_sym_get] = ACTIONS(1123),
    [anon_sym_set] = ACTIONS(1123),
    [anon_sym_declare] = ACTIONS(1123),
    [anon_sym_public] = ACTIONS(1123),
    [anon_sym_private] = ACTIONS(1123),
    [anon_sym_protected] = ACTIONS(1123),
    [anon_sym_module] = ACTIONS(1123),
    [anon_sym_any] = ACTIONS(1123),
    [anon_sym_number] = ACTIONS(1123),
    [anon_sym_boolean] = ACTIONS(1123),
    [anon_sym_string] = ACTIONS(1123),
    [anon_sym_symbol] = ACTIONS(1123),
    [anon_sym_interface] = ACTIONS(1123),
    [anon_sym_enum] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1129),
  },
  [117] = {
    [ts_builtin_sym_end] = ACTIONS(1131),
    [sym_identifier] = ACTIONS(1133),
    [anon_sym_export] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_default] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(1133),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1133),
    [anon_sym_typeof] = ACTIONS(1133),
    [anon_sym_import] = ACTIONS(1133),
    [anon_sym_var] = ACTIONS(1133),
    [anon_sym_let] = ACTIONS(1133),
    [anon_sym_const] = ACTIONS(1133),
    [anon_sym_if] = ACTIONS(1133),
    [anon_sym_else] = ACTIONS(1133),
    [anon_sym_switch] = ACTIONS(1133),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_in] = ACTIONS(1133),
    [anon_sym_while] = ACTIONS(1133),
    [anon_sym_do] = ACTIONS(1133),
    [anon_sym_try] = ACTIONS(1133),
    [anon_sym_with] = ACTIONS(1133),
    [anon_sym_break] = ACTIONS(1133),
    [anon_sym_continue] = ACTIONS(1133),
    [anon_sym_debugger] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1133),
    [anon_sym_throw] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1131),
    [anon_sym_case] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1133),
    [anon_sym_class] = ACTIONS(1133),
    [anon_sym_async] = ACTIONS(1133),
    [anon_sym_function] = ACTIONS(1133),
    [anon_sym_new] = ACTIONS(1133),
    [anon_sym_QMARK] = ACTIONS(1131),
    [anon_sym_AMP_AMP] = ACTIONS(1131),
    [anon_sym_PIPE_PIPE] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_GT_GT_GT] = ACTIONS(1131),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1131),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_PERCENT] = ACTIONS(1131),
    [anon_sym_STAR_STAR] = ACTIONS(1131),
    [anon_sym_LT_EQ] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1131),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1131),
    [anon_sym_GT_EQ] = ACTIONS(1131),
    [anon_sym_instanceof] = ACTIONS(1133),
    [anon_sym_BANG] = ACTIONS(1133),
    [anon_sym_TILDE] = ACTIONS(1131),
    [anon_sym_void] = ACTIONS(1133),
    [anon_sym_delete] = ACTIONS(1133),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [anon_sym_SQUOTE] = ACTIONS(1131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [sym_number] = ACTIONS(1131),
    [sym_this] = ACTIONS(1133),
    [sym_super] = ACTIONS(1133),
    [sym_true] = ACTIONS(1133),
    [sym_false] = ACTIONS(1133),
    [sym_null] = ACTIONS(1133),
    [sym_undefined] = ACTIONS(1133),
    [anon_sym_AT] = ACTIONS(1131),
    [anon_sym_static] = ACTIONS(1133),
    [anon_sym_abstract] = ACTIONS(1133),
    [anon_sym_get] = ACTIONS(1133),
    [anon_sym_set] = ACTIONS(1133),
    [anon_sym_declare] = ACTIONS(1133),
    [anon_sym_public] = ACTIONS(1133),
    [anon_sym_private] = ACTIONS(1133),
    [anon_sym_protected] = ACTIONS(1133),
    [anon_sym_module] = ACTIONS(1133),
    [anon_sym_any] = ACTIONS(1133),
    [anon_sym_number] = ACTIONS(1133),
    [anon_sym_boolean] = ACTIONS(1133),
    [anon_sym_string] = ACTIONS(1133),
    [anon_sym_symbol] = ACTIONS(1133),
    [anon_sym_interface] = ACTIONS(1133),
    [anon_sym_enum] = ACTIONS(1133),
    [sym__automatic_semicolon] = ACTIONS(1131),
  },
  [118] = {
    [ts_builtin_sym_end] = ACTIONS(1135),
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_export] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_default] = ACTIONS(1137),
    [anon_sym_as] = ACTIONS(1139),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1137),
    [anon_sym_typeof] = ACTIONS(1137),
    [anon_sym_import] = ACTIONS(1137),
    [anon_sym_var] = ACTIONS(1137),
    [anon_sym_let] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_await] = ACTIONS(1137),
    [anon_sym_in] = ACTIONS(1139),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_do] = ACTIONS(1137),
    [anon_sym_try] = ACTIONS(1137),
    [anon_sym_with] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_debugger] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_throw] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_case] = ACTIONS(1137),
    [anon_sym_yield] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_GT] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_class] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1137),
    [anon_sym_function] = ACTIONS(1137),
    [anon_sym_new] = ACTIONS(1137),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_AMP_AMP] = ACTIONS(1141),
    [anon_sym_PIPE_PIPE] = ACTIONS(1141),
    [anon_sym_GT_GT] = ACTIONS(1139),
    [anon_sym_GT_GT_GT] = ACTIONS(1141),
    [anon_sym_LT_LT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(1139),
    [anon_sym_CARET] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_PERCENT] = ACTIONS(1141),
    [anon_sym_STAR_STAR] = ACTIONS(1141),
    [anon_sym_LT_EQ] = ACTIONS(1141),
    [anon_sym_EQ_EQ] = ACTIONS(1139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1141),
    [anon_sym_BANG_EQ] = ACTIONS(1139),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1141),
    [anon_sym_GT_EQ] = ACTIONS(1141),
    [anon_sym_instanceof] = ACTIONS(1139),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_void] = ACTIONS(1137),
    [anon_sym_delete] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1135),
    [sym_this] = ACTIONS(1137),
    [sym_super] = ACTIONS(1137),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [sym_null] = ACTIONS(1137),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_abstract] = ACTIONS(1137),
    [anon_sym_get] = ACTIONS(1137),
    [anon_sym_set] = ACTIONS(1137),
    [anon_sym_declare] = ACTIONS(1137),
    [anon_sym_public] = ACTIONS(1137),
    [anon_sym_private] = ACTIONS(1137),
    [anon_sym_protected] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1137),
    [anon_sym_any] = ACTIONS(1137),
    [anon_sym_number] = ACTIONS(1137),
    [anon_sym_boolean] = ACTIONS(1137),
    [anon_sym_string] = ACTIONS(1137),
    [anon_sym_symbol] = ACTIONS(1137),
    [anon_sym_interface] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [sym__automatic_semicolon] = ACTIONS(1143),
  },
  [119] = {
    [ts_builtin_sym_end] = ACTIONS(1145),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(1147),
    [anon_sym_STAR] = ACTIONS(1149),
    [anon_sym_default] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(1149),
    [anon_sym_namespace] = ACTIONS(1147),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [anon_sym_COMMA] = ACTIONS(1151),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_type] = ACTIONS(1147),
    [anon_sym_typeof] = ACTIONS(1147),
    [anon_sym_import] = ACTIONS(1147),
    [anon_sym_var] = ACTIONS(1147),
    [anon_sym_let] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1147),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_else] = ACTIONS(1147),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_in] = ACTIONS(1149),
    [anon_sym_while] = ACTIONS(1147),
    [anon_sym_do] = ACTIONS(1147),
    [anon_sym_try] = ACTIONS(1147),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_break] = ACTIONS(1147),
    [anon_sym_continue] = ACTIONS(1147),
    [anon_sym_debugger] = ACTIONS(1147),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_throw] = ACTIONS(1147),
    [anon_sym_SEMI] = ACTIONS(1145),
    [anon_sym_case] = ACTIONS(1147),
    [anon_sym_yield] = ACTIONS(1147),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1149),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_class] = ACTIONS(1147),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(1147),
    [anon_sym_new] = ACTIONS(1147),
    [anon_sym_QMARK] = ACTIONS(1151),
    [anon_sym_AMP_AMP] = ACTIONS(1151),
    [anon_sym_PIPE_PIPE] = ACTIONS(1151),
    [anon_sym_GT_GT] = ACTIONS(1149),
    [anon_sym_GT_GT_GT] = ACTIONS(1151),
    [anon_sym_LT_LT] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(1151),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1151),
    [anon_sym_STAR_STAR] = ACTIONS(1151),
    [anon_sym_LT_EQ] = ACTIONS(1151),
    [anon_sym_EQ_EQ] = ACTIONS(1149),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1151),
    [anon_sym_BANG_EQ] = ACTIONS(1149),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1151),
    [anon_sym_GT_EQ] = ACTIONS(1151),
    [anon_sym_instanceof] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1145),
    [anon_sym_void] = ACTIONS(1147),
    [anon_sym_delete] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1145),
    [anon_sym_SQUOTE] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [sym_number] = ACTIONS(1145),
    [sym_this] = ACTIONS(1147),
    [sym_super] = ACTIONS(1147),
    [sym_true] = ACTIONS(1147),
    [sym_false] = ACTIONS(1147),
    [sym_null] = ACTIONS(1147),
    [sym_undefined] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(1145),
    [anon_sym_static] = ACTIONS(1147),
    [anon_sym_abstract] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(1147),
    [anon_sym_set] = ACTIONS(1147),
    [anon_sym_declare] = ACTIONS(1147),
    [anon_sym_public] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(1147),
    [anon_sym_protected] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(1147),
    [anon_sym_any] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(1147),
    [anon_sym_interface] = ACTIONS(1147),
    [anon_sym_enum] = ACTIONS(1147),
    [sym__automatic_semicolon] = ACTIONS(1153),
  },
  [120] = {
    [ts_builtin_sym_end] = ACTIONS(1155),
    [sym_identifier] = ACTIONS(1157),
    [anon_sym_export] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_default] = ACTIONS(1157),
    [anon_sym_as] = ACTIONS(1157),
    [anon_sym_namespace] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1155),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_type] = ACTIONS(1157),
    [anon_sym_typeof] = ACTIONS(1157),
    [anon_sym_import] = ACTIONS(1157),
    [anon_sym_var] = ACTIONS(1157),
    [anon_sym_let] = ACTIONS(1157),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1157),
    [anon_sym_else] = ACTIONS(1157),
    [anon_sym_switch] = ACTIONS(1157),
    [anon_sym_for] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_await] = ACTIONS(1157),
    [anon_sym_in] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1157),
    [anon_sym_do] = ACTIONS(1157),
    [anon_sym_try] = ACTIONS(1157),
    [anon_sym_with] = ACTIONS(1157),
    [anon_sym_break] = ACTIONS(1157),
    [anon_sym_continue] = ACTIONS(1157),
    [anon_sym_debugger] = ACTIONS(1157),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_throw] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym_case] = ACTIONS(1157),
    [anon_sym_yield] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(1157),
    [anon_sym_SLASH] = ACTIONS(1157),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_class] = ACTIONS(1157),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(1157),
    [anon_sym_QMARK] = ACTIONS(1155),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1157),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1155),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_STAR_STAR] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_instanceof] = ACTIONS(1157),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1155),
    [anon_sym_void] = ACTIONS(1157),
    [anon_sym_delete] = ACTIONS(1157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1155),
    [anon_sym_DASH_DASH] = ACTIONS(1155),
    [anon_sym_DQUOTE] = ACTIONS(1155),
    [anon_sym_SQUOTE] = ACTIONS(1155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1155),
    [sym_number] = ACTIONS(1155),
    [sym_this] = ACTIONS(1157),
    [sym_super] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_null] = ACTIONS(1157),
    [sym_undefined] = ACTIONS(1157),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(1157),
    [anon_sym_abstract] = ACTIONS(1157),
    [anon_sym_get] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(1157),
    [anon_sym_declare] = ACTIONS(1157),
    [anon_sym_public] = ACTIONS(1157),
    [anon_sym_private] = ACTIONS(1157),
    [anon_sym_protected] = ACTIONS(1157),
    [anon_sym_module] = ACTIONS(1157),
    [anon_sym_any] = ACTIONS(1157),
    [anon_sym_number] = ACTIONS(1157),
    [anon_sym_boolean] = ACTIONS(1157),
    [anon_sym_string] = ACTIONS(1157),
    [anon_sym_symbol] = ACTIONS(1157),
    [anon_sym_interface] = ACTIONS(1157),
    [anon_sym_enum] = ACTIONS(1157),
    [sym__automatic_semicolon] = ACTIONS(1155),
  },
  [121] = {
    [ts_builtin_sym_end] = ACTIONS(1159),
    [sym_identifier] = ACTIONS(1161),
    [anon_sym_export] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_default] = ACTIONS(1161),
    [anon_sym_as] = ACTIONS(1163),
    [anon_sym_namespace] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1165),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_type] = ACTIONS(1161),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_import] = ACTIONS(1161),
    [anon_sym_var] = ACTIONS(1161),
    [anon_sym_let] = ACTIONS(1161),
    [anon_sym_const] = ACTIONS(1161),
    [anon_sym_if] = ACTIONS(1161),
    [anon_sym_else] = ACTIONS(1161),
    [anon_sym_switch] = ACTIONS(1161),
    [anon_sym_for] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_await] = ACTIONS(1161),
    [anon_sym_in] = ACTIONS(1163),
    [anon_sym_while] = ACTIONS(1161),
    [anon_sym_do] = ACTIONS(1161),
    [anon_sym_try] = ACTIONS(1161),
    [anon_sym_with] = ACTIONS(1161),
    [anon_sym_break] = ACTIONS(1161),
    [anon_sym_continue] = ACTIONS(1161),
    [anon_sym_debugger] = ACTIONS(1161),
    [anon_sym_return] = ACTIONS(1161),
    [anon_sym_throw] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(1161),
    [anon_sym_LBRACK] = ACTIONS(1159),
    [anon_sym_LT] = ACTIONS(1161),
    [anon_sym_GT] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1161),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_class] = ACTIONS(1161),
    [anon_sym_async] = ACTIONS(1161),
    [anon_sym_function] = ACTIONS(1161),
    [anon_sym_new] = ACTIONS(1161),
    [anon_sym_QMARK] = ACTIONS(1165),
    [anon_sym_AMP_AMP] = ACTIONS(1165),
    [anon_sym_PIPE_PIPE] = ACTIONS(1165),
    [anon_sym_GT_GT] = ACTIONS(1163),
    [anon_sym_GT_GT_GT] = ACTIONS(1165),
    [anon_sym_LT_LT] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_CARET] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_STAR_STAR] = ACTIONS(1165),
    [anon_sym_LT_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ] = ACTIONS(1163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ] = ACTIONS(1163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1165),
    [anon_sym_GT_EQ] = ACTIONS(1165),
    [anon_sym_instanceof] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_TILDE] = ACTIONS(1159),
    [anon_sym_void] = ACTIONS(1161),
    [anon_sym_delete] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1159),
    [anon_sym_DASH_DASH] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_SQUOTE] = ACTIONS(1159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1159),
    [sym_number] = ACTIONS(1159),
    [sym_this] = ACTIONS(1161),
    [sym_super] = ACTIONS(1161),
    [sym_true] = ACTIONS(1161),
    [sym_false] = ACTIONS(1161),
    [sym_null] = ACTIONS(1161),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_AT] = ACTIONS(1159),
    [anon_sym_static] = ACTIONS(1161),
    [anon_sym_abstract] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(1161),
    [anon_sym_set] = ACTIONS(1161),
    [anon_sym_declare] = ACTIONS(1161),
    [anon_sym_public] = ACTIONS(1161),
    [anon_sym_private] = ACTIONS(1161),
    [anon_sym_protected] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(1161),
    [anon_sym_any] = ACTIONS(1161),
    [anon_sym_number] = ACTIONS(1161),
    [anon_sym_boolean] = ACTIONS(1161),
    [anon_sym_string] = ACTIONS(1161),
    [anon_sym_symbol] = ACTIONS(1161),
    [anon_sym_interface] = ACTIONS(1161),
    [anon_sym_enum] = ACTIONS(1161),
    [sym__automatic_semicolon] = ACTIONS(1167),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(1169),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_export] = ACTIONS(1171),
    [anon_sym_STAR] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1171),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_namespace] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(1169),
    [anon_sym_COMMA] = ACTIONS(1175),
    [anon_sym_RBRACE] = ACTIONS(1169),
    [anon_sym_type] = ACTIONS(1171),
    [anon_sym_typeof] = ACTIONS(1171),
    [anon_sym_import] = ACTIONS(1171),
    [anon_sym_var] = ACTIONS(1171),
    [anon_sym_let] = ACTIONS(1171),
    [anon_sym_const] = ACTIONS(1171),
    [anon_sym_if] = ACTIONS(1171),
    [anon_sym_else] = ACTIONS(1171),
    [anon_sym_switch] = ACTIONS(1171),
    [anon_sym_for] = ACTIONS(1171),
    [anon_sym_LPAREN] = ACTIONS(1169),
    [anon_sym_await] = ACTIONS(1171),
    [anon_sym_in] = ACTIONS(1173),
    [anon_sym_while] = ACTIONS(1171),
    [anon_sym_do] = ACTIONS(1171),
    [anon_sym_try] = ACTIONS(1171),
    [anon_sym_with] = ACTIONS(1171),
    [anon_sym_break] = ACTIONS(1171),
    [anon_sym_continue] = ACTIONS(1171),
    [anon_sym_debugger] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1171),
    [anon_sym_throw] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1169),
    [anon_sym_case] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_SLASH] = ACTIONS(1171),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_class] = ACTIONS(1171),
    [anon_sym_async] = ACTIONS(1171),
    [anon_sym_function] = ACTIONS(1171),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_QMARK] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1175),
    [anon_sym_LT_LT] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_PERCENT] = ACTIONS(1175),
    [anon_sym_STAR_STAR] = ACTIONS(1175),
    [anon_sym_LT_EQ] = ACTIONS(1175),
    [anon_sym_EQ_EQ] = ACTIONS(1173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1175),
    [anon_sym_BANG_EQ] = ACTIONS(1173),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1175),
    [anon_sym_GT_EQ] = ACTIONS(1175),
    [anon_sym_instanceof] = ACTIONS(1173),
    [anon_sym_BANG] = ACTIONS(1171),
    [anon_sym_TILDE] = ACTIONS(1169),
    [anon_sym_void] = ACTIONS(1171),
    [anon_sym_delete] = ACTIONS(1171),
    [anon_sym_PLUS_PLUS] = ACTIONS(1169),
    [anon_sym_DASH_DASH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1169),
    [anon_sym_SQUOTE] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1169),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_super] = ACTIONS(1171),
    [sym_true] = ACTIONS(1171),
    [sym_false] = ACTIONS(1171),
    [sym_null] = ACTIONS(1171),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(1169),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_abstract] = ACTIONS(1171),
    [anon_sym_get] = ACTIONS(1171),
    [anon_sym_set] = ACTIONS(1171),
    [anon_sym_declare] = ACTIONS(1171),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_any] = ACTIONS(1171),
    [anon_sym_number] = ACTIONS(1171),
    [anon_sym_boolean] = ACTIONS(1171),
    [anon_sym_string] = ACTIONS(1171),
    [anon_sym_symbol] = ACTIONS(1171),
    [anon_sym_interface] = ACTIONS(1171),
    [anon_sym_enum] = ACTIONS(1171),
    [sym__automatic_semicolon] = ACTIONS(1177),
  },
  [123] = {
    [ts_builtin_sym_end] = ACTIONS(1179),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(1181),
    [anon_sym_as] = ACTIONS(1183),
    [anon_sym_namespace] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1179),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_typeof] = ACTIONS(1181),
    [anon_sym_import] = ACTIONS(1181),
    [anon_sym_var] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_const] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1181),
    [anon_sym_else] = ACTIONS(1181),
    [anon_sym_switch] = ACTIONS(1181),
    [anon_sym_for] = ACTIONS(1181),
    [anon_sym_LPAREN] = ACTIONS(1179),
    [anon_sym_await] = ACTIONS(1181),
    [anon_sym_in] = ACTIONS(1183),
    [anon_sym_while] = ACTIONS(1181),
    [anon_sym_do] = ACTIONS(1181),
    [anon_sym_try] = ACTIONS(1181),
    [anon_sym_with] = ACTIONS(1181),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_continue] = ACTIONS(1181),
    [anon_sym_debugger] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1181),
    [anon_sym_throw] = ACTIONS(1181),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_case] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(1181),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(1181),
    [anon_sym_async] = ACTIONS(1181),
    [anon_sym_function] = ACTIONS(1181),
    [anon_sym_new] = ACTIONS(1181),
    [anon_sym_QMARK] = ACTIONS(1185),
    [anon_sym_AMP_AMP] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_GT_GT] = ACTIONS(1183),
    [anon_sym_GT_GT_GT] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(1185),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1185),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_PERCENT] = ACTIONS(1185),
    [anon_sym_STAR_STAR] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1185),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1185),
    [anon_sym_GT_EQ] = ACTIONS(1185),
    [anon_sym_instanceof] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(1181),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_void] = ACTIONS(1181),
    [anon_sym_delete] = ACTIONS(1181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1179),
    [anon_sym_SQUOTE] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_super] = ACTIONS(1181),
    [sym_true] = ACTIONS(1181),
    [sym_false] = ACTIONS(1181),
    [sym_null] = ACTIONS(1181),
    [sym_undefined] = ACTIONS(1181),
    [anon_sym_AT] = ACTIONS(1179),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_abstract] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_interface] = ACTIONS(1181),
    [anon_sym_enum] = ACTIONS(1181),
    [sym__automatic_semicolon] = ACTIONS(1187),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(1189),
    [sym_identifier] = ACTIONS(1191),
    [anon_sym_export] = ACTIONS(1191),
    [anon_sym_STAR] = ACTIONS(1193),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_as] = ACTIONS(1193),
    [anon_sym_namespace] = ACTIONS(1191),
    [anon_sym_LBRACE] = ACTIONS(1189),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_type] = ACTIONS(1191),
    [anon_sym_typeof] = ACTIONS(1191),
    [anon_sym_import] = ACTIONS(1191),
    [anon_sym_var] = ACTIONS(1191),
    [anon_sym_let] = ACTIONS(1191),
    [anon_sym_const] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1191),
    [anon_sym_switch] = ACTIONS(1191),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_LPAREN] = ACTIONS(1189),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(1193),
    [anon_sym_while] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(1191),
    [anon_sym_try] = ACTIONS(1191),
    [anon_sym_with] = ACTIONS(1191),
    [anon_sym_break] = ACTIONS(1191),
    [anon_sym_continue] = ACTIONS(1191),
    [anon_sym_debugger] = ACTIONS(1191),
    [anon_sym_return] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1191),
    [anon_sym_SEMI] = ACTIONS(1189),
    [anon_sym_case] = ACTIONS(1191),
    [anon_sym_yield] = ACTIONS(1191),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LT] = ACTIONS(1191),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1191),
    [anon_sym_DOT] = ACTIONS(1193),
    [anon_sym_class] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1191),
    [anon_sym_function] = ACTIONS(1191),
    [anon_sym_new] = ACTIONS(1191),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1193),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1193),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1191),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1191),
    [anon_sym_delete] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1189),
    [anon_sym_DASH_DASH] = ACTIONS(1189),
    [anon_sym_DQUOTE] = ACTIONS(1189),
    [anon_sym_SQUOTE] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1189),
    [sym_number] = ACTIONS(1189),
    [sym_this] = ACTIONS(1191),
    [sym_super] = ACTIONS(1191),
    [sym_true] = ACTIONS(1191),
    [sym_false] = ACTIONS(1191),
    [sym_null] = ACTIONS(1191),
    [sym_undefined] = ACTIONS(1191),
    [anon_sym_AT] = ACTIONS(1189),
    [anon_sym_static] = ACTIONS(1191),
    [anon_sym_abstract] = ACTIONS(1191),
    [anon_sym_get] = ACTIONS(1191),
    [anon_sym_set] = ACTIONS(1191),
    [anon_sym_declare] = ACTIONS(1191),
    [anon_sym_public] = ACTIONS(1191),
    [anon_sym_private] = ACTIONS(1191),
    [anon_sym_protected] = ACTIONS(1191),
    [anon_sym_module] = ACTIONS(1191),
    [anon_sym_any] = ACTIONS(1191),
    [anon_sym_number] = ACTIONS(1191),
    [anon_sym_boolean] = ACTIONS(1191),
    [anon_sym_string] = ACTIONS(1191),
    [anon_sym_symbol] = ACTIONS(1191),
    [anon_sym_interface] = ACTIONS(1191),
    [anon_sym_enum] = ACTIONS(1191),
    [sym__automatic_semicolon] = ACTIONS(1197),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_export] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_type] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym_import] = ACTIONS(1201),
    [anon_sym_var] = ACTIONS(1201),
    [anon_sym_let] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_try] = ACTIONS(1201),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_debugger] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_throw] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_yield] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(1201),
    [anon_sym_new] = ACTIONS(1201),
    [anon_sym_QMARK] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_CARET] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1201),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_instanceof] = ACTIONS(1201),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_void] = ACTIONS(1201),
    [anon_sym_delete] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [sym_number] = ACTIONS(1199),
    [sym_this] = ACTIONS(1201),
    [sym_super] = ACTIONS(1201),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [sym_null] = ACTIONS(1201),
    [sym_undefined] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_abstract] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1201),
    [anon_sym_declare] = ACTIONS(1201),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1201),
    [anon_sym_any] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1201),
    [anon_sym_symbol] = ACTIONS(1201),
    [anon_sym_interface] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [sym__automatic_semicolon] = ACTIONS(1199),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(1203),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_as] = ACTIONS(1207),
    [anon_sym_namespace] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1203),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1205),
    [anon_sym_var] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_else] = ACTIONS(1205),
    [anon_sym_switch] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_while] = ACTIONS(1205),
    [anon_sym_do] = ACTIONS(1205),
    [anon_sym_try] = ACTIONS(1205),
    [anon_sym_with] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_debugger] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_throw] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1203),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1203),
    [anon_sym_LT] = ACTIONS(1205),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1205),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_class] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_function] = ACTIONS(1205),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1205),
    [anon_sym_DASH] = ACTIONS(1205),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1203),
    [anon_sym_void] = ACTIONS(1205),
    [anon_sym_delete] = ACTIONS(1205),
    [anon_sym_PLUS_PLUS] = ACTIONS(1203),
    [anon_sym_DASH_DASH] = ACTIONS(1203),
    [anon_sym_DQUOTE] = ACTIONS(1203),
    [anon_sym_SQUOTE] = ACTIONS(1203),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1203),
    [sym_number] = ACTIONS(1203),
    [sym_this] = ACTIONS(1205),
    [sym_super] = ACTIONS(1205),
    [sym_true] = ACTIONS(1205),
    [sym_false] = ACTIONS(1205),
    [sym_null] = ACTIONS(1205),
    [sym_undefined] = ACTIONS(1205),
    [anon_sym_AT] = ACTIONS(1203),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_abstract] = ACTIONS(1205),
    [anon_sym_get] = ACTIONS(1205),
    [anon_sym_set] = ACTIONS(1205),
    [anon_sym_declare] = ACTIONS(1205),
    [anon_sym_public] = ACTIONS(1205),
    [anon_sym_private] = ACTIONS(1205),
    [anon_sym_protected] = ACTIONS(1205),
    [anon_sym_module] = ACTIONS(1205),
    [anon_sym_any] = ACTIONS(1205),
    [anon_sym_number] = ACTIONS(1205),
    [anon_sym_boolean] = ACTIONS(1205),
    [anon_sym_string] = ACTIONS(1205),
    [anon_sym_symbol] = ACTIONS(1205),
    [anon_sym_interface] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(1211),
    [sym_identifier] = ACTIONS(1213),
    [anon_sym_export] = ACTIONS(1213),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_default] = ACTIONS(1213),
    [anon_sym_as] = ACTIONS(1215),
    [anon_sym_namespace] = ACTIONS(1213),
    [anon_sym_LBRACE] = ACTIONS(1211),
    [anon_sym_COMMA] = ACTIONS(1217),
    [anon_sym_RBRACE] = ACTIONS(1211),
    [anon_sym_type] = ACTIONS(1213),
    [anon_sym_typeof] = ACTIONS(1213),
    [anon_sym_import] = ACTIONS(1213),
    [anon_sym_var] = ACTIONS(1213),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1213),
    [anon_sym_if] = ACTIONS(1213),
    [anon_sym_else] = ACTIONS(1213),
    [anon_sym_switch] = ACTIONS(1213),
    [anon_sym_for] = ACTIONS(1213),
    [anon_sym_LPAREN] = ACTIONS(1211),
    [anon_sym_await] = ACTIONS(1213),
    [anon_sym_in] = ACTIONS(1215),
    [anon_sym_while] = ACTIONS(1213),
    [anon_sym_do] = ACTIONS(1213),
    [anon_sym_try] = ACTIONS(1213),
    [anon_sym_with] = ACTIONS(1213),
    [anon_sym_break] = ACTIONS(1213),
    [anon_sym_continue] = ACTIONS(1213),
    [anon_sym_debugger] = ACTIONS(1213),
    [anon_sym_return] = ACTIONS(1213),
    [anon_sym_throw] = ACTIONS(1213),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym_case] = ACTIONS(1213),
    [anon_sym_yield] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(1213),
    [anon_sym_GT] = ACTIONS(1215),
    [anon_sym_SLASH] = ACTIONS(1213),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_class] = ACTIONS(1213),
    [anon_sym_async] = ACTIONS(1213),
    [anon_sym_function] = ACTIONS(1213),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_QMARK] = ACTIONS(1217),
    [anon_sym_AMP_AMP] = ACTIONS(1217),
    [anon_sym_PIPE_PIPE] = ACTIONS(1217),
    [anon_sym_GT_GT] = ACTIONS(1215),
    [anon_sym_GT_GT_GT] = ACTIONS(1217),
    [anon_sym_LT_LT] = ACTIONS(1217),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1217),
    [anon_sym_PIPE] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_DASH] = ACTIONS(1213),
    [anon_sym_PERCENT] = ACTIONS(1217),
    [anon_sym_STAR_STAR] = ACTIONS(1217),
    [anon_sym_LT_EQ] = ACTIONS(1217),
    [anon_sym_EQ_EQ] = ACTIONS(1215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1217),
    [anon_sym_BANG_EQ] = ACTIONS(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1217),
    [anon_sym_GT_EQ] = ACTIONS(1217),
    [anon_sym_instanceof] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1211),
    [anon_sym_void] = ACTIONS(1213),
    [anon_sym_delete] = ACTIONS(1213),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1211),
    [sym_number] = ACTIONS(1211),
    [sym_this] = ACTIONS(1213),
    [sym_super] = ACTIONS(1213),
    [sym_true] = ACTIONS(1213),
    [sym_false] = ACTIONS(1213),
    [sym_null] = ACTIONS(1213),
    [sym_undefined] = ACTIONS(1213),
    [anon_sym_AT] = ACTIONS(1211),
    [anon_sym_static] = ACTIONS(1213),
    [anon_sym_abstract] = ACTIONS(1213),
    [anon_sym_get] = ACTIONS(1213),
    [anon_sym_set] = ACTIONS(1213),
    [anon_sym_declare] = ACTIONS(1213),
    [anon_sym_public] = ACTIONS(1213),
    [anon_sym_private] = ACTIONS(1213),
    [anon_sym_protected] = ACTIONS(1213),
    [anon_sym_module] = ACTIONS(1213),
    [anon_sym_any] = ACTIONS(1213),
    [anon_sym_number] = ACTIONS(1213),
    [anon_sym_boolean] = ACTIONS(1213),
    [anon_sym_string] = ACTIONS(1213),
    [anon_sym_symbol] = ACTIONS(1213),
    [anon_sym_interface] = ACTIONS(1213),
    [anon_sym_enum] = ACTIONS(1213),
    [sym__automatic_semicolon] = ACTIONS(1219),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(1221),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1223),
    [anon_sym_STAR] = ACTIONS(1225),
    [anon_sym_default] = ACTIONS(1223),
    [anon_sym_as] = ACTIONS(1225),
    [anon_sym_namespace] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_RBRACE] = ACTIONS(1221),
    [anon_sym_type] = ACTIONS(1223),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_import] = ACTIONS(1223),
    [anon_sym_var] = ACTIONS(1223),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_const] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_switch] = ACTIONS(1223),
    [anon_sym_for] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1221),
    [anon_sym_await] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1225),
    [anon_sym_while] = ACTIONS(1223),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_try] = ACTIONS(1223),
    [anon_sym_with] = ACTIONS(1223),
    [anon_sym_break] = ACTIONS(1223),
    [anon_sym_continue] = ACTIONS(1223),
    [anon_sym_debugger] = ACTIONS(1223),
    [anon_sym_return] = ACTIONS(1223),
    [anon_sym_throw] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1221),
    [anon_sym_case] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_class] = ACTIONS(1223),
    [anon_sym_async] = ACTIONS(1223),
    [anon_sym_function] = ACTIONS(1223),
    [anon_sym_new] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1225),
    [anon_sym_GT_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_DASH] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1227),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_instanceof] = ACTIONS(1225),
    [anon_sym_BANG] = ACTIONS(1223),
    [anon_sym_TILDE] = ACTIONS(1221),
    [anon_sym_void] = ACTIONS(1223),
    [anon_sym_delete] = ACTIONS(1223),
    [anon_sym_PLUS_PLUS] = ACTIONS(1221),
    [anon_sym_DASH_DASH] = ACTIONS(1221),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1221),
    [sym_number] = ACTIONS(1221),
    [sym_this] = ACTIONS(1223),
    [sym_super] = ACTIONS(1223),
    [sym_true] = ACTIONS(1223),
    [sym_false] = ACTIONS(1223),
    [sym_null] = ACTIONS(1223),
    [sym_undefined] = ACTIONS(1223),
    [anon_sym_AT] = ACTIONS(1221),
    [anon_sym_static] = ACTIONS(1223),
    [anon_sym_abstract] = ACTIONS(1223),
    [anon_sym_get] = ACTIONS(1223),
    [anon_sym_set] = ACTIONS(1223),
    [anon_sym_declare] = ACTIONS(1223),
    [anon_sym_public] = ACTIONS(1223),
    [anon_sym_private] = ACTIONS(1223),
    [anon_sym_protected] = ACTIONS(1223),
    [anon_sym_module] = ACTIONS(1223),
    [anon_sym_any] = ACTIONS(1223),
    [anon_sym_number] = ACTIONS(1223),
    [anon_sym_boolean] = ACTIONS(1223),
    [anon_sym_string] = ACTIONS(1223),
    [anon_sym_symbol] = ACTIONS(1223),
    [anon_sym_interface] = ACTIONS(1223),
    [anon_sym_enum] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1229),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_export] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_type] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym_import] = ACTIONS(1201),
    [anon_sym_var] = ACTIONS(1201),
    [anon_sym_let] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_try] = ACTIONS(1201),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_debugger] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_throw] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_yield] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(1201),
    [anon_sym_new] = ACTIONS(1201),
    [anon_sym_QMARK] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_CARET] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1201),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_instanceof] = ACTIONS(1201),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_void] = ACTIONS(1201),
    [anon_sym_delete] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [sym_number] = ACTIONS(1199),
    [sym_this] = ACTIONS(1201),
    [sym_super] = ACTIONS(1201),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [sym_null] = ACTIONS(1201),
    [sym_undefined] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_abstract] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1201),
    [anon_sym_declare] = ACTIONS(1201),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1201),
    [anon_sym_any] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1201),
    [anon_sym_symbol] = ACTIONS(1201),
    [anon_sym_interface] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [sym__automatic_semicolon] = ACTIONS(1231),
  },
  [130] = {
    [ts_builtin_sym_end] = ACTIONS(1233),
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_export] = ACTIONS(1235),
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1235),
    [anon_sym_as] = ACTIONS(1237),
    [anon_sym_namespace] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_type] = ACTIONS(1235),
    [anon_sym_typeof] = ACTIONS(1235),
    [anon_sym_import] = ACTIONS(1235),
    [anon_sym_var] = ACTIONS(1235),
    [anon_sym_let] = ACTIONS(1235),
    [anon_sym_const] = ACTIONS(1235),
    [anon_sym_if] = ACTIONS(1235),
    [anon_sym_else] = ACTIONS(1235),
    [anon_sym_switch] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_await] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1235),
    [anon_sym_do] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1235),
    [anon_sym_with] = ACTIONS(1235),
    [anon_sym_break] = ACTIONS(1235),
    [anon_sym_continue] = ACTIONS(1235),
    [anon_sym_debugger] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1235),
    [anon_sym_throw] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1235),
    [anon_sym_yield] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1237),
    [anon_sym_class] = ACTIONS(1235),
    [anon_sym_async] = ACTIONS(1235),
    [anon_sym_function] = ACTIONS(1235),
    [anon_sym_new] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1239),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_GT_GT_GT] = ACTIONS(1239),
    [anon_sym_LT_LT] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1239),
    [anon_sym_STAR_STAR] = ACTIONS(1239),
    [anon_sym_LT_EQ] = ACTIONS(1239),
    [anon_sym_EQ_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1239),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1239),
    [anon_sym_GT_EQ] = ACTIONS(1239),
    [anon_sym_instanceof] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1233),
    [anon_sym_void] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [anon_sym_DQUOTE] = ACTIONS(1233),
    [anon_sym_SQUOTE] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1233),
    [sym_number] = ACTIONS(1233),
    [sym_this] = ACTIONS(1235),
    [sym_super] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_null] = ACTIONS(1235),
    [sym_undefined] = ACTIONS(1235),
    [anon_sym_AT] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1235),
    [anon_sym_abstract] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(1235),
    [anon_sym_set] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1235),
    [anon_sym_public] = ACTIONS(1235),
    [anon_sym_private] = ACTIONS(1235),
    [anon_sym_protected] = ACTIONS(1235),
    [anon_sym_module] = ACTIONS(1235),
    [anon_sym_any] = ACTIONS(1235),
    [anon_sym_number] = ACTIONS(1235),
    [anon_sym_boolean] = ACTIONS(1235),
    [anon_sym_string] = ACTIONS(1235),
    [anon_sym_symbol] = ACTIONS(1235),
    [anon_sym_interface] = ACTIONS(1235),
    [anon_sym_enum] = ACTIONS(1235),
    [sym__automatic_semicolon] = ACTIONS(1241),
  },
  [131] = {
    [sym_import] = STATE(1033),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1033),
    [sym_yield_expression] = STATE(1033),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1462),
    [sym_class] = STATE(1033),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1033),
    [sym_arrow_function] = STATE(1033),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1033),
    [sym_new_expression] = STATE(1033),
    [sym_await_expression] = STATE(1033),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1033),
    [sym_augmented_assignment_expression] = STATE(1033),
    [sym_ternary_expression] = STATE(1033),
    [sym_binary_expression] = STATE(1033),
    [sym_unary_expression] = STATE(1033),
    [sym_update_expression] = STATE(1033),
    [sym_sequence_expression] = STATE(2831),
    [sym_string] = STATE(1033),
    [sym_template_string] = STATE(1033),
    [sym_regex] = STATE(1033),
    [sym_meta_property] = STATE(1033),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_rest_parameter] = STATE(2459),
    [sym_non_null_expression] = STATE(1033),
    [sym_type_assertion] = STATE(1033),
    [sym_as_expression] = STATE(1033),
    [sym_internal_module] = STATE(1033),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2459),
    [sym_optional_parameter] = STATE(2459),
    [sym__parameter_name] = STATE(1975),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(1642),
    [sym_identifier] = ACTIONS(1243),
    [anon_sym_export] = ACTIONS(765),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(1245),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1247),
    [sym_this] = ACTIONS(1249),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(803),
    [sym_false] = ACTIONS(803),
    [sym_null] = ACTIONS(803),
    [sym_undefined] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(765),
    [anon_sym_get] = ACTIONS(765),
    [anon_sym_set] = ACTIONS(765),
    [anon_sym_declare] = ACTIONS(765),
    [anon_sym_public] = ACTIONS(807),
    [anon_sym_private] = ACTIONS(807),
    [anon_sym_protected] = ACTIONS(807),
    [anon_sym_module] = ACTIONS(765),
    [anon_sym_any] = ACTIONS(765),
    [anon_sym_number] = ACTIONS(765),
    [anon_sym_boolean] = ACTIONS(765),
    [anon_sym_string] = ACTIONS(765),
    [anon_sym_symbol] = ACTIONS(765),
    [sym_readonly] = ACTIONS(811),
  },
  [132] = {
    [sym_import] = STATE(1202),
    [sym_expression_statement] = STATE(151),
    [sym_variable_declaration] = STATE(151),
    [sym_lexical_declaration] = STATE(151),
    [sym_empty_statement] = STATE(151),
    [sym_parenthesized_expression] = STATE(831),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1285),
    [sym_array] = STATE(1287),
    [sym_class] = STATE(1202),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1202),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(831),
    [sym_subscript_expression] = STATE(831),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_internal_module] = STATE(1202),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(1251),
    [anon_sym_export] = ACTIONS(1253),
    [anon_sym_namespace] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1253),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_var] = ACTIONS(1257),
    [anon_sym_let] = ACTIONS(1259),
    [anon_sym_const] = ACTIONS(1259),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1261),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1263),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_get] = ACTIONS(1253),
    [anon_sym_set] = ACTIONS(1253),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_public] = ACTIONS(1253),
    [anon_sym_private] = ACTIONS(1253),
    [anon_sym_protected] = ACTIONS(1253),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_any] = ACTIONS(1253),
    [anon_sym_number] = ACTIONS(1253),
    [anon_sym_boolean] = ACTIONS(1253),
    [anon_sym_string] = ACTIONS(1253),
    [anon_sym_symbol] = ACTIONS(1253),
  },
  [133] = {
    [sym_import] = STATE(1108),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1108),
    [sym_yield_expression] = STATE(1108),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1462),
    [sym_class] = STATE(1108),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1108),
    [sym_arrow_function] = STATE(1108),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1108),
    [sym_new_expression] = STATE(1108),
    [sym_await_expression] = STATE(1108),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1108),
    [sym_augmented_assignment_expression] = STATE(1108),
    [sym_ternary_expression] = STATE(1108),
    [sym_binary_expression] = STATE(1108),
    [sym_unary_expression] = STATE(1108),
    [sym_update_expression] = STATE(1108),
    [sym_sequence_expression] = STATE(2796),
    [sym_string] = STATE(1108),
    [sym_template_string] = STATE(1108),
    [sym_regex] = STATE(1108),
    [sym_meta_property] = STATE(1108),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_rest_parameter] = STATE(2459),
    [sym_non_null_expression] = STATE(1108),
    [sym_type_assertion] = STATE(1108),
    [sym_as_expression] = STATE(1108),
    [sym_internal_module] = STATE(1108),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2459),
    [sym_optional_parameter] = STATE(2459),
    [sym__parameter_name] = STATE(1975),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(1642),
    [sym_identifier] = ACTIONS(1243),
    [anon_sym_export] = ACTIONS(765),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(1245),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1265),
    [sym_this] = ACTIONS(1249),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(817),
    [sym_false] = ACTIONS(817),
    [sym_null] = ACTIONS(817),
    [sym_undefined] = ACTIONS(817),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(765),
    [anon_sym_get] = ACTIONS(765),
    [anon_sym_set] = ACTIONS(765),
    [anon_sym_declare] = ACTIONS(765),
    [anon_sym_public] = ACTIONS(807),
    [anon_sym_private] = ACTIONS(807),
    [anon_sym_protected] = ACTIONS(807),
    [anon_sym_module] = ACTIONS(765),
    [anon_sym_any] = ACTIONS(765),
    [anon_sym_number] = ACTIONS(765),
    [anon_sym_boolean] = ACTIONS(765),
    [anon_sym_string] = ACTIONS(765),
    [anon_sym_symbol] = ACTIONS(765),
    [sym_readonly] = ACTIONS(811),
  },
  [134] = {
    [sym_import] = STATE(1202),
    [sym_expression_statement] = STATE(149),
    [sym_variable_declaration] = STATE(149),
    [sym_lexical_declaration] = STATE(149),
    [sym_empty_statement] = STATE(149),
    [sym_parenthesized_expression] = STATE(831),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1285),
    [sym_array] = STATE(1287),
    [sym_class] = STATE(1202),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1202),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(831),
    [sym_subscript_expression] = STATE(831),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_internal_module] = STATE(1202),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(1251),
    [anon_sym_export] = ACTIONS(1253),
    [anon_sym_namespace] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1253),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_var] = ACTIONS(1257),
    [anon_sym_let] = ACTIONS(1259),
    [anon_sym_const] = ACTIONS(1259),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1261),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1263),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_get] = ACTIONS(1253),
    [anon_sym_set] = ACTIONS(1253),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_public] = ACTIONS(1253),
    [anon_sym_private] = ACTIONS(1253),
    [anon_sym_protected] = ACTIONS(1253),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_any] = ACTIONS(1253),
    [anon_sym_number] = ACTIONS(1253),
    [anon_sym_boolean] = ACTIONS(1253),
    [anon_sym_string] = ACTIONS(1253),
    [anon_sym_symbol] = ACTIONS(1253),
  },
  [135] = {
    [sym_import] = STATE(1114),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1114),
    [sym_yield_expression] = STATE(1114),
    [sym_object] = STATE(1460),
    [sym_array] = STATE(1462),
    [sym_class] = STATE(1114),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1114),
    [sym_arrow_function] = STATE(1114),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1114),
    [sym_new_expression] = STATE(1114),
    [sym_await_expression] = STATE(1114),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1114),
    [sym_augmented_assignment_expression] = STATE(1114),
    [sym_ternary_expression] = STATE(1114),
    [sym_binary_expression] = STATE(1114),
    [sym_unary_expression] = STATE(1114),
    [sym_update_expression] = STATE(1114),
    [sym_sequence_expression] = STATE(2748),
    [sym_string] = STATE(1114),
    [sym_template_string] = STATE(1114),
    [sym_regex] = STATE(1114),
    [sym_meta_property] = STATE(1114),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_rest_parameter] = STATE(2459),
    [sym_non_null_expression] = STATE(1114),
    [sym_type_assertion] = STATE(1114),
    [sym_as_expression] = STATE(1114),
    [sym_internal_module] = STATE(1114),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2459),
    [sym_optional_parameter] = STATE(2459),
    [sym__parameter_name] = STATE(1975),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(1642),
    [sym_identifier] = ACTIONS(1243),
    [anon_sym_export] = ACTIONS(765),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(1245),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1267),
    [sym_this] = ACTIONS(1249),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(819),
    [sym_false] = ACTIONS(819),
    [sym_null] = ACTIONS(819),
    [sym_undefined] = ACTIONS(819),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(765),
    [anon_sym_get] = ACTIONS(765),
    [anon_sym_set] = ACTIONS(765),
    [anon_sym_declare] = ACTIONS(765),
    [anon_sym_public] = ACTIONS(807),
    [anon_sym_private] = ACTIONS(807),
    [anon_sym_protected] = ACTIONS(807),
    [anon_sym_module] = ACTIONS(765),
    [anon_sym_any] = ACTIONS(765),
    [anon_sym_number] = ACTIONS(765),
    [anon_sym_boolean] = ACTIONS(765),
    [anon_sym_string] = ACTIONS(765),
    [anon_sym_symbol] = ACTIONS(765),
    [sym_readonly] = ACTIONS(811),
  },
  [136] = {
    [sym_import] = STATE(1175),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1175),
    [sym_yield_expression] = STATE(1175),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1175),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1175),
    [sym_arrow_function] = STATE(1175),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1175),
    [sym_new_expression] = STATE(1175),
    [sym_await_expression] = STATE(1175),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1175),
    [sym_augmented_assignment_expression] = STATE(1175),
    [sym_spread_element] = STATE(2505),
    [sym_ternary_expression] = STATE(1175),
    [sym_binary_expression] = STATE(1175),
    [sym_unary_expression] = STATE(1175),
    [sym_update_expression] = STATE(1175),
    [sym_string] = STATE(1175),
    [sym_template_string] = STATE(1175),
    [sym_regex] = STATE(1175),
    [sym_meta_property] = STATE(1175),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1175),
    [sym_as_expression] = STATE(1175),
    [sym_internal_module] = STATE(1175),
    [sym_mapped_type_clause] = STATE(2875),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [aux_sym_array_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(1269),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(829),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1275),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(1277),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1279),
    [sym_this] = ACTIONS(1281),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1281),
    [sym_false] = ACTIONS(1281),
    [sym_null] = ACTIONS(1281),
    [sym_undefined] = ACTIONS(1281),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [137] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1168),
    [sym_yield_expression] = STATE(1168),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1168),
    [sym_await_expression] = STATE(1168),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1168),
    [sym_augmented_assignment_expression] = STATE(1168),
    [sym_spread_element] = STATE(2444),
    [sym_ternary_expression] = STATE(1168),
    [sym_binary_expression] = STATE(1168),
    [sym_unary_expression] = STATE(1168),
    [sym_update_expression] = STATE(1168),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1168),
    [sym_type_assertion] = STATE(1168),
    [sym_as_expression] = STATE(1168),
    [sym_internal_module] = STATE(1168),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [aux_sym_array_repeat1] = STATE(2439),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1283),
    [sym_this] = ACTIONS(847),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(847),
    [sym_false] = ACTIONS(847),
    [sym_null] = ACTIONS(847),
    [sym_undefined] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [138] = {
    [sym_import] = STATE(1350),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1350),
    [sym_yield_expression] = STATE(1350),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1350),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1350),
    [sym_arrow_function] = STATE(1350),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1350),
    [sym_new_expression] = STATE(1350),
    [sym_await_expression] = STATE(1350),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1350),
    [sym_augmented_assignment_expression] = STATE(1350),
    [sym_spread_element] = STATE(2486),
    [sym_ternary_expression] = STATE(1350),
    [sym_binary_expression] = STATE(1350),
    [sym_unary_expression] = STATE(1350),
    [sym_update_expression] = STATE(1350),
    [sym_sequence_expression] = STATE(2329),
    [sym_string] = STATE(1350),
    [sym_template_string] = STATE(1350),
    [sym_regex] = STATE(1350),
    [sym_meta_property] = STATE(1350),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1350),
    [sym_type_assertion] = STATE(1350),
    [sym_as_expression] = STATE(1350),
    [sym_internal_module] = STATE(1350),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(1285),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1287),
    [sym_this] = ACTIONS(1289),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1289),
    [sym_false] = ACTIONS(1289),
    [sym_null] = ACTIONS(1289),
    [sym_undefined] = ACTIONS(1289),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [139] = {
    [sym_import] = STATE(1176),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1176),
    [sym_yield_expression] = STATE(1176),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1176),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1176),
    [sym_arrow_function] = STATE(1176),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1176),
    [sym_new_expression] = STATE(1176),
    [sym_await_expression] = STATE(1176),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1176),
    [sym_augmented_assignment_expression] = STATE(1176),
    [sym_spread_element] = STATE(2505),
    [sym_ternary_expression] = STATE(1176),
    [sym_binary_expression] = STATE(1176),
    [sym_unary_expression] = STATE(1176),
    [sym_update_expression] = STATE(1176),
    [sym_string] = STATE(1176),
    [sym_template_string] = STATE(1176),
    [sym_regex] = STATE(1176),
    [sym_meta_property] = STATE(1176),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1176),
    [sym_as_expression] = STATE(1176),
    [sym_internal_module] = STATE(1176),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [aux_sym_array_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(829),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1291),
    [sym_this] = ACTIONS(1293),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [sym_null] = ACTIONS(1293),
    [sym_undefined] = ACTIONS(1293),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [140] = {
    [sym_import] = STATE(1139),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1139),
    [sym_yield_expression] = STATE(1139),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1139),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1139),
    [sym_arrow_function] = STATE(1139),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1139),
    [sym_new_expression] = STATE(1139),
    [sym_await_expression] = STATE(1139),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1139),
    [sym_augmented_assignment_expression] = STATE(1139),
    [sym_spread_element] = STATE(2471),
    [sym_ternary_expression] = STATE(1139),
    [sym_binary_expression] = STATE(1139),
    [sym_unary_expression] = STATE(1139),
    [sym_update_expression] = STATE(1139),
    [sym_string] = STATE(1139),
    [sym_template_string] = STATE(1139),
    [sym_regex] = STATE(1139),
    [sym_meta_property] = STATE(1139),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1139),
    [sym_type_assertion] = STATE(1139),
    [sym_as_expression] = STATE(1139),
    [sym_internal_module] = STATE(1139),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [aux_sym_array_repeat1] = STATE(2472),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(1295),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1299),
    [sym_false] = ACTIONS(1299),
    [sym_null] = ACTIONS(1299),
    [sym_undefined] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [141] = {
    [sym_import] = STATE(1218),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1218),
    [sym_yield_expression] = STATE(1218),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1218),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1218),
    [sym_arrow_function] = STATE(1218),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1218),
    [sym_new_expression] = STATE(1218),
    [sym_await_expression] = STATE(1218),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1218),
    [sym_augmented_assignment_expression] = STATE(1218),
    [sym_spread_element] = STATE(2520),
    [sym_ternary_expression] = STATE(1218),
    [sym_binary_expression] = STATE(1218),
    [sym_unary_expression] = STATE(1218),
    [sym_update_expression] = STATE(1218),
    [sym_string] = STATE(1218),
    [sym_template_string] = STATE(1218),
    [sym_regex] = STATE(1218),
    [sym_meta_property] = STATE(1218),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1218),
    [sym_type_assertion] = STATE(1218),
    [sym_as_expression] = STATE(1218),
    [sym_internal_module] = STATE(1218),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [aux_sym_array_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(849),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1301),
    [sym_this] = ACTIONS(1303),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1303),
    [sym_false] = ACTIONS(1303),
    [sym_null] = ACTIONS(1303),
    [sym_undefined] = ACTIONS(1303),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [142] = {
    [sym_import] = STATE(1224),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1224),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1224),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_spread_element] = STATE(2520),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1224),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_internal_module] = STATE(1224),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [aux_sym_array_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(849),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1305),
    [sym_this] = ACTIONS(851),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(851),
    [sym_false] = ACTIONS(851),
    [sym_null] = ACTIONS(851),
    [sym_undefined] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [143] = {
    [sym_import] = STATE(1146),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1146),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1146),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1146),
    [sym_arrow_function] = STATE(1146),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1146),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1146),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2424),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1146),
    [sym_template_string] = STATE(1146),
    [sym_regex] = STATE(1146),
    [sym_meta_property] = STATE(1146),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1146),
    [sym_type_assertion] = STATE(1146),
    [sym_as_expression] = STATE(1146),
    [sym_internal_module] = STATE(1146),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [aux_sym_array_repeat1] = STATE(2421),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(1307),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1311),
    [sym_false] = ACTIONS(1311),
    [sym_null] = ACTIONS(1311),
    [sym_undefined] = ACTIONS(1311),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [144] = {
    [sym_import] = STATE(1210),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1210),
    [sym_yield_expression] = STATE(1210),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1210),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1210),
    [sym_arrow_function] = STATE(1210),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1210),
    [sym_new_expression] = STATE(1210),
    [sym_await_expression] = STATE(1210),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1210),
    [sym_augmented_assignment_expression] = STATE(1210),
    [sym_spread_element] = STATE(2390),
    [sym_ternary_expression] = STATE(1210),
    [sym_binary_expression] = STATE(1210),
    [sym_unary_expression] = STATE(1210),
    [sym_update_expression] = STATE(1210),
    [sym_string] = STATE(1210),
    [sym_template_string] = STATE(1210),
    [sym_regex] = STATE(1210),
    [sym_meta_property] = STATE(1210),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1210),
    [sym_type_assertion] = STATE(1210),
    [sym_as_expression] = STATE(1210),
    [sym_internal_module] = STATE(1210),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [aux_sym_array_repeat1] = STATE(2474),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(1313),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1315),
    [sym_this] = ACTIONS(1317),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [sym_null] = ACTIONS(1317),
    [sym_undefined] = ACTIONS(1317),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [145] = {
    [sym_import] = STATE(1229),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1229),
    [sym_yield_expression] = STATE(1229),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1229),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1229),
    [sym_arrow_function] = STATE(1229),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1229),
    [sym_new_expression] = STATE(1229),
    [sym_await_expression] = STATE(1229),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1229),
    [sym_augmented_assignment_expression] = STATE(1229),
    [sym_spread_element] = STATE(2381),
    [sym_ternary_expression] = STATE(1229),
    [sym_binary_expression] = STATE(1229),
    [sym_unary_expression] = STATE(1229),
    [sym_update_expression] = STATE(1229),
    [sym_string] = STATE(1229),
    [sym_template_string] = STATE(1229),
    [sym_regex] = STATE(1229),
    [sym_meta_property] = STATE(1229),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1229),
    [sym_type_assertion] = STATE(1229),
    [sym_as_expression] = STATE(1229),
    [sym_internal_module] = STATE(1229),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [aux_sym_array_repeat1] = STATE(2382),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(1319),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1321),
    [sym_this] = ACTIONS(1323),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1323),
    [sym_false] = ACTIONS(1323),
    [sym_null] = ACTIONS(1323),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [146] = {
    [sym_import] = STATE(1166),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1166),
    [sym_yield_expression] = STATE(1166),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1166),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1166),
    [sym_arrow_function] = STATE(1166),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1166),
    [sym_new_expression] = STATE(1166),
    [sym_await_expression] = STATE(1166),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1166),
    [sym_augmented_assignment_expression] = STATE(1166),
    [sym_spread_element] = STATE(2486),
    [sym_ternary_expression] = STATE(1166),
    [sym_binary_expression] = STATE(1166),
    [sym_unary_expression] = STATE(1166),
    [sym_update_expression] = STATE(1166),
    [sym_string] = STATE(1166),
    [sym_template_string] = STATE(1166),
    [sym_regex] = STATE(1166),
    [sym_meta_property] = STATE(1166),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1166),
    [sym_type_assertion] = STATE(1166),
    [sym_as_expression] = STATE(1166),
    [sym_internal_module] = STATE(1166),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(1285),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1325),
    [sym_this] = ACTIONS(1327),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [sym_null] = ACTIONS(1327),
    [sym_undefined] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [147] = {
    [sym_import] = STATE(1189),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1189),
    [sym_yield_expression] = STATE(1189),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1189),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1189),
    [sym_arrow_function] = STATE(1189),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1189),
    [sym_new_expression] = STATE(1189),
    [sym_await_expression] = STATE(1189),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1189),
    [sym_augmented_assignment_expression] = STATE(1189),
    [sym_spread_element] = STATE(2505),
    [sym_ternary_expression] = STATE(1189),
    [sym_binary_expression] = STATE(1189),
    [sym_unary_expression] = STATE(1189),
    [sym_update_expression] = STATE(1189),
    [sym_string] = STATE(1189),
    [sym_template_string] = STATE(1189),
    [sym_regex] = STATE(1189),
    [sym_meta_property] = STATE(1189),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1189),
    [sym_type_assertion] = STATE(1189),
    [sym_as_expression] = STATE(1189),
    [sym_internal_module] = STATE(1189),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [aux_sym_array_repeat1] = STATE(2504),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(829),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1329),
    [sym_this] = ACTIONS(841),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(841),
    [sym_false] = ACTIONS(841),
    [sym_null] = ACTIONS(841),
    [sym_undefined] = ACTIONS(841),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [148] = {
    [sym_export_clause] = STATE(2269),
    [sym__declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym_lexical_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_function_declaration] = STATE(520),
    [sym_generator_function_declaration] = STATE(520),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(520),
    [sym_ambient_declaration] = STATE(520),
    [sym_abstract_class_declaration] = STATE(520),
    [sym_module] = STATE(520),
    [sym_internal_module] = STATE(520),
    [sym_import_alias] = STATE(520),
    [sym_interface_declaration] = STATE(520),
    [sym_enum_declaration] = STATE(520),
    [sym_type_alias_declaration] = STATE(520),
    [aux_sym_export_statement_repeat1] = STATE(2356),
    [aux_sym_object_repeat1] = STATE(2399),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_default] = ACTIONS(1333),
    [anon_sym_EQ] = ACTIONS(1335),
    [anon_sym_as] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(1343),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_class] = ACTIONS(1358),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(1362),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1364),
    [anon_sym_declare] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1368),
    [anon_sym_interface] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1372),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [149] = {
    [sym_import] = STATE(1202),
    [sym_expression_statement] = STATE(165),
    [sym_empty_statement] = STATE(165),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1202),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_internal_module] = STATE(1202),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [150] = {
    [sym_export_clause] = STATE(2269),
    [sym__declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym_lexical_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_function_declaration] = STATE(520),
    [sym_generator_function_declaration] = STATE(520),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(520),
    [sym_ambient_declaration] = STATE(520),
    [sym_abstract_class_declaration] = STATE(520),
    [sym_module] = STATE(520),
    [sym_internal_module] = STATE(520),
    [sym_import_alias] = STATE(520),
    [sym_interface_declaration] = STATE(520),
    [sym_enum_declaration] = STATE(520),
    [sym_type_alias_declaration] = STATE(520),
    [aux_sym_export_statement_repeat1] = STATE(2356),
    [aux_sym_object_repeat1] = STATE(2484),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_default] = ACTIONS(1333),
    [anon_sym_EQ] = ACTIONS(1335),
    [anon_sym_as] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(1343),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_class] = ACTIONS(1358),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(1362),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1364),
    [anon_sym_declare] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1368),
    [anon_sym_interface] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1372),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [151] = {
    [sym_import] = STATE(1202),
    [sym_expression_statement] = STATE(163),
    [sym_empty_statement] = STATE(163),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1202),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1202),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_sequence_expression] = STATE(2570),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1202),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_internal_module] = STATE(1202),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [152] = {
    [sym_export_clause] = STATE(2269),
    [sym__declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym_lexical_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_function_declaration] = STATE(520),
    [sym_generator_function_declaration] = STATE(520),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(520),
    [sym_ambient_declaration] = STATE(520),
    [sym_abstract_class_declaration] = STATE(520),
    [sym_module] = STATE(520),
    [sym_internal_module] = STATE(520),
    [sym_import_alias] = STATE(520),
    [sym_interface_declaration] = STATE(520),
    [sym_enum_declaration] = STATE(520),
    [sym_type_alias_declaration] = STATE(520),
    [aux_sym_export_statement_repeat1] = STATE(2356),
    [aux_sym_object_repeat1] = STATE(2392),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_default] = ACTIONS(1333),
    [anon_sym_EQ] = ACTIONS(1335),
    [anon_sym_as] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(1343),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_class] = ACTIONS(1358),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(1362),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1364),
    [anon_sym_declare] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1368),
    [anon_sym_interface] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1372),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [153] = {
    [sym_import] = STATE(997),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(997),
    [sym_yield_expression] = STATE(997),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_nested_identifier] = STATE(2849),
    [sym_class] = STATE(997),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(997),
    [sym_arrow_function] = STATE(997),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(997),
    [sym_new_expression] = STATE(997),
    [sym_await_expression] = STATE(997),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(997),
    [sym_augmented_assignment_expression] = STATE(997),
    [sym_ternary_expression] = STATE(997),
    [sym_binary_expression] = STATE(997),
    [sym_unary_expression] = STATE(997),
    [sym_update_expression] = STATE(997),
    [sym_string] = STATE(997),
    [sym_template_string] = STATE(997),
    [sym_regex] = STATE(997),
    [sym_meta_property] = STATE(997),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(997),
    [sym_type_assertion] = STATE(997),
    [sym_as_expression] = STATE(997),
    [sym_internal_module] = STATE(997),
    [sym_nested_type_identifier] = STATE(2044),
    [sym_generic_type] = STATE(2290),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(1374),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1378),
    [sym_this] = ACTIONS(1380),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1380),
    [sym_false] = ACTIONS(1380),
    [sym_null] = ACTIONS(1380),
    [sym_undefined] = ACTIONS(1380),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [154] = {
    [sym_import] = STATE(1026),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1026),
    [sym_yield_expression] = STATE(1026),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(1026),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1026),
    [sym_arrow_function] = STATE(1026),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1026),
    [sym_new_expression] = STATE(1026),
    [sym_await_expression] = STATE(1026),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1026),
    [sym_augmented_assignment_expression] = STATE(1026),
    [sym_ternary_expression] = STATE(1026),
    [sym_binary_expression] = STATE(1026),
    [sym_unary_expression] = STATE(1026),
    [sym_update_expression] = STATE(1026),
    [sym_string] = STATE(1026),
    [sym_template_string] = STATE(1026),
    [sym_regex] = STATE(1026),
    [sym_meta_property] = STATE(1026),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1026),
    [sym_type_assertion] = STATE(1026),
    [sym_as_expression] = STATE(1026),
    [sym_internal_module] = STATE(1026),
    [sym_nested_type_identifier] = STATE(2032),
    [sym_generic_type] = STATE(2355),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1382),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1384),
    [sym_this] = ACTIONS(1386),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1386),
    [sym_false] = ACTIONS(1386),
    [sym_null] = ACTIONS(1386),
    [sym_undefined] = ACTIONS(1386),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [155] = {
    [sym_import] = STATE(1150),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1150),
    [sym_yield_expression] = STATE(1150),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_nested_identifier] = STATE(2849),
    [sym_class] = STATE(1150),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1150),
    [sym_arrow_function] = STATE(1150),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1150),
    [sym_new_expression] = STATE(1150),
    [sym_await_expression] = STATE(1150),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1150),
    [sym_augmented_assignment_expression] = STATE(1150),
    [sym_ternary_expression] = STATE(1150),
    [sym_binary_expression] = STATE(1150),
    [sym_unary_expression] = STATE(1150),
    [sym_update_expression] = STATE(1150),
    [sym_string] = STATE(1150),
    [sym_template_string] = STATE(1150),
    [sym_regex] = STATE(1150),
    [sym_meta_property] = STATE(1150),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1150),
    [sym_type_assertion] = STATE(1150),
    [sym_as_expression] = STATE(1150),
    [sym_internal_module] = STATE(1150),
    [sym_nested_type_identifier] = STATE(2218),
    [sym_generic_type] = STATE(2415),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1390),
    [sym_this] = ACTIONS(1392),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1392),
    [sym_false] = ACTIONS(1392),
    [sym_null] = ACTIONS(1392),
    [sym_undefined] = ACTIONS(1392),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [156] = {
    [sym_import] = STATE(1208),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1208),
    [sym_yield_expression] = STATE(1208),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1208),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1208),
    [sym_arrow_function] = STATE(1208),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1208),
    [sym_new_expression] = STATE(1208),
    [sym_await_expression] = STATE(1208),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1208),
    [sym_augmented_assignment_expression] = STATE(1208),
    [sym_ternary_expression] = STATE(1208),
    [sym_binary_expression] = STATE(1208),
    [sym_unary_expression] = STATE(1208),
    [sym_update_expression] = STATE(1208),
    [sym_sequence_expression] = STATE(2730),
    [sym_string] = STATE(1208),
    [sym_template_string] = STATE(1208),
    [sym_regex] = STATE(1208),
    [sym_meta_property] = STATE(1208),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1208),
    [sym_type_assertion] = STATE(1208),
    [sym_as_expression] = STATE(1208),
    [sym_internal_module] = STATE(1208),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(1394),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1396),
    [sym_this] = ACTIONS(1398),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1398),
    [sym_false] = ACTIONS(1398),
    [sym_null] = ACTIONS(1398),
    [sym_undefined] = ACTIONS(1398),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(1394),
  },
  [157] = {
    [sym_import] = STATE(1186),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1186),
    [sym_yield_expression] = STATE(1186),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_nested_identifier] = STATE(2744),
    [sym_class] = STATE(1186),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1186),
    [sym_arrow_function] = STATE(1186),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1186),
    [sym_new_expression] = STATE(1186),
    [sym_await_expression] = STATE(1186),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1186),
    [sym_augmented_assignment_expression] = STATE(1186),
    [sym_ternary_expression] = STATE(1186),
    [sym_binary_expression] = STATE(1186),
    [sym_unary_expression] = STATE(1186),
    [sym_update_expression] = STATE(1186),
    [sym_string] = STATE(1186),
    [sym_template_string] = STATE(1186),
    [sym_regex] = STATE(1186),
    [sym_meta_property] = STATE(1186),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1186),
    [sym_type_assertion] = STATE(1186),
    [sym_as_expression] = STATE(1186),
    [sym_internal_module] = STATE(1186),
    [sym_nested_type_identifier] = STATE(2128),
    [sym_generic_type] = STATE(2443),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1402),
    [sym_this] = ACTIONS(1404),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1404),
    [sym_false] = ACTIONS(1404),
    [sym_null] = ACTIONS(1404),
    [sym_undefined] = ACTIONS(1404),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [158] = {
    [sym_import] = STATE(1597),
    [sym_parenthesized_expression] = STATE(900),
    [sym__expression] = STATE(1597),
    [sym_yield_expression] = STATE(1597),
    [sym_object] = STATE(1656),
    [sym_array] = STATE(1654),
    [sym_class] = STATE(1597),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1597),
    [sym_arrow_function] = STATE(1597),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1597),
    [sym_new_expression] = STATE(1597),
    [sym_await_expression] = STATE(1597),
    [sym_member_expression] = STATE(900),
    [sym_subscript_expression] = STATE(900),
    [sym_assignment_expression] = STATE(1597),
    [sym_augmented_assignment_expression] = STATE(1597),
    [sym_ternary_expression] = STATE(1597),
    [sym_binary_expression] = STATE(1597),
    [sym_unary_expression] = STATE(1597),
    [sym_update_expression] = STATE(1597),
    [sym_string] = STATE(1597),
    [sym_template_string] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_meta_property] = STATE(1597),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1597),
    [sym_type_assertion] = STATE(1597),
    [sym_as_expression] = STATE(1597),
    [sym_internal_module] = STATE(1597),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1406),
    [anon_sym_export] = ACTIONS(1408),
    [anon_sym_namespace] = ACTIONS(1410),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1408),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_var] = ACTIONS(1412),
    [anon_sym_let] = ACTIONS(1412),
    [anon_sym_const] = ACTIONS(1412),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1414),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1416),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1418),
    [sym_this] = ACTIONS(1420),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1420),
    [sym_false] = ACTIONS(1420),
    [sym_null] = ACTIONS(1420),
    [sym_undefined] = ACTIONS(1420),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1408),
    [anon_sym_get] = ACTIONS(1408),
    [anon_sym_set] = ACTIONS(1408),
    [anon_sym_declare] = ACTIONS(1408),
    [anon_sym_public] = ACTIONS(1408),
    [anon_sym_private] = ACTIONS(1408),
    [anon_sym_protected] = ACTIONS(1408),
    [anon_sym_module] = ACTIONS(1408),
    [anon_sym_any] = ACTIONS(1408),
    [anon_sym_number] = ACTIONS(1408),
    [anon_sym_boolean] = ACTIONS(1408),
    [anon_sym_string] = ACTIONS(1408),
    [anon_sym_symbol] = ACTIONS(1408),
  },
  [159] = {
    [sym_export_clause] = STATE(2269),
    [sym__declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym_lexical_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_function_declaration] = STATE(520),
    [sym_generator_function_declaration] = STATE(520),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(520),
    [sym_ambient_declaration] = STATE(520),
    [sym_abstract_class_declaration] = STATE(520),
    [sym_module] = STATE(520),
    [sym_internal_module] = STATE(520),
    [sym_import_alias] = STATE(520),
    [sym_interface_declaration] = STATE(520),
    [sym_enum_declaration] = STATE(520),
    [sym_type_alias_declaration] = STATE(520),
    [aux_sym_export_statement_repeat1] = STATE(2331),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_default] = ACTIONS(1333),
    [anon_sym_EQ] = ACTIONS(1422),
    [anon_sym_as] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1343),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_class] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1428),
    [anon_sym_function] = ACTIONS(1430),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1432),
    [anon_sym_declare] = ACTIONS(1434),
    [anon_sym_module] = ACTIONS(1436),
    [anon_sym_interface] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1372),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [160] = {
    [sym__declaration] = STATE(577),
    [sym_variable_declaration] = STATE(577),
    [sym_lexical_declaration] = STATE(577),
    [sym_class_declaration] = STATE(577),
    [sym_function_declaration] = STATE(577),
    [sym_generator_function_declaration] = STATE(577),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(577),
    [sym_abstract_class_declaration] = STATE(577),
    [sym_module] = STATE(577),
    [sym_internal_module] = STATE(577),
    [sym_import_alias] = STATE(577),
    [sym_interface_declaration] = STATE(577),
    [sym_enum_declaration] = STATE(577),
    [sym_type_alias_declaration] = STATE(577),
    [aux_sym_export_statement_repeat1] = STATE(2356),
    [aux_sym_object_repeat1] = STATE(2399),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(1343),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_class] = ACTIONS(1358),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(1362),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1364),
    [anon_sym_declare] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1438),
    [anon_sym_global] = ACTIONS(1440),
    [anon_sym_interface] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1372),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [161] = {
    [sym__declaration] = STATE(577),
    [sym_variable_declaration] = STATE(577),
    [sym_lexical_declaration] = STATE(577),
    [sym_class_declaration] = STATE(577),
    [sym_function_declaration] = STATE(577),
    [sym_generator_function_declaration] = STATE(577),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(577),
    [sym_abstract_class_declaration] = STATE(577),
    [sym_module] = STATE(577),
    [sym_internal_module] = STATE(577),
    [sym_import_alias] = STATE(577),
    [sym_interface_declaration] = STATE(577),
    [sym_enum_declaration] = STATE(577),
    [sym_type_alias_declaration] = STATE(577),
    [aux_sym_export_statement_repeat1] = STATE(2356),
    [aux_sym_object_repeat1] = STATE(2484),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(1343),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_class] = ACTIONS(1358),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(1362),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1364),
    [anon_sym_declare] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1438),
    [anon_sym_global] = ACTIONS(1440),
    [anon_sym_interface] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1372),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [162] = {
    [sym_export_clause] = STATE(2269),
    [sym__declaration] = STATE(520),
    [sym_variable_declaration] = STATE(520),
    [sym_lexical_declaration] = STATE(520),
    [sym_class_declaration] = STATE(520),
    [sym_function_declaration] = STATE(520),
    [sym_generator_function_declaration] = STATE(520),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(520),
    [sym_ambient_declaration] = STATE(520),
    [sym_abstract_class_declaration] = STATE(520),
    [sym_module] = STATE(520),
    [sym_internal_module] = STATE(520),
    [sym_import_alias] = STATE(520),
    [sym_interface_declaration] = STATE(520),
    [sym_enum_declaration] = STATE(520),
    [sym_type_alias_declaration] = STATE(520),
    [aux_sym_export_statement_repeat1] = STATE(2356),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_default] = ACTIONS(1333),
    [anon_sym_EQ] = ACTIONS(1422),
    [anon_sym_as] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1343),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_class] = ACTIONS(1358),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(1362),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1364),
    [anon_sym_declare] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1368),
    [anon_sym_interface] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1372),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [163] = {
    [sym_import] = STATE(1298),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1298),
    [sym_yield_expression] = STATE(1298),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1298),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1298),
    [sym_arrow_function] = STATE(1298),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1298),
    [sym_new_expression] = STATE(1298),
    [sym_await_expression] = STATE(1298),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1298),
    [sym_augmented_assignment_expression] = STATE(1298),
    [sym_ternary_expression] = STATE(1298),
    [sym_binary_expression] = STATE(1298),
    [sym_unary_expression] = STATE(1298),
    [sym_update_expression] = STATE(1298),
    [sym_sequence_expression] = STATE(2799),
    [sym_string] = STATE(1298),
    [sym_template_string] = STATE(1298),
    [sym_regex] = STATE(1298),
    [sym_meta_property] = STATE(1298),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1298),
    [sym_type_assertion] = STATE(1298),
    [sym_as_expression] = STATE(1298),
    [sym_internal_module] = STATE(1298),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1444),
    [sym_this] = ACTIONS(1446),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1446),
    [sym_false] = ACTIONS(1446),
    [sym_null] = ACTIONS(1446),
    [sym_undefined] = ACTIONS(1446),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [164] = {
    [sym__declaration] = STATE(577),
    [sym_variable_declaration] = STATE(577),
    [sym_lexical_declaration] = STATE(577),
    [sym_class_declaration] = STATE(577),
    [sym_function_declaration] = STATE(577),
    [sym_generator_function_declaration] = STATE(577),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(577),
    [sym_abstract_class_declaration] = STATE(577),
    [sym_module] = STATE(577),
    [sym_internal_module] = STATE(577),
    [sym_import_alias] = STATE(577),
    [sym_interface_declaration] = STATE(577),
    [sym_enum_declaration] = STATE(577),
    [sym_type_alias_declaration] = STATE(577),
    [aux_sym_export_statement_repeat1] = STATE(2356),
    [aux_sym_object_repeat1] = STATE(2392),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(1343),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_class] = ACTIONS(1358),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(1362),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1364),
    [anon_sym_declare] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1438),
    [anon_sym_global] = ACTIONS(1440),
    [anon_sym_interface] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1372),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [165] = {
    [sym_import] = STATE(1319),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1319),
    [sym_yield_expression] = STATE(1319),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1319),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1319),
    [sym_arrow_function] = STATE(1319),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1319),
    [sym_new_expression] = STATE(1319),
    [sym_await_expression] = STATE(1319),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1319),
    [sym_augmented_assignment_expression] = STATE(1319),
    [sym_ternary_expression] = STATE(1319),
    [sym_binary_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1319),
    [sym_update_expression] = STATE(1319),
    [sym_sequence_expression] = STATE(2794),
    [sym_string] = STATE(1319),
    [sym_template_string] = STATE(1319),
    [sym_regex] = STATE(1319),
    [sym_meta_property] = STATE(1319),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1319),
    [sym_type_assertion] = STATE(1319),
    [sym_as_expression] = STATE(1319),
    [sym_internal_module] = STATE(1319),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(1448),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1450),
    [sym_this] = ACTIONS(1452),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1452),
    [sym_false] = ACTIONS(1452),
    [sym_null] = ACTIONS(1452),
    [sym_undefined] = ACTIONS(1452),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [166] = {
    [sym_import] = STATE(1293),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1293),
    [sym_yield_expression] = STATE(1293),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1293),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1293),
    [sym_arrow_function] = STATE(1293),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1293),
    [sym_new_expression] = STATE(1293),
    [sym_await_expression] = STATE(1293),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1293),
    [sym_augmented_assignment_expression] = STATE(1293),
    [sym_ternary_expression] = STATE(1293),
    [sym_binary_expression] = STATE(1293),
    [sym_unary_expression] = STATE(1293),
    [sym_update_expression] = STATE(1293),
    [sym_sequence_expression] = STATE(2899),
    [sym_string] = STATE(1293),
    [sym_template_string] = STATE(1293),
    [sym_regex] = STATE(1293),
    [sym_meta_property] = STATE(1293),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1293),
    [sym_type_assertion] = STATE(1293),
    [sym_as_expression] = STATE(1293),
    [sym_internal_module] = STATE(1293),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1454),
    [sym_this] = ACTIONS(1456),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1456),
    [sym_false] = ACTIONS(1456),
    [sym_null] = ACTIONS(1456),
    [sym_undefined] = ACTIONS(1456),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [167] = {
    [sym_import] = STATE(1042),
    [sym_statement_block] = STATE(1391),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1042),
    [sym_yield_expression] = STATE(1042),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1042),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1042),
    [sym_arrow_function] = STATE(1042),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1042),
    [sym_new_expression] = STATE(1042),
    [sym_await_expression] = STATE(1042),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1042),
    [sym_augmented_assignment_expression] = STATE(1042),
    [sym_ternary_expression] = STATE(1042),
    [sym_binary_expression] = STATE(1042),
    [sym_unary_expression] = STATE(1042),
    [sym_update_expression] = STATE(1042),
    [sym_string] = STATE(1042),
    [sym_template_string] = STATE(1042),
    [sym_regex] = STATE(1042),
    [sym_meta_property] = STATE(1042),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1042),
    [sym_type_assertion] = STATE(1042),
    [sym_as_expression] = STATE(1042),
    [sym_internal_module] = STATE(1042),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1460),
    [sym_this] = ACTIONS(1462),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1462),
    [sym_false] = ACTIONS(1462),
    [sym_null] = ACTIONS(1462),
    [sym_undefined] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [168] = {
    [sym_import] = STATE(1108),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1108),
    [sym_yield_expression] = STATE(1108),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1108),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1108),
    [sym_arrow_function] = STATE(1108),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1108),
    [sym_new_expression] = STATE(1108),
    [sym_await_expression] = STATE(1108),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1108),
    [sym_augmented_assignment_expression] = STATE(1108),
    [sym_ternary_expression] = STATE(1108),
    [sym_binary_expression] = STATE(1108),
    [sym_unary_expression] = STATE(1108),
    [sym_update_expression] = STATE(1108),
    [sym_sequence_expression] = STATE(2796),
    [sym_string] = STATE(1108),
    [sym_template_string] = STATE(1108),
    [sym_regex] = STATE(1108),
    [sym_meta_property] = STATE(1108),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1108),
    [sym_type_assertion] = STATE(1108),
    [sym_as_expression] = STATE(1108),
    [sym_internal_module] = STATE(1108),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1265),
    [sym_this] = ACTIONS(817),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(817),
    [sym_false] = ACTIONS(817),
    [sym_null] = ACTIONS(817),
    [sym_undefined] = ACTIONS(817),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [169] = {
    [sym_import] = STATE(1345),
    [sym_statement_block] = STATE(1001),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1345),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1345),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1345),
    [sym_arrow_function] = STATE(1345),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1345),
    [sym_new_expression] = STATE(1345),
    [sym_await_expression] = STATE(1345),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1345),
    [sym_augmented_assignment_expression] = STATE(1345),
    [sym_ternary_expression] = STATE(1345),
    [sym_binary_expression] = STATE(1345),
    [sym_unary_expression] = STATE(1345),
    [sym_update_expression] = STATE(1345),
    [sym_string] = STATE(1345),
    [sym_template_string] = STATE(1345),
    [sym_regex] = STATE(1345),
    [sym_meta_property] = STATE(1345),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(1345),
    [sym_as_expression] = STATE(1345),
    [sym_internal_module] = STATE(1345),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1466),
    [sym_this] = ACTIONS(1468),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_null] = ACTIONS(1468),
    [sym_undefined] = ACTIONS(1468),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [170] = {
    [sym_import] = STATE(962),
    [sym_statement_block] = STATE(1083),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(962),
    [sym_yield_expression] = STATE(962),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(962),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(962),
    [sym_arrow_function] = STATE(962),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(962),
    [sym_new_expression] = STATE(962),
    [sym_await_expression] = STATE(962),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(962),
    [sym_augmented_assignment_expression] = STATE(962),
    [sym_ternary_expression] = STATE(962),
    [sym_binary_expression] = STATE(962),
    [sym_unary_expression] = STATE(962),
    [sym_update_expression] = STATE(962),
    [sym_string] = STATE(962),
    [sym_template_string] = STATE(962),
    [sym_regex] = STATE(962),
    [sym_meta_property] = STATE(962),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(962),
    [sym_type_assertion] = STATE(962),
    [sym_as_expression] = STATE(962),
    [sym_internal_module] = STATE(962),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1470),
    [sym_this] = ACTIONS(1472),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_undefined] = ACTIONS(1472),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [171] = {
    [sym_import] = STATE(1263),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1263),
    [sym_yield_expression] = STATE(1263),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1263),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1263),
    [sym_arrow_function] = STATE(1263),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1263),
    [sym_new_expression] = STATE(1263),
    [sym_await_expression] = STATE(1263),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1263),
    [sym_augmented_assignment_expression] = STATE(1263),
    [sym_ternary_expression] = STATE(1263),
    [sym_binary_expression] = STATE(1263),
    [sym_unary_expression] = STATE(1263),
    [sym_update_expression] = STATE(1263),
    [sym_sequence_expression] = STATE(2802),
    [sym_string] = STATE(1263),
    [sym_template_string] = STATE(1263),
    [sym_regex] = STATE(1263),
    [sym_meta_property] = STATE(1263),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1263),
    [sym_type_assertion] = STATE(1263),
    [sym_as_expression] = STATE(1263),
    [sym_internal_module] = STATE(1263),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1474),
    [sym_this] = ACTIONS(1476),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [sym_null] = ACTIONS(1476),
    [sym_undefined] = ACTIONS(1476),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [172] = {
    [sym_import] = STATE(957),
    [sym_statement_block] = STATE(1080),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(957),
    [sym_yield_expression] = STATE(957),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(957),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(957),
    [sym_arrow_function] = STATE(957),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(957),
    [sym_new_expression] = STATE(957),
    [sym_await_expression] = STATE(957),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(957),
    [sym_augmented_assignment_expression] = STATE(957),
    [sym_ternary_expression] = STATE(957),
    [sym_binary_expression] = STATE(957),
    [sym_unary_expression] = STATE(957),
    [sym_update_expression] = STATE(957),
    [sym_string] = STATE(957),
    [sym_template_string] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_meta_property] = STATE(957),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(957),
    [sym_type_assertion] = STATE(957),
    [sym_as_expression] = STATE(957),
    [sym_internal_module] = STATE(957),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1478),
    [sym_this] = ACTIONS(1480),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [sym_null] = ACTIONS(1480),
    [sym_undefined] = ACTIONS(1480),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [173] = {
    [sym_import] = STATE(1337),
    [sym_statement_block] = STATE(1418),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1337),
    [sym_yield_expression] = STATE(1337),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1337),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1337),
    [sym_arrow_function] = STATE(1337),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1337),
    [sym_new_expression] = STATE(1337),
    [sym_await_expression] = STATE(1337),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1337),
    [sym_augmented_assignment_expression] = STATE(1337),
    [sym_ternary_expression] = STATE(1337),
    [sym_binary_expression] = STATE(1337),
    [sym_unary_expression] = STATE(1337),
    [sym_update_expression] = STATE(1337),
    [sym_string] = STATE(1337),
    [sym_template_string] = STATE(1337),
    [sym_regex] = STATE(1337),
    [sym_meta_property] = STATE(1337),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(1337),
    [sym_as_expression] = STATE(1337),
    [sym_internal_module] = STATE(1337),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1482),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_null] = ACTIONS(1484),
    [sym_undefined] = ACTIONS(1484),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [174] = {
    [sym_import] = STATE(982),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(982),
    [sym_yield_expression] = STATE(982),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_nested_identifier] = STATE(410),
    [sym_class] = STATE(982),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(982),
    [sym_arrow_function] = STATE(982),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(982),
    [sym_new_expression] = STATE(982),
    [sym_await_expression] = STATE(982),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(982),
    [sym_augmented_assignment_expression] = STATE(982),
    [sym_ternary_expression] = STATE(982),
    [sym_binary_expression] = STATE(982),
    [sym_unary_expression] = STATE(982),
    [sym_update_expression] = STATE(982),
    [sym_string] = STATE(982),
    [sym_template_string] = STATE(982),
    [sym_regex] = STATE(982),
    [sym_meta_property] = STATE(982),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(982),
    [sym_type_assertion] = STATE(982),
    [sym_as_expression] = STATE(982),
    [sym_internal_module] = STATE(982),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1486),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(579),
    [sym_this] = ACTIONS(581),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_null] = ACTIONS(581),
    [sym_undefined] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [175] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(652),
    [sym__expression] = STATE(1597),
    [sym_yield_expression] = STATE(1597),
    [sym_object] = STATE(932),
    [sym_array] = STATE(940),
    [sym_class] = STATE(984),
    [sym_function] = STATE(930),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1597),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(1597),
    [sym_member_expression] = STATE(652),
    [sym_subscript_expression] = STATE(652),
    [sym_assignment_expression] = STATE(1597),
    [sym_augmented_assignment_expression] = STATE(1597),
    [sym_ternary_expression] = STATE(1597),
    [sym_binary_expression] = STATE(1597),
    [sym_unary_expression] = STATE(1597),
    [sym_update_expression] = STATE(1597),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2490),
    [sym_non_null_expression] = STATE(1597),
    [sym_type_assertion] = STATE(1597),
    [sym_as_expression] = STATE(1597),
    [sym_internal_module] = STATE(1597),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2631),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1488),
    [anon_sym_export] = ACTIONS(1490),
    [anon_sym_namespace] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1490),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(1494),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1496),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1498),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1500),
    [sym_this] = ACTIONS(1502),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [sym_null] = ACTIONS(1502),
    [sym_undefined] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1490),
    [anon_sym_get] = ACTIONS(1490),
    [anon_sym_set] = ACTIONS(1490),
    [anon_sym_declare] = ACTIONS(1490),
    [anon_sym_public] = ACTIONS(1490),
    [anon_sym_private] = ACTIONS(1490),
    [anon_sym_protected] = ACTIONS(1490),
    [anon_sym_module] = ACTIONS(1490),
    [anon_sym_any] = ACTIONS(1490),
    [anon_sym_number] = ACTIONS(1490),
    [anon_sym_boolean] = ACTIONS(1490),
    [anon_sym_string] = ACTIONS(1490),
    [anon_sym_symbol] = ACTIONS(1490),
  },
  [176] = {
    [sym_import] = STATE(985),
    [sym_statement_block] = STATE(1041),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(985),
    [sym_yield_expression] = STATE(985),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(985),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(985),
    [sym_arrow_function] = STATE(985),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(985),
    [sym_new_expression] = STATE(985),
    [sym_await_expression] = STATE(985),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(985),
    [sym_augmented_assignment_expression] = STATE(985),
    [sym_ternary_expression] = STATE(985),
    [sym_binary_expression] = STATE(985),
    [sym_unary_expression] = STATE(985),
    [sym_update_expression] = STATE(985),
    [sym_string] = STATE(985),
    [sym_template_string] = STATE(985),
    [sym_regex] = STATE(985),
    [sym_meta_property] = STATE(985),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(985),
    [sym_type_assertion] = STATE(985),
    [sym_as_expression] = STATE(985),
    [sym_internal_module] = STATE(985),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1504),
    [sym_this] = ACTIONS(1506),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [sym_null] = ACTIONS(1506),
    [sym_undefined] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [177] = {
    [sym_import] = STATE(1459),
    [sym_parenthesized_expression] = STATE(841),
    [sym__expression] = STATE(1530),
    [sym_yield_expression] = STATE(1530),
    [sym_object] = STATE(1268),
    [sym_array] = STATE(1264),
    [sym_class] = STATE(1459),
    [sym_function] = STATE(1219),
    [sym_generator_function] = STATE(1459),
    [sym_arrow_function] = STATE(1459),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1530),
    [sym_new_expression] = STATE(1459),
    [sym_await_expression] = STATE(1530),
    [sym_member_expression] = STATE(841),
    [sym_subscript_expression] = STATE(841),
    [sym_assignment_expression] = STATE(1530),
    [sym_augmented_assignment_expression] = STATE(1530),
    [sym_ternary_expression] = STATE(1530),
    [sym_binary_expression] = STATE(1530),
    [sym_unary_expression] = STATE(1530),
    [sym_update_expression] = STATE(1530),
    [sym_string] = STATE(1459),
    [sym_template_string] = STATE(1459),
    [sym_regex] = STATE(1459),
    [sym_meta_property] = STATE(1459),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1530),
    [sym_type_assertion] = STATE(1530),
    [sym_as_expression] = STATE(1530),
    [sym_internal_module] = STATE(1530),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_export] = ACTIONS(1510),
    [anon_sym_namespace] = ACTIONS(1512),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(1510),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_DOT] = ACTIONS(1514),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(1516),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1518),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1520),
    [sym_this] = ACTIONS(1522),
    [sym_super] = ACTIONS(1524),
    [sym_true] = ACTIONS(1522),
    [sym_false] = ACTIONS(1522),
    [sym_null] = ACTIONS(1522),
    [sym_undefined] = ACTIONS(1522),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1510),
    [anon_sym_get] = ACTIONS(1510),
    [anon_sym_set] = ACTIONS(1510),
    [anon_sym_declare] = ACTIONS(1510),
    [anon_sym_public] = ACTIONS(1510),
    [anon_sym_private] = ACTIONS(1510),
    [anon_sym_protected] = ACTIONS(1510),
    [anon_sym_module] = ACTIONS(1510),
    [anon_sym_any] = ACTIONS(1510),
    [anon_sym_number] = ACTIONS(1510),
    [anon_sym_boolean] = ACTIONS(1510),
    [anon_sym_string] = ACTIONS(1510),
    [anon_sym_symbol] = ACTIONS(1510),
  },
  [178] = {
    [sym_import] = STATE(1340),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1340),
    [sym_yield_expression] = STATE(1340),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1340),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1340),
    [sym_arrow_function] = STATE(1340),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1340),
    [sym_new_expression] = STATE(1340),
    [sym_await_expression] = STATE(1340),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1340),
    [sym_augmented_assignment_expression] = STATE(1340),
    [sym_ternary_expression] = STATE(1340),
    [sym_binary_expression] = STATE(1340),
    [sym_unary_expression] = STATE(1340),
    [sym_update_expression] = STATE(1340),
    [sym_sequence_expression] = STATE(2883),
    [sym_string] = STATE(1340),
    [sym_template_string] = STATE(1340),
    [sym_regex] = STATE(1340),
    [sym_meta_property] = STATE(1340),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1340),
    [sym_type_assertion] = STATE(1340),
    [sym_as_expression] = STATE(1340),
    [sym_internal_module] = STATE(1340),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1526),
    [sym_this] = ACTIONS(1528),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1528),
    [sym_false] = ACTIONS(1528),
    [sym_null] = ACTIONS(1528),
    [sym_undefined] = ACTIONS(1528),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [179] = {
    [sym_import] = STATE(1234),
    [sym_statement_block] = STATE(1593),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1234),
    [sym_yield_expression] = STATE(1234),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1234),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1234),
    [sym_arrow_function] = STATE(1234),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1234),
    [sym_new_expression] = STATE(1234),
    [sym_await_expression] = STATE(1234),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1234),
    [sym_augmented_assignment_expression] = STATE(1234),
    [sym_ternary_expression] = STATE(1234),
    [sym_binary_expression] = STATE(1234),
    [sym_unary_expression] = STATE(1234),
    [sym_update_expression] = STATE(1234),
    [sym_string] = STATE(1234),
    [sym_template_string] = STATE(1234),
    [sym_regex] = STATE(1234),
    [sym_meta_property] = STATE(1234),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1234),
    [sym_type_assertion] = STATE(1234),
    [sym_as_expression] = STATE(1234),
    [sym_internal_module] = STATE(1234),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1530),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1532),
    [sym_this] = ACTIONS(1534),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1534),
    [sym_false] = ACTIONS(1534),
    [sym_null] = ACTIONS(1534),
    [sym_undefined] = ACTIONS(1534),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [180] = {
    [sym_import] = STATE(1349),
    [sym_parenthesized_expression] = STATE(805),
    [sym__expression] = STATE(1513),
    [sym_yield_expression] = STATE(1513),
    [sym_object] = STATE(1183),
    [sym_array] = STATE(1180),
    [sym_class] = STATE(1349),
    [sym_function] = STATE(995),
    [sym_generator_function] = STATE(1349),
    [sym_arrow_function] = STATE(1349),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1513),
    [sym_new_expression] = STATE(1349),
    [sym_await_expression] = STATE(1513),
    [sym_member_expression] = STATE(805),
    [sym_subscript_expression] = STATE(805),
    [sym_assignment_expression] = STATE(1513),
    [sym_augmented_assignment_expression] = STATE(1513),
    [sym_ternary_expression] = STATE(1513),
    [sym_binary_expression] = STATE(1513),
    [sym_unary_expression] = STATE(1513),
    [sym_update_expression] = STATE(1513),
    [sym_string] = STATE(1349),
    [sym_template_string] = STATE(1349),
    [sym_regex] = STATE(1349),
    [sym_meta_property] = STATE(1349),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1513),
    [sym_as_expression] = STATE(1513),
    [sym_internal_module] = STATE(1513),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(1536),
    [anon_sym_export] = ACTIONS(1538),
    [anon_sym_namespace] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1538),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1542),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1544),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1546),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1548),
    [sym_this] = ACTIONS(1550),
    [sym_super] = ACTIONS(1552),
    [sym_true] = ACTIONS(1550),
    [sym_false] = ACTIONS(1550),
    [sym_null] = ACTIONS(1550),
    [sym_undefined] = ACTIONS(1550),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1538),
    [anon_sym_get] = ACTIONS(1538),
    [anon_sym_set] = ACTIONS(1538),
    [anon_sym_declare] = ACTIONS(1538),
    [anon_sym_public] = ACTIONS(1538),
    [anon_sym_private] = ACTIONS(1538),
    [anon_sym_protected] = ACTIONS(1538),
    [anon_sym_module] = ACTIONS(1538),
    [anon_sym_any] = ACTIONS(1538),
    [anon_sym_number] = ACTIONS(1538),
    [anon_sym_boolean] = ACTIONS(1538),
    [anon_sym_string] = ACTIONS(1538),
    [anon_sym_symbol] = ACTIONS(1538),
  },
  [181] = {
    [sym_import] = STATE(1097),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1097),
    [sym_yield_expression] = STATE(1097),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_nested_identifier] = STATE(410),
    [sym_class] = STATE(1097),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1097),
    [sym_arrow_function] = STATE(1097),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1097),
    [sym_new_expression] = STATE(1097),
    [sym_await_expression] = STATE(1097),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1097),
    [sym_augmented_assignment_expression] = STATE(1097),
    [sym_ternary_expression] = STATE(1097),
    [sym_binary_expression] = STATE(1097),
    [sym_unary_expression] = STATE(1097),
    [sym_update_expression] = STATE(1097),
    [sym_string] = STATE(1097),
    [sym_template_string] = STATE(1097),
    [sym_regex] = STATE(1097),
    [sym_meta_property] = STATE(1097),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1097),
    [sym_type_assertion] = STATE(1097),
    [sym_as_expression] = STATE(1097),
    [sym_internal_module] = STATE(1097),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(1554),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [182] = {
    [sym_import] = STATE(1354),
    [sym_statement_block] = STATE(1409),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1354),
    [sym_yield_expression] = STATE(1354),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1354),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1354),
    [sym_arrow_function] = STATE(1354),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1354),
    [sym_new_expression] = STATE(1354),
    [sym_await_expression] = STATE(1354),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1354),
    [sym_augmented_assignment_expression] = STATE(1354),
    [sym_ternary_expression] = STATE(1354),
    [sym_binary_expression] = STATE(1354),
    [sym_unary_expression] = STATE(1354),
    [sym_update_expression] = STATE(1354),
    [sym_string] = STATE(1354),
    [sym_template_string] = STATE(1354),
    [sym_regex] = STATE(1354),
    [sym_meta_property] = STATE(1354),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1354),
    [sym_as_expression] = STATE(1354),
    [sym_internal_module] = STATE(1354),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1556),
    [sym_this] = ACTIONS(1558),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1558),
    [sym_false] = ACTIONS(1558),
    [sym_null] = ACTIONS(1558),
    [sym_undefined] = ACTIONS(1558),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [183] = {
    [sym_import] = STATE(1172),
    [sym_statement_block] = STATE(1536),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1172),
    [sym_yield_expression] = STATE(1172),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1172),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1172),
    [sym_arrow_function] = STATE(1172),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1172),
    [sym_new_expression] = STATE(1172),
    [sym_await_expression] = STATE(1172),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1172),
    [sym_augmented_assignment_expression] = STATE(1172),
    [sym_ternary_expression] = STATE(1172),
    [sym_binary_expression] = STATE(1172),
    [sym_unary_expression] = STATE(1172),
    [sym_update_expression] = STATE(1172),
    [sym_string] = STATE(1172),
    [sym_template_string] = STATE(1172),
    [sym_regex] = STATE(1172),
    [sym_meta_property] = STATE(1172),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1172),
    [sym_type_assertion] = STATE(1172),
    [sym_as_expression] = STATE(1172),
    [sym_internal_module] = STATE(1172),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1530),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1560),
    [sym_this] = ACTIONS(1562),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1562),
    [sym_false] = ACTIONS(1562),
    [sym_null] = ACTIONS(1562),
    [sym_undefined] = ACTIONS(1562),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [184] = {
    [sym_import] = STATE(979),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(979),
    [sym_yield_expression] = STATE(979),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(979),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(979),
    [sym_arrow_function] = STATE(979),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(979),
    [sym_new_expression] = STATE(979),
    [sym_await_expression] = STATE(979),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(979),
    [sym_augmented_assignment_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym_update_expression] = STATE(979),
    [sym_sequence_expression] = STATE(2329),
    [sym_string] = STATE(979),
    [sym_template_string] = STATE(979),
    [sym_regex] = STATE(979),
    [sym_meta_property] = STATE(979),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(979),
    [sym_type_assertion] = STATE(979),
    [sym_as_expression] = STATE(979),
    [sym_internal_module] = STATE(979),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1564),
    [sym_this] = ACTIONS(1566),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1566),
    [sym_false] = ACTIONS(1566),
    [sym_null] = ACTIONS(1566),
    [sym_undefined] = ACTIONS(1566),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [185] = {
    [sym_import] = STATE(1327),
    [sym_statement_block] = STATE(1389),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1327),
    [sym_yield_expression] = STATE(1327),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1327),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1327),
    [sym_arrow_function] = STATE(1327),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1327),
    [sym_new_expression] = STATE(1327),
    [sym_await_expression] = STATE(1327),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1327),
    [sym_augmented_assignment_expression] = STATE(1327),
    [sym_ternary_expression] = STATE(1327),
    [sym_binary_expression] = STATE(1327),
    [sym_unary_expression] = STATE(1327),
    [sym_update_expression] = STATE(1327),
    [sym_string] = STATE(1327),
    [sym_template_string] = STATE(1327),
    [sym_regex] = STATE(1327),
    [sym_meta_property] = STATE(1327),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1327),
    [sym_type_assertion] = STATE(1327),
    [sym_as_expression] = STATE(1327),
    [sym_internal_module] = STATE(1327),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1568),
    [sym_this] = ACTIONS(1570),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1570),
    [sym_false] = ACTIONS(1570),
    [sym_null] = ACTIONS(1570),
    [sym_undefined] = ACTIONS(1570),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [186] = {
    [sym_import] = STATE(1317),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1317),
    [sym_yield_expression] = STATE(1317),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1317),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1317),
    [sym_arrow_function] = STATE(1317),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1317),
    [sym_new_expression] = STATE(1317),
    [sym_await_expression] = STATE(1317),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1317),
    [sym_augmented_assignment_expression] = STATE(1317),
    [sym_ternary_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_unary_expression] = STATE(1317),
    [sym_update_expression] = STATE(1317),
    [sym_sequence_expression] = STATE(2739),
    [sym_string] = STATE(1317),
    [sym_template_string] = STATE(1317),
    [sym_regex] = STATE(1317),
    [sym_meta_property] = STATE(1317),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1317),
    [sym_type_assertion] = STATE(1317),
    [sym_as_expression] = STATE(1317),
    [sym_internal_module] = STATE(1317),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1572),
    [sym_this] = ACTIONS(1574),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1574),
    [sym_false] = ACTIONS(1574),
    [sym_null] = ACTIONS(1574),
    [sym_undefined] = ACTIONS(1574),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [187] = {
    [sym_import] = STATE(1323),
    [sym_statement_block] = STATE(1391),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1323),
    [sym_yield_expression] = STATE(1323),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1323),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1323),
    [sym_arrow_function] = STATE(1323),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1323),
    [sym_new_expression] = STATE(1323),
    [sym_await_expression] = STATE(1323),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1323),
    [sym_augmented_assignment_expression] = STATE(1323),
    [sym_ternary_expression] = STATE(1323),
    [sym_binary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(1323),
    [sym_update_expression] = STATE(1323),
    [sym_string] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_regex] = STATE(1323),
    [sym_meta_property] = STATE(1323),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1323),
    [sym_type_assertion] = STATE(1323),
    [sym_as_expression] = STATE(1323),
    [sym_internal_module] = STATE(1323),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1576),
    [sym_this] = ACTIONS(1578),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1578),
    [sym_false] = ACTIONS(1578),
    [sym_null] = ACTIONS(1578),
    [sym_undefined] = ACTIONS(1578),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [188] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(652),
    [sym__expression] = STATE(1597),
    [sym_yield_expression] = STATE(1597),
    [sym_object] = STATE(932),
    [sym_array] = STATE(940),
    [sym_class] = STATE(984),
    [sym_function] = STATE(930),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1597),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(1597),
    [sym_member_expression] = STATE(652),
    [sym_subscript_expression] = STATE(652),
    [sym_assignment_expression] = STATE(1597),
    [sym_augmented_assignment_expression] = STATE(1597),
    [sym_ternary_expression] = STATE(1597),
    [sym_binary_expression] = STATE(1597),
    [sym_unary_expression] = STATE(1597),
    [sym_update_expression] = STATE(1597),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1597),
    [sym_type_assertion] = STATE(1597),
    [sym_as_expression] = STATE(1597),
    [sym_internal_module] = STATE(1597),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1580),
    [anon_sym_export] = ACTIONS(1582),
    [anon_sym_namespace] = ACTIONS(1584),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1582),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(1494),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1586),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1588),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1500),
    [sym_this] = ACTIONS(1502),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [sym_null] = ACTIONS(1502),
    [sym_undefined] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1582),
    [anon_sym_get] = ACTIONS(1582),
    [anon_sym_set] = ACTIONS(1582),
    [anon_sym_declare] = ACTIONS(1582),
    [anon_sym_public] = ACTIONS(1582),
    [anon_sym_private] = ACTIONS(1582),
    [anon_sym_protected] = ACTIONS(1582),
    [anon_sym_module] = ACTIONS(1582),
    [anon_sym_any] = ACTIONS(1582),
    [anon_sym_number] = ACTIONS(1582),
    [anon_sym_boolean] = ACTIONS(1582),
    [anon_sym_string] = ACTIONS(1582),
    [anon_sym_symbol] = ACTIONS(1582),
  },
  [189] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(652),
    [sym__expression] = STATE(1597),
    [sym_yield_expression] = STATE(1597),
    [sym_object] = STATE(932),
    [sym_array] = STATE(940),
    [sym_class] = STATE(984),
    [sym_function] = STATE(930),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1597),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(1597),
    [sym_member_expression] = STATE(652),
    [sym_subscript_expression] = STATE(652),
    [sym_assignment_expression] = STATE(1597),
    [sym_augmented_assignment_expression] = STATE(1597),
    [sym_ternary_expression] = STATE(1597),
    [sym_binary_expression] = STATE(1597),
    [sym_unary_expression] = STATE(1597),
    [sym_update_expression] = STATE(1597),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1597),
    [sym_type_assertion] = STATE(1597),
    [sym_as_expression] = STATE(1597),
    [sym_internal_module] = STATE(1597),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1590),
    [anon_sym_export] = ACTIONS(1592),
    [anon_sym_namespace] = ACTIONS(1594),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1592),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(1494),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1596),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1598),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1500),
    [sym_this] = ACTIONS(1502),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [sym_null] = ACTIONS(1502),
    [sym_undefined] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1592),
    [anon_sym_get] = ACTIONS(1592),
    [anon_sym_set] = ACTIONS(1592),
    [anon_sym_declare] = ACTIONS(1592),
    [anon_sym_public] = ACTIONS(1592),
    [anon_sym_private] = ACTIONS(1592),
    [anon_sym_protected] = ACTIONS(1592),
    [anon_sym_module] = ACTIONS(1592),
    [anon_sym_any] = ACTIONS(1592),
    [anon_sym_number] = ACTIONS(1592),
    [anon_sym_boolean] = ACTIONS(1592),
    [anon_sym_string] = ACTIONS(1592),
    [anon_sym_symbol] = ACTIONS(1592),
  },
  [190] = {
    [sym_import] = STATE(1309),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1309),
    [sym_yield_expression] = STATE(1309),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1309),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1309),
    [sym_arrow_function] = STATE(1309),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1309),
    [sym_new_expression] = STATE(1309),
    [sym_await_expression] = STATE(1309),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1309),
    [sym_augmented_assignment_expression] = STATE(1309),
    [sym_ternary_expression] = STATE(1309),
    [sym_binary_expression] = STATE(1309),
    [sym_unary_expression] = STATE(1309),
    [sym_update_expression] = STATE(1309),
    [sym_sequence_expression] = STATE(2790),
    [sym_string] = STATE(1309),
    [sym_template_string] = STATE(1309),
    [sym_regex] = STATE(1309),
    [sym_meta_property] = STATE(1309),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1309),
    [sym_type_assertion] = STATE(1309),
    [sym_as_expression] = STATE(1309),
    [sym_internal_module] = STATE(1309),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1600),
    [sym_this] = ACTIONS(1602),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1602),
    [sym_false] = ACTIONS(1602),
    [sym_null] = ACTIONS(1602),
    [sym_undefined] = ACTIONS(1602),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [191] = {
    [sym_import] = STATE(1316),
    [sym_statement_block] = STATE(1392),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1316),
    [sym_yield_expression] = STATE(1316),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1316),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1316),
    [sym_arrow_function] = STATE(1316),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1316),
    [sym_new_expression] = STATE(1316),
    [sym_await_expression] = STATE(1316),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1316),
    [sym_augmented_assignment_expression] = STATE(1316),
    [sym_ternary_expression] = STATE(1316),
    [sym_binary_expression] = STATE(1316),
    [sym_unary_expression] = STATE(1316),
    [sym_update_expression] = STATE(1316),
    [sym_string] = STATE(1316),
    [sym_template_string] = STATE(1316),
    [sym_regex] = STATE(1316),
    [sym_meta_property] = STATE(1316),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1316),
    [sym_type_assertion] = STATE(1316),
    [sym_as_expression] = STATE(1316),
    [sym_internal_module] = STATE(1316),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1604),
    [sym_this] = ACTIONS(1606),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1606),
    [sym_false] = ACTIONS(1606),
    [sym_null] = ACTIONS(1606),
    [sym_undefined] = ACTIONS(1606),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [192] = {
    [sym_import] = STATE(1242),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1242),
    [sym_yield_expression] = STATE(1242),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1242),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1242),
    [sym_arrow_function] = STATE(1242),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1242),
    [sym_new_expression] = STATE(1242),
    [sym_await_expression] = STATE(1242),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1242),
    [sym_augmented_assignment_expression] = STATE(1242),
    [sym_ternary_expression] = STATE(1242),
    [sym_binary_expression] = STATE(1242),
    [sym_unary_expression] = STATE(1242),
    [sym_update_expression] = STATE(1242),
    [sym_sequence_expression] = STATE(2793),
    [sym_string] = STATE(1242),
    [sym_template_string] = STATE(1242),
    [sym_regex] = STATE(1242),
    [sym_meta_property] = STATE(1242),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1242),
    [sym_as_expression] = STATE(1242),
    [sym_internal_module] = STATE(1242),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1608),
    [sym_this] = ACTIONS(1610),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1610),
    [sym_false] = ACTIONS(1610),
    [sym_null] = ACTIONS(1610),
    [sym_undefined] = ACTIONS(1610),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [193] = {
    [sym_import] = STATE(1253),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1253),
    [sym_yield_expression] = STATE(1253),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_nested_identifier] = STATE(410),
    [sym_class] = STATE(1253),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1253),
    [sym_arrow_function] = STATE(1253),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1253),
    [sym_new_expression] = STATE(1253),
    [sym_await_expression] = STATE(1253),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1253),
    [sym_augmented_assignment_expression] = STATE(1253),
    [sym_ternary_expression] = STATE(1253),
    [sym_binary_expression] = STATE(1253),
    [sym_unary_expression] = STATE(1253),
    [sym_update_expression] = STATE(1253),
    [sym_string] = STATE(1253),
    [sym_template_string] = STATE(1253),
    [sym_regex] = STATE(1253),
    [sym_meta_property] = STATE(1253),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1253),
    [sym_type_assertion] = STATE(1253),
    [sym_as_expression] = STATE(1253),
    [sym_internal_module] = STATE(1253),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(1612),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(642),
    [sym_this] = ACTIONS(644),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(644),
    [sym_false] = ACTIONS(644),
    [sym_null] = ACTIONS(644),
    [sym_undefined] = ACTIONS(644),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [194] = {
    [sym_import] = STATE(1019),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1019),
    [sym_yield_expression] = STATE(1019),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1019),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1019),
    [sym_arrow_function] = STATE(1019),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1019),
    [sym_new_expression] = STATE(1019),
    [sym_await_expression] = STATE(1019),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1019),
    [sym_augmented_assignment_expression] = STATE(1019),
    [sym_ternary_expression] = STATE(1019),
    [sym_binary_expression] = STATE(1019),
    [sym_unary_expression] = STATE(1019),
    [sym_update_expression] = STATE(1019),
    [sym_sequence_expression] = STATE(2933),
    [sym_string] = STATE(1019),
    [sym_template_string] = STATE(1019),
    [sym_regex] = STATE(1019),
    [sym_meta_property] = STATE(1019),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1019),
    [sym_type_assertion] = STATE(1019),
    [sym_as_expression] = STATE(1019),
    [sym_internal_module] = STATE(1019),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1614),
    [sym_this] = ACTIONS(1616),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1616),
    [sym_false] = ACTIONS(1616),
    [sym_null] = ACTIONS(1616),
    [sym_undefined] = ACTIONS(1616),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [195] = {
    [sym_import] = STATE(1349),
    [sym_parenthesized_expression] = STATE(805),
    [sym__expression] = STATE(1513),
    [sym_yield_expression] = STATE(1513),
    [sym_object] = STATE(1183),
    [sym_array] = STATE(1180),
    [sym_class] = STATE(1349),
    [sym_function] = STATE(995),
    [sym_generator_function] = STATE(1349),
    [sym_arrow_function] = STATE(1349),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1513),
    [sym_new_expression] = STATE(1349),
    [sym_await_expression] = STATE(1513),
    [sym_member_expression] = STATE(805),
    [sym_subscript_expression] = STATE(805),
    [sym_assignment_expression] = STATE(1513),
    [sym_augmented_assignment_expression] = STATE(1513),
    [sym_ternary_expression] = STATE(1513),
    [sym_binary_expression] = STATE(1513),
    [sym_unary_expression] = STATE(1513),
    [sym_update_expression] = STATE(1513),
    [sym_string] = STATE(1349),
    [sym_template_string] = STATE(1349),
    [sym_regex] = STATE(1349),
    [sym_meta_property] = STATE(1349),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2523),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1513),
    [sym_as_expression] = STATE(1513),
    [sym_internal_module] = STATE(1513),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2727),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(1618),
    [anon_sym_export] = ACTIONS(1620),
    [anon_sym_namespace] = ACTIONS(1622),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1620),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1542),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1626),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1548),
    [sym_this] = ACTIONS(1550),
    [sym_super] = ACTIONS(1552),
    [sym_true] = ACTIONS(1550),
    [sym_false] = ACTIONS(1550),
    [sym_null] = ACTIONS(1550),
    [sym_undefined] = ACTIONS(1550),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1620),
    [anon_sym_get] = ACTIONS(1620),
    [anon_sym_set] = ACTIONS(1620),
    [anon_sym_declare] = ACTIONS(1620),
    [anon_sym_public] = ACTIONS(1620),
    [anon_sym_private] = ACTIONS(1620),
    [anon_sym_protected] = ACTIONS(1620),
    [anon_sym_module] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1620),
    [anon_sym_number] = ACTIONS(1620),
    [anon_sym_boolean] = ACTIONS(1620),
    [anon_sym_string] = ACTIONS(1620),
    [anon_sym_symbol] = ACTIONS(1620),
  },
  [196] = {
    [sym_import] = STATE(948),
    [sym_statement_block] = STATE(1001),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(948),
    [sym_yield_expression] = STATE(948),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(948),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(948),
    [sym_arrow_function] = STATE(948),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(948),
    [sym_new_expression] = STATE(948),
    [sym_await_expression] = STATE(948),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(948),
    [sym_augmented_assignment_expression] = STATE(948),
    [sym_ternary_expression] = STATE(948),
    [sym_binary_expression] = STATE(948),
    [sym_unary_expression] = STATE(948),
    [sym_update_expression] = STATE(948),
    [sym_string] = STATE(948),
    [sym_template_string] = STATE(948),
    [sym_regex] = STATE(948),
    [sym_meta_property] = STATE(948),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(948),
    [sym_type_assertion] = STATE(948),
    [sym_as_expression] = STATE(948),
    [sym_internal_module] = STATE(948),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1628),
    [sym_this] = ACTIONS(1630),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1630),
    [sym_false] = ACTIONS(1630),
    [sym_null] = ACTIONS(1630),
    [sym_undefined] = ACTIONS(1630),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [197] = {
    [sym_import] = STATE(1459),
    [sym_parenthesized_expression] = STATE(841),
    [sym__expression] = STATE(1530),
    [sym_yield_expression] = STATE(1530),
    [sym_object] = STATE(1268),
    [sym_array] = STATE(1264),
    [sym_class] = STATE(1459),
    [sym_function] = STATE(1219),
    [sym_generator_function] = STATE(1459),
    [sym_arrow_function] = STATE(1459),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1530),
    [sym_new_expression] = STATE(1459),
    [sym_await_expression] = STATE(1530),
    [sym_member_expression] = STATE(841),
    [sym_subscript_expression] = STATE(841),
    [sym_assignment_expression] = STATE(1530),
    [sym_augmented_assignment_expression] = STATE(1530),
    [sym_ternary_expression] = STATE(1530),
    [sym_binary_expression] = STATE(1530),
    [sym_unary_expression] = STATE(1530),
    [sym_update_expression] = STATE(1530),
    [sym_string] = STATE(1459),
    [sym_template_string] = STATE(1459),
    [sym_regex] = STATE(1459),
    [sym_meta_property] = STATE(1459),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2523),
    [sym_non_null_expression] = STATE(1530),
    [sym_type_assertion] = STATE(1530),
    [sym_as_expression] = STATE(1530),
    [sym_internal_module] = STATE(1530),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2727),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_export] = ACTIONS(1510),
    [anon_sym_namespace] = ACTIONS(1512),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(1510),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_DOT] = ACTIONS(1514),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(1516),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1518),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1520),
    [sym_this] = ACTIONS(1522),
    [sym_super] = ACTIONS(1524),
    [sym_true] = ACTIONS(1522),
    [sym_false] = ACTIONS(1522),
    [sym_null] = ACTIONS(1522),
    [sym_undefined] = ACTIONS(1522),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1510),
    [anon_sym_get] = ACTIONS(1510),
    [anon_sym_set] = ACTIONS(1510),
    [anon_sym_declare] = ACTIONS(1510),
    [anon_sym_public] = ACTIONS(1510),
    [anon_sym_private] = ACTIONS(1510),
    [anon_sym_protected] = ACTIONS(1510),
    [anon_sym_module] = ACTIONS(1510),
    [anon_sym_any] = ACTIONS(1510),
    [anon_sym_number] = ACTIONS(1510),
    [anon_sym_boolean] = ACTIONS(1510),
    [anon_sym_string] = ACTIONS(1510),
    [anon_sym_symbol] = ACTIONS(1510),
  },
  [198] = {
    [sym_import] = STATE(1209),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1209),
    [sym_yield_expression] = STATE(1209),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1209),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1209),
    [sym_arrow_function] = STATE(1209),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1209),
    [sym_new_expression] = STATE(1209),
    [sym_await_expression] = STATE(1209),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1209),
    [sym_augmented_assignment_expression] = STATE(1209),
    [sym_ternary_expression] = STATE(1209),
    [sym_binary_expression] = STATE(1209),
    [sym_unary_expression] = STATE(1209),
    [sym_update_expression] = STATE(1209),
    [sym_sequence_expression] = STATE(2728),
    [sym_string] = STATE(1209),
    [sym_template_string] = STATE(1209),
    [sym_regex] = STATE(1209),
    [sym_meta_property] = STATE(1209),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1209),
    [sym_type_assertion] = STATE(1209),
    [sym_as_expression] = STATE(1209),
    [sym_internal_module] = STATE(1209),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1632),
    [sym_this] = ACTIONS(1634),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1634),
    [sym_false] = ACTIONS(1634),
    [sym_null] = ACTIONS(1634),
    [sym_undefined] = ACTIONS(1634),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [199] = {
    [sym_import] = STATE(1089),
    [sym_statement_block] = STATE(1468),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1089),
    [sym_yield_expression] = STATE(1089),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1089),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1089),
    [sym_arrow_function] = STATE(1089),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1089),
    [sym_new_expression] = STATE(1089),
    [sym_await_expression] = STATE(1089),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1089),
    [sym_augmented_assignment_expression] = STATE(1089),
    [sym_ternary_expression] = STATE(1089),
    [sym_binary_expression] = STATE(1089),
    [sym_unary_expression] = STATE(1089),
    [sym_update_expression] = STATE(1089),
    [sym_string] = STATE(1089),
    [sym_template_string] = STATE(1089),
    [sym_regex] = STATE(1089),
    [sym_meta_property] = STATE(1089),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1089),
    [sym_type_assertion] = STATE(1089),
    [sym_as_expression] = STATE(1089),
    [sym_internal_module] = STATE(1089),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1636),
    [sym_this] = ACTIONS(1638),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1638),
    [sym_false] = ACTIONS(1638),
    [sym_null] = ACTIONS(1638),
    [sym_undefined] = ACTIONS(1638),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [200] = {
    [sym_import] = STATE(1281),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1281),
    [sym_yield_expression] = STATE(1281),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1281),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1281),
    [sym_arrow_function] = STATE(1281),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1281),
    [sym_new_expression] = STATE(1281),
    [sym_await_expression] = STATE(1281),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1281),
    [sym_augmented_assignment_expression] = STATE(1281),
    [sym_ternary_expression] = STATE(1281),
    [sym_binary_expression] = STATE(1281),
    [sym_unary_expression] = STATE(1281),
    [sym_update_expression] = STATE(1281),
    [sym_sequence_expression] = STATE(2904),
    [sym_string] = STATE(1281),
    [sym_template_string] = STATE(1281),
    [sym_regex] = STATE(1281),
    [sym_meta_property] = STATE(1281),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1281),
    [sym_type_assertion] = STATE(1281),
    [sym_as_expression] = STATE(1281),
    [sym_internal_module] = STATE(1281),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1640),
    [sym_this] = ACTIONS(1642),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1642),
    [sym_false] = ACTIONS(1642),
    [sym_null] = ACTIONS(1642),
    [sym_undefined] = ACTIONS(1642),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [201] = {
    [sym_import] = STATE(1200),
    [sym_statement_block] = STATE(1001),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1200),
    [sym_yield_expression] = STATE(1200),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1200),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1200),
    [sym_arrow_function] = STATE(1200),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_await_expression] = STATE(1200),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1200),
    [sym_augmented_assignment_expression] = STATE(1200),
    [sym_ternary_expression] = STATE(1200),
    [sym_binary_expression] = STATE(1200),
    [sym_unary_expression] = STATE(1200),
    [sym_update_expression] = STATE(1200),
    [sym_string] = STATE(1200),
    [sym_template_string] = STATE(1200),
    [sym_regex] = STATE(1200),
    [sym_meta_property] = STATE(1200),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1200),
    [sym_type_assertion] = STATE(1200),
    [sym_as_expression] = STATE(1200),
    [sym_internal_module] = STATE(1200),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1644),
    [sym_this] = ACTIONS(1646),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1646),
    [sym_false] = ACTIONS(1646),
    [sym_null] = ACTIONS(1646),
    [sym_undefined] = ACTIONS(1646),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [202] = {
    [sym_import] = STATE(1349),
    [sym_parenthesized_expression] = STATE(805),
    [sym__expression] = STATE(1513),
    [sym_yield_expression] = STATE(1513),
    [sym_object] = STATE(1183),
    [sym_array] = STATE(1180),
    [sym_class] = STATE(1349),
    [sym_function] = STATE(995),
    [sym_generator_function] = STATE(1349),
    [sym_arrow_function] = STATE(1349),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1513),
    [sym_new_expression] = STATE(1349),
    [sym_await_expression] = STATE(1513),
    [sym_member_expression] = STATE(805),
    [sym_subscript_expression] = STATE(805),
    [sym_assignment_expression] = STATE(1513),
    [sym_augmented_assignment_expression] = STATE(1513),
    [sym_ternary_expression] = STATE(1513),
    [sym_binary_expression] = STATE(1513),
    [sym_unary_expression] = STATE(1513),
    [sym_update_expression] = STATE(1513),
    [sym_string] = STATE(1349),
    [sym_template_string] = STATE(1349),
    [sym_regex] = STATE(1349),
    [sym_meta_property] = STATE(1349),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1513),
    [sym_as_expression] = STATE(1513),
    [sym_internal_module] = STATE(1513),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(1618),
    [anon_sym_export] = ACTIONS(1620),
    [anon_sym_namespace] = ACTIONS(1622),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1620),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1542),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1626),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1548),
    [sym_this] = ACTIONS(1550),
    [sym_super] = ACTIONS(1552),
    [sym_true] = ACTIONS(1550),
    [sym_false] = ACTIONS(1550),
    [sym_null] = ACTIONS(1550),
    [sym_undefined] = ACTIONS(1550),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1620),
    [anon_sym_get] = ACTIONS(1620),
    [anon_sym_set] = ACTIONS(1620),
    [anon_sym_declare] = ACTIONS(1620),
    [anon_sym_public] = ACTIONS(1620),
    [anon_sym_private] = ACTIONS(1620),
    [anon_sym_protected] = ACTIONS(1620),
    [anon_sym_module] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1620),
    [anon_sym_number] = ACTIONS(1620),
    [anon_sym_boolean] = ACTIONS(1620),
    [anon_sym_string] = ACTIONS(1620),
    [anon_sym_symbol] = ACTIONS(1620),
  },
  [203] = {
    [sym_import] = STATE(1051),
    [sym_statement_block] = STATE(1409),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1051),
    [sym_yield_expression] = STATE(1051),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1051),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1051),
    [sym_arrow_function] = STATE(1051),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1051),
    [sym_new_expression] = STATE(1051),
    [sym_await_expression] = STATE(1051),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1051),
    [sym_augmented_assignment_expression] = STATE(1051),
    [sym_ternary_expression] = STATE(1051),
    [sym_binary_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1051),
    [sym_update_expression] = STATE(1051),
    [sym_string] = STATE(1051),
    [sym_template_string] = STATE(1051),
    [sym_regex] = STATE(1051),
    [sym_meta_property] = STATE(1051),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1051),
    [sym_type_assertion] = STATE(1051),
    [sym_as_expression] = STATE(1051),
    [sym_internal_module] = STATE(1051),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1648),
    [sym_this] = ACTIONS(1650),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_null] = ACTIONS(1650),
    [sym_undefined] = ACTIONS(1650),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [204] = {
    [sym_import] = STATE(1266),
    [sym_statement_block] = STATE(1083),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1266),
    [sym_yield_expression] = STATE(1266),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1266),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1266),
    [sym_arrow_function] = STATE(1266),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1266),
    [sym_new_expression] = STATE(1266),
    [sym_await_expression] = STATE(1266),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1266),
    [sym_augmented_assignment_expression] = STATE(1266),
    [sym_ternary_expression] = STATE(1266),
    [sym_binary_expression] = STATE(1266),
    [sym_unary_expression] = STATE(1266),
    [sym_update_expression] = STATE(1266),
    [sym_string] = STATE(1266),
    [sym_template_string] = STATE(1266),
    [sym_regex] = STATE(1266),
    [sym_meta_property] = STATE(1266),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1266),
    [sym_type_assertion] = STATE(1266),
    [sym_as_expression] = STATE(1266),
    [sym_internal_module] = STATE(1266),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1652),
    [sym_this] = ACTIONS(1654),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1654),
    [sym_false] = ACTIONS(1654),
    [sym_null] = ACTIONS(1654),
    [sym_undefined] = ACTIONS(1654),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [205] = {
    [sym_import] = STATE(967),
    [sym_statement_block] = STATE(1088),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(967),
    [sym_yield_expression] = STATE(967),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(967),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(967),
    [sym_arrow_function] = STATE(967),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(967),
    [sym_new_expression] = STATE(967),
    [sym_await_expression] = STATE(967),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(967),
    [sym_augmented_assignment_expression] = STATE(967),
    [sym_ternary_expression] = STATE(967),
    [sym_binary_expression] = STATE(967),
    [sym_unary_expression] = STATE(967),
    [sym_update_expression] = STATE(967),
    [sym_string] = STATE(967),
    [sym_template_string] = STATE(967),
    [sym_regex] = STATE(967),
    [sym_meta_property] = STATE(967),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(967),
    [sym_type_assertion] = STATE(967),
    [sym_as_expression] = STATE(967),
    [sym_internal_module] = STATE(967),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1656),
    [sym_this] = ACTIONS(1658),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1658),
    [sym_false] = ACTIONS(1658),
    [sym_null] = ACTIONS(1658),
    [sym_undefined] = ACTIONS(1658),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [206] = {
    [sym_import] = STATE(1349),
    [sym_parenthesized_expression] = STATE(805),
    [sym__expression] = STATE(1513),
    [sym_yield_expression] = STATE(1513),
    [sym_object] = STATE(1183),
    [sym_array] = STATE(1180),
    [sym_class] = STATE(1349),
    [sym_function] = STATE(995),
    [sym_generator_function] = STATE(1349),
    [sym_arrow_function] = STATE(1349),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1513),
    [sym_new_expression] = STATE(1349),
    [sym_await_expression] = STATE(1513),
    [sym_member_expression] = STATE(805),
    [sym_subscript_expression] = STATE(805),
    [sym_assignment_expression] = STATE(1513),
    [sym_augmented_assignment_expression] = STATE(1513),
    [sym_ternary_expression] = STATE(1513),
    [sym_binary_expression] = STATE(1513),
    [sym_unary_expression] = STATE(1513),
    [sym_update_expression] = STATE(1513),
    [sym_string] = STATE(1349),
    [sym_template_string] = STATE(1349),
    [sym_regex] = STATE(1349),
    [sym_meta_property] = STATE(1349),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2523),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1513),
    [sym_as_expression] = STATE(1513),
    [sym_internal_module] = STATE(1513),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2727),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(1536),
    [anon_sym_export] = ACTIONS(1538),
    [anon_sym_namespace] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1538),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1542),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1544),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1546),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1548),
    [sym_this] = ACTIONS(1550),
    [sym_super] = ACTIONS(1552),
    [sym_true] = ACTIONS(1550),
    [sym_false] = ACTIONS(1550),
    [sym_null] = ACTIONS(1550),
    [sym_undefined] = ACTIONS(1550),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1538),
    [anon_sym_get] = ACTIONS(1538),
    [anon_sym_set] = ACTIONS(1538),
    [anon_sym_declare] = ACTIONS(1538),
    [anon_sym_public] = ACTIONS(1538),
    [anon_sym_private] = ACTIONS(1538),
    [anon_sym_protected] = ACTIONS(1538),
    [anon_sym_module] = ACTIONS(1538),
    [anon_sym_any] = ACTIONS(1538),
    [anon_sym_number] = ACTIONS(1538),
    [anon_sym_boolean] = ACTIONS(1538),
    [anon_sym_string] = ACTIONS(1538),
    [anon_sym_symbol] = ACTIONS(1538),
  },
  [207] = {
    [sym_import] = STATE(1199),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1199),
    [sym_yield_expression] = STATE(1199),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1199),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1199),
    [sym_arrow_function] = STATE(1199),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1199),
    [sym_new_expression] = STATE(1199),
    [sym_await_expression] = STATE(1199),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1199),
    [sym_augmented_assignment_expression] = STATE(1199),
    [sym_ternary_expression] = STATE(1199),
    [sym_binary_expression] = STATE(1199),
    [sym_unary_expression] = STATE(1199),
    [sym_update_expression] = STATE(1199),
    [sym_sequence_expression] = STATE(2719),
    [sym_string] = STATE(1199),
    [sym_template_string] = STATE(1199),
    [sym_regex] = STATE(1199),
    [sym_meta_property] = STATE(1199),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1199),
    [sym_type_assertion] = STATE(1199),
    [sym_as_expression] = STATE(1199),
    [sym_internal_module] = STATE(1199),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1660),
    [sym_this] = ACTIONS(1662),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1662),
    [sym_false] = ACTIONS(1662),
    [sym_null] = ACTIONS(1662),
    [sym_undefined] = ACTIONS(1662),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [208] = {
    [sym_import] = STATE(1305),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1305),
    [sym_yield_expression] = STATE(1305),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1305),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1305),
    [sym_arrow_function] = STATE(1305),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1305),
    [sym_new_expression] = STATE(1305),
    [sym_await_expression] = STATE(1305),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1305),
    [sym_augmented_assignment_expression] = STATE(1305),
    [sym_ternary_expression] = STATE(1305),
    [sym_binary_expression] = STATE(1305),
    [sym_unary_expression] = STATE(1305),
    [sym_update_expression] = STATE(1305),
    [sym_sequence_expression] = STATE(2891),
    [sym_string] = STATE(1305),
    [sym_template_string] = STATE(1305),
    [sym_regex] = STATE(1305),
    [sym_meta_property] = STATE(1305),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1305),
    [sym_type_assertion] = STATE(1305),
    [sym_as_expression] = STATE(1305),
    [sym_internal_module] = STATE(1305),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1664),
    [sym_this] = ACTIONS(1666),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1666),
    [sym_false] = ACTIONS(1666),
    [sym_null] = ACTIONS(1666),
    [sym_undefined] = ACTIONS(1666),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [209] = {
    [sym_import] = STATE(1364),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1364),
    [sym_yield_expression] = STATE(1364),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1364),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1364),
    [sym_arrow_function] = STATE(1364),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1364),
    [sym_new_expression] = STATE(1364),
    [sym_await_expression] = STATE(1364),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1364),
    [sym_augmented_assignment_expression] = STATE(1364),
    [sym_ternary_expression] = STATE(1364),
    [sym_binary_expression] = STATE(1364),
    [sym_unary_expression] = STATE(1364),
    [sym_update_expression] = STATE(1364),
    [sym_string] = STATE(1364),
    [sym_template_string] = STATE(1364),
    [sym_regex] = STATE(1364),
    [sym_meta_property] = STATE(1364),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1364),
    [sym_type_assertion] = STATE(1364),
    [sym_as_expression] = STATE(1364),
    [sym_internal_module] = STATE(1364),
    [sym_mapped_type_clause] = STATE(2875),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1668),
    [anon_sym_export] = ACTIONS(1670),
    [anon_sym_namespace] = ACTIONS(1672),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1670),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1676),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1678),
    [sym_this] = ACTIONS(1680),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1680),
    [sym_false] = ACTIONS(1680),
    [sym_null] = ACTIONS(1680),
    [sym_undefined] = ACTIONS(1680),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1670),
    [anon_sym_get] = ACTIONS(1670),
    [anon_sym_set] = ACTIONS(1670),
    [anon_sym_declare] = ACTIONS(1670),
    [anon_sym_public] = ACTIONS(1670),
    [anon_sym_private] = ACTIONS(1670),
    [anon_sym_protected] = ACTIONS(1670),
    [anon_sym_module] = ACTIONS(1670),
    [anon_sym_any] = ACTIONS(1670),
    [anon_sym_number] = ACTIONS(1670),
    [anon_sym_boolean] = ACTIONS(1670),
    [anon_sym_string] = ACTIONS(1670),
    [anon_sym_symbol] = ACTIONS(1670),
  },
  [210] = {
    [sym_import] = STATE(1286),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1286),
    [sym_yield_expression] = STATE(1286),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1286),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1286),
    [sym_arrow_function] = STATE(1286),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1286),
    [sym_new_expression] = STATE(1286),
    [sym_await_expression] = STATE(1286),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1286),
    [sym_augmented_assignment_expression] = STATE(1286),
    [sym_ternary_expression] = STATE(1286),
    [sym_binary_expression] = STATE(1286),
    [sym_unary_expression] = STATE(1286),
    [sym_update_expression] = STATE(1286),
    [sym_sequence_expression] = STATE(2803),
    [sym_string] = STATE(1286),
    [sym_template_string] = STATE(1286),
    [sym_regex] = STATE(1286),
    [sym_meta_property] = STATE(1286),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1286),
    [sym_type_assertion] = STATE(1286),
    [sym_as_expression] = STATE(1286),
    [sym_internal_module] = STATE(1286),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1682),
    [sym_this] = ACTIONS(1684),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1684),
    [sym_false] = ACTIONS(1684),
    [sym_null] = ACTIONS(1684),
    [sym_undefined] = ACTIONS(1684),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [211] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(652),
    [sym__expression] = STATE(1597),
    [sym_yield_expression] = STATE(1597),
    [sym_object] = STATE(932),
    [sym_array] = STATE(940),
    [sym_class] = STATE(984),
    [sym_function] = STATE(930),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1597),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(1597),
    [sym_member_expression] = STATE(652),
    [sym_subscript_expression] = STATE(652),
    [sym_assignment_expression] = STATE(1597),
    [sym_augmented_assignment_expression] = STATE(1597),
    [sym_ternary_expression] = STATE(1597),
    [sym_binary_expression] = STATE(1597),
    [sym_unary_expression] = STATE(1597),
    [sym_update_expression] = STATE(1597),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1597),
    [sym_type_assertion] = STATE(1597),
    [sym_as_expression] = STATE(1597),
    [sym_internal_module] = STATE(1597),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1488),
    [anon_sym_export] = ACTIONS(1490),
    [anon_sym_namespace] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1490),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(1494),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1496),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1498),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1500),
    [sym_this] = ACTIONS(1502),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [sym_null] = ACTIONS(1502),
    [sym_undefined] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1490),
    [anon_sym_get] = ACTIONS(1490),
    [anon_sym_set] = ACTIONS(1490),
    [anon_sym_declare] = ACTIONS(1490),
    [anon_sym_public] = ACTIONS(1490),
    [anon_sym_private] = ACTIONS(1490),
    [anon_sym_protected] = ACTIONS(1490),
    [anon_sym_module] = ACTIONS(1490),
    [anon_sym_any] = ACTIONS(1490),
    [anon_sym_number] = ACTIONS(1490),
    [anon_sym_boolean] = ACTIONS(1490),
    [anon_sym_string] = ACTIONS(1490),
    [anon_sym_symbol] = ACTIONS(1490),
  },
  [212] = {
    [sym_import] = STATE(1315),
    [sym_statement_block] = STATE(1041),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1315),
    [sym_yield_expression] = STATE(1315),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1315),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1315),
    [sym_arrow_function] = STATE(1315),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1315),
    [sym_new_expression] = STATE(1315),
    [sym_await_expression] = STATE(1315),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1315),
    [sym_augmented_assignment_expression] = STATE(1315),
    [sym_ternary_expression] = STATE(1315),
    [sym_binary_expression] = STATE(1315),
    [sym_unary_expression] = STATE(1315),
    [sym_update_expression] = STATE(1315),
    [sym_string] = STATE(1315),
    [sym_template_string] = STATE(1315),
    [sym_regex] = STATE(1315),
    [sym_meta_property] = STATE(1315),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1315),
    [sym_type_assertion] = STATE(1315),
    [sym_as_expression] = STATE(1315),
    [sym_internal_module] = STATE(1315),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1686),
    [sym_this] = ACTIONS(1688),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_undefined] = ACTIONS(1688),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [213] = {
    [sym_import] = STATE(1272),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1272),
    [sym_yield_expression] = STATE(1272),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1272),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1272),
    [sym_arrow_function] = STATE(1272),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1272),
    [sym_new_expression] = STATE(1272),
    [sym_await_expression] = STATE(1272),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1272),
    [sym_augmented_assignment_expression] = STATE(1272),
    [sym_ternary_expression] = STATE(1272),
    [sym_binary_expression] = STATE(1272),
    [sym_unary_expression] = STATE(1272),
    [sym_update_expression] = STATE(1272),
    [sym_sequence_expression] = STATE(2804),
    [sym_string] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_regex] = STATE(1272),
    [sym_meta_property] = STATE(1272),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1272),
    [sym_type_assertion] = STATE(1272),
    [sym_as_expression] = STATE(1272),
    [sym_internal_module] = STATE(1272),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1690),
    [sym_this] = ACTIONS(1692),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_null] = ACTIONS(1692),
    [sym_undefined] = ACTIONS(1692),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [214] = {
    [sym_import] = STATE(1597),
    [sym_variable_declarator] = STATE(2332),
    [sym_parenthesized_expression] = STATE(899),
    [sym__expression] = STATE(1597),
    [sym_yield_expression] = STATE(1597),
    [sym_object] = STATE(953),
    [sym_array] = STATE(947),
    [sym_class] = STATE(1597),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1597),
    [sym_arrow_function] = STATE(1597),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1597),
    [sym_new_expression] = STATE(1597),
    [sym_await_expression] = STATE(1597),
    [sym_member_expression] = STATE(899),
    [sym_subscript_expression] = STATE(899),
    [sym_assignment_expression] = STATE(1597),
    [sym_augmented_assignment_expression] = STATE(1597),
    [sym_ternary_expression] = STATE(1597),
    [sym_binary_expression] = STATE(1597),
    [sym_unary_expression] = STATE(1597),
    [sym_update_expression] = STATE(1597),
    [sym_string] = STATE(1597),
    [sym_template_string] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_meta_property] = STATE(1597),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1597),
    [sym_type_assertion] = STATE(1597),
    [sym_as_expression] = STATE(1597),
    [sym_internal_module] = STATE(1597),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1694),
    [anon_sym_export] = ACTIONS(1696),
    [anon_sym_namespace] = ACTIONS(1698),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1696),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1700),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1702),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1418),
    [sym_this] = ACTIONS(1420),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1420),
    [sym_false] = ACTIONS(1420),
    [sym_null] = ACTIONS(1420),
    [sym_undefined] = ACTIONS(1420),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1696),
    [anon_sym_get] = ACTIONS(1696),
    [anon_sym_set] = ACTIONS(1696),
    [anon_sym_declare] = ACTIONS(1696),
    [anon_sym_public] = ACTIONS(1696),
    [anon_sym_private] = ACTIONS(1696),
    [anon_sym_protected] = ACTIONS(1696),
    [anon_sym_module] = ACTIONS(1696),
    [anon_sym_any] = ACTIONS(1696),
    [anon_sym_number] = ACTIONS(1696),
    [anon_sym_boolean] = ACTIONS(1696),
    [anon_sym_string] = ACTIONS(1696),
    [anon_sym_symbol] = ACTIONS(1696),
  },
  [215] = {
    [sym_import] = STATE(1597),
    [sym_variable_declarator] = STATE(2327),
    [sym_parenthesized_expression] = STATE(899),
    [sym__expression] = STATE(1597),
    [sym_yield_expression] = STATE(1597),
    [sym_object] = STATE(953),
    [sym_array] = STATE(947),
    [sym_class] = STATE(1597),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1597),
    [sym_arrow_function] = STATE(1597),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1597),
    [sym_new_expression] = STATE(1597),
    [sym_await_expression] = STATE(1597),
    [sym_member_expression] = STATE(899),
    [sym_subscript_expression] = STATE(899),
    [sym_assignment_expression] = STATE(1597),
    [sym_augmented_assignment_expression] = STATE(1597),
    [sym_ternary_expression] = STATE(1597),
    [sym_binary_expression] = STATE(1597),
    [sym_unary_expression] = STATE(1597),
    [sym_update_expression] = STATE(1597),
    [sym_string] = STATE(1597),
    [sym_template_string] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_meta_property] = STATE(1597),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1597),
    [sym_type_assertion] = STATE(1597),
    [sym_as_expression] = STATE(1597),
    [sym_internal_module] = STATE(1597),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1694),
    [anon_sym_export] = ACTIONS(1696),
    [anon_sym_namespace] = ACTIONS(1698),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1696),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1700),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1702),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1418),
    [sym_this] = ACTIONS(1420),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1420),
    [sym_false] = ACTIONS(1420),
    [sym_null] = ACTIONS(1420),
    [sym_undefined] = ACTIONS(1420),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1696),
    [anon_sym_get] = ACTIONS(1696),
    [anon_sym_set] = ACTIONS(1696),
    [anon_sym_declare] = ACTIONS(1696),
    [anon_sym_public] = ACTIONS(1696),
    [anon_sym_private] = ACTIONS(1696),
    [anon_sym_protected] = ACTIONS(1696),
    [anon_sym_module] = ACTIONS(1696),
    [anon_sym_any] = ACTIONS(1696),
    [anon_sym_number] = ACTIONS(1696),
    [anon_sym_boolean] = ACTIONS(1696),
    [anon_sym_string] = ACTIONS(1696),
    [anon_sym_symbol] = ACTIONS(1696),
  },
  [216] = {
    [sym_import] = STATE(982),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(982),
    [sym_yield_expression] = STATE(982),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_nested_identifier] = STATE(1832),
    [sym_class] = STATE(982),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(982),
    [sym_arrow_function] = STATE(982),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(982),
    [sym_new_expression] = STATE(982),
    [sym_await_expression] = STATE(982),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(982),
    [sym_augmented_assignment_expression] = STATE(982),
    [sym_ternary_expression] = STATE(982),
    [sym_binary_expression] = STATE(982),
    [sym_unary_expression] = STATE(982),
    [sym_update_expression] = STATE(982),
    [sym_string] = STATE(982),
    [sym_template_string] = STATE(982),
    [sym_regex] = STATE(982),
    [sym_meta_property] = STATE(982),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(982),
    [sym_type_assertion] = STATE(982),
    [sym_as_expression] = STATE(982),
    [sym_internal_module] = STATE(982),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(579),
    [sym_this] = ACTIONS(581),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_null] = ACTIONS(581),
    [sym_undefined] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [217] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(652),
    [sym__expression] = STATE(1597),
    [sym_yield_expression] = STATE(1597),
    [sym_object] = STATE(932),
    [sym_array] = STATE(940),
    [sym_class] = STATE(984),
    [sym_function] = STATE(930),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1597),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(1597),
    [sym_member_expression] = STATE(652),
    [sym_subscript_expression] = STATE(652),
    [sym_assignment_expression] = STATE(1597),
    [sym_augmented_assignment_expression] = STATE(1597),
    [sym_ternary_expression] = STATE(1597),
    [sym_binary_expression] = STATE(1597),
    [sym_unary_expression] = STATE(1597),
    [sym_update_expression] = STATE(1597),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2523),
    [sym_non_null_expression] = STATE(1597),
    [sym_type_assertion] = STATE(1597),
    [sym_as_expression] = STATE(1597),
    [sym_internal_module] = STATE(1597),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2727),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1590),
    [anon_sym_export] = ACTIONS(1592),
    [anon_sym_namespace] = ACTIONS(1594),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1592),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(1494),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1596),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1598),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1500),
    [sym_this] = ACTIONS(1502),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [sym_null] = ACTIONS(1502),
    [sym_undefined] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1592),
    [anon_sym_get] = ACTIONS(1592),
    [anon_sym_set] = ACTIONS(1592),
    [anon_sym_declare] = ACTIONS(1592),
    [anon_sym_public] = ACTIONS(1592),
    [anon_sym_private] = ACTIONS(1592),
    [anon_sym_protected] = ACTIONS(1592),
    [anon_sym_module] = ACTIONS(1592),
    [anon_sym_any] = ACTIONS(1592),
    [anon_sym_number] = ACTIONS(1592),
    [anon_sym_boolean] = ACTIONS(1592),
    [anon_sym_string] = ACTIONS(1592),
    [anon_sym_symbol] = ACTIONS(1592),
  },
  [218] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_nested_identifier] = STATE(410),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1245),
    [sym_type_assertion] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1706),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [219] = {
    [sym_import] = STATE(1207),
    [sym_statement_block] = STATE(1088),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1207),
    [sym_yield_expression] = STATE(1207),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1207),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1207),
    [sym_arrow_function] = STATE(1207),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1207),
    [sym_new_expression] = STATE(1207),
    [sym_await_expression] = STATE(1207),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1207),
    [sym_augmented_assignment_expression] = STATE(1207),
    [sym_ternary_expression] = STATE(1207),
    [sym_binary_expression] = STATE(1207),
    [sym_unary_expression] = STATE(1207),
    [sym_update_expression] = STATE(1207),
    [sym_string] = STATE(1207),
    [sym_template_string] = STATE(1207),
    [sym_regex] = STATE(1207),
    [sym_meta_property] = STATE(1207),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1207),
    [sym_type_assertion] = STATE(1207),
    [sym_as_expression] = STATE(1207),
    [sym_internal_module] = STATE(1207),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1708),
    [sym_this] = ACTIONS(1710),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1710),
    [sym_false] = ACTIONS(1710),
    [sym_null] = ACTIONS(1710),
    [sym_undefined] = ACTIONS(1710),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [220] = {
    [sym_import] = STATE(1193),
    [sym_statement_block] = STATE(1083),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1193),
    [sym_yield_expression] = STATE(1193),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1193),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1193),
    [sym_arrow_function] = STATE(1193),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1193),
    [sym_new_expression] = STATE(1193),
    [sym_await_expression] = STATE(1193),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1193),
    [sym_augmented_assignment_expression] = STATE(1193),
    [sym_ternary_expression] = STATE(1193),
    [sym_binary_expression] = STATE(1193),
    [sym_unary_expression] = STATE(1193),
    [sym_update_expression] = STATE(1193),
    [sym_string] = STATE(1193),
    [sym_template_string] = STATE(1193),
    [sym_regex] = STATE(1193),
    [sym_meta_property] = STATE(1193),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1193),
    [sym_type_assertion] = STATE(1193),
    [sym_as_expression] = STATE(1193),
    [sym_internal_module] = STATE(1193),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1712),
    [sym_this] = ACTIONS(1714),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1714),
    [sym_false] = ACTIONS(1714),
    [sym_null] = ACTIONS(1714),
    [sym_undefined] = ACTIONS(1714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [221] = {
    [sym_import] = STATE(1226),
    [sym_statement_block] = STATE(1080),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1226),
    [sym_yield_expression] = STATE(1226),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1226),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1226),
    [sym_arrow_function] = STATE(1226),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1226),
    [sym_new_expression] = STATE(1226),
    [sym_await_expression] = STATE(1226),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1226),
    [sym_augmented_assignment_expression] = STATE(1226),
    [sym_ternary_expression] = STATE(1226),
    [sym_binary_expression] = STATE(1226),
    [sym_unary_expression] = STATE(1226),
    [sym_update_expression] = STATE(1226),
    [sym_string] = STATE(1226),
    [sym_template_string] = STATE(1226),
    [sym_regex] = STATE(1226),
    [sym_meta_property] = STATE(1226),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1226),
    [sym_type_assertion] = STATE(1226),
    [sym_as_expression] = STATE(1226),
    [sym_internal_module] = STATE(1226),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1716),
    [sym_this] = ACTIONS(1718),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1718),
    [sym_false] = ACTIONS(1718),
    [sym_null] = ACTIONS(1718),
    [sym_undefined] = ACTIONS(1718),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [222] = {
    [sym_import] = STATE(1134),
    [sym_statement_block] = STATE(1066),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1134),
    [sym_yield_expression] = STATE(1134),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1134),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1134),
    [sym_arrow_function] = STATE(1134),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1134),
    [sym_new_expression] = STATE(1134),
    [sym_await_expression] = STATE(1134),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1134),
    [sym_augmented_assignment_expression] = STATE(1134),
    [sym_ternary_expression] = STATE(1134),
    [sym_binary_expression] = STATE(1134),
    [sym_unary_expression] = STATE(1134),
    [sym_update_expression] = STATE(1134),
    [sym_string] = STATE(1134),
    [sym_template_string] = STATE(1134),
    [sym_regex] = STATE(1134),
    [sym_meta_property] = STATE(1134),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1134),
    [sym_type_assertion] = STATE(1134),
    [sym_as_expression] = STATE(1134),
    [sym_internal_module] = STATE(1134),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1720),
    [sym_this] = ACTIONS(1722),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1722),
    [sym_false] = ACTIONS(1722),
    [sym_null] = ACTIONS(1722),
    [sym_undefined] = ACTIONS(1722),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [223] = {
    [sym_import] = STATE(1043),
    [sym_statement_block] = STATE(1392),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1043),
    [sym_yield_expression] = STATE(1043),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1043),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1043),
    [sym_arrow_function] = STATE(1043),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1043),
    [sym_new_expression] = STATE(1043),
    [sym_await_expression] = STATE(1043),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1043),
    [sym_augmented_assignment_expression] = STATE(1043),
    [sym_ternary_expression] = STATE(1043),
    [sym_binary_expression] = STATE(1043),
    [sym_unary_expression] = STATE(1043),
    [sym_update_expression] = STATE(1043),
    [sym_string] = STATE(1043),
    [sym_template_string] = STATE(1043),
    [sym_regex] = STATE(1043),
    [sym_meta_property] = STATE(1043),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1043),
    [sym_as_expression] = STATE(1043),
    [sym_internal_module] = STATE(1043),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1724),
    [sym_this] = ACTIONS(1726),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1726),
    [sym_false] = ACTIONS(1726),
    [sym_null] = ACTIONS(1726),
    [sym_undefined] = ACTIONS(1726),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [224] = {
    [sym_import] = STATE(982),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(982),
    [sym_yield_expression] = STATE(982),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_nested_identifier] = STATE(410),
    [sym_class] = STATE(982),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(982),
    [sym_arrow_function] = STATE(982),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(982),
    [sym_new_expression] = STATE(982),
    [sym_await_expression] = STATE(982),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(982),
    [sym_augmented_assignment_expression] = STATE(982),
    [sym_ternary_expression] = STATE(982),
    [sym_binary_expression] = STATE(982),
    [sym_unary_expression] = STATE(982),
    [sym_update_expression] = STATE(982),
    [sym_string] = STATE(982),
    [sym_template_string] = STATE(982),
    [sym_regex] = STATE(982),
    [sym_meta_property] = STATE(982),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(982),
    [sym_type_assertion] = STATE(982),
    [sym_as_expression] = STATE(982),
    [sym_internal_module] = STATE(982),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1728),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(579),
    [sym_this] = ACTIONS(581),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_null] = ACTIONS(581),
    [sym_undefined] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [225] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1041),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1212),
    [sym_yield_expression] = STATE(1212),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1212),
    [sym_await_expression] = STATE(1212),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1212),
    [sym_augmented_assignment_expression] = STATE(1212),
    [sym_ternary_expression] = STATE(1212),
    [sym_binary_expression] = STATE(1212),
    [sym_unary_expression] = STATE(1212),
    [sym_update_expression] = STATE(1212),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1212),
    [sym_type_assertion] = STATE(1212),
    [sym_as_expression] = STATE(1212),
    [sym_internal_module] = STATE(1212),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1730),
    [sym_this] = ACTIONS(1732),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1732),
    [sym_false] = ACTIONS(1732),
    [sym_null] = ACTIONS(1732),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [226] = {
    [sym_import] = STATE(1304),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1304),
    [sym_yield_expression] = STATE(1304),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1304),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1304),
    [sym_arrow_function] = STATE(1304),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1304),
    [sym_new_expression] = STATE(1304),
    [sym_await_expression] = STATE(1304),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1304),
    [sym_augmented_assignment_expression] = STATE(1304),
    [sym_ternary_expression] = STATE(1304),
    [sym_binary_expression] = STATE(1304),
    [sym_unary_expression] = STATE(1304),
    [sym_update_expression] = STATE(1304),
    [sym_sequence_expression] = STATE(2773),
    [sym_string] = STATE(1304),
    [sym_template_string] = STATE(1304),
    [sym_regex] = STATE(1304),
    [sym_meta_property] = STATE(1304),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(1304),
    [sym_as_expression] = STATE(1304),
    [sym_internal_module] = STATE(1304),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1734),
    [sym_this] = ACTIONS(1736),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1736),
    [sym_false] = ACTIONS(1736),
    [sym_null] = ACTIONS(1736),
    [sym_undefined] = ACTIONS(1736),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [227] = {
    [sym_import] = STATE(1341),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1341),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1341),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1341),
    [sym_arrow_function] = STATE(1341),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1341),
    [sym_new_expression] = STATE(1341),
    [sym_await_expression] = STATE(1341),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1341),
    [sym_augmented_assignment_expression] = STATE(1341),
    [sym_ternary_expression] = STATE(1341),
    [sym_binary_expression] = STATE(1341),
    [sym_unary_expression] = STATE(1341),
    [sym_update_expression] = STATE(1341),
    [sym_sequence_expression] = STATE(2753),
    [sym_string] = STATE(1341),
    [sym_template_string] = STATE(1341),
    [sym_regex] = STATE(1341),
    [sym_meta_property] = STATE(1341),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1341),
    [sym_type_assertion] = STATE(1341),
    [sym_as_expression] = STATE(1341),
    [sym_internal_module] = STATE(1341),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1738),
    [sym_this] = ACTIONS(1740),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1740),
    [sym_false] = ACTIONS(1740),
    [sym_null] = ACTIONS(1740),
    [sym_undefined] = ACTIONS(1740),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [228] = {
    [sym_import] = STATE(956),
    [sym_statement_block] = STATE(1066),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(956),
    [sym_yield_expression] = STATE(956),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(956),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(956),
    [sym_arrow_function] = STATE(956),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(956),
    [sym_new_expression] = STATE(956),
    [sym_await_expression] = STATE(956),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(956),
    [sym_augmented_assignment_expression] = STATE(956),
    [sym_ternary_expression] = STATE(956),
    [sym_binary_expression] = STATE(956),
    [sym_unary_expression] = STATE(956),
    [sym_update_expression] = STATE(956),
    [sym_string] = STATE(956),
    [sym_template_string] = STATE(956),
    [sym_regex] = STATE(956),
    [sym_meta_property] = STATE(956),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(956),
    [sym_type_assertion] = STATE(956),
    [sym_as_expression] = STATE(956),
    [sym_internal_module] = STATE(956),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1742),
    [sym_this] = ACTIONS(1744),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1744),
    [sym_false] = ACTIONS(1744),
    [sym_null] = ACTIONS(1744),
    [sym_undefined] = ACTIONS(1744),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [229] = {
    [sym_import] = STATE(1227),
    [sym_statement_block] = STATE(1500),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1227),
    [sym_yield_expression] = STATE(1227),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1227),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1227),
    [sym_arrow_function] = STATE(1227),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1227),
    [sym_new_expression] = STATE(1227),
    [sym_await_expression] = STATE(1227),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1227),
    [sym_augmented_assignment_expression] = STATE(1227),
    [sym_ternary_expression] = STATE(1227),
    [sym_binary_expression] = STATE(1227),
    [sym_unary_expression] = STATE(1227),
    [sym_update_expression] = STATE(1227),
    [sym_string] = STATE(1227),
    [sym_template_string] = STATE(1227),
    [sym_regex] = STATE(1227),
    [sym_meta_property] = STATE(1227),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1227),
    [sym_type_assertion] = STATE(1227),
    [sym_as_expression] = STATE(1227),
    [sym_internal_module] = STATE(1227),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1530),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1746),
    [sym_this] = ACTIONS(1748),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1748),
    [sym_false] = ACTIONS(1748),
    [sym_null] = ACTIONS(1748),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [230] = {
    [sym_import] = STATE(1251),
    [sym_statement_block] = STATE(1066),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1251),
    [sym_yield_expression] = STATE(1251),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1251),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1251),
    [sym_arrow_function] = STATE(1251),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1251),
    [sym_new_expression] = STATE(1251),
    [sym_await_expression] = STATE(1251),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1251),
    [sym_augmented_assignment_expression] = STATE(1251),
    [sym_ternary_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_unary_expression] = STATE(1251),
    [sym_update_expression] = STATE(1251),
    [sym_string] = STATE(1251),
    [sym_template_string] = STATE(1251),
    [sym_regex] = STATE(1251),
    [sym_meta_property] = STATE(1251),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1251),
    [sym_type_assertion] = STATE(1251),
    [sym_as_expression] = STATE(1251),
    [sym_internal_module] = STATE(1251),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1750),
    [sym_this] = ACTIONS(1752),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1752),
    [sym_false] = ACTIONS(1752),
    [sym_null] = ACTIONS(1752),
    [sym_undefined] = ACTIONS(1752),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [231] = {
    [sym_import] = STATE(1036),
    [sym_statement_block] = STATE(1389),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1036),
    [sym_yield_expression] = STATE(1036),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1036),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1036),
    [sym_arrow_function] = STATE(1036),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1036),
    [sym_new_expression] = STATE(1036),
    [sym_await_expression] = STATE(1036),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1036),
    [sym_augmented_assignment_expression] = STATE(1036),
    [sym_ternary_expression] = STATE(1036),
    [sym_binary_expression] = STATE(1036),
    [sym_unary_expression] = STATE(1036),
    [sym_update_expression] = STATE(1036),
    [sym_string] = STATE(1036),
    [sym_template_string] = STATE(1036),
    [sym_regex] = STATE(1036),
    [sym_meta_property] = STATE(1036),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1036),
    [sym_type_assertion] = STATE(1036),
    [sym_as_expression] = STATE(1036),
    [sym_internal_module] = STATE(1036),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1754),
    [sym_this] = ACTIONS(1756),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1756),
    [sym_false] = ACTIONS(1756),
    [sym_null] = ACTIONS(1756),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [232] = {
    [sym_import] = STATE(1259),
    [sym_statement_block] = STATE(1080),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1259),
    [sym_yield_expression] = STATE(1259),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1259),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1259),
    [sym_arrow_function] = STATE(1259),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1259),
    [sym_new_expression] = STATE(1259),
    [sym_await_expression] = STATE(1259),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1259),
    [sym_augmented_assignment_expression] = STATE(1259),
    [sym_ternary_expression] = STATE(1259),
    [sym_binary_expression] = STATE(1259),
    [sym_unary_expression] = STATE(1259),
    [sym_update_expression] = STATE(1259),
    [sym_string] = STATE(1259),
    [sym_template_string] = STATE(1259),
    [sym_regex] = STATE(1259),
    [sym_meta_property] = STATE(1259),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1259),
    [sym_type_assertion] = STATE(1259),
    [sym_as_expression] = STATE(1259),
    [sym_internal_module] = STATE(1259),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1758),
    [sym_this] = ACTIONS(1760),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1760),
    [sym_false] = ACTIONS(1760),
    [sym_null] = ACTIONS(1760),
    [sym_undefined] = ACTIONS(1760),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [233] = {
    [sym_import] = STATE(1297),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1297),
    [sym_yield_expression] = STATE(1297),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1297),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1297),
    [sym_arrow_function] = STATE(1297),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1297),
    [sym_new_expression] = STATE(1297),
    [sym_await_expression] = STATE(1297),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1297),
    [sym_augmented_assignment_expression] = STATE(1297),
    [sym_ternary_expression] = STATE(1297),
    [sym_binary_expression] = STATE(1297),
    [sym_unary_expression] = STATE(1297),
    [sym_update_expression] = STATE(1297),
    [sym_sequence_expression] = STATE(2937),
    [sym_string] = STATE(1297),
    [sym_template_string] = STATE(1297),
    [sym_regex] = STATE(1297),
    [sym_meta_property] = STATE(1297),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1297),
    [sym_type_assertion] = STATE(1297),
    [sym_as_expression] = STATE(1297),
    [sym_internal_module] = STATE(1297),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1762),
    [sym_this] = ACTIONS(1764),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1764),
    [sym_false] = ACTIONS(1764),
    [sym_null] = ACTIONS(1764),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [234] = {
    [sym_import] = STATE(1301),
    [sym_statement_block] = STATE(1088),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1301),
    [sym_yield_expression] = STATE(1301),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1301),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1301),
    [sym_arrow_function] = STATE(1301),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1301),
    [sym_new_expression] = STATE(1301),
    [sym_await_expression] = STATE(1301),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1301),
    [sym_augmented_assignment_expression] = STATE(1301),
    [sym_ternary_expression] = STATE(1301),
    [sym_binary_expression] = STATE(1301),
    [sym_unary_expression] = STATE(1301),
    [sym_update_expression] = STATE(1301),
    [sym_string] = STATE(1301),
    [sym_template_string] = STATE(1301),
    [sym_regex] = STATE(1301),
    [sym_meta_property] = STATE(1301),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1301),
    [sym_type_assertion] = STATE(1301),
    [sym_as_expression] = STATE(1301),
    [sym_internal_module] = STATE(1301),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1766),
    [sym_this] = ACTIONS(1768),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1768),
    [sym_false] = ACTIONS(1768),
    [sym_null] = ACTIONS(1768),
    [sym_undefined] = ACTIONS(1768),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [235] = {
    [sym_import] = STATE(1153),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1153),
    [sym_yield_expression] = STATE(1153),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_nested_identifier] = STATE(410),
    [sym_class] = STATE(1153),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1153),
    [sym_arrow_function] = STATE(1153),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1153),
    [sym_new_expression] = STATE(1153),
    [sym_await_expression] = STATE(1153),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1153),
    [sym_augmented_assignment_expression] = STATE(1153),
    [sym_ternary_expression] = STATE(1153),
    [sym_binary_expression] = STATE(1153),
    [sym_unary_expression] = STATE(1153),
    [sym_update_expression] = STATE(1153),
    [sym_string] = STATE(1153),
    [sym_template_string] = STATE(1153),
    [sym_regex] = STATE(1153),
    [sym_meta_property] = STATE(1153),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1153),
    [sym_type_assertion] = STATE(1153),
    [sym_as_expression] = STATE(1153),
    [sym_internal_module] = STATE(1153),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(754),
    [sym_this] = ACTIONS(756),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(756),
    [sym_false] = ACTIONS(756),
    [sym_null] = ACTIONS(756),
    [sym_undefined] = ACTIONS(756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [236] = {
    [sym_import] = STATE(1228),
    [sym_statement_block] = STATE(1617),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1228),
    [sym_yield_expression] = STATE(1228),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1228),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1228),
    [sym_arrow_function] = STATE(1228),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1228),
    [sym_new_expression] = STATE(1228),
    [sym_await_expression] = STATE(1228),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1228),
    [sym_augmented_assignment_expression] = STATE(1228),
    [sym_ternary_expression] = STATE(1228),
    [sym_binary_expression] = STATE(1228),
    [sym_unary_expression] = STATE(1228),
    [sym_update_expression] = STATE(1228),
    [sym_string] = STATE(1228),
    [sym_template_string] = STATE(1228),
    [sym_regex] = STATE(1228),
    [sym_meta_property] = STATE(1228),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1228),
    [sym_type_assertion] = STATE(1228),
    [sym_as_expression] = STATE(1228),
    [sym_internal_module] = STATE(1228),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1530),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1772),
    [sym_this] = ACTIONS(1774),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1774),
    [sym_false] = ACTIONS(1774),
    [sym_null] = ACTIONS(1774),
    [sym_undefined] = ACTIONS(1774),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [237] = {
    [sym_import] = STATE(1117),
    [sym_statement_block] = STATE(1418),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1117),
    [sym_yield_expression] = STATE(1117),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1117),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1117),
    [sym_arrow_function] = STATE(1117),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1117),
    [sym_new_expression] = STATE(1117),
    [sym_await_expression] = STATE(1117),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1117),
    [sym_augmented_assignment_expression] = STATE(1117),
    [sym_ternary_expression] = STATE(1117),
    [sym_binary_expression] = STATE(1117),
    [sym_unary_expression] = STATE(1117),
    [sym_update_expression] = STATE(1117),
    [sym_string] = STATE(1117),
    [sym_template_string] = STATE(1117),
    [sym_regex] = STATE(1117),
    [sym_meta_property] = STATE(1117),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1117),
    [sym_type_assertion] = STATE(1117),
    [sym_as_expression] = STATE(1117),
    [sym_internal_module] = STATE(1117),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1776),
    [sym_this] = ACTIONS(1778),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1778),
    [sym_false] = ACTIONS(1778),
    [sym_null] = ACTIONS(1778),
    [sym_undefined] = ACTIONS(1778),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [238] = {
    [sym_import] = STATE(1236),
    [sym_statement_block] = STATE(1621),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1236),
    [sym_yield_expression] = STATE(1236),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1236),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1236),
    [sym_arrow_function] = STATE(1236),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1236),
    [sym_new_expression] = STATE(1236),
    [sym_await_expression] = STATE(1236),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1236),
    [sym_augmented_assignment_expression] = STATE(1236),
    [sym_ternary_expression] = STATE(1236),
    [sym_binary_expression] = STATE(1236),
    [sym_unary_expression] = STATE(1236),
    [sym_update_expression] = STATE(1236),
    [sym_string] = STATE(1236),
    [sym_template_string] = STATE(1236),
    [sym_regex] = STATE(1236),
    [sym_meta_property] = STATE(1236),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1236),
    [sym_type_assertion] = STATE(1236),
    [sym_as_expression] = STATE(1236),
    [sym_internal_module] = STATE(1236),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1530),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1780),
    [sym_this] = ACTIONS(1782),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1782),
    [sym_false] = ACTIONS(1782),
    [sym_null] = ACTIONS(1782),
    [sym_undefined] = ACTIONS(1782),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [239] = {
    [sym_import] = STATE(1238),
    [sym_statement_block] = STATE(1619),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1238),
    [sym_yield_expression] = STATE(1238),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1238),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1238),
    [sym_arrow_function] = STATE(1238),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1238),
    [sym_new_expression] = STATE(1238),
    [sym_await_expression] = STATE(1238),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1238),
    [sym_augmented_assignment_expression] = STATE(1238),
    [sym_ternary_expression] = STATE(1238),
    [sym_binary_expression] = STATE(1238),
    [sym_unary_expression] = STATE(1238),
    [sym_update_expression] = STATE(1238),
    [sym_string] = STATE(1238),
    [sym_template_string] = STATE(1238),
    [sym_regex] = STATE(1238),
    [sym_meta_property] = STATE(1238),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1238),
    [sym_type_assertion] = STATE(1238),
    [sym_as_expression] = STATE(1238),
    [sym_internal_module] = STATE(1238),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1530),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1784),
    [sym_this] = ACTIONS(1786),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1786),
    [sym_false] = ACTIONS(1786),
    [sym_null] = ACTIONS(1786),
    [sym_undefined] = ACTIONS(1786),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [240] = {
    [sym_import] = STATE(1179),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1179),
    [sym_yield_expression] = STATE(1179),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_nested_identifier] = STATE(410),
    [sym_class] = STATE(1179),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1179),
    [sym_arrow_function] = STATE(1179),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1179),
    [sym_new_expression] = STATE(1179),
    [sym_await_expression] = STATE(1179),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1179),
    [sym_augmented_assignment_expression] = STATE(1179),
    [sym_ternary_expression] = STATE(1179),
    [sym_binary_expression] = STATE(1179),
    [sym_unary_expression] = STATE(1179),
    [sym_update_expression] = STATE(1179),
    [sym_string] = STATE(1179),
    [sym_template_string] = STATE(1179),
    [sym_regex] = STATE(1179),
    [sym_meta_property] = STATE(1179),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1179),
    [sym_type_assertion] = STATE(1179),
    [sym_as_expression] = STATE(1179),
    [sym_internal_module] = STATE(1179),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(716),
    [sym_this] = ACTIONS(718),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(718),
    [sym_false] = ACTIONS(718),
    [sym_null] = ACTIONS(718),
    [sym_undefined] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [241] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(652),
    [sym__expression] = STATE(1597),
    [sym_yield_expression] = STATE(1597),
    [sym_object] = STATE(932),
    [sym_array] = STATE(940),
    [sym_class] = STATE(984),
    [sym_function] = STATE(930),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1597),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(1597),
    [sym_member_expression] = STATE(652),
    [sym_subscript_expression] = STATE(652),
    [sym_assignment_expression] = STATE(1597),
    [sym_augmented_assignment_expression] = STATE(1597),
    [sym_ternary_expression] = STATE(1597),
    [sym_binary_expression] = STATE(1597),
    [sym_unary_expression] = STATE(1597),
    [sym_update_expression] = STATE(1597),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2523),
    [sym_non_null_expression] = STATE(1597),
    [sym_type_assertion] = STATE(1597),
    [sym_as_expression] = STATE(1597),
    [sym_internal_module] = STATE(1597),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2727),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1580),
    [anon_sym_export] = ACTIONS(1582),
    [anon_sym_namespace] = ACTIONS(1584),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1582),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(1494),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1586),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1588),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1500),
    [sym_this] = ACTIONS(1502),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [sym_null] = ACTIONS(1502),
    [sym_undefined] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1582),
    [anon_sym_get] = ACTIONS(1582),
    [anon_sym_set] = ACTIONS(1582),
    [anon_sym_declare] = ACTIONS(1582),
    [anon_sym_public] = ACTIONS(1582),
    [anon_sym_private] = ACTIONS(1582),
    [anon_sym_protected] = ACTIONS(1582),
    [anon_sym_module] = ACTIONS(1582),
    [anon_sym_any] = ACTIONS(1582),
    [anon_sym_number] = ACTIONS(1582),
    [anon_sym_boolean] = ACTIONS(1582),
    [anon_sym_string] = ACTIONS(1582),
    [anon_sym_symbol] = ACTIONS(1582),
  },
  [242] = {
    [sym_import] = STATE(1313),
    [sym_statement_block] = STATE(1468),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1313),
    [sym_yield_expression] = STATE(1313),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1313),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1313),
    [sym_arrow_function] = STATE(1313),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1313),
    [sym_new_expression] = STATE(1313),
    [sym_await_expression] = STATE(1313),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1313),
    [sym_augmented_assignment_expression] = STATE(1313),
    [sym_ternary_expression] = STATE(1313),
    [sym_binary_expression] = STATE(1313),
    [sym_unary_expression] = STATE(1313),
    [sym_update_expression] = STATE(1313),
    [sym_string] = STATE(1313),
    [sym_template_string] = STATE(1313),
    [sym_regex] = STATE(1313),
    [sym_meta_property] = STATE(1313),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1313),
    [sym_type_assertion] = STATE(1313),
    [sym_as_expression] = STATE(1313),
    [sym_internal_module] = STATE(1313),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1790),
    [sym_this] = ACTIONS(1792),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1792),
    [sym_false] = ACTIONS(1792),
    [sym_null] = ACTIONS(1792),
    [sym_undefined] = ACTIONS(1792),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [243] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(652),
    [sym__expression] = STATE(1597),
    [sym_yield_expression] = STATE(1597),
    [sym_object] = STATE(932),
    [sym_array] = STATE(940),
    [sym_class] = STATE(984),
    [sym_function] = STATE(930),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1597),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(1597),
    [sym_member_expression] = STATE(652),
    [sym_subscript_expression] = STATE(652),
    [sym_assignment_expression] = STATE(1597),
    [sym_augmented_assignment_expression] = STATE(1597),
    [sym_ternary_expression] = STATE(1597),
    [sym_binary_expression] = STATE(1597),
    [sym_unary_expression] = STATE(1597),
    [sym_update_expression] = STATE(1597),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2523),
    [sym_non_null_expression] = STATE(1597),
    [sym_type_assertion] = STATE(1597),
    [sym_as_expression] = STATE(1597),
    [sym_internal_module] = STATE(1597),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2727),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1488),
    [anon_sym_export] = ACTIONS(1490),
    [anon_sym_namespace] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1490),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(1494),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1496),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1498),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1500),
    [sym_this] = ACTIONS(1502),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [sym_null] = ACTIONS(1502),
    [sym_undefined] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1490),
    [anon_sym_get] = ACTIONS(1490),
    [anon_sym_set] = ACTIONS(1490),
    [anon_sym_declare] = ACTIONS(1490),
    [anon_sym_public] = ACTIONS(1490),
    [anon_sym_private] = ACTIONS(1490),
    [anon_sym_protected] = ACTIONS(1490),
    [anon_sym_module] = ACTIONS(1490),
    [anon_sym_any] = ACTIONS(1490),
    [anon_sym_number] = ACTIONS(1490),
    [anon_sym_boolean] = ACTIONS(1490),
    [anon_sym_string] = ACTIONS(1490),
    [anon_sym_symbol] = ACTIONS(1490),
  },
  [244] = {
    [sym_import] = STATE(982),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(982),
    [sym_yield_expression] = STATE(982),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_nested_identifier] = STATE(410),
    [sym_class] = STATE(982),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(982),
    [sym_arrow_function] = STATE(982),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(982),
    [sym_new_expression] = STATE(982),
    [sym_await_expression] = STATE(982),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(982),
    [sym_augmented_assignment_expression] = STATE(982),
    [sym_ternary_expression] = STATE(982),
    [sym_binary_expression] = STATE(982),
    [sym_unary_expression] = STATE(982),
    [sym_update_expression] = STATE(982),
    [sym_string] = STATE(982),
    [sym_template_string] = STATE(982),
    [sym_regex] = STATE(982),
    [sym_meta_property] = STATE(982),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(982),
    [sym_type_assertion] = STATE(982),
    [sym_as_expression] = STATE(982),
    [sym_internal_module] = STATE(982),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1794),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(579),
    [sym_this] = ACTIONS(581),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_null] = ACTIONS(581),
    [sym_undefined] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [245] = {
    [sym_import] = STATE(1111),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1111),
    [sym_yield_expression] = STATE(1111),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1111),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1111),
    [sym_arrow_function] = STATE(1111),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1111),
    [sym_new_expression] = STATE(1111),
    [sym_await_expression] = STATE(1111),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1111),
    [sym_augmented_assignment_expression] = STATE(1111),
    [sym_ternary_expression] = STATE(1111),
    [sym_binary_expression] = STATE(1111),
    [sym_unary_expression] = STATE(1111),
    [sym_update_expression] = STATE(1111),
    [sym_string] = STATE(1111),
    [sym_template_string] = STATE(1111),
    [sym_regex] = STATE(1111),
    [sym_meta_property] = STATE(1111),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1111),
    [sym_type_assertion] = STATE(1111),
    [sym_as_expression] = STATE(1111),
    [sym_internal_module] = STATE(1111),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1796),
    [sym_this] = ACTIONS(1798),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1798),
    [sym_false] = ACTIONS(1798),
    [sym_null] = ACTIONS(1798),
    [sym_undefined] = ACTIONS(1798),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [246] = {
    [sym_import] = STATE(1311),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1311),
    [sym_yield_expression] = STATE(1311),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1311),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1311),
    [sym_arrow_function] = STATE(1311),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1311),
    [sym_new_expression] = STATE(1311),
    [sym_await_expression] = STATE(1311),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1311),
    [sym_augmented_assignment_expression] = STATE(1311),
    [sym_ternary_expression] = STATE(1311),
    [sym_binary_expression] = STATE(1311),
    [sym_unary_expression] = STATE(1311),
    [sym_update_expression] = STATE(1311),
    [sym_string] = STATE(1311),
    [sym_template_string] = STATE(1311),
    [sym_regex] = STATE(1311),
    [sym_meta_property] = STATE(1311),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1311),
    [sym_as_expression] = STATE(1311),
    [sym_internal_module] = STATE(1311),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1800),
    [sym_this] = ACTIONS(1802),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1802),
    [sym_false] = ACTIONS(1802),
    [sym_null] = ACTIONS(1802),
    [sym_undefined] = ACTIONS(1802),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [247] = {
    [sym_import] = STATE(1260),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1260),
    [sym_yield_expression] = STATE(1260),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1260),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1260),
    [sym_arrow_function] = STATE(1260),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1260),
    [sym_new_expression] = STATE(1260),
    [sym_await_expression] = STATE(1260),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1260),
    [sym_augmented_assignment_expression] = STATE(1260),
    [sym_ternary_expression] = STATE(1260),
    [sym_binary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1260),
    [sym_update_expression] = STATE(1260),
    [sym_string] = STATE(1260),
    [sym_template_string] = STATE(1260),
    [sym_regex] = STATE(1260),
    [sym_meta_property] = STATE(1260),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1260),
    [sym_type_assertion] = STATE(1260),
    [sym_as_expression] = STATE(1260),
    [sym_internal_module] = STATE(1260),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1804),
    [sym_this] = ACTIONS(1806),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1806),
    [sym_false] = ACTIONS(1806),
    [sym_null] = ACTIONS(1806),
    [sym_undefined] = ACTIONS(1806),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [248] = {
    [sym_import] = STATE(1257),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1257),
    [sym_yield_expression] = STATE(1257),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1257),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1257),
    [sym_arrow_function] = STATE(1257),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1257),
    [sym_new_expression] = STATE(1257),
    [sym_await_expression] = STATE(1257),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1257),
    [sym_augmented_assignment_expression] = STATE(1257),
    [sym_ternary_expression] = STATE(1257),
    [sym_binary_expression] = STATE(1257),
    [sym_unary_expression] = STATE(1257),
    [sym_update_expression] = STATE(1257),
    [sym_string] = STATE(1257),
    [sym_template_string] = STATE(1257),
    [sym_regex] = STATE(1257),
    [sym_meta_property] = STATE(1257),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1257),
    [sym_type_assertion] = STATE(1257),
    [sym_as_expression] = STATE(1257),
    [sym_internal_module] = STATE(1257),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1808),
    [sym_this] = ACTIONS(1810),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1810),
    [sym_false] = ACTIONS(1810),
    [sym_null] = ACTIONS(1810),
    [sym_undefined] = ACTIONS(1810),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [249] = {
    [sym_import] = STATE(1247),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1247),
    [sym_yield_expression] = STATE(1247),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1247),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1247),
    [sym_arrow_function] = STATE(1247),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1247),
    [sym_new_expression] = STATE(1247),
    [sym_await_expression] = STATE(1247),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1247),
    [sym_augmented_assignment_expression] = STATE(1247),
    [sym_ternary_expression] = STATE(1247),
    [sym_binary_expression] = STATE(1247),
    [sym_unary_expression] = STATE(1247),
    [sym_update_expression] = STATE(1247),
    [sym_string] = STATE(1247),
    [sym_template_string] = STATE(1247),
    [sym_regex] = STATE(1247),
    [sym_meta_property] = STATE(1247),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1247),
    [sym_type_assertion] = STATE(1247),
    [sym_as_expression] = STATE(1247),
    [sym_internal_module] = STATE(1247),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1812),
    [sym_this] = ACTIONS(1814),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1814),
    [sym_false] = ACTIONS(1814),
    [sym_null] = ACTIONS(1814),
    [sym_undefined] = ACTIONS(1814),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [250] = {
    [sym_import] = STATE(1258),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1258),
    [sym_yield_expression] = STATE(1258),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1258),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1258),
    [sym_arrow_function] = STATE(1258),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1258),
    [sym_new_expression] = STATE(1258),
    [sym_await_expression] = STATE(1258),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1258),
    [sym_augmented_assignment_expression] = STATE(1258),
    [sym_ternary_expression] = STATE(1258),
    [sym_binary_expression] = STATE(1258),
    [sym_unary_expression] = STATE(1258),
    [sym_update_expression] = STATE(1258),
    [sym_string] = STATE(1258),
    [sym_template_string] = STATE(1258),
    [sym_regex] = STATE(1258),
    [sym_meta_property] = STATE(1258),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1258),
    [sym_type_assertion] = STATE(1258),
    [sym_as_expression] = STATE(1258),
    [sym_internal_module] = STATE(1258),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1816),
    [sym_this] = ACTIONS(971),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(971),
    [sym_false] = ACTIONS(971),
    [sym_null] = ACTIONS(971),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [251] = {
    [sym_import] = STATE(1419),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1419),
    [sym_yield_expression] = STATE(1419),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1419),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1419),
    [sym_arrow_function] = STATE(1419),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1419),
    [sym_new_expression] = STATE(1419),
    [sym_await_expression] = STATE(1419),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1419),
    [sym_augmented_assignment_expression] = STATE(1419),
    [sym_ternary_expression] = STATE(1419),
    [sym_binary_expression] = STATE(1419),
    [sym_unary_expression] = STATE(1419),
    [sym_update_expression] = STATE(1419),
    [sym_string] = STATE(1419),
    [sym_template_string] = STATE(1419),
    [sym_regex] = STATE(1419),
    [sym_meta_property] = STATE(1419),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1419),
    [sym_type_assertion] = STATE(1419),
    [sym_as_expression] = STATE(1419),
    [sym_internal_module] = STATE(1419),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1818),
    [sym_this] = ACTIONS(1820),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1820),
    [sym_false] = ACTIONS(1820),
    [sym_null] = ACTIONS(1820),
    [sym_undefined] = ACTIONS(1820),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [252] = {
    [sym_import] = STATE(1248),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1248),
    [sym_yield_expression] = STATE(1248),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1248),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1248),
    [sym_arrow_function] = STATE(1248),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1248),
    [sym_new_expression] = STATE(1248),
    [sym_await_expression] = STATE(1248),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1248),
    [sym_augmented_assignment_expression] = STATE(1248),
    [sym_ternary_expression] = STATE(1248),
    [sym_binary_expression] = STATE(1248),
    [sym_unary_expression] = STATE(1248),
    [sym_update_expression] = STATE(1248),
    [sym_string] = STATE(1248),
    [sym_template_string] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_meta_property] = STATE(1248),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1248),
    [sym_type_assertion] = STATE(1248),
    [sym_as_expression] = STATE(1248),
    [sym_internal_module] = STATE(1248),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1822),
    [sym_this] = ACTIONS(1824),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1824),
    [sym_false] = ACTIONS(1824),
    [sym_null] = ACTIONS(1824),
    [sym_undefined] = ACTIONS(1824),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [253] = {
    [sym_import] = STATE(1220),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1220),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1220),
    [sym_arrow_function] = STATE(1220),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1220),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1220),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1826),
    [sym_this] = ACTIONS(1828),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1828),
    [sym_false] = ACTIONS(1828),
    [sym_null] = ACTIONS(1828),
    [sym_undefined] = ACTIONS(1828),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [254] = {
    [sym_import] = STATE(1271),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1271),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1271),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1271),
    [sym_arrow_function] = STATE(1271),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_ternary_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_update_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_regex] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1271),
    [sym_type_assertion] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1830),
    [sym_this] = ACTIONS(1832),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1832),
    [sym_false] = ACTIONS(1832),
    [sym_null] = ACTIONS(1832),
    [sym_undefined] = ACTIONS(1832),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [255] = {
    [sym_import] = STATE(1273),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1273),
    [sym_yield_expression] = STATE(1273),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1273),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1273),
    [sym_arrow_function] = STATE(1273),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1273),
    [sym_new_expression] = STATE(1273),
    [sym_await_expression] = STATE(1273),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1273),
    [sym_augmented_assignment_expression] = STATE(1273),
    [sym_ternary_expression] = STATE(1273),
    [sym_binary_expression] = STATE(1273),
    [sym_unary_expression] = STATE(1273),
    [sym_update_expression] = STATE(1273),
    [sym_string] = STATE(1273),
    [sym_template_string] = STATE(1273),
    [sym_regex] = STATE(1273),
    [sym_meta_property] = STATE(1273),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(1273),
    [sym_as_expression] = STATE(1273),
    [sym_internal_module] = STATE(1273),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1834),
    [sym_this] = ACTIONS(1836),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1836),
    [sym_false] = ACTIONS(1836),
    [sym_null] = ACTIONS(1836),
    [sym_undefined] = ACTIONS(1836),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [256] = {
    [sym_import] = STATE(1204),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1204),
    [sym_yield_expression] = STATE(1204),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1204),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1204),
    [sym_arrow_function] = STATE(1204),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1204),
    [sym_new_expression] = STATE(1204),
    [sym_await_expression] = STATE(1204),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1204),
    [sym_augmented_assignment_expression] = STATE(1204),
    [sym_ternary_expression] = STATE(1204),
    [sym_binary_expression] = STATE(1204),
    [sym_unary_expression] = STATE(1204),
    [sym_update_expression] = STATE(1204),
    [sym_string] = STATE(1204),
    [sym_template_string] = STATE(1204),
    [sym_regex] = STATE(1204),
    [sym_meta_property] = STATE(1204),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1204),
    [sym_type_assertion] = STATE(1204),
    [sym_as_expression] = STATE(1204),
    [sym_internal_module] = STATE(1204),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1838),
    [sym_this] = ACTIONS(1840),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1840),
    [sym_false] = ACTIONS(1840),
    [sym_null] = ACTIONS(1840),
    [sym_undefined] = ACTIONS(1840),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [257] = {
    [sym_import] = STATE(1124),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1124),
    [sym_yield_expression] = STATE(1124),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1124),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1124),
    [sym_arrow_function] = STATE(1124),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1124),
    [sym_new_expression] = STATE(1124),
    [sym_await_expression] = STATE(1124),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1124),
    [sym_augmented_assignment_expression] = STATE(1124),
    [sym_ternary_expression] = STATE(1124),
    [sym_binary_expression] = STATE(1124),
    [sym_unary_expression] = STATE(1124),
    [sym_update_expression] = STATE(1124),
    [sym_string] = STATE(1124),
    [sym_template_string] = STATE(1124),
    [sym_regex] = STATE(1124),
    [sym_meta_property] = STATE(1124),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1124),
    [sym_as_expression] = STATE(1124),
    [sym_internal_module] = STATE(1124),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1842),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [258] = {
    [sym_import] = STATE(958),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(958),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(958),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(958),
    [sym_arrow_function] = STATE(958),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(958),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(958),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(958),
    [sym_template_string] = STATE(958),
    [sym_regex] = STATE(958),
    [sym_meta_property] = STATE(958),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(958),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_internal_module] = STATE(958),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1846),
    [sym_this] = ACTIONS(1848),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [sym_undefined] = ACTIONS(1848),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [259] = {
    [sym_import] = STATE(959),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(959),
    [sym_yield_expression] = STATE(959),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(959),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(959),
    [sym_arrow_function] = STATE(959),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(959),
    [sym_new_expression] = STATE(959),
    [sym_await_expression] = STATE(959),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(959),
    [sym_augmented_assignment_expression] = STATE(959),
    [sym_ternary_expression] = STATE(959),
    [sym_binary_expression] = STATE(959),
    [sym_unary_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_string] = STATE(959),
    [sym_template_string] = STATE(959),
    [sym_regex] = STATE(959),
    [sym_meta_property] = STATE(959),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(959),
    [sym_type_assertion] = STATE(959),
    [sym_as_expression] = STATE(959),
    [sym_internal_module] = STATE(959),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1850),
    [sym_this] = ACTIONS(1852),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1852),
    [sym_false] = ACTIONS(1852),
    [sym_null] = ACTIONS(1852),
    [sym_undefined] = ACTIONS(1852),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [260] = {
    [sym_import] = STATE(1095),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1095),
    [sym_yield_expression] = STATE(1095),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1095),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1095),
    [sym_arrow_function] = STATE(1095),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1095),
    [sym_new_expression] = STATE(1095),
    [sym_await_expression] = STATE(1095),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1095),
    [sym_augmented_assignment_expression] = STATE(1095),
    [sym_ternary_expression] = STATE(1095),
    [sym_binary_expression] = STATE(1095),
    [sym_unary_expression] = STATE(1095),
    [sym_update_expression] = STATE(1095),
    [sym_string] = STATE(1095),
    [sym_template_string] = STATE(1095),
    [sym_regex] = STATE(1095),
    [sym_meta_property] = STATE(1095),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1095),
    [sym_type_assertion] = STATE(1095),
    [sym_as_expression] = STATE(1095),
    [sym_internal_module] = STATE(1095),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1854),
    [sym_this] = ACTIONS(1856),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1856),
    [sym_false] = ACTIONS(1856),
    [sym_null] = ACTIONS(1856),
    [sym_undefined] = ACTIONS(1856),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [261] = {
    [sym_import] = STATE(1329),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1329),
    [sym_yield_expression] = STATE(1329),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1329),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1329),
    [sym_arrow_function] = STATE(1329),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1329),
    [sym_new_expression] = STATE(1329),
    [sym_await_expression] = STATE(1329),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1329),
    [sym_augmented_assignment_expression] = STATE(1329),
    [sym_ternary_expression] = STATE(1329),
    [sym_binary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1329),
    [sym_update_expression] = STATE(1329),
    [sym_string] = STATE(1329),
    [sym_template_string] = STATE(1329),
    [sym_regex] = STATE(1329),
    [sym_meta_property] = STATE(1329),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1329),
    [sym_type_assertion] = STATE(1329),
    [sym_as_expression] = STATE(1329),
    [sym_internal_module] = STATE(1329),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(1858),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1860),
    [sym_this] = ACTIONS(1862),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1862),
    [sym_false] = ACTIONS(1862),
    [sym_null] = ACTIONS(1862),
    [sym_undefined] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [262] = {
    [sym_import] = STATE(1277),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1277),
    [sym_yield_expression] = STATE(1277),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1277),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1277),
    [sym_arrow_function] = STATE(1277),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1277),
    [sym_new_expression] = STATE(1277),
    [sym_await_expression] = STATE(1277),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1277),
    [sym_augmented_assignment_expression] = STATE(1277),
    [sym_ternary_expression] = STATE(1277),
    [sym_binary_expression] = STATE(1277),
    [sym_unary_expression] = STATE(1277),
    [sym_update_expression] = STATE(1277),
    [sym_string] = STATE(1277),
    [sym_template_string] = STATE(1277),
    [sym_regex] = STATE(1277),
    [sym_meta_property] = STATE(1277),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1277),
    [sym_type_assertion] = STATE(1277),
    [sym_as_expression] = STATE(1277),
    [sym_internal_module] = STATE(1277),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1864),
    [sym_this] = ACTIONS(1866),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1866),
    [sym_false] = ACTIONS(1866),
    [sym_null] = ACTIONS(1866),
    [sym_undefined] = ACTIONS(1866),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [263] = {
    [sym_import] = STATE(1140),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1140),
    [sym_yield_expression] = STATE(1140),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1140),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1140),
    [sym_arrow_function] = STATE(1140),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1140),
    [sym_new_expression] = STATE(1140),
    [sym_await_expression] = STATE(1140),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1140),
    [sym_augmented_assignment_expression] = STATE(1140),
    [sym_ternary_expression] = STATE(1140),
    [sym_binary_expression] = STATE(1140),
    [sym_unary_expression] = STATE(1140),
    [sym_update_expression] = STATE(1140),
    [sym_string] = STATE(1140),
    [sym_template_string] = STATE(1140),
    [sym_regex] = STATE(1140),
    [sym_meta_property] = STATE(1140),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1140),
    [sym_as_expression] = STATE(1140),
    [sym_internal_module] = STATE(1140),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1868),
    [sym_this] = ACTIONS(1870),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1870),
    [sym_false] = ACTIONS(1870),
    [sym_null] = ACTIONS(1870),
    [sym_undefined] = ACTIONS(1870),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [264] = {
    [sym_import] = STATE(963),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(963),
    [sym_yield_expression] = STATE(963),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(963),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(963),
    [sym_arrow_function] = STATE(963),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(963),
    [sym_new_expression] = STATE(963),
    [sym_await_expression] = STATE(963),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(963),
    [sym_augmented_assignment_expression] = STATE(963),
    [sym_ternary_expression] = STATE(963),
    [sym_binary_expression] = STATE(963),
    [sym_unary_expression] = STATE(963),
    [sym_update_expression] = STATE(963),
    [sym_string] = STATE(963),
    [sym_template_string] = STATE(963),
    [sym_regex] = STATE(963),
    [sym_meta_property] = STATE(963),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(963),
    [sym_type_assertion] = STATE(963),
    [sym_as_expression] = STATE(963),
    [sym_internal_module] = STATE(963),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1872),
    [sym_this] = ACTIONS(1874),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1874),
    [sym_false] = ACTIONS(1874),
    [sym_null] = ACTIONS(1874),
    [sym_undefined] = ACTIONS(1874),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [265] = {
    [sym_import] = STATE(1220),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1220),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1220),
    [sym_arrow_function] = STATE(1220),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1220),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1220),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1876),
    [sym_this] = ACTIONS(1828),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1828),
    [sym_false] = ACTIONS(1828),
    [sym_null] = ACTIONS(1828),
    [sym_undefined] = ACTIONS(1828),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [266] = {
    [sym_import] = STATE(964),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(964),
    [sym_yield_expression] = STATE(964),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(964),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(964),
    [sym_arrow_function] = STATE(964),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(964),
    [sym_new_expression] = STATE(964),
    [sym_await_expression] = STATE(964),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(964),
    [sym_augmented_assignment_expression] = STATE(964),
    [sym_ternary_expression] = STATE(964),
    [sym_binary_expression] = STATE(964),
    [sym_unary_expression] = STATE(964),
    [sym_update_expression] = STATE(964),
    [sym_string] = STATE(964),
    [sym_template_string] = STATE(964),
    [sym_regex] = STATE(964),
    [sym_meta_property] = STATE(964),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(964),
    [sym_type_assertion] = STATE(964),
    [sym_as_expression] = STATE(964),
    [sym_internal_module] = STATE(964),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1878),
    [sym_this] = ACTIONS(1880),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1880),
    [sym_false] = ACTIONS(1880),
    [sym_null] = ACTIONS(1880),
    [sym_undefined] = ACTIONS(1880),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [267] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1882),
    [sym_this] = ACTIONS(1884),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1884),
    [sym_false] = ACTIONS(1884),
    [sym_null] = ACTIONS(1884),
    [sym_undefined] = ACTIONS(1884),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [268] = {
    [sym_import] = STATE(1294),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1294),
    [sym_yield_expression] = STATE(1294),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1294),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1294),
    [sym_arrow_function] = STATE(1294),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1294),
    [sym_new_expression] = STATE(1294),
    [sym_await_expression] = STATE(1294),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1294),
    [sym_augmented_assignment_expression] = STATE(1294),
    [sym_ternary_expression] = STATE(1294),
    [sym_binary_expression] = STATE(1294),
    [sym_unary_expression] = STATE(1294),
    [sym_update_expression] = STATE(1294),
    [sym_string] = STATE(1294),
    [sym_template_string] = STATE(1294),
    [sym_regex] = STATE(1294),
    [sym_meta_property] = STATE(1294),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1294),
    [sym_type_assertion] = STATE(1294),
    [sym_as_expression] = STATE(1294),
    [sym_internal_module] = STATE(1294),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1886),
    [sym_this] = ACTIONS(1888),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1888),
    [sym_false] = ACTIONS(1888),
    [sym_null] = ACTIONS(1888),
    [sym_undefined] = ACTIONS(1888),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [269] = {
    [sym_import] = STATE(966),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(966),
    [sym_yield_expression] = STATE(966),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(966),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(966),
    [sym_arrow_function] = STATE(966),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(966),
    [sym_new_expression] = STATE(966),
    [sym_await_expression] = STATE(966),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(966),
    [sym_augmented_assignment_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym_update_expression] = STATE(966),
    [sym_string] = STATE(966),
    [sym_template_string] = STATE(966),
    [sym_regex] = STATE(966),
    [sym_meta_property] = STATE(966),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(966),
    [sym_type_assertion] = STATE(966),
    [sym_as_expression] = STATE(966),
    [sym_internal_module] = STATE(966),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1890),
    [sym_this] = ACTIONS(1892),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1892),
    [sym_false] = ACTIONS(1892),
    [sym_null] = ACTIONS(1892),
    [sym_undefined] = ACTIONS(1892),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [270] = {
    [sym_import] = STATE(1030),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1030),
    [sym_yield_expression] = STATE(1030),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1030),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1030),
    [sym_arrow_function] = STATE(1030),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1030),
    [sym_new_expression] = STATE(1030),
    [sym_await_expression] = STATE(1030),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1030),
    [sym_augmented_assignment_expression] = STATE(1030),
    [sym_ternary_expression] = STATE(1030),
    [sym_binary_expression] = STATE(1030),
    [sym_unary_expression] = STATE(1030),
    [sym_update_expression] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_template_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [sym_meta_property] = STATE(1030),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1030),
    [sym_type_assertion] = STATE(1030),
    [sym_as_expression] = STATE(1030),
    [sym_internal_module] = STATE(1030),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1894),
    [sym_this] = ACTIONS(1896),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1896),
    [sym_false] = ACTIONS(1896),
    [sym_null] = ACTIONS(1896),
    [sym_undefined] = ACTIONS(1896),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [271] = {
    [sym_import] = STATE(1279),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1279),
    [sym_yield_expression] = STATE(1279),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1279),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1279),
    [sym_arrow_function] = STATE(1279),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1279),
    [sym_new_expression] = STATE(1279),
    [sym_await_expression] = STATE(1279),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1279),
    [sym_augmented_assignment_expression] = STATE(1279),
    [sym_ternary_expression] = STATE(1279),
    [sym_binary_expression] = STATE(1279),
    [sym_unary_expression] = STATE(1279),
    [sym_update_expression] = STATE(1279),
    [sym_string] = STATE(1279),
    [sym_template_string] = STATE(1279),
    [sym_regex] = STATE(1279),
    [sym_meta_property] = STATE(1279),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1279),
    [sym_type_assertion] = STATE(1279),
    [sym_as_expression] = STATE(1279),
    [sym_internal_module] = STATE(1279),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1898),
    [sym_this] = ACTIONS(1900),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1900),
    [sym_false] = ACTIONS(1900),
    [sym_null] = ACTIONS(1900),
    [sym_undefined] = ACTIONS(1900),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [272] = {
    [sym_import] = STATE(976),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(976),
    [sym_yield_expression] = STATE(976),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(976),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(976),
    [sym_arrow_function] = STATE(976),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(976),
    [sym_new_expression] = STATE(976),
    [sym_await_expression] = STATE(976),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(976),
    [sym_augmented_assignment_expression] = STATE(976),
    [sym_ternary_expression] = STATE(976),
    [sym_binary_expression] = STATE(976),
    [sym_unary_expression] = STATE(976),
    [sym_update_expression] = STATE(976),
    [sym_string] = STATE(976),
    [sym_template_string] = STATE(976),
    [sym_regex] = STATE(976),
    [sym_meta_property] = STATE(976),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(976),
    [sym_type_assertion] = STATE(976),
    [sym_as_expression] = STATE(976),
    [sym_internal_module] = STATE(976),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1902),
    [sym_this] = ACTIONS(1904),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1904),
    [sym_false] = ACTIONS(1904),
    [sym_null] = ACTIONS(1904),
    [sym_undefined] = ACTIONS(1904),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [273] = {
    [sym_import] = STATE(1018),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1018),
    [sym_yield_expression] = STATE(1018),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1018),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1018),
    [sym_arrow_function] = STATE(1018),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1018),
    [sym_new_expression] = STATE(1018),
    [sym_await_expression] = STATE(1018),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1018),
    [sym_augmented_assignment_expression] = STATE(1018),
    [sym_ternary_expression] = STATE(1018),
    [sym_binary_expression] = STATE(1018),
    [sym_unary_expression] = STATE(1018),
    [sym_update_expression] = STATE(1018),
    [sym_string] = STATE(1018),
    [sym_template_string] = STATE(1018),
    [sym_regex] = STATE(1018),
    [sym_meta_property] = STATE(1018),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1018),
    [sym_type_assertion] = STATE(1018),
    [sym_as_expression] = STATE(1018),
    [sym_internal_module] = STATE(1018),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(941),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(941),
    [sym_false] = ACTIONS(941),
    [sym_null] = ACTIONS(941),
    [sym_undefined] = ACTIONS(941),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [274] = {
    [sym_import] = STATE(1274),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1274),
    [sym_yield_expression] = STATE(1274),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1274),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1274),
    [sym_arrow_function] = STATE(1274),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1274),
    [sym_new_expression] = STATE(1274),
    [sym_await_expression] = STATE(1274),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1274),
    [sym_augmented_assignment_expression] = STATE(1274),
    [sym_ternary_expression] = STATE(1274),
    [sym_binary_expression] = STATE(1274),
    [sym_unary_expression] = STATE(1274),
    [sym_update_expression] = STATE(1274),
    [sym_string] = STATE(1274),
    [sym_template_string] = STATE(1274),
    [sym_regex] = STATE(1274),
    [sym_meta_property] = STATE(1274),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1274),
    [sym_type_assertion] = STATE(1274),
    [sym_as_expression] = STATE(1274),
    [sym_internal_module] = STATE(1274),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1908),
    [sym_this] = ACTIONS(1910),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [sym_null] = ACTIONS(1910),
    [sym_undefined] = ACTIONS(1910),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [275] = {
    [sym_import] = STATE(1411),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1411),
    [sym_yield_expression] = STATE(1411),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1411),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1411),
    [sym_arrow_function] = STATE(1411),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1411),
    [sym_new_expression] = STATE(1411),
    [sym_await_expression] = STATE(1411),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1411),
    [sym_augmented_assignment_expression] = STATE(1411),
    [sym_ternary_expression] = STATE(1411),
    [sym_binary_expression] = STATE(1411),
    [sym_unary_expression] = STATE(1411),
    [sym_update_expression] = STATE(1411),
    [sym_string] = STATE(1411),
    [sym_template_string] = STATE(1411),
    [sym_regex] = STATE(1411),
    [sym_meta_property] = STATE(1411),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1411),
    [sym_type_assertion] = STATE(1411),
    [sym_as_expression] = STATE(1411),
    [sym_internal_module] = STATE(1411),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1912),
    [sym_this] = ACTIONS(1914),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1914),
    [sym_false] = ACTIONS(1914),
    [sym_null] = ACTIONS(1914),
    [sym_undefined] = ACTIONS(1914),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [276] = {
    [sym_import] = STATE(1133),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1133),
    [sym_yield_expression] = STATE(1133),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1133),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1133),
    [sym_arrow_function] = STATE(1133),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1133),
    [sym_new_expression] = STATE(1133),
    [sym_await_expression] = STATE(1133),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1133),
    [sym_augmented_assignment_expression] = STATE(1133),
    [sym_ternary_expression] = STATE(1133),
    [sym_binary_expression] = STATE(1133),
    [sym_unary_expression] = STATE(1133),
    [sym_update_expression] = STATE(1133),
    [sym_string] = STATE(1133),
    [sym_template_string] = STATE(1133),
    [sym_regex] = STATE(1133),
    [sym_meta_property] = STATE(1133),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1133),
    [sym_type_assertion] = STATE(1133),
    [sym_as_expression] = STATE(1133),
    [sym_internal_module] = STATE(1133),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1916),
    [sym_this] = ACTIONS(1918),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1918),
    [sym_false] = ACTIONS(1918),
    [sym_null] = ACTIONS(1918),
    [sym_undefined] = ACTIONS(1918),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [277] = {
    [sym_import] = STATE(1094),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1094),
    [sym_yield_expression] = STATE(1094),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1094),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1094),
    [sym_arrow_function] = STATE(1094),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1094),
    [sym_new_expression] = STATE(1094),
    [sym_await_expression] = STATE(1094),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1094),
    [sym_augmented_assignment_expression] = STATE(1094),
    [sym_ternary_expression] = STATE(1094),
    [sym_binary_expression] = STATE(1094),
    [sym_unary_expression] = STATE(1094),
    [sym_update_expression] = STATE(1094),
    [sym_string] = STATE(1094),
    [sym_template_string] = STATE(1094),
    [sym_regex] = STATE(1094),
    [sym_meta_property] = STATE(1094),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1094),
    [sym_as_expression] = STATE(1094),
    [sym_internal_module] = STATE(1094),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1920),
    [sym_this] = ACTIONS(1922),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1922),
    [sym_false] = ACTIONS(1922),
    [sym_null] = ACTIONS(1922),
    [sym_undefined] = ACTIONS(1922),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [278] = {
    [sym_import] = STATE(1073),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1073),
    [sym_yield_expression] = STATE(1073),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1073),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1073),
    [sym_arrow_function] = STATE(1073),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1073),
    [sym_new_expression] = STATE(1073),
    [sym_await_expression] = STATE(1073),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1073),
    [sym_augmented_assignment_expression] = STATE(1073),
    [sym_ternary_expression] = STATE(1073),
    [sym_binary_expression] = STATE(1073),
    [sym_unary_expression] = STATE(1073),
    [sym_update_expression] = STATE(1073),
    [sym_string] = STATE(1073),
    [sym_template_string] = STATE(1073),
    [sym_regex] = STATE(1073),
    [sym_meta_property] = STATE(1073),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1073),
    [sym_type_assertion] = STATE(1073),
    [sym_as_expression] = STATE(1073),
    [sym_internal_module] = STATE(1073),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1924),
    [sym_this] = ACTIONS(1926),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1926),
    [sym_false] = ACTIONS(1926),
    [sym_null] = ACTIONS(1926),
    [sym_undefined] = ACTIONS(1926),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [279] = {
    [sym_import] = STATE(1015),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1015),
    [sym_yield_expression] = STATE(1015),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1015),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1015),
    [sym_arrow_function] = STATE(1015),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1015),
    [sym_new_expression] = STATE(1015),
    [sym_await_expression] = STATE(1015),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1015),
    [sym_augmented_assignment_expression] = STATE(1015),
    [sym_ternary_expression] = STATE(1015),
    [sym_binary_expression] = STATE(1015),
    [sym_unary_expression] = STATE(1015),
    [sym_update_expression] = STATE(1015),
    [sym_string] = STATE(1015),
    [sym_template_string] = STATE(1015),
    [sym_regex] = STATE(1015),
    [sym_meta_property] = STATE(1015),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1015),
    [sym_type_assertion] = STATE(1015),
    [sym_as_expression] = STATE(1015),
    [sym_internal_module] = STATE(1015),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1928),
    [sym_this] = ACTIONS(1930),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [280] = {
    [sym_import] = STATE(1190),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1190),
    [sym_yield_expression] = STATE(1190),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1190),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1190),
    [sym_arrow_function] = STATE(1190),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1190),
    [sym_new_expression] = STATE(1190),
    [sym_await_expression] = STATE(1190),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1190),
    [sym_augmented_assignment_expression] = STATE(1190),
    [sym_ternary_expression] = STATE(1190),
    [sym_binary_expression] = STATE(1190),
    [sym_unary_expression] = STATE(1190),
    [sym_update_expression] = STATE(1190),
    [sym_string] = STATE(1190),
    [sym_template_string] = STATE(1190),
    [sym_regex] = STATE(1190),
    [sym_meta_property] = STATE(1190),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1190),
    [sym_type_assertion] = STATE(1190),
    [sym_as_expression] = STATE(1190),
    [sym_internal_module] = STATE(1190),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1932),
    [sym_this] = ACTIONS(1934),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1934),
    [sym_false] = ACTIONS(1934),
    [sym_null] = ACTIONS(1934),
    [sym_undefined] = ACTIONS(1934),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [281] = {
    [sym_import] = STATE(1136),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1136),
    [sym_yield_expression] = STATE(1136),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1136),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1136),
    [sym_arrow_function] = STATE(1136),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1136),
    [sym_new_expression] = STATE(1136),
    [sym_await_expression] = STATE(1136),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1136),
    [sym_augmented_assignment_expression] = STATE(1136),
    [sym_ternary_expression] = STATE(1136),
    [sym_binary_expression] = STATE(1136),
    [sym_unary_expression] = STATE(1136),
    [sym_update_expression] = STATE(1136),
    [sym_string] = STATE(1136),
    [sym_template_string] = STATE(1136),
    [sym_regex] = STATE(1136),
    [sym_meta_property] = STATE(1136),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1136),
    [sym_as_expression] = STATE(1136),
    [sym_internal_module] = STATE(1136),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1936),
    [sym_this] = ACTIONS(1938),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [sym_null] = ACTIONS(1938),
    [sym_undefined] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [282] = {
    [sym_import] = STATE(1064),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1064),
    [sym_yield_expression] = STATE(1064),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1064),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1064),
    [sym_arrow_function] = STATE(1064),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1064),
    [sym_new_expression] = STATE(1064),
    [sym_await_expression] = STATE(1064),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1064),
    [sym_augmented_assignment_expression] = STATE(1064),
    [sym_ternary_expression] = STATE(1064),
    [sym_binary_expression] = STATE(1064),
    [sym_unary_expression] = STATE(1064),
    [sym_update_expression] = STATE(1064),
    [sym_string] = STATE(1064),
    [sym_template_string] = STATE(1064),
    [sym_regex] = STATE(1064),
    [sym_meta_property] = STATE(1064),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1064),
    [sym_type_assertion] = STATE(1064),
    [sym_as_expression] = STATE(1064),
    [sym_internal_module] = STATE(1064),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1940),
    [sym_this] = ACTIONS(1942),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1942),
    [sym_false] = ACTIONS(1942),
    [sym_null] = ACTIONS(1942),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [283] = {
    [sym_import] = STATE(1063),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1063),
    [sym_yield_expression] = STATE(1063),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1063),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1063),
    [sym_arrow_function] = STATE(1063),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1063),
    [sym_new_expression] = STATE(1063),
    [sym_await_expression] = STATE(1063),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1063),
    [sym_augmented_assignment_expression] = STATE(1063),
    [sym_ternary_expression] = STATE(1063),
    [sym_binary_expression] = STATE(1063),
    [sym_unary_expression] = STATE(1063),
    [sym_update_expression] = STATE(1063),
    [sym_string] = STATE(1063),
    [sym_template_string] = STATE(1063),
    [sym_regex] = STATE(1063),
    [sym_meta_property] = STATE(1063),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1063),
    [sym_type_assertion] = STATE(1063),
    [sym_as_expression] = STATE(1063),
    [sym_internal_module] = STATE(1063),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1944),
    [sym_this] = ACTIONS(1946),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1946),
    [sym_false] = ACTIONS(1946),
    [sym_null] = ACTIONS(1946),
    [sym_undefined] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [284] = {
    [sym_import] = STATE(1148),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1148),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1148),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1148),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_internal_module] = STATE(1148),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1948),
    [sym_this] = ACTIONS(1950),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1950),
    [sym_false] = ACTIONS(1950),
    [sym_null] = ACTIONS(1950),
    [sym_undefined] = ACTIONS(1950),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [285] = {
    [sym_import] = STATE(1195),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1195),
    [sym_yield_expression] = STATE(1195),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1195),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1195),
    [sym_arrow_function] = STATE(1195),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1195),
    [sym_new_expression] = STATE(1195),
    [sym_await_expression] = STATE(1195),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1195),
    [sym_augmented_assignment_expression] = STATE(1195),
    [sym_ternary_expression] = STATE(1195),
    [sym_binary_expression] = STATE(1195),
    [sym_unary_expression] = STATE(1195),
    [sym_update_expression] = STATE(1195),
    [sym_string] = STATE(1195),
    [sym_template_string] = STATE(1195),
    [sym_regex] = STATE(1195),
    [sym_meta_property] = STATE(1195),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1195),
    [sym_type_assertion] = STATE(1195),
    [sym_as_expression] = STATE(1195),
    [sym_internal_module] = STATE(1195),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1952),
    [sym_this] = ACTIONS(1954),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1954),
    [sym_false] = ACTIONS(1954),
    [sym_null] = ACTIONS(1954),
    [sym_undefined] = ACTIONS(1954),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [286] = {
    [sym_import] = STATE(1292),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1292),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1292),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1292),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_internal_module] = STATE(1292),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1956),
    [sym_this] = ACTIONS(1958),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1958),
    [sym_false] = ACTIONS(1958),
    [sym_null] = ACTIONS(1958),
    [sym_undefined] = ACTIONS(1958),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [287] = {
    [sym_import] = STATE(969),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(969),
    [sym_yield_expression] = STATE(969),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(969),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(969),
    [sym_arrow_function] = STATE(969),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(969),
    [sym_new_expression] = STATE(969),
    [sym_await_expression] = STATE(969),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(969),
    [sym_augmented_assignment_expression] = STATE(969),
    [sym_ternary_expression] = STATE(969),
    [sym_binary_expression] = STATE(969),
    [sym_unary_expression] = STATE(969),
    [sym_update_expression] = STATE(969),
    [sym_string] = STATE(969),
    [sym_template_string] = STATE(969),
    [sym_regex] = STATE(969),
    [sym_meta_property] = STATE(969),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(969),
    [sym_type_assertion] = STATE(969),
    [sym_as_expression] = STATE(969),
    [sym_internal_module] = STATE(969),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1960),
    [sym_this] = ACTIONS(1962),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1962),
    [sym_false] = ACTIONS(1962),
    [sym_null] = ACTIONS(1962),
    [sym_undefined] = ACTIONS(1962),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [288] = {
    [sym_import] = STATE(1283),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1283),
    [sym_yield_expression] = STATE(1283),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1283),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1283),
    [sym_arrow_function] = STATE(1283),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1283),
    [sym_new_expression] = STATE(1283),
    [sym_await_expression] = STATE(1283),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1283),
    [sym_augmented_assignment_expression] = STATE(1283),
    [sym_ternary_expression] = STATE(1283),
    [sym_binary_expression] = STATE(1283),
    [sym_unary_expression] = STATE(1283),
    [sym_update_expression] = STATE(1283),
    [sym_string] = STATE(1283),
    [sym_template_string] = STATE(1283),
    [sym_regex] = STATE(1283),
    [sym_meta_property] = STATE(1283),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1283),
    [sym_type_assertion] = STATE(1283),
    [sym_as_expression] = STATE(1283),
    [sym_internal_module] = STATE(1283),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1964),
    [sym_this] = ACTIONS(1966),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1966),
    [sym_false] = ACTIONS(1966),
    [sym_null] = ACTIONS(1966),
    [sym_undefined] = ACTIONS(1966),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [289] = {
    [sym_import] = STATE(1157),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1157),
    [sym_yield_expression] = STATE(1157),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1157),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1157),
    [sym_arrow_function] = STATE(1157),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1157),
    [sym_new_expression] = STATE(1157),
    [sym_await_expression] = STATE(1157),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1157),
    [sym_augmented_assignment_expression] = STATE(1157),
    [sym_ternary_expression] = STATE(1157),
    [sym_binary_expression] = STATE(1157),
    [sym_unary_expression] = STATE(1157),
    [sym_update_expression] = STATE(1157),
    [sym_string] = STATE(1157),
    [sym_template_string] = STATE(1157),
    [sym_regex] = STATE(1157),
    [sym_meta_property] = STATE(1157),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1157),
    [sym_type_assertion] = STATE(1157),
    [sym_as_expression] = STATE(1157),
    [sym_internal_module] = STATE(1157),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1968),
    [sym_this] = ACTIONS(1970),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1970),
    [sym_false] = ACTIONS(1970),
    [sym_null] = ACTIONS(1970),
    [sym_undefined] = ACTIONS(1970),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [290] = {
    [sym_import] = STATE(923),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(923),
    [sym_yield_expression] = STATE(923),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(923),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(923),
    [sym_arrow_function] = STATE(923),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(923),
    [sym_new_expression] = STATE(923),
    [sym_await_expression] = STATE(923),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(923),
    [sym_augmented_assignment_expression] = STATE(923),
    [sym_ternary_expression] = STATE(923),
    [sym_binary_expression] = STATE(923),
    [sym_unary_expression] = STATE(923),
    [sym_update_expression] = STATE(923),
    [sym_string] = STATE(923),
    [sym_template_string] = STATE(923),
    [sym_regex] = STATE(923),
    [sym_meta_property] = STATE(923),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(923),
    [sym_type_assertion] = STATE(923),
    [sym_as_expression] = STATE(923),
    [sym_internal_module] = STATE(923),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1972),
    [sym_this] = ACTIONS(1974),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [sym_null] = ACTIONS(1974),
    [sym_undefined] = ACTIONS(1974),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [291] = {
    [sym_import] = STATE(923),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(923),
    [sym_yield_expression] = STATE(923),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(923),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(923),
    [sym_arrow_function] = STATE(923),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(923),
    [sym_new_expression] = STATE(923),
    [sym_await_expression] = STATE(923),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(923),
    [sym_augmented_assignment_expression] = STATE(923),
    [sym_ternary_expression] = STATE(923),
    [sym_binary_expression] = STATE(923),
    [sym_unary_expression] = STATE(923),
    [sym_update_expression] = STATE(923),
    [sym_string] = STATE(923),
    [sym_template_string] = STATE(923),
    [sym_regex] = STATE(923),
    [sym_meta_property] = STATE(923),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(923),
    [sym_type_assertion] = STATE(923),
    [sym_as_expression] = STATE(923),
    [sym_internal_module] = STATE(923),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1972),
    [sym_this] = ACTIONS(1974),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [sym_null] = ACTIONS(1974),
    [sym_undefined] = ACTIONS(1974),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [292] = {
    [sym_import] = STATE(1173),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1173),
    [sym_yield_expression] = STATE(1173),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1173),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1173),
    [sym_arrow_function] = STATE(1173),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1173),
    [sym_new_expression] = STATE(1173),
    [sym_await_expression] = STATE(1173),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1173),
    [sym_augmented_assignment_expression] = STATE(1173),
    [sym_ternary_expression] = STATE(1173),
    [sym_binary_expression] = STATE(1173),
    [sym_unary_expression] = STATE(1173),
    [sym_update_expression] = STATE(1173),
    [sym_string] = STATE(1173),
    [sym_template_string] = STATE(1173),
    [sym_regex] = STATE(1173),
    [sym_meta_property] = STATE(1173),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1173),
    [sym_type_assertion] = STATE(1173),
    [sym_as_expression] = STATE(1173),
    [sym_internal_module] = STATE(1173),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1976),
    [sym_this] = ACTIONS(1978),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1978),
    [sym_false] = ACTIONS(1978),
    [sym_null] = ACTIONS(1978),
    [sym_undefined] = ACTIONS(1978),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [293] = {
    [sym_import] = STATE(1178),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1178),
    [sym_yield_expression] = STATE(1178),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1178),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1178),
    [sym_arrow_function] = STATE(1178),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1178),
    [sym_new_expression] = STATE(1178),
    [sym_await_expression] = STATE(1178),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1178),
    [sym_augmented_assignment_expression] = STATE(1178),
    [sym_ternary_expression] = STATE(1178),
    [sym_binary_expression] = STATE(1178),
    [sym_unary_expression] = STATE(1178),
    [sym_update_expression] = STATE(1178),
    [sym_string] = STATE(1178),
    [sym_template_string] = STATE(1178),
    [sym_regex] = STATE(1178),
    [sym_meta_property] = STATE(1178),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1178),
    [sym_type_assertion] = STATE(1178),
    [sym_as_expression] = STATE(1178),
    [sym_internal_module] = STATE(1178),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1980),
    [sym_this] = ACTIONS(1982),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1982),
    [sym_false] = ACTIONS(1982),
    [sym_null] = ACTIONS(1982),
    [sym_undefined] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [294] = {
    [sym_import] = STATE(1174),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1174),
    [sym_yield_expression] = STATE(1174),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1174),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1174),
    [sym_arrow_function] = STATE(1174),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1174),
    [sym_new_expression] = STATE(1174),
    [sym_await_expression] = STATE(1174),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1174),
    [sym_augmented_assignment_expression] = STATE(1174),
    [sym_ternary_expression] = STATE(1174),
    [sym_binary_expression] = STATE(1174),
    [sym_unary_expression] = STATE(1174),
    [sym_update_expression] = STATE(1174),
    [sym_string] = STATE(1174),
    [sym_template_string] = STATE(1174),
    [sym_regex] = STATE(1174),
    [sym_meta_property] = STATE(1174),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1174),
    [sym_type_assertion] = STATE(1174),
    [sym_as_expression] = STATE(1174),
    [sym_internal_module] = STATE(1174),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1984),
    [sym_this] = ACTIONS(1986),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1986),
    [sym_false] = ACTIONS(1986),
    [sym_null] = ACTIONS(1986),
    [sym_undefined] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [295] = {
    [sym_import] = STATE(1198),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1198),
    [sym_yield_expression] = STATE(1198),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1198),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1198),
    [sym_arrow_function] = STATE(1198),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1198),
    [sym_new_expression] = STATE(1198),
    [sym_await_expression] = STATE(1198),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1198),
    [sym_augmented_assignment_expression] = STATE(1198),
    [sym_ternary_expression] = STATE(1198),
    [sym_binary_expression] = STATE(1198),
    [sym_unary_expression] = STATE(1198),
    [sym_update_expression] = STATE(1198),
    [sym_string] = STATE(1198),
    [sym_template_string] = STATE(1198),
    [sym_regex] = STATE(1198),
    [sym_meta_property] = STATE(1198),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1198),
    [sym_type_assertion] = STATE(1198),
    [sym_as_expression] = STATE(1198),
    [sym_internal_module] = STATE(1198),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1988),
    [sym_this] = ACTIONS(1990),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_null] = ACTIONS(1990),
    [sym_undefined] = ACTIONS(1990),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [296] = {
    [sym_import] = STATE(978),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(978),
    [sym_yield_expression] = STATE(978),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(978),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(978),
    [sym_arrow_function] = STATE(978),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(978),
    [sym_new_expression] = STATE(978),
    [sym_await_expression] = STATE(978),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(978),
    [sym_augmented_assignment_expression] = STATE(978),
    [sym_ternary_expression] = STATE(978),
    [sym_binary_expression] = STATE(978),
    [sym_unary_expression] = STATE(978),
    [sym_update_expression] = STATE(978),
    [sym_string] = STATE(978),
    [sym_template_string] = STATE(978),
    [sym_regex] = STATE(978),
    [sym_meta_property] = STATE(978),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(978),
    [sym_type_assertion] = STATE(978),
    [sym_as_expression] = STATE(978),
    [sym_internal_module] = STATE(978),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1992),
    [sym_this] = ACTIONS(921),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(921),
    [sym_false] = ACTIONS(921),
    [sym_null] = ACTIONS(921),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [297] = {
    [sym_import] = STATE(965),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(965),
    [sym_yield_expression] = STATE(965),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(965),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(965),
    [sym_arrow_function] = STATE(965),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(965),
    [sym_new_expression] = STATE(965),
    [sym_await_expression] = STATE(965),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(965),
    [sym_augmented_assignment_expression] = STATE(965),
    [sym_ternary_expression] = STATE(965),
    [sym_binary_expression] = STATE(965),
    [sym_unary_expression] = STATE(965),
    [sym_update_expression] = STATE(965),
    [sym_string] = STATE(965),
    [sym_template_string] = STATE(965),
    [sym_regex] = STATE(965),
    [sym_meta_property] = STATE(965),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(965),
    [sym_type_assertion] = STATE(965),
    [sym_as_expression] = STATE(965),
    [sym_internal_module] = STATE(965),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1994),
    [sym_this] = ACTIONS(1996),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [sym_null] = ACTIONS(1996),
    [sym_undefined] = ACTIONS(1996),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [298] = {
    [sym_import] = STATE(1181),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1181),
    [sym_yield_expression] = STATE(1181),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1181),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1181),
    [sym_arrow_function] = STATE(1181),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1181),
    [sym_new_expression] = STATE(1181),
    [sym_await_expression] = STATE(1181),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1181),
    [sym_augmented_assignment_expression] = STATE(1181),
    [sym_ternary_expression] = STATE(1181),
    [sym_binary_expression] = STATE(1181),
    [sym_unary_expression] = STATE(1181),
    [sym_update_expression] = STATE(1181),
    [sym_string] = STATE(1181),
    [sym_template_string] = STATE(1181),
    [sym_regex] = STATE(1181),
    [sym_meta_property] = STATE(1181),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1181),
    [sym_type_assertion] = STATE(1181),
    [sym_as_expression] = STATE(1181),
    [sym_internal_module] = STATE(1181),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1998),
    [sym_this] = ACTIONS(2000),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2000),
    [sym_false] = ACTIONS(2000),
    [sym_null] = ACTIONS(2000),
    [sym_undefined] = ACTIONS(2000),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [299] = {
    [sym_import] = STATE(1179),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1179),
    [sym_yield_expression] = STATE(1179),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1179),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1179),
    [sym_arrow_function] = STATE(1179),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1179),
    [sym_new_expression] = STATE(1179),
    [sym_await_expression] = STATE(1179),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1179),
    [sym_augmented_assignment_expression] = STATE(1179),
    [sym_ternary_expression] = STATE(1179),
    [sym_binary_expression] = STATE(1179),
    [sym_unary_expression] = STATE(1179),
    [sym_update_expression] = STATE(1179),
    [sym_string] = STATE(1179),
    [sym_template_string] = STATE(1179),
    [sym_regex] = STATE(1179),
    [sym_meta_property] = STATE(1179),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1179),
    [sym_type_assertion] = STATE(1179),
    [sym_as_expression] = STATE(1179),
    [sym_internal_module] = STATE(1179),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(716),
    [sym_this] = ACTIONS(718),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(718),
    [sym_false] = ACTIONS(718),
    [sym_null] = ACTIONS(718),
    [sym_undefined] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [300] = {
    [sym_import] = STATE(1299),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1299),
    [sym_yield_expression] = STATE(1299),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1299),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1299),
    [sym_arrow_function] = STATE(1299),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1299),
    [sym_new_expression] = STATE(1299),
    [sym_await_expression] = STATE(1299),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1299),
    [sym_augmented_assignment_expression] = STATE(1299),
    [sym_ternary_expression] = STATE(1299),
    [sym_binary_expression] = STATE(1299),
    [sym_unary_expression] = STATE(1299),
    [sym_update_expression] = STATE(1299),
    [sym_string] = STATE(1299),
    [sym_template_string] = STATE(1299),
    [sym_regex] = STATE(1299),
    [sym_meta_property] = STATE(1299),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1299),
    [sym_type_assertion] = STATE(1299),
    [sym_as_expression] = STATE(1299),
    [sym_internal_module] = STATE(1299),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2002),
    [sym_this] = ACTIONS(2004),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2004),
    [sym_false] = ACTIONS(2004),
    [sym_null] = ACTIONS(2004),
    [sym_undefined] = ACTIONS(2004),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [301] = {
    [sym_import] = STATE(1291),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1291),
    [sym_yield_expression] = STATE(1291),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1291),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1291),
    [sym_arrow_function] = STATE(1291),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1291),
    [sym_new_expression] = STATE(1291),
    [sym_await_expression] = STATE(1291),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1291),
    [sym_augmented_assignment_expression] = STATE(1291),
    [sym_ternary_expression] = STATE(1291),
    [sym_binary_expression] = STATE(1291),
    [sym_unary_expression] = STATE(1291),
    [sym_update_expression] = STATE(1291),
    [sym_string] = STATE(1291),
    [sym_template_string] = STATE(1291),
    [sym_regex] = STATE(1291),
    [sym_meta_property] = STATE(1291),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1291),
    [sym_type_assertion] = STATE(1291),
    [sym_as_expression] = STATE(1291),
    [sym_internal_module] = STATE(1291),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2006),
    [sym_this] = ACTIONS(2008),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2008),
    [sym_false] = ACTIONS(2008),
    [sym_null] = ACTIONS(2008),
    [sym_undefined] = ACTIONS(2008),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [302] = {
    [sym_import] = STATE(1006),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1006),
    [sym_yield_expression] = STATE(1006),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1006),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1006),
    [sym_arrow_function] = STATE(1006),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1006),
    [sym_new_expression] = STATE(1006),
    [sym_await_expression] = STATE(1006),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1006),
    [sym_augmented_assignment_expression] = STATE(1006),
    [sym_ternary_expression] = STATE(1006),
    [sym_binary_expression] = STATE(1006),
    [sym_unary_expression] = STATE(1006),
    [sym_update_expression] = STATE(1006),
    [sym_string] = STATE(1006),
    [sym_template_string] = STATE(1006),
    [sym_regex] = STATE(1006),
    [sym_meta_property] = STATE(1006),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1006),
    [sym_type_assertion] = STATE(1006),
    [sym_as_expression] = STATE(1006),
    [sym_internal_module] = STATE(1006),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2010),
    [sym_this] = ACTIONS(2012),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2012),
    [sym_false] = ACTIONS(2012),
    [sym_null] = ACTIONS(2012),
    [sym_undefined] = ACTIONS(2012),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [303] = {
    [sym_import] = STATE(1158),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1158),
    [sym_yield_expression] = STATE(1158),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1158),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1158),
    [sym_arrow_function] = STATE(1158),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1158),
    [sym_new_expression] = STATE(1158),
    [sym_await_expression] = STATE(1158),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1158),
    [sym_augmented_assignment_expression] = STATE(1158),
    [sym_ternary_expression] = STATE(1158),
    [sym_binary_expression] = STATE(1158),
    [sym_unary_expression] = STATE(1158),
    [sym_update_expression] = STATE(1158),
    [sym_string] = STATE(1158),
    [sym_template_string] = STATE(1158),
    [sym_regex] = STATE(1158),
    [sym_meta_property] = STATE(1158),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1158),
    [sym_type_assertion] = STATE(1158),
    [sym_as_expression] = STATE(1158),
    [sym_internal_module] = STATE(1158),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2014),
    [sym_this] = ACTIONS(2016),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2016),
    [sym_false] = ACTIONS(2016),
    [sym_null] = ACTIONS(2016),
    [sym_undefined] = ACTIONS(2016),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [304] = {
    [sym_import] = STATE(1005),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1005),
    [sym_yield_expression] = STATE(1005),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1005),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1005),
    [sym_arrow_function] = STATE(1005),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1005),
    [sym_new_expression] = STATE(1005),
    [sym_await_expression] = STATE(1005),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1005),
    [sym_augmented_assignment_expression] = STATE(1005),
    [sym_ternary_expression] = STATE(1005),
    [sym_binary_expression] = STATE(1005),
    [sym_unary_expression] = STATE(1005),
    [sym_update_expression] = STATE(1005),
    [sym_string] = STATE(1005),
    [sym_template_string] = STATE(1005),
    [sym_regex] = STATE(1005),
    [sym_meta_property] = STATE(1005),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1005),
    [sym_type_assertion] = STATE(1005),
    [sym_as_expression] = STATE(1005),
    [sym_internal_module] = STATE(1005),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2018),
    [sym_this] = ACTIONS(2020),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2020),
    [sym_false] = ACTIONS(2020),
    [sym_null] = ACTIONS(2020),
    [sym_undefined] = ACTIONS(2020),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [305] = {
    [sym_import] = STATE(1004),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1004),
    [sym_yield_expression] = STATE(1004),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1004),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1004),
    [sym_arrow_function] = STATE(1004),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1004),
    [sym_new_expression] = STATE(1004),
    [sym_await_expression] = STATE(1004),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1004),
    [sym_augmented_assignment_expression] = STATE(1004),
    [sym_ternary_expression] = STATE(1004),
    [sym_binary_expression] = STATE(1004),
    [sym_unary_expression] = STATE(1004),
    [sym_update_expression] = STATE(1004),
    [sym_string] = STATE(1004),
    [sym_template_string] = STATE(1004),
    [sym_regex] = STATE(1004),
    [sym_meta_property] = STATE(1004),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1004),
    [sym_type_assertion] = STATE(1004),
    [sym_as_expression] = STATE(1004),
    [sym_internal_module] = STATE(1004),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2022),
    [sym_this] = ACTIONS(2024),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2024),
    [sym_false] = ACTIONS(2024),
    [sym_null] = ACTIONS(2024),
    [sym_undefined] = ACTIONS(2024),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [306] = {
    [sym_import] = STATE(1006),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1006),
    [sym_yield_expression] = STATE(1006),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1006),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1006),
    [sym_arrow_function] = STATE(1006),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1006),
    [sym_new_expression] = STATE(1006),
    [sym_await_expression] = STATE(1006),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1006),
    [sym_augmented_assignment_expression] = STATE(1006),
    [sym_ternary_expression] = STATE(1006),
    [sym_binary_expression] = STATE(1006),
    [sym_unary_expression] = STATE(1006),
    [sym_update_expression] = STATE(1006),
    [sym_string] = STATE(1006),
    [sym_template_string] = STATE(1006),
    [sym_regex] = STATE(1006),
    [sym_meta_property] = STATE(1006),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1006),
    [sym_type_assertion] = STATE(1006),
    [sym_as_expression] = STATE(1006),
    [sym_internal_module] = STATE(1006),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2026),
    [sym_this] = ACTIONS(2012),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2012),
    [sym_false] = ACTIONS(2012),
    [sym_null] = ACTIONS(2012),
    [sym_undefined] = ACTIONS(2012),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [307] = {
    [sym_import] = STATE(1279),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1279),
    [sym_yield_expression] = STATE(1279),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1279),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1279),
    [sym_arrow_function] = STATE(1279),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1279),
    [sym_new_expression] = STATE(1279),
    [sym_await_expression] = STATE(1279),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1279),
    [sym_augmented_assignment_expression] = STATE(1279),
    [sym_ternary_expression] = STATE(1279),
    [sym_binary_expression] = STATE(1279),
    [sym_unary_expression] = STATE(1279),
    [sym_update_expression] = STATE(1279),
    [sym_string] = STATE(1279),
    [sym_template_string] = STATE(1279),
    [sym_regex] = STATE(1279),
    [sym_meta_property] = STATE(1279),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1279),
    [sym_type_assertion] = STATE(1279),
    [sym_as_expression] = STATE(1279),
    [sym_internal_module] = STATE(1279),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(1900),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1900),
    [sym_false] = ACTIONS(1900),
    [sym_null] = ACTIONS(1900),
    [sym_undefined] = ACTIONS(1900),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [308] = {
    [sym_import] = STATE(1270),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1270),
    [sym_type_assertion] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2030),
    [sym_this] = ACTIONS(2032),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [309] = {
    [sym_import] = STATE(1308),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1308),
    [sym_yield_expression] = STATE(1308),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1308),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1308),
    [sym_arrow_function] = STATE(1308),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1308),
    [sym_new_expression] = STATE(1308),
    [sym_await_expression] = STATE(1308),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1308),
    [sym_augmented_assignment_expression] = STATE(1308),
    [sym_ternary_expression] = STATE(1308),
    [sym_binary_expression] = STATE(1308),
    [sym_unary_expression] = STATE(1308),
    [sym_update_expression] = STATE(1308),
    [sym_string] = STATE(1308),
    [sym_template_string] = STATE(1308),
    [sym_regex] = STATE(1308),
    [sym_meta_property] = STATE(1308),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1308),
    [sym_type_assertion] = STATE(1308),
    [sym_as_expression] = STATE(1308),
    [sym_internal_module] = STATE(1308),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2034),
    [sym_this] = ACTIONS(2036),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2036),
    [sym_false] = ACTIONS(2036),
    [sym_null] = ACTIONS(2036),
    [sym_undefined] = ACTIONS(2036),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [310] = {
    [sym_import] = STATE(1252),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1252),
    [sym_yield_expression] = STATE(1252),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1252),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1252),
    [sym_arrow_function] = STATE(1252),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1252),
    [sym_new_expression] = STATE(1252),
    [sym_await_expression] = STATE(1252),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1252),
    [sym_augmented_assignment_expression] = STATE(1252),
    [sym_ternary_expression] = STATE(1252),
    [sym_binary_expression] = STATE(1252),
    [sym_unary_expression] = STATE(1252),
    [sym_update_expression] = STATE(1252),
    [sym_string] = STATE(1252),
    [sym_template_string] = STATE(1252),
    [sym_regex] = STATE(1252),
    [sym_meta_property] = STATE(1252),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1252),
    [sym_type_assertion] = STATE(1252),
    [sym_as_expression] = STATE(1252),
    [sym_internal_module] = STATE(1252),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2026),
    [sym_this] = ACTIONS(2038),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2038),
    [sym_false] = ACTIONS(2038),
    [sym_null] = ACTIONS(2038),
    [sym_undefined] = ACTIONS(2038),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [311] = {
    [sym_import] = STATE(1159),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1159),
    [sym_yield_expression] = STATE(1159),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1159),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1159),
    [sym_arrow_function] = STATE(1159),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1159),
    [sym_new_expression] = STATE(1159),
    [sym_await_expression] = STATE(1159),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1159),
    [sym_augmented_assignment_expression] = STATE(1159),
    [sym_ternary_expression] = STATE(1159),
    [sym_binary_expression] = STATE(1159),
    [sym_unary_expression] = STATE(1159),
    [sym_update_expression] = STATE(1159),
    [sym_string] = STATE(1159),
    [sym_template_string] = STATE(1159),
    [sym_regex] = STATE(1159),
    [sym_meta_property] = STATE(1159),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1159),
    [sym_type_assertion] = STATE(1159),
    [sym_as_expression] = STATE(1159),
    [sym_internal_module] = STATE(1159),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2040),
    [sym_this] = ACTIONS(2042),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2042),
    [sym_false] = ACTIONS(2042),
    [sym_null] = ACTIONS(2042),
    [sym_undefined] = ACTIONS(2042),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [312] = {
    [sym_import] = STATE(976),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(976),
    [sym_yield_expression] = STATE(976),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(976),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(976),
    [sym_arrow_function] = STATE(976),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(976),
    [sym_new_expression] = STATE(976),
    [sym_await_expression] = STATE(976),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(976),
    [sym_augmented_assignment_expression] = STATE(976),
    [sym_ternary_expression] = STATE(976),
    [sym_binary_expression] = STATE(976),
    [sym_unary_expression] = STATE(976),
    [sym_update_expression] = STATE(976),
    [sym_string] = STATE(976),
    [sym_template_string] = STATE(976),
    [sym_regex] = STATE(976),
    [sym_meta_property] = STATE(976),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(976),
    [sym_type_assertion] = STATE(976),
    [sym_as_expression] = STATE(976),
    [sym_internal_module] = STATE(976),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2044),
    [sym_this] = ACTIONS(1904),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1904),
    [sym_false] = ACTIONS(1904),
    [sym_null] = ACTIONS(1904),
    [sym_undefined] = ACTIONS(1904),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [313] = {
    [sym_import] = STATE(1163),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1163),
    [sym_yield_expression] = STATE(1163),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1163),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1163),
    [sym_arrow_function] = STATE(1163),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1163),
    [sym_new_expression] = STATE(1163),
    [sym_await_expression] = STATE(1163),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1163),
    [sym_augmented_assignment_expression] = STATE(1163),
    [sym_ternary_expression] = STATE(1163),
    [sym_binary_expression] = STATE(1163),
    [sym_unary_expression] = STATE(1163),
    [sym_update_expression] = STATE(1163),
    [sym_string] = STATE(1163),
    [sym_template_string] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_meta_property] = STATE(1163),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1163),
    [sym_type_assertion] = STATE(1163),
    [sym_as_expression] = STATE(1163),
    [sym_internal_module] = STATE(1163),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2046),
    [sym_this] = ACTIONS(2048),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2048),
    [sym_false] = ACTIONS(2048),
    [sym_null] = ACTIONS(2048),
    [sym_undefined] = ACTIONS(2048),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [314] = {
    [sym_import] = STATE(1035),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1035),
    [sym_yield_expression] = STATE(1035),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1035),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1035),
    [sym_arrow_function] = STATE(1035),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1035),
    [sym_new_expression] = STATE(1035),
    [sym_await_expression] = STATE(1035),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1035),
    [sym_augmented_assignment_expression] = STATE(1035),
    [sym_ternary_expression] = STATE(1035),
    [sym_binary_expression] = STATE(1035),
    [sym_unary_expression] = STATE(1035),
    [sym_update_expression] = STATE(1035),
    [sym_string] = STATE(1035),
    [sym_template_string] = STATE(1035),
    [sym_regex] = STATE(1035),
    [sym_meta_property] = STATE(1035),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1035),
    [sym_as_expression] = STATE(1035),
    [sym_internal_module] = STATE(1035),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2050),
    [sym_this] = ACTIONS(2052),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2052),
    [sym_false] = ACTIONS(2052),
    [sym_null] = ACTIONS(2052),
    [sym_undefined] = ACTIONS(2052),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [315] = {
    [sym_import] = STATE(980),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(980),
    [sym_yield_expression] = STATE(980),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(980),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(980),
    [sym_arrow_function] = STATE(980),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(980),
    [sym_new_expression] = STATE(980),
    [sym_await_expression] = STATE(980),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(980),
    [sym_augmented_assignment_expression] = STATE(980),
    [sym_ternary_expression] = STATE(980),
    [sym_binary_expression] = STATE(980),
    [sym_unary_expression] = STATE(980),
    [sym_update_expression] = STATE(980),
    [sym_string] = STATE(980),
    [sym_template_string] = STATE(980),
    [sym_regex] = STATE(980),
    [sym_meta_property] = STATE(980),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(980),
    [sym_type_assertion] = STATE(980),
    [sym_as_expression] = STATE(980),
    [sym_internal_module] = STATE(980),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2054),
    [sym_this] = ACTIONS(2056),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2056),
    [sym_false] = ACTIONS(2056),
    [sym_null] = ACTIONS(2056),
    [sym_undefined] = ACTIONS(2056),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [316] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1245),
    [sym_type_assertion] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [317] = {
    [sym_import] = STATE(983),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(983),
    [sym_yield_expression] = STATE(983),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(983),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(983),
    [sym_arrow_function] = STATE(983),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(983),
    [sym_new_expression] = STATE(983),
    [sym_await_expression] = STATE(983),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(983),
    [sym_augmented_assignment_expression] = STATE(983),
    [sym_ternary_expression] = STATE(983),
    [sym_binary_expression] = STATE(983),
    [sym_unary_expression] = STATE(983),
    [sym_update_expression] = STATE(983),
    [sym_string] = STATE(983),
    [sym_template_string] = STATE(983),
    [sym_regex] = STATE(983),
    [sym_meta_property] = STATE(983),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(983),
    [sym_type_assertion] = STATE(983),
    [sym_as_expression] = STATE(983),
    [sym_internal_module] = STATE(983),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [318] = {
    [sym_import] = STATE(1000),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1000),
    [sym_yield_expression] = STATE(1000),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1000),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1000),
    [sym_arrow_function] = STATE(1000),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1000),
    [sym_new_expression] = STATE(1000),
    [sym_await_expression] = STATE(1000),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1000),
    [sym_augmented_assignment_expression] = STATE(1000),
    [sym_ternary_expression] = STATE(1000),
    [sym_binary_expression] = STATE(1000),
    [sym_unary_expression] = STATE(1000),
    [sym_update_expression] = STATE(1000),
    [sym_string] = STATE(1000),
    [sym_template_string] = STATE(1000),
    [sym_regex] = STATE(1000),
    [sym_meta_property] = STATE(1000),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1000),
    [sym_type_assertion] = STATE(1000),
    [sym_as_expression] = STATE(1000),
    [sym_internal_module] = STATE(1000),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(2062),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2064),
    [sym_this] = ACTIONS(2066),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_undefined] = ACTIONS(2066),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [319] = {
    [sym_import] = STATE(1320),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1320),
    [sym_yield_expression] = STATE(1320),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1320),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1320),
    [sym_arrow_function] = STATE(1320),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1320),
    [sym_new_expression] = STATE(1320),
    [sym_await_expression] = STATE(1320),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1320),
    [sym_augmented_assignment_expression] = STATE(1320),
    [sym_ternary_expression] = STATE(1320),
    [sym_binary_expression] = STATE(1320),
    [sym_unary_expression] = STATE(1320),
    [sym_update_expression] = STATE(1320),
    [sym_string] = STATE(1320),
    [sym_template_string] = STATE(1320),
    [sym_regex] = STATE(1320),
    [sym_meta_property] = STATE(1320),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1320),
    [sym_type_assertion] = STATE(1320),
    [sym_as_expression] = STATE(1320),
    [sym_internal_module] = STATE(1320),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2068),
    [sym_this] = ACTIONS(2070),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2070),
    [sym_false] = ACTIONS(2070),
    [sym_null] = ACTIONS(2070),
    [sym_undefined] = ACTIONS(2070),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [320] = {
    [sym_import] = STATE(1164),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1164),
    [sym_yield_expression] = STATE(1164),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1164),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1164),
    [sym_arrow_function] = STATE(1164),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1164),
    [sym_new_expression] = STATE(1164),
    [sym_await_expression] = STATE(1164),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1164),
    [sym_augmented_assignment_expression] = STATE(1164),
    [sym_ternary_expression] = STATE(1164),
    [sym_binary_expression] = STATE(1164),
    [sym_unary_expression] = STATE(1164),
    [sym_update_expression] = STATE(1164),
    [sym_string] = STATE(1164),
    [sym_template_string] = STATE(1164),
    [sym_regex] = STATE(1164),
    [sym_meta_property] = STATE(1164),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1164),
    [sym_type_assertion] = STATE(1164),
    [sym_as_expression] = STATE(1164),
    [sym_internal_module] = STATE(1164),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2072),
    [sym_this] = ACTIONS(901),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(901),
    [sym_false] = ACTIONS(901),
    [sym_null] = ACTIONS(901),
    [sym_undefined] = ACTIONS(901),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [321] = {
    [sym_import] = STATE(1167),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1167),
    [sym_yield_expression] = STATE(1167),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1167),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1167),
    [sym_arrow_function] = STATE(1167),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1167),
    [sym_new_expression] = STATE(1167),
    [sym_await_expression] = STATE(1167),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1167),
    [sym_augmented_assignment_expression] = STATE(1167),
    [sym_ternary_expression] = STATE(1167),
    [sym_binary_expression] = STATE(1167),
    [sym_unary_expression] = STATE(1167),
    [sym_update_expression] = STATE(1167),
    [sym_string] = STATE(1167),
    [sym_template_string] = STATE(1167),
    [sym_regex] = STATE(1167),
    [sym_meta_property] = STATE(1167),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1167),
    [sym_as_expression] = STATE(1167),
    [sym_internal_module] = STATE(1167),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2074),
    [sym_this] = ACTIONS(2076),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2076),
    [sym_false] = ACTIONS(2076),
    [sym_null] = ACTIONS(2076),
    [sym_undefined] = ACTIONS(2076),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [322] = {
    [sym_import] = STATE(1376),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1376),
    [sym_yield_expression] = STATE(1376),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1376),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1376),
    [sym_arrow_function] = STATE(1376),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1376),
    [sym_new_expression] = STATE(1376),
    [sym_await_expression] = STATE(1376),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1376),
    [sym_augmented_assignment_expression] = STATE(1376),
    [sym_ternary_expression] = STATE(1376),
    [sym_binary_expression] = STATE(1376),
    [sym_unary_expression] = STATE(1376),
    [sym_update_expression] = STATE(1376),
    [sym_string] = STATE(1376),
    [sym_template_string] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_meta_property] = STATE(1376),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1376),
    [sym_type_assertion] = STATE(1376),
    [sym_as_expression] = STATE(1376),
    [sym_internal_module] = STATE(1376),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2078),
    [sym_this] = ACTIONS(2080),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2080),
    [sym_false] = ACTIONS(2080),
    [sym_null] = ACTIONS(2080),
    [sym_undefined] = ACTIONS(2080),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [323] = {
    [sym_import] = STATE(1169),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1169),
    [sym_yield_expression] = STATE(1169),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1169),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1169),
    [sym_arrow_function] = STATE(1169),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1169),
    [sym_new_expression] = STATE(1169),
    [sym_await_expression] = STATE(1169),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1169),
    [sym_augmented_assignment_expression] = STATE(1169),
    [sym_ternary_expression] = STATE(1169),
    [sym_binary_expression] = STATE(1169),
    [sym_unary_expression] = STATE(1169),
    [sym_update_expression] = STATE(1169),
    [sym_string] = STATE(1169),
    [sym_template_string] = STATE(1169),
    [sym_regex] = STATE(1169),
    [sym_meta_property] = STATE(1169),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1169),
    [sym_type_assertion] = STATE(1169),
    [sym_as_expression] = STATE(1169),
    [sym_internal_module] = STATE(1169),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [324] = {
    [sym_import] = STATE(1000),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1000),
    [sym_yield_expression] = STATE(1000),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1000),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1000),
    [sym_arrow_function] = STATE(1000),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1000),
    [sym_new_expression] = STATE(1000),
    [sym_await_expression] = STATE(1000),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1000),
    [sym_augmented_assignment_expression] = STATE(1000),
    [sym_ternary_expression] = STATE(1000),
    [sym_binary_expression] = STATE(1000),
    [sym_unary_expression] = STATE(1000),
    [sym_update_expression] = STATE(1000),
    [sym_string] = STATE(1000),
    [sym_template_string] = STATE(1000),
    [sym_regex] = STATE(1000),
    [sym_meta_property] = STATE(1000),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1000),
    [sym_type_assertion] = STATE(1000),
    [sym_as_expression] = STATE(1000),
    [sym_internal_module] = STATE(1000),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2064),
    [sym_this] = ACTIONS(2066),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_undefined] = ACTIONS(2066),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [325] = {
    [sym_import] = STATE(986),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(986),
    [sym_yield_expression] = STATE(986),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(986),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(986),
    [sym_arrow_function] = STATE(986),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(986),
    [sym_new_expression] = STATE(986),
    [sym_await_expression] = STATE(986),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(986),
    [sym_augmented_assignment_expression] = STATE(986),
    [sym_ternary_expression] = STATE(986),
    [sym_binary_expression] = STATE(986),
    [sym_unary_expression] = STATE(986),
    [sym_update_expression] = STATE(986),
    [sym_string] = STATE(986),
    [sym_template_string] = STATE(986),
    [sym_regex] = STATE(986),
    [sym_meta_property] = STATE(986),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(986),
    [sym_type_assertion] = STATE(986),
    [sym_as_expression] = STATE(986),
    [sym_internal_module] = STATE(986),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2086),
    [sym_this] = ACTIONS(2088),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2088),
    [sym_false] = ACTIONS(2088),
    [sym_null] = ACTIONS(2088),
    [sym_undefined] = ACTIONS(2088),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [326] = {
    [sym__declaration] = STATE(577),
    [sym_variable_declaration] = STATE(577),
    [sym_lexical_declaration] = STATE(577),
    [sym_class_declaration] = STATE(577),
    [sym_function_declaration] = STATE(577),
    [sym_generator_function_declaration] = STATE(577),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(577),
    [sym_abstract_class_declaration] = STATE(577),
    [sym_module] = STATE(577),
    [sym_internal_module] = STATE(577),
    [sym_import_alias] = STATE(577),
    [sym_interface_declaration] = STATE(577),
    [sym_enum_declaration] = STATE(577),
    [sym_type_alias_declaration] = STATE(577),
    [aux_sym_export_statement_repeat1] = STATE(2356),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1343),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_class] = ACTIONS(1358),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(1362),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1364),
    [anon_sym_declare] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1438),
    [anon_sym_global] = ACTIONS(1440),
    [anon_sym_interface] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1372),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [327] = {
    [sym_import] = STATE(1364),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1364),
    [sym_yield_expression] = STATE(1364),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1364),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1364),
    [sym_arrow_function] = STATE(1364),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1364),
    [sym_new_expression] = STATE(1364),
    [sym_await_expression] = STATE(1364),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1364),
    [sym_augmented_assignment_expression] = STATE(1364),
    [sym_ternary_expression] = STATE(1364),
    [sym_binary_expression] = STATE(1364),
    [sym_unary_expression] = STATE(1364),
    [sym_update_expression] = STATE(1364),
    [sym_string] = STATE(1364),
    [sym_template_string] = STATE(1364),
    [sym_regex] = STATE(1364),
    [sym_meta_property] = STATE(1364),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1364),
    [sym_type_assertion] = STATE(1364),
    [sym_as_expression] = STATE(1364),
    [sym_internal_module] = STATE(1364),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1678),
    [sym_this] = ACTIONS(1680),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1680),
    [sym_false] = ACTIONS(1680),
    [sym_null] = ACTIONS(1680),
    [sym_undefined] = ACTIONS(1680),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [328] = {
    [sym_import] = STATE(1007),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1007),
    [sym_yield_expression] = STATE(1007),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1007),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1007),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1007),
    [sym_augmented_assignment_expression] = STATE(1007),
    [sym_ternary_expression] = STATE(1007),
    [sym_binary_expression] = STATE(1007),
    [sym_unary_expression] = STATE(1007),
    [sym_update_expression] = STATE(1007),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1007),
    [sym_type_assertion] = STATE(1007),
    [sym_as_expression] = STATE(1007),
    [sym_internal_module] = STATE(1007),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2090),
    [sym_this] = ACTIONS(2092),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2092),
    [sym_false] = ACTIONS(2092),
    [sym_null] = ACTIONS(2092),
    [sym_undefined] = ACTIONS(2092),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [329] = {
    [sym_import] = STATE(1353),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1353),
    [sym_yield_expression] = STATE(1353),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1353),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_await_expression] = STATE(1353),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1353),
    [sym_augmented_assignment_expression] = STATE(1353),
    [sym_ternary_expression] = STATE(1353),
    [sym_binary_expression] = STATE(1353),
    [sym_unary_expression] = STATE(1353),
    [sym_update_expression] = STATE(1353),
    [sym_string] = STATE(1353),
    [sym_template_string] = STATE(1353),
    [sym_regex] = STATE(1353),
    [sym_meta_property] = STATE(1353),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1353),
    [sym_type_assertion] = STATE(1353),
    [sym_as_expression] = STATE(1353),
    [sym_internal_module] = STATE(1353),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2094),
    [sym_this] = ACTIONS(2096),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2096),
    [sym_false] = ACTIONS(2096),
    [sym_null] = ACTIONS(2096),
    [sym_undefined] = ACTIONS(2096),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [330] = {
    [sym_import] = STATE(1351),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1351),
    [sym_yield_expression] = STATE(1351),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1351),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1351),
    [sym_arrow_function] = STATE(1351),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1351),
    [sym_new_expression] = STATE(1351),
    [sym_await_expression] = STATE(1351),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1351),
    [sym_augmented_assignment_expression] = STATE(1351),
    [sym_ternary_expression] = STATE(1351),
    [sym_binary_expression] = STATE(1351),
    [sym_unary_expression] = STATE(1351),
    [sym_update_expression] = STATE(1351),
    [sym_string] = STATE(1351),
    [sym_template_string] = STATE(1351),
    [sym_regex] = STATE(1351),
    [sym_meta_property] = STATE(1351),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1351),
    [sym_as_expression] = STATE(1351),
    [sym_internal_module] = STATE(1351),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [331] = {
    [sym_import] = STATE(1348),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1348),
    [sym_yield_expression] = STATE(1348),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1348),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1348),
    [sym_arrow_function] = STATE(1348),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1348),
    [sym_new_expression] = STATE(1348),
    [sym_await_expression] = STATE(1348),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1348),
    [sym_augmented_assignment_expression] = STATE(1348),
    [sym_ternary_expression] = STATE(1348),
    [sym_binary_expression] = STATE(1348),
    [sym_unary_expression] = STATE(1348),
    [sym_update_expression] = STATE(1348),
    [sym_string] = STATE(1348),
    [sym_template_string] = STATE(1348),
    [sym_regex] = STATE(1348),
    [sym_meta_property] = STATE(1348),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1348),
    [sym_as_expression] = STATE(1348),
    [sym_internal_module] = STATE(1348),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2102),
    [sym_this] = ACTIONS(2104),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2104),
    [sym_false] = ACTIONS(2104),
    [sym_null] = ACTIONS(2104),
    [sym_undefined] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [332] = {
    [sym_import] = STATE(1347),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1347),
    [sym_yield_expression] = STATE(1347),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1347),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1347),
    [sym_arrow_function] = STATE(1347),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1347),
    [sym_new_expression] = STATE(1347),
    [sym_await_expression] = STATE(1347),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1347),
    [sym_augmented_assignment_expression] = STATE(1347),
    [sym_ternary_expression] = STATE(1347),
    [sym_binary_expression] = STATE(1347),
    [sym_unary_expression] = STATE(1347),
    [sym_update_expression] = STATE(1347),
    [sym_string] = STATE(1347),
    [sym_template_string] = STATE(1347),
    [sym_regex] = STATE(1347),
    [sym_meta_property] = STATE(1347),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1347),
    [sym_type_assertion] = STATE(1347),
    [sym_as_expression] = STATE(1347),
    [sym_internal_module] = STATE(1347),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [333] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(990),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(990),
    [sym_type_assertion] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2110),
    [sym_this] = ACTIONS(2112),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2112),
    [sym_false] = ACTIONS(2112),
    [sym_null] = ACTIONS(2112),
    [sym_undefined] = ACTIONS(2112),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [334] = {
    [sym_import] = STATE(1087),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1087),
    [sym_yield_expression] = STATE(1087),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1087),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1087),
    [sym_arrow_function] = STATE(1087),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1087),
    [sym_new_expression] = STATE(1087),
    [sym_await_expression] = STATE(1087),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1087),
    [sym_augmented_assignment_expression] = STATE(1087),
    [sym_ternary_expression] = STATE(1087),
    [sym_binary_expression] = STATE(1087),
    [sym_unary_expression] = STATE(1087),
    [sym_update_expression] = STATE(1087),
    [sym_string] = STATE(1087),
    [sym_template_string] = STATE(1087),
    [sym_regex] = STATE(1087),
    [sym_meta_property] = STATE(1087),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1087),
    [sym_as_expression] = STATE(1087),
    [sym_internal_module] = STATE(1087),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2114),
    [sym_this] = ACTIONS(2116),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2116),
    [sym_false] = ACTIONS(2116),
    [sym_null] = ACTIONS(2116),
    [sym_undefined] = ACTIONS(2116),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [335] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1346),
    [sym_yield_expression] = STATE(1346),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1346),
    [sym_await_expression] = STATE(1346),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1346),
    [sym_augmented_assignment_expression] = STATE(1346),
    [sym_ternary_expression] = STATE(1346),
    [sym_binary_expression] = STATE(1346),
    [sym_unary_expression] = STATE(1346),
    [sym_update_expression] = STATE(1346),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1346),
    [sym_type_assertion] = STATE(1346),
    [sym_as_expression] = STATE(1346),
    [sym_internal_module] = STATE(1346),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2118),
    [sym_this] = ACTIONS(2120),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2120),
    [sym_false] = ACTIONS(2120),
    [sym_null] = ACTIONS(2120),
    [sym_undefined] = ACTIONS(2120),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [336] = {
    [sym_import] = STATE(1344),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1344),
    [sym_yield_expression] = STATE(1344),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1344),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1344),
    [sym_arrow_function] = STATE(1344),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1344),
    [sym_new_expression] = STATE(1344),
    [sym_await_expression] = STATE(1344),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1344),
    [sym_augmented_assignment_expression] = STATE(1344),
    [sym_ternary_expression] = STATE(1344),
    [sym_binary_expression] = STATE(1344),
    [sym_unary_expression] = STATE(1344),
    [sym_update_expression] = STATE(1344),
    [sym_string] = STATE(1344),
    [sym_template_string] = STATE(1344),
    [sym_regex] = STATE(1344),
    [sym_meta_property] = STATE(1344),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1344),
    [sym_type_assertion] = STATE(1344),
    [sym_as_expression] = STATE(1344),
    [sym_internal_module] = STATE(1344),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2122),
    [sym_this] = ACTIONS(2124),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2124),
    [sym_false] = ACTIONS(2124),
    [sym_null] = ACTIONS(2124),
    [sym_undefined] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [337] = {
    [sym_import] = STATE(1477),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1477),
    [sym_yield_expression] = STATE(1477),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1477),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1477),
    [sym_arrow_function] = STATE(1477),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1477),
    [sym_new_expression] = STATE(1477),
    [sym_await_expression] = STATE(1477),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1477),
    [sym_augmented_assignment_expression] = STATE(1477),
    [sym_ternary_expression] = STATE(1477),
    [sym_binary_expression] = STATE(1477),
    [sym_unary_expression] = STATE(1477),
    [sym_update_expression] = STATE(1477),
    [sym_string] = STATE(1477),
    [sym_template_string] = STATE(1477),
    [sym_regex] = STATE(1477),
    [sym_meta_property] = STATE(1477),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1477),
    [sym_type_assertion] = STATE(1477),
    [sym_as_expression] = STATE(1477),
    [sym_internal_module] = STATE(1477),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2126),
    [sym_this] = ACTIONS(2128),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2128),
    [sym_false] = ACTIONS(2128),
    [sym_null] = ACTIONS(2128),
    [sym_undefined] = ACTIONS(2128),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [338] = {
    [sym_import] = STATE(1343),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1343),
    [sym_yield_expression] = STATE(1343),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1343),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1343),
    [sym_arrow_function] = STATE(1343),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1343),
    [sym_new_expression] = STATE(1343),
    [sym_await_expression] = STATE(1343),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1343),
    [sym_augmented_assignment_expression] = STATE(1343),
    [sym_ternary_expression] = STATE(1343),
    [sym_binary_expression] = STATE(1343),
    [sym_unary_expression] = STATE(1343),
    [sym_update_expression] = STATE(1343),
    [sym_string] = STATE(1343),
    [sym_template_string] = STATE(1343),
    [sym_regex] = STATE(1343),
    [sym_meta_property] = STATE(1343),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1343),
    [sym_type_assertion] = STATE(1343),
    [sym_as_expression] = STATE(1343),
    [sym_internal_module] = STATE(1343),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2130),
    [sym_this] = ACTIONS(875),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(875),
    [sym_false] = ACTIONS(875),
    [sym_null] = ACTIONS(875),
    [sym_undefined] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [339] = {
    [sym_import] = STATE(1087),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1087),
    [sym_yield_expression] = STATE(1087),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1087),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1087),
    [sym_arrow_function] = STATE(1087),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1087),
    [sym_new_expression] = STATE(1087),
    [sym_await_expression] = STATE(1087),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1087),
    [sym_augmented_assignment_expression] = STATE(1087),
    [sym_ternary_expression] = STATE(1087),
    [sym_binary_expression] = STATE(1087),
    [sym_unary_expression] = STATE(1087),
    [sym_update_expression] = STATE(1087),
    [sym_string] = STATE(1087),
    [sym_template_string] = STATE(1087),
    [sym_regex] = STATE(1087),
    [sym_meta_property] = STATE(1087),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1087),
    [sym_as_expression] = STATE(1087),
    [sym_internal_module] = STATE(1087),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2114),
    [sym_this] = ACTIONS(2116),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2116),
    [sym_false] = ACTIONS(2116),
    [sym_null] = ACTIONS(2116),
    [sym_undefined] = ACTIONS(2116),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [340] = {
    [sym_import] = STATE(1002),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1002),
    [sym_yield_expression] = STATE(1002),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1002),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1002),
    [sym_arrow_function] = STATE(1002),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1002),
    [sym_new_expression] = STATE(1002),
    [sym_await_expression] = STATE(1002),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1002),
    [sym_augmented_assignment_expression] = STATE(1002),
    [sym_ternary_expression] = STATE(1002),
    [sym_binary_expression] = STATE(1002),
    [sym_unary_expression] = STATE(1002),
    [sym_update_expression] = STATE(1002),
    [sym_string] = STATE(1002),
    [sym_template_string] = STATE(1002),
    [sym_regex] = STATE(1002),
    [sym_meta_property] = STATE(1002),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1002),
    [sym_type_assertion] = STATE(1002),
    [sym_as_expression] = STATE(1002),
    [sym_internal_module] = STATE(1002),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2132),
    [sym_this] = ACTIONS(2134),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2134),
    [sym_false] = ACTIONS(2134),
    [sym_null] = ACTIONS(2134),
    [sym_undefined] = ACTIONS(2134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [341] = {
    [sym_import] = STATE(1342),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1342),
    [sym_yield_expression] = STATE(1342),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1342),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1342),
    [sym_arrow_function] = STATE(1342),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1342),
    [sym_new_expression] = STATE(1342),
    [sym_await_expression] = STATE(1342),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1342),
    [sym_augmented_assignment_expression] = STATE(1342),
    [sym_ternary_expression] = STATE(1342),
    [sym_binary_expression] = STATE(1342),
    [sym_unary_expression] = STATE(1342),
    [sym_update_expression] = STATE(1342),
    [sym_string] = STATE(1342),
    [sym_template_string] = STATE(1342),
    [sym_regex] = STATE(1342),
    [sym_meta_property] = STATE(1342),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1342),
    [sym_type_assertion] = STATE(1342),
    [sym_as_expression] = STATE(1342),
    [sym_internal_module] = STATE(1342),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2136),
    [sym_this] = ACTIONS(2138),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2138),
    [sym_false] = ACTIONS(2138),
    [sym_null] = ACTIONS(2138),
    [sym_undefined] = ACTIONS(2138),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [342] = {
    [sym_import] = STATE(1177),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1177),
    [sym_yield_expression] = STATE(1177),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1177),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1177),
    [sym_arrow_function] = STATE(1177),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1177),
    [sym_new_expression] = STATE(1177),
    [sym_await_expression] = STATE(1177),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1177),
    [sym_augmented_assignment_expression] = STATE(1177),
    [sym_ternary_expression] = STATE(1177),
    [sym_binary_expression] = STATE(1177),
    [sym_unary_expression] = STATE(1177),
    [sym_update_expression] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_template_string] = STATE(1177),
    [sym_regex] = STATE(1177),
    [sym_meta_property] = STATE(1177),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1177),
    [sym_type_assertion] = STATE(1177),
    [sym_as_expression] = STATE(1177),
    [sym_internal_module] = STATE(1177),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2140),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [343] = {
    [sym_import] = STATE(1338),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1338),
    [sym_yield_expression] = STATE(1338),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1338),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1338),
    [sym_arrow_function] = STATE(1338),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1338),
    [sym_new_expression] = STATE(1338),
    [sym_await_expression] = STATE(1338),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1338),
    [sym_augmented_assignment_expression] = STATE(1338),
    [sym_ternary_expression] = STATE(1338),
    [sym_binary_expression] = STATE(1338),
    [sym_unary_expression] = STATE(1338),
    [sym_update_expression] = STATE(1338),
    [sym_string] = STATE(1338),
    [sym_template_string] = STATE(1338),
    [sym_regex] = STATE(1338),
    [sym_meta_property] = STATE(1338),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1338),
    [sym_as_expression] = STATE(1338),
    [sym_internal_module] = STATE(1338),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2144),
    [sym_this] = ACTIONS(2146),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2146),
    [sym_false] = ACTIONS(2146),
    [sym_null] = ACTIONS(2146),
    [sym_undefined] = ACTIONS(2146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [344] = {
    [sym_import] = STATE(999),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(999),
    [sym_yield_expression] = STATE(999),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(999),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(999),
    [sym_arrow_function] = STATE(999),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(999),
    [sym_new_expression] = STATE(999),
    [sym_await_expression] = STATE(999),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(999),
    [sym_augmented_assignment_expression] = STATE(999),
    [sym_ternary_expression] = STATE(999),
    [sym_binary_expression] = STATE(999),
    [sym_unary_expression] = STATE(999),
    [sym_update_expression] = STATE(999),
    [sym_string] = STATE(999),
    [sym_template_string] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_meta_property] = STATE(999),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(999),
    [sym_type_assertion] = STATE(999),
    [sym_as_expression] = STATE(999),
    [sym_internal_module] = STATE(999),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2148),
    [sym_this] = ACTIONS(2150),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2150),
    [sym_false] = ACTIONS(2150),
    [sym_null] = ACTIONS(2150),
    [sym_undefined] = ACTIONS(2150),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [345] = {
    [sym_import] = STATE(1004),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1004),
    [sym_yield_expression] = STATE(1004),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1004),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1004),
    [sym_arrow_function] = STATE(1004),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1004),
    [sym_new_expression] = STATE(1004),
    [sym_await_expression] = STATE(1004),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1004),
    [sym_augmented_assignment_expression] = STATE(1004),
    [sym_ternary_expression] = STATE(1004),
    [sym_binary_expression] = STATE(1004),
    [sym_unary_expression] = STATE(1004),
    [sym_update_expression] = STATE(1004),
    [sym_string] = STATE(1004),
    [sym_template_string] = STATE(1004),
    [sym_regex] = STATE(1004),
    [sym_meta_property] = STATE(1004),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1004),
    [sym_type_assertion] = STATE(1004),
    [sym_as_expression] = STATE(1004),
    [sym_internal_module] = STATE(1004),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2022),
    [sym_this] = ACTIONS(2024),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2024),
    [sym_false] = ACTIONS(2024),
    [sym_null] = ACTIONS(2024),
    [sym_undefined] = ACTIONS(2024),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [346] = {
    [sym_import] = STATE(1329),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1329),
    [sym_yield_expression] = STATE(1329),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1329),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1329),
    [sym_arrow_function] = STATE(1329),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1329),
    [sym_new_expression] = STATE(1329),
    [sym_await_expression] = STATE(1329),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1329),
    [sym_augmented_assignment_expression] = STATE(1329),
    [sym_ternary_expression] = STATE(1329),
    [sym_binary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1329),
    [sym_update_expression] = STATE(1329),
    [sym_string] = STATE(1329),
    [sym_template_string] = STATE(1329),
    [sym_regex] = STATE(1329),
    [sym_meta_property] = STATE(1329),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1329),
    [sym_type_assertion] = STATE(1329),
    [sym_as_expression] = STATE(1329),
    [sym_internal_module] = STATE(1329),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1860),
    [sym_this] = ACTIONS(1862),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1862),
    [sym_false] = ACTIONS(1862),
    [sym_null] = ACTIONS(1862),
    [sym_undefined] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [347] = {
    [sym_import] = STATE(1028),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1028),
    [sym_yield_expression] = STATE(1028),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1028),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1028),
    [sym_arrow_function] = STATE(1028),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1028),
    [sym_new_expression] = STATE(1028),
    [sym_await_expression] = STATE(1028),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1028),
    [sym_augmented_assignment_expression] = STATE(1028),
    [sym_ternary_expression] = STATE(1028),
    [sym_binary_expression] = STATE(1028),
    [sym_unary_expression] = STATE(1028),
    [sym_update_expression] = STATE(1028),
    [sym_string] = STATE(1028),
    [sym_template_string] = STATE(1028),
    [sym_regex] = STATE(1028),
    [sym_meta_property] = STATE(1028),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1028),
    [sym_as_expression] = STATE(1028),
    [sym_internal_module] = STATE(1028),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2152),
    [sym_this] = ACTIONS(2154),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2154),
    [sym_false] = ACTIONS(2154),
    [sym_null] = ACTIONS(2154),
    [sym_undefined] = ACTIONS(2154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [348] = {
    [sym_import] = STATE(1360),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1360),
    [sym_yield_expression] = STATE(1360),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1360),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1360),
    [sym_arrow_function] = STATE(1360),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1360),
    [sym_new_expression] = STATE(1360),
    [sym_await_expression] = STATE(1360),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1360),
    [sym_augmented_assignment_expression] = STATE(1360),
    [sym_ternary_expression] = STATE(1360),
    [sym_binary_expression] = STATE(1360),
    [sym_unary_expression] = STATE(1360),
    [sym_update_expression] = STATE(1360),
    [sym_string] = STATE(1360),
    [sym_template_string] = STATE(1360),
    [sym_regex] = STATE(1360),
    [sym_meta_property] = STATE(1360),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1360),
    [sym_type_assertion] = STATE(1360),
    [sym_as_expression] = STATE(1360),
    [sym_internal_module] = STATE(1360),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2156),
    [sym_this] = ACTIONS(1005),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1005),
    [sym_false] = ACTIONS(1005),
    [sym_null] = ACTIONS(1005),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [349] = {
    [sym_import] = STATE(1335),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1335),
    [sym_yield_expression] = STATE(1335),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1335),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1335),
    [sym_arrow_function] = STATE(1335),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1335),
    [sym_new_expression] = STATE(1335),
    [sym_await_expression] = STATE(1335),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1335),
    [sym_augmented_assignment_expression] = STATE(1335),
    [sym_ternary_expression] = STATE(1335),
    [sym_binary_expression] = STATE(1335),
    [sym_unary_expression] = STATE(1335),
    [sym_update_expression] = STATE(1335),
    [sym_string] = STATE(1335),
    [sym_template_string] = STATE(1335),
    [sym_regex] = STATE(1335),
    [sym_meta_property] = STATE(1335),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1335),
    [sym_type_assertion] = STATE(1335),
    [sym_as_expression] = STATE(1335),
    [sym_internal_module] = STATE(1335),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2158),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [350] = {
    [sym_import] = STATE(1062),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1062),
    [sym_yield_expression] = STATE(1062),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1062),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1062),
    [sym_arrow_function] = STATE(1062),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1062),
    [sym_new_expression] = STATE(1062),
    [sym_await_expression] = STATE(1062),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1062),
    [sym_augmented_assignment_expression] = STATE(1062),
    [sym_ternary_expression] = STATE(1062),
    [sym_binary_expression] = STATE(1062),
    [sym_unary_expression] = STATE(1062),
    [sym_update_expression] = STATE(1062),
    [sym_string] = STATE(1062),
    [sym_template_string] = STATE(1062),
    [sym_regex] = STATE(1062),
    [sym_meta_property] = STATE(1062),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1062),
    [sym_type_assertion] = STATE(1062),
    [sym_as_expression] = STATE(1062),
    [sym_internal_module] = STATE(1062),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(2162),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2164),
    [sym_this] = ACTIONS(2166),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [sym_null] = ACTIONS(2166),
    [sym_undefined] = ACTIONS(2166),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [351] = {
    [sym_import] = STATE(1331),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1331),
    [sym_yield_expression] = STATE(1331),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1331),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1331),
    [sym_arrow_function] = STATE(1331),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1331),
    [sym_new_expression] = STATE(1331),
    [sym_await_expression] = STATE(1331),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1331),
    [sym_augmented_assignment_expression] = STATE(1331),
    [sym_ternary_expression] = STATE(1331),
    [sym_binary_expression] = STATE(1331),
    [sym_unary_expression] = STATE(1331),
    [sym_update_expression] = STATE(1331),
    [sym_string] = STATE(1331),
    [sym_template_string] = STATE(1331),
    [sym_regex] = STATE(1331),
    [sym_meta_property] = STATE(1331),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1331),
    [sym_type_assertion] = STATE(1331),
    [sym_as_expression] = STATE(1331),
    [sym_internal_module] = STATE(1331),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2168),
    [sym_this] = ACTIONS(2170),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2170),
    [sym_false] = ACTIONS(2170),
    [sym_null] = ACTIONS(2170),
    [sym_undefined] = ACTIONS(2170),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [352] = {
    [sym_import] = STATE(1332),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1332),
    [sym_yield_expression] = STATE(1332),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1332),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1332),
    [sym_arrow_function] = STATE(1332),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1332),
    [sym_new_expression] = STATE(1332),
    [sym_await_expression] = STATE(1332),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1332),
    [sym_augmented_assignment_expression] = STATE(1332),
    [sym_ternary_expression] = STATE(1332),
    [sym_binary_expression] = STATE(1332),
    [sym_unary_expression] = STATE(1332),
    [sym_update_expression] = STATE(1332),
    [sym_string] = STATE(1332),
    [sym_template_string] = STATE(1332),
    [sym_regex] = STATE(1332),
    [sym_meta_property] = STATE(1332),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(1332),
    [sym_as_expression] = STATE(1332),
    [sym_internal_module] = STATE(1332),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2172),
    [sym_this] = ACTIONS(2174),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2174),
    [sym_false] = ACTIONS(2174),
    [sym_null] = ACTIONS(2174),
    [sym_undefined] = ACTIONS(2174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [353] = {
    [sym_import] = STATE(1188),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1188),
    [sym_yield_expression] = STATE(1188),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1188),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1188),
    [sym_arrow_function] = STATE(1188),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1188),
    [sym_new_expression] = STATE(1188),
    [sym_await_expression] = STATE(1188),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1188),
    [sym_augmented_assignment_expression] = STATE(1188),
    [sym_ternary_expression] = STATE(1188),
    [sym_binary_expression] = STATE(1188),
    [sym_unary_expression] = STATE(1188),
    [sym_update_expression] = STATE(1188),
    [sym_string] = STATE(1188),
    [sym_template_string] = STATE(1188),
    [sym_regex] = STATE(1188),
    [sym_meta_property] = STATE(1188),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1188),
    [sym_type_assertion] = STATE(1188),
    [sym_as_expression] = STATE(1188),
    [sym_internal_module] = STATE(1188),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2176),
    [sym_this] = ACTIONS(2178),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2178),
    [sym_false] = ACTIONS(2178),
    [sym_null] = ACTIONS(2178),
    [sym_undefined] = ACTIONS(2178),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [354] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1256),
    [sym_type_assertion] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2180),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [sym_undefined] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [355] = {
    [sym_import] = STATE(1252),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1252),
    [sym_yield_expression] = STATE(1252),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1252),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1252),
    [sym_arrow_function] = STATE(1252),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1252),
    [sym_new_expression] = STATE(1252),
    [sym_await_expression] = STATE(1252),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1252),
    [sym_augmented_assignment_expression] = STATE(1252),
    [sym_ternary_expression] = STATE(1252),
    [sym_binary_expression] = STATE(1252),
    [sym_unary_expression] = STATE(1252),
    [sym_update_expression] = STATE(1252),
    [sym_string] = STATE(1252),
    [sym_template_string] = STATE(1252),
    [sym_regex] = STATE(1252),
    [sym_meta_property] = STATE(1252),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1252),
    [sym_type_assertion] = STATE(1252),
    [sym_as_expression] = STATE(1252),
    [sym_internal_module] = STATE(1252),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2184),
    [sym_this] = ACTIONS(2038),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2038),
    [sym_false] = ACTIONS(2038),
    [sym_null] = ACTIONS(2038),
    [sym_undefined] = ACTIONS(2038),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [356] = {
    [sym_import] = STATE(1300),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1300),
    [sym_yield_expression] = STATE(1300),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1300),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1300),
    [sym_arrow_function] = STATE(1300),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1300),
    [sym_new_expression] = STATE(1300),
    [sym_await_expression] = STATE(1300),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1300),
    [sym_augmented_assignment_expression] = STATE(1300),
    [sym_ternary_expression] = STATE(1300),
    [sym_binary_expression] = STATE(1300),
    [sym_unary_expression] = STATE(1300),
    [sym_update_expression] = STATE(1300),
    [sym_string] = STATE(1300),
    [sym_template_string] = STATE(1300),
    [sym_regex] = STATE(1300),
    [sym_meta_property] = STATE(1300),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1300),
    [sym_type_assertion] = STATE(1300),
    [sym_as_expression] = STATE(1300),
    [sym_internal_module] = STATE(1300),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2186),
    [sym_this] = ACTIONS(2188),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [357] = {
    [sym_import] = STATE(1090),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1090),
    [sym_yield_expression] = STATE(1090),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1090),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1090),
    [sym_arrow_function] = STATE(1090),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1090),
    [sym_new_expression] = STATE(1090),
    [sym_await_expression] = STATE(1090),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1090),
    [sym_augmented_assignment_expression] = STATE(1090),
    [sym_ternary_expression] = STATE(1090),
    [sym_binary_expression] = STATE(1090),
    [sym_unary_expression] = STATE(1090),
    [sym_update_expression] = STATE(1090),
    [sym_string] = STATE(1090),
    [sym_template_string] = STATE(1090),
    [sym_regex] = STATE(1090),
    [sym_meta_property] = STATE(1090),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1090),
    [sym_type_assertion] = STATE(1090),
    [sym_as_expression] = STATE(1090),
    [sym_internal_module] = STATE(1090),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(2062),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2190),
    [sym_this] = ACTIONS(2192),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2192),
    [sym_false] = ACTIONS(2192),
    [sym_null] = ACTIONS(2192),
    [sym_undefined] = ACTIONS(2192),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [358] = {
    [sym_import] = STATE(1250),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1250),
    [sym_yield_expression] = STATE(1250),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1250),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1250),
    [sym_arrow_function] = STATE(1250),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1250),
    [sym_new_expression] = STATE(1250),
    [sym_await_expression] = STATE(1250),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1250),
    [sym_augmented_assignment_expression] = STATE(1250),
    [sym_ternary_expression] = STATE(1250),
    [sym_binary_expression] = STATE(1250),
    [sym_unary_expression] = STATE(1250),
    [sym_update_expression] = STATE(1250),
    [sym_string] = STATE(1250),
    [sym_template_string] = STATE(1250),
    [sym_regex] = STATE(1250),
    [sym_meta_property] = STATE(1250),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1250),
    [sym_type_assertion] = STATE(1250),
    [sym_as_expression] = STATE(1250),
    [sym_internal_module] = STATE(1250),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2194),
    [sym_this] = ACTIONS(2196),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_undefined] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [359] = {
    [sym_import] = STATE(1253),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1253),
    [sym_yield_expression] = STATE(1253),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1253),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1253),
    [sym_arrow_function] = STATE(1253),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1253),
    [sym_new_expression] = STATE(1253),
    [sym_await_expression] = STATE(1253),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1253),
    [sym_augmented_assignment_expression] = STATE(1253),
    [sym_ternary_expression] = STATE(1253),
    [sym_binary_expression] = STATE(1253),
    [sym_unary_expression] = STATE(1253),
    [sym_update_expression] = STATE(1253),
    [sym_string] = STATE(1253),
    [sym_template_string] = STATE(1253),
    [sym_regex] = STATE(1253),
    [sym_meta_property] = STATE(1253),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1253),
    [sym_type_assertion] = STATE(1253),
    [sym_as_expression] = STATE(1253),
    [sym_internal_module] = STATE(1253),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(642),
    [sym_this] = ACTIONS(644),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(644),
    [sym_false] = ACTIONS(644),
    [sym_null] = ACTIONS(644),
    [sym_undefined] = ACTIONS(644),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [360] = {
    [sym_import] = STATE(968),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(968),
    [sym_yield_expression] = STATE(968),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(968),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(968),
    [sym_arrow_function] = STATE(968),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(968),
    [sym_new_expression] = STATE(968),
    [sym_await_expression] = STATE(968),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(968),
    [sym_augmented_assignment_expression] = STATE(968),
    [sym_ternary_expression] = STATE(968),
    [sym_binary_expression] = STATE(968),
    [sym_unary_expression] = STATE(968),
    [sym_update_expression] = STATE(968),
    [sym_string] = STATE(968),
    [sym_template_string] = STATE(968),
    [sym_regex] = STATE(968),
    [sym_meta_property] = STATE(968),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(968),
    [sym_type_assertion] = STATE(968),
    [sym_as_expression] = STATE(968),
    [sym_internal_module] = STATE(968),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2198),
    [sym_this] = ACTIONS(2200),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2200),
    [sym_false] = ACTIONS(2200),
    [sym_null] = ACTIONS(2200),
    [sym_undefined] = ACTIONS(2200),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [361] = {
    [sym_import] = STATE(1432),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1432),
    [sym_yield_expression] = STATE(1432),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1432),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1432),
    [sym_arrow_function] = STATE(1432),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1432),
    [sym_new_expression] = STATE(1432),
    [sym_await_expression] = STATE(1432),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1432),
    [sym_augmented_assignment_expression] = STATE(1432),
    [sym_ternary_expression] = STATE(1432),
    [sym_binary_expression] = STATE(1432),
    [sym_unary_expression] = STATE(1432),
    [sym_update_expression] = STATE(1432),
    [sym_string] = STATE(1432),
    [sym_template_string] = STATE(1432),
    [sym_regex] = STATE(1432),
    [sym_meta_property] = STATE(1432),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1432),
    [sym_type_assertion] = STATE(1432),
    [sym_as_expression] = STATE(1432),
    [sym_internal_module] = STATE(1432),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2202),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [362] = {
    [sym_import] = STATE(1326),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1326),
    [sym_yield_expression] = STATE(1326),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1326),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1326),
    [sym_arrow_function] = STATE(1326),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1326),
    [sym_new_expression] = STATE(1326),
    [sym_await_expression] = STATE(1326),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1326),
    [sym_augmented_assignment_expression] = STATE(1326),
    [sym_ternary_expression] = STATE(1326),
    [sym_binary_expression] = STATE(1326),
    [sym_unary_expression] = STATE(1326),
    [sym_update_expression] = STATE(1326),
    [sym_string] = STATE(1326),
    [sym_template_string] = STATE(1326),
    [sym_regex] = STATE(1326),
    [sym_meta_property] = STATE(1326),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1326),
    [sym_type_assertion] = STATE(1326),
    [sym_as_expression] = STATE(1326),
    [sym_internal_module] = STATE(1326),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2206),
    [sym_this] = ACTIONS(2208),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2208),
    [sym_false] = ACTIONS(2208),
    [sym_null] = ACTIONS(2208),
    [sym_undefined] = ACTIONS(2208),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [363] = {
    [sym_import] = STATE(1485),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1485),
    [sym_yield_expression] = STATE(1485),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1485),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1485),
    [sym_arrow_function] = STATE(1485),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1485),
    [sym_new_expression] = STATE(1485),
    [sym_await_expression] = STATE(1485),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1485),
    [sym_augmented_assignment_expression] = STATE(1485),
    [sym_ternary_expression] = STATE(1485),
    [sym_binary_expression] = STATE(1485),
    [sym_unary_expression] = STATE(1485),
    [sym_update_expression] = STATE(1485),
    [sym_string] = STATE(1485),
    [sym_template_string] = STATE(1485),
    [sym_regex] = STATE(1485),
    [sym_meta_property] = STATE(1485),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1485),
    [sym_type_assertion] = STATE(1485),
    [sym_as_expression] = STATE(1485),
    [sym_internal_module] = STATE(1485),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2210),
    [sym_this] = ACTIONS(2212),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2212),
    [sym_false] = ACTIONS(2212),
    [sym_null] = ACTIONS(2212),
    [sym_undefined] = ACTIONS(2212),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [364] = {
    [sym_import] = STATE(1143),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1143),
    [sym_yield_expression] = STATE(1143),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1143),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1143),
    [sym_arrow_function] = STATE(1143),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1143),
    [sym_new_expression] = STATE(1143),
    [sym_await_expression] = STATE(1143),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1143),
    [sym_augmented_assignment_expression] = STATE(1143),
    [sym_ternary_expression] = STATE(1143),
    [sym_binary_expression] = STATE(1143),
    [sym_unary_expression] = STATE(1143),
    [sym_update_expression] = STATE(1143),
    [sym_string] = STATE(1143),
    [sym_template_string] = STATE(1143),
    [sym_regex] = STATE(1143),
    [sym_meta_property] = STATE(1143),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1143),
    [sym_as_expression] = STATE(1143),
    [sym_internal_module] = STATE(1143),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2214),
    [sym_this] = ACTIONS(2216),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_undefined] = ACTIONS(2216),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [365] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1144),
    [sym_yield_expression] = STATE(1144),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1144),
    [sym_await_expression] = STATE(1144),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1144),
    [sym_augmented_assignment_expression] = STATE(1144),
    [sym_ternary_expression] = STATE(1144),
    [sym_binary_expression] = STATE(1144),
    [sym_unary_expression] = STATE(1144),
    [sym_update_expression] = STATE(1144),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1144),
    [sym_as_expression] = STATE(1144),
    [sym_internal_module] = STATE(1144),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2218),
    [sym_this] = ACTIONS(2220),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2220),
    [sym_false] = ACTIONS(2220),
    [sym_null] = ACTIONS(2220),
    [sym_undefined] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [366] = {
    [sym_import] = STATE(1239),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1239),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1239),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1239),
    [sym_arrow_function] = STATE(1239),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1239),
    [sym_new_expression] = STATE(1239),
    [sym_await_expression] = STATE(1239),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1239),
    [sym_augmented_assignment_expression] = STATE(1239),
    [sym_ternary_expression] = STATE(1239),
    [sym_binary_expression] = STATE(1239),
    [sym_unary_expression] = STATE(1239),
    [sym_update_expression] = STATE(1239),
    [sym_string] = STATE(1239),
    [sym_template_string] = STATE(1239),
    [sym_regex] = STATE(1239),
    [sym_meta_property] = STATE(1239),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1239),
    [sym_type_assertion] = STATE(1239),
    [sym_as_expression] = STATE(1239),
    [sym_internal_module] = STATE(1239),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2222),
    [sym_this] = ACTIONS(2224),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [sym_null] = ACTIONS(2224),
    [sym_undefined] = ACTIONS(2224),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [367] = {
    [sym_import] = STATE(1217),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1217),
    [sym_yield_expression] = STATE(1217),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1217),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1217),
    [sym_arrow_function] = STATE(1217),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1217),
    [sym_new_expression] = STATE(1217),
    [sym_await_expression] = STATE(1217),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1217),
    [sym_augmented_assignment_expression] = STATE(1217),
    [sym_ternary_expression] = STATE(1217),
    [sym_binary_expression] = STATE(1217),
    [sym_unary_expression] = STATE(1217),
    [sym_update_expression] = STATE(1217),
    [sym_string] = STATE(1217),
    [sym_template_string] = STATE(1217),
    [sym_regex] = STATE(1217),
    [sym_meta_property] = STATE(1217),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1217),
    [sym_type_assertion] = STATE(1217),
    [sym_as_expression] = STATE(1217),
    [sym_internal_module] = STATE(1217),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2226),
    [sym_this] = ACTIONS(2228),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [sym_null] = ACTIONS(2228),
    [sym_undefined] = ACTIONS(2228),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [368] = {
    [sym_import] = STATE(1240),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1240),
    [sym_yield_expression] = STATE(1240),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1240),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1240),
    [sym_arrow_function] = STATE(1240),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1240),
    [sym_new_expression] = STATE(1240),
    [sym_await_expression] = STATE(1240),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1240),
    [sym_augmented_assignment_expression] = STATE(1240),
    [sym_ternary_expression] = STATE(1240),
    [sym_binary_expression] = STATE(1240),
    [sym_unary_expression] = STATE(1240),
    [sym_update_expression] = STATE(1240),
    [sym_string] = STATE(1240),
    [sym_template_string] = STATE(1240),
    [sym_regex] = STATE(1240),
    [sym_meta_property] = STATE(1240),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1240),
    [sym_as_expression] = STATE(1240),
    [sym_internal_module] = STATE(1240),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2230),
    [sym_this] = ACTIONS(2232),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [sym_null] = ACTIONS(2232),
    [sym_undefined] = ACTIONS(2232),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [369] = {
    [sym_import] = STATE(971),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(971),
    [sym_yield_expression] = STATE(971),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(971),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(971),
    [sym_arrow_function] = STATE(971),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(971),
    [sym_new_expression] = STATE(971),
    [sym_await_expression] = STATE(971),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(971),
    [sym_augmented_assignment_expression] = STATE(971),
    [sym_ternary_expression] = STATE(971),
    [sym_binary_expression] = STATE(971),
    [sym_unary_expression] = STATE(971),
    [sym_update_expression] = STATE(971),
    [sym_string] = STATE(971),
    [sym_template_string] = STATE(971),
    [sym_regex] = STATE(971),
    [sym_meta_property] = STATE(971),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(971),
    [sym_type_assertion] = STATE(971),
    [sym_as_expression] = STATE(971),
    [sym_internal_module] = STATE(971),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2234),
    [sym_this] = ACTIONS(2236),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2236),
    [sym_false] = ACTIONS(2236),
    [sym_null] = ACTIONS(2236),
    [sym_undefined] = ACTIONS(2236),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [370] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1222),
    [sym_yield_expression] = STATE(1222),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1222),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1222),
    [sym_arrow_function] = STATE(1222),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1222),
    [sym_new_expression] = STATE(1222),
    [sym_await_expression] = STATE(1222),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1222),
    [sym_augmented_assignment_expression] = STATE(1222),
    [sym_ternary_expression] = STATE(1222),
    [sym_binary_expression] = STATE(1222),
    [sym_unary_expression] = STATE(1222),
    [sym_update_expression] = STATE(1222),
    [sym_string] = STATE(1222),
    [sym_template_string] = STATE(1222),
    [sym_regex] = STATE(1222),
    [sym_meta_property] = STATE(1222),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1222),
    [sym_type_assertion] = STATE(1222),
    [sym_as_expression] = STATE(1222),
    [sym_internal_module] = STATE(1222),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2238),
    [sym_this] = ACTIONS(2240),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2240),
    [sym_false] = ACTIONS(2240),
    [sym_null] = ACTIONS(2240),
    [sym_undefined] = ACTIONS(2240),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [371] = {
    [sym_import] = STATE(1312),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1312),
    [sym_yield_expression] = STATE(1312),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1312),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1312),
    [sym_arrow_function] = STATE(1312),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1312),
    [sym_new_expression] = STATE(1312),
    [sym_await_expression] = STATE(1312),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1312),
    [sym_augmented_assignment_expression] = STATE(1312),
    [sym_ternary_expression] = STATE(1312),
    [sym_binary_expression] = STATE(1312),
    [sym_unary_expression] = STATE(1312),
    [sym_update_expression] = STATE(1312),
    [sym_string] = STATE(1312),
    [sym_template_string] = STATE(1312),
    [sym_regex] = STATE(1312),
    [sym_meta_property] = STATE(1312),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1312),
    [sym_type_assertion] = STATE(1312),
    [sym_as_expression] = STATE(1312),
    [sym_internal_module] = STATE(1312),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2242),
    [sym_this] = ACTIONS(2244),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [sym_null] = ACTIONS(2244),
    [sym_undefined] = ACTIONS(2244),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [372] = {
    [sym_import] = STATE(1314),
    [sym_parenthesized_expression] = STATE(896),
    [sym__expression] = STATE(1314),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1592),
    [sym_array] = STATE(1590),
    [sym_class] = STATE(1314),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1314),
    [sym_arrow_function] = STATE(1314),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1314),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_assignment_expression] = STATE(1314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1314),
    [sym_template_string] = STATE(1314),
    [sym_regex] = STATE(1314),
    [sym_meta_property] = STATE(1314),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1314),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(334),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_namespace] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_typeof] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_void] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2246),
    [sym_this] = ACTIONS(2248),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [sym_null] = ACTIONS(2248),
    [sym_undefined] = ACTIONS(2248),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
    [anon_sym_declare] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(612),
    [anon_sym_number] = ACTIONS(612),
    [anon_sym_boolean] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_symbol] = ACTIONS(612),
  },
  [373] = {
    [sym_import] = STATE(1221),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1221),
    [sym_yield_expression] = STATE(1221),
    [sym_object] = STATE(1464),
    [sym_array] = STATE(1463),
    [sym_class] = STATE(1221),
    [sym_function] = STATE(1162),
    [sym_generator_function] = STATE(1221),
    [sym_arrow_function] = STATE(1221),
    [sym__call_signature] = STATE(2741),
    [sym_call_expression] = STATE(1221),
    [sym_new_expression] = STATE(1221),
    [sym_await_expression] = STATE(1221),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1221),
    [sym_augmented_assignment_expression] = STATE(1221),
    [sym_ternary_expression] = STATE(1221),
    [sym_binary_expression] = STATE(1221),
    [sym_unary_expression] = STATE(1221),
    [sym_update_expression] = STATE(1221),
    [sym_string] = STATE(1221),
    [sym_template_string] = STATE(1221),
    [sym_regex] = STATE(1221),
    [sym_meta_property] = STATE(1221),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1221),
    [sym_type_assertion] = STATE(1221),
    [sym_as_expression] = STATE(1221),
    [sym_internal_module] = STATE(1221),
    [sym_type_arguments] = STATE(368),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2250),
    [sym_this] = ACTIONS(2252),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [sym_null] = ACTIONS(2252),
    [sym_undefined] = ACTIONS(2252),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
  },
  [374] = {
    [sym_import] = STATE(1325),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1325),
    [sym_yield_expression] = STATE(1325),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1325),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1325),
    [sym_arrow_function] = STATE(1325),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1325),
    [sym_new_expression] = STATE(1325),
    [sym_await_expression] = STATE(1325),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1325),
    [sym_augmented_assignment_expression] = STATE(1325),
    [sym_ternary_expression] = STATE(1325),
    [sym_binary_expression] = STATE(1325),
    [sym_unary_expression] = STATE(1325),
    [sym_update_expression] = STATE(1325),
    [sym_string] = STATE(1325),
    [sym_template_string] = STATE(1325),
    [sym_regex] = STATE(1325),
    [sym_meta_property] = STATE(1325),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1325),
    [sym_type_assertion] = STATE(1325),
    [sym_as_expression] = STATE(1325),
    [sym_internal_module] = STATE(1325),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2254),
    [sym_this] = ACTIONS(2256),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [sym_null] = ACTIONS(2256),
    [sym_undefined] = ACTIONS(2256),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [375] = {
    [sym_import] = STATE(1085),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1085),
    [sym_yield_expression] = STATE(1085),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1085),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1085),
    [sym_arrow_function] = STATE(1085),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1085),
    [sym_new_expression] = STATE(1085),
    [sym_await_expression] = STATE(1085),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1085),
    [sym_augmented_assignment_expression] = STATE(1085),
    [sym_ternary_expression] = STATE(1085),
    [sym_binary_expression] = STATE(1085),
    [sym_unary_expression] = STATE(1085),
    [sym_update_expression] = STATE(1085),
    [sym_string] = STATE(1085),
    [sym_template_string] = STATE(1085),
    [sym_regex] = STATE(1085),
    [sym_meta_property] = STATE(1085),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1085),
    [sym_as_expression] = STATE(1085),
    [sym_internal_module] = STATE(1085),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2258),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [376] = {
    [sym_import] = STATE(1437),
    [sym_parenthesized_expression] = STATE(881),
    [sym__expression] = STATE(1437),
    [sym_yield_expression] = STATE(1437),
    [sym_object] = STATE(1549),
    [sym_array] = STATE(1548),
    [sym_class] = STATE(1437),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1437),
    [sym_arrow_function] = STATE(1437),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1437),
    [sym_new_expression] = STATE(1437),
    [sym_await_expression] = STATE(1437),
    [sym_member_expression] = STATE(881),
    [sym_subscript_expression] = STATE(881),
    [sym_assignment_expression] = STATE(1437),
    [sym_augmented_assignment_expression] = STATE(1437),
    [sym_ternary_expression] = STATE(1437),
    [sym_binary_expression] = STATE(1437),
    [sym_unary_expression] = STATE(1437),
    [sym_update_expression] = STATE(1437),
    [sym_string] = STATE(1437),
    [sym_template_string] = STATE(1437),
    [sym_regex] = STATE(1437),
    [sym_meta_property] = STATE(1437),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1437),
    [sym_type_assertion] = STATE(1437),
    [sym_as_expression] = STATE(1437),
    [sym_internal_module] = STATE(1437),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2262),
    [sym_this] = ACTIONS(2264),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [sym_null] = ACTIONS(2264),
    [sym_undefined] = ACTIONS(2264),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
  },
  [377] = {
    [sym_import] = STATE(1154),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1154),
    [sym_yield_expression] = STATE(1154),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1154),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1154),
    [sym_arrow_function] = STATE(1154),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1154),
    [sym_new_expression] = STATE(1154),
    [sym_await_expression] = STATE(1154),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1154),
    [sym_augmented_assignment_expression] = STATE(1154),
    [sym_ternary_expression] = STATE(1154),
    [sym_binary_expression] = STATE(1154),
    [sym_unary_expression] = STATE(1154),
    [sym_update_expression] = STATE(1154),
    [sym_string] = STATE(1154),
    [sym_template_string] = STATE(1154),
    [sym_regex] = STATE(1154),
    [sym_meta_property] = STATE(1154),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1154),
    [sym_type_assertion] = STATE(1154),
    [sym_as_expression] = STATE(1154),
    [sym_internal_module] = STATE(1154),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2266),
    [sym_this] = ACTIONS(2268),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2268),
    [sym_false] = ACTIONS(2268),
    [sym_null] = ACTIONS(2268),
    [sym_undefined] = ACTIONS(2268),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [378] = {
    [sym__declaration] = STATE(577),
    [sym_variable_declaration] = STATE(577),
    [sym_lexical_declaration] = STATE(577),
    [sym_class_declaration] = STATE(577),
    [sym_function_declaration] = STATE(577),
    [sym_generator_function_declaration] = STATE(577),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(577),
    [sym_abstract_class_declaration] = STATE(577),
    [sym_module] = STATE(577),
    [sym_internal_module] = STATE(577),
    [sym_import_alias] = STATE(577),
    [sym_interface_declaration] = STATE(577),
    [sym_enum_declaration] = STATE(577),
    [sym_type_alias_declaration] = STATE(577),
    [aux_sym_export_statement_repeat1] = STATE(2331),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1424),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1343),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_class] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1428),
    [anon_sym_function] = ACTIONS(1430),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1432),
    [anon_sym_declare] = ACTIONS(1434),
    [anon_sym_module] = ACTIONS(2270),
    [anon_sym_global] = ACTIONS(1440),
    [anon_sym_interface] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1372),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [379] = {
    [sym_import] = STATE(923),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(923),
    [sym_yield_expression] = STATE(923),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(923),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(923),
    [sym_arrow_function] = STATE(923),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(923),
    [sym_new_expression] = STATE(923),
    [sym_await_expression] = STATE(923),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(923),
    [sym_augmented_assignment_expression] = STATE(923),
    [sym_ternary_expression] = STATE(923),
    [sym_binary_expression] = STATE(923),
    [sym_unary_expression] = STATE(923),
    [sym_update_expression] = STATE(923),
    [sym_string] = STATE(923),
    [sym_template_string] = STATE(923),
    [sym_regex] = STATE(923),
    [sym_meta_property] = STATE(923),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(923),
    [sym_type_assertion] = STATE(923),
    [sym_as_expression] = STATE(923),
    [sym_internal_module] = STATE(923),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1972),
    [sym_this] = ACTIONS(1974),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [sym_null] = ACTIONS(1974),
    [sym_undefined] = ACTIONS(1974),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [380] = {
    [sym_import] = STATE(1597),
    [sym_parenthesized_expression] = STATE(899),
    [sym__expression] = STATE(1597),
    [sym_yield_expression] = STATE(1597),
    [sym_object] = STATE(1628),
    [sym_array] = STATE(1627),
    [sym_class] = STATE(1597),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1597),
    [sym_arrow_function] = STATE(1597),
    [sym__call_signature] = STATE(2832),
    [sym_call_expression] = STATE(1597),
    [sym_new_expression] = STATE(1597),
    [sym_await_expression] = STATE(1597),
    [sym_member_expression] = STATE(899),
    [sym_subscript_expression] = STATE(899),
    [sym_assignment_expression] = STATE(1597),
    [sym_augmented_assignment_expression] = STATE(1597),
    [sym_ternary_expression] = STATE(1597),
    [sym_binary_expression] = STATE(1597),
    [sym_unary_expression] = STATE(1597),
    [sym_update_expression] = STATE(1597),
    [sym_string] = STATE(1597),
    [sym_template_string] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_meta_property] = STATE(1597),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1597),
    [sym_type_assertion] = STATE(1597),
    [sym_as_expression] = STATE(1597),
    [sym_internal_module] = STATE(1597),
    [sym_type_arguments] = STATE(290),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(1696),
    [anon_sym_namespace] = ACTIONS(1698),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1696),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1700),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1702),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1418),
    [sym_this] = ACTIONS(1420),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1420),
    [sym_false] = ACTIONS(1420),
    [sym_null] = ACTIONS(1420),
    [sym_undefined] = ACTIONS(1420),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1696),
    [anon_sym_get] = ACTIONS(1696),
    [anon_sym_set] = ACTIONS(1696),
    [anon_sym_declare] = ACTIONS(1696),
    [anon_sym_public] = ACTIONS(1696),
    [anon_sym_private] = ACTIONS(1696),
    [anon_sym_protected] = ACTIONS(1696),
    [anon_sym_module] = ACTIONS(1696),
    [anon_sym_any] = ACTIONS(1696),
    [anon_sym_number] = ACTIONS(1696),
    [anon_sym_boolean] = ACTIONS(1696),
    [anon_sym_string] = ACTIONS(1696),
    [anon_sym_symbol] = ACTIONS(1696),
  },
  [381] = {
    [sym_import] = STATE(982),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(982),
    [sym_yield_expression] = STATE(982),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(982),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(982),
    [sym_arrow_function] = STATE(982),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(982),
    [sym_new_expression] = STATE(982),
    [sym_await_expression] = STATE(982),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(982),
    [sym_augmented_assignment_expression] = STATE(982),
    [sym_ternary_expression] = STATE(982),
    [sym_binary_expression] = STATE(982),
    [sym_unary_expression] = STATE(982),
    [sym_update_expression] = STATE(982),
    [sym_string] = STATE(982),
    [sym_template_string] = STATE(982),
    [sym_regex] = STATE(982),
    [sym_meta_property] = STATE(982),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(982),
    [sym_type_assertion] = STATE(982),
    [sym_as_expression] = STATE(982),
    [sym_internal_module] = STATE(982),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(579),
    [sym_this] = ACTIONS(581),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_null] = ACTIONS(581),
    [sym_undefined] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [382] = {
    [sym_import] = STATE(965),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(965),
    [sym_yield_expression] = STATE(965),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(965),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(965),
    [sym_arrow_function] = STATE(965),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(965),
    [sym_new_expression] = STATE(965),
    [sym_await_expression] = STATE(965),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(965),
    [sym_augmented_assignment_expression] = STATE(965),
    [sym_ternary_expression] = STATE(965),
    [sym_binary_expression] = STATE(965),
    [sym_unary_expression] = STATE(965),
    [sym_update_expression] = STATE(965),
    [sym_string] = STATE(965),
    [sym_template_string] = STATE(965),
    [sym_regex] = STATE(965),
    [sym_meta_property] = STATE(965),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(965),
    [sym_type_assertion] = STATE(965),
    [sym_as_expression] = STATE(965),
    [sym_internal_module] = STATE(965),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1994),
    [sym_this] = ACTIONS(1996),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [sym_null] = ACTIONS(1996),
    [sym_undefined] = ACTIONS(1996),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [383] = {
    [sym_import] = STATE(976),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(976),
    [sym_yield_expression] = STATE(976),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(976),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(976),
    [sym_arrow_function] = STATE(976),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(976),
    [sym_new_expression] = STATE(976),
    [sym_await_expression] = STATE(976),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(976),
    [sym_augmented_assignment_expression] = STATE(976),
    [sym_ternary_expression] = STATE(976),
    [sym_binary_expression] = STATE(976),
    [sym_unary_expression] = STATE(976),
    [sym_update_expression] = STATE(976),
    [sym_string] = STATE(976),
    [sym_template_string] = STATE(976),
    [sym_regex] = STATE(976),
    [sym_meta_property] = STATE(976),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(976),
    [sym_type_assertion] = STATE(976),
    [sym_as_expression] = STATE(976),
    [sym_internal_module] = STATE(976),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2274),
    [sym_this] = ACTIONS(1904),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1904),
    [sym_false] = ACTIONS(1904),
    [sym_null] = ACTIONS(1904),
    [sym_undefined] = ACTIONS(1904),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [384] = {
    [sym_import] = STATE(1225),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1225),
    [sym_yield_expression] = STATE(1225),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1225),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1225),
    [sym_arrow_function] = STATE(1225),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1225),
    [sym_new_expression] = STATE(1225),
    [sym_await_expression] = STATE(1225),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1225),
    [sym_augmented_assignment_expression] = STATE(1225),
    [sym_ternary_expression] = STATE(1225),
    [sym_binary_expression] = STATE(1225),
    [sym_unary_expression] = STATE(1225),
    [sym_update_expression] = STATE(1225),
    [sym_string] = STATE(1225),
    [sym_template_string] = STATE(1225),
    [sym_regex] = STATE(1225),
    [sym_meta_property] = STATE(1225),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1225),
    [sym_type_assertion] = STATE(1225),
    [sym_as_expression] = STATE(1225),
    [sym_internal_module] = STATE(1225),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2276),
    [sym_this] = ACTIONS(2278),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2278),
    [sym_false] = ACTIONS(2278),
    [sym_null] = ACTIONS(2278),
    [sym_undefined] = ACTIONS(2278),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [385] = {
    [sym_import] = STATE(949),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(949),
    [sym_yield_expression] = STATE(949),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(949),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(949),
    [sym_arrow_function] = STATE(949),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(949),
    [sym_new_expression] = STATE(949),
    [sym_await_expression] = STATE(949),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(949),
    [sym_augmented_assignment_expression] = STATE(949),
    [sym_ternary_expression] = STATE(949),
    [sym_binary_expression] = STATE(949),
    [sym_unary_expression] = STATE(949),
    [sym_update_expression] = STATE(949),
    [sym_string] = STATE(949),
    [sym_template_string] = STATE(949),
    [sym_regex] = STATE(949),
    [sym_meta_property] = STATE(949),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(949),
    [sym_type_assertion] = STATE(949),
    [sym_as_expression] = STATE(949),
    [sym_internal_module] = STATE(949),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2280),
    [sym_this] = ACTIONS(2282),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2282),
    [sym_false] = ACTIONS(2282),
    [sym_null] = ACTIONS(2282),
    [sym_undefined] = ACTIONS(2282),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [386] = {
    [sym_import] = STATE(1155),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1155),
    [sym_yield_expression] = STATE(1155),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1155),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1155),
    [sym_arrow_function] = STATE(1155),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1155),
    [sym_new_expression] = STATE(1155),
    [sym_await_expression] = STATE(1155),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1155),
    [sym_augmented_assignment_expression] = STATE(1155),
    [sym_ternary_expression] = STATE(1155),
    [sym_binary_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1155),
    [sym_update_expression] = STATE(1155),
    [sym_string] = STATE(1155),
    [sym_template_string] = STATE(1155),
    [sym_regex] = STATE(1155),
    [sym_meta_property] = STATE(1155),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1155),
    [sym_type_assertion] = STATE(1155),
    [sym_as_expression] = STATE(1155),
    [sym_internal_module] = STATE(1155),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2284),
    [sym_this] = ACTIONS(2286),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2286),
    [sym_false] = ACTIONS(2286),
    [sym_null] = ACTIONS(2286),
    [sym_undefined] = ACTIONS(2286),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [387] = {
    [sym_import] = STATE(1090),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1090),
    [sym_yield_expression] = STATE(1090),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1090),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1090),
    [sym_arrow_function] = STATE(1090),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1090),
    [sym_new_expression] = STATE(1090),
    [sym_await_expression] = STATE(1090),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1090),
    [sym_augmented_assignment_expression] = STATE(1090),
    [sym_ternary_expression] = STATE(1090),
    [sym_binary_expression] = STATE(1090),
    [sym_unary_expression] = STATE(1090),
    [sym_update_expression] = STATE(1090),
    [sym_string] = STATE(1090),
    [sym_template_string] = STATE(1090),
    [sym_regex] = STATE(1090),
    [sym_meta_property] = STATE(1090),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1090),
    [sym_type_assertion] = STATE(1090),
    [sym_as_expression] = STATE(1090),
    [sym_internal_module] = STATE(1090),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2190),
    [sym_this] = ACTIONS(2192),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2192),
    [sym_false] = ACTIONS(2192),
    [sym_null] = ACTIONS(2192),
    [sym_undefined] = ACTIONS(2192),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [388] = {
    [sym_import] = STATE(1153),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1153),
    [sym_yield_expression] = STATE(1153),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1153),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1153),
    [sym_arrow_function] = STATE(1153),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1153),
    [sym_new_expression] = STATE(1153),
    [sym_await_expression] = STATE(1153),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1153),
    [sym_augmented_assignment_expression] = STATE(1153),
    [sym_ternary_expression] = STATE(1153),
    [sym_binary_expression] = STATE(1153),
    [sym_unary_expression] = STATE(1153),
    [sym_update_expression] = STATE(1153),
    [sym_string] = STATE(1153),
    [sym_template_string] = STATE(1153),
    [sym_regex] = STATE(1153),
    [sym_meta_property] = STATE(1153),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1153),
    [sym_type_assertion] = STATE(1153),
    [sym_as_expression] = STATE(1153),
    [sym_internal_module] = STATE(1153),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(754),
    [sym_this] = ACTIONS(756),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(756),
    [sym_false] = ACTIONS(756),
    [sym_null] = ACTIONS(756),
    [sym_undefined] = ACTIONS(756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [389] = {
    [sym_import] = STATE(974),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(974),
    [sym_yield_expression] = STATE(974),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(974),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(974),
    [sym_arrow_function] = STATE(974),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(974),
    [sym_new_expression] = STATE(974),
    [sym_await_expression] = STATE(974),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(974),
    [sym_augmented_assignment_expression] = STATE(974),
    [sym_ternary_expression] = STATE(974),
    [sym_binary_expression] = STATE(974),
    [sym_unary_expression] = STATE(974),
    [sym_update_expression] = STATE(974),
    [sym_string] = STATE(974),
    [sym_template_string] = STATE(974),
    [sym_regex] = STATE(974),
    [sym_meta_property] = STATE(974),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(974),
    [sym_type_assertion] = STATE(974),
    [sym_as_expression] = STATE(974),
    [sym_internal_module] = STATE(974),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2288),
    [sym_this] = ACTIONS(2290),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2290),
    [sym_false] = ACTIONS(2290),
    [sym_null] = ACTIONS(2290),
    [sym_undefined] = ACTIONS(2290),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [390] = {
    [sym_import] = STATE(976),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(976),
    [sym_yield_expression] = STATE(976),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(976),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(976),
    [sym_arrow_function] = STATE(976),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(976),
    [sym_new_expression] = STATE(976),
    [sym_await_expression] = STATE(976),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(976),
    [sym_augmented_assignment_expression] = STATE(976),
    [sym_ternary_expression] = STATE(976),
    [sym_binary_expression] = STATE(976),
    [sym_unary_expression] = STATE(976),
    [sym_update_expression] = STATE(976),
    [sym_string] = STATE(976),
    [sym_template_string] = STATE(976),
    [sym_regex] = STATE(976),
    [sym_meta_property] = STATE(976),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(976),
    [sym_type_assertion] = STATE(976),
    [sym_as_expression] = STATE(976),
    [sym_internal_module] = STATE(976),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2292),
    [sym_this] = ACTIONS(1904),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1904),
    [sym_false] = ACTIONS(1904),
    [sym_null] = ACTIONS(1904),
    [sym_undefined] = ACTIONS(1904),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [391] = {
    [sym_import] = STATE(1097),
    [sym_parenthesized_expression] = STATE(830),
    [sym__expression] = STATE(1097),
    [sym_yield_expression] = STATE(1097),
    [sym_object] = STATE(1280),
    [sym_array] = STATE(1278),
    [sym_class] = STATE(1097),
    [sym_function] = STATE(1025),
    [sym_generator_function] = STATE(1097),
    [sym_arrow_function] = STATE(1097),
    [sym__call_signature] = STATE(2894),
    [sym_call_expression] = STATE(1097),
    [sym_new_expression] = STATE(1097),
    [sym_await_expression] = STATE(1097),
    [sym_member_expression] = STATE(830),
    [sym_subscript_expression] = STATE(830),
    [sym_assignment_expression] = STATE(1097),
    [sym_augmented_assignment_expression] = STATE(1097),
    [sym_ternary_expression] = STATE(1097),
    [sym_binary_expression] = STATE(1097),
    [sym_unary_expression] = STATE(1097),
    [sym_update_expression] = STATE(1097),
    [sym_string] = STATE(1097),
    [sym_template_string] = STATE(1097),
    [sym_regex] = STATE(1097),
    [sym_meta_property] = STATE(1097),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1097),
    [sym_type_assertion] = STATE(1097),
    [sym_as_expression] = STATE(1097),
    [sym_internal_module] = STATE(1097),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
  },
  [392] = {
    [sym_import] = STATE(1191),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1191),
    [sym_yield_expression] = STATE(1191),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1191),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1191),
    [sym_arrow_function] = STATE(1191),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1191),
    [sym_new_expression] = STATE(1191),
    [sym_await_expression] = STATE(1191),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1191),
    [sym_augmented_assignment_expression] = STATE(1191),
    [sym_ternary_expression] = STATE(1191),
    [sym_binary_expression] = STATE(1191),
    [sym_unary_expression] = STATE(1191),
    [sym_update_expression] = STATE(1191),
    [sym_string] = STATE(1191),
    [sym_template_string] = STATE(1191),
    [sym_regex] = STATE(1191),
    [sym_meta_property] = STATE(1191),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1191),
    [sym_type_assertion] = STATE(1191),
    [sym_as_expression] = STATE(1191),
    [sym_internal_module] = STATE(1191),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2294),
    [sym_this] = ACTIONS(2296),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [sym_null] = ACTIONS(2296),
    [sym_undefined] = ACTIONS(2296),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [393] = {
    [sym_import] = STATE(1206),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1206),
    [sym_yield_expression] = STATE(1206),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1206),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1206),
    [sym_arrow_function] = STATE(1206),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1206),
    [sym_new_expression] = STATE(1206),
    [sym_await_expression] = STATE(1206),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1206),
    [sym_augmented_assignment_expression] = STATE(1206),
    [sym_ternary_expression] = STATE(1206),
    [sym_binary_expression] = STATE(1206),
    [sym_unary_expression] = STATE(1206),
    [sym_update_expression] = STATE(1206),
    [sym_string] = STATE(1206),
    [sym_template_string] = STATE(1206),
    [sym_regex] = STATE(1206),
    [sym_meta_property] = STATE(1206),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1206),
    [sym_type_assertion] = STATE(1206),
    [sym_as_expression] = STATE(1206),
    [sym_internal_module] = STATE(1206),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2298),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [394] = {
    [sym_import] = STATE(1062),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(1062),
    [sym_yield_expression] = STATE(1062),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(1062),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1062),
    [sym_arrow_function] = STATE(1062),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(1062),
    [sym_new_expression] = STATE(1062),
    [sym_await_expression] = STATE(1062),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(1062),
    [sym_augmented_assignment_expression] = STATE(1062),
    [sym_ternary_expression] = STATE(1062),
    [sym_binary_expression] = STATE(1062),
    [sym_unary_expression] = STATE(1062),
    [sym_update_expression] = STATE(1062),
    [sym_string] = STATE(1062),
    [sym_template_string] = STATE(1062),
    [sym_regex] = STATE(1062),
    [sym_meta_property] = STATE(1062),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1062),
    [sym_type_assertion] = STATE(1062),
    [sym_as_expression] = STATE(1062),
    [sym_internal_module] = STATE(1062),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2164),
    [sym_this] = ACTIONS(2166),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [sym_null] = ACTIONS(2166),
    [sym_undefined] = ACTIONS(2166),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [395] = {
    [sym_import] = STATE(1171),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1171),
    [sym_yield_expression] = STATE(1171),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1171),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1171),
    [sym_arrow_function] = STATE(1171),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1171),
    [sym_new_expression] = STATE(1171),
    [sym_await_expression] = STATE(1171),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1171),
    [sym_augmented_assignment_expression] = STATE(1171),
    [sym_ternary_expression] = STATE(1171),
    [sym_binary_expression] = STATE(1171),
    [sym_unary_expression] = STATE(1171),
    [sym_update_expression] = STATE(1171),
    [sym_string] = STATE(1171),
    [sym_template_string] = STATE(1171),
    [sym_regex] = STATE(1171),
    [sym_meta_property] = STATE(1171),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1171),
    [sym_type_assertion] = STATE(1171),
    [sym_as_expression] = STATE(1171),
    [sym_internal_module] = STATE(1171),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2302),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [396] = {
    [sym_import] = STATE(1142),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1142),
    [sym_yield_expression] = STATE(1142),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1142),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1142),
    [sym_arrow_function] = STATE(1142),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1142),
    [sym_new_expression] = STATE(1142),
    [sym_await_expression] = STATE(1142),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1142),
    [sym_augmented_assignment_expression] = STATE(1142),
    [sym_ternary_expression] = STATE(1142),
    [sym_binary_expression] = STATE(1142),
    [sym_unary_expression] = STATE(1142),
    [sym_update_expression] = STATE(1142),
    [sym_string] = STATE(1142),
    [sym_template_string] = STATE(1142),
    [sym_regex] = STATE(1142),
    [sym_meta_property] = STATE(1142),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1142),
    [sym_type_assertion] = STATE(1142),
    [sym_as_expression] = STATE(1142),
    [sym_internal_module] = STATE(1142),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2306),
    [sym_this] = ACTIONS(1023),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [397] = {
    [sym_import] = STATE(1241),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1241),
    [sym_yield_expression] = STATE(1241),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1241),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1241),
    [sym_arrow_function] = STATE(1241),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1241),
    [sym_new_expression] = STATE(1241),
    [sym_await_expression] = STATE(1241),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1241),
    [sym_augmented_assignment_expression] = STATE(1241),
    [sym_ternary_expression] = STATE(1241),
    [sym_binary_expression] = STATE(1241),
    [sym_unary_expression] = STATE(1241),
    [sym_update_expression] = STATE(1241),
    [sym_string] = STATE(1241),
    [sym_template_string] = STATE(1241),
    [sym_regex] = STATE(1241),
    [sym_meta_property] = STATE(1241),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1241),
    [sym_type_assertion] = STATE(1241),
    [sym_as_expression] = STATE(1241),
    [sym_internal_module] = STATE(1241),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2308),
    [sym_this] = ACTIONS(2310),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2310),
    [sym_false] = ACTIONS(2310),
    [sym_null] = ACTIONS(2310),
    [sym_undefined] = ACTIONS(2310),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [398] = {
    [sym_import] = STATE(1149),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1149),
    [sym_yield_expression] = STATE(1149),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1149),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1149),
    [sym_arrow_function] = STATE(1149),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1149),
    [sym_new_expression] = STATE(1149),
    [sym_await_expression] = STATE(1149),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1149),
    [sym_augmented_assignment_expression] = STATE(1149),
    [sym_ternary_expression] = STATE(1149),
    [sym_binary_expression] = STATE(1149),
    [sym_unary_expression] = STATE(1149),
    [sym_update_expression] = STATE(1149),
    [sym_string] = STATE(1149),
    [sym_template_string] = STATE(1149),
    [sym_regex] = STATE(1149),
    [sym_meta_property] = STATE(1149),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1149),
    [sym_type_assertion] = STATE(1149),
    [sym_as_expression] = STATE(1149),
    [sym_internal_module] = STATE(1149),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2312),
    [sym_this] = ACTIONS(2314),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2314),
    [sym_false] = ACTIONS(2314),
    [sym_null] = ACTIONS(2314),
    [sym_undefined] = ACTIONS(2314),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [399] = {
    [sym_import] = STATE(976),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(976),
    [sym_yield_expression] = STATE(976),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(976),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(976),
    [sym_arrow_function] = STATE(976),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(976),
    [sym_new_expression] = STATE(976),
    [sym_await_expression] = STATE(976),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(976),
    [sym_augmented_assignment_expression] = STATE(976),
    [sym_ternary_expression] = STATE(976),
    [sym_binary_expression] = STATE(976),
    [sym_unary_expression] = STATE(976),
    [sym_update_expression] = STATE(976),
    [sym_string] = STATE(976),
    [sym_template_string] = STATE(976),
    [sym_regex] = STATE(976),
    [sym_meta_property] = STATE(976),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(976),
    [sym_type_assertion] = STATE(976),
    [sym_as_expression] = STATE(976),
    [sym_internal_module] = STATE(976),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1898),
    [sym_this] = ACTIONS(1904),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1904),
    [sym_false] = ACTIONS(1904),
    [sym_null] = ACTIONS(1904),
    [sym_undefined] = ACTIONS(1904),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [400] = {
    [sym_import] = STATE(1184),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1184),
    [sym_yield_expression] = STATE(1184),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1184),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1184),
    [sym_arrow_function] = STATE(1184),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1184),
    [sym_new_expression] = STATE(1184),
    [sym_await_expression] = STATE(1184),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1184),
    [sym_augmented_assignment_expression] = STATE(1184),
    [sym_ternary_expression] = STATE(1184),
    [sym_binary_expression] = STATE(1184),
    [sym_unary_expression] = STATE(1184),
    [sym_update_expression] = STATE(1184),
    [sym_string] = STATE(1184),
    [sym_template_string] = STATE(1184),
    [sym_regex] = STATE(1184),
    [sym_meta_property] = STATE(1184),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1184),
    [sym_type_assertion] = STATE(1184),
    [sym_as_expression] = STATE(1184),
    [sym_internal_module] = STATE(1184),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2316),
    [sym_this] = ACTIONS(2318),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [sym_null] = ACTIONS(2318),
    [sym_undefined] = ACTIONS(2318),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [401] = {
    [sym_import] = STATE(1174),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1174),
    [sym_yield_expression] = STATE(1174),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1174),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1174),
    [sym_arrow_function] = STATE(1174),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1174),
    [sym_new_expression] = STATE(1174),
    [sym_await_expression] = STATE(1174),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1174),
    [sym_augmented_assignment_expression] = STATE(1174),
    [sym_ternary_expression] = STATE(1174),
    [sym_binary_expression] = STATE(1174),
    [sym_unary_expression] = STATE(1174),
    [sym_update_expression] = STATE(1174),
    [sym_string] = STATE(1174),
    [sym_template_string] = STATE(1174),
    [sym_regex] = STATE(1174),
    [sym_meta_property] = STATE(1174),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1174),
    [sym_type_assertion] = STATE(1174),
    [sym_as_expression] = STATE(1174),
    [sym_internal_module] = STATE(1174),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(1898),
    [sym_this] = ACTIONS(1986),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1986),
    [sym_false] = ACTIONS(1986),
    [sym_null] = ACTIONS(1986),
    [sym_undefined] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [402] = {
    [sym_import] = STATE(1211),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1211),
    [sym_yield_expression] = STATE(1211),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1211),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1211),
    [sym_arrow_function] = STATE(1211),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1211),
    [sym_new_expression] = STATE(1211),
    [sym_await_expression] = STATE(1211),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1211),
    [sym_augmented_assignment_expression] = STATE(1211),
    [sym_ternary_expression] = STATE(1211),
    [sym_binary_expression] = STATE(1211),
    [sym_unary_expression] = STATE(1211),
    [sym_update_expression] = STATE(1211),
    [sym_string] = STATE(1211),
    [sym_template_string] = STATE(1211),
    [sym_regex] = STATE(1211),
    [sym_meta_property] = STATE(1211),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1211),
    [sym_type_assertion] = STATE(1211),
    [sym_as_expression] = STATE(1211),
    [sym_internal_module] = STATE(1211),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2320),
    [sym_this] = ACTIONS(2322),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2322),
    [sym_false] = ACTIONS(2322),
    [sym_null] = ACTIONS(2322),
    [sym_undefined] = ACTIONS(2322),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [403] = {
    [sym_import] = STATE(987),
    [sym_parenthesized_expression] = STATE(798),
    [sym__expression] = STATE(987),
    [sym_yield_expression] = STATE(987),
    [sym_object] = STATE(1232),
    [sym_array] = STATE(1230),
    [sym_class] = STATE(987),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(987),
    [sym_arrow_function] = STATE(987),
    [sym__call_signature] = STATE(2838),
    [sym_call_expression] = STATE(987),
    [sym_new_expression] = STATE(987),
    [sym_await_expression] = STATE(987),
    [sym_member_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_assignment_expression] = STATE(987),
    [sym_augmented_assignment_expression] = STATE(987),
    [sym_ternary_expression] = STATE(987),
    [sym_binary_expression] = STATE(987),
    [sym_unary_expression] = STATE(987),
    [sym_update_expression] = STATE(987),
    [sym_string] = STATE(987),
    [sym_template_string] = STATE(987),
    [sym_regex] = STATE(987),
    [sym_meta_property] = STATE(987),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(987),
    [sym_type_assertion] = STATE(987),
    [sym_as_expression] = STATE(987),
    [sym_internal_module] = STATE(987),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_delete] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2324),
    [sym_this] = ACTIONS(2326),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2326),
    [sym_false] = ACTIONS(2326),
    [sym_null] = ACTIONS(2326),
    [sym_undefined] = ACTIONS(2326),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
  },
  [404] = {
    [sym_import] = STATE(1203),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1203),
    [sym_yield_expression] = STATE(1203),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1203),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1203),
    [sym_arrow_function] = STATE(1203),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1203),
    [sym_new_expression] = STATE(1203),
    [sym_await_expression] = STATE(1203),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1203),
    [sym_augmented_assignment_expression] = STATE(1203),
    [sym_ternary_expression] = STATE(1203),
    [sym_binary_expression] = STATE(1203),
    [sym_unary_expression] = STATE(1203),
    [sym_update_expression] = STATE(1203),
    [sym_string] = STATE(1203),
    [sym_template_string] = STATE(1203),
    [sym_regex] = STATE(1203),
    [sym_meta_property] = STATE(1203),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1203),
    [sym_type_assertion] = STATE(1203),
    [sym_as_expression] = STATE(1203),
    [sym_internal_module] = STATE(1203),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2328),
    [sym_this] = ACTIONS(2330),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [sym_null] = ACTIONS(2330),
    [sym_undefined] = ACTIONS(2330),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [405] = {
    [sym_import] = STATE(1237),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1237),
    [sym_yield_expression] = STATE(1237),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1237),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1237),
    [sym_arrow_function] = STATE(1237),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1237),
    [sym_new_expression] = STATE(1237),
    [sym_await_expression] = STATE(1237),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1237),
    [sym_augmented_assignment_expression] = STATE(1237),
    [sym_ternary_expression] = STATE(1237),
    [sym_binary_expression] = STATE(1237),
    [sym_unary_expression] = STATE(1237),
    [sym_update_expression] = STATE(1237),
    [sym_string] = STATE(1237),
    [sym_template_string] = STATE(1237),
    [sym_regex] = STATE(1237),
    [sym_meta_property] = STATE(1237),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1237),
    [sym_type_assertion] = STATE(1237),
    [sym_as_expression] = STATE(1237),
    [sym_internal_module] = STATE(1237),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2332),
    [sym_this] = ACTIONS(2334),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2334),
    [sym_false] = ACTIONS(2334),
    [sym_null] = ACTIONS(2334),
    [sym_undefined] = ACTIONS(2334),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [406] = {
    [sym_import] = STATE(1205),
    [sym_parenthesized_expression] = STATE(862),
    [sym__expression] = STATE(1205),
    [sym_yield_expression] = STATE(1205),
    [sym_object] = STATE(1395),
    [sym_array] = STATE(1394),
    [sym_class] = STATE(1205),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1205),
    [sym_arrow_function] = STATE(1205),
    [sym__call_signature] = STATE(2757),
    [sym_call_expression] = STATE(1205),
    [sym_new_expression] = STATE(1205),
    [sym_await_expression] = STATE(1205),
    [sym_member_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_assignment_expression] = STATE(1205),
    [sym_augmented_assignment_expression] = STATE(1205),
    [sym_ternary_expression] = STATE(1205),
    [sym_binary_expression] = STATE(1205),
    [sym_unary_expression] = STATE(1205),
    [sym_update_expression] = STATE(1205),
    [sym_string] = STATE(1205),
    [sym_template_string] = STATE(1205),
    [sym_regex] = STATE(1205),
    [sym_meta_property] = STATE(1205),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2340),
    [sym_non_null_expression] = STATE(1205),
    [sym_type_assertion] = STATE(1205),
    [sym_as_expression] = STATE(1205),
    [sym_internal_module] = STATE(1205),
    [sym_type_arguments] = STATE(291),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_export_statement_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(551),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(2336),
    [sym_this] = ACTIONS(2338),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2338),
    [sym_false] = ACTIONS(2338),
    [sym_null] = ACTIONS(2338),
    [sym_undefined] = ACTIONS(2338),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
  },
  [407] = {
    [ts_builtin_sym_end] = ACTIONS(1097),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(1099),
    [anon_sym_default] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_namespace] = ACTIONS(1099),
    [anon_sym_LBRACE] = ACTIONS(1097),
    [anon_sym_COMMA] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1099),
    [anon_sym_var] = ACTIONS(1099),
    [anon_sym_let] = ACTIONS(1099),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_if] = ACTIONS(1099),
    [anon_sym_else] = ACTIONS(1099),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_RPAREN] = ACTIONS(1097),
    [anon_sym_await] = ACTIONS(1099),
    [anon_sym_while] = ACTIONS(1099),
    [anon_sym_do] = ACTIONS(1099),
    [anon_sym_try] = ACTIONS(1099),
    [anon_sym_with] = ACTIONS(1099),
    [anon_sym_break] = ACTIONS(1099),
    [anon_sym_continue] = ACTIONS(1099),
    [anon_sym_debugger] = ACTIONS(1099),
    [anon_sym_return] = ACTIONS(1099),
    [anon_sym_throw] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_COLON] = ACTIONS(1097),
    [anon_sym_case] = ACTIONS(1099),
    [anon_sym_yield] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [anon_sym_RBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_SLASH] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1099),
    [anon_sym_function] = ACTIONS(1099),
    [anon_sym_EQ_GT] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_void] = ACTIONS(1099),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [sym_number] = ACTIONS(1097),
    [sym_this] = ACTIONS(1099),
    [sym_super] = ACTIONS(1099),
    [sym_true] = ACTIONS(1099),
    [sym_false] = ACTIONS(1099),
    [sym_null] = ACTIONS(1099),
    [sym_undefined] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1097),
    [anon_sym_static] = ACTIONS(1099),
    [anon_sym_abstract] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(1099),
    [anon_sym_set] = ACTIONS(1099),
    [anon_sym_declare] = ACTIONS(1099),
    [anon_sym_public] = ACTIONS(1099),
    [anon_sym_private] = ACTIONS(1099),
    [anon_sym_protected] = ACTIONS(1099),
    [anon_sym_module] = ACTIONS(1099),
    [anon_sym_any] = ACTIONS(1099),
    [anon_sym_number] = ACTIONS(1099),
    [anon_sym_boolean] = ACTIONS(1099),
    [anon_sym_string] = ACTIONS(1099),
    [anon_sym_symbol] = ACTIONS(1099),
    [anon_sym_interface] = ACTIONS(1099),
    [anon_sym_enum] = ACTIONS(1099),
  },
  [408] = {
    [ts_builtin_sym_end] = ACTIONS(1111),
    [sym_identifier] = ACTIONS(1113),
    [anon_sym_export] = ACTIONS(1113),
    [anon_sym_default] = ACTIONS(1113),
    [anon_sym_EQ] = ACTIONS(1113),
    [anon_sym_namespace] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_COMMA] = ACTIONS(1111),
    [anon_sym_RBRACE] = ACTIONS(1111),
    [anon_sym_type] = ACTIONS(1113),
    [anon_sym_typeof] = ACTIONS(1113),
    [anon_sym_import] = ACTIONS(1113),
    [anon_sym_var] = ACTIONS(1113),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_const] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(1113),
    [anon_sym_else] = ACTIONS(1113),
    [anon_sym_switch] = ACTIONS(1113),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_RPAREN] = ACTIONS(1111),
    [anon_sym_await] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1113),
    [anon_sym_do] = ACTIONS(1113),
    [anon_sym_try] = ACTIONS(1113),
    [anon_sym_with] = ACTIONS(1113),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1113),
    [anon_sym_debugger] = ACTIONS(1113),
    [anon_sym_return] = ACTIONS(1113),
    [anon_sym_throw] = ACTIONS(1113),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_COLON] = ACTIONS(1111),
    [anon_sym_case] = ACTIONS(1113),
    [anon_sym_yield] = ACTIONS(1113),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_RBRACK] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_class] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(1113),
    [anon_sym_EQ_GT] = ACTIONS(1111),
    [anon_sym_new] = ACTIONS(1113),
    [anon_sym_QMARK] = ACTIONS(1111),
    [anon_sym_AMP] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_PLUS] = ACTIONS(1113),
    [anon_sym_DASH] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1111),
    [anon_sym_void] = ACTIONS(1113),
    [anon_sym_delete] = ACTIONS(1113),
    [anon_sym_PLUS_PLUS] = ACTIONS(1111),
    [anon_sym_DASH_DASH] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(1111),
    [anon_sym_SQUOTE] = ACTIONS(1111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(1111),
    [sym_this] = ACTIONS(1113),
    [sym_super] = ACTIONS(1113),
    [sym_true] = ACTIONS(1113),
    [sym_false] = ACTIONS(1113),
    [sym_null] = ACTIONS(1113),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym_static] = ACTIONS(1113),
    [anon_sym_abstract] = ACTIONS(1113),
    [anon_sym_get] = ACTIONS(1113),
    [anon_sym_set] = ACTIONS(1113),
    [anon_sym_declare] = ACTIONS(1113),
    [anon_sym_public] = ACTIONS(1113),
    [anon_sym_private] = ACTIONS(1113),
    [anon_sym_protected] = ACTIONS(1113),
    [anon_sym_module] = ACTIONS(1113),
    [anon_sym_any] = ACTIONS(1113),
    [anon_sym_number] = ACTIONS(1113),
    [anon_sym_boolean] = ACTIONS(1113),
    [anon_sym_string] = ACTIONS(1113),
    [anon_sym_symbol] = ACTIONS(1113),
    [anon_sym_interface] = ACTIONS(1113),
    [anon_sym_enum] = ACTIONS(1113),
  },
  [409] = {
    [ts_builtin_sym_end] = ACTIONS(2340),
    [sym_identifier] = ACTIONS(2342),
    [anon_sym_export] = ACTIONS(2342),
    [anon_sym_default] = ACTIONS(2342),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_namespace] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2340),
    [anon_sym_RBRACE] = ACTIONS(2340),
    [anon_sym_type] = ACTIONS(2342),
    [anon_sym_typeof] = ACTIONS(2342),
    [anon_sym_import] = ACTIONS(2342),
    [anon_sym_var] = ACTIONS(2342),
    [anon_sym_let] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_if] = ACTIONS(2342),
    [anon_sym_else] = ACTIONS(2342),
    [anon_sym_switch] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_RPAREN] = ACTIONS(2340),
    [anon_sym_await] = ACTIONS(2342),
    [anon_sym_while] = ACTIONS(2342),
    [anon_sym_do] = ACTIONS(2342),
    [anon_sym_try] = ACTIONS(2342),
    [anon_sym_with] = ACTIONS(2342),
    [anon_sym_break] = ACTIONS(2342),
    [anon_sym_continue] = ACTIONS(2342),
    [anon_sym_debugger] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2342),
    [anon_sym_throw] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2340),
    [anon_sym_case] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_RBRACK] = ACTIONS(2340),
    [anon_sym_LT] = ACTIONS(2340),
    [anon_sym_GT] = ACTIONS(2340),
    [anon_sym_SLASH] = ACTIONS(2342),
    [anon_sym_DOT] = ACTIONS(1059),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_async] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2342),
    [anon_sym_EQ_GT] = ACTIONS(2340),
    [anon_sym_new] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_PIPE] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_void] = ACTIONS(2342),
    [anon_sym_delete] = ACTIONS(2342),
    [anon_sym_PLUS_PLUS] = ACTIONS(2340),
    [anon_sym_DASH_DASH] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_SQUOTE] = ACTIONS(2340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2340),
    [sym_number] = ACTIONS(2340),
    [sym_this] = ACTIONS(2342),
    [sym_super] = ACTIONS(2342),
    [sym_true] = ACTIONS(2342),
    [sym_false] = ACTIONS(2342),
    [sym_null] = ACTIONS(2342),
    [sym_undefined] = ACTIONS(2342),
    [anon_sym_AT] = ACTIONS(2340),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_abstract] = ACTIONS(2342),
    [anon_sym_get] = ACTIONS(2342),
    [anon_sym_set] = ACTIONS(2342),
    [anon_sym_declare] = ACTIONS(2342),
    [anon_sym_public] = ACTIONS(2342),
    [anon_sym_private] = ACTIONS(2342),
    [anon_sym_protected] = ACTIONS(2342),
    [anon_sym_module] = ACTIONS(2342),
    [anon_sym_any] = ACTIONS(2342),
    [anon_sym_number] = ACTIONS(2342),
    [anon_sym_boolean] = ACTIONS(2342),
    [anon_sym_string] = ACTIONS(2342),
    [anon_sym_symbol] = ACTIONS(2342),
    [anon_sym_implements] = ACTIONS(2342),
    [anon_sym_interface] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
  },
  [410] = {
    [ts_builtin_sym_end] = ACTIONS(2344),
    [sym_identifier] = ACTIONS(2346),
    [anon_sym_export] = ACTIONS(2346),
    [anon_sym_default] = ACTIONS(2346),
    [anon_sym_EQ] = ACTIONS(2346),
    [anon_sym_namespace] = ACTIONS(2346),
    [anon_sym_LBRACE] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_type] = ACTIONS(2346),
    [anon_sym_typeof] = ACTIONS(2346),
    [anon_sym_import] = ACTIONS(2346),
    [anon_sym_var] = ACTIONS(2346),
    [anon_sym_let] = ACTIONS(2346),
    [anon_sym_const] = ACTIONS(2346),
    [anon_sym_if] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2346),
    [anon_sym_switch] = ACTIONS(2346),
    [anon_sym_for] = ACTIONS(2346),
    [anon_sym_LPAREN] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_await] = ACTIONS(2346),
    [anon_sym_while] = ACTIONS(2346),
    [anon_sym_do] = ACTIONS(2346),
    [anon_sym_try] = ACTIONS(2346),
    [anon_sym_with] = ACTIONS(2346),
    [anon_sym_break] = ACTIONS(2346),
    [anon_sym_continue] = ACTIONS(2346),
    [anon_sym_debugger] = ACTIONS(2346),
    [anon_sym_return] = ACTIONS(2346),
    [anon_sym_throw] = ACTIONS(2346),
    [anon_sym_SEMI] = ACTIONS(2344),
    [anon_sym_case] = ACTIONS(2346),
    [anon_sym_yield] = ACTIONS(2346),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_RBRACK] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_GT] = ACTIONS(2344),
    [anon_sym_SLASH] = ACTIONS(2346),
    [anon_sym_DOT] = ACTIONS(2348),
    [anon_sym_class] = ACTIONS(2346),
    [anon_sym_async] = ACTIONS(2346),
    [anon_sym_function] = ACTIONS(2346),
    [anon_sym_EQ_GT] = ACTIONS(2344),
    [anon_sym_new] = ACTIONS(2346),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_PIPE] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2344),
    [anon_sym_void] = ACTIONS(2346),
    [anon_sym_delete] = ACTIONS(2346),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_SQUOTE] = ACTIONS(2344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [sym_number] = ACTIONS(2344),
    [sym_this] = ACTIONS(2346),
    [sym_super] = ACTIONS(2346),
    [sym_true] = ACTIONS(2346),
    [sym_false] = ACTIONS(2346),
    [sym_null] = ACTIONS(2346),
    [sym_undefined] = ACTIONS(2346),
    [anon_sym_AT] = ACTIONS(2344),
    [anon_sym_static] = ACTIONS(2346),
    [anon_sym_abstract] = ACTIONS(2346),
    [anon_sym_get] = ACTIONS(2346),
    [anon_sym_set] = ACTIONS(2346),
    [anon_sym_declare] = ACTIONS(2346),
    [anon_sym_public] = ACTIONS(2346),
    [anon_sym_private] = ACTIONS(2346),
    [anon_sym_protected] = ACTIONS(2346),
    [anon_sym_module] = ACTIONS(2346),
    [anon_sym_any] = ACTIONS(2346),
    [anon_sym_number] = ACTIONS(2346),
    [anon_sym_boolean] = ACTIONS(2346),
    [anon_sym_string] = ACTIONS(2346),
    [anon_sym_symbol] = ACTIONS(2346),
    [anon_sym_interface] = ACTIONS(2346),
    [anon_sym_enum] = ACTIONS(2346),
  },
  [411] = {
    [ts_builtin_sym_end] = ACTIONS(1057),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(1059),
    [anon_sym_default] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_namespace] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_type] = ACTIONS(1059),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(1059),
    [anon_sym_var] = ACTIONS(1059),
    [anon_sym_let] = ACTIONS(1059),
    [anon_sym_const] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_else] = ACTIONS(1059),
    [anon_sym_switch] = ACTIONS(1059),
    [anon_sym_for] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_await] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_do] = ACTIONS(1059),
    [anon_sym_try] = ACTIONS(1059),
    [anon_sym_with] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1059),
    [anon_sym_continue] = ACTIONS(1059),
    [anon_sym_debugger] = ACTIONS(1059),
    [anon_sym_return] = ACTIONS(1059),
    [anon_sym_throw] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1057),
    [anon_sym_case] = ACTIONS(1059),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_RBRACK] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1057),
    [anon_sym_SLASH] = ACTIONS(1059),
    [anon_sym_DOT] = ACTIONS(1059),
    [anon_sym_class] = ACTIONS(1059),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_function] = ACTIONS(1059),
    [anon_sym_EQ_GT] = ACTIONS(1057),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1057),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1057),
    [anon_sym_DASH_DASH] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_SQUOTE] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [sym_number] = ACTIONS(1057),
    [sym_this] = ACTIONS(1059),
    [sym_super] = ACTIONS(1059),
    [sym_true] = ACTIONS(1059),
    [sym_false] = ACTIONS(1059),
    [sym_null] = ACTIONS(1059),
    [sym_undefined] = ACTIONS(1059),
    [anon_sym_AT] = ACTIONS(1057),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_abstract] = ACTIONS(1059),
    [anon_sym_get] = ACTIONS(1059),
    [anon_sym_set] = ACTIONS(1059),
    [anon_sym_declare] = ACTIONS(1059),
    [anon_sym_public] = ACTIONS(1059),
    [anon_sym_private] = ACTIONS(1059),
    [anon_sym_protected] = ACTIONS(1059),
    [anon_sym_module] = ACTIONS(1059),
    [anon_sym_any] = ACTIONS(1059),
    [anon_sym_number] = ACTIONS(1059),
    [anon_sym_boolean] = ACTIONS(1059),
    [anon_sym_string] = ACTIONS(1059),
    [anon_sym_symbol] = ACTIONS(1059),
    [anon_sym_interface] = ACTIONS(1059),
    [anon_sym_enum] = ACTIONS(1059),
  },
  [412] = {
    [sym__call_signature] = STATE(2751),
    [sym_string] = STATE(2056),
    [sym_formal_parameters] = STATE(2340),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(2350),
    [anon_sym_export] = ACTIONS(2352),
    [anon_sym_STAR] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2352),
    [anon_sym_LPAREN] = ACTIONS(2357),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2352),
    [anon_sym_function] = ACTIONS(2368),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2352),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2352),
    [anon_sym_get] = ACTIONS(2376),
    [anon_sym_set] = ACTIONS(2376),
    [anon_sym_declare] = ACTIONS(2352),
    [anon_sym_public] = ACTIONS(2352),
    [anon_sym_private] = ACTIONS(2352),
    [anon_sym_protected] = ACTIONS(2352),
    [anon_sym_module] = ACTIONS(2352),
    [anon_sym_any] = ACTIONS(2352),
    [anon_sym_number] = ACTIONS(2352),
    [anon_sym_boolean] = ACTIONS(2352),
    [anon_sym_string] = ACTIONS(2352),
    [anon_sym_symbol] = ACTIONS(2352),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [413] = {
    [ts_builtin_sym_end] = ACTIONS(2378),
    [sym_identifier] = ACTIONS(2380),
    [anon_sym_export] = ACTIONS(2380),
    [anon_sym_default] = ACTIONS(2380),
    [anon_sym_EQ] = ACTIONS(2380),
    [anon_sym_namespace] = ACTIONS(2380),
    [anon_sym_LBRACE] = ACTIONS(2378),
    [anon_sym_COMMA] = ACTIONS(2378),
    [anon_sym_RBRACE] = ACTIONS(2378),
    [anon_sym_type] = ACTIONS(2380),
    [anon_sym_typeof] = ACTIONS(2380),
    [anon_sym_import] = ACTIONS(2380),
    [anon_sym_var] = ACTIONS(2380),
    [anon_sym_let] = ACTIONS(2380),
    [anon_sym_const] = ACTIONS(2380),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_else] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2380),
    [anon_sym_for] = ACTIONS(2380),
    [anon_sym_LPAREN] = ACTIONS(2378),
    [anon_sym_RPAREN] = ACTIONS(2378),
    [anon_sym_await] = ACTIONS(2380),
    [anon_sym_while] = ACTIONS(2380),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_try] = ACTIONS(2380),
    [anon_sym_with] = ACTIONS(2380),
    [anon_sym_break] = ACTIONS(2380),
    [anon_sym_continue] = ACTIONS(2380),
    [anon_sym_debugger] = ACTIONS(2380),
    [anon_sym_return] = ACTIONS(2380),
    [anon_sym_throw] = ACTIONS(2380),
    [anon_sym_SEMI] = ACTIONS(2378),
    [anon_sym_case] = ACTIONS(2380),
    [anon_sym_yield] = ACTIONS(2380),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_RBRACK] = ACTIONS(2378),
    [anon_sym_LT] = ACTIONS(2378),
    [anon_sym_GT] = ACTIONS(2378),
    [anon_sym_SLASH] = ACTIONS(2380),
    [anon_sym_class] = ACTIONS(2380),
    [anon_sym_async] = ACTIONS(2380),
    [anon_sym_function] = ACTIONS(2380),
    [anon_sym_EQ_GT] = ACTIONS(2378),
    [anon_sym_new] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_PIPE] = ACTIONS(2378),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [anon_sym_void] = ACTIONS(2380),
    [anon_sym_delete] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [anon_sym_SQUOTE] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2378),
    [sym_number] = ACTIONS(2378),
    [sym_this] = ACTIONS(2380),
    [sym_super] = ACTIONS(2380),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [sym_null] = ACTIONS(2380),
    [sym_undefined] = ACTIONS(2380),
    [anon_sym_AT] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2380),
    [anon_sym_abstract] = ACTIONS(2380),
    [anon_sym_get] = ACTIONS(2380),
    [anon_sym_set] = ACTIONS(2380),
    [anon_sym_declare] = ACTIONS(2380),
    [anon_sym_public] = ACTIONS(2380),
    [anon_sym_private] = ACTIONS(2380),
    [anon_sym_protected] = ACTIONS(2380),
    [anon_sym_module] = ACTIONS(2380),
    [anon_sym_any] = ACTIONS(2380),
    [anon_sym_number] = ACTIONS(2380),
    [anon_sym_boolean] = ACTIONS(2380),
    [anon_sym_string] = ACTIONS(2380),
    [anon_sym_symbol] = ACTIONS(2380),
    [anon_sym_implements] = ACTIONS(2380),
    [anon_sym_interface] = ACTIONS(2380),
    [anon_sym_enum] = ACTIONS(2380),
  },
  [414] = {
    [ts_builtin_sym_end] = ACTIONS(2382),
    [sym_identifier] = ACTIONS(2384),
    [anon_sym_export] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_EQ] = ACTIONS(2384),
    [anon_sym_namespace] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2382),
    [anon_sym_COMMA] = ACTIONS(2382),
    [anon_sym_RBRACE] = ACTIONS(2382),
    [anon_sym_type] = ACTIONS(2384),
    [anon_sym_typeof] = ACTIONS(2384),
    [anon_sym_import] = ACTIONS(2384),
    [anon_sym_var] = ACTIONS(2384),
    [anon_sym_let] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_else] = ACTIONS(2384),
    [anon_sym_switch] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_LPAREN] = ACTIONS(2382),
    [anon_sym_RPAREN] = ACTIONS(2382),
    [anon_sym_await] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [anon_sym_with] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_debugger] = ACTIONS(2384),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_throw] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_yield] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_RBRACK] = ACTIONS(2382),
    [anon_sym_LT] = ACTIONS(2382),
    [anon_sym_GT] = ACTIONS(2382),
    [anon_sym_SLASH] = ACTIONS(2384),
    [anon_sym_DOT] = ACTIONS(2386),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_async] = ACTIONS(2384),
    [anon_sym_function] = ACTIONS(2384),
    [anon_sym_EQ_GT] = ACTIONS(2382),
    [anon_sym_new] = ACTIONS(2384),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_PIPE] = ACTIONS(2382),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2382),
    [anon_sym_TILDE] = ACTIONS(2382),
    [anon_sym_void] = ACTIONS(2384),
    [anon_sym_delete] = ACTIONS(2384),
    [anon_sym_PLUS_PLUS] = ACTIONS(2382),
    [anon_sym_DASH_DASH] = ACTIONS(2382),
    [anon_sym_DQUOTE] = ACTIONS(2382),
    [anon_sym_SQUOTE] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2382),
    [sym_number] = ACTIONS(2382),
    [sym_this] = ACTIONS(2384),
    [sym_super] = ACTIONS(2384),
    [sym_true] = ACTIONS(2384),
    [sym_false] = ACTIONS(2384),
    [sym_null] = ACTIONS(2384),
    [sym_undefined] = ACTIONS(2384),
    [anon_sym_AT] = ACTIONS(2382),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_abstract] = ACTIONS(2384),
    [anon_sym_get] = ACTIONS(2384),
    [anon_sym_set] = ACTIONS(2384),
    [anon_sym_declare] = ACTIONS(2384),
    [anon_sym_public] = ACTIONS(2384),
    [anon_sym_private] = ACTIONS(2384),
    [anon_sym_protected] = ACTIONS(2384),
    [anon_sym_module] = ACTIONS(2384),
    [anon_sym_any] = ACTIONS(2384),
    [anon_sym_number] = ACTIONS(2384),
    [anon_sym_boolean] = ACTIONS(2384),
    [anon_sym_string] = ACTIONS(2384),
    [anon_sym_symbol] = ACTIONS(2384),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
  },
  [415] = {
    [sym__call_signature] = STATE(2751),
    [sym_string] = STATE(2056),
    [sym_formal_parameters] = STATE(2340),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(2350),
    [anon_sym_export] = ACTIONS(2352),
    [anon_sym_STAR] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2352),
    [anon_sym_LPAREN] = ACTIONS(2357),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2352),
    [anon_sym_function] = ACTIONS(2368),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2352),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2352),
    [anon_sym_get] = ACTIONS(2376),
    [anon_sym_set] = ACTIONS(2376),
    [anon_sym_declare] = ACTIONS(2352),
    [anon_sym_public] = ACTIONS(2352),
    [anon_sym_private] = ACTIONS(2352),
    [anon_sym_protected] = ACTIONS(2352),
    [anon_sym_module] = ACTIONS(2352),
    [anon_sym_any] = ACTIONS(2352),
    [anon_sym_number] = ACTIONS(2352),
    [anon_sym_boolean] = ACTIONS(2352),
    [anon_sym_string] = ACTIONS(2352),
    [anon_sym_symbol] = ACTIONS(2352),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [416] = {
    [ts_builtin_sym_end] = ACTIONS(2388),
    [sym_identifier] = ACTIONS(2390),
    [anon_sym_export] = ACTIONS(2390),
    [anon_sym_default] = ACTIONS(2390),
    [anon_sym_EQ] = ACTIONS(2390),
    [anon_sym_namespace] = ACTIONS(2390),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_type] = ACTIONS(2390),
    [anon_sym_typeof] = ACTIONS(2390),
    [anon_sym_import] = ACTIONS(2390),
    [anon_sym_var] = ACTIONS(2390),
    [anon_sym_let] = ACTIONS(2390),
    [anon_sym_const] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2390),
    [anon_sym_switch] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_RPAREN] = ACTIONS(2388),
    [anon_sym_await] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_do] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_with] = ACTIONS(2390),
    [anon_sym_break] = ACTIONS(2390),
    [anon_sym_continue] = ACTIONS(2390),
    [anon_sym_debugger] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_throw] = ACTIONS(2390),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym_case] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_RBRACK] = ACTIONS(2388),
    [anon_sym_LT] = ACTIONS(2388),
    [anon_sym_GT] = ACTIONS(2388),
    [anon_sym_SLASH] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_function] = ACTIONS(2390),
    [anon_sym_EQ_GT] = ACTIONS(2388),
    [anon_sym_new] = ACTIONS(2390),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym_PIPE] = ACTIONS(2388),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_void] = ACTIONS(2390),
    [anon_sym_delete] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [anon_sym_DQUOTE] = ACTIONS(2388),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2388),
    [sym_number] = ACTIONS(2388),
    [sym_this] = ACTIONS(2390),
    [sym_super] = ACTIONS(2390),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [sym_null] = ACTIONS(2390),
    [sym_undefined] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(2388),
    [anon_sym_static] = ACTIONS(2390),
    [anon_sym_abstract] = ACTIONS(2390),
    [anon_sym_get] = ACTIONS(2390),
    [anon_sym_set] = ACTIONS(2390),
    [anon_sym_declare] = ACTIONS(2390),
    [anon_sym_public] = ACTIONS(2390),
    [anon_sym_private] = ACTIONS(2390),
    [anon_sym_protected] = ACTIONS(2390),
    [anon_sym_module] = ACTIONS(2390),
    [anon_sym_any] = ACTIONS(2390),
    [anon_sym_number] = ACTIONS(2390),
    [anon_sym_boolean] = ACTIONS(2390),
    [anon_sym_string] = ACTIONS(2390),
    [anon_sym_symbol] = ACTIONS(2390),
    [anon_sym_implements] = ACTIONS(2390),
    [anon_sym_interface] = ACTIONS(2390),
    [anon_sym_enum] = ACTIONS(2390),
  },
  [417] = {
    [ts_builtin_sym_end] = ACTIONS(2392),
    [sym_identifier] = ACTIONS(2394),
    [anon_sym_export] = ACTIONS(2394),
    [anon_sym_default] = ACTIONS(2394),
    [anon_sym_EQ] = ACTIONS(2394),
    [anon_sym_namespace] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_COMMA] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_type] = ACTIONS(2394),
    [anon_sym_typeof] = ACTIONS(2394),
    [anon_sym_import] = ACTIONS(2394),
    [anon_sym_var] = ACTIONS(2394),
    [anon_sym_let] = ACTIONS(2394),
    [anon_sym_const] = ACTIONS(2394),
    [anon_sym_if] = ACTIONS(2394),
    [anon_sym_else] = ACTIONS(2394),
    [anon_sym_switch] = ACTIONS(2394),
    [anon_sym_for] = ACTIONS(2394),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_RPAREN] = ACTIONS(2392),
    [anon_sym_await] = ACTIONS(2394),
    [anon_sym_while] = ACTIONS(2394),
    [anon_sym_do] = ACTIONS(2394),
    [anon_sym_try] = ACTIONS(2394),
    [anon_sym_with] = ACTIONS(2394),
    [anon_sym_break] = ACTIONS(2394),
    [anon_sym_continue] = ACTIONS(2394),
    [anon_sym_debugger] = ACTIONS(2394),
    [anon_sym_return] = ACTIONS(2394),
    [anon_sym_throw] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym_case] = ACTIONS(2394),
    [anon_sym_yield] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_RBRACK] = ACTIONS(2392),
    [anon_sym_LT] = ACTIONS(2392),
    [anon_sym_GT] = ACTIONS(2392),
    [anon_sym_SLASH] = ACTIONS(2394),
    [anon_sym_class] = ACTIONS(2394),
    [anon_sym_async] = ACTIONS(2394),
    [anon_sym_function] = ACTIONS(2394),
    [anon_sym_EQ_GT] = ACTIONS(2392),
    [anon_sym_new] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2392),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_BANG] = ACTIONS(2392),
    [anon_sym_TILDE] = ACTIONS(2392),
    [anon_sym_void] = ACTIONS(2394),
    [anon_sym_delete] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [anon_sym_DQUOTE] = ACTIONS(2392),
    [anon_sym_SQUOTE] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2392),
    [sym_number] = ACTIONS(2392),
    [sym_this] = ACTIONS(2394),
    [sym_super] = ACTIONS(2394),
    [sym_true] = ACTIONS(2394),
    [sym_false] = ACTIONS(2394),
    [sym_null] = ACTIONS(2394),
    [sym_undefined] = ACTIONS(2394),
    [anon_sym_AT] = ACTIONS(2392),
    [anon_sym_static] = ACTIONS(2394),
    [anon_sym_abstract] = ACTIONS(2394),
    [anon_sym_get] = ACTIONS(2394),
    [anon_sym_set] = ACTIONS(2394),
    [anon_sym_declare] = ACTIONS(2394),
    [anon_sym_public] = ACTIONS(2394),
    [anon_sym_private] = ACTIONS(2394),
    [anon_sym_protected] = ACTIONS(2394),
    [anon_sym_module] = ACTIONS(2394),
    [anon_sym_any] = ACTIONS(2394),
    [anon_sym_number] = ACTIONS(2394),
    [anon_sym_boolean] = ACTIONS(2394),
    [anon_sym_string] = ACTIONS(2394),
    [anon_sym_symbol] = ACTIONS(2394),
    [anon_sym_implements] = ACTIONS(2394),
    [anon_sym_interface] = ACTIONS(2394),
    [anon_sym_enum] = ACTIONS(2394),
  },
  [418] = {
    [ts_builtin_sym_end] = ACTIONS(2396),
    [sym_identifier] = ACTIONS(2398),
    [anon_sym_export] = ACTIONS(2398),
    [anon_sym_default] = ACTIONS(2398),
    [anon_sym_EQ] = ACTIONS(2398),
    [anon_sym_namespace] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2396),
    [anon_sym_COMMA] = ACTIONS(2396),
    [anon_sym_RBRACE] = ACTIONS(2396),
    [anon_sym_type] = ACTIONS(2398),
    [anon_sym_typeof] = ACTIONS(2398),
    [anon_sym_import] = ACTIONS(2398),
    [anon_sym_var] = ACTIONS(2398),
    [anon_sym_let] = ACTIONS(2398),
    [anon_sym_const] = ACTIONS(2398),
    [anon_sym_if] = ACTIONS(2398),
    [anon_sym_else] = ACTIONS(2398),
    [anon_sym_switch] = ACTIONS(2398),
    [anon_sym_for] = ACTIONS(2398),
    [anon_sym_LPAREN] = ACTIONS(2396),
    [anon_sym_RPAREN] = ACTIONS(2396),
    [anon_sym_await] = ACTIONS(2398),
    [anon_sym_while] = ACTIONS(2398),
    [anon_sym_do] = ACTIONS(2398),
    [anon_sym_try] = ACTIONS(2398),
    [anon_sym_with] = ACTIONS(2398),
    [anon_sym_break] = ACTIONS(2398),
    [anon_sym_continue] = ACTIONS(2398),
    [anon_sym_debugger] = ACTIONS(2398),
    [anon_sym_return] = ACTIONS(2398),
    [anon_sym_throw] = ACTIONS(2398),
    [anon_sym_SEMI] = ACTIONS(2396),
    [anon_sym_case] = ACTIONS(2398),
    [anon_sym_yield] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2396),
    [anon_sym_RBRACK] = ACTIONS(2396),
    [anon_sym_LT] = ACTIONS(2396),
    [anon_sym_GT] = ACTIONS(2396),
    [anon_sym_SLASH] = ACTIONS(2398),
    [anon_sym_class] = ACTIONS(2398),
    [anon_sym_async] = ACTIONS(2398),
    [anon_sym_function] = ACTIONS(2398),
    [anon_sym_EQ_GT] = ACTIONS(2396),
    [anon_sym_new] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2396),
    [anon_sym_PIPE] = ACTIONS(2396),
    [anon_sym_PLUS] = ACTIONS(2398),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_BANG] = ACTIONS(2396),
    [anon_sym_TILDE] = ACTIONS(2396),
    [anon_sym_void] = ACTIONS(2398),
    [anon_sym_delete] = ACTIONS(2398),
    [anon_sym_PLUS_PLUS] = ACTIONS(2396),
    [anon_sym_DASH_DASH] = ACTIONS(2396),
    [anon_sym_DQUOTE] = ACTIONS(2396),
    [anon_sym_SQUOTE] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_number] = ACTIONS(2396),
    [sym_this] = ACTIONS(2398),
    [sym_super] = ACTIONS(2398),
    [sym_true] = ACTIONS(2398),
    [sym_false] = ACTIONS(2398),
    [sym_null] = ACTIONS(2398),
    [sym_undefined] = ACTIONS(2398),
    [anon_sym_AT] = ACTIONS(2396),
    [anon_sym_static] = ACTIONS(2398),
    [anon_sym_abstract] = ACTIONS(2398),
    [anon_sym_get] = ACTIONS(2398),
    [anon_sym_set] = ACTIONS(2398),
    [anon_sym_declare] = ACTIONS(2398),
    [anon_sym_public] = ACTIONS(2398),
    [anon_sym_private] = ACTIONS(2398),
    [anon_sym_protected] = ACTIONS(2398),
    [anon_sym_module] = ACTIONS(2398),
    [anon_sym_any] = ACTIONS(2398),
    [anon_sym_number] = ACTIONS(2398),
    [anon_sym_boolean] = ACTIONS(2398),
    [anon_sym_string] = ACTIONS(2398),
    [anon_sym_symbol] = ACTIONS(2398),
    [anon_sym_implements] = ACTIONS(2398),
    [anon_sym_interface] = ACTIONS(2398),
    [anon_sym_enum] = ACTIONS(2398),
  },
  [419] = {
    [sym__call_signature] = STATE(2751),
    [sym_string] = STATE(2056),
    [sym_formal_parameters] = STATE(2340),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [sym_type_parameters] = STATE(2576),
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(2350),
    [anon_sym_export] = ACTIONS(2352),
    [anon_sym_STAR] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2352),
    [anon_sym_LPAREN] = ACTIONS(2357),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2352),
    [anon_sym_function] = ACTIONS(2368),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2352),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2352),
    [anon_sym_get] = ACTIONS(2376),
    [anon_sym_set] = ACTIONS(2376),
    [anon_sym_declare] = ACTIONS(2352),
    [anon_sym_public] = ACTIONS(2352),
    [anon_sym_private] = ACTIONS(2352),
    [anon_sym_protected] = ACTIONS(2352),
    [anon_sym_module] = ACTIONS(2352),
    [anon_sym_any] = ACTIONS(2352),
    [anon_sym_number] = ACTIONS(2352),
    [anon_sym_boolean] = ACTIONS(2352),
    [anon_sym_string] = ACTIONS(2352),
    [anon_sym_symbol] = ACTIONS(2352),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [420] = {
    [ts_builtin_sym_end] = ACTIONS(2400),
    [sym_identifier] = ACTIONS(2402),
    [anon_sym_export] = ACTIONS(2402),
    [anon_sym_default] = ACTIONS(2402),
    [anon_sym_EQ] = ACTIONS(2402),
    [anon_sym_namespace] = ACTIONS(2402),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_COMMA] = ACTIONS(2400),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_type] = ACTIONS(2402),
    [anon_sym_typeof] = ACTIONS(2402),
    [anon_sym_import] = ACTIONS(2402),
    [anon_sym_var] = ACTIONS(2402),
    [anon_sym_let] = ACTIONS(2402),
    [anon_sym_const] = ACTIONS(2402),
    [anon_sym_if] = ACTIONS(2402),
    [anon_sym_else] = ACTIONS(2402),
    [anon_sym_switch] = ACTIONS(2402),
    [anon_sym_for] = ACTIONS(2402),
    [anon_sym_LPAREN] = ACTIONS(2400),
    [anon_sym_RPAREN] = ACTIONS(2400),
    [anon_sym_await] = ACTIONS(2402),
    [anon_sym_while] = ACTIONS(2402),
    [anon_sym_do] = ACTIONS(2402),
    [anon_sym_try] = ACTIONS(2402),
    [anon_sym_with] = ACTIONS(2402),
    [anon_sym_break] = ACTIONS(2402),
    [anon_sym_continue] = ACTIONS(2402),
    [anon_sym_debugger] = ACTIONS(2402),
    [anon_sym_return] = ACTIONS(2402),
    [anon_sym_throw] = ACTIONS(2402),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_case] = ACTIONS(2402),
    [anon_sym_yield] = ACTIONS(2402),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_RBRACK] = ACTIONS(2400),
    [anon_sym_LT] = ACTIONS(2400),
    [anon_sym_GT] = ACTIONS(2400),
    [anon_sym_SLASH] = ACTIONS(2402),
    [anon_sym_class] = ACTIONS(2402),
    [anon_sym_async] = ACTIONS(2402),
    [anon_sym_function] = ACTIONS(2402),
    [anon_sym_EQ_GT] = ACTIONS(2400),
    [anon_sym_new] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_PIPE] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_TILDE] = ACTIONS(2400),
    [anon_sym_void] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [anon_sym_DQUOTE] = ACTIONS(2400),
    [anon_sym_SQUOTE] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2400),
    [sym_number] = ACTIONS(2400),
    [sym_this] = ACTIONS(2402),
    [sym_super] = ACTIONS(2402),
    [sym_true] = ACTIONS(2402),
    [sym_false] = ACTIONS(2402),
    [sym_null] = ACTIONS(2402),
    [sym_undefined] = ACTIONS(2402),
    [anon_sym_AT] = ACTIONS(2400),
    [anon_sym_static] = ACTIONS(2402),
    [anon_sym_abstract] = ACTIONS(2402),
    [anon_sym_get] = ACTIONS(2402),
    [anon_sym_set] = ACTIONS(2402),
    [anon_sym_declare] = ACTIONS(2402),
    [anon_sym_public] = ACTIONS(2402),
    [anon_sym_private] = ACTIONS(2402),
    [anon_sym_protected] = ACTIONS(2402),
    [anon_sym_module] = ACTIONS(2402),
    [anon_sym_any] = ACTIONS(2402),
    [anon_sym_number] = ACTIONS(2402),
    [anon_sym_boolean] = ACTIONS(2402),
    [anon_sym_string] = ACTIONS(2402),
    [anon_sym_symbol] = ACTIONS(2402),
    [anon_sym_implements] = ACTIONS(2402),
    [anon_sym_interface] = ACTIONS(2402),
    [anon_sym_enum] = ACTIONS(2402),
  },
  [421] = {
    [ts_builtin_sym_end] = ACTIONS(2404),
    [sym_identifier] = ACTIONS(2406),
    [anon_sym_export] = ACTIONS(2406),
    [anon_sym_default] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(2406),
    [anon_sym_namespace] = ACTIONS(2406),
    [anon_sym_LBRACE] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_RBRACE] = ACTIONS(2404),
    [anon_sym_type] = ACTIONS(2406),
    [anon_sym_typeof] = ACTIONS(2406),
    [anon_sym_import] = ACTIONS(2406),
    [anon_sym_var] = ACTIONS(2406),
    [anon_sym_let] = ACTIONS(2406),
    [anon_sym_const] = ACTIONS(2406),
    [anon_sym_if] = ACTIONS(2406),
    [anon_sym_else] = ACTIONS(2406),
    [anon_sym_switch] = ACTIONS(2406),
    [anon_sym_for] = ACTIONS(2406),
    [anon_sym_LPAREN] = ACTIONS(2404),
    [anon_sym_RPAREN] = ACTIONS(2404),
    [anon_sym_await] = ACTIONS(2406),
    [anon_sym_while] = ACTIONS(2406),
    [anon_sym_do] = ACTIONS(2406),
    [anon_sym_try] = ACTIONS(2406),
    [anon_sym_with] = ACTIONS(2406),
    [anon_sym_break] = ACTIONS(2406),
    [anon_sym_continue] = ACTIONS(2406),
    [anon_sym_debugger] = ACTIONS(2406),
    [anon_sym_return] = ACTIONS(2406),
    [anon_sym_throw] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2404),
    [anon_sym_case] = ACTIONS(2406),
    [anon_sym_yield] = ACTIONS(2406),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_RBRACK] = ACTIONS(2404),
    [anon_sym_LT] = ACTIONS(2404),
    [anon_sym_GT] = ACTIONS(2404),
    [anon_sym_SLASH] = ACTIONS(2406),
    [anon_sym_class] = ACTIONS(2406),
    [anon_sym_async] = ACTIONS(2406),
    [anon_sym_function] = ACTIONS(2406),
    [anon_sym_EQ_GT] = ACTIONS(2404),
    [anon_sym_new] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_PIPE] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2406),
    [anon_sym_DASH] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2404),
    [anon_sym_TILDE] = ACTIONS(2404),
    [anon_sym_void] = ACTIONS(2406),
    [anon_sym_delete] = ACTIONS(2406),
    [anon_sym_PLUS_PLUS] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2404),
    [anon_sym_DQUOTE] = ACTIONS(2404),
    [anon_sym_SQUOTE] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2404),
    [sym_number] = ACTIONS(2404),
    [sym_this] = ACTIONS(2406),
    [sym_super] = ACTIONS(2406),
    [sym_true] = ACTIONS(2406),
    [sym_false] = ACTIONS(2406),
    [sym_null] = ACTIONS(2406),
    [sym_undefined] = ACTIONS(2406),
    [anon_sym_AT] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2406),
    [anon_sym_abstract] = ACTIONS(2406),
    [anon_sym_get] = ACTIONS(2406),
    [anon_sym_set] = ACTIONS(2406),
    [anon_sym_declare] = ACTIONS(2406),
    [anon_sym_public] = ACTIONS(2406),
    [anon_sym_private] = ACTIONS(2406),
    [anon_sym_protected] = ACTIONS(2406),
    [anon_sym_module] = ACTIONS(2406),
    [anon_sym_any] = ACTIONS(2406),
    [anon_sym_number] = ACTIONS(2406),
    [anon_sym_boolean] = ACTIONS(2406),
    [anon_sym_string] = ACTIONS(2406),
    [anon_sym_symbol] = ACTIONS(2406),
    [anon_sym_interface] = ACTIONS(2406),
    [anon_sym_enum] = ACTIONS(2406),
  },
  [422] = {
    [ts_builtin_sym_end] = ACTIONS(2408),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_export] = ACTIONS(2410),
    [anon_sym_default] = ACTIONS(2410),
    [anon_sym_EQ] = ACTIONS(2410),
    [anon_sym_namespace] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_COMMA] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [anon_sym_type] = ACTIONS(2410),
    [anon_sym_typeof] = ACTIONS(2410),
    [anon_sym_import] = ACTIONS(2410),
    [anon_sym_var] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2410),
    [anon_sym_switch] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_LPAREN] = ACTIONS(2408),
    [anon_sym_RPAREN] = ACTIONS(2408),
    [anon_sym_await] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2410),
    [anon_sym_with] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2410),
    [anon_sym_continue] = ACTIONS(2410),
    [anon_sym_debugger] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_throw] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_case] = ACTIONS(2410),
    [anon_sym_yield] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2408),
    [anon_sym_RBRACK] = ACTIONS(2408),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_SLASH] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_async] = ACTIONS(2410),
    [anon_sym_function] = ACTIONS(2410),
    [anon_sym_EQ_GT] = ACTIONS(2408),
    [anon_sym_new] = ACTIONS(2410),
    [anon_sym_AMP] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [anon_sym_void] = ACTIONS(2410),
    [anon_sym_delete] = ACTIONS(2410),
    [anon_sym_PLUS_PLUS] = ACTIONS(2408),
    [anon_sym_DASH_DASH] = ACTIONS(2408),
    [anon_sym_DQUOTE] = ACTIONS(2408),
    [anon_sym_SQUOTE] = ACTIONS(2408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2408),
    [sym_number] = ACTIONS(2408),
    [sym_this] = ACTIONS(2410),
    [sym_super] = ACTIONS(2410),
    [sym_true] = ACTIONS(2410),
    [sym_false] = ACTIONS(2410),
    [sym_null] = ACTIONS(2410),
    [sym_undefined] = ACTIONS(2410),
    [anon_sym_AT] = ACTIONS(2408),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_abstract] = ACTIONS(2410),
    [anon_sym_get] = ACTIONS(2410),
    [anon_sym_set] = ACTIONS(2410),
    [anon_sym_declare] = ACTIONS(2410),
    [anon_sym_public] = ACTIONS(2410),
    [anon_sym_private] = ACTIONS(2410),
    [anon_sym_protected] = ACTIONS(2410),
    [anon_sym_module] = ACTIONS(2410),
    [anon_sym_any] = ACTIONS(2410),
    [anon_sym_number] = ACTIONS(2410),
    [anon_sym_boolean] = ACTIONS(2410),
    [anon_sym_string] = ACTIONS(2410),
    [anon_sym_symbol] = ACTIONS(2410),
    [anon_sym_interface] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
  },
  [423] = {
    [ts_builtin_sym_end] = ACTIONS(2412),
    [sym_identifier] = ACTIONS(2414),
    [anon_sym_export] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_EQ] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_type] = ACTIONS(2414),
    [anon_sym_typeof] = ACTIONS(2414),
    [anon_sym_import] = ACTIONS(2414),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_else] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [anon_sym_RPAREN] = ACTIONS(2412),
    [anon_sym_await] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [anon_sym_with] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_debugger] = ACTIONS(2414),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym_case] = ACTIONS(2414),
    [anon_sym_yield] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_RBRACK] = ACTIONS(2412),
    [anon_sym_LT] = ACTIONS(2412),
    [anon_sym_GT] = ACTIONS(2412),
    [anon_sym_SLASH] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_async] = ACTIONS(2414),
    [anon_sym_function] = ACTIONS(2414),
    [anon_sym_EQ_GT] = ACTIONS(2412),
    [anon_sym_new] = ACTIONS(2414),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_PIPE] = ACTIONS(2412),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_void] = ACTIONS(2414),
    [anon_sym_delete] = ACTIONS(2414),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2412),
    [sym_number] = ACTIONS(2412),
    [sym_this] = ACTIONS(2414),
    [sym_super] = ACTIONS(2414),
    [sym_true] = ACTIONS(2414),
    [sym_false] = ACTIONS(2414),
    [sym_null] = ACTIONS(2414),
    [sym_undefined] = ACTIONS(2414),
    [anon_sym_AT] = ACTIONS(2412),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_abstract] = ACTIONS(2414),
    [anon_sym_get] = ACTIONS(2414),
    [anon_sym_set] = ACTIONS(2414),
    [anon_sym_declare] = ACTIONS(2414),
    [anon_sym_public] = ACTIONS(2414),
    [anon_sym_private] = ACTIONS(2414),
    [anon_sym_protected] = ACTIONS(2414),
    [anon_sym_module] = ACTIONS(2414),
    [anon_sym_any] = ACTIONS(2414),
    [anon_sym_number] = ACTIONS(2414),
    [anon_sym_boolean] = ACTIONS(2414),
    [anon_sym_string] = ACTIONS(2414),
    [anon_sym_symbol] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
  },
  [424] = {
    [ts_builtin_sym_end] = ACTIONS(2416),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_export] = ACTIONS(2418),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2418),
    [anon_sym_namespace] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_type] = ACTIONS(2418),
    [anon_sym_typeof] = ACTIONS(2418),
    [anon_sym_import] = ACTIONS(2418),
    [anon_sym_var] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_else] = ACTIONS(2418),
    [anon_sym_switch] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_RPAREN] = ACTIONS(2416),
    [anon_sym_await] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_with] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_debugger] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_throw] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym_case] = ACTIONS(2418),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_RBRACK] = ACTIONS(2416),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2416),
    [anon_sym_SLASH] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_async] = ACTIONS(2418),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_EQ_GT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2416),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_void] = ACTIONS(2418),
    [anon_sym_delete] = ACTIONS(2418),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_DQUOTE] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2416),
    [sym_number] = ACTIONS(2416),
    [sym_this] = ACTIONS(2418),
    [sym_super] = ACTIONS(2418),
    [sym_true] = ACTIONS(2418),
    [sym_false] = ACTIONS(2418),
    [sym_null] = ACTIONS(2418),
    [sym_undefined] = ACTIONS(2418),
    [anon_sym_AT] = ACTIONS(2416),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_abstract] = ACTIONS(2418),
    [anon_sym_get] = ACTIONS(2418),
    [anon_sym_set] = ACTIONS(2418),
    [anon_sym_declare] = ACTIONS(2418),
    [anon_sym_public] = ACTIONS(2418),
    [anon_sym_private] = ACTIONS(2418),
    [anon_sym_protected] = ACTIONS(2418),
    [anon_sym_module] = ACTIONS(2418),
    [anon_sym_any] = ACTIONS(2418),
    [anon_sym_number] = ACTIONS(2418),
    [anon_sym_boolean] = ACTIONS(2418),
    [anon_sym_string] = ACTIONS(2418),
    [anon_sym_symbol] = ACTIONS(2418),
    [anon_sym_interface] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
  },
  [425] = {
    [ts_builtin_sym_end] = ACTIONS(2420),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_export] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_type] = ACTIONS(2422),
    [anon_sym_typeof] = ACTIONS(2422),
    [anon_sym_import] = ACTIONS(2422),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [anon_sym_await] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_with] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_debugger] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_RBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_GT] = ACTIONS(2420),
    [anon_sym_SLASH] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_async] = ACTIONS(2422),
    [anon_sym_function] = ACTIONS(2422),
    [anon_sym_EQ_GT] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_AMP] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2420),
    [sym_number] = ACTIONS(2420),
    [sym_this] = ACTIONS(2422),
    [sym_super] = ACTIONS(2422),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [sym_null] = ACTIONS(2422),
    [sym_undefined] = ACTIONS(2422),
    [anon_sym_AT] = ACTIONS(2420),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_abstract] = ACTIONS(2422),
    [anon_sym_get] = ACTIONS(2422),
    [anon_sym_set] = ACTIONS(2422),
    [anon_sym_declare] = ACTIONS(2422),
    [anon_sym_public] = ACTIONS(2422),
    [anon_sym_private] = ACTIONS(2422),
    [anon_sym_protected] = ACTIONS(2422),
    [anon_sym_module] = ACTIONS(2422),
    [anon_sym_any] = ACTIONS(2422),
    [anon_sym_number] = ACTIONS(2422),
    [anon_sym_boolean] = ACTIONS(2422),
    [anon_sym_string] = ACTIONS(2422),
    [anon_sym_symbol] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
  },
  [426] = {
    [ts_builtin_sym_end] = ACTIONS(2424),
    [sym_identifier] = ACTIONS(2426),
    [anon_sym_export] = ACTIONS(2426),
    [anon_sym_default] = ACTIONS(2426),
    [anon_sym_EQ] = ACTIONS(2426),
    [anon_sym_namespace] = ACTIONS(2426),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_type] = ACTIONS(2426),
    [anon_sym_typeof] = ACTIONS(2426),
    [anon_sym_import] = ACTIONS(2426),
    [anon_sym_var] = ACTIONS(2426),
    [anon_sym_let] = ACTIONS(2426),
    [anon_sym_const] = ACTIONS(2426),
    [anon_sym_if] = ACTIONS(2426),
    [anon_sym_else] = ACTIONS(2426),
    [anon_sym_switch] = ACTIONS(2426),
    [anon_sym_for] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_RPAREN] = ACTIONS(2424),
    [anon_sym_await] = ACTIONS(2426),
    [anon_sym_while] = ACTIONS(2426),
    [anon_sym_do] = ACTIONS(2426),
    [anon_sym_try] = ACTIONS(2426),
    [anon_sym_with] = ACTIONS(2426),
    [anon_sym_break] = ACTIONS(2426),
    [anon_sym_continue] = ACTIONS(2426),
    [anon_sym_debugger] = ACTIONS(2426),
    [anon_sym_return] = ACTIONS(2426),
    [anon_sym_throw] = ACTIONS(2426),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_case] = ACTIONS(2426),
    [anon_sym_yield] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_RBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_GT] = ACTIONS(2424),
    [anon_sym_SLASH] = ACTIONS(2426),
    [anon_sym_class] = ACTIONS(2426),
    [anon_sym_async] = ACTIONS(2426),
    [anon_sym_function] = ACTIONS(2426),
    [anon_sym_EQ_GT] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2424),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_BANG] = ACTIONS(2424),
    [anon_sym_TILDE] = ACTIONS(2424),
    [anon_sym_void] = ACTIONS(2426),
    [anon_sym_delete] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [anon_sym_DQUOTE] = ACTIONS(2424),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2424),
    [sym_number] = ACTIONS(2424),
    [sym_this] = ACTIONS(2426),
    [sym_super] = ACTIONS(2426),
    [sym_true] = ACTIONS(2426),
    [sym_false] = ACTIONS(2426),
    [sym_null] = ACTIONS(2426),
    [sym_undefined] = ACTIONS(2426),
    [anon_sym_AT] = ACTIONS(2424),
    [anon_sym_static] = ACTIONS(2426),
    [anon_sym_abstract] = ACTIONS(2426),
    [anon_sym_get] = ACTIONS(2426),
    [anon_sym_set] = ACTIONS(2426),
    [anon_sym_declare] = ACTIONS(2426),
    [anon_sym_public] = ACTIONS(2426),
    [anon_sym_private] = ACTIONS(2426),
    [anon_sym_protected] = ACTIONS(2426),
    [anon_sym_module] = ACTIONS(2426),
    [anon_sym_any] = ACTIONS(2426),
    [anon_sym_number] = ACTIONS(2426),
    [anon_sym_boolean] = ACTIONS(2426),
    [anon_sym_string] = ACTIONS(2426),
    [anon_sym_symbol] = ACTIONS(2426),
    [anon_sym_interface] = ACTIONS(2426),
    [anon_sym_enum] = ACTIONS(2426),
  },
  [427] = {
    [ts_builtin_sym_end] = ACTIONS(2430),
    [sym_identifier] = ACTIONS(2432),
    [anon_sym_export] = ACTIONS(2432),
    [anon_sym_default] = ACTIONS(2432),
    [anon_sym_EQ] = ACTIONS(2432),
    [anon_sym_namespace] = ACTIONS(2432),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2430),
    [anon_sym_RBRACE] = ACTIONS(2430),
    [anon_sym_type] = ACTIONS(2432),
    [anon_sym_typeof] = ACTIONS(2432),
    [anon_sym_import] = ACTIONS(2432),
    [anon_sym_var] = ACTIONS(2432),
    [anon_sym_let] = ACTIONS(2432),
    [anon_sym_const] = ACTIONS(2432),
    [anon_sym_if] = ACTIONS(2432),
    [anon_sym_else] = ACTIONS(2432),
    [anon_sym_switch] = ACTIONS(2432),
    [anon_sym_for] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(2430),
    [anon_sym_await] = ACTIONS(2432),
    [anon_sym_while] = ACTIONS(2432),
    [anon_sym_do] = ACTIONS(2432),
    [anon_sym_try] = ACTIONS(2432),
    [anon_sym_with] = ACTIONS(2432),
    [anon_sym_break] = ACTIONS(2432),
    [anon_sym_continue] = ACTIONS(2432),
    [anon_sym_debugger] = ACTIONS(2432),
    [anon_sym_return] = ACTIONS(2432),
    [anon_sym_throw] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(2432),
    [anon_sym_yield] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_RBRACK] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2432),
    [anon_sym_class] = ACTIONS(2432),
    [anon_sym_async] = ACTIONS(2432),
    [anon_sym_function] = ACTIONS(2432),
    [anon_sym_EQ_GT] = ACTIONS(2430),
    [anon_sym_new] = ACTIONS(2432),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_TILDE] = ACTIONS(2430),
    [anon_sym_void] = ACTIONS(2432),
    [anon_sym_delete] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(2430),
    [anon_sym_SQUOTE] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2430),
    [sym_number] = ACTIONS(2430),
    [sym_this] = ACTIONS(2432),
    [sym_super] = ACTIONS(2432),
    [sym_true] = ACTIONS(2432),
    [sym_false] = ACTIONS(2432),
    [sym_null] = ACTIONS(2432),
    [sym_undefined] = ACTIONS(2432),
    [anon_sym_AT] = ACTIONS(2430),
    [anon_sym_static] = ACTIONS(2432),
    [anon_sym_abstract] = ACTIONS(2432),
    [anon_sym_get] = ACTIONS(2432),
    [anon_sym_set] = ACTIONS(2432),
    [anon_sym_declare] = ACTIONS(2432),
    [anon_sym_public] = ACTIONS(2432),
    [anon_sym_private] = ACTIONS(2432),
    [anon_sym_protected] = ACTIONS(2432),
    [anon_sym_module] = ACTIONS(2432),
    [anon_sym_any] = ACTIONS(2432),
    [anon_sym_number] = ACTIONS(2432),
    [anon_sym_boolean] = ACTIONS(2432),
    [anon_sym_string] = ACTIONS(2432),
    [anon_sym_symbol] = ACTIONS(2432),
    [anon_sym_interface] = ACTIONS(2432),
    [anon_sym_enum] = ACTIONS(2432),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(2434),
    [sym_identifier] = ACTIONS(2436),
    [anon_sym_export] = ACTIONS(2436),
    [anon_sym_default] = ACTIONS(2436),
    [anon_sym_EQ] = ACTIONS(2436),
    [anon_sym_namespace] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2434),
    [anon_sym_RBRACE] = ACTIONS(2434),
    [anon_sym_type] = ACTIONS(2436),
    [anon_sym_typeof] = ACTIONS(2436),
    [anon_sym_import] = ACTIONS(2436),
    [anon_sym_var] = ACTIONS(2436),
    [anon_sym_let] = ACTIONS(2436),
    [anon_sym_const] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(2436),
    [anon_sym_else] = ACTIONS(2436),
    [anon_sym_switch] = ACTIONS(2436),
    [anon_sym_for] = ACTIONS(2436),
    [anon_sym_LPAREN] = ACTIONS(2434),
    [anon_sym_RPAREN] = ACTIONS(2434),
    [anon_sym_await] = ACTIONS(2436),
    [anon_sym_while] = ACTIONS(2436),
    [anon_sym_do] = ACTIONS(2436),
    [anon_sym_try] = ACTIONS(2436),
    [anon_sym_with] = ACTIONS(2436),
    [anon_sym_break] = ACTIONS(2436),
    [anon_sym_continue] = ACTIONS(2436),
    [anon_sym_debugger] = ACTIONS(2436),
    [anon_sym_return] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2436),
    [anon_sym_SEMI] = ACTIONS(2434),
    [anon_sym_case] = ACTIONS(2436),
    [anon_sym_yield] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_RBRACK] = ACTIONS(2434),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_GT] = ACTIONS(2434),
    [anon_sym_SLASH] = ACTIONS(2436),
    [anon_sym_class] = ACTIONS(2436),
    [anon_sym_async] = ACTIONS(2436),
    [anon_sym_function] = ACTIONS(2436),
    [anon_sym_EQ_GT] = ACTIONS(2434),
    [anon_sym_new] = ACTIONS(2436),
    [anon_sym_AMP] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_TILDE] = ACTIONS(2434),
    [anon_sym_void] = ACTIONS(2436),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2434),
    [anon_sym_DASH_DASH] = ACTIONS(2434),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [anon_sym_SQUOTE] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2434),
    [sym_number] = ACTIONS(2434),
    [sym_this] = ACTIONS(2436),
    [sym_super] = ACTIONS(2436),
    [sym_true] = ACTIONS(2436),
    [sym_false] = ACTIONS(2436),
    [sym_null] = ACTIONS(2436),
    [sym_undefined] = ACTIONS(2436),
    [anon_sym_AT] = ACTIONS(2434),
    [anon_sym_static] = ACTIONS(2436),
    [anon_sym_abstract] = ACTIONS(2436),
    [anon_sym_get] = ACTIONS(2436),
    [anon_sym_set] = ACTIONS(2436),
    [anon_sym_declare] = ACTIONS(2436),
    [anon_sym_public] = ACTIONS(2436),
    [anon_sym_private] = ACTIONS(2436),
    [anon_sym_protected] = ACTIONS(2436),
    [anon_sym_module] = ACTIONS(2436),
    [anon_sym_any] = ACTIONS(2436),
    [anon_sym_number] = ACTIONS(2436),
    [anon_sym_boolean] = ACTIONS(2436),
    [anon_sym_string] = ACTIONS(2436),
    [anon_sym_symbol] = ACTIONS(2436),
    [anon_sym_interface] = ACTIONS(2436),
    [anon_sym_enum] = ACTIONS(2436),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(2438),
    [sym_identifier] = ACTIONS(2440),
    [anon_sym_export] = ACTIONS(2440),
    [anon_sym_default] = ACTIONS(2440),
    [anon_sym_EQ] = ACTIONS(2440),
    [anon_sym_namespace] = ACTIONS(2440),
    [anon_sym_LBRACE] = ACTIONS(2438),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_RBRACE] = ACTIONS(2438),
    [anon_sym_type] = ACTIONS(2440),
    [anon_sym_typeof] = ACTIONS(2440),
    [anon_sym_import] = ACTIONS(2440),
    [anon_sym_var] = ACTIONS(2440),
    [anon_sym_let] = ACTIONS(2440),
    [anon_sym_const] = ACTIONS(2440),
    [anon_sym_if] = ACTIONS(2440),
    [anon_sym_else] = ACTIONS(2440),
    [anon_sym_switch] = ACTIONS(2440),
    [anon_sym_for] = ACTIONS(2440),
    [anon_sym_LPAREN] = ACTIONS(2438),
    [anon_sym_RPAREN] = ACTIONS(2438),
    [anon_sym_await] = ACTIONS(2440),
    [anon_sym_while] = ACTIONS(2440),
    [anon_sym_do] = ACTIONS(2440),
    [anon_sym_try] = ACTIONS(2440),
    [anon_sym_with] = ACTIONS(2440),
    [anon_sym_break] = ACTIONS(2440),
    [anon_sym_continue] = ACTIONS(2440),
    [anon_sym_debugger] = ACTIONS(2440),
    [anon_sym_return] = ACTIONS(2440),
    [anon_sym_throw] = ACTIONS(2440),
    [anon_sym_SEMI] = ACTIONS(2438),
    [anon_sym_case] = ACTIONS(2440),
    [anon_sym_yield] = ACTIONS(2440),
    [anon_sym_LBRACK] = ACTIONS(2438),
    [anon_sym_RBRACK] = ACTIONS(2438),
    [anon_sym_LT] = ACTIONS(2438),
    [anon_sym_GT] = ACTIONS(2438),
    [anon_sym_SLASH] = ACTIONS(2440),
    [anon_sym_class] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2440),
    [anon_sym_function] = ACTIONS(2440),
    [anon_sym_EQ_GT] = ACTIONS(2438),
    [anon_sym_new] = ACTIONS(2440),
    [anon_sym_AMP] = ACTIONS(2438),
    [anon_sym_PIPE] = ACTIONS(2438),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_DASH] = ACTIONS(2440),
    [anon_sym_BANG] = ACTIONS(2438),
    [anon_sym_TILDE] = ACTIONS(2438),
    [anon_sym_void] = ACTIONS(2440),
    [anon_sym_delete] = ACTIONS(2440),
    [anon_sym_PLUS_PLUS] = ACTIONS(2438),
    [anon_sym_DASH_DASH] = ACTIONS(2438),
    [anon_sym_DQUOTE] = ACTIONS(2438),
    [anon_sym_SQUOTE] = ACTIONS(2438),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2438),
    [sym_number] = ACTIONS(2438),
    [sym_this] = ACTIONS(2440),
    [sym_super] = ACTIONS(2440),
    [sym_true] = ACTIONS(2440),
    [sym_false] = ACTIONS(2440),
    [sym_null] = ACTIONS(2440),
    [sym_undefined] = ACTIONS(2440),
    [anon_sym_AT] = ACTIONS(2438),
    [anon_sym_static] = ACTIONS(2440),
    [anon_sym_abstract] = ACTIONS(2440),
    [anon_sym_get] = ACTIONS(2440),
    [anon_sym_set] = ACTIONS(2440),
    [anon_sym_declare] = ACTIONS(2440),
    [anon_sym_public] = ACTIONS(2440),
    [anon_sym_private] = ACTIONS(2440),
    [anon_sym_protected] = ACTIONS(2440),
    [anon_sym_module] = ACTIONS(2440),
    [anon_sym_any] = ACTIONS(2440),
    [anon_sym_number] = ACTIONS(2440),
    [anon_sym_boolean] = ACTIONS(2440),
    [anon_sym_string] = ACTIONS(2440),
    [anon_sym_symbol] = ACTIONS(2440),
    [anon_sym_interface] = ACTIONS(2440),
    [anon_sym_enum] = ACTIONS(2440),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(2442),
    [sym_identifier] = ACTIONS(2444),
    [anon_sym_export] = ACTIONS(2444),
    [anon_sym_default] = ACTIONS(2444),
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_namespace] = ACTIONS(2444),
    [anon_sym_LBRACE] = ACTIONS(2442),
    [anon_sym_COMMA] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_type] = ACTIONS(2444),
    [anon_sym_typeof] = ACTIONS(2444),
    [anon_sym_import] = ACTIONS(2444),
    [anon_sym_var] = ACTIONS(2444),
    [anon_sym_let] = ACTIONS(2444),
    [anon_sym_const] = ACTIONS(2444),
    [anon_sym_if] = ACTIONS(2444),
    [anon_sym_else] = ACTIONS(2444),
    [anon_sym_switch] = ACTIONS(2444),
    [anon_sym_for] = ACTIONS(2444),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [anon_sym_RPAREN] = ACTIONS(2442),
    [anon_sym_await] = ACTIONS(2444),
    [anon_sym_while] = ACTIONS(2444),
    [anon_sym_do] = ACTIONS(2444),
    [anon_sym_try] = ACTIONS(2444),
    [anon_sym_with] = ACTIONS(2444),
    [anon_sym_break] = ACTIONS(2444),
    [anon_sym_continue] = ACTIONS(2444),
    [anon_sym_debugger] = ACTIONS(2444),
    [anon_sym_return] = ACTIONS(2444),
    [anon_sym_throw] = ACTIONS(2444),
    [anon_sym_SEMI] = ACTIONS(2442),
    [anon_sym_case] = ACTIONS(2444),
    [anon_sym_yield] = ACTIONS(2444),
    [anon_sym_LBRACK] = ACTIONS(2442),
    [anon_sym_RBRACK] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2442),
    [anon_sym_GT] = ACTIONS(2442),
    [anon_sym_SLASH] = ACTIONS(2444),
    [anon_sym_class] = ACTIONS(2444),
    [anon_sym_async] = ACTIONS(2444),
    [anon_sym_function] = ACTIONS(2444),
    [anon_sym_EQ_GT] = ACTIONS(2442),
    [anon_sym_new] = ACTIONS(2444),
    [anon_sym_AMP] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_TILDE] = ACTIONS(2442),
    [anon_sym_void] = ACTIONS(2444),
    [anon_sym_delete] = ACTIONS(2444),
    [anon_sym_PLUS_PLUS] = ACTIONS(2442),
    [anon_sym_DASH_DASH] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_SQUOTE] = ACTIONS(2442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [sym_number] = ACTIONS(2442),
    [sym_this] = ACTIONS(2444),
    [sym_super] = ACTIONS(2444),
    [sym_true] = ACTIONS(2444),
    [sym_false] = ACTIONS(2444),
    [sym_null] = ACTIONS(2444),
    [sym_undefined] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2442),
    [anon_sym_static] = ACTIONS(2444),
    [anon_sym_abstract] = ACTIONS(2444),
    [anon_sym_get] = ACTIONS(2444),
    [anon_sym_set] = ACTIONS(2444),
    [anon_sym_declare] = ACTIONS(2444),
    [anon_sym_public] = ACTIONS(2444),
    [anon_sym_private] = ACTIONS(2444),
    [anon_sym_protected] = ACTIONS(2444),
    [anon_sym_module] = ACTIONS(2444),
    [anon_sym_any] = ACTIONS(2444),
    [anon_sym_number] = ACTIONS(2444),
    [anon_sym_boolean] = ACTIONS(2444),
    [anon_sym_string] = ACTIONS(2444),
    [anon_sym_symbol] = ACTIONS(2444),
    [anon_sym_interface] = ACTIONS(2444),
    [anon_sym_enum] = ACTIONS(2444),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(2446),
    [sym_identifier] = ACTIONS(2448),
    [anon_sym_export] = ACTIONS(2448),
    [anon_sym_default] = ACTIONS(2448),
    [anon_sym_EQ] = ACTIONS(2448),
    [anon_sym_namespace] = ACTIONS(2448),
    [anon_sym_LBRACE] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(2446),
    [anon_sym_type] = ACTIONS(2448),
    [anon_sym_typeof] = ACTIONS(2448),
    [anon_sym_import] = ACTIONS(2448),
    [anon_sym_var] = ACTIONS(2448),
    [anon_sym_let] = ACTIONS(2448),
    [anon_sym_const] = ACTIONS(2448),
    [anon_sym_if] = ACTIONS(2448),
    [anon_sym_else] = ACTIONS(2448),
    [anon_sym_switch] = ACTIONS(2448),
    [anon_sym_for] = ACTIONS(2448),
    [anon_sym_LPAREN] = ACTIONS(2446),
    [anon_sym_RPAREN] = ACTIONS(2446),
    [anon_sym_await] = ACTIONS(2448),
    [anon_sym_while] = ACTIONS(2448),
    [anon_sym_do] = ACTIONS(2448),
    [anon_sym_try] = ACTIONS(2448),
    [anon_sym_with] = ACTIONS(2448),
    [anon_sym_break] = ACTIONS(2448),
    [anon_sym_continue] = ACTIONS(2448),
    [anon_sym_debugger] = ACTIONS(2448),
    [anon_sym_return] = ACTIONS(2448),
    [anon_sym_throw] = ACTIONS(2448),
    [anon_sym_SEMI] = ACTIONS(2446),
    [anon_sym_case] = ACTIONS(2448),
    [anon_sym_yield] = ACTIONS(2448),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [anon_sym_RBRACK] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2448),
    [anon_sym_class] = ACTIONS(2448),
    [anon_sym_async] = ACTIONS(2448),
    [anon_sym_function] = ACTIONS(2448),
    [anon_sym_EQ_GT] = ACTIONS(2446),
    [anon_sym_new] = ACTIONS(2448),
    [anon_sym_AMP] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_TILDE] = ACTIONS(2446),
    [anon_sym_void] = ACTIONS(2448),
    [anon_sym_delete] = ACTIONS(2448),
    [anon_sym_PLUS_PLUS] = ACTIONS(2446),
    [anon_sym_DASH_DASH] = ACTIONS(2446),
    [anon_sym_DQUOTE] = ACTIONS(2446),
    [anon_sym_SQUOTE] = ACTIONS(2446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2446),
    [sym_number] = ACTIONS(2446),
    [sym_this] = ACTIONS(2448),
    [sym_super] = ACTIONS(2448),
    [sym_true] = ACTIONS(2448),
    [sym_false] = ACTIONS(2448),
    [sym_null] = ACTIONS(2448),
    [sym_undefined] = ACTIONS(2448),
    [anon_sym_AT] = ACTIONS(2446),
    [anon_sym_static] = ACTIONS(2448),
    [anon_sym_abstract] = ACTIONS(2448),
    [anon_sym_get] = ACTIONS(2448),
    [anon_sym_set] = ACTIONS(2448),
    [anon_sym_declare] = ACTIONS(2448),
    [anon_sym_public] = ACTIONS(2448),
    [anon_sym_private] = ACTIONS(2448),
    [anon_sym_protected] = ACTIONS(2448),
    [anon_sym_module] = ACTIONS(2448),
    [anon_sym_any] = ACTIONS(2448),
    [anon_sym_number] = ACTIONS(2448),
    [anon_sym_boolean] = ACTIONS(2448),
    [anon_sym_string] = ACTIONS(2448),
    [anon_sym_symbol] = ACTIONS(2448),
    [anon_sym_interface] = ACTIONS(2448),
    [anon_sym_enum] = ACTIONS(2448),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(2450),
    [sym_identifier] = ACTIONS(2452),
    [anon_sym_export] = ACTIONS(2452),
    [anon_sym_default] = ACTIONS(2452),
    [anon_sym_EQ] = ACTIONS(2452),
    [anon_sym_namespace] = ACTIONS(2452),
    [anon_sym_LBRACE] = ACTIONS(2450),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [anon_sym_type] = ACTIONS(2452),
    [anon_sym_typeof] = ACTIONS(2452),
    [anon_sym_import] = ACTIONS(2452),
    [anon_sym_var] = ACTIONS(2452),
    [anon_sym_let] = ACTIONS(2452),
    [anon_sym_const] = ACTIONS(2452),
    [anon_sym_if] = ACTIONS(2452),
    [anon_sym_else] = ACTIONS(2452),
    [anon_sym_switch] = ACTIONS(2452),
    [anon_sym_for] = ACTIONS(2452),
    [anon_sym_LPAREN] = ACTIONS(2450),
    [anon_sym_RPAREN] = ACTIONS(2450),
    [anon_sym_await] = ACTIONS(2452),
    [anon_sym_while] = ACTIONS(2452),
    [anon_sym_do] = ACTIONS(2452),
    [anon_sym_try] = ACTIONS(2452),
    [anon_sym_with] = ACTIONS(2452),
    [anon_sym_break] = ACTIONS(2452),
    [anon_sym_continue] = ACTIONS(2452),
    [anon_sym_debugger] = ACTIONS(2452),
    [anon_sym_return] = ACTIONS(2452),
    [anon_sym_throw] = ACTIONS(2452),
    [anon_sym_SEMI] = ACTIONS(2450),
    [anon_sym_case] = ACTIONS(2452),
    [anon_sym_yield] = ACTIONS(2452),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_RBRACK] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_class] = ACTIONS(2452),
    [anon_sym_async] = ACTIONS(2452),
    [anon_sym_function] = ACTIONS(2452),
    [anon_sym_EQ_GT] = ACTIONS(2450),
    [anon_sym_new] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2450),
    [anon_sym_PIPE] = ACTIONS(2450),
    [anon_sym_PLUS] = ACTIONS(2452),
    [anon_sym_DASH] = ACTIONS(2452),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_void] = ACTIONS(2452),
    [anon_sym_delete] = ACTIONS(2452),
    [anon_sym_PLUS_PLUS] = ACTIONS(2450),
    [anon_sym_DASH_DASH] = ACTIONS(2450),
    [anon_sym_DQUOTE] = ACTIONS(2450),
    [anon_sym_SQUOTE] = ACTIONS(2450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2450),
    [sym_number] = ACTIONS(2450),
    [sym_this] = ACTIONS(2452),
    [sym_super] = ACTIONS(2452),
    [sym_true] = ACTIONS(2452),
    [sym_false] = ACTIONS(2452),
    [sym_null] = ACTIONS(2452),
    [sym_undefined] = ACTIONS(2452),
    [anon_sym_AT] = ACTIONS(2450),
    [anon_sym_static] = ACTIONS(2452),
    [anon_sym_abstract] = ACTIONS(2452),
    [anon_sym_get] = ACTIONS(2452),
    [anon_sym_set] = ACTIONS(2452),
    [anon_sym_declare] = ACTIONS(2452),
    [anon_sym_public] = ACTIONS(2452),
    [anon_sym_private] = ACTIONS(2452),
    [anon_sym_protected] = ACTIONS(2452),
    [anon_sym_module] = ACTIONS(2452),
    [anon_sym_any] = ACTIONS(2452),
    [anon_sym_number] = ACTIONS(2452),
    [anon_sym_boolean] = ACTIONS(2452),
    [anon_sym_string] = ACTIONS(2452),
    [anon_sym_symbol] = ACTIONS(2452),
    [anon_sym_interface] = ACTIONS(2452),
    [anon_sym_enum] = ACTIONS(2452),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(2454),
    [sym_identifier] = ACTIONS(2456),
    [anon_sym_export] = ACTIONS(2456),
    [anon_sym_default] = ACTIONS(2456),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_namespace] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_type] = ACTIONS(2456),
    [anon_sym_typeof] = ACTIONS(2456),
    [anon_sym_import] = ACTIONS(2456),
    [anon_sym_var] = ACTIONS(2456),
    [anon_sym_let] = ACTIONS(2456),
    [anon_sym_const] = ACTIONS(2456),
    [anon_sym_if] = ACTIONS(2456),
    [anon_sym_else] = ACTIONS(2456),
    [anon_sym_switch] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_RPAREN] = ACTIONS(2454),
    [anon_sym_await] = ACTIONS(2456),
    [anon_sym_while] = ACTIONS(2456),
    [anon_sym_do] = ACTIONS(2456),
    [anon_sym_try] = ACTIONS(2456),
    [anon_sym_with] = ACTIONS(2456),
    [anon_sym_break] = ACTIONS(2456),
    [anon_sym_continue] = ACTIONS(2456),
    [anon_sym_debugger] = ACTIONS(2456),
    [anon_sym_return] = ACTIONS(2456),
    [anon_sym_throw] = ACTIONS(2456),
    [anon_sym_SEMI] = ACTIONS(2454),
    [anon_sym_case] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2456),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_RBRACK] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_GT] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2456),
    [anon_sym_class] = ACTIONS(2456),
    [anon_sym_async] = ACTIONS(2456),
    [anon_sym_function] = ACTIONS(2456),
    [anon_sym_EQ_GT] = ACTIONS(2454),
    [anon_sym_new] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_BANG] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2454),
    [anon_sym_void] = ACTIONS(2456),
    [anon_sym_delete] = ACTIONS(2456),
    [anon_sym_PLUS_PLUS] = ACTIONS(2454),
    [anon_sym_DASH_DASH] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_SQUOTE] = ACTIONS(2454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [sym_number] = ACTIONS(2454),
    [sym_this] = ACTIONS(2456),
    [sym_super] = ACTIONS(2456),
    [sym_true] = ACTIONS(2456),
    [sym_false] = ACTIONS(2456),
    [sym_null] = ACTIONS(2456),
    [sym_undefined] = ACTIONS(2456),
    [anon_sym_AT] = ACTIONS(2454),
    [anon_sym_static] = ACTIONS(2456),
    [anon_sym_abstract] = ACTIONS(2456),
    [anon_sym_get] = ACTIONS(2456),
    [anon_sym_set] = ACTIONS(2456),
    [anon_sym_declare] = ACTIONS(2456),
    [anon_sym_public] = ACTIONS(2456),
    [anon_sym_private] = ACTIONS(2456),
    [anon_sym_protected] = ACTIONS(2456),
    [anon_sym_module] = ACTIONS(2456),
    [anon_sym_any] = ACTIONS(2456),
    [anon_sym_number] = ACTIONS(2456),
    [anon_sym_boolean] = ACTIONS(2456),
    [anon_sym_string] = ACTIONS(2456),
    [anon_sym_symbol] = ACTIONS(2456),
    [anon_sym_interface] = ACTIONS(2456),
    [anon_sym_enum] = ACTIONS(2456),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(2458),
    [sym_identifier] = ACTIONS(2460),
    [anon_sym_export] = ACTIONS(2460),
    [anon_sym_default] = ACTIONS(2460),
    [anon_sym_EQ] = ACTIONS(2460),
    [anon_sym_namespace] = ACTIONS(2460),
    [anon_sym_LBRACE] = ACTIONS(2458),
    [anon_sym_COMMA] = ACTIONS(2458),
    [anon_sym_RBRACE] = ACTIONS(2458),
    [anon_sym_type] = ACTIONS(2460),
    [anon_sym_typeof] = ACTIONS(2460),
    [anon_sym_import] = ACTIONS(2460),
    [anon_sym_var] = ACTIONS(2460),
    [anon_sym_let] = ACTIONS(2460),
    [anon_sym_const] = ACTIONS(2460),
    [anon_sym_if] = ACTIONS(2460),
    [anon_sym_else] = ACTIONS(2460),
    [anon_sym_switch] = ACTIONS(2460),
    [anon_sym_for] = ACTIONS(2460),
    [anon_sym_LPAREN] = ACTIONS(2458),
    [anon_sym_RPAREN] = ACTIONS(2458),
    [anon_sym_await] = ACTIONS(2460),
    [anon_sym_while] = ACTIONS(2460),
    [anon_sym_do] = ACTIONS(2460),
    [anon_sym_try] = ACTIONS(2460),
    [anon_sym_with] = ACTIONS(2460),
    [anon_sym_break] = ACTIONS(2460),
    [anon_sym_continue] = ACTIONS(2460),
    [anon_sym_debugger] = ACTIONS(2460),
    [anon_sym_return] = ACTIONS(2460),
    [anon_sym_throw] = ACTIONS(2460),
    [anon_sym_SEMI] = ACTIONS(2458),
    [anon_sym_case] = ACTIONS(2460),
    [anon_sym_yield] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2458),
    [anon_sym_RBRACK] = ACTIONS(2458),
    [anon_sym_LT] = ACTIONS(2458),
    [anon_sym_GT] = ACTIONS(2458),
    [anon_sym_SLASH] = ACTIONS(2460),
    [anon_sym_class] = ACTIONS(2460),
    [anon_sym_async] = ACTIONS(2460),
    [anon_sym_function] = ACTIONS(2460),
    [anon_sym_EQ_GT] = ACTIONS(2458),
    [anon_sym_new] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2458),
    [anon_sym_PIPE] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2460),
    [anon_sym_DASH] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2458),
    [anon_sym_TILDE] = ACTIONS(2458),
    [anon_sym_void] = ACTIONS(2460),
    [anon_sym_delete] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(2458),
    [anon_sym_DASH_DASH] = ACTIONS(2458),
    [anon_sym_DQUOTE] = ACTIONS(2458),
    [anon_sym_SQUOTE] = ACTIONS(2458),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2458),
    [sym_number] = ACTIONS(2458),
    [sym_this] = ACTIONS(2460),
    [sym_super] = ACTIONS(2460),
    [sym_true] = ACTIONS(2460),
    [sym_false] = ACTIONS(2460),
    [sym_null] = ACTIONS(2460),
    [sym_undefined] = ACTIONS(2460),
    [anon_sym_AT] = ACTIONS(2458),
    [anon_sym_static] = ACTIONS(2460),
    [anon_sym_abstract] = ACTIONS(2460),
    [anon_sym_get] = ACTIONS(2460),
    [anon_sym_set] = ACTIONS(2460),
    [anon_sym_declare] = ACTIONS(2460),
    [anon_sym_public] = ACTIONS(2460),
    [anon_sym_private] = ACTIONS(2460),
    [anon_sym_protected] = ACTIONS(2460),
    [anon_sym_module] = ACTIONS(2460),
    [anon_sym_any] = ACTIONS(2460),
    [anon_sym_number] = ACTIONS(2460),
    [anon_sym_boolean] = ACTIONS(2460),
    [anon_sym_string] = ACTIONS(2460),
    [anon_sym_symbol] = ACTIONS(2460),
    [anon_sym_interface] = ACTIONS(2460),
    [anon_sym_enum] = ACTIONS(2460),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(2462),
    [sym_identifier] = ACTIONS(2464),
    [anon_sym_export] = ACTIONS(2464),
    [anon_sym_default] = ACTIONS(2464),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_namespace] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_type] = ACTIONS(2464),
    [anon_sym_typeof] = ACTIONS(2464),
    [anon_sym_import] = ACTIONS(2464),
    [anon_sym_var] = ACTIONS(2464),
    [anon_sym_let] = ACTIONS(2464),
    [anon_sym_const] = ACTIONS(2464),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_else] = ACTIONS(2464),
    [anon_sym_switch] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_await] = ACTIONS(2464),
    [anon_sym_while] = ACTIONS(2464),
    [anon_sym_do] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2464),
    [anon_sym_with] = ACTIONS(2464),
    [anon_sym_break] = ACTIONS(2464),
    [anon_sym_continue] = ACTIONS(2464),
    [anon_sym_debugger] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2464),
    [anon_sym_throw] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_case] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_RBRACK] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2462),
    [anon_sym_GT] = ACTIONS(2462),
    [anon_sym_SLASH] = ACTIONS(2464),
    [anon_sym_class] = ACTIONS(2464),
    [anon_sym_async] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2464),
    [anon_sym_EQ_GT] = ACTIONS(2462),
    [anon_sym_new] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [anon_sym_void] = ACTIONS(2464),
    [anon_sym_delete] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_SQUOTE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [sym_number] = ACTIONS(2462),
    [sym_this] = ACTIONS(2464),
    [sym_super] = ACTIONS(2464),
    [sym_true] = ACTIONS(2464),
    [sym_false] = ACTIONS(2464),
    [sym_null] = ACTIONS(2464),
    [sym_undefined] = ACTIONS(2464),
    [anon_sym_AT] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2464),
    [anon_sym_abstract] = ACTIONS(2464),
    [anon_sym_get] = ACTIONS(2464),
    [anon_sym_set] = ACTIONS(2464),
    [anon_sym_declare] = ACTIONS(2464),
    [anon_sym_public] = ACTIONS(2464),
    [anon_sym_private] = ACTIONS(2464),
    [anon_sym_protected] = ACTIONS(2464),
    [anon_sym_module] = ACTIONS(2464),
    [anon_sym_any] = ACTIONS(2464),
    [anon_sym_number] = ACTIONS(2464),
    [anon_sym_boolean] = ACTIONS(2464),
    [anon_sym_string] = ACTIONS(2464),
    [anon_sym_symbol] = ACTIONS(2464),
    [anon_sym_interface] = ACTIONS(2464),
    [anon_sym_enum] = ACTIONS(2464),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(2466),
    [sym_identifier] = ACTIONS(2468),
    [anon_sym_export] = ACTIONS(2468),
    [anon_sym_default] = ACTIONS(2468),
    [anon_sym_EQ] = ACTIONS(2468),
    [anon_sym_namespace] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_type] = ACTIONS(2468),
    [anon_sym_typeof] = ACTIONS(2468),
    [anon_sym_import] = ACTIONS(2468),
    [anon_sym_var] = ACTIONS(2468),
    [anon_sym_let] = ACTIONS(2468),
    [anon_sym_const] = ACTIONS(2468),
    [anon_sym_if] = ACTIONS(2468),
    [anon_sym_else] = ACTIONS(2468),
    [anon_sym_switch] = ACTIONS(2468),
    [anon_sym_for] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_RPAREN] = ACTIONS(2466),
    [anon_sym_await] = ACTIONS(2468),
    [anon_sym_while] = ACTIONS(2468),
    [anon_sym_do] = ACTIONS(2468),
    [anon_sym_try] = ACTIONS(2468),
    [anon_sym_with] = ACTIONS(2468),
    [anon_sym_break] = ACTIONS(2468),
    [anon_sym_continue] = ACTIONS(2468),
    [anon_sym_debugger] = ACTIONS(2468),
    [anon_sym_return] = ACTIONS(2468),
    [anon_sym_throw] = ACTIONS(2468),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_case] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2468),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_RBRACK] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_SLASH] = ACTIONS(2468),
    [anon_sym_class] = ACTIONS(2468),
    [anon_sym_async] = ACTIONS(2468),
    [anon_sym_function] = ACTIONS(2468),
    [anon_sym_EQ_GT] = ACTIONS(2466),
    [anon_sym_new] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2468),
    [anon_sym_DASH] = ACTIONS(2468),
    [anon_sym_BANG] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2466),
    [anon_sym_void] = ACTIONS(2468),
    [anon_sym_delete] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(2466),
    [anon_sym_DASH_DASH] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2466),
    [anon_sym_SQUOTE] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2466),
    [sym_number] = ACTIONS(2466),
    [sym_this] = ACTIONS(2468),
    [sym_super] = ACTIONS(2468),
    [sym_true] = ACTIONS(2468),
    [sym_false] = ACTIONS(2468),
    [sym_null] = ACTIONS(2468),
    [sym_undefined] = ACTIONS(2468),
    [anon_sym_AT] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(2468),
    [anon_sym_abstract] = ACTIONS(2468),
    [anon_sym_get] = ACTIONS(2468),
    [anon_sym_set] = ACTIONS(2468),
    [anon_sym_declare] = ACTIONS(2468),
    [anon_sym_public] = ACTIONS(2468),
    [anon_sym_private] = ACTIONS(2468),
    [anon_sym_protected] = ACTIONS(2468),
    [anon_sym_module] = ACTIONS(2468),
    [anon_sym_any] = ACTIONS(2468),
    [anon_sym_number] = ACTIONS(2468),
    [anon_sym_boolean] = ACTIONS(2468),
    [anon_sym_string] = ACTIONS(2468),
    [anon_sym_symbol] = ACTIONS(2468),
    [anon_sym_interface] = ACTIONS(2468),
    [anon_sym_enum] = ACTIONS(2468),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(589),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_export] = ACTIONS(2470),
    [anon_sym_default] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2470),
    [anon_sym_namespace] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(589),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_type] = ACTIONS(2470),
    [anon_sym_typeof] = ACTIONS(2470),
    [anon_sym_import] = ACTIONS(2470),
    [anon_sym_var] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_else] = ACTIONS(2470),
    [anon_sym_switch] = ACTIONS(2470),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(589),
    [anon_sym_await] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_with] = ACTIONS(2470),
    [anon_sym_break] = ACTIONS(2470),
    [anon_sym_continue] = ACTIONS(2470),
    [anon_sym_debugger] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_throw] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_case] = ACTIONS(2470),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_RBRACK] = ACTIONS(589),
    [anon_sym_LT] = ACTIONS(589),
    [anon_sym_GT] = ACTIONS(589),
    [anon_sym_SLASH] = ACTIONS(2470),
    [anon_sym_class] = ACTIONS(2470),
    [anon_sym_async] = ACTIONS(2470),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_EQ_GT] = ACTIONS(589),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(589),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [anon_sym_void] = ACTIONS(2470),
    [anon_sym_delete] = ACTIONS(2470),
    [anon_sym_PLUS_PLUS] = ACTIONS(589),
    [anon_sym_DASH_DASH] = ACTIONS(589),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [anon_sym_SQUOTE] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(589),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(2470),
    [sym_super] = ACTIONS(2470),
    [sym_true] = ACTIONS(2470),
    [sym_false] = ACTIONS(2470),
    [sym_null] = ACTIONS(2470),
    [sym_undefined] = ACTIONS(2470),
    [anon_sym_AT] = ACTIONS(589),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_abstract] = ACTIONS(2470),
    [anon_sym_get] = ACTIONS(2470),
    [anon_sym_set] = ACTIONS(2470),
    [anon_sym_declare] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2470),
    [anon_sym_private] = ACTIONS(2470),
    [anon_sym_protected] = ACTIONS(2470),
    [anon_sym_module] = ACTIONS(2470),
    [anon_sym_any] = ACTIONS(2470),
    [anon_sym_number] = ACTIONS(2470),
    [anon_sym_boolean] = ACTIONS(2470),
    [anon_sym_string] = ACTIONS(2470),
    [anon_sym_symbol] = ACTIONS(2470),
    [anon_sym_interface] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(2472),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_export] = ACTIONS(2474),
    [anon_sym_default] = ACTIONS(2474),
    [anon_sym_EQ] = ACTIONS(2474),
    [anon_sym_namespace] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_type] = ACTIONS(2474),
    [anon_sym_typeof] = ACTIONS(2474),
    [anon_sym_import] = ACTIONS(2474),
    [anon_sym_var] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_const] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_else] = ACTIONS(2474),
    [anon_sym_switch] = ACTIONS(2474),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_await] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_with] = ACTIONS(2474),
    [anon_sym_break] = ACTIONS(2474),
    [anon_sym_continue] = ACTIONS(2474),
    [anon_sym_debugger] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_throw] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_case] = ACTIONS(2474),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2474),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_async] = ACTIONS(2474),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_EQ_GT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(2472),
    [anon_sym_PIPE] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [anon_sym_void] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(2474),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [anon_sym_DQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2472),
    [sym_number] = ACTIONS(2472),
    [sym_this] = ACTIONS(2474),
    [sym_super] = ACTIONS(2474),
    [sym_true] = ACTIONS(2474),
    [sym_false] = ACTIONS(2474),
    [sym_null] = ACTIONS(2474),
    [sym_undefined] = ACTIONS(2474),
    [anon_sym_AT] = ACTIONS(2472),
    [anon_sym_static] = ACTIONS(2474),
    [anon_sym_abstract] = ACTIONS(2474),
    [anon_sym_get] = ACTIONS(2474),
    [anon_sym_set] = ACTIONS(2474),
    [anon_sym_declare] = ACTIONS(2474),
    [anon_sym_public] = ACTIONS(2474),
    [anon_sym_private] = ACTIONS(2474),
    [anon_sym_protected] = ACTIONS(2474),
    [anon_sym_module] = ACTIONS(2474),
    [anon_sym_any] = ACTIONS(2474),
    [anon_sym_number] = ACTIONS(2474),
    [anon_sym_boolean] = ACTIONS(2474),
    [anon_sym_string] = ACTIONS(2474),
    [anon_sym_symbol] = ACTIONS(2474),
    [anon_sym_interface] = ACTIONS(2474),
    [anon_sym_enum] = ACTIONS(2474),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(2476),
    [sym_identifier] = ACTIONS(2478),
    [anon_sym_export] = ACTIONS(2478),
    [anon_sym_default] = ACTIONS(2478),
    [anon_sym_EQ] = ACTIONS(2478),
    [anon_sym_namespace] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(2476),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_type] = ACTIONS(2478),
    [anon_sym_typeof] = ACTIONS(2478),
    [anon_sym_import] = ACTIONS(2478),
    [anon_sym_var] = ACTIONS(2478),
    [anon_sym_let] = ACTIONS(2478),
    [anon_sym_const] = ACTIONS(2478),
    [anon_sym_if] = ACTIONS(2478),
    [anon_sym_else] = ACTIONS(2478),
    [anon_sym_switch] = ACTIONS(2478),
    [anon_sym_for] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_RPAREN] = ACTIONS(2476),
    [anon_sym_await] = ACTIONS(2478),
    [anon_sym_while] = ACTIONS(2478),
    [anon_sym_do] = ACTIONS(2478),
    [anon_sym_try] = ACTIONS(2478),
    [anon_sym_with] = ACTIONS(2478),
    [anon_sym_break] = ACTIONS(2478),
    [anon_sym_continue] = ACTIONS(2478),
    [anon_sym_debugger] = ACTIONS(2478),
    [anon_sym_return] = ACTIONS(2478),
    [anon_sym_throw] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_case] = ACTIONS(2478),
    [anon_sym_yield] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_RBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_GT] = ACTIONS(2476),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_class] = ACTIONS(2478),
    [anon_sym_async] = ACTIONS(2478),
    [anon_sym_function] = ACTIONS(2478),
    [anon_sym_EQ_GT] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2476),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2476),
    [anon_sym_TILDE] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(2478),
    [anon_sym_delete] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [anon_sym_DQUOTE] = ACTIONS(2476),
    [anon_sym_SQUOTE] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2476),
    [sym_number] = ACTIONS(2476),
    [sym_this] = ACTIONS(2478),
    [sym_super] = ACTIONS(2478),
    [sym_true] = ACTIONS(2478),
    [sym_false] = ACTIONS(2478),
    [sym_null] = ACTIONS(2478),
    [sym_undefined] = ACTIONS(2478),
    [anon_sym_AT] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2478),
    [anon_sym_abstract] = ACTIONS(2478),
    [anon_sym_get] = ACTIONS(2478),
    [anon_sym_set] = ACTIONS(2478),
    [anon_sym_declare] = ACTIONS(2478),
    [anon_sym_public] = ACTIONS(2478),
    [anon_sym_private] = ACTIONS(2478),
    [anon_sym_protected] = ACTIONS(2478),
    [anon_sym_module] = ACTIONS(2478),
    [anon_sym_any] = ACTIONS(2478),
    [anon_sym_number] = ACTIONS(2478),
    [anon_sym_boolean] = ACTIONS(2478),
    [anon_sym_string] = ACTIONS(2478),
    [anon_sym_symbol] = ACTIONS(2478),
    [anon_sym_interface] = ACTIONS(2478),
    [anon_sym_enum] = ACTIONS(2478),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(2480),
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_else] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_RPAREN] = ACTIONS(2480),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2482),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_RBRACK] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(2480),
    [anon_sym_GT] = ACTIONS(2480),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_EQ_GT] = ACTIONS(2480),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2480),
    [anon_sym_TILDE] = ACTIONS(2480),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2480),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [anon_sym_SQUOTE] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2480),
    [sym_number] = ACTIONS(2480),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2480),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(2484),
    [sym_identifier] = ACTIONS(2486),
    [anon_sym_export] = ACTIONS(2486),
    [anon_sym_default] = ACTIONS(2486),
    [anon_sym_EQ] = ACTIONS(2486),
    [anon_sym_namespace] = ACTIONS(2486),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_COMMA] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_type] = ACTIONS(2486),
    [anon_sym_typeof] = ACTIONS(2486),
    [anon_sym_import] = ACTIONS(2486),
    [anon_sym_var] = ACTIONS(2486),
    [anon_sym_let] = ACTIONS(2486),
    [anon_sym_const] = ACTIONS(2486),
    [anon_sym_if] = ACTIONS(2486),
    [anon_sym_else] = ACTIONS(2486),
    [anon_sym_switch] = ACTIONS(2486),
    [anon_sym_for] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_RPAREN] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2486),
    [anon_sym_while] = ACTIONS(2486),
    [anon_sym_do] = ACTIONS(2486),
    [anon_sym_try] = ACTIONS(2486),
    [anon_sym_with] = ACTIONS(2486),
    [anon_sym_break] = ACTIONS(2486),
    [anon_sym_continue] = ACTIONS(2486),
    [anon_sym_debugger] = ACTIONS(2486),
    [anon_sym_return] = ACTIONS(2486),
    [anon_sym_throw] = ACTIONS(2486),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_case] = ACTIONS(2486),
    [anon_sym_yield] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_RBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_GT] = ACTIONS(2484),
    [anon_sym_SLASH] = ACTIONS(2486),
    [anon_sym_class] = ACTIONS(2486),
    [anon_sym_async] = ACTIONS(2486),
    [anon_sym_function] = ACTIONS(2486),
    [anon_sym_EQ_GT] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_PIPE] = ACTIONS(2484),
    [anon_sym_PLUS] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_void] = ACTIONS(2486),
    [anon_sym_delete] = ACTIONS(2486),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [sym_number] = ACTIONS(2484),
    [sym_this] = ACTIONS(2486),
    [sym_super] = ACTIONS(2486),
    [sym_true] = ACTIONS(2486),
    [sym_false] = ACTIONS(2486),
    [sym_null] = ACTIONS(2486),
    [sym_undefined] = ACTIONS(2486),
    [anon_sym_AT] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2486),
    [anon_sym_abstract] = ACTIONS(2486),
    [anon_sym_get] = ACTIONS(2486),
    [anon_sym_set] = ACTIONS(2486),
    [anon_sym_declare] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2486),
    [anon_sym_private] = ACTIONS(2486),
    [anon_sym_protected] = ACTIONS(2486),
    [anon_sym_module] = ACTIONS(2486),
    [anon_sym_any] = ACTIONS(2486),
    [anon_sym_number] = ACTIONS(2486),
    [anon_sym_boolean] = ACTIONS(2486),
    [anon_sym_string] = ACTIONS(2486),
    [anon_sym_symbol] = ACTIONS(2486),
    [anon_sym_interface] = ACTIONS(2486),
    [anon_sym_enum] = ACTIONS(2486),
  },
  [442] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym_readonly] = ACTIONS(2494),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [443] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym_readonly] = ACTIONS(2494),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [444] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym_readonly] = ACTIONS(2494),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [445] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [446] = {
    [sym_type_arguments] = STATE(413),
    [ts_builtin_sym_end] = ACTIONS(2496),
    [sym_identifier] = ACTIONS(2498),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_default] = ACTIONS(2498),
    [anon_sym_namespace] = ACTIONS(2498),
    [anon_sym_LBRACE] = ACTIONS(2496),
    [anon_sym_RBRACE] = ACTIONS(2496),
    [anon_sym_type] = ACTIONS(2498),
    [anon_sym_typeof] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2498),
    [anon_sym_var] = ACTIONS(2498),
    [anon_sym_let] = ACTIONS(2498),
    [anon_sym_const] = ACTIONS(2498),
    [anon_sym_if] = ACTIONS(2498),
    [anon_sym_else] = ACTIONS(2498),
    [anon_sym_switch] = ACTIONS(2498),
    [anon_sym_for] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_await] = ACTIONS(2498),
    [anon_sym_while] = ACTIONS(2498),
    [anon_sym_do] = ACTIONS(2498),
    [anon_sym_try] = ACTIONS(2498),
    [anon_sym_with] = ACTIONS(2498),
    [anon_sym_break] = ACTIONS(2498),
    [anon_sym_continue] = ACTIONS(2498),
    [anon_sym_debugger] = ACTIONS(2498),
    [anon_sym_return] = ACTIONS(2498),
    [anon_sym_throw] = ACTIONS(2498),
    [anon_sym_SEMI] = ACTIONS(2496),
    [anon_sym_case] = ACTIONS(2498),
    [anon_sym_yield] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_LT] = ACTIONS(2500),
    [anon_sym_SLASH] = ACTIONS(2498),
    [anon_sym_DOT] = ACTIONS(2386),
    [anon_sym_class] = ACTIONS(2498),
    [anon_sym_async] = ACTIONS(2498),
    [anon_sym_function] = ACTIONS(2498),
    [anon_sym_new] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_PIPE] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_void] = ACTIONS(2498),
    [anon_sym_delete] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2496),
    [anon_sym_DQUOTE] = ACTIONS(2496),
    [anon_sym_SQUOTE] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2496),
    [sym_number] = ACTIONS(2496),
    [sym_this] = ACTIONS(2498),
    [sym_super] = ACTIONS(2498),
    [sym_true] = ACTIONS(2498),
    [sym_false] = ACTIONS(2498),
    [sym_null] = ACTIONS(2498),
    [sym_undefined] = ACTIONS(2498),
    [anon_sym_AT] = ACTIONS(2496),
    [anon_sym_static] = ACTIONS(2498),
    [anon_sym_abstract] = ACTIONS(2498),
    [anon_sym_get] = ACTIONS(2498),
    [anon_sym_set] = ACTIONS(2498),
    [anon_sym_declare] = ACTIONS(2498),
    [anon_sym_public] = ACTIONS(2498),
    [anon_sym_private] = ACTIONS(2498),
    [anon_sym_protected] = ACTIONS(2498),
    [anon_sym_module] = ACTIONS(2498),
    [anon_sym_any] = ACTIONS(2498),
    [anon_sym_number] = ACTIONS(2498),
    [anon_sym_boolean] = ACTIONS(2498),
    [anon_sym_string] = ACTIONS(2498),
    [anon_sym_symbol] = ACTIONS(2498),
    [anon_sym_interface] = ACTIONS(2498),
    [anon_sym_enum] = ACTIONS(2498),
    [anon_sym_is] = ACTIONS(2503),
  },
  [447] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [448] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [449] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2743),
    [sym_rest_parameter] = STATE(2459),
    [sym_nested_type_identifier] = STATE(1794),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2459),
    [sym_optional_parameter] = STATE(2459),
    [sym__parameter_name] = STATE(1975),
    [sym__type] = STATE(2454),
    [sym_constructor_type] = STATE(2454),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2454),
    [sym_intersection_type] = STATE(2454),
    [sym_function_type] = STATE(2454),
    [aux_sym_export_statement_repeat1] = STATE(1666),
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(2509),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(2521),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(2525),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2521),
    [anon_sym_number] = ACTIONS(2521),
    [anon_sym_boolean] = ACTIONS(2521),
    [anon_sym_string] = ACTIONS(2521),
    [anon_sym_symbol] = ACTIONS(2521),
    [sym_readonly] = ACTIONS(811),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [450] = {
    [ts_builtin_sym_end] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_export] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_type] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym_import] = ACTIONS(1201),
    [anon_sym_var] = ACTIONS(1201),
    [anon_sym_let] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_try] = ACTIONS(1201),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_debugger] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_throw] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_catch] = ACTIONS(1201),
    [anon_sym_finally] = ACTIONS(1201),
    [anon_sym_yield] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(1201),
    [anon_sym_new] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_void] = ACTIONS(1201),
    [anon_sym_delete] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [sym_number] = ACTIONS(1199),
    [sym_this] = ACTIONS(1201),
    [sym_super] = ACTIONS(1201),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [sym_null] = ACTIONS(1201),
    [sym_undefined] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_abstract] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1201),
    [anon_sym_declare] = ACTIONS(1201),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1201),
    [anon_sym_any] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1201),
    [anon_sym_symbol] = ACTIONS(1201),
    [anon_sym_interface] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [sym__automatic_semicolon] = ACTIONS(2531),
  },
  [451] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2743),
    [sym_rest_parameter] = STATE(2459),
    [sym_nested_type_identifier] = STATE(1794),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2459),
    [sym_optional_parameter] = STATE(2459),
    [sym__parameter_name] = STATE(1975),
    [sym__type] = STATE(2372),
    [sym_constructor_type] = STATE(2372),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2372),
    [sym_intersection_type] = STATE(2372),
    [sym_function_type] = STATE(2372),
    [aux_sym_export_statement_repeat1] = STATE(1666),
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(2509),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(2521),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(2525),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2521),
    [anon_sym_number] = ACTIONS(2521),
    [anon_sym_boolean] = ACTIONS(2521),
    [anon_sym_string] = ACTIONS(2521),
    [anon_sym_symbol] = ACTIONS(2521),
    [sym_readonly] = ACTIONS(811),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [452] = {
    [sym_catch_clause] = STATE(468),
    [sym_finally_clause] = STATE(522),
    [ts_builtin_sym_end] = ACTIONS(2533),
    [sym_identifier] = ACTIONS(2535),
    [anon_sym_export] = ACTIONS(2535),
    [anon_sym_default] = ACTIONS(2535),
    [anon_sym_namespace] = ACTIONS(2535),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_RBRACE] = ACTIONS(2533),
    [anon_sym_type] = ACTIONS(2535),
    [anon_sym_typeof] = ACTIONS(2535),
    [anon_sym_import] = ACTIONS(2535),
    [anon_sym_var] = ACTIONS(2535),
    [anon_sym_let] = ACTIONS(2535),
    [anon_sym_const] = ACTIONS(2535),
    [anon_sym_if] = ACTIONS(2535),
    [anon_sym_else] = ACTIONS(2535),
    [anon_sym_switch] = ACTIONS(2535),
    [anon_sym_for] = ACTIONS(2535),
    [anon_sym_LPAREN] = ACTIONS(2533),
    [anon_sym_await] = ACTIONS(2535),
    [anon_sym_while] = ACTIONS(2535),
    [anon_sym_do] = ACTIONS(2535),
    [anon_sym_try] = ACTIONS(2535),
    [anon_sym_with] = ACTIONS(2535),
    [anon_sym_break] = ACTIONS(2535),
    [anon_sym_continue] = ACTIONS(2535),
    [anon_sym_debugger] = ACTIONS(2535),
    [anon_sym_return] = ACTIONS(2535),
    [anon_sym_throw] = ACTIONS(2535),
    [anon_sym_SEMI] = ACTIONS(2533),
    [anon_sym_case] = ACTIONS(2535),
    [anon_sym_catch] = ACTIONS(2537),
    [anon_sym_finally] = ACTIONS(2539),
    [anon_sym_yield] = ACTIONS(2535),
    [anon_sym_LBRACK] = ACTIONS(2533),
    [anon_sym_LT] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2535),
    [anon_sym_class] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(2535),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_new] = ACTIONS(2535),
    [anon_sym_PLUS] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2535),
    [anon_sym_BANG] = ACTIONS(2533),
    [anon_sym_TILDE] = ACTIONS(2533),
    [anon_sym_void] = ACTIONS(2535),
    [anon_sym_delete] = ACTIONS(2535),
    [anon_sym_PLUS_PLUS] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(2533),
    [anon_sym_DQUOTE] = ACTIONS(2533),
    [anon_sym_SQUOTE] = ACTIONS(2533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2533),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(2535),
    [sym_super] = ACTIONS(2535),
    [sym_true] = ACTIONS(2535),
    [sym_false] = ACTIONS(2535),
    [sym_null] = ACTIONS(2535),
    [sym_undefined] = ACTIONS(2535),
    [anon_sym_AT] = ACTIONS(2533),
    [anon_sym_static] = ACTIONS(2535),
    [anon_sym_abstract] = ACTIONS(2535),
    [anon_sym_get] = ACTIONS(2535),
    [anon_sym_set] = ACTIONS(2535),
    [anon_sym_declare] = ACTIONS(2535),
    [anon_sym_public] = ACTIONS(2535),
    [anon_sym_private] = ACTIONS(2535),
    [anon_sym_protected] = ACTIONS(2535),
    [anon_sym_module] = ACTIONS(2535),
    [anon_sym_any] = ACTIONS(2535),
    [anon_sym_number] = ACTIONS(2535),
    [anon_sym_boolean] = ACTIONS(2535),
    [anon_sym_string] = ACTIONS(2535),
    [anon_sym_symbol] = ACTIONS(2535),
    [anon_sym_interface] = ACTIONS(2535),
    [anon_sym_enum] = ACTIONS(2535),
  },
  [453] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2743),
    [sym_rest_parameter] = STATE(2459),
    [sym_nested_type_identifier] = STATE(1794),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2459),
    [sym_optional_parameter] = STATE(2459),
    [sym__parameter_name] = STATE(1975),
    [sym__type] = STATE(2506),
    [sym_constructor_type] = STATE(2506),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2506),
    [sym_intersection_type] = STATE(2506),
    [sym_function_type] = STATE(2506),
    [aux_sym_export_statement_repeat1] = STATE(1666),
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(2509),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(2521),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(2525),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2521),
    [anon_sym_number] = ACTIONS(2521),
    [anon_sym_boolean] = ACTIONS(2521),
    [anon_sym_string] = ACTIONS(2521),
    [anon_sym_symbol] = ACTIONS(2521),
    [sym_readonly] = ACTIONS(811),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [454] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2743),
    [sym_rest_parameter] = STATE(2459),
    [sym_nested_type_identifier] = STATE(1794),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2459),
    [sym_optional_parameter] = STATE(2459),
    [sym__parameter_name] = STATE(1975),
    [sym__type] = STATE(2460),
    [sym_constructor_type] = STATE(2460),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2460),
    [sym_intersection_type] = STATE(2460),
    [sym_function_type] = STATE(2460),
    [aux_sym_export_statement_repeat1] = STATE(1666),
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(2509),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(2521),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(2525),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2521),
    [anon_sym_number] = ACTIONS(2521),
    [anon_sym_boolean] = ACTIONS(2521),
    [anon_sym_string] = ACTIONS(2521),
    [anon_sym_symbol] = ACTIONS(2521),
    [sym_readonly] = ACTIONS(811),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [455] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(2743),
    [sym_rest_parameter] = STATE(2459),
    [sym_nested_type_identifier] = STATE(1794),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2459),
    [sym_optional_parameter] = STATE(2459),
    [sym__parameter_name] = STATE(1975),
    [sym__type] = STATE(2437),
    [sym_constructor_type] = STATE(2437),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2437),
    [sym_intersection_type] = STATE(2437),
    [sym_function_type] = STATE(2437),
    [aux_sym_export_statement_repeat1] = STATE(1666),
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(2509),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(2521),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(2525),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2521),
    [anon_sym_number] = ACTIONS(2521),
    [anon_sym_boolean] = ACTIONS(2521),
    [anon_sym_string] = ACTIONS(2521),
    [anon_sym_symbol] = ACTIONS(2521),
    [sym_readonly] = ACTIONS(811),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [456] = {
    [ts_builtin_sym_end] = ACTIONS(1061),
    [sym_identifier] = ACTIONS(1063),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_default] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_import] = ACTIONS(1063),
    [anon_sym_var] = ACTIONS(1063),
    [anon_sym_let] = ACTIONS(1063),
    [anon_sym_const] = ACTIONS(1063),
    [anon_sym_if] = ACTIONS(1063),
    [anon_sym_else] = ACTIONS(1063),
    [anon_sym_switch] = ACTIONS(1063),
    [anon_sym_for] = ACTIONS(1063),
    [anon_sym_LPAREN] = ACTIONS(1061),
    [anon_sym_await] = ACTIONS(1063),
    [anon_sym_while] = ACTIONS(1063),
    [anon_sym_do] = ACTIONS(1063),
    [anon_sym_try] = ACTIONS(1063),
    [anon_sym_with] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1063),
    [anon_sym_continue] = ACTIONS(1063),
    [anon_sym_debugger] = ACTIONS(1063),
    [anon_sym_return] = ACTIONS(1063),
    [anon_sym_throw] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_case] = ACTIONS(1063),
    [anon_sym_catch] = ACTIONS(1063),
    [anon_sym_finally] = ACTIONS(1063),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_SLASH] = ACTIONS(1063),
    [anon_sym_class] = ACTIONS(1063),
    [anon_sym_async] = ACTIONS(1063),
    [anon_sym_function] = ACTIONS(1063),
    [anon_sym_new] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [anon_sym_void] = ACTIONS(1063),
    [anon_sym_delete] = ACTIONS(1063),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [anon_sym_SQUOTE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [sym_number] = ACTIONS(1061),
    [sym_this] = ACTIONS(1063),
    [sym_super] = ACTIONS(1063),
    [sym_true] = ACTIONS(1063),
    [sym_false] = ACTIONS(1063),
    [sym_null] = ACTIONS(1063),
    [sym_undefined] = ACTIONS(1063),
    [anon_sym_AT] = ACTIONS(1061),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_abstract] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
    [anon_sym_interface] = ACTIONS(1063),
    [anon_sym_enum] = ACTIONS(1063),
    [sym__automatic_semicolon] = ACTIONS(1069),
  },
  [457] = {
    [ts_builtin_sym_end] = ACTIONS(1115),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_export] = ACTIONS(1117),
    [anon_sym_default] = ACTIONS(1117),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1115),
    [anon_sym_type] = ACTIONS(1117),
    [anon_sym_typeof] = ACTIONS(1117),
    [anon_sym_import] = ACTIONS(1117),
    [anon_sym_var] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_const] = ACTIONS(1117),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_else] = ACTIONS(1117),
    [anon_sym_switch] = ACTIONS(1117),
    [anon_sym_for] = ACTIONS(1117),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_await] = ACTIONS(1117),
    [anon_sym_while] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1117),
    [anon_sym_with] = ACTIONS(1117),
    [anon_sym_break] = ACTIONS(1117),
    [anon_sym_continue] = ACTIONS(1117),
    [anon_sym_debugger] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1117),
    [anon_sym_throw] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1115),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_catch] = ACTIONS(1117),
    [anon_sym_finally] = ACTIONS(1117),
    [anon_sym_yield] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1115),
    [anon_sym_SLASH] = ACTIONS(1117),
    [anon_sym_class] = ACTIONS(1117),
    [anon_sym_async] = ACTIONS(1117),
    [anon_sym_function] = ACTIONS(1117),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_void] = ACTIONS(1117),
    [anon_sym_delete] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [sym_number] = ACTIONS(1115),
    [sym_this] = ACTIONS(1117),
    [sym_super] = ACTIONS(1117),
    [sym_true] = ACTIONS(1117),
    [sym_false] = ACTIONS(1117),
    [sym_null] = ACTIONS(1117),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(1115),
    [anon_sym_static] = ACTIONS(1117),
    [anon_sym_abstract] = ACTIONS(1117),
    [anon_sym_get] = ACTIONS(1117),
    [anon_sym_set] = ACTIONS(1117),
    [anon_sym_declare] = ACTIONS(1117),
    [anon_sym_public] = ACTIONS(1117),
    [anon_sym_private] = ACTIONS(1117),
    [anon_sym_protected] = ACTIONS(1117),
    [anon_sym_module] = ACTIONS(1117),
    [anon_sym_any] = ACTIONS(1117),
    [anon_sym_number] = ACTIONS(1117),
    [anon_sym_boolean] = ACTIONS(1117),
    [anon_sym_string] = ACTIONS(1117),
    [anon_sym_symbol] = ACTIONS(1117),
    [anon_sym_interface] = ACTIONS(1117),
    [anon_sym_enum] = ACTIONS(1117),
  },
  [458] = {
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(2541),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2541),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2543),
    [anon_sym_SQUOTE] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2543),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [459] = {
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(2541),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2541),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2543),
    [anon_sym_SQUOTE] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2543),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [460] = {
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(2541),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2541),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2543),
    [anon_sym_SQUOTE] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2543),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [461] = {
    [ts_builtin_sym_end] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_export] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_type] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym_import] = ACTIONS(1201),
    [anon_sym_var] = ACTIONS(1201),
    [anon_sym_let] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_try] = ACTIONS(1201),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_debugger] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_throw] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_catch] = ACTIONS(1201),
    [anon_sym_finally] = ACTIONS(1201),
    [anon_sym_yield] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(1201),
    [anon_sym_new] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_void] = ACTIONS(1201),
    [anon_sym_delete] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [sym_number] = ACTIONS(1199),
    [sym_this] = ACTIONS(1201),
    [sym_super] = ACTIONS(1201),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [sym_null] = ACTIONS(1201),
    [sym_undefined] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_abstract] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1201),
    [anon_sym_declare] = ACTIONS(1201),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1201),
    [anon_sym_any] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1201),
    [anon_sym_symbol] = ACTIONS(1201),
    [anon_sym_interface] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
  },
  [462] = {
    [sym__call_signature] = STATE(2936),
    [sym_arguments] = STATE(1032),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2545),
    [anon_sym_export] = ACTIONS(2547),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(2547),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(2547),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_RPAREN] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_COLON] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_async] = ACTIONS(2547),
    [anon_sym_function] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_void] = ACTIONS(2547),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_static] = ACTIONS(2547),
    [anon_sym_get] = ACTIONS(2547),
    [anon_sym_set] = ACTIONS(2547),
    [anon_sym_declare] = ACTIONS(2547),
    [anon_sym_public] = ACTIONS(2547),
    [anon_sym_private] = ACTIONS(2547),
    [anon_sym_protected] = ACTIONS(2547),
    [anon_sym_module] = ACTIONS(2547),
    [anon_sym_any] = ACTIONS(2547),
    [anon_sym_number] = ACTIONS(2547),
    [anon_sym_boolean] = ACTIONS(2547),
    [anon_sym_string] = ACTIONS(2547),
    [anon_sym_symbol] = ACTIONS(2547),
  },
  [463] = {
    [sym_type_arguments] = STATE(417),
    [ts_builtin_sym_end] = ACTIONS(2553),
    [sym_identifier] = ACTIONS(2555),
    [anon_sym_export] = ACTIONS(2555),
    [anon_sym_default] = ACTIONS(2555),
    [anon_sym_namespace] = ACTIONS(2555),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_RBRACE] = ACTIONS(2553),
    [anon_sym_type] = ACTIONS(2555),
    [anon_sym_typeof] = ACTIONS(2555),
    [anon_sym_import] = ACTIONS(2555),
    [anon_sym_var] = ACTIONS(2555),
    [anon_sym_let] = ACTIONS(2555),
    [anon_sym_const] = ACTIONS(2555),
    [anon_sym_if] = ACTIONS(2555),
    [anon_sym_else] = ACTIONS(2555),
    [anon_sym_switch] = ACTIONS(2555),
    [anon_sym_for] = ACTIONS(2555),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_await] = ACTIONS(2555),
    [anon_sym_while] = ACTIONS(2555),
    [anon_sym_do] = ACTIONS(2555),
    [anon_sym_try] = ACTIONS(2555),
    [anon_sym_with] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2555),
    [anon_sym_continue] = ACTIONS(2555),
    [anon_sym_debugger] = ACTIONS(2555),
    [anon_sym_return] = ACTIONS(2555),
    [anon_sym_throw] = ACTIONS(2555),
    [anon_sym_SEMI] = ACTIONS(2553),
    [anon_sym_case] = ACTIONS(2555),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LT] = ACTIONS(2557),
    [anon_sym_SLASH] = ACTIONS(2555),
    [anon_sym_class] = ACTIONS(2555),
    [anon_sym_async] = ACTIONS(2555),
    [anon_sym_function] = ACTIONS(2555),
    [anon_sym_new] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2555),
    [anon_sym_BANG] = ACTIONS(2553),
    [anon_sym_TILDE] = ACTIONS(2553),
    [anon_sym_void] = ACTIONS(2555),
    [anon_sym_delete] = ACTIONS(2555),
    [anon_sym_PLUS_PLUS] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(2553),
    [anon_sym_SQUOTE] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2553),
    [sym_number] = ACTIONS(2553),
    [sym_this] = ACTIONS(2555),
    [sym_super] = ACTIONS(2555),
    [sym_true] = ACTIONS(2555),
    [sym_false] = ACTIONS(2555),
    [sym_null] = ACTIONS(2555),
    [sym_undefined] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2553),
    [anon_sym_static] = ACTIONS(2555),
    [anon_sym_abstract] = ACTIONS(2555),
    [anon_sym_get] = ACTIONS(2555),
    [anon_sym_set] = ACTIONS(2555),
    [anon_sym_declare] = ACTIONS(2555),
    [anon_sym_public] = ACTIONS(2555),
    [anon_sym_private] = ACTIONS(2555),
    [anon_sym_protected] = ACTIONS(2555),
    [anon_sym_module] = ACTIONS(2555),
    [anon_sym_any] = ACTIONS(2555),
    [anon_sym_number] = ACTIONS(2555),
    [anon_sym_boolean] = ACTIONS(2555),
    [anon_sym_string] = ACTIONS(2555),
    [anon_sym_symbol] = ACTIONS(2555),
    [anon_sym_interface] = ACTIONS(2555),
    [anon_sym_enum] = ACTIONS(2555),
  },
  [464] = {
    [sym_statement_block] = STATE(510),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [anon_sym_export] = ACTIONS(1073),
    [anon_sym_default] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(1073),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_type] = ACTIONS(1073),
    [anon_sym_typeof] = ACTIONS(1073),
    [anon_sym_import] = ACTIONS(1073),
    [anon_sym_var] = ACTIONS(1073),
    [anon_sym_let] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1073),
    [anon_sym_if] = ACTIONS(1073),
    [anon_sym_else] = ACTIONS(1073),
    [anon_sym_switch] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1073),
    [anon_sym_do] = ACTIONS(1073),
    [anon_sym_try] = ACTIONS(1073),
    [anon_sym_with] = ACTIONS(1073),
    [anon_sym_break] = ACTIONS(1073),
    [anon_sym_continue] = ACTIONS(1073),
    [anon_sym_debugger] = ACTIONS(1073),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_throw] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(2348),
    [anon_sym_class] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1073),
    [anon_sym_function] = ACTIONS(1073),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1073),
    [anon_sym_delete] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [sym_number] = ACTIONS(1071),
    [sym_this] = ACTIONS(1073),
    [sym_super] = ACTIONS(1073),
    [sym_true] = ACTIONS(1073),
    [sym_false] = ACTIONS(1073),
    [sym_null] = ACTIONS(1073),
    [sym_undefined] = ACTIONS(1073),
    [anon_sym_AT] = ACTIONS(1071),
    [anon_sym_static] = ACTIONS(1073),
    [anon_sym_abstract] = ACTIONS(1073),
    [anon_sym_get] = ACTIONS(1073),
    [anon_sym_set] = ACTIONS(1073),
    [anon_sym_declare] = ACTIONS(1073),
    [anon_sym_public] = ACTIONS(1073),
    [anon_sym_private] = ACTIONS(1073),
    [anon_sym_protected] = ACTIONS(1073),
    [anon_sym_module] = ACTIONS(1073),
    [anon_sym_any] = ACTIONS(1073),
    [anon_sym_number] = ACTIONS(1073),
    [anon_sym_boolean] = ACTIONS(1073),
    [anon_sym_string] = ACTIONS(1073),
    [anon_sym_symbol] = ACTIONS(1073),
    [anon_sym_interface] = ACTIONS(1073),
    [anon_sym_enum] = ACTIONS(1073),
  },
  [465] = {
    [sym__call_signature] = STATE(2936),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2545),
    [anon_sym_export] = ACTIONS(2547),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2547),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2547),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_async] = ACTIONS(2547),
    [anon_sym_function] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2547),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2547),
    [anon_sym_get] = ACTIONS(2547),
    [anon_sym_set] = ACTIONS(2547),
    [anon_sym_declare] = ACTIONS(2547),
    [anon_sym_public] = ACTIONS(2547),
    [anon_sym_private] = ACTIONS(2547),
    [anon_sym_protected] = ACTIONS(2547),
    [anon_sym_module] = ACTIONS(2547),
    [anon_sym_any] = ACTIONS(2547),
    [anon_sym_number] = ACTIONS(2547),
    [anon_sym_boolean] = ACTIONS(2547),
    [anon_sym_string] = ACTIONS(2547),
    [anon_sym_symbol] = ACTIONS(2547),
  },
  [466] = {
    [sym__call_signature] = STATE(2751),
    [sym_arguments] = STATE(1428),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2568),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_async] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2572),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_static] = ACTIONS(2570),
    [anon_sym_get] = ACTIONS(2570),
    [anon_sym_set] = ACTIONS(2570),
    [anon_sym_declare] = ACTIONS(2570),
    [anon_sym_public] = ACTIONS(2570),
    [anon_sym_private] = ACTIONS(2570),
    [anon_sym_protected] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [sym__automatic_semicolon] = ACTIONS(501),
  },
  [467] = {
    [ts_builtin_sym_end] = ACTIONS(2574),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_default] = ACTIONS(2576),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_LBRACE] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2574),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_typeof] = ACTIONS(2576),
    [anon_sym_import] = ACTIONS(2576),
    [anon_sym_var] = ACTIONS(2576),
    [anon_sym_let] = ACTIONS(2576),
    [anon_sym_const] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(2576),
    [anon_sym_else] = ACTIONS(2576),
    [anon_sym_switch] = ACTIONS(2576),
    [anon_sym_for] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(2574),
    [anon_sym_await] = ACTIONS(2576),
    [anon_sym_while] = ACTIONS(2576),
    [anon_sym_do] = ACTIONS(2576),
    [anon_sym_try] = ACTIONS(2576),
    [anon_sym_with] = ACTIONS(2576),
    [anon_sym_break] = ACTIONS(2576),
    [anon_sym_continue] = ACTIONS(2576),
    [anon_sym_debugger] = ACTIONS(2576),
    [anon_sym_return] = ACTIONS(2576),
    [anon_sym_throw] = ACTIONS(2576),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym_case] = ACTIONS(2576),
    [anon_sym_yield] = ACTIONS(2576),
    [anon_sym_LBRACK] = ACTIONS(2574),
    [anon_sym_LT] = ACTIONS(2574),
    [anon_sym_SLASH] = ACTIONS(2576),
    [anon_sym_class] = ACTIONS(2576),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_function] = ACTIONS(2576),
    [anon_sym_new] = ACTIONS(2576),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2576),
    [anon_sym_DASH] = ACTIONS(2576),
    [anon_sym_BANG] = ACTIONS(2574),
    [anon_sym_TILDE] = ACTIONS(2574),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_delete] = ACTIONS(2576),
    [anon_sym_PLUS_PLUS] = ACTIONS(2574),
    [anon_sym_DASH_DASH] = ACTIONS(2574),
    [anon_sym_DQUOTE] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2574),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2574),
    [sym_number] = ACTIONS(2574),
    [sym_this] = ACTIONS(2576),
    [sym_super] = ACTIONS(2576),
    [sym_true] = ACTIONS(2576),
    [sym_false] = ACTIONS(2576),
    [sym_null] = ACTIONS(2576),
    [sym_undefined] = ACTIONS(2576),
    [anon_sym_AT] = ACTIONS(2574),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_abstract] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [anon_sym_interface] = ACTIONS(2576),
    [anon_sym_enum] = ACTIONS(2576),
  },
  [468] = {
    [sym_finally_clause] = STATE(528),
    [ts_builtin_sym_end] = ACTIONS(2582),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_export] = ACTIONS(2584),
    [anon_sym_default] = ACTIONS(2584),
    [anon_sym_namespace] = ACTIONS(2584),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_RBRACE] = ACTIONS(2582),
    [anon_sym_type] = ACTIONS(2584),
    [anon_sym_typeof] = ACTIONS(2584),
    [anon_sym_import] = ACTIONS(2584),
    [anon_sym_var] = ACTIONS(2584),
    [anon_sym_let] = ACTIONS(2584),
    [anon_sym_const] = ACTIONS(2584),
    [anon_sym_if] = ACTIONS(2584),
    [anon_sym_else] = ACTIONS(2584),
    [anon_sym_switch] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2584),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_await] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2584),
    [anon_sym_do] = ACTIONS(2584),
    [anon_sym_try] = ACTIONS(2584),
    [anon_sym_with] = ACTIONS(2584),
    [anon_sym_break] = ACTIONS(2584),
    [anon_sym_continue] = ACTIONS(2584),
    [anon_sym_debugger] = ACTIONS(2584),
    [anon_sym_return] = ACTIONS(2584),
    [anon_sym_throw] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2584),
    [anon_sym_finally] = ACTIONS(2539),
    [anon_sym_yield] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_class] = ACTIONS(2584),
    [anon_sym_async] = ACTIONS(2584),
    [anon_sym_function] = ACTIONS(2584),
    [anon_sym_new] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_DASH] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2582),
    [anon_sym_void] = ACTIONS(2584),
    [anon_sym_delete] = ACTIONS(2584),
    [anon_sym_PLUS_PLUS] = ACTIONS(2582),
    [anon_sym_DASH_DASH] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [sym_number] = ACTIONS(2582),
    [sym_this] = ACTIONS(2584),
    [sym_super] = ACTIONS(2584),
    [sym_true] = ACTIONS(2584),
    [sym_false] = ACTIONS(2584),
    [sym_null] = ACTIONS(2584),
    [sym_undefined] = ACTIONS(2584),
    [anon_sym_AT] = ACTIONS(2582),
    [anon_sym_static] = ACTIONS(2584),
    [anon_sym_abstract] = ACTIONS(2584),
    [anon_sym_get] = ACTIONS(2584),
    [anon_sym_set] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2584),
    [anon_sym_public] = ACTIONS(2584),
    [anon_sym_private] = ACTIONS(2584),
    [anon_sym_protected] = ACTIONS(2584),
    [anon_sym_module] = ACTIONS(2584),
    [anon_sym_any] = ACTIONS(2584),
    [anon_sym_number] = ACTIONS(2584),
    [anon_sym_boolean] = ACTIONS(2584),
    [anon_sym_string] = ACTIONS(2584),
    [anon_sym_symbol] = ACTIONS(2584),
    [anon_sym_interface] = ACTIONS(2584),
    [anon_sym_enum] = ACTIONS(2584),
  },
  [469] = {
    [ts_builtin_sym_end] = ACTIONS(2586),
    [sym_identifier] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_default] = ACTIONS(2588),
    [anon_sym_namespace] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2586),
    [anon_sym_RBRACE] = ACTIONS(2586),
    [anon_sym_type] = ACTIONS(2588),
    [anon_sym_typeof] = ACTIONS(2588),
    [anon_sym_import] = ACTIONS(2588),
    [anon_sym_var] = ACTIONS(2588),
    [anon_sym_let] = ACTIONS(2588),
    [anon_sym_const] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_else] = ACTIONS(2588),
    [anon_sym_switch] = ACTIONS(2588),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_await] = ACTIONS(2588),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_do] = ACTIONS(2588),
    [anon_sym_try] = ACTIONS(2588),
    [anon_sym_with] = ACTIONS(2588),
    [anon_sym_break] = ACTIONS(2588),
    [anon_sym_continue] = ACTIONS(2588),
    [anon_sym_debugger] = ACTIONS(2588),
    [anon_sym_return] = ACTIONS(2588),
    [anon_sym_throw] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_yield] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_SLASH] = ACTIONS(2588),
    [anon_sym_class] = ACTIONS(2588),
    [anon_sym_async] = ACTIONS(2588),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_new] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_TILDE] = ACTIONS(2586),
    [anon_sym_void] = ACTIONS(2588),
    [anon_sym_delete] = ACTIONS(2588),
    [anon_sym_PLUS_PLUS] = ACTIONS(2586),
    [anon_sym_DASH_DASH] = ACTIONS(2586),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [anon_sym_SQUOTE] = ACTIONS(2586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [sym_number] = ACTIONS(2586),
    [sym_this] = ACTIONS(2588),
    [sym_super] = ACTIONS(2588),
    [sym_true] = ACTIONS(2588),
    [sym_false] = ACTIONS(2588),
    [sym_null] = ACTIONS(2588),
    [sym_undefined] = ACTIONS(2588),
    [anon_sym_AT] = ACTIONS(2586),
    [anon_sym_static] = ACTIONS(2588),
    [anon_sym_abstract] = ACTIONS(2588),
    [anon_sym_get] = ACTIONS(2588),
    [anon_sym_set] = ACTIONS(2588),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_public] = ACTIONS(2588),
    [anon_sym_private] = ACTIONS(2588),
    [anon_sym_protected] = ACTIONS(2588),
    [anon_sym_module] = ACTIONS(2588),
    [anon_sym_any] = ACTIONS(2588),
    [anon_sym_number] = ACTIONS(2588),
    [anon_sym_boolean] = ACTIONS(2588),
    [anon_sym_string] = ACTIONS(2588),
    [anon_sym_symbol] = ACTIONS(2588),
    [anon_sym_interface] = ACTIONS(2588),
    [anon_sym_enum] = ACTIONS(2588),
  },
  [470] = {
    [ts_builtin_sym_end] = ACTIONS(2590),
    [sym_identifier] = ACTIONS(2592),
    [anon_sym_export] = ACTIONS(2592),
    [anon_sym_default] = ACTIONS(2592),
    [anon_sym_namespace] = ACTIONS(2592),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_type] = ACTIONS(2592),
    [anon_sym_typeof] = ACTIONS(2592),
    [anon_sym_import] = ACTIONS(2592),
    [anon_sym_var] = ACTIONS(2592),
    [anon_sym_let] = ACTIONS(2592),
    [anon_sym_const] = ACTIONS(2592),
    [anon_sym_if] = ACTIONS(2592),
    [anon_sym_else] = ACTIONS(2592),
    [anon_sym_switch] = ACTIONS(2592),
    [anon_sym_for] = ACTIONS(2592),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_await] = ACTIONS(2592),
    [anon_sym_while] = ACTIONS(2592),
    [anon_sym_do] = ACTIONS(2592),
    [anon_sym_try] = ACTIONS(2592),
    [anon_sym_with] = ACTIONS(2592),
    [anon_sym_break] = ACTIONS(2592),
    [anon_sym_continue] = ACTIONS(2592),
    [anon_sym_debugger] = ACTIONS(2592),
    [anon_sym_return] = ACTIONS(2592),
    [anon_sym_throw] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2592),
    [anon_sym_yield] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_SLASH] = ACTIONS(2592),
    [anon_sym_class] = ACTIONS(2592),
    [anon_sym_async] = ACTIONS(2592),
    [anon_sym_function] = ACTIONS(2592),
    [anon_sym_new] = ACTIONS(2592),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_TILDE] = ACTIONS(2590),
    [anon_sym_void] = ACTIONS(2592),
    [anon_sym_delete] = ACTIONS(2592),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [anon_sym_DQUOTE] = ACTIONS(2590),
    [anon_sym_SQUOTE] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2590),
    [sym_number] = ACTIONS(2590),
    [sym_this] = ACTIONS(2592),
    [sym_super] = ACTIONS(2592),
    [sym_true] = ACTIONS(2592),
    [sym_false] = ACTIONS(2592),
    [sym_null] = ACTIONS(2592),
    [sym_undefined] = ACTIONS(2592),
    [anon_sym_AT] = ACTIONS(2590),
    [anon_sym_static] = ACTIONS(2592),
    [anon_sym_abstract] = ACTIONS(2592),
    [anon_sym_get] = ACTIONS(2592),
    [anon_sym_set] = ACTIONS(2592),
    [anon_sym_declare] = ACTIONS(2592),
    [anon_sym_public] = ACTIONS(2592),
    [anon_sym_private] = ACTIONS(2592),
    [anon_sym_protected] = ACTIONS(2592),
    [anon_sym_module] = ACTIONS(2592),
    [anon_sym_any] = ACTIONS(2592),
    [anon_sym_number] = ACTIONS(2592),
    [anon_sym_boolean] = ACTIONS(2592),
    [anon_sym_string] = ACTIONS(2592),
    [anon_sym_symbol] = ACTIONS(2592),
    [anon_sym_interface] = ACTIONS(2592),
    [anon_sym_enum] = ACTIONS(2592),
  },
  [471] = {
    [ts_builtin_sym_end] = ACTIONS(2594),
    [sym_identifier] = ACTIONS(2596),
    [anon_sym_export] = ACTIONS(2596),
    [anon_sym_default] = ACTIONS(2596),
    [anon_sym_namespace] = ACTIONS(2596),
    [anon_sym_LBRACE] = ACTIONS(2594),
    [anon_sym_RBRACE] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2596),
    [anon_sym_typeof] = ACTIONS(2596),
    [anon_sym_import] = ACTIONS(2596),
    [anon_sym_var] = ACTIONS(2596),
    [anon_sym_let] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_else] = ACTIONS(2596),
    [anon_sym_switch] = ACTIONS(2596),
    [anon_sym_for] = ACTIONS(2596),
    [anon_sym_LPAREN] = ACTIONS(2594),
    [anon_sym_await] = ACTIONS(2596),
    [anon_sym_while] = ACTIONS(2596),
    [anon_sym_do] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2596),
    [anon_sym_with] = ACTIONS(2596),
    [anon_sym_break] = ACTIONS(2596),
    [anon_sym_continue] = ACTIONS(2596),
    [anon_sym_debugger] = ACTIONS(2596),
    [anon_sym_return] = ACTIONS(2596),
    [anon_sym_throw] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym_case] = ACTIONS(2596),
    [anon_sym_yield] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_LT] = ACTIONS(2594),
    [anon_sym_SLASH] = ACTIONS(2596),
    [anon_sym_class] = ACTIONS(2596),
    [anon_sym_async] = ACTIONS(2596),
    [anon_sym_function] = ACTIONS(2596),
    [anon_sym_new] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_DASH] = ACTIONS(2596),
    [anon_sym_BANG] = ACTIONS(2594),
    [anon_sym_TILDE] = ACTIONS(2594),
    [anon_sym_void] = ACTIONS(2596),
    [anon_sym_delete] = ACTIONS(2596),
    [anon_sym_PLUS_PLUS] = ACTIONS(2594),
    [anon_sym_DASH_DASH] = ACTIONS(2594),
    [anon_sym_DQUOTE] = ACTIONS(2594),
    [anon_sym_SQUOTE] = ACTIONS(2594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2594),
    [sym_number] = ACTIONS(2594),
    [sym_this] = ACTIONS(2596),
    [sym_super] = ACTIONS(2596),
    [sym_true] = ACTIONS(2596),
    [sym_false] = ACTIONS(2596),
    [sym_null] = ACTIONS(2596),
    [sym_undefined] = ACTIONS(2596),
    [anon_sym_AT] = ACTIONS(2594),
    [anon_sym_static] = ACTIONS(2596),
    [anon_sym_abstract] = ACTIONS(2596),
    [anon_sym_get] = ACTIONS(2596),
    [anon_sym_set] = ACTIONS(2596),
    [anon_sym_declare] = ACTIONS(2596),
    [anon_sym_public] = ACTIONS(2596),
    [anon_sym_private] = ACTIONS(2596),
    [anon_sym_protected] = ACTIONS(2596),
    [anon_sym_module] = ACTIONS(2596),
    [anon_sym_any] = ACTIONS(2596),
    [anon_sym_number] = ACTIONS(2596),
    [anon_sym_boolean] = ACTIONS(2596),
    [anon_sym_string] = ACTIONS(2596),
    [anon_sym_symbol] = ACTIONS(2596),
    [anon_sym_interface] = ACTIONS(2596),
    [anon_sym_enum] = ACTIONS(2596),
  },
  [472] = {
    [ts_builtin_sym_end] = ACTIONS(2598),
    [sym_identifier] = ACTIONS(2600),
    [anon_sym_export] = ACTIONS(2600),
    [anon_sym_default] = ACTIONS(2600),
    [anon_sym_namespace] = ACTIONS(2600),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_type] = ACTIONS(2600),
    [anon_sym_typeof] = ACTIONS(2600),
    [anon_sym_import] = ACTIONS(2600),
    [anon_sym_var] = ACTIONS(2600),
    [anon_sym_let] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_else] = ACTIONS(2600),
    [anon_sym_switch] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_await] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [anon_sym_do] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [anon_sym_with] = ACTIONS(2600),
    [anon_sym_break] = ACTIONS(2600),
    [anon_sym_continue] = ACTIONS(2600),
    [anon_sym_debugger] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_throw] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_case] = ACTIONS(2600),
    [anon_sym_yield] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_SLASH] = ACTIONS(2600),
    [anon_sym_class] = ACTIONS(2600),
    [anon_sym_async] = ACTIONS(2600),
    [anon_sym_function] = ACTIONS(2600),
    [anon_sym_new] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_BANG] = ACTIONS(2598),
    [anon_sym_TILDE] = ACTIONS(2598),
    [anon_sym_void] = ACTIONS(2600),
    [anon_sym_delete] = ACTIONS(2600),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [anon_sym_DQUOTE] = ACTIONS(2598),
    [anon_sym_SQUOTE] = ACTIONS(2598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2598),
    [sym_number] = ACTIONS(2598),
    [sym_this] = ACTIONS(2600),
    [sym_super] = ACTIONS(2600),
    [sym_true] = ACTIONS(2600),
    [sym_false] = ACTIONS(2600),
    [sym_null] = ACTIONS(2600),
    [sym_undefined] = ACTIONS(2600),
    [anon_sym_AT] = ACTIONS(2598),
    [anon_sym_static] = ACTIONS(2600),
    [anon_sym_abstract] = ACTIONS(2600),
    [anon_sym_get] = ACTIONS(2600),
    [anon_sym_set] = ACTIONS(2600),
    [anon_sym_declare] = ACTIONS(2600),
    [anon_sym_public] = ACTIONS(2600),
    [anon_sym_private] = ACTIONS(2600),
    [anon_sym_protected] = ACTIONS(2600),
    [anon_sym_module] = ACTIONS(2600),
    [anon_sym_any] = ACTIONS(2600),
    [anon_sym_number] = ACTIONS(2600),
    [anon_sym_boolean] = ACTIONS(2600),
    [anon_sym_string] = ACTIONS(2600),
    [anon_sym_symbol] = ACTIONS(2600),
    [anon_sym_interface] = ACTIONS(2600),
    [anon_sym_enum] = ACTIONS(2600),
  },
  [473] = {
    [ts_builtin_sym_end] = ACTIONS(2602),
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2602),
    [anon_sym_TILDE] = ACTIONS(2602),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_SQUOTE] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [sym_number] = ACTIONS(2602),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2602),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
  },
  [474] = {
    [ts_builtin_sym_end] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_export] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_type] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym_import] = ACTIONS(1201),
    [anon_sym_var] = ACTIONS(1201),
    [anon_sym_let] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_try] = ACTIONS(1201),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_debugger] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_throw] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_yield] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(1201),
    [anon_sym_new] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_void] = ACTIONS(1201),
    [anon_sym_delete] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [sym_number] = ACTIONS(1199),
    [sym_this] = ACTIONS(1201),
    [sym_super] = ACTIONS(1201),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [sym_null] = ACTIONS(1201),
    [sym_undefined] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_abstract] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1201),
    [anon_sym_declare] = ACTIONS(1201),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1201),
    [anon_sym_any] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1201),
    [anon_sym_symbol] = ACTIONS(1201),
    [anon_sym_interface] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [sym__automatic_semicolon] = ACTIONS(1199),
  },
  [475] = {
    [ts_builtin_sym_end] = ACTIONS(2606),
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_RPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2606),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
  },
  [476] = {
    [ts_builtin_sym_end] = ACTIONS(1189),
    [sym_identifier] = ACTIONS(1191),
    [anon_sym_export] = ACTIONS(1191),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_namespace] = ACTIONS(1191),
    [anon_sym_LBRACE] = ACTIONS(1189),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_type] = ACTIONS(1191),
    [anon_sym_typeof] = ACTIONS(1191),
    [anon_sym_import] = ACTIONS(1191),
    [anon_sym_var] = ACTIONS(1191),
    [anon_sym_let] = ACTIONS(1191),
    [anon_sym_const] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1191),
    [anon_sym_switch] = ACTIONS(1191),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_LPAREN] = ACTIONS(1189),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_while] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(1191),
    [anon_sym_try] = ACTIONS(1191),
    [anon_sym_with] = ACTIONS(1191),
    [anon_sym_break] = ACTIONS(1191),
    [anon_sym_continue] = ACTIONS(1191),
    [anon_sym_debugger] = ACTIONS(1191),
    [anon_sym_return] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1191),
    [anon_sym_SEMI] = ACTIONS(1189),
    [anon_sym_case] = ACTIONS(1191),
    [anon_sym_yield] = ACTIONS(1191),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1191),
    [anon_sym_class] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1191),
    [anon_sym_function] = ACTIONS(1191),
    [anon_sym_new] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1191),
    [anon_sym_delete] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1189),
    [anon_sym_DASH_DASH] = ACTIONS(1189),
    [anon_sym_DQUOTE] = ACTIONS(1189),
    [anon_sym_SQUOTE] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1189),
    [sym_number] = ACTIONS(1189),
    [sym_this] = ACTIONS(1191),
    [sym_super] = ACTIONS(1191),
    [sym_true] = ACTIONS(1191),
    [sym_false] = ACTIONS(1191),
    [sym_null] = ACTIONS(1191),
    [sym_undefined] = ACTIONS(1191),
    [anon_sym_AT] = ACTIONS(1189),
    [anon_sym_static] = ACTIONS(1191),
    [anon_sym_abstract] = ACTIONS(1191),
    [anon_sym_get] = ACTIONS(1191),
    [anon_sym_set] = ACTIONS(1191),
    [anon_sym_declare] = ACTIONS(1191),
    [anon_sym_public] = ACTIONS(1191),
    [anon_sym_private] = ACTIONS(1191),
    [anon_sym_protected] = ACTIONS(1191),
    [anon_sym_module] = ACTIONS(1191),
    [anon_sym_any] = ACTIONS(1191),
    [anon_sym_number] = ACTIONS(1191),
    [anon_sym_boolean] = ACTIONS(1191),
    [anon_sym_string] = ACTIONS(1191),
    [anon_sym_symbol] = ACTIONS(1191),
    [anon_sym_interface] = ACTIONS(1191),
    [anon_sym_enum] = ACTIONS(1191),
    [sym__automatic_semicolon] = ACTIONS(1197),
  },
  [477] = {
    [ts_builtin_sym_end] = ACTIONS(1061),
    [sym_identifier] = ACTIONS(1063),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_default] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_import] = ACTIONS(1063),
    [anon_sym_var] = ACTIONS(1063),
    [anon_sym_let] = ACTIONS(1063),
    [anon_sym_const] = ACTIONS(1063),
    [anon_sym_if] = ACTIONS(1063),
    [anon_sym_else] = ACTIONS(1063),
    [anon_sym_switch] = ACTIONS(1063),
    [anon_sym_for] = ACTIONS(1063),
    [anon_sym_LPAREN] = ACTIONS(1061),
    [anon_sym_await] = ACTIONS(1063),
    [anon_sym_while] = ACTIONS(1063),
    [anon_sym_do] = ACTIONS(1063),
    [anon_sym_try] = ACTIONS(1063),
    [anon_sym_with] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1063),
    [anon_sym_continue] = ACTIONS(1063),
    [anon_sym_debugger] = ACTIONS(1063),
    [anon_sym_return] = ACTIONS(1063),
    [anon_sym_throw] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_case] = ACTIONS(1063),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_SLASH] = ACTIONS(1063),
    [anon_sym_class] = ACTIONS(1063),
    [anon_sym_async] = ACTIONS(1063),
    [anon_sym_function] = ACTIONS(1063),
    [anon_sym_new] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [anon_sym_void] = ACTIONS(1063),
    [anon_sym_delete] = ACTIONS(1063),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [anon_sym_SQUOTE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [sym_number] = ACTIONS(1061),
    [sym_this] = ACTIONS(1063),
    [sym_super] = ACTIONS(1063),
    [sym_true] = ACTIONS(1063),
    [sym_false] = ACTIONS(1063),
    [sym_null] = ACTIONS(1063),
    [sym_undefined] = ACTIONS(1063),
    [anon_sym_AT] = ACTIONS(1061),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_abstract] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
    [anon_sym_interface] = ACTIONS(1063),
    [anon_sym_enum] = ACTIONS(1063),
    [sym__automatic_semicolon] = ACTIONS(2610),
  },
  [478] = {
    [sym__call_signature] = STATE(2751),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2568),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_async] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2572),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2570),
    [anon_sym_get] = ACTIONS(2570),
    [anon_sym_set] = ACTIONS(2570),
    [anon_sym_declare] = ACTIONS(2570),
    [anon_sym_public] = ACTIONS(2570),
    [anon_sym_private] = ACTIONS(2570),
    [anon_sym_protected] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [479] = {
    [sym__call_signature] = STATE(2756),
    [sym_arguments] = STATE(1518),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_export] = ACTIONS(2614),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(2614),
    [anon_sym_LBRACE] = ACTIONS(493),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(2614),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_async] = ACTIONS(2614),
    [anon_sym_function] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(664),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_void] = ACTIONS(2614),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_static] = ACTIONS(2614),
    [anon_sym_get] = ACTIONS(2614),
    [anon_sym_set] = ACTIONS(2614),
    [anon_sym_declare] = ACTIONS(2614),
    [anon_sym_public] = ACTIONS(2614),
    [anon_sym_private] = ACTIONS(2614),
    [anon_sym_protected] = ACTIONS(2614),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_any] = ACTIONS(2614),
    [anon_sym_number] = ACTIONS(2614),
    [anon_sym_boolean] = ACTIONS(2614),
    [anon_sym_string] = ACTIONS(2614),
    [anon_sym_symbol] = ACTIONS(2614),
    [anon_sym_LBRACE_PIPE] = ACTIONS(501),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(1131),
    [sym_identifier] = ACTIONS(1133),
    [anon_sym_export] = ACTIONS(1133),
    [anon_sym_default] = ACTIONS(1133),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1133),
    [anon_sym_typeof] = ACTIONS(1133),
    [anon_sym_import] = ACTIONS(1133),
    [anon_sym_var] = ACTIONS(1133),
    [anon_sym_let] = ACTIONS(1133),
    [anon_sym_const] = ACTIONS(1133),
    [anon_sym_if] = ACTIONS(1133),
    [anon_sym_else] = ACTIONS(1133),
    [anon_sym_switch] = ACTIONS(1133),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_while] = ACTIONS(1133),
    [anon_sym_do] = ACTIONS(1133),
    [anon_sym_try] = ACTIONS(1133),
    [anon_sym_with] = ACTIONS(1133),
    [anon_sym_break] = ACTIONS(1133),
    [anon_sym_continue] = ACTIONS(1133),
    [anon_sym_debugger] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1133),
    [anon_sym_throw] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1131),
    [anon_sym_case] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_SLASH] = ACTIONS(1133),
    [anon_sym_class] = ACTIONS(1133),
    [anon_sym_async] = ACTIONS(1133),
    [anon_sym_function] = ACTIONS(1133),
    [anon_sym_new] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [anon_sym_void] = ACTIONS(1133),
    [anon_sym_delete] = ACTIONS(1133),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [anon_sym_SQUOTE] = ACTIONS(1131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [sym_number] = ACTIONS(1131),
    [sym_this] = ACTIONS(1133),
    [sym_super] = ACTIONS(1133),
    [sym_true] = ACTIONS(1133),
    [sym_false] = ACTIONS(1133),
    [sym_null] = ACTIONS(1133),
    [sym_undefined] = ACTIONS(1133),
    [anon_sym_AT] = ACTIONS(1131),
    [anon_sym_static] = ACTIONS(1133),
    [anon_sym_abstract] = ACTIONS(1133),
    [anon_sym_get] = ACTIONS(1133),
    [anon_sym_set] = ACTIONS(1133),
    [anon_sym_declare] = ACTIONS(1133),
    [anon_sym_public] = ACTIONS(1133),
    [anon_sym_private] = ACTIONS(1133),
    [anon_sym_protected] = ACTIONS(1133),
    [anon_sym_module] = ACTIONS(1133),
    [anon_sym_any] = ACTIONS(1133),
    [anon_sym_number] = ACTIONS(1133),
    [anon_sym_boolean] = ACTIONS(1133),
    [anon_sym_string] = ACTIONS(1133),
    [anon_sym_symbol] = ACTIONS(1133),
    [anon_sym_interface] = ACTIONS(1133),
    [anon_sym_enum] = ACTIONS(1133),
    [sym__automatic_semicolon] = ACTIONS(1131),
  },
  [481] = {
    [ts_builtin_sym_end] = ACTIONS(1169),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_export] = ACTIONS(1171),
    [anon_sym_default] = ACTIONS(1171),
    [anon_sym_namespace] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(1169),
    [anon_sym_RBRACE] = ACTIONS(1169),
    [anon_sym_type] = ACTIONS(1171),
    [anon_sym_typeof] = ACTIONS(1171),
    [anon_sym_import] = ACTIONS(1171),
    [anon_sym_var] = ACTIONS(1171),
    [anon_sym_let] = ACTIONS(1171),
    [anon_sym_const] = ACTIONS(1171),
    [anon_sym_if] = ACTIONS(1171),
    [anon_sym_else] = ACTIONS(1171),
    [anon_sym_switch] = ACTIONS(1171),
    [anon_sym_for] = ACTIONS(1171),
    [anon_sym_LPAREN] = ACTIONS(1169),
    [anon_sym_await] = ACTIONS(1171),
    [anon_sym_while] = ACTIONS(1171),
    [anon_sym_do] = ACTIONS(1171),
    [anon_sym_try] = ACTIONS(1171),
    [anon_sym_with] = ACTIONS(1171),
    [anon_sym_break] = ACTIONS(1171),
    [anon_sym_continue] = ACTIONS(1171),
    [anon_sym_debugger] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1171),
    [anon_sym_throw] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1169),
    [anon_sym_case] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(1171),
    [anon_sym_class] = ACTIONS(1171),
    [anon_sym_async] = ACTIONS(1171),
    [anon_sym_function] = ACTIONS(1171),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1169),
    [anon_sym_TILDE] = ACTIONS(1169),
    [anon_sym_void] = ACTIONS(1171),
    [anon_sym_delete] = ACTIONS(1171),
    [anon_sym_PLUS_PLUS] = ACTIONS(1169),
    [anon_sym_DASH_DASH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1169),
    [anon_sym_SQUOTE] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1169),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_super] = ACTIONS(1171),
    [sym_true] = ACTIONS(1171),
    [sym_false] = ACTIONS(1171),
    [sym_null] = ACTIONS(1171),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(1169),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_abstract] = ACTIONS(1171),
    [anon_sym_get] = ACTIONS(1171),
    [anon_sym_set] = ACTIONS(1171),
    [anon_sym_declare] = ACTIONS(1171),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_any] = ACTIONS(1171),
    [anon_sym_number] = ACTIONS(1171),
    [anon_sym_boolean] = ACTIONS(1171),
    [anon_sym_string] = ACTIONS(1171),
    [anon_sym_symbol] = ACTIONS(1171),
    [anon_sym_interface] = ACTIONS(1171),
    [anon_sym_enum] = ACTIONS(1171),
    [sym__automatic_semicolon] = ACTIONS(1177),
  },
  [482] = {
    [sym__call_signature] = STATE(2751),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2568),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_async] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2368),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2570),
    [anon_sym_get] = ACTIONS(2570),
    [anon_sym_set] = ACTIONS(2570),
    [anon_sym_declare] = ACTIONS(2570),
    [anon_sym_public] = ACTIONS(2570),
    [anon_sym_private] = ACTIONS(2570),
    [anon_sym_protected] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [483] = {
    [ts_builtin_sym_end] = ACTIONS(1115),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_export] = ACTIONS(1117),
    [anon_sym_default] = ACTIONS(1117),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1115),
    [anon_sym_type] = ACTIONS(1117),
    [anon_sym_typeof] = ACTIONS(1117),
    [anon_sym_import] = ACTIONS(1117),
    [anon_sym_var] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_const] = ACTIONS(1117),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_else] = ACTIONS(1117),
    [anon_sym_switch] = ACTIONS(1117),
    [anon_sym_for] = ACTIONS(1117),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_await] = ACTIONS(1117),
    [anon_sym_while] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1117),
    [anon_sym_with] = ACTIONS(1117),
    [anon_sym_break] = ACTIONS(1117),
    [anon_sym_continue] = ACTIONS(1117),
    [anon_sym_debugger] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1117),
    [anon_sym_throw] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1115),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_yield] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1115),
    [anon_sym_SLASH] = ACTIONS(1117),
    [anon_sym_class] = ACTIONS(1117),
    [anon_sym_async] = ACTIONS(1117),
    [anon_sym_function] = ACTIONS(1117),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_void] = ACTIONS(1117),
    [anon_sym_delete] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [sym_number] = ACTIONS(1115),
    [sym_this] = ACTIONS(1117),
    [sym_super] = ACTIONS(1117),
    [sym_true] = ACTIONS(1117),
    [sym_false] = ACTIONS(1117),
    [sym_null] = ACTIONS(1117),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(1115),
    [anon_sym_static] = ACTIONS(1117),
    [anon_sym_abstract] = ACTIONS(1117),
    [anon_sym_get] = ACTIONS(1117),
    [anon_sym_set] = ACTIONS(1117),
    [anon_sym_declare] = ACTIONS(1117),
    [anon_sym_public] = ACTIONS(1117),
    [anon_sym_private] = ACTIONS(1117),
    [anon_sym_protected] = ACTIONS(1117),
    [anon_sym_module] = ACTIONS(1117),
    [anon_sym_any] = ACTIONS(1117),
    [anon_sym_number] = ACTIONS(1117),
    [anon_sym_boolean] = ACTIONS(1117),
    [anon_sym_string] = ACTIONS(1117),
    [anon_sym_symbol] = ACTIONS(1117),
    [anon_sym_interface] = ACTIONS(1117),
    [anon_sym_enum] = ACTIONS(1117),
    [sym__automatic_semicolon] = ACTIONS(1115),
  },
  [484] = {
    [ts_builtin_sym_end] = ACTIONS(1159),
    [sym_identifier] = ACTIONS(1161),
    [anon_sym_export] = ACTIONS(1161),
    [anon_sym_default] = ACTIONS(1161),
    [anon_sym_namespace] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_type] = ACTIONS(1161),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_import] = ACTIONS(1161),
    [anon_sym_var] = ACTIONS(1161),
    [anon_sym_let] = ACTIONS(1161),
    [anon_sym_const] = ACTIONS(1161),
    [anon_sym_if] = ACTIONS(1161),
    [anon_sym_else] = ACTIONS(1161),
    [anon_sym_switch] = ACTIONS(1161),
    [anon_sym_for] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_await] = ACTIONS(1161),
    [anon_sym_while] = ACTIONS(1161),
    [anon_sym_do] = ACTIONS(1161),
    [anon_sym_try] = ACTIONS(1161),
    [anon_sym_with] = ACTIONS(1161),
    [anon_sym_break] = ACTIONS(1161),
    [anon_sym_continue] = ACTIONS(1161),
    [anon_sym_debugger] = ACTIONS(1161),
    [anon_sym_return] = ACTIONS(1161),
    [anon_sym_throw] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(1161),
    [anon_sym_LBRACK] = ACTIONS(1159),
    [anon_sym_LT] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(1161),
    [anon_sym_class] = ACTIONS(1161),
    [anon_sym_async] = ACTIONS(1161),
    [anon_sym_function] = ACTIONS(1161),
    [anon_sym_new] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_BANG] = ACTIONS(1159),
    [anon_sym_TILDE] = ACTIONS(1159),
    [anon_sym_void] = ACTIONS(1161),
    [anon_sym_delete] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1159),
    [anon_sym_DASH_DASH] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_SQUOTE] = ACTIONS(1159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1159),
    [sym_number] = ACTIONS(1159),
    [sym_this] = ACTIONS(1161),
    [sym_super] = ACTIONS(1161),
    [sym_true] = ACTIONS(1161),
    [sym_false] = ACTIONS(1161),
    [sym_null] = ACTIONS(1161),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_AT] = ACTIONS(1159),
    [anon_sym_static] = ACTIONS(1161),
    [anon_sym_abstract] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(1161),
    [anon_sym_set] = ACTIONS(1161),
    [anon_sym_declare] = ACTIONS(1161),
    [anon_sym_public] = ACTIONS(1161),
    [anon_sym_private] = ACTIONS(1161),
    [anon_sym_protected] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(1161),
    [anon_sym_any] = ACTIONS(1161),
    [anon_sym_number] = ACTIONS(1161),
    [anon_sym_boolean] = ACTIONS(1161),
    [anon_sym_string] = ACTIONS(1161),
    [anon_sym_symbol] = ACTIONS(1161),
    [anon_sym_interface] = ACTIONS(1161),
    [anon_sym_enum] = ACTIONS(1161),
    [sym__automatic_semicolon] = ACTIONS(1167),
  },
  [485] = {
    [sym_statement_block] = STATE(510),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [anon_sym_export] = ACTIONS(1073),
    [anon_sym_default] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(1073),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_type] = ACTIONS(1073),
    [anon_sym_typeof] = ACTIONS(1073),
    [anon_sym_import] = ACTIONS(1073),
    [anon_sym_var] = ACTIONS(1073),
    [anon_sym_let] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1073),
    [anon_sym_if] = ACTIONS(1073),
    [anon_sym_else] = ACTIONS(1073),
    [anon_sym_switch] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1073),
    [anon_sym_do] = ACTIONS(1073),
    [anon_sym_try] = ACTIONS(1073),
    [anon_sym_with] = ACTIONS(1073),
    [anon_sym_break] = ACTIONS(1073),
    [anon_sym_continue] = ACTIONS(1073),
    [anon_sym_debugger] = ACTIONS(1073),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_throw] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1073),
    [anon_sym_function] = ACTIONS(1073),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1073),
    [anon_sym_delete] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [sym_number] = ACTIONS(1071),
    [sym_this] = ACTIONS(1073),
    [sym_super] = ACTIONS(1073),
    [sym_true] = ACTIONS(1073),
    [sym_false] = ACTIONS(1073),
    [sym_null] = ACTIONS(1073),
    [sym_undefined] = ACTIONS(1073),
    [anon_sym_AT] = ACTIONS(1071),
    [anon_sym_static] = ACTIONS(1073),
    [anon_sym_abstract] = ACTIONS(1073),
    [anon_sym_get] = ACTIONS(1073),
    [anon_sym_set] = ACTIONS(1073),
    [anon_sym_declare] = ACTIONS(1073),
    [anon_sym_public] = ACTIONS(1073),
    [anon_sym_private] = ACTIONS(1073),
    [anon_sym_protected] = ACTIONS(1073),
    [anon_sym_module] = ACTIONS(1073),
    [anon_sym_any] = ACTIONS(1073),
    [anon_sym_number] = ACTIONS(1073),
    [anon_sym_boolean] = ACTIONS(1073),
    [anon_sym_string] = ACTIONS(1073),
    [anon_sym_symbol] = ACTIONS(1073),
    [anon_sym_interface] = ACTIONS(1073),
    [anon_sym_enum] = ACTIONS(1073),
  },
  [486] = {
    [ts_builtin_sym_end] = ACTIONS(1233),
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_export] = ACTIONS(1235),
    [anon_sym_default] = ACTIONS(1235),
    [anon_sym_namespace] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_type] = ACTIONS(1235),
    [anon_sym_typeof] = ACTIONS(1235),
    [anon_sym_import] = ACTIONS(1235),
    [anon_sym_var] = ACTIONS(1235),
    [anon_sym_let] = ACTIONS(1235),
    [anon_sym_const] = ACTIONS(1235),
    [anon_sym_if] = ACTIONS(1235),
    [anon_sym_else] = ACTIONS(1235),
    [anon_sym_switch] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_await] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1235),
    [anon_sym_do] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1235),
    [anon_sym_with] = ACTIONS(1235),
    [anon_sym_break] = ACTIONS(1235),
    [anon_sym_continue] = ACTIONS(1235),
    [anon_sym_debugger] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1235),
    [anon_sym_throw] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1235),
    [anon_sym_yield] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1233),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_class] = ACTIONS(1235),
    [anon_sym_async] = ACTIONS(1235),
    [anon_sym_function] = ACTIONS(1235),
    [anon_sym_new] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1233),
    [anon_sym_void] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [anon_sym_DQUOTE] = ACTIONS(1233),
    [anon_sym_SQUOTE] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1233),
    [sym_number] = ACTIONS(1233),
    [sym_this] = ACTIONS(1235),
    [sym_super] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_null] = ACTIONS(1235),
    [sym_undefined] = ACTIONS(1235),
    [anon_sym_AT] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1235),
    [anon_sym_abstract] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(1235),
    [anon_sym_set] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1235),
    [anon_sym_public] = ACTIONS(1235),
    [anon_sym_private] = ACTIONS(1235),
    [anon_sym_protected] = ACTIONS(1235),
    [anon_sym_module] = ACTIONS(1235),
    [anon_sym_any] = ACTIONS(1235),
    [anon_sym_number] = ACTIONS(1235),
    [anon_sym_boolean] = ACTIONS(1235),
    [anon_sym_string] = ACTIONS(1235),
    [anon_sym_symbol] = ACTIONS(1235),
    [anon_sym_interface] = ACTIONS(1235),
    [anon_sym_enum] = ACTIONS(1235),
    [sym__automatic_semicolon] = ACTIONS(1241),
  },
  [487] = {
    [ts_builtin_sym_end] = ACTIONS(1211),
    [sym_identifier] = ACTIONS(1213),
    [anon_sym_export] = ACTIONS(1213),
    [anon_sym_default] = ACTIONS(1213),
    [anon_sym_namespace] = ACTIONS(1213),
    [anon_sym_LBRACE] = ACTIONS(1211),
    [anon_sym_RBRACE] = ACTIONS(1211),
    [anon_sym_type] = ACTIONS(1213),
    [anon_sym_typeof] = ACTIONS(1213),
    [anon_sym_import] = ACTIONS(1213),
    [anon_sym_var] = ACTIONS(1213),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1213),
    [anon_sym_if] = ACTIONS(1213),
    [anon_sym_else] = ACTIONS(1213),
    [anon_sym_switch] = ACTIONS(1213),
    [anon_sym_for] = ACTIONS(1213),
    [anon_sym_LPAREN] = ACTIONS(1211),
    [anon_sym_await] = ACTIONS(1213),
    [anon_sym_while] = ACTIONS(1213),
    [anon_sym_do] = ACTIONS(1213),
    [anon_sym_try] = ACTIONS(1213),
    [anon_sym_with] = ACTIONS(1213),
    [anon_sym_break] = ACTIONS(1213),
    [anon_sym_continue] = ACTIONS(1213),
    [anon_sym_debugger] = ACTIONS(1213),
    [anon_sym_return] = ACTIONS(1213),
    [anon_sym_throw] = ACTIONS(1213),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym_case] = ACTIONS(1213),
    [anon_sym_yield] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(1213),
    [anon_sym_class] = ACTIONS(1213),
    [anon_sym_async] = ACTIONS(1213),
    [anon_sym_function] = ACTIONS(1213),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_DASH] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1211),
    [anon_sym_TILDE] = ACTIONS(1211),
    [anon_sym_void] = ACTIONS(1213),
    [anon_sym_delete] = ACTIONS(1213),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1211),
    [sym_number] = ACTIONS(1211),
    [sym_this] = ACTIONS(1213),
    [sym_super] = ACTIONS(1213),
    [sym_true] = ACTIONS(1213),
    [sym_false] = ACTIONS(1213),
    [sym_null] = ACTIONS(1213),
    [sym_undefined] = ACTIONS(1213),
    [anon_sym_AT] = ACTIONS(1211),
    [anon_sym_static] = ACTIONS(1213),
    [anon_sym_abstract] = ACTIONS(1213),
    [anon_sym_get] = ACTIONS(1213),
    [anon_sym_set] = ACTIONS(1213),
    [anon_sym_declare] = ACTIONS(1213),
    [anon_sym_public] = ACTIONS(1213),
    [anon_sym_private] = ACTIONS(1213),
    [anon_sym_protected] = ACTIONS(1213),
    [anon_sym_module] = ACTIONS(1213),
    [anon_sym_any] = ACTIONS(1213),
    [anon_sym_number] = ACTIONS(1213),
    [anon_sym_boolean] = ACTIONS(1213),
    [anon_sym_string] = ACTIONS(1213),
    [anon_sym_symbol] = ACTIONS(1213),
    [anon_sym_interface] = ACTIONS(1213),
    [anon_sym_enum] = ACTIONS(1213),
    [sym__automatic_semicolon] = ACTIONS(1219),
  },
  [488] = {
    [ts_builtin_sym_end] = ACTIONS(1155),
    [sym_identifier] = ACTIONS(1157),
    [anon_sym_export] = ACTIONS(1157),
    [anon_sym_default] = ACTIONS(1157),
    [anon_sym_namespace] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1155),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_type] = ACTIONS(1157),
    [anon_sym_typeof] = ACTIONS(1157),
    [anon_sym_import] = ACTIONS(1157),
    [anon_sym_var] = ACTIONS(1157),
    [anon_sym_let] = ACTIONS(1157),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1157),
    [anon_sym_else] = ACTIONS(1157),
    [anon_sym_switch] = ACTIONS(1157),
    [anon_sym_for] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_await] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1157),
    [anon_sym_do] = ACTIONS(1157),
    [anon_sym_try] = ACTIONS(1157),
    [anon_sym_with] = ACTIONS(1157),
    [anon_sym_break] = ACTIONS(1157),
    [anon_sym_continue] = ACTIONS(1157),
    [anon_sym_debugger] = ACTIONS(1157),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_throw] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym_case] = ACTIONS(1157),
    [anon_sym_yield] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_SLASH] = ACTIONS(1157),
    [anon_sym_class] = ACTIONS(1157),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_TILDE] = ACTIONS(1155),
    [anon_sym_void] = ACTIONS(1157),
    [anon_sym_delete] = ACTIONS(1157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1155),
    [anon_sym_DASH_DASH] = ACTIONS(1155),
    [anon_sym_DQUOTE] = ACTIONS(1155),
    [anon_sym_SQUOTE] = ACTIONS(1155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1155),
    [sym_number] = ACTIONS(1155),
    [sym_this] = ACTIONS(1157),
    [sym_super] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_null] = ACTIONS(1157),
    [sym_undefined] = ACTIONS(1157),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(1157),
    [anon_sym_abstract] = ACTIONS(1157),
    [anon_sym_get] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(1157),
    [anon_sym_declare] = ACTIONS(1157),
    [anon_sym_public] = ACTIONS(1157),
    [anon_sym_private] = ACTIONS(1157),
    [anon_sym_protected] = ACTIONS(1157),
    [anon_sym_module] = ACTIONS(1157),
    [anon_sym_any] = ACTIONS(1157),
    [anon_sym_number] = ACTIONS(1157),
    [anon_sym_boolean] = ACTIONS(1157),
    [anon_sym_string] = ACTIONS(1157),
    [anon_sym_symbol] = ACTIONS(1157),
    [anon_sym_interface] = ACTIONS(1157),
    [anon_sym_enum] = ACTIONS(1157),
    [sym__automatic_semicolon] = ACTIONS(1155),
  },
  [489] = {
    [ts_builtin_sym_end] = ACTIONS(1121),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(1123),
    [anon_sym_default] = ACTIONS(1123),
    [anon_sym_namespace] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_RBRACE] = ACTIONS(1121),
    [anon_sym_type] = ACTIONS(1123),
    [anon_sym_typeof] = ACTIONS(1123),
    [anon_sym_import] = ACTIONS(1123),
    [anon_sym_var] = ACTIONS(1123),
    [anon_sym_let] = ACTIONS(1123),
    [anon_sym_const] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1123),
    [anon_sym_else] = ACTIONS(1123),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_for] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_await] = ACTIONS(1123),
    [anon_sym_while] = ACTIONS(1123),
    [anon_sym_do] = ACTIONS(1123),
    [anon_sym_try] = ACTIONS(1123),
    [anon_sym_with] = ACTIONS(1123),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_continue] = ACTIONS(1123),
    [anon_sym_debugger] = ACTIONS(1123),
    [anon_sym_return] = ACTIONS(1123),
    [anon_sym_throw] = ACTIONS(1123),
    [anon_sym_SEMI] = ACTIONS(1121),
    [anon_sym_case] = ACTIONS(1123),
    [anon_sym_yield] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1123),
    [anon_sym_class] = ACTIONS(1123),
    [anon_sym_async] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1123),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_void] = ACTIONS(1123),
    [anon_sym_delete] = ACTIONS(1123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_DQUOTE] = ACTIONS(1121),
    [anon_sym_SQUOTE] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1121),
    [sym_number] = ACTIONS(1121),
    [sym_this] = ACTIONS(1123),
    [sym_super] = ACTIONS(1123),
    [sym_true] = ACTIONS(1123),
    [sym_false] = ACTIONS(1123),
    [sym_null] = ACTIONS(1123),
    [sym_undefined] = ACTIONS(1123),
    [anon_sym_AT] = ACTIONS(1121),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_abstract] = ACTIONS(1123),
    [anon_sym_get] = ACTIONS(1123),
    [anon_sym_set] = ACTIONS(1123),
    [anon_sym_declare] = ACTIONS(1123),
    [anon_sym_public] = ACTIONS(1123),
    [anon_sym_private] = ACTIONS(1123),
    [anon_sym_protected] = ACTIONS(1123),
    [anon_sym_module] = ACTIONS(1123),
    [anon_sym_any] = ACTIONS(1123),
    [anon_sym_number] = ACTIONS(1123),
    [anon_sym_boolean] = ACTIONS(1123),
    [anon_sym_string] = ACTIONS(1123),
    [anon_sym_symbol] = ACTIONS(1123),
    [anon_sym_interface] = ACTIONS(1123),
    [anon_sym_enum] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1129),
  },
  [490] = {
    [ts_builtin_sym_end] = ACTIONS(2620),
    [sym_identifier] = ACTIONS(2622),
    [anon_sym_export] = ACTIONS(2622),
    [anon_sym_default] = ACTIONS(2622),
    [anon_sym_namespace] = ACTIONS(2622),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_RBRACE] = ACTIONS(2620),
    [anon_sym_type] = ACTIONS(2622),
    [anon_sym_typeof] = ACTIONS(2622),
    [anon_sym_import] = ACTIONS(2622),
    [anon_sym_var] = ACTIONS(2622),
    [anon_sym_let] = ACTIONS(2622),
    [anon_sym_const] = ACTIONS(2622),
    [anon_sym_if] = ACTIONS(2622),
    [anon_sym_else] = ACTIONS(2622),
    [anon_sym_switch] = ACTIONS(2622),
    [anon_sym_for] = ACTIONS(2622),
    [anon_sym_LPAREN] = ACTIONS(2620),
    [anon_sym_await] = ACTIONS(2622),
    [anon_sym_while] = ACTIONS(2622),
    [anon_sym_do] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2622),
    [anon_sym_with] = ACTIONS(2622),
    [anon_sym_break] = ACTIONS(2622),
    [anon_sym_continue] = ACTIONS(2622),
    [anon_sym_debugger] = ACTIONS(2622),
    [anon_sym_return] = ACTIONS(2622),
    [anon_sym_throw] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_case] = ACTIONS(2622),
    [anon_sym_finally] = ACTIONS(2622),
    [anon_sym_yield] = ACTIONS(2622),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(2620),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_class] = ACTIONS(2622),
    [anon_sym_async] = ACTIONS(2622),
    [anon_sym_function] = ACTIONS(2622),
    [anon_sym_new] = ACTIONS(2622),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_DASH] = ACTIONS(2622),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_TILDE] = ACTIONS(2620),
    [anon_sym_void] = ACTIONS(2622),
    [anon_sym_delete] = ACTIONS(2622),
    [anon_sym_PLUS_PLUS] = ACTIONS(2620),
    [anon_sym_DASH_DASH] = ACTIONS(2620),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2620),
    [sym_number] = ACTIONS(2620),
    [sym_this] = ACTIONS(2622),
    [sym_super] = ACTIONS(2622),
    [sym_true] = ACTIONS(2622),
    [sym_false] = ACTIONS(2622),
    [sym_null] = ACTIONS(2622),
    [sym_undefined] = ACTIONS(2622),
    [anon_sym_AT] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2622),
    [anon_sym_abstract] = ACTIONS(2622),
    [anon_sym_get] = ACTIONS(2622),
    [anon_sym_set] = ACTIONS(2622),
    [anon_sym_declare] = ACTIONS(2622),
    [anon_sym_public] = ACTIONS(2622),
    [anon_sym_private] = ACTIONS(2622),
    [anon_sym_protected] = ACTIONS(2622),
    [anon_sym_module] = ACTIONS(2622),
    [anon_sym_any] = ACTIONS(2622),
    [anon_sym_number] = ACTIONS(2622),
    [anon_sym_boolean] = ACTIONS(2622),
    [anon_sym_string] = ACTIONS(2622),
    [anon_sym_symbol] = ACTIONS(2622),
    [anon_sym_interface] = ACTIONS(2622),
    [anon_sym_enum] = ACTIONS(2622),
  },
  [491] = {
    [ts_builtin_sym_end] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_export] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_type] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym_import] = ACTIONS(1201),
    [anon_sym_var] = ACTIONS(1201),
    [anon_sym_let] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_try] = ACTIONS(1201),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_debugger] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_throw] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_yield] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(1201),
    [anon_sym_new] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_void] = ACTIONS(1201),
    [anon_sym_delete] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [sym_number] = ACTIONS(1199),
    [sym_this] = ACTIONS(1201),
    [sym_super] = ACTIONS(1201),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [sym_null] = ACTIONS(1201),
    [sym_undefined] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_abstract] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1201),
    [anon_sym_declare] = ACTIONS(1201),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1201),
    [anon_sym_any] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1201),
    [anon_sym_symbol] = ACTIONS(1201),
    [anon_sym_interface] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [sym__automatic_semicolon] = ACTIONS(2624),
  },
  [492] = {
    [ts_builtin_sym_end] = ACTIONS(1179),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_default] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym_RBRACE] = ACTIONS(1179),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_typeof] = ACTIONS(1181),
    [anon_sym_import] = ACTIONS(1181),
    [anon_sym_var] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_const] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1181),
    [anon_sym_else] = ACTIONS(1181),
    [anon_sym_switch] = ACTIONS(1181),
    [anon_sym_for] = ACTIONS(1181),
    [anon_sym_LPAREN] = ACTIONS(1179),
    [anon_sym_await] = ACTIONS(1181),
    [anon_sym_while] = ACTIONS(1181),
    [anon_sym_do] = ACTIONS(1181),
    [anon_sym_try] = ACTIONS(1181),
    [anon_sym_with] = ACTIONS(1181),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_continue] = ACTIONS(1181),
    [anon_sym_debugger] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1181),
    [anon_sym_throw] = ACTIONS(1181),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_case] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(1179),
    [anon_sym_SLASH] = ACTIONS(1181),
    [anon_sym_class] = ACTIONS(1181),
    [anon_sym_async] = ACTIONS(1181),
    [anon_sym_function] = ACTIONS(1181),
    [anon_sym_new] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_void] = ACTIONS(1181),
    [anon_sym_delete] = ACTIONS(1181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1179),
    [anon_sym_SQUOTE] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_super] = ACTIONS(1181),
    [sym_true] = ACTIONS(1181),
    [sym_false] = ACTIONS(1181),
    [sym_null] = ACTIONS(1181),
    [sym_undefined] = ACTIONS(1181),
    [anon_sym_AT] = ACTIONS(1179),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_abstract] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_interface] = ACTIONS(1181),
    [anon_sym_enum] = ACTIONS(1181),
    [sym__automatic_semicolon] = ACTIONS(1187),
  },
  [493] = {
    [ts_builtin_sym_end] = ACTIONS(1145),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1147),
    [anon_sym_namespace] = ACTIONS(1147),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_type] = ACTIONS(1147),
    [anon_sym_typeof] = ACTIONS(1147),
    [anon_sym_import] = ACTIONS(1147),
    [anon_sym_var] = ACTIONS(1147),
    [anon_sym_let] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1147),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_else] = ACTIONS(1147),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1147),
    [anon_sym_do] = ACTIONS(1147),
    [anon_sym_try] = ACTIONS(1147),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_break] = ACTIONS(1147),
    [anon_sym_continue] = ACTIONS(1147),
    [anon_sym_debugger] = ACTIONS(1147),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_throw] = ACTIONS(1147),
    [anon_sym_SEMI] = ACTIONS(1145),
    [anon_sym_case] = ACTIONS(1147),
    [anon_sym_yield] = ACTIONS(1147),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_class] = ACTIONS(1147),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(1147),
    [anon_sym_new] = ACTIONS(1147),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1145),
    [anon_sym_TILDE] = ACTIONS(1145),
    [anon_sym_void] = ACTIONS(1147),
    [anon_sym_delete] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1145),
    [anon_sym_SQUOTE] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [sym_number] = ACTIONS(1145),
    [sym_this] = ACTIONS(1147),
    [sym_super] = ACTIONS(1147),
    [sym_true] = ACTIONS(1147),
    [sym_false] = ACTIONS(1147),
    [sym_null] = ACTIONS(1147),
    [sym_undefined] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(1145),
    [anon_sym_static] = ACTIONS(1147),
    [anon_sym_abstract] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(1147),
    [anon_sym_set] = ACTIONS(1147),
    [anon_sym_declare] = ACTIONS(1147),
    [anon_sym_public] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(1147),
    [anon_sym_protected] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(1147),
    [anon_sym_any] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(1147),
    [anon_sym_interface] = ACTIONS(1147),
    [anon_sym_enum] = ACTIONS(1147),
    [sym__automatic_semicolon] = ACTIONS(1153),
  },
  [494] = {
    [sym__call_signature] = STATE(2751),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2568),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_async] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2626),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2570),
    [anon_sym_get] = ACTIONS(2570),
    [anon_sym_set] = ACTIONS(2570),
    [anon_sym_declare] = ACTIONS(2570),
    [anon_sym_public] = ACTIONS(2570),
    [anon_sym_private] = ACTIONS(2570),
    [anon_sym_protected] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [495] = {
    [ts_builtin_sym_end] = ACTIONS(1135),
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_export] = ACTIONS(1137),
    [anon_sym_default] = ACTIONS(1137),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1137),
    [anon_sym_typeof] = ACTIONS(1137),
    [anon_sym_import] = ACTIONS(1137),
    [anon_sym_var] = ACTIONS(1137),
    [anon_sym_let] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_await] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_do] = ACTIONS(1137),
    [anon_sym_try] = ACTIONS(1137),
    [anon_sym_with] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_debugger] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_throw] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_case] = ACTIONS(1137),
    [anon_sym_yield] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_class] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1137),
    [anon_sym_function] = ACTIONS(1137),
    [anon_sym_new] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_void] = ACTIONS(1137),
    [anon_sym_delete] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1135),
    [sym_this] = ACTIONS(1137),
    [sym_super] = ACTIONS(1137),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [sym_null] = ACTIONS(1137),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_abstract] = ACTIONS(1137),
    [anon_sym_get] = ACTIONS(1137),
    [anon_sym_set] = ACTIONS(1137),
    [anon_sym_declare] = ACTIONS(1137),
    [anon_sym_public] = ACTIONS(1137),
    [anon_sym_private] = ACTIONS(1137),
    [anon_sym_protected] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1137),
    [anon_sym_any] = ACTIONS(1137),
    [anon_sym_number] = ACTIONS(1137),
    [anon_sym_boolean] = ACTIONS(1137),
    [anon_sym_string] = ACTIONS(1137),
    [anon_sym_symbol] = ACTIONS(1137),
    [anon_sym_interface] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [sym__automatic_semicolon] = ACTIONS(1143),
  },
  [496] = {
    [ts_builtin_sym_end] = ACTIONS(1221),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1223),
    [anon_sym_default] = ACTIONS(1223),
    [anon_sym_namespace] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1221),
    [anon_sym_type] = ACTIONS(1223),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_import] = ACTIONS(1223),
    [anon_sym_var] = ACTIONS(1223),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_const] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_switch] = ACTIONS(1223),
    [anon_sym_for] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1221),
    [anon_sym_await] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_try] = ACTIONS(1223),
    [anon_sym_with] = ACTIONS(1223),
    [anon_sym_break] = ACTIONS(1223),
    [anon_sym_continue] = ACTIONS(1223),
    [anon_sym_debugger] = ACTIONS(1223),
    [anon_sym_return] = ACTIONS(1223),
    [anon_sym_throw] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1221),
    [anon_sym_case] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_class] = ACTIONS(1223),
    [anon_sym_async] = ACTIONS(1223),
    [anon_sym_function] = ACTIONS(1223),
    [anon_sym_new] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_DASH] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_TILDE] = ACTIONS(1221),
    [anon_sym_void] = ACTIONS(1223),
    [anon_sym_delete] = ACTIONS(1223),
    [anon_sym_PLUS_PLUS] = ACTIONS(1221),
    [anon_sym_DASH_DASH] = ACTIONS(1221),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1221),
    [sym_number] = ACTIONS(1221),
    [sym_this] = ACTIONS(1223),
    [sym_super] = ACTIONS(1223),
    [sym_true] = ACTIONS(1223),
    [sym_false] = ACTIONS(1223),
    [sym_null] = ACTIONS(1223),
    [sym_undefined] = ACTIONS(1223),
    [anon_sym_AT] = ACTIONS(1221),
    [anon_sym_static] = ACTIONS(1223),
    [anon_sym_abstract] = ACTIONS(1223),
    [anon_sym_get] = ACTIONS(1223),
    [anon_sym_set] = ACTIONS(1223),
    [anon_sym_declare] = ACTIONS(1223),
    [anon_sym_public] = ACTIONS(1223),
    [anon_sym_private] = ACTIONS(1223),
    [anon_sym_protected] = ACTIONS(1223),
    [anon_sym_module] = ACTIONS(1223),
    [anon_sym_any] = ACTIONS(1223),
    [anon_sym_number] = ACTIONS(1223),
    [anon_sym_boolean] = ACTIONS(1223),
    [anon_sym_string] = ACTIONS(1223),
    [anon_sym_symbol] = ACTIONS(1223),
    [anon_sym_interface] = ACTIONS(1223),
    [anon_sym_enum] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1229),
  },
  [497] = {
    [ts_builtin_sym_end] = ACTIONS(2628),
    [sym_identifier] = ACTIONS(2630),
    [anon_sym_export] = ACTIONS(2630),
    [anon_sym_default] = ACTIONS(2630),
    [anon_sym_namespace] = ACTIONS(2630),
    [anon_sym_LBRACE] = ACTIONS(2628),
    [anon_sym_RBRACE] = ACTIONS(2628),
    [anon_sym_type] = ACTIONS(2630),
    [anon_sym_typeof] = ACTIONS(2630),
    [anon_sym_import] = ACTIONS(2630),
    [anon_sym_var] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(2630),
    [anon_sym_const] = ACTIONS(2630),
    [anon_sym_if] = ACTIONS(2630),
    [anon_sym_else] = ACTIONS(2630),
    [anon_sym_switch] = ACTIONS(2630),
    [anon_sym_for] = ACTIONS(2630),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2628),
    [anon_sym_await] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2630),
    [anon_sym_do] = ACTIONS(2630),
    [anon_sym_try] = ACTIONS(2630),
    [anon_sym_with] = ACTIONS(2630),
    [anon_sym_break] = ACTIONS(2630),
    [anon_sym_continue] = ACTIONS(2630),
    [anon_sym_debugger] = ACTIONS(2630),
    [anon_sym_return] = ACTIONS(2630),
    [anon_sym_throw] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2630),
    [anon_sym_yield] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_class] = ACTIONS(2630),
    [anon_sym_async] = ACTIONS(2630),
    [anon_sym_function] = ACTIONS(2630),
    [anon_sym_new] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_DASH] = ACTIONS(2630),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2628),
    [anon_sym_void] = ACTIONS(2630),
    [anon_sym_delete] = ACTIONS(2630),
    [anon_sym_PLUS_PLUS] = ACTIONS(2628),
    [anon_sym_DASH_DASH] = ACTIONS(2628),
    [anon_sym_DQUOTE] = ACTIONS(2628),
    [anon_sym_SQUOTE] = ACTIONS(2628),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2628),
    [sym_number] = ACTIONS(2628),
    [sym_this] = ACTIONS(2630),
    [sym_super] = ACTIONS(2630),
    [sym_true] = ACTIONS(2630),
    [sym_false] = ACTIONS(2630),
    [sym_null] = ACTIONS(2630),
    [sym_undefined] = ACTIONS(2630),
    [anon_sym_AT] = ACTIONS(2628),
    [anon_sym_static] = ACTIONS(2630),
    [anon_sym_abstract] = ACTIONS(2630),
    [anon_sym_get] = ACTIONS(2630),
    [anon_sym_set] = ACTIONS(2630),
    [anon_sym_declare] = ACTIONS(2630),
    [anon_sym_public] = ACTIONS(2630),
    [anon_sym_private] = ACTIONS(2630),
    [anon_sym_protected] = ACTIONS(2630),
    [anon_sym_module] = ACTIONS(2630),
    [anon_sym_any] = ACTIONS(2630),
    [anon_sym_number] = ACTIONS(2630),
    [anon_sym_boolean] = ACTIONS(2630),
    [anon_sym_string] = ACTIONS(2630),
    [anon_sym_symbol] = ACTIONS(2630),
    [anon_sym_interface] = ACTIONS(2630),
    [anon_sym_enum] = ACTIONS(2630),
  },
  [498] = {
    [ts_builtin_sym_end] = ACTIONS(1087),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1089),
    [anon_sym_default] = ACTIONS(1089),
    [anon_sym_namespace] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1087),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_type] = ACTIONS(1089),
    [anon_sym_typeof] = ACTIONS(1089),
    [anon_sym_import] = ACTIONS(1089),
    [anon_sym_var] = ACTIONS(1089),
    [anon_sym_let] = ACTIONS(1089),
    [anon_sym_const] = ACTIONS(1089),
    [anon_sym_if] = ACTIONS(1089),
    [anon_sym_else] = ACTIONS(1089),
    [anon_sym_switch] = ACTIONS(1089),
    [anon_sym_for] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_await] = ACTIONS(1089),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(1089),
    [anon_sym_try] = ACTIONS(1089),
    [anon_sym_with] = ACTIONS(1089),
    [anon_sym_break] = ACTIONS(1089),
    [anon_sym_continue] = ACTIONS(1089),
    [anon_sym_debugger] = ACTIONS(1089),
    [anon_sym_return] = ACTIONS(1089),
    [anon_sym_throw] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_case] = ACTIONS(1089),
    [anon_sym_yield] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_SLASH] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1089),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_new] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1089),
    [anon_sym_DASH] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1089),
    [anon_sym_delete] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_SQUOTE] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [sym_number] = ACTIONS(1087),
    [sym_this] = ACTIONS(1089),
    [sym_super] = ACTIONS(1089),
    [sym_true] = ACTIONS(1089),
    [sym_false] = ACTIONS(1089),
    [sym_null] = ACTIONS(1089),
    [sym_undefined] = ACTIONS(1089),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_static] = ACTIONS(1089),
    [anon_sym_abstract] = ACTIONS(1089),
    [anon_sym_get] = ACTIONS(1089),
    [anon_sym_set] = ACTIONS(1089),
    [anon_sym_declare] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1089),
    [anon_sym_private] = ACTIONS(1089),
    [anon_sym_protected] = ACTIONS(1089),
    [anon_sym_module] = ACTIONS(1089),
    [anon_sym_any] = ACTIONS(1089),
    [anon_sym_number] = ACTIONS(1089),
    [anon_sym_boolean] = ACTIONS(1089),
    [anon_sym_string] = ACTIONS(1089),
    [anon_sym_symbol] = ACTIONS(1089),
    [anon_sym_interface] = ACTIONS(1089),
    [anon_sym_enum] = ACTIONS(1089),
    [sym__automatic_semicolon] = ACTIONS(1095),
  },
  [499] = {
    [ts_builtin_sym_end] = ACTIONS(2632),
    [sym_identifier] = ACTIONS(2634),
    [anon_sym_export] = ACTIONS(2634),
    [anon_sym_default] = ACTIONS(2634),
    [anon_sym_namespace] = ACTIONS(2634),
    [anon_sym_LBRACE] = ACTIONS(2632),
    [anon_sym_RBRACE] = ACTIONS(2632),
    [anon_sym_type] = ACTIONS(2634),
    [anon_sym_typeof] = ACTIONS(2634),
    [anon_sym_import] = ACTIONS(2634),
    [anon_sym_var] = ACTIONS(2634),
    [anon_sym_let] = ACTIONS(2634),
    [anon_sym_const] = ACTIONS(2634),
    [anon_sym_if] = ACTIONS(2634),
    [anon_sym_else] = ACTIONS(2634),
    [anon_sym_switch] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2634),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_await] = ACTIONS(2634),
    [anon_sym_while] = ACTIONS(2634),
    [anon_sym_do] = ACTIONS(2634),
    [anon_sym_try] = ACTIONS(2634),
    [anon_sym_with] = ACTIONS(2634),
    [anon_sym_break] = ACTIONS(2634),
    [anon_sym_continue] = ACTIONS(2634),
    [anon_sym_debugger] = ACTIONS(2634),
    [anon_sym_return] = ACTIONS(2634),
    [anon_sym_throw] = ACTIONS(2634),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2634),
    [anon_sym_finally] = ACTIONS(2634),
    [anon_sym_yield] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_class] = ACTIONS(2634),
    [anon_sym_async] = ACTIONS(2634),
    [anon_sym_function] = ACTIONS(2634),
    [anon_sym_new] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2632),
    [anon_sym_void] = ACTIONS(2634),
    [anon_sym_delete] = ACTIONS(2634),
    [anon_sym_PLUS_PLUS] = ACTIONS(2632),
    [anon_sym_DASH_DASH] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [anon_sym_SQUOTE] = ACTIONS(2632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [sym_number] = ACTIONS(2632),
    [sym_this] = ACTIONS(2634),
    [sym_super] = ACTIONS(2634),
    [sym_true] = ACTIONS(2634),
    [sym_false] = ACTIONS(2634),
    [sym_null] = ACTIONS(2634),
    [sym_undefined] = ACTIONS(2634),
    [anon_sym_AT] = ACTIONS(2632),
    [anon_sym_static] = ACTIONS(2634),
    [anon_sym_abstract] = ACTIONS(2634),
    [anon_sym_get] = ACTIONS(2634),
    [anon_sym_set] = ACTIONS(2634),
    [anon_sym_declare] = ACTIONS(2634),
    [anon_sym_public] = ACTIONS(2634),
    [anon_sym_private] = ACTIONS(2634),
    [anon_sym_protected] = ACTIONS(2634),
    [anon_sym_module] = ACTIONS(2634),
    [anon_sym_any] = ACTIONS(2634),
    [anon_sym_number] = ACTIONS(2634),
    [anon_sym_boolean] = ACTIONS(2634),
    [anon_sym_string] = ACTIONS(2634),
    [anon_sym_symbol] = ACTIONS(2634),
    [anon_sym_interface] = ACTIONS(2634),
    [anon_sym_enum] = ACTIONS(2634),
  },
  [500] = {
    [sym__call_signature] = STATE(2760),
    [sym_arguments] = STATE(1032),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2636),
    [anon_sym_export] = ACTIONS(2638),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(2638),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(2638),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_async] = ACTIONS(2638),
    [anon_sym_function] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(648),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_void] = ACTIONS(2638),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_static] = ACTIONS(2638),
    [anon_sym_get] = ACTIONS(2638),
    [anon_sym_set] = ACTIONS(2638),
    [anon_sym_declare] = ACTIONS(2638),
    [anon_sym_public] = ACTIONS(2638),
    [anon_sym_private] = ACTIONS(2638),
    [anon_sym_protected] = ACTIONS(2638),
    [anon_sym_module] = ACTIONS(2638),
    [anon_sym_any] = ACTIONS(2638),
    [anon_sym_number] = ACTIONS(2638),
    [anon_sym_boolean] = ACTIONS(2638),
    [anon_sym_string] = ACTIONS(2638),
    [anon_sym_symbol] = ACTIONS(2638),
    [anon_sym_implements] = ACTIONS(493),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(2640),
    [sym_identifier] = ACTIONS(2642),
    [anon_sym_export] = ACTIONS(2642),
    [anon_sym_default] = ACTIONS(2642),
    [anon_sym_namespace] = ACTIONS(2642),
    [anon_sym_LBRACE] = ACTIONS(2640),
    [anon_sym_RBRACE] = ACTIONS(2640),
    [anon_sym_type] = ACTIONS(2642),
    [anon_sym_typeof] = ACTIONS(2642),
    [anon_sym_import] = ACTIONS(2642),
    [anon_sym_var] = ACTIONS(2642),
    [anon_sym_let] = ACTIONS(2642),
    [anon_sym_const] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(2642),
    [anon_sym_else] = ACTIONS(2642),
    [anon_sym_switch] = ACTIONS(2642),
    [anon_sym_for] = ACTIONS(2642),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_await] = ACTIONS(2642),
    [anon_sym_while] = ACTIONS(2642),
    [anon_sym_do] = ACTIONS(2642),
    [anon_sym_try] = ACTIONS(2642),
    [anon_sym_with] = ACTIONS(2642),
    [anon_sym_break] = ACTIONS(2642),
    [anon_sym_continue] = ACTIONS(2642),
    [anon_sym_debugger] = ACTIONS(2642),
    [anon_sym_return] = ACTIONS(2642),
    [anon_sym_throw] = ACTIONS(2642),
    [anon_sym_SEMI] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2642),
    [anon_sym_finally] = ACTIONS(2642),
    [anon_sym_yield] = ACTIONS(2642),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_SLASH] = ACTIONS(2642),
    [anon_sym_class] = ACTIONS(2642),
    [anon_sym_async] = ACTIONS(2642),
    [anon_sym_function] = ACTIONS(2642),
    [anon_sym_new] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_DASH] = ACTIONS(2642),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2640),
    [anon_sym_void] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_PLUS_PLUS] = ACTIONS(2640),
    [anon_sym_DASH_DASH] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(2640),
    [anon_sym_SQUOTE] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2640),
    [sym_number] = ACTIONS(2640),
    [sym_this] = ACTIONS(2642),
    [sym_super] = ACTIONS(2642),
    [sym_true] = ACTIONS(2642),
    [sym_false] = ACTIONS(2642),
    [sym_null] = ACTIONS(2642),
    [sym_undefined] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(2640),
    [anon_sym_static] = ACTIONS(2642),
    [anon_sym_abstract] = ACTIONS(2642),
    [anon_sym_get] = ACTIONS(2642),
    [anon_sym_set] = ACTIONS(2642),
    [anon_sym_declare] = ACTIONS(2642),
    [anon_sym_public] = ACTIONS(2642),
    [anon_sym_private] = ACTIONS(2642),
    [anon_sym_protected] = ACTIONS(2642),
    [anon_sym_module] = ACTIONS(2642),
    [anon_sym_any] = ACTIONS(2642),
    [anon_sym_number] = ACTIONS(2642),
    [anon_sym_boolean] = ACTIONS(2642),
    [anon_sym_string] = ACTIONS(2642),
    [anon_sym_symbol] = ACTIONS(2642),
    [anon_sym_interface] = ACTIONS(2642),
    [anon_sym_enum] = ACTIONS(2642),
  },
  [502] = {
    [ts_builtin_sym_end] = ACTIONS(2644),
    [sym_identifier] = ACTIONS(2646),
    [anon_sym_export] = ACTIONS(2646),
    [anon_sym_default] = ACTIONS(2646),
    [anon_sym_namespace] = ACTIONS(2646),
    [anon_sym_LBRACE] = ACTIONS(2644),
    [anon_sym_RBRACE] = ACTIONS(2644),
    [anon_sym_type] = ACTIONS(2646),
    [anon_sym_typeof] = ACTIONS(2646),
    [anon_sym_import] = ACTIONS(2646),
    [anon_sym_var] = ACTIONS(2646),
    [anon_sym_let] = ACTIONS(2646),
    [anon_sym_const] = ACTIONS(2646),
    [anon_sym_if] = ACTIONS(2646),
    [anon_sym_else] = ACTIONS(2646),
    [anon_sym_switch] = ACTIONS(2646),
    [anon_sym_for] = ACTIONS(2646),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_await] = ACTIONS(2646),
    [anon_sym_while] = ACTIONS(2646),
    [anon_sym_do] = ACTIONS(2646),
    [anon_sym_try] = ACTIONS(2646),
    [anon_sym_with] = ACTIONS(2646),
    [anon_sym_break] = ACTIONS(2646),
    [anon_sym_continue] = ACTIONS(2646),
    [anon_sym_debugger] = ACTIONS(2646),
    [anon_sym_return] = ACTIONS(2646),
    [anon_sym_throw] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2646),
    [anon_sym_finally] = ACTIONS(2646),
    [anon_sym_yield] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_class] = ACTIONS(2646),
    [anon_sym_async] = ACTIONS(2646),
    [anon_sym_function] = ACTIONS(2646),
    [anon_sym_new] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_DASH] = ACTIONS(2646),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2644),
    [anon_sym_void] = ACTIONS(2646),
    [anon_sym_delete] = ACTIONS(2646),
    [anon_sym_PLUS_PLUS] = ACTIONS(2644),
    [anon_sym_DASH_DASH] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_SQUOTE] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [sym_number] = ACTIONS(2644),
    [sym_this] = ACTIONS(2646),
    [sym_super] = ACTIONS(2646),
    [sym_true] = ACTIONS(2646),
    [sym_false] = ACTIONS(2646),
    [sym_null] = ACTIONS(2646),
    [sym_undefined] = ACTIONS(2646),
    [anon_sym_AT] = ACTIONS(2644),
    [anon_sym_static] = ACTIONS(2646),
    [anon_sym_abstract] = ACTIONS(2646),
    [anon_sym_get] = ACTIONS(2646),
    [anon_sym_set] = ACTIONS(2646),
    [anon_sym_declare] = ACTIONS(2646),
    [anon_sym_public] = ACTIONS(2646),
    [anon_sym_private] = ACTIONS(2646),
    [anon_sym_protected] = ACTIONS(2646),
    [anon_sym_module] = ACTIONS(2646),
    [anon_sym_any] = ACTIONS(2646),
    [anon_sym_number] = ACTIONS(2646),
    [anon_sym_boolean] = ACTIONS(2646),
    [anon_sym_string] = ACTIONS(2646),
    [anon_sym_symbol] = ACTIONS(2646),
    [anon_sym_interface] = ACTIONS(2646),
    [anon_sym_enum] = ACTIONS(2646),
  },
  [503] = {
    [sym__call_signature] = STATE(2751),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2568),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_async] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2572),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2570),
    [anon_sym_get] = ACTIONS(2570),
    [anon_sym_set] = ACTIONS(2570),
    [anon_sym_declare] = ACTIONS(2570),
    [anon_sym_public] = ACTIONS(2570),
    [anon_sym_private] = ACTIONS(2570),
    [anon_sym_protected] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(1101),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_namespace] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_RBRACE] = ACTIONS(1101),
    [anon_sym_type] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1103),
    [anon_sym_import] = ACTIONS(1103),
    [anon_sym_var] = ACTIONS(1103),
    [anon_sym_let] = ACTIONS(1103),
    [anon_sym_const] = ACTIONS(1103),
    [anon_sym_if] = ACTIONS(1103),
    [anon_sym_else] = ACTIONS(1103),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_for] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1103),
    [anon_sym_do] = ACTIONS(1103),
    [anon_sym_try] = ACTIONS(1103),
    [anon_sym_with] = ACTIONS(1103),
    [anon_sym_break] = ACTIONS(1103),
    [anon_sym_continue] = ACTIONS(1103),
    [anon_sym_debugger] = ACTIONS(1103),
    [anon_sym_return] = ACTIONS(1103),
    [anon_sym_throw] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_case] = ACTIONS(1103),
    [anon_sym_yield] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1101),
    [anon_sym_SLASH] = ACTIONS(1103),
    [anon_sym_class] = ACTIONS(1103),
    [anon_sym_async] = ACTIONS(1103),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1103),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_BANG] = ACTIONS(1101),
    [anon_sym_TILDE] = ACTIONS(1101),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_PLUS_PLUS] = ACTIONS(1101),
    [anon_sym_DASH_DASH] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_SQUOTE] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [sym_number] = ACTIONS(1101),
    [sym_this] = ACTIONS(1103),
    [sym_super] = ACTIONS(1103),
    [sym_true] = ACTIONS(1103),
    [sym_false] = ACTIONS(1103),
    [sym_null] = ACTIONS(1103),
    [sym_undefined] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(1101),
    [anon_sym_static] = ACTIONS(1103),
    [anon_sym_abstract] = ACTIONS(1103),
    [anon_sym_get] = ACTIONS(1103),
    [anon_sym_set] = ACTIONS(1103),
    [anon_sym_declare] = ACTIONS(1103),
    [anon_sym_public] = ACTIONS(1103),
    [anon_sym_private] = ACTIONS(1103),
    [anon_sym_protected] = ACTIONS(1103),
    [anon_sym_module] = ACTIONS(1103),
    [anon_sym_any] = ACTIONS(1103),
    [anon_sym_number] = ACTIONS(1103),
    [anon_sym_boolean] = ACTIONS(1103),
    [anon_sym_string] = ACTIONS(1103),
    [anon_sym_symbol] = ACTIONS(1103),
    [anon_sym_interface] = ACTIONS(1103),
    [anon_sym_enum] = ACTIONS(1103),
    [sym__automatic_semicolon] = ACTIONS(1109),
  },
  [505] = {
    [ts_builtin_sym_end] = ACTIONS(2648),
    [sym_identifier] = ACTIONS(2650),
    [anon_sym_export] = ACTIONS(2650),
    [anon_sym_default] = ACTIONS(2650),
    [anon_sym_namespace] = ACTIONS(2650),
    [anon_sym_LBRACE] = ACTIONS(2648),
    [anon_sym_RBRACE] = ACTIONS(2648),
    [anon_sym_type] = ACTIONS(2650),
    [anon_sym_typeof] = ACTIONS(2650),
    [anon_sym_import] = ACTIONS(2650),
    [anon_sym_var] = ACTIONS(2650),
    [anon_sym_let] = ACTIONS(2650),
    [anon_sym_const] = ACTIONS(2650),
    [anon_sym_if] = ACTIONS(2650),
    [anon_sym_else] = ACTIONS(2650),
    [anon_sym_switch] = ACTIONS(2650),
    [anon_sym_for] = ACTIONS(2650),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_await] = ACTIONS(2650),
    [anon_sym_while] = ACTIONS(2650),
    [anon_sym_do] = ACTIONS(2650),
    [anon_sym_try] = ACTIONS(2650),
    [anon_sym_with] = ACTIONS(2650),
    [anon_sym_break] = ACTIONS(2650),
    [anon_sym_continue] = ACTIONS(2650),
    [anon_sym_debugger] = ACTIONS(2650),
    [anon_sym_return] = ACTIONS(2650),
    [anon_sym_throw] = ACTIONS(2650),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_case] = ACTIONS(2650),
    [anon_sym_yield] = ACTIONS(2650),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_SLASH] = ACTIONS(2650),
    [anon_sym_class] = ACTIONS(2650),
    [anon_sym_async] = ACTIONS(2650),
    [anon_sym_function] = ACTIONS(2650),
    [anon_sym_new] = ACTIONS(2650),
    [anon_sym_PLUS] = ACTIONS(2650),
    [anon_sym_DASH] = ACTIONS(2650),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_void] = ACTIONS(2650),
    [anon_sym_delete] = ACTIONS(2650),
    [anon_sym_PLUS_PLUS] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(2648),
    [anon_sym_DQUOTE] = ACTIONS(2648),
    [anon_sym_SQUOTE] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2648),
    [sym_number] = ACTIONS(2648),
    [sym_this] = ACTIONS(2650),
    [sym_super] = ACTIONS(2650),
    [sym_true] = ACTIONS(2650),
    [sym_false] = ACTIONS(2650),
    [sym_null] = ACTIONS(2650),
    [sym_undefined] = ACTIONS(2650),
    [anon_sym_AT] = ACTIONS(2648),
    [anon_sym_static] = ACTIONS(2650),
    [anon_sym_abstract] = ACTIONS(2650),
    [anon_sym_get] = ACTIONS(2650),
    [anon_sym_set] = ACTIONS(2650),
    [anon_sym_declare] = ACTIONS(2650),
    [anon_sym_public] = ACTIONS(2650),
    [anon_sym_private] = ACTIONS(2650),
    [anon_sym_protected] = ACTIONS(2650),
    [anon_sym_module] = ACTIONS(2650),
    [anon_sym_any] = ACTIONS(2650),
    [anon_sym_number] = ACTIONS(2650),
    [anon_sym_boolean] = ACTIONS(2650),
    [anon_sym_string] = ACTIONS(2650),
    [anon_sym_symbol] = ACTIONS(2650),
    [anon_sym_interface] = ACTIONS(2650),
    [anon_sym_enum] = ACTIONS(2650),
  },
  [506] = {
    [ts_builtin_sym_end] = ACTIONS(2652),
    [sym_identifier] = ACTIONS(2654),
    [anon_sym_export] = ACTIONS(2654),
    [anon_sym_default] = ACTIONS(2654),
    [anon_sym_namespace] = ACTIONS(2654),
    [anon_sym_LBRACE] = ACTIONS(2652),
    [anon_sym_RBRACE] = ACTIONS(2652),
    [anon_sym_type] = ACTIONS(2654),
    [anon_sym_typeof] = ACTIONS(2654),
    [anon_sym_import] = ACTIONS(2654),
    [anon_sym_var] = ACTIONS(2654),
    [anon_sym_let] = ACTIONS(2654),
    [anon_sym_const] = ACTIONS(2654),
    [anon_sym_if] = ACTIONS(2654),
    [anon_sym_else] = ACTIONS(2654),
    [anon_sym_switch] = ACTIONS(2654),
    [anon_sym_for] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2652),
    [anon_sym_await] = ACTIONS(2654),
    [anon_sym_while] = ACTIONS(2654),
    [anon_sym_do] = ACTIONS(2654),
    [anon_sym_try] = ACTIONS(2654),
    [anon_sym_with] = ACTIONS(2654),
    [anon_sym_break] = ACTIONS(2654),
    [anon_sym_continue] = ACTIONS(2654),
    [anon_sym_debugger] = ACTIONS(2654),
    [anon_sym_return] = ACTIONS(2654),
    [anon_sym_throw] = ACTIONS(2654),
    [anon_sym_SEMI] = ACTIONS(2652),
    [anon_sym_case] = ACTIONS(2654),
    [anon_sym_yield] = ACTIONS(2654),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [anon_sym_LT] = ACTIONS(2652),
    [anon_sym_SLASH] = ACTIONS(2654),
    [anon_sym_class] = ACTIONS(2654),
    [anon_sym_async] = ACTIONS(2654),
    [anon_sym_function] = ACTIONS(2654),
    [anon_sym_new] = ACTIONS(2654),
    [anon_sym_PLUS] = ACTIONS(2654),
    [anon_sym_DASH] = ACTIONS(2654),
    [anon_sym_BANG] = ACTIONS(2652),
    [anon_sym_TILDE] = ACTIONS(2652),
    [anon_sym_void] = ACTIONS(2654),
    [anon_sym_delete] = ACTIONS(2654),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2652),
    [anon_sym_SQUOTE] = ACTIONS(2652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2652),
    [sym_number] = ACTIONS(2652),
    [sym_this] = ACTIONS(2654),
    [sym_super] = ACTIONS(2654),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_null] = ACTIONS(2654),
    [sym_undefined] = ACTIONS(2654),
    [anon_sym_AT] = ACTIONS(2652),
    [anon_sym_static] = ACTIONS(2654),
    [anon_sym_abstract] = ACTIONS(2654),
    [anon_sym_get] = ACTIONS(2654),
    [anon_sym_set] = ACTIONS(2654),
    [anon_sym_declare] = ACTIONS(2654),
    [anon_sym_public] = ACTIONS(2654),
    [anon_sym_private] = ACTIONS(2654),
    [anon_sym_protected] = ACTIONS(2654),
    [anon_sym_module] = ACTIONS(2654),
    [anon_sym_any] = ACTIONS(2654),
    [anon_sym_number] = ACTIONS(2654),
    [anon_sym_boolean] = ACTIONS(2654),
    [anon_sym_string] = ACTIONS(2654),
    [anon_sym_symbol] = ACTIONS(2654),
    [anon_sym_interface] = ACTIONS(2654),
    [anon_sym_enum] = ACTIONS(2654),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(2656),
    [sym_identifier] = ACTIONS(2658),
    [anon_sym_export] = ACTIONS(2658),
    [anon_sym_default] = ACTIONS(2658),
    [anon_sym_namespace] = ACTIONS(2658),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_RBRACE] = ACTIONS(2656),
    [anon_sym_type] = ACTIONS(2658),
    [anon_sym_typeof] = ACTIONS(2658),
    [anon_sym_import] = ACTIONS(2658),
    [anon_sym_var] = ACTIONS(2658),
    [anon_sym_let] = ACTIONS(2658),
    [anon_sym_const] = ACTIONS(2658),
    [anon_sym_if] = ACTIONS(2658),
    [anon_sym_else] = ACTIONS(2658),
    [anon_sym_switch] = ACTIONS(2658),
    [anon_sym_for] = ACTIONS(2658),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_while] = ACTIONS(2658),
    [anon_sym_do] = ACTIONS(2658),
    [anon_sym_try] = ACTIONS(2658),
    [anon_sym_with] = ACTIONS(2658),
    [anon_sym_break] = ACTIONS(2658),
    [anon_sym_continue] = ACTIONS(2658),
    [anon_sym_debugger] = ACTIONS(2658),
    [anon_sym_return] = ACTIONS(2658),
    [anon_sym_throw] = ACTIONS(2658),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_case] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2658),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2656),
    [anon_sym_SLASH] = ACTIONS(2658),
    [anon_sym_class] = ACTIONS(2658),
    [anon_sym_async] = ACTIONS(2658),
    [anon_sym_function] = ACTIONS(2658),
    [anon_sym_new] = ACTIONS(2658),
    [anon_sym_PLUS] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(2658),
    [anon_sym_BANG] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2656),
    [anon_sym_void] = ACTIONS(2658),
    [anon_sym_delete] = ACTIONS(2658),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_DQUOTE] = ACTIONS(2656),
    [anon_sym_SQUOTE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2656),
    [sym_number] = ACTIONS(2656),
    [sym_this] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_undefined] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2658),
    [anon_sym_abstract] = ACTIONS(2658),
    [anon_sym_get] = ACTIONS(2658),
    [anon_sym_set] = ACTIONS(2658),
    [anon_sym_declare] = ACTIONS(2658),
    [anon_sym_public] = ACTIONS(2658),
    [anon_sym_private] = ACTIONS(2658),
    [anon_sym_protected] = ACTIONS(2658),
    [anon_sym_module] = ACTIONS(2658),
    [anon_sym_any] = ACTIONS(2658),
    [anon_sym_number] = ACTIONS(2658),
    [anon_sym_boolean] = ACTIONS(2658),
    [anon_sym_string] = ACTIONS(2658),
    [anon_sym_symbol] = ACTIONS(2658),
    [anon_sym_interface] = ACTIONS(2658),
    [anon_sym_enum] = ACTIONS(2658),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(2660),
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2662),
    [anon_sym_default] = ACTIONS(2662),
    [anon_sym_namespace] = ACTIONS(2662),
    [anon_sym_LBRACE] = ACTIONS(2660),
    [anon_sym_RBRACE] = ACTIONS(2660),
    [anon_sym_type] = ACTIONS(2662),
    [anon_sym_typeof] = ACTIONS(2662),
    [anon_sym_import] = ACTIONS(2662),
    [anon_sym_var] = ACTIONS(2662),
    [anon_sym_let] = ACTIONS(2662),
    [anon_sym_const] = ACTIONS(2662),
    [anon_sym_if] = ACTIONS(2662),
    [anon_sym_else] = ACTIONS(2662),
    [anon_sym_switch] = ACTIONS(2662),
    [anon_sym_for] = ACTIONS(2662),
    [anon_sym_LPAREN] = ACTIONS(2660),
    [anon_sym_await] = ACTIONS(2662),
    [anon_sym_while] = ACTIONS(2662),
    [anon_sym_do] = ACTIONS(2662),
    [anon_sym_try] = ACTIONS(2662),
    [anon_sym_with] = ACTIONS(2662),
    [anon_sym_break] = ACTIONS(2662),
    [anon_sym_continue] = ACTIONS(2662),
    [anon_sym_debugger] = ACTIONS(2662),
    [anon_sym_return] = ACTIONS(2662),
    [anon_sym_throw] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2660),
    [anon_sym_case] = ACTIONS(2662),
    [anon_sym_yield] = ACTIONS(2662),
    [anon_sym_LBRACK] = ACTIONS(2660),
    [anon_sym_LT] = ACTIONS(2660),
    [anon_sym_SLASH] = ACTIONS(2662),
    [anon_sym_class] = ACTIONS(2662),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(2662),
    [anon_sym_new] = ACTIONS(2662),
    [anon_sym_PLUS] = ACTIONS(2662),
    [anon_sym_DASH] = ACTIONS(2662),
    [anon_sym_BANG] = ACTIONS(2660),
    [anon_sym_TILDE] = ACTIONS(2660),
    [anon_sym_void] = ACTIONS(2662),
    [anon_sym_delete] = ACTIONS(2662),
    [anon_sym_PLUS_PLUS] = ACTIONS(2660),
    [anon_sym_DASH_DASH] = ACTIONS(2660),
    [anon_sym_DQUOTE] = ACTIONS(2660),
    [anon_sym_SQUOTE] = ACTIONS(2660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2660),
    [sym_number] = ACTIONS(2660),
    [sym_this] = ACTIONS(2662),
    [sym_super] = ACTIONS(2662),
    [sym_true] = ACTIONS(2662),
    [sym_false] = ACTIONS(2662),
    [sym_null] = ACTIONS(2662),
    [sym_undefined] = ACTIONS(2662),
    [anon_sym_AT] = ACTIONS(2660),
    [anon_sym_static] = ACTIONS(2662),
    [anon_sym_abstract] = ACTIONS(2662),
    [anon_sym_get] = ACTIONS(2662),
    [anon_sym_set] = ACTIONS(2662),
    [anon_sym_declare] = ACTIONS(2662),
    [anon_sym_public] = ACTIONS(2662),
    [anon_sym_private] = ACTIONS(2662),
    [anon_sym_protected] = ACTIONS(2662),
    [anon_sym_module] = ACTIONS(2662),
    [anon_sym_any] = ACTIONS(2662),
    [anon_sym_number] = ACTIONS(2662),
    [anon_sym_boolean] = ACTIONS(2662),
    [anon_sym_string] = ACTIONS(2662),
    [anon_sym_symbol] = ACTIONS(2662),
    [anon_sym_interface] = ACTIONS(2662),
    [anon_sym_enum] = ACTIONS(2662),
  },
  [509] = {
    [ts_builtin_sym_end] = ACTIONS(2664),
    [sym_identifier] = ACTIONS(2666),
    [anon_sym_export] = ACTIONS(2666),
    [anon_sym_default] = ACTIONS(2666),
    [anon_sym_namespace] = ACTIONS(2666),
    [anon_sym_LBRACE] = ACTIONS(2664),
    [anon_sym_RBRACE] = ACTIONS(2664),
    [anon_sym_type] = ACTIONS(2666),
    [anon_sym_typeof] = ACTIONS(2666),
    [anon_sym_import] = ACTIONS(2666),
    [anon_sym_var] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(2666),
    [anon_sym_const] = ACTIONS(2666),
    [anon_sym_if] = ACTIONS(2666),
    [anon_sym_else] = ACTIONS(2666),
    [anon_sym_switch] = ACTIONS(2666),
    [anon_sym_for] = ACTIONS(2666),
    [anon_sym_LPAREN] = ACTIONS(2664),
    [anon_sym_await] = ACTIONS(2666),
    [anon_sym_while] = ACTIONS(2666),
    [anon_sym_do] = ACTIONS(2666),
    [anon_sym_try] = ACTIONS(2666),
    [anon_sym_with] = ACTIONS(2666),
    [anon_sym_break] = ACTIONS(2666),
    [anon_sym_continue] = ACTIONS(2666),
    [anon_sym_debugger] = ACTIONS(2666),
    [anon_sym_return] = ACTIONS(2666),
    [anon_sym_throw] = ACTIONS(2666),
    [anon_sym_SEMI] = ACTIONS(2664),
    [anon_sym_case] = ACTIONS(2666),
    [anon_sym_yield] = ACTIONS(2666),
    [anon_sym_LBRACK] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2664),
    [anon_sym_SLASH] = ACTIONS(2666),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_async] = ACTIONS(2666),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2666),
    [anon_sym_DASH] = ACTIONS(2666),
    [anon_sym_BANG] = ACTIONS(2664),
    [anon_sym_TILDE] = ACTIONS(2664),
    [anon_sym_void] = ACTIONS(2666),
    [anon_sym_delete] = ACTIONS(2666),
    [anon_sym_PLUS_PLUS] = ACTIONS(2664),
    [anon_sym_DASH_DASH] = ACTIONS(2664),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_SQUOTE] = ACTIONS(2664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [sym_number] = ACTIONS(2664),
    [sym_this] = ACTIONS(2666),
    [sym_super] = ACTIONS(2666),
    [sym_true] = ACTIONS(2666),
    [sym_false] = ACTIONS(2666),
    [sym_null] = ACTIONS(2666),
    [sym_undefined] = ACTIONS(2666),
    [anon_sym_AT] = ACTIONS(2664),
    [anon_sym_static] = ACTIONS(2666),
    [anon_sym_abstract] = ACTIONS(2666),
    [anon_sym_get] = ACTIONS(2666),
    [anon_sym_set] = ACTIONS(2666),
    [anon_sym_declare] = ACTIONS(2666),
    [anon_sym_public] = ACTIONS(2666),
    [anon_sym_private] = ACTIONS(2666),
    [anon_sym_protected] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2666),
    [anon_sym_any] = ACTIONS(2666),
    [anon_sym_number] = ACTIONS(2666),
    [anon_sym_boolean] = ACTIONS(2666),
    [anon_sym_string] = ACTIONS(2666),
    [anon_sym_symbol] = ACTIONS(2666),
    [anon_sym_interface] = ACTIONS(2666),
    [anon_sym_enum] = ACTIONS(2666),
  },
  [510] = {
    [ts_builtin_sym_end] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(1083),
    [anon_sym_namespace] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1083),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_import] = ACTIONS(1083),
    [anon_sym_var] = ACTIONS(1083),
    [anon_sym_let] = ACTIONS(1083),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_if] = ACTIONS(1083),
    [anon_sym_else] = ACTIONS(1083),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_for] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_while] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_try] = ACTIONS(1083),
    [anon_sym_with] = ACTIONS(1083),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_continue] = ACTIONS(1083),
    [anon_sym_debugger] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1083),
    [anon_sym_throw] = ACTIONS(1083),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_case] = ACTIONS(1083),
    [anon_sym_yield] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_class] = ACTIONS(1083),
    [anon_sym_async] = ACTIONS(1083),
    [anon_sym_function] = ACTIONS(1083),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_void] = ACTIONS(1083),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_DQUOTE] = ACTIONS(1081),
    [anon_sym_SQUOTE] = ACTIONS(1081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_number] = ACTIONS(1081),
    [sym_this] = ACTIONS(1083),
    [sym_super] = ACTIONS(1083),
    [sym_true] = ACTIONS(1083),
    [sym_false] = ACTIONS(1083),
    [sym_null] = ACTIONS(1083),
    [sym_undefined] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(1081),
    [anon_sym_static] = ACTIONS(1083),
    [anon_sym_abstract] = ACTIONS(1083),
    [anon_sym_get] = ACTIONS(1083),
    [anon_sym_set] = ACTIONS(1083),
    [anon_sym_declare] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1083),
    [anon_sym_private] = ACTIONS(1083),
    [anon_sym_protected] = ACTIONS(1083),
    [anon_sym_module] = ACTIONS(1083),
    [anon_sym_any] = ACTIONS(1083),
    [anon_sym_number] = ACTIONS(1083),
    [anon_sym_boolean] = ACTIONS(1083),
    [anon_sym_string] = ACTIONS(1083),
    [anon_sym_symbol] = ACTIONS(1083),
    [anon_sym_interface] = ACTIONS(1083),
    [anon_sym_enum] = ACTIONS(1083),
  },
  [511] = {
    [sym__call_signature] = STATE(2936),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2545),
    [anon_sym_export] = ACTIONS(2547),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2547),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2547),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_async] = ACTIONS(2547),
    [anon_sym_function] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2547),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2547),
    [anon_sym_get] = ACTIONS(2547),
    [anon_sym_set] = ACTIONS(2547),
    [anon_sym_declare] = ACTIONS(2547),
    [anon_sym_public] = ACTIONS(2547),
    [anon_sym_private] = ACTIONS(2547),
    [anon_sym_protected] = ACTIONS(2547),
    [anon_sym_module] = ACTIONS(2547),
    [anon_sym_any] = ACTIONS(2547),
    [anon_sym_number] = ACTIONS(2547),
    [anon_sym_boolean] = ACTIONS(2547),
    [anon_sym_string] = ACTIONS(2547),
    [anon_sym_symbol] = ACTIONS(2547),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(2668),
    [sym_identifier] = ACTIONS(2670),
    [anon_sym_export] = ACTIONS(2670),
    [anon_sym_default] = ACTIONS(2670),
    [anon_sym_namespace] = ACTIONS(2670),
    [anon_sym_LBRACE] = ACTIONS(2668),
    [anon_sym_RBRACE] = ACTIONS(2668),
    [anon_sym_type] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2670),
    [anon_sym_import] = ACTIONS(2670),
    [anon_sym_var] = ACTIONS(2670),
    [anon_sym_let] = ACTIONS(2670),
    [anon_sym_const] = ACTIONS(2670),
    [anon_sym_if] = ACTIONS(2670),
    [anon_sym_else] = ACTIONS(2670),
    [anon_sym_switch] = ACTIONS(2670),
    [anon_sym_for] = ACTIONS(2670),
    [anon_sym_LPAREN] = ACTIONS(2668),
    [anon_sym_await] = ACTIONS(2670),
    [anon_sym_while] = ACTIONS(2670),
    [anon_sym_do] = ACTIONS(2670),
    [anon_sym_try] = ACTIONS(2670),
    [anon_sym_with] = ACTIONS(2670),
    [anon_sym_break] = ACTIONS(2670),
    [anon_sym_continue] = ACTIONS(2670),
    [anon_sym_debugger] = ACTIONS(2670),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_throw] = ACTIONS(2670),
    [anon_sym_SEMI] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2670),
    [anon_sym_LBRACK] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2668),
    [anon_sym_SLASH] = ACTIONS(2670),
    [anon_sym_class] = ACTIONS(2670),
    [anon_sym_async] = ACTIONS(2670),
    [anon_sym_function] = ACTIONS(2670),
    [anon_sym_new] = ACTIONS(2670),
    [anon_sym_PLUS] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(2670),
    [anon_sym_BANG] = ACTIONS(2668),
    [anon_sym_TILDE] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2670),
    [anon_sym_delete] = ACTIONS(2670),
    [anon_sym_PLUS_PLUS] = ACTIONS(2668),
    [anon_sym_DASH_DASH] = ACTIONS(2668),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_SQUOTE] = ACTIONS(2668),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2668),
    [sym_number] = ACTIONS(2668),
    [sym_this] = ACTIONS(2670),
    [sym_super] = ACTIONS(2670),
    [sym_true] = ACTIONS(2670),
    [sym_false] = ACTIONS(2670),
    [sym_null] = ACTIONS(2670),
    [sym_undefined] = ACTIONS(2670),
    [anon_sym_AT] = ACTIONS(2668),
    [anon_sym_static] = ACTIONS(2670),
    [anon_sym_abstract] = ACTIONS(2670),
    [anon_sym_get] = ACTIONS(2670),
    [anon_sym_set] = ACTIONS(2670),
    [anon_sym_declare] = ACTIONS(2670),
    [anon_sym_public] = ACTIONS(2670),
    [anon_sym_private] = ACTIONS(2670),
    [anon_sym_protected] = ACTIONS(2670),
    [anon_sym_module] = ACTIONS(2670),
    [anon_sym_any] = ACTIONS(2670),
    [anon_sym_number] = ACTIONS(2670),
    [anon_sym_boolean] = ACTIONS(2670),
    [anon_sym_string] = ACTIONS(2670),
    [anon_sym_symbol] = ACTIONS(2670),
    [anon_sym_interface] = ACTIONS(2670),
    [anon_sym_enum] = ACTIONS(2670),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(2672),
    [sym_identifier] = ACTIONS(2674),
    [anon_sym_export] = ACTIONS(2674),
    [anon_sym_default] = ACTIONS(2674),
    [anon_sym_namespace] = ACTIONS(2674),
    [anon_sym_LBRACE] = ACTIONS(2672),
    [anon_sym_RBRACE] = ACTIONS(2672),
    [anon_sym_type] = ACTIONS(2674),
    [anon_sym_typeof] = ACTIONS(2674),
    [anon_sym_import] = ACTIONS(2674),
    [anon_sym_var] = ACTIONS(2674),
    [anon_sym_let] = ACTIONS(2674),
    [anon_sym_const] = ACTIONS(2674),
    [anon_sym_if] = ACTIONS(2674),
    [anon_sym_else] = ACTIONS(2674),
    [anon_sym_switch] = ACTIONS(2674),
    [anon_sym_for] = ACTIONS(2674),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [anon_sym_await] = ACTIONS(2674),
    [anon_sym_while] = ACTIONS(2674),
    [anon_sym_do] = ACTIONS(2674),
    [anon_sym_try] = ACTIONS(2674),
    [anon_sym_with] = ACTIONS(2674),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_continue] = ACTIONS(2674),
    [anon_sym_debugger] = ACTIONS(2674),
    [anon_sym_return] = ACTIONS(2674),
    [anon_sym_throw] = ACTIONS(2674),
    [anon_sym_SEMI] = ACTIONS(2672),
    [anon_sym_case] = ACTIONS(2674),
    [anon_sym_yield] = ACTIONS(2674),
    [anon_sym_LBRACK] = ACTIONS(2672),
    [anon_sym_LT] = ACTIONS(2672),
    [anon_sym_SLASH] = ACTIONS(2674),
    [anon_sym_class] = ACTIONS(2674),
    [anon_sym_async] = ACTIONS(2674),
    [anon_sym_function] = ACTIONS(2674),
    [anon_sym_new] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2674),
    [anon_sym_DASH] = ACTIONS(2674),
    [anon_sym_BANG] = ACTIONS(2672),
    [anon_sym_TILDE] = ACTIONS(2672),
    [anon_sym_void] = ACTIONS(2674),
    [anon_sym_delete] = ACTIONS(2674),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(2672),
    [anon_sym_SQUOTE] = ACTIONS(2672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2672),
    [sym_number] = ACTIONS(2672),
    [sym_this] = ACTIONS(2674),
    [sym_super] = ACTIONS(2674),
    [sym_true] = ACTIONS(2674),
    [sym_false] = ACTIONS(2674),
    [sym_null] = ACTIONS(2674),
    [sym_undefined] = ACTIONS(2674),
    [anon_sym_AT] = ACTIONS(2672),
    [anon_sym_static] = ACTIONS(2674),
    [anon_sym_abstract] = ACTIONS(2674),
    [anon_sym_get] = ACTIONS(2674),
    [anon_sym_set] = ACTIONS(2674),
    [anon_sym_declare] = ACTIONS(2674),
    [anon_sym_public] = ACTIONS(2674),
    [anon_sym_private] = ACTIONS(2674),
    [anon_sym_protected] = ACTIONS(2674),
    [anon_sym_module] = ACTIONS(2674),
    [anon_sym_any] = ACTIONS(2674),
    [anon_sym_number] = ACTIONS(2674),
    [anon_sym_boolean] = ACTIONS(2674),
    [anon_sym_string] = ACTIONS(2674),
    [anon_sym_symbol] = ACTIONS(2674),
    [anon_sym_interface] = ACTIONS(2674),
    [anon_sym_enum] = ACTIONS(2674),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(2676),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2676),
    [anon_sym_RBRACE] = ACTIONS(2676),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2676),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2676),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_LT] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2676),
    [anon_sym_TILDE] = ACTIONS(2676),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2676),
    [anon_sym_DASH_DASH] = ACTIONS(2676),
    [anon_sym_DQUOTE] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2676),
    [sym_number] = ACTIONS(2676),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [515] = {
    [ts_builtin_sym_end] = ACTIONS(2680),
    [sym_identifier] = ACTIONS(2682),
    [anon_sym_export] = ACTIONS(2682),
    [anon_sym_default] = ACTIONS(2682),
    [anon_sym_namespace] = ACTIONS(2682),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_type] = ACTIONS(2682),
    [anon_sym_typeof] = ACTIONS(2682),
    [anon_sym_import] = ACTIONS(2682),
    [anon_sym_var] = ACTIONS(2682),
    [anon_sym_let] = ACTIONS(2682),
    [anon_sym_const] = ACTIONS(2682),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_else] = ACTIONS(2682),
    [anon_sym_switch] = ACTIONS(2682),
    [anon_sym_for] = ACTIONS(2682),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2682),
    [anon_sym_while] = ACTIONS(2682),
    [anon_sym_do] = ACTIONS(2682),
    [anon_sym_try] = ACTIONS(2682),
    [anon_sym_with] = ACTIONS(2682),
    [anon_sym_break] = ACTIONS(2682),
    [anon_sym_continue] = ACTIONS(2682),
    [anon_sym_debugger] = ACTIONS(2682),
    [anon_sym_return] = ACTIONS(2682),
    [anon_sym_throw] = ACTIONS(2682),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2682),
    [anon_sym_yield] = ACTIONS(2682),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2680),
    [anon_sym_SLASH] = ACTIONS(2682),
    [anon_sym_class] = ACTIONS(2682),
    [anon_sym_async] = ACTIONS(2682),
    [anon_sym_function] = ACTIONS(2682),
    [anon_sym_new] = ACTIONS(2682),
    [anon_sym_PLUS] = ACTIONS(2682),
    [anon_sym_DASH] = ACTIONS(2682),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2682),
    [anon_sym_delete] = ACTIONS(2682),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2682),
    [sym_super] = ACTIONS(2682),
    [sym_true] = ACTIONS(2682),
    [sym_false] = ACTIONS(2682),
    [sym_null] = ACTIONS(2682),
    [sym_undefined] = ACTIONS(2682),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2682),
    [anon_sym_abstract] = ACTIONS(2682),
    [anon_sym_get] = ACTIONS(2682),
    [anon_sym_set] = ACTIONS(2682),
    [anon_sym_declare] = ACTIONS(2682),
    [anon_sym_public] = ACTIONS(2682),
    [anon_sym_private] = ACTIONS(2682),
    [anon_sym_protected] = ACTIONS(2682),
    [anon_sym_module] = ACTIONS(2682),
    [anon_sym_any] = ACTIONS(2682),
    [anon_sym_number] = ACTIONS(2682),
    [anon_sym_boolean] = ACTIONS(2682),
    [anon_sym_string] = ACTIONS(2682),
    [anon_sym_symbol] = ACTIONS(2682),
    [anon_sym_interface] = ACTIONS(2682),
    [anon_sym_enum] = ACTIONS(2682),
  },
  [516] = {
    [sym__call_signature] = STATE(2936),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2545),
    [anon_sym_export] = ACTIONS(2547),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2547),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2547),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(608),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_async] = ACTIONS(2547),
    [anon_sym_function] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2547),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2547),
    [anon_sym_get] = ACTIONS(2547),
    [anon_sym_set] = ACTIONS(2547),
    [anon_sym_declare] = ACTIONS(2547),
    [anon_sym_public] = ACTIONS(2547),
    [anon_sym_private] = ACTIONS(2547),
    [anon_sym_protected] = ACTIONS(2547),
    [anon_sym_module] = ACTIONS(2547),
    [anon_sym_any] = ACTIONS(2547),
    [anon_sym_number] = ACTIONS(2547),
    [anon_sym_boolean] = ACTIONS(2547),
    [anon_sym_string] = ACTIONS(2547),
    [anon_sym_symbol] = ACTIONS(2547),
  },
  [517] = {
    [ts_builtin_sym_end] = ACTIONS(2684),
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_default] = ACTIONS(2686),
    [anon_sym_namespace] = ACTIONS(2686),
    [anon_sym_LBRACE] = ACTIONS(2684),
    [anon_sym_RBRACE] = ACTIONS(2684),
    [anon_sym_type] = ACTIONS(2686),
    [anon_sym_typeof] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2686),
    [anon_sym_var] = ACTIONS(2686),
    [anon_sym_let] = ACTIONS(2686),
    [anon_sym_const] = ACTIONS(2686),
    [anon_sym_if] = ACTIONS(2686),
    [anon_sym_else] = ACTIONS(2686),
    [anon_sym_switch] = ACTIONS(2686),
    [anon_sym_for] = ACTIONS(2686),
    [anon_sym_LPAREN] = ACTIONS(2684),
    [anon_sym_await] = ACTIONS(2686),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_do] = ACTIONS(2686),
    [anon_sym_try] = ACTIONS(2686),
    [anon_sym_with] = ACTIONS(2686),
    [anon_sym_break] = ACTIONS(2686),
    [anon_sym_continue] = ACTIONS(2686),
    [anon_sym_debugger] = ACTIONS(2686),
    [anon_sym_return] = ACTIONS(2686),
    [anon_sym_throw] = ACTIONS(2686),
    [anon_sym_SEMI] = ACTIONS(2684),
    [anon_sym_case] = ACTIONS(2686),
    [anon_sym_yield] = ACTIONS(2686),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_LT] = ACTIONS(2684),
    [anon_sym_SLASH] = ACTIONS(2686),
    [anon_sym_class] = ACTIONS(2686),
    [anon_sym_async] = ACTIONS(2686),
    [anon_sym_function] = ACTIONS(2686),
    [anon_sym_new] = ACTIONS(2686),
    [anon_sym_PLUS] = ACTIONS(2686),
    [anon_sym_DASH] = ACTIONS(2686),
    [anon_sym_BANG] = ACTIONS(2684),
    [anon_sym_TILDE] = ACTIONS(2684),
    [anon_sym_void] = ACTIONS(2686),
    [anon_sym_delete] = ACTIONS(2686),
    [anon_sym_PLUS_PLUS] = ACTIONS(2684),
    [anon_sym_DASH_DASH] = ACTIONS(2684),
    [anon_sym_DQUOTE] = ACTIONS(2684),
    [anon_sym_SQUOTE] = ACTIONS(2684),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2684),
    [sym_number] = ACTIONS(2684),
    [sym_this] = ACTIONS(2686),
    [sym_super] = ACTIONS(2686),
    [sym_true] = ACTIONS(2686),
    [sym_false] = ACTIONS(2686),
    [sym_null] = ACTIONS(2686),
    [sym_undefined] = ACTIONS(2686),
    [anon_sym_AT] = ACTIONS(2684),
    [anon_sym_static] = ACTIONS(2686),
    [anon_sym_abstract] = ACTIONS(2686),
    [anon_sym_get] = ACTIONS(2686),
    [anon_sym_set] = ACTIONS(2686),
    [anon_sym_declare] = ACTIONS(2686),
    [anon_sym_public] = ACTIONS(2686),
    [anon_sym_private] = ACTIONS(2686),
    [anon_sym_protected] = ACTIONS(2686),
    [anon_sym_module] = ACTIONS(2686),
    [anon_sym_any] = ACTIONS(2686),
    [anon_sym_number] = ACTIONS(2686),
    [anon_sym_boolean] = ACTIONS(2686),
    [anon_sym_string] = ACTIONS(2686),
    [anon_sym_symbol] = ACTIONS(2686),
    [anon_sym_interface] = ACTIONS(2686),
    [anon_sym_enum] = ACTIONS(2686),
  },
  [518] = {
    [ts_builtin_sym_end] = ACTIONS(2688),
    [sym_identifier] = ACTIONS(2690),
    [anon_sym_export] = ACTIONS(2690),
    [anon_sym_default] = ACTIONS(2690),
    [anon_sym_namespace] = ACTIONS(2690),
    [anon_sym_LBRACE] = ACTIONS(2688),
    [anon_sym_RBRACE] = ACTIONS(2688),
    [anon_sym_type] = ACTIONS(2690),
    [anon_sym_typeof] = ACTIONS(2690),
    [anon_sym_import] = ACTIONS(2690),
    [anon_sym_var] = ACTIONS(2690),
    [anon_sym_let] = ACTIONS(2690),
    [anon_sym_const] = ACTIONS(2690),
    [anon_sym_if] = ACTIONS(2690),
    [anon_sym_else] = ACTIONS(2690),
    [anon_sym_switch] = ACTIONS(2690),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2688),
    [anon_sym_await] = ACTIONS(2690),
    [anon_sym_while] = ACTIONS(2690),
    [anon_sym_do] = ACTIONS(2690),
    [anon_sym_try] = ACTIONS(2690),
    [anon_sym_with] = ACTIONS(2690),
    [anon_sym_break] = ACTIONS(2690),
    [anon_sym_continue] = ACTIONS(2690),
    [anon_sym_debugger] = ACTIONS(2690),
    [anon_sym_return] = ACTIONS(2690),
    [anon_sym_throw] = ACTIONS(2690),
    [anon_sym_SEMI] = ACTIONS(2688),
    [anon_sym_case] = ACTIONS(2690),
    [anon_sym_yield] = ACTIONS(2690),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_LT] = ACTIONS(2688),
    [anon_sym_SLASH] = ACTIONS(2690),
    [anon_sym_class] = ACTIONS(2690),
    [anon_sym_async] = ACTIONS(2690),
    [anon_sym_function] = ACTIONS(2690),
    [anon_sym_new] = ACTIONS(2690),
    [anon_sym_PLUS] = ACTIONS(2690),
    [anon_sym_DASH] = ACTIONS(2690),
    [anon_sym_BANG] = ACTIONS(2688),
    [anon_sym_TILDE] = ACTIONS(2688),
    [anon_sym_void] = ACTIONS(2690),
    [anon_sym_delete] = ACTIONS(2690),
    [anon_sym_PLUS_PLUS] = ACTIONS(2688),
    [anon_sym_DASH_DASH] = ACTIONS(2688),
    [anon_sym_DQUOTE] = ACTIONS(2688),
    [anon_sym_SQUOTE] = ACTIONS(2688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2688),
    [sym_number] = ACTIONS(2688),
    [sym_this] = ACTIONS(2690),
    [sym_super] = ACTIONS(2690),
    [sym_true] = ACTIONS(2690),
    [sym_false] = ACTIONS(2690),
    [sym_null] = ACTIONS(2690),
    [sym_undefined] = ACTIONS(2690),
    [anon_sym_AT] = ACTIONS(2688),
    [anon_sym_static] = ACTIONS(2690),
    [anon_sym_abstract] = ACTIONS(2690),
    [anon_sym_get] = ACTIONS(2690),
    [anon_sym_set] = ACTIONS(2690),
    [anon_sym_declare] = ACTIONS(2690),
    [anon_sym_public] = ACTIONS(2690),
    [anon_sym_private] = ACTIONS(2690),
    [anon_sym_protected] = ACTIONS(2690),
    [anon_sym_module] = ACTIONS(2690),
    [anon_sym_any] = ACTIONS(2690),
    [anon_sym_number] = ACTIONS(2690),
    [anon_sym_boolean] = ACTIONS(2690),
    [anon_sym_string] = ACTIONS(2690),
    [anon_sym_symbol] = ACTIONS(2690),
    [anon_sym_interface] = ACTIONS(2690),
    [anon_sym_enum] = ACTIONS(2690),
  },
  [519] = {
    [ts_builtin_sym_end] = ACTIONS(1077),
    [sym_identifier] = ACTIONS(1079),
    [anon_sym_export] = ACTIONS(1079),
    [anon_sym_default] = ACTIONS(1079),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_type] = ACTIONS(1079),
    [anon_sym_typeof] = ACTIONS(1079),
    [anon_sym_import] = ACTIONS(1079),
    [anon_sym_var] = ACTIONS(1079),
    [anon_sym_let] = ACTIONS(1079),
    [anon_sym_const] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1079),
    [anon_sym_switch] = ACTIONS(1079),
    [anon_sym_for] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_while] = ACTIONS(1079),
    [anon_sym_do] = ACTIONS(1079),
    [anon_sym_try] = ACTIONS(1079),
    [anon_sym_with] = ACTIONS(1079),
    [anon_sym_break] = ACTIONS(1079),
    [anon_sym_continue] = ACTIONS(1079),
    [anon_sym_debugger] = ACTIONS(1079),
    [anon_sym_return] = ACTIONS(1079),
    [anon_sym_throw] = ACTIONS(1079),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_case] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1077),
    [anon_sym_SLASH] = ACTIONS(1079),
    [anon_sym_class] = ACTIONS(1079),
    [anon_sym_async] = ACTIONS(1079),
    [anon_sym_function] = ACTIONS(1079),
    [anon_sym_new] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(1079),
    [anon_sym_DASH] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [anon_sym_void] = ACTIONS(1079),
    [anon_sym_delete] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1077),
    [anon_sym_SQUOTE] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [sym_number] = ACTIONS(1077),
    [sym_this] = ACTIONS(1079),
    [sym_super] = ACTIONS(1079),
    [sym_true] = ACTIONS(1079),
    [sym_false] = ACTIONS(1079),
    [sym_null] = ACTIONS(1079),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1079),
    [anon_sym_abstract] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(1079),
    [anon_sym_set] = ACTIONS(1079),
    [anon_sym_declare] = ACTIONS(1079),
    [anon_sym_public] = ACTIONS(1079),
    [anon_sym_private] = ACTIONS(1079),
    [anon_sym_protected] = ACTIONS(1079),
    [anon_sym_module] = ACTIONS(1079),
    [anon_sym_any] = ACTIONS(1079),
    [anon_sym_number] = ACTIONS(1079),
    [anon_sym_boolean] = ACTIONS(1079),
    [anon_sym_string] = ACTIONS(1079),
    [anon_sym_symbol] = ACTIONS(1079),
    [anon_sym_interface] = ACTIONS(1079),
    [anon_sym_enum] = ACTIONS(1079),
  },
  [520] = {
    [ts_builtin_sym_end] = ACTIONS(2692),
    [sym_identifier] = ACTIONS(2694),
    [anon_sym_export] = ACTIONS(2694),
    [anon_sym_default] = ACTIONS(2694),
    [anon_sym_namespace] = ACTIONS(2694),
    [anon_sym_LBRACE] = ACTIONS(2692),
    [anon_sym_RBRACE] = ACTIONS(2692),
    [anon_sym_type] = ACTIONS(2694),
    [anon_sym_typeof] = ACTIONS(2694),
    [anon_sym_import] = ACTIONS(2694),
    [anon_sym_var] = ACTIONS(2694),
    [anon_sym_let] = ACTIONS(2694),
    [anon_sym_const] = ACTIONS(2694),
    [anon_sym_if] = ACTIONS(2694),
    [anon_sym_else] = ACTIONS(2694),
    [anon_sym_switch] = ACTIONS(2694),
    [anon_sym_for] = ACTIONS(2694),
    [anon_sym_LPAREN] = ACTIONS(2692),
    [anon_sym_await] = ACTIONS(2694),
    [anon_sym_while] = ACTIONS(2694),
    [anon_sym_do] = ACTIONS(2694),
    [anon_sym_try] = ACTIONS(2694),
    [anon_sym_with] = ACTIONS(2694),
    [anon_sym_break] = ACTIONS(2694),
    [anon_sym_continue] = ACTIONS(2694),
    [anon_sym_debugger] = ACTIONS(2694),
    [anon_sym_return] = ACTIONS(2694),
    [anon_sym_throw] = ACTIONS(2694),
    [anon_sym_SEMI] = ACTIONS(2692),
    [anon_sym_case] = ACTIONS(2694),
    [anon_sym_yield] = ACTIONS(2694),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_LT] = ACTIONS(2692),
    [anon_sym_SLASH] = ACTIONS(2694),
    [anon_sym_class] = ACTIONS(2694),
    [anon_sym_async] = ACTIONS(2694),
    [anon_sym_function] = ACTIONS(2694),
    [anon_sym_new] = ACTIONS(2694),
    [anon_sym_PLUS] = ACTIONS(2694),
    [anon_sym_DASH] = ACTIONS(2694),
    [anon_sym_BANG] = ACTIONS(2692),
    [anon_sym_TILDE] = ACTIONS(2692),
    [anon_sym_void] = ACTIONS(2694),
    [anon_sym_delete] = ACTIONS(2694),
    [anon_sym_PLUS_PLUS] = ACTIONS(2692),
    [anon_sym_DASH_DASH] = ACTIONS(2692),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [anon_sym_SQUOTE] = ACTIONS(2692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2692),
    [sym_number] = ACTIONS(2692),
    [sym_this] = ACTIONS(2694),
    [sym_super] = ACTIONS(2694),
    [sym_true] = ACTIONS(2694),
    [sym_false] = ACTIONS(2694),
    [sym_null] = ACTIONS(2694),
    [sym_undefined] = ACTIONS(2694),
    [anon_sym_AT] = ACTIONS(2692),
    [anon_sym_static] = ACTIONS(2694),
    [anon_sym_abstract] = ACTIONS(2694),
    [anon_sym_get] = ACTIONS(2694),
    [anon_sym_set] = ACTIONS(2694),
    [anon_sym_declare] = ACTIONS(2694),
    [anon_sym_public] = ACTIONS(2694),
    [anon_sym_private] = ACTIONS(2694),
    [anon_sym_protected] = ACTIONS(2694),
    [anon_sym_module] = ACTIONS(2694),
    [anon_sym_any] = ACTIONS(2694),
    [anon_sym_number] = ACTIONS(2694),
    [anon_sym_boolean] = ACTIONS(2694),
    [anon_sym_string] = ACTIONS(2694),
    [anon_sym_symbol] = ACTIONS(2694),
    [anon_sym_interface] = ACTIONS(2694),
    [anon_sym_enum] = ACTIONS(2694),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(2696),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_export] = ACTIONS(2698),
    [anon_sym_default] = ACTIONS(2698),
    [anon_sym_namespace] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2696),
    [anon_sym_RBRACE] = ACTIONS(2696),
    [anon_sym_type] = ACTIONS(2698),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_import] = ACTIONS(2698),
    [anon_sym_var] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_const] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_else] = ACTIONS(2698),
    [anon_sym_switch] = ACTIONS(2698),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_await] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_with] = ACTIONS(2698),
    [anon_sym_break] = ACTIONS(2698),
    [anon_sym_continue] = ACTIONS(2698),
    [anon_sym_debugger] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_throw] = ACTIONS(2698),
    [anon_sym_SEMI] = ACTIONS(2696),
    [anon_sym_case] = ACTIONS(2698),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_LT] = ACTIONS(2696),
    [anon_sym_SLASH] = ACTIONS(2698),
    [anon_sym_class] = ACTIONS(2698),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2696),
    [anon_sym_TILDE] = ACTIONS(2696),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_delete] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2696),
    [anon_sym_DASH_DASH] = ACTIONS(2696),
    [anon_sym_DQUOTE] = ACTIONS(2696),
    [anon_sym_SQUOTE] = ACTIONS(2696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2696),
    [sym_number] = ACTIONS(2696),
    [sym_this] = ACTIONS(2698),
    [sym_super] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_AT] = ACTIONS(2696),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_get] = ACTIONS(2698),
    [anon_sym_set] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2698),
    [anon_sym_public] = ACTIONS(2698),
    [anon_sym_private] = ACTIONS(2698),
    [anon_sym_protected] = ACTIONS(2698),
    [anon_sym_module] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_interface] = ACTIONS(2698),
    [anon_sym_enum] = ACTIONS(2698),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(2700),
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_default] = ACTIONS(2702),
    [anon_sym_namespace] = ACTIONS(2702),
    [anon_sym_LBRACE] = ACTIONS(2700),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_type] = ACTIONS(2702),
    [anon_sym_typeof] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_var] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_else] = ACTIONS(2702),
    [anon_sym_switch] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2700),
    [anon_sym_await] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [anon_sym_do] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_with] = ACTIONS(2702),
    [anon_sym_break] = ACTIONS(2702),
    [anon_sym_continue] = ACTIONS(2702),
    [anon_sym_debugger] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_throw] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_case] = ACTIONS(2702),
    [anon_sym_yield] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_SLASH] = ACTIONS(2702),
    [anon_sym_class] = ACTIONS(2702),
    [anon_sym_async] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_DASH] = ACTIONS(2702),
    [anon_sym_BANG] = ACTIONS(2700),
    [anon_sym_TILDE] = ACTIONS(2700),
    [anon_sym_void] = ACTIONS(2702),
    [anon_sym_delete] = ACTIONS(2702),
    [anon_sym_PLUS_PLUS] = ACTIONS(2700),
    [anon_sym_DASH_DASH] = ACTIONS(2700),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2702),
    [sym_super] = ACTIONS(2702),
    [sym_true] = ACTIONS(2702),
    [sym_false] = ACTIONS(2702),
    [sym_null] = ACTIONS(2702),
    [sym_undefined] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2700),
    [anon_sym_static] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_get] = ACTIONS(2702),
    [anon_sym_set] = ACTIONS(2702),
    [anon_sym_declare] = ACTIONS(2702),
    [anon_sym_public] = ACTIONS(2702),
    [anon_sym_private] = ACTIONS(2702),
    [anon_sym_protected] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_any] = ACTIONS(2702),
    [anon_sym_number] = ACTIONS(2702),
    [anon_sym_boolean] = ACTIONS(2702),
    [anon_sym_string] = ACTIONS(2702),
    [anon_sym_symbol] = ACTIONS(2702),
    [anon_sym_interface] = ACTIONS(2702),
    [anon_sym_enum] = ACTIONS(2702),
  },
  [523] = {
    [ts_builtin_sym_end] = ACTIONS(2704),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_export] = ACTIONS(2706),
    [anon_sym_default] = ACTIONS(2706),
    [anon_sym_namespace] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2704),
    [anon_sym_RBRACE] = ACTIONS(2704),
    [anon_sym_type] = ACTIONS(2706),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_import] = ACTIONS(2706),
    [anon_sym_var] = ACTIONS(2706),
    [anon_sym_let] = ACTIONS(2706),
    [anon_sym_const] = ACTIONS(2706),
    [anon_sym_if] = ACTIONS(2706),
    [anon_sym_else] = ACTIONS(2706),
    [anon_sym_switch] = ACTIONS(2706),
    [anon_sym_for] = ACTIONS(2706),
    [anon_sym_LPAREN] = ACTIONS(2704),
    [anon_sym_await] = ACTIONS(2706),
    [anon_sym_while] = ACTIONS(2706),
    [anon_sym_do] = ACTIONS(2706),
    [anon_sym_try] = ACTIONS(2706),
    [anon_sym_with] = ACTIONS(2706),
    [anon_sym_break] = ACTIONS(2706),
    [anon_sym_continue] = ACTIONS(2706),
    [anon_sym_debugger] = ACTIONS(2706),
    [anon_sym_return] = ACTIONS(2706),
    [anon_sym_throw] = ACTIONS(2706),
    [anon_sym_SEMI] = ACTIONS(2704),
    [anon_sym_case] = ACTIONS(2706),
    [anon_sym_yield] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(2704),
    [anon_sym_LT] = ACTIONS(2704),
    [anon_sym_SLASH] = ACTIONS(2706),
    [anon_sym_class] = ACTIONS(2706),
    [anon_sym_async] = ACTIONS(2706),
    [anon_sym_function] = ACTIONS(2706),
    [anon_sym_new] = ACTIONS(2706),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2704),
    [anon_sym_DASH_DASH] = ACTIONS(2704),
    [anon_sym_DQUOTE] = ACTIONS(2704),
    [anon_sym_SQUOTE] = ACTIONS(2704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2704),
    [sym_number] = ACTIONS(2704),
    [sym_this] = ACTIONS(2706),
    [sym_super] = ACTIONS(2706),
    [sym_true] = ACTIONS(2706),
    [sym_false] = ACTIONS(2706),
    [sym_null] = ACTIONS(2706),
    [sym_undefined] = ACTIONS(2706),
    [anon_sym_AT] = ACTIONS(2704),
    [anon_sym_static] = ACTIONS(2706),
    [anon_sym_abstract] = ACTIONS(2706),
    [anon_sym_get] = ACTIONS(2706),
    [anon_sym_set] = ACTIONS(2706),
    [anon_sym_declare] = ACTIONS(2706),
    [anon_sym_public] = ACTIONS(2706),
    [anon_sym_private] = ACTIONS(2706),
    [anon_sym_protected] = ACTIONS(2706),
    [anon_sym_module] = ACTIONS(2706),
    [anon_sym_any] = ACTIONS(2706),
    [anon_sym_number] = ACTIONS(2706),
    [anon_sym_boolean] = ACTIONS(2706),
    [anon_sym_string] = ACTIONS(2706),
    [anon_sym_symbol] = ACTIONS(2706),
    [anon_sym_interface] = ACTIONS(2706),
    [anon_sym_enum] = ACTIONS(2706),
  },
  [524] = {
    [ts_builtin_sym_end] = ACTIONS(2708),
    [sym_identifier] = ACTIONS(2710),
    [anon_sym_export] = ACTIONS(2710),
    [anon_sym_default] = ACTIONS(2710),
    [anon_sym_namespace] = ACTIONS(2710),
    [anon_sym_LBRACE] = ACTIONS(2708),
    [anon_sym_RBRACE] = ACTIONS(2708),
    [anon_sym_type] = ACTIONS(2710),
    [anon_sym_typeof] = ACTIONS(2710),
    [anon_sym_import] = ACTIONS(2710),
    [anon_sym_var] = ACTIONS(2710),
    [anon_sym_let] = ACTIONS(2710),
    [anon_sym_const] = ACTIONS(2710),
    [anon_sym_if] = ACTIONS(2710),
    [anon_sym_else] = ACTIONS(2710),
    [anon_sym_switch] = ACTIONS(2710),
    [anon_sym_for] = ACTIONS(2710),
    [anon_sym_LPAREN] = ACTIONS(2708),
    [anon_sym_await] = ACTIONS(2710),
    [anon_sym_while] = ACTIONS(2710),
    [anon_sym_do] = ACTIONS(2710),
    [anon_sym_try] = ACTIONS(2710),
    [anon_sym_with] = ACTIONS(2710),
    [anon_sym_break] = ACTIONS(2710),
    [anon_sym_continue] = ACTIONS(2710),
    [anon_sym_debugger] = ACTIONS(2710),
    [anon_sym_return] = ACTIONS(2710),
    [anon_sym_throw] = ACTIONS(2710),
    [anon_sym_SEMI] = ACTIONS(2708),
    [anon_sym_case] = ACTIONS(2710),
    [anon_sym_yield] = ACTIONS(2710),
    [anon_sym_LBRACK] = ACTIONS(2708),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_SLASH] = ACTIONS(2710),
    [anon_sym_class] = ACTIONS(2710),
    [anon_sym_async] = ACTIONS(2710),
    [anon_sym_function] = ACTIONS(2710),
    [anon_sym_new] = ACTIONS(2710),
    [anon_sym_PLUS] = ACTIONS(2710),
    [anon_sym_DASH] = ACTIONS(2710),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_void] = ACTIONS(2710),
    [anon_sym_delete] = ACTIONS(2710),
    [anon_sym_PLUS_PLUS] = ACTIONS(2708),
    [anon_sym_DASH_DASH] = ACTIONS(2708),
    [anon_sym_DQUOTE] = ACTIONS(2708),
    [anon_sym_SQUOTE] = ACTIONS(2708),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2708),
    [sym_number] = ACTIONS(2708),
    [sym_this] = ACTIONS(2710),
    [sym_super] = ACTIONS(2710),
    [sym_true] = ACTIONS(2710),
    [sym_false] = ACTIONS(2710),
    [sym_null] = ACTIONS(2710),
    [sym_undefined] = ACTIONS(2710),
    [anon_sym_AT] = ACTIONS(2708),
    [anon_sym_static] = ACTIONS(2710),
    [anon_sym_abstract] = ACTIONS(2710),
    [anon_sym_get] = ACTIONS(2710),
    [anon_sym_set] = ACTIONS(2710),
    [anon_sym_declare] = ACTIONS(2710),
    [anon_sym_public] = ACTIONS(2710),
    [anon_sym_private] = ACTIONS(2710),
    [anon_sym_protected] = ACTIONS(2710),
    [anon_sym_module] = ACTIONS(2710),
    [anon_sym_any] = ACTIONS(2710),
    [anon_sym_number] = ACTIONS(2710),
    [anon_sym_boolean] = ACTIONS(2710),
    [anon_sym_string] = ACTIONS(2710),
    [anon_sym_symbol] = ACTIONS(2710),
    [anon_sym_interface] = ACTIONS(2710),
    [anon_sym_enum] = ACTIONS(2710),
  },
  [525] = {
    [ts_builtin_sym_end] = ACTIONS(2712),
    [sym_identifier] = ACTIONS(2714),
    [anon_sym_export] = ACTIONS(2714),
    [anon_sym_default] = ACTIONS(2714),
    [anon_sym_namespace] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(2712),
    [anon_sym_RBRACE] = ACTIONS(2712),
    [anon_sym_type] = ACTIONS(2714),
    [anon_sym_typeof] = ACTIONS(2714),
    [anon_sym_import] = ACTIONS(2714),
    [anon_sym_var] = ACTIONS(2714),
    [anon_sym_let] = ACTIONS(2714),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_if] = ACTIONS(2714),
    [anon_sym_else] = ACTIONS(2714),
    [anon_sym_switch] = ACTIONS(2714),
    [anon_sym_for] = ACTIONS(2714),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [anon_sym_await] = ACTIONS(2714),
    [anon_sym_while] = ACTIONS(2714),
    [anon_sym_do] = ACTIONS(2714),
    [anon_sym_try] = ACTIONS(2714),
    [anon_sym_with] = ACTIONS(2714),
    [anon_sym_break] = ACTIONS(2714),
    [anon_sym_continue] = ACTIONS(2714),
    [anon_sym_debugger] = ACTIONS(2714),
    [anon_sym_return] = ACTIONS(2714),
    [anon_sym_throw] = ACTIONS(2714),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_case] = ACTIONS(2714),
    [anon_sym_yield] = ACTIONS(2714),
    [anon_sym_LBRACK] = ACTIONS(2712),
    [anon_sym_LT] = ACTIONS(2712),
    [anon_sym_SLASH] = ACTIONS(2714),
    [anon_sym_class] = ACTIONS(2714),
    [anon_sym_async] = ACTIONS(2714),
    [anon_sym_function] = ACTIONS(2714),
    [anon_sym_new] = ACTIONS(2714),
    [anon_sym_PLUS] = ACTIONS(2714),
    [anon_sym_DASH] = ACTIONS(2714),
    [anon_sym_BANG] = ACTIONS(2712),
    [anon_sym_TILDE] = ACTIONS(2712),
    [anon_sym_void] = ACTIONS(2714),
    [anon_sym_delete] = ACTIONS(2714),
    [anon_sym_PLUS_PLUS] = ACTIONS(2712),
    [anon_sym_DASH_DASH] = ACTIONS(2712),
    [anon_sym_DQUOTE] = ACTIONS(2712),
    [anon_sym_SQUOTE] = ACTIONS(2712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2712),
    [sym_number] = ACTIONS(2712),
    [sym_this] = ACTIONS(2714),
    [sym_super] = ACTIONS(2714),
    [sym_true] = ACTIONS(2714),
    [sym_false] = ACTIONS(2714),
    [sym_null] = ACTIONS(2714),
    [sym_undefined] = ACTIONS(2714),
    [anon_sym_AT] = ACTIONS(2712),
    [anon_sym_static] = ACTIONS(2714),
    [anon_sym_abstract] = ACTIONS(2714),
    [anon_sym_get] = ACTIONS(2714),
    [anon_sym_set] = ACTIONS(2714),
    [anon_sym_declare] = ACTIONS(2714),
    [anon_sym_public] = ACTIONS(2714),
    [anon_sym_private] = ACTIONS(2714),
    [anon_sym_protected] = ACTIONS(2714),
    [anon_sym_module] = ACTIONS(2714),
    [anon_sym_any] = ACTIONS(2714),
    [anon_sym_number] = ACTIONS(2714),
    [anon_sym_boolean] = ACTIONS(2714),
    [anon_sym_string] = ACTIONS(2714),
    [anon_sym_symbol] = ACTIONS(2714),
    [anon_sym_interface] = ACTIONS(2714),
    [anon_sym_enum] = ACTIONS(2714),
  },
  [526] = {
    [ts_builtin_sym_end] = ACTIONS(2716),
    [sym_identifier] = ACTIONS(2718),
    [anon_sym_export] = ACTIONS(2718),
    [anon_sym_default] = ACTIONS(2718),
    [anon_sym_namespace] = ACTIONS(2718),
    [anon_sym_LBRACE] = ACTIONS(2716),
    [anon_sym_RBRACE] = ACTIONS(2716),
    [anon_sym_type] = ACTIONS(2718),
    [anon_sym_typeof] = ACTIONS(2718),
    [anon_sym_import] = ACTIONS(2718),
    [anon_sym_var] = ACTIONS(2718),
    [anon_sym_let] = ACTIONS(2718),
    [anon_sym_const] = ACTIONS(2718),
    [anon_sym_if] = ACTIONS(2718),
    [anon_sym_else] = ACTIONS(2718),
    [anon_sym_switch] = ACTIONS(2718),
    [anon_sym_for] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(2716),
    [anon_sym_await] = ACTIONS(2718),
    [anon_sym_while] = ACTIONS(2718),
    [anon_sym_do] = ACTIONS(2718),
    [anon_sym_try] = ACTIONS(2718),
    [anon_sym_with] = ACTIONS(2718),
    [anon_sym_break] = ACTIONS(2718),
    [anon_sym_continue] = ACTIONS(2718),
    [anon_sym_debugger] = ACTIONS(2718),
    [anon_sym_return] = ACTIONS(2718),
    [anon_sym_throw] = ACTIONS(2718),
    [anon_sym_SEMI] = ACTIONS(2716),
    [anon_sym_case] = ACTIONS(2718),
    [anon_sym_yield] = ACTIONS(2718),
    [anon_sym_LBRACK] = ACTIONS(2716),
    [anon_sym_LT] = ACTIONS(2716),
    [anon_sym_SLASH] = ACTIONS(2718),
    [anon_sym_class] = ACTIONS(2718),
    [anon_sym_async] = ACTIONS(2718),
    [anon_sym_function] = ACTIONS(2718),
    [anon_sym_new] = ACTIONS(2718),
    [anon_sym_PLUS] = ACTIONS(2718),
    [anon_sym_DASH] = ACTIONS(2718),
    [anon_sym_BANG] = ACTIONS(2716),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_void] = ACTIONS(2718),
    [anon_sym_delete] = ACTIONS(2718),
    [anon_sym_PLUS_PLUS] = ACTIONS(2716),
    [anon_sym_DASH_DASH] = ACTIONS(2716),
    [anon_sym_DQUOTE] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2716),
    [sym_number] = ACTIONS(2716),
    [sym_this] = ACTIONS(2718),
    [sym_super] = ACTIONS(2718),
    [sym_true] = ACTIONS(2718),
    [sym_false] = ACTIONS(2718),
    [sym_null] = ACTIONS(2718),
    [sym_undefined] = ACTIONS(2718),
    [anon_sym_AT] = ACTIONS(2716),
    [anon_sym_static] = ACTIONS(2718),
    [anon_sym_abstract] = ACTIONS(2718),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
    [anon_sym_declare] = ACTIONS(2718),
    [anon_sym_public] = ACTIONS(2718),
    [anon_sym_private] = ACTIONS(2718),
    [anon_sym_protected] = ACTIONS(2718),
    [anon_sym_module] = ACTIONS(2718),
    [anon_sym_any] = ACTIONS(2718),
    [anon_sym_number] = ACTIONS(2718),
    [anon_sym_boolean] = ACTIONS(2718),
    [anon_sym_string] = ACTIONS(2718),
    [anon_sym_symbol] = ACTIONS(2718),
    [anon_sym_interface] = ACTIONS(2718),
    [anon_sym_enum] = ACTIONS(2718),
  },
  [527] = {
    [ts_builtin_sym_end] = ACTIONS(2720),
    [sym_identifier] = ACTIONS(2722),
    [anon_sym_export] = ACTIONS(2722),
    [anon_sym_default] = ACTIONS(2722),
    [anon_sym_namespace] = ACTIONS(2722),
    [anon_sym_LBRACE] = ACTIONS(2720),
    [anon_sym_RBRACE] = ACTIONS(2720),
    [anon_sym_type] = ACTIONS(2722),
    [anon_sym_typeof] = ACTIONS(2722),
    [anon_sym_import] = ACTIONS(2722),
    [anon_sym_var] = ACTIONS(2722),
    [anon_sym_let] = ACTIONS(2722),
    [anon_sym_const] = ACTIONS(2722),
    [anon_sym_if] = ACTIONS(2722),
    [anon_sym_else] = ACTIONS(2722),
    [anon_sym_switch] = ACTIONS(2722),
    [anon_sym_for] = ACTIONS(2722),
    [anon_sym_LPAREN] = ACTIONS(2720),
    [anon_sym_await] = ACTIONS(2722),
    [anon_sym_while] = ACTIONS(2722),
    [anon_sym_do] = ACTIONS(2722),
    [anon_sym_try] = ACTIONS(2722),
    [anon_sym_with] = ACTIONS(2722),
    [anon_sym_break] = ACTIONS(2722),
    [anon_sym_continue] = ACTIONS(2722),
    [anon_sym_debugger] = ACTIONS(2722),
    [anon_sym_return] = ACTIONS(2722),
    [anon_sym_throw] = ACTIONS(2722),
    [anon_sym_SEMI] = ACTIONS(2720),
    [anon_sym_case] = ACTIONS(2722),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(2720),
    [anon_sym_LT] = ACTIONS(2720),
    [anon_sym_SLASH] = ACTIONS(2722),
    [anon_sym_class] = ACTIONS(2722),
    [anon_sym_async] = ACTIONS(2722),
    [anon_sym_function] = ACTIONS(2722),
    [anon_sym_new] = ACTIONS(2722),
    [anon_sym_PLUS] = ACTIONS(2722),
    [anon_sym_DASH] = ACTIONS(2722),
    [anon_sym_BANG] = ACTIONS(2720),
    [anon_sym_TILDE] = ACTIONS(2720),
    [anon_sym_void] = ACTIONS(2722),
    [anon_sym_delete] = ACTIONS(2722),
    [anon_sym_PLUS_PLUS] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(2720),
    [anon_sym_DQUOTE] = ACTIONS(2720),
    [anon_sym_SQUOTE] = ACTIONS(2720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2720),
    [sym_number] = ACTIONS(2720),
    [sym_this] = ACTIONS(2722),
    [sym_super] = ACTIONS(2722),
    [sym_true] = ACTIONS(2722),
    [sym_false] = ACTIONS(2722),
    [sym_null] = ACTIONS(2722),
    [sym_undefined] = ACTIONS(2722),
    [anon_sym_AT] = ACTIONS(2720),
    [anon_sym_static] = ACTIONS(2722),
    [anon_sym_abstract] = ACTIONS(2722),
    [anon_sym_get] = ACTIONS(2722),
    [anon_sym_set] = ACTIONS(2722),
    [anon_sym_declare] = ACTIONS(2722),
    [anon_sym_public] = ACTIONS(2722),
    [anon_sym_private] = ACTIONS(2722),
    [anon_sym_protected] = ACTIONS(2722),
    [anon_sym_module] = ACTIONS(2722),
    [anon_sym_any] = ACTIONS(2722),
    [anon_sym_number] = ACTIONS(2722),
    [anon_sym_boolean] = ACTIONS(2722),
    [anon_sym_string] = ACTIONS(2722),
    [anon_sym_symbol] = ACTIONS(2722),
    [anon_sym_interface] = ACTIONS(2722),
    [anon_sym_enum] = ACTIONS(2722),
  },
  [528] = {
    [ts_builtin_sym_end] = ACTIONS(2724),
    [sym_identifier] = ACTIONS(2726),
    [anon_sym_export] = ACTIONS(2726),
    [anon_sym_default] = ACTIONS(2726),
    [anon_sym_namespace] = ACTIONS(2726),
    [anon_sym_LBRACE] = ACTIONS(2724),
    [anon_sym_RBRACE] = ACTIONS(2724),
    [anon_sym_type] = ACTIONS(2726),
    [anon_sym_typeof] = ACTIONS(2726),
    [anon_sym_import] = ACTIONS(2726),
    [anon_sym_var] = ACTIONS(2726),
    [anon_sym_let] = ACTIONS(2726),
    [anon_sym_const] = ACTIONS(2726),
    [anon_sym_if] = ACTIONS(2726),
    [anon_sym_else] = ACTIONS(2726),
    [anon_sym_switch] = ACTIONS(2726),
    [anon_sym_for] = ACTIONS(2726),
    [anon_sym_LPAREN] = ACTIONS(2724),
    [anon_sym_await] = ACTIONS(2726),
    [anon_sym_while] = ACTIONS(2726),
    [anon_sym_do] = ACTIONS(2726),
    [anon_sym_try] = ACTIONS(2726),
    [anon_sym_with] = ACTIONS(2726),
    [anon_sym_break] = ACTIONS(2726),
    [anon_sym_continue] = ACTIONS(2726),
    [anon_sym_debugger] = ACTIONS(2726),
    [anon_sym_return] = ACTIONS(2726),
    [anon_sym_throw] = ACTIONS(2726),
    [anon_sym_SEMI] = ACTIONS(2724),
    [anon_sym_case] = ACTIONS(2726),
    [anon_sym_yield] = ACTIONS(2726),
    [anon_sym_LBRACK] = ACTIONS(2724),
    [anon_sym_LT] = ACTIONS(2724),
    [anon_sym_SLASH] = ACTIONS(2726),
    [anon_sym_class] = ACTIONS(2726),
    [anon_sym_async] = ACTIONS(2726),
    [anon_sym_function] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2726),
    [anon_sym_PLUS] = ACTIONS(2726),
    [anon_sym_DASH] = ACTIONS(2726),
    [anon_sym_BANG] = ACTIONS(2724),
    [anon_sym_TILDE] = ACTIONS(2724),
    [anon_sym_void] = ACTIONS(2726),
    [anon_sym_delete] = ACTIONS(2726),
    [anon_sym_PLUS_PLUS] = ACTIONS(2724),
    [anon_sym_DASH_DASH] = ACTIONS(2724),
    [anon_sym_DQUOTE] = ACTIONS(2724),
    [anon_sym_SQUOTE] = ACTIONS(2724),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2724),
    [sym_number] = ACTIONS(2724),
    [sym_this] = ACTIONS(2726),
    [sym_super] = ACTIONS(2726),
    [sym_true] = ACTIONS(2726),
    [sym_false] = ACTIONS(2726),
    [sym_null] = ACTIONS(2726),
    [sym_undefined] = ACTIONS(2726),
    [anon_sym_AT] = ACTIONS(2724),
    [anon_sym_static] = ACTIONS(2726),
    [anon_sym_abstract] = ACTIONS(2726),
    [anon_sym_get] = ACTIONS(2726),
    [anon_sym_set] = ACTIONS(2726),
    [anon_sym_declare] = ACTIONS(2726),
    [anon_sym_public] = ACTIONS(2726),
    [anon_sym_private] = ACTIONS(2726),
    [anon_sym_protected] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2726),
    [anon_sym_any] = ACTIONS(2726),
    [anon_sym_number] = ACTIONS(2726),
    [anon_sym_boolean] = ACTIONS(2726),
    [anon_sym_string] = ACTIONS(2726),
    [anon_sym_symbol] = ACTIONS(2726),
    [anon_sym_interface] = ACTIONS(2726),
    [anon_sym_enum] = ACTIONS(2726),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(2728),
    [sym_identifier] = ACTIONS(2730),
    [anon_sym_export] = ACTIONS(2730),
    [anon_sym_default] = ACTIONS(2730),
    [anon_sym_namespace] = ACTIONS(2730),
    [anon_sym_LBRACE] = ACTIONS(2728),
    [anon_sym_RBRACE] = ACTIONS(2728),
    [anon_sym_type] = ACTIONS(2730),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_import] = ACTIONS(2730),
    [anon_sym_var] = ACTIONS(2730),
    [anon_sym_let] = ACTIONS(2730),
    [anon_sym_const] = ACTIONS(2730),
    [anon_sym_if] = ACTIONS(2730),
    [anon_sym_else] = ACTIONS(2732),
    [anon_sym_switch] = ACTIONS(2730),
    [anon_sym_for] = ACTIONS(2730),
    [anon_sym_LPAREN] = ACTIONS(2728),
    [anon_sym_await] = ACTIONS(2730),
    [anon_sym_while] = ACTIONS(2730),
    [anon_sym_do] = ACTIONS(2730),
    [anon_sym_try] = ACTIONS(2730),
    [anon_sym_with] = ACTIONS(2730),
    [anon_sym_break] = ACTIONS(2730),
    [anon_sym_continue] = ACTIONS(2730),
    [anon_sym_debugger] = ACTIONS(2730),
    [anon_sym_return] = ACTIONS(2730),
    [anon_sym_throw] = ACTIONS(2730),
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_case] = ACTIONS(2730),
    [anon_sym_yield] = ACTIONS(2730),
    [anon_sym_LBRACK] = ACTIONS(2728),
    [anon_sym_LT] = ACTIONS(2728),
    [anon_sym_SLASH] = ACTIONS(2730),
    [anon_sym_class] = ACTIONS(2730),
    [anon_sym_async] = ACTIONS(2730),
    [anon_sym_function] = ACTIONS(2730),
    [anon_sym_new] = ACTIONS(2730),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2728),
    [anon_sym_TILDE] = ACTIONS(2728),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2728),
    [anon_sym_DASH_DASH] = ACTIONS(2728),
    [anon_sym_DQUOTE] = ACTIONS(2728),
    [anon_sym_SQUOTE] = ACTIONS(2728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2728),
    [sym_number] = ACTIONS(2728),
    [sym_this] = ACTIONS(2730),
    [sym_super] = ACTIONS(2730),
    [sym_true] = ACTIONS(2730),
    [sym_false] = ACTIONS(2730),
    [sym_null] = ACTIONS(2730),
    [sym_undefined] = ACTIONS(2730),
    [anon_sym_AT] = ACTIONS(2728),
    [anon_sym_static] = ACTIONS(2730),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_get] = ACTIONS(2730),
    [anon_sym_set] = ACTIONS(2730),
    [anon_sym_declare] = ACTIONS(2730),
    [anon_sym_public] = ACTIONS(2730),
    [anon_sym_private] = ACTIONS(2730),
    [anon_sym_protected] = ACTIONS(2730),
    [anon_sym_module] = ACTIONS(2730),
    [anon_sym_any] = ACTIONS(2730),
    [anon_sym_number] = ACTIONS(2730),
    [anon_sym_boolean] = ACTIONS(2730),
    [anon_sym_string] = ACTIONS(2730),
    [anon_sym_symbol] = ACTIONS(2730),
    [anon_sym_interface] = ACTIONS(2730),
    [anon_sym_enum] = ACTIONS(2730),
  },
  [530] = {
    [sym__call_signature] = STATE(2835),
    [sym_arguments] = STATE(1032),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2734),
    [anon_sym_export] = ACTIONS(2736),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(2736),
    [anon_sym_type] = ACTIONS(2736),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_COLON] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_async] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_void] = ACTIONS(2736),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_static] = ACTIONS(2736),
    [anon_sym_get] = ACTIONS(2736),
    [anon_sym_set] = ACTIONS(2736),
    [anon_sym_declare] = ACTIONS(2736),
    [anon_sym_public] = ACTIONS(2736),
    [anon_sym_private] = ACTIONS(2736),
    [anon_sym_protected] = ACTIONS(2736),
    [anon_sym_module] = ACTIONS(2736),
    [anon_sym_any] = ACTIONS(2736),
    [anon_sym_number] = ACTIONS(2736),
    [anon_sym_boolean] = ACTIONS(2736),
    [anon_sym_string] = ACTIONS(2736),
    [anon_sym_symbol] = ACTIONS(2736),
  },
  [531] = {
    [ts_builtin_sym_end] = ACTIONS(2738),
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_export] = ACTIONS(2740),
    [anon_sym_default] = ACTIONS(2740),
    [anon_sym_namespace] = ACTIONS(2740),
    [anon_sym_LBRACE] = ACTIONS(2738),
    [anon_sym_RBRACE] = ACTIONS(2738),
    [anon_sym_type] = ACTIONS(2740),
    [anon_sym_typeof] = ACTIONS(2740),
    [anon_sym_import] = ACTIONS(2740),
    [anon_sym_var] = ACTIONS(2740),
    [anon_sym_let] = ACTIONS(2740),
    [anon_sym_const] = ACTIONS(2740),
    [anon_sym_if] = ACTIONS(2740),
    [anon_sym_else] = ACTIONS(2740),
    [anon_sym_switch] = ACTIONS(2740),
    [anon_sym_for] = ACTIONS(2740),
    [anon_sym_LPAREN] = ACTIONS(2738),
    [anon_sym_await] = ACTIONS(2740),
    [anon_sym_while] = ACTIONS(2740),
    [anon_sym_do] = ACTIONS(2740),
    [anon_sym_try] = ACTIONS(2740),
    [anon_sym_with] = ACTIONS(2740),
    [anon_sym_break] = ACTIONS(2740),
    [anon_sym_continue] = ACTIONS(2740),
    [anon_sym_debugger] = ACTIONS(2740),
    [anon_sym_return] = ACTIONS(2740),
    [anon_sym_throw] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2738),
    [anon_sym_case] = ACTIONS(2740),
    [anon_sym_yield] = ACTIONS(2740),
    [anon_sym_LBRACK] = ACTIONS(2738),
    [anon_sym_LT] = ACTIONS(2738),
    [anon_sym_SLASH] = ACTIONS(2740),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_async] = ACTIONS(2740),
    [anon_sym_function] = ACTIONS(2740),
    [anon_sym_new] = ACTIONS(2740),
    [anon_sym_PLUS] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2738),
    [anon_sym_TILDE] = ACTIONS(2738),
    [anon_sym_void] = ACTIONS(2740),
    [anon_sym_delete] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2738),
    [anon_sym_DASH_DASH] = ACTIONS(2738),
    [anon_sym_DQUOTE] = ACTIONS(2738),
    [anon_sym_SQUOTE] = ACTIONS(2738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2738),
    [sym_number] = ACTIONS(2738),
    [sym_this] = ACTIONS(2740),
    [sym_super] = ACTIONS(2740),
    [sym_true] = ACTIONS(2740),
    [sym_false] = ACTIONS(2740),
    [sym_null] = ACTIONS(2740),
    [sym_undefined] = ACTIONS(2740),
    [anon_sym_AT] = ACTIONS(2738),
    [anon_sym_static] = ACTIONS(2740),
    [anon_sym_abstract] = ACTIONS(2740),
    [anon_sym_get] = ACTIONS(2740),
    [anon_sym_set] = ACTIONS(2740),
    [anon_sym_declare] = ACTIONS(2740),
    [anon_sym_public] = ACTIONS(2740),
    [anon_sym_private] = ACTIONS(2740),
    [anon_sym_protected] = ACTIONS(2740),
    [anon_sym_module] = ACTIONS(2740),
    [anon_sym_any] = ACTIONS(2740),
    [anon_sym_number] = ACTIONS(2740),
    [anon_sym_boolean] = ACTIONS(2740),
    [anon_sym_string] = ACTIONS(2740),
    [anon_sym_symbol] = ACTIONS(2740),
    [anon_sym_interface] = ACTIONS(2740),
    [anon_sym_enum] = ACTIONS(2740),
  },
  [532] = {
    [ts_builtin_sym_end] = ACTIONS(2742),
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_namespace] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2742),
    [anon_sym_RBRACE] = ACTIONS(2742),
    [anon_sym_type] = ACTIONS(2744),
    [anon_sym_typeof] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_var] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_else] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2742),
    [anon_sym_await] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_with] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_debugger] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_throw] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_yield] = ACTIONS(2744),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_SLASH] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_BANG] = ACTIONS(2742),
    [anon_sym_TILDE] = ACTIONS(2742),
    [anon_sym_void] = ACTIONS(2744),
    [anon_sym_delete] = ACTIONS(2744),
    [anon_sym_PLUS_PLUS] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2742),
    [anon_sym_DQUOTE] = ACTIONS(2742),
    [anon_sym_SQUOTE] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2742),
    [sym_number] = ACTIONS(2742),
    [sym_this] = ACTIONS(2744),
    [sym_super] = ACTIONS(2744),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [sym_null] = ACTIONS(2744),
    [sym_undefined] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_get] = ACTIONS(2744),
    [anon_sym_set] = ACTIONS(2744),
    [anon_sym_declare] = ACTIONS(2744),
    [anon_sym_public] = ACTIONS(2744),
    [anon_sym_private] = ACTIONS(2744),
    [anon_sym_protected] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_any] = ACTIONS(2744),
    [anon_sym_number] = ACTIONS(2744),
    [anon_sym_boolean] = ACTIONS(2744),
    [anon_sym_string] = ACTIONS(2744),
    [anon_sym_symbol] = ACTIONS(2744),
    [anon_sym_interface] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
  },
  [533] = {
    [ts_builtin_sym_end] = ACTIONS(2746),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_export] = ACTIONS(2748),
    [anon_sym_default] = ACTIONS(2748),
    [anon_sym_namespace] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_type] = ACTIONS(2748),
    [anon_sym_typeof] = ACTIONS(2748),
    [anon_sym_import] = ACTIONS(2748),
    [anon_sym_var] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_const] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_switch] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [anon_sym_await] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_with] = ACTIONS(2748),
    [anon_sym_break] = ACTIONS(2748),
    [anon_sym_continue] = ACTIONS(2748),
    [anon_sym_debugger] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_throw] = ACTIONS(2748),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_case] = ACTIONS(2748),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2746),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_SLASH] = ACTIONS(2748),
    [anon_sym_class] = ACTIONS(2748),
    [anon_sym_async] = ACTIONS(2748),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_void] = ACTIONS(2748),
    [anon_sym_delete] = ACTIONS(2748),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_SQUOTE] = ACTIONS(2746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [sym_number] = ACTIONS(2746),
    [sym_this] = ACTIONS(2748),
    [sym_super] = ACTIONS(2748),
    [sym_true] = ACTIONS(2748),
    [sym_false] = ACTIONS(2748),
    [sym_null] = ACTIONS(2748),
    [sym_undefined] = ACTIONS(2748),
    [anon_sym_AT] = ACTIONS(2746),
    [anon_sym_static] = ACTIONS(2748),
    [anon_sym_abstract] = ACTIONS(2748),
    [anon_sym_get] = ACTIONS(2748),
    [anon_sym_set] = ACTIONS(2748),
    [anon_sym_declare] = ACTIONS(2748),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_module] = ACTIONS(2748),
    [anon_sym_any] = ACTIONS(2748),
    [anon_sym_number] = ACTIONS(2748),
    [anon_sym_boolean] = ACTIONS(2748),
    [anon_sym_string] = ACTIONS(2748),
    [anon_sym_symbol] = ACTIONS(2748),
    [anon_sym_interface] = ACTIONS(2748),
    [anon_sym_enum] = ACTIONS(2748),
  },
  [534] = {
    [ts_builtin_sym_end] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(2752),
    [anon_sym_export] = ACTIONS(2752),
    [anon_sym_default] = ACTIONS(2752),
    [anon_sym_namespace] = ACTIONS(2752),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [anon_sym_type] = ACTIONS(2752),
    [anon_sym_typeof] = ACTIONS(2752),
    [anon_sym_import] = ACTIONS(2752),
    [anon_sym_var] = ACTIONS(2752),
    [anon_sym_let] = ACTIONS(2752),
    [anon_sym_const] = ACTIONS(2752),
    [anon_sym_if] = ACTIONS(2752),
    [anon_sym_else] = ACTIONS(2752),
    [anon_sym_switch] = ACTIONS(2752),
    [anon_sym_for] = ACTIONS(2752),
    [anon_sym_LPAREN] = ACTIONS(2750),
    [anon_sym_await] = ACTIONS(2752),
    [anon_sym_while] = ACTIONS(2752),
    [anon_sym_do] = ACTIONS(2752),
    [anon_sym_try] = ACTIONS(2752),
    [anon_sym_with] = ACTIONS(2752),
    [anon_sym_break] = ACTIONS(2752),
    [anon_sym_continue] = ACTIONS(2752),
    [anon_sym_debugger] = ACTIONS(2752),
    [anon_sym_return] = ACTIONS(2752),
    [anon_sym_throw] = ACTIONS(2752),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_case] = ACTIONS(2752),
    [anon_sym_yield] = ACTIONS(2752),
    [anon_sym_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_SLASH] = ACTIONS(2752),
    [anon_sym_class] = ACTIONS(2752),
    [anon_sym_async] = ACTIONS(2752),
    [anon_sym_function] = ACTIONS(2752),
    [anon_sym_new] = ACTIONS(2752),
    [anon_sym_PLUS] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2752),
    [anon_sym_BANG] = ACTIONS(2750),
    [anon_sym_TILDE] = ACTIONS(2750),
    [anon_sym_void] = ACTIONS(2752),
    [anon_sym_delete] = ACTIONS(2752),
    [anon_sym_PLUS_PLUS] = ACTIONS(2750),
    [anon_sym_DASH_DASH] = ACTIONS(2750),
    [anon_sym_DQUOTE] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2750),
    [sym_number] = ACTIONS(2750),
    [sym_this] = ACTIONS(2752),
    [sym_super] = ACTIONS(2752),
    [sym_true] = ACTIONS(2752),
    [sym_false] = ACTIONS(2752),
    [sym_null] = ACTIONS(2752),
    [sym_undefined] = ACTIONS(2752),
    [anon_sym_AT] = ACTIONS(2750),
    [anon_sym_static] = ACTIONS(2752),
    [anon_sym_abstract] = ACTIONS(2752),
    [anon_sym_get] = ACTIONS(2752),
    [anon_sym_set] = ACTIONS(2752),
    [anon_sym_declare] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2752),
    [anon_sym_private] = ACTIONS(2752),
    [anon_sym_protected] = ACTIONS(2752),
    [anon_sym_module] = ACTIONS(2752),
    [anon_sym_any] = ACTIONS(2752),
    [anon_sym_number] = ACTIONS(2752),
    [anon_sym_boolean] = ACTIONS(2752),
    [anon_sym_string] = ACTIONS(2752),
    [anon_sym_symbol] = ACTIONS(2752),
    [anon_sym_interface] = ACTIONS(2752),
    [anon_sym_enum] = ACTIONS(2752),
  },
  [535] = {
    [ts_builtin_sym_end] = ACTIONS(2754),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_export] = ACTIONS(2756),
    [anon_sym_default] = ACTIONS(2756),
    [anon_sym_namespace] = ACTIONS(2756),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_RBRACE] = ACTIONS(2754),
    [anon_sym_type] = ACTIONS(2756),
    [anon_sym_typeof] = ACTIONS(2756),
    [anon_sym_import] = ACTIONS(2756),
    [anon_sym_var] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_else] = ACTIONS(2756),
    [anon_sym_switch] = ACTIONS(2756),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_await] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_with] = ACTIONS(2756),
    [anon_sym_break] = ACTIONS(2756),
    [anon_sym_continue] = ACTIONS(2756),
    [anon_sym_debugger] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_throw] = ACTIONS(2756),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_case] = ACTIONS(2756),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_SLASH] = ACTIONS(2756),
    [anon_sym_class] = ACTIONS(2756),
    [anon_sym_async] = ACTIONS(2756),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_BANG] = ACTIONS(2754),
    [anon_sym_TILDE] = ACTIONS(2754),
    [anon_sym_void] = ACTIONS(2756),
    [anon_sym_delete] = ACTIONS(2756),
    [anon_sym_PLUS_PLUS] = ACTIONS(2754),
    [anon_sym_DASH_DASH] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_SQUOTE] = ACTIONS(2754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [sym_number] = ACTIONS(2754),
    [sym_this] = ACTIONS(2756),
    [sym_super] = ACTIONS(2756),
    [sym_true] = ACTIONS(2756),
    [sym_false] = ACTIONS(2756),
    [sym_null] = ACTIONS(2756),
    [sym_undefined] = ACTIONS(2756),
    [anon_sym_AT] = ACTIONS(2754),
    [anon_sym_static] = ACTIONS(2756),
    [anon_sym_abstract] = ACTIONS(2756),
    [anon_sym_get] = ACTIONS(2756),
    [anon_sym_set] = ACTIONS(2756),
    [anon_sym_declare] = ACTIONS(2756),
    [anon_sym_public] = ACTIONS(2756),
    [anon_sym_private] = ACTIONS(2756),
    [anon_sym_protected] = ACTIONS(2756),
    [anon_sym_module] = ACTIONS(2756),
    [anon_sym_any] = ACTIONS(2756),
    [anon_sym_number] = ACTIONS(2756),
    [anon_sym_boolean] = ACTIONS(2756),
    [anon_sym_string] = ACTIONS(2756),
    [anon_sym_symbol] = ACTIONS(2756),
    [anon_sym_interface] = ACTIONS(2756),
    [anon_sym_enum] = ACTIONS(2756),
  },
  [536] = {
    [ts_builtin_sym_end] = ACTIONS(2758),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_export] = ACTIONS(2760),
    [anon_sym_default] = ACTIONS(2760),
    [anon_sym_namespace] = ACTIONS(2760),
    [anon_sym_LBRACE] = ACTIONS(2758),
    [anon_sym_RBRACE] = ACTIONS(2758),
    [anon_sym_type] = ACTIONS(2760),
    [anon_sym_typeof] = ACTIONS(2760),
    [anon_sym_import] = ACTIONS(2760),
    [anon_sym_var] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_const] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_else] = ACTIONS(2760),
    [anon_sym_switch] = ACTIONS(2760),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(2758),
    [anon_sym_await] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_with] = ACTIONS(2760),
    [anon_sym_break] = ACTIONS(2760),
    [anon_sym_continue] = ACTIONS(2760),
    [anon_sym_debugger] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_throw] = ACTIONS(2760),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym_case] = ACTIONS(2760),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_SLASH] = ACTIONS(2760),
    [anon_sym_class] = ACTIONS(2760),
    [anon_sym_async] = ACTIONS(2760),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_BANG] = ACTIONS(2758),
    [anon_sym_TILDE] = ACTIONS(2758),
    [anon_sym_void] = ACTIONS(2760),
    [anon_sym_delete] = ACTIONS(2760),
    [anon_sym_PLUS_PLUS] = ACTIONS(2758),
    [anon_sym_DASH_DASH] = ACTIONS(2758),
    [anon_sym_DQUOTE] = ACTIONS(2758),
    [anon_sym_SQUOTE] = ACTIONS(2758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2758),
    [sym_number] = ACTIONS(2758),
    [sym_this] = ACTIONS(2760),
    [sym_super] = ACTIONS(2760),
    [sym_true] = ACTIONS(2760),
    [sym_false] = ACTIONS(2760),
    [sym_null] = ACTIONS(2760),
    [sym_undefined] = ACTIONS(2760),
    [anon_sym_AT] = ACTIONS(2758),
    [anon_sym_static] = ACTIONS(2760),
    [anon_sym_abstract] = ACTIONS(2760),
    [anon_sym_get] = ACTIONS(2760),
    [anon_sym_set] = ACTIONS(2760),
    [anon_sym_declare] = ACTIONS(2760),
    [anon_sym_public] = ACTIONS(2760),
    [anon_sym_private] = ACTIONS(2760),
    [anon_sym_protected] = ACTIONS(2760),
    [anon_sym_module] = ACTIONS(2760),
    [anon_sym_any] = ACTIONS(2760),
    [anon_sym_number] = ACTIONS(2760),
    [anon_sym_boolean] = ACTIONS(2760),
    [anon_sym_string] = ACTIONS(2760),
    [anon_sym_symbol] = ACTIONS(2760),
    [anon_sym_interface] = ACTIONS(2760),
    [anon_sym_enum] = ACTIONS(2760),
  },
  [537] = {
    [ts_builtin_sym_end] = ACTIONS(2762),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_export] = ACTIONS(2764),
    [anon_sym_default] = ACTIONS(2764),
    [anon_sym_namespace] = ACTIONS(2764),
    [anon_sym_LBRACE] = ACTIONS(2762),
    [anon_sym_RBRACE] = ACTIONS(2762),
    [anon_sym_type] = ACTIONS(2764),
    [anon_sym_typeof] = ACTIONS(2764),
    [anon_sym_import] = ACTIONS(2764),
    [anon_sym_var] = ACTIONS(2764),
    [anon_sym_let] = ACTIONS(2764),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2764),
    [anon_sym_else] = ACTIONS(2764),
    [anon_sym_switch] = ACTIONS(2764),
    [anon_sym_for] = ACTIONS(2764),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [anon_sym_await] = ACTIONS(2764),
    [anon_sym_while] = ACTIONS(2764),
    [anon_sym_do] = ACTIONS(2764),
    [anon_sym_try] = ACTIONS(2764),
    [anon_sym_with] = ACTIONS(2764),
    [anon_sym_break] = ACTIONS(2764),
    [anon_sym_continue] = ACTIONS(2764),
    [anon_sym_debugger] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(2764),
    [anon_sym_throw] = ACTIONS(2764),
    [anon_sym_SEMI] = ACTIONS(2762),
    [anon_sym_case] = ACTIONS(2764),
    [anon_sym_yield] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_SLASH] = ACTIONS(2764),
    [anon_sym_class] = ACTIONS(2764),
    [anon_sym_async] = ACTIONS(2764),
    [anon_sym_function] = ACTIONS(2764),
    [anon_sym_new] = ACTIONS(2764),
    [anon_sym_PLUS] = ACTIONS(2764),
    [anon_sym_DASH] = ACTIONS(2764),
    [anon_sym_BANG] = ACTIONS(2762),
    [anon_sym_TILDE] = ACTIONS(2762),
    [anon_sym_void] = ACTIONS(2764),
    [anon_sym_delete] = ACTIONS(2764),
    [anon_sym_PLUS_PLUS] = ACTIONS(2762),
    [anon_sym_DASH_DASH] = ACTIONS(2762),
    [anon_sym_DQUOTE] = ACTIONS(2762),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2762),
    [sym_number] = ACTIONS(2762),
    [sym_this] = ACTIONS(2764),
    [sym_super] = ACTIONS(2764),
    [sym_true] = ACTIONS(2764),
    [sym_false] = ACTIONS(2764),
    [sym_null] = ACTIONS(2764),
    [sym_undefined] = ACTIONS(2764),
    [anon_sym_AT] = ACTIONS(2762),
    [anon_sym_static] = ACTIONS(2764),
    [anon_sym_abstract] = ACTIONS(2764),
    [anon_sym_get] = ACTIONS(2764),
    [anon_sym_set] = ACTIONS(2764),
    [anon_sym_declare] = ACTIONS(2764),
    [anon_sym_public] = ACTIONS(2764),
    [anon_sym_private] = ACTIONS(2764),
    [anon_sym_protected] = ACTIONS(2764),
    [anon_sym_module] = ACTIONS(2764),
    [anon_sym_any] = ACTIONS(2764),
    [anon_sym_number] = ACTIONS(2764),
    [anon_sym_boolean] = ACTIONS(2764),
    [anon_sym_string] = ACTIONS(2764),
    [anon_sym_symbol] = ACTIONS(2764),
    [anon_sym_interface] = ACTIONS(2764),
    [anon_sym_enum] = ACTIONS(2764),
  },
  [538] = {
    [ts_builtin_sym_end] = ACTIONS(2766),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_export] = ACTIONS(2768),
    [anon_sym_default] = ACTIONS(2768),
    [anon_sym_namespace] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_RBRACE] = ACTIONS(2766),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_typeof] = ACTIONS(2768),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_var] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_const] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_else] = ACTIONS(2768),
    [anon_sym_switch] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_await] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_break] = ACTIONS(2768),
    [anon_sym_continue] = ACTIONS(2768),
    [anon_sym_debugger] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_throw] = ACTIONS(2768),
    [anon_sym_SEMI] = ACTIONS(2766),
    [anon_sym_case] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LT] = ACTIONS(2766),
    [anon_sym_SLASH] = ACTIONS(2768),
    [anon_sym_class] = ACTIONS(2768),
    [anon_sym_async] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_BANG] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2766),
    [anon_sym_void] = ACTIONS(2768),
    [anon_sym_delete] = ACTIONS(2768),
    [anon_sym_PLUS_PLUS] = ACTIONS(2766),
    [anon_sym_DASH_DASH] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_SQUOTE] = ACTIONS(2766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2766),
    [sym_number] = ACTIONS(2766),
    [sym_this] = ACTIONS(2768),
    [sym_super] = ACTIONS(2768),
    [sym_true] = ACTIONS(2768),
    [sym_false] = ACTIONS(2768),
    [sym_null] = ACTIONS(2768),
    [sym_undefined] = ACTIONS(2768),
    [anon_sym_AT] = ACTIONS(2766),
    [anon_sym_static] = ACTIONS(2768),
    [anon_sym_abstract] = ACTIONS(2768),
    [anon_sym_get] = ACTIONS(2768),
    [anon_sym_set] = ACTIONS(2768),
    [anon_sym_declare] = ACTIONS(2768),
    [anon_sym_public] = ACTIONS(2768),
    [anon_sym_private] = ACTIONS(2768),
    [anon_sym_protected] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_any] = ACTIONS(2768),
    [anon_sym_number] = ACTIONS(2768),
    [anon_sym_boolean] = ACTIONS(2768),
    [anon_sym_string] = ACTIONS(2768),
    [anon_sym_symbol] = ACTIONS(2768),
    [anon_sym_interface] = ACTIONS(2768),
    [anon_sym_enum] = ACTIONS(2768),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(2770),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_export] = ACTIONS(2772),
    [anon_sym_default] = ACTIONS(2772),
    [anon_sym_namespace] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_type] = ACTIONS(2772),
    [anon_sym_typeof] = ACTIONS(2772),
    [anon_sym_import] = ACTIONS(2772),
    [anon_sym_var] = ACTIONS(2772),
    [anon_sym_let] = ACTIONS(2772),
    [anon_sym_const] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(2772),
    [anon_sym_else] = ACTIONS(2772),
    [anon_sym_switch] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_await] = ACTIONS(2772),
    [anon_sym_while] = ACTIONS(2772),
    [anon_sym_do] = ACTIONS(2772),
    [anon_sym_try] = ACTIONS(2772),
    [anon_sym_with] = ACTIONS(2772),
    [anon_sym_break] = ACTIONS(2772),
    [anon_sym_continue] = ACTIONS(2772),
    [anon_sym_debugger] = ACTIONS(2772),
    [anon_sym_return] = ACTIONS(2772),
    [anon_sym_throw] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_case] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2772),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_SLASH] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2772),
    [anon_sym_PLUS] = ACTIONS(2772),
    [anon_sym_DASH] = ACTIONS(2772),
    [anon_sym_BANG] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2770),
    [anon_sym_void] = ACTIONS(2772),
    [anon_sym_delete] = ACTIONS(2772),
    [anon_sym_PLUS_PLUS] = ACTIONS(2770),
    [anon_sym_DASH_DASH] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2770),
    [sym_number] = ACTIONS(2770),
    [sym_this] = ACTIONS(2772),
    [sym_super] = ACTIONS(2772),
    [sym_true] = ACTIONS(2772),
    [sym_false] = ACTIONS(2772),
    [sym_null] = ACTIONS(2772),
    [sym_undefined] = ACTIONS(2772),
    [anon_sym_AT] = ACTIONS(2770),
    [anon_sym_static] = ACTIONS(2772),
    [anon_sym_abstract] = ACTIONS(2772),
    [anon_sym_get] = ACTIONS(2772),
    [anon_sym_set] = ACTIONS(2772),
    [anon_sym_declare] = ACTIONS(2772),
    [anon_sym_public] = ACTIONS(2772),
    [anon_sym_private] = ACTIONS(2772),
    [anon_sym_protected] = ACTIONS(2772),
    [anon_sym_module] = ACTIONS(2772),
    [anon_sym_any] = ACTIONS(2772),
    [anon_sym_number] = ACTIONS(2772),
    [anon_sym_boolean] = ACTIONS(2772),
    [anon_sym_string] = ACTIONS(2772),
    [anon_sym_symbol] = ACTIONS(2772),
    [anon_sym_interface] = ACTIONS(2772),
    [anon_sym_enum] = ACTIONS(2772),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(2774),
    [sym_identifier] = ACTIONS(2776),
    [anon_sym_export] = ACTIONS(2776),
    [anon_sym_default] = ACTIONS(2776),
    [anon_sym_namespace] = ACTIONS(2776),
    [anon_sym_LBRACE] = ACTIONS(2774),
    [anon_sym_RBRACE] = ACTIONS(2774),
    [anon_sym_type] = ACTIONS(2776),
    [anon_sym_typeof] = ACTIONS(2776),
    [anon_sym_import] = ACTIONS(2776),
    [anon_sym_var] = ACTIONS(2776),
    [anon_sym_let] = ACTIONS(2776),
    [anon_sym_const] = ACTIONS(2776),
    [anon_sym_if] = ACTIONS(2776),
    [anon_sym_else] = ACTIONS(2776),
    [anon_sym_switch] = ACTIONS(2776),
    [anon_sym_for] = ACTIONS(2776),
    [anon_sym_LPAREN] = ACTIONS(2774),
    [anon_sym_await] = ACTIONS(2776),
    [anon_sym_while] = ACTIONS(2776),
    [anon_sym_do] = ACTIONS(2776),
    [anon_sym_try] = ACTIONS(2776),
    [anon_sym_with] = ACTIONS(2776),
    [anon_sym_break] = ACTIONS(2776),
    [anon_sym_continue] = ACTIONS(2776),
    [anon_sym_debugger] = ACTIONS(2776),
    [anon_sym_return] = ACTIONS(2776),
    [anon_sym_throw] = ACTIONS(2776),
    [anon_sym_SEMI] = ACTIONS(2774),
    [anon_sym_case] = ACTIONS(2776),
    [anon_sym_yield] = ACTIONS(2776),
    [anon_sym_LBRACK] = ACTIONS(2774),
    [anon_sym_LT] = ACTIONS(2774),
    [anon_sym_SLASH] = ACTIONS(2776),
    [anon_sym_class] = ACTIONS(2776),
    [anon_sym_async] = ACTIONS(2776),
    [anon_sym_function] = ACTIONS(2776),
    [anon_sym_new] = ACTIONS(2776),
    [anon_sym_PLUS] = ACTIONS(2776),
    [anon_sym_DASH] = ACTIONS(2776),
    [anon_sym_BANG] = ACTIONS(2774),
    [anon_sym_TILDE] = ACTIONS(2774),
    [anon_sym_void] = ACTIONS(2776),
    [anon_sym_delete] = ACTIONS(2776),
    [anon_sym_PLUS_PLUS] = ACTIONS(2774),
    [anon_sym_DASH_DASH] = ACTIONS(2774),
    [anon_sym_DQUOTE] = ACTIONS(2774),
    [anon_sym_SQUOTE] = ACTIONS(2774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2774),
    [sym_number] = ACTIONS(2774),
    [sym_this] = ACTIONS(2776),
    [sym_super] = ACTIONS(2776),
    [sym_true] = ACTIONS(2776),
    [sym_false] = ACTIONS(2776),
    [sym_null] = ACTIONS(2776),
    [sym_undefined] = ACTIONS(2776),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_static] = ACTIONS(2776),
    [anon_sym_abstract] = ACTIONS(2776),
    [anon_sym_get] = ACTIONS(2776),
    [anon_sym_set] = ACTIONS(2776),
    [anon_sym_declare] = ACTIONS(2776),
    [anon_sym_public] = ACTIONS(2776),
    [anon_sym_private] = ACTIONS(2776),
    [anon_sym_protected] = ACTIONS(2776),
    [anon_sym_module] = ACTIONS(2776),
    [anon_sym_any] = ACTIONS(2776),
    [anon_sym_number] = ACTIONS(2776),
    [anon_sym_boolean] = ACTIONS(2776),
    [anon_sym_string] = ACTIONS(2776),
    [anon_sym_symbol] = ACTIONS(2776),
    [anon_sym_interface] = ACTIONS(2776),
    [anon_sym_enum] = ACTIONS(2776),
  },
  [541] = {
    [ts_builtin_sym_end] = ACTIONS(2778),
    [sym_identifier] = ACTIONS(2780),
    [anon_sym_export] = ACTIONS(2780),
    [anon_sym_default] = ACTIONS(2780),
    [anon_sym_namespace] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2778),
    [anon_sym_RBRACE] = ACTIONS(2778),
    [anon_sym_type] = ACTIONS(2780),
    [anon_sym_typeof] = ACTIONS(2780),
    [anon_sym_import] = ACTIONS(2780),
    [anon_sym_var] = ACTIONS(2780),
    [anon_sym_let] = ACTIONS(2780),
    [anon_sym_const] = ACTIONS(2780),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_else] = ACTIONS(2780),
    [anon_sym_switch] = ACTIONS(2780),
    [anon_sym_for] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2778),
    [anon_sym_await] = ACTIONS(2780),
    [anon_sym_while] = ACTIONS(2780),
    [anon_sym_do] = ACTIONS(2780),
    [anon_sym_try] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2780),
    [anon_sym_break] = ACTIONS(2780),
    [anon_sym_continue] = ACTIONS(2780),
    [anon_sym_debugger] = ACTIONS(2780),
    [anon_sym_return] = ACTIONS(2780),
    [anon_sym_throw] = ACTIONS(2780),
    [anon_sym_SEMI] = ACTIONS(2778),
    [anon_sym_case] = ACTIONS(2780),
    [anon_sym_yield] = ACTIONS(2780),
    [anon_sym_LBRACK] = ACTIONS(2778),
    [anon_sym_LT] = ACTIONS(2778),
    [anon_sym_SLASH] = ACTIONS(2780),
    [anon_sym_class] = ACTIONS(2780),
    [anon_sym_async] = ACTIONS(2780),
    [anon_sym_function] = ACTIONS(2780),
    [anon_sym_new] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2780),
    [anon_sym_DASH] = ACTIONS(2780),
    [anon_sym_BANG] = ACTIONS(2778),
    [anon_sym_TILDE] = ACTIONS(2778),
    [anon_sym_void] = ACTIONS(2780),
    [anon_sym_delete] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2778),
    [anon_sym_DASH_DASH] = ACTIONS(2778),
    [anon_sym_DQUOTE] = ACTIONS(2778),
    [anon_sym_SQUOTE] = ACTIONS(2778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2778),
    [sym_number] = ACTIONS(2778),
    [sym_this] = ACTIONS(2780),
    [sym_super] = ACTIONS(2780),
    [sym_true] = ACTIONS(2780),
    [sym_false] = ACTIONS(2780),
    [sym_null] = ACTIONS(2780),
    [sym_undefined] = ACTIONS(2780),
    [anon_sym_AT] = ACTIONS(2778),
    [anon_sym_static] = ACTIONS(2780),
    [anon_sym_abstract] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2780),
    [anon_sym_set] = ACTIONS(2780),
    [anon_sym_declare] = ACTIONS(2780),
    [anon_sym_public] = ACTIONS(2780),
    [anon_sym_private] = ACTIONS(2780),
    [anon_sym_protected] = ACTIONS(2780),
    [anon_sym_module] = ACTIONS(2780),
    [anon_sym_any] = ACTIONS(2780),
    [anon_sym_number] = ACTIONS(2780),
    [anon_sym_boolean] = ACTIONS(2780),
    [anon_sym_string] = ACTIONS(2780),
    [anon_sym_symbol] = ACTIONS(2780),
    [anon_sym_interface] = ACTIONS(2780),
    [anon_sym_enum] = ACTIONS(2780),
  },
  [542] = {
    [ts_builtin_sym_end] = ACTIONS(2782),
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_export] = ACTIONS(2784),
    [anon_sym_default] = ACTIONS(2784),
    [anon_sym_namespace] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2782),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_type] = ACTIONS(2784),
    [anon_sym_typeof] = ACTIONS(2784),
    [anon_sym_import] = ACTIONS(2784),
    [anon_sym_var] = ACTIONS(2784),
    [anon_sym_let] = ACTIONS(2784),
    [anon_sym_const] = ACTIONS(2784),
    [anon_sym_if] = ACTIONS(2784),
    [anon_sym_else] = ACTIONS(2784),
    [anon_sym_switch] = ACTIONS(2784),
    [anon_sym_for] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_await] = ACTIONS(2784),
    [anon_sym_while] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_try] = ACTIONS(2784),
    [anon_sym_with] = ACTIONS(2784),
    [anon_sym_break] = ACTIONS(2784),
    [anon_sym_continue] = ACTIONS(2784),
    [anon_sym_debugger] = ACTIONS(2784),
    [anon_sym_return] = ACTIONS(2784),
    [anon_sym_throw] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2782),
    [anon_sym_case] = ACTIONS(2784),
    [anon_sym_yield] = ACTIONS(2784),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_SLASH] = ACTIONS(2784),
    [anon_sym_class] = ACTIONS(2784),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_function] = ACTIONS(2784),
    [anon_sym_new] = ACTIONS(2784),
    [anon_sym_PLUS] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2784),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_TILDE] = ACTIONS(2782),
    [anon_sym_void] = ACTIONS(2784),
    [anon_sym_delete] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2782),
    [anon_sym_DASH_DASH] = ACTIONS(2782),
    [anon_sym_DQUOTE] = ACTIONS(2782),
    [anon_sym_SQUOTE] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2782),
    [sym_number] = ACTIONS(2782),
    [sym_this] = ACTIONS(2784),
    [sym_super] = ACTIONS(2784),
    [sym_true] = ACTIONS(2784),
    [sym_false] = ACTIONS(2784),
    [sym_null] = ACTIONS(2784),
    [sym_undefined] = ACTIONS(2784),
    [anon_sym_AT] = ACTIONS(2782),
    [anon_sym_static] = ACTIONS(2784),
    [anon_sym_abstract] = ACTIONS(2784),
    [anon_sym_get] = ACTIONS(2784),
    [anon_sym_set] = ACTIONS(2784),
    [anon_sym_declare] = ACTIONS(2784),
    [anon_sym_public] = ACTIONS(2784),
    [anon_sym_private] = ACTIONS(2784),
    [anon_sym_protected] = ACTIONS(2784),
    [anon_sym_module] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [anon_sym_interface] = ACTIONS(2784),
    [anon_sym_enum] = ACTIONS(2784),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(2786),
    [sym_identifier] = ACTIONS(2788),
    [anon_sym_export] = ACTIONS(2788),
    [anon_sym_default] = ACTIONS(2788),
    [anon_sym_namespace] = ACTIONS(2788),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_type] = ACTIONS(2788),
    [anon_sym_typeof] = ACTIONS(2788),
    [anon_sym_import] = ACTIONS(2788),
    [anon_sym_var] = ACTIONS(2788),
    [anon_sym_let] = ACTIONS(2788),
    [anon_sym_const] = ACTIONS(2788),
    [anon_sym_if] = ACTIONS(2788),
    [anon_sym_else] = ACTIONS(2788),
    [anon_sym_switch] = ACTIONS(2788),
    [anon_sym_for] = ACTIONS(2788),
    [anon_sym_LPAREN] = ACTIONS(2786),
    [anon_sym_await] = ACTIONS(2788),
    [anon_sym_while] = ACTIONS(2788),
    [anon_sym_do] = ACTIONS(2788),
    [anon_sym_try] = ACTIONS(2788),
    [anon_sym_with] = ACTIONS(2788),
    [anon_sym_break] = ACTIONS(2788),
    [anon_sym_continue] = ACTIONS(2788),
    [anon_sym_debugger] = ACTIONS(2788),
    [anon_sym_return] = ACTIONS(2788),
    [anon_sym_throw] = ACTIONS(2788),
    [anon_sym_SEMI] = ACTIONS(2786),
    [anon_sym_case] = ACTIONS(2788),
    [anon_sym_yield] = ACTIONS(2788),
    [anon_sym_LBRACK] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2788),
    [anon_sym_class] = ACTIONS(2788),
    [anon_sym_async] = ACTIONS(2788),
    [anon_sym_function] = ACTIONS(2788),
    [anon_sym_new] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(2788),
    [anon_sym_DASH] = ACTIONS(2788),
    [anon_sym_BANG] = ACTIONS(2786),
    [anon_sym_TILDE] = ACTIONS(2786),
    [anon_sym_void] = ACTIONS(2788),
    [anon_sym_delete] = ACTIONS(2788),
    [anon_sym_PLUS_PLUS] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2786),
    [anon_sym_DQUOTE] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2786),
    [sym_number] = ACTIONS(2786),
    [sym_this] = ACTIONS(2788),
    [sym_super] = ACTIONS(2788),
    [sym_true] = ACTIONS(2788),
    [sym_false] = ACTIONS(2788),
    [sym_null] = ACTIONS(2788),
    [sym_undefined] = ACTIONS(2788),
    [anon_sym_AT] = ACTIONS(2786),
    [anon_sym_static] = ACTIONS(2788),
    [anon_sym_abstract] = ACTIONS(2788),
    [anon_sym_get] = ACTIONS(2788),
    [anon_sym_set] = ACTIONS(2788),
    [anon_sym_declare] = ACTIONS(2788),
    [anon_sym_public] = ACTIONS(2788),
    [anon_sym_private] = ACTIONS(2788),
    [anon_sym_protected] = ACTIONS(2788),
    [anon_sym_module] = ACTIONS(2788),
    [anon_sym_any] = ACTIONS(2788),
    [anon_sym_number] = ACTIONS(2788),
    [anon_sym_boolean] = ACTIONS(2788),
    [anon_sym_string] = ACTIONS(2788),
    [anon_sym_symbol] = ACTIONS(2788),
    [anon_sym_interface] = ACTIONS(2788),
    [anon_sym_enum] = ACTIONS(2788),
  },
  [544] = {
    [ts_builtin_sym_end] = ACTIONS(2790),
    [sym_identifier] = ACTIONS(2792),
    [anon_sym_export] = ACTIONS(2792),
    [anon_sym_default] = ACTIONS(2792),
    [anon_sym_namespace] = ACTIONS(2792),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [anon_sym_type] = ACTIONS(2792),
    [anon_sym_typeof] = ACTIONS(2792),
    [anon_sym_import] = ACTIONS(2792),
    [anon_sym_var] = ACTIONS(2792),
    [anon_sym_let] = ACTIONS(2792),
    [anon_sym_const] = ACTIONS(2792),
    [anon_sym_if] = ACTIONS(2792),
    [anon_sym_else] = ACTIONS(2792),
    [anon_sym_switch] = ACTIONS(2792),
    [anon_sym_for] = ACTIONS(2792),
    [anon_sym_LPAREN] = ACTIONS(2790),
    [anon_sym_await] = ACTIONS(2792),
    [anon_sym_while] = ACTIONS(2792),
    [anon_sym_do] = ACTIONS(2792),
    [anon_sym_try] = ACTIONS(2792),
    [anon_sym_with] = ACTIONS(2792),
    [anon_sym_break] = ACTIONS(2792),
    [anon_sym_continue] = ACTIONS(2792),
    [anon_sym_debugger] = ACTIONS(2792),
    [anon_sym_return] = ACTIONS(2792),
    [anon_sym_throw] = ACTIONS(2792),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_case] = ACTIONS(2792),
    [anon_sym_yield] = ACTIONS(2792),
    [anon_sym_LBRACK] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_SLASH] = ACTIONS(2792),
    [anon_sym_class] = ACTIONS(2792),
    [anon_sym_async] = ACTIONS(2792),
    [anon_sym_function] = ACTIONS(2792),
    [anon_sym_new] = ACTIONS(2792),
    [anon_sym_PLUS] = ACTIONS(2792),
    [anon_sym_DASH] = ACTIONS(2792),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_TILDE] = ACTIONS(2790),
    [anon_sym_void] = ACTIONS(2792),
    [anon_sym_delete] = ACTIONS(2792),
    [anon_sym_PLUS_PLUS] = ACTIONS(2790),
    [anon_sym_DASH_DASH] = ACTIONS(2790),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_SQUOTE] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [sym_number] = ACTIONS(2790),
    [sym_this] = ACTIONS(2792),
    [sym_super] = ACTIONS(2792),
    [sym_true] = ACTIONS(2792),
    [sym_false] = ACTIONS(2792),
    [sym_null] = ACTIONS(2792),
    [sym_undefined] = ACTIONS(2792),
    [anon_sym_AT] = ACTIONS(2790),
    [anon_sym_static] = ACTIONS(2792),
    [anon_sym_abstract] = ACTIONS(2792),
    [anon_sym_get] = ACTIONS(2792),
    [anon_sym_set] = ACTIONS(2792),
    [anon_sym_declare] = ACTIONS(2792),
    [anon_sym_public] = ACTIONS(2792),
    [anon_sym_private] = ACTIONS(2792),
    [anon_sym_protected] = ACTIONS(2792),
    [anon_sym_module] = ACTIONS(2792),
    [anon_sym_any] = ACTIONS(2792),
    [anon_sym_number] = ACTIONS(2792),
    [anon_sym_boolean] = ACTIONS(2792),
    [anon_sym_string] = ACTIONS(2792),
    [anon_sym_symbol] = ACTIONS(2792),
    [anon_sym_interface] = ACTIONS(2792),
    [anon_sym_enum] = ACTIONS(2792),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(2794),
    [sym_identifier] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2796),
    [anon_sym_default] = ACTIONS(2796),
    [anon_sym_namespace] = ACTIONS(2796),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2796),
    [anon_sym_typeof] = ACTIONS(2796),
    [anon_sym_import] = ACTIONS(2796),
    [anon_sym_var] = ACTIONS(2796),
    [anon_sym_let] = ACTIONS(2796),
    [anon_sym_const] = ACTIONS(2796),
    [anon_sym_if] = ACTIONS(2796),
    [anon_sym_else] = ACTIONS(2796),
    [anon_sym_switch] = ACTIONS(2796),
    [anon_sym_for] = ACTIONS(2796),
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_await] = ACTIONS(2796),
    [anon_sym_while] = ACTIONS(2796),
    [anon_sym_do] = ACTIONS(2796),
    [anon_sym_try] = ACTIONS(2796),
    [anon_sym_with] = ACTIONS(2796),
    [anon_sym_break] = ACTIONS(2796),
    [anon_sym_continue] = ACTIONS(2796),
    [anon_sym_debugger] = ACTIONS(2796),
    [anon_sym_return] = ACTIONS(2796),
    [anon_sym_throw] = ACTIONS(2796),
    [anon_sym_SEMI] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2796),
    [anon_sym_yield] = ACTIONS(2796),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_SLASH] = ACTIONS(2796),
    [anon_sym_class] = ACTIONS(2796),
    [anon_sym_async] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2796),
    [anon_sym_new] = ACTIONS(2796),
    [anon_sym_PLUS] = ACTIONS(2796),
    [anon_sym_DASH] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_TILDE] = ACTIONS(2794),
    [anon_sym_void] = ACTIONS(2796),
    [anon_sym_delete] = ACTIONS(2796),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2794),
    [sym_number] = ACTIONS(2794),
    [sym_this] = ACTIONS(2796),
    [sym_super] = ACTIONS(2796),
    [sym_true] = ACTIONS(2796),
    [sym_false] = ACTIONS(2796),
    [sym_null] = ACTIONS(2796),
    [sym_undefined] = ACTIONS(2796),
    [anon_sym_AT] = ACTIONS(2794),
    [anon_sym_static] = ACTIONS(2796),
    [anon_sym_abstract] = ACTIONS(2796),
    [anon_sym_get] = ACTIONS(2796),
    [anon_sym_set] = ACTIONS(2796),
    [anon_sym_declare] = ACTIONS(2796),
    [anon_sym_public] = ACTIONS(2796),
    [anon_sym_private] = ACTIONS(2796),
    [anon_sym_protected] = ACTIONS(2796),
    [anon_sym_module] = ACTIONS(2796),
    [anon_sym_any] = ACTIONS(2796),
    [anon_sym_number] = ACTIONS(2796),
    [anon_sym_boolean] = ACTIONS(2796),
    [anon_sym_string] = ACTIONS(2796),
    [anon_sym_symbol] = ACTIONS(2796),
    [anon_sym_interface] = ACTIONS(2796),
    [anon_sym_enum] = ACTIONS(2796),
  },
  [546] = {
    [sym__call_signature] = STATE(2936),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2545),
    [anon_sym_export] = ACTIONS(2547),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2547),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2547),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_async] = ACTIONS(2547),
    [anon_sym_function] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2547),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2547),
    [anon_sym_get] = ACTIONS(2547),
    [anon_sym_set] = ACTIONS(2547),
    [anon_sym_declare] = ACTIONS(2547),
    [anon_sym_public] = ACTIONS(2547),
    [anon_sym_private] = ACTIONS(2547),
    [anon_sym_protected] = ACTIONS(2547),
    [anon_sym_module] = ACTIONS(2547),
    [anon_sym_any] = ACTIONS(2547),
    [anon_sym_number] = ACTIONS(2547),
    [anon_sym_boolean] = ACTIONS(2547),
    [anon_sym_string] = ACTIONS(2547),
    [anon_sym_symbol] = ACTIONS(2547),
  },
  [547] = {
    [ts_builtin_sym_end] = ACTIONS(2798),
    [sym_identifier] = ACTIONS(2800),
    [anon_sym_export] = ACTIONS(2800),
    [anon_sym_default] = ACTIONS(2800),
    [anon_sym_namespace] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2798),
    [anon_sym_RBRACE] = ACTIONS(2798),
    [anon_sym_type] = ACTIONS(2800),
    [anon_sym_typeof] = ACTIONS(2800),
    [anon_sym_import] = ACTIONS(2800),
    [anon_sym_var] = ACTIONS(2800),
    [anon_sym_let] = ACTIONS(2800),
    [anon_sym_const] = ACTIONS(2800),
    [anon_sym_if] = ACTIONS(2800),
    [anon_sym_else] = ACTIONS(2800),
    [anon_sym_switch] = ACTIONS(2800),
    [anon_sym_for] = ACTIONS(2800),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_await] = ACTIONS(2800),
    [anon_sym_while] = ACTIONS(2800),
    [anon_sym_do] = ACTIONS(2800),
    [anon_sym_try] = ACTIONS(2800),
    [anon_sym_with] = ACTIONS(2800),
    [anon_sym_break] = ACTIONS(2800),
    [anon_sym_continue] = ACTIONS(2800),
    [anon_sym_debugger] = ACTIONS(2800),
    [anon_sym_return] = ACTIONS(2800),
    [anon_sym_throw] = ACTIONS(2800),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_case] = ACTIONS(2800),
    [anon_sym_yield] = ACTIONS(2800),
    [anon_sym_LBRACK] = ACTIONS(2798),
    [anon_sym_LT] = ACTIONS(2798),
    [anon_sym_SLASH] = ACTIONS(2800),
    [anon_sym_class] = ACTIONS(2800),
    [anon_sym_async] = ACTIONS(2800),
    [anon_sym_function] = ACTIONS(2800),
    [anon_sym_new] = ACTIONS(2800),
    [anon_sym_PLUS] = ACTIONS(2800),
    [anon_sym_DASH] = ACTIONS(2800),
    [anon_sym_BANG] = ACTIONS(2798),
    [anon_sym_TILDE] = ACTIONS(2798),
    [anon_sym_void] = ACTIONS(2800),
    [anon_sym_delete] = ACTIONS(2800),
    [anon_sym_PLUS_PLUS] = ACTIONS(2798),
    [anon_sym_DASH_DASH] = ACTIONS(2798),
    [anon_sym_DQUOTE] = ACTIONS(2798),
    [anon_sym_SQUOTE] = ACTIONS(2798),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2798),
    [sym_number] = ACTIONS(2798),
    [sym_this] = ACTIONS(2800),
    [sym_super] = ACTIONS(2800),
    [sym_true] = ACTIONS(2800),
    [sym_false] = ACTIONS(2800),
    [sym_null] = ACTIONS(2800),
    [sym_undefined] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2798),
    [anon_sym_static] = ACTIONS(2800),
    [anon_sym_abstract] = ACTIONS(2800),
    [anon_sym_get] = ACTIONS(2800),
    [anon_sym_set] = ACTIONS(2800),
    [anon_sym_declare] = ACTIONS(2800),
    [anon_sym_public] = ACTIONS(2800),
    [anon_sym_private] = ACTIONS(2800),
    [anon_sym_protected] = ACTIONS(2800),
    [anon_sym_module] = ACTIONS(2800),
    [anon_sym_any] = ACTIONS(2800),
    [anon_sym_number] = ACTIONS(2800),
    [anon_sym_boolean] = ACTIONS(2800),
    [anon_sym_string] = ACTIONS(2800),
    [anon_sym_symbol] = ACTIONS(2800),
    [anon_sym_interface] = ACTIONS(2800),
    [anon_sym_enum] = ACTIONS(2800),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(1155),
    [sym_identifier] = ACTIONS(1157),
    [anon_sym_export] = ACTIONS(1157),
    [anon_sym_default] = ACTIONS(1157),
    [anon_sym_namespace] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1155),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_type] = ACTIONS(1157),
    [anon_sym_typeof] = ACTIONS(1157),
    [anon_sym_import] = ACTIONS(1157),
    [anon_sym_var] = ACTIONS(1157),
    [anon_sym_let] = ACTIONS(1157),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1157),
    [anon_sym_else] = ACTIONS(1157),
    [anon_sym_switch] = ACTIONS(1157),
    [anon_sym_for] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_await] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1157),
    [anon_sym_do] = ACTIONS(1157),
    [anon_sym_try] = ACTIONS(1157),
    [anon_sym_with] = ACTIONS(1157),
    [anon_sym_break] = ACTIONS(1157),
    [anon_sym_continue] = ACTIONS(1157),
    [anon_sym_debugger] = ACTIONS(1157),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_throw] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym_case] = ACTIONS(1157),
    [anon_sym_yield] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_SLASH] = ACTIONS(1157),
    [anon_sym_class] = ACTIONS(1157),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_TILDE] = ACTIONS(1155),
    [anon_sym_void] = ACTIONS(1157),
    [anon_sym_delete] = ACTIONS(1157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1155),
    [anon_sym_DASH_DASH] = ACTIONS(1155),
    [anon_sym_DQUOTE] = ACTIONS(1155),
    [anon_sym_SQUOTE] = ACTIONS(1155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1155),
    [sym_number] = ACTIONS(1155),
    [sym_this] = ACTIONS(1157),
    [sym_super] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_null] = ACTIONS(1157),
    [sym_undefined] = ACTIONS(1157),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(1157),
    [anon_sym_abstract] = ACTIONS(1157),
    [anon_sym_get] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(1157),
    [anon_sym_declare] = ACTIONS(1157),
    [anon_sym_public] = ACTIONS(1157),
    [anon_sym_private] = ACTIONS(1157),
    [anon_sym_protected] = ACTIONS(1157),
    [anon_sym_module] = ACTIONS(1157),
    [anon_sym_any] = ACTIONS(1157),
    [anon_sym_number] = ACTIONS(1157),
    [anon_sym_boolean] = ACTIONS(1157),
    [anon_sym_string] = ACTIONS(1157),
    [anon_sym_symbol] = ACTIONS(1157),
    [anon_sym_interface] = ACTIONS(1157),
    [anon_sym_enum] = ACTIONS(1157),
  },
  [549] = {
    [ts_builtin_sym_end] = ACTIONS(2802),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_export] = ACTIONS(2804),
    [anon_sym_default] = ACTIONS(2804),
    [anon_sym_namespace] = ACTIONS(2804),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_RBRACE] = ACTIONS(2802),
    [anon_sym_type] = ACTIONS(2804),
    [anon_sym_typeof] = ACTIONS(2804),
    [anon_sym_import] = ACTIONS(2804),
    [anon_sym_var] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_const] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_else] = ACTIONS(2804),
    [anon_sym_switch] = ACTIONS(2804),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2802),
    [anon_sym_await] = ACTIONS(2804),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_with] = ACTIONS(2804),
    [anon_sym_break] = ACTIONS(2804),
    [anon_sym_continue] = ACTIONS(2804),
    [anon_sym_debugger] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_throw] = ACTIONS(2804),
    [anon_sym_SEMI] = ACTIONS(2802),
    [anon_sym_case] = ACTIONS(2804),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2802),
    [anon_sym_LT] = ACTIONS(2802),
    [anon_sym_SLASH] = ACTIONS(2804),
    [anon_sym_class] = ACTIONS(2804),
    [anon_sym_async] = ACTIONS(2804),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_BANG] = ACTIONS(2802),
    [anon_sym_TILDE] = ACTIONS(2802),
    [anon_sym_void] = ACTIONS(2804),
    [anon_sym_delete] = ACTIONS(2804),
    [anon_sym_PLUS_PLUS] = ACTIONS(2802),
    [anon_sym_DASH_DASH] = ACTIONS(2802),
    [anon_sym_DQUOTE] = ACTIONS(2802),
    [anon_sym_SQUOTE] = ACTIONS(2802),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2802),
    [sym_number] = ACTIONS(2802),
    [sym_this] = ACTIONS(2804),
    [sym_super] = ACTIONS(2804),
    [sym_true] = ACTIONS(2804),
    [sym_false] = ACTIONS(2804),
    [sym_null] = ACTIONS(2804),
    [sym_undefined] = ACTIONS(2804),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_static] = ACTIONS(2804),
    [anon_sym_abstract] = ACTIONS(2804),
    [anon_sym_get] = ACTIONS(2804),
    [anon_sym_set] = ACTIONS(2804),
    [anon_sym_declare] = ACTIONS(2804),
    [anon_sym_public] = ACTIONS(2804),
    [anon_sym_private] = ACTIONS(2804),
    [anon_sym_protected] = ACTIONS(2804),
    [anon_sym_module] = ACTIONS(2804),
    [anon_sym_any] = ACTIONS(2804),
    [anon_sym_number] = ACTIONS(2804),
    [anon_sym_boolean] = ACTIONS(2804),
    [anon_sym_string] = ACTIONS(2804),
    [anon_sym_symbol] = ACTIONS(2804),
    [anon_sym_interface] = ACTIONS(2804),
    [anon_sym_enum] = ACTIONS(2804),
  },
  [550] = {
    [sym__call_signature] = STATE(2756),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_export] = ACTIONS(2614),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2614),
    [anon_sym_LBRACE] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2614),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_async] = ACTIONS(2614),
    [anon_sym_function] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(664),
    [anon_sym_PLUS_EQ] = ACTIONS(698),
    [anon_sym_DASH_EQ] = ACTIONS(698),
    [anon_sym_STAR_EQ] = ACTIONS(698),
    [anon_sym_SLASH_EQ] = ACTIONS(698),
    [anon_sym_PERCENT_EQ] = ACTIONS(698),
    [anon_sym_CARET_EQ] = ACTIONS(698),
    [anon_sym_AMP_EQ] = ACTIONS(698),
    [anon_sym_PIPE_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_LT_LT_EQ] = ACTIONS(698),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(698),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2614),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2614),
    [anon_sym_get] = ACTIONS(2614),
    [anon_sym_set] = ACTIONS(2614),
    [anon_sym_declare] = ACTIONS(2614),
    [anon_sym_public] = ACTIONS(2614),
    [anon_sym_private] = ACTIONS(2614),
    [anon_sym_protected] = ACTIONS(2614),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_any] = ACTIONS(2614),
    [anon_sym_number] = ACTIONS(2614),
    [anon_sym_boolean] = ACTIONS(2614),
    [anon_sym_string] = ACTIONS(2614),
    [anon_sym_symbol] = ACTIONS(2614),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [551] = {
    [ts_builtin_sym_end] = ACTIONS(2806),
    [sym_identifier] = ACTIONS(2808),
    [anon_sym_export] = ACTIONS(2808),
    [anon_sym_default] = ACTIONS(2808),
    [anon_sym_namespace] = ACTIONS(2808),
    [anon_sym_LBRACE] = ACTIONS(2806),
    [anon_sym_RBRACE] = ACTIONS(2806),
    [anon_sym_type] = ACTIONS(2808),
    [anon_sym_typeof] = ACTIONS(2808),
    [anon_sym_import] = ACTIONS(2808),
    [anon_sym_var] = ACTIONS(2808),
    [anon_sym_let] = ACTIONS(2808),
    [anon_sym_const] = ACTIONS(2808),
    [anon_sym_if] = ACTIONS(2808),
    [anon_sym_else] = ACTIONS(2808),
    [anon_sym_switch] = ACTIONS(2808),
    [anon_sym_for] = ACTIONS(2808),
    [anon_sym_LPAREN] = ACTIONS(2806),
    [anon_sym_await] = ACTIONS(2808),
    [anon_sym_while] = ACTIONS(2808),
    [anon_sym_do] = ACTIONS(2808),
    [anon_sym_try] = ACTIONS(2808),
    [anon_sym_with] = ACTIONS(2808),
    [anon_sym_break] = ACTIONS(2808),
    [anon_sym_continue] = ACTIONS(2808),
    [anon_sym_debugger] = ACTIONS(2808),
    [anon_sym_return] = ACTIONS(2808),
    [anon_sym_throw] = ACTIONS(2808),
    [anon_sym_SEMI] = ACTIONS(2806),
    [anon_sym_case] = ACTIONS(2808),
    [anon_sym_yield] = ACTIONS(2808),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_SLASH] = ACTIONS(2808),
    [anon_sym_class] = ACTIONS(2808),
    [anon_sym_async] = ACTIONS(2808),
    [anon_sym_function] = ACTIONS(2808),
    [anon_sym_new] = ACTIONS(2808),
    [anon_sym_PLUS] = ACTIONS(2808),
    [anon_sym_DASH] = ACTIONS(2808),
    [anon_sym_BANG] = ACTIONS(2806),
    [anon_sym_TILDE] = ACTIONS(2806),
    [anon_sym_void] = ACTIONS(2808),
    [anon_sym_delete] = ACTIONS(2808),
    [anon_sym_PLUS_PLUS] = ACTIONS(2806),
    [anon_sym_DASH_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(2806),
    [anon_sym_SQUOTE] = ACTIONS(2806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2806),
    [sym_number] = ACTIONS(2806),
    [sym_this] = ACTIONS(2808),
    [sym_super] = ACTIONS(2808),
    [sym_true] = ACTIONS(2808),
    [sym_false] = ACTIONS(2808),
    [sym_null] = ACTIONS(2808),
    [sym_undefined] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(2806),
    [anon_sym_static] = ACTIONS(2808),
    [anon_sym_abstract] = ACTIONS(2808),
    [anon_sym_get] = ACTIONS(2808),
    [anon_sym_set] = ACTIONS(2808),
    [anon_sym_declare] = ACTIONS(2808),
    [anon_sym_public] = ACTIONS(2808),
    [anon_sym_private] = ACTIONS(2808),
    [anon_sym_protected] = ACTIONS(2808),
    [anon_sym_module] = ACTIONS(2808),
    [anon_sym_any] = ACTIONS(2808),
    [anon_sym_number] = ACTIONS(2808),
    [anon_sym_boolean] = ACTIONS(2808),
    [anon_sym_string] = ACTIONS(2808),
    [anon_sym_symbol] = ACTIONS(2808),
    [anon_sym_interface] = ACTIONS(2808),
    [anon_sym_enum] = ACTIONS(2808),
  },
  [552] = {
    [sym__call_signature] = STATE(2885),
    [sym_arguments] = STATE(1428),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2810),
    [anon_sym_export] = ACTIONS(2812),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(2812),
    [anon_sym_type] = ACTIONS(2812),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_async] = ACTIONS(2812),
    [anon_sym_function] = ACTIONS(2572),
    [anon_sym_EQ_GT] = ACTIONS(626),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_void] = ACTIONS(2812),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_static] = ACTIONS(2812),
    [anon_sym_get] = ACTIONS(2812),
    [anon_sym_set] = ACTIONS(2812),
    [anon_sym_declare] = ACTIONS(2812),
    [anon_sym_public] = ACTIONS(2812),
    [anon_sym_private] = ACTIONS(2812),
    [anon_sym_protected] = ACTIONS(2812),
    [anon_sym_module] = ACTIONS(2812),
    [anon_sym_any] = ACTIONS(2812),
    [anon_sym_number] = ACTIONS(2812),
    [anon_sym_boolean] = ACTIONS(2812),
    [anon_sym_string] = ACTIONS(2812),
    [anon_sym_symbol] = ACTIONS(2812),
    [sym__automatic_semicolon] = ACTIONS(501),
  },
  [553] = {
    [ts_builtin_sym_end] = ACTIONS(2814),
    [sym_identifier] = ACTIONS(2816),
    [anon_sym_export] = ACTIONS(2816),
    [anon_sym_default] = ACTIONS(2816),
    [anon_sym_namespace] = ACTIONS(2816),
    [anon_sym_LBRACE] = ACTIONS(2814),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_type] = ACTIONS(2816),
    [anon_sym_typeof] = ACTIONS(2816),
    [anon_sym_import] = ACTIONS(2816),
    [anon_sym_var] = ACTIONS(2816),
    [anon_sym_let] = ACTIONS(2816),
    [anon_sym_const] = ACTIONS(2816),
    [anon_sym_if] = ACTIONS(2816),
    [anon_sym_else] = ACTIONS(2816),
    [anon_sym_switch] = ACTIONS(2816),
    [anon_sym_for] = ACTIONS(2816),
    [anon_sym_LPAREN] = ACTIONS(2814),
    [anon_sym_await] = ACTIONS(2816),
    [anon_sym_while] = ACTIONS(2816),
    [anon_sym_do] = ACTIONS(2816),
    [anon_sym_try] = ACTIONS(2816),
    [anon_sym_with] = ACTIONS(2816),
    [anon_sym_break] = ACTIONS(2816),
    [anon_sym_continue] = ACTIONS(2816),
    [anon_sym_debugger] = ACTIONS(2816),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_throw] = ACTIONS(2816),
    [anon_sym_SEMI] = ACTIONS(2814),
    [anon_sym_case] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2816),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_SLASH] = ACTIONS(2816),
    [anon_sym_class] = ACTIONS(2816),
    [anon_sym_async] = ACTIONS(2816),
    [anon_sym_function] = ACTIONS(2816),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_PLUS] = ACTIONS(2816),
    [anon_sym_DASH] = ACTIONS(2816),
    [anon_sym_BANG] = ACTIONS(2814),
    [anon_sym_TILDE] = ACTIONS(2814),
    [anon_sym_void] = ACTIONS(2816),
    [anon_sym_delete] = ACTIONS(2816),
    [anon_sym_PLUS_PLUS] = ACTIONS(2814),
    [anon_sym_DASH_DASH] = ACTIONS(2814),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [anon_sym_SQUOTE] = ACTIONS(2814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [sym_number] = ACTIONS(2814),
    [sym_this] = ACTIONS(2816),
    [sym_super] = ACTIONS(2816),
    [sym_true] = ACTIONS(2816),
    [sym_false] = ACTIONS(2816),
    [sym_null] = ACTIONS(2816),
    [sym_undefined] = ACTIONS(2816),
    [anon_sym_AT] = ACTIONS(2814),
    [anon_sym_static] = ACTIONS(2816),
    [anon_sym_abstract] = ACTIONS(2816),
    [anon_sym_get] = ACTIONS(2816),
    [anon_sym_set] = ACTIONS(2816),
    [anon_sym_declare] = ACTIONS(2816),
    [anon_sym_public] = ACTIONS(2816),
    [anon_sym_private] = ACTIONS(2816),
    [anon_sym_protected] = ACTIONS(2816),
    [anon_sym_module] = ACTIONS(2816),
    [anon_sym_any] = ACTIONS(2816),
    [anon_sym_number] = ACTIONS(2816),
    [anon_sym_boolean] = ACTIONS(2816),
    [anon_sym_string] = ACTIONS(2816),
    [anon_sym_symbol] = ACTIONS(2816),
    [anon_sym_interface] = ACTIONS(2816),
    [anon_sym_enum] = ACTIONS(2816),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(2818),
    [sym_identifier] = ACTIONS(2820),
    [anon_sym_export] = ACTIONS(2820),
    [anon_sym_default] = ACTIONS(2820),
    [anon_sym_namespace] = ACTIONS(2820),
    [anon_sym_LBRACE] = ACTIONS(2818),
    [anon_sym_RBRACE] = ACTIONS(2818),
    [anon_sym_type] = ACTIONS(2820),
    [anon_sym_typeof] = ACTIONS(2820),
    [anon_sym_import] = ACTIONS(2820),
    [anon_sym_var] = ACTIONS(2820),
    [anon_sym_let] = ACTIONS(2820),
    [anon_sym_const] = ACTIONS(2820),
    [anon_sym_if] = ACTIONS(2820),
    [anon_sym_else] = ACTIONS(2820),
    [anon_sym_switch] = ACTIONS(2820),
    [anon_sym_for] = ACTIONS(2820),
    [anon_sym_LPAREN] = ACTIONS(2818),
    [anon_sym_await] = ACTIONS(2820),
    [anon_sym_while] = ACTIONS(2820),
    [anon_sym_do] = ACTIONS(2820),
    [anon_sym_try] = ACTIONS(2820),
    [anon_sym_with] = ACTIONS(2820),
    [anon_sym_break] = ACTIONS(2820),
    [anon_sym_continue] = ACTIONS(2820),
    [anon_sym_debugger] = ACTIONS(2820),
    [anon_sym_return] = ACTIONS(2820),
    [anon_sym_throw] = ACTIONS(2820),
    [anon_sym_SEMI] = ACTIONS(2818),
    [anon_sym_case] = ACTIONS(2820),
    [anon_sym_yield] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_LT] = ACTIONS(2818),
    [anon_sym_SLASH] = ACTIONS(2820),
    [anon_sym_class] = ACTIONS(2820),
    [anon_sym_async] = ACTIONS(2820),
    [anon_sym_function] = ACTIONS(2820),
    [anon_sym_new] = ACTIONS(2820),
    [anon_sym_PLUS] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2820),
    [anon_sym_BANG] = ACTIONS(2818),
    [anon_sym_TILDE] = ACTIONS(2818),
    [anon_sym_void] = ACTIONS(2820),
    [anon_sym_delete] = ACTIONS(2820),
    [anon_sym_PLUS_PLUS] = ACTIONS(2818),
    [anon_sym_DASH_DASH] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(2818),
    [anon_sym_SQUOTE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [sym_number] = ACTIONS(2818),
    [sym_this] = ACTIONS(2820),
    [sym_super] = ACTIONS(2820),
    [sym_true] = ACTIONS(2820),
    [sym_false] = ACTIONS(2820),
    [sym_null] = ACTIONS(2820),
    [sym_undefined] = ACTIONS(2820),
    [anon_sym_AT] = ACTIONS(2818),
    [anon_sym_static] = ACTIONS(2820),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_get] = ACTIONS(2820),
    [anon_sym_set] = ACTIONS(2820),
    [anon_sym_declare] = ACTIONS(2820),
    [anon_sym_public] = ACTIONS(2820),
    [anon_sym_private] = ACTIONS(2820),
    [anon_sym_protected] = ACTIONS(2820),
    [anon_sym_module] = ACTIONS(2820),
    [anon_sym_any] = ACTIONS(2820),
    [anon_sym_number] = ACTIONS(2820),
    [anon_sym_boolean] = ACTIONS(2820),
    [anon_sym_string] = ACTIONS(2820),
    [anon_sym_symbol] = ACTIONS(2820),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_enum] = ACTIONS(2820),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(2822),
    [sym_identifier] = ACTIONS(2824),
    [anon_sym_export] = ACTIONS(2824),
    [anon_sym_default] = ACTIONS(2824),
    [anon_sym_namespace] = ACTIONS(2824),
    [anon_sym_LBRACE] = ACTIONS(2822),
    [anon_sym_RBRACE] = ACTIONS(2822),
    [anon_sym_type] = ACTIONS(2824),
    [anon_sym_typeof] = ACTIONS(2824),
    [anon_sym_import] = ACTIONS(2824),
    [anon_sym_var] = ACTIONS(2824),
    [anon_sym_let] = ACTIONS(2824),
    [anon_sym_const] = ACTIONS(2824),
    [anon_sym_if] = ACTIONS(2824),
    [anon_sym_else] = ACTIONS(2824),
    [anon_sym_switch] = ACTIONS(2824),
    [anon_sym_for] = ACTIONS(2824),
    [anon_sym_LPAREN] = ACTIONS(2822),
    [anon_sym_await] = ACTIONS(2824),
    [anon_sym_while] = ACTIONS(2824),
    [anon_sym_do] = ACTIONS(2824),
    [anon_sym_try] = ACTIONS(2824),
    [anon_sym_with] = ACTIONS(2824),
    [anon_sym_break] = ACTIONS(2824),
    [anon_sym_continue] = ACTIONS(2824),
    [anon_sym_debugger] = ACTIONS(2824),
    [anon_sym_return] = ACTIONS(2824),
    [anon_sym_throw] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2822),
    [anon_sym_case] = ACTIONS(2824),
    [anon_sym_yield] = ACTIONS(2824),
    [anon_sym_LBRACK] = ACTIONS(2822),
    [anon_sym_LT] = ACTIONS(2822),
    [anon_sym_SLASH] = ACTIONS(2824),
    [anon_sym_class] = ACTIONS(2824),
    [anon_sym_async] = ACTIONS(2824),
    [anon_sym_function] = ACTIONS(2824),
    [anon_sym_new] = ACTIONS(2824),
    [anon_sym_PLUS] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2824),
    [anon_sym_BANG] = ACTIONS(2822),
    [anon_sym_TILDE] = ACTIONS(2822),
    [anon_sym_void] = ACTIONS(2824),
    [anon_sym_delete] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2822),
    [anon_sym_DASH_DASH] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_SQUOTE] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [sym_number] = ACTIONS(2822),
    [sym_this] = ACTIONS(2824),
    [sym_super] = ACTIONS(2824),
    [sym_true] = ACTIONS(2824),
    [sym_false] = ACTIONS(2824),
    [sym_null] = ACTIONS(2824),
    [sym_undefined] = ACTIONS(2824),
    [anon_sym_AT] = ACTIONS(2822),
    [anon_sym_static] = ACTIONS(2824),
    [anon_sym_abstract] = ACTIONS(2824),
    [anon_sym_get] = ACTIONS(2824),
    [anon_sym_set] = ACTIONS(2824),
    [anon_sym_declare] = ACTIONS(2824),
    [anon_sym_public] = ACTIONS(2824),
    [anon_sym_private] = ACTIONS(2824),
    [anon_sym_protected] = ACTIONS(2824),
    [anon_sym_module] = ACTIONS(2824),
    [anon_sym_any] = ACTIONS(2824),
    [anon_sym_number] = ACTIONS(2824),
    [anon_sym_boolean] = ACTIONS(2824),
    [anon_sym_string] = ACTIONS(2824),
    [anon_sym_symbol] = ACTIONS(2824),
    [anon_sym_interface] = ACTIONS(2824),
    [anon_sym_enum] = ACTIONS(2824),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(1131),
    [sym_identifier] = ACTIONS(1133),
    [anon_sym_export] = ACTIONS(1133),
    [anon_sym_default] = ACTIONS(1133),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1133),
    [anon_sym_typeof] = ACTIONS(1133),
    [anon_sym_import] = ACTIONS(1133),
    [anon_sym_var] = ACTIONS(1133),
    [anon_sym_let] = ACTIONS(1133),
    [anon_sym_const] = ACTIONS(1133),
    [anon_sym_if] = ACTIONS(1133),
    [anon_sym_else] = ACTIONS(1133),
    [anon_sym_switch] = ACTIONS(1133),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_while] = ACTIONS(1133),
    [anon_sym_do] = ACTIONS(1133),
    [anon_sym_try] = ACTIONS(1133),
    [anon_sym_with] = ACTIONS(1133),
    [anon_sym_break] = ACTIONS(1133),
    [anon_sym_continue] = ACTIONS(1133),
    [anon_sym_debugger] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1133),
    [anon_sym_throw] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1131),
    [anon_sym_case] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_SLASH] = ACTIONS(1133),
    [anon_sym_class] = ACTIONS(1133),
    [anon_sym_async] = ACTIONS(1133),
    [anon_sym_function] = ACTIONS(1133),
    [anon_sym_new] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [anon_sym_void] = ACTIONS(1133),
    [anon_sym_delete] = ACTIONS(1133),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [anon_sym_SQUOTE] = ACTIONS(1131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [sym_number] = ACTIONS(1131),
    [sym_this] = ACTIONS(1133),
    [sym_super] = ACTIONS(1133),
    [sym_true] = ACTIONS(1133),
    [sym_false] = ACTIONS(1133),
    [sym_null] = ACTIONS(1133),
    [sym_undefined] = ACTIONS(1133),
    [anon_sym_AT] = ACTIONS(1131),
    [anon_sym_static] = ACTIONS(1133),
    [anon_sym_abstract] = ACTIONS(1133),
    [anon_sym_get] = ACTIONS(1133),
    [anon_sym_set] = ACTIONS(1133),
    [anon_sym_declare] = ACTIONS(1133),
    [anon_sym_public] = ACTIONS(1133),
    [anon_sym_private] = ACTIONS(1133),
    [anon_sym_protected] = ACTIONS(1133),
    [anon_sym_module] = ACTIONS(1133),
    [anon_sym_any] = ACTIONS(1133),
    [anon_sym_number] = ACTIONS(1133),
    [anon_sym_boolean] = ACTIONS(1133),
    [anon_sym_string] = ACTIONS(1133),
    [anon_sym_symbol] = ACTIONS(1133),
    [anon_sym_interface] = ACTIONS(1133),
    [anon_sym_enum] = ACTIONS(1133),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(2826),
    [sym_identifier] = ACTIONS(2828),
    [anon_sym_export] = ACTIONS(2828),
    [anon_sym_default] = ACTIONS(2828),
    [anon_sym_namespace] = ACTIONS(2828),
    [anon_sym_LBRACE] = ACTIONS(2826),
    [anon_sym_RBRACE] = ACTIONS(2826),
    [anon_sym_type] = ACTIONS(2828),
    [anon_sym_typeof] = ACTIONS(2828),
    [anon_sym_import] = ACTIONS(2828),
    [anon_sym_var] = ACTIONS(2828),
    [anon_sym_let] = ACTIONS(2828),
    [anon_sym_const] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2828),
    [anon_sym_else] = ACTIONS(2828),
    [anon_sym_switch] = ACTIONS(2828),
    [anon_sym_for] = ACTIONS(2828),
    [anon_sym_LPAREN] = ACTIONS(2826),
    [anon_sym_await] = ACTIONS(2828),
    [anon_sym_while] = ACTIONS(2828),
    [anon_sym_do] = ACTIONS(2828),
    [anon_sym_try] = ACTIONS(2828),
    [anon_sym_with] = ACTIONS(2828),
    [anon_sym_break] = ACTIONS(2828),
    [anon_sym_continue] = ACTIONS(2828),
    [anon_sym_debugger] = ACTIONS(2828),
    [anon_sym_return] = ACTIONS(2828),
    [anon_sym_throw] = ACTIONS(2828),
    [anon_sym_SEMI] = ACTIONS(2826),
    [anon_sym_case] = ACTIONS(2828),
    [anon_sym_yield] = ACTIONS(2828),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_SLASH] = ACTIONS(2828),
    [anon_sym_class] = ACTIONS(2828),
    [anon_sym_async] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2828),
    [anon_sym_new] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(2828),
    [anon_sym_DASH] = ACTIONS(2828),
    [anon_sym_BANG] = ACTIONS(2826),
    [anon_sym_TILDE] = ACTIONS(2826),
    [anon_sym_void] = ACTIONS(2828),
    [anon_sym_delete] = ACTIONS(2828),
    [anon_sym_PLUS_PLUS] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2826),
    [anon_sym_DQUOTE] = ACTIONS(2826),
    [anon_sym_SQUOTE] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2826),
    [sym_number] = ACTIONS(2826),
    [sym_this] = ACTIONS(2828),
    [sym_super] = ACTIONS(2828),
    [sym_true] = ACTIONS(2828),
    [sym_false] = ACTIONS(2828),
    [sym_null] = ACTIONS(2828),
    [sym_undefined] = ACTIONS(2828),
    [anon_sym_AT] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2828),
    [anon_sym_abstract] = ACTIONS(2828),
    [anon_sym_get] = ACTIONS(2828),
    [anon_sym_set] = ACTIONS(2828),
    [anon_sym_declare] = ACTIONS(2828),
    [anon_sym_public] = ACTIONS(2828),
    [anon_sym_private] = ACTIONS(2828),
    [anon_sym_protected] = ACTIONS(2828),
    [anon_sym_module] = ACTIONS(2828),
    [anon_sym_any] = ACTIONS(2828),
    [anon_sym_number] = ACTIONS(2828),
    [anon_sym_boolean] = ACTIONS(2828),
    [anon_sym_string] = ACTIONS(2828),
    [anon_sym_symbol] = ACTIONS(2828),
    [anon_sym_interface] = ACTIONS(2828),
    [anon_sym_enum] = ACTIONS(2828),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(2830),
    [sym_identifier] = ACTIONS(2832),
    [anon_sym_export] = ACTIONS(2832),
    [anon_sym_default] = ACTIONS(2832),
    [anon_sym_namespace] = ACTIONS(2832),
    [anon_sym_LBRACE] = ACTIONS(2830),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [anon_sym_type] = ACTIONS(2832),
    [anon_sym_typeof] = ACTIONS(2832),
    [anon_sym_import] = ACTIONS(2832),
    [anon_sym_var] = ACTIONS(2832),
    [anon_sym_let] = ACTIONS(2832),
    [anon_sym_const] = ACTIONS(2832),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_else] = ACTIONS(2832),
    [anon_sym_switch] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2832),
    [anon_sym_LPAREN] = ACTIONS(2830),
    [anon_sym_await] = ACTIONS(2832),
    [anon_sym_while] = ACTIONS(2832),
    [anon_sym_do] = ACTIONS(2832),
    [anon_sym_try] = ACTIONS(2832),
    [anon_sym_with] = ACTIONS(2832),
    [anon_sym_break] = ACTIONS(2832),
    [anon_sym_continue] = ACTIONS(2832),
    [anon_sym_debugger] = ACTIONS(2832),
    [anon_sym_return] = ACTIONS(2832),
    [anon_sym_throw] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2830),
    [anon_sym_case] = ACTIONS(2832),
    [anon_sym_yield] = ACTIONS(2832),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_LT] = ACTIONS(2830),
    [anon_sym_SLASH] = ACTIONS(2832),
    [anon_sym_class] = ACTIONS(2832),
    [anon_sym_async] = ACTIONS(2832),
    [anon_sym_function] = ACTIONS(2832),
    [anon_sym_new] = ACTIONS(2832),
    [anon_sym_PLUS] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2832),
    [anon_sym_BANG] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_void] = ACTIONS(2832),
    [anon_sym_delete] = ACTIONS(2832),
    [anon_sym_PLUS_PLUS] = ACTIONS(2830),
    [anon_sym_DASH_DASH] = ACTIONS(2830),
    [anon_sym_DQUOTE] = ACTIONS(2830),
    [anon_sym_SQUOTE] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2830),
    [sym_number] = ACTIONS(2830),
    [sym_this] = ACTIONS(2832),
    [sym_super] = ACTIONS(2832),
    [sym_true] = ACTIONS(2832),
    [sym_false] = ACTIONS(2832),
    [sym_null] = ACTIONS(2832),
    [sym_undefined] = ACTIONS(2832),
    [anon_sym_AT] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2832),
    [anon_sym_abstract] = ACTIONS(2832),
    [anon_sym_get] = ACTIONS(2832),
    [anon_sym_set] = ACTIONS(2832),
    [anon_sym_declare] = ACTIONS(2832),
    [anon_sym_public] = ACTIONS(2832),
    [anon_sym_private] = ACTIONS(2832),
    [anon_sym_protected] = ACTIONS(2832),
    [anon_sym_module] = ACTIONS(2832),
    [anon_sym_any] = ACTIONS(2832),
    [anon_sym_number] = ACTIONS(2832),
    [anon_sym_boolean] = ACTIONS(2832),
    [anon_sym_string] = ACTIONS(2832),
    [anon_sym_symbol] = ACTIONS(2832),
    [anon_sym_interface] = ACTIONS(2832),
    [anon_sym_enum] = ACTIONS(2832),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(2834),
    [sym_identifier] = ACTIONS(2836),
    [anon_sym_export] = ACTIONS(2836),
    [anon_sym_default] = ACTIONS(2836),
    [anon_sym_namespace] = ACTIONS(2836),
    [anon_sym_LBRACE] = ACTIONS(2834),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_type] = ACTIONS(2836),
    [anon_sym_typeof] = ACTIONS(2836),
    [anon_sym_import] = ACTIONS(2836),
    [anon_sym_var] = ACTIONS(2836),
    [anon_sym_let] = ACTIONS(2836),
    [anon_sym_const] = ACTIONS(2836),
    [anon_sym_if] = ACTIONS(2836),
    [anon_sym_else] = ACTIONS(2836),
    [anon_sym_switch] = ACTIONS(2836),
    [anon_sym_for] = ACTIONS(2836),
    [anon_sym_LPAREN] = ACTIONS(2834),
    [anon_sym_await] = ACTIONS(2836),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_do] = ACTIONS(2836),
    [anon_sym_try] = ACTIONS(2836),
    [anon_sym_with] = ACTIONS(2836),
    [anon_sym_break] = ACTIONS(2836),
    [anon_sym_continue] = ACTIONS(2836),
    [anon_sym_debugger] = ACTIONS(2836),
    [anon_sym_return] = ACTIONS(2836),
    [anon_sym_throw] = ACTIONS(2836),
    [anon_sym_SEMI] = ACTIONS(2834),
    [anon_sym_case] = ACTIONS(2836),
    [anon_sym_yield] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_LT] = ACTIONS(2834),
    [anon_sym_SLASH] = ACTIONS(2836),
    [anon_sym_class] = ACTIONS(2836),
    [anon_sym_async] = ACTIONS(2836),
    [anon_sym_function] = ACTIONS(2836),
    [anon_sym_new] = ACTIONS(2836),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_BANG] = ACTIONS(2834),
    [anon_sym_TILDE] = ACTIONS(2834),
    [anon_sym_void] = ACTIONS(2836),
    [anon_sym_delete] = ACTIONS(2836),
    [anon_sym_PLUS_PLUS] = ACTIONS(2834),
    [anon_sym_DASH_DASH] = ACTIONS(2834),
    [anon_sym_DQUOTE] = ACTIONS(2834),
    [anon_sym_SQUOTE] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2834),
    [sym_number] = ACTIONS(2834),
    [sym_this] = ACTIONS(2836),
    [sym_super] = ACTIONS(2836),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_undefined] = ACTIONS(2836),
    [anon_sym_AT] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2836),
    [anon_sym_abstract] = ACTIONS(2836),
    [anon_sym_get] = ACTIONS(2836),
    [anon_sym_set] = ACTIONS(2836),
    [anon_sym_declare] = ACTIONS(2836),
    [anon_sym_public] = ACTIONS(2836),
    [anon_sym_private] = ACTIONS(2836),
    [anon_sym_protected] = ACTIONS(2836),
    [anon_sym_module] = ACTIONS(2836),
    [anon_sym_any] = ACTIONS(2836),
    [anon_sym_number] = ACTIONS(2836),
    [anon_sym_boolean] = ACTIONS(2836),
    [anon_sym_string] = ACTIONS(2836),
    [anon_sym_symbol] = ACTIONS(2836),
    [anon_sym_interface] = ACTIONS(2836),
    [anon_sym_enum] = ACTIONS(2836),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(2838),
    [sym_identifier] = ACTIONS(2840),
    [anon_sym_export] = ACTIONS(2840),
    [anon_sym_default] = ACTIONS(2840),
    [anon_sym_namespace] = ACTIONS(2840),
    [anon_sym_LBRACE] = ACTIONS(2838),
    [anon_sym_RBRACE] = ACTIONS(2838),
    [anon_sym_type] = ACTIONS(2840),
    [anon_sym_typeof] = ACTIONS(2840),
    [anon_sym_import] = ACTIONS(2840),
    [anon_sym_var] = ACTIONS(2840),
    [anon_sym_let] = ACTIONS(2840),
    [anon_sym_const] = ACTIONS(2840),
    [anon_sym_if] = ACTIONS(2840),
    [anon_sym_else] = ACTIONS(2840),
    [anon_sym_switch] = ACTIONS(2840),
    [anon_sym_for] = ACTIONS(2840),
    [anon_sym_LPAREN] = ACTIONS(2838),
    [anon_sym_await] = ACTIONS(2840),
    [anon_sym_while] = ACTIONS(2840),
    [anon_sym_do] = ACTIONS(2840),
    [anon_sym_try] = ACTIONS(2840),
    [anon_sym_with] = ACTIONS(2840),
    [anon_sym_break] = ACTIONS(2840),
    [anon_sym_continue] = ACTIONS(2840),
    [anon_sym_debugger] = ACTIONS(2840),
    [anon_sym_return] = ACTIONS(2840),
    [anon_sym_throw] = ACTIONS(2840),
    [anon_sym_SEMI] = ACTIONS(2838),
    [anon_sym_case] = ACTIONS(2840),
    [anon_sym_yield] = ACTIONS(2840),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_LT] = ACTIONS(2838),
    [anon_sym_SLASH] = ACTIONS(2840),
    [anon_sym_class] = ACTIONS(2840),
    [anon_sym_async] = ACTIONS(2840),
    [anon_sym_function] = ACTIONS(2840),
    [anon_sym_new] = ACTIONS(2840),
    [anon_sym_PLUS] = ACTIONS(2840),
    [anon_sym_DASH] = ACTIONS(2840),
    [anon_sym_BANG] = ACTIONS(2838),
    [anon_sym_TILDE] = ACTIONS(2838),
    [anon_sym_void] = ACTIONS(2840),
    [anon_sym_delete] = ACTIONS(2840),
    [anon_sym_PLUS_PLUS] = ACTIONS(2838),
    [anon_sym_DASH_DASH] = ACTIONS(2838),
    [anon_sym_DQUOTE] = ACTIONS(2838),
    [anon_sym_SQUOTE] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2838),
    [sym_number] = ACTIONS(2838),
    [sym_this] = ACTIONS(2840),
    [sym_super] = ACTIONS(2840),
    [sym_true] = ACTIONS(2840),
    [sym_false] = ACTIONS(2840),
    [sym_null] = ACTIONS(2840),
    [sym_undefined] = ACTIONS(2840),
    [anon_sym_AT] = ACTIONS(2838),
    [anon_sym_static] = ACTIONS(2840),
    [anon_sym_abstract] = ACTIONS(2840),
    [anon_sym_get] = ACTIONS(2840),
    [anon_sym_set] = ACTIONS(2840),
    [anon_sym_declare] = ACTIONS(2840),
    [anon_sym_public] = ACTIONS(2840),
    [anon_sym_private] = ACTIONS(2840),
    [anon_sym_protected] = ACTIONS(2840),
    [anon_sym_module] = ACTIONS(2840),
    [anon_sym_any] = ACTIONS(2840),
    [anon_sym_number] = ACTIONS(2840),
    [anon_sym_boolean] = ACTIONS(2840),
    [anon_sym_string] = ACTIONS(2840),
    [anon_sym_symbol] = ACTIONS(2840),
    [anon_sym_interface] = ACTIONS(2840),
    [anon_sym_enum] = ACTIONS(2840),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(2842),
    [sym_identifier] = ACTIONS(2844),
    [anon_sym_export] = ACTIONS(2844),
    [anon_sym_default] = ACTIONS(2844),
    [anon_sym_namespace] = ACTIONS(2844),
    [anon_sym_LBRACE] = ACTIONS(2842),
    [anon_sym_RBRACE] = ACTIONS(2842),
    [anon_sym_type] = ACTIONS(2844),
    [anon_sym_typeof] = ACTIONS(2844),
    [anon_sym_import] = ACTIONS(2844),
    [anon_sym_var] = ACTIONS(2844),
    [anon_sym_let] = ACTIONS(2844),
    [anon_sym_const] = ACTIONS(2844),
    [anon_sym_if] = ACTIONS(2844),
    [anon_sym_else] = ACTIONS(2844),
    [anon_sym_switch] = ACTIONS(2844),
    [anon_sym_for] = ACTIONS(2844),
    [anon_sym_LPAREN] = ACTIONS(2842),
    [anon_sym_await] = ACTIONS(2844),
    [anon_sym_while] = ACTIONS(2844),
    [anon_sym_do] = ACTIONS(2844),
    [anon_sym_try] = ACTIONS(2844),
    [anon_sym_with] = ACTIONS(2844),
    [anon_sym_break] = ACTIONS(2844),
    [anon_sym_continue] = ACTIONS(2844),
    [anon_sym_debugger] = ACTIONS(2844),
    [anon_sym_return] = ACTIONS(2844),
    [anon_sym_throw] = ACTIONS(2844),
    [anon_sym_SEMI] = ACTIONS(2842),
    [anon_sym_case] = ACTIONS(2844),
    [anon_sym_yield] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_LT] = ACTIONS(2842),
    [anon_sym_SLASH] = ACTIONS(2844),
    [anon_sym_class] = ACTIONS(2844),
    [anon_sym_async] = ACTIONS(2844),
    [anon_sym_function] = ACTIONS(2844),
    [anon_sym_new] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2842),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_void] = ACTIONS(2844),
    [anon_sym_delete] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2842),
    [anon_sym_DASH_DASH] = ACTIONS(2842),
    [anon_sym_DQUOTE] = ACTIONS(2842),
    [anon_sym_SQUOTE] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2842),
    [sym_number] = ACTIONS(2842),
    [sym_this] = ACTIONS(2844),
    [sym_super] = ACTIONS(2844),
    [sym_true] = ACTIONS(2844),
    [sym_false] = ACTIONS(2844),
    [sym_null] = ACTIONS(2844),
    [sym_undefined] = ACTIONS(2844),
    [anon_sym_AT] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2844),
    [anon_sym_abstract] = ACTIONS(2844),
    [anon_sym_get] = ACTIONS(2844),
    [anon_sym_set] = ACTIONS(2844),
    [anon_sym_declare] = ACTIONS(2844),
    [anon_sym_public] = ACTIONS(2844),
    [anon_sym_private] = ACTIONS(2844),
    [anon_sym_protected] = ACTIONS(2844),
    [anon_sym_module] = ACTIONS(2844),
    [anon_sym_any] = ACTIONS(2844),
    [anon_sym_number] = ACTIONS(2844),
    [anon_sym_boolean] = ACTIONS(2844),
    [anon_sym_string] = ACTIONS(2844),
    [anon_sym_symbol] = ACTIONS(2844),
    [anon_sym_interface] = ACTIONS(2844),
    [anon_sym_enum] = ACTIONS(2844),
  },
  [562] = {
    [ts_builtin_sym_end] = ACTIONS(2846),
    [sym_identifier] = ACTIONS(2848),
    [anon_sym_export] = ACTIONS(2848),
    [anon_sym_default] = ACTIONS(2848),
    [anon_sym_namespace] = ACTIONS(2848),
    [anon_sym_LBRACE] = ACTIONS(2846),
    [anon_sym_RBRACE] = ACTIONS(2846),
    [anon_sym_type] = ACTIONS(2848),
    [anon_sym_typeof] = ACTIONS(2848),
    [anon_sym_import] = ACTIONS(2848),
    [anon_sym_var] = ACTIONS(2848),
    [anon_sym_let] = ACTIONS(2848),
    [anon_sym_const] = ACTIONS(2848),
    [anon_sym_if] = ACTIONS(2848),
    [anon_sym_else] = ACTIONS(2848),
    [anon_sym_switch] = ACTIONS(2848),
    [anon_sym_for] = ACTIONS(2848),
    [anon_sym_LPAREN] = ACTIONS(2846),
    [anon_sym_await] = ACTIONS(2848),
    [anon_sym_while] = ACTIONS(2848),
    [anon_sym_do] = ACTIONS(2848),
    [anon_sym_try] = ACTIONS(2848),
    [anon_sym_with] = ACTIONS(2848),
    [anon_sym_break] = ACTIONS(2848),
    [anon_sym_continue] = ACTIONS(2848),
    [anon_sym_debugger] = ACTIONS(2848),
    [anon_sym_return] = ACTIONS(2848),
    [anon_sym_throw] = ACTIONS(2848),
    [anon_sym_SEMI] = ACTIONS(2846),
    [anon_sym_case] = ACTIONS(2848),
    [anon_sym_yield] = ACTIONS(2848),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_LT] = ACTIONS(2846),
    [anon_sym_SLASH] = ACTIONS(2848),
    [anon_sym_class] = ACTIONS(2848),
    [anon_sym_async] = ACTIONS(2848),
    [anon_sym_function] = ACTIONS(2848),
    [anon_sym_new] = ACTIONS(2848),
    [anon_sym_PLUS] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2846),
    [anon_sym_TILDE] = ACTIONS(2846),
    [anon_sym_void] = ACTIONS(2848),
    [anon_sym_delete] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2846),
    [anon_sym_DASH_DASH] = ACTIONS(2846),
    [anon_sym_DQUOTE] = ACTIONS(2846),
    [anon_sym_SQUOTE] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2846),
    [sym_number] = ACTIONS(2846),
    [sym_this] = ACTIONS(2848),
    [sym_super] = ACTIONS(2848),
    [sym_true] = ACTIONS(2848),
    [sym_false] = ACTIONS(2848),
    [sym_null] = ACTIONS(2848),
    [sym_undefined] = ACTIONS(2848),
    [anon_sym_AT] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2848),
    [anon_sym_abstract] = ACTIONS(2848),
    [anon_sym_get] = ACTIONS(2848),
    [anon_sym_set] = ACTIONS(2848),
    [anon_sym_declare] = ACTIONS(2848),
    [anon_sym_public] = ACTIONS(2848),
    [anon_sym_private] = ACTIONS(2848),
    [anon_sym_protected] = ACTIONS(2848),
    [anon_sym_module] = ACTIONS(2848),
    [anon_sym_any] = ACTIONS(2848),
    [anon_sym_number] = ACTIONS(2848),
    [anon_sym_boolean] = ACTIONS(2848),
    [anon_sym_string] = ACTIONS(2848),
    [anon_sym_symbol] = ACTIONS(2848),
    [anon_sym_interface] = ACTIONS(2848),
    [anon_sym_enum] = ACTIONS(2848),
  },
  [563] = {
    [ts_builtin_sym_end] = ACTIONS(2850),
    [sym_identifier] = ACTIONS(2852),
    [anon_sym_export] = ACTIONS(2852),
    [anon_sym_default] = ACTIONS(2852),
    [anon_sym_namespace] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2850),
    [anon_sym_RBRACE] = ACTIONS(2850),
    [anon_sym_type] = ACTIONS(2852),
    [anon_sym_typeof] = ACTIONS(2852),
    [anon_sym_import] = ACTIONS(2852),
    [anon_sym_var] = ACTIONS(2852),
    [anon_sym_let] = ACTIONS(2852),
    [anon_sym_const] = ACTIONS(2852),
    [anon_sym_if] = ACTIONS(2852),
    [anon_sym_else] = ACTIONS(2852),
    [anon_sym_switch] = ACTIONS(2852),
    [anon_sym_for] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2850),
    [anon_sym_await] = ACTIONS(2852),
    [anon_sym_while] = ACTIONS(2852),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_try] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2852),
    [anon_sym_break] = ACTIONS(2852),
    [anon_sym_continue] = ACTIONS(2852),
    [anon_sym_debugger] = ACTIONS(2852),
    [anon_sym_return] = ACTIONS(2852),
    [anon_sym_throw] = ACTIONS(2852),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2852),
    [anon_sym_yield] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_LT] = ACTIONS(2850),
    [anon_sym_SLASH] = ACTIONS(2852),
    [anon_sym_class] = ACTIONS(2852),
    [anon_sym_async] = ACTIONS(2852),
    [anon_sym_function] = ACTIONS(2852),
    [anon_sym_new] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2850),
    [anon_sym_TILDE] = ACTIONS(2850),
    [anon_sym_void] = ACTIONS(2852),
    [anon_sym_delete] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2850),
    [anon_sym_DQUOTE] = ACTIONS(2850),
    [anon_sym_SQUOTE] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2850),
    [sym_number] = ACTIONS(2850),
    [sym_this] = ACTIONS(2852),
    [sym_super] = ACTIONS(2852),
    [sym_true] = ACTIONS(2852),
    [sym_false] = ACTIONS(2852),
    [sym_null] = ACTIONS(2852),
    [sym_undefined] = ACTIONS(2852),
    [anon_sym_AT] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2852),
    [anon_sym_abstract] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2852),
    [anon_sym_set] = ACTIONS(2852),
    [anon_sym_declare] = ACTIONS(2852),
    [anon_sym_public] = ACTIONS(2852),
    [anon_sym_private] = ACTIONS(2852),
    [anon_sym_protected] = ACTIONS(2852),
    [anon_sym_module] = ACTIONS(2852),
    [anon_sym_any] = ACTIONS(2852),
    [anon_sym_number] = ACTIONS(2852),
    [anon_sym_boolean] = ACTIONS(2852),
    [anon_sym_string] = ACTIONS(2852),
    [anon_sym_symbol] = ACTIONS(2852),
    [anon_sym_interface] = ACTIONS(2852),
    [anon_sym_enum] = ACTIONS(2852),
  },
  [564] = {
    [ts_builtin_sym_end] = ACTIONS(2854),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_export] = ACTIONS(2856),
    [anon_sym_default] = ACTIONS(2856),
    [anon_sym_namespace] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_RBRACE] = ACTIONS(2854),
    [anon_sym_type] = ACTIONS(2856),
    [anon_sym_typeof] = ACTIONS(2856),
    [anon_sym_import] = ACTIONS(2856),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_else] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(2856),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2854),
    [anon_sym_await] = ACTIONS(2856),
    [anon_sym_while] = ACTIONS(2856),
    [anon_sym_do] = ACTIONS(2856),
    [anon_sym_try] = ACTIONS(2856),
    [anon_sym_with] = ACTIONS(2856),
    [anon_sym_break] = ACTIONS(2856),
    [anon_sym_continue] = ACTIONS(2856),
    [anon_sym_debugger] = ACTIONS(2856),
    [anon_sym_return] = ACTIONS(2856),
    [anon_sym_throw] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym_case] = ACTIONS(2856),
    [anon_sym_yield] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2854),
    [anon_sym_LT] = ACTIONS(2854),
    [anon_sym_SLASH] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_async] = ACTIONS(2856),
    [anon_sym_function] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2854),
    [anon_sym_TILDE] = ACTIONS(2854),
    [anon_sym_void] = ACTIONS(2856),
    [anon_sym_delete] = ACTIONS(2856),
    [anon_sym_PLUS_PLUS] = ACTIONS(2854),
    [anon_sym_DASH_DASH] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2854),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2854),
    [sym_number] = ACTIONS(2854),
    [sym_this] = ACTIONS(2856),
    [sym_super] = ACTIONS(2856),
    [sym_true] = ACTIONS(2856),
    [sym_false] = ACTIONS(2856),
    [sym_null] = ACTIONS(2856),
    [sym_undefined] = ACTIONS(2856),
    [anon_sym_AT] = ACTIONS(2854),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_abstract] = ACTIONS(2856),
    [anon_sym_get] = ACTIONS(2856),
    [anon_sym_set] = ACTIONS(2856),
    [anon_sym_declare] = ACTIONS(2856),
    [anon_sym_public] = ACTIONS(2856),
    [anon_sym_private] = ACTIONS(2856),
    [anon_sym_protected] = ACTIONS(2856),
    [anon_sym_module] = ACTIONS(2856),
    [anon_sym_any] = ACTIONS(2856),
    [anon_sym_number] = ACTIONS(2856),
    [anon_sym_boolean] = ACTIONS(2856),
    [anon_sym_string] = ACTIONS(2856),
    [anon_sym_symbol] = ACTIONS(2856),
    [anon_sym_interface] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(2858),
    [sym_identifier] = ACTIONS(2860),
    [anon_sym_export] = ACTIONS(2860),
    [anon_sym_default] = ACTIONS(2860),
    [anon_sym_namespace] = ACTIONS(2860),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2858),
    [anon_sym_type] = ACTIONS(2860),
    [anon_sym_typeof] = ACTIONS(2860),
    [anon_sym_import] = ACTIONS(2860),
    [anon_sym_var] = ACTIONS(2860),
    [anon_sym_let] = ACTIONS(2860),
    [anon_sym_const] = ACTIONS(2860),
    [anon_sym_if] = ACTIONS(2860),
    [anon_sym_else] = ACTIONS(2860),
    [anon_sym_switch] = ACTIONS(2860),
    [anon_sym_for] = ACTIONS(2860),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_await] = ACTIONS(2860),
    [anon_sym_while] = ACTIONS(2860),
    [anon_sym_do] = ACTIONS(2860),
    [anon_sym_try] = ACTIONS(2860),
    [anon_sym_with] = ACTIONS(2860),
    [anon_sym_break] = ACTIONS(2860),
    [anon_sym_continue] = ACTIONS(2860),
    [anon_sym_debugger] = ACTIONS(2860),
    [anon_sym_return] = ACTIONS(2860),
    [anon_sym_throw] = ACTIONS(2860),
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym_case] = ACTIONS(2860),
    [anon_sym_yield] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2858),
    [anon_sym_LT] = ACTIONS(2858),
    [anon_sym_SLASH] = ACTIONS(2860),
    [anon_sym_class] = ACTIONS(2860),
    [anon_sym_async] = ACTIONS(2860),
    [anon_sym_function] = ACTIONS(2860),
    [anon_sym_new] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_void] = ACTIONS(2860),
    [anon_sym_delete] = ACTIONS(2860),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [anon_sym_DQUOTE] = ACTIONS(2858),
    [anon_sym_SQUOTE] = ACTIONS(2858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2858),
    [sym_number] = ACTIONS(2858),
    [sym_this] = ACTIONS(2860),
    [sym_super] = ACTIONS(2860),
    [sym_true] = ACTIONS(2860),
    [sym_false] = ACTIONS(2860),
    [sym_null] = ACTIONS(2860),
    [sym_undefined] = ACTIONS(2860),
    [anon_sym_AT] = ACTIONS(2858),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_abstract] = ACTIONS(2860),
    [anon_sym_get] = ACTIONS(2860),
    [anon_sym_set] = ACTIONS(2860),
    [anon_sym_declare] = ACTIONS(2860),
    [anon_sym_public] = ACTIONS(2860),
    [anon_sym_private] = ACTIONS(2860),
    [anon_sym_protected] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2860),
    [anon_sym_any] = ACTIONS(2860),
    [anon_sym_number] = ACTIONS(2860),
    [anon_sym_boolean] = ACTIONS(2860),
    [anon_sym_string] = ACTIONS(2860),
    [anon_sym_symbol] = ACTIONS(2860),
    [anon_sym_interface] = ACTIONS(2860),
    [anon_sym_enum] = ACTIONS(2860),
  },
  [566] = {
    [ts_builtin_sym_end] = ACTIONS(2862),
    [sym_identifier] = ACTIONS(2864),
    [anon_sym_export] = ACTIONS(2864),
    [anon_sym_default] = ACTIONS(2864),
    [anon_sym_namespace] = ACTIONS(2864),
    [anon_sym_LBRACE] = ACTIONS(2862),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_type] = ACTIONS(2864),
    [anon_sym_typeof] = ACTIONS(2864),
    [anon_sym_import] = ACTIONS(2864),
    [anon_sym_var] = ACTIONS(2864),
    [anon_sym_let] = ACTIONS(2864),
    [anon_sym_const] = ACTIONS(2864),
    [anon_sym_if] = ACTIONS(2864),
    [anon_sym_else] = ACTIONS(2864),
    [anon_sym_switch] = ACTIONS(2864),
    [anon_sym_for] = ACTIONS(2864),
    [anon_sym_LPAREN] = ACTIONS(2862),
    [anon_sym_await] = ACTIONS(2864),
    [anon_sym_while] = ACTIONS(2864),
    [anon_sym_do] = ACTIONS(2864),
    [anon_sym_try] = ACTIONS(2864),
    [anon_sym_with] = ACTIONS(2864),
    [anon_sym_break] = ACTIONS(2864),
    [anon_sym_continue] = ACTIONS(2864),
    [anon_sym_debugger] = ACTIONS(2864),
    [anon_sym_return] = ACTIONS(2864),
    [anon_sym_throw] = ACTIONS(2864),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym_case] = ACTIONS(2864),
    [anon_sym_yield] = ACTIONS(2864),
    [anon_sym_LBRACK] = ACTIONS(2862),
    [anon_sym_LT] = ACTIONS(2862),
    [anon_sym_SLASH] = ACTIONS(2864),
    [anon_sym_class] = ACTIONS(2864),
    [anon_sym_async] = ACTIONS(2864),
    [anon_sym_function] = ACTIONS(2864),
    [anon_sym_new] = ACTIONS(2864),
    [anon_sym_PLUS] = ACTIONS(2864),
    [anon_sym_DASH] = ACTIONS(2864),
    [anon_sym_BANG] = ACTIONS(2862),
    [anon_sym_TILDE] = ACTIONS(2862),
    [anon_sym_void] = ACTIONS(2864),
    [anon_sym_delete] = ACTIONS(2864),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_DQUOTE] = ACTIONS(2862),
    [anon_sym_SQUOTE] = ACTIONS(2862),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_number] = ACTIONS(2862),
    [sym_this] = ACTIONS(2864),
    [sym_super] = ACTIONS(2864),
    [sym_true] = ACTIONS(2864),
    [sym_false] = ACTIONS(2864),
    [sym_null] = ACTIONS(2864),
    [sym_undefined] = ACTIONS(2864),
    [anon_sym_AT] = ACTIONS(2862),
    [anon_sym_static] = ACTIONS(2864),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_get] = ACTIONS(2864),
    [anon_sym_set] = ACTIONS(2864),
    [anon_sym_declare] = ACTIONS(2864),
    [anon_sym_public] = ACTIONS(2864),
    [anon_sym_private] = ACTIONS(2864),
    [anon_sym_protected] = ACTIONS(2864),
    [anon_sym_module] = ACTIONS(2864),
    [anon_sym_any] = ACTIONS(2864),
    [anon_sym_number] = ACTIONS(2864),
    [anon_sym_boolean] = ACTIONS(2864),
    [anon_sym_string] = ACTIONS(2864),
    [anon_sym_symbol] = ACTIONS(2864),
    [anon_sym_interface] = ACTIONS(2864),
    [anon_sym_enum] = ACTIONS(2864),
  },
  [567] = {
    [ts_builtin_sym_end] = ACTIONS(2866),
    [sym_identifier] = ACTIONS(2868),
    [anon_sym_export] = ACTIONS(2868),
    [anon_sym_default] = ACTIONS(2868),
    [anon_sym_namespace] = ACTIONS(2868),
    [anon_sym_LBRACE] = ACTIONS(2866),
    [anon_sym_RBRACE] = ACTIONS(2866),
    [anon_sym_type] = ACTIONS(2868),
    [anon_sym_typeof] = ACTIONS(2868),
    [anon_sym_import] = ACTIONS(2868),
    [anon_sym_var] = ACTIONS(2868),
    [anon_sym_let] = ACTIONS(2868),
    [anon_sym_const] = ACTIONS(2868),
    [anon_sym_if] = ACTIONS(2868),
    [anon_sym_else] = ACTIONS(2868),
    [anon_sym_switch] = ACTIONS(2868),
    [anon_sym_for] = ACTIONS(2868),
    [anon_sym_LPAREN] = ACTIONS(2866),
    [anon_sym_await] = ACTIONS(2868),
    [anon_sym_while] = ACTIONS(2868),
    [anon_sym_do] = ACTIONS(2868),
    [anon_sym_try] = ACTIONS(2868),
    [anon_sym_with] = ACTIONS(2868),
    [anon_sym_break] = ACTIONS(2868),
    [anon_sym_continue] = ACTIONS(2868),
    [anon_sym_debugger] = ACTIONS(2868),
    [anon_sym_return] = ACTIONS(2868),
    [anon_sym_throw] = ACTIONS(2868),
    [anon_sym_SEMI] = ACTIONS(2866),
    [anon_sym_case] = ACTIONS(2868),
    [anon_sym_yield] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2866),
    [anon_sym_LT] = ACTIONS(2866),
    [anon_sym_SLASH] = ACTIONS(2868),
    [anon_sym_class] = ACTIONS(2868),
    [anon_sym_async] = ACTIONS(2868),
    [anon_sym_function] = ACTIONS(2868),
    [anon_sym_new] = ACTIONS(2868),
    [anon_sym_PLUS] = ACTIONS(2868),
    [anon_sym_DASH] = ACTIONS(2868),
    [anon_sym_BANG] = ACTIONS(2866),
    [anon_sym_TILDE] = ACTIONS(2866),
    [anon_sym_void] = ACTIONS(2868),
    [anon_sym_delete] = ACTIONS(2868),
    [anon_sym_PLUS_PLUS] = ACTIONS(2866),
    [anon_sym_DASH_DASH] = ACTIONS(2866),
    [anon_sym_DQUOTE] = ACTIONS(2866),
    [anon_sym_SQUOTE] = ACTIONS(2866),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2866),
    [sym_number] = ACTIONS(2866),
    [sym_this] = ACTIONS(2868),
    [sym_super] = ACTIONS(2868),
    [sym_true] = ACTIONS(2868),
    [sym_false] = ACTIONS(2868),
    [sym_null] = ACTIONS(2868),
    [sym_undefined] = ACTIONS(2868),
    [anon_sym_AT] = ACTIONS(2866),
    [anon_sym_static] = ACTIONS(2868),
    [anon_sym_abstract] = ACTIONS(2868),
    [anon_sym_get] = ACTIONS(2868),
    [anon_sym_set] = ACTIONS(2868),
    [anon_sym_declare] = ACTIONS(2868),
    [anon_sym_public] = ACTIONS(2868),
    [anon_sym_private] = ACTIONS(2868),
    [anon_sym_protected] = ACTIONS(2868),
    [anon_sym_module] = ACTIONS(2868),
    [anon_sym_any] = ACTIONS(2868),
    [anon_sym_number] = ACTIONS(2868),
    [anon_sym_boolean] = ACTIONS(2868),
    [anon_sym_string] = ACTIONS(2868),
    [anon_sym_symbol] = ACTIONS(2868),
    [anon_sym_interface] = ACTIONS(2868),
    [anon_sym_enum] = ACTIONS(2868),
  },
  [568] = {
    [ts_builtin_sym_end] = ACTIONS(2870),
    [sym_identifier] = ACTIONS(2872),
    [anon_sym_export] = ACTIONS(2872),
    [anon_sym_default] = ACTIONS(2872),
    [anon_sym_namespace] = ACTIONS(2872),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_RBRACE] = ACTIONS(2870),
    [anon_sym_type] = ACTIONS(2872),
    [anon_sym_typeof] = ACTIONS(2872),
    [anon_sym_import] = ACTIONS(2872),
    [anon_sym_var] = ACTIONS(2872),
    [anon_sym_let] = ACTIONS(2872),
    [anon_sym_const] = ACTIONS(2872),
    [anon_sym_if] = ACTIONS(2872),
    [anon_sym_else] = ACTIONS(2872),
    [anon_sym_switch] = ACTIONS(2872),
    [anon_sym_for] = ACTIONS(2872),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_await] = ACTIONS(2872),
    [anon_sym_while] = ACTIONS(2872),
    [anon_sym_do] = ACTIONS(2872),
    [anon_sym_try] = ACTIONS(2872),
    [anon_sym_with] = ACTIONS(2872),
    [anon_sym_break] = ACTIONS(2872),
    [anon_sym_continue] = ACTIONS(2872),
    [anon_sym_debugger] = ACTIONS(2872),
    [anon_sym_return] = ACTIONS(2872),
    [anon_sym_throw] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2870),
    [anon_sym_case] = ACTIONS(2872),
    [anon_sym_yield] = ACTIONS(2872),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_LT] = ACTIONS(2870),
    [anon_sym_SLASH] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2872),
    [anon_sym_async] = ACTIONS(2872),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_new] = ACTIONS(2872),
    [anon_sym_PLUS] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(2872),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_void] = ACTIONS(2872),
    [anon_sym_delete] = ACTIONS(2872),
    [anon_sym_PLUS_PLUS] = ACTIONS(2870),
    [anon_sym_DASH_DASH] = ACTIONS(2870),
    [anon_sym_DQUOTE] = ACTIONS(2870),
    [anon_sym_SQUOTE] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym_this] = ACTIONS(2872),
    [sym_super] = ACTIONS(2872),
    [sym_true] = ACTIONS(2872),
    [sym_false] = ACTIONS(2872),
    [sym_null] = ACTIONS(2872),
    [sym_undefined] = ACTIONS(2872),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_static] = ACTIONS(2872),
    [anon_sym_abstract] = ACTIONS(2872),
    [anon_sym_get] = ACTIONS(2872),
    [anon_sym_set] = ACTIONS(2872),
    [anon_sym_declare] = ACTIONS(2872),
    [anon_sym_public] = ACTIONS(2872),
    [anon_sym_private] = ACTIONS(2872),
    [anon_sym_protected] = ACTIONS(2872),
    [anon_sym_module] = ACTIONS(2872),
    [anon_sym_any] = ACTIONS(2872),
    [anon_sym_number] = ACTIONS(2872),
    [anon_sym_boolean] = ACTIONS(2872),
    [anon_sym_string] = ACTIONS(2872),
    [anon_sym_symbol] = ACTIONS(2872),
    [anon_sym_interface] = ACTIONS(2872),
    [anon_sym_enum] = ACTIONS(2872),
  },
  [569] = {
    [ts_builtin_sym_end] = ACTIONS(2874),
    [sym_identifier] = ACTIONS(2876),
    [anon_sym_export] = ACTIONS(2876),
    [anon_sym_default] = ACTIONS(2876),
    [anon_sym_namespace] = ACTIONS(2876),
    [anon_sym_LBRACE] = ACTIONS(2874),
    [anon_sym_RBRACE] = ACTIONS(2874),
    [anon_sym_type] = ACTIONS(2876),
    [anon_sym_typeof] = ACTIONS(2876),
    [anon_sym_import] = ACTIONS(2876),
    [anon_sym_var] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2876),
    [anon_sym_const] = ACTIONS(2876),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_else] = ACTIONS(2876),
    [anon_sym_switch] = ACTIONS(2876),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_LPAREN] = ACTIONS(2874),
    [anon_sym_await] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_do] = ACTIONS(2876),
    [anon_sym_try] = ACTIONS(2876),
    [anon_sym_with] = ACTIONS(2876),
    [anon_sym_break] = ACTIONS(2876),
    [anon_sym_continue] = ACTIONS(2876),
    [anon_sym_debugger] = ACTIONS(2876),
    [anon_sym_return] = ACTIONS(2876),
    [anon_sym_throw] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_case] = ACTIONS(2876),
    [anon_sym_yield] = ACTIONS(2876),
    [anon_sym_LBRACK] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2874),
    [anon_sym_SLASH] = ACTIONS(2876),
    [anon_sym_class] = ACTIONS(2876),
    [anon_sym_async] = ACTIONS(2876),
    [anon_sym_function] = ACTIONS(2876),
    [anon_sym_new] = ACTIONS(2876),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_BANG] = ACTIONS(2874),
    [anon_sym_TILDE] = ACTIONS(2874),
    [anon_sym_void] = ACTIONS(2876),
    [anon_sym_delete] = ACTIONS(2876),
    [anon_sym_PLUS_PLUS] = ACTIONS(2874),
    [anon_sym_DASH_DASH] = ACTIONS(2874),
    [anon_sym_DQUOTE] = ACTIONS(2874),
    [anon_sym_SQUOTE] = ACTIONS(2874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2874),
    [sym_number] = ACTIONS(2874),
    [sym_this] = ACTIONS(2876),
    [sym_super] = ACTIONS(2876),
    [sym_true] = ACTIONS(2876),
    [sym_false] = ACTIONS(2876),
    [sym_null] = ACTIONS(2876),
    [sym_undefined] = ACTIONS(2876),
    [anon_sym_AT] = ACTIONS(2874),
    [anon_sym_static] = ACTIONS(2876),
    [anon_sym_abstract] = ACTIONS(2876),
    [anon_sym_get] = ACTIONS(2876),
    [anon_sym_set] = ACTIONS(2876),
    [anon_sym_declare] = ACTIONS(2876),
    [anon_sym_public] = ACTIONS(2876),
    [anon_sym_private] = ACTIONS(2876),
    [anon_sym_protected] = ACTIONS(2876),
    [anon_sym_module] = ACTIONS(2876),
    [anon_sym_any] = ACTIONS(2876),
    [anon_sym_number] = ACTIONS(2876),
    [anon_sym_boolean] = ACTIONS(2876),
    [anon_sym_string] = ACTIONS(2876),
    [anon_sym_symbol] = ACTIONS(2876),
    [anon_sym_interface] = ACTIONS(2876),
    [anon_sym_enum] = ACTIONS(2876),
  },
  [570] = {
    [ts_builtin_sym_end] = ACTIONS(2878),
    [sym_identifier] = ACTIONS(2880),
    [anon_sym_export] = ACTIONS(2880),
    [anon_sym_default] = ACTIONS(2880),
    [anon_sym_namespace] = ACTIONS(2880),
    [anon_sym_LBRACE] = ACTIONS(2878),
    [anon_sym_RBRACE] = ACTIONS(2878),
    [anon_sym_type] = ACTIONS(2880),
    [anon_sym_typeof] = ACTIONS(2880),
    [anon_sym_import] = ACTIONS(2880),
    [anon_sym_var] = ACTIONS(2880),
    [anon_sym_let] = ACTIONS(2880),
    [anon_sym_const] = ACTIONS(2880),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_else] = ACTIONS(2880),
    [anon_sym_switch] = ACTIONS(2880),
    [anon_sym_for] = ACTIONS(2880),
    [anon_sym_LPAREN] = ACTIONS(2878),
    [anon_sym_await] = ACTIONS(2880),
    [anon_sym_while] = ACTIONS(2880),
    [anon_sym_do] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2880),
    [anon_sym_with] = ACTIONS(2880),
    [anon_sym_break] = ACTIONS(2880),
    [anon_sym_continue] = ACTIONS(2880),
    [anon_sym_debugger] = ACTIONS(2880),
    [anon_sym_return] = ACTIONS(2880),
    [anon_sym_throw] = ACTIONS(2880),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_case] = ACTIONS(2880),
    [anon_sym_yield] = ACTIONS(2880),
    [anon_sym_LBRACK] = ACTIONS(2878),
    [anon_sym_LT] = ACTIONS(2878),
    [anon_sym_SLASH] = ACTIONS(2880),
    [anon_sym_class] = ACTIONS(2880),
    [anon_sym_async] = ACTIONS(2880),
    [anon_sym_function] = ACTIONS(2880),
    [anon_sym_new] = ACTIONS(2880),
    [anon_sym_PLUS] = ACTIONS(2880),
    [anon_sym_DASH] = ACTIONS(2880),
    [anon_sym_BANG] = ACTIONS(2878),
    [anon_sym_TILDE] = ACTIONS(2878),
    [anon_sym_void] = ACTIONS(2880),
    [anon_sym_delete] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2878),
    [anon_sym_DASH_DASH] = ACTIONS(2878),
    [anon_sym_DQUOTE] = ACTIONS(2878),
    [anon_sym_SQUOTE] = ACTIONS(2878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2878),
    [sym_number] = ACTIONS(2878),
    [sym_this] = ACTIONS(2880),
    [sym_super] = ACTIONS(2880),
    [sym_true] = ACTIONS(2880),
    [sym_false] = ACTIONS(2880),
    [sym_null] = ACTIONS(2880),
    [sym_undefined] = ACTIONS(2880),
    [anon_sym_AT] = ACTIONS(2878),
    [anon_sym_static] = ACTIONS(2880),
    [anon_sym_abstract] = ACTIONS(2880),
    [anon_sym_get] = ACTIONS(2880),
    [anon_sym_set] = ACTIONS(2880),
    [anon_sym_declare] = ACTIONS(2880),
    [anon_sym_public] = ACTIONS(2880),
    [anon_sym_private] = ACTIONS(2880),
    [anon_sym_protected] = ACTIONS(2880),
    [anon_sym_module] = ACTIONS(2880),
    [anon_sym_any] = ACTIONS(2880),
    [anon_sym_number] = ACTIONS(2880),
    [anon_sym_boolean] = ACTIONS(2880),
    [anon_sym_string] = ACTIONS(2880),
    [anon_sym_symbol] = ACTIONS(2880),
    [anon_sym_interface] = ACTIONS(2880),
    [anon_sym_enum] = ACTIONS(2880),
  },
  [571] = {
    [ts_builtin_sym_end] = ACTIONS(2882),
    [sym_identifier] = ACTIONS(2884),
    [anon_sym_export] = ACTIONS(2884),
    [anon_sym_default] = ACTIONS(2884),
    [anon_sym_namespace] = ACTIONS(2884),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_RBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2884),
    [anon_sym_typeof] = ACTIONS(2884),
    [anon_sym_import] = ACTIONS(2884),
    [anon_sym_var] = ACTIONS(2884),
    [anon_sym_let] = ACTIONS(2884),
    [anon_sym_const] = ACTIONS(2884),
    [anon_sym_if] = ACTIONS(2884),
    [anon_sym_else] = ACTIONS(2884),
    [anon_sym_switch] = ACTIONS(2884),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_LPAREN] = ACTIONS(2882),
    [anon_sym_await] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2884),
    [anon_sym_do] = ACTIONS(2884),
    [anon_sym_try] = ACTIONS(2884),
    [anon_sym_with] = ACTIONS(2884),
    [anon_sym_break] = ACTIONS(2884),
    [anon_sym_continue] = ACTIONS(2884),
    [anon_sym_debugger] = ACTIONS(2884),
    [anon_sym_return] = ACTIONS(2884),
    [anon_sym_throw] = ACTIONS(2884),
    [anon_sym_SEMI] = ACTIONS(2882),
    [anon_sym_case] = ACTIONS(2884),
    [anon_sym_yield] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2882),
    [anon_sym_LT] = ACTIONS(2882),
    [anon_sym_SLASH] = ACTIONS(2884),
    [anon_sym_class] = ACTIONS(2884),
    [anon_sym_async] = ACTIONS(2884),
    [anon_sym_function] = ACTIONS(2884),
    [anon_sym_new] = ACTIONS(2884),
    [anon_sym_PLUS] = ACTIONS(2884),
    [anon_sym_DASH] = ACTIONS(2884),
    [anon_sym_BANG] = ACTIONS(2882),
    [anon_sym_TILDE] = ACTIONS(2882),
    [anon_sym_void] = ACTIONS(2884),
    [anon_sym_delete] = ACTIONS(2884),
    [anon_sym_PLUS_PLUS] = ACTIONS(2882),
    [anon_sym_DASH_DASH] = ACTIONS(2882),
    [anon_sym_DQUOTE] = ACTIONS(2882),
    [anon_sym_SQUOTE] = ACTIONS(2882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2882),
    [sym_number] = ACTIONS(2882),
    [sym_this] = ACTIONS(2884),
    [sym_super] = ACTIONS(2884),
    [sym_true] = ACTIONS(2884),
    [sym_false] = ACTIONS(2884),
    [sym_null] = ACTIONS(2884),
    [sym_undefined] = ACTIONS(2884),
    [anon_sym_AT] = ACTIONS(2882),
    [anon_sym_static] = ACTIONS(2884),
    [anon_sym_abstract] = ACTIONS(2884),
    [anon_sym_get] = ACTIONS(2884),
    [anon_sym_set] = ACTIONS(2884),
    [anon_sym_declare] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2884),
    [anon_sym_private] = ACTIONS(2884),
    [anon_sym_protected] = ACTIONS(2884),
    [anon_sym_module] = ACTIONS(2884),
    [anon_sym_any] = ACTIONS(2884),
    [anon_sym_number] = ACTIONS(2884),
    [anon_sym_boolean] = ACTIONS(2884),
    [anon_sym_string] = ACTIONS(2884),
    [anon_sym_symbol] = ACTIONS(2884),
    [anon_sym_interface] = ACTIONS(2884),
    [anon_sym_enum] = ACTIONS(2884),
  },
  [572] = {
    [ts_builtin_sym_end] = ACTIONS(2886),
    [sym_identifier] = ACTIONS(2888),
    [anon_sym_export] = ACTIONS(2888),
    [anon_sym_default] = ACTIONS(2888),
    [anon_sym_namespace] = ACTIONS(2888),
    [anon_sym_LBRACE] = ACTIONS(2886),
    [anon_sym_RBRACE] = ACTIONS(2886),
    [anon_sym_type] = ACTIONS(2888),
    [anon_sym_typeof] = ACTIONS(2888),
    [anon_sym_import] = ACTIONS(2888),
    [anon_sym_var] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_const] = ACTIONS(2888),
    [anon_sym_if] = ACTIONS(2888),
    [anon_sym_else] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2888),
    [anon_sym_for] = ACTIONS(2888),
    [anon_sym_LPAREN] = ACTIONS(2886),
    [anon_sym_await] = ACTIONS(2888),
    [anon_sym_while] = ACTIONS(2888),
    [anon_sym_do] = ACTIONS(2888),
    [anon_sym_try] = ACTIONS(2888),
    [anon_sym_with] = ACTIONS(2888),
    [anon_sym_break] = ACTIONS(2888),
    [anon_sym_continue] = ACTIONS(2888),
    [anon_sym_debugger] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2888),
    [anon_sym_throw] = ACTIONS(2888),
    [anon_sym_SEMI] = ACTIONS(2886),
    [anon_sym_case] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_LBRACK] = ACTIONS(2886),
    [anon_sym_LT] = ACTIONS(2886),
    [anon_sym_SLASH] = ACTIONS(2888),
    [anon_sym_class] = ACTIONS(2888),
    [anon_sym_async] = ACTIONS(2888),
    [anon_sym_function] = ACTIONS(2888),
    [anon_sym_new] = ACTIONS(2888),
    [anon_sym_PLUS] = ACTIONS(2888),
    [anon_sym_DASH] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2886),
    [anon_sym_TILDE] = ACTIONS(2886),
    [anon_sym_void] = ACTIONS(2888),
    [anon_sym_delete] = ACTIONS(2888),
    [anon_sym_PLUS_PLUS] = ACTIONS(2886),
    [anon_sym_DASH_DASH] = ACTIONS(2886),
    [anon_sym_DQUOTE] = ACTIONS(2886),
    [anon_sym_SQUOTE] = ACTIONS(2886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2886),
    [sym_number] = ACTIONS(2886),
    [sym_this] = ACTIONS(2888),
    [sym_super] = ACTIONS(2888),
    [sym_true] = ACTIONS(2888),
    [sym_false] = ACTIONS(2888),
    [sym_null] = ACTIONS(2888),
    [sym_undefined] = ACTIONS(2888),
    [anon_sym_AT] = ACTIONS(2886),
    [anon_sym_static] = ACTIONS(2888),
    [anon_sym_abstract] = ACTIONS(2888),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_declare] = ACTIONS(2888),
    [anon_sym_public] = ACTIONS(2888),
    [anon_sym_private] = ACTIONS(2888),
    [anon_sym_protected] = ACTIONS(2888),
    [anon_sym_module] = ACTIONS(2888),
    [anon_sym_any] = ACTIONS(2888),
    [anon_sym_number] = ACTIONS(2888),
    [anon_sym_boolean] = ACTIONS(2888),
    [anon_sym_string] = ACTIONS(2888),
    [anon_sym_symbol] = ACTIONS(2888),
    [anon_sym_interface] = ACTIONS(2888),
    [anon_sym_enum] = ACTIONS(2888),
  },
  [573] = {
    [ts_builtin_sym_end] = ACTIONS(2890),
    [sym_identifier] = ACTIONS(2892),
    [anon_sym_export] = ACTIONS(2892),
    [anon_sym_default] = ACTIONS(2892),
    [anon_sym_namespace] = ACTIONS(2892),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2890),
    [anon_sym_type] = ACTIONS(2892),
    [anon_sym_typeof] = ACTIONS(2892),
    [anon_sym_import] = ACTIONS(2892),
    [anon_sym_var] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_if] = ACTIONS(2892),
    [anon_sym_else] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_for] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(2890),
    [anon_sym_await] = ACTIONS(2892),
    [anon_sym_while] = ACTIONS(2892),
    [anon_sym_do] = ACTIONS(2892),
    [anon_sym_try] = ACTIONS(2892),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_break] = ACTIONS(2892),
    [anon_sym_continue] = ACTIONS(2892),
    [anon_sym_debugger] = ACTIONS(2892),
    [anon_sym_return] = ACTIONS(2892),
    [anon_sym_throw] = ACTIONS(2892),
    [anon_sym_SEMI] = ACTIONS(2890),
    [anon_sym_case] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_LBRACK] = ACTIONS(2890),
    [anon_sym_LT] = ACTIONS(2890),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_class] = ACTIONS(2892),
    [anon_sym_async] = ACTIONS(2892),
    [anon_sym_function] = ACTIONS(2892),
    [anon_sym_new] = ACTIONS(2892),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2890),
    [anon_sym_TILDE] = ACTIONS(2890),
    [anon_sym_void] = ACTIONS(2892),
    [anon_sym_delete] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2890),
    [anon_sym_DASH_DASH] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(2890),
    [anon_sym_SQUOTE] = ACTIONS(2890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [sym_number] = ACTIONS(2890),
    [sym_this] = ACTIONS(2892),
    [sym_super] = ACTIONS(2892),
    [sym_true] = ACTIONS(2892),
    [sym_false] = ACTIONS(2892),
    [sym_null] = ACTIONS(2892),
    [sym_undefined] = ACTIONS(2892),
    [anon_sym_AT] = ACTIONS(2890),
    [anon_sym_static] = ACTIONS(2892),
    [anon_sym_abstract] = ACTIONS(2892),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_declare] = ACTIONS(2892),
    [anon_sym_public] = ACTIONS(2892),
    [anon_sym_private] = ACTIONS(2892),
    [anon_sym_protected] = ACTIONS(2892),
    [anon_sym_module] = ACTIONS(2892),
    [anon_sym_any] = ACTIONS(2892),
    [anon_sym_number] = ACTIONS(2892),
    [anon_sym_boolean] = ACTIONS(2892),
    [anon_sym_string] = ACTIONS(2892),
    [anon_sym_symbol] = ACTIONS(2892),
    [anon_sym_interface] = ACTIONS(2892),
    [anon_sym_enum] = ACTIONS(2892),
  },
  [574] = {
    [ts_builtin_sym_end] = ACTIONS(2894),
    [sym_identifier] = ACTIONS(2896),
    [anon_sym_export] = ACTIONS(2896),
    [anon_sym_default] = ACTIONS(2896),
    [anon_sym_namespace] = ACTIONS(2896),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_type] = ACTIONS(2896),
    [anon_sym_typeof] = ACTIONS(2896),
    [anon_sym_import] = ACTIONS(2896),
    [anon_sym_var] = ACTIONS(2896),
    [anon_sym_let] = ACTIONS(2896),
    [anon_sym_const] = ACTIONS(2896),
    [anon_sym_if] = ACTIONS(2896),
    [anon_sym_else] = ACTIONS(2896),
    [anon_sym_switch] = ACTIONS(2896),
    [anon_sym_for] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_await] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2896),
    [anon_sym_do] = ACTIONS(2896),
    [anon_sym_try] = ACTIONS(2896),
    [anon_sym_with] = ACTIONS(2896),
    [anon_sym_break] = ACTIONS(2896),
    [anon_sym_continue] = ACTIONS(2896),
    [anon_sym_debugger] = ACTIONS(2896),
    [anon_sym_return] = ACTIONS(2896),
    [anon_sym_throw] = ACTIONS(2896),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_case] = ACTIONS(2896),
    [anon_sym_yield] = ACTIONS(2896),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LT] = ACTIONS(2894),
    [anon_sym_SLASH] = ACTIONS(2896),
    [anon_sym_class] = ACTIONS(2896),
    [anon_sym_async] = ACTIONS(2896),
    [anon_sym_function] = ACTIONS(2896),
    [anon_sym_new] = ACTIONS(2896),
    [anon_sym_PLUS] = ACTIONS(2896),
    [anon_sym_DASH] = ACTIONS(2896),
    [anon_sym_BANG] = ACTIONS(2894),
    [anon_sym_TILDE] = ACTIONS(2894),
    [anon_sym_void] = ACTIONS(2896),
    [anon_sym_delete] = ACTIONS(2896),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_DQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2894),
    [sym_number] = ACTIONS(2894),
    [sym_this] = ACTIONS(2896),
    [sym_super] = ACTIONS(2896),
    [sym_true] = ACTIONS(2896),
    [sym_false] = ACTIONS(2896),
    [sym_null] = ACTIONS(2896),
    [sym_undefined] = ACTIONS(2896),
    [anon_sym_AT] = ACTIONS(2894),
    [anon_sym_static] = ACTIONS(2896),
    [anon_sym_abstract] = ACTIONS(2896),
    [anon_sym_get] = ACTIONS(2896),
    [anon_sym_set] = ACTIONS(2896),
    [anon_sym_declare] = ACTIONS(2896),
    [anon_sym_public] = ACTIONS(2896),
    [anon_sym_private] = ACTIONS(2896),
    [anon_sym_protected] = ACTIONS(2896),
    [anon_sym_module] = ACTIONS(2896),
    [anon_sym_any] = ACTIONS(2896),
    [anon_sym_number] = ACTIONS(2896),
    [anon_sym_boolean] = ACTIONS(2896),
    [anon_sym_string] = ACTIONS(2896),
    [anon_sym_symbol] = ACTIONS(2896),
    [anon_sym_interface] = ACTIONS(2896),
    [anon_sym_enum] = ACTIONS(2896),
  },
  [575] = {
    [ts_builtin_sym_end] = ACTIONS(2898),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_LBRACE] = ACTIONS(2898),
    [anon_sym_RBRACE] = ACTIONS(2898),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_typeof] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2900),
    [anon_sym_var] = ACTIONS(2900),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_const] = ACTIONS(2900),
    [anon_sym_if] = ACTIONS(2900),
    [anon_sym_else] = ACTIONS(2900),
    [anon_sym_switch] = ACTIONS(2900),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_await] = ACTIONS(2900),
    [anon_sym_while] = ACTIONS(2900),
    [anon_sym_do] = ACTIONS(2900),
    [anon_sym_try] = ACTIONS(2900),
    [anon_sym_with] = ACTIONS(2900),
    [anon_sym_break] = ACTIONS(2900),
    [anon_sym_continue] = ACTIONS(2900),
    [anon_sym_debugger] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2900),
    [anon_sym_throw] = ACTIONS(2900),
    [anon_sym_SEMI] = ACTIONS(2898),
    [anon_sym_case] = ACTIONS(2900),
    [anon_sym_yield] = ACTIONS(2900),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [anon_sym_LT] = ACTIONS(2898),
    [anon_sym_SLASH] = ACTIONS(2900),
    [anon_sym_class] = ACTIONS(2900),
    [anon_sym_async] = ACTIONS(2900),
    [anon_sym_function] = ACTIONS(2900),
    [anon_sym_new] = ACTIONS(2900),
    [anon_sym_PLUS] = ACTIONS(2900),
    [anon_sym_DASH] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(2898),
    [anon_sym_TILDE] = ACTIONS(2898),
    [anon_sym_void] = ACTIONS(2900),
    [anon_sym_delete] = ACTIONS(2900),
    [anon_sym_PLUS_PLUS] = ACTIONS(2898),
    [anon_sym_DASH_DASH] = ACTIONS(2898),
    [anon_sym_DQUOTE] = ACTIONS(2898),
    [anon_sym_SQUOTE] = ACTIONS(2898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2898),
    [sym_number] = ACTIONS(2898),
    [sym_this] = ACTIONS(2900),
    [sym_super] = ACTIONS(2900),
    [sym_true] = ACTIONS(2900),
    [sym_false] = ACTIONS(2900),
    [sym_null] = ACTIONS(2900),
    [sym_undefined] = ACTIONS(2900),
    [anon_sym_AT] = ACTIONS(2898),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_abstract] = ACTIONS(2900),
    [anon_sym_get] = ACTIONS(2900),
    [anon_sym_set] = ACTIONS(2900),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_interface] = ACTIONS(2900),
    [anon_sym_enum] = ACTIONS(2900),
  },
  [576] = {
    [ts_builtin_sym_end] = ACTIONS(2902),
    [sym_identifier] = ACTIONS(2904),
    [anon_sym_export] = ACTIONS(2904),
    [anon_sym_default] = ACTIONS(2904),
    [anon_sym_namespace] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_RBRACE] = ACTIONS(2902),
    [anon_sym_type] = ACTIONS(2904),
    [anon_sym_typeof] = ACTIONS(2904),
    [anon_sym_import] = ACTIONS(2904),
    [anon_sym_var] = ACTIONS(2904),
    [anon_sym_let] = ACTIONS(2904),
    [anon_sym_const] = ACTIONS(2904),
    [anon_sym_if] = ACTIONS(2904),
    [anon_sym_else] = ACTIONS(2904),
    [anon_sym_switch] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_await] = ACTIONS(2904),
    [anon_sym_while] = ACTIONS(2904),
    [anon_sym_do] = ACTIONS(2904),
    [anon_sym_try] = ACTIONS(2904),
    [anon_sym_with] = ACTIONS(2904),
    [anon_sym_break] = ACTIONS(2904),
    [anon_sym_continue] = ACTIONS(2904),
    [anon_sym_debugger] = ACTIONS(2904),
    [anon_sym_return] = ACTIONS(2904),
    [anon_sym_throw] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(2902),
    [anon_sym_case] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(2904),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_LT] = ACTIONS(2902),
    [anon_sym_SLASH] = ACTIONS(2904),
    [anon_sym_class] = ACTIONS(2904),
    [anon_sym_async] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2904),
    [anon_sym_new] = ACTIONS(2904),
    [anon_sym_PLUS] = ACTIONS(2904),
    [anon_sym_DASH] = ACTIONS(2904),
    [anon_sym_BANG] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2902),
    [anon_sym_void] = ACTIONS(2904),
    [anon_sym_delete] = ACTIONS(2904),
    [anon_sym_PLUS_PLUS] = ACTIONS(2902),
    [anon_sym_DASH_DASH] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2902),
    [anon_sym_SQUOTE] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2902),
    [sym_number] = ACTIONS(2902),
    [sym_this] = ACTIONS(2904),
    [sym_super] = ACTIONS(2904),
    [sym_true] = ACTIONS(2904),
    [sym_false] = ACTIONS(2904),
    [sym_null] = ACTIONS(2904),
    [sym_undefined] = ACTIONS(2904),
    [anon_sym_AT] = ACTIONS(2902),
    [anon_sym_static] = ACTIONS(2904),
    [anon_sym_abstract] = ACTIONS(2904),
    [anon_sym_get] = ACTIONS(2904),
    [anon_sym_set] = ACTIONS(2904),
    [anon_sym_declare] = ACTIONS(2904),
    [anon_sym_public] = ACTIONS(2904),
    [anon_sym_private] = ACTIONS(2904),
    [anon_sym_protected] = ACTIONS(2904),
    [anon_sym_module] = ACTIONS(2904),
    [anon_sym_any] = ACTIONS(2904),
    [anon_sym_number] = ACTIONS(2904),
    [anon_sym_boolean] = ACTIONS(2904),
    [anon_sym_string] = ACTIONS(2904),
    [anon_sym_symbol] = ACTIONS(2904),
    [anon_sym_interface] = ACTIONS(2904),
    [anon_sym_enum] = ACTIONS(2904),
  },
  [577] = {
    [ts_builtin_sym_end] = ACTIONS(2906),
    [sym_identifier] = ACTIONS(2908),
    [anon_sym_export] = ACTIONS(2908),
    [anon_sym_default] = ACTIONS(2908),
    [anon_sym_namespace] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(2906),
    [anon_sym_type] = ACTIONS(2908),
    [anon_sym_typeof] = ACTIONS(2908),
    [anon_sym_import] = ACTIONS(2908),
    [anon_sym_var] = ACTIONS(2908),
    [anon_sym_let] = ACTIONS(2908),
    [anon_sym_const] = ACTIONS(2908),
    [anon_sym_if] = ACTIONS(2908),
    [anon_sym_else] = ACTIONS(2908),
    [anon_sym_switch] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_await] = ACTIONS(2908),
    [anon_sym_while] = ACTIONS(2908),
    [anon_sym_do] = ACTIONS(2908),
    [anon_sym_try] = ACTIONS(2908),
    [anon_sym_with] = ACTIONS(2908),
    [anon_sym_break] = ACTIONS(2908),
    [anon_sym_continue] = ACTIONS(2908),
    [anon_sym_debugger] = ACTIONS(2908),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_throw] = ACTIONS(2908),
    [anon_sym_SEMI] = ACTIONS(2906),
    [anon_sym_case] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2908),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_LT] = ACTIONS(2906),
    [anon_sym_SLASH] = ACTIONS(2908),
    [anon_sym_class] = ACTIONS(2908),
    [anon_sym_async] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2908),
    [anon_sym_new] = ACTIONS(2908),
    [anon_sym_PLUS] = ACTIONS(2908),
    [anon_sym_DASH] = ACTIONS(2908),
    [anon_sym_BANG] = ACTIONS(2906),
    [anon_sym_TILDE] = ACTIONS(2906),
    [anon_sym_void] = ACTIONS(2908),
    [anon_sym_delete] = ACTIONS(2908),
    [anon_sym_PLUS_PLUS] = ACTIONS(2906),
    [anon_sym_DASH_DASH] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_SQUOTE] = ACTIONS(2906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2906),
    [sym_number] = ACTIONS(2906),
    [sym_this] = ACTIONS(2908),
    [sym_super] = ACTIONS(2908),
    [sym_true] = ACTIONS(2908),
    [sym_false] = ACTIONS(2908),
    [sym_null] = ACTIONS(2908),
    [sym_undefined] = ACTIONS(2908),
    [anon_sym_AT] = ACTIONS(2906),
    [anon_sym_static] = ACTIONS(2908),
    [anon_sym_abstract] = ACTIONS(2908),
    [anon_sym_get] = ACTIONS(2908),
    [anon_sym_set] = ACTIONS(2908),
    [anon_sym_declare] = ACTIONS(2908),
    [anon_sym_public] = ACTIONS(2908),
    [anon_sym_private] = ACTIONS(2908),
    [anon_sym_protected] = ACTIONS(2908),
    [anon_sym_module] = ACTIONS(2908),
    [anon_sym_any] = ACTIONS(2908),
    [anon_sym_number] = ACTIONS(2908),
    [anon_sym_boolean] = ACTIONS(2908),
    [anon_sym_string] = ACTIONS(2908),
    [anon_sym_symbol] = ACTIONS(2908),
    [anon_sym_interface] = ACTIONS(2908),
    [anon_sym_enum] = ACTIONS(2908),
  },
  [578] = {
    [ts_builtin_sym_end] = ACTIONS(2910),
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_default] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_RBRACE] = ACTIONS(2910),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2912),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_var] = ACTIONS(2912),
    [anon_sym_let] = ACTIONS(2912),
    [anon_sym_const] = ACTIONS(2912),
    [anon_sym_if] = ACTIONS(2912),
    [anon_sym_else] = ACTIONS(2912),
    [anon_sym_switch] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_await] = ACTIONS(2912),
    [anon_sym_while] = ACTIONS(2912),
    [anon_sym_do] = ACTIONS(2912),
    [anon_sym_try] = ACTIONS(2912),
    [anon_sym_with] = ACTIONS(2912),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_continue] = ACTIONS(2912),
    [anon_sym_debugger] = ACTIONS(2912),
    [anon_sym_return] = ACTIONS(2912),
    [anon_sym_throw] = ACTIONS(2912),
    [anon_sym_SEMI] = ACTIONS(2910),
    [anon_sym_case] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2912),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_LT] = ACTIONS(2910),
    [anon_sym_SLASH] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2912),
    [anon_sym_PLUS] = ACTIONS(2912),
    [anon_sym_DASH] = ACTIONS(2912),
    [anon_sym_BANG] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2910),
    [anon_sym_void] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2912),
    [anon_sym_PLUS_PLUS] = ACTIONS(2910),
    [anon_sym_DASH_DASH] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_SQUOTE] = ACTIONS(2910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2910),
    [sym_number] = ACTIONS(2910),
    [sym_this] = ACTIONS(2912),
    [sym_super] = ACTIONS(2912),
    [sym_true] = ACTIONS(2912),
    [sym_false] = ACTIONS(2912),
    [sym_null] = ACTIONS(2912),
    [sym_undefined] = ACTIONS(2912),
    [anon_sym_AT] = ACTIONS(2910),
    [anon_sym_static] = ACTIONS(2912),
    [anon_sym_abstract] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_interface] = ACTIONS(2912),
    [anon_sym_enum] = ACTIONS(2912),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(2914),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_export] = ACTIONS(2916),
    [anon_sym_default] = ACTIONS(2916),
    [anon_sym_namespace] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_RBRACE] = ACTIONS(2914),
    [anon_sym_type] = ACTIONS(2916),
    [anon_sym_typeof] = ACTIONS(2916),
    [anon_sym_import] = ACTIONS(2916),
    [anon_sym_var] = ACTIONS(2916),
    [anon_sym_let] = ACTIONS(2916),
    [anon_sym_const] = ACTIONS(2916),
    [anon_sym_if] = ACTIONS(2916),
    [anon_sym_else] = ACTIONS(2916),
    [anon_sym_switch] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_await] = ACTIONS(2916),
    [anon_sym_while] = ACTIONS(2916),
    [anon_sym_do] = ACTIONS(2916),
    [anon_sym_try] = ACTIONS(2916),
    [anon_sym_with] = ACTIONS(2916),
    [anon_sym_break] = ACTIONS(2916),
    [anon_sym_continue] = ACTIONS(2916),
    [anon_sym_debugger] = ACTIONS(2916),
    [anon_sym_return] = ACTIONS(2916),
    [anon_sym_throw] = ACTIONS(2916),
    [anon_sym_SEMI] = ACTIONS(2914),
    [anon_sym_case] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2916),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_LT] = ACTIONS(2914),
    [anon_sym_SLASH] = ACTIONS(2916),
    [anon_sym_class] = ACTIONS(2916),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_PLUS] = ACTIONS(2916),
    [anon_sym_DASH] = ACTIONS(2916),
    [anon_sym_BANG] = ACTIONS(2914),
    [anon_sym_TILDE] = ACTIONS(2914),
    [anon_sym_void] = ACTIONS(2916),
    [anon_sym_delete] = ACTIONS(2916),
    [anon_sym_PLUS_PLUS] = ACTIONS(2914),
    [anon_sym_DASH_DASH] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_SQUOTE] = ACTIONS(2914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2914),
    [sym_number] = ACTIONS(2914),
    [sym_this] = ACTIONS(2916),
    [sym_super] = ACTIONS(2916),
    [sym_true] = ACTIONS(2916),
    [sym_false] = ACTIONS(2916),
    [sym_null] = ACTIONS(2916),
    [sym_undefined] = ACTIONS(2916),
    [anon_sym_AT] = ACTIONS(2914),
    [anon_sym_static] = ACTIONS(2916),
    [anon_sym_abstract] = ACTIONS(2916),
    [anon_sym_get] = ACTIONS(2916),
    [anon_sym_set] = ACTIONS(2916),
    [anon_sym_declare] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2916),
    [anon_sym_private] = ACTIONS(2916),
    [anon_sym_protected] = ACTIONS(2916),
    [anon_sym_module] = ACTIONS(2916),
    [anon_sym_any] = ACTIONS(2916),
    [anon_sym_number] = ACTIONS(2916),
    [anon_sym_boolean] = ACTIONS(2916),
    [anon_sym_string] = ACTIONS(2916),
    [anon_sym_symbol] = ACTIONS(2916),
    [anon_sym_interface] = ACTIONS(2916),
    [anon_sym_enum] = ACTIONS(2916),
  },
  [580] = {
    [sym__call_signature] = STATE(2760),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2636),
    [anon_sym_export] = ACTIONS(2638),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2638),
    [anon_sym_LBRACE] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2638),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_async] = ACTIONS(2638),
    [anon_sym_function] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(648),
    [anon_sym_PLUS_EQ] = ACTIONS(742),
    [anon_sym_DASH_EQ] = ACTIONS(742),
    [anon_sym_STAR_EQ] = ACTIONS(742),
    [anon_sym_SLASH_EQ] = ACTIONS(742),
    [anon_sym_PERCENT_EQ] = ACTIONS(742),
    [anon_sym_CARET_EQ] = ACTIONS(742),
    [anon_sym_AMP_EQ] = ACTIONS(742),
    [anon_sym_PIPE_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_LT_EQ] = ACTIONS(742),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2638),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2638),
    [anon_sym_get] = ACTIONS(2638),
    [anon_sym_set] = ACTIONS(2638),
    [anon_sym_declare] = ACTIONS(2638),
    [anon_sym_public] = ACTIONS(2638),
    [anon_sym_private] = ACTIONS(2638),
    [anon_sym_protected] = ACTIONS(2638),
    [anon_sym_module] = ACTIONS(2638),
    [anon_sym_any] = ACTIONS(2638),
    [anon_sym_number] = ACTIONS(2638),
    [anon_sym_boolean] = ACTIONS(2638),
    [anon_sym_string] = ACTIONS(2638),
    [anon_sym_symbol] = ACTIONS(2638),
    [anon_sym_implements] = ACTIONS(445),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(2918),
    [sym_identifier] = ACTIONS(2920),
    [anon_sym_export] = ACTIONS(2920),
    [anon_sym_default] = ACTIONS(2920),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_RBRACE] = ACTIONS(2918),
    [anon_sym_type] = ACTIONS(2920),
    [anon_sym_typeof] = ACTIONS(2920),
    [anon_sym_import] = ACTIONS(2920),
    [anon_sym_var] = ACTIONS(2920),
    [anon_sym_let] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_if] = ACTIONS(2920),
    [anon_sym_else] = ACTIONS(2920),
    [anon_sym_switch] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2920),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_await] = ACTIONS(2920),
    [anon_sym_while] = ACTIONS(2920),
    [anon_sym_do] = ACTIONS(2920),
    [anon_sym_try] = ACTIONS(2920),
    [anon_sym_with] = ACTIONS(2920),
    [anon_sym_break] = ACTIONS(2920),
    [anon_sym_continue] = ACTIONS(2920),
    [anon_sym_debugger] = ACTIONS(2920),
    [anon_sym_return] = ACTIONS(2920),
    [anon_sym_throw] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2918),
    [anon_sym_case] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_LT] = ACTIONS(2918),
    [anon_sym_SLASH] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_async] = ACTIONS(2920),
    [anon_sym_function] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2920),
    [anon_sym_DASH] = ACTIONS(2920),
    [anon_sym_BANG] = ACTIONS(2918),
    [anon_sym_TILDE] = ACTIONS(2918),
    [anon_sym_void] = ACTIONS(2920),
    [anon_sym_delete] = ACTIONS(2920),
    [anon_sym_PLUS_PLUS] = ACTIONS(2918),
    [anon_sym_DASH_DASH] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_SQUOTE] = ACTIONS(2918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2918),
    [sym_number] = ACTIONS(2918),
    [sym_this] = ACTIONS(2920),
    [sym_super] = ACTIONS(2920),
    [sym_true] = ACTIONS(2920),
    [sym_false] = ACTIONS(2920),
    [sym_null] = ACTIONS(2920),
    [sym_undefined] = ACTIONS(2920),
    [anon_sym_AT] = ACTIONS(2918),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_abstract] = ACTIONS(2920),
    [anon_sym_get] = ACTIONS(2920),
    [anon_sym_set] = ACTIONS(2920),
    [anon_sym_declare] = ACTIONS(2920),
    [anon_sym_public] = ACTIONS(2920),
    [anon_sym_private] = ACTIONS(2920),
    [anon_sym_protected] = ACTIONS(2920),
    [anon_sym_module] = ACTIONS(2920),
    [anon_sym_any] = ACTIONS(2920),
    [anon_sym_number] = ACTIONS(2920),
    [anon_sym_boolean] = ACTIONS(2920),
    [anon_sym_string] = ACTIONS(2920),
    [anon_sym_symbol] = ACTIONS(2920),
    [anon_sym_interface] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
  },
  [582] = {
    [ts_builtin_sym_end] = ACTIONS(2922),
    [sym_identifier] = ACTIONS(2924),
    [anon_sym_export] = ACTIONS(2924),
    [anon_sym_default] = ACTIONS(2924),
    [anon_sym_namespace] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_RBRACE] = ACTIONS(2922),
    [anon_sym_type] = ACTIONS(2924),
    [anon_sym_typeof] = ACTIONS(2924),
    [anon_sym_import] = ACTIONS(2924),
    [anon_sym_var] = ACTIONS(2924),
    [anon_sym_let] = ACTIONS(2924),
    [anon_sym_const] = ACTIONS(2924),
    [anon_sym_if] = ACTIONS(2924),
    [anon_sym_else] = ACTIONS(2924),
    [anon_sym_switch] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2924),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_await] = ACTIONS(2924),
    [anon_sym_while] = ACTIONS(2924),
    [anon_sym_do] = ACTIONS(2924),
    [anon_sym_try] = ACTIONS(2924),
    [anon_sym_with] = ACTIONS(2924),
    [anon_sym_break] = ACTIONS(2924),
    [anon_sym_continue] = ACTIONS(2924),
    [anon_sym_debugger] = ACTIONS(2924),
    [anon_sym_return] = ACTIONS(2924),
    [anon_sym_throw] = ACTIONS(2924),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym_case] = ACTIONS(2924),
    [anon_sym_yield] = ACTIONS(2924),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2924),
    [anon_sym_class] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(2924),
    [anon_sym_function] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2924),
    [anon_sym_PLUS] = ACTIONS(2924),
    [anon_sym_DASH] = ACTIONS(2924),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_void] = ACTIONS(2924),
    [anon_sym_delete] = ACTIONS(2924),
    [anon_sym_PLUS_PLUS] = ACTIONS(2922),
    [anon_sym_DASH_DASH] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [anon_sym_SQUOTE] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2922),
    [sym_number] = ACTIONS(2922),
    [sym_this] = ACTIONS(2924),
    [sym_super] = ACTIONS(2924),
    [sym_true] = ACTIONS(2924),
    [sym_false] = ACTIONS(2924),
    [sym_null] = ACTIONS(2924),
    [sym_undefined] = ACTIONS(2924),
    [anon_sym_AT] = ACTIONS(2922),
    [anon_sym_static] = ACTIONS(2924),
    [anon_sym_abstract] = ACTIONS(2924),
    [anon_sym_get] = ACTIONS(2924),
    [anon_sym_set] = ACTIONS(2924),
    [anon_sym_declare] = ACTIONS(2924),
    [anon_sym_public] = ACTIONS(2924),
    [anon_sym_private] = ACTIONS(2924),
    [anon_sym_protected] = ACTIONS(2924),
    [anon_sym_module] = ACTIONS(2924),
    [anon_sym_any] = ACTIONS(2924),
    [anon_sym_number] = ACTIONS(2924),
    [anon_sym_boolean] = ACTIONS(2924),
    [anon_sym_string] = ACTIONS(2924),
    [anon_sym_symbol] = ACTIONS(2924),
    [anon_sym_interface] = ACTIONS(2924),
    [anon_sym_enum] = ACTIONS(2924),
  },
  [583] = {
    [ts_builtin_sym_end] = ACTIONS(2926),
    [sym_identifier] = ACTIONS(2928),
    [anon_sym_export] = ACTIONS(2928),
    [anon_sym_default] = ACTIONS(2928),
    [anon_sym_namespace] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_RBRACE] = ACTIONS(2926),
    [anon_sym_type] = ACTIONS(2928),
    [anon_sym_typeof] = ACTIONS(2928),
    [anon_sym_import] = ACTIONS(2928),
    [anon_sym_var] = ACTIONS(2928),
    [anon_sym_let] = ACTIONS(2928),
    [anon_sym_const] = ACTIONS(2928),
    [anon_sym_if] = ACTIONS(2928),
    [anon_sym_else] = ACTIONS(2928),
    [anon_sym_switch] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2928),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_await] = ACTIONS(2928),
    [anon_sym_while] = ACTIONS(2928),
    [anon_sym_do] = ACTIONS(2928),
    [anon_sym_try] = ACTIONS(2928),
    [anon_sym_with] = ACTIONS(2928),
    [anon_sym_break] = ACTIONS(2928),
    [anon_sym_continue] = ACTIONS(2928),
    [anon_sym_debugger] = ACTIONS(2928),
    [anon_sym_return] = ACTIONS(2928),
    [anon_sym_throw] = ACTIONS(2928),
    [anon_sym_SEMI] = ACTIONS(2926),
    [anon_sym_case] = ACTIONS(2928),
    [anon_sym_yield] = ACTIONS(2928),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LT] = ACTIONS(2926),
    [anon_sym_SLASH] = ACTIONS(2928),
    [anon_sym_class] = ACTIONS(2928),
    [anon_sym_async] = ACTIONS(2928),
    [anon_sym_function] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2928),
    [anon_sym_PLUS] = ACTIONS(2928),
    [anon_sym_DASH] = ACTIONS(2928),
    [anon_sym_BANG] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2926),
    [anon_sym_void] = ACTIONS(2928),
    [anon_sym_delete] = ACTIONS(2928),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_SQUOTE] = ACTIONS(2926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2926),
    [sym_number] = ACTIONS(2926),
    [sym_this] = ACTIONS(2928),
    [sym_super] = ACTIONS(2928),
    [sym_true] = ACTIONS(2928),
    [sym_false] = ACTIONS(2928),
    [sym_null] = ACTIONS(2928),
    [sym_undefined] = ACTIONS(2928),
    [anon_sym_AT] = ACTIONS(2926),
    [anon_sym_static] = ACTIONS(2928),
    [anon_sym_abstract] = ACTIONS(2928),
    [anon_sym_get] = ACTIONS(2928),
    [anon_sym_set] = ACTIONS(2928),
    [anon_sym_declare] = ACTIONS(2928),
    [anon_sym_public] = ACTIONS(2928),
    [anon_sym_private] = ACTIONS(2928),
    [anon_sym_protected] = ACTIONS(2928),
    [anon_sym_module] = ACTIONS(2928),
    [anon_sym_any] = ACTIONS(2928),
    [anon_sym_number] = ACTIONS(2928),
    [anon_sym_boolean] = ACTIONS(2928),
    [anon_sym_string] = ACTIONS(2928),
    [anon_sym_symbol] = ACTIONS(2928),
    [anon_sym_interface] = ACTIONS(2928),
    [anon_sym_enum] = ACTIONS(2928),
  },
  [584] = {
    [ts_builtin_sym_end] = ACTIONS(2930),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_export] = ACTIONS(2932),
    [anon_sym_default] = ACTIONS(2932),
    [anon_sym_namespace] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_RBRACE] = ACTIONS(2930),
    [anon_sym_type] = ACTIONS(2932),
    [anon_sym_typeof] = ACTIONS(2932),
    [anon_sym_import] = ACTIONS(2932),
    [anon_sym_var] = ACTIONS(2932),
    [anon_sym_let] = ACTIONS(2932),
    [anon_sym_const] = ACTIONS(2932),
    [anon_sym_if] = ACTIONS(2932),
    [anon_sym_else] = ACTIONS(2932),
    [anon_sym_switch] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2932),
    [anon_sym_LPAREN] = ACTIONS(2930),
    [anon_sym_await] = ACTIONS(2932),
    [anon_sym_while] = ACTIONS(2932),
    [anon_sym_do] = ACTIONS(2932),
    [anon_sym_try] = ACTIONS(2932),
    [anon_sym_with] = ACTIONS(2932),
    [anon_sym_break] = ACTIONS(2932),
    [anon_sym_continue] = ACTIONS(2932),
    [anon_sym_debugger] = ACTIONS(2932),
    [anon_sym_return] = ACTIONS(2932),
    [anon_sym_throw] = ACTIONS(2932),
    [anon_sym_SEMI] = ACTIONS(2930),
    [anon_sym_case] = ACTIONS(2932),
    [anon_sym_yield] = ACTIONS(2932),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2930),
    [anon_sym_SLASH] = ACTIONS(2932),
    [anon_sym_class] = ACTIONS(2932),
    [anon_sym_async] = ACTIONS(2932),
    [anon_sym_function] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2932),
    [anon_sym_PLUS] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2932),
    [anon_sym_BANG] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2930),
    [anon_sym_void] = ACTIONS(2932),
    [anon_sym_delete] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2930),
    [anon_sym_DASH_DASH] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_SQUOTE] = ACTIONS(2930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [sym_number] = ACTIONS(2930),
    [sym_this] = ACTIONS(2932),
    [sym_super] = ACTIONS(2932),
    [sym_true] = ACTIONS(2932),
    [sym_false] = ACTIONS(2932),
    [sym_null] = ACTIONS(2932),
    [sym_undefined] = ACTIONS(2932),
    [anon_sym_AT] = ACTIONS(2930),
    [anon_sym_static] = ACTIONS(2932),
    [anon_sym_abstract] = ACTIONS(2932),
    [anon_sym_get] = ACTIONS(2932),
    [anon_sym_set] = ACTIONS(2932),
    [anon_sym_declare] = ACTIONS(2932),
    [anon_sym_public] = ACTIONS(2932),
    [anon_sym_private] = ACTIONS(2932),
    [anon_sym_protected] = ACTIONS(2932),
    [anon_sym_module] = ACTIONS(2932),
    [anon_sym_any] = ACTIONS(2932),
    [anon_sym_number] = ACTIONS(2932),
    [anon_sym_boolean] = ACTIONS(2932),
    [anon_sym_string] = ACTIONS(2932),
    [anon_sym_symbol] = ACTIONS(2932),
    [anon_sym_interface] = ACTIONS(2932),
    [anon_sym_enum] = ACTIONS(2932),
  },
  [585] = {
    [ts_builtin_sym_end] = ACTIONS(2934),
    [sym_identifier] = ACTIONS(2936),
    [anon_sym_export] = ACTIONS(2936),
    [anon_sym_default] = ACTIONS(2936),
    [anon_sym_namespace] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_RBRACE] = ACTIONS(2934),
    [anon_sym_type] = ACTIONS(2936),
    [anon_sym_typeof] = ACTIONS(2936),
    [anon_sym_import] = ACTIONS(2936),
    [anon_sym_var] = ACTIONS(2936),
    [anon_sym_let] = ACTIONS(2936),
    [anon_sym_const] = ACTIONS(2936),
    [anon_sym_if] = ACTIONS(2936),
    [anon_sym_else] = ACTIONS(2936),
    [anon_sym_switch] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_await] = ACTIONS(2936),
    [anon_sym_while] = ACTIONS(2936),
    [anon_sym_do] = ACTIONS(2936),
    [anon_sym_try] = ACTIONS(2936),
    [anon_sym_with] = ACTIONS(2936),
    [anon_sym_break] = ACTIONS(2936),
    [anon_sym_continue] = ACTIONS(2936),
    [anon_sym_debugger] = ACTIONS(2936),
    [anon_sym_return] = ACTIONS(2936),
    [anon_sym_throw] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2934),
    [anon_sym_case] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_LT] = ACTIONS(2934),
    [anon_sym_SLASH] = ACTIONS(2936),
    [anon_sym_class] = ACTIONS(2936),
    [anon_sym_async] = ACTIONS(2936),
    [anon_sym_function] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2936),
    [anon_sym_PLUS] = ACTIONS(2936),
    [anon_sym_DASH] = ACTIONS(2936),
    [anon_sym_BANG] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2934),
    [anon_sym_void] = ACTIONS(2936),
    [anon_sym_delete] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2934),
    [anon_sym_DASH_DASH] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [anon_sym_SQUOTE] = ACTIONS(2934),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2934),
    [sym_number] = ACTIONS(2934),
    [sym_this] = ACTIONS(2936),
    [sym_super] = ACTIONS(2936),
    [sym_true] = ACTIONS(2936),
    [sym_false] = ACTIONS(2936),
    [sym_null] = ACTIONS(2936),
    [sym_undefined] = ACTIONS(2936),
    [anon_sym_AT] = ACTIONS(2934),
    [anon_sym_static] = ACTIONS(2936),
    [anon_sym_abstract] = ACTIONS(2936),
    [anon_sym_get] = ACTIONS(2936),
    [anon_sym_set] = ACTIONS(2936),
    [anon_sym_declare] = ACTIONS(2936),
    [anon_sym_public] = ACTIONS(2936),
    [anon_sym_private] = ACTIONS(2936),
    [anon_sym_protected] = ACTIONS(2936),
    [anon_sym_module] = ACTIONS(2936),
    [anon_sym_any] = ACTIONS(2936),
    [anon_sym_number] = ACTIONS(2936),
    [anon_sym_boolean] = ACTIONS(2936),
    [anon_sym_string] = ACTIONS(2936),
    [anon_sym_symbol] = ACTIONS(2936),
    [anon_sym_interface] = ACTIONS(2936),
    [anon_sym_enum] = ACTIONS(2936),
  },
  [586] = {
    [ts_builtin_sym_end] = ACTIONS(2938),
    [sym_identifier] = ACTIONS(2940),
    [anon_sym_export] = ACTIONS(2940),
    [anon_sym_default] = ACTIONS(2940),
    [anon_sym_namespace] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_RBRACE] = ACTIONS(2938),
    [anon_sym_type] = ACTIONS(2940),
    [anon_sym_typeof] = ACTIONS(2940),
    [anon_sym_import] = ACTIONS(2940),
    [anon_sym_var] = ACTIONS(2940),
    [anon_sym_let] = ACTIONS(2940),
    [anon_sym_const] = ACTIONS(2940),
    [anon_sym_if] = ACTIONS(2940),
    [anon_sym_else] = ACTIONS(2940),
    [anon_sym_switch] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_await] = ACTIONS(2940),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_do] = ACTIONS(2940),
    [anon_sym_try] = ACTIONS(2940),
    [anon_sym_with] = ACTIONS(2940),
    [anon_sym_break] = ACTIONS(2940),
    [anon_sym_continue] = ACTIONS(2940),
    [anon_sym_debugger] = ACTIONS(2940),
    [anon_sym_return] = ACTIONS(2940),
    [anon_sym_throw] = ACTIONS(2940),
    [anon_sym_SEMI] = ACTIONS(2938),
    [anon_sym_case] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2940),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LT] = ACTIONS(2938),
    [anon_sym_SLASH] = ACTIONS(2940),
    [anon_sym_class] = ACTIONS(2940),
    [anon_sym_async] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2940),
    [anon_sym_new] = ACTIONS(2940),
    [anon_sym_PLUS] = ACTIONS(2940),
    [anon_sym_DASH] = ACTIONS(2940),
    [anon_sym_BANG] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2938),
    [anon_sym_void] = ACTIONS(2940),
    [anon_sym_delete] = ACTIONS(2940),
    [anon_sym_PLUS_PLUS] = ACTIONS(2938),
    [anon_sym_DASH_DASH] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_SQUOTE] = ACTIONS(2938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2938),
    [sym_number] = ACTIONS(2938),
    [sym_this] = ACTIONS(2940),
    [sym_super] = ACTIONS(2940),
    [sym_true] = ACTIONS(2940),
    [sym_false] = ACTIONS(2940),
    [sym_null] = ACTIONS(2940),
    [sym_undefined] = ACTIONS(2940),
    [anon_sym_AT] = ACTIONS(2938),
    [anon_sym_static] = ACTIONS(2940),
    [anon_sym_abstract] = ACTIONS(2940),
    [anon_sym_get] = ACTIONS(2940),
    [anon_sym_set] = ACTIONS(2940),
    [anon_sym_declare] = ACTIONS(2940),
    [anon_sym_public] = ACTIONS(2940),
    [anon_sym_private] = ACTIONS(2940),
    [anon_sym_protected] = ACTIONS(2940),
    [anon_sym_module] = ACTIONS(2940),
    [anon_sym_any] = ACTIONS(2940),
    [anon_sym_number] = ACTIONS(2940),
    [anon_sym_boolean] = ACTIONS(2940),
    [anon_sym_string] = ACTIONS(2940),
    [anon_sym_symbol] = ACTIONS(2940),
    [anon_sym_interface] = ACTIONS(2940),
    [anon_sym_enum] = ACTIONS(2940),
  },
  [587] = {
    [ts_builtin_sym_end] = ACTIONS(2942),
    [sym_identifier] = ACTIONS(2944),
    [anon_sym_export] = ACTIONS(2944),
    [anon_sym_default] = ACTIONS(2944),
    [anon_sym_namespace] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_RBRACE] = ACTIONS(2942),
    [anon_sym_type] = ACTIONS(2944),
    [anon_sym_typeof] = ACTIONS(2944),
    [anon_sym_import] = ACTIONS(2944),
    [anon_sym_var] = ACTIONS(2944),
    [anon_sym_let] = ACTIONS(2944),
    [anon_sym_const] = ACTIONS(2944),
    [anon_sym_if] = ACTIONS(2944),
    [anon_sym_else] = ACTIONS(2944),
    [anon_sym_switch] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2944),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_await] = ACTIONS(2944),
    [anon_sym_while] = ACTIONS(2944),
    [anon_sym_do] = ACTIONS(2944),
    [anon_sym_try] = ACTIONS(2944),
    [anon_sym_with] = ACTIONS(2944),
    [anon_sym_break] = ACTIONS(2944),
    [anon_sym_continue] = ACTIONS(2944),
    [anon_sym_debugger] = ACTIONS(2944),
    [anon_sym_return] = ACTIONS(2944),
    [anon_sym_throw] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2942),
    [anon_sym_case] = ACTIONS(2944),
    [anon_sym_yield] = ACTIONS(2944),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_LT] = ACTIONS(2942),
    [anon_sym_SLASH] = ACTIONS(2944),
    [anon_sym_class] = ACTIONS(2944),
    [anon_sym_async] = ACTIONS(2944),
    [anon_sym_function] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2944),
    [anon_sym_DASH] = ACTIONS(2944),
    [anon_sym_BANG] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2942),
    [anon_sym_void] = ACTIONS(2944),
    [anon_sym_delete] = ACTIONS(2944),
    [anon_sym_PLUS_PLUS] = ACTIONS(2942),
    [anon_sym_DASH_DASH] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [anon_sym_SQUOTE] = ACTIONS(2942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2942),
    [sym_number] = ACTIONS(2942),
    [sym_this] = ACTIONS(2944),
    [sym_super] = ACTIONS(2944),
    [sym_true] = ACTIONS(2944),
    [sym_false] = ACTIONS(2944),
    [sym_null] = ACTIONS(2944),
    [sym_undefined] = ACTIONS(2944),
    [anon_sym_AT] = ACTIONS(2942),
    [anon_sym_static] = ACTIONS(2944),
    [anon_sym_abstract] = ACTIONS(2944),
    [anon_sym_get] = ACTIONS(2944),
    [anon_sym_set] = ACTIONS(2944),
    [anon_sym_declare] = ACTIONS(2944),
    [anon_sym_public] = ACTIONS(2944),
    [anon_sym_private] = ACTIONS(2944),
    [anon_sym_protected] = ACTIONS(2944),
    [anon_sym_module] = ACTIONS(2944),
    [anon_sym_any] = ACTIONS(2944),
    [anon_sym_number] = ACTIONS(2944),
    [anon_sym_boolean] = ACTIONS(2944),
    [anon_sym_string] = ACTIONS(2944),
    [anon_sym_symbol] = ACTIONS(2944),
    [anon_sym_interface] = ACTIONS(2944),
    [anon_sym_enum] = ACTIONS(2944),
  },
  [588] = {
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_LBRACE] = ACTIONS(2543),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(608),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2541),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_this] = ACTIONS(2541),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
  },
  [589] = {
    [sym__call_signature] = STATE(2835),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2734),
    [anon_sym_export] = ACTIONS(2736),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2736),
    [anon_sym_type] = ACTIONS(2736),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_async] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2736),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2736),
    [anon_sym_get] = ACTIONS(2736),
    [anon_sym_set] = ACTIONS(2736),
    [anon_sym_declare] = ACTIONS(2736),
    [anon_sym_public] = ACTIONS(2736),
    [anon_sym_private] = ACTIONS(2736),
    [anon_sym_protected] = ACTIONS(2736),
    [anon_sym_module] = ACTIONS(2736),
    [anon_sym_any] = ACTIONS(2736),
    [anon_sym_number] = ACTIONS(2736),
    [anon_sym_boolean] = ACTIONS(2736),
    [anon_sym_string] = ACTIONS(2736),
    [anon_sym_symbol] = ACTIONS(2736),
  },
  [590] = {
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_LBRACE] = ACTIONS(2543),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2541),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_this] = ACTIONS(2541),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
  },
  [591] = {
    [sym__call_signature] = STATE(2835),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2734),
    [anon_sym_export] = ACTIONS(2736),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2736),
    [anon_sym_type] = ACTIONS(2736),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_async] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2736),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2736),
    [anon_sym_get] = ACTIONS(2736),
    [anon_sym_set] = ACTIONS(2736),
    [anon_sym_declare] = ACTIONS(2736),
    [anon_sym_public] = ACTIONS(2736),
    [anon_sym_private] = ACTIONS(2736),
    [anon_sym_protected] = ACTIONS(2736),
    [anon_sym_module] = ACTIONS(2736),
    [anon_sym_any] = ACTIONS(2736),
    [anon_sym_number] = ACTIONS(2736),
    [anon_sym_boolean] = ACTIONS(2736),
    [anon_sym_string] = ACTIONS(2736),
    [anon_sym_symbol] = ACTIONS(2736),
  },
  [592] = {
    [sym__call_signature] = STATE(2885),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2810),
    [anon_sym_export] = ACTIONS(2812),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(614),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2812),
    [anon_sym_type] = ACTIONS(2812),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_async] = ACTIONS(2812),
    [anon_sym_function] = ACTIONS(2572),
    [anon_sym_EQ_GT] = ACTIONS(626),
    [anon_sym_PLUS_EQ] = ACTIONS(630),
    [anon_sym_DASH_EQ] = ACTIONS(630),
    [anon_sym_STAR_EQ] = ACTIONS(630),
    [anon_sym_SLASH_EQ] = ACTIONS(630),
    [anon_sym_PERCENT_EQ] = ACTIONS(630),
    [anon_sym_CARET_EQ] = ACTIONS(630),
    [anon_sym_AMP_EQ] = ACTIONS(630),
    [anon_sym_PIPE_EQ] = ACTIONS(630),
    [anon_sym_GT_GT_EQ] = ACTIONS(630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(630),
    [anon_sym_LT_LT_EQ] = ACTIONS(630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(630),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2812),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2812),
    [anon_sym_get] = ACTIONS(2812),
    [anon_sym_set] = ACTIONS(2812),
    [anon_sym_declare] = ACTIONS(2812),
    [anon_sym_public] = ACTIONS(2812),
    [anon_sym_private] = ACTIONS(2812),
    [anon_sym_protected] = ACTIONS(2812),
    [anon_sym_module] = ACTIONS(2812),
    [anon_sym_any] = ACTIONS(2812),
    [anon_sym_number] = ACTIONS(2812),
    [anon_sym_boolean] = ACTIONS(2812),
    [anon_sym_string] = ACTIONS(2812),
    [anon_sym_symbol] = ACTIONS(2812),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [593] = {
    [sym__call_signature] = STATE(2835),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2734),
    [anon_sym_export] = ACTIONS(2736),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2736),
    [anon_sym_type] = ACTIONS(2736),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_async] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2736),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2736),
    [anon_sym_get] = ACTIONS(2736),
    [anon_sym_set] = ACTIONS(2736),
    [anon_sym_declare] = ACTIONS(2736),
    [anon_sym_public] = ACTIONS(2736),
    [anon_sym_private] = ACTIONS(2736),
    [anon_sym_protected] = ACTIONS(2736),
    [anon_sym_module] = ACTIONS(2736),
    [anon_sym_any] = ACTIONS(2736),
    [anon_sym_number] = ACTIONS(2736),
    [anon_sym_boolean] = ACTIONS(2736),
    [anon_sym_string] = ACTIONS(2736),
    [anon_sym_symbol] = ACTIONS(2736),
  },
  [594] = {
    [sym__call_signature] = STATE(2835),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(2734),
    [anon_sym_export] = ACTIONS(2736),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2736),
    [anon_sym_type] = ACTIONS(2736),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(758),
    [anon_sym_of] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_async] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2736),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2736),
    [anon_sym_get] = ACTIONS(2736),
    [anon_sym_set] = ACTIONS(2736),
    [anon_sym_declare] = ACTIONS(2736),
    [anon_sym_public] = ACTIONS(2736),
    [anon_sym_private] = ACTIONS(2736),
    [anon_sym_protected] = ACTIONS(2736),
    [anon_sym_module] = ACTIONS(2736),
    [anon_sym_any] = ACTIONS(2736),
    [anon_sym_number] = ACTIONS(2736),
    [anon_sym_boolean] = ACTIONS(2736),
    [anon_sym_string] = ACTIONS(2736),
    [anon_sym_symbol] = ACTIONS(2736),
  },
  [595] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_export] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_type] = ACTIONS(2946),
    [anon_sym_typeof] = ACTIONS(2946),
    [anon_sym_import] = ACTIONS(2946),
    [anon_sym_var] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_LPAREN] = ACTIONS(2948),
    [anon_sym_await] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_with] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_debugger] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_SLASH] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_async] = ACTIONS(2946),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_void] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2948),
    [sym_number] = ACTIONS(2948),
    [sym_this] = ACTIONS(2946),
    [sym_super] = ACTIONS(2946),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [sym_null] = ACTIONS(2946),
    [sym_undefined] = ACTIONS(2946),
    [anon_sym_AT] = ACTIONS(2948),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_abstract] = ACTIONS(2946),
    [anon_sym_get] = ACTIONS(2946),
    [anon_sym_set] = ACTIONS(2946),
    [anon_sym_declare] = ACTIONS(2946),
    [anon_sym_public] = ACTIONS(2946),
    [anon_sym_private] = ACTIONS(2946),
    [anon_sym_protected] = ACTIONS(2946),
    [anon_sym_module] = ACTIONS(2946),
    [anon_sym_any] = ACTIONS(2946),
    [anon_sym_number] = ACTIONS(2946),
    [anon_sym_boolean] = ACTIONS(2946),
    [anon_sym_string] = ACTIONS(2946),
    [anon_sym_symbol] = ACTIONS(2946),
    [anon_sym_interface] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
  },
  [596] = {
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_export] = ACTIONS(2950),
    [anon_sym_namespace] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_type] = ACTIONS(2950),
    [anon_sym_typeof] = ACTIONS(2950),
    [anon_sym_import] = ACTIONS(2950),
    [anon_sym_var] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_switch] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_LPAREN] = ACTIONS(2952),
    [anon_sym_await] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_with] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_debugger] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_throw] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_async] = ACTIONS(2950),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_BANG] = ACTIONS(2952),
    [anon_sym_TILDE] = ACTIONS(2952),
    [anon_sym_void] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [anon_sym_SQUOTE] = ACTIONS(2952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2952),
    [sym_number] = ACTIONS(2952),
    [sym_this] = ACTIONS(2950),
    [sym_super] = ACTIONS(2950),
    [sym_true] = ACTIONS(2950),
    [sym_false] = ACTIONS(2950),
    [sym_null] = ACTIONS(2950),
    [sym_undefined] = ACTIONS(2950),
    [anon_sym_AT] = ACTIONS(2952),
    [anon_sym_static] = ACTIONS(2950),
    [anon_sym_abstract] = ACTIONS(2950),
    [anon_sym_get] = ACTIONS(2950),
    [anon_sym_set] = ACTIONS(2950),
    [anon_sym_declare] = ACTIONS(2950),
    [anon_sym_public] = ACTIONS(2950),
    [anon_sym_private] = ACTIONS(2950),
    [anon_sym_protected] = ACTIONS(2950),
    [anon_sym_module] = ACTIONS(2950),
    [anon_sym_any] = ACTIONS(2950),
    [anon_sym_number] = ACTIONS(2950),
    [anon_sym_boolean] = ACTIONS(2950),
    [anon_sym_string] = ACTIONS(2950),
    [anon_sym_symbol] = ACTIONS(2950),
    [anon_sym_interface] = ACTIONS(2950),
    [anon_sym_enum] = ACTIONS(2950),
  },
  [597] = {
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_export] = ACTIONS(2954),
    [anon_sym_namespace] = ACTIONS(2954),
    [anon_sym_LBRACE] = ACTIONS(2956),
    [anon_sym_type] = ACTIONS(2954),
    [anon_sym_typeof] = ACTIONS(2954),
    [anon_sym_import] = ACTIONS(2954),
    [anon_sym_var] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_const] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_switch] = ACTIONS(2954),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_LPAREN] = ACTIONS(2956),
    [anon_sym_await] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_with] = ACTIONS(2954),
    [anon_sym_break] = ACTIONS(2954),
    [anon_sym_continue] = ACTIONS(2954),
    [anon_sym_debugger] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_throw] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_class] = ACTIONS(2954),
    [anon_sym_async] = ACTIONS(2954),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_BANG] = ACTIONS(2956),
    [anon_sym_TILDE] = ACTIONS(2956),
    [anon_sym_void] = ACTIONS(2954),
    [anon_sym_delete] = ACTIONS(2954),
    [anon_sym_PLUS_PLUS] = ACTIONS(2956),
    [anon_sym_DASH_DASH] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(2956),
    [anon_sym_SQUOTE] = ACTIONS(2956),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2956),
    [sym_number] = ACTIONS(2956),
    [sym_this] = ACTIONS(2954),
    [sym_super] = ACTIONS(2954),
    [sym_true] = ACTIONS(2954),
    [sym_false] = ACTIONS(2954),
    [sym_null] = ACTIONS(2954),
    [sym_undefined] = ACTIONS(2954),
    [anon_sym_AT] = ACTIONS(2956),
    [anon_sym_static] = ACTIONS(2954),
    [anon_sym_abstract] = ACTIONS(2954),
    [anon_sym_get] = ACTIONS(2954),
    [anon_sym_set] = ACTIONS(2954),
    [anon_sym_declare] = ACTIONS(2954),
    [anon_sym_public] = ACTIONS(2954),
    [anon_sym_private] = ACTIONS(2954),
    [anon_sym_protected] = ACTIONS(2954),
    [anon_sym_module] = ACTIONS(2954),
    [anon_sym_any] = ACTIONS(2954),
    [anon_sym_number] = ACTIONS(2954),
    [anon_sym_boolean] = ACTIONS(2954),
    [anon_sym_string] = ACTIONS(2954),
    [anon_sym_symbol] = ACTIONS(2954),
    [anon_sym_interface] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2954),
  },
  [598] = {
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_export] = ACTIONS(2958),
    [anon_sym_namespace] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_type] = ACTIONS(2958),
    [anon_sym_typeof] = ACTIONS(2958),
    [anon_sym_import] = ACTIONS(2958),
    [anon_sym_var] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_const] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_switch] = ACTIONS(2958),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_LPAREN] = ACTIONS(2960),
    [anon_sym_await] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_with] = ACTIONS(2958),
    [anon_sym_break] = ACTIONS(2958),
    [anon_sym_continue] = ACTIONS(2958),
    [anon_sym_debugger] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_throw] = ACTIONS(2958),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_SLASH] = ACTIONS(2958),
    [anon_sym_class] = ACTIONS(2958),
    [anon_sym_async] = ACTIONS(2958),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_BANG] = ACTIONS(2960),
    [anon_sym_TILDE] = ACTIONS(2960),
    [anon_sym_void] = ACTIONS(2958),
    [anon_sym_delete] = ACTIONS(2958),
    [anon_sym_PLUS_PLUS] = ACTIONS(2960),
    [anon_sym_DASH_DASH] = ACTIONS(2960),
    [anon_sym_DQUOTE] = ACTIONS(2960),
    [anon_sym_SQUOTE] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2960),
    [sym_number] = ACTIONS(2960),
    [sym_this] = ACTIONS(2958),
    [sym_super] = ACTIONS(2958),
    [sym_true] = ACTIONS(2958),
    [sym_false] = ACTIONS(2958),
    [sym_null] = ACTIONS(2958),
    [sym_undefined] = ACTIONS(2958),
    [anon_sym_AT] = ACTIONS(2960),
    [anon_sym_static] = ACTIONS(2958),
    [anon_sym_abstract] = ACTIONS(2958),
    [anon_sym_get] = ACTIONS(2958),
    [anon_sym_set] = ACTIONS(2958),
    [anon_sym_declare] = ACTIONS(2958),
    [anon_sym_public] = ACTIONS(2958),
    [anon_sym_private] = ACTIONS(2958),
    [anon_sym_protected] = ACTIONS(2958),
    [anon_sym_module] = ACTIONS(2958),
    [anon_sym_any] = ACTIONS(2958),
    [anon_sym_number] = ACTIONS(2958),
    [anon_sym_boolean] = ACTIONS(2958),
    [anon_sym_string] = ACTIONS(2958),
    [anon_sym_symbol] = ACTIONS(2958),
    [anon_sym_interface] = ACTIONS(2958),
    [anon_sym_enum] = ACTIONS(2958),
  },
  [599] = {
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_export] = ACTIONS(2962),
    [anon_sym_namespace] = ACTIONS(2962),
    [anon_sym_LBRACE] = ACTIONS(2964),
    [anon_sym_type] = ACTIONS(2962),
    [anon_sym_typeof] = ACTIONS(2962),
    [anon_sym_import] = ACTIONS(2962),
    [anon_sym_var] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_const] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_switch] = ACTIONS(2962),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_LPAREN] = ACTIONS(2964),
    [anon_sym_await] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_with] = ACTIONS(2962),
    [anon_sym_break] = ACTIONS(2962),
    [anon_sym_continue] = ACTIONS(2962),
    [anon_sym_debugger] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_throw] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2962),
    [anon_sym_class] = ACTIONS(2962),
    [anon_sym_async] = ACTIONS(2962),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_BANG] = ACTIONS(2964),
    [anon_sym_TILDE] = ACTIONS(2964),
    [anon_sym_void] = ACTIONS(2962),
    [anon_sym_delete] = ACTIONS(2962),
    [anon_sym_PLUS_PLUS] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2964),
    [anon_sym_DQUOTE] = ACTIONS(2964),
    [anon_sym_SQUOTE] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2964),
    [sym_number] = ACTIONS(2964),
    [sym_this] = ACTIONS(2962),
    [sym_super] = ACTIONS(2962),
    [sym_true] = ACTIONS(2962),
    [sym_false] = ACTIONS(2962),
    [sym_null] = ACTIONS(2962),
    [sym_undefined] = ACTIONS(2962),
    [anon_sym_AT] = ACTIONS(2964),
    [anon_sym_static] = ACTIONS(2962),
    [anon_sym_abstract] = ACTIONS(2962),
    [anon_sym_get] = ACTIONS(2962),
    [anon_sym_set] = ACTIONS(2962),
    [anon_sym_declare] = ACTIONS(2962),
    [anon_sym_public] = ACTIONS(2962),
    [anon_sym_private] = ACTIONS(2962),
    [anon_sym_protected] = ACTIONS(2962),
    [anon_sym_module] = ACTIONS(2962),
    [anon_sym_any] = ACTIONS(2962),
    [anon_sym_number] = ACTIONS(2962),
    [anon_sym_boolean] = ACTIONS(2962),
    [anon_sym_string] = ACTIONS(2962),
    [anon_sym_symbol] = ACTIONS(2962),
    [anon_sym_interface] = ACTIONS(2962),
    [anon_sym_enum] = ACTIONS(2962),
  },
  [600] = {
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2966),
    [anon_sym_namespace] = ACTIONS(2966),
    [anon_sym_LBRACE] = ACTIONS(2968),
    [anon_sym_type] = ACTIONS(2966),
    [anon_sym_typeof] = ACTIONS(2966),
    [anon_sym_import] = ACTIONS(2966),
    [anon_sym_var] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_const] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_switch] = ACTIONS(2966),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_LPAREN] = ACTIONS(2968),
    [anon_sym_await] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_with] = ACTIONS(2966),
    [anon_sym_break] = ACTIONS(2966),
    [anon_sym_continue] = ACTIONS(2966),
    [anon_sym_debugger] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_throw] = ACTIONS(2966),
    [anon_sym_SEMI] = ACTIONS(2968),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2968),
    [anon_sym_SLASH] = ACTIONS(2966),
    [anon_sym_class] = ACTIONS(2966),
    [anon_sym_async] = ACTIONS(2966),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_BANG] = ACTIONS(2968),
    [anon_sym_TILDE] = ACTIONS(2968),
    [anon_sym_void] = ACTIONS(2966),
    [anon_sym_delete] = ACTIONS(2966),
    [anon_sym_PLUS_PLUS] = ACTIONS(2968),
    [anon_sym_DASH_DASH] = ACTIONS(2968),
    [anon_sym_DQUOTE] = ACTIONS(2968),
    [anon_sym_SQUOTE] = ACTIONS(2968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2968),
    [sym_number] = ACTIONS(2968),
    [sym_this] = ACTIONS(2966),
    [sym_super] = ACTIONS(2966),
    [sym_true] = ACTIONS(2966),
    [sym_false] = ACTIONS(2966),
    [sym_null] = ACTIONS(2966),
    [sym_undefined] = ACTIONS(2966),
    [anon_sym_AT] = ACTIONS(2968),
    [anon_sym_static] = ACTIONS(2966),
    [anon_sym_abstract] = ACTIONS(2966),
    [anon_sym_get] = ACTIONS(2966),
    [anon_sym_set] = ACTIONS(2966),
    [anon_sym_declare] = ACTIONS(2966),
    [anon_sym_public] = ACTIONS(2966),
    [anon_sym_private] = ACTIONS(2966),
    [anon_sym_protected] = ACTIONS(2966),
    [anon_sym_module] = ACTIONS(2966),
    [anon_sym_any] = ACTIONS(2966),
    [anon_sym_number] = ACTIONS(2966),
    [anon_sym_boolean] = ACTIONS(2966),
    [anon_sym_string] = ACTIONS(2966),
    [anon_sym_symbol] = ACTIONS(2966),
    [anon_sym_interface] = ACTIONS(2966),
    [anon_sym_enum] = ACTIONS(2966),
  },
  [601] = {
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_export] = ACTIONS(2970),
    [anon_sym_namespace] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2970),
    [anon_sym_typeof] = ACTIONS(2970),
    [anon_sym_import] = ACTIONS(2970),
    [anon_sym_var] = ACTIONS(2970),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_LPAREN] = ACTIONS(2972),
    [anon_sym_await] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_with] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_debugger] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_SLASH] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_async] = ACTIONS(2970),
    [anon_sym_function] = ACTIONS(2970),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_void] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2972),
    [sym_number] = ACTIONS(2972),
    [sym_this] = ACTIONS(2970),
    [sym_super] = ACTIONS(2970),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [sym_null] = ACTIONS(2970),
    [sym_undefined] = ACTIONS(2970),
    [anon_sym_AT] = ACTIONS(2972),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_abstract] = ACTIONS(2970),
    [anon_sym_get] = ACTIONS(2970),
    [anon_sym_set] = ACTIONS(2970),
    [anon_sym_declare] = ACTIONS(2970),
    [anon_sym_public] = ACTIONS(2970),
    [anon_sym_private] = ACTIONS(2970),
    [anon_sym_protected] = ACTIONS(2970),
    [anon_sym_module] = ACTIONS(2970),
    [anon_sym_any] = ACTIONS(2970),
    [anon_sym_number] = ACTIONS(2970),
    [anon_sym_boolean] = ACTIONS(2970),
    [anon_sym_string] = ACTIONS(2970),
    [anon_sym_symbol] = ACTIONS(2970),
    [anon_sym_interface] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
  },
  [602] = {
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_export] = ACTIONS(2974),
    [anon_sym_namespace] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2976),
    [anon_sym_type] = ACTIONS(2974),
    [anon_sym_typeof] = ACTIONS(2974),
    [anon_sym_import] = ACTIONS(2974),
    [anon_sym_var] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_const] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_switch] = ACTIONS(2974),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(2976),
    [anon_sym_await] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_with] = ACTIONS(2974),
    [anon_sym_break] = ACTIONS(2974),
    [anon_sym_continue] = ACTIONS(2974),
    [anon_sym_debugger] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_throw] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_SLASH] = ACTIONS(2974),
    [anon_sym_class] = ACTIONS(2974),
    [anon_sym_async] = ACTIONS(2974),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2976),
    [anon_sym_TILDE] = ACTIONS(2976),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_delete] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(2976),
    [anon_sym_DASH_DASH] = ACTIONS(2976),
    [anon_sym_DQUOTE] = ACTIONS(2976),
    [anon_sym_SQUOTE] = ACTIONS(2976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2976),
    [sym_number] = ACTIONS(2976),
    [sym_this] = ACTIONS(2974),
    [sym_super] = ACTIONS(2974),
    [sym_true] = ACTIONS(2974),
    [sym_false] = ACTIONS(2974),
    [sym_null] = ACTIONS(2974),
    [sym_undefined] = ACTIONS(2974),
    [anon_sym_AT] = ACTIONS(2976),
    [anon_sym_static] = ACTIONS(2974),
    [anon_sym_abstract] = ACTIONS(2974),
    [anon_sym_get] = ACTIONS(2974),
    [anon_sym_set] = ACTIONS(2974),
    [anon_sym_declare] = ACTIONS(2974),
    [anon_sym_public] = ACTIONS(2974),
    [anon_sym_private] = ACTIONS(2974),
    [anon_sym_protected] = ACTIONS(2974),
    [anon_sym_module] = ACTIONS(2974),
    [anon_sym_any] = ACTIONS(2974),
    [anon_sym_number] = ACTIONS(2974),
    [anon_sym_boolean] = ACTIONS(2974),
    [anon_sym_string] = ACTIONS(2974),
    [anon_sym_symbol] = ACTIONS(2974),
    [anon_sym_interface] = ACTIONS(2974),
    [anon_sym_enum] = ACTIONS(2974),
  },
  [603] = {
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_export] = ACTIONS(2978),
    [anon_sym_namespace] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_type] = ACTIONS(2978),
    [anon_sym_typeof] = ACTIONS(2978),
    [anon_sym_import] = ACTIONS(2978),
    [anon_sym_var] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_const] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_switch] = ACTIONS(2978),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_LPAREN] = ACTIONS(2980),
    [anon_sym_await] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_with] = ACTIONS(2978),
    [anon_sym_break] = ACTIONS(2978),
    [anon_sym_continue] = ACTIONS(2978),
    [anon_sym_debugger] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_throw] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_SLASH] = ACTIONS(2978),
    [anon_sym_class] = ACTIONS(2978),
    [anon_sym_async] = ACTIONS(2978),
    [anon_sym_function] = ACTIONS(2978),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_BANG] = ACTIONS(2980),
    [anon_sym_TILDE] = ACTIONS(2980),
    [anon_sym_void] = ACTIONS(2978),
    [anon_sym_delete] = ACTIONS(2978),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [anon_sym_SQUOTE] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2980),
    [sym_number] = ACTIONS(2980),
    [sym_this] = ACTIONS(2978),
    [sym_super] = ACTIONS(2978),
    [sym_true] = ACTIONS(2978),
    [sym_false] = ACTIONS(2978),
    [sym_null] = ACTIONS(2978),
    [sym_undefined] = ACTIONS(2978),
    [anon_sym_AT] = ACTIONS(2980),
    [anon_sym_static] = ACTIONS(2978),
    [anon_sym_abstract] = ACTIONS(2978),
    [anon_sym_get] = ACTIONS(2978),
    [anon_sym_set] = ACTIONS(2978),
    [anon_sym_declare] = ACTIONS(2978),
    [anon_sym_public] = ACTIONS(2978),
    [anon_sym_private] = ACTIONS(2978),
    [anon_sym_protected] = ACTIONS(2978),
    [anon_sym_module] = ACTIONS(2978),
    [anon_sym_any] = ACTIONS(2978),
    [anon_sym_number] = ACTIONS(2978),
    [anon_sym_boolean] = ACTIONS(2978),
    [anon_sym_string] = ACTIONS(2978),
    [anon_sym_symbol] = ACTIONS(2978),
    [anon_sym_interface] = ACTIONS(2978),
    [anon_sym_enum] = ACTIONS(2978),
  },
  [604] = {
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_export] = ACTIONS(2982),
    [anon_sym_namespace] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_type] = ACTIONS(2982),
    [anon_sym_typeof] = ACTIONS(2982),
    [anon_sym_import] = ACTIONS(2982),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_const] = ACTIONS(2982),
    [anon_sym_if] = ACTIONS(2982),
    [anon_sym_switch] = ACTIONS(2982),
    [anon_sym_for] = ACTIONS(2982),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_await] = ACTIONS(2982),
    [anon_sym_while] = ACTIONS(2982),
    [anon_sym_do] = ACTIONS(2982),
    [anon_sym_try] = ACTIONS(2982),
    [anon_sym_with] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2982),
    [anon_sym_continue] = ACTIONS(2982),
    [anon_sym_debugger] = ACTIONS(2982),
    [anon_sym_return] = ACTIONS(2982),
    [anon_sym_throw] = ACTIONS(2982),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_LT] = ACTIONS(2984),
    [anon_sym_SLASH] = ACTIONS(2982),
    [anon_sym_class] = ACTIONS(2982),
    [anon_sym_async] = ACTIONS(2982),
    [anon_sym_function] = ACTIONS(2982),
    [anon_sym_new] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_BANG] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2984),
    [anon_sym_void] = ACTIONS(2982),
    [anon_sym_delete] = ACTIONS(2982),
    [anon_sym_PLUS_PLUS] = ACTIONS(2984),
    [anon_sym_DASH_DASH] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_SQUOTE] = ACTIONS(2984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2984),
    [sym_number] = ACTIONS(2984),
    [sym_this] = ACTIONS(2982),
    [sym_super] = ACTIONS(2982),
    [sym_true] = ACTIONS(2982),
    [sym_false] = ACTIONS(2982),
    [sym_null] = ACTIONS(2982),
    [sym_undefined] = ACTIONS(2982),
    [anon_sym_AT] = ACTIONS(2984),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_abstract] = ACTIONS(2982),
    [anon_sym_get] = ACTIONS(2982),
    [anon_sym_set] = ACTIONS(2982),
    [anon_sym_declare] = ACTIONS(2982),
    [anon_sym_public] = ACTIONS(2982),
    [anon_sym_private] = ACTIONS(2982),
    [anon_sym_protected] = ACTIONS(2982),
    [anon_sym_module] = ACTIONS(2982),
    [anon_sym_any] = ACTIONS(2982),
    [anon_sym_number] = ACTIONS(2982),
    [anon_sym_boolean] = ACTIONS(2982),
    [anon_sym_string] = ACTIONS(2982),
    [anon_sym_symbol] = ACTIONS(2982),
    [anon_sym_interface] = ACTIONS(2982),
    [anon_sym_enum] = ACTIONS(2982),
  },
  [605] = {
    [sym_nested_identifier] = STATE(109),
    [sym_string] = STATE(106),
    [sym__module] = STATE(107),
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(2986),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_SQUOTE] = ACTIONS(2990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [606] = {
    [sym_nested_identifier] = STATE(464),
    [sym_string] = STATE(485),
    [sym__module] = STATE(579),
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [607] = {
    [sym_nested_identifier] = STATE(464),
    [sym_string] = STATE(485),
    [sym__module] = STATE(579),
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [608] = {
    [sym_nested_identifier] = STATE(109),
    [sym_string] = STATE(106),
    [sym__module] = STATE(107),
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(2986),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_SQUOTE] = ACTIONS(2990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [609] = {
    [sym_nested_identifier] = STATE(951),
    [sym_string] = STATE(950),
    [sym_arguments] = STATE(1032),
    [sym__module] = STATE(1046),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_COLON] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
  },
  [610] = {
    [sym_nested_identifier] = STATE(109),
    [sym_string] = STATE(106),
    [sym__module] = STATE(107),
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(2986),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_SQUOTE] = ACTIONS(2990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [611] = {
    [sym_nested_identifier] = STATE(464),
    [sym_string] = STATE(485),
    [sym__module] = STATE(579),
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [612] = {
    [sym_nested_identifier] = STATE(951),
    [sym_string] = STATE(950),
    [sym_arguments] = STATE(1428),
    [sym__module] = STATE(1046),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym__automatic_semicolon] = ACTIONS(501),
  },
  [613] = {
    [sym_nested_identifier] = STATE(951),
    [sym_string] = STATE(950),
    [sym__module] = STATE(1046),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [614] = {
    [sym_export_statement] = STATE(2017),
    [sym_object] = STATE(2824),
    [sym_assignment_pattern] = STATE(2396),
    [sym_array] = STATE(2825),
    [sym__call_signature] = STATE(2116),
    [sym_spread_element] = STATE(2396),
    [sym_string] = STATE(1795),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym_method_definition] = STATE(2396),
    [sym_pair] = STATE(2396),
    [sym__property_name] = STATE(1795),
    [sym_computed_property_name] = STATE(1795),
    [sym_method_signature] = STATE(2017),
    [sym_accessibility_modifier] = STATE(1737),
    [sym_call_signature] = STATE(2017),
    [sym_property_signature] = STATE(2017),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2017),
    [sym_index_signature] = STATE(2017),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [aux_sym_object_repeat1] = STATE(2398),
    [sym_identifier] = ACTIONS(3000),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_namespace] = ACTIONS(3000),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(3008),
    [anon_sym_type] = ACTIONS(3000),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3000),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3024),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_get] = ACTIONS(3028),
    [anon_sym_set] = ACTIONS(3028),
    [anon_sym_declare] = ACTIONS(3000),
    [anon_sym_public] = ACTIONS(3030),
    [anon_sym_private] = ACTIONS(3030),
    [anon_sym_protected] = ACTIONS(3030),
    [anon_sym_module] = ACTIONS(3000),
    [anon_sym_any] = ACTIONS(3000),
    [anon_sym_number] = ACTIONS(3000),
    [anon_sym_boolean] = ACTIONS(3000),
    [anon_sym_string] = ACTIONS(3000),
    [anon_sym_symbol] = ACTIONS(3000),
    [sym_readonly] = ACTIONS(3032),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3034),
  },
  [615] = {
    [sym_export_statement] = STATE(2017),
    [sym_object] = STATE(2824),
    [sym_assignment_pattern] = STATE(2462),
    [sym_array] = STATE(2825),
    [sym__call_signature] = STATE(2116),
    [sym_spread_element] = STATE(2462),
    [sym_string] = STATE(1795),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym_method_definition] = STATE(2462),
    [sym_pair] = STATE(2462),
    [sym__property_name] = STATE(1795),
    [sym_computed_property_name] = STATE(1795),
    [sym_method_signature] = STATE(2017),
    [sym_accessibility_modifier] = STATE(1737),
    [sym_call_signature] = STATE(2017),
    [sym_property_signature] = STATE(2017),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2017),
    [sym_index_signature] = STATE(2017),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [aux_sym_object_repeat1] = STATE(2453),
    [sym_identifier] = ACTIONS(3036),
    [anon_sym_export] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_namespace] = ACTIONS(3036),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_type] = ACTIONS(3036),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3024),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3044),
    [anon_sym_get] = ACTIONS(3046),
    [anon_sym_set] = ACTIONS(3046),
    [anon_sym_declare] = ACTIONS(3036),
    [anon_sym_public] = ACTIONS(3048),
    [anon_sym_private] = ACTIONS(3048),
    [anon_sym_protected] = ACTIONS(3048),
    [anon_sym_module] = ACTIONS(3036),
    [anon_sym_any] = ACTIONS(3036),
    [anon_sym_number] = ACTIONS(3036),
    [anon_sym_boolean] = ACTIONS(3036),
    [anon_sym_string] = ACTIONS(3036),
    [anon_sym_symbol] = ACTIONS(3036),
    [sym_readonly] = ACTIONS(3032),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3034),
  },
  [616] = {
    [sym_nested_identifier] = STATE(951),
    [sym_string] = STATE(950),
    [sym_arguments] = STATE(1032),
    [sym__module] = STATE(1046),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(648),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_implements] = ACTIONS(493),
  },
  [617] = {
    [sym_export_statement] = STATE(2017),
    [sym_object] = STATE(2824),
    [sym_assignment_pattern] = STATE(2396),
    [sym_array] = STATE(2825),
    [sym__call_signature] = STATE(2116),
    [sym_spread_element] = STATE(2396),
    [sym_string] = STATE(1795),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym_method_definition] = STATE(2396),
    [sym_pair] = STATE(2396),
    [sym__property_name] = STATE(1795),
    [sym_computed_property_name] = STATE(1795),
    [sym_method_signature] = STATE(2017),
    [sym_accessibility_modifier] = STATE(1737),
    [sym_call_signature] = STATE(2017),
    [sym_property_signature] = STATE(2017),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2017),
    [sym_index_signature] = STATE(2017),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [aux_sym_object_repeat1] = STATE(2398),
    [sym_identifier] = ACTIONS(3000),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_namespace] = ACTIONS(3000),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(3050),
    [anon_sym_type] = ACTIONS(3000),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3000),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3024),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_get] = ACTIONS(3028),
    [anon_sym_set] = ACTIONS(3028),
    [anon_sym_declare] = ACTIONS(3000),
    [anon_sym_public] = ACTIONS(3030),
    [anon_sym_private] = ACTIONS(3030),
    [anon_sym_protected] = ACTIONS(3030),
    [anon_sym_module] = ACTIONS(3000),
    [anon_sym_any] = ACTIONS(3000),
    [anon_sym_number] = ACTIONS(3000),
    [anon_sym_boolean] = ACTIONS(3000),
    [anon_sym_string] = ACTIONS(3000),
    [anon_sym_symbol] = ACTIONS(3000),
    [sym_readonly] = ACTIONS(3032),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3034),
  },
  [618] = {
    [sym_nested_identifier] = STATE(994),
    [sym_string] = STATE(993),
    [sym__module] = STATE(1165),
    [sym_identifier] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [619] = {
    [sym_export_statement] = STATE(1996),
    [sym_object] = STATE(2824),
    [sym_assignment_pattern] = STATE(2396),
    [sym_array] = STATE(2825),
    [sym__call_signature] = STATE(2116),
    [sym_spread_element] = STATE(2396),
    [sym_string] = STATE(1795),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym_method_definition] = STATE(2396),
    [sym_pair] = STATE(2396),
    [sym__property_name] = STATE(1795),
    [sym_computed_property_name] = STATE(1795),
    [sym_method_signature] = STATE(1996),
    [sym_accessibility_modifier] = STATE(1737),
    [sym_call_signature] = STATE(1996),
    [sym_property_signature] = STATE(1996),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(1996),
    [sym_index_signature] = STATE(1996),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [aux_sym_object_repeat1] = STATE(2398),
    [sym_identifier] = ACTIONS(3000),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_namespace] = ACTIONS(3000),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(3054),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_type] = ACTIONS(3000),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3000),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3024),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_get] = ACTIONS(3028),
    [anon_sym_set] = ACTIONS(3028),
    [anon_sym_declare] = ACTIONS(3000),
    [anon_sym_public] = ACTIONS(3030),
    [anon_sym_private] = ACTIONS(3030),
    [anon_sym_protected] = ACTIONS(3030),
    [anon_sym_module] = ACTIONS(3000),
    [anon_sym_any] = ACTIONS(3000),
    [anon_sym_number] = ACTIONS(3000),
    [anon_sym_boolean] = ACTIONS(3000),
    [anon_sym_string] = ACTIONS(3000),
    [anon_sym_symbol] = ACTIONS(3000),
    [sym_readonly] = ACTIONS(3032),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3060),
  },
  [620] = {
    [sym_nested_identifier] = STATE(464),
    [sym_string] = STATE(485),
    [sym__module] = STATE(579),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [621] = {
    [sym_export_statement] = STATE(2017),
    [sym_object] = STATE(2824),
    [sym_assignment_pattern] = STATE(2396),
    [sym_array] = STATE(2825),
    [sym__call_signature] = STATE(2116),
    [sym_spread_element] = STATE(2396),
    [sym_string] = STATE(1795),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym_method_definition] = STATE(2396),
    [sym_pair] = STATE(2396),
    [sym__property_name] = STATE(1795),
    [sym_computed_property_name] = STATE(1795),
    [sym_method_signature] = STATE(2017),
    [sym_accessibility_modifier] = STATE(1737),
    [sym_call_signature] = STATE(2017),
    [sym_property_signature] = STATE(2017),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2017),
    [sym_index_signature] = STATE(2017),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [aux_sym_object_repeat1] = STATE(2398),
    [sym_identifier] = ACTIONS(3000),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_namespace] = ACTIONS(3000),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(3062),
    [anon_sym_type] = ACTIONS(3000),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3000),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3024),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_get] = ACTIONS(3028),
    [anon_sym_set] = ACTIONS(3028),
    [anon_sym_declare] = ACTIONS(3000),
    [anon_sym_public] = ACTIONS(3030),
    [anon_sym_private] = ACTIONS(3030),
    [anon_sym_protected] = ACTIONS(3030),
    [anon_sym_module] = ACTIONS(3000),
    [anon_sym_any] = ACTIONS(3000),
    [anon_sym_number] = ACTIONS(3000),
    [anon_sym_boolean] = ACTIONS(3000),
    [anon_sym_string] = ACTIONS(3000),
    [anon_sym_symbol] = ACTIONS(3000),
    [sym_readonly] = ACTIONS(3032),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3034),
  },
  [622] = {
    [sym_nested_identifier] = STATE(109),
    [sym_string] = STATE(106),
    [sym__module] = STATE(107),
    [sym_identifier] = ACTIONS(2986),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_SQUOTE] = ACTIONS(2990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [623] = {
    [sym_export_statement] = STATE(2017),
    [sym_object] = STATE(2824),
    [sym_assignment_pattern] = STATE(2374),
    [sym_array] = STATE(2825),
    [sym__call_signature] = STATE(2116),
    [sym_spread_element] = STATE(2374),
    [sym_string] = STATE(1795),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym_method_definition] = STATE(2374),
    [sym_pair] = STATE(2374),
    [sym__property_name] = STATE(1795),
    [sym_computed_property_name] = STATE(1795),
    [sym_method_signature] = STATE(2017),
    [sym_accessibility_modifier] = STATE(1737),
    [sym_call_signature] = STATE(2017),
    [sym_property_signature] = STATE(2017),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2017),
    [sym_index_signature] = STATE(2017),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [aux_sym_object_repeat1] = STATE(2516),
    [sym_identifier] = ACTIONS(3064),
    [anon_sym_export] = ACTIONS(3066),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_namespace] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(3068),
    [anon_sym_type] = ACTIONS(3064),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3070),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3064),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3024),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_get] = ACTIONS(3074),
    [anon_sym_set] = ACTIONS(3074),
    [anon_sym_declare] = ACTIONS(3064),
    [anon_sym_public] = ACTIONS(3076),
    [anon_sym_private] = ACTIONS(3076),
    [anon_sym_protected] = ACTIONS(3076),
    [anon_sym_module] = ACTIONS(3064),
    [anon_sym_any] = ACTIONS(3064),
    [anon_sym_number] = ACTIONS(3064),
    [anon_sym_boolean] = ACTIONS(3064),
    [anon_sym_string] = ACTIONS(3064),
    [anon_sym_symbol] = ACTIONS(3064),
    [sym_readonly] = ACTIONS(3032),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3034),
  },
  [624] = {
    [sym_nested_identifier] = STATE(994),
    [sym_string] = STATE(993),
    [sym__module] = STATE(1165),
    [sym_identifier] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [625] = {
    [sym_export_statement] = STATE(2017),
    [sym_object] = STATE(2824),
    [sym_assignment_pattern] = STATE(2396),
    [sym_array] = STATE(2825),
    [sym__call_signature] = STATE(2116),
    [sym_spread_element] = STATE(2396),
    [sym_string] = STATE(1795),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym_method_definition] = STATE(2396),
    [sym_pair] = STATE(2396),
    [sym__property_name] = STATE(1795),
    [sym_computed_property_name] = STATE(1795),
    [sym_method_signature] = STATE(2017),
    [sym_accessibility_modifier] = STATE(1737),
    [sym_call_signature] = STATE(2017),
    [sym_property_signature] = STATE(2017),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2017),
    [sym_index_signature] = STATE(2017),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [aux_sym_object_repeat1] = STATE(2398),
    [sym_identifier] = ACTIONS(3000),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_namespace] = ACTIONS(3000),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(3078),
    [anon_sym_type] = ACTIONS(3000),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3000),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3024),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_get] = ACTIONS(3028),
    [anon_sym_set] = ACTIONS(3028),
    [anon_sym_declare] = ACTIONS(3000),
    [anon_sym_public] = ACTIONS(3030),
    [anon_sym_private] = ACTIONS(3030),
    [anon_sym_protected] = ACTIONS(3030),
    [anon_sym_module] = ACTIONS(3000),
    [anon_sym_any] = ACTIONS(3000),
    [anon_sym_number] = ACTIONS(3000),
    [anon_sym_boolean] = ACTIONS(3000),
    [anon_sym_string] = ACTIONS(3000),
    [anon_sym_symbol] = ACTIONS(3000),
    [sym_readonly] = ACTIONS(3032),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3034),
  },
  [626] = {
    [sym_nested_identifier] = STATE(994),
    [sym_string] = STATE(993),
    [sym__module] = STATE(1165),
    [sym_identifier] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [627] = {
    [sym_nested_identifier] = STATE(464),
    [sym_string] = STATE(485),
    [sym__module] = STATE(579),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [628] = {
    [sym_nested_identifier] = STATE(951),
    [sym_string] = STATE(950),
    [sym_arguments] = STATE(1518),
    [sym__module] = STATE(1046),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_LBRACE] = ACTIONS(493),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(664),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_LBRACE_PIPE] = ACTIONS(501),
  },
  [629] = {
    [sym_nested_identifier] = STATE(951),
    [sym_string] = STATE(950),
    [sym__module] = STATE(1046),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [630] = {
    [sym_nested_identifier] = STATE(951),
    [sym_string] = STATE(950),
    [sym_arguments] = STATE(1032),
    [sym__module] = STATE(1046),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_COLON] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
  },
  [631] = {
    [sym_nested_identifier] = STATE(951),
    [sym_string] = STATE(950),
    [sym_arguments] = STATE(1428),
    [sym__module] = STATE(1046),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(626),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym__automatic_semicolon] = ACTIONS(501),
  },
  [632] = {
    [sym_nested_identifier] = STATE(951),
    [sym_string] = STATE(950),
    [sym__module] = STATE(1046),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(608),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [633] = {
    [sym_nested_identifier] = STATE(951),
    [sym_string] = STATE(950),
    [sym__module] = STATE(1046),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(648),
    [anon_sym_PLUS_EQ] = ACTIONS(742),
    [anon_sym_DASH_EQ] = ACTIONS(742),
    [anon_sym_STAR_EQ] = ACTIONS(742),
    [anon_sym_SLASH_EQ] = ACTIONS(742),
    [anon_sym_PERCENT_EQ] = ACTIONS(742),
    [anon_sym_CARET_EQ] = ACTIONS(742),
    [anon_sym_AMP_EQ] = ACTIONS(742),
    [anon_sym_PIPE_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_LT_EQ] = ACTIONS(742),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_implements] = ACTIONS(445),
  },
  [634] = {
    [sym_nested_identifier] = STATE(951),
    [sym_string] = STATE(950),
    [sym__module] = STATE(1046),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [635] = {
    [sym_nested_identifier] = STATE(1407),
    [sym_string] = STATE(1406),
    [sym__module] = STATE(1577),
    [sym_identifier] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(664),
    [anon_sym_PLUS_EQ] = ACTIONS(698),
    [anon_sym_DASH_EQ] = ACTIONS(698),
    [anon_sym_STAR_EQ] = ACTIONS(698),
    [anon_sym_SLASH_EQ] = ACTIONS(698),
    [anon_sym_PERCENT_EQ] = ACTIONS(698),
    [anon_sym_CARET_EQ] = ACTIONS(698),
    [anon_sym_AMP_EQ] = ACTIONS(698),
    [anon_sym_PIPE_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_LT_LT_EQ] = ACTIONS(698),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(698),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [636] = {
    [sym_nested_identifier] = STATE(951),
    [sym_string] = STATE(950),
    [sym__module] = STATE(1046),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [637] = {
    [sym_nested_identifier] = STATE(994),
    [sym_string] = STATE(993),
    [sym__module] = STATE(1165),
    [sym_identifier] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(614),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(626),
    [anon_sym_PLUS_EQ] = ACTIONS(630),
    [anon_sym_DASH_EQ] = ACTIONS(630),
    [anon_sym_STAR_EQ] = ACTIONS(630),
    [anon_sym_SLASH_EQ] = ACTIONS(630),
    [anon_sym_PERCENT_EQ] = ACTIONS(630),
    [anon_sym_CARET_EQ] = ACTIONS(630),
    [anon_sym_AMP_EQ] = ACTIONS(630),
    [anon_sym_PIPE_EQ] = ACTIONS(630),
    [anon_sym_GT_GT_EQ] = ACTIONS(630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(630),
    [anon_sym_LT_LT_EQ] = ACTIONS(630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(630),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [638] = {
    [sym_nested_identifier] = STATE(951),
    [sym_string] = STATE(950),
    [sym__module] = STATE(1046),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [639] = {
    [sym_export_statement] = STATE(2016),
    [sym_object] = STATE(2824),
    [sym_assignment_pattern] = STATE(2627),
    [sym_array] = STATE(2825),
    [sym__call_signature] = STATE(2116),
    [sym_spread_element] = STATE(2627),
    [sym_string] = STATE(1795),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym_method_definition] = STATE(2627),
    [sym_pair] = STATE(2627),
    [sym__property_name] = STATE(1795),
    [sym_computed_property_name] = STATE(1795),
    [sym_method_signature] = STATE(2016),
    [sym_accessibility_modifier] = STATE(1737),
    [sym_call_signature] = STATE(2016),
    [sym_property_signature] = STATE(2016),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2016),
    [sym_index_signature] = STATE(2016),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3084),
    [anon_sym_export] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_namespace] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(3088),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_type] = ACTIONS(3084),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3024),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_get] = ACTIONS(3094),
    [anon_sym_set] = ACTIONS(3094),
    [anon_sym_declare] = ACTIONS(3084),
    [anon_sym_public] = ACTIONS(3096),
    [anon_sym_private] = ACTIONS(3096),
    [anon_sym_protected] = ACTIONS(3096),
    [anon_sym_module] = ACTIONS(3084),
    [anon_sym_any] = ACTIONS(3084),
    [anon_sym_number] = ACTIONS(3084),
    [anon_sym_boolean] = ACTIONS(3084),
    [anon_sym_string] = ACTIONS(3084),
    [anon_sym_symbol] = ACTIONS(3084),
    [sym_readonly] = ACTIONS(3032),
  },
  [640] = {
    [sym__initializer] = STATE(2495),
    [sym_type_annotation] = STATE(2096),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3098),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(3102),
    [anon_sym_of] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(3100),
  },
  [641] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_RBRACE] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_RPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_of] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3117),
    [anon_sym_RBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3117),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [anon_sym_implements] = ACTIONS(3117),
  },
  [642] = {
    [sym_export_statement] = STATE(2053),
    [sym_object] = STATE(2824),
    [sym_assignment_pattern] = STATE(2627),
    [sym_array] = STATE(2825),
    [sym__call_signature] = STATE(2116),
    [sym_spread_element] = STATE(2627),
    [sym_string] = STATE(1795),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym_method_definition] = STATE(2627),
    [sym_pair] = STATE(2627),
    [sym__property_name] = STATE(1795),
    [sym_computed_property_name] = STATE(1795),
    [sym_method_signature] = STATE(2053),
    [sym_accessibility_modifier] = STATE(1737),
    [sym_call_signature] = STATE(2053),
    [sym_property_signature] = STATE(2053),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2053),
    [sym_index_signature] = STATE(2053),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3084),
    [anon_sym_export] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_namespace] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(3088),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_type] = ACTIONS(3084),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3024),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_get] = ACTIONS(3094),
    [anon_sym_set] = ACTIONS(3094),
    [anon_sym_declare] = ACTIONS(3084),
    [anon_sym_public] = ACTIONS(3096),
    [anon_sym_private] = ACTIONS(3096),
    [anon_sym_protected] = ACTIONS(3096),
    [anon_sym_module] = ACTIONS(3084),
    [anon_sym_any] = ACTIONS(3084),
    [anon_sym_number] = ACTIONS(3084),
    [anon_sym_boolean] = ACTIONS(3084),
    [anon_sym_string] = ACTIONS(3084),
    [anon_sym_symbol] = ACTIONS(3084),
    [sym_readonly] = ACTIONS(3032),
  },
  [643] = {
    [sym_nested_identifier] = STATE(951),
    [sym_string] = STATE(950),
    [sym__module] = STATE(1046),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(758),
    [anon_sym_of] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [644] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_template_string] = STATE(1045),
    [sym_formal_parameters] = STATE(2764),
    [sym_nested_type_identifier] = STATE(1491),
    [sym__type] = STATE(1048),
    [sym_constructor_type] = STATE(1048),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2602),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1048),
    [sym_intersection_type] = STATE(1048),
    [sym_function_type] = STATE(1048),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_PIPE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [645] = {
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(3153),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [646] = {
    [sym_type_arguments] = STATE(413),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3155),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3157),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(3157),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(3160),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3166),
    [anon_sym_EQ_GT] = ACTIONS(3168),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_is] = ACTIONS(3172),
  },
  [647] = {
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_EQ] = ACTIONS(3174),
    [anon_sym_as] = ACTIONS(3176),
    [anon_sym_LBRACE] = ACTIONS(3176),
    [anon_sym_COMMA] = ACTIONS(3176),
    [anon_sym_RBRACE] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(3176),
    [anon_sym_RPAREN] = ACTIONS(3176),
    [anon_sym_in] = ACTIONS(3174),
    [anon_sym_of] = ACTIONS(3176),
    [anon_sym_COLON] = ACTIONS(3176),
    [anon_sym_LBRACK] = ACTIONS(3176),
    [anon_sym_RBRACK] = ACTIONS(3176),
    [anon_sym_LT] = ACTIONS(3174),
    [anon_sym_GT] = ACTIONS(3174),
    [anon_sym_SLASH] = ACTIONS(3174),
    [anon_sym_DOT] = ACTIONS(3176),
    [anon_sym_PLUS_EQ] = ACTIONS(3176),
    [anon_sym_DASH_EQ] = ACTIONS(3176),
    [anon_sym_STAR_EQ] = ACTIONS(3176),
    [anon_sym_SLASH_EQ] = ACTIONS(3176),
    [anon_sym_PERCENT_EQ] = ACTIONS(3176),
    [anon_sym_CARET_EQ] = ACTIONS(3176),
    [anon_sym_AMP_EQ] = ACTIONS(3176),
    [anon_sym_PIPE_EQ] = ACTIONS(3176),
    [anon_sym_GT_GT_EQ] = ACTIONS(3176),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3176),
    [anon_sym_LT_LT_EQ] = ACTIONS(3176),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3176),
    [anon_sym_QMARK] = ACTIONS(3176),
    [anon_sym_AMP_AMP] = ACTIONS(3176),
    [anon_sym_PIPE_PIPE] = ACTIONS(3176),
    [anon_sym_GT_GT] = ACTIONS(3174),
    [anon_sym_GT_GT_GT] = ACTIONS(3174),
    [anon_sym_LT_LT] = ACTIONS(3174),
    [anon_sym_AMP] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3174),
    [anon_sym_PIPE] = ACTIONS(3174),
    [anon_sym_PLUS] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3174),
    [anon_sym_PERCENT] = ACTIONS(3174),
    [anon_sym_STAR_STAR] = ACTIONS(3174),
    [anon_sym_LT_EQ] = ACTIONS(3176),
    [anon_sym_EQ_EQ] = ACTIONS(3174),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3176),
    [anon_sym_BANG_EQ] = ACTIONS(3174),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3176),
    [anon_sym_GT_EQ] = ACTIONS(3176),
    [anon_sym_instanceof] = ACTIONS(3176),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3176),
    [anon_sym_implements] = ACTIONS(3176),
  },
  [648] = {
    [sym_type_arguments] = STATE(1872),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3155),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3157),
    [anon_sym_RBRACE] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(3157),
    [anon_sym_LT] = ACTIONS(3178),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3181),
    [anon_sym_EQ_GT] = ACTIONS(3168),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_is] = ACTIONS(3183),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2496),
    [sym__automatic_semicolon] = ACTIONS(2496),
  },
  [649] = {
    [sym_nested_identifier] = STATE(2855),
    [sym_string] = STATE(1572),
    [sym_template_string] = STATE(1575),
    [sym_formal_parameters] = STATE(2930),
    [sym_nested_type_identifier] = STATE(1385),
    [sym__type] = STATE(1576),
    [sym_constructor_type] = STATE(1576),
    [sym__primary_type] = STATE(1571),
    [sym_generic_type] = STATE(1571),
    [sym_type_predicate] = STATE(1571),
    [sym_type_query] = STATE(1571),
    [sym_index_type_query] = STATE(1571),
    [sym_lookup_type] = STATE(1571),
    [sym_literal_type] = STATE(1571),
    [sym__number] = STATE(1572),
    [sym_existential_type] = STATE(1571),
    [sym_flow_maybe_type] = STATE(1571),
    [sym_parenthesized_type] = STATE(1571),
    [sym_predefined_type] = STATE(1571),
    [sym_object_type] = STATE(1571),
    [sym_type_parameters] = STATE(2592),
    [sym_array_type] = STATE(1571),
    [sym_tuple_type] = STATE(1571),
    [sym_union_type] = STATE(1576),
    [sym_intersection_type] = STATE(1576),
    [sym_function_type] = STATE(1576),
    [sym_identifier] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3197),
    [anon_sym_QMARK] = ACTIONS(3199),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(3209),
    [sym_this] = ACTIONS(3211),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_keyof] = ACTIONS(3215),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3217),
  },
  [650] = {
    [sym_nested_identifier] = STATE(2853),
    [sym_string] = STATE(1375),
    [sym_template_string] = STATE(1415),
    [sym_formal_parameters] = STATE(2911),
    [sym_nested_type_identifier] = STATE(1290),
    [sym__type] = STATE(1414),
    [sym_constructor_type] = STATE(1414),
    [sym__primary_type] = STATE(1372),
    [sym_generic_type] = STATE(1372),
    [sym_type_predicate] = STATE(1372),
    [sym_type_query] = STATE(1372),
    [sym_index_type_query] = STATE(1372),
    [sym_lookup_type] = STATE(1372),
    [sym_literal_type] = STATE(1372),
    [sym__number] = STATE(1375),
    [sym_existential_type] = STATE(1372),
    [sym_flow_maybe_type] = STATE(1372),
    [sym_parenthesized_type] = STATE(1372),
    [sym_predefined_type] = STATE(1372),
    [sym_object_type] = STATE(1372),
    [sym_type_parameters] = STATE(2603),
    [sym_array_type] = STATE(1372),
    [sym_tuple_type] = STATE(1372),
    [sym_union_type] = STATE(1414),
    [sym_intersection_type] = STATE(1414),
    [sym_function_type] = STATE(1414),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_QMARK] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(3243),
    [sym_this] = ACTIONS(3245),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_keyof] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
  },
  [651] = {
    [anon_sym_STAR] = ACTIONS(3253),
    [anon_sym_EQ] = ACTIONS(3253),
    [anon_sym_as] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_COMMA] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_RPAREN] = ACTIONS(3255),
    [anon_sym_in] = ACTIONS(3253),
    [anon_sym_of] = ACTIONS(3255),
    [anon_sym_COLON] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_RBRACK] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3253),
    [anon_sym_GT] = ACTIONS(3253),
    [anon_sym_SLASH] = ACTIONS(3253),
    [anon_sym_DOT] = ACTIONS(3255),
    [anon_sym_PLUS_EQ] = ACTIONS(3255),
    [anon_sym_DASH_EQ] = ACTIONS(3255),
    [anon_sym_STAR_EQ] = ACTIONS(3255),
    [anon_sym_SLASH_EQ] = ACTIONS(3255),
    [anon_sym_PERCENT_EQ] = ACTIONS(3255),
    [anon_sym_CARET_EQ] = ACTIONS(3255),
    [anon_sym_AMP_EQ] = ACTIONS(3255),
    [anon_sym_PIPE_EQ] = ACTIONS(3255),
    [anon_sym_GT_GT_EQ] = ACTIONS(3255),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3255),
    [anon_sym_LT_LT_EQ] = ACTIONS(3255),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3255),
    [anon_sym_QMARK] = ACTIONS(3255),
    [anon_sym_AMP_AMP] = ACTIONS(3255),
    [anon_sym_PIPE_PIPE] = ACTIONS(3255),
    [anon_sym_GT_GT] = ACTIONS(3253),
    [anon_sym_GT_GT_GT] = ACTIONS(3253),
    [anon_sym_LT_LT] = ACTIONS(3253),
    [anon_sym_AMP] = ACTIONS(3253),
    [anon_sym_CARET] = ACTIONS(3253),
    [anon_sym_PIPE] = ACTIONS(3253),
    [anon_sym_PLUS] = ACTIONS(3253),
    [anon_sym_DASH] = ACTIONS(3253),
    [anon_sym_PERCENT] = ACTIONS(3253),
    [anon_sym_STAR_STAR] = ACTIONS(3253),
    [anon_sym_LT_EQ] = ACTIONS(3255),
    [anon_sym_EQ_EQ] = ACTIONS(3253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3255),
    [anon_sym_BANG_EQ] = ACTIONS(3253),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3255),
    [anon_sym_GT_EQ] = ACTIONS(3255),
    [anon_sym_instanceof] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3253),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [anon_sym_implements] = ACTIONS(3255),
  },
  [652] = {
    [sym_arguments] = STATE(1037),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3261),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_RBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3261),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3257),
    [anon_sym_LT_LT] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3257),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_STAR_STAR] = ACTIONS(3257),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_implements] = ACTIONS(3261),
  },
  [653] = {
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(3153),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [654] = {
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(3153),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [655] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_template_string] = STATE(1045),
    [sym_formal_parameters] = STATE(2840),
    [sym_nested_type_identifier] = STATE(1231),
    [sym__type] = STATE(1048),
    [sym_constructor_type] = STATE(1048),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2608),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1048),
    [sym_intersection_type] = STATE(1048),
    [sym_function_type] = STATE(1048),
    [sym_identifier] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3265),
    [anon_sym_QMARK] = ACTIONS(3267),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [656] = {
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2970),
    [anon_sym_as] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2972),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_in] = ACTIONS(2970),
    [anon_sym_of] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_RBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2970),
    [anon_sym_GT] = ACTIONS(2970),
    [anon_sym_SLASH] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2972),
    [anon_sym_PLUS_EQ] = ACTIONS(2972),
    [anon_sym_DASH_EQ] = ACTIONS(2972),
    [anon_sym_STAR_EQ] = ACTIONS(2972),
    [anon_sym_SLASH_EQ] = ACTIONS(2972),
    [anon_sym_PERCENT_EQ] = ACTIONS(2972),
    [anon_sym_CARET_EQ] = ACTIONS(2972),
    [anon_sym_AMP_EQ] = ACTIONS(2972),
    [anon_sym_PIPE_EQ] = ACTIONS(2972),
    [anon_sym_GT_GT_EQ] = ACTIONS(2972),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2972),
    [anon_sym_LT_LT_EQ] = ACTIONS(2972),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2972),
    [anon_sym_QMARK] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2970),
    [anon_sym_GT_GT_GT] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_CARET] = ACTIONS(2970),
    [anon_sym_PIPE] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_STAR_STAR] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2972),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2972),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [anon_sym_instanceof] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2972),
    [anon_sym_implements] = ACTIONS(2972),
  },
  [657] = {
    [sym_nested_identifier] = STATE(951),
    [sym_string] = STATE(950),
    [sym__module] = STATE(1046),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [658] = {
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2950),
    [anon_sym_as] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2952),
    [anon_sym_RPAREN] = ACTIONS(2952),
    [anon_sym_in] = ACTIONS(2950),
    [anon_sym_of] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2952),
    [anon_sym_LBRACK] = ACTIONS(2952),
    [anon_sym_RBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2950),
    [anon_sym_GT] = ACTIONS(2950),
    [anon_sym_SLASH] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_PLUS_EQ] = ACTIONS(2952),
    [anon_sym_DASH_EQ] = ACTIONS(2952),
    [anon_sym_STAR_EQ] = ACTIONS(2952),
    [anon_sym_SLASH_EQ] = ACTIONS(2952),
    [anon_sym_PERCENT_EQ] = ACTIONS(2952),
    [anon_sym_CARET_EQ] = ACTIONS(2952),
    [anon_sym_AMP_EQ] = ACTIONS(2952),
    [anon_sym_PIPE_EQ] = ACTIONS(2952),
    [anon_sym_GT_GT_EQ] = ACTIONS(2952),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2952),
    [anon_sym_LT_LT_EQ] = ACTIONS(2952),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2952),
    [anon_sym_QMARK] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_PIPE_PIPE] = ACTIONS(2952),
    [anon_sym_GT_GT] = ACTIONS(2950),
    [anon_sym_GT_GT_GT] = ACTIONS(2950),
    [anon_sym_LT_LT] = ACTIONS(2950),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_CARET] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_STAR_STAR] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2952),
    [anon_sym_EQ_EQ] = ACTIONS(2950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2952),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2952),
    [anon_sym_instanceof] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2950),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2952),
    [anon_sym_implements] = ACTIONS(2952),
  },
  [659] = {
    [aux_sym_object_repeat1] = STATE(2484),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3273),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(3278),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3283),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3275),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [660] = {
    [aux_sym_object_repeat1] = STATE(2399),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [661] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2522),
    [sym_constructor_type] = STATE(2522),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2522),
    [sym_intersection_type] = STATE(2522),
    [sym_function_type] = STATE(2522),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_RBRACK] = ACTIONS(3293),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [662] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2028),
    [sym_constructor_type] = STATE(2028),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2028),
    [sym_intersection_type] = STATE(2028),
    [sym_function_type] = STATE(2028),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(3299),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [663] = {
    [sym_arguments] = STATE(1032),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_COLON] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
  },
  [664] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2028),
    [sym_constructor_type] = STATE(2028),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2028),
    [sym_intersection_type] = STATE(2028),
    [sym_function_type] = STATE(2028),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [665] = {
    [aux_sym_object_repeat1] = STATE(2392),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [666] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2379),
    [sym_constructor_type] = STATE(2379),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2379),
    [sym_intersection_type] = STATE(2379),
    [sym_function_type] = STATE(2379),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_RBRACK] = ACTIONS(3303),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [667] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2028),
    [sym_constructor_type] = STATE(2028),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2028),
    [sym_intersection_type] = STATE(2028),
    [sym_function_type] = STATE(2028),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(3305),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [668] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3307),
    [anon_sym_RBRACE] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_RPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [anon_sym_RBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3310),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [anon_sym_implements] = ACTIONS(3117),
  },
  [669] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2479),
    [sym_constructor_type] = STATE(2479),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2479),
    [sym_intersection_type] = STATE(2479),
    [sym_function_type] = STATE(2479),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_RBRACK] = ACTIONS(3313),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [670] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2028),
    [sym_constructor_type] = STATE(2028),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2028),
    [sym_intersection_type] = STATE(2028),
    [sym_function_type] = STATE(2028),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(3315),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [671] = {
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_EQ] = ACTIONS(2950),
    [anon_sym_as] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3319),
    [anon_sym_COMMA] = ACTIONS(3319),
    [anon_sym_RBRACE] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3319),
    [anon_sym_in] = ACTIONS(3317),
    [anon_sym_COLON] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_RBRACK] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(3317),
    [anon_sym_GT] = ACTIONS(3317),
    [anon_sym_SLASH] = ACTIONS(3317),
    [anon_sym_DOT] = ACTIONS(3319),
    [anon_sym_PLUS_EQ] = ACTIONS(2952),
    [anon_sym_DASH_EQ] = ACTIONS(2952),
    [anon_sym_STAR_EQ] = ACTIONS(2952),
    [anon_sym_SLASH_EQ] = ACTIONS(2952),
    [anon_sym_PERCENT_EQ] = ACTIONS(2952),
    [anon_sym_CARET_EQ] = ACTIONS(2952),
    [anon_sym_AMP_EQ] = ACTIONS(2952),
    [anon_sym_PIPE_EQ] = ACTIONS(2952),
    [anon_sym_GT_GT_EQ] = ACTIONS(2952),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2952),
    [anon_sym_LT_LT_EQ] = ACTIONS(2952),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2952),
    [anon_sym_QMARK] = ACTIONS(3319),
    [anon_sym_AMP_AMP] = ACTIONS(3319),
    [anon_sym_PIPE_PIPE] = ACTIONS(3319),
    [anon_sym_GT_GT] = ACTIONS(3317),
    [anon_sym_GT_GT_GT] = ACTIONS(3317),
    [anon_sym_LT_LT] = ACTIONS(3317),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3317),
    [anon_sym_PIPE] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_PERCENT] = ACTIONS(3317),
    [anon_sym_STAR_STAR] = ACTIONS(3317),
    [anon_sym_LT_EQ] = ACTIONS(3319),
    [anon_sym_EQ_EQ] = ACTIONS(3317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3319),
    [anon_sym_BANG_EQ] = ACTIONS(3317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3319),
    [anon_sym_GT_EQ] = ACTIONS(3319),
    [anon_sym_instanceof] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [anon_sym_implements] = ACTIONS(3319),
  },
  [672] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2370),
    [sym_constructor_type] = STATE(2370),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2370),
    [sym_intersection_type] = STATE(2370),
    [sym_function_type] = STATE(2370),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_RBRACK] = ACTIONS(3321),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [673] = {
    [sym_arguments] = STATE(1037),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3261),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_RBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3168),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3257),
    [anon_sym_LT_LT] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3257),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_STAR_STAR] = ACTIONS(3257),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
  },
  [674] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2028),
    [sym_constructor_type] = STATE(2028),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2028),
    [sym_intersection_type] = STATE(2028),
    [sym_function_type] = STATE(2028),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(3323),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [675] = {
    [aux_sym_object_repeat1] = STATE(2484),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [676] = {
    [sym_type_arguments] = STATE(413),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3325),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3157),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(3157),
    [anon_sym_LT] = ACTIONS(3160),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3327),
    [anon_sym_EQ_GT] = ACTIONS(3283),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_is] = ACTIONS(3172),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [677] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2256),
    [sym_constructor_type] = STATE(2256),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_type_parameter] = STATE(2482),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2256),
    [sym_intersection_type] = STATE(2256),
    [sym_function_type] = STATE(2256),
    [sym_identifier] = ACTIONS(3329),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [678] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2028),
    [sym_constructor_type] = STATE(2028),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2028),
    [sym_intersection_type] = STATE(2028),
    [sym_function_type] = STATE(2028),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(3331),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [679] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3333),
    [anon_sym_RBRACE] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_RPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_RBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3336),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [anon_sym_implements] = ACTIONS(3117),
  },
  [680] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2028),
    [sym_constructor_type] = STATE(2028),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2028),
    [sym_intersection_type] = STATE(2028),
    [sym_function_type] = STATE(2028),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(3339),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [681] = {
    [aux_sym_object_repeat1] = STATE(2392),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3273),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(3278),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3283),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3275),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [682] = {
    [aux_sym_object_repeat1] = STATE(2399),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3273),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(3278),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3283),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3275),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [683] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2028),
    [sym_constructor_type] = STATE(2028),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2028),
    [sym_intersection_type] = STATE(2028),
    [sym_function_type] = STATE(2028),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [684] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2394),
    [sym_constructor_type] = STATE(2394),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2394),
    [sym_intersection_type] = STATE(2394),
    [sym_function_type] = STATE(2394),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_RBRACK] = ACTIONS(3343),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [685] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2028),
    [sym_constructor_type] = STATE(2028),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2028),
    [sym_intersection_type] = STATE(2028),
    [sym_function_type] = STATE(2028),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(3345),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [686] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2028),
    [sym_constructor_type] = STATE(2028),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2028),
    [sym_intersection_type] = STATE(2028),
    [sym_function_type] = STATE(2028),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(3347),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [687] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2764),
    [sym_nested_type_identifier] = STATE(1491),
    [sym__type] = STATE(1084),
    [sym_constructor_type] = STATE(1084),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2602),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1084),
    [sym_intersection_type] = STATE(1084),
    [sym_function_type] = STATE(1084),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_PIPE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [688] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2325),
    [sym_constructor_type] = STATE(2325),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2325),
    [sym_intersection_type] = STATE(2325),
    [sym_function_type] = STATE(2325),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [689] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_formal_parameters] = STATE(2778),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(1869),
    [sym_constructor_type] = STATE(1869),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2735),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(1869),
    [sym_intersection_type] = STATE(1869),
    [sym_function_type] = STATE(1869),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [690] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2454),
    [sym_constructor_type] = STATE(2454),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2454),
    [sym_intersection_type] = STATE(2454),
    [sym_function_type] = STATE(2454),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [691] = {
    [sym_nested_identifier] = STATE(2853),
    [sym_string] = STATE(1375),
    [sym_formal_parameters] = STATE(2911),
    [sym_nested_type_identifier] = STATE(1290),
    [sym__type] = STATE(1474),
    [sym_constructor_type] = STATE(1474),
    [sym__primary_type] = STATE(1372),
    [sym_generic_type] = STATE(1372),
    [sym_type_predicate] = STATE(1372),
    [sym_type_query] = STATE(1372),
    [sym_index_type_query] = STATE(1372),
    [sym_lookup_type] = STATE(1372),
    [sym_literal_type] = STATE(1372),
    [sym__number] = STATE(1375),
    [sym_existential_type] = STATE(1372),
    [sym_flow_maybe_type] = STATE(1372),
    [sym_parenthesized_type] = STATE(1372),
    [sym_predefined_type] = STATE(1372),
    [sym_object_type] = STATE(1372),
    [sym_type_parameters] = STATE(2603),
    [sym_array_type] = STATE(1372),
    [sym_tuple_type] = STATE(1372),
    [sym_union_type] = STATE(1474),
    [sym_intersection_type] = STATE(1474),
    [sym_function_type] = STATE(1474),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_QMARK] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3243),
    [sym_this] = ACTIONS(3245),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_keyof] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
  },
  [692] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2889),
    [sym_nested_type_identifier] = STATE(463),
    [sym__type] = STATE(467),
    [sym_constructor_type] = STATE(467),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2598),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(467),
    [sym_intersection_type] = STATE(467),
    [sym_function_type] = STATE(467),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_QMARK] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [693] = {
    [sym_type_arguments] = STATE(413),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3381),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(3157),
    [anon_sym_LT] = ACTIONS(3160),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3383),
    [anon_sym_EQ_GT] = ACTIONS(3385),
    [anon_sym_PLUS_EQ] = ACTIONS(3387),
    [anon_sym_DASH_EQ] = ACTIONS(3387),
    [anon_sym_STAR_EQ] = ACTIONS(3387),
    [anon_sym_SLASH_EQ] = ACTIONS(3387),
    [anon_sym_PERCENT_EQ] = ACTIONS(3387),
    [anon_sym_CARET_EQ] = ACTIONS(3387),
    [anon_sym_AMP_EQ] = ACTIONS(3387),
    [anon_sym_PIPE_EQ] = ACTIONS(3387),
    [anon_sym_GT_GT_EQ] = ACTIONS(3387),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3387),
    [anon_sym_LT_LT_EQ] = ACTIONS(3387),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_is] = ACTIONS(3172),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [694] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2198),
    [sym_constructor_type] = STATE(2198),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2198),
    [sym_intersection_type] = STATE(2198),
    [sym_function_type] = STATE(2198),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [695] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_formal_parameters] = STATE(2778),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(1888),
    [sym_constructor_type] = STATE(1888),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2735),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(1888),
    [sym_intersection_type] = STATE(1888),
    [sym_function_type] = STATE(1888),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [696] = {
    [sym_type_arguments] = STATE(413),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(3157),
    [anon_sym_LT] = ACTIONS(3160),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3166),
    [anon_sym_EQ_GT] = ACTIONS(3391),
    [anon_sym_PLUS_EQ] = ACTIONS(3393),
    [anon_sym_DASH_EQ] = ACTIONS(3393),
    [anon_sym_STAR_EQ] = ACTIONS(3393),
    [anon_sym_SLASH_EQ] = ACTIONS(3393),
    [anon_sym_PERCENT_EQ] = ACTIONS(3393),
    [anon_sym_CARET_EQ] = ACTIONS(3393),
    [anon_sym_AMP_EQ] = ACTIONS(3393),
    [anon_sym_PIPE_EQ] = ACTIONS(3393),
    [anon_sym_GT_GT_EQ] = ACTIONS(3393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3393),
    [anon_sym_LT_LT_EQ] = ACTIONS(3393),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3393),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_implements] = ACTIONS(1209),
    [anon_sym_is] = ACTIONS(3172),
  },
  [697] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_formal_parameters] = STATE(2778),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(1861),
    [sym_constructor_type] = STATE(1861),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2735),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(1861),
    [sym_intersection_type] = STATE(1861),
    [sym_function_type] = STATE(1861),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [698] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_formal_parameters] = STATE(2778),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(1943),
    [sym_constructor_type] = STATE(1943),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2735),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(1943),
    [sym_intersection_type] = STATE(1943),
    [sym_function_type] = STATE(1943),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [699] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2764),
    [sym_nested_type_identifier] = STATE(1491),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2602),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1091),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_PIPE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [700] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2372),
    [sym_constructor_type] = STATE(2372),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2372),
    [sym_intersection_type] = STATE(2372),
    [sym_function_type] = STATE(2372),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [701] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2764),
    [sym_nested_type_identifier] = STATE(1491),
    [sym__type] = STATE(1494),
    [sym_constructor_type] = STATE(1494),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2602),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1494),
    [sym_intersection_type] = STATE(1494),
    [sym_function_type] = STATE(1494),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_PIPE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [702] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2764),
    [sym_nested_type_identifier] = STATE(1491),
    [sym__type] = STATE(1496),
    [sym_constructor_type] = STATE(1496),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2602),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1496),
    [sym_intersection_type] = STATE(1496),
    [sym_function_type] = STATE(1496),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_PIPE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [703] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2764),
    [sym_nested_type_identifier] = STATE(1491),
    [sym__type] = STATE(1101),
    [sym_constructor_type] = STATE(1101),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2602),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1101),
    [sym_intersection_type] = STATE(1101),
    [sym_function_type] = STATE(1101),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_PIPE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [704] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2477),
    [sym_constructor_type] = STATE(2477),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2477),
    [sym_intersection_type] = STATE(2477),
    [sym_function_type] = STATE(2477),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [705] = {
    [sym_nested_identifier] = STATE(2855),
    [sym_string] = STATE(1572),
    [sym_formal_parameters] = STATE(2930),
    [sym_nested_type_identifier] = STATE(1385),
    [sym__type] = STATE(1564),
    [sym_constructor_type] = STATE(1564),
    [sym__primary_type] = STATE(1571),
    [sym_generic_type] = STATE(1571),
    [sym_type_predicate] = STATE(1571),
    [sym_type_query] = STATE(1571),
    [sym_index_type_query] = STATE(1571),
    [sym_lookup_type] = STATE(1571),
    [sym_literal_type] = STATE(1571),
    [sym__number] = STATE(1572),
    [sym_existential_type] = STATE(1571),
    [sym_flow_maybe_type] = STATE(1571),
    [sym_parenthesized_type] = STATE(1571),
    [sym_predefined_type] = STATE(1571),
    [sym_object_type] = STATE(1571),
    [sym_type_parameters] = STATE(2592),
    [sym_array_type] = STATE(1571),
    [sym_tuple_type] = STATE(1571),
    [sym_union_type] = STATE(1564),
    [sym_intersection_type] = STATE(1564),
    [sym_function_type] = STATE(1564),
    [sym_identifier] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3197),
    [anon_sym_QMARK] = ACTIONS(3199),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3209),
    [sym_this] = ACTIONS(3211),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_keyof] = ACTIONS(3215),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3217),
  },
  [706] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2460),
    [sym_constructor_type] = STATE(2460),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2460),
    [sym_intersection_type] = STATE(2460),
    [sym_function_type] = STATE(2460),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [707] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2840),
    [sym_nested_type_identifier] = STATE(1231),
    [sym__type] = STATE(1084),
    [sym_constructor_type] = STATE(1084),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2608),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1084),
    [sym_intersection_type] = STATE(1084),
    [sym_function_type] = STATE(1084),
    [sym_identifier] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3265),
    [anon_sym_QMARK] = ACTIONS(3267),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [708] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2764),
    [sym_nested_type_identifier] = STATE(1491),
    [sym__type] = STATE(1100),
    [sym_constructor_type] = STATE(1100),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2602),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1100),
    [sym_intersection_type] = STATE(1100),
    [sym_function_type] = STATE(1100),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_PIPE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [709] = {
    [sym_nested_identifier] = STATE(2853),
    [sym_string] = STATE(1375),
    [sym_formal_parameters] = STATE(2911),
    [sym_nested_type_identifier] = STATE(1290),
    [sym__type] = STATE(1473),
    [sym_constructor_type] = STATE(1473),
    [sym__primary_type] = STATE(1372),
    [sym_generic_type] = STATE(1372),
    [sym_type_predicate] = STATE(1372),
    [sym_type_query] = STATE(1372),
    [sym_index_type_query] = STATE(1372),
    [sym_lookup_type] = STATE(1372),
    [sym_literal_type] = STATE(1372),
    [sym__number] = STATE(1375),
    [sym_existential_type] = STATE(1372),
    [sym_flow_maybe_type] = STATE(1372),
    [sym_parenthesized_type] = STATE(1372),
    [sym_predefined_type] = STATE(1372),
    [sym_object_type] = STATE(1372),
    [sym_type_parameters] = STATE(2603),
    [sym_array_type] = STATE(1372),
    [sym_tuple_type] = STATE(1372),
    [sym_union_type] = STATE(1473),
    [sym_intersection_type] = STATE(1473),
    [sym_function_type] = STATE(1473),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_QMARK] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3243),
    [sym_this] = ACTIONS(3245),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_keyof] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
  },
  [710] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2840),
    [sym_nested_type_identifier] = STATE(1231),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2608),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1091),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym_identifier] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3265),
    [anon_sym_QMARK] = ACTIONS(3267),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [711] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2764),
    [sym_nested_type_identifier] = STATE(1491),
    [sym__type] = STATE(1519),
    [sym_constructor_type] = STATE(1519),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2602),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1519),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_PIPE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [712] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_formal_parameters] = STATE(2778),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(2270),
    [sym_constructor_type] = STATE(2270),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2735),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(2270),
    [sym_intersection_type] = STATE(2270),
    [sym_function_type] = STATE(2270),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [713] = {
    [sym_nested_identifier] = STATE(2855),
    [sym_string] = STATE(1572),
    [sym_formal_parameters] = STATE(2930),
    [sym_nested_type_identifier] = STATE(1385),
    [sym__type] = STATE(1563),
    [sym_constructor_type] = STATE(1563),
    [sym__primary_type] = STATE(1571),
    [sym_generic_type] = STATE(1571),
    [sym_type_predicate] = STATE(1571),
    [sym_type_query] = STATE(1571),
    [sym_index_type_query] = STATE(1571),
    [sym_lookup_type] = STATE(1571),
    [sym_literal_type] = STATE(1571),
    [sym__number] = STATE(1572),
    [sym_existential_type] = STATE(1571),
    [sym_flow_maybe_type] = STATE(1571),
    [sym_parenthesized_type] = STATE(1571),
    [sym_predefined_type] = STATE(1571),
    [sym_object_type] = STATE(1571),
    [sym_type_parameters] = STATE(2592),
    [sym_array_type] = STATE(1571),
    [sym_tuple_type] = STATE(1571),
    [sym_union_type] = STATE(1563),
    [sym_intersection_type] = STATE(1563),
    [sym_function_type] = STATE(1563),
    [sym_identifier] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3197),
    [anon_sym_QMARK] = ACTIONS(3199),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3209),
    [sym_this] = ACTIONS(3211),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_keyof] = ACTIONS(3215),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3217),
  },
  [714] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(423),
    [sym_constructor_type] = STATE(423),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(423),
    [sym_intersection_type] = STATE(423),
    [sym_function_type] = STATE(423),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [715] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2121),
    [sym_constructor_type] = STATE(2121),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2121),
    [sym_intersection_type] = STATE(2121),
    [sym_function_type] = STATE(2121),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [716] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(427),
    [sym_constructor_type] = STATE(427),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(427),
    [sym_intersection_type] = STATE(427),
    [sym_function_type] = STATE(427),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [717] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2764),
    [sym_nested_type_identifier] = STATE(1491),
    [sym__type] = STATE(1520),
    [sym_constructor_type] = STATE(1520),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2602),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1520),
    [sym_intersection_type] = STATE(1520),
    [sym_function_type] = STATE(1520),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_PIPE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [718] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2764),
    [sym_nested_type_identifier] = STATE(1491),
    [sym__type] = STATE(1521),
    [sym_constructor_type] = STATE(1521),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2602),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1521),
    [sym_intersection_type] = STATE(1521),
    [sym_function_type] = STATE(1521),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_PIPE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [719] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2889),
    [sym_nested_type_identifier] = STATE(463),
    [sym__type] = STATE(423),
    [sym_constructor_type] = STATE(423),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2598),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(423),
    [sym_intersection_type] = STATE(423),
    [sym_function_type] = STATE(423),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_QMARK] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [720] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2889),
    [sym_nested_type_identifier] = STATE(463),
    [sym__type] = STATE(427),
    [sym_constructor_type] = STATE(427),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2598),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(427),
    [sym_intersection_type] = STATE(427),
    [sym_function_type] = STATE(427),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_QMARK] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [721] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2186),
    [sym_constructor_type] = STATE(2186),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2186),
    [sym_intersection_type] = STATE(2186),
    [sym_function_type] = STATE(2186),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [722] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(1821),
    [sym_constructor_type] = STATE(1821),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(1821),
    [sym_intersection_type] = STATE(1821),
    [sym_function_type] = STATE(1821),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [723] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2124),
    [sym_constructor_type] = STATE(2124),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2124),
    [sym_intersection_type] = STATE(2124),
    [sym_function_type] = STATE(2124),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [724] = {
    [sym_arguments] = STATE(1428),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym__automatic_semicolon] = ACTIONS(501),
  },
  [725] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(1822),
    [sym_constructor_type] = STATE(1822),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(1822),
    [sym_intersection_type] = STATE(1822),
    [sym_function_type] = STATE(1822),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [726] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2094),
    [sym_constructor_type] = STATE(2094),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2094),
    [sym_intersection_type] = STATE(2094),
    [sym_function_type] = STATE(2094),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [727] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2506),
    [sym_constructor_type] = STATE(2506),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2506),
    [sym_intersection_type] = STATE(2506),
    [sym_function_type] = STATE(2506),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [728] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_formal_parameters] = STATE(2778),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(1867),
    [sym_constructor_type] = STATE(1867),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2735),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(1867),
    [sym_intersection_type] = STATE(1867),
    [sym_function_type] = STATE(1867),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [729] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(1927),
    [sym_constructor_type] = STATE(1927),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(1927),
    [sym_intersection_type] = STATE(1927),
    [sym_function_type] = STATE(1927),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [730] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(436),
    [sym_constructor_type] = STATE(436),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(436),
    [sym_intersection_type] = STATE(436),
    [sym_function_type] = STATE(436),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [731] = {
    [sym_type_arguments] = STATE(413),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3395),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3398),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(3401),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(3398),
    [anon_sym_LBRACK] = ACTIONS(3157),
    [anon_sym_LT] = ACTIONS(3160),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3405),
    [anon_sym_EQ_GT] = ACTIONS(3168),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(3398),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_is] = ACTIONS(3172),
  },
  [732] = {
    [sym_type_arguments] = STATE(1561),
    [aux_sym_extends_clause_repeat1] = STATE(2287),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3407),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_COMMA] = ACTIONS(3411),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(3413),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3416),
    [anon_sym_EQ_GT] = ACTIONS(3418),
    [anon_sym_PLUS_EQ] = ACTIONS(3420),
    [anon_sym_DASH_EQ] = ACTIONS(3420),
    [anon_sym_STAR_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_PERCENT_EQ] = ACTIONS(3420),
    [anon_sym_CARET_EQ] = ACTIONS(3420),
    [anon_sym_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_LT_LT_EQ] = ACTIONS(3420),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3420),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3422),
  },
  [733] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(422),
    [sym_constructor_type] = STATE(422),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(422),
    [sym_intersection_type] = STATE(422),
    [sym_function_type] = STATE(422),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [734] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2889),
    [sym_nested_type_identifier] = STATE(463),
    [sym__type] = STATE(471),
    [sym_constructor_type] = STATE(471),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2598),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(471),
    [sym_intersection_type] = STATE(471),
    [sym_function_type] = STATE(471),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_QMARK] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [735] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_formal_parameters] = STATE(2778),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(1865),
    [sym_constructor_type] = STATE(1865),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2735),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(1865),
    [sym_intersection_type] = STATE(1865),
    [sym_function_type] = STATE(1865),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [736] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_formal_parameters] = STATE(2778),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(1874),
    [sym_constructor_type] = STATE(1874),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2735),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(1874),
    [sym_intersection_type] = STATE(1874),
    [sym_function_type] = STATE(1874),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [737] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2170),
    [sym_constructor_type] = STATE(2170),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2170),
    [sym_intersection_type] = STATE(2170),
    [sym_function_type] = STATE(2170),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [738] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2840),
    [sym_nested_type_identifier] = STATE(1231),
    [sym__type] = STATE(1275),
    [sym_constructor_type] = STATE(1275),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2608),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1275),
    [sym_intersection_type] = STATE(1275),
    [sym_function_type] = STATE(1275),
    [sym_identifier] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3265),
    [anon_sym_QMARK] = ACTIONS(3267),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [739] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(1807),
    [sym_constructor_type] = STATE(1807),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(1807),
    [sym_intersection_type] = STATE(1807),
    [sym_function_type] = STATE(1807),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [740] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2840),
    [sym_nested_type_identifier] = STATE(1231),
    [sym__type] = STATE(1333),
    [sym_constructor_type] = STATE(1333),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2608),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1333),
    [sym_intersection_type] = STATE(1333),
    [sym_function_type] = STATE(1333),
    [sym_identifier] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3265),
    [anon_sym_QMARK] = ACTIONS(3267),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [741] = {
    [sym_nested_identifier] = STATE(2853),
    [sym_string] = STATE(1375),
    [sym_formal_parameters] = STATE(2911),
    [sym_nested_type_identifier] = STATE(1290),
    [sym__type] = STATE(1379),
    [sym_constructor_type] = STATE(1379),
    [sym__primary_type] = STATE(1372),
    [sym_generic_type] = STATE(1372),
    [sym_type_predicate] = STATE(1372),
    [sym_type_query] = STATE(1372),
    [sym_index_type_query] = STATE(1372),
    [sym_lookup_type] = STATE(1372),
    [sym_literal_type] = STATE(1372),
    [sym__number] = STATE(1375),
    [sym_existential_type] = STATE(1372),
    [sym_flow_maybe_type] = STATE(1372),
    [sym_parenthesized_type] = STATE(1372),
    [sym_predefined_type] = STATE(1372),
    [sym_object_type] = STATE(1372),
    [sym_type_parameters] = STATE(2603),
    [sym_array_type] = STATE(1372),
    [sym_tuple_type] = STATE(1372),
    [sym_union_type] = STATE(1379),
    [sym_intersection_type] = STATE(1379),
    [sym_function_type] = STATE(1379),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_QMARK] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3243),
    [sym_this] = ACTIONS(3245),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_keyof] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
  },
  [742] = {
    [sym_nested_identifier] = STATE(2853),
    [sym_string] = STATE(1375),
    [sym_formal_parameters] = STATE(2911),
    [sym_nested_type_identifier] = STATE(1290),
    [sym__type] = STATE(1378),
    [sym_constructor_type] = STATE(1378),
    [sym__primary_type] = STATE(1372),
    [sym_generic_type] = STATE(1372),
    [sym_type_predicate] = STATE(1372),
    [sym_type_query] = STATE(1372),
    [sym_index_type_query] = STATE(1372),
    [sym_lookup_type] = STATE(1372),
    [sym_literal_type] = STATE(1372),
    [sym__number] = STATE(1375),
    [sym_existential_type] = STATE(1372),
    [sym_flow_maybe_type] = STATE(1372),
    [sym_parenthesized_type] = STATE(1372),
    [sym_predefined_type] = STATE(1372),
    [sym_object_type] = STATE(1372),
    [sym_type_parameters] = STATE(2603),
    [sym_array_type] = STATE(1372),
    [sym_tuple_type] = STATE(1372),
    [sym_union_type] = STATE(1378),
    [sym_intersection_type] = STATE(1378),
    [sym_function_type] = STATE(1378),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_QMARK] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3243),
    [sym_this] = ACTIONS(3245),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_keyof] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
  },
  [743] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2256),
    [sym_constructor_type] = STATE(2256),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2256),
    [sym_intersection_type] = STATE(2256),
    [sym_function_type] = STATE(2256),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [744] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2840),
    [sym_nested_type_identifier] = STATE(1231),
    [sym__type] = STATE(1322),
    [sym_constructor_type] = STATE(1322),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2608),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1322),
    [sym_intersection_type] = STATE(1322),
    [sym_function_type] = STATE(1322),
    [sym_identifier] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3265),
    [anon_sym_QMARK] = ACTIONS(3267),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [745] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_formal_parameters] = STATE(2778),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(1846),
    [sym_constructor_type] = STATE(1846),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2735),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(1846),
    [sym_intersection_type] = STATE(1846),
    [sym_function_type] = STATE(1846),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [746] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_formal_parameters] = STATE(2778),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(1842),
    [sym_constructor_type] = STATE(1842),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2735),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(1842),
    [sym_intersection_type] = STATE(1842),
    [sym_function_type] = STATE(1842),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [747] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2840),
    [sym_nested_type_identifier] = STATE(1231),
    [sym__type] = STATE(1101),
    [sym_constructor_type] = STATE(1101),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2608),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1101),
    [sym_intersection_type] = STATE(1101),
    [sym_function_type] = STATE(1101),
    [sym_identifier] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3265),
    [anon_sym_QMARK] = ACTIONS(3267),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [748] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2840),
    [sym_nested_type_identifier] = STATE(1231),
    [sym__type] = STATE(1100),
    [sym_constructor_type] = STATE(1100),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2608),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1100),
    [sym_intersection_type] = STATE(1100),
    [sym_function_type] = STATE(1100),
    [sym_identifier] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3265),
    [anon_sym_QMARK] = ACTIONS(3267),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [749] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2028),
    [sym_constructor_type] = STATE(2028),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2028),
    [sym_intersection_type] = STATE(2028),
    [sym_function_type] = STATE(2028),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [750] = {
    [sym_nested_identifier] = STATE(2853),
    [sym_string] = STATE(1375),
    [sym_formal_parameters] = STATE(2911),
    [sym_nested_type_identifier] = STATE(1290),
    [sym__type] = STATE(1471),
    [sym_constructor_type] = STATE(1471),
    [sym__primary_type] = STATE(1372),
    [sym_generic_type] = STATE(1372),
    [sym_type_predicate] = STATE(1372),
    [sym_type_query] = STATE(1372),
    [sym_index_type_query] = STATE(1372),
    [sym_lookup_type] = STATE(1372),
    [sym_literal_type] = STATE(1372),
    [sym__number] = STATE(1375),
    [sym_existential_type] = STATE(1372),
    [sym_flow_maybe_type] = STATE(1372),
    [sym_parenthesized_type] = STATE(1372),
    [sym_predefined_type] = STATE(1372),
    [sym_object_type] = STATE(1372),
    [sym_type_parameters] = STATE(2603),
    [sym_array_type] = STATE(1372),
    [sym_tuple_type] = STATE(1372),
    [sym_union_type] = STATE(1471),
    [sym_intersection_type] = STATE(1471),
    [sym_function_type] = STATE(1471),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_QMARK] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3243),
    [sym_this] = ACTIONS(3245),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_keyof] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
  },
  [751] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_formal_parameters] = STATE(2778),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(1840),
    [sym_constructor_type] = STATE(1840),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2735),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(1840),
    [sym_intersection_type] = STATE(1840),
    [sym_function_type] = STATE(1840),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [752] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(1815),
    [sym_constructor_type] = STATE(1815),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(1815),
    [sym_intersection_type] = STATE(1815),
    [sym_function_type] = STATE(1815),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [753] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2889),
    [sym_nested_type_identifier] = STATE(463),
    [sym__type] = STATE(470),
    [sym_constructor_type] = STATE(470),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2598),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(470),
    [sym_intersection_type] = STATE(470),
    [sym_function_type] = STATE(470),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_QMARK] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [754] = {
    [sym_type_arguments] = STATE(413),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(3157),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(3160),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3424),
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_is] = ACTIONS(3172),
  },
  [755] = {
    [sym_type_arguments] = STATE(413),
    [aux_sym_extends_clause_repeat1] = STATE(2303),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(3422),
    [anon_sym_COMMA] = ACTIONS(3426),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(3160),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3428),
    [anon_sym_EQ_GT] = ACTIONS(3391),
    [anon_sym_PLUS_EQ] = ACTIONS(3393),
    [anon_sym_DASH_EQ] = ACTIONS(3393),
    [anon_sym_STAR_EQ] = ACTIONS(3393),
    [anon_sym_SLASH_EQ] = ACTIONS(3393),
    [anon_sym_PERCENT_EQ] = ACTIONS(3393),
    [anon_sym_CARET_EQ] = ACTIONS(3393),
    [anon_sym_AMP_EQ] = ACTIONS(3393),
    [anon_sym_PIPE_EQ] = ACTIONS(3393),
    [anon_sym_GT_GT_EQ] = ACTIONS(3393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3393),
    [anon_sym_LT_LT_EQ] = ACTIONS(3393),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3393),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_implements] = ACTIONS(3422),
  },
  [756] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2204),
    [sym_constructor_type] = STATE(2204),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2204),
    [sym_intersection_type] = STATE(2204),
    [sym_function_type] = STATE(2204),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [757] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_formal_parameters] = STATE(2778),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(2362),
    [sym_constructor_type] = STATE(2362),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2735),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(2362),
    [sym_intersection_type] = STATE(2362),
    [sym_function_type] = STATE(2362),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [758] = {
    [sym_identifier] = ACTIONS(3153),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [759] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3155),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3430),
    [anon_sym_EQ_GT] = ACTIONS(3168),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2344),
    [sym__automatic_semicolon] = ACTIONS(2344),
  },
  [760] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2350),
    [sym_constructor_type] = STATE(2350),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2350),
    [sym_intersection_type] = STATE(2350),
    [sym_function_type] = STATE(2350),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [761] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_formal_parameters] = STATE(2778),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(2314),
    [sym_constructor_type] = STATE(2314),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2735),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(2314),
    [sym_intersection_type] = STATE(2314),
    [sym_function_type] = STATE(2314),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [762] = {
    [sym_nested_identifier] = STATE(2853),
    [sym_string] = STATE(1375),
    [sym_formal_parameters] = STATE(2911),
    [sym_nested_type_identifier] = STATE(1290),
    [sym__type] = STATE(1480),
    [sym_constructor_type] = STATE(1480),
    [sym__primary_type] = STATE(1372),
    [sym_generic_type] = STATE(1372),
    [sym_type_predicate] = STATE(1372),
    [sym_type_query] = STATE(1372),
    [sym_index_type_query] = STATE(1372),
    [sym_lookup_type] = STATE(1372),
    [sym_literal_type] = STATE(1372),
    [sym__number] = STATE(1375),
    [sym_existential_type] = STATE(1372),
    [sym_flow_maybe_type] = STATE(1372),
    [sym_parenthesized_type] = STATE(1372),
    [sym_predefined_type] = STATE(1372),
    [sym_object_type] = STATE(1372),
    [sym_type_parameters] = STATE(2603),
    [sym_array_type] = STATE(1372),
    [sym_tuple_type] = STATE(1372),
    [sym_union_type] = STATE(1480),
    [sym_intersection_type] = STATE(1480),
    [sym_function_type] = STATE(1480),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_QMARK] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3243),
    [sym_this] = ACTIONS(3245),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_keyof] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
  },
  [763] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3155),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3168),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [764] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2889),
    [sym_nested_type_identifier] = STATE(463),
    [sym__type] = STATE(469),
    [sym_constructor_type] = STATE(469),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2598),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(469),
    [sym_intersection_type] = STATE(469),
    [sym_function_type] = STATE(469),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_QMARK] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [765] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2840),
    [sym_nested_type_identifier] = STATE(1231),
    [sym__type] = STATE(1288),
    [sym_constructor_type] = STATE(1288),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2608),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1288),
    [sym_intersection_type] = STATE(1288),
    [sym_function_type] = STATE(1288),
    [sym_identifier] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3265),
    [anon_sym_QMARK] = ACTIONS(3267),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [766] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2122),
    [sym_constructor_type] = STATE(2122),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2122),
    [sym_intersection_type] = STATE(2122),
    [sym_function_type] = STATE(2122),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [767] = {
    [sym_arguments] = STATE(1424),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3283),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3257),
    [anon_sym_LT_LT] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3257),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_STAR_STAR] = ACTIONS(3257),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [sym__automatic_semicolon] = ACTIONS(3261),
  },
  [768] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(1819),
    [sym_constructor_type] = STATE(1819),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(1819),
    [sym_intersection_type] = STATE(1819),
    [sym_function_type] = STATE(1819),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [769] = {
    [sym_nested_identifier] = STATE(2853),
    [sym_string] = STATE(1375),
    [sym_formal_parameters] = STATE(2911),
    [sym_nested_type_identifier] = STATE(1290),
    [sym__type] = STATE(1465),
    [sym_constructor_type] = STATE(1465),
    [sym__primary_type] = STATE(1372),
    [sym_generic_type] = STATE(1372),
    [sym_type_predicate] = STATE(1372),
    [sym_type_query] = STATE(1372),
    [sym_index_type_query] = STATE(1372),
    [sym_lookup_type] = STATE(1372),
    [sym_literal_type] = STATE(1372),
    [sym__number] = STATE(1375),
    [sym_existential_type] = STATE(1372),
    [sym_flow_maybe_type] = STATE(1372),
    [sym_parenthesized_type] = STATE(1372),
    [sym_predefined_type] = STATE(1372),
    [sym_object_type] = STATE(1372),
    [sym_type_parameters] = STATE(2603),
    [sym_array_type] = STATE(1372),
    [sym_tuple_type] = STATE(1372),
    [sym_union_type] = STATE(1465),
    [sym_intersection_type] = STATE(1465),
    [sym_function_type] = STATE(1465),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_QMARK] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3243),
    [sym_this] = ACTIONS(3245),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_keyof] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
  },
  [770] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2224),
    [sym_constructor_type] = STATE(2224),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2224),
    [sym_intersection_type] = STATE(2224),
    [sym_function_type] = STATE(2224),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [771] = {
    [sym_nested_identifier] = STATE(2853),
    [sym_string] = STATE(1375),
    [sym_formal_parameters] = STATE(2911),
    [sym_nested_type_identifier] = STATE(1290),
    [sym__type] = STATE(1483),
    [sym_constructor_type] = STATE(1483),
    [sym__primary_type] = STATE(1372),
    [sym_generic_type] = STATE(1372),
    [sym_type_predicate] = STATE(1372),
    [sym_type_query] = STATE(1372),
    [sym_index_type_query] = STATE(1372),
    [sym_lookup_type] = STATE(1372),
    [sym_literal_type] = STATE(1372),
    [sym__number] = STATE(1375),
    [sym_existential_type] = STATE(1372),
    [sym_flow_maybe_type] = STATE(1372),
    [sym_parenthesized_type] = STATE(1372),
    [sym_predefined_type] = STATE(1372),
    [sym_object_type] = STATE(1372),
    [sym_type_parameters] = STATE(2603),
    [sym_array_type] = STATE(1372),
    [sym_tuple_type] = STATE(1372),
    [sym_union_type] = STATE(1483),
    [sym_intersection_type] = STATE(1483),
    [sym_function_type] = STATE(1483),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_QMARK] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3243),
    [sym_this] = ACTIONS(3245),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_keyof] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
  },
  [772] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_formal_parameters] = STATE(2778),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(1848),
    [sym_constructor_type] = STATE(1848),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2735),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(1848),
    [sym_intersection_type] = STATE(1848),
    [sym_function_type] = STATE(1848),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [773] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3155),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3432),
    [anon_sym_EQ_GT] = ACTIONS(3168),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [774] = {
    [sym_type_arguments] = STATE(413),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3407),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(3157),
    [anon_sym_LT] = ACTIONS(3160),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3434),
    [anon_sym_EQ_GT] = ACTIONS(3418),
    [anon_sym_PLUS_EQ] = ACTIONS(3420),
    [anon_sym_DASH_EQ] = ACTIONS(3420),
    [anon_sym_STAR_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_PERCENT_EQ] = ACTIONS(3420),
    [anon_sym_CARET_EQ] = ACTIONS(3420),
    [anon_sym_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_LT_LT_EQ] = ACTIONS(3420),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3420),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_is] = ACTIONS(3172),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1209),
  },
  [775] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_formal_parameters] = STATE(2778),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__type] = STATE(2330),
    [sym_constructor_type] = STATE(2330),
    [sym__primary_type] = STATE(1870),
    [sym_generic_type] = STATE(1870),
    [sym_type_predicate] = STATE(1870),
    [sym_type_query] = STATE(1870),
    [sym_index_type_query] = STATE(1870),
    [sym_lookup_type] = STATE(1870),
    [sym_literal_type] = STATE(1870),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1870),
    [sym_flow_maybe_type] = STATE(1870),
    [sym_parenthesized_type] = STATE(1870),
    [sym_predefined_type] = STATE(1870),
    [sym_object_type] = STATE(1870),
    [sym_type_parameters] = STATE(2735),
    [sym_array_type] = STATE(1870),
    [sym_tuple_type] = STATE(1870),
    [sym_union_type] = STATE(2330),
    [sym_intersection_type] = STATE(2330),
    [sym_function_type] = STATE(2330),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [776] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_formal_parameters] = STATE(2840),
    [sym_nested_type_identifier] = STATE(1231),
    [sym__type] = STATE(1276),
    [sym_constructor_type] = STATE(1276),
    [sym__primary_type] = STATE(1052),
    [sym_generic_type] = STATE(1052),
    [sym_type_predicate] = STATE(1052),
    [sym_type_query] = STATE(1052),
    [sym_index_type_query] = STATE(1052),
    [sym_lookup_type] = STATE(1052),
    [sym_literal_type] = STATE(1052),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1052),
    [sym_flow_maybe_type] = STATE(1052),
    [sym_parenthesized_type] = STATE(1052),
    [sym_predefined_type] = STATE(1052),
    [sym_object_type] = STATE(1052),
    [sym_type_parameters] = STATE(2608),
    [sym_array_type] = STATE(1052),
    [sym_tuple_type] = STATE(1052),
    [sym_union_type] = STATE(1276),
    [sym_intersection_type] = STATE(1276),
    [sym_function_type] = STATE(1276),
    [sym_identifier] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3265),
    [anon_sym_QMARK] = ACTIONS(3267),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [777] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2889),
    [sym_nested_type_identifier] = STATE(463),
    [sym__type] = STATE(422),
    [sym_constructor_type] = STATE(422),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2598),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(422),
    [sym_intersection_type] = STATE(422),
    [sym_function_type] = STATE(422),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_QMARK] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [778] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2889),
    [sym_nested_type_identifier] = STATE(463),
    [sym__type] = STATE(436),
    [sym_constructor_type] = STATE(436),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2598),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(436),
    [sym_intersection_type] = STATE(436),
    [sym_function_type] = STATE(436),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_QMARK] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [779] = {
    [sym_nested_identifier] = STATE(2855),
    [sym_string] = STATE(1572),
    [sym_formal_parameters] = STATE(2930),
    [sym_nested_type_identifier] = STATE(1385),
    [sym__type] = STATE(1514),
    [sym_constructor_type] = STATE(1514),
    [sym__primary_type] = STATE(1571),
    [sym_generic_type] = STATE(1571),
    [sym_type_predicate] = STATE(1571),
    [sym_type_query] = STATE(1571),
    [sym_index_type_query] = STATE(1571),
    [sym_lookup_type] = STATE(1571),
    [sym_literal_type] = STATE(1571),
    [sym__number] = STATE(1572),
    [sym_existential_type] = STATE(1571),
    [sym_flow_maybe_type] = STATE(1571),
    [sym_parenthesized_type] = STATE(1571),
    [sym_predefined_type] = STATE(1571),
    [sym_object_type] = STATE(1571),
    [sym_type_parameters] = STATE(2592),
    [sym_array_type] = STATE(1571),
    [sym_tuple_type] = STATE(1571),
    [sym_union_type] = STATE(1514),
    [sym_intersection_type] = STATE(1514),
    [sym_function_type] = STATE(1514),
    [sym_identifier] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3197),
    [anon_sym_QMARK] = ACTIONS(3199),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3209),
    [sym_this] = ACTIONS(3211),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_keyof] = ACTIONS(3215),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3217),
  },
  [780] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2889),
    [sym_nested_type_identifier] = STATE(463),
    [sym__type] = STATE(472),
    [sym_constructor_type] = STATE(472),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2598),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(472),
    [sym_intersection_type] = STATE(472),
    [sym_function_type] = STATE(472),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_QMARK] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [781] = {
    [sym_nested_identifier] = STATE(2855),
    [sym_string] = STATE(1572),
    [sym_formal_parameters] = STATE(2930),
    [sym_nested_type_identifier] = STATE(1385),
    [sym__type] = STATE(1515),
    [sym_constructor_type] = STATE(1515),
    [sym__primary_type] = STATE(1571),
    [sym_generic_type] = STATE(1571),
    [sym_type_predicate] = STATE(1571),
    [sym_type_query] = STATE(1571),
    [sym_index_type_query] = STATE(1571),
    [sym_lookup_type] = STATE(1571),
    [sym_literal_type] = STATE(1571),
    [sym__number] = STATE(1572),
    [sym_existential_type] = STATE(1571),
    [sym_flow_maybe_type] = STATE(1571),
    [sym_parenthesized_type] = STATE(1571),
    [sym_predefined_type] = STATE(1571),
    [sym_object_type] = STATE(1571),
    [sym_type_parameters] = STATE(2592),
    [sym_array_type] = STATE(1571),
    [sym_tuple_type] = STATE(1571),
    [sym_union_type] = STATE(1515),
    [sym_intersection_type] = STATE(1515),
    [sym_function_type] = STATE(1515),
    [sym_identifier] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3197),
    [anon_sym_QMARK] = ACTIONS(3199),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3209),
    [sym_this] = ACTIONS(3211),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_keyof] = ACTIONS(3215),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3217),
  },
  [782] = {
    [sym_nested_identifier] = STATE(2855),
    [sym_string] = STATE(1572),
    [sym_formal_parameters] = STATE(2930),
    [sym_nested_type_identifier] = STATE(1385),
    [sym__type] = STATE(1516),
    [sym_constructor_type] = STATE(1516),
    [sym__primary_type] = STATE(1571),
    [sym_generic_type] = STATE(1571),
    [sym_type_predicate] = STATE(1571),
    [sym_type_query] = STATE(1571),
    [sym_index_type_query] = STATE(1571),
    [sym_lookup_type] = STATE(1571),
    [sym_literal_type] = STATE(1571),
    [sym__number] = STATE(1572),
    [sym_existential_type] = STATE(1571),
    [sym_flow_maybe_type] = STATE(1571),
    [sym_parenthesized_type] = STATE(1571),
    [sym_predefined_type] = STATE(1571),
    [sym_object_type] = STATE(1571),
    [sym_type_parameters] = STATE(2592),
    [sym_array_type] = STATE(1571),
    [sym_tuple_type] = STATE(1571),
    [sym_union_type] = STATE(1516),
    [sym_intersection_type] = STATE(1516),
    [sym_function_type] = STATE(1516),
    [sym_identifier] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3197),
    [anon_sym_QMARK] = ACTIONS(3199),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3209),
    [sym_this] = ACTIONS(3211),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_keyof] = ACTIONS(3215),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3217),
  },
  [783] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [784] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_PIPE_RBRACE] = ACTIONS(589),
    [sym__automatic_semicolon] = ACTIONS(589),
  },
  [785] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(586),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [786] = {
    [sym_identifier] = ACTIONS(3153),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [787] = {
    [sym_nested_identifier] = STATE(2853),
    [sym_string] = STATE(1375),
    [sym_formal_parameters] = STATE(2911),
    [sym_nested_type_identifier] = STATE(1290),
    [sym__type] = STATE(1470),
    [sym_constructor_type] = STATE(1470),
    [sym__primary_type] = STATE(1372),
    [sym_generic_type] = STATE(1372),
    [sym_type_predicate] = STATE(1372),
    [sym_type_query] = STATE(1372),
    [sym_index_type_query] = STATE(1372),
    [sym_lookup_type] = STATE(1372),
    [sym_literal_type] = STATE(1372),
    [sym__number] = STATE(1375),
    [sym_existential_type] = STATE(1372),
    [sym_flow_maybe_type] = STATE(1372),
    [sym_parenthesized_type] = STATE(1372),
    [sym_predefined_type] = STATE(1372),
    [sym_object_type] = STATE(1372),
    [sym_type_parameters] = STATE(2603),
    [sym_array_type] = STATE(1372),
    [sym_tuple_type] = STATE(1372),
    [sym_union_type] = STATE(1470),
    [sym_intersection_type] = STATE(1470),
    [sym_function_type] = STATE(1470),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_QMARK] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3235),
    [anon_sym_PIPE] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3243),
    [sym_this] = ACTIONS(3245),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_keyof] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
  },
  [788] = {
    [sym_nested_identifier] = STATE(2855),
    [sym_string] = STATE(1572),
    [sym_formal_parameters] = STATE(2930),
    [sym_nested_type_identifier] = STATE(1385),
    [sym__type] = STATE(1545),
    [sym_constructor_type] = STATE(1545),
    [sym__primary_type] = STATE(1571),
    [sym_generic_type] = STATE(1571),
    [sym_type_predicate] = STATE(1571),
    [sym_type_query] = STATE(1571),
    [sym_index_type_query] = STATE(1571),
    [sym_lookup_type] = STATE(1571),
    [sym_literal_type] = STATE(1571),
    [sym__number] = STATE(1572),
    [sym_existential_type] = STATE(1571),
    [sym_flow_maybe_type] = STATE(1571),
    [sym_parenthesized_type] = STATE(1571),
    [sym_predefined_type] = STATE(1571),
    [sym_object_type] = STATE(1571),
    [sym_type_parameters] = STATE(2592),
    [sym_array_type] = STATE(1571),
    [sym_tuple_type] = STATE(1571),
    [sym_union_type] = STATE(1545),
    [sym_intersection_type] = STATE(1545),
    [sym_function_type] = STATE(1545),
    [sym_identifier] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3197),
    [anon_sym_QMARK] = ACTIONS(3199),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3209),
    [sym_this] = ACTIONS(3211),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_keyof] = ACTIONS(3215),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3217),
  },
  [789] = {
    [sym_nested_identifier] = STATE(2855),
    [sym_string] = STATE(1572),
    [sym_formal_parameters] = STATE(2930),
    [sym_nested_type_identifier] = STATE(1385),
    [sym__type] = STATE(1546),
    [sym_constructor_type] = STATE(1546),
    [sym__primary_type] = STATE(1571),
    [sym_generic_type] = STATE(1571),
    [sym_type_predicate] = STATE(1571),
    [sym_type_query] = STATE(1571),
    [sym_index_type_query] = STATE(1571),
    [sym_lookup_type] = STATE(1571),
    [sym_literal_type] = STATE(1571),
    [sym__number] = STATE(1572),
    [sym_existential_type] = STATE(1571),
    [sym_flow_maybe_type] = STATE(1571),
    [sym_parenthesized_type] = STATE(1571),
    [sym_predefined_type] = STATE(1571),
    [sym_object_type] = STATE(1571),
    [sym_type_parameters] = STATE(2592),
    [sym_array_type] = STATE(1571),
    [sym_tuple_type] = STATE(1571),
    [sym_union_type] = STATE(1546),
    [sym_intersection_type] = STATE(1546),
    [sym_function_type] = STATE(1546),
    [sym_identifier] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3197),
    [anon_sym_QMARK] = ACTIONS(3199),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3209),
    [sym_this] = ACTIONS(3211),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_keyof] = ACTIONS(3215),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3217),
  },
  [790] = {
    [sym_nested_identifier] = STATE(2855),
    [sym_string] = STATE(1572),
    [sym_formal_parameters] = STATE(2930),
    [sym_nested_type_identifier] = STATE(1385),
    [sym__type] = STATE(1523),
    [sym_constructor_type] = STATE(1523),
    [sym__primary_type] = STATE(1571),
    [sym_generic_type] = STATE(1571),
    [sym_type_predicate] = STATE(1571),
    [sym_type_query] = STATE(1571),
    [sym_index_type_query] = STATE(1571),
    [sym_lookup_type] = STATE(1571),
    [sym_literal_type] = STATE(1571),
    [sym__number] = STATE(1572),
    [sym_existential_type] = STATE(1571),
    [sym_flow_maybe_type] = STATE(1571),
    [sym_parenthesized_type] = STATE(1571),
    [sym_predefined_type] = STATE(1571),
    [sym_object_type] = STATE(1571),
    [sym_type_parameters] = STATE(2592),
    [sym_array_type] = STATE(1571),
    [sym_tuple_type] = STATE(1571),
    [sym_union_type] = STATE(1523),
    [sym_intersection_type] = STATE(1523),
    [sym_function_type] = STATE(1523),
    [sym_identifier] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3197),
    [anon_sym_QMARK] = ACTIONS(3199),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3209),
    [sym_this] = ACTIONS(3211),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_keyof] = ACTIONS(3215),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3217),
  },
  [791] = {
    [sym_nested_identifier] = STATE(2855),
    [sym_string] = STATE(1572),
    [sym_formal_parameters] = STATE(2930),
    [sym_nested_type_identifier] = STATE(1385),
    [sym__type] = STATE(1524),
    [sym_constructor_type] = STATE(1524),
    [sym__primary_type] = STATE(1571),
    [sym_generic_type] = STATE(1571),
    [sym_type_predicate] = STATE(1571),
    [sym_type_query] = STATE(1571),
    [sym_index_type_query] = STATE(1571),
    [sym_lookup_type] = STATE(1571),
    [sym_literal_type] = STATE(1571),
    [sym__number] = STATE(1572),
    [sym_existential_type] = STATE(1571),
    [sym_flow_maybe_type] = STATE(1571),
    [sym_parenthesized_type] = STATE(1571),
    [sym_predefined_type] = STATE(1571),
    [sym_object_type] = STATE(1571),
    [sym_type_parameters] = STATE(2592),
    [sym_array_type] = STATE(1571),
    [sym_tuple_type] = STATE(1571),
    [sym_union_type] = STATE(1524),
    [sym_intersection_type] = STATE(1524),
    [sym_function_type] = STATE(1524),
    [sym_identifier] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3197),
    [anon_sym_QMARK] = ACTIONS(3199),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3209),
    [sym_this] = ACTIONS(3211),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_keyof] = ACTIONS(3215),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3217),
  },
  [792] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2889),
    [sym_nested_type_identifier] = STATE(463),
    [sym__type] = STATE(473),
    [sym_constructor_type] = STATE(473),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2598),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(473),
    [sym_intersection_type] = STATE(473),
    [sym_function_type] = STATE(473),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_QMARK] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [793] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2087),
    [sym_constructor_type] = STATE(2087),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2087),
    [sym_intersection_type] = STATE(2087),
    [sym_function_type] = STATE(2087),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [794] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2437),
    [sym_constructor_type] = STATE(2437),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2437),
    [sym_intersection_type] = STATE(2437),
    [sym_function_type] = STATE(2437),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [795] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2743),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__type] = STATE(2108),
    [sym_constructor_type] = STATE(2108),
    [sym__primary_type] = STATE(426),
    [sym_generic_type] = STATE(426),
    [sym_type_predicate] = STATE(426),
    [sym_type_query] = STATE(426),
    [sym_index_type_query] = STATE(426),
    [sym_lookup_type] = STATE(426),
    [sym_literal_type] = STATE(426),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(426),
    [sym_flow_maybe_type] = STATE(426),
    [sym_parenthesized_type] = STATE(426),
    [sym_predefined_type] = STATE(426),
    [sym_object_type] = STATE(426),
    [sym_type_parameters] = STATE(2714),
    [sym_array_type] = STATE(426),
    [sym_tuple_type] = STATE(426),
    [sym_union_type] = STATE(2108),
    [sym_intersection_type] = STATE(2108),
    [sym_function_type] = STATE(2108),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3297),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [796] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3325),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(3436),
    [anon_sym_of] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3283),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [797] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(3441),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [798] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3155),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [799] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3307),
    [anon_sym_RBRACE] = ACTIONS(3307),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_SEMI] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [anon_sym_LT] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1057),
    [sym__automatic_semicolon] = ACTIONS(1057),
  },
  [800] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [801] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3325),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3283),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [802] = {
    [sym_type_arguments] = STATE(1561),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3407),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(3413),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3416),
    [anon_sym_EQ_GT] = ACTIONS(3418),
    [anon_sym_PLUS_EQ] = ACTIONS(3420),
    [anon_sym_DASH_EQ] = ACTIONS(3420),
    [anon_sym_STAR_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_PERCENT_EQ] = ACTIONS(3420),
    [anon_sym_CARET_EQ] = ACTIONS(3420),
    [anon_sym_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_LT_LT_EQ] = ACTIONS(3420),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3420),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3445),
  },
  [803] = {
    [sym_type_arguments] = STATE(413),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3155),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(3157),
    [anon_sym_RBRACK] = ACTIONS(3157),
    [anon_sym_LT] = ACTIONS(3160),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3447),
    [anon_sym_EQ_GT] = ACTIONS(3168),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_is] = ACTIONS(3172),
  },
  [804] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [805] = {
    [sym_arguments] = STATE(1424),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3261),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3257),
    [anon_sym_LT_LT] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3257),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_STAR_STAR] = ACTIONS(3257),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [sym__automatic_semicolon] = ACTIONS(3261),
  },
  [806] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_RBRACE] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_of] = ACTIONS(3117),
    [anon_sym_SEMI] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3117),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [sym__automatic_semicolon] = ACTIONS(3117),
  },
  [807] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3325),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3283),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [808] = {
    [sym_type_annotation] = STATE(2551),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3155),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(3449),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3168),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [809] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3325),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3454),
    [anon_sym_EQ_GT] = ACTIONS(3283),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [810] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3333),
    [anon_sym_RBRACE] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_SEMI] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2340),
    [sym__automatic_semicolon] = ACTIONS(2340),
  },
  [811] = {
    [anon_sym_STAR] = ACTIONS(3253),
    [anon_sym_EQ] = ACTIONS(3253),
    [anon_sym_as] = ACTIONS(3255),
    [anon_sym_COMMA] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_in] = ACTIONS(3253),
    [anon_sym_of] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3253),
    [anon_sym_GT] = ACTIONS(3253),
    [anon_sym_SLASH] = ACTIONS(3253),
    [anon_sym_DOT] = ACTIONS(3255),
    [anon_sym_PLUS_EQ] = ACTIONS(3255),
    [anon_sym_DASH_EQ] = ACTIONS(3255),
    [anon_sym_STAR_EQ] = ACTIONS(3255),
    [anon_sym_SLASH_EQ] = ACTIONS(3255),
    [anon_sym_PERCENT_EQ] = ACTIONS(3255),
    [anon_sym_CARET_EQ] = ACTIONS(3255),
    [anon_sym_AMP_EQ] = ACTIONS(3255),
    [anon_sym_PIPE_EQ] = ACTIONS(3255),
    [anon_sym_GT_GT_EQ] = ACTIONS(3255),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3255),
    [anon_sym_LT_LT_EQ] = ACTIONS(3255),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3255),
    [anon_sym_QMARK] = ACTIONS(3255),
    [anon_sym_AMP_AMP] = ACTIONS(3255),
    [anon_sym_PIPE_PIPE] = ACTIONS(3255),
    [anon_sym_GT_GT] = ACTIONS(3253),
    [anon_sym_GT_GT_GT] = ACTIONS(3253),
    [anon_sym_LT_LT] = ACTIONS(3253),
    [anon_sym_AMP] = ACTIONS(3253),
    [anon_sym_CARET] = ACTIONS(3253),
    [anon_sym_PIPE] = ACTIONS(3253),
    [anon_sym_PLUS] = ACTIONS(3253),
    [anon_sym_DASH] = ACTIONS(3253),
    [anon_sym_PERCENT] = ACTIONS(3253),
    [anon_sym_STAR_STAR] = ACTIONS(3253),
    [anon_sym_LT_EQ] = ACTIONS(3255),
    [anon_sym_EQ_EQ] = ACTIONS(3253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3255),
    [anon_sym_BANG_EQ] = ACTIONS(3253),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3255),
    [anon_sym_GT_EQ] = ACTIONS(3255),
    [anon_sym_instanceof] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3253),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym__automatic_semicolon] = ACTIONS(3255),
  },
  [812] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(586),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [813] = {
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2950),
    [anon_sym_as] = ACTIONS(2952),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2952),
    [anon_sym_in] = ACTIONS(2950),
    [anon_sym_of] = ACTIONS(2952),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2950),
    [anon_sym_GT] = ACTIONS(2950),
    [anon_sym_SLASH] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_PLUS_EQ] = ACTIONS(2952),
    [anon_sym_DASH_EQ] = ACTIONS(2952),
    [anon_sym_STAR_EQ] = ACTIONS(2952),
    [anon_sym_SLASH_EQ] = ACTIONS(2952),
    [anon_sym_PERCENT_EQ] = ACTIONS(2952),
    [anon_sym_CARET_EQ] = ACTIONS(2952),
    [anon_sym_AMP_EQ] = ACTIONS(2952),
    [anon_sym_PIPE_EQ] = ACTIONS(2952),
    [anon_sym_GT_GT_EQ] = ACTIONS(2952),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2952),
    [anon_sym_LT_LT_EQ] = ACTIONS(2952),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2952),
    [anon_sym_QMARK] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_PIPE_PIPE] = ACTIONS(2952),
    [anon_sym_GT_GT] = ACTIONS(2950),
    [anon_sym_GT_GT_GT] = ACTIONS(2950),
    [anon_sym_LT_LT] = ACTIONS(2950),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_CARET] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_STAR_STAR] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2952),
    [anon_sym_EQ_EQ] = ACTIONS(2950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2952),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2952),
    [anon_sym_instanceof] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2950),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2952),
    [sym__automatic_semicolon] = ACTIONS(2952),
  },
  [814] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3325),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(3456),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3283),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(3456),
  },
  [815] = {
    [sym_arguments] = STATE(1518),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(493),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(664),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_LBRACE_PIPE] = ACTIONS(501),
  },
  [816] = {
    [sym_arguments] = STATE(1531),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_EQ_GT] = ACTIONS(3418),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3257),
    [anon_sym_LT_LT] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3257),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_STAR_STAR] = ACTIONS(3257),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3261),
  },
  [817] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [818] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3325),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3283),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [819] = {
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2970),
    [anon_sym_as] = ACTIONS(2972),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2972),
    [anon_sym_in] = ACTIONS(2970),
    [anon_sym_of] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2970),
    [anon_sym_GT] = ACTIONS(2970),
    [anon_sym_SLASH] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2972),
    [anon_sym_PLUS_EQ] = ACTIONS(2972),
    [anon_sym_DASH_EQ] = ACTIONS(2972),
    [anon_sym_STAR_EQ] = ACTIONS(2972),
    [anon_sym_SLASH_EQ] = ACTIONS(2972),
    [anon_sym_PERCENT_EQ] = ACTIONS(2972),
    [anon_sym_CARET_EQ] = ACTIONS(2972),
    [anon_sym_AMP_EQ] = ACTIONS(2972),
    [anon_sym_PIPE_EQ] = ACTIONS(2972),
    [anon_sym_GT_GT_EQ] = ACTIONS(2972),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2972),
    [anon_sym_LT_LT_EQ] = ACTIONS(2972),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2972),
    [anon_sym_QMARK] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2970),
    [anon_sym_GT_GT_GT] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_CARET] = ACTIONS(2970),
    [anon_sym_PIPE] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_STAR_STAR] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2972),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2972),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [anon_sym_instanceof] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2972),
    [sym__automatic_semicolon] = ACTIONS(2972),
  },
  [820] = {
    [sym_arguments] = STATE(1037),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3391),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3257),
    [anon_sym_LT_LT] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3257),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_STAR_STAR] = ACTIONS(3257),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_implements] = ACTIONS(3261),
  },
  [821] = {
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_EQ] = ACTIONS(3174),
    [anon_sym_as] = ACTIONS(3176),
    [anon_sym_COMMA] = ACTIONS(3176),
    [anon_sym_RBRACE] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(3176),
    [anon_sym_in] = ACTIONS(3174),
    [anon_sym_of] = ACTIONS(3176),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym_LBRACK] = ACTIONS(3176),
    [anon_sym_LT] = ACTIONS(3174),
    [anon_sym_GT] = ACTIONS(3174),
    [anon_sym_SLASH] = ACTIONS(3174),
    [anon_sym_DOT] = ACTIONS(3176),
    [anon_sym_PLUS_EQ] = ACTIONS(3176),
    [anon_sym_DASH_EQ] = ACTIONS(3176),
    [anon_sym_STAR_EQ] = ACTIONS(3176),
    [anon_sym_SLASH_EQ] = ACTIONS(3176),
    [anon_sym_PERCENT_EQ] = ACTIONS(3176),
    [anon_sym_CARET_EQ] = ACTIONS(3176),
    [anon_sym_AMP_EQ] = ACTIONS(3176),
    [anon_sym_PIPE_EQ] = ACTIONS(3176),
    [anon_sym_GT_GT_EQ] = ACTIONS(3176),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3176),
    [anon_sym_LT_LT_EQ] = ACTIONS(3176),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3176),
    [anon_sym_QMARK] = ACTIONS(3176),
    [anon_sym_AMP_AMP] = ACTIONS(3176),
    [anon_sym_PIPE_PIPE] = ACTIONS(3176),
    [anon_sym_GT_GT] = ACTIONS(3174),
    [anon_sym_GT_GT_GT] = ACTIONS(3174),
    [anon_sym_LT_LT] = ACTIONS(3174),
    [anon_sym_AMP] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3174),
    [anon_sym_PIPE] = ACTIONS(3174),
    [anon_sym_PLUS] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3174),
    [anon_sym_PERCENT] = ACTIONS(3174),
    [anon_sym_STAR_STAR] = ACTIONS(3174),
    [anon_sym_LT_EQ] = ACTIONS(3176),
    [anon_sym_EQ_EQ] = ACTIONS(3174),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3176),
    [anon_sym_BANG_EQ] = ACTIONS(3174),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3176),
    [anon_sym_GT_EQ] = ACTIONS(3176),
    [anon_sym_instanceof] = ACTIONS(3176),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3176),
    [sym__automatic_semicolon] = ACTIONS(3176),
  },
  [822] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3155),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(3460),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3168),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(3460),
  },
  [823] = {
    [sym_arguments] = STATE(1032),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(648),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_implements] = ACTIONS(501),
  },
  [824] = {
    [sym_type_arguments] = STATE(413),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_COMMA] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(3160),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3428),
    [anon_sym_EQ_GT] = ACTIONS(3391),
    [anon_sym_PLUS_EQ] = ACTIONS(3393),
    [anon_sym_DASH_EQ] = ACTIONS(3393),
    [anon_sym_STAR_EQ] = ACTIONS(3393),
    [anon_sym_SLASH_EQ] = ACTIONS(3393),
    [anon_sym_PERCENT_EQ] = ACTIONS(3393),
    [anon_sym_CARET_EQ] = ACTIONS(3393),
    [anon_sym_AMP_EQ] = ACTIONS(3393),
    [anon_sym_PIPE_EQ] = ACTIONS(3393),
    [anon_sym_GT_GT_EQ] = ACTIONS(3393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3393),
    [anon_sym_LT_LT_EQ] = ACTIONS(3393),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3393),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_implements] = ACTIONS(3445),
  },
  [825] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(614),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(586),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(626),
    [anon_sym_PLUS_EQ] = ACTIONS(630),
    [anon_sym_DASH_EQ] = ACTIONS(630),
    [anon_sym_STAR_EQ] = ACTIONS(630),
    [anon_sym_SLASH_EQ] = ACTIONS(630),
    [anon_sym_PERCENT_EQ] = ACTIONS(630),
    [anon_sym_CARET_EQ] = ACTIONS(630),
    [anon_sym_AMP_EQ] = ACTIONS(630),
    [anon_sym_PIPE_EQ] = ACTIONS(630),
    [anon_sym_GT_GT_EQ] = ACTIONS(630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(630),
    [anon_sym_LT_LT_EQ] = ACTIONS(630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(630),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [826] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3155),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(3462),
    [anon_sym_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3168),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [827] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3407),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_EQ_GT] = ACTIONS(3418),
    [anon_sym_PLUS_EQ] = ACTIONS(3420),
    [anon_sym_DASH_EQ] = ACTIONS(3420),
    [anon_sym_STAR_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_PERCENT_EQ] = ACTIONS(3420),
    [anon_sym_CARET_EQ] = ACTIONS(3420),
    [anon_sym_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_LT_LT_EQ] = ACTIONS(3420),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3420),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1209),
  },
  [828] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3407),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3466),
    [anon_sym_EQ_GT] = ACTIONS(3418),
    [anon_sym_PLUS_EQ] = ACTIONS(3420),
    [anon_sym_DASH_EQ] = ACTIONS(3420),
    [anon_sym_STAR_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_PERCENT_EQ] = ACTIONS(3420),
    [anon_sym_CARET_EQ] = ACTIONS(3420),
    [anon_sym_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_LT_LT_EQ] = ACTIONS(3420),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3420),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1209),
  },
  [829] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(664),
    [anon_sym_PLUS_EQ] = ACTIONS(698),
    [anon_sym_DASH_EQ] = ACTIONS(698),
    [anon_sym_STAR_EQ] = ACTIONS(698),
    [anon_sym_SLASH_EQ] = ACTIONS(698),
    [anon_sym_PERCENT_EQ] = ACTIONS(698),
    [anon_sym_CARET_EQ] = ACTIONS(698),
    [anon_sym_AMP_EQ] = ACTIONS(698),
    [anon_sym_PIPE_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_LT_LT_EQ] = ACTIONS(698),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(698),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [830] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3325),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [831] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3325),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(3436),
    [anon_sym_of] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [832] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3381),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_EQ_GT] = ACTIONS(3385),
    [anon_sym_PLUS_EQ] = ACTIONS(3387),
    [anon_sym_DASH_EQ] = ACTIONS(3387),
    [anon_sym_STAR_EQ] = ACTIONS(3387),
    [anon_sym_SLASH_EQ] = ACTIONS(3387),
    [anon_sym_PERCENT_EQ] = ACTIONS(3387),
    [anon_sym_CARET_EQ] = ACTIONS(3387),
    [anon_sym_AMP_EQ] = ACTIONS(3387),
    [anon_sym_PIPE_EQ] = ACTIONS(3387),
    [anon_sym_GT_GT_EQ] = ACTIONS(3387),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3387),
    [anon_sym_LT_LT_EQ] = ACTIONS(3387),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [833] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3395),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3398),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(3398),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(3398),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3168),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(3398),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [834] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(648),
    [anon_sym_PLUS_EQ] = ACTIONS(742),
    [anon_sym_DASH_EQ] = ACTIONS(742),
    [anon_sym_STAR_EQ] = ACTIONS(742),
    [anon_sym_SLASH_EQ] = ACTIONS(742),
    [anon_sym_PERCENT_EQ] = ACTIONS(742),
    [anon_sym_CARET_EQ] = ACTIONS(742),
    [anon_sym_AMP_EQ] = ACTIONS(742),
    [anon_sym_PIPE_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_LT_EQ] = ACTIONS(742),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_implements] = ACTIONS(453),
  },
  [835] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3395),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3398),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(3398),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(3470),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3168),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(3398),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [836] = {
    [sym_arguments] = STATE(1428),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(626),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym__automatic_semicolon] = ACTIONS(501),
  },
  [837] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(586),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [838] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [839] = {
    [sym_arguments] = STATE(1037),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_RBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3257),
    [anon_sym_LT_LT] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3257),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_STAR_STAR] = ACTIONS(3257),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
  },
  [840] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(608),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [841] = {
    [sym_arguments] = STATE(1531),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3261),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3257),
    [anon_sym_LT_LT] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3257),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_STAR_STAR] = ACTIONS(3257),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3261),
  },
  [842] = {
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_EQ] = ACTIONS(2950),
    [anon_sym_as] = ACTIONS(3319),
    [anon_sym_COMMA] = ACTIONS(3319),
    [anon_sym_RBRACE] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_in] = ACTIONS(3317),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(3317),
    [anon_sym_GT] = ACTIONS(3317),
    [anon_sym_SLASH] = ACTIONS(3317),
    [anon_sym_DOT] = ACTIONS(3319),
    [anon_sym_PLUS_EQ] = ACTIONS(2952),
    [anon_sym_DASH_EQ] = ACTIONS(2952),
    [anon_sym_STAR_EQ] = ACTIONS(2952),
    [anon_sym_SLASH_EQ] = ACTIONS(2952),
    [anon_sym_PERCENT_EQ] = ACTIONS(2952),
    [anon_sym_CARET_EQ] = ACTIONS(2952),
    [anon_sym_AMP_EQ] = ACTIONS(2952),
    [anon_sym_PIPE_EQ] = ACTIONS(2952),
    [anon_sym_GT_GT_EQ] = ACTIONS(2952),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2952),
    [anon_sym_LT_LT_EQ] = ACTIONS(2952),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2952),
    [anon_sym_QMARK] = ACTIONS(3319),
    [anon_sym_AMP_AMP] = ACTIONS(3319),
    [anon_sym_PIPE_PIPE] = ACTIONS(3319),
    [anon_sym_GT_GT] = ACTIONS(3317),
    [anon_sym_GT_GT_GT] = ACTIONS(3317),
    [anon_sym_LT_LT] = ACTIONS(3317),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3317),
    [anon_sym_PIPE] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_PERCENT] = ACTIONS(3317),
    [anon_sym_STAR_STAR] = ACTIONS(3317),
    [anon_sym_LT_EQ] = ACTIONS(3319),
    [anon_sym_EQ_EQ] = ACTIONS(3317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3319),
    [anon_sym_BANG_EQ] = ACTIONS(3317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3319),
    [anon_sym_GT_EQ] = ACTIONS(3319),
    [anon_sym_instanceof] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [sym__automatic_semicolon] = ACTIONS(3319),
  },
  [843] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3391),
    [anon_sym_PLUS_EQ] = ACTIONS(3393),
    [anon_sym_DASH_EQ] = ACTIONS(3393),
    [anon_sym_STAR_EQ] = ACTIONS(3393),
    [anon_sym_SLASH_EQ] = ACTIONS(3393),
    [anon_sym_PERCENT_EQ] = ACTIONS(3393),
    [anon_sym_CARET_EQ] = ACTIONS(3393),
    [anon_sym_AMP_EQ] = ACTIONS(3393),
    [anon_sym_PIPE_EQ] = ACTIONS(3393),
    [anon_sym_GT_GT_EQ] = ACTIONS(3393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3393),
    [anon_sym_LT_LT_EQ] = ACTIONS(3393),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3393),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_implements] = ACTIONS(1209),
  },
  [844] = {
    [sym_arguments] = STATE(1424),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3385),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3257),
    [anon_sym_LT_LT] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3257),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_STAR_STAR] = ACTIONS(3257),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [sym__automatic_semicolon] = ACTIONS(3261),
  },
  [845] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3432),
    [anon_sym_EQ_GT] = ACTIONS(3391),
    [anon_sym_PLUS_EQ] = ACTIONS(3393),
    [anon_sym_DASH_EQ] = ACTIONS(3393),
    [anon_sym_STAR_EQ] = ACTIONS(3393),
    [anon_sym_SLASH_EQ] = ACTIONS(3393),
    [anon_sym_PERCENT_EQ] = ACTIONS(3393),
    [anon_sym_CARET_EQ] = ACTIONS(3393),
    [anon_sym_AMP_EQ] = ACTIONS(3393),
    [anon_sym_PIPE_EQ] = ACTIONS(3393),
    [anon_sym_GT_GT_EQ] = ACTIONS(3393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3393),
    [anon_sym_LT_LT_EQ] = ACTIONS(3393),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3393),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_implements] = ACTIONS(1209),
  },
  [846] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [847] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3333),
    [anon_sym_RBRACE] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_SEMI] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3336),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [sym__automatic_semicolon] = ACTIONS(3117),
  },
  [848] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3307),
    [anon_sym_RBRACE] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_SEMI] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [anon_sym_LT] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3310),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [sym__automatic_semicolon] = ACTIONS(3117),
  },
  [849] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(586),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(648),
    [anon_sym_PLUS_EQ] = ACTIONS(742),
    [anon_sym_DASH_EQ] = ACTIONS(742),
    [anon_sym_STAR_EQ] = ACTIONS(742),
    [anon_sym_SLASH_EQ] = ACTIONS(742),
    [anon_sym_PERCENT_EQ] = ACTIONS(742),
    [anon_sym_CARET_EQ] = ACTIONS(742),
    [anon_sym_AMP_EQ] = ACTIONS(742),
    [anon_sym_PIPE_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_LT_EQ] = ACTIONS(742),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_implements] = ACTIONS(453),
  },
  [850] = {
    [sym_arguments] = STATE(1032),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_COLON] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
  },
  [851] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(650),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [852] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(586),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(664),
    [anon_sym_PLUS_EQ] = ACTIONS(698),
    [anon_sym_DASH_EQ] = ACTIONS(698),
    [anon_sym_STAR_EQ] = ACTIONS(698),
    [anon_sym_SLASH_EQ] = ACTIONS(698),
    [anon_sym_PERCENT_EQ] = ACTIONS(698),
    [anon_sym_CARET_EQ] = ACTIONS(698),
    [anon_sym_AMP_EQ] = ACTIONS(698),
    [anon_sym_PIPE_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_LT_LT_EQ] = ACTIONS(698),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(698),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [853] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [854] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3155),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3474),
    [anon_sym_EQ_GT] = ACTIONS(3168),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [855] = {
    [anon_sym_STAR] = ACTIONS(3253),
    [anon_sym_EQ] = ACTIONS(3253),
    [anon_sym_as] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_COMMA] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_in] = ACTIONS(3253),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3253),
    [anon_sym_GT] = ACTIONS(3253),
    [anon_sym_SLASH] = ACTIONS(3253),
    [anon_sym_DOT] = ACTIONS(3255),
    [anon_sym_PLUS_EQ] = ACTIONS(3255),
    [anon_sym_DASH_EQ] = ACTIONS(3255),
    [anon_sym_STAR_EQ] = ACTIONS(3255),
    [anon_sym_SLASH_EQ] = ACTIONS(3255),
    [anon_sym_PERCENT_EQ] = ACTIONS(3255),
    [anon_sym_CARET_EQ] = ACTIONS(3255),
    [anon_sym_AMP_EQ] = ACTIONS(3255),
    [anon_sym_PIPE_EQ] = ACTIONS(3255),
    [anon_sym_GT_GT_EQ] = ACTIONS(3255),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3255),
    [anon_sym_LT_LT_EQ] = ACTIONS(3255),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3255),
    [anon_sym_QMARK] = ACTIONS(3255),
    [anon_sym_AMP_AMP] = ACTIONS(3255),
    [anon_sym_PIPE_PIPE] = ACTIONS(3255),
    [anon_sym_GT_GT] = ACTIONS(3253),
    [anon_sym_GT_GT_GT] = ACTIONS(3253),
    [anon_sym_LT_LT] = ACTIONS(3253),
    [anon_sym_AMP] = ACTIONS(3253),
    [anon_sym_CARET] = ACTIONS(3253),
    [anon_sym_PIPE] = ACTIONS(3253),
    [anon_sym_PLUS] = ACTIONS(3253),
    [anon_sym_DASH] = ACTIONS(3253),
    [anon_sym_PERCENT] = ACTIONS(3253),
    [anon_sym_STAR_STAR] = ACTIONS(3253),
    [anon_sym_LT_EQ] = ACTIONS(3255),
    [anon_sym_EQ_EQ] = ACTIONS(3253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3255),
    [anon_sym_BANG_EQ] = ACTIONS(3253),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3255),
    [anon_sym_GT_EQ] = ACTIONS(3255),
    [anon_sym_instanceof] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3253),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3255),
  },
  [856] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(614),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(626),
    [anon_sym_PLUS_EQ] = ACTIONS(630),
    [anon_sym_DASH_EQ] = ACTIONS(630),
    [anon_sym_STAR_EQ] = ACTIONS(630),
    [anon_sym_SLASH_EQ] = ACTIONS(630),
    [anon_sym_PERCENT_EQ] = ACTIONS(630),
    [anon_sym_CARET_EQ] = ACTIONS(630),
    [anon_sym_AMP_EQ] = ACTIONS(630),
    [anon_sym_PIPE_EQ] = ACTIONS(630),
    [anon_sym_GT_GT_EQ] = ACTIONS(630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(630),
    [anon_sym_LT_LT_EQ] = ACTIONS(630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(630),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [857] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [858] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [anon_sym_RBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3310),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
  },
  [859] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_SEMI] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [anon_sym_LT] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3310),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [sym__automatic_semicolon] = ACTIONS(3117),
  },
  [860] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3407),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(3420),
    [anon_sym_DASH_EQ] = ACTIONS(3420),
    [anon_sym_STAR_EQ] = ACTIONS(3420),
    [anon_sym_SLASH_EQ] = ACTIONS(3420),
    [anon_sym_PERCENT_EQ] = ACTIONS(3420),
    [anon_sym_CARET_EQ] = ACTIONS(3420),
    [anon_sym_AMP_EQ] = ACTIONS(3420),
    [anon_sym_PIPE_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3420),
    [anon_sym_LT_LT_EQ] = ACTIONS(3420),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3420),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1209),
  },
  [861] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [862] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(3393),
    [anon_sym_DASH_EQ] = ACTIONS(3393),
    [anon_sym_STAR_EQ] = ACTIONS(3393),
    [anon_sym_SLASH_EQ] = ACTIONS(3393),
    [anon_sym_PERCENT_EQ] = ACTIONS(3393),
    [anon_sym_CARET_EQ] = ACTIONS(3393),
    [anon_sym_AMP_EQ] = ACTIONS(3393),
    [anon_sym_PIPE_EQ] = ACTIONS(3393),
    [anon_sym_GT_GT_EQ] = ACTIONS(3393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3393),
    [anon_sym_LT_LT_EQ] = ACTIONS(3393),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3393),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_implements] = ACTIONS(1209),
  },
  [863] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [864] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_RPAREN] = ACTIONS(3307),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [anon_sym_LT] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
  },
  [865] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3333),
  },
  [866] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_RBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3336),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
  },
  [867] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3307),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [anon_sym_LT] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3310),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
  },
  [868] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [869] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3381),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_EQ_GT] = ACTIONS(3385),
    [anon_sym_PLUS_EQ] = ACTIONS(3387),
    [anon_sym_DASH_EQ] = ACTIONS(3387),
    [anon_sym_STAR_EQ] = ACTIONS(3387),
    [anon_sym_SLASH_EQ] = ACTIONS(3387),
    [anon_sym_PERCENT_EQ] = ACTIONS(3387),
    [anon_sym_CARET_EQ] = ACTIONS(3387),
    [anon_sym_AMP_EQ] = ACTIONS(3387),
    [anon_sym_PIPE_EQ] = ACTIONS(3387),
    [anon_sym_GT_GT_EQ] = ACTIONS(3387),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3387),
    [anon_sym_LT_LT_EQ] = ACTIONS(3387),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [870] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3333),
    [anon_sym_COMMA] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [anon_sym_implements] = ACTIONS(3333),
  },
  [871] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_RPAREN] = ACTIONS(3333),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
  },
  [872] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3117),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
  },
  [873] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3155),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_RBRACK] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_EQ_GT] = ACTIONS(3168),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [874] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_SEMI] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3336),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [sym__automatic_semicolon] = ACTIONS(3117),
  },
  [875] = {
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2950),
    [anon_sym_as] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2952),
    [anon_sym_in] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2950),
    [anon_sym_GT] = ACTIONS(2950),
    [anon_sym_SLASH] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_PLUS_EQ] = ACTIONS(2952),
    [anon_sym_DASH_EQ] = ACTIONS(2952),
    [anon_sym_STAR_EQ] = ACTIONS(2952),
    [anon_sym_SLASH_EQ] = ACTIONS(2952),
    [anon_sym_PERCENT_EQ] = ACTIONS(2952),
    [anon_sym_CARET_EQ] = ACTIONS(2952),
    [anon_sym_AMP_EQ] = ACTIONS(2952),
    [anon_sym_PIPE_EQ] = ACTIONS(2952),
    [anon_sym_GT_GT_EQ] = ACTIONS(2952),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2952),
    [anon_sym_LT_LT_EQ] = ACTIONS(2952),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2952),
    [anon_sym_QMARK] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_PIPE_PIPE] = ACTIONS(2952),
    [anon_sym_GT_GT] = ACTIONS(2950),
    [anon_sym_GT_GT_GT] = ACTIONS(2950),
    [anon_sym_LT_LT] = ACTIONS(2950),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_CARET] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_STAR_STAR] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2952),
    [anon_sym_EQ_EQ] = ACTIONS(2950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2952),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2952),
    [anon_sym_instanceof] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2950),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2952),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2952),
  },
  [876] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(3462),
    [anon_sym_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [877] = {
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_EQ] = ACTIONS(3174),
    [anon_sym_as] = ACTIONS(3176),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_COMMA] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(3176),
    [anon_sym_in] = ACTIONS(3174),
    [anon_sym_LBRACK] = ACTIONS(3176),
    [anon_sym_LT] = ACTIONS(3174),
    [anon_sym_GT] = ACTIONS(3174),
    [anon_sym_SLASH] = ACTIONS(3174),
    [anon_sym_DOT] = ACTIONS(3176),
    [anon_sym_PLUS_EQ] = ACTIONS(3176),
    [anon_sym_DASH_EQ] = ACTIONS(3176),
    [anon_sym_STAR_EQ] = ACTIONS(3176),
    [anon_sym_SLASH_EQ] = ACTIONS(3176),
    [anon_sym_PERCENT_EQ] = ACTIONS(3176),
    [anon_sym_CARET_EQ] = ACTIONS(3176),
    [anon_sym_AMP_EQ] = ACTIONS(3176),
    [anon_sym_PIPE_EQ] = ACTIONS(3176),
    [anon_sym_GT_GT_EQ] = ACTIONS(3176),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3176),
    [anon_sym_LT_LT_EQ] = ACTIONS(3176),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3176),
    [anon_sym_QMARK] = ACTIONS(3176),
    [anon_sym_AMP_AMP] = ACTIONS(3176),
    [anon_sym_PIPE_PIPE] = ACTIONS(3176),
    [anon_sym_GT_GT] = ACTIONS(3174),
    [anon_sym_GT_GT_GT] = ACTIONS(3174),
    [anon_sym_LT_LT] = ACTIONS(3174),
    [anon_sym_AMP] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3174),
    [anon_sym_PIPE] = ACTIONS(3174),
    [anon_sym_PLUS] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3174),
    [anon_sym_PERCENT] = ACTIONS(3174),
    [anon_sym_STAR_STAR] = ACTIONS(3174),
    [anon_sym_LT_EQ] = ACTIONS(3176),
    [anon_sym_EQ_EQ] = ACTIONS(3174),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3176),
    [anon_sym_BANG_EQ] = ACTIONS(3174),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3176),
    [anon_sym_GT_EQ] = ACTIONS(3176),
    [anon_sym_instanceof] = ACTIONS(3176),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3176),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3176),
  },
  [878] = {
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_EQ] = ACTIONS(2950),
    [anon_sym_as] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_COMMA] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_in] = ACTIONS(3317),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(3317),
    [anon_sym_GT] = ACTIONS(3317),
    [anon_sym_SLASH] = ACTIONS(3317),
    [anon_sym_DOT] = ACTIONS(3319),
    [anon_sym_PLUS_EQ] = ACTIONS(2952),
    [anon_sym_DASH_EQ] = ACTIONS(2952),
    [anon_sym_STAR_EQ] = ACTIONS(2952),
    [anon_sym_SLASH_EQ] = ACTIONS(2952),
    [anon_sym_PERCENT_EQ] = ACTIONS(2952),
    [anon_sym_CARET_EQ] = ACTIONS(2952),
    [anon_sym_AMP_EQ] = ACTIONS(2952),
    [anon_sym_PIPE_EQ] = ACTIONS(2952),
    [anon_sym_GT_GT_EQ] = ACTIONS(2952),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2952),
    [anon_sym_LT_LT_EQ] = ACTIONS(2952),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2952),
    [anon_sym_QMARK] = ACTIONS(3319),
    [anon_sym_AMP_AMP] = ACTIONS(3319),
    [anon_sym_PIPE_PIPE] = ACTIONS(3319),
    [anon_sym_GT_GT] = ACTIONS(3317),
    [anon_sym_GT_GT_GT] = ACTIONS(3317),
    [anon_sym_LT_LT] = ACTIONS(3317),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3317),
    [anon_sym_PIPE] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_PERCENT] = ACTIONS(3317),
    [anon_sym_STAR_STAR] = ACTIONS(3317),
    [anon_sym_LT_EQ] = ACTIONS(3319),
    [anon_sym_EQ_EQ] = ACTIONS(3317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3319),
    [anon_sym_BANG_EQ] = ACTIONS(3317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3319),
    [anon_sym_GT_EQ] = ACTIONS(3319),
    [anon_sym_instanceof] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3319),
  },
  [879] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3336),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
  },
  [880] = {
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2970),
    [anon_sym_as] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2972),
    [anon_sym_in] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2970),
    [anon_sym_GT] = ACTIONS(2970),
    [anon_sym_SLASH] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2972),
    [anon_sym_PLUS_EQ] = ACTIONS(2972),
    [anon_sym_DASH_EQ] = ACTIONS(2972),
    [anon_sym_STAR_EQ] = ACTIONS(2972),
    [anon_sym_SLASH_EQ] = ACTIONS(2972),
    [anon_sym_PERCENT_EQ] = ACTIONS(2972),
    [anon_sym_CARET_EQ] = ACTIONS(2972),
    [anon_sym_AMP_EQ] = ACTIONS(2972),
    [anon_sym_PIPE_EQ] = ACTIONS(2972),
    [anon_sym_GT_GT_EQ] = ACTIONS(2972),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2972),
    [anon_sym_LT_LT_EQ] = ACTIONS(2972),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2972),
    [anon_sym_QMARK] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2970),
    [anon_sym_GT_GT_GT] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_CARET] = ACTIONS(2970),
    [anon_sym_PIPE] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_STAR_STAR] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2972),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2972),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [anon_sym_instanceof] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
  },
  [881] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [882] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [883] = {
    [sym_export_clause] = STATE(2354),
    [sym__declaration] = STATE(2098),
    [sym_variable_declaration] = STATE(2098),
    [sym_lexical_declaration] = STATE(2098),
    [sym_class_declaration] = STATE(2098),
    [sym_function_declaration] = STATE(2098),
    [sym_generator_function_declaration] = STATE(2098),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(2098),
    [sym_ambient_declaration] = STATE(2098),
    [sym_abstract_class_declaration] = STATE(2098),
    [sym_module] = STATE(2098),
    [sym_internal_module] = STATE(2098),
    [sym_import_alias] = STATE(2098),
    [sym_interface_declaration] = STATE(2098),
    [sym_enum_declaration] = STATE(2098),
    [sym_type_alias_declaration] = STATE(2098),
    [aux_sym_export_statement_repeat1] = STATE(2277),
    [aux_sym_object_repeat1] = STATE(2484),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3482),
    [anon_sym_as] = ACTIONS(3484),
    [anon_sym_namespace] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(3490),
    [anon_sym_import] = ACTIONS(3492),
    [anon_sym_var] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3496),
    [anon_sym_const] = ACTIONS(3498),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_class] = ACTIONS(3500),
    [anon_sym_async] = ACTIONS(3502),
    [anon_sym_function] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3506),
    [anon_sym_declare] = ACTIONS(3508),
    [anon_sym_module] = ACTIONS(3510),
    [anon_sym_interface] = ACTIONS(3512),
    [anon_sym_enum] = ACTIONS(3514),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [884] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(3102),
    [anon_sym_of] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [885] = {
    [sym_export_statement] = STATE(1996),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(1996),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(1996),
    [sym_property_signature] = STATE(1996),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(1996),
    [sym_index_signature] = STATE(1996),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3058),
    [anon_sym_RBRACE] = ACTIONS(3060),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3060),
  },
  [886] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(3436),
    [anon_sym_of] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [887] = {
    [sym_export_clause] = STATE(2354),
    [sym__declaration] = STATE(2098),
    [sym_variable_declaration] = STATE(2098),
    [sym_lexical_declaration] = STATE(2098),
    [sym_class_declaration] = STATE(2098),
    [sym_function_declaration] = STATE(2098),
    [sym_generator_function_declaration] = STATE(2098),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(2098),
    [sym_ambient_declaration] = STATE(2098),
    [sym_abstract_class_declaration] = STATE(2098),
    [sym_module] = STATE(2098),
    [sym_internal_module] = STATE(2098),
    [sym_import_alias] = STATE(2098),
    [sym_interface_declaration] = STATE(2098),
    [sym_enum_declaration] = STATE(2098),
    [sym_type_alias_declaration] = STATE(2098),
    [aux_sym_export_statement_repeat1] = STATE(2277),
    [aux_sym_object_repeat1] = STATE(2399),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3482),
    [anon_sym_as] = ACTIONS(3484),
    [anon_sym_namespace] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(3490),
    [anon_sym_import] = ACTIONS(3492),
    [anon_sym_var] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3496),
    [anon_sym_const] = ACTIONS(3498),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_class] = ACTIONS(3500),
    [anon_sym_async] = ACTIONS(3502),
    [anon_sym_function] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3506),
    [anon_sym_declare] = ACTIONS(3508),
    [anon_sym_module] = ACTIONS(3510),
    [anon_sym_interface] = ACTIONS(3512),
    [anon_sym_enum] = ACTIONS(3514),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [888] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(758),
    [anon_sym_of] = ACTIONS(3536),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [889] = {
    [sym_export_statement] = STATE(2017),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2017),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2017),
    [sym_property_signature] = STATE(2017),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2017),
    [sym_index_signature] = STATE(2017),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3034),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3034),
  },
  [890] = {
    [sym_export_statement] = STATE(1999),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(1999),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(1999),
    [sym_property_signature] = STATE(1999),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(1999),
    [sym_index_signature] = STATE(1999),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3538),
    [anon_sym_RBRACE] = ACTIONS(3540),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3538),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3540),
  },
  [891] = {
    [sym_export_statement] = STATE(1987),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(1987),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(1987),
    [sym_property_signature] = STATE(1987),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(1987),
    [sym_index_signature] = STATE(1987),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3542),
    [anon_sym_RBRACE] = ACTIONS(3544),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3542),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3544),
  },
  [892] = {
    [sym_export_statement] = STATE(2059),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2059),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2059),
    [sym_property_signature] = STATE(2059),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2059),
    [sym_index_signature] = STATE(2059),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_RBRACE] = ACTIONS(3548),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3546),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3548),
  },
  [893] = {
    [sym_export_clause] = STATE(2354),
    [sym__declaration] = STATE(2098),
    [sym_variable_declaration] = STATE(2098),
    [sym_lexical_declaration] = STATE(2098),
    [sym_class_declaration] = STATE(2098),
    [sym_function_declaration] = STATE(2098),
    [sym_generator_function_declaration] = STATE(2098),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(2098),
    [sym_ambient_declaration] = STATE(2098),
    [sym_abstract_class_declaration] = STATE(2098),
    [sym_module] = STATE(2098),
    [sym_internal_module] = STATE(2098),
    [sym_import_alias] = STATE(2098),
    [sym_interface_declaration] = STATE(2098),
    [sym_enum_declaration] = STATE(2098),
    [sym_type_alias_declaration] = STATE(2098),
    [aux_sym_export_statement_repeat1] = STATE(2277),
    [aux_sym_object_repeat1] = STATE(2392),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3482),
    [anon_sym_as] = ACTIONS(3484),
    [anon_sym_namespace] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(3490),
    [anon_sym_import] = ACTIONS(3492),
    [anon_sym_var] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3496),
    [anon_sym_const] = ACTIONS(3498),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_class] = ACTIONS(3500),
    [anon_sym_async] = ACTIONS(3502),
    [anon_sym_function] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3506),
    [anon_sym_declare] = ACTIONS(3508),
    [anon_sym_module] = ACTIONS(3510),
    [anon_sym_interface] = ACTIONS(3512),
    [anon_sym_enum] = ACTIONS(3514),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [894] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_RBRACK] = ACTIONS(3333),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
  },
  [895] = {
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3307),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [anon_sym_RBRACK] = ACTIONS(3307),
    [anon_sym_LT] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3117),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_PIPE_PIPE] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3115),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
  },
  [896] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3381),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(3387),
    [anon_sym_DASH_EQ] = ACTIONS(3387),
    [anon_sym_STAR_EQ] = ACTIONS(3387),
    [anon_sym_SLASH_EQ] = ACTIONS(3387),
    [anon_sym_PERCENT_EQ] = ACTIONS(3387),
    [anon_sym_CARET_EQ] = ACTIONS(3387),
    [anon_sym_AMP_EQ] = ACTIONS(3387),
    [anon_sym_PIPE_EQ] = ACTIONS(3387),
    [anon_sym_GT_GT_EQ] = ACTIONS(3387),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3387),
    [anon_sym_LT_LT_EQ] = ACTIONS(3387),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [897] = {
    [sym_export_clause] = STATE(2354),
    [sym__declaration] = STATE(2098),
    [sym_variable_declaration] = STATE(2098),
    [sym_lexical_declaration] = STATE(2098),
    [sym_class_declaration] = STATE(2098),
    [sym_function_declaration] = STATE(2098),
    [sym_generator_function_declaration] = STATE(2098),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(2098),
    [sym_ambient_declaration] = STATE(2098),
    [sym_abstract_class_declaration] = STATE(2098),
    [sym_module] = STATE(2098),
    [sym_internal_module] = STATE(2098),
    [sym_import_alias] = STATE(2098),
    [sym_interface_declaration] = STATE(2098),
    [sym_enum_declaration] = STATE(2098),
    [sym_type_alias_declaration] = STATE(2098),
    [aux_sym_export_statement_repeat1] = STATE(2277),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3550),
    [anon_sym_as] = ACTIONS(3484),
    [anon_sym_namespace] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(3490),
    [anon_sym_import] = ACTIONS(3492),
    [anon_sym_var] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3496),
    [anon_sym_const] = ACTIONS(3498),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_class] = ACTIONS(3500),
    [anon_sym_async] = ACTIONS(3502),
    [anon_sym_function] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3506),
    [anon_sym_declare] = ACTIONS(3508),
    [anon_sym_module] = ACTIONS(3510),
    [anon_sym_interface] = ACTIONS(3512),
    [anon_sym_enum] = ACTIONS(3514),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [898] = {
    [sym_export_clause] = STATE(2354),
    [sym__declaration] = STATE(2098),
    [sym_variable_declaration] = STATE(2098),
    [sym_lexical_declaration] = STATE(2098),
    [sym_class_declaration] = STATE(2098),
    [sym_function_declaration] = STATE(2098),
    [sym_generator_function_declaration] = STATE(2098),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(2098),
    [sym_ambient_declaration] = STATE(2098),
    [sym_abstract_class_declaration] = STATE(2098),
    [sym_module] = STATE(2098),
    [sym_internal_module] = STATE(2098),
    [sym_import_alias] = STATE(2098),
    [sym_interface_declaration] = STATE(2098),
    [sym_enum_declaration] = STATE(2098),
    [sym_type_alias_declaration] = STATE(2098),
    [aux_sym_export_statement_repeat1] = STATE(2277),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3482),
    [anon_sym_as] = ACTIONS(3484),
    [anon_sym_namespace] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(3552),
    [anon_sym_RBRACE] = ACTIONS(3552),
    [anon_sym_type] = ACTIONS(3490),
    [anon_sym_import] = ACTIONS(3492),
    [anon_sym_var] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3496),
    [anon_sym_const] = ACTIONS(3498),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_class] = ACTIONS(3500),
    [anon_sym_async] = ACTIONS(3502),
    [anon_sym_function] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3506),
    [anon_sym_declare] = ACTIONS(3508),
    [anon_sym_module] = ACTIONS(3510),
    [anon_sym_interface] = ACTIONS(3512),
    [anon_sym_enum] = ACTIONS(3514),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [899] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(3102),
    [anon_sym_of] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [900] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(3436),
    [anon_sym_of] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [901] = {
    [sym_import_clause] = STATE(2649),
    [sym_namespace_import] = STATE(2812),
    [sym_named_imports] = STATE(2812),
    [sym_string] = STATE(2650),
    [sym_import_require_clause] = STATE(2650),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_STAR] = ACTIONS(3557),
    [anon_sym_as] = ACTIONS(3559),
    [anon_sym_LBRACE] = ACTIONS(3561),
    [anon_sym_COMMA] = ACTIONS(3563),
    [anon_sym_type] = ACTIONS(3565),
    [anon_sym_typeof] = ACTIONS(3565),
    [anon_sym_LPAREN] = ACTIONS(3563),
    [anon_sym_in] = ACTIONS(3559),
    [anon_sym_SEMI] = ACTIONS(3563),
    [anon_sym_LBRACK] = ACTIONS(3563),
    [anon_sym_LT] = ACTIONS(3559),
    [anon_sym_GT] = ACTIONS(3559),
    [anon_sym_SLASH] = ACTIONS(3559),
    [anon_sym_DOT] = ACTIONS(3563),
    [anon_sym_QMARK] = ACTIONS(3563),
    [anon_sym_AMP_AMP] = ACTIONS(3563),
    [anon_sym_PIPE_PIPE] = ACTIONS(3563),
    [anon_sym_GT_GT] = ACTIONS(3559),
    [anon_sym_GT_GT_GT] = ACTIONS(3563),
    [anon_sym_LT_LT] = ACTIONS(3563),
    [anon_sym_AMP] = ACTIONS(3559),
    [anon_sym_CARET] = ACTIONS(3563),
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_PERCENT] = ACTIONS(3563),
    [anon_sym_STAR_STAR] = ACTIONS(3563),
    [anon_sym_LT_EQ] = ACTIONS(3563),
    [anon_sym_EQ_EQ] = ACTIONS(3559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3563),
    [anon_sym_BANG_EQ] = ACTIONS(3559),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3563),
    [anon_sym_GT_EQ] = ACTIONS(3563),
    [anon_sym_instanceof] = ACTIONS(3559),
    [anon_sym_BANG] = ACTIONS(3559),
    [anon_sym_PLUS_PLUS] = ACTIONS(3563),
    [anon_sym_DASH_DASH] = ACTIONS(3563),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3563),
    [sym__automatic_semicolon] = ACTIONS(3563),
  },
  [902] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3567),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3567),
  },
  [903] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3569),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3569),
  },
  [904] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3571),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3571),
  },
  [905] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3573),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3573),
  },
  [906] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3575),
  },
  [907] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3577),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3577),
  },
  [908] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3579),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3579),
  },
  [909] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3581),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3581),
  },
  [910] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3583),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3583),
  },
  [911] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3585),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3585),
  },
  [912] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3587),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3587),
  },
  [913] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3589),
  },
  [914] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3591),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3591),
  },
  [915] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3593),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3593),
  },
  [916] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3595),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3595),
  },
  [917] = {
    [sym_export_statement] = STATE(2031),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2031),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2031),
    [sym_property_signature] = STATE(2031),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2031),
    [sym_index_signature] = STATE(2031),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
  },
  [918] = {
    [sym_export_statement] = STATE(2155),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2155),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2155),
    [sym_property_signature] = STATE(2155),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2155),
    [sym_index_signature] = STATE(2155),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
  },
  [919] = {
    [sym_export_statement] = STATE(2016),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2016),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2016),
    [sym_property_signature] = STATE(2016),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2016),
    [sym_index_signature] = STATE(2016),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
  },
  [920] = {
    [sym_export_statement] = STATE(2071),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2071),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2071),
    [sym_property_signature] = STATE(2071),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2071),
    [sym_index_signature] = STATE(2071),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
  },
  [921] = {
    [sym_export_statement] = STATE(2025),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2025),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2025),
    [sym_property_signature] = STATE(2025),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2025),
    [sym_index_signature] = STATE(2025),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
  },
  [922] = {
    [sym_export_statement] = STATE(2053),
    [sym__call_signature] = STATE(2116),
    [sym_string] = STATE(1796),
    [sym_decorator] = STATE(1762),
    [sym_formal_parameters] = STATE(1904),
    [sym__property_name] = STATE(1796),
    [sym_computed_property_name] = STATE(1796),
    [sym_method_signature] = STATE(2053),
    [sym_accessibility_modifier] = STATE(1733),
    [sym_call_signature] = STATE(2053),
    [sym_property_signature] = STATE(2053),
    [sym_type_parameters] = STATE(2610),
    [sym_construct_signature] = STATE(2053),
    [sym_index_signature] = STATE(2053),
    [aux_sym_export_statement_repeat1] = STATE(2318),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3518),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(3524),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3528),
    [anon_sym_get] = ACTIONS(3530),
    [anon_sym_set] = ACTIONS(3530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(3534),
  },
  [923] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3597),
    [anon_sym_as] = ACTIONS(3599),
    [anon_sym_LBRACE] = ACTIONS(3599),
    [anon_sym_COMMA] = ACTIONS(3599),
    [anon_sym_RBRACE] = ACTIONS(3599),
    [anon_sym_LPAREN] = ACTIONS(3599),
    [anon_sym_RPAREN] = ACTIONS(3599),
    [anon_sym_in] = ACTIONS(3597),
    [anon_sym_COLON] = ACTIONS(3599),
    [anon_sym_LBRACK] = ACTIONS(3599),
    [anon_sym_RBRACK] = ACTIONS(3599),
    [anon_sym_LT] = ACTIONS(3597),
    [anon_sym_GT] = ACTIONS(3597),
    [anon_sym_SLASH] = ACTIONS(3597),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_QMARK] = ACTIONS(3599),
    [anon_sym_AMP_AMP] = ACTIONS(3599),
    [anon_sym_PIPE_PIPE] = ACTIONS(3599),
    [anon_sym_GT_GT] = ACTIONS(3597),
    [anon_sym_GT_GT_GT] = ACTIONS(3599),
    [anon_sym_LT_LT] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym_CARET] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(3597),
    [anon_sym_PLUS] = ACTIONS(3597),
    [anon_sym_DASH] = ACTIONS(3597),
    [anon_sym_PERCENT] = ACTIONS(3599),
    [anon_sym_STAR_STAR] = ACTIONS(3599),
    [anon_sym_LT_EQ] = ACTIONS(3599),
    [anon_sym_EQ_EQ] = ACTIONS(3597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3599),
    [anon_sym_BANG_EQ] = ACTIONS(3597),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3599),
    [anon_sym_GT_EQ] = ACTIONS(3599),
    [anon_sym_instanceof] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3597),
    [anon_sym_PLUS_PLUS] = ACTIONS(3599),
    [anon_sym_DASH_DASH] = ACTIONS(3599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3599),
    [anon_sym_implements] = ACTIONS(3599),
  },
  [924] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(3601),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(1209),
  },
  [925] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(3601),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(1209),
  },
  [926] = {
    [anon_sym_STAR] = ACTIONS(1113),
    [anon_sym_EQ] = ACTIONS(1113),
    [anon_sym_as] = ACTIONS(1111),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_COMMA] = ACTIONS(1111),
    [anon_sym_RBRACE] = ACTIONS(1111),
    [anon_sym_else] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_RPAREN] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1111),
    [anon_sym_COLON] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_RBRACK] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1113),
    [anon_sym_GT] = ACTIONS(1113),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_QMARK] = ACTIONS(1111),
    [anon_sym_AMP_AMP] = ACTIONS(1111),
    [anon_sym_PIPE_PIPE] = ACTIONS(1111),
    [anon_sym_GT_GT] = ACTIONS(1113),
    [anon_sym_GT_GT_GT] = ACTIONS(1111),
    [anon_sym_LT_LT] = ACTIONS(1111),
    [anon_sym_AMP] = ACTIONS(1113),
    [anon_sym_CARET] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1113),
    [anon_sym_PLUS] = ACTIONS(1113),
    [anon_sym_DASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1111),
    [anon_sym_STAR_STAR] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_EQ_EQ] = ACTIONS(1113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ] = ACTIONS(1113),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1111),
    [anon_sym_instanceof] = ACTIONS(1111),
    [anon_sym_BANG] = ACTIONS(1113),
    [anon_sym_PLUS_PLUS] = ACTIONS(1111),
    [anon_sym_DASH_DASH] = ACTIONS(1111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [anon_sym_implements] = ACTIONS(1111),
  },
  [927] = {
    [anon_sym_export] = ACTIONS(3605),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_as] = ACTIONS(3605),
    [anon_sym_LBRACE] = ACTIONS(3605),
    [anon_sym_COMMA] = ACTIONS(3605),
    [anon_sym_RBRACE] = ACTIONS(3605),
    [anon_sym_LPAREN] = ACTIONS(3605),
    [anon_sym_RPAREN] = ACTIONS(3605),
    [anon_sym_in] = ACTIONS(3607),
    [anon_sym_COLON] = ACTIONS(3605),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_RBRACK] = ACTIONS(3605),
    [anon_sym_LT] = ACTIONS(3607),
    [anon_sym_GT] = ACTIONS(3607),
    [anon_sym_SLASH] = ACTIONS(3607),
    [anon_sym_DOT] = ACTIONS(3605),
    [anon_sym_class] = ACTIONS(3605),
    [anon_sym_QMARK] = ACTIONS(3605),
    [anon_sym_AMP_AMP] = ACTIONS(3605),
    [anon_sym_PIPE_PIPE] = ACTIONS(3605),
    [anon_sym_GT_GT] = ACTIONS(3607),
    [anon_sym_GT_GT_GT] = ACTIONS(3605),
    [anon_sym_LT_LT] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_CARET] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PERCENT] = ACTIONS(3605),
    [anon_sym_STAR_STAR] = ACTIONS(3605),
    [anon_sym_LT_EQ] = ACTIONS(3605),
    [anon_sym_EQ_EQ] = ACTIONS(3607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3605),
    [anon_sym_BANG_EQ] = ACTIONS(3607),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3605),
    [anon_sym_GT_EQ] = ACTIONS(3605),
    [anon_sym_instanceof] = ACTIONS(3605),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3605),
    [anon_sym_AT] = ACTIONS(3605),
    [anon_sym_implements] = ACTIONS(3605),
  },
  [928] = {
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1097),
    [anon_sym_COMMA] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1097),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_RPAREN] = ACTIONS(1097),
    [anon_sym_in] = ACTIONS(1099),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_COLON] = ACTIONS(1097),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [anon_sym_RBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(1099),
    [anon_sym_DOT] = ACTIONS(1097),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_GT_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_PERCENT] = ACTIONS(1097),
    [anon_sym_STAR_STAR] = ACTIONS(1097),
    [anon_sym_LT_EQ] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1097),
    [anon_sym_BANG_EQ] = ACTIONS(1099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1097),
    [anon_sym_instanceof] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_implements] = ACTIONS(1097),
  },
  [929] = {
    [anon_sym_export] = ACTIONS(3609),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_as] = ACTIONS(3609),
    [anon_sym_LBRACE] = ACTIONS(3609),
    [anon_sym_COMMA] = ACTIONS(3609),
    [anon_sym_RBRACE] = ACTIONS(3609),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [anon_sym_RPAREN] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3611),
    [anon_sym_COLON] = ACTIONS(3609),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_RBRACK] = ACTIONS(3609),
    [anon_sym_LT] = ACTIONS(3611),
    [anon_sym_GT] = ACTIONS(3611),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_DOT] = ACTIONS(3609),
    [anon_sym_class] = ACTIONS(3609),
    [anon_sym_QMARK] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_PIPE_PIPE] = ACTIONS(3609),
    [anon_sym_GT_GT] = ACTIONS(3611),
    [anon_sym_GT_GT_GT] = ACTIONS(3609),
    [anon_sym_LT_LT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_CARET] = ACTIONS(3609),
    [anon_sym_PIPE] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3609),
    [anon_sym_STAR_STAR] = ACTIONS(3609),
    [anon_sym_LT_EQ] = ACTIONS(3609),
    [anon_sym_EQ_EQ] = ACTIONS(3611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3609),
    [anon_sym_BANG_EQ] = ACTIONS(3611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3609),
    [anon_sym_GT_EQ] = ACTIONS(3609),
    [anon_sym_instanceof] = ACTIONS(3609),
    [anon_sym_BANG] = ACTIONS(3611),
    [anon_sym_PLUS_PLUS] = ACTIONS(3609),
    [anon_sym_DASH_DASH] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3609),
    [anon_sym_AT] = ACTIONS(3609),
    [anon_sym_implements] = ACTIONS(3609),
  },
  [930] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1038),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_RPAREN] = ACTIONS(3261),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_RBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_implements] = ACTIONS(3261),
  },
  [931] = {
    [anon_sym_export] = ACTIONS(3319),
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_as] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3319),
    [anon_sym_COMMA] = ACTIONS(3319),
    [anon_sym_RBRACE] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3319),
    [anon_sym_in] = ACTIONS(3317),
    [anon_sym_COLON] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_RBRACK] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(3317),
    [anon_sym_GT] = ACTIONS(3317),
    [anon_sym_SLASH] = ACTIONS(3317),
    [anon_sym_DOT] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_QMARK] = ACTIONS(3319),
    [anon_sym_AMP_AMP] = ACTIONS(3319),
    [anon_sym_PIPE_PIPE] = ACTIONS(3319),
    [anon_sym_GT_GT] = ACTIONS(3317),
    [anon_sym_GT_GT_GT] = ACTIONS(3319),
    [anon_sym_LT_LT] = ACTIONS(3319),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3319),
    [anon_sym_PIPE] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_PERCENT] = ACTIONS(3319),
    [anon_sym_STAR_STAR] = ACTIONS(3319),
    [anon_sym_LT_EQ] = ACTIONS(3319),
    [anon_sym_EQ_EQ] = ACTIONS(3317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3319),
    [anon_sym_BANG_EQ] = ACTIONS(3317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3319),
    [anon_sym_GT_EQ] = ACTIONS(3319),
    [anon_sym_instanceof] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [anon_sym_AT] = ACTIONS(3319),
    [anon_sym_implements] = ACTIONS(3319),
  },
  [932] = {
    [sym_arguments] = STATE(1037),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3613),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3261),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_RBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_implements] = ACTIONS(3261),
  },
  [933] = {
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_EQ] = ACTIONS(3615),
    [anon_sym_as] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_in] = ACTIONS(3615),
    [anon_sym_of] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3615),
    [anon_sym_GT] = ACTIONS(3615),
    [anon_sym_SLASH] = ACTIONS(3615),
    [anon_sym_DOT] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3615),
    [anon_sym_GT_GT_GT] = ACTIONS(3617),
    [anon_sym_LT_LT] = ACTIONS(3617),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_CARET] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_PERCENT] = ACTIONS(3617),
    [anon_sym_STAR_STAR] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ_EQ] = ACTIONS(3615),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3617),
    [anon_sym_BANG_EQ] = ACTIONS(3615),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_instanceof] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3617),
    [anon_sym_implements] = ACTIONS(3617),
  },
  [934] = {
    [anon_sym_STAR] = ACTIONS(1113),
    [anon_sym_as] = ACTIONS(1111),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_COMMA] = ACTIONS(1111),
    [anon_sym_RBRACE] = ACTIONS(1111),
    [anon_sym_else] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1111),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_COLON] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1113),
    [anon_sym_GT] = ACTIONS(1113),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_QMARK] = ACTIONS(1111),
    [anon_sym_AMP_AMP] = ACTIONS(1111),
    [anon_sym_PIPE_PIPE] = ACTIONS(1111),
    [anon_sym_GT_GT] = ACTIONS(1113),
    [anon_sym_GT_GT_GT] = ACTIONS(1111),
    [anon_sym_LT_LT] = ACTIONS(1111),
    [anon_sym_AMP] = ACTIONS(1113),
    [anon_sym_CARET] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1113),
    [anon_sym_PLUS] = ACTIONS(1113),
    [anon_sym_DASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1111),
    [anon_sym_STAR_STAR] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_EQ_EQ] = ACTIONS(1113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ] = ACTIONS(1113),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1111),
    [anon_sym_instanceof] = ACTIONS(1111),
    [anon_sym_BANG] = ACTIONS(1113),
    [anon_sym_PLUS_PLUS] = ACTIONS(1111),
    [anon_sym_DASH_DASH] = ACTIONS(1111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1111),
    [sym__automatic_semicolon] = ACTIONS(1111),
  },
  [935] = {
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_EQ] = ACTIONS(3619),
    [anon_sym_as] = ACTIONS(3621),
    [anon_sym_LBRACE] = ACTIONS(3621),
    [anon_sym_COMMA] = ACTIONS(3621),
    [anon_sym_RBRACE] = ACTIONS(3621),
    [anon_sym_LPAREN] = ACTIONS(3621),
    [anon_sym_RPAREN] = ACTIONS(3621),
    [anon_sym_in] = ACTIONS(3619),
    [anon_sym_of] = ACTIONS(3621),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK] = ACTIONS(3621),
    [anon_sym_RBRACK] = ACTIONS(3621),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_SLASH] = ACTIONS(3619),
    [anon_sym_DOT] = ACTIONS(3621),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_PIPE_PIPE] = ACTIONS(3621),
    [anon_sym_GT_GT] = ACTIONS(3619),
    [anon_sym_GT_GT_GT] = ACTIONS(3621),
    [anon_sym_LT_LT] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_CARET] = ACTIONS(3621),
    [anon_sym_PIPE] = ACTIONS(3619),
    [anon_sym_PLUS] = ACTIONS(3619),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_PERCENT] = ACTIONS(3621),
    [anon_sym_STAR_STAR] = ACTIONS(3621),
    [anon_sym_LT_EQ] = ACTIONS(3621),
    [anon_sym_EQ_EQ] = ACTIONS(3619),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3621),
    [anon_sym_BANG_EQ] = ACTIONS(3619),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3621),
    [anon_sym_GT_EQ] = ACTIONS(3621),
    [anon_sym_instanceof] = ACTIONS(3621),
    [anon_sym_BANG] = ACTIONS(3619),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3621),
    [anon_sym_implements] = ACTIONS(3621),
  },
  [936] = {
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1061),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1061),
    [anon_sym_RPAREN] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_COLON] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(1063),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_GT_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_PERCENT] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1061),
    [anon_sym_GT_EQ] = ACTIONS(1061),
    [anon_sym_instanceof] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_implements] = ACTIONS(1061),
    [sym__automatic_semicolon] = ACTIONS(3623),
  },
  [937] = {
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1131),
    [anon_sym_else] = ACTIONS(1131),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_in] = ACTIONS(1133),
    [anon_sym_while] = ACTIONS(1131),
    [anon_sym_COLON] = ACTIONS(1131),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_RBRACK] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1131),
    [anon_sym_QMARK] = ACTIONS(1131),
    [anon_sym_AMP_AMP] = ACTIONS(1131),
    [anon_sym_PIPE_PIPE] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_GT_GT_GT] = ACTIONS(1131),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1131),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_PERCENT] = ACTIONS(1131),
    [anon_sym_STAR_STAR] = ACTIONS(1131),
    [anon_sym_LT_EQ] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1131),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1131),
    [anon_sym_GT_EQ] = ACTIONS(1131),
    [anon_sym_instanceof] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1133),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1131),
  },
  [938] = {
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1097),
    [anon_sym_COMMA] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1097),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_in] = ACTIONS(1099),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_COLON] = ACTIONS(1097),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(1099),
    [anon_sym_DOT] = ACTIONS(1097),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_GT_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_PERCENT] = ACTIONS(1097),
    [anon_sym_STAR_STAR] = ACTIONS(1097),
    [anon_sym_LT_EQ] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1097),
    [anon_sym_BANG_EQ] = ACTIONS(1099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1097),
    [anon_sym_instanceof] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1097),
    [sym__automatic_semicolon] = ACTIONS(1097),
  },
  [939] = {
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_RPAREN] = ACTIONS(1067),
    [anon_sym_in] = ACTIONS(1065),
    [anon_sym_of] = ACTIONS(1067),
    [anon_sym_COLON] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_RBRACK] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1065),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [anon_sym_implements] = ACTIONS(1067),
  },
  [940] = {
    [sym_arguments] = STATE(1037),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3625),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3261),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_RBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_implements] = ACTIONS(3261),
  },
  [941] = {
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_EQ] = ACTIONS(3627),
    [anon_sym_as] = ACTIONS(3629),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_COMMA] = ACTIONS(3629),
    [anon_sym_RBRACE] = ACTIONS(3629),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_RPAREN] = ACTIONS(3629),
    [anon_sym_in] = ACTIONS(3627),
    [anon_sym_of] = ACTIONS(3629),
    [anon_sym_COLON] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_RBRACK] = ACTIONS(3629),
    [anon_sym_LT] = ACTIONS(3627),
    [anon_sym_GT] = ACTIONS(3627),
    [anon_sym_SLASH] = ACTIONS(3627),
    [anon_sym_DOT] = ACTIONS(3629),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_GT_GT] = ACTIONS(3627),
    [anon_sym_GT_GT_GT] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3627),
    [anon_sym_CARET] = ACTIONS(3629),
    [anon_sym_PIPE] = ACTIONS(3627),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_PERCENT] = ACTIONS(3629),
    [anon_sym_STAR_STAR] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ] = ACTIONS(3627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_BANG_EQ] = ACTIONS(3627),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3629),
    [anon_sym_GT_EQ] = ACTIONS(3629),
    [anon_sym_instanceof] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3627),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3629),
    [anon_sym_implements] = ACTIONS(3629),
  },
  [942] = {
    [anon_sym_STAR] = ACTIONS(3631),
    [anon_sym_EQ] = ACTIONS(3631),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_LBRACE] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3633),
    [anon_sym_RBRACE] = ACTIONS(3633),
    [anon_sym_LPAREN] = ACTIONS(3633),
    [anon_sym_RPAREN] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3631),
    [anon_sym_of] = ACTIONS(3633),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_RBRACK] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(3631),
    [anon_sym_GT] = ACTIONS(3631),
    [anon_sym_SLASH] = ACTIONS(3631),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_AMP_AMP] = ACTIONS(3633),
    [anon_sym_PIPE_PIPE] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3631),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3631),
    [anon_sym_PLUS] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3631),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_STAR_STAR] = ACTIONS(3633),
    [anon_sym_LT_EQ] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3631),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3631),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3633),
    [anon_sym_GT_EQ] = ACTIONS(3633),
    [anon_sym_instanceof] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3631),
    [anon_sym_PLUS_PLUS] = ACTIONS(3633),
    [anon_sym_DASH_DASH] = ACTIONS(3633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3633),
    [anon_sym_implements] = ACTIONS(3633),
  },
  [943] = {
    [anon_sym_STAR] = ACTIONS(3635),
    [anon_sym_EQ] = ACTIONS(3635),
    [anon_sym_as] = ACTIONS(3637),
    [anon_sym_LBRACE] = ACTIONS(3637),
    [anon_sym_COMMA] = ACTIONS(3637),
    [anon_sym_RBRACE] = ACTIONS(3637),
    [anon_sym_LPAREN] = ACTIONS(3637),
    [anon_sym_RPAREN] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3635),
    [anon_sym_of] = ACTIONS(3637),
    [anon_sym_COLON] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_RBRACK] = ACTIONS(3637),
    [anon_sym_LT] = ACTIONS(3635),
    [anon_sym_GT] = ACTIONS(3635),
    [anon_sym_SLASH] = ACTIONS(3635),
    [anon_sym_DOT] = ACTIONS(3637),
    [anon_sym_QMARK] = ACTIONS(3637),
    [anon_sym_AMP_AMP] = ACTIONS(3637),
    [anon_sym_PIPE_PIPE] = ACTIONS(3637),
    [anon_sym_GT_GT] = ACTIONS(3635),
    [anon_sym_GT_GT_GT] = ACTIONS(3637),
    [anon_sym_LT_LT] = ACTIONS(3637),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PIPE] = ACTIONS(3635),
    [anon_sym_PLUS] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(3635),
    [anon_sym_PERCENT] = ACTIONS(3637),
    [anon_sym_STAR_STAR] = ACTIONS(3637),
    [anon_sym_LT_EQ] = ACTIONS(3637),
    [anon_sym_EQ_EQ] = ACTIONS(3635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3637),
    [anon_sym_BANG_EQ] = ACTIONS(3635),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3637),
    [anon_sym_GT_EQ] = ACTIONS(3637),
    [anon_sym_instanceof] = ACTIONS(3637),
    [anon_sym_BANG] = ACTIONS(3635),
    [anon_sym_PLUS_PLUS] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3637),
    [anon_sym_implements] = ACTIONS(3637),
  },
  [944] = {
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_EQ] = ACTIONS(3639),
    [anon_sym_as] = ACTIONS(3641),
    [anon_sym_LBRACE] = ACTIONS(3641),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_RBRACE] = ACTIONS(3641),
    [anon_sym_LPAREN] = ACTIONS(3641),
    [anon_sym_RPAREN] = ACTIONS(3641),
    [anon_sym_in] = ACTIONS(3639),
    [anon_sym_of] = ACTIONS(3641),
    [anon_sym_COLON] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_RBRACK] = ACTIONS(3641),
    [anon_sym_LT] = ACTIONS(3639),
    [anon_sym_GT] = ACTIONS(3639),
    [anon_sym_SLASH] = ACTIONS(3639),
    [anon_sym_DOT] = ACTIONS(3641),
    [anon_sym_QMARK] = ACTIONS(3641),
    [anon_sym_AMP_AMP] = ACTIONS(3641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3641),
    [anon_sym_GT_GT] = ACTIONS(3639),
    [anon_sym_GT_GT_GT] = ACTIONS(3641),
    [anon_sym_LT_LT] = ACTIONS(3641),
    [anon_sym_AMP] = ACTIONS(3639),
    [anon_sym_CARET] = ACTIONS(3641),
    [anon_sym_PIPE] = ACTIONS(3639),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_PERCENT] = ACTIONS(3641),
    [anon_sym_STAR_STAR] = ACTIONS(3641),
    [anon_sym_LT_EQ] = ACTIONS(3641),
    [anon_sym_EQ_EQ] = ACTIONS(3639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3641),
    [anon_sym_BANG_EQ] = ACTIONS(3639),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3641),
    [anon_sym_GT_EQ] = ACTIONS(3641),
    [anon_sym_instanceof] = ACTIONS(3641),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_PLUS_PLUS] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3641),
    [anon_sym_implements] = ACTIONS(3641),
  },
  [945] = {
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_EQ] = ACTIONS(3643),
    [anon_sym_as] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3645),
    [anon_sym_COMMA] = ACTIONS(3645),
    [anon_sym_RBRACE] = ACTIONS(3645),
    [anon_sym_LPAREN] = ACTIONS(3645),
    [anon_sym_RPAREN] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3643),
    [anon_sym_of] = ACTIONS(3645),
    [anon_sym_COLON] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_RBRACK] = ACTIONS(3645),
    [anon_sym_LT] = ACTIONS(3643),
    [anon_sym_GT] = ACTIONS(3643),
    [anon_sym_SLASH] = ACTIONS(3643),
    [anon_sym_DOT] = ACTIONS(3645),
    [anon_sym_QMARK] = ACTIONS(3645),
    [anon_sym_AMP_AMP] = ACTIONS(3645),
    [anon_sym_PIPE_PIPE] = ACTIONS(3645),
    [anon_sym_GT_GT] = ACTIONS(3643),
    [anon_sym_GT_GT_GT] = ACTIONS(3645),
    [anon_sym_LT_LT] = ACTIONS(3645),
    [anon_sym_AMP] = ACTIONS(3643),
    [anon_sym_CARET] = ACTIONS(3645),
    [anon_sym_PIPE] = ACTIONS(3643),
    [anon_sym_PLUS] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3643),
    [anon_sym_PERCENT] = ACTIONS(3645),
    [anon_sym_STAR_STAR] = ACTIONS(3645),
    [anon_sym_LT_EQ] = ACTIONS(3645),
    [anon_sym_EQ_EQ] = ACTIONS(3643),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3645),
    [anon_sym_BANG_EQ] = ACTIONS(3643),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3645),
    [anon_sym_GT_EQ] = ACTIONS(3645),
    [anon_sym_instanceof] = ACTIONS(3645),
    [anon_sym_BANG] = ACTIONS(3643),
    [anon_sym_PLUS_PLUS] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3645),
    [anon_sym_implements] = ACTIONS(3645),
  },
  [946] = {
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_as] = ACTIONS(1155),
    [anon_sym_LBRACE] = ACTIONS(1155),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_else] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_in] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1155),
    [anon_sym_COLON] = ACTIONS(1155),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(1157),
    [anon_sym_SLASH] = ACTIONS(1157),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_QMARK] = ACTIONS(1155),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1157),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1155),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_STAR_STAR] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_instanceof] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1155),
    [anon_sym_DASH_DASH] = ACTIONS(1155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1155),
    [anon_sym_implements] = ACTIONS(1155),
  },
  [947] = {
    [sym__initializer] = STATE(2526),
    [sym_type_annotation] = STATE(2072),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3647),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3649),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(3651),
    [anon_sym_of] = ACTIONS(3654),
    [anon_sym_SEMI] = ACTIONS(3649),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(3649),
  },
  [948] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3660),
    [anon_sym_RBRACE] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3660),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3660),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [949] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3688),
    [anon_sym_RBRACE] = ACTIONS(3688),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3688),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3688),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3688),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [950] = {
    [sym_statement_block] = STATE(1055),
    [anon_sym_STAR] = ACTIONS(1073),
    [anon_sym_as] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(3690),
    [anon_sym_COMMA] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_COLON] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_RBRACK] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(1071),
    [anon_sym_QMARK] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_STAR_STAR] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1071),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_instanceof] = ACTIONS(1071),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_implements] = ACTIONS(1071),
  },
  [951] = {
    [sym_statement_block] = STATE(1055),
    [anon_sym_STAR] = ACTIONS(1073),
    [anon_sym_as] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(3690),
    [anon_sym_COMMA] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_COLON] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_RBRACK] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(3692),
    [anon_sym_QMARK] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_STAR_STAR] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1071),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_instanceof] = ACTIONS(1071),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_implements] = ACTIONS(1071),
  },
  [952] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3694),
    [anon_sym_RBRACE] = ACTIONS(3694),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3694),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3694),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3694),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [953] = {
    [sym__initializer] = STATE(2503),
    [sym_type_annotation] = STATE(2082),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3696),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(3700),
    [anon_sym_of] = ACTIONS(3703),
    [anon_sym_SEMI] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(3698),
  },
  [954] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_nested_type_identifier] = STATE(1231),
    [sym__primary_type] = STATE(1078),
    [sym_generic_type] = STATE(1078),
    [sym_type_predicate] = STATE(1078),
    [sym_type_query] = STATE(1078),
    [sym_index_type_query] = STATE(1078),
    [sym_lookup_type] = STATE(1078),
    [sym_literal_type] = STATE(1078),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1078),
    [sym_flow_maybe_type] = STATE(1078),
    [sym_parenthesized_type] = STATE(1078),
    [sym_predefined_type] = STATE(1078),
    [sym_object_type] = STATE(1078),
    [sym_array_type] = STATE(1078),
    [sym_tuple_type] = STATE(1078),
    [sym_identifier] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_QMARK] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3707),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [955] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_annotation] = STATE(2789),
    [sym_type_arguments] = STATE(2282),
    [aux_sym_array_repeat1] = STATE(2373),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [956] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3713),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3713),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3713),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [957] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3715),
    [anon_sym_RBRACE] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [958] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3717),
    [anon_sym_RBRACE] = ACTIONS(3717),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3717),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3717),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3717),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [959] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [960] = {
    [sym_nested_identifier] = STATE(2855),
    [sym_string] = STATE(1572),
    [sym_nested_type_identifier] = STATE(1385),
    [sym__primary_type] = STATE(1565),
    [sym_generic_type] = STATE(1565),
    [sym_type_predicate] = STATE(1565),
    [sym_type_query] = STATE(1565),
    [sym_index_type_query] = STATE(1565),
    [sym_lookup_type] = STATE(1565),
    [sym_literal_type] = STATE(1565),
    [sym__number] = STATE(1572),
    [sym_existential_type] = STATE(1565),
    [sym_flow_maybe_type] = STATE(1565),
    [sym_parenthesized_type] = STATE(1565),
    [sym_predefined_type] = STATE(1565),
    [sym_object_type] = STATE(1565),
    [sym_array_type] = STATE(1565),
    [sym_tuple_type] = STATE(1565),
    [sym_identifier] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_QMARK] = ACTIONS(3199),
    [anon_sym_PLUS] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3209),
    [sym_this] = ACTIONS(3723),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_keyof] = ACTIONS(3215),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3217),
  },
  [961] = {
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_as] = ACTIONS(3609),
    [anon_sym_LBRACE] = ACTIONS(3609),
    [anon_sym_COMMA] = ACTIONS(3609),
    [anon_sym_RBRACE] = ACTIONS(3609),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [anon_sym_RPAREN] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3611),
    [anon_sym_COLON] = ACTIONS(3725),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_RBRACK] = ACTIONS(3609),
    [anon_sym_LT] = ACTIONS(3611),
    [anon_sym_GT] = ACTIONS(3611),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_DOT] = ACTIONS(3609),
    [anon_sym_EQ_GT] = ACTIONS(3725),
    [anon_sym_QMARK] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_PIPE_PIPE] = ACTIONS(3609),
    [anon_sym_GT_GT] = ACTIONS(3611),
    [anon_sym_GT_GT_GT] = ACTIONS(3609),
    [anon_sym_LT_LT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_CARET] = ACTIONS(3609),
    [anon_sym_PIPE] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3609),
    [anon_sym_STAR_STAR] = ACTIONS(3609),
    [anon_sym_LT_EQ] = ACTIONS(3609),
    [anon_sym_EQ_EQ] = ACTIONS(3611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3609),
    [anon_sym_BANG_EQ] = ACTIONS(3611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3609),
    [anon_sym_GT_EQ] = ACTIONS(3609),
    [anon_sym_instanceof] = ACTIONS(3609),
    [anon_sym_BANG] = ACTIONS(3611),
    [anon_sym_PLUS_PLUS] = ACTIONS(3609),
    [anon_sym_DASH_DASH] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3609),
    [anon_sym_implements] = ACTIONS(3609),
  },
  [962] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_RBRACE] = ACTIONS(3727),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3727),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3727),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [963] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3733),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3729),
    [anon_sym_GT_GT_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [964] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3733),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [965] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3738),
    [anon_sym_RBRACE] = ACTIONS(3738),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_RPAREN] = ACTIONS(3738),
    [anon_sym_in] = ACTIONS(3736),
    [anon_sym_COLON] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3738),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_GT] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_GT_GT] = ACTIONS(3736),
    [anon_sym_GT_GT_GT] = ACTIONS(3738),
    [anon_sym_LT_LT] = ACTIONS(3738),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_CARET] = ACTIONS(3738),
    [anon_sym_PIPE] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_STAR_STAR] = ACTIONS(3738),
    [anon_sym_LT_EQ] = ACTIONS(3738),
    [anon_sym_EQ_EQ] = ACTIONS(3736),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3738),
    [anon_sym_GT_EQ] = ACTIONS(3738),
    [anon_sym_instanceof] = ACTIONS(3738),
    [anon_sym_BANG] = ACTIONS(3736),
    [anon_sym_PLUS_PLUS] = ACTIONS(3738),
    [anon_sym_DASH_DASH] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3738),
  },
  [966] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [967] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_RBRACE] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3740),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3740),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [968] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3742),
    [anon_sym_RBRACE] = ACTIONS(3742),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3742),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3742),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [969] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [970] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_string] = STATE(1050),
    [sym_nested_type_identifier] = STATE(1491),
    [sym__primary_type] = STATE(1078),
    [sym_generic_type] = STATE(1078),
    [sym_type_predicate] = STATE(1078),
    [sym_type_query] = STATE(1078),
    [sym_index_type_query] = STATE(1078),
    [sym_lookup_type] = STATE(1078),
    [sym_literal_type] = STATE(1078),
    [sym__number] = STATE(1050),
    [sym_existential_type] = STATE(1078),
    [sym_flow_maybe_type] = STATE(1078),
    [sym_parenthesized_type] = STATE(1078),
    [sym_predefined_type] = STATE(1078),
    [sym_object_type] = STATE(1078),
    [sym_array_type] = STATE(1078),
    [sym_tuple_type] = STATE(1078),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3707),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3151),
  },
  [971] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [972] = {
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_RPAREN] = ACTIONS(1067),
    [anon_sym_in] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_RBRACK] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(2486),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [anon_sym_implements] = ACTIONS(1067),
  },
  [973] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_nested_type_identifier] = STATE(1794),
    [sym__primary_type] = STATE(428),
    [sym_generic_type] = STATE(428),
    [sym_type_predicate] = STATE(428),
    [sym_type_query] = STATE(428),
    [sym_index_type_query] = STATE(428),
    [sym_lookup_type] = STATE(428),
    [sym_literal_type] = STATE(428),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(428),
    [sym_flow_maybe_type] = STATE(428),
    [sym_parenthesized_type] = STATE(428),
    [sym_predefined_type] = STATE(428),
    [sym_object_type] = STATE(428),
    [sym_array_type] = STATE(428),
    [sym_tuple_type] = STATE(428),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3748),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [974] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_RBRACE] = ACTIONS(3752),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3752),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3752),
    [anon_sym_LT] = ACTIONS(3754),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [975] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_string] = STATE(429),
    [sym_nested_type_identifier] = STATE(463),
    [sym__primary_type] = STATE(428),
    [sym_generic_type] = STATE(428),
    [sym_type_predicate] = STATE(428),
    [sym_type_query] = STATE(428),
    [sym_index_type_query] = STATE(428),
    [sym_lookup_type] = STATE(428),
    [sym_literal_type] = STATE(428),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(428),
    [sym_flow_maybe_type] = STATE(428),
    [sym_parenthesized_type] = STATE(428),
    [sym_predefined_type] = STATE(428),
    [sym_object_type] = STATE(428),
    [sym_array_type] = STATE(428),
    [sym_tuple_type] = STATE(428),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(3748),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_keyof] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [976] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_RBRACE] = ACTIONS(3752),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3752),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3752),
    [anon_sym_LT] = ACTIONS(3754),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3750),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [977] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_annotation] = STATE(2789),
    [sym_type_arguments] = STATE(2282),
    [aux_sym_array_repeat1] = STATE(2494),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3757),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [978] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [979] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3761),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3761),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3761),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [980] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3733),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3729),
    [anon_sym_GT_GT_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [981] = {
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_as] = ACTIONS(1061),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1061),
    [anon_sym_RPAREN] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_COLON] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(1063),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_GT_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_PERCENT] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1061),
    [anon_sym_GT_EQ] = ACTIONS(1061),
    [anon_sym_instanceof] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_implements] = ACTIONS(1061),
    [sym__automatic_semicolon] = ACTIONS(3623),
  },
  [982] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_RBRACE] = ACTIONS(3752),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3752),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3752),
    [anon_sym_LT] = ACTIONS(3754),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [983] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3763),
    [anon_sym_RBRACE] = ACTIONS(3763),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3763),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3763),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3763),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [984] = {
    [sym_arguments] = STATE(1037),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3261),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_RBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_implements] = ACTIONS(3261),
  },
  [985] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3765),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3765),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [986] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3767),
    [anon_sym_RBRACE] = ACTIONS(3767),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3767),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [987] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3769),
    [anon_sym_RBRACE] = ACTIONS(3769),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3769),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3769),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [988] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_annotation] = STATE(2789),
    [sym_type_arguments] = STATE(2282),
    [aux_sym_array_repeat1] = STATE(2481),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3771),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [989] = {
    [anon_sym_STAR] = ACTIONS(1201),
    [anon_sym_as] = ACTIONS(1199),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_in] = ACTIONS(1201),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_RBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(1199),
    [anon_sym_QMARK] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_CARET] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1201),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_instanceof] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [anon_sym_implements] = ACTIONS(1199),
    [sym__automatic_semicolon] = ACTIONS(3773),
  },
  [990] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3775),
    [anon_sym_RBRACE] = ACTIONS(3775),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3775),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3775),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3775),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [991] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(1856),
    [sym_nested_type_identifier] = STATE(1813),
    [sym__primary_type] = STATE(1864),
    [sym_generic_type] = STATE(1864),
    [sym_type_predicate] = STATE(1864),
    [sym_type_query] = STATE(1864),
    [sym_index_type_query] = STATE(1864),
    [sym_lookup_type] = STATE(1864),
    [sym_literal_type] = STATE(1864),
    [sym__number] = STATE(1856),
    [sym_existential_type] = STATE(1864),
    [sym_flow_maybe_type] = STATE(1864),
    [sym_parenthesized_type] = STATE(1864),
    [sym_predefined_type] = STATE(1864),
    [sym_object_type] = STATE(1864),
    [sym_array_type] = STATE(1864),
    [sym_tuple_type] = STATE(1864),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3777),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3365),
    [sym_this] = ACTIONS(3779),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_keyof] = ACTIONS(1009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1011),
  },
  [992] = {
    [sym_nested_identifier] = STATE(2853),
    [sym_string] = STATE(1375),
    [sym_nested_type_identifier] = STATE(1290),
    [sym__primary_type] = STATE(1377),
    [sym_generic_type] = STATE(1377),
    [sym_type_predicate] = STATE(1377),
    [sym_type_query] = STATE(1377),
    [sym_index_type_query] = STATE(1377),
    [sym_lookup_type] = STATE(1377),
    [sym_literal_type] = STATE(1377),
    [sym__number] = STATE(1375),
    [sym_existential_type] = STATE(1377),
    [sym_flow_maybe_type] = STATE(1377),
    [sym_parenthesized_type] = STATE(1377),
    [sym_predefined_type] = STATE(1377),
    [sym_object_type] = STATE(1377),
    [sym_array_type] = STATE(1377),
    [sym_tuple_type] = STATE(1377),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_QMARK] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3243),
    [sym_this] = ACTIONS(3783),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_keyof] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
  },
  [993] = {
    [sym_statement_block] = STATE(1215),
    [anon_sym_STAR] = ACTIONS(1073),
    [anon_sym_as] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_COMMA] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(1071),
    [anon_sym_QMARK] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_STAR_STAR] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1071),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_instanceof] = ACTIONS(1071),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [sym__automatic_semicolon] = ACTIONS(1071),
  },
  [994] = {
    [sym_statement_block] = STATE(1215),
    [anon_sym_STAR] = ACTIONS(1073),
    [anon_sym_as] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_COMMA] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(3787),
    [anon_sym_QMARK] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_STAR_STAR] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1071),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_instanceof] = ACTIONS(1071),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [sym__automatic_semicolon] = ACTIONS(1071),
  },
  [995] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1423),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [sym__automatic_semicolon] = ACTIONS(3261),
  },
  [996] = {
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_as] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_in] = ACTIONS(2474),
    [anon_sym_COLON] = ACTIONS(2472),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2474),
    [anon_sym_GT] = ACTIONS(2474),
    [anon_sym_SLASH] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2472),
    [anon_sym_QMARK] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_PIPE_PIPE] = ACTIONS(2472),
    [anon_sym_GT_GT] = ACTIONS(2474),
    [anon_sym_GT_GT_GT] = ACTIONS(2472),
    [anon_sym_LT_LT] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_CARET] = ACTIONS(2472),
    [anon_sym_PIPE] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2472),
    [anon_sym_STAR_STAR] = ACTIONS(2472),
    [anon_sym_LT_EQ] = ACTIONS(2472),
    [anon_sym_EQ_EQ] = ACTIONS(2474),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2472),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2472),
    [anon_sym_GT_EQ] = ACTIONS(2472),
    [anon_sym_instanceof] = ACTIONS(2472),
    [anon_sym_BANG] = ACTIONS(2474),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2472),
    [anon_sym_implements] = ACTIONS(2472),
  },
  [997] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [aux_sym_extends_clause_repeat1] = STATE(2284),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3793),
    [anon_sym_COMMA] = ACTIONS(3411),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3823),
  },
  [998] = {
    [anon_sym_STAR] = ACTIONS(1201),
    [anon_sym_as] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_else] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_in] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1199),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(1199),
    [anon_sym_QMARK] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_CARET] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1201),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_instanceof] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1199),
    [sym__automatic_semicolon] = ACTIONS(1199),
  },
  [999] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3829),
    [anon_sym_RBRACE] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3719),
  },
  [1000] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3862),
    [anon_sym_RBRACE] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3742),
  },
  [1001] = {
    [anon_sym_STAR] = ACTIONS(3867),
    [anon_sym_as] = ACTIONS(3660),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3660),
    [anon_sym_RBRACE] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_RPAREN] = ACTIONS(3660),
    [anon_sym_in] = ACTIONS(3867),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_RBRACK] = ACTIONS(3660),
    [anon_sym_LT] = ACTIONS(3867),
    [anon_sym_GT] = ACTIONS(3867),
    [anon_sym_SLASH] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_GT_GT] = ACTIONS(3867),
    [anon_sym_GT_GT_GT] = ACTIONS(3660),
    [anon_sym_LT_LT] = ACTIONS(3660),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_CARET] = ACTIONS(3660),
    [anon_sym_PIPE] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_STAR_STAR] = ACTIONS(3660),
    [anon_sym_LT_EQ] = ACTIONS(3660),
    [anon_sym_EQ_EQ] = ACTIONS(3867),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3660),
    [anon_sym_GT_EQ] = ACTIONS(3660),
    [anon_sym_instanceof] = ACTIONS(3660),
    [anon_sym_BANG] = ACTIONS(3867),
    [anon_sym_PLUS_PLUS] = ACTIONS(3660),
    [anon_sym_DASH_DASH] = ACTIONS(3660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3660),
    [anon_sym_implements] = ACTIONS(3660),
  },
  [1002] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3869),
    [anon_sym_RBRACE] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3767),
  },
  [1003] = {
    [anon_sym_STAR] = ACTIONS(3631),
    [anon_sym_EQ] = ACTIONS(3631),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3633),
    [anon_sym_RBRACE] = ACTIONS(3633),
    [anon_sym_LPAREN] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3631),
    [anon_sym_of] = ACTIONS(3633),
    [anon_sym_SEMI] = ACTIONS(3633),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(3631),
    [anon_sym_GT] = ACTIONS(3631),
    [anon_sym_SLASH] = ACTIONS(3631),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_AMP_AMP] = ACTIONS(3633),
    [anon_sym_PIPE_PIPE] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3631),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3631),
    [anon_sym_PLUS] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3631),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_STAR_STAR] = ACTIONS(3633),
    [anon_sym_LT_EQ] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3631),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3631),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3633),
    [anon_sym_GT_EQ] = ACTIONS(3633),
    [anon_sym_instanceof] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3631),
    [anon_sym_PLUS_PLUS] = ACTIONS(3633),
    [anon_sym_DASH_DASH] = ACTIONS(3633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3633),
    [sym__automatic_semicolon] = ACTIONS(3633),
  },
  [1004] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3738),
    [anon_sym_RBRACE] = ACTIONS(3738),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_in] = ACTIONS(3736),
    [anon_sym_SEMI] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_GT] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_GT_GT] = ACTIONS(3736),
    [anon_sym_GT_GT_GT] = ACTIONS(3738),
    [anon_sym_LT_LT] = ACTIONS(3738),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_CARET] = ACTIONS(3738),
    [anon_sym_PIPE] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_STAR_STAR] = ACTIONS(3738),
    [anon_sym_LT_EQ] = ACTIONS(3738),
    [anon_sym_EQ_EQ] = ACTIONS(3736),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3738),
    [anon_sym_GT_EQ] = ACTIONS(3738),
    [anon_sym_instanceof] = ACTIONS(3738),
    [anon_sym_BANG] = ACTIONS(3736),
    [anon_sym_PLUS_PLUS] = ACTIONS(3738),
    [anon_sym_DASH_DASH] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3738),
    [sym__automatic_semicolon] = ACTIONS(3738),
  },
  [1005] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_RBRACE] = ACTIONS(3752),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3872),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3752),
  },
  [1006] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_RBRACE] = ACTIONS(3752),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3872),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3750),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3752),
  },
  [1007] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3775),
    [anon_sym_RBRACE] = ACTIONS(3775),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3775),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3775),
  },
  [1008] = {
    [anon_sym_STAR] = ACTIONS(3875),
    [anon_sym_as] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(3877),
    [anon_sym_COMMA] = ACTIONS(3877),
    [anon_sym_RBRACE] = ACTIONS(3877),
    [anon_sym_LPAREN] = ACTIONS(3877),
    [anon_sym_RPAREN] = ACTIONS(3877),
    [anon_sym_in] = ACTIONS(3875),
    [anon_sym_COLON] = ACTIONS(3877),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_RBRACK] = ACTIONS(3877),
    [anon_sym_LT] = ACTIONS(3875),
    [anon_sym_GT] = ACTIONS(3875),
    [anon_sym_SLASH] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3877),
    [anon_sym_QMARK] = ACTIONS(3877),
    [anon_sym_AMP_AMP] = ACTIONS(3877),
    [anon_sym_PIPE_PIPE] = ACTIONS(3877),
    [anon_sym_GT_GT] = ACTIONS(3875),
    [anon_sym_GT_GT_GT] = ACTIONS(3877),
    [anon_sym_LT_LT] = ACTIONS(3877),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_CARET] = ACTIONS(3877),
    [anon_sym_PIPE] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3877),
    [anon_sym_STAR_STAR] = ACTIONS(3877),
    [anon_sym_LT_EQ] = ACTIONS(3877),
    [anon_sym_EQ_EQ] = ACTIONS(3875),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3877),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3877),
    [anon_sym_GT_EQ] = ACTIONS(3877),
    [anon_sym_instanceof] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(3875),
    [anon_sym_PLUS_PLUS] = ACTIONS(3877),
    [anon_sym_DASH_DASH] = ACTIONS(3877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3877),
    [anon_sym_implements] = ACTIONS(3877),
  },
  [1009] = {
    [anon_sym_STAR] = ACTIONS(3879),
    [anon_sym_as] = ACTIONS(3881),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3881),
    [anon_sym_RBRACE] = ACTIONS(3881),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3881),
    [anon_sym_in] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_RBRACK] = ACTIONS(3881),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_SLASH] = ACTIONS(3879),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [anon_sym_GT_GT_GT] = ACTIONS(3881),
    [anon_sym_LT_LT] = ACTIONS(3881),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_CARET] = ACTIONS(3881),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_DASH] = ACTIONS(3879),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_STAR_STAR] = ACTIONS(3881),
    [anon_sym_LT_EQ] = ACTIONS(3881),
    [anon_sym_EQ_EQ] = ACTIONS(3879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3879),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3881),
    [anon_sym_GT_EQ] = ACTIONS(3881),
    [anon_sym_instanceof] = ACTIONS(3881),
    [anon_sym_BANG] = ACTIONS(3879),
    [anon_sym_PLUS_PLUS] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3881),
    [anon_sym_implements] = ACTIONS(3881),
  },
  [1010] = {
    [anon_sym_STAR] = ACTIONS(3883),
    [anon_sym_as] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3885),
    [anon_sym_RBRACE] = ACTIONS(3885),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_RPAREN] = ACTIONS(3885),
    [anon_sym_in] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_RBRACK] = ACTIONS(3885),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_GT] = ACTIONS(3883),
    [anon_sym_SLASH] = ACTIONS(3883),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_GT_GT] = ACTIONS(3883),
    [anon_sym_GT_GT_GT] = ACTIONS(3885),
    [anon_sym_LT_LT] = ACTIONS(3885),
    [anon_sym_AMP] = ACTIONS(3883),
    [anon_sym_CARET] = ACTIONS(3885),
    [anon_sym_PIPE] = ACTIONS(3883),
    [anon_sym_PLUS] = ACTIONS(3883),
    [anon_sym_DASH] = ACTIONS(3883),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_STAR_STAR] = ACTIONS(3885),
    [anon_sym_LT_EQ] = ACTIONS(3885),
    [anon_sym_EQ_EQ] = ACTIONS(3883),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3883),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3885),
    [anon_sym_GT_EQ] = ACTIONS(3885),
    [anon_sym_instanceof] = ACTIONS(3885),
    [anon_sym_BANG] = ACTIONS(3883),
    [anon_sym_PLUS_PLUS] = ACTIONS(3885),
    [anon_sym_DASH_DASH] = ACTIONS(3885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3885),
    [anon_sym_implements] = ACTIONS(3885),
  },
  [1011] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3601),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1012] = {
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_EQ] = ACTIONS(3639),
    [anon_sym_as] = ACTIONS(3641),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_RBRACE] = ACTIONS(3641),
    [anon_sym_LPAREN] = ACTIONS(3641),
    [anon_sym_in] = ACTIONS(3639),
    [anon_sym_of] = ACTIONS(3641),
    [anon_sym_SEMI] = ACTIONS(3641),
    [anon_sym_COLON] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_LT] = ACTIONS(3639),
    [anon_sym_GT] = ACTIONS(3639),
    [anon_sym_SLASH] = ACTIONS(3639),
    [anon_sym_DOT] = ACTIONS(3641),
    [anon_sym_QMARK] = ACTIONS(3641),
    [anon_sym_AMP_AMP] = ACTIONS(3641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3641),
    [anon_sym_GT_GT] = ACTIONS(3639),
    [anon_sym_GT_GT_GT] = ACTIONS(3641),
    [anon_sym_LT_LT] = ACTIONS(3641),
    [anon_sym_AMP] = ACTIONS(3639),
    [anon_sym_CARET] = ACTIONS(3641),
    [anon_sym_PIPE] = ACTIONS(3639),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_PERCENT] = ACTIONS(3641),
    [anon_sym_STAR_STAR] = ACTIONS(3641),
    [anon_sym_LT_EQ] = ACTIONS(3641),
    [anon_sym_EQ_EQ] = ACTIONS(3639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3641),
    [anon_sym_BANG_EQ] = ACTIONS(3639),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3641),
    [anon_sym_GT_EQ] = ACTIONS(3641),
    [anon_sym_instanceof] = ACTIONS(3641),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_PLUS_PLUS] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3641),
    [sym__automatic_semicolon] = ACTIONS(3641),
  },
  [1013] = {
    [anon_sym_STAR] = ACTIONS(3887),
    [anon_sym_as] = ACTIONS(3889),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3889),
    [anon_sym_RBRACE] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_RPAREN] = ACTIONS(3889),
    [anon_sym_in] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_RBRACK] = ACTIONS(3889),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_GT] = ACTIONS(3887),
    [anon_sym_SLASH] = ACTIONS(3887),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_GT_GT] = ACTIONS(3887),
    [anon_sym_GT_GT_GT] = ACTIONS(3889),
    [anon_sym_LT_LT] = ACTIONS(3889),
    [anon_sym_AMP] = ACTIONS(3887),
    [anon_sym_CARET] = ACTIONS(3889),
    [anon_sym_PIPE] = ACTIONS(3887),
    [anon_sym_PLUS] = ACTIONS(3887),
    [anon_sym_DASH] = ACTIONS(3887),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_STAR_STAR] = ACTIONS(3889),
    [anon_sym_LT_EQ] = ACTIONS(3889),
    [anon_sym_EQ_EQ] = ACTIONS(3887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3887),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3889),
    [anon_sym_GT_EQ] = ACTIONS(3889),
    [anon_sym_instanceof] = ACTIONS(3889),
    [anon_sym_BANG] = ACTIONS(3887),
    [anon_sym_PLUS_PLUS] = ACTIONS(3889),
    [anon_sym_DASH_DASH] = ACTIONS(3889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3889),
    [anon_sym_implements] = ACTIONS(3889),
  },
  [1014] = {
    [anon_sym_STAR] = ACTIONS(3635),
    [anon_sym_EQ] = ACTIONS(3635),
    [anon_sym_as] = ACTIONS(3637),
    [anon_sym_COMMA] = ACTIONS(3637),
    [anon_sym_RBRACE] = ACTIONS(3637),
    [anon_sym_LPAREN] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3635),
    [anon_sym_of] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(3637),
    [anon_sym_COLON] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_LT] = ACTIONS(3635),
    [anon_sym_GT] = ACTIONS(3635),
    [anon_sym_SLASH] = ACTIONS(3635),
    [anon_sym_DOT] = ACTIONS(3637),
    [anon_sym_QMARK] = ACTIONS(3637),
    [anon_sym_AMP_AMP] = ACTIONS(3637),
    [anon_sym_PIPE_PIPE] = ACTIONS(3637),
    [anon_sym_GT_GT] = ACTIONS(3635),
    [anon_sym_GT_GT_GT] = ACTIONS(3637),
    [anon_sym_LT_LT] = ACTIONS(3637),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PIPE] = ACTIONS(3635),
    [anon_sym_PLUS] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(3635),
    [anon_sym_PERCENT] = ACTIONS(3637),
    [anon_sym_STAR_STAR] = ACTIONS(3637),
    [anon_sym_LT_EQ] = ACTIONS(3637),
    [anon_sym_EQ_EQ] = ACTIONS(3635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3637),
    [anon_sym_BANG_EQ] = ACTIONS(3635),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3637),
    [anon_sym_GT_EQ] = ACTIONS(3637),
    [anon_sym_instanceof] = ACTIONS(3637),
    [anon_sym_BANG] = ACTIONS(3635),
    [anon_sym_PLUS_PLUS] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3637),
    [sym__automatic_semicolon] = ACTIONS(3637),
  },
  [1015] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3729),
    [anon_sym_GT_GT_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3731),
  },
  [1016] = {
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_EQ] = ACTIONS(3643),
    [anon_sym_as] = ACTIONS(3645),
    [anon_sym_COMMA] = ACTIONS(3645),
    [anon_sym_RBRACE] = ACTIONS(3645),
    [anon_sym_LPAREN] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3643),
    [anon_sym_of] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_COLON] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_LT] = ACTIONS(3643),
    [anon_sym_GT] = ACTIONS(3643),
    [anon_sym_SLASH] = ACTIONS(3643),
    [anon_sym_DOT] = ACTIONS(3645),
    [anon_sym_QMARK] = ACTIONS(3645),
    [anon_sym_AMP_AMP] = ACTIONS(3645),
    [anon_sym_PIPE_PIPE] = ACTIONS(3645),
    [anon_sym_GT_GT] = ACTIONS(3643),
    [anon_sym_GT_GT_GT] = ACTIONS(3645),
    [anon_sym_LT_LT] = ACTIONS(3645),
    [anon_sym_AMP] = ACTIONS(3643),
    [anon_sym_CARET] = ACTIONS(3645),
    [anon_sym_PIPE] = ACTIONS(3643),
    [anon_sym_PLUS] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3643),
    [anon_sym_PERCENT] = ACTIONS(3645),
    [anon_sym_STAR_STAR] = ACTIONS(3645),
    [anon_sym_LT_EQ] = ACTIONS(3645),
    [anon_sym_EQ_EQ] = ACTIONS(3643),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3645),
    [anon_sym_BANG_EQ] = ACTIONS(3643),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3645),
    [anon_sym_GT_EQ] = ACTIONS(3645),
    [anon_sym_instanceof] = ACTIONS(3645),
    [anon_sym_BANG] = ACTIONS(3643),
    [anon_sym_PLUS_PLUS] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3645),
    [sym__automatic_semicolon] = ACTIONS(3645),
  },
  [1017] = {
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_as] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(1063),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_GT_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_PERCENT] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1061),
    [anon_sym_GT_EQ] = ACTIONS(1061),
    [anon_sym_instanceof] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1061),
    [sym__automatic_semicolon] = ACTIONS(3894),
  },
  [1018] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3731),
  },
  [1019] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_annotation] = STATE(2913),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3896),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1020] = {
    [sym_object] = STATE(2824),
    [sym_assignment_pattern] = STATE(2396),
    [sym_array] = STATE(2825),
    [sym_spread_element] = STATE(2396),
    [sym_string] = STATE(1980),
    [sym_method_definition] = STATE(2396),
    [sym_pair] = STATE(2396),
    [sym__property_name] = STATE(1980),
    [sym_computed_property_name] = STATE(1980),
    [sym_accessibility_modifier] = STATE(1726),
    [aux_sym_object_repeat1] = STATE(2398),
    [sym_identifier] = ACTIONS(3898),
    [anon_sym_export] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(3900),
    [anon_sym_type] = ACTIONS(3898),
    [anon_sym_LBRACK] = ACTIONS(3902),
    [anon_sym_async] = ACTIONS(3904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3906),
    [anon_sym_static] = ACTIONS(3908),
    [anon_sym_get] = ACTIONS(3910),
    [anon_sym_set] = ACTIONS(3910),
    [anon_sym_declare] = ACTIONS(3898),
    [anon_sym_public] = ACTIONS(3912),
    [anon_sym_private] = ACTIONS(3912),
    [anon_sym_protected] = ACTIONS(3912),
    [anon_sym_module] = ACTIONS(3898),
    [anon_sym_any] = ACTIONS(3898),
    [anon_sym_number] = ACTIONS(3898),
    [anon_sym_boolean] = ACTIONS(3898),
    [anon_sym_string] = ACTIONS(3898),
    [anon_sym_symbol] = ACTIONS(3898),
    [sym_readonly] = ACTIONS(145),
  },
  [1021] = {
    [anon_sym_STAR] = ACTIONS(3914),
    [anon_sym_as] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3916),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_RBRACE] = ACTIONS(3916),
    [anon_sym_LPAREN] = ACTIONS(3916),
    [anon_sym_RPAREN] = ACTIONS(3916),
    [anon_sym_in] = ACTIONS(3914),
    [anon_sym_COLON] = ACTIONS(3916),
    [anon_sym_LBRACK] = ACTIONS(3916),
    [anon_sym_RBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3914),
    [anon_sym_GT] = ACTIONS(3914),
    [anon_sym_SLASH] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3916),
    [anon_sym_QMARK] = ACTIONS(3916),
    [anon_sym_AMP_AMP] = ACTIONS(3916),
    [anon_sym_PIPE_PIPE] = ACTIONS(3916),
    [anon_sym_GT_GT] = ACTIONS(3914),
    [anon_sym_GT_GT_GT] = ACTIONS(3916),
    [anon_sym_LT_LT] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_CARET] = ACTIONS(3916),
    [anon_sym_PIPE] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3916),
    [anon_sym_STAR_STAR] = ACTIONS(3916),
    [anon_sym_LT_EQ] = ACTIONS(3916),
    [anon_sym_EQ_EQ] = ACTIONS(3914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3916),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3916),
    [anon_sym_GT_EQ] = ACTIONS(3916),
    [anon_sym_instanceof] = ACTIONS(3916),
    [anon_sym_BANG] = ACTIONS(3914),
    [anon_sym_PLUS_PLUS] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(3916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3916),
    [anon_sym_implements] = ACTIONS(3916),
  },
  [1022] = {
    [anon_sym_STAR] = ACTIONS(3918),
    [anon_sym_as] = ACTIONS(3920),
    [anon_sym_LBRACE] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(3920),
    [anon_sym_RBRACE] = ACTIONS(3920),
    [anon_sym_LPAREN] = ACTIONS(3920),
    [anon_sym_RPAREN] = ACTIONS(3920),
    [anon_sym_in] = ACTIONS(3918),
    [anon_sym_COLON] = ACTIONS(3920),
    [anon_sym_LBRACK] = ACTIONS(3920),
    [anon_sym_RBRACK] = ACTIONS(3920),
    [anon_sym_LT] = ACTIONS(3918),
    [anon_sym_GT] = ACTIONS(3918),
    [anon_sym_SLASH] = ACTIONS(3918),
    [anon_sym_DOT] = ACTIONS(3920),
    [anon_sym_QMARK] = ACTIONS(3920),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3920),
    [anon_sym_GT_GT] = ACTIONS(3918),
    [anon_sym_GT_GT_GT] = ACTIONS(3920),
    [anon_sym_LT_LT] = ACTIONS(3920),
    [anon_sym_AMP] = ACTIONS(3918),
    [anon_sym_CARET] = ACTIONS(3920),
    [anon_sym_PIPE] = ACTIONS(3918),
    [anon_sym_PLUS] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3918),
    [anon_sym_PERCENT] = ACTIONS(3920),
    [anon_sym_STAR_STAR] = ACTIONS(3920),
    [anon_sym_LT_EQ] = ACTIONS(3920),
    [anon_sym_EQ_EQ] = ACTIONS(3918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3920),
    [anon_sym_BANG_EQ] = ACTIONS(3918),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3920),
    [anon_sym_GT_EQ] = ACTIONS(3920),
    [anon_sym_instanceof] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_PLUS_PLUS] = ACTIONS(3920),
    [anon_sym_DASH_DASH] = ACTIONS(3920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3920),
    [anon_sym_implements] = ACTIONS(3920),
  },
  [1023] = {
    [anon_sym_STAR] = ACTIONS(3922),
    [anon_sym_as] = ACTIONS(3924),
    [anon_sym_LBRACE] = ACTIONS(3924),
    [anon_sym_COMMA] = ACTIONS(3924),
    [anon_sym_RBRACE] = ACTIONS(3924),
    [anon_sym_LPAREN] = ACTIONS(3924),
    [anon_sym_RPAREN] = ACTIONS(3924),
    [anon_sym_in] = ACTIONS(3922),
    [anon_sym_COLON] = ACTIONS(3924),
    [anon_sym_LBRACK] = ACTIONS(3924),
    [anon_sym_RBRACK] = ACTIONS(3924),
    [anon_sym_LT] = ACTIONS(3922),
    [anon_sym_GT] = ACTIONS(3922),
    [anon_sym_SLASH] = ACTIONS(3922),
    [anon_sym_DOT] = ACTIONS(3924),
    [anon_sym_QMARK] = ACTIONS(3924),
    [anon_sym_AMP_AMP] = ACTIONS(3924),
    [anon_sym_PIPE_PIPE] = ACTIONS(3924),
    [anon_sym_GT_GT] = ACTIONS(3922),
    [anon_sym_GT_GT_GT] = ACTIONS(3924),
    [anon_sym_LT_LT] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(3922),
    [anon_sym_CARET] = ACTIONS(3924),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_PLUS] = ACTIONS(3922),
    [anon_sym_DASH] = ACTIONS(3922),
    [anon_sym_PERCENT] = ACTIONS(3924),
    [anon_sym_STAR_STAR] = ACTIONS(3924),
    [anon_sym_LT_EQ] = ACTIONS(3924),
    [anon_sym_EQ_EQ] = ACTIONS(3922),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3924),
    [anon_sym_BANG_EQ] = ACTIONS(3922),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3924),
    [anon_sym_GT_EQ] = ACTIONS(3924),
    [anon_sym_instanceof] = ACTIONS(3924),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_PLUS_PLUS] = ACTIONS(3924),
    [anon_sym_DASH_DASH] = ACTIONS(3924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3924),
    [anon_sym_implements] = ACTIONS(3924),
  },
  [1024] = {
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_EQ] = ACTIONS(3619),
    [anon_sym_as] = ACTIONS(3621),
    [anon_sym_COMMA] = ACTIONS(3621),
    [anon_sym_RBRACE] = ACTIONS(3621),
    [anon_sym_LPAREN] = ACTIONS(3621),
    [anon_sym_in] = ACTIONS(3619),
    [anon_sym_of] = ACTIONS(3621),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK] = ACTIONS(3621),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_SLASH] = ACTIONS(3619),
    [anon_sym_DOT] = ACTIONS(3621),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_PIPE_PIPE] = ACTIONS(3621),
    [anon_sym_GT_GT] = ACTIONS(3619),
    [anon_sym_GT_GT_GT] = ACTIONS(3621),
    [anon_sym_LT_LT] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_CARET] = ACTIONS(3621),
    [anon_sym_PIPE] = ACTIONS(3619),
    [anon_sym_PLUS] = ACTIONS(3619),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_PERCENT] = ACTIONS(3621),
    [anon_sym_STAR_STAR] = ACTIONS(3621),
    [anon_sym_LT_EQ] = ACTIONS(3621),
    [anon_sym_EQ_EQ] = ACTIONS(3619),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3621),
    [anon_sym_BANG_EQ] = ACTIONS(3619),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3621),
    [anon_sym_GT_EQ] = ACTIONS(3621),
    [anon_sym_instanceof] = ACTIONS(3621),
    [anon_sym_BANG] = ACTIONS(3619),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3621),
    [sym__automatic_semicolon] = ACTIONS(3621),
  },
  [1025] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(3601),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1026] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [aux_sym_extends_clause_repeat1] = STATE(2300),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3426),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3823),
  },
  [1027] = {
    [anon_sym_STAR] = ACTIONS(3952),
    [anon_sym_as] = ACTIONS(3954),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3954),
    [anon_sym_RBRACE] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_RPAREN] = ACTIONS(3954),
    [anon_sym_in] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_RBRACK] = ACTIONS(3954),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_GT] = ACTIONS(3952),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_GT_GT] = ACTIONS(3952),
    [anon_sym_GT_GT_GT] = ACTIONS(3954),
    [anon_sym_LT_LT] = ACTIONS(3954),
    [anon_sym_AMP] = ACTIONS(3952),
    [anon_sym_CARET] = ACTIONS(3954),
    [anon_sym_PIPE] = ACTIONS(3952),
    [anon_sym_PLUS] = ACTIONS(3952),
    [anon_sym_DASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3954),
    [anon_sym_LT_EQ] = ACTIONS(3954),
    [anon_sym_EQ_EQ] = ACTIONS(3952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3952),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3954),
    [anon_sym_GT_EQ] = ACTIONS(3954),
    [anon_sym_instanceof] = ACTIONS(3954),
    [anon_sym_BANG] = ACTIONS(3952),
    [anon_sym_PLUS_PLUS] = ACTIONS(3954),
    [anon_sym_DASH_DASH] = ACTIONS(3954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3954),
    [anon_sym_implements] = ACTIONS(3954),
  },
  [1028] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_RBRACE] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3717),
  },
  [1029] = {
    [anon_sym_STAR] = ACTIONS(3559),
    [anon_sym_as] = ACTIONS(3563),
    [anon_sym_LBRACE] = ACTIONS(3563),
    [anon_sym_COMMA] = ACTIONS(3563),
    [anon_sym_RBRACE] = ACTIONS(3563),
    [anon_sym_LPAREN] = ACTIONS(3563),
    [anon_sym_RPAREN] = ACTIONS(3563),
    [anon_sym_in] = ACTIONS(3559),
    [anon_sym_COLON] = ACTIONS(3563),
    [anon_sym_LBRACK] = ACTIONS(3563),
    [anon_sym_RBRACK] = ACTIONS(3563),
    [anon_sym_LT] = ACTIONS(3559),
    [anon_sym_GT] = ACTIONS(3559),
    [anon_sym_SLASH] = ACTIONS(3559),
    [anon_sym_DOT] = ACTIONS(3563),
    [anon_sym_QMARK] = ACTIONS(3563),
    [anon_sym_AMP_AMP] = ACTIONS(3563),
    [anon_sym_PIPE_PIPE] = ACTIONS(3563),
    [anon_sym_GT_GT] = ACTIONS(3559),
    [anon_sym_GT_GT_GT] = ACTIONS(3563),
    [anon_sym_LT_LT] = ACTIONS(3563),
    [anon_sym_AMP] = ACTIONS(3559),
    [anon_sym_CARET] = ACTIONS(3563),
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_PERCENT] = ACTIONS(3563),
    [anon_sym_STAR_STAR] = ACTIONS(3563),
    [anon_sym_LT_EQ] = ACTIONS(3563),
    [anon_sym_EQ_EQ] = ACTIONS(3559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3563),
    [anon_sym_BANG_EQ] = ACTIONS(3559),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3563),
    [anon_sym_GT_EQ] = ACTIONS(3563),
    [anon_sym_instanceof] = ACTIONS(3563),
    [anon_sym_BANG] = ACTIONS(3559),
    [anon_sym_PLUS_PLUS] = ACTIONS(3563),
    [anon_sym_DASH_DASH] = ACTIONS(3563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3563),
    [anon_sym_implements] = ACTIONS(3563),
  },
  [1030] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3729),
    [anon_sym_GT_GT_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3731),
  },
  [1031] = {
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_as] = ACTIONS(1155),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_else] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_in] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(1157),
    [anon_sym_SLASH] = ACTIONS(1157),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_QMARK] = ACTIONS(1155),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1157),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1155),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_STAR_STAR] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_instanceof] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1155),
    [anon_sym_DASH_DASH] = ACTIONS(1155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1155),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1155),
    [sym__automatic_semicolon] = ACTIONS(1155),
  },
  [1032] = {
    [anon_sym_STAR] = ACTIONS(3961),
    [anon_sym_as] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3963),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_RBRACE] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3963),
    [anon_sym_RPAREN] = ACTIONS(3963),
    [anon_sym_in] = ACTIONS(3961),
    [anon_sym_COLON] = ACTIONS(3963),
    [anon_sym_LBRACK] = ACTIONS(3963),
    [anon_sym_RBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3961),
    [anon_sym_GT] = ACTIONS(3961),
    [anon_sym_SLASH] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3963),
    [anon_sym_QMARK] = ACTIONS(3963),
    [anon_sym_AMP_AMP] = ACTIONS(3963),
    [anon_sym_PIPE_PIPE] = ACTIONS(3963),
    [anon_sym_GT_GT] = ACTIONS(3961),
    [anon_sym_GT_GT_GT] = ACTIONS(3963),
    [anon_sym_LT_LT] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_CARET] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3963),
    [anon_sym_STAR_STAR] = ACTIONS(3963),
    [anon_sym_LT_EQ] = ACTIONS(3963),
    [anon_sym_EQ_EQ] = ACTIONS(3961),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3963),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3963),
    [anon_sym_GT_EQ] = ACTIONS(3963),
    [anon_sym_instanceof] = ACTIONS(3963),
    [anon_sym_BANG] = ACTIONS(3961),
    [anon_sym_PLUS_PLUS] = ACTIONS(3963),
    [anon_sym_DASH_DASH] = ACTIONS(3963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3963),
    [anon_sym_implements] = ACTIONS(3963),
  },
  [1033] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_annotation] = STATE(2740),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(3965),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1034] = {
    [anon_sym_STAR] = ACTIONS(3967),
    [anon_sym_as] = ACTIONS(3969),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3969),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_RPAREN] = ACTIONS(3969),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_RBRACK] = ACTIONS(3969),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_GT] = ACTIONS(3967),
    [anon_sym_SLASH] = ACTIONS(3967),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_GT_GT] = ACTIONS(3967),
    [anon_sym_GT_GT_GT] = ACTIONS(3969),
    [anon_sym_LT_LT] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_CARET] = ACTIONS(3969),
    [anon_sym_PIPE] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_STAR_STAR] = ACTIONS(3969),
    [anon_sym_LT_EQ] = ACTIONS(3969),
    [anon_sym_EQ_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3969),
    [anon_sym_GT_EQ] = ACTIONS(3969),
    [anon_sym_instanceof] = ACTIONS(3969),
    [anon_sym_BANG] = ACTIONS(3967),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3969),
    [anon_sym_implements] = ACTIONS(3969),
  },
  [1035] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3769),
    [anon_sym_RBRACE] = ACTIONS(3769),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3769),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3769),
  },
  [1036] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3715),
    [anon_sym_RBRACE] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3715),
  },
  [1037] = {
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_RBRACE] = ACTIONS(3973),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_RPAREN] = ACTIONS(3973),
    [anon_sym_in] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_RBRACK] = ACTIONS(3973),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_GT] = ACTIONS(3971),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3973),
    [anon_sym_LT_LT] = ACTIONS(3973),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_CARET] = ACTIONS(3973),
    [anon_sym_PIPE] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_STAR_STAR] = ACTIONS(3973),
    [anon_sym_LT_EQ] = ACTIONS(3973),
    [anon_sym_EQ_EQ] = ACTIONS(3971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3971),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3973),
    [anon_sym_GT_EQ] = ACTIONS(3973),
    [anon_sym_instanceof] = ACTIONS(3973),
    [anon_sym_BANG] = ACTIONS(3971),
    [anon_sym_PLUS_PLUS] = ACTIONS(3973),
    [anon_sym_DASH_DASH] = ACTIONS(3973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3973),
    [anon_sym_implements] = ACTIONS(3973),
  },
  [1038] = {
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_RBRACE] = ACTIONS(3973),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_RPAREN] = ACTIONS(3973),
    [anon_sym_in] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_RBRACK] = ACTIONS(3973),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_GT] = ACTIONS(3971),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3973),
    [anon_sym_LT_LT] = ACTIONS(3973),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_CARET] = ACTIONS(3973),
    [anon_sym_PIPE] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_STAR_STAR] = ACTIONS(3973),
    [anon_sym_LT_EQ] = ACTIONS(3973),
    [anon_sym_EQ_EQ] = ACTIONS(3971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3971),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3973),
    [anon_sym_GT_EQ] = ACTIONS(3973),
    [anon_sym_instanceof] = ACTIONS(3973),
    [anon_sym_BANG] = ACTIONS(3971),
    [anon_sym_PLUS_PLUS] = ACTIONS(3973),
    [anon_sym_DASH_DASH] = ACTIONS(3973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3973),
    [anon_sym_implements] = ACTIONS(3973),
  },
  [1039] = {
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_as] = ACTIONS(3977),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3977),
    [anon_sym_RBRACE] = ACTIONS(3977),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_RPAREN] = ACTIONS(3977),
    [anon_sym_in] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_RBRACK] = ACTIONS(3977),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_GT] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3975),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_GT_GT] = ACTIONS(3975),
    [anon_sym_GT_GT_GT] = ACTIONS(3977),
    [anon_sym_LT_LT] = ACTIONS(3977),
    [anon_sym_AMP] = ACTIONS(3975),
    [anon_sym_CARET] = ACTIONS(3977),
    [anon_sym_PIPE] = ACTIONS(3975),
    [anon_sym_PLUS] = ACTIONS(3975),
    [anon_sym_DASH] = ACTIONS(3975),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_STAR_STAR] = ACTIONS(3977),
    [anon_sym_LT_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ] = ACTIONS(3975),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3975),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3977),
    [anon_sym_GT_EQ] = ACTIONS(3977),
    [anon_sym_instanceof] = ACTIONS(3977),
    [anon_sym_BANG] = ACTIONS(3975),
    [anon_sym_PLUS_PLUS] = ACTIONS(3977),
    [anon_sym_DASH_DASH] = ACTIONS(3977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3977),
    [anon_sym_implements] = ACTIONS(3977),
  },
  [1040] = {
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_in] = ACTIONS(1065),
    [anon_sym_of] = ACTIONS(1067),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COLON] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1065),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [sym__automatic_semicolon] = ACTIONS(1067),
  },
  [1041] = {
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_as] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3765),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3765),
    [anon_sym_RPAREN] = ACTIONS(3765),
    [anon_sym_in] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3765),
    [anon_sym_LBRACK] = ACTIONS(3765),
    [anon_sym_RBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_DOT] = ACTIONS(3765),
    [anon_sym_QMARK] = ACTIONS(3765),
    [anon_sym_AMP_AMP] = ACTIONS(3765),
    [anon_sym_PIPE_PIPE] = ACTIONS(3765),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3765),
    [anon_sym_LT_LT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_CARET] = ACTIONS(3765),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_PERCENT] = ACTIONS(3765),
    [anon_sym_STAR_STAR] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3765),
    [anon_sym_EQ_EQ] = ACTIONS(3979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3765),
    [anon_sym_BANG_EQ] = ACTIONS(3979),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3765),
    [anon_sym_GT_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3765),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3765),
    [anon_sym_DASH_DASH] = ACTIONS(3765),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3765),
    [anon_sym_implements] = ACTIONS(3765),
  },
  [1042] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_RBRACE] = ACTIONS(3727),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3727),
  },
  [1043] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_RBRACE] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3740),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3740),
  },
  [1044] = {
    [anon_sym_STAR] = ACTIONS(3981),
    [anon_sym_as] = ACTIONS(3983),
    [anon_sym_LBRACE] = ACTIONS(3983),
    [anon_sym_COMMA] = ACTIONS(3983),
    [anon_sym_RBRACE] = ACTIONS(3983),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_RPAREN] = ACTIONS(3983),
    [anon_sym_in] = ACTIONS(3981),
    [anon_sym_COLON] = ACTIONS(3983),
    [anon_sym_LBRACK] = ACTIONS(3983),
    [anon_sym_RBRACK] = ACTIONS(3983),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3981),
    [anon_sym_SLASH] = ACTIONS(3981),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3983),
    [anon_sym_PIPE_PIPE] = ACTIONS(3983),
    [anon_sym_GT_GT] = ACTIONS(3981),
    [anon_sym_GT_GT_GT] = ACTIONS(3983),
    [anon_sym_LT_LT] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3981),
    [anon_sym_CARET] = ACTIONS(3983),
    [anon_sym_PIPE] = ACTIONS(3981),
    [anon_sym_PLUS] = ACTIONS(3981),
    [anon_sym_DASH] = ACTIONS(3981),
    [anon_sym_PERCENT] = ACTIONS(3983),
    [anon_sym_STAR_STAR] = ACTIONS(3983),
    [anon_sym_LT_EQ] = ACTIONS(3983),
    [anon_sym_EQ_EQ] = ACTIONS(3981),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3983),
    [anon_sym_BANG_EQ] = ACTIONS(3981),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3983),
    [anon_sym_GT_EQ] = ACTIONS(3983),
    [anon_sym_instanceof] = ACTIONS(3983),
    [anon_sym_BANG] = ACTIONS(3981),
    [anon_sym_PLUS_PLUS] = ACTIONS(3983),
    [anon_sym_DASH_DASH] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3983),
    [anon_sym_implements] = ACTIONS(3983),
  },
  [1045] = {
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_as] = ACTIONS(3987),
    [anon_sym_LBRACE] = ACTIONS(3987),
    [anon_sym_COMMA] = ACTIONS(3987),
    [anon_sym_RBRACE] = ACTIONS(3987),
    [anon_sym_LPAREN] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3987),
    [anon_sym_in] = ACTIONS(3985),
    [anon_sym_COLON] = ACTIONS(3987),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_RBRACK] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3985),
    [anon_sym_GT] = ACTIONS(3985),
    [anon_sym_SLASH] = ACTIONS(3985),
    [anon_sym_DOT] = ACTIONS(3987),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3987),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_GT_GT_GT] = ACTIONS(3987),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3985),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3985),
    [anon_sym_DASH] = ACTIONS(3985),
    [anon_sym_PERCENT] = ACTIONS(3987),
    [anon_sym_STAR_STAR] = ACTIONS(3987),
    [anon_sym_LT_EQ] = ACTIONS(3987),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3987),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3987),
    [anon_sym_GT_EQ] = ACTIONS(3987),
    [anon_sym_instanceof] = ACTIONS(3987),
    [anon_sym_BANG] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3987),
    [anon_sym_DASH_DASH] = ACTIONS(3987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3987),
    [anon_sym_implements] = ACTIONS(3987),
  },
  [1046] = {
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_as] = ACTIONS(1077),
    [anon_sym_LBRACE] = ACTIONS(1077),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_RPAREN] = ACTIONS(1077),
    [anon_sym_in] = ACTIONS(1079),
    [anon_sym_COLON] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_RBRACK] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_SLASH] = ACTIONS(1079),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(1079),
    [anon_sym_DASH] = ACTIONS(1079),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1079),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1077),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [anon_sym_implements] = ACTIONS(1077),
  },
  [1047] = {
    [anon_sym_STAR] = ACTIONS(2444),
    [anon_sym_as] = ACTIONS(2442),
    [anon_sym_LBRACE] = ACTIONS(2442),
    [anon_sym_COMMA] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [anon_sym_RPAREN] = ACTIONS(2442),
    [anon_sym_in] = ACTIONS(2444),
    [anon_sym_COLON] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2442),
    [anon_sym_RBRACK] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(2444),
    [anon_sym_DOT] = ACTIONS(2442),
    [anon_sym_QMARK] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_GT_GT] = ACTIONS(2444),
    [anon_sym_GT_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_CARET] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_PERCENT] = ACTIONS(2442),
    [anon_sym_STAR_STAR] = ACTIONS(2442),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_EQ_EQ] = ACTIONS(2444),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ] = ACTIONS(2444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_instanceof] = ACTIONS(2442),
    [anon_sym_BANG] = ACTIONS(2444),
    [anon_sym_PLUS_PLUS] = ACTIONS(2442),
    [anon_sym_DASH_DASH] = ACTIONS(2442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_implements] = ACTIONS(2442),
  },
  [1048] = {
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_as] = ACTIONS(3987),
    [anon_sym_LBRACE] = ACTIONS(3987),
    [anon_sym_COMMA] = ACTIONS(3987),
    [anon_sym_RBRACE] = ACTIONS(3987),
    [anon_sym_LPAREN] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3987),
    [anon_sym_in] = ACTIONS(3985),
    [anon_sym_COLON] = ACTIONS(3987),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_RBRACK] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3985),
    [anon_sym_GT] = ACTIONS(3985),
    [anon_sym_SLASH] = ACTIONS(3985),
    [anon_sym_DOT] = ACTIONS(3987),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3987),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_GT_GT_GT] = ACTIONS(3987),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3985),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3985),
    [anon_sym_DASH] = ACTIONS(3985),
    [anon_sym_PERCENT] = ACTIONS(3987),
    [anon_sym_STAR_STAR] = ACTIONS(3987),
    [anon_sym_LT_EQ] = ACTIONS(3987),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3987),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3987),
    [anon_sym_GT_EQ] = ACTIONS(3987),
    [anon_sym_instanceof] = ACTIONS(3987),
    [anon_sym_BANG] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3987),
    [anon_sym_DASH_DASH] = ACTIONS(3987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3987),
    [anon_sym_implements] = ACTIONS(3987),
  },
  [1049] = {
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_as] = ACTIONS(589),
    [anon_sym_LBRACE] = ACTIONS(589),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(589),
    [anon_sym_in] = ACTIONS(2470),
    [anon_sym_COLON] = ACTIONS(589),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_RBRACK] = ACTIONS(589),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_GT] = ACTIONS(2470),
    [anon_sym_SLASH] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(589),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_AMP_AMP] = ACTIONS(589),
    [anon_sym_PIPE_PIPE] = ACTIONS(589),
    [anon_sym_GT_GT] = ACTIONS(2470),
    [anon_sym_GT_GT_GT] = ACTIONS(589),
    [anon_sym_LT_LT] = ACTIONS(589),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_CARET] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(589),
    [anon_sym_STAR_STAR] = ACTIONS(589),
    [anon_sym_LT_EQ] = ACTIONS(589),
    [anon_sym_EQ_EQ] = ACTIONS(2470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(589),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(589),
    [anon_sym_GT_EQ] = ACTIONS(589),
    [anon_sym_instanceof] = ACTIONS(589),
    [anon_sym_BANG] = ACTIONS(2470),
    [anon_sym_PLUS_PLUS] = ACTIONS(589),
    [anon_sym_DASH_DASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(589),
    [anon_sym_implements] = ACTIONS(589),
  },
  [1050] = {
    [anon_sym_STAR] = ACTIONS(2440),
    [anon_sym_as] = ACTIONS(2438),
    [anon_sym_LBRACE] = ACTIONS(2438),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_RBRACE] = ACTIONS(2438),
    [anon_sym_LPAREN] = ACTIONS(2438),
    [anon_sym_RPAREN] = ACTIONS(2438),
    [anon_sym_in] = ACTIONS(2440),
    [anon_sym_COLON] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(2438),
    [anon_sym_RBRACK] = ACTIONS(2438),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2440),
    [anon_sym_SLASH] = ACTIONS(2440),
    [anon_sym_DOT] = ACTIONS(2438),
    [anon_sym_QMARK] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2438),
    [anon_sym_PIPE_PIPE] = ACTIONS(2438),
    [anon_sym_GT_GT] = ACTIONS(2440),
    [anon_sym_GT_GT_GT] = ACTIONS(2438),
    [anon_sym_LT_LT] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2440),
    [anon_sym_CARET] = ACTIONS(2438),
    [anon_sym_PIPE] = ACTIONS(2440),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_DASH] = ACTIONS(2440),
    [anon_sym_PERCENT] = ACTIONS(2438),
    [anon_sym_STAR_STAR] = ACTIONS(2438),
    [anon_sym_LT_EQ] = ACTIONS(2438),
    [anon_sym_EQ_EQ] = ACTIONS(2440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2438),
    [anon_sym_BANG_EQ] = ACTIONS(2440),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2438),
    [anon_sym_GT_EQ] = ACTIONS(2438),
    [anon_sym_instanceof] = ACTIONS(2438),
    [anon_sym_BANG] = ACTIONS(2440),
    [anon_sym_PLUS_PLUS] = ACTIONS(2438),
    [anon_sym_DASH_DASH] = ACTIONS(2438),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2438),
    [anon_sym_implements] = ACTIONS(2438),
  },
  [1051] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3713),
  },
  [1052] = {
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_as] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_RPAREN] = ACTIONS(2424),
    [anon_sym_in] = ACTIONS(2426),
    [anon_sym_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK] = ACTIONS(3989),
    [anon_sym_RBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_GT] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2426),
    [anon_sym_DOT] = ACTIONS(2424),
    [anon_sym_QMARK] = ACTIONS(2424),
    [anon_sym_AMP_AMP] = ACTIONS(2424),
    [anon_sym_PIPE_PIPE] = ACTIONS(2424),
    [anon_sym_GT_GT] = ACTIONS(2426),
    [anon_sym_GT_GT_GT] = ACTIONS(2424),
    [anon_sym_LT_LT] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2426),
    [anon_sym_CARET] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_PERCENT] = ACTIONS(2424),
    [anon_sym_STAR_STAR] = ACTIONS(2424),
    [anon_sym_LT_EQ] = ACTIONS(2424),
    [anon_sym_EQ_EQ] = ACTIONS(2426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2424),
    [anon_sym_BANG_EQ] = ACTIONS(2426),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2424),
    [anon_sym_GT_EQ] = ACTIONS(2424),
    [anon_sym_instanceof] = ACTIONS(2424),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2424),
    [anon_sym_implements] = ACTIONS(2424),
  },
  [1053] = {
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_EQ] = ACTIONS(3615),
    [anon_sym_as] = ACTIONS(3617),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_in] = ACTIONS(3615),
    [anon_sym_of] = ACTIONS(3617),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3615),
    [anon_sym_GT] = ACTIONS(3615),
    [anon_sym_SLASH] = ACTIONS(3615),
    [anon_sym_DOT] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3615),
    [anon_sym_GT_GT_GT] = ACTIONS(3617),
    [anon_sym_LT_LT] = ACTIONS(3617),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_CARET] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_PERCENT] = ACTIONS(3617),
    [anon_sym_STAR_STAR] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ_EQ] = ACTIONS(3615),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3617),
    [anon_sym_BANG_EQ] = ACTIONS(3615),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_instanceof] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3617),
    [sym__automatic_semicolon] = ACTIONS(3617),
  },
  [1054] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(3994),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(3994),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(3994),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_implements] = ACTIONS(1209),
  },
  [1055] = {
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_as] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1081),
    [anon_sym_STAR_STAR] = ACTIONS(1081),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1081),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [anon_sym_implements] = ACTIONS(1081),
  },
  [1056] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(4000),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(4000),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_implements] = ACTIONS(1209),
  },
  [1057] = {
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_EQ] = ACTIONS(3627),
    [anon_sym_as] = ACTIONS(3629),
    [anon_sym_COMMA] = ACTIONS(3629),
    [anon_sym_RBRACE] = ACTIONS(3629),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_in] = ACTIONS(3627),
    [anon_sym_of] = ACTIONS(3629),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_COLON] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_LT] = ACTIONS(3627),
    [anon_sym_GT] = ACTIONS(3627),
    [anon_sym_SLASH] = ACTIONS(3627),
    [anon_sym_DOT] = ACTIONS(3629),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_GT_GT] = ACTIONS(3627),
    [anon_sym_GT_GT_GT] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3627),
    [anon_sym_CARET] = ACTIONS(3629),
    [anon_sym_PIPE] = ACTIONS(3627),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_PERCENT] = ACTIONS(3629),
    [anon_sym_STAR_STAR] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ] = ACTIONS(3627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_BANG_EQ] = ACTIONS(3627),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3629),
    [anon_sym_GT_EQ] = ACTIONS(3629),
    [anon_sym_instanceof] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3627),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3629),
    [sym__automatic_semicolon] = ACTIONS(3629),
  },
  [1058] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3694),
    [anon_sym_RBRACE] = ACTIONS(3694),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3694),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3694),
  },
  [1059] = {
    [anon_sym_STAR] = ACTIONS(1201),
    [anon_sym_as] = ACTIONS(1199),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_in] = ACTIONS(1201),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_RBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(1199),
    [anon_sym_QMARK] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_CARET] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1201),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_instanceof] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [anon_sym_implements] = ACTIONS(1199),
  },
  [1060] = {
    [anon_sym_STAR] = ACTIONS(2486),
    [anon_sym_as] = ACTIONS(2484),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_COMMA] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_RPAREN] = ACTIONS(2484),
    [anon_sym_in] = ACTIONS(2486),
    [anon_sym_COLON] = ACTIONS(2484),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_RBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2486),
    [anon_sym_GT] = ACTIONS(2486),
    [anon_sym_SLASH] = ACTIONS(2486),
    [anon_sym_DOT] = ACTIONS(2484),
    [anon_sym_QMARK] = ACTIONS(2484),
    [anon_sym_AMP_AMP] = ACTIONS(2484),
    [anon_sym_PIPE_PIPE] = ACTIONS(2484),
    [anon_sym_GT_GT] = ACTIONS(2486),
    [anon_sym_GT_GT_GT] = ACTIONS(2484),
    [anon_sym_LT_LT] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_CARET] = ACTIONS(2484),
    [anon_sym_PIPE] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2486),
    [anon_sym_PERCENT] = ACTIONS(2484),
    [anon_sym_STAR_STAR] = ACTIONS(2484),
    [anon_sym_LT_EQ] = ACTIONS(2484),
    [anon_sym_EQ_EQ] = ACTIONS(2486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2484),
    [anon_sym_BANG_EQ] = ACTIONS(2486),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2484),
    [anon_sym_GT_EQ] = ACTIONS(2484),
    [anon_sym_instanceof] = ACTIONS(2484),
    [anon_sym_BANG] = ACTIONS(2486),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [anon_sym_implements] = ACTIONS(2484),
  },
  [1061] = {
    [anon_sym_STAR] = ACTIONS(2346),
    [anon_sym_as] = ACTIONS(2344),
    [anon_sym_LBRACE] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_in] = ACTIONS(2346),
    [anon_sym_COLON] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_RBRACK] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_SLASH] = ACTIONS(2346),
    [anon_sym_DOT] = ACTIONS(3692),
    [anon_sym_QMARK] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_GT_GT] = ACTIONS(2346),
    [anon_sym_GT_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_CARET] = ACTIONS(2344),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_PERCENT] = ACTIONS(2344),
    [anon_sym_STAR_STAR] = ACTIONS(2344),
    [anon_sym_LT_EQ] = ACTIONS(2344),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2344),
    [anon_sym_BANG_EQ] = ACTIONS(2346),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2344),
    [anon_sym_GT_EQ] = ACTIONS(2344),
    [anon_sym_instanceof] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2346),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_implements] = ACTIONS(2344),
  },
  [1062] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(4003),
    [anon_sym_RBRACE] = ACTIONS(4003),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4003),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(4003),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1063] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3717),
    [anon_sym_RBRACE] = ACTIONS(3717),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3717),
  },
  [1064] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3719),
  },
  [1065] = {
    [anon_sym_STAR] = ACTIONS(2448),
    [anon_sym_as] = ACTIONS(2446),
    [anon_sym_LBRACE] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2446),
    [anon_sym_RPAREN] = ACTIONS(2446),
    [anon_sym_in] = ACTIONS(2448),
    [anon_sym_COLON] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [anon_sym_RBRACK] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_SLASH] = ACTIONS(2448),
    [anon_sym_DOT] = ACTIONS(2446),
    [anon_sym_QMARK] = ACTIONS(2446),
    [anon_sym_AMP_AMP] = ACTIONS(2446),
    [anon_sym_PIPE_PIPE] = ACTIONS(2446),
    [anon_sym_GT_GT] = ACTIONS(2448),
    [anon_sym_GT_GT_GT] = ACTIONS(2446),
    [anon_sym_LT_LT] = ACTIONS(2446),
    [anon_sym_AMP] = ACTIONS(2448),
    [anon_sym_CARET] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PERCENT] = ACTIONS(2446),
    [anon_sym_STAR_STAR] = ACTIONS(2446),
    [anon_sym_LT_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ] = ACTIONS(2448),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2448),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2446),
    [anon_sym_GT_EQ] = ACTIONS(2446),
    [anon_sym_instanceof] = ACTIONS(2446),
    [anon_sym_BANG] = ACTIONS(2448),
    [anon_sym_PLUS_PLUS] = ACTIONS(2446),
    [anon_sym_DASH_DASH] = ACTIONS(2446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2446),
    [anon_sym_implements] = ACTIONS(2446),
  },
  [1066] = {
    [anon_sym_STAR] = ACTIONS(4005),
    [anon_sym_as] = ACTIONS(3713),
    [anon_sym_LBRACE] = ACTIONS(3713),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3713),
    [anon_sym_RPAREN] = ACTIONS(3713),
    [anon_sym_in] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(3713),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_RBRACK] = ACTIONS(3713),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_GT] = ACTIONS(4005),
    [anon_sym_SLASH] = ACTIONS(4005),
    [anon_sym_DOT] = ACTIONS(3713),
    [anon_sym_QMARK] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3713),
    [anon_sym_PIPE_PIPE] = ACTIONS(3713),
    [anon_sym_GT_GT] = ACTIONS(4005),
    [anon_sym_GT_GT_GT] = ACTIONS(3713),
    [anon_sym_LT_LT] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(4005),
    [anon_sym_CARET] = ACTIONS(3713),
    [anon_sym_PIPE] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PERCENT] = ACTIONS(3713),
    [anon_sym_STAR_STAR] = ACTIONS(3713),
    [anon_sym_LT_EQ] = ACTIONS(3713),
    [anon_sym_EQ_EQ] = ACTIONS(4005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3713),
    [anon_sym_BANG_EQ] = ACTIONS(4005),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3713),
    [anon_sym_GT_EQ] = ACTIONS(3713),
    [anon_sym_instanceof] = ACTIONS(3713),
    [anon_sym_BANG] = ACTIONS(4005),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3713),
    [anon_sym_implements] = ACTIONS(3713),
  },
  [1067] = {
    [sym_object] = STATE(2824),
    [sym_assignment_pattern] = STATE(2374),
    [sym_array] = STATE(2825),
    [sym_spread_element] = STATE(2374),
    [sym_string] = STATE(1980),
    [sym_method_definition] = STATE(2374),
    [sym_pair] = STATE(2374),
    [sym__property_name] = STATE(1980),
    [sym_computed_property_name] = STATE(1980),
    [sym_accessibility_modifier] = STATE(1726),
    [aux_sym_object_repeat1] = STATE(2516),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_export] = ACTIONS(4007),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(4007),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4009),
    [anon_sym_type] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(3902),
    [anon_sym_async] = ACTIONS(4011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3906),
    [anon_sym_static] = ACTIONS(4013),
    [anon_sym_get] = ACTIONS(4015),
    [anon_sym_set] = ACTIONS(4015),
    [anon_sym_declare] = ACTIONS(4007),
    [anon_sym_public] = ACTIONS(4017),
    [anon_sym_private] = ACTIONS(4017),
    [anon_sym_protected] = ACTIONS(4017),
    [anon_sym_module] = ACTIONS(4007),
    [anon_sym_any] = ACTIONS(4007),
    [anon_sym_number] = ACTIONS(4007),
    [anon_sym_boolean] = ACTIONS(4007),
    [anon_sym_string] = ACTIONS(4007),
    [anon_sym_symbol] = ACTIONS(4007),
    [sym_readonly] = ACTIONS(145),
  },
  [1068] = {
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_as] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2458),
    [anon_sym_COMMA] = ACTIONS(2458),
    [anon_sym_RBRACE] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2458),
    [anon_sym_RPAREN] = ACTIONS(2458),
    [anon_sym_in] = ACTIONS(2460),
    [anon_sym_COLON] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2458),
    [anon_sym_RBRACK] = ACTIONS(2458),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_GT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2460),
    [anon_sym_DOT] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2458),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2458),
    [anon_sym_LT_LT] = ACTIONS(2458),
    [anon_sym_AMP] = ACTIONS(2460),
    [anon_sym_CARET] = ACTIONS(2458),
    [anon_sym_PIPE] = ACTIONS(2460),
    [anon_sym_PLUS] = ACTIONS(2460),
    [anon_sym_DASH] = ACTIONS(2460),
    [anon_sym_PERCENT] = ACTIONS(2458),
    [anon_sym_STAR_STAR] = ACTIONS(2458),
    [anon_sym_LT_EQ] = ACTIONS(2458),
    [anon_sym_EQ_EQ] = ACTIONS(2460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2458),
    [anon_sym_BANG_EQ] = ACTIONS(2460),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2458),
    [anon_sym_GT_EQ] = ACTIONS(2458),
    [anon_sym_instanceof] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(2458),
    [anon_sym_DASH_DASH] = ACTIONS(2458),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2458),
    [anon_sym_implements] = ACTIONS(2458),
  },
  [1069] = {
    [sym_type_arguments] = STATE(1106),
    [anon_sym_STAR] = ACTIONS(2498),
    [anon_sym_as] = ACTIONS(2496),
    [anon_sym_COMMA] = ACTIONS(2496),
    [anon_sym_RBRACE] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_RPAREN] = ACTIONS(2496),
    [anon_sym_in] = ACTIONS(2498),
    [anon_sym_COLON] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_RBRACK] = ACTIONS(2496),
    [anon_sym_LT] = ACTIONS(4019),
    [anon_sym_GT] = ACTIONS(2498),
    [anon_sym_SLASH] = ACTIONS(2498),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(2496),
    [anon_sym_AMP_AMP] = ACTIONS(2496),
    [anon_sym_PIPE_PIPE] = ACTIONS(2496),
    [anon_sym_GT_GT] = ACTIONS(2498),
    [anon_sym_GT_GT_GT] = ACTIONS(2496),
    [anon_sym_LT_LT] = ACTIONS(2496),
    [anon_sym_AMP] = ACTIONS(2498),
    [anon_sym_CARET] = ACTIONS(2496),
    [anon_sym_PIPE] = ACTIONS(2498),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2498),
    [anon_sym_PERCENT] = ACTIONS(2496),
    [anon_sym_STAR_STAR] = ACTIONS(2496),
    [anon_sym_LT_EQ] = ACTIONS(2496),
    [anon_sym_EQ_EQ] = ACTIONS(2498),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2496),
    [anon_sym_BANG_EQ] = ACTIONS(2498),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2496),
    [anon_sym_GT_EQ] = ACTIONS(2496),
    [anon_sym_instanceof] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2496),
    [anon_sym_is] = ACTIONS(4024),
  },
  [1070] = {
    [anon_sym_STAR] = ACTIONS(1117),
    [anon_sym_as] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1115),
    [anon_sym_else] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_in] = ACTIONS(1117),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(1115),
    [anon_sym_LBRACK] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_SLASH] = ACTIONS(1117),
    [anon_sym_DOT] = ACTIONS(1115),
    [anon_sym_QMARK] = ACTIONS(1115),
    [anon_sym_AMP_AMP] = ACTIONS(1115),
    [anon_sym_PIPE_PIPE] = ACTIONS(1115),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_GT_GT_GT] = ACTIONS(1115),
    [anon_sym_LT_LT] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1117),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_PIPE] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_PERCENT] = ACTIONS(1115),
    [anon_sym_STAR_STAR] = ACTIONS(1115),
    [anon_sym_LT_EQ] = ACTIONS(1115),
    [anon_sym_EQ_EQ] = ACTIONS(1117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1115),
    [anon_sym_BANG_EQ] = ACTIONS(1117),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1115),
    [anon_sym_instanceof] = ACTIONS(1115),
    [anon_sym_BANG] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1115),
    [sym__automatic_semicolon] = ACTIONS(1115),
  },
  [1071] = {
    [anon_sym_STAR] = ACTIONS(1193),
    [anon_sym_as] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_RPAREN] = ACTIONS(1195),
    [anon_sym_in] = ACTIONS(1193),
    [anon_sym_COLON] = ACTIONS(1195),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_RBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1193),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1193),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [anon_sym_implements] = ACTIONS(1195),
  },
  [1072] = {
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1131),
    [anon_sym_else] = ACTIONS(1131),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_in] = ACTIONS(1133),
    [anon_sym_while] = ACTIONS(1131),
    [anon_sym_SEMI] = ACTIONS(1131),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1131),
    [anon_sym_QMARK] = ACTIONS(1131),
    [anon_sym_AMP_AMP] = ACTIONS(1131),
    [anon_sym_PIPE_PIPE] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_GT_GT_GT] = ACTIONS(1131),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1131),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_PERCENT] = ACTIONS(1131),
    [anon_sym_STAR_STAR] = ACTIONS(1131),
    [anon_sym_LT_EQ] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1131),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1131),
    [anon_sym_GT_EQ] = ACTIONS(1131),
    [anon_sym_instanceof] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1133),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1131),
    [sym__automatic_semicolon] = ACTIONS(1131),
  },
  [1073] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3731),
  },
  [1074] = {
    [anon_sym_STAR] = ACTIONS(2456),
    [anon_sym_as] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_RPAREN] = ACTIONS(2454),
    [anon_sym_in] = ACTIONS(2456),
    [anon_sym_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_RBRACK] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_SLASH] = ACTIONS(2456),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_GT_GT] = ACTIONS(2456),
    [anon_sym_GT_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_STAR_STAR] = ACTIONS(2454),
    [anon_sym_LT_EQ] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(2456),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2456),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2454),
    [anon_sym_GT_EQ] = ACTIONS(2454),
    [anon_sym_instanceof] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2456),
    [anon_sym_PLUS_PLUS] = ACTIONS(2454),
    [anon_sym_DASH_DASH] = ACTIONS(2454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_implements] = ACTIONS(2454),
  },
  [1075] = {
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_as] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_COMMA] = ACTIONS(2400),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_LPAREN] = ACTIONS(2400),
    [anon_sym_RPAREN] = ACTIONS(2400),
    [anon_sym_in] = ACTIONS(2402),
    [anon_sym_COLON] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_RBRACK] = ACTIONS(2400),
    [anon_sym_LT] = ACTIONS(2402),
    [anon_sym_GT] = ACTIONS(2402),
    [anon_sym_SLASH] = ACTIONS(2402),
    [anon_sym_DOT] = ACTIONS(2400),
    [anon_sym_QMARK] = ACTIONS(2400),
    [anon_sym_AMP_AMP] = ACTIONS(2400),
    [anon_sym_PIPE_PIPE] = ACTIONS(2400),
    [anon_sym_GT_GT] = ACTIONS(2402),
    [anon_sym_GT_GT_GT] = ACTIONS(2400),
    [anon_sym_LT_LT] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2402),
    [anon_sym_CARET] = ACTIONS(2400),
    [anon_sym_PIPE] = ACTIONS(2402),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2402),
    [anon_sym_PERCENT] = ACTIONS(2400),
    [anon_sym_STAR_STAR] = ACTIONS(2400),
    [anon_sym_LT_EQ] = ACTIONS(2400),
    [anon_sym_EQ_EQ] = ACTIONS(2402),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2400),
    [anon_sym_BANG_EQ] = ACTIONS(2402),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2400),
    [anon_sym_GT_EQ] = ACTIONS(2400),
    [anon_sym_instanceof] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2400),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2400),
  },
  [1076] = {
    [anon_sym_STAR] = ACTIONS(4026),
    [anon_sym_as] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_in] = ACTIONS(4026),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_RBRACK] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_DOT] = ACTIONS(4028),
    [anon_sym_QMARK] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_STAR_STAR] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4026),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_instanceof] = ACTIONS(4028),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4028),
    [anon_sym_implements] = ACTIONS(4028),
  },
  [1077] = {
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_as] = ACTIONS(2416),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_RPAREN] = ACTIONS(2416),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_RBRACK] = ACTIONS(2416),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(2416),
    [anon_sym_QMARK] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_GT_GT] = ACTIONS(2418),
    [anon_sym_GT_GT_GT] = ACTIONS(2416),
    [anon_sym_LT_LT] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_CARET] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2416),
    [anon_sym_STAR_STAR] = ACTIONS(2416),
    [anon_sym_LT_EQ] = ACTIONS(2416),
    [anon_sym_EQ_EQ] = ACTIONS(2418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2416),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2416),
    [anon_sym_GT_EQ] = ACTIONS(2416),
    [anon_sym_instanceof] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2416),
    [anon_sym_implements] = ACTIONS(2416),
  },
  [1078] = {
    [anon_sym_STAR] = ACTIONS(2436),
    [anon_sym_as] = ACTIONS(2434),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2434),
    [anon_sym_RBRACE] = ACTIONS(2434),
    [anon_sym_LPAREN] = ACTIONS(2434),
    [anon_sym_RPAREN] = ACTIONS(2434),
    [anon_sym_in] = ACTIONS(2436),
    [anon_sym_COLON] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(3989),
    [anon_sym_RBRACK] = ACTIONS(2434),
    [anon_sym_LT] = ACTIONS(2436),
    [anon_sym_GT] = ACTIONS(2436),
    [anon_sym_SLASH] = ACTIONS(2436),
    [anon_sym_DOT] = ACTIONS(2434),
    [anon_sym_QMARK] = ACTIONS(2434),
    [anon_sym_AMP_AMP] = ACTIONS(2434),
    [anon_sym_PIPE_PIPE] = ACTIONS(2434),
    [anon_sym_GT_GT] = ACTIONS(2436),
    [anon_sym_GT_GT_GT] = ACTIONS(2434),
    [anon_sym_LT_LT] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_CARET] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_PERCENT] = ACTIONS(2434),
    [anon_sym_STAR_STAR] = ACTIONS(2434),
    [anon_sym_LT_EQ] = ACTIONS(2434),
    [anon_sym_EQ_EQ] = ACTIONS(2436),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2434),
    [anon_sym_BANG_EQ] = ACTIONS(2436),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2434),
    [anon_sym_GT_EQ] = ACTIONS(2434),
    [anon_sym_instanceof] = ACTIONS(2434),
    [anon_sym_BANG] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2434),
    [anon_sym_DASH_DASH] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2434),
    [anon_sym_implements] = ACTIONS(2434),
  },
  [1079] = {
    [anon_sym_STAR] = ACTIONS(4030),
    [anon_sym_as] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(4032),
    [anon_sym_COMMA] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(4032),
    [anon_sym_LPAREN] = ACTIONS(4032),
    [anon_sym_RPAREN] = ACTIONS(4032),
    [anon_sym_in] = ACTIONS(4030),
    [anon_sym_COLON] = ACTIONS(4032),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_RBRACK] = ACTIONS(4032),
    [anon_sym_LT] = ACTIONS(4030),
    [anon_sym_GT] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4030),
    [anon_sym_DOT] = ACTIONS(4032),
    [anon_sym_QMARK] = ACTIONS(4032),
    [anon_sym_AMP_AMP] = ACTIONS(4032),
    [anon_sym_PIPE_PIPE] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_GT_GT_GT] = ACTIONS(4032),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4030),
    [anon_sym_CARET] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4030),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_DASH] = ACTIONS(4030),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_LT_EQ] = ACTIONS(4032),
    [anon_sym_EQ_EQ] = ACTIONS(4030),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4032),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4032),
    [anon_sym_GT_EQ] = ACTIONS(4032),
    [anon_sym_instanceof] = ACTIONS(4032),
    [anon_sym_BANG] = ACTIONS(4030),
    [anon_sym_PLUS_PLUS] = ACTIONS(4032),
    [anon_sym_DASH_DASH] = ACTIONS(4032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4032),
    [anon_sym_implements] = ACTIONS(4032),
  },
  [1080] = {
    [anon_sym_STAR] = ACTIONS(4034),
    [anon_sym_as] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3715),
    [anon_sym_COMMA] = ACTIONS(3715),
    [anon_sym_RBRACE] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3715),
    [anon_sym_RPAREN] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(4034),
    [anon_sym_COLON] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_DOT] = ACTIONS(3715),
    [anon_sym_QMARK] = ACTIONS(3715),
    [anon_sym_AMP_AMP] = ACTIONS(3715),
    [anon_sym_PIPE_PIPE] = ACTIONS(3715),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [anon_sym_GT_GT_GT] = ACTIONS(3715),
    [anon_sym_LT_LT] = ACTIONS(3715),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_CARET] = ACTIONS(3715),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(3715),
    [anon_sym_STAR_STAR] = ACTIONS(3715),
    [anon_sym_LT_EQ] = ACTIONS(3715),
    [anon_sym_EQ_EQ] = ACTIONS(4034),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3715),
    [anon_sym_BANG_EQ] = ACTIONS(4034),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3715),
    [anon_sym_GT_EQ] = ACTIONS(3715),
    [anon_sym_instanceof] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(4034),
    [anon_sym_PLUS_PLUS] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [anon_sym_implements] = ACTIONS(3715),
  },
  [1081] = {
    [anon_sym_STAR] = ACTIONS(2422),
    [anon_sym_as] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_RBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_SLASH] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2420),
    [anon_sym_QMARK] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_GT_GT] = ACTIONS(2422),
    [anon_sym_GT_GT_GT] = ACTIONS(2420),
    [anon_sym_LT_LT] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_CARET] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2420),
    [anon_sym_STAR_STAR] = ACTIONS(2420),
    [anon_sym_LT_EQ] = ACTIONS(2420),
    [anon_sym_EQ_EQ] = ACTIONS(2422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2420),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2420),
    [anon_sym_GT_EQ] = ACTIONS(2420),
    [anon_sym_instanceof] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2420),
    [anon_sym_implements] = ACTIONS(2420),
  },
  [1082] = {
    [anon_sym_STAR] = ACTIONS(4036),
    [anon_sym_as] = ACTIONS(4038),
    [anon_sym_LBRACE] = ACTIONS(4038),
    [anon_sym_COMMA] = ACTIONS(4038),
    [anon_sym_RBRACE] = ACTIONS(4038),
    [anon_sym_LPAREN] = ACTIONS(4038),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [anon_sym_in] = ACTIONS(4036),
    [anon_sym_COLON] = ACTIONS(4038),
    [anon_sym_LBRACK] = ACTIONS(4038),
    [anon_sym_RBRACK] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4036),
    [anon_sym_SLASH] = ACTIONS(4036),
    [anon_sym_DOT] = ACTIONS(4038),
    [anon_sym_QMARK] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4036),
    [anon_sym_GT_GT_GT] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_CARET] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_PLUS] = ACTIONS(4036),
    [anon_sym_DASH] = ACTIONS(4036),
    [anon_sym_PERCENT] = ACTIONS(4038),
    [anon_sym_STAR_STAR] = ACTIONS(4038),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4038),
    [anon_sym_BANG_EQ] = ACTIONS(4036),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4038),
    [anon_sym_instanceof] = ACTIONS(4038),
    [anon_sym_BANG] = ACTIONS(4036),
    [anon_sym_PLUS_PLUS] = ACTIONS(4038),
    [anon_sym_DASH_DASH] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_implements] = ACTIONS(4038),
  },
  [1083] = {
    [anon_sym_STAR] = ACTIONS(4040),
    [anon_sym_as] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(3727),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_RBRACE] = ACTIONS(3727),
    [anon_sym_LPAREN] = ACTIONS(3727),
    [anon_sym_RPAREN] = ACTIONS(3727),
    [anon_sym_in] = ACTIONS(4040),
    [anon_sym_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3727),
    [anon_sym_RBRACK] = ACTIONS(3727),
    [anon_sym_LT] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4040),
    [anon_sym_SLASH] = ACTIONS(4040),
    [anon_sym_DOT] = ACTIONS(3727),
    [anon_sym_QMARK] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3727),
    [anon_sym_PIPE_PIPE] = ACTIONS(3727),
    [anon_sym_GT_GT] = ACTIONS(4040),
    [anon_sym_GT_GT_GT] = ACTIONS(3727),
    [anon_sym_LT_LT] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_CARET] = ACTIONS(3727),
    [anon_sym_PIPE] = ACTIONS(4040),
    [anon_sym_PLUS] = ACTIONS(4040),
    [anon_sym_DASH] = ACTIONS(4040),
    [anon_sym_PERCENT] = ACTIONS(3727),
    [anon_sym_STAR_STAR] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(3727),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3727),
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3727),
    [anon_sym_GT_EQ] = ACTIONS(3727),
    [anon_sym_instanceof] = ACTIONS(3727),
    [anon_sym_BANG] = ACTIONS(4040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3727),
    [anon_sym_DASH_DASH] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3727),
    [anon_sym_implements] = ACTIONS(3727),
  },
  [1084] = {
    [anon_sym_STAR] = ACTIONS(2432),
    [anon_sym_as] = ACTIONS(2430),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2430),
    [anon_sym_RBRACE] = ACTIONS(2430),
    [anon_sym_LPAREN] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(2430),
    [anon_sym_in] = ACTIONS(2432),
    [anon_sym_COLON] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_RBRACK] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2432),
    [anon_sym_GT] = ACTIONS(2432),
    [anon_sym_SLASH] = ACTIONS(2432),
    [anon_sym_DOT] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(2430),
    [anon_sym_AMP_AMP] = ACTIONS(2430),
    [anon_sym_PIPE_PIPE] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(2432),
    [anon_sym_GT_GT_GT] = ACTIONS(2430),
    [anon_sym_LT_LT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2432),
    [anon_sym_CARET] = ACTIONS(2430),
    [anon_sym_PIPE] = ACTIONS(2432),
    [anon_sym_PLUS] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2432),
    [anon_sym_PERCENT] = ACTIONS(2430),
    [anon_sym_STAR_STAR] = ACTIONS(2430),
    [anon_sym_LT_EQ] = ACTIONS(2430),
    [anon_sym_EQ_EQ] = ACTIONS(2432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2430),
    [anon_sym_BANG_EQ] = ACTIONS(2432),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2430),
    [anon_sym_GT_EQ] = ACTIONS(2430),
    [anon_sym_instanceof] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2430),
    [anon_sym_implements] = ACTIONS(2430),
  },
  [1085] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3744),
  },
  [1086] = {
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_else] = ACTIONS(1057),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_in] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1059),
    [anon_sym_DOT] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_GT_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_PERCENT] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1059),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_instanceof] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1057),
    [anon_sym_DASH_DASH] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [sym__automatic_semicolon] = ACTIONS(1057),
  },
  [1087] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3597),
    [anon_sym_as] = ACTIONS(3599),
    [anon_sym_COMMA] = ACTIONS(3599),
    [anon_sym_RBRACE] = ACTIONS(3599),
    [anon_sym_LPAREN] = ACTIONS(3599),
    [anon_sym_in] = ACTIONS(3597),
    [anon_sym_SEMI] = ACTIONS(3599),
    [anon_sym_LBRACK] = ACTIONS(3599),
    [anon_sym_LT] = ACTIONS(3597),
    [anon_sym_GT] = ACTIONS(3597),
    [anon_sym_SLASH] = ACTIONS(3597),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_QMARK] = ACTIONS(3599),
    [anon_sym_AMP_AMP] = ACTIONS(3599),
    [anon_sym_PIPE_PIPE] = ACTIONS(3599),
    [anon_sym_GT_GT] = ACTIONS(3597),
    [anon_sym_GT_GT_GT] = ACTIONS(3599),
    [anon_sym_LT_LT] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym_CARET] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(3597),
    [anon_sym_PLUS] = ACTIONS(3597),
    [anon_sym_DASH] = ACTIONS(3597),
    [anon_sym_PERCENT] = ACTIONS(3599),
    [anon_sym_STAR_STAR] = ACTIONS(3599),
    [anon_sym_LT_EQ] = ACTIONS(3599),
    [anon_sym_EQ_EQ] = ACTIONS(3597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3599),
    [anon_sym_BANG_EQ] = ACTIONS(3597),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3599),
    [anon_sym_GT_EQ] = ACTIONS(3599),
    [anon_sym_instanceof] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3597),
    [anon_sym_PLUS_PLUS] = ACTIONS(3599),
    [anon_sym_DASH_DASH] = ACTIONS(3599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3599),
    [sym__automatic_semicolon] = ACTIONS(3599),
  },
  [1088] = {
    [anon_sym_STAR] = ACTIONS(4042),
    [anon_sym_as] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3740),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_RBRACE] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3740),
    [anon_sym_RPAREN] = ACTIONS(3740),
    [anon_sym_in] = ACTIONS(4042),
    [anon_sym_COLON] = ACTIONS(3740),
    [anon_sym_LBRACK] = ACTIONS(3740),
    [anon_sym_RBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_SLASH] = ACTIONS(4042),
    [anon_sym_DOT] = ACTIONS(3740),
    [anon_sym_QMARK] = ACTIONS(3740),
    [anon_sym_AMP_AMP] = ACTIONS(3740),
    [anon_sym_PIPE_PIPE] = ACTIONS(3740),
    [anon_sym_GT_GT] = ACTIONS(4042),
    [anon_sym_GT_GT_GT] = ACTIONS(3740),
    [anon_sym_LT_LT] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(4042),
    [anon_sym_CARET] = ACTIONS(3740),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_PLUS] = ACTIONS(4042),
    [anon_sym_DASH] = ACTIONS(4042),
    [anon_sym_PERCENT] = ACTIONS(3740),
    [anon_sym_STAR_STAR] = ACTIONS(3740),
    [anon_sym_LT_EQ] = ACTIONS(3740),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3740),
    [anon_sym_BANG_EQ] = ACTIONS(4042),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3740),
    [anon_sym_GT_EQ] = ACTIONS(3740),
    [anon_sym_instanceof] = ACTIONS(3740),
    [anon_sym_BANG] = ACTIONS(4042),
    [anon_sym_PLUS_PLUS] = ACTIONS(3740),
    [anon_sym_DASH_DASH] = ACTIONS(3740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3740),
    [anon_sym_implements] = ACTIONS(3740),
  },
  [1089] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3660),
    [anon_sym_RBRACE] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3660),
  },
  [1090] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3742),
    [anon_sym_RBRACE] = ACTIONS(3742),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3742),
  },
  [1091] = {
    [anon_sym_STAR] = ACTIONS(2414),
    [anon_sym_as] = ACTIONS(2412),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [anon_sym_RPAREN] = ACTIONS(2412),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_RBRACK] = ACTIONS(2412),
    [anon_sym_LT] = ACTIONS(2414),
    [anon_sym_GT] = ACTIONS(2414),
    [anon_sym_SLASH] = ACTIONS(2414),
    [anon_sym_DOT] = ACTIONS(2412),
    [anon_sym_QMARK] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2412),
    [anon_sym_GT_GT] = ACTIONS(2414),
    [anon_sym_GT_GT_GT] = ACTIONS(2412),
    [anon_sym_LT_LT] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_CARET] = ACTIONS(2412),
    [anon_sym_PIPE] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PERCENT] = ACTIONS(2412),
    [anon_sym_STAR_STAR] = ACTIONS(2412),
    [anon_sym_LT_EQ] = ACTIONS(2412),
    [anon_sym_EQ_EQ] = ACTIONS(2414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2412),
    [anon_sym_BANG_EQ] = ACTIONS(2414),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2412),
    [anon_sym_GT_EQ] = ACTIONS(2412),
    [anon_sym_instanceof] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2414),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2412),
    [anon_sym_implements] = ACTIONS(2412),
  },
  [1092] = {
    [anon_sym_STAR] = ACTIONS(4044),
    [anon_sym_as] = ACTIONS(4046),
    [anon_sym_LBRACE] = ACTIONS(4046),
    [anon_sym_COMMA] = ACTIONS(4046),
    [anon_sym_RBRACE] = ACTIONS(4046),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(4046),
    [anon_sym_in] = ACTIONS(4044),
    [anon_sym_COLON] = ACTIONS(4046),
    [anon_sym_LBRACK] = ACTIONS(4046),
    [anon_sym_RBRACK] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_SLASH] = ACTIONS(4044),
    [anon_sym_DOT] = ACTIONS(4046),
    [anon_sym_QMARK] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(4044),
    [anon_sym_GT_GT_GT] = ACTIONS(4046),
    [anon_sym_LT_LT] = ACTIONS(4046),
    [anon_sym_AMP] = ACTIONS(4044),
    [anon_sym_CARET] = ACTIONS(4046),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_PLUS] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(4044),
    [anon_sym_PERCENT] = ACTIONS(4046),
    [anon_sym_STAR_STAR] = ACTIONS(4046),
    [anon_sym_LT_EQ] = ACTIONS(4046),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4046),
    [anon_sym_BANG_EQ] = ACTIONS(4044),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4046),
    [anon_sym_GT_EQ] = ACTIONS(4046),
    [anon_sym_instanceof] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(4044),
    [anon_sym_PLUS_PLUS] = ACTIONS(4046),
    [anon_sym_DASH_DASH] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [anon_sym_implements] = ACTIONS(4046),
  },
  [1093] = {
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_as] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2476),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_RPAREN] = ACTIONS(2476),
    [anon_sym_in] = ACTIONS(2478),
    [anon_sym_COLON] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_RBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2478),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_DOT] = ACTIONS(2476),
    [anon_sym_QMARK] = ACTIONS(2476),
    [anon_sym_AMP_AMP] = ACTIONS(2476),
    [anon_sym_PIPE_PIPE] = ACTIONS(2476),
    [anon_sym_GT_GT] = ACTIONS(2478),
    [anon_sym_GT_GT_GT] = ACTIONS(2476),
    [anon_sym_LT_LT] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_CARET] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_PERCENT] = ACTIONS(2476),
    [anon_sym_STAR_STAR] = ACTIONS(2476),
    [anon_sym_LT_EQ] = ACTIONS(2476),
    [anon_sym_EQ_EQ] = ACTIONS(2478),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2476),
    [anon_sym_BANG_EQ] = ACTIONS(2478),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2476),
    [anon_sym_GT_EQ] = ACTIONS(2476),
    [anon_sym_instanceof] = ACTIONS(2476),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2476),
    [anon_sym_implements] = ACTIONS(2476),
  },
  [1094] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3731),
  },
  [1095] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3688),
    [anon_sym_RBRACE] = ACTIONS(3688),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3688),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3688),
  },
  [1096] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_implements] = ACTIONS(1209),
  },
  [1097] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_RBRACE] = ACTIONS(3752),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3872),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3752),
  },
  [1098] = {
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_as] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_RBRACK] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_SLASH] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_GT_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_CARET] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_STAR_STAR] = ACTIONS(2462),
    [anon_sym_LT_EQ] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2462),
    [anon_sym_instanceof] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_implements] = ACTIONS(2462),
  },
  [1099] = {
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_as] = ACTIONS(4050),
    [anon_sym_LBRACE] = ACTIONS(4050),
    [anon_sym_COMMA] = ACTIONS(4050),
    [anon_sym_RBRACE] = ACTIONS(4050),
    [anon_sym_LPAREN] = ACTIONS(4050),
    [anon_sym_RPAREN] = ACTIONS(4050),
    [anon_sym_in] = ACTIONS(4048),
    [anon_sym_COLON] = ACTIONS(4050),
    [anon_sym_LBRACK] = ACTIONS(4050),
    [anon_sym_RBRACK] = ACTIONS(4050),
    [anon_sym_LT] = ACTIONS(4048),
    [anon_sym_GT] = ACTIONS(4048),
    [anon_sym_SLASH] = ACTIONS(4048),
    [anon_sym_DOT] = ACTIONS(4050),
    [anon_sym_QMARK] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4048),
    [anon_sym_GT_GT_GT] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_PLUS] = ACTIONS(4048),
    [anon_sym_DASH] = ACTIONS(4048),
    [anon_sym_PERCENT] = ACTIONS(4050),
    [anon_sym_STAR_STAR] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4050),
    [anon_sym_GT_EQ] = ACTIONS(4050),
    [anon_sym_instanceof] = ACTIONS(4050),
    [anon_sym_BANG] = ACTIONS(4048),
    [anon_sym_PLUS_PLUS] = ACTIONS(4050),
    [anon_sym_DASH_DASH] = ACTIONS(4050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4050),
    [anon_sym_implements] = ACTIONS(4050),
  },
  [1100] = {
    [anon_sym_STAR] = ACTIONS(2410),
    [anon_sym_as] = ACTIONS(2408),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_COMMA] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [anon_sym_LPAREN] = ACTIONS(2408),
    [anon_sym_RPAREN] = ACTIONS(2408),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_COLON] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2408),
    [anon_sym_RBRACK] = ACTIONS(2408),
    [anon_sym_LT] = ACTIONS(2410),
    [anon_sym_GT] = ACTIONS(2410),
    [anon_sym_SLASH] = ACTIONS(2410),
    [anon_sym_DOT] = ACTIONS(2408),
    [anon_sym_QMARK] = ACTIONS(2408),
    [anon_sym_AMP_AMP] = ACTIONS(2408),
    [anon_sym_PIPE_PIPE] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2410),
    [anon_sym_GT_GT_GT] = ACTIONS(2408),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_CARET] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_PERCENT] = ACTIONS(2408),
    [anon_sym_STAR_STAR] = ACTIONS(2408),
    [anon_sym_LT_EQ] = ACTIONS(2408),
    [anon_sym_EQ_EQ] = ACTIONS(2410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2408),
    [anon_sym_BANG_EQ] = ACTIONS(2410),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2408),
    [anon_sym_GT_EQ] = ACTIONS(2408),
    [anon_sym_instanceof] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_PLUS_PLUS] = ACTIONS(2408),
    [anon_sym_DASH_DASH] = ACTIONS(2408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2408),
    [anon_sym_implements] = ACTIONS(2408),
  },
  [1101] = {
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_RPAREN] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2468),
    [anon_sym_COLON] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_RBRACK] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_GT] = ACTIONS(2468),
    [anon_sym_SLASH] = ACTIONS(2468),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2468),
    [anon_sym_GT_GT_GT] = ACTIONS(2466),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_CARET] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(2468),
    [anon_sym_DASH] = ACTIONS(2468),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_STAR_STAR] = ACTIONS(2466),
    [anon_sym_LT_EQ] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2466),
    [anon_sym_GT_EQ] = ACTIONS(2466),
    [anon_sym_instanceof] = ACTIONS(2466),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(2466),
    [anon_sym_DASH_DASH] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2466),
    [anon_sym_implements] = ACTIONS(2466),
  },
  [1102] = {
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_as] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_RPAREN] = ACTIONS(2388),
    [anon_sym_in] = ACTIONS(2390),
    [anon_sym_COLON] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_RBRACK] = ACTIONS(2388),
    [anon_sym_LT] = ACTIONS(2390),
    [anon_sym_GT] = ACTIONS(2390),
    [anon_sym_SLASH] = ACTIONS(2390),
    [anon_sym_DOT] = ACTIONS(2388),
    [anon_sym_QMARK] = ACTIONS(2388),
    [anon_sym_AMP_AMP] = ACTIONS(2388),
    [anon_sym_PIPE_PIPE] = ACTIONS(2388),
    [anon_sym_GT_GT] = ACTIONS(2390),
    [anon_sym_GT_GT_GT] = ACTIONS(2388),
    [anon_sym_LT_LT] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_CARET] = ACTIONS(2388),
    [anon_sym_PIPE] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_PERCENT] = ACTIONS(2388),
    [anon_sym_STAR_STAR] = ACTIONS(2388),
    [anon_sym_LT_EQ] = ACTIONS(2388),
    [anon_sym_EQ_EQ] = ACTIONS(2390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2388),
    [anon_sym_BANG_EQ] = ACTIONS(2390),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2388),
    [anon_sym_GT_EQ] = ACTIONS(2388),
    [anon_sym_instanceof] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2388),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2388),
  },
  [1103] = {
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_as] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4054),
    [anon_sym_RBRACE] = ACTIONS(4054),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_RPAREN] = ACTIONS(4054),
    [anon_sym_in] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_RBRACK] = ACTIONS(4054),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4054),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_CARET] = ACTIONS(4054),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_PLUS] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_STAR_STAR] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_instanceof] = ACTIONS(4054),
    [anon_sym_BANG] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4054),
    [anon_sym_DASH_DASH] = ACTIONS(4054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4054),
    [anon_sym_implements] = ACTIONS(4054),
  },
  [1104] = {
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_as] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1107),
    [anon_sym_COMMA] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(1107),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1107),
    [anon_sym_in] = ACTIONS(1105),
    [anon_sym_COLON] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_RBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1107),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_GT_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1107),
    [anon_sym_LT_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1107),
    [anon_sym_GT_EQ] = ACTIONS(1107),
    [anon_sym_instanceof] = ACTIONS(1107),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_implements] = ACTIONS(1107),
  },
  [1105] = {
    [anon_sym_STAR] = ACTIONS(2398),
    [anon_sym_as] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_COMMA] = ACTIONS(2396),
    [anon_sym_RBRACE] = ACTIONS(2396),
    [anon_sym_LPAREN] = ACTIONS(2396),
    [anon_sym_RPAREN] = ACTIONS(2396),
    [anon_sym_in] = ACTIONS(2398),
    [anon_sym_COLON] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2396),
    [anon_sym_RBRACK] = ACTIONS(2396),
    [anon_sym_LT] = ACTIONS(2398),
    [anon_sym_GT] = ACTIONS(2398),
    [anon_sym_SLASH] = ACTIONS(2398),
    [anon_sym_DOT] = ACTIONS(2396),
    [anon_sym_QMARK] = ACTIONS(2396),
    [anon_sym_AMP_AMP] = ACTIONS(2396),
    [anon_sym_PIPE_PIPE] = ACTIONS(2396),
    [anon_sym_GT_GT] = ACTIONS(2398),
    [anon_sym_GT_GT_GT] = ACTIONS(2396),
    [anon_sym_LT_LT] = ACTIONS(2396),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_CARET] = ACTIONS(2396),
    [anon_sym_PIPE] = ACTIONS(2398),
    [anon_sym_PLUS] = ACTIONS(2398),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_PERCENT] = ACTIONS(2396),
    [anon_sym_STAR_STAR] = ACTIONS(2396),
    [anon_sym_LT_EQ] = ACTIONS(2396),
    [anon_sym_EQ_EQ] = ACTIONS(2398),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2396),
    [anon_sym_BANG_EQ] = ACTIONS(2398),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2396),
    [anon_sym_GT_EQ] = ACTIONS(2396),
    [anon_sym_instanceof] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_PLUS_PLUS] = ACTIONS(2396),
    [anon_sym_DASH_DASH] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2396),
  },
  [1106] = {
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_as] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2378),
    [anon_sym_COMMA] = ACTIONS(2378),
    [anon_sym_RBRACE] = ACTIONS(2378),
    [anon_sym_LPAREN] = ACTIONS(2378),
    [anon_sym_RPAREN] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2380),
    [anon_sym_COLON] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_RBRACK] = ACTIONS(2378),
    [anon_sym_LT] = ACTIONS(2380),
    [anon_sym_GT] = ACTIONS(2380),
    [anon_sym_SLASH] = ACTIONS(2380),
    [anon_sym_DOT] = ACTIONS(2378),
    [anon_sym_QMARK] = ACTIONS(2378),
    [anon_sym_AMP_AMP] = ACTIONS(2378),
    [anon_sym_PIPE_PIPE] = ACTIONS(2378),
    [anon_sym_GT_GT] = ACTIONS(2380),
    [anon_sym_GT_GT_GT] = ACTIONS(2378),
    [anon_sym_LT_LT] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2380),
    [anon_sym_CARET] = ACTIONS(2378),
    [anon_sym_PIPE] = ACTIONS(2380),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2380),
    [anon_sym_PERCENT] = ACTIONS(2378),
    [anon_sym_STAR_STAR] = ACTIONS(2378),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_EQ] = ACTIONS(2380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2378),
    [anon_sym_BANG_EQ] = ACTIONS(2380),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2378),
    [anon_sym_GT_EQ] = ACTIONS(2378),
    [anon_sym_instanceof] = ACTIONS(2378),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2378),
    [anon_sym_implements] = ACTIONS(2378),
  },
  [1107] = {
    [anon_sym_STAR] = ACTIONS(1149),
    [anon_sym_as] = ACTIONS(1151),
    [anon_sym_LBRACE] = ACTIONS(1151),
    [anon_sym_COMMA] = ACTIONS(1151),
    [anon_sym_RBRACE] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1151),
    [anon_sym_in] = ACTIONS(1149),
    [anon_sym_COLON] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(1149),
    [anon_sym_GT] = ACTIONS(1149),
    [anon_sym_SLASH] = ACTIONS(1149),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_QMARK] = ACTIONS(1151),
    [anon_sym_AMP_AMP] = ACTIONS(1151),
    [anon_sym_PIPE_PIPE] = ACTIONS(1151),
    [anon_sym_GT_GT] = ACTIONS(1149),
    [anon_sym_GT_GT_GT] = ACTIONS(1151),
    [anon_sym_LT_LT] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(1151),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_PLUS] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_PERCENT] = ACTIONS(1151),
    [anon_sym_STAR_STAR] = ACTIONS(1151),
    [anon_sym_LT_EQ] = ACTIONS(1151),
    [anon_sym_EQ_EQ] = ACTIONS(1149),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1151),
    [anon_sym_BANG_EQ] = ACTIONS(1149),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1151),
    [anon_sym_GT_EQ] = ACTIONS(1151),
    [anon_sym_instanceof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1149),
    [anon_sym_PLUS_PLUS] = ACTIONS(1151),
    [anon_sym_DASH_DASH] = ACTIONS(1151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1151),
    [anon_sym_implements] = ACTIONS(1151),
  },
  [1108] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_annotation] = STATE(2931),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4056),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1109] = {
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_as] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_COMMA] = ACTIONS(1217),
    [anon_sym_RBRACE] = ACTIONS(1217),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_RPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(1215),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(1217),
    [anon_sym_RBRACK] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1215),
    [anon_sym_GT] = ACTIONS(1215),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1217),
    [anon_sym_AMP_AMP] = ACTIONS(1217),
    [anon_sym_PIPE_PIPE] = ACTIONS(1217),
    [anon_sym_GT_GT] = ACTIONS(1215),
    [anon_sym_GT_GT_GT] = ACTIONS(1217),
    [anon_sym_LT_LT] = ACTIONS(1217),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1217),
    [anon_sym_PIPE] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1217),
    [anon_sym_STAR_STAR] = ACTIONS(1217),
    [anon_sym_LT_EQ] = ACTIONS(1217),
    [anon_sym_EQ_EQ] = ACTIONS(1215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1217),
    [anon_sym_BANG_EQ] = ACTIONS(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1217),
    [anon_sym_GT_EQ] = ACTIONS(1217),
    [anon_sym_instanceof] = ACTIONS(1217),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1217),
    [anon_sym_implements] = ACTIONS(1217),
  },
  [1110] = {
    [anon_sym_STAR] = ACTIONS(2384),
    [anon_sym_as] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(2382),
    [anon_sym_COMMA] = ACTIONS(2382),
    [anon_sym_RBRACE] = ACTIONS(2382),
    [anon_sym_LPAREN] = ACTIONS(2382),
    [anon_sym_RPAREN] = ACTIONS(2382),
    [anon_sym_in] = ACTIONS(2384),
    [anon_sym_COLON] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_RBRACK] = ACTIONS(2382),
    [anon_sym_LT] = ACTIONS(2384),
    [anon_sym_GT] = ACTIONS(2384),
    [anon_sym_SLASH] = ACTIONS(2384),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(2382),
    [anon_sym_AMP_AMP] = ACTIONS(2382),
    [anon_sym_PIPE_PIPE] = ACTIONS(2382),
    [anon_sym_GT_GT] = ACTIONS(2384),
    [anon_sym_GT_GT_GT] = ACTIONS(2382),
    [anon_sym_LT_LT] = ACTIONS(2382),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym_CARET] = ACTIONS(2382),
    [anon_sym_PIPE] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_PERCENT] = ACTIONS(2382),
    [anon_sym_STAR_STAR] = ACTIONS(2382),
    [anon_sym_LT_EQ] = ACTIONS(2382),
    [anon_sym_EQ_EQ] = ACTIONS(2384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2382),
    [anon_sym_BANG_EQ] = ACTIONS(2384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2382),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_instanceof] = ACTIONS(2382),
    [anon_sym_BANG] = ACTIONS(2384),
    [anon_sym_PLUS_PLUS] = ACTIONS(2382),
    [anon_sym_DASH_DASH] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2382),
    [anon_sym_implements] = ACTIONS(2382),
  },
  [1111] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3763),
    [anon_sym_RBRACE] = ACTIONS(3763),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3763),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3763),
  },
  [1112] = {
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_as] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_RPAREN] = ACTIONS(1239),
    [anon_sym_in] = ACTIONS(1237),
    [anon_sym_COLON] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_RBRACK] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1239),
    [anon_sym_QMARK] = ACTIONS(1239),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_GT_GT_GT] = ACTIONS(1239),
    [anon_sym_LT_LT] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PERCENT] = ACTIONS(1239),
    [anon_sym_STAR_STAR] = ACTIONS(1239),
    [anon_sym_LT_EQ] = ACTIONS(1239),
    [anon_sym_EQ_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1239),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1239),
    [anon_sym_GT_EQ] = ACTIONS(1239),
    [anon_sym_instanceof] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [anon_sym_implements] = ACTIONS(1239),
  },
  [1113] = {
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_as] = ACTIONS(2450),
    [anon_sym_LBRACE] = ACTIONS(2450),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(2450),
    [anon_sym_RPAREN] = ACTIONS(2450),
    [anon_sym_in] = ACTIONS(2452),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_RBRACK] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(2452),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_DOT] = ACTIONS(2450),
    [anon_sym_QMARK] = ACTIONS(2450),
    [anon_sym_AMP_AMP] = ACTIONS(2450),
    [anon_sym_PIPE_PIPE] = ACTIONS(2450),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_CARET] = ACTIONS(2450),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2452),
    [anon_sym_DASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_STAR_STAR] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_EQ_EQ] = ACTIONS(2452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG_EQ] = ACTIONS(2452),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_PLUS_PLUS] = ACTIONS(2450),
    [anon_sym_DASH_DASH] = ACTIONS(2450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2450),
    [anon_sym_implements] = ACTIONS(2450),
  },
  [1114] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_annotation] = STATE(2789),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1115] = {
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_as] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_COMMA] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_RPAREN] = ACTIONS(2392),
    [anon_sym_in] = ACTIONS(2394),
    [anon_sym_COLON] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_RBRACK] = ACTIONS(2392),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_GT] = ACTIONS(2394),
    [anon_sym_SLASH] = ACTIONS(2394),
    [anon_sym_DOT] = ACTIONS(2392),
    [anon_sym_QMARK] = ACTIONS(2392),
    [anon_sym_AMP_AMP] = ACTIONS(2392),
    [anon_sym_PIPE_PIPE] = ACTIONS(2392),
    [anon_sym_GT_GT] = ACTIONS(2394),
    [anon_sym_GT_GT_GT] = ACTIONS(2392),
    [anon_sym_LT_LT] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_CARET] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_PERCENT] = ACTIONS(2392),
    [anon_sym_STAR_STAR] = ACTIONS(2392),
    [anon_sym_LT_EQ] = ACTIONS(2392),
    [anon_sym_EQ_EQ] = ACTIONS(2394),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2392),
    [anon_sym_BANG_EQ] = ACTIONS(2394),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2392),
    [anon_sym_GT_EQ] = ACTIONS(2392),
    [anon_sym_instanceof] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2392),
    [anon_sym_implements] = ACTIONS(2392),
  },
  [1116] = {
    [anon_sym_STAR] = ACTIONS(2342),
    [anon_sym_as] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2340),
    [anon_sym_RBRACE] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_RPAREN] = ACTIONS(2340),
    [anon_sym_in] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_RBRACK] = ACTIONS(2340),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_GT] = ACTIONS(2342),
    [anon_sym_SLASH] = ACTIONS(2342),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(2342),
    [anon_sym_GT_GT_GT] = ACTIONS(2340),
    [anon_sym_LT_LT] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_CARET] = ACTIONS(2340),
    [anon_sym_PIPE] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_STAR_STAR] = ACTIONS(2340),
    [anon_sym_LT_EQ] = ACTIONS(2340),
    [anon_sym_EQ_EQ] = ACTIONS(2342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2342),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2340),
    [anon_sym_GT_EQ] = ACTIONS(2340),
    [anon_sym_instanceof] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_PLUS_PLUS] = ACTIONS(2340),
    [anon_sym_DASH_DASH] = ACTIONS(2340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2340),
    [anon_sym_implements] = ACTIONS(2340),
  },
  [1117] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3765),
  },
  [1118] = {
    [anon_sym_STAR] = ACTIONS(4063),
    [anon_sym_as] = ACTIONS(4065),
    [anon_sym_LBRACE] = ACTIONS(4065),
    [anon_sym_COMMA] = ACTIONS(4065),
    [anon_sym_RBRACE] = ACTIONS(4065),
    [anon_sym_LPAREN] = ACTIONS(4065),
    [anon_sym_RPAREN] = ACTIONS(4065),
    [anon_sym_in] = ACTIONS(4063),
    [anon_sym_COLON] = ACTIONS(4065),
    [anon_sym_LBRACK] = ACTIONS(4065),
    [anon_sym_RBRACK] = ACTIONS(4065),
    [anon_sym_LT] = ACTIONS(4063),
    [anon_sym_GT] = ACTIONS(4063),
    [anon_sym_SLASH] = ACTIONS(4063),
    [anon_sym_DOT] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(4065),
    [anon_sym_AMP_AMP] = ACTIONS(4065),
    [anon_sym_PIPE_PIPE] = ACTIONS(4065),
    [anon_sym_GT_GT] = ACTIONS(4063),
    [anon_sym_GT_GT_GT] = ACTIONS(4065),
    [anon_sym_LT_LT] = ACTIONS(4065),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_CARET] = ACTIONS(4065),
    [anon_sym_PIPE] = ACTIONS(4063),
    [anon_sym_PLUS] = ACTIONS(4063),
    [anon_sym_DASH] = ACTIONS(4063),
    [anon_sym_PERCENT] = ACTIONS(4065),
    [anon_sym_STAR_STAR] = ACTIONS(4065),
    [anon_sym_LT_EQ] = ACTIONS(4065),
    [anon_sym_EQ_EQ] = ACTIONS(4063),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4065),
    [anon_sym_BANG_EQ] = ACTIONS(4063),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4065),
    [anon_sym_GT_EQ] = ACTIONS(4065),
    [anon_sym_instanceof] = ACTIONS(4065),
    [anon_sym_BANG] = ACTIONS(4063),
    [anon_sym_PLUS_PLUS] = ACTIONS(4065),
    [anon_sym_DASH_DASH] = ACTIONS(4065),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4065),
    [anon_sym_implements] = ACTIONS(4065),
  },
  [1119] = {
    [sym_object] = STATE(2824),
    [sym_assignment_pattern] = STATE(2462),
    [sym_array] = STATE(2825),
    [sym_spread_element] = STATE(2462),
    [sym_string] = STATE(1980),
    [sym_method_definition] = STATE(2462),
    [sym_pair] = STATE(2462),
    [sym__property_name] = STATE(1980),
    [sym_computed_property_name] = STATE(1980),
    [sym_accessibility_modifier] = STATE(1726),
    [aux_sym_object_repeat1] = STATE(2453),
    [sym_identifier] = ACTIONS(4067),
    [anon_sym_export] = ACTIONS(4067),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(4067),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4069),
    [anon_sym_type] = ACTIONS(4067),
    [anon_sym_LBRACK] = ACTIONS(3902),
    [anon_sym_async] = ACTIONS(4071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3906),
    [anon_sym_static] = ACTIONS(4073),
    [anon_sym_get] = ACTIONS(4075),
    [anon_sym_set] = ACTIONS(4075),
    [anon_sym_declare] = ACTIONS(4067),
    [anon_sym_public] = ACTIONS(4077),
    [anon_sym_private] = ACTIONS(4077),
    [anon_sym_protected] = ACTIONS(4077),
    [anon_sym_module] = ACTIONS(4067),
    [anon_sym_any] = ACTIONS(4067),
    [anon_sym_number] = ACTIONS(4067),
    [anon_sym_boolean] = ACTIONS(4067),
    [anon_sym_string] = ACTIONS(4067),
    [anon_sym_symbol] = ACTIONS(4067),
    [sym_readonly] = ACTIONS(145),
  },
  [1120] = {
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_as] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_RBRACK] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1093),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_instanceof] = ACTIONS(1093),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_implements] = ACTIONS(1093),
  },
  [1121] = {
    [anon_sym_STAR] = ACTIONS(1225),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1227),
    [anon_sym_RPAREN] = ACTIONS(1227),
    [anon_sym_in] = ACTIONS(1225),
    [anon_sym_COLON] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1225),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1225),
    [anon_sym_GT_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_PERCENT] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1227),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1225),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [anon_sym_implements] = ACTIONS(1227),
  },
  [1122] = {
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_as] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_RBRACE] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2404),
    [anon_sym_RPAREN] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2406),
    [anon_sym_COLON] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_RBRACK] = ACTIONS(2404),
    [anon_sym_LT] = ACTIONS(2406),
    [anon_sym_GT] = ACTIONS(2406),
    [anon_sym_SLASH] = ACTIONS(2406),
    [anon_sym_DOT] = ACTIONS(2404),
    [anon_sym_QMARK] = ACTIONS(2404),
    [anon_sym_AMP_AMP] = ACTIONS(2404),
    [anon_sym_PIPE_PIPE] = ACTIONS(2404),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_GT_GT_GT] = ACTIONS(2404),
    [anon_sym_LT_LT] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_CARET] = ACTIONS(2404),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_PLUS] = ACTIONS(2406),
    [anon_sym_DASH] = ACTIONS(2406),
    [anon_sym_PERCENT] = ACTIONS(2404),
    [anon_sym_STAR_STAR] = ACTIONS(2404),
    [anon_sym_LT_EQ] = ACTIONS(2404),
    [anon_sym_EQ_EQ] = ACTIONS(2406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2404),
    [anon_sym_BANG_EQ] = ACTIONS(2406),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2404),
    [anon_sym_GT_EQ] = ACTIONS(2404),
    [anon_sym_instanceof] = ACTIONS(2404),
    [anon_sym_BANG] = ACTIONS(2406),
    [anon_sym_PLUS_PLUS] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2404),
    [anon_sym_implements] = ACTIONS(2404),
  },
  [1123] = {
    [anon_sym_STAR] = ACTIONS(2482),
    [anon_sym_as] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_RPAREN] = ACTIONS(2480),
    [anon_sym_in] = ACTIONS(2482),
    [anon_sym_COLON] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_RBRACK] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(2482),
    [anon_sym_GT] = ACTIONS(2482),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_DOT] = ACTIONS(2480),
    [anon_sym_QMARK] = ACTIONS(2480),
    [anon_sym_AMP_AMP] = ACTIONS(2480),
    [anon_sym_PIPE_PIPE] = ACTIONS(2480),
    [anon_sym_GT_GT] = ACTIONS(2482),
    [anon_sym_GT_GT_GT] = ACTIONS(2480),
    [anon_sym_LT_LT] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym_CARET] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_PERCENT] = ACTIONS(2480),
    [anon_sym_STAR_STAR] = ACTIONS(2480),
    [anon_sym_LT_EQ] = ACTIONS(2480),
    [anon_sym_EQ_EQ] = ACTIONS(2482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2480),
    [anon_sym_BANG_EQ] = ACTIONS(2482),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2480),
    [anon_sym_GT_EQ] = ACTIONS(2480),
    [anon_sym_instanceof] = ACTIONS(2480),
    [anon_sym_BANG] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2480),
    [anon_sym_implements] = ACTIONS(2480),
  },
  [1124] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3767),
    [anon_sym_RBRACE] = ACTIONS(3767),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3767),
  },
  [1125] = {
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_RPAREN] = ACTIONS(1185),
    [anon_sym_in] = ACTIONS(1183),
    [anon_sym_COLON] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_RBRACK] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1183),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_DOT] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(1185),
    [anon_sym_AMP_AMP] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_GT_GT] = ACTIONS(1183),
    [anon_sym_GT_GT_GT] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(1185),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1185),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_PERCENT] = ACTIONS(1185),
    [anon_sym_STAR_STAR] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1185),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1185),
    [anon_sym_GT_EQ] = ACTIONS(1185),
    [anon_sym_instanceof] = ACTIONS(1185),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1185),
    [anon_sym_implements] = ACTIONS(1185),
  },
  [1126] = {
    [anon_sym_STAR] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_RBRACE] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_RPAREN] = ACTIONS(1127),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_COLON] = ACTIONS(1127),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_RBRACK] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1125),
    [anon_sym_GT] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_GT_GT] = ACTIONS(1125),
    [anon_sym_GT_GT_GT] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_CARET] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1125),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1125),
    [anon_sym_PERCENT] = ACTIONS(1127),
    [anon_sym_STAR_STAR] = ACTIONS(1127),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_instanceof] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1127),
    [anon_sym_implements] = ACTIONS(1127),
  },
  [1127] = {
    [anon_sym_STAR] = ACTIONS(1173),
    [anon_sym_as] = ACTIONS(1175),
    [anon_sym_LBRACE] = ACTIONS(1175),
    [anon_sym_COMMA] = ACTIONS(1175),
    [anon_sym_RBRACE] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1175),
    [anon_sym_RPAREN] = ACTIONS(1175),
    [anon_sym_in] = ACTIONS(1173),
    [anon_sym_COLON] = ACTIONS(1175),
    [anon_sym_LBRACK] = ACTIONS(1175),
    [anon_sym_RBRACK] = ACTIONS(1175),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_DOT] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1175),
    [anon_sym_LT_LT] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1175),
    [anon_sym_STAR_STAR] = ACTIONS(1175),
    [anon_sym_LT_EQ] = ACTIONS(1175),
    [anon_sym_EQ_EQ] = ACTIONS(1173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1175),
    [anon_sym_BANG_EQ] = ACTIONS(1173),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1175),
    [anon_sym_GT_EQ] = ACTIONS(1175),
    [anon_sym_instanceof] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1175),
    [anon_sym_implements] = ACTIONS(1175),
  },
  [1128] = {
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_as] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1165),
    [anon_sym_COMMA] = ACTIONS(1165),
    [anon_sym_RBRACE] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1165),
    [anon_sym_RPAREN] = ACTIONS(1165),
    [anon_sym_in] = ACTIONS(1163),
    [anon_sym_COLON] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1163),
    [anon_sym_GT] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_DOT] = ACTIONS(1165),
    [anon_sym_QMARK] = ACTIONS(1165),
    [anon_sym_AMP_AMP] = ACTIONS(1165),
    [anon_sym_PIPE_PIPE] = ACTIONS(1165),
    [anon_sym_GT_GT] = ACTIONS(1163),
    [anon_sym_GT_GT_GT] = ACTIONS(1165),
    [anon_sym_LT_LT] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_CARET] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_STAR_STAR] = ACTIONS(1165),
    [anon_sym_LT_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ] = ACTIONS(1163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ] = ACTIONS(1163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1165),
    [anon_sym_GT_EQ] = ACTIONS(1165),
    [anon_sym_instanceof] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1165),
    [anon_sym_implements] = ACTIONS(1165),
  },
  [1129] = {
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1141),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_in] = ACTIONS(1139),
    [anon_sym_COLON] = ACTIONS(1141),
    [anon_sym_LBRACK] = ACTIONS(1141),
    [anon_sym_RBRACK] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(1139),
    [anon_sym_GT] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1141),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_AMP_AMP] = ACTIONS(1141),
    [anon_sym_PIPE_PIPE] = ACTIONS(1141),
    [anon_sym_GT_GT] = ACTIONS(1139),
    [anon_sym_GT_GT_GT] = ACTIONS(1141),
    [anon_sym_LT_LT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(1139),
    [anon_sym_CARET] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1139),
    [anon_sym_PERCENT] = ACTIONS(1141),
    [anon_sym_STAR_STAR] = ACTIONS(1141),
    [anon_sym_LT_EQ] = ACTIONS(1141),
    [anon_sym_EQ_EQ] = ACTIONS(1139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1141),
    [anon_sym_BANG_EQ] = ACTIONS(1139),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1141),
    [anon_sym_GT_EQ] = ACTIONS(1141),
    [anon_sym_instanceof] = ACTIONS(1141),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_PLUS_PLUS] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_implements] = ACTIONS(1141),
  },
  [1130] = {
    [anon_sym_STAR] = ACTIONS(4079),
    [anon_sym_as] = ACTIONS(4081),
    [anon_sym_LBRACE] = ACTIONS(4081),
    [anon_sym_COMMA] = ACTIONS(4081),
    [anon_sym_RBRACE] = ACTIONS(4081),
    [anon_sym_LPAREN] = ACTIONS(4081),
    [anon_sym_RPAREN] = ACTIONS(4081),
    [anon_sym_in] = ACTIONS(4079),
    [anon_sym_COLON] = ACTIONS(4081),
    [anon_sym_LBRACK] = ACTIONS(4081),
    [anon_sym_RBRACK] = ACTIONS(4081),
    [anon_sym_LT] = ACTIONS(4079),
    [anon_sym_GT] = ACTIONS(4079),
    [anon_sym_SLASH] = ACTIONS(4079),
    [anon_sym_DOT] = ACTIONS(4081),
    [anon_sym_QMARK] = ACTIONS(4081),
    [anon_sym_AMP_AMP] = ACTIONS(4081),
    [anon_sym_PIPE_PIPE] = ACTIONS(4081),
    [anon_sym_GT_GT] = ACTIONS(4079),
    [anon_sym_GT_GT_GT] = ACTIONS(4081),
    [anon_sym_LT_LT] = ACTIONS(4081),
    [anon_sym_AMP] = ACTIONS(4079),
    [anon_sym_CARET] = ACTIONS(4081),
    [anon_sym_PIPE] = ACTIONS(4079),
    [anon_sym_PLUS] = ACTIONS(4079),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_PERCENT] = ACTIONS(4081),
    [anon_sym_STAR_STAR] = ACTIONS(4081),
    [anon_sym_LT_EQ] = ACTIONS(4081),
    [anon_sym_EQ_EQ] = ACTIONS(4079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4081),
    [anon_sym_BANG_EQ] = ACTIONS(4079),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4081),
    [anon_sym_GT_EQ] = ACTIONS(4081),
    [anon_sym_instanceof] = ACTIONS(4081),
    [anon_sym_BANG] = ACTIONS(4079),
    [anon_sym_PLUS_PLUS] = ACTIONS(4081),
    [anon_sym_DASH_DASH] = ACTIONS(4081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4081),
    [anon_sym_implements] = ACTIONS(4081),
  },
  [1131] = {
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_in] = ACTIONS(1059),
    [anon_sym_COLON] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_RBRACK] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1059),
    [anon_sym_DOT] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_GT_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_PERCENT] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1059),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_instanceof] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1057),
    [anon_sym_DASH_DASH] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_implements] = ACTIONS(1057),
  },
  [1132] = {
    [anon_sym_STAR] = ACTIONS(1117),
    [anon_sym_as] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_RPAREN] = ACTIONS(1115),
    [anon_sym_in] = ACTIONS(1117),
    [anon_sym_COLON] = ACTIONS(1115),
    [anon_sym_LBRACK] = ACTIONS(1115),
    [anon_sym_RBRACK] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_SLASH] = ACTIONS(1117),
    [anon_sym_DOT] = ACTIONS(1115),
    [anon_sym_QMARK] = ACTIONS(1115),
    [anon_sym_AMP_AMP] = ACTIONS(1115),
    [anon_sym_PIPE_PIPE] = ACTIONS(1115),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_GT_GT_GT] = ACTIONS(1115),
    [anon_sym_LT_LT] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1117),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_PIPE] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_PERCENT] = ACTIONS(1115),
    [anon_sym_STAR_STAR] = ACTIONS(1115),
    [anon_sym_LT_EQ] = ACTIONS(1115),
    [anon_sym_EQ_EQ] = ACTIONS(1117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1115),
    [anon_sym_BANG_EQ] = ACTIONS(1117),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1115),
    [anon_sym_instanceof] = ACTIONS(1115),
    [anon_sym_BANG] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1115),
  },
  [1133] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3731),
  },
  [1134] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3713),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3713),
  },
  [1135] = {
    [sym_string] = STATE(1787),
    [sym_decorator] = STATE(1194),
    [sym_public_field_definition] = STATE(2416),
    [sym_method_definition] = STATE(1690),
    [sym__property_name] = STATE(1787),
    [sym_computed_property_name] = STATE(1787),
    [sym_method_signature] = STATE(2416),
    [sym_abstract_method_signature] = STATE(2416),
    [sym_accessibility_modifier] = STATE(1716),
    [sym_index_signature] = STATE(2416),
    [aux_sym_class_body_repeat1] = STATE(1194),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4083),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(4085),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_async] = ACTIONS(4087),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_get] = ACTIONS(4095),
    [anon_sym_set] = ACTIONS(4095),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4097),
  },
  [1136] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4099),
    [anon_sym_COMMA] = ACTIONS(3717),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3717),
  },
  [1137] = {
    [sym_string] = STATE(1797),
    [sym__property_name] = STATE(1797),
    [sym_computed_property_name] = STATE(1797),
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4101),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(4107),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4109),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4111),
    [anon_sym_set] = ACTIONS(4111),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1138] = {
    [anon_sym_STAR] = ACTIONS(4115),
    [anon_sym_as] = ACTIONS(4115),
    [anon_sym_COMMA] = ACTIONS(4117),
    [anon_sym_RBRACE] = ACTIONS(4117),
    [anon_sym_LPAREN] = ACTIONS(4117),
    [anon_sym_RPAREN] = ACTIONS(4117),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_COLON] = ACTIONS(4117),
    [anon_sym_LBRACK] = ACTIONS(4117),
    [anon_sym_RBRACK] = ACTIONS(4117),
    [anon_sym_LT] = ACTIONS(4115),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4115),
    [anon_sym_DOT] = ACTIONS(4117),
    [anon_sym_QMARK] = ACTIONS(4117),
    [anon_sym_AMP_AMP] = ACTIONS(4117),
    [anon_sym_PIPE_PIPE] = ACTIONS(4117),
    [anon_sym_GT_GT] = ACTIONS(4115),
    [anon_sym_GT_GT_GT] = ACTIONS(4117),
    [anon_sym_LT_LT] = ACTIONS(4117),
    [anon_sym_AMP] = ACTIONS(4115),
    [anon_sym_CARET] = ACTIONS(4117),
    [anon_sym_PIPE] = ACTIONS(4115),
    [anon_sym_PLUS] = ACTIONS(4115),
    [anon_sym_DASH] = ACTIONS(4115),
    [anon_sym_PERCENT] = ACTIONS(4117),
    [anon_sym_STAR_STAR] = ACTIONS(4117),
    [anon_sym_LT_EQ] = ACTIONS(4117),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4117),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4117),
    [anon_sym_GT_EQ] = ACTIONS(4117),
    [anon_sym_instanceof] = ACTIONS(4115),
    [anon_sym_BANG] = ACTIONS(4115),
    [anon_sym_PLUS_PLUS] = ACTIONS(4117),
    [anon_sym_DASH_DASH] = ACTIONS(4117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4117),
    [sym_regex_flags] = ACTIONS(4119),
  },
  [1139] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [aux_sym_array_repeat1] = STATE(2481),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4121),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1140] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4123),
    [anon_sym_COMMA] = ACTIONS(3769),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3769),
  },
  [1141] = {
    [sym_type_arguments] = STATE(1382),
    [anon_sym_STAR] = ACTIONS(2498),
    [anon_sym_as] = ACTIONS(2496),
    [anon_sym_COMMA] = ACTIONS(2496),
    [anon_sym_RBRACE] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_in] = ACTIONS(2498),
    [anon_sym_SEMI] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_LT] = ACTIONS(4125),
    [anon_sym_GT] = ACTIONS(2498),
    [anon_sym_SLASH] = ACTIONS(2498),
    [anon_sym_DOT] = ACTIONS(4128),
    [anon_sym_QMARK] = ACTIONS(2496),
    [anon_sym_AMP_AMP] = ACTIONS(2496),
    [anon_sym_PIPE_PIPE] = ACTIONS(2496),
    [anon_sym_GT_GT] = ACTIONS(2498),
    [anon_sym_GT_GT_GT] = ACTIONS(2496),
    [anon_sym_LT_LT] = ACTIONS(2496),
    [anon_sym_AMP] = ACTIONS(2498),
    [anon_sym_CARET] = ACTIONS(2496),
    [anon_sym_PIPE] = ACTIONS(2498),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2498),
    [anon_sym_PERCENT] = ACTIONS(2496),
    [anon_sym_STAR_STAR] = ACTIONS(2496),
    [anon_sym_LT_EQ] = ACTIONS(2496),
    [anon_sym_EQ_EQ] = ACTIONS(2498),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2496),
    [anon_sym_BANG_EQ] = ACTIONS(2498),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2496),
    [anon_sym_GT_EQ] = ACTIONS(2496),
    [anon_sym_instanceof] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2496),
    [anon_sym_is] = ACTIONS(4130),
    [sym__automatic_semicolon] = ACTIONS(2496),
  },
  [1142] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3731),
  },
  [1143] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3744),
  },
  [1144] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_COMMA] = ACTIONS(3742),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3742),
  },
  [1145] = {
    [sym_string] = STATE(1797),
    [sym__property_name] = STATE(1797),
    [sym_computed_property_name] = STATE(1797),
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4101),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(4107),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4109),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4111),
    [anon_sym_set] = ACTIONS(4111),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1146] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [aux_sym_array_repeat1] = STATE(2373),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4132),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1147] = {
    [anon_sym_STAR] = ACTIONS(1201),
    [anon_sym_as] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_else] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_in] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1199),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(1199),
    [anon_sym_QMARK] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_CARET] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1201),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_instanceof] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [sym__automatic_semicolon] = ACTIONS(4134),
  },
  [1148] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4136),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3719),
  },
  [1149] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3731),
  },
  [1150] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4140),
  },
  [1151] = {
    [sym_string] = STATE(1787),
    [sym_decorator] = STATE(1223),
    [sym_public_field_definition] = STATE(2416),
    [sym_method_definition] = STATE(1690),
    [sym__property_name] = STATE(1787),
    [sym_computed_property_name] = STATE(1787),
    [sym_method_signature] = STATE(2416),
    [sym_abstract_method_signature] = STATE(2416),
    [sym_accessibility_modifier] = STATE(1716),
    [sym_index_signature] = STATE(2416),
    [aux_sym_class_body_repeat1] = STATE(1223),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4083),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(4142),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_async] = ACTIONS(4087),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_get] = ACTIONS(4095),
    [anon_sym_set] = ACTIONS(4095),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4097),
  },
  [1152] = {
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_as] = ACTIONS(3609),
    [anon_sym_COMMA] = ACTIONS(3609),
    [anon_sym_RBRACE] = ACTIONS(3609),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3611),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym_COLON] = ACTIONS(3725),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_LT] = ACTIONS(3611),
    [anon_sym_GT] = ACTIONS(3611),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_DOT] = ACTIONS(3609),
    [anon_sym_EQ_GT] = ACTIONS(3725),
    [anon_sym_QMARK] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_PIPE_PIPE] = ACTIONS(3609),
    [anon_sym_GT_GT] = ACTIONS(3611),
    [anon_sym_GT_GT_GT] = ACTIONS(3609),
    [anon_sym_LT_LT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_CARET] = ACTIONS(3609),
    [anon_sym_PIPE] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3609),
    [anon_sym_STAR_STAR] = ACTIONS(3609),
    [anon_sym_LT_EQ] = ACTIONS(3609),
    [anon_sym_EQ_EQ] = ACTIONS(3611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3609),
    [anon_sym_BANG_EQ] = ACTIONS(3611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3609),
    [anon_sym_GT_EQ] = ACTIONS(3609),
    [anon_sym_instanceof] = ACTIONS(3609),
    [anon_sym_BANG] = ACTIONS(3611),
    [anon_sym_PLUS_PLUS] = ACTIONS(3609),
    [anon_sym_DASH_DASH] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3609),
    [sym__automatic_semicolon] = ACTIONS(3609),
  },
  [1153] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3752),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3752),
  },
  [1154] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4147),
  },
  [1155] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3688),
    [anon_sym_COMMA] = ACTIONS(3688),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3688),
  },
  [1156] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(3694),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3694),
  },
  [1157] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3729),
    [anon_sym_GT_GT_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3731),
  },
  [1158] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3731),
  },
  [1159] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3731),
  },
  [1160] = {
    [sym_string] = STATE(1787),
    [sym_decorator] = STATE(1223),
    [sym_public_field_definition] = STATE(2416),
    [sym_method_definition] = STATE(1690),
    [sym__property_name] = STATE(1787),
    [sym_computed_property_name] = STATE(1787),
    [sym_method_signature] = STATE(2416),
    [sym_abstract_method_signature] = STATE(2416),
    [sym_accessibility_modifier] = STATE(1716),
    [sym_index_signature] = STATE(2416),
    [aux_sym_class_body_repeat1] = STATE(1223),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4083),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(4152),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_async] = ACTIONS(4087),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_get] = ACTIONS(4095),
    [anon_sym_set] = ACTIONS(4095),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4097),
  },
  [1161] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3601),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1209),
  },
  [1162] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(3601),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1209),
  },
  [1163] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3731),
  },
  [1164] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3731),
  },
  [1165] = {
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_as] = ACTIONS(1077),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_else] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_in] = ACTIONS(1079),
    [anon_sym_while] = ACTIONS(1077),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_SLASH] = ACTIONS(1079),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(1079),
    [anon_sym_DASH] = ACTIONS(1079),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1079),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1077),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [sym__automatic_semicolon] = ACTIONS(1077),
  },
  [1166] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4154),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1167] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3729),
    [anon_sym_GT_GT_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3731),
  },
  [1168] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [aux_sym_array_repeat1] = STATE(2369),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1169] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(3763),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3763),
  },
  [1170] = {
    [sym_string] = STATE(1787),
    [sym_decorator] = STATE(1233),
    [sym_public_field_definition] = STATE(2416),
    [sym_method_definition] = STATE(1690),
    [sym__property_name] = STATE(1787),
    [sym_computed_property_name] = STATE(1787),
    [sym_method_signature] = STATE(2416),
    [sym_abstract_method_signature] = STATE(2416),
    [sym_accessibility_modifier] = STATE(1716),
    [sym_index_signature] = STATE(2416),
    [aux_sym_class_body_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4083),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(4160),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_async] = ACTIONS(4087),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_get] = ACTIONS(4095),
    [anon_sym_set] = ACTIONS(4095),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4097),
  },
  [1171] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3729),
    [anon_sym_GT_GT_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3731),
  },
  [1172] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3979),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
  },
  [1173] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3738),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_in] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_GT] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_GT_GT] = ACTIONS(3736),
    [anon_sym_GT_GT_GT] = ACTIONS(3738),
    [anon_sym_LT_LT] = ACTIONS(3738),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_CARET] = ACTIONS(3738),
    [anon_sym_PIPE] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_STAR_STAR] = ACTIONS(3738),
    [anon_sym_LT_EQ] = ACTIONS(3738),
    [anon_sym_EQ_EQ] = ACTIONS(3736),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3738),
    [anon_sym_GT_EQ] = ACTIONS(3738),
    [anon_sym_instanceof] = ACTIONS(3738),
    [anon_sym_BANG] = ACTIONS(3736),
    [anon_sym_PLUS_PLUS] = ACTIONS(3738),
    [anon_sym_DASH_DASH] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3738),
    [anon_sym_implements] = ACTIONS(3738),
  },
  [1174] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3752),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3750),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3752),
  },
  [1175] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [aux_sym_array_repeat1] = STATE(2456),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(4165),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1176] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [aux_sym_array_repeat1] = STATE(2456),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(4167),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1177] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(3767),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3767),
  },
  [1178] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3752),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3752),
  },
  [1179] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3750),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(4171),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3752),
  },
  [1180] = {
    [sym_arguments] = STATE(1424),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3625),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [sym__automatic_semicolon] = ACTIONS(3261),
  },
  [1181] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(3688),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3688),
  },
  [1182] = {
    [sym_string] = STATE(1787),
    [sym_decorator] = STATE(1223),
    [sym_public_field_definition] = STATE(2416),
    [sym_method_definition] = STATE(1690),
    [sym__property_name] = STATE(1787),
    [sym_computed_property_name] = STATE(1787),
    [sym_method_signature] = STATE(2416),
    [sym_abstract_method_signature] = STATE(2416),
    [sym_accessibility_modifier] = STATE(1716),
    [sym_index_signature] = STATE(2416),
    [aux_sym_class_body_repeat1] = STATE(1223),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4083),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(4176),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_async] = ACTIONS(4087),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_get] = ACTIONS(4095),
    [anon_sym_set] = ACTIONS(4095),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4097),
  },
  [1183] = {
    [sym_arguments] = STATE(1424),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3613),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [sym__automatic_semicolon] = ACTIONS(3261),
  },
  [1184] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3731),
  },
  [1185] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_COMMA] = ACTIONS(3694),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3694),
  },
  [1186] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(4140),
  },
  [1187] = {
    [sym_string] = STATE(1787),
    [sym_decorator] = STATE(1151),
    [sym_public_field_definition] = STATE(2416),
    [sym_method_definition] = STATE(1690),
    [sym__property_name] = STATE(1787),
    [sym_computed_property_name] = STATE(1787),
    [sym_method_signature] = STATE(2416),
    [sym_abstract_method_signature] = STATE(2416),
    [sym_accessibility_modifier] = STATE(1716),
    [sym_index_signature] = STATE(2416),
    [aux_sym_class_body_repeat1] = STATE(1151),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4083),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(4180),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_async] = ACTIONS(4087),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_get] = ACTIONS(4095),
    [anon_sym_set] = ACTIONS(4095),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4097),
  },
  [1188] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3775),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3775),
  },
  [1189] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [aux_sym_array_repeat1] = STATE(2456),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1190] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4147),
  },
  [1191] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3767),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3767),
  },
  [1192] = {
    [sym_string] = STATE(1787),
    [sym_decorator] = STATE(1160),
    [sym_public_field_definition] = STATE(2416),
    [sym_method_definition] = STATE(1690),
    [sym__property_name] = STATE(1787),
    [sym_computed_property_name] = STATE(1787),
    [sym_method_signature] = STATE(2416),
    [sym_abstract_method_signature] = STATE(2416),
    [sym_accessibility_modifier] = STATE(1716),
    [sym_index_signature] = STATE(2416),
    [aux_sym_class_body_repeat1] = STATE(1160),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4083),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_async] = ACTIONS(4087),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_get] = ACTIONS(4095),
    [anon_sym_set] = ACTIONS(4095),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4097),
  },
  [1193] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3727),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3727),
  },
  [1194] = {
    [sym_string] = STATE(1787),
    [sym_decorator] = STATE(1223),
    [sym_public_field_definition] = STATE(2416),
    [sym_method_definition] = STATE(1690),
    [sym__property_name] = STATE(1787),
    [sym_computed_property_name] = STATE(1787),
    [sym_method_signature] = STATE(2416),
    [sym_abstract_method_signature] = STATE(2416),
    [sym_accessibility_modifier] = STATE(1716),
    [sym_index_signature] = STATE(2416),
    [aux_sym_class_body_repeat1] = STATE(1223),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4083),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(4188),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_async] = ACTIONS(4087),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_get] = ACTIONS(4095),
    [anon_sym_set] = ACTIONS(4095),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4097),
  },
  [1195] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4147),
  },
  [1196] = {
    [sym_string] = STATE(1787),
    [sym_decorator] = STATE(1201),
    [sym_public_field_definition] = STATE(2416),
    [sym_method_definition] = STATE(1690),
    [sym__property_name] = STATE(1787),
    [sym_computed_property_name] = STATE(1787),
    [sym_method_signature] = STATE(2416),
    [sym_abstract_method_signature] = STATE(2416),
    [sym_accessibility_modifier] = STATE(1716),
    [sym_index_signature] = STATE(2416),
    [aux_sym_class_body_repeat1] = STATE(1201),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4083),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(4190),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_async] = ACTIONS(4087),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_get] = ACTIONS(4095),
    [anon_sym_set] = ACTIONS(4095),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4097),
  },
  [1197] = {
    [sym_string] = STATE(1797),
    [sym__property_name] = STATE(1797),
    [sym_computed_property_name] = STATE(1797),
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4101),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(4107),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4109),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4111),
    [anon_sym_set] = ACTIONS(4111),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1198] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4147),
  },
  [1199] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3761),
  },
  [1200] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3660),
  },
  [1201] = {
    [sym_string] = STATE(1787),
    [sym_decorator] = STATE(1223),
    [sym_public_field_definition] = STATE(2416),
    [sym_method_definition] = STATE(1690),
    [sym__property_name] = STATE(1787),
    [sym_computed_property_name] = STATE(1787),
    [sym_method_signature] = STATE(2416),
    [sym_abstract_method_signature] = STATE(2416),
    [sym_accessibility_modifier] = STATE(1716),
    [sym_index_signature] = STATE(2416),
    [aux_sym_class_body_repeat1] = STATE(1223),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4083),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(4194),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_async] = ACTIONS(4087),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_get] = ACTIONS(4095),
    [anon_sym_set] = ACTIONS(4095),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4097),
  },
  [1202] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(4196),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4196),
  },
  [1203] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3731),
  },
  [1204] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(4147),
    [anon_sym_RBRACE] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4147),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1205] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3729),
    [anon_sym_GT_GT_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3731),
  },
  [1206] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3763),
    [anon_sym_COMMA] = ACTIONS(3763),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3763),
  },
  [1207] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3740),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3740),
  },
  [1208] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(4198),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4198),
  },
  [1209] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_COMMA] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(4200),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_GT] = ACTIONS(3846),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3856),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4200),
  },
  [1210] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [aux_sym_array_repeat1] = STATE(2494),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4202),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1211] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3717),
    [anon_sym_COMMA] = ACTIONS(3717),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3717),
  },
  [1212] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3765),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3765),
  },
  [1213] = {
    [sym_string] = STATE(1787),
    [sym_decorator] = STATE(1182),
    [sym_public_field_definition] = STATE(2416),
    [sym_method_definition] = STATE(1690),
    [sym__property_name] = STATE(1787),
    [sym_computed_property_name] = STATE(1787),
    [sym_method_signature] = STATE(2416),
    [sym_abstract_method_signature] = STATE(2416),
    [sym_accessibility_modifier] = STATE(1716),
    [sym_index_signature] = STATE(2416),
    [aux_sym_class_body_repeat1] = STATE(1182),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4083),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_async] = ACTIONS(4087),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_get] = ACTIONS(4095),
    [anon_sym_set] = ACTIONS(4095),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4097),
  },
  [1214] = {
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_in] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2484),
    [sym__automatic_semicolon] = ACTIONS(2484),
  },
  [1215] = {
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_as] = ACTIONS(1081),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_while] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1081),
    [anon_sym_STAR_STAR] = ACTIONS(1081),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1081),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym__automatic_semicolon] = ACTIONS(1081),
  },
  [1216] = {
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_else] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_in] = ACTIONS(1065),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1065),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [sym__automatic_semicolon] = ACTIONS(1069),
  },
  [1217] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3744),
  },
  [1218] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [aux_sym_array_repeat1] = STATE(2485),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1219] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1532),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3261),
  },
  [1220] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3750),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(4171),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3750),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3752),
  },
  [1221] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3750),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(4171),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3752),
  },
  [1222] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3738),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_in] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_GT] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_GT_GT] = ACTIONS(3736),
    [anon_sym_GT_GT_GT] = ACTIONS(3738),
    [anon_sym_LT_LT] = ACTIONS(3738),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_CARET] = ACTIONS(3738),
    [anon_sym_PIPE] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_STAR_STAR] = ACTIONS(3738),
    [anon_sym_LT_EQ] = ACTIONS(3738),
    [anon_sym_EQ_EQ] = ACTIONS(3736),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3738),
    [anon_sym_GT_EQ] = ACTIONS(3738),
    [anon_sym_instanceof] = ACTIONS(3738),
    [anon_sym_BANG] = ACTIONS(3736),
    [anon_sym_PLUS_PLUS] = ACTIONS(3738),
    [anon_sym_DASH_DASH] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3738),
  },
  [1223] = {
    [sym_string] = STATE(1787),
    [sym_decorator] = STATE(1223),
    [sym_public_field_definition] = STATE(2416),
    [sym_method_definition] = STATE(1690),
    [sym__property_name] = STATE(1787),
    [sym_computed_property_name] = STATE(1787),
    [sym_method_signature] = STATE(2416),
    [sym_abstract_method_signature] = STATE(2416),
    [sym_accessibility_modifier] = STATE(1716),
    [sym_index_signature] = STATE(2416),
    [aux_sym_class_body_repeat1] = STATE(1223),
    [sym_identifier] = ACTIONS(4210),
    [anon_sym_export] = ACTIONS(4210),
    [anon_sym_STAR] = ACTIONS(4213),
    [anon_sym_namespace] = ACTIONS(4210),
    [anon_sym_RBRACE] = ACTIONS(4216),
    [anon_sym_type] = ACTIONS(4210),
    [anon_sym_LBRACK] = ACTIONS(4218),
    [anon_sym_async] = ACTIONS(4221),
    [anon_sym_void] = ACTIONS(4210),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_SQUOTE] = ACTIONS(4227),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4230),
    [anon_sym_AT] = ACTIONS(4233),
    [anon_sym_static] = ACTIONS(4236),
    [anon_sym_abstract] = ACTIONS(4239),
    [anon_sym_get] = ACTIONS(4242),
    [anon_sym_set] = ACTIONS(4242),
    [anon_sym_declare] = ACTIONS(4210),
    [anon_sym_public] = ACTIONS(4245),
    [anon_sym_private] = ACTIONS(4245),
    [anon_sym_protected] = ACTIONS(4245),
    [anon_sym_module] = ACTIONS(4210),
    [anon_sym_any] = ACTIONS(4210),
    [anon_sym_number] = ACTIONS(4210),
    [anon_sym_boolean] = ACTIONS(4210),
    [anon_sym_string] = ACTIONS(4210),
    [anon_sym_symbol] = ACTIONS(4210),
    [sym_readonly] = ACTIONS(4248),
  },
  [1224] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [aux_sym_array_repeat1] = STATE(2485),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1225] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3775),
    [anon_sym_COMMA] = ACTIONS(3775),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3775),
  },
  [1226] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3715),
    [anon_sym_COMMA] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3715),
  },
  [1227] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3660),
  },
  [1228] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4034),
    [anon_sym_COMMA] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3715),
  },
  [1229] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [aux_sym_array_repeat1] = STATE(2395),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4253),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1230] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4255),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1231] = {
    [sym_type_arguments] = STATE(1115),
    [anon_sym_STAR] = ACTIONS(2555),
    [anon_sym_as] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2553),
    [anon_sym_RBRACE] = ACTIONS(2553),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_RPAREN] = ACTIONS(2553),
    [anon_sym_in] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK] = ACTIONS(2553),
    [anon_sym_LT] = ACTIONS(4257),
    [anon_sym_GT] = ACTIONS(2555),
    [anon_sym_SLASH] = ACTIONS(2555),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_GT_GT] = ACTIONS(2555),
    [anon_sym_GT_GT_GT] = ACTIONS(2553),
    [anon_sym_LT_LT] = ACTIONS(2553),
    [anon_sym_AMP] = ACTIONS(2555),
    [anon_sym_CARET] = ACTIONS(2553),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2555),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_STAR_STAR] = ACTIONS(2553),
    [anon_sym_LT_EQ] = ACTIONS(2553),
    [anon_sym_EQ_EQ] = ACTIONS(2555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2553),
    [anon_sym_BANG_EQ] = ACTIONS(2555),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2553),
    [anon_sym_GT_EQ] = ACTIONS(2553),
    [anon_sym_instanceof] = ACTIONS(2553),
    [anon_sym_BANG] = ACTIONS(2555),
    [anon_sym_PLUS_PLUS] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2553),
  },
  [1232] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4260),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1233] = {
    [sym_string] = STATE(1787),
    [sym_decorator] = STATE(1223),
    [sym_public_field_definition] = STATE(2416),
    [sym_method_definition] = STATE(1690),
    [sym__property_name] = STATE(1787),
    [sym_computed_property_name] = STATE(1787),
    [sym_method_signature] = STATE(2416),
    [sym_abstract_method_signature] = STATE(2416),
    [sym_accessibility_modifier] = STATE(1716),
    [sym_index_signature] = STATE(2416),
    [aux_sym_class_body_repeat1] = STATE(1223),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4083),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(4262),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_async] = ACTIONS(4087),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_get] = ACTIONS(4095),
    [anon_sym_set] = ACTIONS(4095),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3532),
    [anon_sym_private] = ACTIONS(3532),
    [anon_sym_protected] = ACTIONS(3532),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4097),
  },
  [1234] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4005),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3713),
  },
  [1235] = {
    [sym_object] = STATE(2824),
    [sym_assignment_pattern] = STATE(2627),
    [sym_array] = STATE(2825),
    [sym_spread_element] = STATE(2627),
    [sym_string] = STATE(1980),
    [sym_method_definition] = STATE(2627),
    [sym_pair] = STATE(2627),
    [sym__property_name] = STATE(1980),
    [sym_computed_property_name] = STATE(1980),
    [sym_accessibility_modifier] = STATE(1726),
    [sym_identifier] = ACTIONS(4264),
    [anon_sym_export] = ACTIONS(4264),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(4264),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(3088),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_type] = ACTIONS(4264),
    [anon_sym_LBRACK] = ACTIONS(3902),
    [anon_sym_async] = ACTIONS(4266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(4264),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3906),
    [anon_sym_static] = ACTIONS(4268),
    [anon_sym_get] = ACTIONS(4270),
    [anon_sym_set] = ACTIONS(4270),
    [anon_sym_declare] = ACTIONS(4264),
    [anon_sym_public] = ACTIONS(4272),
    [anon_sym_private] = ACTIONS(4272),
    [anon_sym_protected] = ACTIONS(4272),
    [anon_sym_module] = ACTIONS(4264),
    [anon_sym_any] = ACTIONS(4264),
    [anon_sym_number] = ACTIONS(4264),
    [anon_sym_boolean] = ACTIONS(4264),
    [anon_sym_string] = ACTIONS(4264),
    [anon_sym_symbol] = ACTIONS(4264),
    [sym_readonly] = ACTIONS(145),
  },
  [1236] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4040),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3727),
  },
  [1237] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3719),
  },
  [1238] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4042),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
  },
  [1239] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4274),
    [anon_sym_COMMA] = ACTIONS(3742),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3789),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3789),
    [anon_sym_GT_GT_GT] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3807),
    [anon_sym_STAR_STAR] = ACTIONS(3815),
    [anon_sym_LT_EQ] = ACTIONS(3817),
    [anon_sym_EQ_EQ] = ACTIONS(3795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3817),
    [anon_sym_BANG_EQ] = ACTIONS(3795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3817),
    [anon_sym_GT_EQ] = ACTIONS(3817),
    [anon_sym_instanceof] = ACTIONS(3817),
    [anon_sym_BANG] = ACTIONS(3819),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3742),
  },
  [1240] = {
    [sym_template_string] = STATE(1503),
    [sym_arguments] = STATE(1503),
    [sym_type_arguments] = STATE(2342),
    [anon_sym_STAR] = ACTIONS(3597),
    [anon_sym_as] = ACTIONS(3599),
    [anon_sym_LBRACE] = ACTIONS(3597),
    [anon_sym_COMMA] = ACTIONS(3599),
    [anon_sym_LPAREN] = ACTIONS(3599),
    [anon_sym_in] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3599),
    [anon_sym_LT] = ACTIONS(3597),
    [anon_sym_GT] = ACTIONS(3597),
    [anon_sym_SLASH] = ACTIONS(3597),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_QMARK] = ACTIONS(3599),
    [anon_sym_AMP_AMP] = ACTIONS(3599),
    [anon_sym_PIPE_PIPE] = ACTIONS(3599),
    [anon_sym_GT_GT] = ACTIONS(3597),
    [anon_sym_GT_GT_GT] = ACTIONS(3599),
    [anon_sym_LT_LT] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym_CARET] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(3597),
    [anon_sym_PLUS] = ACTIONS(3597),
    [anon_sym_DASH] = ACTIONS(3597),
    [anon_sym_PERCENT] = ACTIONS(3599),
    [anon_sym_STAR_STAR] = ACTIONS(3599),
    [anon_sym_LT_EQ] = ACTIONS(3599),
    [anon_sym_EQ_EQ] = ACTIONS(3597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3599),
    [anon_sym_BANG_EQ] = ACTIONS(3597),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3599),
    [anon_sym_GT_EQ] = ACTIONS(3599),
    [anon_sym_instanceof] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3597),
    [anon_sym_PLUS_PLUS] = ACTIONS(3599),
    [anon_sym_DASH_DASH] = ACTIONS(3599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3599),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3599),
  },
  [1241] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_as] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3769),
    [anon_sym_COMMA] = ACTIONS(3769),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3932),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_SLASH] = ACTIONS(3926),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3934),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3926),
    [anon_sym_GT_GT_GT] = ACTIONS(3940),
    [anon_sym_LT_LT] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_STAR_STAR] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3930),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3930),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [anon_sym_implements] = ACTIONS(3769),
  },
  [1242] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4276),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1243] = {
    [anon_sym_STAR] = ACTIONS(2486),
    [anon_sym_as] = ACTIONS(2484),
    [anon_sym_COMMA] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_in] = ACTIONS(2486),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2486),
    [anon_sym_GT] = ACTIONS(2486),
    [anon_sym_SLASH] = ACTIONS(2486),
    [anon_sym_DOT] = ACTIONS(2484),
    [anon_sym_QMARK] = ACTIONS(2484),
    [anon_sym_AMP_AMP] = ACTIONS(2484),
    [anon_sym_PIPE_PIPE] = ACTIONS(2484),
    [anon_sym_GT_GT] = ACTIONS(2486),
    [anon_sym_GT_GT_GT] = ACTIONS(2484),
    [anon_sym_LT_LT] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_CARET] = ACTIONS(2484),
    [anon_sym_PIPE] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2486),
    [anon_sym_PERCENT] = ACTIONS(2484),
    [anon_sym_STAR_STAR] = ACTIONS(2484),
    [anon_sym_LT_EQ] = ACTIONS(2484),
    [anon_sym_EQ_EQ] = ACTIONS(2486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2484),
    [anon_sym_BANG_EQ] = ACTIONS(2486),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2484),
    [anon_sym_GT_EQ] = ACTIONS(2484),
    [anon_sym_instanceof] = ACTIONS(2484),
    [anon_sym_BANG] = ACTIONS(2486),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2484),
    [sym__automatic_semicolon] = ACTIONS(2484),
  },
  [1244] = {
    [sym_type_arguments] = STATE(1106),
    [anon_sym_STAR] = ACTIONS(2498),
    [anon_sym_as] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2496),
    [anon_sym_COMMA] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_in] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_LT] = ACTIONS(4278),
    [anon_sym_GT] = ACTIONS(2498),
    [anon_sym_SLASH] = ACTIONS(2498),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(2496),
    [anon_sym_AMP_AMP] = ACTIONS(2496),
    [anon_sym_PIPE_PIPE] = ACTIONS(2496),
    [anon_sym_GT_GT] = ACTIONS(2498),
    [anon_sym_GT_GT_GT] = ACTIONS(2496),
    [anon_sym_LT_LT] = ACTIONS(2496),
    [anon_sym_AMP] = ACTIONS(2498),
    [anon_sym_CARET] = ACTIONS(2496),
    [anon_sym_PIPE] = ACTIONS(2498),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2498),
    [anon_sym_PERCENT] = ACTIONS(2496),
    [anon_sym_STAR_STAR] = ACTIONS(2496),
    [anon_sym_LT_EQ] = ACTIONS(2496),
    [anon_sym_EQ_EQ] = ACTIONS(2498),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2496),
    [anon_sym_BANG_EQ] = ACTIONS(2498),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2496),
    [anon_sym_GT_EQ] = ACTIONS(2496),
    [anon_sym_instanceof] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2496),
    [anon_sym_implements] = ACTIONS(2496),
    [anon_sym_is] = ACTIONS(4281),
  },
  [1245] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3752),
    [anon_sym_LT] = ACTIONS(4283),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1246] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2462),
    [sym__automatic_semicolon] = ACTIONS(2462),
  },
  [1247] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1248] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(4300),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3729),
    [anon_sym_GT_GT_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1249] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3694),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3694),
  },
  [1250] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3688),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3688),
  },
  [1251] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3713),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3713),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1252] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3750),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3752),
  },
  [1253] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3752),
  },
  [1254] = {
    [sym_string] = STATE(1797),
    [sym__property_name] = STATE(1797),
    [sym_computed_property_name] = STATE(1797),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4101),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3552),
    [anon_sym_RBRACE] = ACTIONS(3552),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(4107),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4109),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4111),
    [anon_sym_set] = ACTIONS(4111),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1255] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_else] = ACTIONS(1203),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_while] = ACTIONS(1203),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1256] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3752),
  },
  [1257] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1258] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1259] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1260] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(4300),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1261] = {
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1061),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(1063),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_GT_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_PERCENT] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1061),
    [anon_sym_GT_EQ] = ACTIONS(1061),
    [anon_sym_instanceof] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1061),
    [sym__automatic_semicolon] = ACTIONS(4340),
  },
  [1262] = {
    [sym_type_arguments] = STATE(1561),
    [anon_sym_STAR] = ACTIONS(2498),
    [anon_sym_as] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_COMMA] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_in] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_LT] = ACTIONS(4019),
    [anon_sym_GT] = ACTIONS(2498),
    [anon_sym_SLASH] = ACTIONS(2498),
    [anon_sym_DOT] = ACTIONS(4342),
    [anon_sym_QMARK] = ACTIONS(2496),
    [anon_sym_AMP_AMP] = ACTIONS(2496),
    [anon_sym_PIPE_PIPE] = ACTIONS(2496),
    [anon_sym_GT_GT] = ACTIONS(2498),
    [anon_sym_GT_GT_GT] = ACTIONS(2496),
    [anon_sym_LT_LT] = ACTIONS(2496),
    [anon_sym_AMP] = ACTIONS(2498),
    [anon_sym_CARET] = ACTIONS(2496),
    [anon_sym_PIPE] = ACTIONS(2498),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2498),
    [anon_sym_PERCENT] = ACTIONS(2496),
    [anon_sym_STAR_STAR] = ACTIONS(2496),
    [anon_sym_LT_EQ] = ACTIONS(2496),
    [anon_sym_EQ_EQ] = ACTIONS(2498),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2496),
    [anon_sym_BANG_EQ] = ACTIONS(2498),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2496),
    [anon_sym_GT_EQ] = ACTIONS(2496),
    [anon_sym_instanceof] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2496),
    [anon_sym_is] = ACTIONS(4344),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2496),
  },
  [1263] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(4346),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1264] = {
    [sym_arguments] = STATE(1531),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3625),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3261),
  },
  [1265] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_RBRACE] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(4000),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2553),
    [sym__automatic_semicolon] = ACTIONS(2553),
  },
  [1266] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3727),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1267] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3694),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3694),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1268] = {
    [sym_arguments] = STATE(1531),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3613),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3261),
  },
  [1269] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(3994),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(3994),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2438),
    [sym__automatic_semicolon] = ACTIONS(2438),
  },
  [1270] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4348),
  },
  [1271] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3763),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3763),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1272] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4350),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1273] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1274] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3769),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1275] = {
    [anon_sym_STAR] = ACTIONS(2588),
    [anon_sym_as] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2586),
    [anon_sym_RBRACE] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_RPAREN] = ACTIONS(2586),
    [anon_sym_in] = ACTIONS(2588),
    [anon_sym_COLON] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2586),
    [anon_sym_RBRACK] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_SLASH] = ACTIONS(2588),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_QMARK] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_GT_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(4352),
    [anon_sym_CARET] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_PERCENT] = ACTIONS(2586),
    [anon_sym_STAR_STAR] = ACTIONS(2586),
    [anon_sym_LT_EQ] = ACTIONS(2586),
    [anon_sym_EQ_EQ] = ACTIONS(2588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2586),
    [anon_sym_BANG_EQ] = ACTIONS(2588),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2586),
    [anon_sym_GT_EQ] = ACTIONS(2586),
    [anon_sym_instanceof] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_PLUS_PLUS] = ACTIONS(2586),
    [anon_sym_DASH_DASH] = ACTIONS(2586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2586),
  },
  [1276] = {
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_as] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_RPAREN] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_COLON] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_RBRACK] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2592),
    [anon_sym_GT] = ACTIONS(2592),
    [anon_sym_SLASH] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2592),
    [anon_sym_GT_GT_GT] = ACTIONS(2590),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(4352),
    [anon_sym_CARET] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_PERCENT] = ACTIONS(2590),
    [anon_sym_STAR_STAR] = ACTIONS(2590),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_EQ_EQ] = ACTIONS(2592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2592),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2590),
    [anon_sym_instanceof] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2590),
  },
  [1277] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3775),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3775),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1278] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4356),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1279] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3752),
    [anon_sym_LT] = ACTIONS(4283),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3750),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1280] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4358),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1281] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4360),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1282] = {
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_as] = ACTIONS(2472),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_in] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2474),
    [anon_sym_GT] = ACTIONS(2474),
    [anon_sym_SLASH] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2472),
    [anon_sym_QMARK] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_PIPE_PIPE] = ACTIONS(2472),
    [anon_sym_GT_GT] = ACTIONS(2474),
    [anon_sym_GT_GT_GT] = ACTIONS(2472),
    [anon_sym_LT_LT] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_CARET] = ACTIONS(2472),
    [anon_sym_PIPE] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2472),
    [anon_sym_STAR_STAR] = ACTIONS(2472),
    [anon_sym_LT_EQ] = ACTIONS(2472),
    [anon_sym_EQ_EQ] = ACTIONS(2474),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2472),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2472),
    [anon_sym_GT_EQ] = ACTIONS(2472),
    [anon_sym_instanceof] = ACTIONS(2472),
    [anon_sym_BANG] = ACTIONS(2474),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2472),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2472),
    [sym__automatic_semicolon] = ACTIONS(2472),
  },
  [1283] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1284] = {
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_in] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(2486),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [sym__automatic_semicolon] = ACTIONS(1067),
  },
  [1285] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4358),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(4362),
    [anon_sym_of] = ACTIONS(4365),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1286] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4367),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1287] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4356),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(4369),
    [anon_sym_of] = ACTIONS(4372),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1288] = {
    [anon_sym_STAR] = ACTIONS(2596),
    [anon_sym_as] = ACTIONS(2594),
    [anon_sym_COMMA] = ACTIONS(2594),
    [anon_sym_RBRACE] = ACTIONS(2594),
    [anon_sym_LPAREN] = ACTIONS(2594),
    [anon_sym_RPAREN] = ACTIONS(2594),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_COLON] = ACTIONS(2594),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_RBRACK] = ACTIONS(2594),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(2596),
    [anon_sym_SLASH] = ACTIONS(2596),
    [anon_sym_DOT] = ACTIONS(2594),
    [anon_sym_QMARK] = ACTIONS(2594),
    [anon_sym_AMP_AMP] = ACTIONS(2594),
    [anon_sym_PIPE_PIPE] = ACTIONS(2594),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_GT_GT_GT] = ACTIONS(2594),
    [anon_sym_LT_LT] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(4352),
    [anon_sym_CARET] = ACTIONS(2594),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_DASH] = ACTIONS(2596),
    [anon_sym_PERCENT] = ACTIONS(2594),
    [anon_sym_STAR_STAR] = ACTIONS(2594),
    [anon_sym_LT_EQ] = ACTIONS(2594),
    [anon_sym_EQ_EQ] = ACTIONS(2596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2594),
    [anon_sym_BANG_EQ] = ACTIONS(2596),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2594),
    [anon_sym_GT_EQ] = ACTIONS(2594),
    [anon_sym_instanceof] = ACTIONS(2594),
    [anon_sym_BANG] = ACTIONS(2596),
    [anon_sym_PLUS_PLUS] = ACTIONS(2594),
    [anon_sym_DASH_DASH] = ACTIONS(2594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2594),
  },
  [1289] = {
    [sym_string] = STATE(2041),
    [sym__property_name] = STATE(2041),
    [sym_computed_property_name] = STATE(2041),
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4101),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4376),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4378),
    [anon_sym_set] = ACTIONS(4378),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1290] = {
    [sym_type_arguments] = STATE(1386),
    [anon_sym_STAR] = ACTIONS(2555),
    [anon_sym_as] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2553),
    [anon_sym_RBRACE] = ACTIONS(2553),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_in] = ACTIONS(2555),
    [anon_sym_SEMI] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LT] = ACTIONS(4380),
    [anon_sym_GT] = ACTIONS(2555),
    [anon_sym_SLASH] = ACTIONS(2555),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_GT_GT] = ACTIONS(2555),
    [anon_sym_GT_GT_GT] = ACTIONS(2553),
    [anon_sym_LT_LT] = ACTIONS(2553),
    [anon_sym_AMP] = ACTIONS(2555),
    [anon_sym_CARET] = ACTIONS(2553),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2555),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_STAR_STAR] = ACTIONS(2553),
    [anon_sym_LT_EQ] = ACTIONS(2553),
    [anon_sym_EQ_EQ] = ACTIONS(2555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2553),
    [anon_sym_BANG_EQ] = ACTIONS(2555),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2553),
    [anon_sym_GT_EQ] = ACTIONS(2553),
    [anon_sym_instanceof] = ACTIONS(2553),
    [anon_sym_BANG] = ACTIONS(2555),
    [anon_sym_PLUS_PLUS] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2553),
    [sym__automatic_semicolon] = ACTIONS(2553),
  },
  [1291] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3752),
    [anon_sym_LT] = ACTIONS(4283),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_GT_GT_GT] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_STAR_STAR] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3752),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3752),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_instanceof] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1292] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3742),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1293] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1294] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3717),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3717),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1295] = {
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_as] = ACTIONS(1107),
    [anon_sym_COMMA] = ACTIONS(1107),
    [anon_sym_else] = ACTIONS(1101),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_in] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1107),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_GT_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1107),
    [anon_sym_LT_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1107),
    [anon_sym_GT_EQ] = ACTIONS(1107),
    [anon_sym_instanceof] = ACTIONS(1107),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [sym__automatic_semicolon] = ACTIONS(1109),
  },
  [1296] = {
    [anon_sym_STAR] = ACTIONS(1149),
    [anon_sym_as] = ACTIONS(1151),
    [anon_sym_COMMA] = ACTIONS(1151),
    [anon_sym_else] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_in] = ACTIONS(1149),
    [anon_sym_while] = ACTIONS(1145),
    [anon_sym_SEMI] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(1149),
    [anon_sym_GT] = ACTIONS(1149),
    [anon_sym_SLASH] = ACTIONS(1149),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_QMARK] = ACTIONS(1151),
    [anon_sym_AMP_AMP] = ACTIONS(1151),
    [anon_sym_PIPE_PIPE] = ACTIONS(1151),
    [anon_sym_GT_GT] = ACTIONS(1149),
    [anon_sym_GT_GT_GT] = ACTIONS(1151),
    [anon_sym_LT_LT] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(1151),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_PLUS] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_PERCENT] = ACTIONS(1151),
    [anon_sym_STAR_STAR] = ACTIONS(1151),
    [anon_sym_LT_EQ] = ACTIONS(1151),
    [anon_sym_EQ_EQ] = ACTIONS(1149),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1151),
    [anon_sym_BANG_EQ] = ACTIONS(1149),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1151),
    [anon_sym_GT_EQ] = ACTIONS(1151),
    [anon_sym_instanceof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1149),
    [anon_sym_PLUS_PLUS] = ACTIONS(1151),
    [anon_sym_DASH_DASH] = ACTIONS(1151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1151),
    [sym__automatic_semicolon] = ACTIONS(1153),
  },
  [1297] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4385),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1298] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4387),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1299] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3769),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3769),
  },
  [1300] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(4389),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4389),
  },
  [1301] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3740),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1302] = {
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(1063),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_GT_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_PERCENT] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1061),
    [anon_sym_GT_EQ] = ACTIONS(1061),
    [anon_sym_instanceof] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [sym__automatic_semicolon] = ACTIONS(3894),
  },
  [1303] = {
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_as] = ACTIONS(2458),
    [anon_sym_COMMA] = ACTIONS(2458),
    [anon_sym_RBRACE] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2458),
    [anon_sym_in] = ACTIONS(2460),
    [anon_sym_SEMI] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2458),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_GT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2460),
    [anon_sym_DOT] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2458),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2458),
    [anon_sym_LT_LT] = ACTIONS(2458),
    [anon_sym_AMP] = ACTIONS(2460),
    [anon_sym_CARET] = ACTIONS(2458),
    [anon_sym_PIPE] = ACTIONS(2460),
    [anon_sym_PLUS] = ACTIONS(2460),
    [anon_sym_DASH] = ACTIONS(2460),
    [anon_sym_PERCENT] = ACTIONS(2458),
    [anon_sym_STAR_STAR] = ACTIONS(2458),
    [anon_sym_LT_EQ] = ACTIONS(2458),
    [anon_sym_EQ_EQ] = ACTIONS(2460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2458),
    [anon_sym_BANG_EQ] = ACTIONS(2460),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2458),
    [anon_sym_GT_EQ] = ACTIONS(2458),
    [anon_sym_instanceof] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(2458),
    [anon_sym_DASH_DASH] = ACTIONS(2458),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2458),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2458),
    [sym__automatic_semicolon] = ACTIONS(2458),
  },
  [1304] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(4391),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1305] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4393),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1306] = {
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_as] = ACTIONS(1217),
    [anon_sym_COMMA] = ACTIONS(1217),
    [anon_sym_else] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(1215),
    [anon_sym_while] = ACTIONS(1211),
    [anon_sym_SEMI] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1215),
    [anon_sym_GT] = ACTIONS(1215),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1217),
    [anon_sym_AMP_AMP] = ACTIONS(1217),
    [anon_sym_PIPE_PIPE] = ACTIONS(1217),
    [anon_sym_GT_GT] = ACTIONS(1215),
    [anon_sym_GT_GT_GT] = ACTIONS(1217),
    [anon_sym_LT_LT] = ACTIONS(1217),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1217),
    [anon_sym_PIPE] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1217),
    [anon_sym_STAR_STAR] = ACTIONS(1217),
    [anon_sym_LT_EQ] = ACTIONS(1217),
    [anon_sym_EQ_EQ] = ACTIONS(1215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1217),
    [anon_sym_BANG_EQ] = ACTIONS(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1217),
    [anon_sym_GT_EQ] = ACTIONS(1217),
    [anon_sym_instanceof] = ACTIONS(1217),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1217),
    [sym__automatic_semicolon] = ACTIONS(1219),
  },
  [1307] = {
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_as] = ACTIONS(3609),
    [anon_sym_LBRACE] = ACTIONS(3611),
    [anon_sym_COMMA] = ACTIONS(3609),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3611),
    [anon_sym_COLON] = ACTIONS(3725),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_LT] = ACTIONS(3611),
    [anon_sym_GT] = ACTIONS(3611),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_DOT] = ACTIONS(3609),
    [anon_sym_EQ_GT] = ACTIONS(3725),
    [anon_sym_QMARK] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_PIPE_PIPE] = ACTIONS(3609),
    [anon_sym_GT_GT] = ACTIONS(3611),
    [anon_sym_GT_GT_GT] = ACTIONS(3609),
    [anon_sym_LT_LT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_CARET] = ACTIONS(3609),
    [anon_sym_PIPE] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3609),
    [anon_sym_STAR_STAR] = ACTIONS(3609),
    [anon_sym_LT_EQ] = ACTIONS(3609),
    [anon_sym_EQ_EQ] = ACTIONS(3611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3609),
    [anon_sym_BANG_EQ] = ACTIONS(3611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3609),
    [anon_sym_GT_EQ] = ACTIONS(3609),
    [anon_sym_instanceof] = ACTIONS(3609),
    [anon_sym_BANG] = ACTIONS(3611),
    [anon_sym_PLUS_PLUS] = ACTIONS(3609),
    [anon_sym_DASH_DASH] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3609),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3609),
  },
  [1308] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(4395),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4395),
  },
  [1309] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4397),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1310] = {
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_as] = ACTIONS(1239),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_else] = ACTIONS(1233),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_in] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1233),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1239),
    [anon_sym_QMARK] = ACTIONS(1239),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_GT_GT_GT] = ACTIONS(1239),
    [anon_sym_LT_LT] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PERCENT] = ACTIONS(1239),
    [anon_sym_STAR_STAR] = ACTIONS(1239),
    [anon_sym_LT_EQ] = ACTIONS(1239),
    [anon_sym_EQ_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1239),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1239),
    [anon_sym_GT_EQ] = ACTIONS(1239),
    [anon_sym_instanceof] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym__automatic_semicolon] = ACTIONS(1241),
  },
  [1311] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(4399),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4399),
  },
  [1312] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3742),
  },
  [1313] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3660),
  },
  [1314] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3744),
  },
  [1315] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3765),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1316] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3740),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3740),
  },
  [1317] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(4401),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1318] = {
    [anon_sym_STAR] = ACTIONS(3631),
    [anon_sym_EQ] = ACTIONS(3631),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3633),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_in] = ACTIONS(3631),
    [anon_sym_SEMI] = ACTIONS(3633),
    [anon_sym_COLON] = ACTIONS(4406),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_GT] = ACTIONS(3631),
    [anon_sym_SLASH] = ACTIONS(3631),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(4403),
    [anon_sym_AMP_AMP] = ACTIONS(3633),
    [anon_sym_PIPE_PIPE] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3631),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3631),
    [anon_sym_PLUS] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3631),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_STAR_STAR] = ACTIONS(3633),
    [anon_sym_LT_EQ] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3631),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3631),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3633),
    [anon_sym_GT_EQ] = ACTIONS(3633),
    [anon_sym_instanceof] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3631),
    [anon_sym_PLUS_PLUS] = ACTIONS(3633),
    [anon_sym_DASH_DASH] = ACTIONS(3633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3633),
    [sym__automatic_semicolon] = ACTIONS(3633),
  },
  [1319] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4411),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1320] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3688),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3688),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1321] = {
    [anon_sym_STAR] = ACTIONS(4115),
    [anon_sym_as] = ACTIONS(4115),
    [anon_sym_COMMA] = ACTIONS(4117),
    [anon_sym_RBRACE] = ACTIONS(4117),
    [anon_sym_LPAREN] = ACTIONS(4117),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_SEMI] = ACTIONS(4117),
    [anon_sym_LBRACK] = ACTIONS(4117),
    [anon_sym_LT] = ACTIONS(4115),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4115),
    [anon_sym_DOT] = ACTIONS(4117),
    [anon_sym_QMARK] = ACTIONS(4117),
    [anon_sym_AMP_AMP] = ACTIONS(4117),
    [anon_sym_PIPE_PIPE] = ACTIONS(4117),
    [anon_sym_GT_GT] = ACTIONS(4115),
    [anon_sym_GT_GT_GT] = ACTIONS(4117),
    [anon_sym_LT_LT] = ACTIONS(4117),
    [anon_sym_AMP] = ACTIONS(4115),
    [anon_sym_CARET] = ACTIONS(4117),
    [anon_sym_PIPE] = ACTIONS(4115),
    [anon_sym_PLUS] = ACTIONS(4115),
    [anon_sym_DASH] = ACTIONS(4115),
    [anon_sym_PERCENT] = ACTIONS(4117),
    [anon_sym_STAR_STAR] = ACTIONS(4117),
    [anon_sym_LT_EQ] = ACTIONS(4117),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4117),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4117),
    [anon_sym_GT_EQ] = ACTIONS(4117),
    [anon_sym_instanceof] = ACTIONS(4115),
    [anon_sym_BANG] = ACTIONS(4115),
    [anon_sym_PLUS_PLUS] = ACTIONS(4117),
    [anon_sym_DASH_DASH] = ACTIONS(4117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4117),
    [sym_regex_flags] = ACTIONS(4413),
    [sym__automatic_semicolon] = ACTIONS(4117),
  },
  [1322] = {
    [anon_sym_STAR] = ACTIONS(2600),
    [anon_sym_as] = ACTIONS(2598),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_RPAREN] = ACTIONS(2598),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_COLON] = ACTIONS(2598),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_RBRACK] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(2600),
    [anon_sym_GT] = ACTIONS(2600),
    [anon_sym_SLASH] = ACTIONS(2600),
    [anon_sym_DOT] = ACTIONS(2598),
    [anon_sym_QMARK] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_PIPE_PIPE] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_GT_GT_GT] = ACTIONS(2598),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(4352),
    [anon_sym_CARET] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_PERCENT] = ACTIONS(2598),
    [anon_sym_STAR_STAR] = ACTIONS(2598),
    [anon_sym_LT_EQ] = ACTIONS(2598),
    [anon_sym_EQ_EQ] = ACTIONS(2600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2598),
    [anon_sym_BANG_EQ] = ACTIONS(2600),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2598),
    [anon_sym_GT_EQ] = ACTIONS(2598),
    [anon_sym_instanceof] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2600),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2598),
  },
  [1323] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3727),
  },
  [1324] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1325] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(4300),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3729),
    [anon_sym_GT_GT_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1326] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3775),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3775),
  },
  [1327] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3715),
  },
  [1328] = {
    [anon_sym_STAR] = ACTIONS(2422),
    [anon_sym_as] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_SLASH] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2420),
    [anon_sym_QMARK] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_GT_GT] = ACTIONS(2422),
    [anon_sym_GT_GT_GT] = ACTIONS(2420),
    [anon_sym_LT_LT] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_CARET] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2420),
    [anon_sym_STAR_STAR] = ACTIONS(2420),
    [anon_sym_LT_EQ] = ACTIONS(2420),
    [anon_sym_EQ_EQ] = ACTIONS(2422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2420),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2420),
    [anon_sym_GT_EQ] = ACTIONS(2420),
    [anon_sym_instanceof] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2420),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2420),
    [sym__automatic_semicolon] = ACTIONS(2420),
  },
  [1329] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_RBRACE] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1330] = {
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(1141),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1141),
    [anon_sym_in] = ACTIONS(1139),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1141),
    [anon_sym_LBRACK] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(1139),
    [anon_sym_GT] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1141),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_AMP_AMP] = ACTIONS(1141),
    [anon_sym_PIPE_PIPE] = ACTIONS(1141),
    [anon_sym_GT_GT] = ACTIONS(1139),
    [anon_sym_GT_GT_GT] = ACTIONS(1141),
    [anon_sym_LT_LT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(1139),
    [anon_sym_CARET] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1139),
    [anon_sym_PERCENT] = ACTIONS(1141),
    [anon_sym_STAR_STAR] = ACTIONS(1141),
    [anon_sym_LT_EQ] = ACTIONS(1141),
    [anon_sym_EQ_EQ] = ACTIONS(1139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1141),
    [anon_sym_BANG_EQ] = ACTIONS(1139),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1141),
    [anon_sym_GT_EQ] = ACTIONS(1141),
    [anon_sym_instanceof] = ACTIONS(1141),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_PLUS_PLUS] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [sym__automatic_semicolon] = ACTIONS(1143),
  },
  [1331] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3832),
    [anon_sym_RBRACE] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1332] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3959),
    [anon_sym_RBRACE] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1333] = {
    [anon_sym_STAR] = ACTIONS(2604),
    [anon_sym_as] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_RPAREN] = ACTIONS(2602),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_COLON] = ACTIONS(2602),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_RBRACK] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_DOT] = ACTIONS(2602),
    [anon_sym_QMARK] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_GT_GT_GT] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(4352),
    [anon_sym_CARET] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PERCENT] = ACTIONS(2602),
    [anon_sym_STAR_STAR] = ACTIONS(2602),
    [anon_sym_LT_EQ] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2604),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2604),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2602),
    [anon_sym_GT_EQ] = ACTIONS(2602),
    [anon_sym_instanceof] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2602),
  },
  [1334] = {
    [anon_sym_STAR] = ACTIONS(2448),
    [anon_sym_as] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2446),
    [anon_sym_in] = ACTIONS(2448),
    [anon_sym_SEMI] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_SLASH] = ACTIONS(2448),
    [anon_sym_DOT] = ACTIONS(2446),
    [anon_sym_QMARK] = ACTIONS(2446),
    [anon_sym_AMP_AMP] = ACTIONS(2446),
    [anon_sym_PIPE_PIPE] = ACTIONS(2446),
    [anon_sym_GT_GT] = ACTIONS(2448),
    [anon_sym_GT_GT_GT] = ACTIONS(2446),
    [anon_sym_LT_LT] = ACTIONS(2446),
    [anon_sym_AMP] = ACTIONS(2448),
    [anon_sym_CARET] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PERCENT] = ACTIONS(2446),
    [anon_sym_STAR_STAR] = ACTIONS(2446),
    [anon_sym_LT_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ] = ACTIONS(2448),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2448),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2446),
    [anon_sym_GT_EQ] = ACTIONS(2446),
    [anon_sym_instanceof] = ACTIONS(2446),
    [anon_sym_BANG] = ACTIONS(2448),
    [anon_sym_PLUS_PLUS] = ACTIONS(2446),
    [anon_sym_DASH_DASH] = ACTIONS(2446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2446),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2446),
    [sym__automatic_semicolon] = ACTIONS(2446),
  },
  [1335] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3767),
  },
  [1336] = {
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_as] = ACTIONS(1165),
    [anon_sym_COMMA] = ACTIONS(1165),
    [anon_sym_else] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1165),
    [anon_sym_in] = ACTIONS(1163),
    [anon_sym_while] = ACTIONS(1159),
    [anon_sym_SEMI] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1163),
    [anon_sym_GT] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_DOT] = ACTIONS(1165),
    [anon_sym_QMARK] = ACTIONS(1165),
    [anon_sym_AMP_AMP] = ACTIONS(1165),
    [anon_sym_PIPE_PIPE] = ACTIONS(1165),
    [anon_sym_GT_GT] = ACTIONS(1163),
    [anon_sym_GT_GT_GT] = ACTIONS(1165),
    [anon_sym_LT_LT] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_CARET] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_STAR_STAR] = ACTIONS(1165),
    [anon_sym_LT_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ] = ACTIONS(1163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ] = ACTIONS(1163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1165),
    [anon_sym_GT_EQ] = ACTIONS(1165),
    [anon_sym_instanceof] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1165),
    [sym__automatic_semicolon] = ACTIONS(1167),
  },
  [1337] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3765),
  },
  [1338] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3763),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3763),
  },
  [1339] = {
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_as] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_else] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1093),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_instanceof] = ACTIONS(1093),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym__automatic_semicolon] = ACTIONS(1095),
  },
  [1340] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(4415),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1341] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_RBRACE] = ACTIONS(4417),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1342] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4419),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3729),
    [anon_sym_GT_GT_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3731),
  },
  [1343] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3731),
  },
  [1344] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3731),
  },
  [1345] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(3660),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1346] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3731),
  },
  [1347] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4419),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3731),
  },
  [1348] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4419),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3729),
    [anon_sym_GT_GT_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3731),
  },
  [1349] = {
    [sym_arguments] = STATE(1424),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [sym__automatic_semicolon] = ACTIONS(3261),
  },
  [1350] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(4154),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1351] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3719),
  },
  [1352] = {
    [anon_sym_STAR] = ACTIONS(1225),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1221),
    [anon_sym_LPAREN] = ACTIONS(1227),
    [anon_sym_in] = ACTIONS(1225),
    [anon_sym_while] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1225),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1225),
    [anon_sym_GT_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_PERCENT] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1227),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1225),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [sym__automatic_semicolon] = ACTIONS(1229),
  },
  [1353] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3717),
  },
  [1354] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2328),
    [anon_sym_STAR] = ACTIONS(4303),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4307),
    [anon_sym_GT] = ACTIONS(4305),
    [anon_sym_SLASH] = ACTIONS(4303),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE_PIPE] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_GT_GT_GT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4315),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_PIPE] = ACTIONS(4319),
    [anon_sym_PLUS] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4315),
    [anon_sym_STAR_STAR] = ACTIONS(4323),
    [anon_sym_LT_EQ] = ACTIONS(4325),
    [anon_sym_EQ_EQ] = ACTIONS(4305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4325),
    [anon_sym_BANG_EQ] = ACTIONS(4305),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4325),
    [anon_sym_GT_EQ] = ACTIONS(4325),
    [anon_sym_instanceof] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3860),
    [anon_sym_DASH_DASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3713),
  },
  [1355] = {
    [sym_string] = STATE(2041),
    [sym__property_name] = STATE(2041),
    [sym_computed_property_name] = STATE(2041),
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4101),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4376),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4378),
    [anon_sym_set] = ACTIONS(4378),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1356] = {
    [sym_string] = STATE(2041),
    [sym__property_name] = STATE(2041),
    [sym_computed_property_name] = STATE(2041),
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4101),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4376),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4378),
    [anon_sym_set] = ACTIONS(4378),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1357] = {
    [anon_sym_STAR] = ACTIONS(1173),
    [anon_sym_as] = ACTIONS(1175),
    [anon_sym_COMMA] = ACTIONS(1175),
    [anon_sym_else] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(1175),
    [anon_sym_in] = ACTIONS(1173),
    [anon_sym_while] = ACTIONS(1169),
    [anon_sym_SEMI] = ACTIONS(1175),
    [anon_sym_LBRACK] = ACTIONS(1175),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_DOT] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1175),
    [anon_sym_LT_LT] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1175),
    [anon_sym_STAR_STAR] = ACTIONS(1175),
    [anon_sym_LT_EQ] = ACTIONS(1175),
    [anon_sym_EQ_EQ] = ACTIONS(1173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1175),
    [anon_sym_BANG_EQ] = ACTIONS(1173),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1175),
    [anon_sym_GT_EQ] = ACTIONS(1175),
    [anon_sym_instanceof] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1175),
    [sym__automatic_semicolon] = ACTIONS(1177),
  },
  [1358] = {
    [anon_sym_STAR] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_else] = ACTIONS(1121),
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_while] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1125),
    [anon_sym_GT] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_GT_GT] = ACTIONS(1125),
    [anon_sym_GT_GT_GT] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_CARET] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1125),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1125),
    [anon_sym_PERCENT] = ACTIONS(1127),
    [anon_sym_STAR_STAR] = ACTIONS(1127),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_instanceof] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1127),
    [sym__automatic_semicolon] = ACTIONS(1129),
  },
  [1359] = {
    [anon_sym_STAR] = ACTIONS(1193),
    [anon_sym_as] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_else] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_in] = ACTIONS(1193),
    [anon_sym_while] = ACTIONS(1189),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1193),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1193),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym__automatic_semicolon] = ACTIONS(1197),
  },
  [1360] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(4422),
    [anon_sym_RBRACE] = ACTIONS(4422),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3656),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_EQ_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_instanceof] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1361] = {
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(1185),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_else] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_in] = ACTIONS(1183),
    [anon_sym_while] = ACTIONS(1179),
    [anon_sym_SEMI] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1183),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_DOT] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(1185),
    [anon_sym_AMP_AMP] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_GT_GT] = ACTIONS(1183),
    [anon_sym_GT_GT_GT] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(1185),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1185),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_PERCENT] = ACTIONS(1185),
    [anon_sym_STAR_STAR] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1185),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1185),
    [anon_sym_GT_EQ] = ACTIONS(1185),
    [anon_sym_instanceof] = ACTIONS(1185),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1185),
    [sym__automatic_semicolon] = ACTIONS(1187),
  },
  [1362] = {
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_as] = ACTIONS(2476),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_in] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2478),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_DOT] = ACTIONS(2476),
    [anon_sym_QMARK] = ACTIONS(2476),
    [anon_sym_AMP_AMP] = ACTIONS(2476),
    [anon_sym_PIPE_PIPE] = ACTIONS(2476),
    [anon_sym_GT_GT] = ACTIONS(2478),
    [anon_sym_GT_GT_GT] = ACTIONS(2476),
    [anon_sym_LT_LT] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_CARET] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_PERCENT] = ACTIONS(2476),
    [anon_sym_STAR_STAR] = ACTIONS(2476),
    [anon_sym_LT_EQ] = ACTIONS(2476),
    [anon_sym_EQ_EQ] = ACTIONS(2478),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2476),
    [anon_sym_BANG_EQ] = ACTIONS(2478),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2476),
    [anon_sym_GT_EQ] = ACTIONS(2476),
    [anon_sym_instanceof] = ACTIONS(2476),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2476),
    [sym__automatic_semicolon] = ACTIONS(2476),
  },
  [1363] = {
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_as] = ACTIONS(3609),
    [anon_sym_COMMA] = ACTIONS(3609),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [anon_sym_RPAREN] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3611),
    [anon_sym_COLON] = ACTIONS(3609),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_LT] = ACTIONS(3611),
    [anon_sym_GT] = ACTIONS(3611),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_DOT] = ACTIONS(3609),
    [anon_sym_EQ_GT] = ACTIONS(3725),
    [anon_sym_QMARK] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_PIPE_PIPE] = ACTIONS(3609),
    [anon_sym_GT_GT] = ACTIONS(3611),
    [anon_sym_GT_GT_GT] = ACTIONS(3609),
    [anon_sym_LT_LT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_CARET] = ACTIONS(3609),
    [anon_sym_PIPE] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3609),
    [anon_sym_STAR_STAR] = ACTIONS(3609),
    [anon_sym_LT_EQ] = ACTIONS(3609),
    [anon_sym_EQ_EQ] = ACTIONS(3611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3609),
    [anon_sym_BANG_EQ] = ACTIONS(3611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3609),
    [anon_sym_GT_EQ] = ACTIONS(3609),
    [anon_sym_instanceof] = ACTIONS(3609),
    [anon_sym_BANG] = ACTIONS(3611),
    [anon_sym_PLUS_PLUS] = ACTIONS(3609),
    [anon_sym_DASH_DASH] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3609),
  },
  [1364] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1365] = {
    [sym_string] = STATE(1798),
    [sym__property_name] = STATE(1798),
    [sym_computed_property_name] = STATE(1798),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4426),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(4428),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4430),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4432),
    [anon_sym_set] = ACTIONS(4432),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4434),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1366] = {
    [sym_string] = STATE(2041),
    [sym__property_name] = STATE(2041),
    [sym_computed_property_name] = STATE(2041),
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4376),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1367] = {
    [anon_sym_STAR] = ACTIONS(1193),
    [anon_sym_as] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_in] = ACTIONS(1193),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1193),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1193),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym__automatic_semicolon] = ACTIONS(1195),
  },
  [1368] = {
    [sym_string] = STATE(2041),
    [sym__property_name] = STATE(2041),
    [sym_computed_property_name] = STATE(2041),
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4376),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1369] = {
    [anon_sym_STAR] = ACTIONS(4026),
    [anon_sym_as] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_in] = ACTIONS(4026),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_DOT] = ACTIONS(4028),
    [anon_sym_QMARK] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_STAR_STAR] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4026),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_instanceof] = ACTIONS(4028),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4028),
    [sym__automatic_semicolon] = ACTIONS(4028),
  },
  [1370] = {
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(2484),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_in] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(2486),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1067),
  },
  [1371] = {
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_as] = ACTIONS(589),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_in] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_GT] = ACTIONS(2470),
    [anon_sym_SLASH] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(589),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_AMP_AMP] = ACTIONS(589),
    [anon_sym_PIPE_PIPE] = ACTIONS(589),
    [anon_sym_GT_GT] = ACTIONS(2470),
    [anon_sym_GT_GT_GT] = ACTIONS(589),
    [anon_sym_LT_LT] = ACTIONS(589),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_CARET] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(589),
    [anon_sym_STAR_STAR] = ACTIONS(589),
    [anon_sym_LT_EQ] = ACTIONS(589),
    [anon_sym_EQ_EQ] = ACTIONS(2470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(589),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(589),
    [anon_sym_GT_EQ] = ACTIONS(589),
    [anon_sym_instanceof] = ACTIONS(589),
    [anon_sym_BANG] = ACTIONS(2470),
    [anon_sym_PLUS_PLUS] = ACTIONS(589),
    [anon_sym_DASH_DASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(589),
    [sym__automatic_semicolon] = ACTIONS(589),
  },
  [1372] = {
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_as] = ACTIONS(2424),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_in] = ACTIONS(2426),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_LBRACK] = ACTIONS(4436),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_GT] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2426),
    [anon_sym_DOT] = ACTIONS(2424),
    [anon_sym_QMARK] = ACTIONS(2424),
    [anon_sym_AMP_AMP] = ACTIONS(2424),
    [anon_sym_PIPE_PIPE] = ACTIONS(2424),
    [anon_sym_GT_GT] = ACTIONS(2426),
    [anon_sym_GT_GT_GT] = ACTIONS(2424),
    [anon_sym_LT_LT] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2426),
    [anon_sym_CARET] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_PERCENT] = ACTIONS(2424),
    [anon_sym_STAR_STAR] = ACTIONS(2424),
    [anon_sym_LT_EQ] = ACTIONS(2424),
    [anon_sym_EQ_EQ] = ACTIONS(2426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2424),
    [anon_sym_BANG_EQ] = ACTIONS(2426),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2424),
    [anon_sym_GT_EQ] = ACTIONS(2424),
    [anon_sym_instanceof] = ACTIONS(2424),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2424),
    [sym__automatic_semicolon] = ACTIONS(2424),
  },
  [1373] = {
    [anon_sym_STAR] = ACTIONS(2346),
    [anon_sym_as] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(2344),
    [anon_sym_in] = ACTIONS(2346),
    [anon_sym_SEMI] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_SLASH] = ACTIONS(2346),
    [anon_sym_DOT] = ACTIONS(3787),
    [anon_sym_QMARK] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_GT_GT] = ACTIONS(2346),
    [anon_sym_GT_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_CARET] = ACTIONS(2344),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_PERCENT] = ACTIONS(2344),
    [anon_sym_STAR_STAR] = ACTIONS(2344),
    [anon_sym_LT_EQ] = ACTIONS(2344),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2344),
    [anon_sym_BANG_EQ] = ACTIONS(2346),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2344),
    [anon_sym_GT_EQ] = ACTIONS(2344),
    [anon_sym_instanceof] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2346),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [sym__automatic_semicolon] = ACTIONS(2344),
  },
  [1374] = {
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_as] = ACTIONS(1061),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(1063),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_GT_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_PERCENT] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1061),
    [anon_sym_GT_EQ] = ACTIONS(1061),
    [anon_sym_instanceof] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1061),
    [sym__automatic_semicolon] = ACTIONS(4340),
  },
  [1375] = {
    [anon_sym_STAR] = ACTIONS(2440),
    [anon_sym_as] = ACTIONS(2438),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_RBRACE] = ACTIONS(2438),
    [anon_sym_LPAREN] = ACTIONS(2438),
    [anon_sym_in] = ACTIONS(2440),
    [anon_sym_SEMI] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(2438),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2440),
    [anon_sym_SLASH] = ACTIONS(2440),
    [anon_sym_DOT] = ACTIONS(2438),
    [anon_sym_QMARK] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2438),
    [anon_sym_PIPE_PIPE] = ACTIONS(2438),
    [anon_sym_GT_GT] = ACTIONS(2440),
    [anon_sym_GT_GT_GT] = ACTIONS(2438),
    [anon_sym_LT_LT] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2440),
    [anon_sym_CARET] = ACTIONS(2438),
    [anon_sym_PIPE] = ACTIONS(2440),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_DASH] = ACTIONS(2440),
    [anon_sym_PERCENT] = ACTIONS(2438),
    [anon_sym_STAR_STAR] = ACTIONS(2438),
    [anon_sym_LT_EQ] = ACTIONS(2438),
    [anon_sym_EQ_EQ] = ACTIONS(2440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2438),
    [anon_sym_BANG_EQ] = ACTIONS(2440),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2438),
    [anon_sym_GT_EQ] = ACTIONS(2438),
    [anon_sym_instanceof] = ACTIONS(2438),
    [anon_sym_BANG] = ACTIONS(2440),
    [anon_sym_PLUS_PLUS] = ACTIONS(2438),
    [anon_sym_DASH_DASH] = ACTIONS(2438),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2438),
    [sym__automatic_semicolon] = ACTIONS(2438),
  },
  [1376] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_RBRACK] = ACTIONS(4438),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1377] = {
    [anon_sym_STAR] = ACTIONS(2436),
    [anon_sym_as] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2434),
    [anon_sym_RBRACE] = ACTIONS(2434),
    [anon_sym_LPAREN] = ACTIONS(2434),
    [anon_sym_in] = ACTIONS(2436),
    [anon_sym_SEMI] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(4436),
    [anon_sym_LT] = ACTIONS(2436),
    [anon_sym_GT] = ACTIONS(2436),
    [anon_sym_SLASH] = ACTIONS(2436),
    [anon_sym_DOT] = ACTIONS(2434),
    [anon_sym_QMARK] = ACTIONS(2434),
    [anon_sym_AMP_AMP] = ACTIONS(2434),
    [anon_sym_PIPE_PIPE] = ACTIONS(2434),
    [anon_sym_GT_GT] = ACTIONS(2436),
    [anon_sym_GT_GT_GT] = ACTIONS(2434),
    [anon_sym_LT_LT] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_CARET] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_PERCENT] = ACTIONS(2434),
    [anon_sym_STAR_STAR] = ACTIONS(2434),
    [anon_sym_LT_EQ] = ACTIONS(2434),
    [anon_sym_EQ_EQ] = ACTIONS(2436),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2434),
    [anon_sym_BANG_EQ] = ACTIONS(2436),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2434),
    [anon_sym_GT_EQ] = ACTIONS(2434),
    [anon_sym_instanceof] = ACTIONS(2434),
    [anon_sym_BANG] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2434),
    [anon_sym_DASH_DASH] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2434),
    [sym__automatic_semicolon] = ACTIONS(2434),
  },
  [1378] = {
    [anon_sym_STAR] = ACTIONS(2432),
    [anon_sym_as] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2430),
    [anon_sym_RBRACE] = ACTIONS(2430),
    [anon_sym_LPAREN] = ACTIONS(2430),
    [anon_sym_in] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2432),
    [anon_sym_GT] = ACTIONS(2432),
    [anon_sym_SLASH] = ACTIONS(2432),
    [anon_sym_DOT] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(2430),
    [anon_sym_AMP_AMP] = ACTIONS(2430),
    [anon_sym_PIPE_PIPE] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(2432),
    [anon_sym_GT_GT_GT] = ACTIONS(2430),
    [anon_sym_LT_LT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2432),
    [anon_sym_CARET] = ACTIONS(2430),
    [anon_sym_PIPE] = ACTIONS(2432),
    [anon_sym_PLUS] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2432),
    [anon_sym_PERCENT] = ACTIONS(2430),
    [anon_sym_STAR_STAR] = ACTIONS(2430),
    [anon_sym_LT_EQ] = ACTIONS(2430),
    [anon_sym_EQ_EQ] = ACTIONS(2432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2430),
    [anon_sym_BANG_EQ] = ACTIONS(2432),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2430),
    [anon_sym_GT_EQ] = ACTIONS(2430),
    [anon_sym_instanceof] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2430),
    [sym__automatic_semicolon] = ACTIONS(2430),
  },
  [1379] = {
    [anon_sym_STAR] = ACTIONS(2414),
    [anon_sym_as] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_LT] = ACTIONS(2414),
    [anon_sym_GT] = ACTIONS(2414),
    [anon_sym_SLASH] = ACTIONS(2414),
    [anon_sym_DOT] = ACTIONS(2412),
    [anon_sym_QMARK] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2412),
    [anon_sym_GT_GT] = ACTIONS(2414),
    [anon_sym_GT_GT_GT] = ACTIONS(2412),
    [anon_sym_LT_LT] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_CARET] = ACTIONS(2412),
    [anon_sym_PIPE] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PERCENT] = ACTIONS(2412),
    [anon_sym_STAR_STAR] = ACTIONS(2412),
    [anon_sym_LT_EQ] = ACTIONS(2412),
    [anon_sym_EQ_EQ] = ACTIONS(2414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2412),
    [anon_sym_BANG_EQ] = ACTIONS(2414),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2412),
    [anon_sym_GT_EQ] = ACTIONS(2412),
    [anon_sym_instanceof] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2414),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2412),
    [sym__automatic_semicolon] = ACTIONS(2412),
  },
  [1380] = {
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_as] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_SLASH] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_GT_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_CARET] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_STAR_STAR] = ACTIONS(2462),
    [anon_sym_LT_EQ] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2462),
    [anon_sym_instanceof] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [sym__automatic_semicolon] = ACTIONS(2462),
  },
  [1381] = {
    [sym_string] = STATE(1788),
    [sym__property_name] = STATE(1788),
    [sym_computed_property_name] = STATE(1788),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4440),
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(4442),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4444),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4446),
    [anon_sym_set] = ACTIONS(4446),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4448),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1382] = {
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_as] = ACTIONS(2378),
    [anon_sym_COMMA] = ACTIONS(2378),
    [anon_sym_RBRACE] = ACTIONS(2378),
    [anon_sym_LPAREN] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2380),
    [anon_sym_SEMI] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_LT] = ACTIONS(2380),
    [anon_sym_GT] = ACTIONS(2380),
    [anon_sym_SLASH] = ACTIONS(2380),
    [anon_sym_DOT] = ACTIONS(2378),
    [anon_sym_QMARK] = ACTIONS(2378),
    [anon_sym_AMP_AMP] = ACTIONS(2378),
    [anon_sym_PIPE_PIPE] = ACTIONS(2378),
    [anon_sym_GT_GT] = ACTIONS(2380),
    [anon_sym_GT_GT_GT] = ACTIONS(2378),
    [anon_sym_LT_LT] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2380),
    [anon_sym_CARET] = ACTIONS(2378),
    [anon_sym_PIPE] = ACTIONS(2380),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2380),
    [anon_sym_PERCENT] = ACTIONS(2378),
    [anon_sym_STAR_STAR] = ACTIONS(2378),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_EQ] = ACTIONS(2380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2378),
    [anon_sym_BANG_EQ] = ACTIONS(2380),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2378),
    [anon_sym_GT_EQ] = ACTIONS(2378),
    [anon_sym_instanceof] = ACTIONS(2378),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2378),
    [sym__automatic_semicolon] = ACTIONS(2378),
  },
  [1383] = {
    [anon_sym_STAR] = ACTIONS(2384),
    [anon_sym_as] = ACTIONS(2382),
    [anon_sym_COMMA] = ACTIONS(2382),
    [anon_sym_RBRACE] = ACTIONS(2382),
    [anon_sym_LPAREN] = ACTIONS(2382),
    [anon_sym_in] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_LT] = ACTIONS(2384),
    [anon_sym_GT] = ACTIONS(2384),
    [anon_sym_SLASH] = ACTIONS(2384),
    [anon_sym_DOT] = ACTIONS(4128),
    [anon_sym_QMARK] = ACTIONS(2382),
    [anon_sym_AMP_AMP] = ACTIONS(2382),
    [anon_sym_PIPE_PIPE] = ACTIONS(2382),
    [anon_sym_GT_GT] = ACTIONS(2384),
    [anon_sym_GT_GT_GT] = ACTIONS(2382),
    [anon_sym_LT_LT] = ACTIONS(2382),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym_CARET] = ACTIONS(2382),
    [anon_sym_PIPE] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_PERCENT] = ACTIONS(2382),
    [anon_sym_STAR_STAR] = ACTIONS(2382),
    [anon_sym_LT_EQ] = ACTIONS(2382),
    [anon_sym_EQ_EQ] = ACTIONS(2384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2382),
    [anon_sym_BANG_EQ] = ACTIONS(2384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2382),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_instanceof] = ACTIONS(2382),
    [anon_sym_BANG] = ACTIONS(2384),
    [anon_sym_PLUS_PLUS] = ACTIONS(2382),
    [anon_sym_DASH_DASH] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2382),
    [sym__automatic_semicolon] = ACTIONS(2382),
  },
  [1384] = {
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_as] = ACTIONS(2450),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(2450),
    [anon_sym_in] = ACTIONS(2452),
    [anon_sym_SEMI] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(2452),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_DOT] = ACTIONS(2450),
    [anon_sym_QMARK] = ACTIONS(2450),
    [anon_sym_AMP_AMP] = ACTIONS(2450),
    [anon_sym_PIPE_PIPE] = ACTIONS(2450),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_CARET] = ACTIONS(2450),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2452),
    [anon_sym_DASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_STAR_STAR] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_EQ_EQ] = ACTIONS(2452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG_EQ] = ACTIONS(2452),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_PLUS_PLUS] = ACTIONS(2450),
    [anon_sym_DASH_DASH] = ACTIONS(2450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2450),
    [sym__automatic_semicolon] = ACTIONS(2450),
  },
  [1385] = {
    [sym_type_arguments] = STATE(1558),
    [anon_sym_STAR] = ACTIONS(2555),
    [anon_sym_as] = ACTIONS(2553),
    [anon_sym_LBRACE] = ACTIONS(2555),
    [anon_sym_COMMA] = ACTIONS(2553),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_in] = ACTIONS(2555),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LT] = ACTIONS(4257),
    [anon_sym_GT] = ACTIONS(2555),
    [anon_sym_SLASH] = ACTIONS(2555),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_GT_GT] = ACTIONS(2555),
    [anon_sym_GT_GT_GT] = ACTIONS(2553),
    [anon_sym_LT_LT] = ACTIONS(2553),
    [anon_sym_AMP] = ACTIONS(2555),
    [anon_sym_CARET] = ACTIONS(2553),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2555),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_STAR_STAR] = ACTIONS(2553),
    [anon_sym_LT_EQ] = ACTIONS(2553),
    [anon_sym_EQ_EQ] = ACTIONS(2555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2553),
    [anon_sym_BANG_EQ] = ACTIONS(2555),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2553),
    [anon_sym_GT_EQ] = ACTIONS(2553),
    [anon_sym_instanceof] = ACTIONS(2553),
    [anon_sym_BANG] = ACTIONS(2555),
    [anon_sym_PLUS_PLUS] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2553),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2553),
  },
  [1386] = {
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_as] = ACTIONS(2392),
    [anon_sym_COMMA] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_in] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_GT] = ACTIONS(2394),
    [anon_sym_SLASH] = ACTIONS(2394),
    [anon_sym_DOT] = ACTIONS(2392),
    [anon_sym_QMARK] = ACTIONS(2392),
    [anon_sym_AMP_AMP] = ACTIONS(2392),
    [anon_sym_PIPE_PIPE] = ACTIONS(2392),
    [anon_sym_GT_GT] = ACTIONS(2394),
    [anon_sym_GT_GT_GT] = ACTIONS(2392),
    [anon_sym_LT_LT] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_CARET] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_PERCENT] = ACTIONS(2392),
    [anon_sym_STAR_STAR] = ACTIONS(2392),
    [anon_sym_LT_EQ] = ACTIONS(2392),
    [anon_sym_EQ_EQ] = ACTIONS(2394),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2392),
    [anon_sym_BANG_EQ] = ACTIONS(2394),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2392),
    [anon_sym_GT_EQ] = ACTIONS(2392),
    [anon_sym_instanceof] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2392),
    [sym__automatic_semicolon] = ACTIONS(2392),
  },
  [1387] = {
    [anon_sym_STAR] = ACTIONS(2398),
    [anon_sym_as] = ACTIONS(2396),
    [anon_sym_COMMA] = ACTIONS(2396),
    [anon_sym_RBRACE] = ACTIONS(2396),
    [anon_sym_LPAREN] = ACTIONS(2396),
    [anon_sym_in] = ACTIONS(2398),
    [anon_sym_SEMI] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2396),
    [anon_sym_LT] = ACTIONS(2398),
    [anon_sym_GT] = ACTIONS(2398),
    [anon_sym_SLASH] = ACTIONS(2398),
    [anon_sym_DOT] = ACTIONS(2396),
    [anon_sym_QMARK] = ACTIONS(2396),
    [anon_sym_AMP_AMP] = ACTIONS(2396),
    [anon_sym_PIPE_PIPE] = ACTIONS(2396),
    [anon_sym_GT_GT] = ACTIONS(2398),
    [anon_sym_GT_GT_GT] = ACTIONS(2396),
    [anon_sym_LT_LT] = ACTIONS(2396),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_CARET] = ACTIONS(2396),
    [anon_sym_PIPE] = ACTIONS(2398),
    [anon_sym_PLUS] = ACTIONS(2398),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_PERCENT] = ACTIONS(2396),
    [anon_sym_STAR_STAR] = ACTIONS(2396),
    [anon_sym_LT_EQ] = ACTIONS(2396),
    [anon_sym_EQ_EQ] = ACTIONS(2398),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2396),
    [anon_sym_BANG_EQ] = ACTIONS(2398),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2396),
    [anon_sym_GT_EQ] = ACTIONS(2396),
    [anon_sym_instanceof] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_PLUS_PLUS] = ACTIONS(2396),
    [anon_sym_DASH_DASH] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym__automatic_semicolon] = ACTIONS(2396),
  },
  [1388] = {
    [anon_sym_STAR] = ACTIONS(4030),
    [anon_sym_as] = ACTIONS(4032),
    [anon_sym_COMMA] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(4032),
    [anon_sym_LPAREN] = ACTIONS(4032),
    [anon_sym_in] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_LT] = ACTIONS(4030),
    [anon_sym_GT] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4030),
    [anon_sym_DOT] = ACTIONS(4032),
    [anon_sym_QMARK] = ACTIONS(4032),
    [anon_sym_AMP_AMP] = ACTIONS(4032),
    [anon_sym_PIPE_PIPE] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_GT_GT_GT] = ACTIONS(4032),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4030),
    [anon_sym_CARET] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4030),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_DASH] = ACTIONS(4030),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_LT_EQ] = ACTIONS(4032),
    [anon_sym_EQ_EQ] = ACTIONS(4030),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4032),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4032),
    [anon_sym_GT_EQ] = ACTIONS(4032),
    [anon_sym_instanceof] = ACTIONS(4032),
    [anon_sym_BANG] = ACTIONS(4030),
    [anon_sym_PLUS_PLUS] = ACTIONS(4032),
    [anon_sym_DASH_DASH] = ACTIONS(4032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4032),
    [sym__automatic_semicolon] = ACTIONS(4032),
  },
  [1389] = {
    [anon_sym_STAR] = ACTIONS(4034),
    [anon_sym_as] = ACTIONS(3715),
    [anon_sym_COMMA] = ACTIONS(3715),
    [anon_sym_RBRACE] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(4034),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_DOT] = ACTIONS(3715),
    [anon_sym_QMARK] = ACTIONS(3715),
    [anon_sym_AMP_AMP] = ACTIONS(3715),
    [anon_sym_PIPE_PIPE] = ACTIONS(3715),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [anon_sym_GT_GT_GT] = ACTIONS(3715),
    [anon_sym_LT_LT] = ACTIONS(3715),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_CARET] = ACTIONS(3715),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(3715),
    [anon_sym_STAR_STAR] = ACTIONS(3715),
    [anon_sym_LT_EQ] = ACTIONS(3715),
    [anon_sym_EQ_EQ] = ACTIONS(4034),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3715),
    [anon_sym_BANG_EQ] = ACTIONS(4034),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3715),
    [anon_sym_GT_EQ] = ACTIONS(3715),
    [anon_sym_instanceof] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(4034),
    [anon_sym_PLUS_PLUS] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [sym__automatic_semicolon] = ACTIONS(3715),
  },
  [1390] = {
    [anon_sym_STAR] = ACTIONS(4036),
    [anon_sym_as] = ACTIONS(4038),
    [anon_sym_COMMA] = ACTIONS(4038),
    [anon_sym_RBRACE] = ACTIONS(4038),
    [anon_sym_LPAREN] = ACTIONS(4038),
    [anon_sym_in] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LBRACK] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4036),
    [anon_sym_SLASH] = ACTIONS(4036),
    [anon_sym_DOT] = ACTIONS(4038),
    [anon_sym_QMARK] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4036),
    [anon_sym_GT_GT_GT] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_CARET] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_PLUS] = ACTIONS(4036),
    [anon_sym_DASH] = ACTIONS(4036),
    [anon_sym_PERCENT] = ACTIONS(4038),
    [anon_sym_STAR_STAR] = ACTIONS(4038),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4038),
    [anon_sym_BANG_EQ] = ACTIONS(4036),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4038),
    [anon_sym_instanceof] = ACTIONS(4038),
    [anon_sym_BANG] = ACTIONS(4036),
    [anon_sym_PLUS_PLUS] = ACTIONS(4038),
    [anon_sym_DASH_DASH] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [sym__automatic_semicolon] = ACTIONS(4038),
  },
  [1391] = {
    [anon_sym_STAR] = ACTIONS(4040),
    [anon_sym_as] = ACTIONS(3727),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_RBRACE] = ACTIONS(3727),
    [anon_sym_LPAREN] = ACTIONS(3727),
    [anon_sym_in] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3727),
    [anon_sym_LT] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4040),
    [anon_sym_SLASH] = ACTIONS(4040),
    [anon_sym_DOT] = ACTIONS(3727),
    [anon_sym_QMARK] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3727),
    [anon_sym_PIPE_PIPE] = ACTIONS(3727),
    [anon_sym_GT_GT] = ACTIONS(4040),
    [anon_sym_GT_GT_GT] = ACTIONS(3727),
    [anon_sym_LT_LT] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_CARET] = ACTIONS(3727),
    [anon_sym_PIPE] = ACTIONS(4040),
    [anon_sym_PLUS] = ACTIONS(4040),
    [anon_sym_DASH] = ACTIONS(4040),
    [anon_sym_PERCENT] = ACTIONS(3727),
    [anon_sym_STAR_STAR] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(3727),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3727),
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3727),
    [anon_sym_GT_EQ] = ACTIONS(3727),
    [anon_sym_instanceof] = ACTIONS(3727),
    [anon_sym_BANG] = ACTIONS(4040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3727),
    [anon_sym_DASH_DASH] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3727),
    [sym__automatic_semicolon] = ACTIONS(3727),
  },
  [1392] = {
    [anon_sym_STAR] = ACTIONS(4042),
    [anon_sym_as] = ACTIONS(3740),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_RBRACE] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3740),
    [anon_sym_in] = ACTIONS(4042),
    [anon_sym_SEMI] = ACTIONS(3740),
    [anon_sym_LBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_SLASH] = ACTIONS(4042),
    [anon_sym_DOT] = ACTIONS(3740),
    [anon_sym_QMARK] = ACTIONS(3740),
    [anon_sym_AMP_AMP] = ACTIONS(3740),
    [anon_sym_PIPE_PIPE] = ACTIONS(3740),
    [anon_sym_GT_GT] = ACTIONS(4042),
    [anon_sym_GT_GT_GT] = ACTIONS(3740),
    [anon_sym_LT_LT] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(4042),
    [anon_sym_CARET] = ACTIONS(3740),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_PLUS] = ACTIONS(4042),
    [anon_sym_DASH] = ACTIONS(4042),
    [anon_sym_PERCENT] = ACTIONS(3740),
    [anon_sym_STAR_STAR] = ACTIONS(3740),
    [anon_sym_LT_EQ] = ACTIONS(3740),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3740),
    [anon_sym_BANG_EQ] = ACTIONS(4042),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3740),
    [anon_sym_GT_EQ] = ACTIONS(3740),
    [anon_sym_instanceof] = ACTIONS(3740),
    [anon_sym_BANG] = ACTIONS(4042),
    [anon_sym_PLUS_PLUS] = ACTIONS(3740),
    [anon_sym_DASH_DASH] = ACTIONS(3740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3740),
    [sym__automatic_semicolon] = ACTIONS(3740),
  },
  [1393] = {
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_RPAREN] = ACTIONS(2484),
    [anon_sym_in] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
  },
  [1394] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4450),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_implements] = ACTIONS(1209),
  },
  [1395] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4452),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_implements] = ACTIONS(1209),
  },
  [1396] = {
    [anon_sym_STAR] = ACTIONS(4044),
    [anon_sym_as] = ACTIONS(4046),
    [anon_sym_COMMA] = ACTIONS(4046),
    [anon_sym_RBRACE] = ACTIONS(4046),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [anon_sym_in] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_LBRACK] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_SLASH] = ACTIONS(4044),
    [anon_sym_DOT] = ACTIONS(4046),
    [anon_sym_QMARK] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(4044),
    [anon_sym_GT_GT_GT] = ACTIONS(4046),
    [anon_sym_LT_LT] = ACTIONS(4046),
    [anon_sym_AMP] = ACTIONS(4044),
    [anon_sym_CARET] = ACTIONS(4046),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_PLUS] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(4044),
    [anon_sym_PERCENT] = ACTIONS(4046),
    [anon_sym_STAR_STAR] = ACTIONS(4046),
    [anon_sym_LT_EQ] = ACTIONS(4046),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4046),
    [anon_sym_BANG_EQ] = ACTIONS(4044),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4046),
    [anon_sym_GT_EQ] = ACTIONS(4046),
    [anon_sym_instanceof] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(4044),
    [anon_sym_PLUS_PLUS] = ACTIONS(4046),
    [anon_sym_DASH_DASH] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [sym__automatic_semicolon] = ACTIONS(4046),
  },
  [1397] = {
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_as] = ACTIONS(3319),
    [anon_sym_COMMA] = ACTIONS(3319),
    [anon_sym_RBRACE] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_in] = ACTIONS(3317),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(3317),
    [anon_sym_GT] = ACTIONS(3317),
    [anon_sym_SLASH] = ACTIONS(3317),
    [anon_sym_DOT] = ACTIONS(3319),
    [anon_sym_QMARK] = ACTIONS(3319),
    [anon_sym_AMP_AMP] = ACTIONS(3319),
    [anon_sym_PIPE_PIPE] = ACTIONS(3319),
    [anon_sym_GT_GT] = ACTIONS(3317),
    [anon_sym_GT_GT_GT] = ACTIONS(3319),
    [anon_sym_LT_LT] = ACTIONS(3319),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3319),
    [anon_sym_PIPE] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_PERCENT] = ACTIONS(3319),
    [anon_sym_STAR_STAR] = ACTIONS(3319),
    [anon_sym_LT_EQ] = ACTIONS(3319),
    [anon_sym_EQ_EQ] = ACTIONS(3317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3319),
    [anon_sym_BANG_EQ] = ACTIONS(3317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3319),
    [anon_sym_GT_EQ] = ACTIONS(3319),
    [anon_sym_instanceof] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [sym__automatic_semicolon] = ACTIONS(3319),
  },
  [1398] = {
    [anon_sym_STAR] = ACTIONS(1201),
    [anon_sym_as] = ACTIONS(1199),
    [anon_sym_LBRACE] = ACTIONS(1201),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_in] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(1199),
    [anon_sym_QMARK] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_CARET] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1201),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_instanceof] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1199),
    [sym__automatic_semicolon] = ACTIONS(4454),
  },
  [1399] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4456),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3398),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(4458),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(3398),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(3398),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(4000),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1400] = {
    [anon_sym_STAR] = ACTIONS(2444),
    [anon_sym_as] = ACTIONS(2442),
    [anon_sym_COMMA] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [anon_sym_in] = ACTIONS(2444),
    [anon_sym_SEMI] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(2444),
    [anon_sym_DOT] = ACTIONS(2442),
    [anon_sym_QMARK] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_GT_GT] = ACTIONS(2444),
    [anon_sym_GT_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_CARET] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_PERCENT] = ACTIONS(2442),
    [anon_sym_STAR_STAR] = ACTIONS(2442),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_EQ_EQ] = ACTIONS(2444),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ] = ACTIONS(2444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_instanceof] = ACTIONS(2442),
    [anon_sym_BANG] = ACTIONS(2444),
    [anon_sym_PLUS_PLUS] = ACTIONS(2442),
    [anon_sym_DASH_DASH] = ACTIONS(2442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [sym__automatic_semicolon] = ACTIONS(2442),
  },
  [1401] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4462),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(4465),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(4465),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(4468),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(4465),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1402] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4470),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(4473),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(4473),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(4476),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(4473),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1403] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4456),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3398),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(3398),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(3470),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(3398),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1404] = {
    [anon_sym_STAR] = ACTIONS(4115),
    [anon_sym_as] = ACTIONS(4115),
    [anon_sym_LBRACE] = ACTIONS(4115),
    [anon_sym_COMMA] = ACTIONS(4117),
    [anon_sym_LPAREN] = ACTIONS(4117),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(4117),
    [anon_sym_LT] = ACTIONS(4115),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4115),
    [anon_sym_DOT] = ACTIONS(4117),
    [anon_sym_QMARK] = ACTIONS(4117),
    [anon_sym_AMP_AMP] = ACTIONS(4117),
    [anon_sym_PIPE_PIPE] = ACTIONS(4117),
    [anon_sym_GT_GT] = ACTIONS(4115),
    [anon_sym_GT_GT_GT] = ACTIONS(4117),
    [anon_sym_LT_LT] = ACTIONS(4117),
    [anon_sym_AMP] = ACTIONS(4115),
    [anon_sym_CARET] = ACTIONS(4117),
    [anon_sym_PIPE] = ACTIONS(4115),
    [anon_sym_PLUS] = ACTIONS(4115),
    [anon_sym_DASH] = ACTIONS(4115),
    [anon_sym_PERCENT] = ACTIONS(4117),
    [anon_sym_STAR_STAR] = ACTIONS(4117),
    [anon_sym_LT_EQ] = ACTIONS(4117),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4117),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4117),
    [anon_sym_GT_EQ] = ACTIONS(4117),
    [anon_sym_instanceof] = ACTIONS(4115),
    [anon_sym_BANG] = ACTIONS(4115),
    [anon_sym_PLUS_PLUS] = ACTIONS(4117),
    [anon_sym_DASH_DASH] = ACTIONS(4117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4117),
    [sym_regex_flags] = ACTIONS(4478),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4117),
  },
  [1405] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1406] = {
    [sym_statement_block] = STATE(1570),
    [anon_sym_STAR] = ACTIONS(1073),
    [anon_sym_as] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(4480),
    [anon_sym_COMMA] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(1071),
    [anon_sym_QMARK] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_STAR_STAR] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1071),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_instanceof] = ACTIONS(1071),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1071),
  },
  [1407] = {
    [sym_statement_block] = STATE(1570),
    [anon_sym_STAR] = ACTIONS(1073),
    [anon_sym_as] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(4480),
    [anon_sym_COMMA] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_STAR_STAR] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1071),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_instanceof] = ACTIONS(1071),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1071),
  },
  [1408] = {
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_as] = ACTIONS(4050),
    [anon_sym_COMMA] = ACTIONS(4050),
    [anon_sym_RBRACE] = ACTIONS(4050),
    [anon_sym_LPAREN] = ACTIONS(4050),
    [anon_sym_in] = ACTIONS(4048),
    [anon_sym_SEMI] = ACTIONS(4050),
    [anon_sym_LBRACK] = ACTIONS(4050),
    [anon_sym_LT] = ACTIONS(4048),
    [anon_sym_GT] = ACTIONS(4048),
    [anon_sym_SLASH] = ACTIONS(4048),
    [anon_sym_DOT] = ACTIONS(4050),
    [anon_sym_QMARK] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4048),
    [anon_sym_GT_GT_GT] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_PLUS] = ACTIONS(4048),
    [anon_sym_DASH] = ACTIONS(4048),
    [anon_sym_PERCENT] = ACTIONS(4050),
    [anon_sym_STAR_STAR] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4050),
    [anon_sym_GT_EQ] = ACTIONS(4050),
    [anon_sym_instanceof] = ACTIONS(4050),
    [anon_sym_BANG] = ACTIONS(4048),
    [anon_sym_PLUS_PLUS] = ACTIONS(4050),
    [anon_sym_DASH_DASH] = ACTIONS(4050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4050),
    [sym__automatic_semicolon] = ACTIONS(4050),
  },
  [1409] = {
    [anon_sym_STAR] = ACTIONS(4005),
    [anon_sym_as] = ACTIONS(3713),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3713),
    [anon_sym_in] = ACTIONS(4005),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_GT] = ACTIONS(4005),
    [anon_sym_SLASH] = ACTIONS(4005),
    [anon_sym_DOT] = ACTIONS(3713),
    [anon_sym_QMARK] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3713),
    [anon_sym_PIPE_PIPE] = ACTIONS(3713),
    [anon_sym_GT_GT] = ACTIONS(4005),
    [anon_sym_GT_GT_GT] = ACTIONS(3713),
    [anon_sym_LT_LT] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(4005),
    [anon_sym_CARET] = ACTIONS(3713),
    [anon_sym_PIPE] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PERCENT] = ACTIONS(3713),
    [anon_sym_STAR_STAR] = ACTIONS(3713),
    [anon_sym_LT_EQ] = ACTIONS(3713),
    [anon_sym_EQ_EQ] = ACTIONS(4005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3713),
    [anon_sym_BANG_EQ] = ACTIONS(4005),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3713),
    [anon_sym_GT_EQ] = ACTIONS(3713),
    [anon_sym_instanceof] = ACTIONS(3713),
    [anon_sym_BANG] = ACTIONS(4005),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3713),
    [sym__automatic_semicolon] = ACTIONS(3713),
  },
  [1410] = {
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_as] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4054),
    [anon_sym_RBRACE] = ACTIONS(4054),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_in] = ACTIONS(4052),
    [anon_sym_SEMI] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4054),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_CARET] = ACTIONS(4054),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_PLUS] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_STAR_STAR] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_instanceof] = ACTIONS(4054),
    [anon_sym_BANG] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4054),
    [anon_sym_DASH_DASH] = ACTIONS(4054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4054),
    [sym__automatic_semicolon] = ACTIONS(4054),
  },
  [1411] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1412] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(4000),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(4000),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1413] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(3994),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(3994),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(3994),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1414] = {
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_as] = ACTIONS(3987),
    [anon_sym_COMMA] = ACTIONS(3987),
    [anon_sym_RBRACE] = ACTIONS(3987),
    [anon_sym_LPAREN] = ACTIONS(3987),
    [anon_sym_in] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3985),
    [anon_sym_GT] = ACTIONS(3985),
    [anon_sym_SLASH] = ACTIONS(3985),
    [anon_sym_DOT] = ACTIONS(3987),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3987),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_GT_GT_GT] = ACTIONS(3987),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3985),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3985),
    [anon_sym_DASH] = ACTIONS(3985),
    [anon_sym_PERCENT] = ACTIONS(3987),
    [anon_sym_STAR_STAR] = ACTIONS(3987),
    [anon_sym_LT_EQ] = ACTIONS(3987),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3987),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3987),
    [anon_sym_GT_EQ] = ACTIONS(3987),
    [anon_sym_instanceof] = ACTIONS(3987),
    [anon_sym_BANG] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3987),
    [anon_sym_DASH_DASH] = ACTIONS(3987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3987),
    [sym__automatic_semicolon] = ACTIONS(3987),
  },
  [1415] = {
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_as] = ACTIONS(3987),
    [anon_sym_COMMA] = ACTIONS(3987),
    [anon_sym_RBRACE] = ACTIONS(3987),
    [anon_sym_LPAREN] = ACTIONS(3987),
    [anon_sym_in] = ACTIONS(3985),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3985),
    [anon_sym_GT] = ACTIONS(3985),
    [anon_sym_SLASH] = ACTIONS(3985),
    [anon_sym_DOT] = ACTIONS(3987),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3987),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_GT_GT_GT] = ACTIONS(3987),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3985),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3985),
    [anon_sym_DASH] = ACTIONS(3985),
    [anon_sym_PERCENT] = ACTIONS(3987),
    [anon_sym_STAR_STAR] = ACTIONS(3987),
    [anon_sym_LT_EQ] = ACTIONS(3987),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3987),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3987),
    [anon_sym_GT_EQ] = ACTIONS(3987),
    [anon_sym_instanceof] = ACTIONS(3987),
    [anon_sym_BANG] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3987),
    [anon_sym_DASH_DASH] = ACTIONS(3987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3987),
    [sym__automatic_semicolon] = ACTIONS(3987),
  },
  [1416] = {
    [anon_sym_STAR] = ACTIONS(3981),
    [anon_sym_as] = ACTIONS(3983),
    [anon_sym_COMMA] = ACTIONS(3983),
    [anon_sym_RBRACE] = ACTIONS(3983),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_in] = ACTIONS(3981),
    [anon_sym_SEMI] = ACTIONS(3983),
    [anon_sym_LBRACK] = ACTIONS(3983),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3981),
    [anon_sym_SLASH] = ACTIONS(3981),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3983),
    [anon_sym_PIPE_PIPE] = ACTIONS(3983),
    [anon_sym_GT_GT] = ACTIONS(3981),
    [anon_sym_GT_GT_GT] = ACTIONS(3983),
    [anon_sym_LT_LT] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3981),
    [anon_sym_CARET] = ACTIONS(3983),
    [anon_sym_PIPE] = ACTIONS(3981),
    [anon_sym_PLUS] = ACTIONS(3981),
    [anon_sym_DASH] = ACTIONS(3981),
    [anon_sym_PERCENT] = ACTIONS(3983),
    [anon_sym_STAR_STAR] = ACTIONS(3983),
    [anon_sym_LT_EQ] = ACTIONS(3983),
    [anon_sym_EQ_EQ] = ACTIONS(3981),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3983),
    [anon_sym_BANG_EQ] = ACTIONS(3981),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3983),
    [anon_sym_GT_EQ] = ACTIONS(3983),
    [anon_sym_instanceof] = ACTIONS(3983),
    [anon_sym_BANG] = ACTIONS(3981),
    [anon_sym_PLUS_PLUS] = ACTIONS(3983),
    [anon_sym_DASH_DASH] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3983),
    [sym__automatic_semicolon] = ACTIONS(3983),
  },
  [1417] = {
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_as] = ACTIONS(3609),
    [anon_sym_COMMA] = ACTIONS(3609),
    [anon_sym_RBRACE] = ACTIONS(3609),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3611),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_LT] = ACTIONS(3611),
    [anon_sym_GT] = ACTIONS(3611),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_DOT] = ACTIONS(3609),
    [anon_sym_QMARK] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_PIPE_PIPE] = ACTIONS(3609),
    [anon_sym_GT_GT] = ACTIONS(3611),
    [anon_sym_GT_GT_GT] = ACTIONS(3609),
    [anon_sym_LT_LT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_CARET] = ACTIONS(3609),
    [anon_sym_PIPE] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3609),
    [anon_sym_STAR_STAR] = ACTIONS(3609),
    [anon_sym_LT_EQ] = ACTIONS(3609),
    [anon_sym_EQ_EQ] = ACTIONS(3611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3609),
    [anon_sym_BANG_EQ] = ACTIONS(3611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3609),
    [anon_sym_GT_EQ] = ACTIONS(3609),
    [anon_sym_instanceof] = ACTIONS(3609),
    [anon_sym_BANG] = ACTIONS(3611),
    [anon_sym_PLUS_PLUS] = ACTIONS(3609),
    [anon_sym_DASH_DASH] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3609),
    [sym__automatic_semicolon] = ACTIONS(3609),
  },
  [1418] = {
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_as] = ACTIONS(3765),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3765),
    [anon_sym_in] = ACTIONS(3979),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_DOT] = ACTIONS(3765),
    [anon_sym_QMARK] = ACTIONS(3765),
    [anon_sym_AMP_AMP] = ACTIONS(3765),
    [anon_sym_PIPE_PIPE] = ACTIONS(3765),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3765),
    [anon_sym_LT_LT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_CARET] = ACTIONS(3765),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_PERCENT] = ACTIONS(3765),
    [anon_sym_STAR_STAR] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3765),
    [anon_sym_EQ_EQ] = ACTIONS(3979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3765),
    [anon_sym_BANG_EQ] = ACTIONS(3979),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3765),
    [anon_sym_GT_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3765),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3765),
    [anon_sym_DASH_DASH] = ACTIONS(3765),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3765),
    [sym__automatic_semicolon] = ACTIONS(3765),
  },
  [1419] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(4486),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1420] = {
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_as] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3977),
    [anon_sym_RBRACE] = ACTIONS(3977),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_in] = ACTIONS(3975),
    [anon_sym_SEMI] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_GT] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3975),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_GT_GT] = ACTIONS(3975),
    [anon_sym_GT_GT_GT] = ACTIONS(3977),
    [anon_sym_LT_LT] = ACTIONS(3977),
    [anon_sym_AMP] = ACTIONS(3975),
    [anon_sym_CARET] = ACTIONS(3977),
    [anon_sym_PIPE] = ACTIONS(3975),
    [anon_sym_PLUS] = ACTIONS(3975),
    [anon_sym_DASH] = ACTIONS(3975),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_STAR_STAR] = ACTIONS(3977),
    [anon_sym_LT_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ] = ACTIONS(3975),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3975),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3977),
    [anon_sym_GT_EQ] = ACTIONS(3977),
    [anon_sym_instanceof] = ACTIONS(3977),
    [anon_sym_BANG] = ACTIONS(3975),
    [anon_sym_PLUS_PLUS] = ACTIONS(3977),
    [anon_sym_DASH_DASH] = ACTIONS(3977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3977),
    [sym__automatic_semicolon] = ACTIONS(3977),
  },
  [1421] = {
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_as] = ACTIONS(1107),
    [anon_sym_COMMA] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(1107),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_in] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1107),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_GT_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1107),
    [anon_sym_LT_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1107),
    [anon_sym_GT_EQ] = ACTIONS(1107),
    [anon_sym_instanceof] = ACTIONS(1107),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [sym__automatic_semicolon] = ACTIONS(1107),
  },
  [1422] = {
    [anon_sym_STAR] = ACTIONS(1149),
    [anon_sym_as] = ACTIONS(1151),
    [anon_sym_COMMA] = ACTIONS(1151),
    [anon_sym_RBRACE] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_in] = ACTIONS(1149),
    [anon_sym_SEMI] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(1149),
    [anon_sym_GT] = ACTIONS(1149),
    [anon_sym_SLASH] = ACTIONS(1149),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_QMARK] = ACTIONS(1151),
    [anon_sym_AMP_AMP] = ACTIONS(1151),
    [anon_sym_PIPE_PIPE] = ACTIONS(1151),
    [anon_sym_GT_GT] = ACTIONS(1149),
    [anon_sym_GT_GT_GT] = ACTIONS(1151),
    [anon_sym_LT_LT] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(1151),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_PLUS] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_PERCENT] = ACTIONS(1151),
    [anon_sym_STAR_STAR] = ACTIONS(1151),
    [anon_sym_LT_EQ] = ACTIONS(1151),
    [anon_sym_EQ_EQ] = ACTIONS(1149),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1151),
    [anon_sym_BANG_EQ] = ACTIONS(1149),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1151),
    [anon_sym_GT_EQ] = ACTIONS(1151),
    [anon_sym_instanceof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1149),
    [anon_sym_PLUS_PLUS] = ACTIONS(1151),
    [anon_sym_DASH_DASH] = ACTIONS(1151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1151),
    [sym__automatic_semicolon] = ACTIONS(1151),
  },
  [1423] = {
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_RBRACE] = ACTIONS(3973),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_in] = ACTIONS(3971),
    [anon_sym_SEMI] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_GT] = ACTIONS(3971),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3973),
    [anon_sym_LT_LT] = ACTIONS(3973),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_CARET] = ACTIONS(3973),
    [anon_sym_PIPE] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_STAR_STAR] = ACTIONS(3973),
    [anon_sym_LT_EQ] = ACTIONS(3973),
    [anon_sym_EQ_EQ] = ACTIONS(3971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3971),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3973),
    [anon_sym_GT_EQ] = ACTIONS(3973),
    [anon_sym_instanceof] = ACTIONS(3973),
    [anon_sym_BANG] = ACTIONS(3971),
    [anon_sym_PLUS_PLUS] = ACTIONS(3973),
    [anon_sym_DASH_DASH] = ACTIONS(3973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3973),
    [sym__automatic_semicolon] = ACTIONS(3973),
  },
  [1424] = {
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_RBRACE] = ACTIONS(3973),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_in] = ACTIONS(3971),
    [anon_sym_SEMI] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_GT] = ACTIONS(3971),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3973),
    [anon_sym_LT_LT] = ACTIONS(3973),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_CARET] = ACTIONS(3973),
    [anon_sym_PIPE] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_STAR_STAR] = ACTIONS(3973),
    [anon_sym_LT_EQ] = ACTIONS(3973),
    [anon_sym_EQ_EQ] = ACTIONS(3971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3971),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3973),
    [anon_sym_GT_EQ] = ACTIONS(3973),
    [anon_sym_instanceof] = ACTIONS(3973),
    [anon_sym_BANG] = ACTIONS(3971),
    [anon_sym_PLUS_PLUS] = ACTIONS(3973),
    [anon_sym_DASH_DASH] = ACTIONS(3973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3973),
    [sym__automatic_semicolon] = ACTIONS(3973),
  },
  [1425] = {
    [anon_sym_STAR] = ACTIONS(3967),
    [anon_sym_as] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3969),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_GT] = ACTIONS(3967),
    [anon_sym_SLASH] = ACTIONS(3967),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_GT_GT] = ACTIONS(3967),
    [anon_sym_GT_GT_GT] = ACTIONS(3969),
    [anon_sym_LT_LT] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_CARET] = ACTIONS(3969),
    [anon_sym_PIPE] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_STAR_STAR] = ACTIONS(3969),
    [anon_sym_LT_EQ] = ACTIONS(3969),
    [anon_sym_EQ_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3969),
    [anon_sym_GT_EQ] = ACTIONS(3969),
    [anon_sym_instanceof] = ACTIONS(3969),
    [anon_sym_BANG] = ACTIONS(3967),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3969),
    [sym__automatic_semicolon] = ACTIONS(3969),
  },
  [1426] = {
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_as] = ACTIONS(1217),
    [anon_sym_COMMA] = ACTIONS(1217),
    [anon_sym_RBRACE] = ACTIONS(1217),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(1215),
    [anon_sym_SEMI] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1215),
    [anon_sym_GT] = ACTIONS(1215),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1217),
    [anon_sym_AMP_AMP] = ACTIONS(1217),
    [anon_sym_PIPE_PIPE] = ACTIONS(1217),
    [anon_sym_GT_GT] = ACTIONS(1215),
    [anon_sym_GT_GT_GT] = ACTIONS(1217),
    [anon_sym_LT_LT] = ACTIONS(1217),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1217),
    [anon_sym_PIPE] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1217),
    [anon_sym_STAR_STAR] = ACTIONS(1217),
    [anon_sym_LT_EQ] = ACTIONS(1217),
    [anon_sym_EQ_EQ] = ACTIONS(1215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1217),
    [anon_sym_BANG_EQ] = ACTIONS(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1217),
    [anon_sym_GT_EQ] = ACTIONS(1217),
    [anon_sym_instanceof] = ACTIONS(1217),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1217),
    [sym__automatic_semicolon] = ACTIONS(1217),
  },
  [1427] = {
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_as] = ACTIONS(1239),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_in] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1239),
    [anon_sym_QMARK] = ACTIONS(1239),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_GT_GT_GT] = ACTIONS(1239),
    [anon_sym_LT_LT] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PERCENT] = ACTIONS(1239),
    [anon_sym_STAR_STAR] = ACTIONS(1239),
    [anon_sym_LT_EQ] = ACTIONS(1239),
    [anon_sym_EQ_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1239),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1239),
    [anon_sym_GT_EQ] = ACTIONS(1239),
    [anon_sym_instanceof] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym__automatic_semicolon] = ACTIONS(1239),
  },
  [1428] = {
    [anon_sym_STAR] = ACTIONS(3961),
    [anon_sym_as] = ACTIONS(3963),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_RBRACE] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3963),
    [anon_sym_in] = ACTIONS(3961),
    [anon_sym_SEMI] = ACTIONS(3963),
    [anon_sym_LBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3961),
    [anon_sym_GT] = ACTIONS(3961),
    [anon_sym_SLASH] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3963),
    [anon_sym_QMARK] = ACTIONS(3963),
    [anon_sym_AMP_AMP] = ACTIONS(3963),
    [anon_sym_PIPE_PIPE] = ACTIONS(3963),
    [anon_sym_GT_GT] = ACTIONS(3961),
    [anon_sym_GT_GT_GT] = ACTIONS(3963),
    [anon_sym_LT_LT] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_CARET] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3963),
    [anon_sym_STAR_STAR] = ACTIONS(3963),
    [anon_sym_LT_EQ] = ACTIONS(3963),
    [anon_sym_EQ_EQ] = ACTIONS(3961),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3963),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3963),
    [anon_sym_GT_EQ] = ACTIONS(3963),
    [anon_sym_instanceof] = ACTIONS(3963),
    [anon_sym_BANG] = ACTIONS(3961),
    [anon_sym_PLUS_PLUS] = ACTIONS(3963),
    [anon_sym_DASH_DASH] = ACTIONS(3963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3963),
    [sym__automatic_semicolon] = ACTIONS(3963),
  },
  [1429] = {
    [anon_sym_STAR] = ACTIONS(3952),
    [anon_sym_as] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3954),
    [anon_sym_RBRACE] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_in] = ACTIONS(3952),
    [anon_sym_SEMI] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_GT] = ACTIONS(3952),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_GT_GT] = ACTIONS(3952),
    [anon_sym_GT_GT_GT] = ACTIONS(3954),
    [anon_sym_LT_LT] = ACTIONS(3954),
    [anon_sym_AMP] = ACTIONS(3952),
    [anon_sym_CARET] = ACTIONS(3954),
    [anon_sym_PIPE] = ACTIONS(3952),
    [anon_sym_PLUS] = ACTIONS(3952),
    [anon_sym_DASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3954),
    [anon_sym_LT_EQ] = ACTIONS(3954),
    [anon_sym_EQ_EQ] = ACTIONS(3952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3952),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3954),
    [anon_sym_GT_EQ] = ACTIONS(3954),
    [anon_sym_instanceof] = ACTIONS(3954),
    [anon_sym_BANG] = ACTIONS(3952),
    [anon_sym_PLUS_PLUS] = ACTIONS(3954),
    [anon_sym_DASH_DASH] = ACTIONS(3954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3954),
    [sym__automatic_semicolon] = ACTIONS(3954),
  },
  [1430] = {
    [anon_sym_STAR] = ACTIONS(3922),
    [anon_sym_as] = ACTIONS(3924),
    [anon_sym_COMMA] = ACTIONS(3924),
    [anon_sym_RBRACE] = ACTIONS(3924),
    [anon_sym_LPAREN] = ACTIONS(3924),
    [anon_sym_in] = ACTIONS(3922),
    [anon_sym_SEMI] = ACTIONS(3924),
    [anon_sym_LBRACK] = ACTIONS(3924),
    [anon_sym_LT] = ACTIONS(3922),
    [anon_sym_GT] = ACTIONS(3922),
    [anon_sym_SLASH] = ACTIONS(3922),
    [anon_sym_DOT] = ACTIONS(3924),
    [anon_sym_QMARK] = ACTIONS(3924),
    [anon_sym_AMP_AMP] = ACTIONS(3924),
    [anon_sym_PIPE_PIPE] = ACTIONS(3924),
    [anon_sym_GT_GT] = ACTIONS(3922),
    [anon_sym_GT_GT_GT] = ACTIONS(3924),
    [anon_sym_LT_LT] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(3922),
    [anon_sym_CARET] = ACTIONS(3924),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_PLUS] = ACTIONS(3922),
    [anon_sym_DASH] = ACTIONS(3922),
    [anon_sym_PERCENT] = ACTIONS(3924),
    [anon_sym_STAR_STAR] = ACTIONS(3924),
    [anon_sym_LT_EQ] = ACTIONS(3924),
    [anon_sym_EQ_EQ] = ACTIONS(3922),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3924),
    [anon_sym_BANG_EQ] = ACTIONS(3922),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3924),
    [anon_sym_GT_EQ] = ACTIONS(3924),
    [anon_sym_instanceof] = ACTIONS(3924),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_PLUS_PLUS] = ACTIONS(3924),
    [anon_sym_DASH_DASH] = ACTIONS(3924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3924),
    [sym__automatic_semicolon] = ACTIONS(3924),
  },
  [1431] = {
    [anon_sym_STAR] = ACTIONS(3914),
    [anon_sym_as] = ACTIONS(3916),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_RBRACE] = ACTIONS(3916),
    [anon_sym_LPAREN] = ACTIONS(3916),
    [anon_sym_in] = ACTIONS(3914),
    [anon_sym_SEMI] = ACTIONS(3916),
    [anon_sym_LBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3914),
    [anon_sym_GT] = ACTIONS(3914),
    [anon_sym_SLASH] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3916),
    [anon_sym_QMARK] = ACTIONS(3916),
    [anon_sym_AMP_AMP] = ACTIONS(3916),
    [anon_sym_PIPE_PIPE] = ACTIONS(3916),
    [anon_sym_GT_GT] = ACTIONS(3914),
    [anon_sym_GT_GT_GT] = ACTIONS(3916),
    [anon_sym_LT_LT] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_CARET] = ACTIONS(3916),
    [anon_sym_PIPE] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3916),
    [anon_sym_STAR_STAR] = ACTIONS(3916),
    [anon_sym_LT_EQ] = ACTIONS(3916),
    [anon_sym_EQ_EQ] = ACTIONS(3914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3916),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3916),
    [anon_sym_GT_EQ] = ACTIONS(3916),
    [anon_sym_instanceof] = ACTIONS(3916),
    [anon_sym_BANG] = ACTIONS(3914),
    [anon_sym_PLUS_PLUS] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(3916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3916),
    [sym__automatic_semicolon] = ACTIONS(3916),
  },
  [1432] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(4488),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1433] = {
    [sym_string] = STATE(2041),
    [sym__property_name] = STATE(2041),
    [sym_computed_property_name] = STATE(2041),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4101),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3552),
    [anon_sym_RBRACE] = ACTIONS(3552),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4376),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4378),
    [anon_sym_set] = ACTIONS(4378),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1434] = {
    [sym_string] = STATE(1801),
    [sym__property_name] = STATE(1801),
    [sym_computed_property_name] = STATE(1801),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4490),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(4492),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4494),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4496),
    [anon_sym_set] = ACTIONS(4496),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4498),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1435] = {
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_EQ] = ACTIONS(3643),
    [anon_sym_as] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3643),
    [anon_sym_COMMA] = ACTIONS(3645),
    [anon_sym_LPAREN] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3643),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_LT] = ACTIONS(3643),
    [anon_sym_GT] = ACTIONS(3643),
    [anon_sym_SLASH] = ACTIONS(3643),
    [anon_sym_DOT] = ACTIONS(3645),
    [anon_sym_QMARK] = ACTIONS(3645),
    [anon_sym_AMP_AMP] = ACTIONS(3645),
    [anon_sym_PIPE_PIPE] = ACTIONS(3645),
    [anon_sym_GT_GT] = ACTIONS(3643),
    [anon_sym_GT_GT_GT] = ACTIONS(3645),
    [anon_sym_LT_LT] = ACTIONS(3645),
    [anon_sym_AMP] = ACTIONS(3643),
    [anon_sym_CARET] = ACTIONS(3645),
    [anon_sym_PIPE] = ACTIONS(3643),
    [anon_sym_PLUS] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3643),
    [anon_sym_PERCENT] = ACTIONS(3645),
    [anon_sym_STAR_STAR] = ACTIONS(3645),
    [anon_sym_LT_EQ] = ACTIONS(3645),
    [anon_sym_EQ_EQ] = ACTIONS(3643),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3645),
    [anon_sym_BANG_EQ] = ACTIONS(3643),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3645),
    [anon_sym_GT_EQ] = ACTIONS(3645),
    [anon_sym_instanceof] = ACTIONS(3645),
    [anon_sym_BANG] = ACTIONS(3643),
    [anon_sym_PLUS_PLUS] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3645),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3645),
  },
  [1436] = {
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_EQ] = ACTIONS(3639),
    [anon_sym_as] = ACTIONS(3641),
    [anon_sym_LBRACE] = ACTIONS(3639),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_LPAREN] = ACTIONS(3641),
    [anon_sym_in] = ACTIONS(3639),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_LT] = ACTIONS(3639),
    [anon_sym_GT] = ACTIONS(3639),
    [anon_sym_SLASH] = ACTIONS(3639),
    [anon_sym_DOT] = ACTIONS(3641),
    [anon_sym_QMARK] = ACTIONS(3641),
    [anon_sym_AMP_AMP] = ACTIONS(3641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3641),
    [anon_sym_GT_GT] = ACTIONS(3639),
    [anon_sym_GT_GT_GT] = ACTIONS(3641),
    [anon_sym_LT_LT] = ACTIONS(3641),
    [anon_sym_AMP] = ACTIONS(3639),
    [anon_sym_CARET] = ACTIONS(3641),
    [anon_sym_PIPE] = ACTIONS(3639),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_PERCENT] = ACTIONS(3641),
    [anon_sym_STAR_STAR] = ACTIONS(3641),
    [anon_sym_LT_EQ] = ACTIONS(3641),
    [anon_sym_EQ_EQ] = ACTIONS(3639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3641),
    [anon_sym_BANG_EQ] = ACTIONS(3639),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3641),
    [anon_sym_GT_EQ] = ACTIONS(3641),
    [anon_sym_instanceof] = ACTIONS(3641),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_PLUS_PLUS] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3641),
  },
  [1437] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(4500),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1438] = {
    [anon_sym_STAR] = ACTIONS(3635),
    [anon_sym_EQ] = ACTIONS(3635),
    [anon_sym_as] = ACTIONS(3637),
    [anon_sym_LBRACE] = ACTIONS(3635),
    [anon_sym_COMMA] = ACTIONS(3637),
    [anon_sym_LPAREN] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3635),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_LT] = ACTIONS(3635),
    [anon_sym_GT] = ACTIONS(3635),
    [anon_sym_SLASH] = ACTIONS(3635),
    [anon_sym_DOT] = ACTIONS(3637),
    [anon_sym_QMARK] = ACTIONS(3637),
    [anon_sym_AMP_AMP] = ACTIONS(3637),
    [anon_sym_PIPE_PIPE] = ACTIONS(3637),
    [anon_sym_GT_GT] = ACTIONS(3635),
    [anon_sym_GT_GT_GT] = ACTIONS(3637),
    [anon_sym_LT_LT] = ACTIONS(3637),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_PIPE] = ACTIONS(3635),
    [anon_sym_PLUS] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(3635),
    [anon_sym_PERCENT] = ACTIONS(3637),
    [anon_sym_STAR_STAR] = ACTIONS(3637),
    [anon_sym_LT_EQ] = ACTIONS(3637),
    [anon_sym_EQ_EQ] = ACTIONS(3635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3637),
    [anon_sym_BANG_EQ] = ACTIONS(3635),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3637),
    [anon_sym_GT_EQ] = ACTIONS(3637),
    [anon_sym_instanceof] = ACTIONS(3637),
    [anon_sym_BANG] = ACTIONS(3635),
    [anon_sym_PLUS_PLUS] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3637),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3637),
  },
  [1439] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(4502),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_COLON] = ACTIONS(4505),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(4507),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1440] = {
    [sym_string] = STATE(1789),
    [sym__property_name] = STATE(1789),
    [sym_computed_property_name] = STATE(1789),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4510),
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(4512),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4514),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4516),
    [anon_sym_set] = ACTIONS(4516),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4518),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1441] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4520),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1442] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4522),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1443] = {
    [anon_sym_STAR] = ACTIONS(4115),
    [anon_sym_as] = ACTIONS(4115),
    [anon_sym_LBRACE] = ACTIONS(4117),
    [anon_sym_COMMA] = ACTIONS(4117),
    [anon_sym_LPAREN] = ACTIONS(4117),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(4117),
    [anon_sym_LT] = ACTIONS(4115),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4115),
    [anon_sym_DOT] = ACTIONS(4117),
    [anon_sym_QMARK] = ACTIONS(4117),
    [anon_sym_AMP_AMP] = ACTIONS(4117),
    [anon_sym_PIPE_PIPE] = ACTIONS(4117),
    [anon_sym_GT_GT] = ACTIONS(4115),
    [anon_sym_GT_GT_GT] = ACTIONS(4117),
    [anon_sym_LT_LT] = ACTIONS(4117),
    [anon_sym_AMP] = ACTIONS(4115),
    [anon_sym_CARET] = ACTIONS(4117),
    [anon_sym_PIPE] = ACTIONS(4115),
    [anon_sym_PLUS] = ACTIONS(4115),
    [anon_sym_DASH] = ACTIONS(4115),
    [anon_sym_PERCENT] = ACTIONS(4117),
    [anon_sym_STAR_STAR] = ACTIONS(4117),
    [anon_sym_LT_EQ] = ACTIONS(4117),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4117),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4117),
    [anon_sym_GT_EQ] = ACTIONS(4117),
    [anon_sym_instanceof] = ACTIONS(4115),
    [anon_sym_BANG] = ACTIONS(4115),
    [anon_sym_PLUS_PLUS] = ACTIONS(4117),
    [anon_sym_DASH_DASH] = ACTIONS(4117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4117),
    [sym_regex_flags] = ACTIONS(4119),
    [anon_sym_implements] = ACTIONS(4115),
  },
  [1444] = {
    [anon_sym_STAR] = ACTIONS(3631),
    [anon_sym_EQ] = ACTIONS(3631),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_LBRACE] = ACTIONS(3631),
    [anon_sym_COMMA] = ACTIONS(3633),
    [anon_sym_LPAREN] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3631),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(3631),
    [anon_sym_GT] = ACTIONS(3631),
    [anon_sym_SLASH] = ACTIONS(3631),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_AMP_AMP] = ACTIONS(3633),
    [anon_sym_PIPE_PIPE] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3631),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3631),
    [anon_sym_PLUS] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3631),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_STAR_STAR] = ACTIONS(3633),
    [anon_sym_LT_EQ] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3631),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BANG_EQ] = ACTIONS(3631),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3633),
    [anon_sym_GT_EQ] = ACTIONS(3633),
    [anon_sym_instanceof] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3631),
    [anon_sym_PLUS_PLUS] = ACTIONS(3633),
    [anon_sym_DASH_DASH] = ACTIONS(3633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3633),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3633),
  },
  [1445] = {
    [anon_sym_STAR] = ACTIONS(4063),
    [anon_sym_as] = ACTIONS(4065),
    [anon_sym_COMMA] = ACTIONS(4065),
    [anon_sym_RBRACE] = ACTIONS(4065),
    [anon_sym_LPAREN] = ACTIONS(4065),
    [anon_sym_in] = ACTIONS(4063),
    [anon_sym_SEMI] = ACTIONS(4065),
    [anon_sym_LBRACK] = ACTIONS(4065),
    [anon_sym_LT] = ACTIONS(4063),
    [anon_sym_GT] = ACTIONS(4063),
    [anon_sym_SLASH] = ACTIONS(4063),
    [anon_sym_DOT] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(4065),
    [anon_sym_AMP_AMP] = ACTIONS(4065),
    [anon_sym_PIPE_PIPE] = ACTIONS(4065),
    [anon_sym_GT_GT] = ACTIONS(4063),
    [anon_sym_GT_GT_GT] = ACTIONS(4065),
    [anon_sym_LT_LT] = ACTIONS(4065),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_CARET] = ACTIONS(4065),
    [anon_sym_PIPE] = ACTIONS(4063),
    [anon_sym_PLUS] = ACTIONS(4063),
    [anon_sym_DASH] = ACTIONS(4063),
    [anon_sym_PERCENT] = ACTIONS(4065),
    [anon_sym_STAR_STAR] = ACTIONS(4065),
    [anon_sym_LT_EQ] = ACTIONS(4065),
    [anon_sym_EQ_EQ] = ACTIONS(4063),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4065),
    [anon_sym_BANG_EQ] = ACTIONS(4063),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4065),
    [anon_sym_GT_EQ] = ACTIONS(4065),
    [anon_sym_instanceof] = ACTIONS(4065),
    [anon_sym_BANG] = ACTIONS(4063),
    [anon_sym_PLUS_PLUS] = ACTIONS(4065),
    [anon_sym_DASH_DASH] = ACTIONS(4065),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4065),
    [sym__automatic_semicolon] = ACTIONS(4065),
  },
  [1446] = {
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_as] = ACTIONS(3605),
    [anon_sym_COMMA] = ACTIONS(3605),
    [anon_sym_RBRACE] = ACTIONS(3605),
    [anon_sym_LPAREN] = ACTIONS(3605),
    [anon_sym_in] = ACTIONS(3607),
    [anon_sym_SEMI] = ACTIONS(3605),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_LT] = ACTIONS(3607),
    [anon_sym_GT] = ACTIONS(3607),
    [anon_sym_SLASH] = ACTIONS(3607),
    [anon_sym_DOT] = ACTIONS(3605),
    [anon_sym_QMARK] = ACTIONS(3605),
    [anon_sym_AMP_AMP] = ACTIONS(3605),
    [anon_sym_PIPE_PIPE] = ACTIONS(3605),
    [anon_sym_GT_GT] = ACTIONS(3607),
    [anon_sym_GT_GT_GT] = ACTIONS(3605),
    [anon_sym_LT_LT] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_CARET] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PERCENT] = ACTIONS(3605),
    [anon_sym_STAR_STAR] = ACTIONS(3605),
    [anon_sym_LT_EQ] = ACTIONS(3605),
    [anon_sym_EQ_EQ] = ACTIONS(3607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3605),
    [anon_sym_BANG_EQ] = ACTIONS(3607),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3605),
    [anon_sym_GT_EQ] = ACTIONS(3605),
    [anon_sym_instanceof] = ACTIONS(3605),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3605),
    [sym__automatic_semicolon] = ACTIONS(3605),
  },
  [1447] = {
    [anon_sym_STAR] = ACTIONS(3559),
    [anon_sym_as] = ACTIONS(3563),
    [anon_sym_COMMA] = ACTIONS(3563),
    [anon_sym_RBRACE] = ACTIONS(3563),
    [anon_sym_LPAREN] = ACTIONS(3563),
    [anon_sym_in] = ACTIONS(3559),
    [anon_sym_SEMI] = ACTIONS(3563),
    [anon_sym_LBRACK] = ACTIONS(3563),
    [anon_sym_LT] = ACTIONS(3559),
    [anon_sym_GT] = ACTIONS(3559),
    [anon_sym_SLASH] = ACTIONS(3559),
    [anon_sym_DOT] = ACTIONS(3563),
    [anon_sym_QMARK] = ACTIONS(3563),
    [anon_sym_AMP_AMP] = ACTIONS(3563),
    [anon_sym_PIPE_PIPE] = ACTIONS(3563),
    [anon_sym_GT_GT] = ACTIONS(3559),
    [anon_sym_GT_GT_GT] = ACTIONS(3563),
    [anon_sym_LT_LT] = ACTIONS(3563),
    [anon_sym_AMP] = ACTIONS(3559),
    [anon_sym_CARET] = ACTIONS(3563),
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_PERCENT] = ACTIONS(3563),
    [anon_sym_STAR_STAR] = ACTIONS(3563),
    [anon_sym_LT_EQ] = ACTIONS(3563),
    [anon_sym_EQ_EQ] = ACTIONS(3559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3563),
    [anon_sym_BANG_EQ] = ACTIONS(3559),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3563),
    [anon_sym_GT_EQ] = ACTIONS(3563),
    [anon_sym_instanceof] = ACTIONS(3563),
    [anon_sym_BANG] = ACTIONS(3559),
    [anon_sym_PLUS_PLUS] = ACTIONS(3563),
    [anon_sym_DASH_DASH] = ACTIONS(3563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3563),
    [sym__automatic_semicolon] = ACTIONS(3563),
  },
  [1448] = {
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_in] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1065),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1067),
  },
  [1449] = {
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_EQ] = ACTIONS(3615),
    [anon_sym_as] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_in] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3615),
    [anon_sym_GT] = ACTIONS(3615),
    [anon_sym_SLASH] = ACTIONS(3615),
    [anon_sym_DOT] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3615),
    [anon_sym_GT_GT_GT] = ACTIONS(3617),
    [anon_sym_LT_LT] = ACTIONS(3617),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_CARET] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_PERCENT] = ACTIONS(3617),
    [anon_sym_STAR_STAR] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ_EQ] = ACTIONS(3615),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3617),
    [anon_sym_BANG_EQ] = ACTIONS(3615),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_instanceof] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3617),
  },
  [1450] = {
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_EQ] = ACTIONS(3619),
    [anon_sym_as] = ACTIONS(3621),
    [anon_sym_LBRACE] = ACTIONS(3619),
    [anon_sym_COMMA] = ACTIONS(3621),
    [anon_sym_LPAREN] = ACTIONS(3621),
    [anon_sym_in] = ACTIONS(3619),
    [anon_sym_LBRACK] = ACTIONS(3621),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_SLASH] = ACTIONS(3619),
    [anon_sym_DOT] = ACTIONS(3621),
    [anon_sym_QMARK] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_PIPE_PIPE] = ACTIONS(3621),
    [anon_sym_GT_GT] = ACTIONS(3619),
    [anon_sym_GT_GT_GT] = ACTIONS(3621),
    [anon_sym_LT_LT] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_CARET] = ACTIONS(3621),
    [anon_sym_PIPE] = ACTIONS(3619),
    [anon_sym_PLUS] = ACTIONS(3619),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_PERCENT] = ACTIONS(3621),
    [anon_sym_STAR_STAR] = ACTIONS(3621),
    [anon_sym_LT_EQ] = ACTIONS(3621),
    [anon_sym_EQ_EQ] = ACTIONS(3619),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3621),
    [anon_sym_BANG_EQ] = ACTIONS(3619),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3621),
    [anon_sym_GT_EQ] = ACTIONS(3621),
    [anon_sym_instanceof] = ACTIONS(3621),
    [anon_sym_BANG] = ACTIONS(3619),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3621),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3621),
  },
  [1451] = {
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(2543),
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2541),
    [anon_sym_DQUOTE] = ACTIONS(2543),
    [anon_sym_SQUOTE] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2543),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_abstract] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1452] = {
    [sym_string] = STATE(1802),
    [sym__property_name] = STATE(1802),
    [sym_computed_property_name] = STATE(1802),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4524),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(4526),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4528),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4530),
    [anon_sym_set] = ACTIONS(4530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4532),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1453] = {
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(1141),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1141),
    [anon_sym_in] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(1141),
    [anon_sym_LBRACK] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(1139),
    [anon_sym_GT] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1141),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_AMP_AMP] = ACTIONS(1141),
    [anon_sym_PIPE_PIPE] = ACTIONS(1141),
    [anon_sym_GT_GT] = ACTIONS(1139),
    [anon_sym_GT_GT_GT] = ACTIONS(1141),
    [anon_sym_LT_LT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(1139),
    [anon_sym_CARET] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1139),
    [anon_sym_PERCENT] = ACTIONS(1141),
    [anon_sym_STAR_STAR] = ACTIONS(1141),
    [anon_sym_LT_EQ] = ACTIONS(1141),
    [anon_sym_EQ_EQ] = ACTIONS(1139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1141),
    [anon_sym_BANG_EQ] = ACTIONS(1139),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1141),
    [anon_sym_GT_EQ] = ACTIONS(1141),
    [anon_sym_instanceof] = ACTIONS(1141),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_PLUS_PLUS] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [sym__automatic_semicolon] = ACTIONS(1141),
  },
  [1454] = {
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_as] = ACTIONS(1165),
    [anon_sym_COMMA] = ACTIONS(1165),
    [anon_sym_RBRACE] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1165),
    [anon_sym_in] = ACTIONS(1163),
    [anon_sym_SEMI] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1163),
    [anon_sym_GT] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_DOT] = ACTIONS(1165),
    [anon_sym_QMARK] = ACTIONS(1165),
    [anon_sym_AMP_AMP] = ACTIONS(1165),
    [anon_sym_PIPE_PIPE] = ACTIONS(1165),
    [anon_sym_GT_GT] = ACTIONS(1163),
    [anon_sym_GT_GT_GT] = ACTIONS(1165),
    [anon_sym_LT_LT] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_CARET] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_STAR_STAR] = ACTIONS(1165),
    [anon_sym_LT_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ] = ACTIONS(1163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ] = ACTIONS(1163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1165),
    [anon_sym_GT_EQ] = ACTIONS(1165),
    [anon_sym_instanceof] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1165),
    [sym__automatic_semicolon] = ACTIONS(1165),
  },
  [1455] = {
    [anon_sym_STAR] = ACTIONS(1173),
    [anon_sym_as] = ACTIONS(1175),
    [anon_sym_COMMA] = ACTIONS(1175),
    [anon_sym_RBRACE] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1175),
    [anon_sym_in] = ACTIONS(1173),
    [anon_sym_SEMI] = ACTIONS(1175),
    [anon_sym_LBRACK] = ACTIONS(1175),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_DOT] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1175),
    [anon_sym_LT_LT] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1175),
    [anon_sym_STAR_STAR] = ACTIONS(1175),
    [anon_sym_LT_EQ] = ACTIONS(1175),
    [anon_sym_EQ_EQ] = ACTIONS(1173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1175),
    [anon_sym_BANG_EQ] = ACTIONS(1173),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1175),
    [anon_sym_GT_EQ] = ACTIONS(1175),
    [anon_sym_instanceof] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1175),
    [sym__automatic_semicolon] = ACTIONS(1175),
  },
  [1456] = {
    [anon_sym_STAR] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_RBRACE] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1125),
    [anon_sym_GT] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_GT_GT] = ACTIONS(1125),
    [anon_sym_GT_GT_GT] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_CARET] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1125),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1125),
    [anon_sym_PERCENT] = ACTIONS(1127),
    [anon_sym_STAR_STAR] = ACTIONS(1127),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_instanceof] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1127),
    [sym__automatic_semicolon] = ACTIONS(1127),
  },
  [1457] = {
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(1185),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_in] = ACTIONS(1183),
    [anon_sym_SEMI] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1183),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_DOT] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(1185),
    [anon_sym_AMP_AMP] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_GT_GT] = ACTIONS(1183),
    [anon_sym_GT_GT_GT] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(1185),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1185),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_PERCENT] = ACTIONS(1185),
    [anon_sym_STAR_STAR] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1185),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1185),
    [anon_sym_GT_EQ] = ACTIONS(1185),
    [anon_sym_instanceof] = ACTIONS(1185),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1185),
    [sym__automatic_semicolon] = ACTIONS(1185),
  },
  [1458] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4456),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3398),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(3398),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(3398),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(3398),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1459] = {
    [sym_arguments] = STATE(1531),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_GT_GT] = ACTIONS(3257),
    [anon_sym_GT_GT_GT] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_LT_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ] = ACTIONS(3257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3261),
    [anon_sym_GT_EQ] = ACTIONS(3261),
    [anon_sym_instanceof] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3261),
  },
  [1460] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4470),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(4473),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(4473),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(4473),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(4473),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1461] = {
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_EQ] = ACTIONS(3627),
    [anon_sym_as] = ACTIONS(3629),
    [anon_sym_LBRACE] = ACTIONS(3627),
    [anon_sym_COMMA] = ACTIONS(3629),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_in] = ACTIONS(3627),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_LT] = ACTIONS(3627),
    [anon_sym_GT] = ACTIONS(3627),
    [anon_sym_SLASH] = ACTIONS(3627),
    [anon_sym_DOT] = ACTIONS(3629),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_GT_GT] = ACTIONS(3627),
    [anon_sym_GT_GT_GT] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3627),
    [anon_sym_CARET] = ACTIONS(3629),
    [anon_sym_PIPE] = ACTIONS(3627),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_PERCENT] = ACTIONS(3629),
    [anon_sym_STAR_STAR] = ACTIONS(3629),
    [anon_sym_LT_EQ] = ACTIONS(3629),
    [anon_sym_EQ_EQ] = ACTIONS(3627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_BANG_EQ] = ACTIONS(3627),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3629),
    [anon_sym_GT_EQ] = ACTIONS(3629),
    [anon_sym_instanceof] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3627),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3629),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3629),
  },
  [1462] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4462),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(4465),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(4465),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(4465),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(4465),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1463] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4534),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1209),
  },
  [1464] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4536),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1209),
  },
  [1465] = {
    [anon_sym_STAR] = ACTIONS(2588),
    [anon_sym_as] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2586),
    [anon_sym_RBRACE] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_in] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_SLASH] = ACTIONS(2588),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_QMARK] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_GT_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(4538),
    [anon_sym_CARET] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_PERCENT] = ACTIONS(2586),
    [anon_sym_STAR_STAR] = ACTIONS(2586),
    [anon_sym_LT_EQ] = ACTIONS(2586),
    [anon_sym_EQ_EQ] = ACTIONS(2588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2586),
    [anon_sym_BANG_EQ] = ACTIONS(2588),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2586),
    [anon_sym_GT_EQ] = ACTIONS(2586),
    [anon_sym_instanceof] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_PLUS_PLUS] = ACTIONS(2586),
    [anon_sym_DASH_DASH] = ACTIONS(2586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [sym__automatic_semicolon] = ACTIONS(2586),
  },
  [1466] = {
    [anon_sym_STAR] = ACTIONS(2482),
    [anon_sym_as] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_in] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(2482),
    [anon_sym_GT] = ACTIONS(2482),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_DOT] = ACTIONS(2480),
    [anon_sym_QMARK] = ACTIONS(2480),
    [anon_sym_AMP_AMP] = ACTIONS(2480),
    [anon_sym_PIPE_PIPE] = ACTIONS(2480),
    [anon_sym_GT_GT] = ACTIONS(2482),
    [anon_sym_GT_GT_GT] = ACTIONS(2480),
    [anon_sym_LT_LT] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym_CARET] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_PERCENT] = ACTIONS(2480),
    [anon_sym_STAR_STAR] = ACTIONS(2480),
    [anon_sym_LT_EQ] = ACTIONS(2480),
    [anon_sym_EQ_EQ] = ACTIONS(2482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2480),
    [anon_sym_BANG_EQ] = ACTIONS(2482),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2480),
    [anon_sym_GT_EQ] = ACTIONS(2480),
    [anon_sym_instanceof] = ACTIONS(2480),
    [anon_sym_BANG] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2480),
    [sym__automatic_semicolon] = ACTIONS(2480),
  },
  [1467] = {
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_as] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_RBRACE] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_LT] = ACTIONS(2406),
    [anon_sym_GT] = ACTIONS(2406),
    [anon_sym_SLASH] = ACTIONS(2406),
    [anon_sym_DOT] = ACTIONS(2404),
    [anon_sym_QMARK] = ACTIONS(2404),
    [anon_sym_AMP_AMP] = ACTIONS(2404),
    [anon_sym_PIPE_PIPE] = ACTIONS(2404),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_GT_GT_GT] = ACTIONS(2404),
    [anon_sym_LT_LT] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_CARET] = ACTIONS(2404),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_PLUS] = ACTIONS(2406),
    [anon_sym_DASH] = ACTIONS(2406),
    [anon_sym_PERCENT] = ACTIONS(2404),
    [anon_sym_STAR_STAR] = ACTIONS(2404),
    [anon_sym_LT_EQ] = ACTIONS(2404),
    [anon_sym_EQ_EQ] = ACTIONS(2406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2404),
    [anon_sym_BANG_EQ] = ACTIONS(2406),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2404),
    [anon_sym_GT_EQ] = ACTIONS(2404),
    [anon_sym_instanceof] = ACTIONS(2404),
    [anon_sym_BANG] = ACTIONS(2406),
    [anon_sym_PLUS_PLUS] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2404),
    [sym__automatic_semicolon] = ACTIONS(2404),
  },
  [1468] = {
    [anon_sym_STAR] = ACTIONS(3867),
    [anon_sym_as] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3660),
    [anon_sym_RBRACE] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_in] = ACTIONS(3867),
    [anon_sym_SEMI] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_LT] = ACTIONS(3867),
    [anon_sym_GT] = ACTIONS(3867),
    [anon_sym_SLASH] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_GT_GT] = ACTIONS(3867),
    [anon_sym_GT_GT_GT] = ACTIONS(3660),
    [anon_sym_LT_LT] = ACTIONS(3660),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_CARET] = ACTIONS(3660),
    [anon_sym_PIPE] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_STAR_STAR] = ACTIONS(3660),
    [anon_sym_LT_EQ] = ACTIONS(3660),
    [anon_sym_EQ_EQ] = ACTIONS(3867),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3660),
    [anon_sym_GT_EQ] = ACTIONS(3660),
    [anon_sym_instanceof] = ACTIONS(3660),
    [anon_sym_BANG] = ACTIONS(3867),
    [anon_sym_PLUS_PLUS] = ACTIONS(3660),
    [anon_sym_DASH_DASH] = ACTIONS(3660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3660),
    [sym__automatic_semicolon] = ACTIONS(3660),
  },
  [1469] = {
    [anon_sym_STAR] = ACTIONS(2342),
    [anon_sym_as] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2340),
    [anon_sym_RBRACE] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_in] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_GT] = ACTIONS(2342),
    [anon_sym_SLASH] = ACTIONS(2342),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(2342),
    [anon_sym_GT_GT_GT] = ACTIONS(2340),
    [anon_sym_LT_LT] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_CARET] = ACTIONS(2340),
    [anon_sym_PIPE] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_STAR_STAR] = ACTIONS(2340),
    [anon_sym_LT_EQ] = ACTIONS(2340),
    [anon_sym_EQ_EQ] = ACTIONS(2342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2342),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2340),
    [anon_sym_GT_EQ] = ACTIONS(2340),
    [anon_sym_instanceof] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_PLUS_PLUS] = ACTIONS(2340),
    [anon_sym_DASH_DASH] = ACTIONS(2340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2340),
    [sym__automatic_semicolon] = ACTIONS(2340),
  },
  [1470] = {
    [anon_sym_STAR] = ACTIONS(2604),
    [anon_sym_as] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_DOT] = ACTIONS(2602),
    [anon_sym_QMARK] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_GT_GT_GT] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(4538),
    [anon_sym_CARET] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PERCENT] = ACTIONS(2602),
    [anon_sym_STAR_STAR] = ACTIONS(2602),
    [anon_sym_LT_EQ] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2604),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2604),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2602),
    [anon_sym_GT_EQ] = ACTIONS(2602),
    [anon_sym_instanceof] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [sym__automatic_semicolon] = ACTIONS(2602),
  },
  [1471] = {
    [anon_sym_STAR] = ACTIONS(2600),
    [anon_sym_as] = ACTIONS(2598),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(2600),
    [anon_sym_GT] = ACTIONS(2600),
    [anon_sym_SLASH] = ACTIONS(2600),
    [anon_sym_DOT] = ACTIONS(2598),
    [anon_sym_QMARK] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_PIPE_PIPE] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_GT_GT_GT] = ACTIONS(2598),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(4538),
    [anon_sym_CARET] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_PERCENT] = ACTIONS(2598),
    [anon_sym_STAR_STAR] = ACTIONS(2598),
    [anon_sym_LT_EQ] = ACTIONS(2598),
    [anon_sym_EQ_EQ] = ACTIONS(2600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2598),
    [anon_sym_BANG_EQ] = ACTIONS(2600),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2598),
    [anon_sym_GT_EQ] = ACTIONS(2598),
    [anon_sym_instanceof] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2600),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2598),
    [sym__automatic_semicolon] = ACTIONS(2598),
  },
  [1472] = {
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_as] = ACTIONS(2388),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_in] = ACTIONS(2390),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_LT] = ACTIONS(2390),
    [anon_sym_GT] = ACTIONS(2390),
    [anon_sym_SLASH] = ACTIONS(2390),
    [anon_sym_DOT] = ACTIONS(2388),
    [anon_sym_QMARK] = ACTIONS(2388),
    [anon_sym_AMP_AMP] = ACTIONS(2388),
    [anon_sym_PIPE_PIPE] = ACTIONS(2388),
    [anon_sym_GT_GT] = ACTIONS(2390),
    [anon_sym_GT_GT_GT] = ACTIONS(2388),
    [anon_sym_LT_LT] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_CARET] = ACTIONS(2388),
    [anon_sym_PIPE] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_PERCENT] = ACTIONS(2388),
    [anon_sym_STAR_STAR] = ACTIONS(2388),
    [anon_sym_LT_EQ] = ACTIONS(2388),
    [anon_sym_EQ_EQ] = ACTIONS(2390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2388),
    [anon_sym_BANG_EQ] = ACTIONS(2390),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2388),
    [anon_sym_GT_EQ] = ACTIONS(2388),
    [anon_sym_instanceof] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2388),
    [sym__automatic_semicolon] = ACTIONS(2388),
  },
  [1473] = {
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2468),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_GT] = ACTIONS(2468),
    [anon_sym_SLASH] = ACTIONS(2468),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2468),
    [anon_sym_GT_GT_GT] = ACTIONS(2466),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_CARET] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(2468),
    [anon_sym_DASH] = ACTIONS(2468),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_STAR_STAR] = ACTIONS(2466),
    [anon_sym_LT_EQ] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2466),
    [anon_sym_GT_EQ] = ACTIONS(2466),
    [anon_sym_instanceof] = ACTIONS(2466),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(2466),
    [anon_sym_DASH_DASH] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2466),
    [sym__automatic_semicolon] = ACTIONS(2466),
  },
  [1474] = {
    [anon_sym_STAR] = ACTIONS(2410),
    [anon_sym_as] = ACTIONS(2408),
    [anon_sym_COMMA] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [anon_sym_LPAREN] = ACTIONS(2408),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2408),
    [anon_sym_LT] = ACTIONS(2410),
    [anon_sym_GT] = ACTIONS(2410),
    [anon_sym_SLASH] = ACTIONS(2410),
    [anon_sym_DOT] = ACTIONS(2408),
    [anon_sym_QMARK] = ACTIONS(2408),
    [anon_sym_AMP_AMP] = ACTIONS(2408),
    [anon_sym_PIPE_PIPE] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2410),
    [anon_sym_GT_GT_GT] = ACTIONS(2408),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_CARET] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_PERCENT] = ACTIONS(2408),
    [anon_sym_STAR_STAR] = ACTIONS(2408),
    [anon_sym_LT_EQ] = ACTIONS(2408),
    [anon_sym_EQ_EQ] = ACTIONS(2410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2408),
    [anon_sym_BANG_EQ] = ACTIONS(2410),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2408),
    [anon_sym_GT_EQ] = ACTIONS(2408),
    [anon_sym_instanceof] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_PLUS_PLUS] = ACTIONS(2408),
    [anon_sym_DASH_DASH] = ACTIONS(2408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2408),
    [sym__automatic_semicolon] = ACTIONS(2408),
  },
  [1475] = {
    [sym_string] = STATE(2041),
    [sym__property_name] = STATE(2041),
    [sym_computed_property_name] = STATE(2041),
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4376),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1476] = {
    [anon_sym_STAR] = ACTIONS(4079),
    [anon_sym_as] = ACTIONS(4081),
    [anon_sym_COMMA] = ACTIONS(4081),
    [anon_sym_RBRACE] = ACTIONS(4081),
    [anon_sym_LPAREN] = ACTIONS(4081),
    [anon_sym_in] = ACTIONS(4079),
    [anon_sym_SEMI] = ACTIONS(4081),
    [anon_sym_LBRACK] = ACTIONS(4081),
    [anon_sym_LT] = ACTIONS(4079),
    [anon_sym_GT] = ACTIONS(4079),
    [anon_sym_SLASH] = ACTIONS(4079),
    [anon_sym_DOT] = ACTIONS(4081),
    [anon_sym_QMARK] = ACTIONS(4081),
    [anon_sym_AMP_AMP] = ACTIONS(4081),
    [anon_sym_PIPE_PIPE] = ACTIONS(4081),
    [anon_sym_GT_GT] = ACTIONS(4079),
    [anon_sym_GT_GT_GT] = ACTIONS(4081),
    [anon_sym_LT_LT] = ACTIONS(4081),
    [anon_sym_AMP] = ACTIONS(4079),
    [anon_sym_CARET] = ACTIONS(4081),
    [anon_sym_PIPE] = ACTIONS(4079),
    [anon_sym_PLUS] = ACTIONS(4079),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_PERCENT] = ACTIONS(4081),
    [anon_sym_STAR_STAR] = ACTIONS(4081),
    [anon_sym_LT_EQ] = ACTIONS(4081),
    [anon_sym_EQ_EQ] = ACTIONS(4079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4081),
    [anon_sym_BANG_EQ] = ACTIONS(4079),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4081),
    [anon_sym_GT_EQ] = ACTIONS(4081),
    [anon_sym_instanceof] = ACTIONS(4081),
    [anon_sym_BANG] = ACTIONS(4079),
    [anon_sym_PLUS_PLUS] = ACTIONS(4081),
    [anon_sym_DASH_DASH] = ACTIONS(4081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4081),
    [sym__automatic_semicolon] = ACTIONS(4081),
  },
  [1477] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(4542),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1478] = {
    [anon_sym_STAR] = ACTIONS(3875),
    [anon_sym_as] = ACTIONS(3877),
    [anon_sym_COMMA] = ACTIONS(3877),
    [anon_sym_RBRACE] = ACTIONS(3877),
    [anon_sym_LPAREN] = ACTIONS(3877),
    [anon_sym_in] = ACTIONS(3875),
    [anon_sym_SEMI] = ACTIONS(3877),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_LT] = ACTIONS(3875),
    [anon_sym_GT] = ACTIONS(3875),
    [anon_sym_SLASH] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3877),
    [anon_sym_QMARK] = ACTIONS(3877),
    [anon_sym_AMP_AMP] = ACTIONS(3877),
    [anon_sym_PIPE_PIPE] = ACTIONS(3877),
    [anon_sym_GT_GT] = ACTIONS(3875),
    [anon_sym_GT_GT_GT] = ACTIONS(3877),
    [anon_sym_LT_LT] = ACTIONS(3877),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_CARET] = ACTIONS(3877),
    [anon_sym_PIPE] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3877),
    [anon_sym_STAR_STAR] = ACTIONS(3877),
    [anon_sym_LT_EQ] = ACTIONS(3877),
    [anon_sym_EQ_EQ] = ACTIONS(3875),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3877),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3877),
    [anon_sym_GT_EQ] = ACTIONS(3877),
    [anon_sym_instanceof] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(3875),
    [anon_sym_PLUS_PLUS] = ACTIONS(3877),
    [anon_sym_DASH_DASH] = ACTIONS(3877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3877),
    [sym__automatic_semicolon] = ACTIONS(3877),
  },
  [1479] = {
    [anon_sym_STAR] = ACTIONS(3879),
    [anon_sym_as] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3881),
    [anon_sym_RBRACE] = ACTIONS(3881),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_in] = ACTIONS(3879),
    [anon_sym_SEMI] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_SLASH] = ACTIONS(3879),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [anon_sym_GT_GT_GT] = ACTIONS(3881),
    [anon_sym_LT_LT] = ACTIONS(3881),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_CARET] = ACTIONS(3881),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_DASH] = ACTIONS(3879),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_STAR_STAR] = ACTIONS(3881),
    [anon_sym_LT_EQ] = ACTIONS(3881),
    [anon_sym_EQ_EQ] = ACTIONS(3879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3879),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3881),
    [anon_sym_GT_EQ] = ACTIONS(3881),
    [anon_sym_instanceof] = ACTIONS(3881),
    [anon_sym_BANG] = ACTIONS(3879),
    [anon_sym_PLUS_PLUS] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3881),
    [sym__automatic_semicolon] = ACTIONS(3881),
  },
  [1480] = {
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_as] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2592),
    [anon_sym_GT] = ACTIONS(2592),
    [anon_sym_SLASH] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2592),
    [anon_sym_GT_GT_GT] = ACTIONS(2590),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(4538),
    [anon_sym_CARET] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_PERCENT] = ACTIONS(2590),
    [anon_sym_STAR_STAR] = ACTIONS(2590),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_EQ_EQ] = ACTIONS(2592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2592),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2590),
    [anon_sym_instanceof] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2590),
    [sym__automatic_semicolon] = ACTIONS(2590),
  },
  [1481] = {
    [anon_sym_STAR] = ACTIONS(2456),
    [anon_sym_as] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_in] = ACTIONS(2456),
    [anon_sym_SEMI] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_SLASH] = ACTIONS(2456),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_GT_GT] = ACTIONS(2456),
    [anon_sym_GT_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_STAR_STAR] = ACTIONS(2454),
    [anon_sym_LT_EQ] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(2456),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2456),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2454),
    [anon_sym_GT_EQ] = ACTIONS(2454),
    [anon_sym_instanceof] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2456),
    [anon_sym_PLUS_PLUS] = ACTIONS(2454),
    [anon_sym_DASH_DASH] = ACTIONS(2454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [sym__automatic_semicolon] = ACTIONS(2454),
  },
  [1482] = {
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_as] = ACTIONS(2400),
    [anon_sym_COMMA] = ACTIONS(2400),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_LPAREN] = ACTIONS(2400),
    [anon_sym_in] = ACTIONS(2402),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_LT] = ACTIONS(2402),
    [anon_sym_GT] = ACTIONS(2402),
    [anon_sym_SLASH] = ACTIONS(2402),
    [anon_sym_DOT] = ACTIONS(2400),
    [anon_sym_QMARK] = ACTIONS(2400),
    [anon_sym_AMP_AMP] = ACTIONS(2400),
    [anon_sym_PIPE_PIPE] = ACTIONS(2400),
    [anon_sym_GT_GT] = ACTIONS(2402),
    [anon_sym_GT_GT_GT] = ACTIONS(2400),
    [anon_sym_LT_LT] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2402),
    [anon_sym_CARET] = ACTIONS(2400),
    [anon_sym_PIPE] = ACTIONS(2402),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2402),
    [anon_sym_PERCENT] = ACTIONS(2400),
    [anon_sym_STAR_STAR] = ACTIONS(2400),
    [anon_sym_LT_EQ] = ACTIONS(2400),
    [anon_sym_EQ_EQ] = ACTIONS(2402),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2400),
    [anon_sym_BANG_EQ] = ACTIONS(2402),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2400),
    [anon_sym_GT_EQ] = ACTIONS(2400),
    [anon_sym_instanceof] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2400),
    [sym__automatic_semicolon] = ACTIONS(2400),
  },
  [1483] = {
    [anon_sym_STAR] = ACTIONS(2596),
    [anon_sym_as] = ACTIONS(2594),
    [anon_sym_COMMA] = ACTIONS(2594),
    [anon_sym_RBRACE] = ACTIONS(2594),
    [anon_sym_LPAREN] = ACTIONS(2594),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(2596),
    [anon_sym_SLASH] = ACTIONS(2596),
    [anon_sym_DOT] = ACTIONS(2594),
    [anon_sym_QMARK] = ACTIONS(2594),
    [anon_sym_AMP_AMP] = ACTIONS(2594),
    [anon_sym_PIPE_PIPE] = ACTIONS(2594),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_GT_GT_GT] = ACTIONS(2594),
    [anon_sym_LT_LT] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(4538),
    [anon_sym_CARET] = ACTIONS(2594),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_DASH] = ACTIONS(2596),
    [anon_sym_PERCENT] = ACTIONS(2594),
    [anon_sym_STAR_STAR] = ACTIONS(2594),
    [anon_sym_LT_EQ] = ACTIONS(2594),
    [anon_sym_EQ_EQ] = ACTIONS(2596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2594),
    [anon_sym_BANG_EQ] = ACTIONS(2596),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2594),
    [anon_sym_GT_EQ] = ACTIONS(2594),
    [anon_sym_instanceof] = ACTIONS(2594),
    [anon_sym_BANG] = ACTIONS(2596),
    [anon_sym_PLUS_PLUS] = ACTIONS(2594),
    [anon_sym_DASH_DASH] = ACTIONS(2594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2594),
    [sym__automatic_semicolon] = ACTIONS(2594),
  },
  [1484] = {
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_as] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(2416),
    [anon_sym_QMARK] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_GT_GT] = ACTIONS(2418),
    [anon_sym_GT_GT_GT] = ACTIONS(2416),
    [anon_sym_LT_LT] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_CARET] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2416),
    [anon_sym_STAR_STAR] = ACTIONS(2416),
    [anon_sym_LT_EQ] = ACTIONS(2416),
    [anon_sym_EQ_EQ] = ACTIONS(2418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2416),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2416),
    [anon_sym_GT_EQ] = ACTIONS(2416),
    [anon_sym_instanceof] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2416),
    [sym__automatic_semicolon] = ACTIONS(2416),
  },
  [1485] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(4544),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1486] = {
    [anon_sym_STAR] = ACTIONS(1225),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1227),
    [anon_sym_in] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1225),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1225),
    [anon_sym_GT_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_PERCENT] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1227),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1225),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [sym__automatic_semicolon] = ACTIONS(1227),
  },
  [1487] = {
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_as] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1093),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_instanceof] = ACTIONS(1093),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym__automatic_semicolon] = ACTIONS(1093),
  },
  [1488] = {
    [anon_sym_STAR] = ACTIONS(3883),
    [anon_sym_as] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3885),
    [anon_sym_RBRACE] = ACTIONS(3885),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_in] = ACTIONS(3883),
    [anon_sym_SEMI] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_GT] = ACTIONS(3883),
    [anon_sym_SLASH] = ACTIONS(3883),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_GT_GT] = ACTIONS(3883),
    [anon_sym_GT_GT_GT] = ACTIONS(3885),
    [anon_sym_LT_LT] = ACTIONS(3885),
    [anon_sym_AMP] = ACTIONS(3883),
    [anon_sym_CARET] = ACTIONS(3885),
    [anon_sym_PIPE] = ACTIONS(3883),
    [anon_sym_PLUS] = ACTIONS(3883),
    [anon_sym_DASH] = ACTIONS(3883),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_STAR_STAR] = ACTIONS(3885),
    [anon_sym_LT_EQ] = ACTIONS(3885),
    [anon_sym_EQ_EQ] = ACTIONS(3883),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3883),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3885),
    [anon_sym_GT_EQ] = ACTIONS(3885),
    [anon_sym_instanceof] = ACTIONS(3885),
    [anon_sym_BANG] = ACTIONS(3883),
    [anon_sym_PLUS_PLUS] = ACTIONS(3885),
    [anon_sym_DASH_DASH] = ACTIONS(3885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3885),
    [sym__automatic_semicolon] = ACTIONS(3885),
  },
  [1489] = {
    [anon_sym_STAR] = ACTIONS(3887),
    [anon_sym_as] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3889),
    [anon_sym_RBRACE] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_in] = ACTIONS(3887),
    [anon_sym_SEMI] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_GT] = ACTIONS(3887),
    [anon_sym_SLASH] = ACTIONS(3887),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_GT_GT] = ACTIONS(3887),
    [anon_sym_GT_GT_GT] = ACTIONS(3889),
    [anon_sym_LT_LT] = ACTIONS(3889),
    [anon_sym_AMP] = ACTIONS(3887),
    [anon_sym_CARET] = ACTIONS(3889),
    [anon_sym_PIPE] = ACTIONS(3887),
    [anon_sym_PLUS] = ACTIONS(3887),
    [anon_sym_DASH] = ACTIONS(3887),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_STAR_STAR] = ACTIONS(3889),
    [anon_sym_LT_EQ] = ACTIONS(3889),
    [anon_sym_EQ_EQ] = ACTIONS(3887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3887),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3889),
    [anon_sym_GT_EQ] = ACTIONS(3889),
    [anon_sym_instanceof] = ACTIONS(3889),
    [anon_sym_BANG] = ACTIONS(3887),
    [anon_sym_PLUS_PLUS] = ACTIONS(3889),
    [anon_sym_DASH_DASH] = ACTIONS(3889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3889),
    [sym__automatic_semicolon] = ACTIONS(3889),
  },
  [1490] = {
    [anon_sym_STAR] = ACTIONS(3918),
    [anon_sym_as] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(3920),
    [anon_sym_RBRACE] = ACTIONS(3920),
    [anon_sym_LPAREN] = ACTIONS(3920),
    [anon_sym_in] = ACTIONS(3918),
    [anon_sym_SEMI] = ACTIONS(3920),
    [anon_sym_LBRACK] = ACTIONS(3920),
    [anon_sym_LT] = ACTIONS(3918),
    [anon_sym_GT] = ACTIONS(3918),
    [anon_sym_SLASH] = ACTIONS(3918),
    [anon_sym_DOT] = ACTIONS(3920),
    [anon_sym_QMARK] = ACTIONS(3920),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3920),
    [anon_sym_GT_GT] = ACTIONS(3918),
    [anon_sym_GT_GT_GT] = ACTIONS(3920),
    [anon_sym_LT_LT] = ACTIONS(3920),
    [anon_sym_AMP] = ACTIONS(3918),
    [anon_sym_CARET] = ACTIONS(3920),
    [anon_sym_PIPE] = ACTIONS(3918),
    [anon_sym_PLUS] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3918),
    [anon_sym_PERCENT] = ACTIONS(3920),
    [anon_sym_STAR_STAR] = ACTIONS(3920),
    [anon_sym_LT_EQ] = ACTIONS(3920),
    [anon_sym_EQ_EQ] = ACTIONS(3918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3920),
    [anon_sym_BANG_EQ] = ACTIONS(3918),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3920),
    [anon_sym_GT_EQ] = ACTIONS(3920),
    [anon_sym_instanceof] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_PLUS_PLUS] = ACTIONS(3920),
    [anon_sym_DASH_DASH] = ACTIONS(3920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3920),
    [sym__automatic_semicolon] = ACTIONS(3920),
  },
  [1491] = {
    [sym_type_arguments] = STATE(1115),
    [anon_sym_STAR] = ACTIONS(2555),
    [anon_sym_as] = ACTIONS(2553),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2553),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_in] = ACTIONS(2555),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LT] = ACTIONS(4546),
    [anon_sym_GT] = ACTIONS(2555),
    [anon_sym_SLASH] = ACTIONS(2555),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_GT_GT] = ACTIONS(2555),
    [anon_sym_GT_GT_GT] = ACTIONS(2553),
    [anon_sym_LT_LT] = ACTIONS(2553),
    [anon_sym_AMP] = ACTIONS(2555),
    [anon_sym_CARET] = ACTIONS(2553),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2555),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_STAR_STAR] = ACTIONS(2553),
    [anon_sym_LT_EQ] = ACTIONS(2553),
    [anon_sym_EQ_EQ] = ACTIONS(2555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2553),
    [anon_sym_BANG_EQ] = ACTIONS(2555),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2553),
    [anon_sym_GT_EQ] = ACTIONS(2553),
    [anon_sym_instanceof] = ACTIONS(2553),
    [anon_sym_BANG] = ACTIONS(2555),
    [anon_sym_PLUS_PLUS] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2553),
    [anon_sym_implements] = ACTIONS(2553),
  },
  [1492] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3601),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1493] = {
    [anon_sym_STAR] = ACTIONS(2444),
    [anon_sym_as] = ACTIONS(2442),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [anon_sym_COMMA] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [anon_sym_in] = ACTIONS(2444),
    [anon_sym_LBRACK] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(2444),
    [anon_sym_DOT] = ACTIONS(2442),
    [anon_sym_QMARK] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_GT_GT] = ACTIONS(2444),
    [anon_sym_GT_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_CARET] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_PERCENT] = ACTIONS(2442),
    [anon_sym_STAR_STAR] = ACTIONS(2442),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_EQ_EQ] = ACTIONS(2444),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ] = ACTIONS(2444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_instanceof] = ACTIONS(2442),
    [anon_sym_BANG] = ACTIONS(2444),
    [anon_sym_PLUS_PLUS] = ACTIONS(2442),
    [anon_sym_DASH_DASH] = ACTIONS(2442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2442),
  },
  [1494] = {
    [anon_sym_STAR] = ACTIONS(2604),
    [anon_sym_as] = ACTIONS(2602),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_DOT] = ACTIONS(2602),
    [anon_sym_QMARK] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_GT_GT_GT] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(4549),
    [anon_sym_CARET] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PERCENT] = ACTIONS(2602),
    [anon_sym_STAR_STAR] = ACTIONS(2602),
    [anon_sym_LT_EQ] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2604),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2604),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2602),
    [anon_sym_GT_EQ] = ACTIONS(2602),
    [anon_sym_instanceof] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_implements] = ACTIONS(2602),
  },
  [1495] = {
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(2543),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2541),
    [anon_sym_DQUOTE] = ACTIONS(2543),
    [anon_sym_SQUOTE] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2543),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1496] = {
    [anon_sym_STAR] = ACTIONS(2600),
    [anon_sym_as] = ACTIONS(2598),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(2600),
    [anon_sym_GT] = ACTIONS(2600),
    [anon_sym_SLASH] = ACTIONS(2600),
    [anon_sym_DOT] = ACTIONS(2598),
    [anon_sym_QMARK] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_PIPE_PIPE] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_GT_GT_GT] = ACTIONS(2598),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(4549),
    [anon_sym_CARET] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_PERCENT] = ACTIONS(2598),
    [anon_sym_STAR_STAR] = ACTIONS(2598),
    [anon_sym_LT_EQ] = ACTIONS(2598),
    [anon_sym_EQ_EQ] = ACTIONS(2600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2598),
    [anon_sym_BANG_EQ] = ACTIONS(2600),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2598),
    [anon_sym_GT_EQ] = ACTIONS(2598),
    [anon_sym_instanceof] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2600),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2598),
    [anon_sym_implements] = ACTIONS(2598),
  },
  [1497] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym_readonly] = ACTIONS(2494),
  },
  [1498] = {
    [sym_string] = STATE(2034),
    [sym__property_name] = STATE(2034),
    [sym_computed_property_name] = STATE(2034),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4426),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4555),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4557),
    [anon_sym_set] = ACTIONS(4557),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1499] = {
    [sym_string] = STATE(2054),
    [sym__property_name] = STATE(2054),
    [sym_computed_property_name] = STATE(2054),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4524),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4559),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4561),
    [anon_sym_set] = ACTIONS(4561),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1500] = {
    [anon_sym_STAR] = ACTIONS(3867),
    [anon_sym_as] = ACTIONS(3660),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_in] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_LT] = ACTIONS(3867),
    [anon_sym_GT] = ACTIONS(3867),
    [anon_sym_SLASH] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_GT_GT] = ACTIONS(3867),
    [anon_sym_GT_GT_GT] = ACTIONS(3660),
    [anon_sym_LT_LT] = ACTIONS(3660),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_CARET] = ACTIONS(3660),
    [anon_sym_PIPE] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_STAR_STAR] = ACTIONS(3660),
    [anon_sym_LT_EQ] = ACTIONS(3660),
    [anon_sym_EQ_EQ] = ACTIONS(3867),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3660),
    [anon_sym_GT_EQ] = ACTIONS(3660),
    [anon_sym_instanceof] = ACTIONS(3660),
    [anon_sym_BANG] = ACTIONS(3867),
    [anon_sym_PLUS_PLUS] = ACTIONS(3660),
    [anon_sym_DASH_DASH] = ACTIONS(3660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3660),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3660),
  },
  [1501] = {
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(2543),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2541),
    [anon_sym_DQUOTE] = ACTIONS(2543),
    [anon_sym_SQUOTE] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2543),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1502] = {
    [anon_sym_STAR] = ACTIONS(3875),
    [anon_sym_as] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3877),
    [anon_sym_LPAREN] = ACTIONS(3877),
    [anon_sym_in] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_LT] = ACTIONS(3875),
    [anon_sym_GT] = ACTIONS(3875),
    [anon_sym_SLASH] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3877),
    [anon_sym_QMARK] = ACTIONS(3877),
    [anon_sym_AMP_AMP] = ACTIONS(3877),
    [anon_sym_PIPE_PIPE] = ACTIONS(3877),
    [anon_sym_GT_GT] = ACTIONS(3875),
    [anon_sym_GT_GT_GT] = ACTIONS(3877),
    [anon_sym_LT_LT] = ACTIONS(3877),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_CARET] = ACTIONS(3877),
    [anon_sym_PIPE] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3877),
    [anon_sym_STAR_STAR] = ACTIONS(3877),
    [anon_sym_LT_EQ] = ACTIONS(3877),
    [anon_sym_EQ_EQ] = ACTIONS(3875),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3877),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3877),
    [anon_sym_GT_EQ] = ACTIONS(3877),
    [anon_sym_instanceof] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(3875),
    [anon_sym_PLUS_PLUS] = ACTIONS(3877),
    [anon_sym_DASH_DASH] = ACTIONS(3877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3877),
  },
  [1503] = {
    [anon_sym_STAR] = ACTIONS(3883),
    [anon_sym_as] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3883),
    [anon_sym_COMMA] = ACTIONS(3885),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_in] = ACTIONS(3883),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_GT] = ACTIONS(3883),
    [anon_sym_SLASH] = ACTIONS(3883),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_GT_GT] = ACTIONS(3883),
    [anon_sym_GT_GT_GT] = ACTIONS(3885),
    [anon_sym_LT_LT] = ACTIONS(3885),
    [anon_sym_AMP] = ACTIONS(3883),
    [anon_sym_CARET] = ACTIONS(3885),
    [anon_sym_PIPE] = ACTIONS(3883),
    [anon_sym_PLUS] = ACTIONS(3883),
    [anon_sym_DASH] = ACTIONS(3883),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_STAR_STAR] = ACTIONS(3885),
    [anon_sym_LT_EQ] = ACTIONS(3885),
    [anon_sym_EQ_EQ] = ACTIONS(3883),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3883),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3885),
    [anon_sym_GT_EQ] = ACTIONS(3885),
    [anon_sym_instanceof] = ACTIONS(3885),
    [anon_sym_BANG] = ACTIONS(3883),
    [anon_sym_PLUS_PLUS] = ACTIONS(3885),
    [anon_sym_DASH_DASH] = ACTIONS(3885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3885),
  },
  [1504] = {
    [anon_sym_STAR] = ACTIONS(3879),
    [anon_sym_as] = ACTIONS(3881),
    [anon_sym_LBRACE] = ACTIONS(3879),
    [anon_sym_COMMA] = ACTIONS(3881),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_in] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_SLASH] = ACTIONS(3879),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [anon_sym_GT_GT_GT] = ACTIONS(3881),
    [anon_sym_LT_LT] = ACTIONS(3881),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_CARET] = ACTIONS(3881),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_DASH] = ACTIONS(3879),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_STAR_STAR] = ACTIONS(3881),
    [anon_sym_LT_EQ] = ACTIONS(3881),
    [anon_sym_EQ_EQ] = ACTIONS(3879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3879),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3881),
    [anon_sym_GT_EQ] = ACTIONS(3881),
    [anon_sym_instanceof] = ACTIONS(3881),
    [anon_sym_BANG] = ACTIONS(3879),
    [anon_sym_PLUS_PLUS] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3881),
  },
  [1505] = {
    [anon_sym_STAR] = ACTIONS(3914),
    [anon_sym_as] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_LPAREN] = ACTIONS(3916),
    [anon_sym_in] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3914),
    [anon_sym_GT] = ACTIONS(3914),
    [anon_sym_SLASH] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3916),
    [anon_sym_QMARK] = ACTIONS(3916),
    [anon_sym_AMP_AMP] = ACTIONS(3916),
    [anon_sym_PIPE_PIPE] = ACTIONS(3916),
    [anon_sym_GT_GT] = ACTIONS(3914),
    [anon_sym_GT_GT_GT] = ACTIONS(3916),
    [anon_sym_LT_LT] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_CARET] = ACTIONS(3916),
    [anon_sym_PIPE] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3916),
    [anon_sym_STAR_STAR] = ACTIONS(3916),
    [anon_sym_LT_EQ] = ACTIONS(3916),
    [anon_sym_EQ_EQ] = ACTIONS(3914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3916),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3916),
    [anon_sym_GT_EQ] = ACTIONS(3916),
    [anon_sym_instanceof] = ACTIONS(3916),
    [anon_sym_BANG] = ACTIONS(3914),
    [anon_sym_PLUS_PLUS] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(3916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3916),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3916),
  },
  [1506] = {
    [anon_sym_STAR] = ACTIONS(3922),
    [anon_sym_as] = ACTIONS(3924),
    [anon_sym_LBRACE] = ACTIONS(3922),
    [anon_sym_COMMA] = ACTIONS(3924),
    [anon_sym_LPAREN] = ACTIONS(3924),
    [anon_sym_in] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3924),
    [anon_sym_LT] = ACTIONS(3922),
    [anon_sym_GT] = ACTIONS(3922),
    [anon_sym_SLASH] = ACTIONS(3922),
    [anon_sym_DOT] = ACTIONS(3924),
    [anon_sym_QMARK] = ACTIONS(3924),
    [anon_sym_AMP_AMP] = ACTIONS(3924),
    [anon_sym_PIPE_PIPE] = ACTIONS(3924),
    [anon_sym_GT_GT] = ACTIONS(3922),
    [anon_sym_GT_GT_GT] = ACTIONS(3924),
    [anon_sym_LT_LT] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(3922),
    [anon_sym_CARET] = ACTIONS(3924),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_PLUS] = ACTIONS(3922),
    [anon_sym_DASH] = ACTIONS(3922),
    [anon_sym_PERCENT] = ACTIONS(3924),
    [anon_sym_STAR_STAR] = ACTIONS(3924),
    [anon_sym_LT_EQ] = ACTIONS(3924),
    [anon_sym_EQ_EQ] = ACTIONS(3922),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3924),
    [anon_sym_BANG_EQ] = ACTIONS(3922),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3924),
    [anon_sym_GT_EQ] = ACTIONS(3924),
    [anon_sym_instanceof] = ACTIONS(3924),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_PLUS_PLUS] = ACTIONS(3924),
    [anon_sym_DASH_DASH] = ACTIONS(3924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3924),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3924),
  },
  [1507] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(3994),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(3994),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(3994),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1209),
  },
  [1508] = {
    [anon_sym_STAR] = ACTIONS(1117),
    [anon_sym_as] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_in] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_SLASH] = ACTIONS(1117),
    [anon_sym_DOT] = ACTIONS(1115),
    [anon_sym_QMARK] = ACTIONS(1115),
    [anon_sym_AMP_AMP] = ACTIONS(1115),
    [anon_sym_PIPE_PIPE] = ACTIONS(1115),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_GT_GT_GT] = ACTIONS(1115),
    [anon_sym_LT_LT] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1117),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_PIPE] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_PERCENT] = ACTIONS(1115),
    [anon_sym_STAR_STAR] = ACTIONS(1115),
    [anon_sym_LT_EQ] = ACTIONS(1115),
    [anon_sym_EQ_EQ] = ACTIONS(1117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1115),
    [anon_sym_BANG_EQ] = ACTIONS(1117),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1115),
    [anon_sym_instanceof] = ACTIONS(1115),
    [anon_sym_BANG] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1115),
  },
  [1509] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(4000),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(4000),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1209),
  },
  [1510] = {
    [anon_sym_STAR] = ACTIONS(3887),
    [anon_sym_as] = ACTIONS(3889),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_COMMA] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_in] = ACTIONS(3887),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_GT] = ACTIONS(3887),
    [anon_sym_SLASH] = ACTIONS(3887),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_GT_GT] = ACTIONS(3887),
    [anon_sym_GT_GT_GT] = ACTIONS(3889),
    [anon_sym_LT_LT] = ACTIONS(3889),
    [anon_sym_AMP] = ACTIONS(3887),
    [anon_sym_CARET] = ACTIONS(3889),
    [anon_sym_PIPE] = ACTIONS(3887),
    [anon_sym_PLUS] = ACTIONS(3887),
    [anon_sym_DASH] = ACTIONS(3887),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_STAR_STAR] = ACTIONS(3889),
    [anon_sym_LT_EQ] = ACTIONS(3889),
    [anon_sym_EQ_EQ] = ACTIONS(3887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3887),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3889),
    [anon_sym_GT_EQ] = ACTIONS(3889),
    [anon_sym_instanceof] = ACTIONS(3889),
    [anon_sym_BANG] = ACTIONS(3887),
    [anon_sym_PLUS_PLUS] = ACTIONS(3889),
    [anon_sym_DASH_DASH] = ACTIONS(3889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3889),
  },
  [1511] = {
    [anon_sym_STAR] = ACTIONS(3952),
    [anon_sym_as] = ACTIONS(3954),
    [anon_sym_LBRACE] = ACTIONS(3952),
    [anon_sym_COMMA] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_in] = ACTIONS(3952),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_GT] = ACTIONS(3952),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_GT_GT] = ACTIONS(3952),
    [anon_sym_GT_GT_GT] = ACTIONS(3954),
    [anon_sym_LT_LT] = ACTIONS(3954),
    [anon_sym_AMP] = ACTIONS(3952),
    [anon_sym_CARET] = ACTIONS(3954),
    [anon_sym_PIPE] = ACTIONS(3952),
    [anon_sym_PLUS] = ACTIONS(3952),
    [anon_sym_DASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3954),
    [anon_sym_LT_EQ] = ACTIONS(3954),
    [anon_sym_EQ_EQ] = ACTIONS(3952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3952),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3954),
    [anon_sym_GT_EQ] = ACTIONS(3954),
    [anon_sym_instanceof] = ACTIONS(3954),
    [anon_sym_BANG] = ACTIONS(3952),
    [anon_sym_PLUS_PLUS] = ACTIONS(3954),
    [anon_sym_DASH_DASH] = ACTIONS(3954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3954),
  },
  [1512] = {
    [anon_sym_STAR] = ACTIONS(1201),
    [anon_sym_as] = ACTIONS(1199),
    [anon_sym_LBRACE] = ACTIONS(1201),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_in] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(1199),
    [anon_sym_QMARK] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_CARET] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1201),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_instanceof] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1199),
  },
  [1513] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1514] = {
    [anon_sym_STAR] = ACTIONS(2588),
    [anon_sym_as] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_COMMA] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_in] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_SLASH] = ACTIONS(2588),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_QMARK] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_GT_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(4563),
    [anon_sym_CARET] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(4565),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_PERCENT] = ACTIONS(2586),
    [anon_sym_STAR_STAR] = ACTIONS(2586),
    [anon_sym_LT_EQ] = ACTIONS(2586),
    [anon_sym_EQ_EQ] = ACTIONS(2588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2586),
    [anon_sym_BANG_EQ] = ACTIONS(2588),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2586),
    [anon_sym_GT_EQ] = ACTIONS(2586),
    [anon_sym_instanceof] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_PLUS_PLUS] = ACTIONS(2586),
    [anon_sym_DASH_DASH] = ACTIONS(2586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2586),
  },
  [1515] = {
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_as] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_COMMA] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2592),
    [anon_sym_GT] = ACTIONS(2592),
    [anon_sym_SLASH] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2592),
    [anon_sym_GT_GT_GT] = ACTIONS(2590),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(4563),
    [anon_sym_CARET] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(4565),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_PERCENT] = ACTIONS(2590),
    [anon_sym_STAR_STAR] = ACTIONS(2590),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_EQ_EQ] = ACTIONS(2592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2592),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2590),
    [anon_sym_instanceof] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2590),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2590),
  },
  [1516] = {
    [anon_sym_STAR] = ACTIONS(2596),
    [anon_sym_as] = ACTIONS(2594),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2594),
    [anon_sym_LPAREN] = ACTIONS(2594),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(2596),
    [anon_sym_SLASH] = ACTIONS(2596),
    [anon_sym_DOT] = ACTIONS(2594),
    [anon_sym_QMARK] = ACTIONS(2594),
    [anon_sym_AMP_AMP] = ACTIONS(2594),
    [anon_sym_PIPE_PIPE] = ACTIONS(2594),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_GT_GT_GT] = ACTIONS(2594),
    [anon_sym_LT_LT] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(4563),
    [anon_sym_CARET] = ACTIONS(2594),
    [anon_sym_PIPE] = ACTIONS(4565),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_DASH] = ACTIONS(2596),
    [anon_sym_PERCENT] = ACTIONS(2594),
    [anon_sym_STAR_STAR] = ACTIONS(2594),
    [anon_sym_LT_EQ] = ACTIONS(2594),
    [anon_sym_EQ_EQ] = ACTIONS(2596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2594),
    [anon_sym_BANG_EQ] = ACTIONS(2596),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2594),
    [anon_sym_GT_EQ] = ACTIONS(2594),
    [anon_sym_instanceof] = ACTIONS(2594),
    [anon_sym_BANG] = ACTIONS(2596),
    [anon_sym_PLUS_PLUS] = ACTIONS(2594),
    [anon_sym_DASH_DASH] = ACTIONS(2594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2594),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2594),
  },
  [1517] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1209),
  },
  [1518] = {
    [anon_sym_STAR] = ACTIONS(3961),
    [anon_sym_as] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3963),
    [anon_sym_in] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3961),
    [anon_sym_GT] = ACTIONS(3961),
    [anon_sym_SLASH] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3963),
    [anon_sym_QMARK] = ACTIONS(3963),
    [anon_sym_AMP_AMP] = ACTIONS(3963),
    [anon_sym_PIPE_PIPE] = ACTIONS(3963),
    [anon_sym_GT_GT] = ACTIONS(3961),
    [anon_sym_GT_GT_GT] = ACTIONS(3963),
    [anon_sym_LT_LT] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_CARET] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3963),
    [anon_sym_STAR_STAR] = ACTIONS(3963),
    [anon_sym_LT_EQ] = ACTIONS(3963),
    [anon_sym_EQ_EQ] = ACTIONS(3961),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3963),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3963),
    [anon_sym_GT_EQ] = ACTIONS(3963),
    [anon_sym_instanceof] = ACTIONS(3963),
    [anon_sym_BANG] = ACTIONS(3961),
    [anon_sym_PLUS_PLUS] = ACTIONS(3963),
    [anon_sym_DASH_DASH] = ACTIONS(3963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3963),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3963),
  },
  [1519] = {
    [anon_sym_STAR] = ACTIONS(2596),
    [anon_sym_as] = ACTIONS(2594),
    [anon_sym_LBRACE] = ACTIONS(2594),
    [anon_sym_COMMA] = ACTIONS(2594),
    [anon_sym_LPAREN] = ACTIONS(2594),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(2596),
    [anon_sym_SLASH] = ACTIONS(2596),
    [anon_sym_DOT] = ACTIONS(2594),
    [anon_sym_QMARK] = ACTIONS(2594),
    [anon_sym_AMP_AMP] = ACTIONS(2594),
    [anon_sym_PIPE_PIPE] = ACTIONS(2594),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_GT_GT_GT] = ACTIONS(2594),
    [anon_sym_LT_LT] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(4549),
    [anon_sym_CARET] = ACTIONS(2594),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_DASH] = ACTIONS(2596),
    [anon_sym_PERCENT] = ACTIONS(2594),
    [anon_sym_STAR_STAR] = ACTIONS(2594),
    [anon_sym_LT_EQ] = ACTIONS(2594),
    [anon_sym_EQ_EQ] = ACTIONS(2596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2594),
    [anon_sym_BANG_EQ] = ACTIONS(2596),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2594),
    [anon_sym_GT_EQ] = ACTIONS(2594),
    [anon_sym_instanceof] = ACTIONS(2594),
    [anon_sym_BANG] = ACTIONS(2596),
    [anon_sym_PLUS_PLUS] = ACTIONS(2594),
    [anon_sym_DASH_DASH] = ACTIONS(2594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2594),
    [anon_sym_implements] = ACTIONS(2594),
  },
  [1520] = {
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_as] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2592),
    [anon_sym_GT] = ACTIONS(2592),
    [anon_sym_SLASH] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2592),
    [anon_sym_GT_GT_GT] = ACTIONS(2590),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(4549),
    [anon_sym_CARET] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_PERCENT] = ACTIONS(2590),
    [anon_sym_STAR_STAR] = ACTIONS(2590),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_EQ_EQ] = ACTIONS(2592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2592),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2590),
    [anon_sym_instanceof] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2590),
    [anon_sym_implements] = ACTIONS(2590),
  },
  [1521] = {
    [anon_sym_STAR] = ACTIONS(2588),
    [anon_sym_as] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_in] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_SLASH] = ACTIONS(2588),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_QMARK] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_GT_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(4549),
    [anon_sym_CARET] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_PERCENT] = ACTIONS(2586),
    [anon_sym_STAR_STAR] = ACTIONS(2586),
    [anon_sym_LT_EQ] = ACTIONS(2586),
    [anon_sym_EQ_EQ] = ACTIONS(2588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2586),
    [anon_sym_BANG_EQ] = ACTIONS(2588),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2586),
    [anon_sym_GT_EQ] = ACTIONS(2586),
    [anon_sym_instanceof] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_PLUS_PLUS] = ACTIONS(2586),
    [anon_sym_DASH_DASH] = ACTIONS(2586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [anon_sym_implements] = ACTIONS(2586),
  },
  [1522] = {
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_as] = ACTIONS(1155),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_in] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(1157),
    [anon_sym_SLASH] = ACTIONS(1157),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_QMARK] = ACTIONS(1155),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1157),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1155),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_STAR_STAR] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_instanceof] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1155),
    [anon_sym_DASH_DASH] = ACTIONS(1155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1155),
  },
  [1523] = {
    [anon_sym_STAR] = ACTIONS(2600),
    [anon_sym_as] = ACTIONS(2598),
    [anon_sym_LBRACE] = ACTIONS(2600),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(2600),
    [anon_sym_GT] = ACTIONS(2600),
    [anon_sym_SLASH] = ACTIONS(2600),
    [anon_sym_DOT] = ACTIONS(2598),
    [anon_sym_QMARK] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_PIPE_PIPE] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_GT_GT_GT] = ACTIONS(2598),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(4563),
    [anon_sym_CARET] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(4565),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_PERCENT] = ACTIONS(2598),
    [anon_sym_STAR_STAR] = ACTIONS(2598),
    [anon_sym_LT_EQ] = ACTIONS(2598),
    [anon_sym_EQ_EQ] = ACTIONS(2600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2598),
    [anon_sym_BANG_EQ] = ACTIONS(2600),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2598),
    [anon_sym_GT_EQ] = ACTIONS(2598),
    [anon_sym_instanceof] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2600),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2598),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2598),
  },
  [1524] = {
    [anon_sym_STAR] = ACTIONS(2604),
    [anon_sym_as] = ACTIONS(2602),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_COMMA] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_DOT] = ACTIONS(2602),
    [anon_sym_QMARK] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_GT_GT_GT] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(4563),
    [anon_sym_CARET] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(4565),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PERCENT] = ACTIONS(2602),
    [anon_sym_STAR_STAR] = ACTIONS(2602),
    [anon_sym_LT_EQ] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2604),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2604),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2602),
    [anon_sym_GT_EQ] = ACTIONS(2602),
    [anon_sym_instanceof] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2602),
  },
  [1525] = {
    [anon_sym_STAR] = ACTIONS(2342),
    [anon_sym_as] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_COMMA] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_in] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_GT] = ACTIONS(2342),
    [anon_sym_SLASH] = ACTIONS(2342),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(2342),
    [anon_sym_GT_GT_GT] = ACTIONS(2340),
    [anon_sym_LT_LT] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_CARET] = ACTIONS(2340),
    [anon_sym_PIPE] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_STAR_STAR] = ACTIONS(2340),
    [anon_sym_LT_EQ] = ACTIONS(2340),
    [anon_sym_EQ_EQ] = ACTIONS(2342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2342),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2340),
    [anon_sym_GT_EQ] = ACTIONS(2340),
    [anon_sym_instanceof] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_PLUS_PLUS] = ACTIONS(2340),
    [anon_sym_DASH_DASH] = ACTIONS(2340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2340),
  },
  [1526] = {
    [anon_sym_STAR] = ACTIONS(3967),
    [anon_sym_as] = ACTIONS(3969),
    [anon_sym_LBRACE] = ACTIONS(3967),
    [anon_sym_COMMA] = ACTIONS(3969),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_GT] = ACTIONS(3967),
    [anon_sym_SLASH] = ACTIONS(3967),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_GT_GT] = ACTIONS(3967),
    [anon_sym_GT_GT_GT] = ACTIONS(3969),
    [anon_sym_LT_LT] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_CARET] = ACTIONS(3969),
    [anon_sym_PIPE] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_STAR_STAR] = ACTIONS(3969),
    [anon_sym_LT_EQ] = ACTIONS(3969),
    [anon_sym_EQ_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3969),
    [anon_sym_GT_EQ] = ACTIONS(3969),
    [anon_sym_instanceof] = ACTIONS(3969),
    [anon_sym_BANG] = ACTIONS(3967),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3969),
  },
  [1527] = {
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_in] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1059),
    [anon_sym_DOT] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_GT_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_PERCENT] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1059),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_instanceof] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1057),
    [anon_sym_DASH_DASH] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1057),
  },
  [1528] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym_readonly] = ACTIONS(2494),
  },
  [1529] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(3994),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(3994),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(3994),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1530] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1531] = {
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3971),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_in] = ACTIONS(3971),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_GT] = ACTIONS(3971),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3973),
    [anon_sym_LT_LT] = ACTIONS(3973),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_CARET] = ACTIONS(3973),
    [anon_sym_PIPE] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_STAR_STAR] = ACTIONS(3973),
    [anon_sym_LT_EQ] = ACTIONS(3973),
    [anon_sym_EQ_EQ] = ACTIONS(3971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3971),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3973),
    [anon_sym_GT_EQ] = ACTIONS(3973),
    [anon_sym_instanceof] = ACTIONS(3973),
    [anon_sym_BANG] = ACTIONS(3971),
    [anon_sym_PLUS_PLUS] = ACTIONS(3973),
    [anon_sym_DASH_DASH] = ACTIONS(3973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3973),
  },
  [1532] = {
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3971),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_in] = ACTIONS(3971),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_GT] = ACTIONS(3971),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3973),
    [anon_sym_LT_LT] = ACTIONS(3973),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_CARET] = ACTIONS(3973),
    [anon_sym_PIPE] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_STAR_STAR] = ACTIONS(3973),
    [anon_sym_LT_EQ] = ACTIONS(3973),
    [anon_sym_EQ_EQ] = ACTIONS(3971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3971),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3973),
    [anon_sym_GT_EQ] = ACTIONS(3973),
    [anon_sym_instanceof] = ACTIONS(3973),
    [anon_sym_BANG] = ACTIONS(3971),
    [anon_sym_PLUS_PLUS] = ACTIONS(3973),
    [anon_sym_DASH_DASH] = ACTIONS(3973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3973),
  },
  [1533] = {
    [anon_sym_STAR] = ACTIONS(1113),
    [anon_sym_as] = ACTIONS(1111),
    [anon_sym_LBRACE] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1113),
    [anon_sym_GT] = ACTIONS(1113),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_QMARK] = ACTIONS(1111),
    [anon_sym_AMP_AMP] = ACTIONS(1111),
    [anon_sym_PIPE_PIPE] = ACTIONS(1111),
    [anon_sym_GT_GT] = ACTIONS(1113),
    [anon_sym_GT_GT_GT] = ACTIONS(1111),
    [anon_sym_LT_LT] = ACTIONS(1111),
    [anon_sym_AMP] = ACTIONS(1113),
    [anon_sym_CARET] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1113),
    [anon_sym_PLUS] = ACTIONS(1113),
    [anon_sym_DASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1111),
    [anon_sym_STAR_STAR] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_EQ_EQ] = ACTIONS(1113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ] = ACTIONS(1113),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1111),
    [anon_sym_instanceof] = ACTIONS(1111),
    [anon_sym_BANG] = ACTIONS(1113),
    [anon_sym_PLUS_PLUS] = ACTIONS(1111),
    [anon_sym_DASH_DASH] = ACTIONS(1111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
  },
  [1534] = {
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_as] = ACTIONS(3977),
    [anon_sym_LBRACE] = ACTIONS(3975),
    [anon_sym_COMMA] = ACTIONS(3977),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_in] = ACTIONS(3975),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_GT] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3975),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_GT_GT] = ACTIONS(3975),
    [anon_sym_GT_GT_GT] = ACTIONS(3977),
    [anon_sym_LT_LT] = ACTIONS(3977),
    [anon_sym_AMP] = ACTIONS(3975),
    [anon_sym_CARET] = ACTIONS(3977),
    [anon_sym_PIPE] = ACTIONS(3975),
    [anon_sym_PLUS] = ACTIONS(3975),
    [anon_sym_DASH] = ACTIONS(3975),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_STAR_STAR] = ACTIONS(3977),
    [anon_sym_LT_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ] = ACTIONS(3975),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3975),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3977),
    [anon_sym_GT_EQ] = ACTIONS(3977),
    [anon_sym_instanceof] = ACTIONS(3977),
    [anon_sym_BANG] = ACTIONS(3975),
    [anon_sym_PLUS_PLUS] = ACTIONS(3977),
    [anon_sym_DASH_DASH] = ACTIONS(3977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3977),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3977),
  },
  [1535] = {
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1131),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_in] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1131),
    [anon_sym_QMARK] = ACTIONS(1131),
    [anon_sym_AMP_AMP] = ACTIONS(1131),
    [anon_sym_PIPE_PIPE] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_GT_GT_GT] = ACTIONS(1131),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1131),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_PERCENT] = ACTIONS(1131),
    [anon_sym_STAR_STAR] = ACTIONS(1131),
    [anon_sym_LT_EQ] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1131),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1131),
    [anon_sym_GT_EQ] = ACTIONS(1131),
    [anon_sym_instanceof] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1133),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1131),
  },
  [1536] = {
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_as] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3979),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3765),
    [anon_sym_in] = ACTIONS(3979),
    [anon_sym_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_DOT] = ACTIONS(3765),
    [anon_sym_QMARK] = ACTIONS(3765),
    [anon_sym_AMP_AMP] = ACTIONS(3765),
    [anon_sym_PIPE_PIPE] = ACTIONS(3765),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3765),
    [anon_sym_LT_LT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_CARET] = ACTIONS(3765),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_PERCENT] = ACTIONS(3765),
    [anon_sym_STAR_STAR] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3765),
    [anon_sym_EQ_EQ] = ACTIONS(3979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3765),
    [anon_sym_BANG_EQ] = ACTIONS(3979),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3765),
    [anon_sym_GT_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3765),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3765),
    [anon_sym_DASH_DASH] = ACTIONS(3765),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3765),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
  },
  [1537] = {
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(1097),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_in] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(1099),
    [anon_sym_DOT] = ACTIONS(1097),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_GT_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_PERCENT] = ACTIONS(1097),
    [anon_sym_STAR_STAR] = ACTIONS(1097),
    [anon_sym_LT_EQ] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1097),
    [anon_sym_BANG_EQ] = ACTIONS(1099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1097),
    [anon_sym_instanceof] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1097),
  },
  [1538] = {
    [anon_sym_STAR] = ACTIONS(2448),
    [anon_sym_as] = ACTIONS(2446),
    [anon_sym_LBRACE] = ACTIONS(2448),
    [anon_sym_COMMA] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2446),
    [anon_sym_in] = ACTIONS(2448),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_SLASH] = ACTIONS(2448),
    [anon_sym_DOT] = ACTIONS(2446),
    [anon_sym_QMARK] = ACTIONS(2446),
    [anon_sym_AMP_AMP] = ACTIONS(2446),
    [anon_sym_PIPE_PIPE] = ACTIONS(2446),
    [anon_sym_GT_GT] = ACTIONS(2448),
    [anon_sym_GT_GT_GT] = ACTIONS(2446),
    [anon_sym_LT_LT] = ACTIONS(2446),
    [anon_sym_AMP] = ACTIONS(2448),
    [anon_sym_CARET] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PERCENT] = ACTIONS(2446),
    [anon_sym_STAR_STAR] = ACTIONS(2446),
    [anon_sym_LT_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ] = ACTIONS(2448),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2448),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2446),
    [anon_sym_GT_EQ] = ACTIONS(2446),
    [anon_sym_instanceof] = ACTIONS(2446),
    [anon_sym_BANG] = ACTIONS(2448),
    [anon_sym_PLUS_PLUS] = ACTIONS(2446),
    [anon_sym_DASH_DASH] = ACTIONS(2446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2446),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2446),
  },
  [1539] = {
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_as] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_COMMA] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2458),
    [anon_sym_in] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2458),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_GT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2460),
    [anon_sym_DOT] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2458),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2458),
    [anon_sym_LT_LT] = ACTIONS(2458),
    [anon_sym_AMP] = ACTIONS(2460),
    [anon_sym_CARET] = ACTIONS(2458),
    [anon_sym_PIPE] = ACTIONS(2460),
    [anon_sym_PLUS] = ACTIONS(2460),
    [anon_sym_DASH] = ACTIONS(2460),
    [anon_sym_PERCENT] = ACTIONS(2458),
    [anon_sym_STAR_STAR] = ACTIONS(2458),
    [anon_sym_LT_EQ] = ACTIONS(2458),
    [anon_sym_EQ_EQ] = ACTIONS(2460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2458),
    [anon_sym_BANG_EQ] = ACTIONS(2460),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2458),
    [anon_sym_GT_EQ] = ACTIONS(2458),
    [anon_sym_instanceof] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(2458),
    [anon_sym_DASH_DASH] = ACTIONS(2458),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2458),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2458),
  },
  [1540] = {
    [anon_sym_STAR] = ACTIONS(2456),
    [anon_sym_as] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_COMMA] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_in] = ACTIONS(2456),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_SLASH] = ACTIONS(2456),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_GT_GT] = ACTIONS(2456),
    [anon_sym_GT_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_STAR_STAR] = ACTIONS(2454),
    [anon_sym_LT_EQ] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(2456),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2456),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2454),
    [anon_sym_GT_EQ] = ACTIONS(2454),
    [anon_sym_instanceof] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2456),
    [anon_sym_PLUS_PLUS] = ACTIONS(2454),
    [anon_sym_DASH_DASH] = ACTIONS(2454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2454),
  },
  [1541] = {
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_as] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_COMMA] = ACTIONS(2400),
    [anon_sym_LPAREN] = ACTIONS(2400),
    [anon_sym_in] = ACTIONS(2402),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_LT] = ACTIONS(2402),
    [anon_sym_GT] = ACTIONS(2402),
    [anon_sym_SLASH] = ACTIONS(2402),
    [anon_sym_DOT] = ACTIONS(2400),
    [anon_sym_QMARK] = ACTIONS(2400),
    [anon_sym_AMP_AMP] = ACTIONS(2400),
    [anon_sym_PIPE_PIPE] = ACTIONS(2400),
    [anon_sym_GT_GT] = ACTIONS(2402),
    [anon_sym_GT_GT_GT] = ACTIONS(2400),
    [anon_sym_LT_LT] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2402),
    [anon_sym_CARET] = ACTIONS(2400),
    [anon_sym_PIPE] = ACTIONS(2402),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2402),
    [anon_sym_PERCENT] = ACTIONS(2400),
    [anon_sym_STAR_STAR] = ACTIONS(2400),
    [anon_sym_LT_EQ] = ACTIONS(2400),
    [anon_sym_EQ_EQ] = ACTIONS(2402),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2400),
    [anon_sym_BANG_EQ] = ACTIONS(2402),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2400),
    [anon_sym_GT_EQ] = ACTIONS(2400),
    [anon_sym_instanceof] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2400),
    [anon_sym_implements] = ACTIONS(2400),
  },
  [1542] = {
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_as] = ACTIONS(2416),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(2416),
    [anon_sym_QMARK] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_GT_GT] = ACTIONS(2418),
    [anon_sym_GT_GT_GT] = ACTIONS(2416),
    [anon_sym_LT_LT] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_CARET] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2416),
    [anon_sym_STAR_STAR] = ACTIONS(2416),
    [anon_sym_LT_EQ] = ACTIONS(2416),
    [anon_sym_EQ_EQ] = ACTIONS(2418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2416),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2416),
    [anon_sym_GT_EQ] = ACTIONS(2416),
    [anon_sym_instanceof] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2416),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2416),
  },
  [1543] = {
    [anon_sym_STAR] = ACTIONS(2422),
    [anon_sym_as] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_SLASH] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2420),
    [anon_sym_QMARK] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_GT_GT] = ACTIONS(2422),
    [anon_sym_GT_GT_GT] = ACTIONS(2420),
    [anon_sym_LT_LT] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_CARET] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2420),
    [anon_sym_STAR_STAR] = ACTIONS(2420),
    [anon_sym_LT_EQ] = ACTIONS(2420),
    [anon_sym_EQ_EQ] = ACTIONS(2422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2420),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2420),
    [anon_sym_GT_EQ] = ACTIONS(2420),
    [anon_sym_instanceof] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2420),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
  },
  [1544] = {
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_as] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_in] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2478),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_DOT] = ACTIONS(2476),
    [anon_sym_QMARK] = ACTIONS(2476),
    [anon_sym_AMP_AMP] = ACTIONS(2476),
    [anon_sym_PIPE_PIPE] = ACTIONS(2476),
    [anon_sym_GT_GT] = ACTIONS(2478),
    [anon_sym_GT_GT_GT] = ACTIONS(2476),
    [anon_sym_LT_LT] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_CARET] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_PERCENT] = ACTIONS(2476),
    [anon_sym_STAR_STAR] = ACTIONS(2476),
    [anon_sym_LT_EQ] = ACTIONS(2476),
    [anon_sym_EQ_EQ] = ACTIONS(2478),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2476),
    [anon_sym_BANG_EQ] = ACTIONS(2478),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2476),
    [anon_sym_GT_EQ] = ACTIONS(2476),
    [anon_sym_instanceof] = ACTIONS(2476),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2476),
  },
  [1545] = {
    [anon_sym_STAR] = ACTIONS(2410),
    [anon_sym_as] = ACTIONS(2408),
    [anon_sym_LBRACE] = ACTIONS(2410),
    [anon_sym_COMMA] = ACTIONS(2408),
    [anon_sym_LPAREN] = ACTIONS(2408),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2408),
    [anon_sym_LT] = ACTIONS(2410),
    [anon_sym_GT] = ACTIONS(2410),
    [anon_sym_SLASH] = ACTIONS(2410),
    [anon_sym_DOT] = ACTIONS(2408),
    [anon_sym_QMARK] = ACTIONS(2408),
    [anon_sym_AMP_AMP] = ACTIONS(2408),
    [anon_sym_PIPE_PIPE] = ACTIONS(2408),
    [anon_sym_GT_GT] = ACTIONS(2410),
    [anon_sym_GT_GT_GT] = ACTIONS(2408),
    [anon_sym_LT_LT] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_CARET] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_PERCENT] = ACTIONS(2408),
    [anon_sym_STAR_STAR] = ACTIONS(2408),
    [anon_sym_LT_EQ] = ACTIONS(2408),
    [anon_sym_EQ_EQ] = ACTIONS(2410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2408),
    [anon_sym_BANG_EQ] = ACTIONS(2410),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2408),
    [anon_sym_GT_EQ] = ACTIONS(2408),
    [anon_sym_instanceof] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_PLUS_PLUS] = ACTIONS(2408),
    [anon_sym_DASH_DASH] = ACTIONS(2408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2408),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2408),
  },
  [1546] = {
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2468),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_GT] = ACTIONS(2468),
    [anon_sym_SLASH] = ACTIONS(2468),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2468),
    [anon_sym_GT_GT_GT] = ACTIONS(2466),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_CARET] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(2468),
    [anon_sym_DASH] = ACTIONS(2468),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_STAR_STAR] = ACTIONS(2466),
    [anon_sym_LT_EQ] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2466),
    [anon_sym_GT_EQ] = ACTIONS(2466),
    [anon_sym_instanceof] = ACTIONS(2466),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(2466),
    [anon_sym_DASH_DASH] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2466),
  },
  [1547] = {
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_as] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_in] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_LT] = ACTIONS(2390),
    [anon_sym_GT] = ACTIONS(2390),
    [anon_sym_SLASH] = ACTIONS(2390),
    [anon_sym_DOT] = ACTIONS(2388),
    [anon_sym_QMARK] = ACTIONS(2388),
    [anon_sym_AMP_AMP] = ACTIONS(2388),
    [anon_sym_PIPE_PIPE] = ACTIONS(2388),
    [anon_sym_GT_GT] = ACTIONS(2390),
    [anon_sym_GT_GT_GT] = ACTIONS(2388),
    [anon_sym_LT_LT] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_CARET] = ACTIONS(2388),
    [anon_sym_PIPE] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_PERCENT] = ACTIONS(2388),
    [anon_sym_STAR_STAR] = ACTIONS(2388),
    [anon_sym_LT_EQ] = ACTIONS(2388),
    [anon_sym_EQ_EQ] = ACTIONS(2390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2388),
    [anon_sym_BANG_EQ] = ACTIONS(2390),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2388),
    [anon_sym_GT_EQ] = ACTIONS(2388),
    [anon_sym_instanceof] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2388),
    [anon_sym_implements] = ACTIONS(2388),
  },
  [1548] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3625),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1549] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3613),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1550] = {
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_as] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2406),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_LT] = ACTIONS(2406),
    [anon_sym_GT] = ACTIONS(2406),
    [anon_sym_SLASH] = ACTIONS(2406),
    [anon_sym_DOT] = ACTIONS(2404),
    [anon_sym_QMARK] = ACTIONS(2404),
    [anon_sym_AMP_AMP] = ACTIONS(2404),
    [anon_sym_PIPE_PIPE] = ACTIONS(2404),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_GT_GT_GT] = ACTIONS(2404),
    [anon_sym_LT_LT] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_CARET] = ACTIONS(2404),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_PLUS] = ACTIONS(2406),
    [anon_sym_DASH] = ACTIONS(2406),
    [anon_sym_PERCENT] = ACTIONS(2404),
    [anon_sym_STAR_STAR] = ACTIONS(2404),
    [anon_sym_LT_EQ] = ACTIONS(2404),
    [anon_sym_EQ_EQ] = ACTIONS(2406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2404),
    [anon_sym_BANG_EQ] = ACTIONS(2406),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2404),
    [anon_sym_GT_EQ] = ACTIONS(2404),
    [anon_sym_instanceof] = ACTIONS(2404),
    [anon_sym_BANG] = ACTIONS(2406),
    [anon_sym_PLUS_PLUS] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2404),
  },
  [1551] = {
    [anon_sym_STAR] = ACTIONS(2482),
    [anon_sym_as] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_in] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(2482),
    [anon_sym_GT] = ACTIONS(2482),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_DOT] = ACTIONS(2480),
    [anon_sym_QMARK] = ACTIONS(2480),
    [anon_sym_AMP_AMP] = ACTIONS(2480),
    [anon_sym_PIPE_PIPE] = ACTIONS(2480),
    [anon_sym_GT_GT] = ACTIONS(2482),
    [anon_sym_GT_GT_GT] = ACTIONS(2480),
    [anon_sym_LT_LT] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym_CARET] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_PERCENT] = ACTIONS(2480),
    [anon_sym_STAR_STAR] = ACTIONS(2480),
    [anon_sym_LT_EQ] = ACTIONS(2480),
    [anon_sym_EQ_EQ] = ACTIONS(2482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2480),
    [anon_sym_BANG_EQ] = ACTIONS(2482),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2480),
    [anon_sym_GT_EQ] = ACTIONS(2480),
    [anon_sym_instanceof] = ACTIONS(2480),
    [anon_sym_BANG] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2480),
  },
  [1552] = {
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_as] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_in] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2474),
    [anon_sym_GT] = ACTIONS(2474),
    [anon_sym_SLASH] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2472),
    [anon_sym_QMARK] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_PIPE_PIPE] = ACTIONS(2472),
    [anon_sym_GT_GT] = ACTIONS(2474),
    [anon_sym_GT_GT_GT] = ACTIONS(2472),
    [anon_sym_LT_LT] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_CARET] = ACTIONS(2472),
    [anon_sym_PIPE] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2472),
    [anon_sym_STAR_STAR] = ACTIONS(2472),
    [anon_sym_LT_EQ] = ACTIONS(2472),
    [anon_sym_EQ_EQ] = ACTIONS(2474),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2472),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2472),
    [anon_sym_GT_EQ] = ACTIONS(2472),
    [anon_sym_instanceof] = ACTIONS(2472),
    [anon_sym_BANG] = ACTIONS(2474),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2472),
  },
  [1553] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2553),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(4000),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(4000),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1554] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(3994),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(3994),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1555] = {
    [sym_string] = STATE(2045),
    [sym__property_name] = STATE(2045),
    [sym_computed_property_name] = STATE(2045),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4440),
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4567),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4569),
    [anon_sym_set] = ACTIONS(4569),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1556] = {
    [anon_sym_STAR] = ACTIONS(2398),
    [anon_sym_as] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2396),
    [anon_sym_COMMA] = ACTIONS(2396),
    [anon_sym_LPAREN] = ACTIONS(2396),
    [anon_sym_in] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2396),
    [anon_sym_LT] = ACTIONS(2398),
    [anon_sym_GT] = ACTIONS(2398),
    [anon_sym_SLASH] = ACTIONS(2398),
    [anon_sym_DOT] = ACTIONS(2396),
    [anon_sym_QMARK] = ACTIONS(2396),
    [anon_sym_AMP_AMP] = ACTIONS(2396),
    [anon_sym_PIPE_PIPE] = ACTIONS(2396),
    [anon_sym_GT_GT] = ACTIONS(2398),
    [anon_sym_GT_GT_GT] = ACTIONS(2396),
    [anon_sym_LT_LT] = ACTIONS(2396),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_CARET] = ACTIONS(2396),
    [anon_sym_PIPE] = ACTIONS(2398),
    [anon_sym_PLUS] = ACTIONS(2398),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_PERCENT] = ACTIONS(2396),
    [anon_sym_STAR_STAR] = ACTIONS(2396),
    [anon_sym_LT_EQ] = ACTIONS(2396),
    [anon_sym_EQ_EQ] = ACTIONS(2398),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2396),
    [anon_sym_BANG_EQ] = ACTIONS(2398),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2396),
    [anon_sym_GT_EQ] = ACTIONS(2396),
    [anon_sym_instanceof] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_PLUS_PLUS] = ACTIONS(2396),
    [anon_sym_DASH_DASH] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [anon_sym_implements] = ACTIONS(2396),
  },
  [1557] = {
    [sym_string] = STATE(2037),
    [sym__property_name] = STATE(2037),
    [sym_computed_property_name] = STATE(2037),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4571),
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4573),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4575),
    [anon_sym_set] = ACTIONS(4575),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1558] = {
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_as] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_COMMA] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_in] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_GT] = ACTIONS(2394),
    [anon_sym_SLASH] = ACTIONS(2394),
    [anon_sym_DOT] = ACTIONS(2392),
    [anon_sym_QMARK] = ACTIONS(2392),
    [anon_sym_AMP_AMP] = ACTIONS(2392),
    [anon_sym_PIPE_PIPE] = ACTIONS(2392),
    [anon_sym_GT_GT] = ACTIONS(2394),
    [anon_sym_GT_GT_GT] = ACTIONS(2392),
    [anon_sym_LT_LT] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_CARET] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_PERCENT] = ACTIONS(2392),
    [anon_sym_STAR_STAR] = ACTIONS(2392),
    [anon_sym_LT_EQ] = ACTIONS(2392),
    [anon_sym_EQ_EQ] = ACTIONS(2394),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2392),
    [anon_sym_BANG_EQ] = ACTIONS(2394),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2392),
    [anon_sym_GT_EQ] = ACTIONS(2392),
    [anon_sym_instanceof] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2392),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2392),
  },
  [1559] = {
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_as] = ACTIONS(2450),
    [anon_sym_LBRACE] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(2450),
    [anon_sym_in] = ACTIONS(2452),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(2452),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_DOT] = ACTIONS(2450),
    [anon_sym_QMARK] = ACTIONS(2450),
    [anon_sym_AMP_AMP] = ACTIONS(2450),
    [anon_sym_PIPE_PIPE] = ACTIONS(2450),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_CARET] = ACTIONS(2450),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2452),
    [anon_sym_DASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_STAR_STAR] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_EQ_EQ] = ACTIONS(2452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG_EQ] = ACTIONS(2452),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_PLUS_PLUS] = ACTIONS(2450),
    [anon_sym_DASH_DASH] = ACTIONS(2450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2450),
  },
  [1560] = {
    [anon_sym_STAR] = ACTIONS(2384),
    [anon_sym_as] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(2384),
    [anon_sym_COMMA] = ACTIONS(2382),
    [anon_sym_LPAREN] = ACTIONS(2382),
    [anon_sym_in] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_LT] = ACTIONS(2384),
    [anon_sym_GT] = ACTIONS(2384),
    [anon_sym_SLASH] = ACTIONS(2384),
    [anon_sym_DOT] = ACTIONS(4342),
    [anon_sym_QMARK] = ACTIONS(2382),
    [anon_sym_AMP_AMP] = ACTIONS(2382),
    [anon_sym_PIPE_PIPE] = ACTIONS(2382),
    [anon_sym_GT_GT] = ACTIONS(2384),
    [anon_sym_GT_GT_GT] = ACTIONS(2382),
    [anon_sym_LT_LT] = ACTIONS(2382),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym_CARET] = ACTIONS(2382),
    [anon_sym_PIPE] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_PERCENT] = ACTIONS(2382),
    [anon_sym_STAR_STAR] = ACTIONS(2382),
    [anon_sym_LT_EQ] = ACTIONS(2382),
    [anon_sym_EQ_EQ] = ACTIONS(2384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2382),
    [anon_sym_BANG_EQ] = ACTIONS(2384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2382),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_instanceof] = ACTIONS(2382),
    [anon_sym_BANG] = ACTIONS(2384),
    [anon_sym_PLUS_PLUS] = ACTIONS(2382),
    [anon_sym_DASH_DASH] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2382),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2382),
  },
  [1561] = {
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_as] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_COMMA] = ACTIONS(2378),
    [anon_sym_LPAREN] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2380),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_LT] = ACTIONS(2380),
    [anon_sym_GT] = ACTIONS(2380),
    [anon_sym_SLASH] = ACTIONS(2380),
    [anon_sym_DOT] = ACTIONS(2378),
    [anon_sym_QMARK] = ACTIONS(2378),
    [anon_sym_AMP_AMP] = ACTIONS(2378),
    [anon_sym_PIPE_PIPE] = ACTIONS(2378),
    [anon_sym_GT_GT] = ACTIONS(2380),
    [anon_sym_GT_GT_GT] = ACTIONS(2378),
    [anon_sym_LT_LT] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2380),
    [anon_sym_CARET] = ACTIONS(2378),
    [anon_sym_PIPE] = ACTIONS(2380),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2380),
    [anon_sym_PERCENT] = ACTIONS(2378),
    [anon_sym_STAR_STAR] = ACTIONS(2378),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_EQ] = ACTIONS(2380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2378),
    [anon_sym_BANG_EQ] = ACTIONS(2380),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2378),
    [anon_sym_GT_EQ] = ACTIONS(2378),
    [anon_sym_instanceof] = ACTIONS(2378),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2378),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2378),
  },
  [1562] = {
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_as] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_SLASH] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_GT_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_CARET] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_STAR_STAR] = ACTIONS(2462),
    [anon_sym_LT_EQ] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2462),
    [anon_sym_instanceof] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2462),
  },
  [1563] = {
    [anon_sym_STAR] = ACTIONS(2414),
    [anon_sym_as] = ACTIONS(2412),
    [anon_sym_LBRACE] = ACTIONS(2414),
    [anon_sym_COMMA] = ACTIONS(2412),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_LT] = ACTIONS(2414),
    [anon_sym_GT] = ACTIONS(2414),
    [anon_sym_SLASH] = ACTIONS(2414),
    [anon_sym_DOT] = ACTIONS(2412),
    [anon_sym_QMARK] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2412),
    [anon_sym_GT_GT] = ACTIONS(2414),
    [anon_sym_GT_GT_GT] = ACTIONS(2412),
    [anon_sym_LT_LT] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_CARET] = ACTIONS(2412),
    [anon_sym_PIPE] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PERCENT] = ACTIONS(2412),
    [anon_sym_STAR_STAR] = ACTIONS(2412),
    [anon_sym_LT_EQ] = ACTIONS(2412),
    [anon_sym_EQ_EQ] = ACTIONS(2414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2412),
    [anon_sym_BANG_EQ] = ACTIONS(2414),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2412),
    [anon_sym_GT_EQ] = ACTIONS(2412),
    [anon_sym_instanceof] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2414),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2412),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2412),
  },
  [1564] = {
    [anon_sym_STAR] = ACTIONS(2432),
    [anon_sym_as] = ACTIONS(2430),
    [anon_sym_LBRACE] = ACTIONS(2432),
    [anon_sym_COMMA] = ACTIONS(2430),
    [anon_sym_LPAREN] = ACTIONS(2430),
    [anon_sym_in] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2432),
    [anon_sym_GT] = ACTIONS(2432),
    [anon_sym_SLASH] = ACTIONS(2432),
    [anon_sym_DOT] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(2430),
    [anon_sym_AMP_AMP] = ACTIONS(2430),
    [anon_sym_PIPE_PIPE] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(2432),
    [anon_sym_GT_GT_GT] = ACTIONS(2430),
    [anon_sym_LT_LT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2432),
    [anon_sym_CARET] = ACTIONS(2430),
    [anon_sym_PIPE] = ACTIONS(2432),
    [anon_sym_PLUS] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2432),
    [anon_sym_PERCENT] = ACTIONS(2430),
    [anon_sym_STAR_STAR] = ACTIONS(2430),
    [anon_sym_LT_EQ] = ACTIONS(2430),
    [anon_sym_EQ_EQ] = ACTIONS(2432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2430),
    [anon_sym_BANG_EQ] = ACTIONS(2432),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2430),
    [anon_sym_GT_EQ] = ACTIONS(2430),
    [anon_sym_instanceof] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2430),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2430),
  },
  [1565] = {
    [anon_sym_STAR] = ACTIONS(2436),
    [anon_sym_as] = ACTIONS(2434),
    [anon_sym_LBRACE] = ACTIONS(2436),
    [anon_sym_COMMA] = ACTIONS(2434),
    [anon_sym_LPAREN] = ACTIONS(2434),
    [anon_sym_in] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(4577),
    [anon_sym_LT] = ACTIONS(2436),
    [anon_sym_GT] = ACTIONS(2436),
    [anon_sym_SLASH] = ACTIONS(2436),
    [anon_sym_DOT] = ACTIONS(2434),
    [anon_sym_QMARK] = ACTIONS(2434),
    [anon_sym_AMP_AMP] = ACTIONS(2434),
    [anon_sym_PIPE_PIPE] = ACTIONS(2434),
    [anon_sym_GT_GT] = ACTIONS(2436),
    [anon_sym_GT_GT_GT] = ACTIONS(2434),
    [anon_sym_LT_LT] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_CARET] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_PERCENT] = ACTIONS(2434),
    [anon_sym_STAR_STAR] = ACTIONS(2434),
    [anon_sym_LT_EQ] = ACTIONS(2434),
    [anon_sym_EQ_EQ] = ACTIONS(2436),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2434),
    [anon_sym_BANG_EQ] = ACTIONS(2436),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2434),
    [anon_sym_GT_EQ] = ACTIONS(2434),
    [anon_sym_instanceof] = ACTIONS(2434),
    [anon_sym_BANG] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2434),
    [anon_sym_DASH_DASH] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2434),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2434),
  },
  [1566] = {
    [anon_sym_STAR] = ACTIONS(2346),
    [anon_sym_as] = ACTIONS(2344),
    [anon_sym_LBRACE] = ACTIONS(2346),
    [anon_sym_COMMA] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(2344),
    [anon_sym_in] = ACTIONS(2346),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_SLASH] = ACTIONS(2346),
    [anon_sym_DOT] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_GT_GT] = ACTIONS(2346),
    [anon_sym_GT_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_CARET] = ACTIONS(2344),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_PERCENT] = ACTIONS(2344),
    [anon_sym_STAR_STAR] = ACTIONS(2344),
    [anon_sym_LT_EQ] = ACTIONS(2344),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2344),
    [anon_sym_BANG_EQ] = ACTIONS(2346),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2344),
    [anon_sym_GT_EQ] = ACTIONS(2344),
    [anon_sym_instanceof] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2346),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2344),
  },
  [1567] = {
    [anon_sym_STAR] = ACTIONS(3981),
    [anon_sym_as] = ACTIONS(3983),
    [anon_sym_LBRACE] = ACTIONS(3981),
    [anon_sym_COMMA] = ACTIONS(3983),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_in] = ACTIONS(3981),
    [anon_sym_LBRACK] = ACTIONS(3983),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3981),
    [anon_sym_SLASH] = ACTIONS(3981),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3983),
    [anon_sym_PIPE_PIPE] = ACTIONS(3983),
    [anon_sym_GT_GT] = ACTIONS(3981),
    [anon_sym_GT_GT_GT] = ACTIONS(3983),
    [anon_sym_LT_LT] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3981),
    [anon_sym_CARET] = ACTIONS(3983),
    [anon_sym_PIPE] = ACTIONS(3981),
    [anon_sym_PLUS] = ACTIONS(3981),
    [anon_sym_DASH] = ACTIONS(3981),
    [anon_sym_PERCENT] = ACTIONS(3983),
    [anon_sym_STAR_STAR] = ACTIONS(3983),
    [anon_sym_LT_EQ] = ACTIONS(3983),
    [anon_sym_EQ_EQ] = ACTIONS(3981),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3983),
    [anon_sym_BANG_EQ] = ACTIONS(3981),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3983),
    [anon_sym_GT_EQ] = ACTIONS(3983),
    [anon_sym_instanceof] = ACTIONS(3983),
    [anon_sym_BANG] = ACTIONS(3981),
    [anon_sym_PLUS_PLUS] = ACTIONS(3983),
    [anon_sym_DASH_DASH] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3983),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3983),
  },
  [1568] = {
    [anon_sym_STAR] = ACTIONS(2486),
    [anon_sym_as] = ACTIONS(2484),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_COMMA] = ACTIONS(2484),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_in] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2486),
    [anon_sym_GT] = ACTIONS(2486),
    [anon_sym_SLASH] = ACTIONS(2486),
    [anon_sym_DOT] = ACTIONS(2484),
    [anon_sym_QMARK] = ACTIONS(2484),
    [anon_sym_AMP_AMP] = ACTIONS(2484),
    [anon_sym_PIPE_PIPE] = ACTIONS(2484),
    [anon_sym_GT_GT] = ACTIONS(2486),
    [anon_sym_GT_GT_GT] = ACTIONS(2484),
    [anon_sym_LT_LT] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_CARET] = ACTIONS(2484),
    [anon_sym_PIPE] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2486),
    [anon_sym_PERCENT] = ACTIONS(2484),
    [anon_sym_STAR_STAR] = ACTIONS(2484),
    [anon_sym_LT_EQ] = ACTIONS(2484),
    [anon_sym_EQ_EQ] = ACTIONS(2486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2484),
    [anon_sym_BANG_EQ] = ACTIONS(2486),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2484),
    [anon_sym_GT_EQ] = ACTIONS(2484),
    [anon_sym_instanceof] = ACTIONS(2484),
    [anon_sym_BANG] = ACTIONS(2486),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2484),
  },
  [1569] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3601),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1570] = {
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_as] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1081),
    [anon_sym_STAR_STAR] = ACTIONS(1081),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1081),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1081),
  },
  [1571] = {
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_as] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_in] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(4577),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_GT] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2426),
    [anon_sym_DOT] = ACTIONS(2424),
    [anon_sym_QMARK] = ACTIONS(2424),
    [anon_sym_AMP_AMP] = ACTIONS(2424),
    [anon_sym_PIPE_PIPE] = ACTIONS(2424),
    [anon_sym_GT_GT] = ACTIONS(2426),
    [anon_sym_GT_GT_GT] = ACTIONS(2424),
    [anon_sym_LT_LT] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2426),
    [anon_sym_CARET] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_PERCENT] = ACTIONS(2424),
    [anon_sym_STAR_STAR] = ACTIONS(2424),
    [anon_sym_LT_EQ] = ACTIONS(2424),
    [anon_sym_EQ_EQ] = ACTIONS(2426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2424),
    [anon_sym_BANG_EQ] = ACTIONS(2426),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2424),
    [anon_sym_GT_EQ] = ACTIONS(2424),
    [anon_sym_instanceof] = ACTIONS(2424),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2424),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
  },
  [1572] = {
    [anon_sym_STAR] = ACTIONS(2440),
    [anon_sym_as] = ACTIONS(2438),
    [anon_sym_LBRACE] = ACTIONS(2440),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_LPAREN] = ACTIONS(2438),
    [anon_sym_in] = ACTIONS(2440),
    [anon_sym_LBRACK] = ACTIONS(2438),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2440),
    [anon_sym_SLASH] = ACTIONS(2440),
    [anon_sym_DOT] = ACTIONS(2438),
    [anon_sym_QMARK] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2438),
    [anon_sym_PIPE_PIPE] = ACTIONS(2438),
    [anon_sym_GT_GT] = ACTIONS(2440),
    [anon_sym_GT_GT_GT] = ACTIONS(2438),
    [anon_sym_LT_LT] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2440),
    [anon_sym_CARET] = ACTIONS(2438),
    [anon_sym_PIPE] = ACTIONS(2440),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_DASH] = ACTIONS(2440),
    [anon_sym_PERCENT] = ACTIONS(2438),
    [anon_sym_STAR_STAR] = ACTIONS(2438),
    [anon_sym_LT_EQ] = ACTIONS(2438),
    [anon_sym_EQ_EQ] = ACTIONS(2440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2438),
    [anon_sym_BANG_EQ] = ACTIONS(2440),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2438),
    [anon_sym_GT_EQ] = ACTIONS(2438),
    [anon_sym_instanceof] = ACTIONS(2438),
    [anon_sym_BANG] = ACTIONS(2440),
    [anon_sym_PLUS_PLUS] = ACTIONS(2438),
    [anon_sym_DASH_DASH] = ACTIONS(2438),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2438),
  },
  [1573] = {
    [sym_string] = STATE(2002),
    [sym__property_name] = STATE(2002),
    [sym_computed_property_name] = STATE(2002),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4510),
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4579),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4581),
    [anon_sym_set] = ACTIONS(4581),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1574] = {
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_as] = ACTIONS(589),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_in] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_GT] = ACTIONS(2470),
    [anon_sym_SLASH] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(589),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_AMP_AMP] = ACTIONS(589),
    [anon_sym_PIPE_PIPE] = ACTIONS(589),
    [anon_sym_GT_GT] = ACTIONS(2470),
    [anon_sym_GT_GT_GT] = ACTIONS(589),
    [anon_sym_LT_LT] = ACTIONS(589),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_CARET] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(589),
    [anon_sym_STAR_STAR] = ACTIONS(589),
    [anon_sym_LT_EQ] = ACTIONS(589),
    [anon_sym_EQ_EQ] = ACTIONS(2470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(589),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(589),
    [anon_sym_GT_EQ] = ACTIONS(589),
    [anon_sym_instanceof] = ACTIONS(589),
    [anon_sym_BANG] = ACTIONS(2470),
    [anon_sym_PLUS_PLUS] = ACTIONS(589),
    [anon_sym_DASH_DASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(589),
    [anon_sym_LBRACE_PIPE] = ACTIONS(589),
  },
  [1575] = {
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_as] = ACTIONS(3987),
    [anon_sym_LBRACE] = ACTIONS(3985),
    [anon_sym_COMMA] = ACTIONS(3987),
    [anon_sym_LPAREN] = ACTIONS(3987),
    [anon_sym_in] = ACTIONS(3985),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3985),
    [anon_sym_GT] = ACTIONS(3985),
    [anon_sym_SLASH] = ACTIONS(3985),
    [anon_sym_DOT] = ACTIONS(3987),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3987),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_GT_GT_GT] = ACTIONS(3987),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3985),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3985),
    [anon_sym_DASH] = ACTIONS(3985),
    [anon_sym_PERCENT] = ACTIONS(3987),
    [anon_sym_STAR_STAR] = ACTIONS(3987),
    [anon_sym_LT_EQ] = ACTIONS(3987),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3987),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3987),
    [anon_sym_GT_EQ] = ACTIONS(3987),
    [anon_sym_instanceof] = ACTIONS(3987),
    [anon_sym_BANG] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3987),
    [anon_sym_DASH_DASH] = ACTIONS(3987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3987),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3987),
  },
  [1576] = {
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_as] = ACTIONS(3987),
    [anon_sym_LBRACE] = ACTIONS(3985),
    [anon_sym_COMMA] = ACTIONS(3987),
    [anon_sym_LPAREN] = ACTIONS(3987),
    [anon_sym_in] = ACTIONS(3985),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(3985),
    [anon_sym_GT] = ACTIONS(3985),
    [anon_sym_SLASH] = ACTIONS(3985),
    [anon_sym_DOT] = ACTIONS(3987),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3987),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3985),
    [anon_sym_GT_GT_GT] = ACTIONS(3987),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3985),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3985),
    [anon_sym_DASH] = ACTIONS(3985),
    [anon_sym_PERCENT] = ACTIONS(3987),
    [anon_sym_STAR_STAR] = ACTIONS(3987),
    [anon_sym_LT_EQ] = ACTIONS(3987),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3987),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3987),
    [anon_sym_GT_EQ] = ACTIONS(3987),
    [anon_sym_instanceof] = ACTIONS(3987),
    [anon_sym_BANG] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3987),
    [anon_sym_DASH_DASH] = ACTIONS(3987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3987),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3987),
  },
  [1577] = {
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_as] = ACTIONS(1077),
    [anon_sym_LBRACE] = ACTIONS(1079),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_in] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_SLASH] = ACTIONS(1079),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(1079),
    [anon_sym_DASH] = ACTIONS(1079),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1079),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1077),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1077),
  },
  [1578] = {
    [sym_string] = STATE(2067),
    [sym__property_name] = STATE(2067),
    [sym_computed_property_name] = STATE(2067),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4585),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4587),
    [anon_sym_set] = ACTIONS(4587),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1579] = {
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_as] = ACTIONS(3605),
    [anon_sym_LBRACE] = ACTIONS(3607),
    [anon_sym_COMMA] = ACTIONS(3605),
    [anon_sym_LPAREN] = ACTIONS(3605),
    [anon_sym_in] = ACTIONS(3607),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_LT] = ACTIONS(3607),
    [anon_sym_GT] = ACTIONS(3607),
    [anon_sym_SLASH] = ACTIONS(3607),
    [anon_sym_DOT] = ACTIONS(3605),
    [anon_sym_QMARK] = ACTIONS(3605),
    [anon_sym_AMP_AMP] = ACTIONS(3605),
    [anon_sym_PIPE_PIPE] = ACTIONS(3605),
    [anon_sym_GT_GT] = ACTIONS(3607),
    [anon_sym_GT_GT_GT] = ACTIONS(3605),
    [anon_sym_LT_LT] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_CARET] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PERCENT] = ACTIONS(3605),
    [anon_sym_STAR_STAR] = ACTIONS(3605),
    [anon_sym_LT_EQ] = ACTIONS(3605),
    [anon_sym_EQ_EQ] = ACTIONS(3607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3605),
    [anon_sym_BANG_EQ] = ACTIONS(3607),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3605),
    [anon_sym_GT_EQ] = ACTIONS(3605),
    [anon_sym_instanceof] = ACTIONS(3605),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3605),
  },
  [1580] = {
    [sym_string] = STATE(2035),
    [sym__property_name] = STATE(2035),
    [sym_computed_property_name] = STATE(2035),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4589),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4591),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4593),
    [anon_sym_set] = ACTIONS(4593),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1581] = {
    [anon_sym_STAR] = ACTIONS(3918),
    [anon_sym_as] = ACTIONS(3920),
    [anon_sym_LBRACE] = ACTIONS(3918),
    [anon_sym_COMMA] = ACTIONS(3920),
    [anon_sym_LPAREN] = ACTIONS(3920),
    [anon_sym_in] = ACTIONS(3918),
    [anon_sym_LBRACK] = ACTIONS(3920),
    [anon_sym_LT] = ACTIONS(3918),
    [anon_sym_GT] = ACTIONS(3918),
    [anon_sym_SLASH] = ACTIONS(3918),
    [anon_sym_DOT] = ACTIONS(3920),
    [anon_sym_QMARK] = ACTIONS(3920),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3920),
    [anon_sym_GT_GT] = ACTIONS(3918),
    [anon_sym_GT_GT_GT] = ACTIONS(3920),
    [anon_sym_LT_LT] = ACTIONS(3920),
    [anon_sym_AMP] = ACTIONS(3918),
    [anon_sym_CARET] = ACTIONS(3920),
    [anon_sym_PIPE] = ACTIONS(3918),
    [anon_sym_PLUS] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3918),
    [anon_sym_PERCENT] = ACTIONS(3920),
    [anon_sym_STAR_STAR] = ACTIONS(3920),
    [anon_sym_LT_EQ] = ACTIONS(3920),
    [anon_sym_EQ_EQ] = ACTIONS(3918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3920),
    [anon_sym_BANG_EQ] = ACTIONS(3918),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3920),
    [anon_sym_GT_EQ] = ACTIONS(3920),
    [anon_sym_instanceof] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_PLUS_PLUS] = ACTIONS(3920),
    [anon_sym_DASH_DASH] = ACTIONS(3920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3920),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3920),
  },
  [1582] = {
    [sym_string] = STATE(2036),
    [sym__property_name] = STATE(2036),
    [sym_computed_property_name] = STATE(2036),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4490),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4595),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4597),
    [anon_sym_set] = ACTIONS(4597),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1583] = {
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(2543),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2541),
    [anon_sym_DQUOTE] = ACTIONS(2543),
    [anon_sym_SQUOTE] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2543),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1584] = {
    [sym_string] = STATE(1998),
    [sym__property_name] = STATE(1998),
    [sym_computed_property_name] = STATE(1998),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4599),
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4601),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4603),
    [anon_sym_set] = ACTIONS(4603),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1585] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1586] = {
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_as] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_COMMA] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_in] = ACTIONS(3317),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(3317),
    [anon_sym_GT] = ACTIONS(3317),
    [anon_sym_SLASH] = ACTIONS(3317),
    [anon_sym_DOT] = ACTIONS(3319),
    [anon_sym_QMARK] = ACTIONS(3319),
    [anon_sym_AMP_AMP] = ACTIONS(3319),
    [anon_sym_PIPE_PIPE] = ACTIONS(3319),
    [anon_sym_GT_GT] = ACTIONS(3317),
    [anon_sym_GT_GT_GT] = ACTIONS(3319),
    [anon_sym_LT_LT] = ACTIONS(3319),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3319),
    [anon_sym_PIPE] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_PERCENT] = ACTIONS(3319),
    [anon_sym_STAR_STAR] = ACTIONS(3319),
    [anon_sym_LT_EQ] = ACTIONS(3319),
    [anon_sym_EQ_EQ] = ACTIONS(3317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3319),
    [anon_sym_BANG_EQ] = ACTIONS(3317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3319),
    [anon_sym_GT_EQ] = ACTIONS(3319),
    [anon_sym_instanceof] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3319),
  },
  [1587] = {
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(2484),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_in] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_RBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
  },
  [1588] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2553),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(4000),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(4000),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1589] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(3994),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(3994),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(3994),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1590] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4605),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1591] = {
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_as] = ACTIONS(3609),
    [anon_sym_LBRACE] = ACTIONS(3611),
    [anon_sym_COMMA] = ACTIONS(3609),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3611),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_LT] = ACTIONS(3611),
    [anon_sym_GT] = ACTIONS(3611),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_DOT] = ACTIONS(3609),
    [anon_sym_QMARK] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_PIPE_PIPE] = ACTIONS(3609),
    [anon_sym_GT_GT] = ACTIONS(3611),
    [anon_sym_GT_GT_GT] = ACTIONS(3609),
    [anon_sym_LT_LT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_CARET] = ACTIONS(3609),
    [anon_sym_PIPE] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3609),
    [anon_sym_STAR_STAR] = ACTIONS(3609),
    [anon_sym_LT_EQ] = ACTIONS(3609),
    [anon_sym_EQ_EQ] = ACTIONS(3611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3609),
    [anon_sym_BANG_EQ] = ACTIONS(3611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3609),
    [anon_sym_GT_EQ] = ACTIONS(3609),
    [anon_sym_instanceof] = ACTIONS(3609),
    [anon_sym_BANG] = ACTIONS(3611),
    [anon_sym_PLUS_PLUS] = ACTIONS(3609),
    [anon_sym_DASH_DASH] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3609),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3609),
  },
  [1592] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(4607),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1593] = {
    [anon_sym_STAR] = ACTIONS(4005),
    [anon_sym_as] = ACTIONS(3713),
    [anon_sym_LBRACE] = ACTIONS(4005),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3713),
    [anon_sym_in] = ACTIONS(4005),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_GT] = ACTIONS(4005),
    [anon_sym_SLASH] = ACTIONS(4005),
    [anon_sym_DOT] = ACTIONS(3713),
    [anon_sym_QMARK] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3713),
    [anon_sym_PIPE_PIPE] = ACTIONS(3713),
    [anon_sym_GT_GT] = ACTIONS(4005),
    [anon_sym_GT_GT_GT] = ACTIONS(3713),
    [anon_sym_LT_LT] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(4005),
    [anon_sym_CARET] = ACTIONS(3713),
    [anon_sym_PIPE] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(4005),
    [anon_sym_DASH] = ACTIONS(4005),
    [anon_sym_PERCENT] = ACTIONS(3713),
    [anon_sym_STAR_STAR] = ACTIONS(3713),
    [anon_sym_LT_EQ] = ACTIONS(3713),
    [anon_sym_EQ_EQ] = ACTIONS(4005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3713),
    [anon_sym_BANG_EQ] = ACTIONS(4005),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3713),
    [anon_sym_GT_EQ] = ACTIONS(3713),
    [anon_sym_instanceof] = ACTIONS(3713),
    [anon_sym_BANG] = ACTIONS(4005),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3713),
  },
  [1594] = {
    [anon_sym_STAR] = ACTIONS(1193),
    [anon_sym_as] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1193),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_in] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1193),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1193),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1195),
  },
  [1595] = {
    [anon_sym_STAR] = ACTIONS(4026),
    [anon_sym_as] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4026),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_in] = ACTIONS(4026),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_DOT] = ACTIONS(4028),
    [anon_sym_QMARK] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_STAR_STAR] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4026),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_instanceof] = ACTIONS(4028),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4028),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4028),
  },
  [1596] = {
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_as] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1093),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_instanceof] = ACTIONS(1093),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1093),
  },
  [1597] = {
    [sym_template_string] = STATE(1010),
    [sym_arguments] = STATE(1010),
    [sym_type_arguments] = STATE(2282),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(4290),
    [anon_sym_GT] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4286),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(4327),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(4286),
    [anon_sym_GT_GT_GT] = ACTIONS(4292),
    [anon_sym_LT_LT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4333),
    [anon_sym_CARET] = ACTIONS(4331),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_PERCENT] = ACTIONS(4292),
    [anon_sym_STAR_STAR] = ACTIONS(4296),
    [anon_sym_LT_EQ] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4298),
    [anon_sym_BANG_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4298),
    [anon_sym_GT_EQ] = ACTIONS(4298),
    [anon_sym_instanceof] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [1598] = {
    [anon_sym_STAR] = ACTIONS(1225),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1227),
    [anon_sym_in] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1225),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1225),
    [anon_sym_GT_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_PERCENT] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1227),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1225),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1227),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1227),
  },
  [1599] = {
    [anon_sym_STAR] = ACTIONS(4030),
    [anon_sym_as] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(4030),
    [anon_sym_COMMA] = ACTIONS(4032),
    [anon_sym_LPAREN] = ACTIONS(4032),
    [anon_sym_in] = ACTIONS(4030),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_LT] = ACTIONS(4030),
    [anon_sym_GT] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4030),
    [anon_sym_DOT] = ACTIONS(4032),
    [anon_sym_QMARK] = ACTIONS(4032),
    [anon_sym_AMP_AMP] = ACTIONS(4032),
    [anon_sym_PIPE_PIPE] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_GT_GT_GT] = ACTIONS(4032),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4030),
    [anon_sym_CARET] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4030),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_DASH] = ACTIONS(4030),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_LT_EQ] = ACTIONS(4032),
    [anon_sym_EQ_EQ] = ACTIONS(4030),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4032),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4032),
    [anon_sym_GT_EQ] = ACTIONS(4032),
    [anon_sym_instanceof] = ACTIONS(4032),
    [anon_sym_BANG] = ACTIONS(4030),
    [anon_sym_PLUS_PLUS] = ACTIONS(4032),
    [anon_sym_DASH_DASH] = ACTIONS(4032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4032),
  },
  [1600] = {
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_in] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1183),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_DOT] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(1185),
    [anon_sym_AMP_AMP] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_GT_GT] = ACTIONS(1183),
    [anon_sym_GT_GT_GT] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(1185),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1185),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_PERCENT] = ACTIONS(1185),
    [anon_sym_STAR_STAR] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1185),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1185),
    [anon_sym_GT_EQ] = ACTIONS(1185),
    [anon_sym_instanceof] = ACTIONS(1185),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1185),
  },
  [1601] = {
    [anon_sym_STAR] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1125),
    [anon_sym_GT] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_GT_GT] = ACTIONS(1125),
    [anon_sym_GT_GT_GT] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_CARET] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1125),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1125),
    [anon_sym_PERCENT] = ACTIONS(1127),
    [anon_sym_STAR_STAR] = ACTIONS(1127),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_instanceof] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1127),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1127),
  },
  [1602] = {
    [anon_sym_STAR] = ACTIONS(1173),
    [anon_sym_as] = ACTIONS(1175),
    [anon_sym_LBRACE] = ACTIONS(1173),
    [anon_sym_COMMA] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1175),
    [anon_sym_in] = ACTIONS(1173),
    [anon_sym_LBRACK] = ACTIONS(1175),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_DOT] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1175),
    [anon_sym_LT_LT] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1175),
    [anon_sym_STAR_STAR] = ACTIONS(1175),
    [anon_sym_LT_EQ] = ACTIONS(1175),
    [anon_sym_EQ_EQ] = ACTIONS(1173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1175),
    [anon_sym_BANG_EQ] = ACTIONS(1173),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1175),
    [anon_sym_GT_EQ] = ACTIONS(1175),
    [anon_sym_instanceof] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1175),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1175),
  },
  [1603] = {
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_as] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_COMMA] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1165),
    [anon_sym_in] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1163),
    [anon_sym_GT] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_DOT] = ACTIONS(1165),
    [anon_sym_QMARK] = ACTIONS(1165),
    [anon_sym_AMP_AMP] = ACTIONS(1165),
    [anon_sym_PIPE_PIPE] = ACTIONS(1165),
    [anon_sym_GT_GT] = ACTIONS(1163),
    [anon_sym_GT_GT_GT] = ACTIONS(1165),
    [anon_sym_LT_LT] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_CARET] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_STAR_STAR] = ACTIONS(1165),
    [anon_sym_LT_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ] = ACTIONS(1163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ] = ACTIONS(1163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1165),
    [anon_sym_GT_EQ] = ACTIONS(1165),
    [anon_sym_instanceof] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1165),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1165),
  },
  [1604] = {
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(1139),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1141),
    [anon_sym_in] = ACTIONS(1139),
    [anon_sym_LBRACK] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(1139),
    [anon_sym_GT] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1141),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_AMP_AMP] = ACTIONS(1141),
    [anon_sym_PIPE_PIPE] = ACTIONS(1141),
    [anon_sym_GT_GT] = ACTIONS(1139),
    [anon_sym_GT_GT_GT] = ACTIONS(1141),
    [anon_sym_LT_LT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(1139),
    [anon_sym_CARET] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1139),
    [anon_sym_PERCENT] = ACTIONS(1141),
    [anon_sym_STAR_STAR] = ACTIONS(1141),
    [anon_sym_LT_EQ] = ACTIONS(1141),
    [anon_sym_EQ_EQ] = ACTIONS(1139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1141),
    [anon_sym_BANG_EQ] = ACTIONS(1139),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1141),
    [anon_sym_GT_EQ] = ACTIONS(1141),
    [anon_sym_instanceof] = ACTIONS(1141),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_PLUS_PLUS] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
  },
  [1605] = {
    [anon_sym_STAR] = ACTIONS(4079),
    [anon_sym_as] = ACTIONS(4081),
    [anon_sym_LBRACE] = ACTIONS(4079),
    [anon_sym_COMMA] = ACTIONS(4081),
    [anon_sym_LPAREN] = ACTIONS(4081),
    [anon_sym_in] = ACTIONS(4079),
    [anon_sym_LBRACK] = ACTIONS(4081),
    [anon_sym_LT] = ACTIONS(4079),
    [anon_sym_GT] = ACTIONS(4079),
    [anon_sym_SLASH] = ACTIONS(4079),
    [anon_sym_DOT] = ACTIONS(4081),
    [anon_sym_QMARK] = ACTIONS(4081),
    [anon_sym_AMP_AMP] = ACTIONS(4081),
    [anon_sym_PIPE_PIPE] = ACTIONS(4081),
    [anon_sym_GT_GT] = ACTIONS(4079),
    [anon_sym_GT_GT_GT] = ACTIONS(4081),
    [anon_sym_LT_LT] = ACTIONS(4081),
    [anon_sym_AMP] = ACTIONS(4079),
    [anon_sym_CARET] = ACTIONS(4081),
    [anon_sym_PIPE] = ACTIONS(4079),
    [anon_sym_PLUS] = ACTIONS(4079),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_PERCENT] = ACTIONS(4081),
    [anon_sym_STAR_STAR] = ACTIONS(4081),
    [anon_sym_LT_EQ] = ACTIONS(4081),
    [anon_sym_EQ_EQ] = ACTIONS(4079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4081),
    [anon_sym_BANG_EQ] = ACTIONS(4079),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4081),
    [anon_sym_GT_EQ] = ACTIONS(4081),
    [anon_sym_instanceof] = ACTIONS(4081),
    [anon_sym_BANG] = ACTIONS(4079),
    [anon_sym_PLUS_PLUS] = ACTIONS(4081),
    [anon_sym_DASH_DASH] = ACTIONS(4081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4081),
  },
  [1606] = {
    [sym_string] = STATE(2049),
    [sym__property_name] = STATE(2049),
    [sym_computed_property_name] = STATE(2049),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4609),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4611),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4613),
    [anon_sym_set] = ACTIONS(4613),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1607] = {
    [sym_string] = STATE(1986),
    [sym__property_name] = STATE(1986),
    [sym_computed_property_name] = STATE(1986),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4617),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4619),
    [anon_sym_set] = ACTIONS(4619),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1608] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym_readonly] = ACTIONS(2494),
  },
  [1609] = {
    [anon_sym_STAR] = ACTIONS(4063),
    [anon_sym_as] = ACTIONS(4065),
    [anon_sym_LBRACE] = ACTIONS(4063),
    [anon_sym_COMMA] = ACTIONS(4065),
    [anon_sym_LPAREN] = ACTIONS(4065),
    [anon_sym_in] = ACTIONS(4063),
    [anon_sym_LBRACK] = ACTIONS(4065),
    [anon_sym_LT] = ACTIONS(4063),
    [anon_sym_GT] = ACTIONS(4063),
    [anon_sym_SLASH] = ACTIONS(4063),
    [anon_sym_DOT] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(4065),
    [anon_sym_AMP_AMP] = ACTIONS(4065),
    [anon_sym_PIPE_PIPE] = ACTIONS(4065),
    [anon_sym_GT_GT] = ACTIONS(4063),
    [anon_sym_GT_GT_GT] = ACTIONS(4065),
    [anon_sym_LT_LT] = ACTIONS(4065),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_CARET] = ACTIONS(4065),
    [anon_sym_PIPE] = ACTIONS(4063),
    [anon_sym_PLUS] = ACTIONS(4063),
    [anon_sym_DASH] = ACTIONS(4063),
    [anon_sym_PERCENT] = ACTIONS(4065),
    [anon_sym_STAR_STAR] = ACTIONS(4065),
    [anon_sym_LT_EQ] = ACTIONS(4065),
    [anon_sym_EQ_EQ] = ACTIONS(4063),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4065),
    [anon_sym_BANG_EQ] = ACTIONS(4063),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4065),
    [anon_sym_GT_EQ] = ACTIONS(4065),
    [anon_sym_instanceof] = ACTIONS(4065),
    [anon_sym_BANG] = ACTIONS(4063),
    [anon_sym_PLUS_PLUS] = ACTIONS(4065),
    [anon_sym_DASH_DASH] = ACTIONS(4065),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4065),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4065),
  },
  [1610] = {
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_as] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_in] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1239),
    [anon_sym_QMARK] = ACTIONS(1239),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_GT_GT_GT] = ACTIONS(1239),
    [anon_sym_LT_LT] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PERCENT] = ACTIONS(1239),
    [anon_sym_STAR_STAR] = ACTIONS(1239),
    [anon_sym_LT_EQ] = ACTIONS(1239),
    [anon_sym_EQ_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1239),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1239),
    [anon_sym_GT_EQ] = ACTIONS(1239),
    [anon_sym_instanceof] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1239),
  },
  [1611] = {
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_as] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_COMMA] = ACTIONS(1217),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(1215),
    [anon_sym_LBRACK] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1215),
    [anon_sym_GT] = ACTIONS(1215),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1217),
    [anon_sym_AMP_AMP] = ACTIONS(1217),
    [anon_sym_PIPE_PIPE] = ACTIONS(1217),
    [anon_sym_GT_GT] = ACTIONS(1215),
    [anon_sym_GT_GT_GT] = ACTIONS(1217),
    [anon_sym_LT_LT] = ACTIONS(1217),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1217),
    [anon_sym_PIPE] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1217),
    [anon_sym_STAR_STAR] = ACTIONS(1217),
    [anon_sym_LT_EQ] = ACTIONS(1217),
    [anon_sym_EQ_EQ] = ACTIONS(1215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1217),
    [anon_sym_BANG_EQ] = ACTIONS(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1217),
    [anon_sym_GT_EQ] = ACTIONS(1217),
    [anon_sym_instanceof] = ACTIONS(1217),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1217),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1217),
  },
  [1612] = {
    [anon_sym_STAR] = ACTIONS(1149),
    [anon_sym_as] = ACTIONS(1151),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_in] = ACTIONS(1149),
    [anon_sym_LBRACK] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(1149),
    [anon_sym_GT] = ACTIONS(1149),
    [anon_sym_SLASH] = ACTIONS(1149),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_QMARK] = ACTIONS(1151),
    [anon_sym_AMP_AMP] = ACTIONS(1151),
    [anon_sym_PIPE_PIPE] = ACTIONS(1151),
    [anon_sym_GT_GT] = ACTIONS(1149),
    [anon_sym_GT_GT_GT] = ACTIONS(1151),
    [anon_sym_LT_LT] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(1151),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_PLUS] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_PERCENT] = ACTIONS(1151),
    [anon_sym_STAR_STAR] = ACTIONS(1151),
    [anon_sym_LT_EQ] = ACTIONS(1151),
    [anon_sym_EQ_EQ] = ACTIONS(1149),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1151),
    [anon_sym_BANG_EQ] = ACTIONS(1149),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1151),
    [anon_sym_GT_EQ] = ACTIONS(1151),
    [anon_sym_instanceof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1149),
    [anon_sym_PLUS_PLUS] = ACTIONS(1151),
    [anon_sym_DASH_DASH] = ACTIONS(1151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1151),
  },
  [1613] = {
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_as] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [anon_sym_COMMA] = ACTIONS(1107),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_in] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1107),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_GT_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1107),
    [anon_sym_LT_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1107),
    [anon_sym_GT_EQ] = ACTIONS(1107),
    [anon_sym_instanceof] = ACTIONS(1107),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
  },
  [1614] = {
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_as] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4052),
    [anon_sym_COMMA] = ACTIONS(4054),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_in] = ACTIONS(4052),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4054),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_CARET] = ACTIONS(4054),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_PLUS] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_STAR_STAR] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_instanceof] = ACTIONS(4054),
    [anon_sym_BANG] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4054),
    [anon_sym_DASH_DASH] = ACTIONS(4054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4054),
  },
  [1615] = {
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_as] = ACTIONS(4050),
    [anon_sym_LBRACE] = ACTIONS(4048),
    [anon_sym_COMMA] = ACTIONS(4050),
    [anon_sym_LPAREN] = ACTIONS(4050),
    [anon_sym_in] = ACTIONS(4048),
    [anon_sym_LBRACK] = ACTIONS(4050),
    [anon_sym_LT] = ACTIONS(4048),
    [anon_sym_GT] = ACTIONS(4048),
    [anon_sym_SLASH] = ACTIONS(4048),
    [anon_sym_DOT] = ACTIONS(4050),
    [anon_sym_QMARK] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4048),
    [anon_sym_GT_GT_GT] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_PLUS] = ACTIONS(4048),
    [anon_sym_DASH] = ACTIONS(4048),
    [anon_sym_PERCENT] = ACTIONS(4050),
    [anon_sym_STAR_STAR] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4050),
    [anon_sym_GT_EQ] = ACTIONS(4050),
    [anon_sym_instanceof] = ACTIONS(4050),
    [anon_sym_BANG] = ACTIONS(4048),
    [anon_sym_PLUS_PLUS] = ACTIONS(4050),
    [anon_sym_DASH_DASH] = ACTIONS(4050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4050),
  },
  [1616] = {
    [anon_sym_STAR] = ACTIONS(3559),
    [anon_sym_as] = ACTIONS(3563),
    [anon_sym_LBRACE] = ACTIONS(3559),
    [anon_sym_COMMA] = ACTIONS(3563),
    [anon_sym_LPAREN] = ACTIONS(3563),
    [anon_sym_in] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(3563),
    [anon_sym_LT] = ACTIONS(3559),
    [anon_sym_GT] = ACTIONS(3559),
    [anon_sym_SLASH] = ACTIONS(3559),
    [anon_sym_DOT] = ACTIONS(3563),
    [anon_sym_QMARK] = ACTIONS(3563),
    [anon_sym_AMP_AMP] = ACTIONS(3563),
    [anon_sym_PIPE_PIPE] = ACTIONS(3563),
    [anon_sym_GT_GT] = ACTIONS(3559),
    [anon_sym_GT_GT_GT] = ACTIONS(3563),
    [anon_sym_LT_LT] = ACTIONS(3563),
    [anon_sym_AMP] = ACTIONS(3559),
    [anon_sym_CARET] = ACTIONS(3563),
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_PERCENT] = ACTIONS(3563),
    [anon_sym_STAR_STAR] = ACTIONS(3563),
    [anon_sym_LT_EQ] = ACTIONS(3563),
    [anon_sym_EQ_EQ] = ACTIONS(3559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3563),
    [anon_sym_BANG_EQ] = ACTIONS(3559),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3563),
    [anon_sym_GT_EQ] = ACTIONS(3563),
    [anon_sym_instanceof] = ACTIONS(3563),
    [anon_sym_BANG] = ACTIONS(3559),
    [anon_sym_PLUS_PLUS] = ACTIONS(3563),
    [anon_sym_DASH_DASH] = ACTIONS(3563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3563),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3563),
  },
  [1617] = {
    [anon_sym_STAR] = ACTIONS(4034),
    [anon_sym_as] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(4034),
    [anon_sym_COMMA] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(4034),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_DOT] = ACTIONS(3715),
    [anon_sym_QMARK] = ACTIONS(3715),
    [anon_sym_AMP_AMP] = ACTIONS(3715),
    [anon_sym_PIPE_PIPE] = ACTIONS(3715),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [anon_sym_GT_GT_GT] = ACTIONS(3715),
    [anon_sym_LT_LT] = ACTIONS(3715),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_CARET] = ACTIONS(3715),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(3715),
    [anon_sym_STAR_STAR] = ACTIONS(3715),
    [anon_sym_LT_EQ] = ACTIONS(3715),
    [anon_sym_EQ_EQ] = ACTIONS(4034),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3715),
    [anon_sym_BANG_EQ] = ACTIONS(4034),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3715),
    [anon_sym_GT_EQ] = ACTIONS(3715),
    [anon_sym_instanceof] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(4034),
    [anon_sym_PLUS_PLUS] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3715),
  },
  [1618] = {
    [anon_sym_STAR] = ACTIONS(4044),
    [anon_sym_as] = ACTIONS(4046),
    [anon_sym_LBRACE] = ACTIONS(4044),
    [anon_sym_COMMA] = ACTIONS(4046),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [anon_sym_in] = ACTIONS(4044),
    [anon_sym_LBRACK] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_SLASH] = ACTIONS(4044),
    [anon_sym_DOT] = ACTIONS(4046),
    [anon_sym_QMARK] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(4044),
    [anon_sym_GT_GT_GT] = ACTIONS(4046),
    [anon_sym_LT_LT] = ACTIONS(4046),
    [anon_sym_AMP] = ACTIONS(4044),
    [anon_sym_CARET] = ACTIONS(4046),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_PLUS] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(4044),
    [anon_sym_PERCENT] = ACTIONS(4046),
    [anon_sym_STAR_STAR] = ACTIONS(4046),
    [anon_sym_LT_EQ] = ACTIONS(4046),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4046),
    [anon_sym_BANG_EQ] = ACTIONS(4044),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4046),
    [anon_sym_GT_EQ] = ACTIONS(4046),
    [anon_sym_instanceof] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(4044),
    [anon_sym_PLUS_PLUS] = ACTIONS(4046),
    [anon_sym_DASH_DASH] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4046),
  },
  [1619] = {
    [anon_sym_STAR] = ACTIONS(4042),
    [anon_sym_as] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(4042),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3740),
    [anon_sym_in] = ACTIONS(4042),
    [anon_sym_LBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_SLASH] = ACTIONS(4042),
    [anon_sym_DOT] = ACTIONS(3740),
    [anon_sym_QMARK] = ACTIONS(3740),
    [anon_sym_AMP_AMP] = ACTIONS(3740),
    [anon_sym_PIPE_PIPE] = ACTIONS(3740),
    [anon_sym_GT_GT] = ACTIONS(4042),
    [anon_sym_GT_GT_GT] = ACTIONS(3740),
    [anon_sym_LT_LT] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(4042),
    [anon_sym_CARET] = ACTIONS(3740),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_PLUS] = ACTIONS(4042),
    [anon_sym_DASH] = ACTIONS(4042),
    [anon_sym_PERCENT] = ACTIONS(3740),
    [anon_sym_STAR_STAR] = ACTIONS(3740),
    [anon_sym_LT_EQ] = ACTIONS(3740),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3740),
    [anon_sym_BANG_EQ] = ACTIONS(4042),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3740),
    [anon_sym_GT_EQ] = ACTIONS(3740),
    [anon_sym_instanceof] = ACTIONS(3740),
    [anon_sym_BANG] = ACTIONS(4042),
    [anon_sym_PLUS_PLUS] = ACTIONS(3740),
    [anon_sym_DASH_DASH] = ACTIONS(3740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
  },
  [1620] = {
    [sym_string] = STATE(2041),
    [sym__property_name] = STATE(2041),
    [sym_computed_property_name] = STATE(2041),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3552),
    [anon_sym_RBRACE] = ACTIONS(3552),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4376),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1621] = {
    [anon_sym_STAR] = ACTIONS(4040),
    [anon_sym_as] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(4040),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_LPAREN] = ACTIONS(3727),
    [anon_sym_in] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(3727),
    [anon_sym_LT] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4040),
    [anon_sym_SLASH] = ACTIONS(4040),
    [anon_sym_DOT] = ACTIONS(3727),
    [anon_sym_QMARK] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3727),
    [anon_sym_PIPE_PIPE] = ACTIONS(3727),
    [anon_sym_GT_GT] = ACTIONS(4040),
    [anon_sym_GT_GT_GT] = ACTIONS(3727),
    [anon_sym_LT_LT] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_CARET] = ACTIONS(3727),
    [anon_sym_PIPE] = ACTIONS(4040),
    [anon_sym_PLUS] = ACTIONS(4040),
    [anon_sym_DASH] = ACTIONS(4040),
    [anon_sym_PERCENT] = ACTIONS(3727),
    [anon_sym_STAR_STAR] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(3727),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3727),
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3727),
    [anon_sym_GT_EQ] = ACTIONS(3727),
    [anon_sym_instanceof] = ACTIONS(3727),
    [anon_sym_BANG] = ACTIONS(4040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3727),
    [anon_sym_DASH_DASH] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3727),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3727),
  },
  [1622] = {
    [anon_sym_STAR] = ACTIONS(4036),
    [anon_sym_as] = ACTIONS(4038),
    [anon_sym_LBRACE] = ACTIONS(4036),
    [anon_sym_COMMA] = ACTIONS(4038),
    [anon_sym_LPAREN] = ACTIONS(4038),
    [anon_sym_in] = ACTIONS(4036),
    [anon_sym_LBRACK] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4036),
    [anon_sym_SLASH] = ACTIONS(4036),
    [anon_sym_DOT] = ACTIONS(4038),
    [anon_sym_QMARK] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4036),
    [anon_sym_GT_GT_GT] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_CARET] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_PLUS] = ACTIONS(4036),
    [anon_sym_DASH] = ACTIONS(4036),
    [anon_sym_PERCENT] = ACTIONS(4038),
    [anon_sym_STAR_STAR] = ACTIONS(4038),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4038),
    [anon_sym_BANG_EQ] = ACTIONS(4036),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4038),
    [anon_sym_instanceof] = ACTIONS(4038),
    [anon_sym_BANG] = ACTIONS(4036),
    [anon_sym_PLUS_PLUS] = ACTIONS(4038),
    [anon_sym_DASH_DASH] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4038),
  },
  [1623] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_RBRACK] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1624] = {
    [sym_string] = STATE(2034),
    [sym__property_name] = STATE(2034),
    [sym_computed_property_name] = STATE(2034),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4555),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1625] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1626] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_decorator] = STATE(1762),
    [sym_rest_parameter] = STATE(2548),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2548),
    [sym_optional_parameter] = STATE(2548),
    [sym__parameter_name] = STATE(1975),
    [aux_sym_export_statement_repeat1] = STATE(1663),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(4623),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4621),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(811),
  },
  [1627] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3625),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(3651),
    [anon_sym_of] = ACTIONS(3654),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1628] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3613),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(3700),
    [anon_sym_of] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1629] = {
    [sym_string] = STATE(2002),
    [sym__property_name] = STATE(2002),
    [sym_computed_property_name] = STATE(2002),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4579),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1630] = {
    [sym_arguments] = STATE(1680),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym_export] = ACTIONS(4625),
    [anon_sym_STAR] = ACTIONS(4627),
    [anon_sym_namespace] = ACTIONS(4625),
    [anon_sym_LBRACE] = ACTIONS(4627),
    [anon_sym_RBRACE] = ACTIONS(4627),
    [anon_sym_type] = ACTIONS(4625),
    [anon_sym_LPAREN] = ACTIONS(4629),
    [anon_sym_LBRACK] = ACTIONS(4627),
    [anon_sym_DOT] = ACTIONS(4631),
    [anon_sym_class] = ACTIONS(4625),
    [anon_sym_async] = ACTIONS(4625),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4627),
    [anon_sym_void] = ACTIONS(4625),
    [anon_sym_DQUOTE] = ACTIONS(4627),
    [anon_sym_SQUOTE] = ACTIONS(4627),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4627),
    [sym_this] = ACTIONS(4625),
    [anon_sym_AT] = ACTIONS(4627),
    [anon_sym_static] = ACTIONS(4625),
    [anon_sym_abstract] = ACTIONS(4625),
    [anon_sym_get] = ACTIONS(4625),
    [anon_sym_set] = ACTIONS(4625),
    [anon_sym_declare] = ACTIONS(4625),
    [anon_sym_public] = ACTIONS(4625),
    [anon_sym_private] = ACTIONS(4625),
    [anon_sym_protected] = ACTIONS(4625),
    [anon_sym_module] = ACTIONS(4625),
    [anon_sym_any] = ACTIONS(4625),
    [anon_sym_number] = ACTIONS(4625),
    [anon_sym_boolean] = ACTIONS(4625),
    [anon_sym_string] = ACTIONS(4625),
    [anon_sym_symbol] = ACTIONS(4625),
    [sym_readonly] = ACTIONS(4625),
  },
  [1631] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_RBRACK] = ACTIONS(3997),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(4000),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1632] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(3994),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(3994),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1633] = {
    [sym_arguments] = STATE(1681),
    [sym_identifier] = ACTIONS(4633),
    [anon_sym_export] = ACTIONS(4633),
    [anon_sym_STAR] = ACTIONS(4635),
    [anon_sym_namespace] = ACTIONS(4633),
    [anon_sym_LBRACE] = ACTIONS(4635),
    [anon_sym_RBRACE] = ACTIONS(4635),
    [anon_sym_type] = ACTIONS(4633),
    [anon_sym_LPAREN] = ACTIONS(4629),
    [anon_sym_LBRACK] = ACTIONS(4635),
    [anon_sym_DOT] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4633),
    [anon_sym_async] = ACTIONS(4633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4635),
    [anon_sym_void] = ACTIONS(4633),
    [anon_sym_DQUOTE] = ACTIONS(4635),
    [anon_sym_SQUOTE] = ACTIONS(4635),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4635),
    [sym_this] = ACTIONS(4633),
    [anon_sym_AT] = ACTIONS(4635),
    [anon_sym_static] = ACTIONS(4633),
    [anon_sym_abstract] = ACTIONS(4633),
    [anon_sym_get] = ACTIONS(4633),
    [anon_sym_set] = ACTIONS(4633),
    [anon_sym_declare] = ACTIONS(4633),
    [anon_sym_public] = ACTIONS(4633),
    [anon_sym_private] = ACTIONS(4633),
    [anon_sym_protected] = ACTIONS(4633),
    [anon_sym_module] = ACTIONS(4633),
    [anon_sym_any] = ACTIONS(4633),
    [anon_sym_number] = ACTIONS(4633),
    [anon_sym_boolean] = ACTIONS(4633),
    [anon_sym_string] = ACTIONS(4633),
    [anon_sym_symbol] = ACTIONS(4633),
    [sym_readonly] = ACTIONS(4633),
  },
  [1634] = {
    [sym_string] = STATE(2054),
    [sym__property_name] = STATE(2054),
    [sym_computed_property_name] = STATE(2054),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4559),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1635] = {
    [sym_string] = STATE(2037),
    [sym__property_name] = STATE(2037),
    [sym_computed_property_name] = STATE(2037),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4573),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1636] = {
    [sym_string] = STATE(1986),
    [sym__property_name] = STATE(1986),
    [sym_computed_property_name] = STATE(1986),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4617),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1637] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(4639),
    [anon_sym_RBRACE] = ACTIONS(4639),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym_readonly] = ACTIONS(2494),
  },
  [1638] = {
    [sym_string] = STATE(2045),
    [sym__property_name] = STATE(2045),
    [sym_computed_property_name] = STATE(2045),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4567),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1639] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_decorator] = STATE(1762),
    [sym_rest_parameter] = STATE(2363),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2363),
    [sym_optional_parameter] = STATE(2363),
    [sym__parameter_name] = STATE(1975),
    [aux_sym_export_statement_repeat1] = STATE(1662),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(4641),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4621),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(811),
  },
  [1640] = {
    [sym_string] = STATE(1998),
    [sym__property_name] = STATE(1998),
    [sym_computed_property_name] = STATE(1998),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4601),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1641] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_decorator] = STATE(1762),
    [sym_rest_parameter] = STATE(2548),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2548),
    [sym_optional_parameter] = STATE(2548),
    [sym__parameter_name] = STATE(1975),
    [aux_sym_export_statement_repeat1] = STATE(1663),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(4643),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4621),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(811),
  },
  [1642] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_decorator] = STATE(1762),
    [sym_rest_parameter] = STATE(2492),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2492),
    [sym_optional_parameter] = STATE(2492),
    [sym__parameter_name] = STATE(1975),
    [aux_sym_export_statement_repeat1] = STATE(1727),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(4645),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4621),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(811),
  },
  [1643] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_decorator] = STATE(1762),
    [sym_rest_parameter] = STATE(2548),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2548),
    [sym_optional_parameter] = STATE(2548),
    [sym__parameter_name] = STATE(1975),
    [aux_sym_export_statement_repeat1] = STATE(1663),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(4647),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4621),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(811),
  },
  [1644] = {
    [sym_string] = STATE(2049),
    [sym__property_name] = STATE(2049),
    [sym_computed_property_name] = STATE(2049),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4611),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1645] = {
    [sym_string] = STATE(1993),
    [sym__property_name] = STATE(1993),
    [sym_computed_property_name] = STATE(1993),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4649),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1646] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1647] = {
    [sym_string] = STATE(2038),
    [sym__property_name] = STATE(2038),
    [sym_computed_property_name] = STATE(2038),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4651),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1648] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_decorator] = STATE(1762),
    [sym_rest_parameter] = STATE(2459),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2459),
    [sym_optional_parameter] = STATE(2459),
    [sym__parameter_name] = STATE(1975),
    [aux_sym_export_statement_repeat1] = STATE(1666),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4621),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(811),
  },
  [1649] = {
    [sym_string] = STATE(2036),
    [sym__property_name] = STATE(2036),
    [sym_computed_property_name] = STATE(2036),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4595),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1650] = {
    [sym_string] = STATE(2035),
    [sym__property_name] = STATE(2035),
    [sym_computed_property_name] = STATE(2035),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4591),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1651] = {
    [sym_string] = STATE(2067),
    [sym__property_name] = STATE(2067),
    [sym_computed_property_name] = STATE(2067),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4585),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1652] = {
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(2543),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(3552),
    [anon_sym_RBRACE] = ACTIONS(3552),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2541),
    [anon_sym_DQUOTE] = ACTIONS(2543),
    [anon_sym_SQUOTE] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2543),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1653] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_decorator] = STATE(1762),
    [sym_rest_parameter] = STATE(2548),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2548),
    [sym_optional_parameter] = STATE(2548),
    [sym__parameter_name] = STATE(1975),
    [aux_sym_export_statement_repeat1] = STATE(1663),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(4653),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4621),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(811),
  },
  [1654] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3625),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(4369),
    [anon_sym_of] = ACTIONS(4372),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1655] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1656] = {
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(3613),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(4362),
    [anon_sym_of] = ACTIONS(4365),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
  },
  [1657] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_decorator] = STATE(1762),
    [sym_rest_parameter] = STATE(2548),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2548),
    [sym_optional_parameter] = STATE(2548),
    [sym__parameter_name] = STATE(1975),
    [aux_sym_export_statement_repeat1] = STATE(1663),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(4655),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4621),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(811),
  },
  [1658] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_decorator] = STATE(1762),
    [sym_rest_parameter] = STATE(2548),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2548),
    [sym_optional_parameter] = STATE(2548),
    [sym__parameter_name] = STATE(1975),
    [aux_sym_export_statement_repeat1] = STATE(1663),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4621),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(811),
  },
  [1659] = {
    [sym_identifier] = ACTIONS(4659),
    [anon_sym_export] = ACTIONS(4659),
    [anon_sym_STAR] = ACTIONS(4661),
    [anon_sym_namespace] = ACTIONS(4659),
    [anon_sym_LBRACE] = ACTIONS(4661),
    [anon_sym_RBRACE] = ACTIONS(4661),
    [anon_sym_type] = ACTIONS(4659),
    [anon_sym_LPAREN] = ACTIONS(4661),
    [anon_sym_LBRACK] = ACTIONS(4661),
    [anon_sym_DOT] = ACTIONS(4659),
    [anon_sym_class] = ACTIONS(4659),
    [anon_sym_async] = ACTIONS(4659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4661),
    [anon_sym_void] = ACTIONS(4659),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [anon_sym_SQUOTE] = ACTIONS(4661),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4661),
    [sym_this] = ACTIONS(4659),
    [anon_sym_AT] = ACTIONS(4661),
    [anon_sym_static] = ACTIONS(4659),
    [anon_sym_abstract] = ACTIONS(4659),
    [anon_sym_get] = ACTIONS(4659),
    [anon_sym_set] = ACTIONS(4659),
    [anon_sym_declare] = ACTIONS(4659),
    [anon_sym_public] = ACTIONS(4659),
    [anon_sym_private] = ACTIONS(4659),
    [anon_sym_protected] = ACTIONS(4659),
    [anon_sym_module] = ACTIONS(4659),
    [anon_sym_any] = ACTIONS(4659),
    [anon_sym_number] = ACTIONS(4659),
    [anon_sym_boolean] = ACTIONS(4659),
    [anon_sym_string] = ACTIONS(4659),
    [anon_sym_symbol] = ACTIONS(4659),
    [sym_readonly] = ACTIONS(4659),
  },
  [1660] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1661] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(4639),
    [anon_sym_RBRACE] = ACTIONS(4639),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1662] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_decorator] = STATE(1762),
    [sym_rest_parameter] = STATE(2458),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2458),
    [sym_optional_parameter] = STATE(2458),
    [sym__parameter_name] = STATE(1975),
    [aux_sym_export_statement_repeat1] = STATE(1727),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4621),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(811),
  },
  [1663] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_decorator] = STATE(1762),
    [sym_rest_parameter] = STATE(2661),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2661),
    [sym_optional_parameter] = STATE(2661),
    [sym__parameter_name] = STATE(1975),
    [aux_sym_export_statement_repeat1] = STATE(1727),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4621),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(811),
  },
  [1664] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1665] = {
    [sym_identifier] = ACTIONS(4663),
    [anon_sym_export] = ACTIONS(4663),
    [anon_sym_STAR] = ACTIONS(4665),
    [anon_sym_namespace] = ACTIONS(4663),
    [anon_sym_LBRACE] = ACTIONS(4665),
    [anon_sym_RBRACE] = ACTIONS(4665),
    [anon_sym_type] = ACTIONS(4663),
    [anon_sym_LPAREN] = ACTIONS(4665),
    [anon_sym_LBRACK] = ACTIONS(4665),
    [anon_sym_DOT] = ACTIONS(4663),
    [anon_sym_class] = ACTIONS(4663),
    [anon_sym_async] = ACTIONS(4663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4665),
    [anon_sym_void] = ACTIONS(4663),
    [anon_sym_DQUOTE] = ACTIONS(4665),
    [anon_sym_SQUOTE] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4665),
    [sym_this] = ACTIONS(4663),
    [anon_sym_AT] = ACTIONS(4665),
    [anon_sym_static] = ACTIONS(4663),
    [anon_sym_abstract] = ACTIONS(4663),
    [anon_sym_get] = ACTIONS(4663),
    [anon_sym_set] = ACTIONS(4663),
    [anon_sym_declare] = ACTIONS(4663),
    [anon_sym_public] = ACTIONS(4663),
    [anon_sym_private] = ACTIONS(4663),
    [anon_sym_protected] = ACTIONS(4663),
    [anon_sym_module] = ACTIONS(4663),
    [anon_sym_any] = ACTIONS(4663),
    [anon_sym_number] = ACTIONS(4663),
    [anon_sym_boolean] = ACTIONS(4663),
    [anon_sym_string] = ACTIONS(4663),
    [anon_sym_symbol] = ACTIONS(4663),
    [sym_readonly] = ACTIONS(4663),
  },
  [1666] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_decorator] = STATE(1762),
    [sym_rest_parameter] = STATE(2492),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2492),
    [sym_optional_parameter] = STATE(2492),
    [sym__parameter_name] = STATE(1975),
    [aux_sym_export_statement_repeat1] = STATE(1727),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4621),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(811),
  },
  [1667] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1668] = {
    [sym_object] = STATE(2093),
    [sym_array] = STATE(2097),
    [sym_decorator] = STATE(1762),
    [sym_rest_parameter] = STATE(2548),
    [sym_accessibility_modifier] = STATE(1778),
    [sym_required_parameter] = STATE(2548),
    [sym_optional_parameter] = STATE(2548),
    [sym__parameter_name] = STATE(1975),
    [aux_sym_export_statement_repeat1] = STATE(1663),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4621),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2529),
    [anon_sym_private] = ACTIONS(2529),
    [anon_sym_protected] = ACTIONS(2529),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(811),
  },
  [1669] = {
    [aux_sym_object_repeat1] = STATE(2399),
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(2543),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2541),
    [anon_sym_DQUOTE] = ACTIONS(2543),
    [anon_sym_SQUOTE] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2543),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
  },
  [1670] = {
    [sym__declaration] = STATE(2077),
    [sym_variable_declaration] = STATE(2077),
    [sym_lexical_declaration] = STATE(2077),
    [sym_class_declaration] = STATE(2077),
    [sym_function_declaration] = STATE(2077),
    [sym_generator_function_declaration] = STATE(2077),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(2077),
    [sym_ambient_declaration] = STATE(2077),
    [sym_abstract_class_declaration] = STATE(2077),
    [sym_module] = STATE(2077),
    [sym_internal_module] = STATE(2077),
    [sym_import_alias] = STATE(2077),
    [sym_interface_declaration] = STATE(2077),
    [sym_enum_declaration] = STATE(2077),
    [sym_type_alias_declaration] = STATE(2077),
    [aux_sym_export_statement_repeat1] = STATE(2277),
    [anon_sym_namespace] = ACTIONS(3486),
    [anon_sym_type] = ACTIONS(3490),
    [anon_sym_import] = ACTIONS(3492),
    [anon_sym_var] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3496),
    [anon_sym_const] = ACTIONS(3498),
    [anon_sym_class] = ACTIONS(3500),
    [anon_sym_async] = ACTIONS(3502),
    [anon_sym_function] = ACTIONS(3504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3506),
    [anon_sym_declare] = ACTIONS(3508),
    [anon_sym_module] = ACTIONS(4667),
    [anon_sym_global] = ACTIONS(4669),
    [anon_sym_interface] = ACTIONS(3512),
    [anon_sym_enum] = ACTIONS(3514),
  },
  [1671] = {
    [aux_sym_object_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(2543),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2541),
    [anon_sym_DQUOTE] = ACTIONS(2543),
    [anon_sym_SQUOTE] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2543),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
  },
  [1672] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(4639),
    [anon_sym_RBRACE] = ACTIONS(4639),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1673] = {
    [sym__declaration] = STATE(577),
    [sym_variable_declaration] = STATE(577),
    [sym_lexical_declaration] = STATE(577),
    [sym_class_declaration] = STATE(577),
    [sym_function_declaration] = STATE(577),
    [sym_generator_function_declaration] = STATE(577),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(577),
    [sym_abstract_class_declaration] = STATE(577),
    [sym_module] = STATE(577),
    [sym_internal_module] = STATE(577),
    [sym_import_alias] = STATE(577),
    [sym_interface_declaration] = STATE(577),
    [sym_enum_declaration] = STATE(577),
    [sym_type_alias_declaration] = STATE(577),
    [aux_sym_export_statement_repeat1] = STATE(2356),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_type] = ACTIONS(1343),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1358),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(1362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1364),
    [anon_sym_declare] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1438),
    [anon_sym_global] = ACTIONS(1440),
    [anon_sym_interface] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1372),
  },
  [1674] = {
    [sym__declaration] = STATE(577),
    [sym_variable_declaration] = STATE(577),
    [sym_lexical_declaration] = STATE(577),
    [sym_class_declaration] = STATE(577),
    [sym_function_declaration] = STATE(577),
    [sym_generator_function_declaration] = STATE(577),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(577),
    [sym_abstract_class_declaration] = STATE(577),
    [sym_module] = STATE(577),
    [sym_internal_module] = STATE(577),
    [sym_import_alias] = STATE(577),
    [sym_interface_declaration] = STATE(577),
    [sym_enum_declaration] = STATE(577),
    [sym_type_alias_declaration] = STATE(577),
    [aux_sym_export_statement_repeat1] = STATE(2331),
    [anon_sym_namespace] = ACTIONS(1424),
    [anon_sym_type] = ACTIONS(1343),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1428),
    [anon_sym_function] = ACTIONS(1430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1432),
    [anon_sym_declare] = ACTIONS(1434),
    [anon_sym_module] = ACTIONS(2270),
    [anon_sym_global] = ACTIONS(1440),
    [anon_sym_interface] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1372),
  },
  [1675] = {
    [sym__declaration] = STATE(549),
    [sym_variable_declaration] = STATE(549),
    [sym_lexical_declaration] = STATE(549),
    [sym_class_declaration] = STATE(549),
    [sym_function_declaration] = STATE(549),
    [sym_generator_function_declaration] = STATE(549),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(549),
    [sym_ambient_declaration] = STATE(549),
    [sym_abstract_class_declaration] = STATE(549),
    [sym_module] = STATE(549),
    [sym_internal_module] = STATE(549),
    [sym_import_alias] = STATE(549),
    [sym_interface_declaration] = STATE(549),
    [sym_enum_declaration] = STATE(549),
    [sym_type_alias_declaration] = STATE(549),
    [aux_sym_export_statement_repeat1] = STATE(2331),
    [anon_sym_default] = ACTIONS(4671),
    [anon_sym_namespace] = ACTIONS(1424),
    [anon_sym_type] = ACTIONS(1343),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1428),
    [anon_sym_function] = ACTIONS(1430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1432),
    [anon_sym_declare] = ACTIONS(1434),
    [anon_sym_module] = ACTIONS(1436),
    [anon_sym_interface] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1372),
  },
  [1676] = {
    [sym__declaration] = STATE(2199),
    [sym_variable_declaration] = STATE(2199),
    [sym_lexical_declaration] = STATE(2199),
    [sym_class_declaration] = STATE(2199),
    [sym_function_declaration] = STATE(2199),
    [sym_generator_function_declaration] = STATE(2199),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(2199),
    [sym_ambient_declaration] = STATE(2199),
    [sym_abstract_class_declaration] = STATE(2199),
    [sym_module] = STATE(2199),
    [sym_internal_module] = STATE(2199),
    [sym_import_alias] = STATE(2199),
    [sym_interface_declaration] = STATE(2199),
    [sym_enum_declaration] = STATE(2199),
    [sym_type_alias_declaration] = STATE(2199),
    [aux_sym_export_statement_repeat1] = STATE(2277),
    [anon_sym_default] = ACTIONS(4673),
    [anon_sym_namespace] = ACTIONS(3486),
    [anon_sym_type] = ACTIONS(3490),
    [anon_sym_import] = ACTIONS(3492),
    [anon_sym_var] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3496),
    [anon_sym_const] = ACTIONS(3498),
    [anon_sym_class] = ACTIONS(3500),
    [anon_sym_async] = ACTIONS(3502),
    [anon_sym_function] = ACTIONS(3504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3506),
    [anon_sym_declare] = ACTIONS(3508),
    [anon_sym_module] = ACTIONS(3510),
    [anon_sym_interface] = ACTIONS(3512),
    [anon_sym_enum] = ACTIONS(3514),
  },
  [1677] = {
    [aux_sym_object_repeat1] = STATE(2484),
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(2543),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2541),
    [anon_sym_DQUOTE] = ACTIONS(2543),
    [anon_sym_SQUOTE] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2543),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
  },
  [1678] = {
    [sym__declaration] = STATE(549),
    [sym_variable_declaration] = STATE(549),
    [sym_lexical_declaration] = STATE(549),
    [sym_class_declaration] = STATE(549),
    [sym_function_declaration] = STATE(549),
    [sym_generator_function_declaration] = STATE(549),
    [sym_decorator] = STATE(1762),
    [sym_function_signature] = STATE(549),
    [sym_ambient_declaration] = STATE(549),
    [sym_abstract_class_declaration] = STATE(549),
    [sym_module] = STATE(549),
    [sym_internal_module] = STATE(549),
    [sym_import_alias] = STATE(549),
    [sym_interface_declaration] = STATE(549),
    [sym_enum_declaration] = STATE(549),
    [sym_type_alias_declaration] = STATE(549),
    [aux_sym_export_statement_repeat1] = STATE(2356),
    [anon_sym_default] = ACTIONS(4671),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_type] = ACTIONS(1343),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1358),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(1362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1364),
    [anon_sym_declare] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1368),
    [anon_sym_interface] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1372),
  },
  [1679] = {
    [sym_identifier] = ACTIONS(3607),
    [anon_sym_export] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3605),
    [anon_sym_namespace] = ACTIONS(3607),
    [anon_sym_LBRACE] = ACTIONS(3605),
    [anon_sym_RBRACE] = ACTIONS(3605),
    [anon_sym_type] = ACTIONS(3607),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_class] = ACTIONS(3607),
    [anon_sym_async] = ACTIONS(3607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3605),
    [anon_sym_void] = ACTIONS(3607),
    [anon_sym_DQUOTE] = ACTIONS(3605),
    [anon_sym_SQUOTE] = ACTIONS(3605),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3605),
    [sym_this] = ACTIONS(3607),
    [anon_sym_AT] = ACTIONS(3605),
    [anon_sym_static] = ACTIONS(3607),
    [anon_sym_abstract] = ACTIONS(3607),
    [anon_sym_get] = ACTIONS(3607),
    [anon_sym_set] = ACTIONS(3607),
    [anon_sym_declare] = ACTIONS(3607),
    [anon_sym_public] = ACTIONS(3607),
    [anon_sym_private] = ACTIONS(3607),
    [anon_sym_protected] = ACTIONS(3607),
    [anon_sym_module] = ACTIONS(3607),
    [anon_sym_any] = ACTIONS(3607),
    [anon_sym_number] = ACTIONS(3607),
    [anon_sym_boolean] = ACTIONS(3607),
    [anon_sym_string] = ACTIONS(3607),
    [anon_sym_symbol] = ACTIONS(3607),
    [sym_readonly] = ACTIONS(3607),
  },
  [1680] = {
    [sym_identifier] = ACTIONS(4675),
    [anon_sym_export] = ACTIONS(4675),
    [anon_sym_STAR] = ACTIONS(4677),
    [anon_sym_namespace] = ACTIONS(4675),
    [anon_sym_LBRACE] = ACTIONS(4677),
    [anon_sym_RBRACE] = ACTIONS(4677),
    [anon_sym_type] = ACTIONS(4675),
    [anon_sym_LBRACK] = ACTIONS(4677),
    [anon_sym_class] = ACTIONS(4675),
    [anon_sym_async] = ACTIONS(4675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4677),
    [anon_sym_void] = ACTIONS(4675),
    [anon_sym_DQUOTE] = ACTIONS(4677),
    [anon_sym_SQUOTE] = ACTIONS(4677),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4677),
    [sym_this] = ACTIONS(4675),
    [anon_sym_AT] = ACTIONS(4677),
    [anon_sym_static] = ACTIONS(4675),
    [anon_sym_abstract] = ACTIONS(4675),
    [anon_sym_get] = ACTIONS(4675),
    [anon_sym_set] = ACTIONS(4675),
    [anon_sym_declare] = ACTIONS(4675),
    [anon_sym_public] = ACTIONS(4675),
    [anon_sym_private] = ACTIONS(4675),
    [anon_sym_protected] = ACTIONS(4675),
    [anon_sym_module] = ACTIONS(4675),
    [anon_sym_any] = ACTIONS(4675),
    [anon_sym_number] = ACTIONS(4675),
    [anon_sym_boolean] = ACTIONS(4675),
    [anon_sym_string] = ACTIONS(4675),
    [anon_sym_symbol] = ACTIONS(4675),
    [sym_readonly] = ACTIONS(4675),
  },
  [1681] = {
    [sym_identifier] = ACTIONS(4679),
    [anon_sym_export] = ACTIONS(4679),
    [anon_sym_STAR] = ACTIONS(4681),
    [anon_sym_namespace] = ACTIONS(4679),
    [anon_sym_LBRACE] = ACTIONS(4681),
    [anon_sym_RBRACE] = ACTIONS(4681),
    [anon_sym_type] = ACTIONS(4679),
    [anon_sym_LBRACK] = ACTIONS(4681),
    [anon_sym_class] = ACTIONS(4679),
    [anon_sym_async] = ACTIONS(4679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4681),
    [anon_sym_void] = ACTIONS(4679),
    [anon_sym_DQUOTE] = ACTIONS(4681),
    [anon_sym_SQUOTE] = ACTIONS(4681),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4681),
    [sym_this] = ACTIONS(4679),
    [anon_sym_AT] = ACTIONS(4681),
    [anon_sym_static] = ACTIONS(4679),
    [anon_sym_abstract] = ACTIONS(4679),
    [anon_sym_get] = ACTIONS(4679),
    [anon_sym_set] = ACTIONS(4679),
    [anon_sym_declare] = ACTIONS(4679),
    [anon_sym_public] = ACTIONS(4679),
    [anon_sym_private] = ACTIONS(4679),
    [anon_sym_protected] = ACTIONS(4679),
    [anon_sym_module] = ACTIONS(4679),
    [anon_sym_any] = ACTIONS(4679),
    [anon_sym_number] = ACTIONS(4679),
    [anon_sym_boolean] = ACTIONS(4679),
    [anon_sym_string] = ACTIONS(4679),
    [anon_sym_symbol] = ACTIONS(4679),
    [sym_readonly] = ACTIONS(4679),
  },
  [1682] = {
    [sym_identifier] = ACTIONS(3611),
    [anon_sym_export] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3609),
    [anon_sym_namespace] = ACTIONS(3611),
    [anon_sym_LBRACE] = ACTIONS(3609),
    [anon_sym_RBRACE] = ACTIONS(3609),
    [anon_sym_type] = ACTIONS(3611),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_class] = ACTIONS(3611),
    [anon_sym_async] = ACTIONS(3611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_void] = ACTIONS(3611),
    [anon_sym_DQUOTE] = ACTIONS(3609),
    [anon_sym_SQUOTE] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3609),
    [sym_this] = ACTIONS(3611),
    [anon_sym_AT] = ACTIONS(3609),
    [anon_sym_static] = ACTIONS(3611),
    [anon_sym_abstract] = ACTIONS(3611),
    [anon_sym_get] = ACTIONS(3611),
    [anon_sym_set] = ACTIONS(3611),
    [anon_sym_declare] = ACTIONS(3611),
    [anon_sym_public] = ACTIONS(3611),
    [anon_sym_private] = ACTIONS(3611),
    [anon_sym_protected] = ACTIONS(3611),
    [anon_sym_module] = ACTIONS(3611),
    [anon_sym_any] = ACTIONS(3611),
    [anon_sym_number] = ACTIONS(3611),
    [anon_sym_boolean] = ACTIONS(3611),
    [anon_sym_string] = ACTIONS(3611),
    [anon_sym_symbol] = ACTIONS(3611),
    [sym_readonly] = ACTIONS(3611),
  },
  [1683] = {
    [sym_identifier] = ACTIONS(3317),
    [anon_sym_export] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(3319),
    [anon_sym_namespace] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(3319),
    [anon_sym_RBRACE] = ACTIONS(3319),
    [anon_sym_type] = ACTIONS(3317),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3317),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3319),
    [anon_sym_void] = ACTIONS(3317),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3319),
    [sym_this] = ACTIONS(3317),
    [anon_sym_AT] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3317),
    [anon_sym_abstract] = ACTIONS(3317),
    [anon_sym_get] = ACTIONS(3317),
    [anon_sym_set] = ACTIONS(3317),
    [anon_sym_declare] = ACTIONS(3317),
    [anon_sym_public] = ACTIONS(3317),
    [anon_sym_private] = ACTIONS(3317),
    [anon_sym_protected] = ACTIONS(3317),
    [anon_sym_module] = ACTIONS(3317),
    [anon_sym_any] = ACTIONS(3317),
    [anon_sym_number] = ACTIONS(3317),
    [anon_sym_boolean] = ACTIONS(3317),
    [anon_sym_string] = ACTIONS(3317),
    [anon_sym_symbol] = ACTIONS(3317),
    [sym_readonly] = ACTIONS(3317),
  },
  [1684] = {
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(2543),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(4639),
    [anon_sym_RBRACE] = ACTIONS(4639),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2541),
    [anon_sym_DQUOTE] = ACTIONS(2543),
    [anon_sym_SQUOTE] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2543),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
  },
  [1685] = {
    [sym_identifier] = ACTIONS(4633),
    [anon_sym_export] = ACTIONS(4633),
    [anon_sym_STAR] = ACTIONS(4635),
    [anon_sym_namespace] = ACTIONS(4633),
    [anon_sym_LBRACE] = ACTIONS(4635),
    [anon_sym_RBRACE] = ACTIONS(4635),
    [anon_sym_type] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4635),
    [anon_sym_class] = ACTIONS(4633),
    [anon_sym_async] = ACTIONS(4633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4635),
    [anon_sym_void] = ACTIONS(4633),
    [anon_sym_DQUOTE] = ACTIONS(4635),
    [anon_sym_SQUOTE] = ACTIONS(4635),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4635),
    [sym_this] = ACTIONS(4633),
    [anon_sym_AT] = ACTIONS(4635),
    [anon_sym_static] = ACTIONS(4633),
    [anon_sym_abstract] = ACTIONS(4633),
    [anon_sym_get] = ACTIONS(4633),
    [anon_sym_set] = ACTIONS(4633),
    [anon_sym_declare] = ACTIONS(4633),
    [anon_sym_public] = ACTIONS(4633),
    [anon_sym_private] = ACTIONS(4633),
    [anon_sym_protected] = ACTIONS(4633),
    [anon_sym_module] = ACTIONS(4633),
    [anon_sym_any] = ACTIONS(4633),
    [anon_sym_number] = ACTIONS(4633),
    [anon_sym_boolean] = ACTIONS(4633),
    [anon_sym_string] = ACTIONS(4633),
    [anon_sym_symbol] = ACTIONS(4633),
    [sym_readonly] = ACTIONS(4633),
  },
  [1686] = {
    [sym_string] = STATE(2011),
    [sym__property_name] = STATE(2011),
    [sym_computed_property_name] = STATE(2011),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4683),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(4685),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4687),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4689),
    [anon_sym_set] = ACTIONS(4689),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym_readonly] = ACTIONS(4691),
  },
  [1687] = {
    [sym_identifier] = ACTIONS(4693),
    [anon_sym_export] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4695),
    [anon_sym_namespace] = ACTIONS(4693),
    [anon_sym_RBRACE] = ACTIONS(4695),
    [anon_sym_type] = ACTIONS(4693),
    [anon_sym_SEMI] = ACTIONS(4695),
    [anon_sym_LBRACK] = ACTIONS(4695),
    [anon_sym_async] = ACTIONS(4693),
    [anon_sym_void] = ACTIONS(4693),
    [anon_sym_DQUOTE] = ACTIONS(4695),
    [anon_sym_SQUOTE] = ACTIONS(4695),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4695),
    [anon_sym_AT] = ACTIONS(4695),
    [anon_sym_static] = ACTIONS(4693),
    [anon_sym_abstract] = ACTIONS(4693),
    [anon_sym_get] = ACTIONS(4693),
    [anon_sym_set] = ACTIONS(4693),
    [anon_sym_declare] = ACTIONS(4693),
    [anon_sym_public] = ACTIONS(4693),
    [anon_sym_private] = ACTIONS(4693),
    [anon_sym_protected] = ACTIONS(4693),
    [anon_sym_module] = ACTIONS(4693),
    [anon_sym_any] = ACTIONS(4693),
    [anon_sym_number] = ACTIONS(4693),
    [anon_sym_boolean] = ACTIONS(4693),
    [anon_sym_string] = ACTIONS(4693),
    [anon_sym_symbol] = ACTIONS(4693),
    [sym_readonly] = ACTIONS(4693),
    [sym__automatic_semicolon] = ACTIONS(4695),
  },
  [1688] = {
    [sym_string] = STATE(2004),
    [sym__property_name] = STATE(2004),
    [sym_computed_property_name] = STATE(2004),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4697),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4699),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4701),
    [anon_sym_set] = ACTIONS(4701),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1689] = {
    [sym_identifier] = ACTIONS(4703),
    [anon_sym_export] = ACTIONS(4703),
    [anon_sym_STAR] = ACTIONS(4705),
    [anon_sym_namespace] = ACTIONS(4703),
    [anon_sym_RBRACE] = ACTIONS(4705),
    [anon_sym_type] = ACTIONS(4703),
    [anon_sym_SEMI] = ACTIONS(4705),
    [anon_sym_LBRACK] = ACTIONS(4705),
    [anon_sym_async] = ACTIONS(4703),
    [anon_sym_void] = ACTIONS(4703),
    [anon_sym_DQUOTE] = ACTIONS(4705),
    [anon_sym_SQUOTE] = ACTIONS(4705),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4705),
    [anon_sym_AT] = ACTIONS(4705),
    [anon_sym_static] = ACTIONS(4703),
    [anon_sym_abstract] = ACTIONS(4703),
    [anon_sym_get] = ACTIONS(4703),
    [anon_sym_set] = ACTIONS(4703),
    [anon_sym_declare] = ACTIONS(4703),
    [anon_sym_public] = ACTIONS(4703),
    [anon_sym_private] = ACTIONS(4703),
    [anon_sym_protected] = ACTIONS(4703),
    [anon_sym_module] = ACTIONS(4703),
    [anon_sym_any] = ACTIONS(4703),
    [anon_sym_number] = ACTIONS(4703),
    [anon_sym_boolean] = ACTIONS(4703),
    [anon_sym_string] = ACTIONS(4703),
    [anon_sym_symbol] = ACTIONS(4703),
    [sym_readonly] = ACTIONS(4703),
    [sym__automatic_semicolon] = ACTIONS(4705),
  },
  [1690] = {
    [sym_identifier] = ACTIONS(4707),
    [anon_sym_export] = ACTIONS(4707),
    [anon_sym_STAR] = ACTIONS(4709),
    [anon_sym_namespace] = ACTIONS(4707),
    [anon_sym_RBRACE] = ACTIONS(4709),
    [anon_sym_type] = ACTIONS(4707),
    [anon_sym_SEMI] = ACTIONS(4711),
    [anon_sym_LBRACK] = ACTIONS(4709),
    [anon_sym_async] = ACTIONS(4707),
    [anon_sym_void] = ACTIONS(4707),
    [anon_sym_DQUOTE] = ACTIONS(4709),
    [anon_sym_SQUOTE] = ACTIONS(4709),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4709),
    [anon_sym_AT] = ACTIONS(4709),
    [anon_sym_static] = ACTIONS(4707),
    [anon_sym_abstract] = ACTIONS(4707),
    [anon_sym_get] = ACTIONS(4707),
    [anon_sym_set] = ACTIONS(4707),
    [anon_sym_declare] = ACTIONS(4707),
    [anon_sym_public] = ACTIONS(4707),
    [anon_sym_private] = ACTIONS(4707),
    [anon_sym_protected] = ACTIONS(4707),
    [anon_sym_module] = ACTIONS(4707),
    [anon_sym_any] = ACTIONS(4707),
    [anon_sym_number] = ACTIONS(4707),
    [anon_sym_boolean] = ACTIONS(4707),
    [anon_sym_string] = ACTIONS(4707),
    [anon_sym_symbol] = ACTIONS(4707),
    [sym_readonly] = ACTIONS(4707),
    [sym__automatic_semicolon] = ACTIONS(4711),
  },
  [1691] = {
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_export] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1115),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_RBRACE] = ACTIONS(1115),
    [anon_sym_type] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1115),
    [anon_sym_LBRACK] = ACTIONS(1115),
    [anon_sym_async] = ACTIONS(1117),
    [anon_sym_void] = ACTIONS(1117),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1115),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1115),
    [anon_sym_AT] = ACTIONS(1115),
    [anon_sym_static] = ACTIONS(1117),
    [anon_sym_abstract] = ACTIONS(1117),
    [anon_sym_get] = ACTIONS(1117),
    [anon_sym_set] = ACTIONS(1117),
    [anon_sym_declare] = ACTIONS(1117),
    [anon_sym_public] = ACTIONS(1117),
    [anon_sym_private] = ACTIONS(1117),
    [anon_sym_protected] = ACTIONS(1117),
    [anon_sym_module] = ACTIONS(1117),
    [anon_sym_any] = ACTIONS(1117),
    [anon_sym_number] = ACTIONS(1117),
    [anon_sym_boolean] = ACTIONS(1117),
    [anon_sym_string] = ACTIONS(1117),
    [anon_sym_symbol] = ACTIONS(1117),
    [sym_readonly] = ACTIONS(1117),
    [sym__automatic_semicolon] = ACTIONS(1115),
  },
  [1692] = {
    [sym_identifier] = ACTIONS(4713),
    [anon_sym_export] = ACTIONS(4713),
    [anon_sym_STAR] = ACTIONS(4715),
    [anon_sym_namespace] = ACTIONS(4713),
    [anon_sym_RBRACE] = ACTIONS(4715),
    [anon_sym_type] = ACTIONS(4713),
    [anon_sym_SEMI] = ACTIONS(4715),
    [anon_sym_LBRACK] = ACTIONS(4715),
    [anon_sym_async] = ACTIONS(4713),
    [anon_sym_void] = ACTIONS(4713),
    [anon_sym_DQUOTE] = ACTIONS(4715),
    [anon_sym_SQUOTE] = ACTIONS(4715),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4715),
    [anon_sym_AT] = ACTIONS(4715),
    [anon_sym_static] = ACTIONS(4713),
    [anon_sym_abstract] = ACTIONS(4713),
    [anon_sym_get] = ACTIONS(4713),
    [anon_sym_set] = ACTIONS(4713),
    [anon_sym_declare] = ACTIONS(4713),
    [anon_sym_public] = ACTIONS(4713),
    [anon_sym_private] = ACTIONS(4713),
    [anon_sym_protected] = ACTIONS(4713),
    [anon_sym_module] = ACTIONS(4713),
    [anon_sym_any] = ACTIONS(4713),
    [anon_sym_number] = ACTIONS(4713),
    [anon_sym_boolean] = ACTIONS(4713),
    [anon_sym_string] = ACTIONS(4713),
    [anon_sym_symbol] = ACTIONS(4713),
    [sym_readonly] = ACTIONS(4713),
    [sym__automatic_semicolon] = ACTIONS(4715),
  },
  [1693] = {
    [sym_identifier] = ACTIONS(4717),
    [anon_sym_export] = ACTIONS(4717),
    [anon_sym_STAR] = ACTIONS(4719),
    [anon_sym_namespace] = ACTIONS(4717),
    [anon_sym_RBRACE] = ACTIONS(4719),
    [anon_sym_type] = ACTIONS(4717),
    [anon_sym_SEMI] = ACTIONS(4719),
    [anon_sym_LBRACK] = ACTIONS(4719),
    [anon_sym_async] = ACTIONS(4717),
    [anon_sym_void] = ACTIONS(4717),
    [anon_sym_DQUOTE] = ACTIONS(4719),
    [anon_sym_SQUOTE] = ACTIONS(4719),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4719),
    [anon_sym_AT] = ACTIONS(4719),
    [anon_sym_static] = ACTIONS(4717),
    [anon_sym_abstract] = ACTIONS(4717),
    [anon_sym_get] = ACTIONS(4717),
    [anon_sym_set] = ACTIONS(4717),
    [anon_sym_declare] = ACTIONS(4717),
    [anon_sym_public] = ACTIONS(4717),
    [anon_sym_private] = ACTIONS(4717),
    [anon_sym_protected] = ACTIONS(4717),
    [anon_sym_module] = ACTIONS(4717),
    [anon_sym_any] = ACTIONS(4717),
    [anon_sym_number] = ACTIONS(4717),
    [anon_sym_boolean] = ACTIONS(4717),
    [anon_sym_string] = ACTIONS(4717),
    [anon_sym_symbol] = ACTIONS(4717),
    [sym_readonly] = ACTIONS(4717),
    [sym__automatic_semicolon] = ACTIONS(4719),
  },
  [1694] = {
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_export] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1199),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_type] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1199),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_abstract] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1201),
    [anon_sym_declare] = ACTIONS(1201),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1201),
    [anon_sym_any] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1201),
    [anon_sym_symbol] = ACTIONS(1201),
    [sym_readonly] = ACTIONS(1201),
    [sym__automatic_semicolon] = ACTIONS(4721),
  },
  [1695] = {
    [sym_identifier] = ACTIONS(1063),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1063),
    [anon_sym_void] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [anon_sym_SQUOTE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1061),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_abstract] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
    [sym_readonly] = ACTIONS(1063),
    [sym__automatic_semicolon] = ACTIONS(4723),
  },
  [1696] = {
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_export] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1199),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_type] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1199),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_abstract] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1201),
    [anon_sym_declare] = ACTIONS(1201),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1201),
    [anon_sym_any] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1201),
    [anon_sym_symbol] = ACTIONS(1201),
    [sym_readonly] = ACTIONS(1201),
    [sym__automatic_semicolon] = ACTIONS(1199),
  },
  [1697] = {
    [sym_identifier] = ACTIONS(4725),
    [anon_sym_export] = ACTIONS(4725),
    [anon_sym_STAR] = ACTIONS(4727),
    [anon_sym_namespace] = ACTIONS(4725),
    [anon_sym_RBRACE] = ACTIONS(4727),
    [anon_sym_type] = ACTIONS(4725),
    [anon_sym_SEMI] = ACTIONS(4727),
    [anon_sym_LBRACK] = ACTIONS(4727),
    [anon_sym_async] = ACTIONS(4725),
    [anon_sym_void] = ACTIONS(4725),
    [anon_sym_DQUOTE] = ACTIONS(4727),
    [anon_sym_SQUOTE] = ACTIONS(4727),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4727),
    [anon_sym_AT] = ACTIONS(4727),
    [anon_sym_static] = ACTIONS(4725),
    [anon_sym_abstract] = ACTIONS(4725),
    [anon_sym_get] = ACTIONS(4725),
    [anon_sym_set] = ACTIONS(4725),
    [anon_sym_declare] = ACTIONS(4725),
    [anon_sym_public] = ACTIONS(4725),
    [anon_sym_private] = ACTIONS(4725),
    [anon_sym_protected] = ACTIONS(4725),
    [anon_sym_module] = ACTIONS(4725),
    [anon_sym_any] = ACTIONS(4725),
    [anon_sym_number] = ACTIONS(4725),
    [anon_sym_boolean] = ACTIONS(4725),
    [anon_sym_string] = ACTIONS(4725),
    [anon_sym_symbol] = ACTIONS(4725),
    [sym_readonly] = ACTIONS(4725),
    [sym__automatic_semicolon] = ACTIONS(4727),
  },
  [1698] = {
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_export] = ACTIONS(4729),
    [anon_sym_STAR] = ACTIONS(4731),
    [anon_sym_namespace] = ACTIONS(4729),
    [anon_sym_RBRACE] = ACTIONS(4731),
    [anon_sym_type] = ACTIONS(4729),
    [anon_sym_SEMI] = ACTIONS(4731),
    [anon_sym_LBRACK] = ACTIONS(4731),
    [anon_sym_async] = ACTIONS(4729),
    [anon_sym_void] = ACTIONS(4729),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_SQUOTE] = ACTIONS(4731),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4731),
    [anon_sym_AT] = ACTIONS(4731),
    [anon_sym_static] = ACTIONS(4729),
    [anon_sym_abstract] = ACTIONS(4729),
    [anon_sym_get] = ACTIONS(4729),
    [anon_sym_set] = ACTIONS(4729),
    [anon_sym_declare] = ACTIONS(4729),
    [anon_sym_public] = ACTIONS(4729),
    [anon_sym_private] = ACTIONS(4729),
    [anon_sym_protected] = ACTIONS(4729),
    [anon_sym_module] = ACTIONS(4729),
    [anon_sym_any] = ACTIONS(4729),
    [anon_sym_number] = ACTIONS(4729),
    [anon_sym_boolean] = ACTIONS(4729),
    [anon_sym_string] = ACTIONS(4729),
    [anon_sym_symbol] = ACTIONS(4729),
    [sym_readonly] = ACTIONS(4729),
    [sym__automatic_semicolon] = ACTIONS(4731),
  },
  [1699] = {
    [sym_identifier] = ACTIONS(4733),
    [anon_sym_export] = ACTIONS(4733),
    [anon_sym_STAR] = ACTIONS(4735),
    [anon_sym_namespace] = ACTIONS(4733),
    [anon_sym_RBRACE] = ACTIONS(4735),
    [anon_sym_type] = ACTIONS(4733),
    [anon_sym_SEMI] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4735),
    [anon_sym_async] = ACTIONS(4733),
    [anon_sym_void] = ACTIONS(4733),
    [anon_sym_DQUOTE] = ACTIONS(4735),
    [anon_sym_SQUOTE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4735),
    [anon_sym_AT] = ACTIONS(4735),
    [anon_sym_static] = ACTIONS(4733),
    [anon_sym_abstract] = ACTIONS(4733),
    [anon_sym_get] = ACTIONS(4733),
    [anon_sym_set] = ACTIONS(4733),
    [anon_sym_declare] = ACTIONS(4733),
    [anon_sym_public] = ACTIONS(4733),
    [anon_sym_private] = ACTIONS(4733),
    [anon_sym_protected] = ACTIONS(4733),
    [anon_sym_module] = ACTIONS(4733),
    [anon_sym_any] = ACTIONS(4733),
    [anon_sym_number] = ACTIONS(4733),
    [anon_sym_boolean] = ACTIONS(4733),
    [anon_sym_string] = ACTIONS(4733),
    [anon_sym_symbol] = ACTIONS(4733),
    [sym_readonly] = ACTIONS(4733),
    [sym__automatic_semicolon] = ACTIONS(4735),
  },
  [1700] = {
    [sym_string] = STATE(2021),
    [sym__property_name] = STATE(2021),
    [sym_computed_property_name] = STATE(2021),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4737),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4739),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4741),
    [anon_sym_set] = ACTIONS(4741),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1701] = {
    [sym_identifier] = ACTIONS(4743),
    [anon_sym_export] = ACTIONS(4743),
    [anon_sym_STAR] = ACTIONS(4745),
    [anon_sym_namespace] = ACTIONS(4743),
    [anon_sym_RBRACE] = ACTIONS(4745),
    [anon_sym_type] = ACTIONS(4743),
    [anon_sym_SEMI] = ACTIONS(4745),
    [anon_sym_LBRACK] = ACTIONS(4745),
    [anon_sym_async] = ACTIONS(4743),
    [anon_sym_void] = ACTIONS(4743),
    [anon_sym_DQUOTE] = ACTIONS(4745),
    [anon_sym_SQUOTE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4745),
    [anon_sym_AT] = ACTIONS(4745),
    [anon_sym_static] = ACTIONS(4743),
    [anon_sym_abstract] = ACTIONS(4743),
    [anon_sym_get] = ACTIONS(4743),
    [anon_sym_set] = ACTIONS(4743),
    [anon_sym_declare] = ACTIONS(4743),
    [anon_sym_public] = ACTIONS(4743),
    [anon_sym_private] = ACTIONS(4743),
    [anon_sym_protected] = ACTIONS(4743),
    [anon_sym_module] = ACTIONS(4743),
    [anon_sym_any] = ACTIONS(4743),
    [anon_sym_number] = ACTIONS(4743),
    [anon_sym_boolean] = ACTIONS(4743),
    [anon_sym_string] = ACTIONS(4743),
    [anon_sym_symbol] = ACTIONS(4743),
    [sym_readonly] = ACTIONS(4743),
    [sym__automatic_semicolon] = ACTIONS(4745),
  },
  [1702] = {
    [sym_identifier] = ACTIONS(4747),
    [anon_sym_export] = ACTIONS(4747),
    [anon_sym_STAR] = ACTIONS(4749),
    [anon_sym_namespace] = ACTIONS(4747),
    [anon_sym_RBRACE] = ACTIONS(4749),
    [anon_sym_type] = ACTIONS(4747),
    [anon_sym_SEMI] = ACTIONS(4749),
    [anon_sym_LBRACK] = ACTIONS(4749),
    [anon_sym_async] = ACTIONS(4747),
    [anon_sym_void] = ACTIONS(4747),
    [anon_sym_DQUOTE] = ACTIONS(4749),
    [anon_sym_SQUOTE] = ACTIONS(4749),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4749),
    [anon_sym_AT] = ACTIONS(4749),
    [anon_sym_static] = ACTIONS(4747),
    [anon_sym_abstract] = ACTIONS(4747),
    [anon_sym_get] = ACTIONS(4747),
    [anon_sym_set] = ACTIONS(4747),
    [anon_sym_declare] = ACTIONS(4747),
    [anon_sym_public] = ACTIONS(4747),
    [anon_sym_private] = ACTIONS(4747),
    [anon_sym_protected] = ACTIONS(4747),
    [anon_sym_module] = ACTIONS(4747),
    [anon_sym_any] = ACTIONS(4747),
    [anon_sym_number] = ACTIONS(4747),
    [anon_sym_boolean] = ACTIONS(4747),
    [anon_sym_string] = ACTIONS(4747),
    [anon_sym_symbol] = ACTIONS(4747),
    [sym_readonly] = ACTIONS(4747),
    [sym__automatic_semicolon] = ACTIONS(4749),
  },
  [1703] = {
    [sym_identifier] = ACTIONS(4751),
    [anon_sym_export] = ACTIONS(4751),
    [anon_sym_STAR] = ACTIONS(4753),
    [anon_sym_namespace] = ACTIONS(4751),
    [anon_sym_RBRACE] = ACTIONS(4753),
    [anon_sym_type] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_LBRACK] = ACTIONS(4753),
    [anon_sym_async] = ACTIONS(4751),
    [anon_sym_void] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4753),
    [anon_sym_AT] = ACTIONS(4753),
    [anon_sym_static] = ACTIONS(4751),
    [anon_sym_abstract] = ACTIONS(4751),
    [anon_sym_get] = ACTIONS(4751),
    [anon_sym_set] = ACTIONS(4751),
    [anon_sym_declare] = ACTIONS(4751),
    [anon_sym_public] = ACTIONS(4751),
    [anon_sym_private] = ACTIONS(4751),
    [anon_sym_protected] = ACTIONS(4751),
    [anon_sym_module] = ACTIONS(4751),
    [anon_sym_any] = ACTIONS(4751),
    [anon_sym_number] = ACTIONS(4751),
    [anon_sym_boolean] = ACTIONS(4751),
    [anon_sym_string] = ACTIONS(4751),
    [anon_sym_symbol] = ACTIONS(4751),
    [sym_readonly] = ACTIONS(4751),
    [sym__automatic_semicolon] = ACTIONS(4753),
  },
  [1704] = {
    [sym_identifier] = ACTIONS(4755),
    [anon_sym_export] = ACTIONS(4755),
    [anon_sym_STAR] = ACTIONS(4757),
    [anon_sym_namespace] = ACTIONS(4755),
    [anon_sym_RBRACE] = ACTIONS(4757),
    [anon_sym_type] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_LBRACK] = ACTIONS(4757),
    [anon_sym_async] = ACTIONS(4755),
    [anon_sym_void] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4757),
    [anon_sym_SQUOTE] = ACTIONS(4757),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4757),
    [anon_sym_AT] = ACTIONS(4757),
    [anon_sym_static] = ACTIONS(4755),
    [anon_sym_abstract] = ACTIONS(4755),
    [anon_sym_get] = ACTIONS(4755),
    [anon_sym_set] = ACTIONS(4755),
    [anon_sym_declare] = ACTIONS(4755),
    [anon_sym_public] = ACTIONS(4755),
    [anon_sym_private] = ACTIONS(4755),
    [anon_sym_protected] = ACTIONS(4755),
    [anon_sym_module] = ACTIONS(4755),
    [anon_sym_any] = ACTIONS(4755),
    [anon_sym_number] = ACTIONS(4755),
    [anon_sym_boolean] = ACTIONS(4755),
    [anon_sym_string] = ACTIONS(4755),
    [anon_sym_symbol] = ACTIONS(4755),
    [sym_readonly] = ACTIONS(4755),
    [sym__automatic_semicolon] = ACTIONS(4757),
  },
  [1705] = {
    [sym_identifier] = ACTIONS(4759),
    [anon_sym_export] = ACTIONS(4759),
    [anon_sym_STAR] = ACTIONS(4761),
    [anon_sym_namespace] = ACTIONS(4759),
    [anon_sym_RBRACE] = ACTIONS(4761),
    [anon_sym_type] = ACTIONS(4759),
    [anon_sym_SEMI] = ACTIONS(4761),
    [anon_sym_LBRACK] = ACTIONS(4761),
    [anon_sym_async] = ACTIONS(4759),
    [anon_sym_void] = ACTIONS(4759),
    [anon_sym_DQUOTE] = ACTIONS(4761),
    [anon_sym_SQUOTE] = ACTIONS(4761),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4761),
    [anon_sym_AT] = ACTIONS(4761),
    [anon_sym_static] = ACTIONS(4759),
    [anon_sym_abstract] = ACTIONS(4759),
    [anon_sym_get] = ACTIONS(4759),
    [anon_sym_set] = ACTIONS(4759),
    [anon_sym_declare] = ACTIONS(4759),
    [anon_sym_public] = ACTIONS(4759),
    [anon_sym_private] = ACTIONS(4759),
    [anon_sym_protected] = ACTIONS(4759),
    [anon_sym_module] = ACTIONS(4759),
    [anon_sym_any] = ACTIONS(4759),
    [anon_sym_number] = ACTIONS(4759),
    [anon_sym_boolean] = ACTIONS(4759),
    [anon_sym_string] = ACTIONS(4759),
    [anon_sym_symbol] = ACTIONS(4759),
    [sym_readonly] = ACTIONS(4759),
    [sym__automatic_semicolon] = ACTIONS(4761),
  },
  [1706] = {
    [sym_string] = STATE(2011),
    [sym__property_name] = STATE(2011),
    [sym_computed_property_name] = STATE(2011),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4683),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4687),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4689),
    [anon_sym_set] = ACTIONS(4689),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1707] = {
    [sym_string] = STATE(2011),
    [sym__property_name] = STATE(2011),
    [sym_computed_property_name] = STATE(2011),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_EQ_GT] = ACTIONS(4763),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4687),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1708] = {
    [sym_string] = STATE(2004),
    [sym__property_name] = STATE(2004),
    [sym_computed_property_name] = STATE(2004),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4699),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1709] = {
    [sym_string] = STATE(2026),
    [sym__property_name] = STATE(2026),
    [sym_computed_property_name] = STATE(2026),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4765),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1710] = {
    [sym_string] = STATE(2034),
    [sym__property_name] = STATE(2034),
    [sym_computed_property_name] = STATE(2034),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4555),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1711] = {
    [sym_string] = STATE(2011),
    [sym__property_name] = STATE(2011),
    [sym_computed_property_name] = STATE(2011),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4687),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1712] = {
    [sym_string] = STATE(2067),
    [sym__property_name] = STATE(2067),
    [sym_computed_property_name] = STATE(2067),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4585),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1713] = {
    [sym_string] = STATE(2035),
    [sym__property_name] = STATE(2035),
    [sym_computed_property_name] = STATE(2035),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4591),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1714] = {
    [sym_string] = STATE(1986),
    [sym__property_name] = STATE(1986),
    [sym_computed_property_name] = STATE(1986),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4617),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1715] = {
    [sym_string] = STATE(1988),
    [sym__property_name] = STATE(1988),
    [sym_computed_property_name] = STATE(1988),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4767),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1716] = {
    [sym_string] = STATE(1789),
    [sym__property_name] = STATE(1789),
    [sym_computed_property_name] = STATE(1789),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4510),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(4512),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4514),
    [anon_sym_static] = ACTIONS(4769),
    [anon_sym_abstract] = ACTIONS(4771),
    [anon_sym_get] = ACTIONS(4516),
    [anon_sym_set] = ACTIONS(4516),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4773),
  },
  [1717] = {
    [sym_string] = STATE(2036),
    [sym__property_name] = STATE(2036),
    [sym_computed_property_name] = STATE(2036),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4595),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1718] = {
    [sym_string] = STATE(1990),
    [sym__property_name] = STATE(1990),
    [sym_computed_property_name] = STATE(1990),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4775),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1719] = {
    [sym_string] = STATE(2049),
    [sym__property_name] = STATE(2049),
    [sym_computed_property_name] = STATE(2049),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4611),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1720] = {
    [sym_string] = STATE(2037),
    [sym__property_name] = STATE(2037),
    [sym_computed_property_name] = STATE(2037),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4573),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1721] = {
    [sym_string] = STATE(2070),
    [sym__property_name] = STATE(2070),
    [sym_computed_property_name] = STATE(2070),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4777),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1722] = {
    [sym_string] = STATE(1998),
    [sym__property_name] = STATE(1998),
    [sym_computed_property_name] = STATE(1998),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4601),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1723] = {
    [sym_string] = STATE(2045),
    [sym__property_name] = STATE(2045),
    [sym_computed_property_name] = STATE(2045),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4567),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1724] = {
    [sym_string] = STATE(2021),
    [sym__property_name] = STATE(2021),
    [sym_computed_property_name] = STATE(2021),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4739),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1725] = {
    [sym_string] = STATE(1792),
    [sym__property_name] = STATE(1792),
    [sym_computed_property_name] = STATE(1792),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4779),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(3516),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4781),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4783),
    [anon_sym_set] = ACTIONS(4783),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4785),
  },
  [1726] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(4787),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [sym_readonly] = ACTIONS(2494),
  },
  [1727] = {
    [sym_decorator] = STATE(1762),
    [aux_sym_export_statement_repeat1] = STATE(1727),
    [sym_identifier] = ACTIONS(4789),
    [anon_sym_export] = ACTIONS(4789),
    [anon_sym_namespace] = ACTIONS(4789),
    [anon_sym_LBRACE] = ACTIONS(4791),
    [anon_sym_type] = ACTIONS(4789),
    [anon_sym_LBRACK] = ACTIONS(4791),
    [anon_sym_class] = ACTIONS(4789),
    [anon_sym_async] = ACTIONS(4789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4791),
    [anon_sym_void] = ACTIONS(4789),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4789),
    [anon_sym_AT] = ACTIONS(4793),
    [anon_sym_static] = ACTIONS(4789),
    [anon_sym_get] = ACTIONS(4789),
    [anon_sym_set] = ACTIONS(4789),
    [anon_sym_declare] = ACTIONS(4789),
    [anon_sym_public] = ACTIONS(4789),
    [anon_sym_private] = ACTIONS(4789),
    [anon_sym_protected] = ACTIONS(4789),
    [anon_sym_module] = ACTIONS(4789),
    [anon_sym_any] = ACTIONS(4789),
    [anon_sym_number] = ACTIONS(4789),
    [anon_sym_boolean] = ACTIONS(4789),
    [anon_sym_string] = ACTIONS(4789),
    [anon_sym_symbol] = ACTIONS(4789),
    [sym_readonly] = ACTIONS(4789),
  },
  [1728] = {
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_EQ] = ACTIONS(608),
    [anon_sym_namespace] = ACTIONS(2541),
    [anon_sym_LBRACE] = ACTIONS(2543),
    [anon_sym_COMMA] = ACTIONS(608),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_RPAREN] = ACTIONS(608),
    [anon_sym_COLON] = ACTIONS(608),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [anon_sym_async] = ACTIONS(2541),
    [anon_sym_QMARK] = ACTIONS(608),
    [anon_sym_void] = ACTIONS(2541),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(2541),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
    [sym_readonly] = ACTIONS(2541),
  },
  [1729] = {
    [sym_string] = STATE(2351),
    [sym__property_name] = STATE(2351),
    [sym_computed_property_name] = STATE(2351),
    [sym_enum_assignment] = STATE(2687),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(4796),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4798),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1730] = {
    [sym_string] = STATE(2210),
    [sym__property_name] = STATE(2210),
    [sym_computed_property_name] = STATE(2210),
    [sym_enum_assignment] = STATE(2446),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(4800),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4802),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1731] = {
    [sym_string] = STATE(2351),
    [sym__property_name] = STATE(2351),
    [sym_computed_property_name] = STATE(2351),
    [sym_enum_assignment] = STATE(2687),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(4804),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4798),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1732] = {
    [sym_string] = STATE(2351),
    [sym__property_name] = STATE(2351),
    [sym_computed_property_name] = STATE(2351),
    [sym_enum_assignment] = STATE(2687),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(4806),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4798),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1733] = {
    [sym_string] = STATE(1802),
    [sym__property_name] = STATE(1802),
    [sym_computed_property_name] = STATE(1802),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4524),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(4526),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4528),
    [anon_sym_static] = ACTIONS(4808),
    [anon_sym_get] = ACTIONS(4530),
    [anon_sym_set] = ACTIONS(4530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4532),
  },
  [1734] = {
    [sym_string] = STATE(2261),
    [sym__property_name] = STATE(2261),
    [sym_computed_property_name] = STATE(2261),
    [sym_enum_assignment] = STATE(2389),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(4810),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4812),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1735] = {
    [sym_string] = STATE(1788),
    [sym__property_name] = STATE(1788),
    [sym_computed_property_name] = STATE(1788),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4440),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(4442),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4444),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_abstract] = ACTIONS(4814),
    [anon_sym_get] = ACTIONS(4446),
    [anon_sym_set] = ACTIONS(4446),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
  },
  [1736] = {
    [sym_string] = STATE(1793),
    [sym__property_name] = STATE(1793),
    [sym_computed_property_name] = STATE(1793),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4816),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(3516),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4818),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4820),
    [anon_sym_set] = ACTIONS(4820),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4814),
  },
  [1737] = {
    [sym_string] = STATE(1797),
    [sym__property_name] = STATE(1797),
    [sym_computed_property_name] = STATE(1797),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4101),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(4107),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4109),
    [anon_sym_static] = ACTIONS(4822),
    [anon_sym_get] = ACTIONS(4111),
    [anon_sym_set] = ACTIONS(4111),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
    [sym_readonly] = ACTIONS(4113),
  },
  [1738] = {
    [sym_string] = STATE(2351),
    [sym__property_name] = STATE(2351),
    [sym_computed_property_name] = STATE(2351),
    [sym_enum_assignment] = STATE(2687),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(4824),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4798),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1739] = {
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_export] = ACTIONS(4826),
    [anon_sym_STAR] = ACTIONS(4216),
    [anon_sym_namespace] = ACTIONS(4826),
    [anon_sym_RBRACE] = ACTIONS(4216),
    [anon_sym_type] = ACTIONS(4826),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_async] = ACTIONS(4826),
    [anon_sym_void] = ACTIONS(4826),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_SQUOTE] = ACTIONS(4216),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4216),
    [anon_sym_AT] = ACTIONS(4216),
    [anon_sym_static] = ACTIONS(4826),
    [anon_sym_abstract] = ACTIONS(4826),
    [anon_sym_get] = ACTIONS(4826),
    [anon_sym_set] = ACTIONS(4826),
    [anon_sym_declare] = ACTIONS(4826),
    [anon_sym_public] = ACTIONS(4826),
    [anon_sym_private] = ACTIONS(4826),
    [anon_sym_protected] = ACTIONS(4826),
    [anon_sym_module] = ACTIONS(4826),
    [anon_sym_any] = ACTIONS(4826),
    [anon_sym_number] = ACTIONS(4826),
    [anon_sym_boolean] = ACTIONS(4826),
    [anon_sym_string] = ACTIONS(4826),
    [anon_sym_symbol] = ACTIONS(4826),
    [sym_readonly] = ACTIONS(4826),
  },
  [1740] = {
    [sym_string] = STATE(1789),
    [sym__property_name] = STATE(1789),
    [sym_computed_property_name] = STATE(1789),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4510),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(4512),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4514),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_abstract] = ACTIONS(4785),
    [anon_sym_get] = ACTIONS(4516),
    [anon_sym_set] = ACTIONS(4516),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
  },
  [1741] = {
    [sym_string] = STATE(2004),
    [sym__property_name] = STATE(2004),
    [sym_computed_property_name] = STATE(2004),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4697),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(4828),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4699),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4701),
    [anon_sym_set] = ACTIONS(4701),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1742] = {
    [sym_string] = STATE(1799),
    [sym__property_name] = STATE(1799),
    [sym_computed_property_name] = STATE(1799),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4589),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(4830),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4832),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4834),
    [anon_sym_set] = ACTIONS(4834),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
  },
  [1743] = {
    [sym_string] = STATE(1788),
    [sym__property_name] = STATE(1788),
    [sym_computed_property_name] = STATE(1788),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4440),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(4442),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4444),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4446),
    [anon_sym_set] = ACTIONS(4446),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
  },
  [1744] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1745] = {
    [sym_string] = STATE(2351),
    [sym__property_name] = STATE(2351),
    [sym_computed_property_name] = STATE(2351),
    [sym_enum_assignment] = STATE(2687),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4798),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1746] = {
    [sym_string] = STATE(1797),
    [sym__property_name] = STATE(1797),
    [sym_computed_property_name] = STATE(1797),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4101),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(4107),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4109),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4111),
    [anon_sym_set] = ACTIONS(4111),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
  },
  [1747] = {
    [sym_string] = STATE(1802),
    [sym__property_name] = STATE(1802),
    [sym_computed_property_name] = STATE(1802),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4524),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(4526),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4528),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4530),
    [anon_sym_set] = ACTIONS(4530),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
  },
  [1748] = {
    [sym_string] = STATE(1800),
    [sym__property_name] = STATE(1800),
    [sym_computed_property_name] = STATE(1800),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4609),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(4836),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4838),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4840),
    [anon_sym_set] = ACTIONS(4840),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
  },
  [1749] = {
    [sym_string] = STATE(1798),
    [sym__property_name] = STATE(1798),
    [sym_computed_property_name] = STATE(1798),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4426),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(4428),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4430),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4432),
    [anon_sym_set] = ACTIONS(4432),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
  },
  [1750] = {
    [sym_string] = STATE(2011),
    [sym__property_name] = STATE(2011),
    [sym_computed_property_name] = STATE(2011),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(4683),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(4685),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4687),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(4689),
    [anon_sym_set] = ACTIONS(4689),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1751] = {
    [sym_string] = STATE(1791),
    [sym__property_name] = STATE(1791),
    [sym_computed_property_name] = STATE(1791),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4599),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(4842),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4844),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4846),
    [anon_sym_set] = ACTIONS(4846),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
  },
  [1752] = {
    [sym_string] = STATE(1801),
    [sym__property_name] = STATE(1801),
    [sym_computed_property_name] = STATE(1801),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(4490),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(4492),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4494),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(4496),
    [anon_sym_set] = ACTIONS(4496),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
  },
  [1753] = {
    [sym_string] = STATE(2021),
    [sym__property_name] = STATE(2021),
    [sym_computed_property_name] = STATE(2021),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4739),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1754] = {
    [sym_string] = STATE(1988),
    [sym__property_name] = STATE(1988),
    [sym_computed_property_name] = STATE(1988),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4767),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1755] = {
    [sym_string] = STATE(2056),
    [sym__property_name] = STATE(2056),
    [sym_computed_property_name] = STATE(2056),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1756] = {
    [sym_string] = STATE(2045),
    [sym__property_name] = STATE(2045),
    [sym_computed_property_name] = STATE(2045),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4567),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1757] = {
    [sym_string] = STATE(1998),
    [sym__property_name] = STATE(1998),
    [sym_computed_property_name] = STATE(1998),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4601),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1758] = {
    [sym_string] = STATE(2004),
    [sym__property_name] = STATE(2004),
    [sym_computed_property_name] = STATE(2004),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4699),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1759] = {
    [sym_string] = STATE(1993),
    [sym__property_name] = STATE(1993),
    [sym_computed_property_name] = STATE(1993),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4649),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1760] = {
    [sym_string] = STATE(1892),
    [sym__property_name] = STATE(1892),
    [sym_computed_property_name] = STATE(1892),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(3516),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4848),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(3516),
    [anon_sym_set] = ACTIONS(3516),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
  },
  [1761] = {
    [sym_string] = STATE(2049),
    [sym__property_name] = STATE(2049),
    [sym_computed_property_name] = STATE(2049),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4611),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1762] = {
    [sym_identifier] = ACTIONS(4850),
    [anon_sym_export] = ACTIONS(4850),
    [anon_sym_namespace] = ACTIONS(4850),
    [anon_sym_LBRACE] = ACTIONS(4852),
    [anon_sym_type] = ACTIONS(4850),
    [anon_sym_LBRACK] = ACTIONS(4852),
    [anon_sym_class] = ACTIONS(4850),
    [anon_sym_async] = ACTIONS(4850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4852),
    [anon_sym_void] = ACTIONS(4850),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4850),
    [anon_sym_AT] = ACTIONS(4852),
    [anon_sym_static] = ACTIONS(4850),
    [anon_sym_get] = ACTIONS(4850),
    [anon_sym_set] = ACTIONS(4850),
    [anon_sym_declare] = ACTIONS(4850),
    [anon_sym_public] = ACTIONS(4850),
    [anon_sym_private] = ACTIONS(4850),
    [anon_sym_protected] = ACTIONS(4850),
    [anon_sym_module] = ACTIONS(4850),
    [anon_sym_any] = ACTIONS(4850),
    [anon_sym_number] = ACTIONS(4850),
    [anon_sym_boolean] = ACTIONS(4850),
    [anon_sym_string] = ACTIONS(4850),
    [anon_sym_symbol] = ACTIONS(4850),
    [sym_readonly] = ACTIONS(4850),
  },
  [1763] = {
    [sym_string] = STATE(2070),
    [sym__property_name] = STATE(2070),
    [sym_computed_property_name] = STATE(2070),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4777),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1764] = {
    [sym_string] = STATE(2041),
    [sym__property_name] = STATE(2041),
    [sym_computed_property_name] = STATE(2041),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4376),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1765] = {
    [sym_string] = STATE(2037),
    [sym__property_name] = STATE(2037),
    [sym_computed_property_name] = STATE(2037),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4573),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1766] = {
    [sym_string] = STATE(2054),
    [sym__property_name] = STATE(2054),
    [sym_computed_property_name] = STATE(2054),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4559),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1767] = {
    [sym_string] = STATE(1990),
    [sym__property_name] = STATE(1990),
    [sym_computed_property_name] = STATE(1990),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4775),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1768] = {
    [sym_string] = STATE(1879),
    [sym__property_name] = STATE(1879),
    [sym_computed_property_name] = STATE(1879),
    [sym_identifier] = ACTIONS(3516),
    [anon_sym_export] = ACTIONS(3516),
    [anon_sym_namespace] = ACTIONS(3516),
    [anon_sym_type] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(3516),
    [anon_sym_void] = ACTIONS(3516),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4854),
    [anon_sym_static] = ACTIONS(3516),
    [anon_sym_get] = ACTIONS(3516),
    [anon_sym_set] = ACTIONS(3516),
    [anon_sym_declare] = ACTIONS(3516),
    [anon_sym_public] = ACTIONS(3516),
    [anon_sym_private] = ACTIONS(3516),
    [anon_sym_protected] = ACTIONS(3516),
    [anon_sym_module] = ACTIONS(3516),
    [anon_sym_any] = ACTIONS(3516),
    [anon_sym_number] = ACTIONS(3516),
    [anon_sym_boolean] = ACTIONS(3516),
    [anon_sym_string] = ACTIONS(3516),
    [anon_sym_symbol] = ACTIONS(3516),
  },
  [1769] = {
    [sym_string] = STATE(2036),
    [sym__property_name] = STATE(2036),
    [sym_computed_property_name] = STATE(2036),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4595),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1770] = {
    [sym_string] = STATE(1986),
    [sym__property_name] = STATE(1986),
    [sym_computed_property_name] = STATE(1986),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4617),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1771] = {
    [sym_string] = STATE(2002),
    [sym__property_name] = STATE(2002),
    [sym_computed_property_name] = STATE(2002),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4579),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1772] = {
    [sym_string] = STATE(2011),
    [sym__property_name] = STATE(2011),
    [sym_computed_property_name] = STATE(2011),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4687),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1773] = {
    [sym_string] = STATE(2034),
    [sym__property_name] = STATE(2034),
    [sym_computed_property_name] = STATE(2034),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4555),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1774] = {
    [sym_string] = STATE(2038),
    [sym__property_name] = STATE(2038),
    [sym_computed_property_name] = STATE(2038),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4651),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1775] = {
    [sym_string] = STATE(2035),
    [sym__property_name] = STATE(2035),
    [sym_computed_property_name] = STATE(2035),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4591),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1776] = {
    [sym_string] = STATE(2026),
    [sym__property_name] = STATE(2026),
    [sym_computed_property_name] = STATE(2026),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4765),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1777] = {
    [sym_string] = STATE(2067),
    [sym__property_name] = STATE(2067),
    [sym_computed_property_name] = STATE(2067),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4585),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
  },
  [1778] = {
    [sym_object] = STATE(2084),
    [sym_array] = STATE(2085),
    [sym_identifier] = ACTIONS(4856),
    [anon_sym_export] = ACTIONS(4858),
    [anon_sym_namespace] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(4858),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_async] = ACTIONS(4858),
    [anon_sym_void] = ACTIONS(4858),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4856),
    [anon_sym_static] = ACTIONS(4858),
    [anon_sym_get] = ACTIONS(4858),
    [anon_sym_set] = ACTIONS(4858),
    [anon_sym_declare] = ACTIONS(4858),
    [anon_sym_public] = ACTIONS(4858),
    [anon_sym_private] = ACTIONS(4858),
    [anon_sym_protected] = ACTIONS(4858),
    [anon_sym_module] = ACTIONS(4858),
    [anon_sym_any] = ACTIONS(4858),
    [anon_sym_number] = ACTIONS(4858),
    [anon_sym_boolean] = ACTIONS(4858),
    [anon_sym_string] = ACTIONS(4858),
    [anon_sym_symbol] = ACTIONS(4858),
    [sym_readonly] = ACTIONS(4860),
  },
  [1779] = {
    [sym_object] = STATE(2084),
    [sym_array] = STATE(2085),
    [sym_identifier] = ACTIONS(4856),
    [anon_sym_export] = ACTIONS(4858),
    [anon_sym_namespace] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(4858),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_async] = ACTIONS(4858),
    [anon_sym_void] = ACTIONS(4858),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4856),
    [anon_sym_static] = ACTIONS(4858),
    [anon_sym_get] = ACTIONS(4858),
    [anon_sym_set] = ACTIONS(4858),
    [anon_sym_declare] = ACTIONS(4858),
    [anon_sym_public] = ACTIONS(4858),
    [anon_sym_private] = ACTIONS(4858),
    [anon_sym_protected] = ACTIONS(4858),
    [anon_sym_module] = ACTIONS(4858),
    [anon_sym_any] = ACTIONS(4858),
    [anon_sym_number] = ACTIONS(4858),
    [anon_sym_boolean] = ACTIONS(4858),
    [anon_sym_string] = ACTIONS(4858),
    [anon_sym_symbol] = ACTIONS(4858),
  },
  [1780] = {
    [sym_object] = STATE(2091),
    [sym_array] = STATE(2086),
    [sym_identifier] = ACTIONS(4862),
    [anon_sym_export] = ACTIONS(4864),
    [anon_sym_namespace] = ACTIONS(4864),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(4864),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_async] = ACTIONS(4864),
    [anon_sym_void] = ACTIONS(4864),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4862),
    [anon_sym_static] = ACTIONS(4864),
    [anon_sym_get] = ACTIONS(4864),
    [anon_sym_set] = ACTIONS(4864),
    [anon_sym_declare] = ACTIONS(4864),
    [anon_sym_public] = ACTIONS(4864),
    [anon_sym_private] = ACTIONS(4864),
    [anon_sym_protected] = ACTIONS(4864),
    [anon_sym_module] = ACTIONS(4864),
    [anon_sym_any] = ACTIONS(4864),
    [anon_sym_number] = ACTIONS(4864),
    [anon_sym_boolean] = ACTIONS(4864),
    [anon_sym_string] = ACTIONS(4864),
    [anon_sym_symbol] = ACTIONS(4864),
  },
  [1781] = {
    [sym_decorator_member_expression] = STATE(1633),
    [sym_decorator_call_expression] = STATE(1685),
    [sym_identifier] = ACTIONS(4866),
    [anon_sym_export] = ACTIONS(4868),
    [anon_sym_namespace] = ACTIONS(4868),
    [anon_sym_type] = ACTIONS(4868),
    [anon_sym_async] = ACTIONS(4868),
    [anon_sym_void] = ACTIONS(4868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(4868),
    [anon_sym_get] = ACTIONS(4868),
    [anon_sym_set] = ACTIONS(4868),
    [anon_sym_declare] = ACTIONS(4868),
    [anon_sym_public] = ACTIONS(4868),
    [anon_sym_private] = ACTIONS(4868),
    [anon_sym_protected] = ACTIONS(4868),
    [anon_sym_module] = ACTIONS(4868),
    [anon_sym_any] = ACTIONS(4868),
    [anon_sym_number] = ACTIONS(4868),
    [anon_sym_boolean] = ACTIONS(4868),
    [anon_sym_string] = ACTIONS(4868),
    [anon_sym_symbol] = ACTIONS(4868),
  },
  [1782] = {
    [sym_decorator_member_expression] = STATE(2013),
    [sym_decorator_call_expression] = STATE(1685),
    [sym_identifier] = ACTIONS(4870),
    [anon_sym_export] = ACTIONS(4872),
    [anon_sym_namespace] = ACTIONS(4872),
    [anon_sym_type] = ACTIONS(4872),
    [anon_sym_async] = ACTIONS(4872),
    [anon_sym_void] = ACTIONS(4872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(4872),
    [anon_sym_get] = ACTIONS(4872),
    [anon_sym_set] = ACTIONS(4872),
    [anon_sym_declare] = ACTIONS(4872),
    [anon_sym_public] = ACTIONS(4872),
    [anon_sym_private] = ACTIONS(4872),
    [anon_sym_protected] = ACTIONS(4872),
    [anon_sym_module] = ACTIONS(4872),
    [anon_sym_any] = ACTIONS(4872),
    [anon_sym_number] = ACTIONS(4872),
    [anon_sym_boolean] = ACTIONS(4872),
    [anon_sym_string] = ACTIONS(4872),
    [anon_sym_symbol] = ACTIONS(4872),
  },
  [1783] = {
    [sym_type_arguments] = STATE(413),
    [anon_sym_EQ] = ACTIONS(2498),
    [anon_sym_LBRACE] = ACTIONS(2496),
    [anon_sym_COMMA] = ACTIONS(2496),
    [anon_sym_else] = ACTIONS(2496),
    [anon_sym_RPAREN] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_RBRACK] = ACTIONS(2496),
    [anon_sym_LT] = ACTIONS(4874),
    [anon_sym_GT] = ACTIONS(2496),
    [anon_sym_DOT] = ACTIONS(4876),
    [anon_sym_EQ_GT] = ACTIONS(2496),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_PIPE] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(3172),
  },
  [1784] = {
    [anon_sym_EQ] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1097),
    [anon_sym_COMMA] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_COLON] = ACTIONS(1097),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_BANG] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1097),
    [sym__automatic_semicolon] = ACTIONS(1097),
  },
  [1785] = {
    [anon_sym_EQ] = ACTIONS(1111),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_COMMA] = ACTIONS(1111),
    [anon_sym_RBRACE] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_COLON] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_QMARK] = ACTIONS(1111),
    [anon_sym_AMP] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1111),
    [sym__automatic_semicolon] = ACTIONS(1111),
  },
  [1786] = {
    [sym_type_arguments] = STATE(1872),
    [anon_sym_EQ] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2496),
    [anon_sym_COMMA] = ACTIONS(2496),
    [anon_sym_RBRACE] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_LT] = ACTIONS(4878),
    [anon_sym_DOT] = ACTIONS(4880),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_PIPE] = ACTIONS(2498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(3183),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2496),
    [sym__automatic_semicolon] = ACTIONS(2496),
  },
  [1787] = {
    [sym__call_signature] = STATE(2229),
    [sym__initializer] = STATE(2449),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2231),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4884),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4884),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(4886),
    [anon_sym_BANG] = ACTIONS(4888),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4884),
  },
  [1788] = {
    [sym__call_signature] = STATE(2126),
    [sym__initializer] = STATE(2409),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2154),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4890),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(4892),
    [anon_sym_BANG] = ACTIONS(4894),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4890),
  },
  [1789] = {
    [sym__call_signature] = STATE(2144),
    [sym__initializer] = STATE(2420),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2143),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4896),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4896),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(4898),
    [anon_sym_BANG] = ACTIONS(4900),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4896),
  },
  [1790] = {
    [sym_type_arguments] = STATE(413),
    [sym_default_type] = STATE(2621),
    [sym_constraint] = STATE(2326),
    [anon_sym_EQ] = ACTIONS(4902),
    [anon_sym_COMMA] = ACTIONS(4904),
    [anon_sym_COLON] = ACTIONS(4907),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_LT] = ACTIONS(4874),
    [anon_sym_GT] = ACTIONS(4904),
    [anon_sym_DOT] = ACTIONS(4876),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_PIPE] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(4907),
    [anon_sym_is] = ACTIONS(3172),
  },
  [1791] = {
    [sym__call_signature] = STATE(2073),
    [sym__initializer] = STATE(2452),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2234),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4909),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(4911),
    [anon_sym_BANG] = ACTIONS(4913),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4909),
  },
  [1792] = {
    [sym__call_signature] = STATE(2422),
    [sym__initializer] = STATE(2420),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2143),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4896),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4896),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(4915),
    [anon_sym_BANG] = ACTIONS(4900),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4896),
  },
  [1793] = {
    [sym__call_signature] = STATE(2400),
    [sym__initializer] = STATE(2409),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2154),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4890),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(4917),
    [anon_sym_BANG] = ACTIONS(4894),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4890),
  },
  [1794] = {
    [sym_type_arguments] = STATE(417),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2553),
    [anon_sym_else] = ACTIONS(2553),
    [anon_sym_RPAREN] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK] = ACTIONS(2553),
    [anon_sym_LT] = ACTIONS(4874),
    [anon_sym_GT] = ACTIONS(2553),
    [anon_sym_EQ_GT] = ACTIONS(2553),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_PIPE] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
  },
  [1795] = {
    [sym__call_signature] = STATE(1958),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2174),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4919),
    [anon_sym_RBRACE] = ACTIONS(4919),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4919),
    [anon_sym_COLON] = ACTIONS(4921),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(4923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4919),
    [sym__automatic_semicolon] = ACTIONS(4919),
  },
  [1796] = {
    [sym__call_signature] = STATE(2171),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2174),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4919),
    [anon_sym_RBRACE] = ACTIONS(4919),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4919),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(4925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4919),
    [sym__automatic_semicolon] = ACTIONS(4919),
  },
  [1797] = {
    [sym__call_signature] = STATE(1961),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2104),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4927),
    [anon_sym_RBRACE] = ACTIONS(4927),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4927),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(4929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4927),
    [sym__automatic_semicolon] = ACTIONS(4927),
  },
  [1798] = {
    [sym__call_signature] = STATE(2106),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2114),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4931),
    [anon_sym_RBRACE] = ACTIONS(4931),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4931),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(4933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4931),
    [sym__automatic_semicolon] = ACTIONS(4931),
  },
  [1799] = {
    [sym__call_signature] = STATE(1940),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2265),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4935),
    [anon_sym_RBRACE] = ACTIONS(4935),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4935),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(4937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4935),
    [sym__automatic_semicolon] = ACTIONS(4935),
  },
  [1800] = {
    [sym__call_signature] = STATE(2248),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2265),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4935),
    [anon_sym_RBRACE] = ACTIONS(4935),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4935),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(4939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4935),
    [sym__automatic_semicolon] = ACTIONS(4935),
  },
  [1801] = {
    [sym__call_signature] = STATE(1950),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2114),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4931),
    [anon_sym_RBRACE] = ACTIONS(4931),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4931),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(4941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4931),
    [sym__automatic_semicolon] = ACTIONS(4931),
  },
  [1802] = {
    [sym__call_signature] = STATE(2175),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2104),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4927),
    [anon_sym_RBRACE] = ACTIONS(4927),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4927),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(4943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4927),
    [sym__automatic_semicolon] = ACTIONS(4927),
  },
  [1803] = {
    [sym__call_signature] = STATE(2388),
    [sym__initializer] = STATE(2406),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2163),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4945),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4945),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4945),
  },
  [1804] = {
    [sym__call_signature] = STATE(1939),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2176),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4947),
    [anon_sym_RBRACE] = ACTIONS(4947),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4947),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4947),
    [sym__automatic_semicolon] = ACTIONS(4947),
  },
  [1805] = {
    [sym__call_signature] = STATE(2100),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2115),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4949),
    [anon_sym_RBRACE] = ACTIONS(4949),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4949),
    [sym__automatic_semicolon] = ACTIONS(4949),
  },
  [1806] = {
    [anon_sym_EQ] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2340),
    [anon_sym_RBRACE] = ACTIONS(2340),
    [anon_sym_SEMI] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_PIPE] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2340),
    [sym__automatic_semicolon] = ACTIONS(2340),
  },
  [1807] = {
    [anon_sym_EQ] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2586),
    [anon_sym_else] = ACTIONS(2586),
    [anon_sym_RPAREN] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2586),
    [anon_sym_RBRACK] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_EQ_GT] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [1808] = {
    [sym__call_signature] = STATE(2266),
    [sym__initializer] = STATE(2403),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2260),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4955),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4955),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4955),
  },
  [1809] = {
    [sym__call_signature] = STATE(2244),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2263),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4957),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4957),
    [sym__automatic_semicolon] = ACTIONS(4957),
  },
  [1810] = {
    [sym__call_signature] = STATE(2190),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2176),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4947),
    [anon_sym_RBRACE] = ACTIONS(4947),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4947),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4947),
    [sym__automatic_semicolon] = ACTIONS(4947),
  },
  [1811] = {
    [sym__call_signature] = STATE(2132),
    [sym__initializer] = STATE(2414),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2130),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4959),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4959),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4959),
  },
  [1812] = {
    [sym__call_signature] = STATE(2119),
    [sym__initializer] = STATE(2406),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2163),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4945),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4945),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4945),
  },
  [1813] = {
    [sym_type_arguments] = STATE(1858),
    [anon_sym_EQ] = ACTIONS(2553),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2553),
    [anon_sym_RBRACE] = ACTIONS(2553),
    [anon_sym_SEMI] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LT] = ACTIONS(4878),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_PIPE] = ACTIONS(2555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2553),
    [sym__automatic_semicolon] = ACTIONS(2553),
  },
  [1814] = {
    [sym_type_arguments] = STATE(413),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_RPAREN] = ACTIONS(4961),
    [anon_sym_COLON] = ACTIONS(3470),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_LT] = ACTIONS(4874),
    [anon_sym_DOT] = ACTIONS(4876),
    [anon_sym_QMARK] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_PIPE] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(3172),
  },
  [1815] = {
    [anon_sym_EQ] = ACTIONS(2596),
    [anon_sym_LBRACE] = ACTIONS(2594),
    [anon_sym_COMMA] = ACTIONS(2594),
    [anon_sym_else] = ACTIONS(2594),
    [anon_sym_RPAREN] = ACTIONS(2594),
    [anon_sym_while] = ACTIONS(2594),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_RBRACK] = ACTIONS(2594),
    [anon_sym_GT] = ACTIONS(2594),
    [anon_sym_EQ_GT] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [1816] = {
    [sym__call_signature] = STATE(2478),
    [sym__initializer] = STATE(2403),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2260),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4955),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4955),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4955),
  },
  [1817] = {
    [sym__call_signature] = STATE(2164),
    [sym__initializer] = STATE(2408),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2146),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4964),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4964),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4964),
  },
  [1818] = {
    [sym__call_signature] = STATE(1957),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2115),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4949),
    [anon_sym_RBRACE] = ACTIONS(4949),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4949),
    [sym__automatic_semicolon] = ACTIONS(4949),
  },
  [1819] = {
    [anon_sym_EQ] = ACTIONS(2592),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2590),
    [anon_sym_else] = ACTIONS(2590),
    [anon_sym_RPAREN] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_RBRACK] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_EQ_GT] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [1820] = {
    [sym__call_signature] = STATE(1948),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2263),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4957),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4957),
    [sym__automatic_semicolon] = ACTIONS(4957),
  },
  [1821] = {
    [anon_sym_EQ] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2602),
    [anon_sym_else] = ACTIONS(2602),
    [anon_sym_RPAREN] = ACTIONS(2602),
    [anon_sym_while] = ACTIONS(2602),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_RBRACK] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_EQ_GT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [1822] = {
    [anon_sym_EQ] = ACTIONS(2600),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_else] = ACTIONS(2598),
    [anon_sym_RPAREN] = ACTIONS(2598),
    [anon_sym_while] = ACTIONS(2598),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_RBRACK] = ACTIONS(2598),
    [anon_sym_GT] = ACTIONS(2598),
    [anon_sym_EQ_GT] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [1823] = {
    [sym__call_signature] = STATE(1960),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2239),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4966),
    [anon_sym_RBRACE] = ACTIONS(4966),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4966),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4966),
    [sym__automatic_semicolon] = ACTIONS(4966),
  },
  [1824] = {
    [sym__call_signature] = STATE(2150),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_annotation] = STATE(2239),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_COMMA] = ACTIONS(4966),
    [anon_sym_RBRACE] = ACTIONS(4966),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(4966),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4966),
    [sym__automatic_semicolon] = ACTIONS(4966),
  },
  [1825] = {
    [anon_sym_EQ] = ACTIONS(4406),
    [anon_sym_COMMA] = ACTIONS(4406),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym_COLON] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4406),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_BANG] = ACTIONS(4406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4406),
    [sym__automatic_semicolon] = ACTIONS(4406),
  },
  [1826] = {
    [aux_sym_object_repeat1] = STATE(2392),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1827] = {
    [aux_sym_object_repeat1] = STATE(2484),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1828] = {
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1829] = {
    [anon_sym_EQ] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(2382),
    [anon_sym_COMMA] = ACTIONS(2382),
    [anon_sym_RBRACE] = ACTIONS(2382),
    [anon_sym_SEMI] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_DOT] = ACTIONS(4880),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_PIPE] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2382),
    [sym__automatic_semicolon] = ACTIONS(2382),
  },
  [1830] = {
    [anon_sym_EQ] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1057),
    [sym__automatic_semicolon] = ACTIONS(1057),
  },
  [1831] = {
    [aux_sym_object_repeat1] = STATE(2399),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1832] = {
    [anon_sym_EQ] = ACTIONS(2344),
    [anon_sym_LBRACE] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_DOT] = ACTIONS(4968),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_PIPE] = ACTIONS(2346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2344),
    [sym__automatic_semicolon] = ACTIONS(2344),
  },
  [1833] = {
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2454),
    [sym__automatic_semicolon] = ACTIONS(2454),
  },
  [1834] = {
    [anon_sym_EQ] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_COMMA] = ACTIONS(2400),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_PIPE] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2400),
    [sym__automatic_semicolon] = ACTIONS(2400),
  },
  [1835] = {
    [sym_class_heritage] = STATE(2663),
    [sym_class_body] = STATE(1505),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1908),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4974),
    [anon_sym_extends] = ACTIONS(4976),
  },
  [1836] = {
    [sym_class_heritage] = STATE(2712),
    [sym_class_body] = STATE(1490),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1970),
    [sym_identifier] = ACTIONS(4978),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4974),
    [anon_sym_extends] = ACTIONS(4976),
  },
  [1837] = {
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2472),
    [anon_sym_PIPE] = ACTIONS(2474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2472),
    [sym__automatic_semicolon] = ACTIONS(2472),
  },
  [1838] = {
    [anon_sym_EQ] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2480),
    [sym__automatic_semicolon] = ACTIONS(2480),
  },
  [1839] = {
    [anon_sym_EQ] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_RBRACE] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_PIPE] = ACTIONS(2406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2404),
    [sym__automatic_semicolon] = ACTIONS(2404),
  },
  [1840] = {
    [anon_sym_EQ] = ACTIONS(2602),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2602),
    [sym__automatic_semicolon] = ACTIONS(2602),
  },
  [1841] = {
    [anon_sym_EQ] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2396),
    [anon_sym_COMMA] = ACTIONS(2396),
    [anon_sym_RBRACE] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2396),
    [anon_sym_AMP] = ACTIONS(2396),
    [anon_sym_PIPE] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2396),
    [sym__automatic_semicolon] = ACTIONS(2396),
  },
  [1842] = {
    [anon_sym_EQ] = ACTIONS(2598),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2598),
    [sym__automatic_semicolon] = ACTIONS(2598),
  },
  [1843] = {
    [sym_import_clause] = STATE(2581),
    [sym_namespace_import] = STATE(2812),
    [sym_named_imports] = STATE(2812),
    [sym_string] = STATE(2578),
    [sym_import_require_clause] = STATE(2578),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_STAR] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(3561),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
  },
  [1844] = {
    [anon_sym_EQ] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym_PIPE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2388),
    [sym__automatic_semicolon] = ACTIONS(2388),
  },
  [1845] = {
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_COMMA] = ACTIONS(3552),
    [anon_sym_RBRACE] = ACTIONS(3552),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3488),
    [sym__automatic_semicolon] = ACTIONS(3488),
  },
  [1846] = {
    [anon_sym_EQ] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2466),
    [sym__automatic_semicolon] = ACTIONS(2466),
  },
  [1847] = {
    [sym_class_heritage] = STATE(2729),
    [sym_class_body] = STATE(1431),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1924),
    [sym_identifier] = ACTIONS(4990),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4974),
    [anon_sym_extends] = ACTIONS(4976),
  },
  [1848] = {
    [anon_sym_EQ] = ACTIONS(2408),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_COMMA] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2408),
    [sym__automatic_semicolon] = ACTIONS(2408),
  },
  [1849] = {
    [anon_sym_EQ] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2476),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2476),
    [sym__automatic_semicolon] = ACTIONS(2476),
  },
  [1850] = {
    [sym_class_heritage] = STATE(2712),
    [sym_class_body] = STATE(1490),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1970),
    [sym_identifier] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4974),
    [anon_sym_extends] = ACTIONS(4976),
  },
  [1851] = {
    [anon_sym_EQ] = ACTIONS(2446),
    [anon_sym_LBRACE] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(2446),
    [anon_sym_SEMI] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [anon_sym_AMP] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(2448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2446),
    [sym__automatic_semicolon] = ACTIONS(2446),
  },
  [1852] = {
    [sym_class_heritage] = STATE(2712),
    [sym_class_body] = STATE(1490),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1970),
    [sym_identifier] = ACTIONS(4994),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4974),
    [anon_sym_extends] = ACTIONS(4976),
  },
  [1853] = {
    [sym_class_heritage] = STATE(2588),
    [sym_class_body] = STATE(1021),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1936),
    [sym_identifier] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4974),
    [anon_sym_extends] = ACTIONS(4976),
  },
  [1854] = {
    [anon_sym_EQ] = ACTIONS(2442),
    [anon_sym_LBRACE] = ACTIONS(2442),
    [anon_sym_COMMA] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2442),
    [sym__automatic_semicolon] = ACTIONS(2442),
  },
  [1855] = {
    [anon_sym_EQ] = ACTIONS(2484),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_COMMA] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_PIPE] = ACTIONS(2486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2484),
    [sym__automatic_semicolon] = ACTIONS(2484),
  },
  [1856] = {
    [anon_sym_EQ] = ACTIONS(2438),
    [anon_sym_LBRACE] = ACTIONS(2438),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_RBRACE] = ACTIONS(2438),
    [anon_sym_SEMI] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2438),
    [anon_sym_PIPE] = ACTIONS(2440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2438),
    [sym__automatic_semicolon] = ACTIONS(2438),
  },
  [1857] = {
    [sym_class_heritage] = STATE(2729),
    [sym_class_body] = STATE(1431),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1924),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4974),
    [anon_sym_extends] = ACTIONS(4976),
  },
  [1858] = {
    [anon_sym_EQ] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_COMMA] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2392),
    [sym__automatic_semicolon] = ACTIONS(2392),
  },
  [1859] = {
    [sym_class_heritage] = STATE(2702),
    [sym_class_body] = STATE(1581),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1982),
    [sym_identifier] = ACTIONS(5002),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4974),
    [anon_sym_extends] = ACTIONS(4976),
  },
  [1860] = {
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2420),
    [sym__automatic_semicolon] = ACTIONS(2420),
  },
  [1861] = {
    [anon_sym_EQ] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2586),
    [anon_sym_RBRACE] = ACTIONS(2586),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2586),
    [sym__automatic_semicolon] = ACTIONS(2586),
  },
  [1862] = {
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2458),
    [anon_sym_COMMA] = ACTIONS(2458),
    [anon_sym_RBRACE] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2458),
    [anon_sym_AMP] = ACTIONS(2458),
    [anon_sym_PIPE] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2458),
    [sym__automatic_semicolon] = ACTIONS(2458),
  },
  [1863] = {
    [anon_sym_EQ] = ACTIONS(589),
    [anon_sym_LBRACE] = ACTIONS(589),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(2470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(589),
    [sym__automatic_semicolon] = ACTIONS(589),
  },
  [1864] = {
    [anon_sym_EQ] = ACTIONS(2434),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2434),
    [anon_sym_RBRACE] = ACTIONS(2434),
    [anon_sym_SEMI] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(5004),
    [anon_sym_AMP] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2434),
    [sym__automatic_semicolon] = ACTIONS(2434),
  },
  [1865] = {
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2430),
    [anon_sym_RBRACE] = ACTIONS(2430),
    [anon_sym_SEMI] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_PIPE] = ACTIONS(2432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2430),
    [sym__automatic_semicolon] = ACTIONS(2430),
  },
  [1866] = {
    [anon_sym_EQ] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(4406),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym_COLON] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4406),
    [anon_sym_QMARK] = ACTIONS(4406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4406),
    [sym__automatic_semicolon] = ACTIONS(4406),
  },
  [1867] = {
    [anon_sym_EQ] = ACTIONS(2412),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_PIPE] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2412),
    [sym__automatic_semicolon] = ACTIONS(2412),
  },
  [1868] = {
    [anon_sym_EQ] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2462),
    [sym__automatic_semicolon] = ACTIONS(2462),
  },
  [1869] = {
    [anon_sym_EQ] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2590),
    [sym__automatic_semicolon] = ACTIONS(2590),
  },
  [1870] = {
    [anon_sym_EQ] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_LBRACK] = ACTIONS(5004),
    [anon_sym_AMP] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2424),
    [sym__automatic_semicolon] = ACTIONS(2424),
  },
  [1871] = {
    [sym_class_heritage] = STATE(2729),
    [sym_class_body] = STATE(1431),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1924),
    [sym_identifier] = ACTIONS(5006),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4974),
    [anon_sym_extends] = ACTIONS(4976),
  },
  [1872] = {
    [anon_sym_EQ] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2378),
    [anon_sym_COMMA] = ACTIONS(2378),
    [anon_sym_RBRACE] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_PIPE] = ACTIONS(2380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2378),
    [sym__automatic_semicolon] = ACTIONS(2378),
  },
  [1873] = {
    [sym_class_heritage] = STATE(2622),
    [sym_class_body] = STATE(1022),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1920),
    [sym_identifier] = ACTIONS(5008),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4974),
    [anon_sym_extends] = ACTIONS(4976),
  },
  [1874] = {
    [anon_sym_EQ] = ACTIONS(2594),
    [anon_sym_LBRACE] = ACTIONS(2594),
    [anon_sym_COMMA] = ACTIONS(2594),
    [anon_sym_RBRACE] = ACTIONS(2594),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2594),
    [sym__automatic_semicolon] = ACTIONS(2594),
  },
  [1875] = {
    [anon_sym_EQ] = ACTIONS(2416),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2416),
    [sym__automatic_semicolon] = ACTIONS(2416),
  },
  [1876] = {
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_LBRACE] = ACTIONS(2450),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [anon_sym_SEMI] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2450),
    [anon_sym_PIPE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2450),
    [sym__automatic_semicolon] = ACTIONS(2450),
  },
  [1877] = {
    [sym_class_heritage] = STATE(2669),
    [sym_class_body] = STATE(557),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1942),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1878] = {
    [sym_class_heritage] = STATE(2723),
    [sym_class_body] = STATE(130),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1926),
    [anon_sym_LBRACE] = ACTIONS(5014),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1879] = {
    [sym__initializer] = STATE(2452),
    [sym_type_annotation] = STATE(2234),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4909),
    [anon_sym_SEMI] = ACTIONS(4909),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(4913),
    [anon_sym_BANG] = ACTIONS(4913),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4909),
  },
  [1880] = {
    [sym_class_heritage] = STATE(2651),
    [sym_class_body] = STATE(486),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1966),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1881] = {
    [sym_class_heritage] = STATE(2632),
    [sym_class_body] = STATE(1310),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1965),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1882] = {
    [sym_class_heritage] = STATE(2607),
    [sym_class_body] = STATE(1367),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1925),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1883] = {
    [sym_class_heritage] = STATE(2693),
    [sym_class_body] = STATE(1427),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1984),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1884] = {
    [sym_class_heritage] = STATE(2555),
    [sym_class_body] = STATE(1359),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1910),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1885] = {
    [sym_class_heritage] = STATE(2590),
    [sym_class_body] = STATE(476),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1938),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1886] = {
    [sym_class_heritage] = STATE(2715),
    [sym_class_body] = STATE(486),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1963),
    [anon_sym_LBRACE] = ACTIONS(5016),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1887] = {
    [sym_class_heritage] = STATE(2595),
    [sym_class_body] = STATE(1071),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1909),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1888] = {
    [anon_sym_EQ] = ACTIONS(5018),
    [anon_sym_LBRACE] = ACTIONS(5018),
    [anon_sym_COMMA] = ACTIONS(5018),
    [anon_sym_RBRACE] = ACTIONS(5018),
    [anon_sym_SEMI] = ACTIONS(5018),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5018),
    [sym__automatic_semicolon] = ACTIONS(5018),
  },
  [1889] = {
    [sym_class_heritage] = STATE(2628),
    [sym_class_body] = STATE(2262),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1964),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1890] = {
    [sym_class_heritage] = STATE(2641),
    [sym_class_body] = STATE(2228),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1946),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1891] = {
    [sym_class_heritage] = STATE(2738),
    [sym_class_body] = STATE(476),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1935),
    [anon_sym_LBRACE] = ACTIONS(5016),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1892] = {
    [sym__initializer] = STATE(2409),
    [sym_type_annotation] = STATE(2154),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(4894),
    [anon_sym_BANG] = ACTIONS(4894),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4890),
  },
  [1893] = {
    [sym_class_heritage] = STATE(2657),
    [sym_class_body] = STATE(1594),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1959),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1894] = {
    [sym_class_heritage] = STATE(2635),
    [sym_class_body] = STATE(1610),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1933),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1895] = {
    [sym_class_heritage] = STATE(2660),
    [sym_class_body] = STATE(2208),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1962),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1896] = {
    [sym_class_heritage] = STATE(2624),
    [sym_class_body] = STATE(124),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1931),
    [anon_sym_LBRACE] = ACTIONS(5014),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1897] = {
    [sym_class_heritage] = STATE(2666),
    [sym_class_body] = STATE(1112),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1967),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1898] = {
    [sym_class_heritage] = STATE(2686),
    [sym_class_body] = STATE(557),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [sym_type_parameters] = STATE(1921),
    [anon_sym_LBRACE] = ACTIONS(5020),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1899] = {
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_RPAREN] = ACTIONS(5022),
    [anon_sym_COLON] = ACTIONS(3470),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_PIPE] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
  },
  [1900] = {
    [aux_sym_object_repeat1] = STATE(2484),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
  },
  [1901] = {
    [aux_sym_object_repeat1] = STATE(2399),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
  },
  [1902] = {
    [anon_sym_EQ] = ACTIONS(608),
    [anon_sym_COMMA] = ACTIONS(608),
    [anon_sym_RPAREN] = ACTIONS(5025),
    [anon_sym_COLON] = ACTIONS(608),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_QMARK] = ACTIONS(608),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
  },
  [1903] = {
    [sym_type_annotation] = STATE(2058),
    [anon_sym_LBRACE] = ACTIONS(5028),
    [anon_sym_COMMA] = ACTIONS(5028),
    [anon_sym_RBRACE] = ACTIONS(5028),
    [anon_sym_SEMI] = ACTIONS(5028),
    [anon_sym_COLON] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5028),
    [sym__automatic_semicolon] = ACTIONS(5028),
  },
  [1904] = {
    [sym_type_annotation] = STATE(2007),
    [anon_sym_LBRACE] = ACTIONS(5030),
    [anon_sym_COMMA] = ACTIONS(5030),
    [anon_sym_RBRACE] = ACTIONS(5030),
    [anon_sym_SEMI] = ACTIONS(5030),
    [anon_sym_COLON] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5030),
    [sym__automatic_semicolon] = ACTIONS(5030),
  },
  [1905] = {
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_RPAREN] = ACTIONS(2484),
    [anon_sym_COLON] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_PIPE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
  },
  [1906] = {
    [sym_statement_block] = STATE(108),
    [anon_sym_LBRACE] = ACTIONS(5032),
    [anon_sym_COMMA] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_DOT] = ACTIONS(5034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1071),
    [sym__automatic_semicolon] = ACTIONS(1071),
  },
  [1907] = {
    [aux_sym_object_repeat1] = STATE(2392),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
  },
  [1908] = {
    [sym_class_heritage] = STATE(2644),
    [sym_class_body] = STATE(1614),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1909] = {
    [sym_class_heritage] = STATE(2653),
    [sym_class_body] = STATE(1107),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1910] = {
    [sym_class_heritage] = STATE(2615),
    [sym_class_body] = STATE(1296),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1911] = {
    [sym_statement_block] = STATE(108),
    [anon_sym_LBRACE] = ACTIONS(5032),
    [anon_sym_COMMA] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1071),
    [sym__automatic_semicolon] = ACTIONS(1071),
  },
  [1912] = {
    [sym_statement_block] = STATE(2553),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(5036),
    [anon_sym_RBRACE] = ACTIONS(5036),
    [anon_sym_SEMI] = ACTIONS(5036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5036),
    [sym__automatic_semicolon] = ACTIONS(5036),
  },
  [1913] = {
    [sym__call_signature] = STATE(2557),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5038),
    [anon_sym_STAR] = ACTIONS(5040),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [1914] = {
    [sym__call_signature] = STATE(2537),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5044),
    [anon_sym_STAR] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [1915] = {
    [sym_nested_identifier] = STATE(464),
    [sym_string] = STATE(485),
    [sym__module] = STATE(579),
    [sym_identifier] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(5050),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
  },
  [1916] = {
    [sym_extends_clause] = STATE(2417),
    [sym_object_type] = STATE(2133),
    [sym_type_parameters] = STATE(2149),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_LT] = ACTIONS(5052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
  },
  [1917] = {
    [sym_statement_block] = STATE(2559),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(5056),
    [anon_sym_RBRACE] = ACTIONS(5056),
    [anon_sym_SEMI] = ACTIONS(5056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5056),
    [sym__automatic_semicolon] = ACTIONS(5056),
  },
  [1918] = {
    [sym__initializer] = STATE(2403),
    [sym_type_annotation] = STATE(2260),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4955),
    [anon_sym_SEMI] = ACTIONS(4955),
    [anon_sym_COLON] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4955),
  },
  [1919] = {
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_COMMA] = ACTIONS(4639),
    [anon_sym_RBRACE] = ACTIONS(4639),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
  },
  [1920] = {
    [sym_class_heritage] = STATE(2556),
    [sym_class_body] = STATE(1023),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1921] = {
    [sym_class_heritage] = STATE(2564),
    [sym_class_body] = STATE(506),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(5020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1922] = {
    [sym__call_signature] = STATE(2682),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5058),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [1923] = {
    [sym__initializer] = STATE(2526),
    [sym_type_annotation] = STATE(2072),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(3649),
    [anon_sym_SEMI] = ACTIONS(3649),
    [anon_sym_COLON] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3649),
  },
  [1924] = {
    [sym_class_heritage] = STATE(2722),
    [sym_class_body] = STATE(1410),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1925] = {
    [sym_class_heritage] = STATE(2707),
    [sym_class_body] = STATE(1422),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1926] = {
    [sym_class_heritage] = STATE(2597),
    [sym_class_body] = STATE(123),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(5014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1927] = {
    [anon_sym_EQ] = ACTIONS(5062),
    [anon_sym_LBRACE] = ACTIONS(5018),
    [anon_sym_COMMA] = ACTIONS(5018),
    [anon_sym_RPAREN] = ACTIONS(5018),
    [anon_sym_EQ_GT] = ACTIONS(5018),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [1928] = {
    [sym_statement_block] = STATE(2565),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(5064),
    [anon_sym_RBRACE] = ACTIONS(5064),
    [anon_sym_SEMI] = ACTIONS(5064),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5064),
    [sym__automatic_semicolon] = ACTIONS(5064),
  },
  [1929] = {
    [anon_sym_LBRACE] = ACTIONS(3725),
    [anon_sym_COMMA] = ACTIONS(3725),
    [anon_sym_RBRACE] = ACTIONS(3725),
    [anon_sym_SEMI] = ACTIONS(3725),
    [anon_sym_COLON] = ACTIONS(3725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3725),
    [sym__automatic_semicolon] = ACTIONS(3725),
  },
  [1930] = {
    [sym__initializer] = STATE(2495),
    [sym_type_annotation] = STATE(2096),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym_COLON] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3100),
  },
  [1931] = {
    [sym_class_heritage] = STATE(2667),
    [sym_class_body] = STATE(119),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(5014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1932] = {
    [sym_statement_block] = STATE(2633),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(5066),
    [anon_sym_RBRACE] = ACTIONS(5066),
    [anon_sym_SEMI] = ACTIONS(5066),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5066),
    [sym__automatic_semicolon] = ACTIONS(5066),
  },
  [1933] = {
    [sym_class_heritage] = STATE(2625),
    [sym_class_body] = STATE(1600),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1934] = {
    [anon_sym_LBRACE] = ACTIONS(5068),
    [anon_sym_COMMA] = ACTIONS(5068),
    [anon_sym_RBRACE] = ACTIONS(5068),
    [anon_sym_SEMI] = ACTIONS(5068),
    [anon_sym_COLON] = ACTIONS(5068),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5068),
    [sym__automatic_semicolon] = ACTIONS(5068),
  },
  [1935] = {
    [sym_class_heritage] = STATE(2717),
    [sym_class_body] = STATE(493),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(5016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1936] = {
    [sym_class_heritage] = STATE(2701),
    [sym_class_body] = STATE(1103),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1937] = {
    [sym__call_signature] = STATE(2706),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_STAR] = ACTIONS(5072),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [1938] = {
    [sym_class_heritage] = STATE(2648),
    [sym_class_body] = STATE(493),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1939] = {
    [sym_statement_block] = STATE(2647),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(5074),
    [anon_sym_RBRACE] = ACTIONS(5074),
    [anon_sym_SEMI] = ACTIONS(5074),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5074),
    [sym__automatic_semicolon] = ACTIONS(5074),
  },
  [1940] = {
    [sym_statement_block] = STATE(2700),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(5076),
    [anon_sym_RBRACE] = ACTIONS(5076),
    [anon_sym_SEMI] = ACTIONS(5076),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5076),
    [sym__automatic_semicolon] = ACTIONS(5076),
  },
  [1941] = {
    [sym__initializer] = STATE(2408),
    [sym_type_annotation] = STATE(2146),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4964),
    [anon_sym_SEMI] = ACTIONS(4964),
    [anon_sym_COLON] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4964),
  },
  [1942] = {
    [sym_class_heritage] = STATE(2680),
    [sym_class_body] = STATE(506),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1943] = {
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2574),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2574),
    [sym__automatic_semicolon] = ACTIONS(2574),
  },
  [1944] = {
    [sym_default_type] = STATE(2621),
    [sym_constraint] = STATE(2326),
    [anon_sym_EQ] = ACTIONS(4902),
    [anon_sym_COMMA] = ACTIONS(5078),
    [anon_sym_COLON] = ACTIONS(4907),
    [anon_sym_GT] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(4907),
  },
  [1945] = {
    [sym_type_annotation] = STATE(2107),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_COLON] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5080),
    [sym__automatic_semicolon] = ACTIONS(5080),
  },
  [1946] = {
    [sym_class_heritage] = STATE(2630),
    [sym_class_body] = STATE(2168),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1947] = {
    [sym_variable_declarator] = STATE(2327),
    [sym_object] = STATE(1949),
    [sym_array] = STATE(1923),
    [sym_identifier] = ACTIONS(5082),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
    [anon_sym_enum] = ACTIONS(5084),
  },
  [1948] = {
    [sym_statement_block] = STATE(2696),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(5086),
    [anon_sym_RBRACE] = ACTIONS(5086),
    [anon_sym_SEMI] = ACTIONS(5086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5086),
    [sym__automatic_semicolon] = ACTIONS(5086),
  },
  [1949] = {
    [sym__initializer] = STATE(2503),
    [sym_type_annotation] = STATE(2082),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3698),
  },
  [1950] = {
    [sym_statement_block] = STATE(2533),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(5088),
    [anon_sym_RBRACE] = ACTIONS(5088),
    [anon_sym_SEMI] = ACTIONS(5088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5088),
    [sym__automatic_semicolon] = ACTIONS(5088),
  },
  [1951] = {
    [sym_predefined_type] = STATE(2859),
    [anon_sym_void] = ACTIONS(5090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(5090),
    [anon_sym_number] = ACTIONS(5090),
    [anon_sym_boolean] = ACTIONS(5090),
    [anon_sym_string] = ACTIONS(5090),
    [anon_sym_symbol] = ACTIONS(5090),
  },
  [1952] = {
    [sym_predefined_type] = STATE(2867),
    [anon_sym_void] = ACTIONS(5090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(5090),
    [anon_sym_number] = ACTIONS(5090),
    [anon_sym_boolean] = ACTIONS(5090),
    [anon_sym_string] = ACTIONS(5090),
    [anon_sym_symbol] = ACTIONS(5090),
  },
  [1953] = {
    [anon_sym_LBRACE] = ACTIONS(5092),
    [anon_sym_COMMA] = ACTIONS(5092),
    [anon_sym_RBRACE] = ACTIONS(5092),
    [anon_sym_SEMI] = ACTIONS(5092),
    [anon_sym_COLON] = ACTIONS(5092),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5092),
    [sym__automatic_semicolon] = ACTIONS(5092),
  },
  [1954] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_string] = STATE(1911),
    [sym__module] = STATE(2078),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_DOT] = ACTIONS(5096),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
  },
  [1955] = {
    [anon_sym_LBRACE] = ACTIONS(5098),
    [anon_sym_COMMA] = ACTIONS(5098),
    [anon_sym_RBRACE] = ACTIONS(5098),
    [anon_sym_SEMI] = ACTIONS(5098),
    [anon_sym_COLON] = ACTIONS(5098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5098),
    [sym__automatic_semicolon] = ACTIONS(5098),
  },
  [1956] = {
    [sym_extends_clause] = STATE(2499),
    [sym_object_type] = STATE(565),
    [sym_type_parameters] = STATE(2257),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(5052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1957] = {
    [sym_statement_block] = STATE(2566),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(5100),
    [anon_sym_RBRACE] = ACTIONS(5100),
    [anon_sym_SEMI] = ACTIONS(5100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5100),
    [sym__automatic_semicolon] = ACTIONS(5100),
  },
  [1958] = {
    [sym_statement_block] = STATE(2611),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(5102),
    [anon_sym_RBRACE] = ACTIONS(5102),
    [anon_sym_SEMI] = ACTIONS(5102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5102),
    [sym__automatic_semicolon] = ACTIONS(5102),
  },
  [1959] = {
    [sym_class_heritage] = STATE(2638),
    [sym_class_body] = STATE(1612),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1960] = {
    [sym_statement_block] = STATE(2708),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_SEMI] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5104),
    [sym__automatic_semicolon] = ACTIONS(5104),
  },
  [1961] = {
    [sym_statement_block] = STATE(2736),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(5106),
    [anon_sym_RBRACE] = ACTIONS(5106),
    [anon_sym_SEMI] = ACTIONS(5106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5106),
    [sym__automatic_semicolon] = ACTIONS(5106),
  },
  [1962] = {
    [sym_class_heritage] = STATE(2642),
    [sym_class_body] = STATE(2233),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1963] = {
    [sym_class_heritage] = STATE(2569),
    [sym_class_body] = STATE(492),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(5016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1964] = {
    [sym_class_heritage] = STATE(2675),
    [sym_class_body] = STATE(2192),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1965] = {
    [sym_class_heritage] = STATE(2677),
    [sym_class_body] = STATE(1361),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1966] = {
    [sym_class_heritage] = STATE(2679),
    [sym_class_body] = STATE(492),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1967] = {
    [sym_class_heritage] = STATE(2684),
    [sym_class_body] = STATE(1125),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1968] = {
    [sym__call_signature] = STATE(2706),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5108),
    [anon_sym_STAR] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [1969] = {
    [sym_variable_declarator] = STATE(2344),
    [sym_object] = STATE(1949),
    [sym_array] = STATE(1923),
    [sym_identifier] = ACTIONS(5082),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
    [anon_sym_enum] = ACTIONS(5112),
  },
  [1970] = {
    [sym_class_heritage] = STATE(2668),
    [sym_class_body] = STATE(1430),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1971] = {
    [sym__call_signature] = STATE(2682),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5114),
    [anon_sym_STAR] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [1972] = {
    [sym_type_annotation] = STATE(2156),
    [anon_sym_COMMA] = ACTIONS(5118),
    [anon_sym_RBRACE] = ACTIONS(5118),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_COLON] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5118),
    [sym__automatic_semicolon] = ACTIONS(5118),
  },
  [1973] = {
    [sym__call_signature] = STATE(2671),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5120),
    [anon_sym_STAR] = ACTIONS(5122),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [1974] = {
    [sym_nested_identifier] = STATE(464),
    [sym_string] = STATE(485),
    [sym__module] = STATE(579),
    [sym_identifier] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(5124),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
  },
  [1975] = {
    [sym__initializer] = STATE(2528),
    [sym_type_annotation] = STATE(2283),
    [anon_sym_EQ] = ACTIONS(5126),
    [anon_sym_COMMA] = ACTIONS(5128),
    [anon_sym_RPAREN] = ACTIONS(5128),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_QMARK] = ACTIONS(5130),
    [sym_comment] = ACTIONS(3),
  },
  [1976] = {
    [sym__call_signature] = STATE(2682),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5132),
    [anon_sym_STAR] = ACTIONS(5134),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [1977] = {
    [sym__initializer] = STATE(2414),
    [sym_type_annotation] = STATE(2130),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4959),
    [anon_sym_SEMI] = ACTIONS(4959),
    [anon_sym_COLON] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4959),
  },
  [1978] = {
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_else] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(1199),
    [anon_sym_SEMI] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1199),
    [sym__automatic_semicolon] = ACTIONS(4134),
  },
  [1979] = {
    [sym__call_signature] = STATE(2694),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5136),
    [anon_sym_STAR] = ACTIONS(5138),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [1980] = {
    [sym__call_signature] = STATE(2612),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_COLON] = ACTIONS(5140),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5142),
    [sym_comment] = ACTIONS(3),
  },
  [1981] = {
    [sym__initializer] = STATE(2406),
    [sym_type_annotation] = STATE(2163),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(4945),
    [anon_sym_SEMI] = ACTIONS(4945),
    [anon_sym_COLON] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4945),
  },
  [1982] = {
    [sym_class_heritage] = STATE(2673),
    [sym_class_body] = STATE(1506),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1983] = {
    [sym__call_signature] = STATE(2706),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5144),
    [anon_sym_STAR] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [1984] = {
    [sym_class_heritage] = STATE(2538),
    [sym_class_body] = STATE(1457),
    [sym_implements_clause] = STATE(2762),
    [sym_extends_clause] = STATE(2473),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
    [anon_sym_extends] = ACTIONS(5012),
  },
  [1985] = {
    [anon_sym_LBRACE] = ACTIONS(5148),
    [anon_sym_COMMA] = ACTIONS(5148),
    [anon_sym_RBRACE] = ACTIONS(5148),
    [anon_sym_SEMI] = ACTIONS(5148),
    [anon_sym_COLON] = ACTIONS(5148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5148),
    [sym__automatic_semicolon] = ACTIONS(5148),
  },
  [1986] = {
    [sym__call_signature] = STATE(2182),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5150),
    [sym_comment] = ACTIONS(3),
  },
  [1987] = {
    [aux_sym_object_type_repeat1] = STATE(2022),
    [anon_sym_COMMA] = ACTIONS(5152),
    [anon_sym_RBRACE] = ACTIONS(5154),
    [anon_sym_SEMI] = ACTIONS(5152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5154),
    [sym__automatic_semicolon] = ACTIONS(5152),
  },
  [1988] = {
    [sym__call_signature] = STATE(2617),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5156),
    [sym_comment] = ACTIONS(3),
  },
  [1989] = {
    [sym_template_substitution] = STATE(2003),
    [aux_sym_template_string_repeat1] = STATE(2003),
    [sym_escape_sequence] = ACTIONS(5158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5162),
    [sym__template_chars] = ACTIONS(5158),
  },
  [1990] = {
    [sym__call_signature] = STATE(2110),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5164),
    [sym_comment] = ACTIONS(3),
  },
  [1991] = {
    [sym_template_substitution] = STATE(2003),
    [aux_sym_template_string_repeat1] = STATE(2003),
    [sym_escape_sequence] = ACTIONS(5158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5162),
    [sym__template_chars] = ACTIONS(5158),
  },
  [1992] = {
    [sym_nested_identifier] = STATE(464),
    [sym_string] = STATE(485),
    [sym__module] = STATE(519),
    [sym_identifier] = ACTIONS(5048),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
  },
  [1993] = {
    [sym__call_signature] = STATE(2400),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5168),
    [sym_comment] = ACTIONS(3),
  },
  [1994] = {
    [sym_switch_case] = STATE(1994),
    [sym_switch_default] = STATE(1994),
    [aux_sym_switch_body_repeat1] = STATE(1994),
    [anon_sym_default] = ACTIONS(5170),
    [anon_sym_RBRACE] = ACTIONS(5173),
    [anon_sym_case] = ACTIONS(5175),
    [sym_comment] = ACTIONS(3),
  },
  [1995] = {
    [sym_variable_declarator] = STATE(2332),
    [sym_object] = STATE(1949),
    [sym_array] = STATE(1923),
    [sym_identifier] = ACTIONS(5178),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [1996] = {
    [aux_sym_object_type_repeat1] = STATE(2019),
    [anon_sym_COMMA] = ACTIONS(5180),
    [anon_sym_RBRACE] = ACTIONS(5182),
    [anon_sym_SEMI] = ACTIONS(5180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5182),
    [sym__automatic_semicolon] = ACTIONS(5180),
  },
  [1997] = {
    [sym__call_signature] = STATE(2688),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [1998] = {
    [sym__call_signature] = STATE(2073),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5186),
    [sym_comment] = ACTIONS(3),
  },
  [1999] = {
    [aux_sym_object_type_repeat1] = STATE(2033),
    [anon_sym_COMMA] = ACTIONS(5188),
    [anon_sym_RBRACE] = ACTIONS(5190),
    [anon_sym_SEMI] = ACTIONS(5188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5190),
    [sym__automatic_semicolon] = ACTIONS(5188),
  },
  [2000] = {
    [sym__call_signature] = STATE(2689),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5192),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2001] = {
    [sym__call_signature] = STATE(2688),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5194),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2002] = {
    [sym__call_signature] = STATE(2144),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5196),
    [sym_comment] = ACTIONS(3),
  },
  [2003] = {
    [sym_template_substitution] = STATE(2003),
    [aux_sym_template_string_repeat1] = STATE(2003),
    [sym_escape_sequence] = ACTIONS(5198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5203),
    [sym__template_chars] = ACTIONS(5198),
  },
  [2004] = {
    [sym__call_signature] = STATE(2534),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5206),
    [sym_comment] = ACTIONS(3),
  },
  [2005] = {
    [sym__import_export_specifier] = STATE(2383),
    [sym_identifier] = ACTIONS(5208),
    [anon_sym_COMMA] = ACTIONS(5210),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_type] = ACTIONS(5214),
    [anon_sym_typeof] = ACTIONS(5214),
    [sym_comment] = ACTIONS(3),
  },
  [2006] = {
    [aux_sym_object_type_repeat1] = STATE(2055),
    [anon_sym_COMMA] = ACTIONS(5216),
    [anon_sym_RBRACE] = ACTIONS(3581),
    [anon_sym_SEMI] = ACTIONS(5216),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3581),
    [sym__automatic_semicolon] = ACTIONS(5216),
  },
  [2007] = {
    [anon_sym_LBRACE] = ACTIONS(5218),
    [anon_sym_COMMA] = ACTIONS(5218),
    [anon_sym_RBRACE] = ACTIONS(5218),
    [anon_sym_SEMI] = ACTIONS(5218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5218),
    [sym__automatic_semicolon] = ACTIONS(5218),
  },
  [2008] = {
    [sym__call_signature] = STATE(2689),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5220),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2009] = {
    [sym_variable_declarator] = STATE(2344),
    [sym_object] = STATE(1949),
    [sym_array] = STATE(1923),
    [sym_identifier] = ACTIONS(5178),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [2010] = {
    [anon_sym_EQ] = ACTIONS(4406),
    [anon_sym_COMMA] = ACTIONS(4406),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4406),
    [anon_sym_QMARK] = ACTIONS(4406),
    [sym_comment] = ACTIONS(3),
  },
  [2011] = {
    [sym__call_signature] = STATE(2710),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5222),
    [sym_comment] = ACTIONS(3),
  },
  [2012] = {
    [sym__call_signature] = STATE(2670),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5224),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2013] = {
    [sym_arguments] = STATE(1681),
    [anon_sym_export] = ACTIONS(4635),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(5226),
    [anon_sym_class] = ACTIONS(4635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(4635),
  },
  [2014] = {
    [sym_variable_declarator] = STATE(2345),
    [sym_object] = STATE(1949),
    [sym_array] = STATE(1923),
    [sym_identifier] = ACTIONS(5178),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [2015] = {
    [sym__import_export_specifier] = STATE(2480),
    [sym_identifier] = ACTIONS(5208),
    [anon_sym_COMMA] = ACTIONS(5228),
    [anon_sym_RBRACE] = ACTIONS(5230),
    [anon_sym_type] = ACTIONS(5214),
    [anon_sym_typeof] = ACTIONS(5214),
    [sym_comment] = ACTIONS(3),
  },
  [2016] = {
    [aux_sym_object_type_repeat1] = STATE(2061),
    [anon_sym_COMMA] = ACTIONS(5232),
    [anon_sym_RBRACE] = ACTIONS(3583),
    [anon_sym_SEMI] = ACTIONS(5232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3583),
    [sym__automatic_semicolon] = ACTIONS(5232),
  },
  [2017] = {
    [aux_sym_object_type_repeat1] = STATE(2040),
    [anon_sym_COMMA] = ACTIONS(5234),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_SEMI] = ACTIONS(5234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5236),
    [sym__automatic_semicolon] = ACTIONS(5234),
  },
  [2018] = {
    [sym_template_substitution] = STATE(1991),
    [aux_sym_template_string_repeat1] = STATE(1991),
    [sym_escape_sequence] = ACTIONS(5238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5240),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5162),
    [sym__template_chars] = ACTIONS(5238),
  },
  [2019] = {
    [aux_sym_object_type_repeat1] = STATE(2055),
    [anon_sym_COMMA] = ACTIONS(5232),
    [anon_sym_RBRACE] = ACTIONS(3583),
    [anon_sym_SEMI] = ACTIONS(5232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3583),
    [sym__automatic_semicolon] = ACTIONS(5232),
  },
  [2020] = {
    [sym_template_substitution] = STATE(2057),
    [aux_sym_template_string_repeat1] = STATE(2057),
    [sym_escape_sequence] = ACTIONS(5242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5244),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5162),
    [sym__template_chars] = ACTIONS(5242),
  },
  [2021] = {
    [sym__call_signature] = STATE(2554),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5246),
    [sym_comment] = ACTIONS(3),
  },
  [2022] = {
    [aux_sym_object_type_repeat1] = STATE(2055),
    [anon_sym_COMMA] = ACTIONS(5248),
    [anon_sym_RBRACE] = ACTIONS(3577),
    [anon_sym_SEMI] = ACTIONS(5248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3577),
    [sym__automatic_semicolon] = ACTIONS(5248),
  },
  [2023] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_string] = STATE(1911),
    [sym__module] = STATE(107),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
  },
  [2024] = {
    [sym_variable_declarator] = STATE(2327),
    [sym_object] = STATE(1949),
    [sym_array] = STATE(1923),
    [sym_identifier] = ACTIONS(5178),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [2025] = {
    [aux_sym_object_type_repeat1] = STATE(2006),
    [anon_sym_COMMA] = ACTIONS(5248),
    [anon_sym_RBRACE] = ACTIONS(3577),
    [anon_sym_SEMI] = ACTIONS(5248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3577),
    [sym__automatic_semicolon] = ACTIONS(5248),
  },
  [2026] = {
    [sym__call_signature] = STATE(1917),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5250),
    [sym_comment] = ACTIONS(3),
  },
  [2027] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_string] = STATE(1911),
    [sym__module] = STATE(2078),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
  },
  [2028] = {
    [anon_sym_LBRACE] = ACTIONS(5252),
    [anon_sym_COMMA] = ACTIONS(5252),
    [anon_sym_RBRACK] = ACTIONS(5252),
    [anon_sym_GT] = ACTIONS(5252),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2029] = {
    [sym_arguments] = STATE(1680),
    [anon_sym_export] = ACTIONS(4627),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(5254),
    [anon_sym_class] = ACTIONS(4627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(4627),
  },
  [2030] = {
    [aux_sym_object_type_repeat1] = STATE(2055),
    [anon_sym_COMMA] = ACTIONS(5256),
    [anon_sym_RBRACE] = ACTIONS(3571),
    [anon_sym_SEMI] = ACTIONS(5256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3571),
    [sym__automatic_semicolon] = ACTIONS(5256),
  },
  [2031] = {
    [aux_sym_object_type_repeat1] = STATE(2051),
    [anon_sym_COMMA] = ACTIONS(5258),
    [anon_sym_RBRACE] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(5258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3585),
    [sym__automatic_semicolon] = ACTIONS(5258),
  },
  [2032] = {
    [sym_type_arguments] = STATE(417),
    [aux_sym_extends_clause_repeat1] = STATE(2300),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3426),
    [anon_sym_LT] = ACTIONS(4874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(3823),
  },
  [2033] = {
    [aux_sym_object_type_repeat1] = STATE(2055),
    [anon_sym_COMMA] = ACTIONS(5258),
    [anon_sym_RBRACE] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(5258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3585),
    [sym__automatic_semicolon] = ACTIONS(5258),
  },
  [2034] = {
    [sym__call_signature] = STATE(2106),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5260),
    [sym_comment] = ACTIONS(3),
  },
  [2035] = {
    [sym__call_signature] = STATE(1940),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5262),
    [sym_comment] = ACTIONS(3),
  },
  [2036] = {
    [sym__call_signature] = STATE(1950),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5264),
    [sym_comment] = ACTIONS(3),
  },
  [2037] = {
    [sym__call_signature] = STATE(2157),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5266),
    [sym_comment] = ACTIONS(3),
  },
  [2038] = {
    [sym__call_signature] = STATE(2411),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5268),
    [sym_comment] = ACTIONS(3),
  },
  [2039] = {
    [sym_variable_declarator] = STATE(2445),
    [sym_object] = STATE(1949),
    [sym_array] = STATE(1923),
    [sym_identifier] = ACTIONS(5178),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [2040] = {
    [aux_sym_object_type_repeat1] = STATE(2055),
    [anon_sym_COMMA] = ACTIONS(5270),
    [anon_sym_RBRACE] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(5270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3591),
    [sym__automatic_semicolon] = ACTIONS(5270),
  },
  [2041] = {
    [sym__call_signature] = STATE(1961),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5272),
    [sym_comment] = ACTIONS(3),
  },
  [2042] = {
    [sym_switch_case] = STATE(2066),
    [sym_switch_default] = STATE(2066),
    [aux_sym_switch_body_repeat1] = STATE(2066),
    [anon_sym_default] = ACTIONS(5274),
    [anon_sym_RBRACE] = ACTIONS(5276),
    [anon_sym_case] = ACTIONS(5278),
    [sym_comment] = ACTIONS(3),
  },
  [2043] = {
    [sym__call_signature] = STATE(2646),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5280),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2044] = {
    [sym_type_arguments] = STATE(1558),
    [aux_sym_extends_clause_repeat1] = STATE(2284),
    [anon_sym_LBRACE] = ACTIONS(3793),
    [anon_sym_COMMA] = ACTIONS(3411),
    [anon_sym_LT] = ACTIONS(5282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3823),
  },
  [2045] = {
    [sym__call_signature] = STATE(2126),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5284),
    [sym_comment] = ACTIONS(3),
  },
  [2046] = {
    [aux_sym_object_type_repeat1] = STATE(2055),
    [anon_sym_COMMA] = ACTIONS(5286),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_SEMI] = ACTIONS(5286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3589),
    [sym__automatic_semicolon] = ACTIONS(5286),
  },
  [2047] = {
    [sym__call_signature] = STATE(2618),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5288),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2048] = {
    [sym_template_substitution] = STATE(1989),
    [aux_sym_template_string_repeat1] = STATE(1989),
    [sym_escape_sequence] = ACTIONS(5290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5162),
    [sym__template_chars] = ACTIONS(5290),
  },
  [2049] = {
    [sym__call_signature] = STATE(2248),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5294),
    [sym_comment] = ACTIONS(3),
  },
  [2050] = {
    [sym__call_signature] = STATE(2689),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5296),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2051] = {
    [aux_sym_object_type_repeat1] = STATE(2055),
    [anon_sym_COMMA] = ACTIONS(5298),
    [anon_sym_RBRACE] = ACTIONS(3579),
    [anon_sym_SEMI] = ACTIONS(5298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3579),
    [sym__automatic_semicolon] = ACTIONS(5298),
  },
  [2052] = {
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
  },
  [2053] = {
    [aux_sym_object_type_repeat1] = STATE(2030),
    [anon_sym_COMMA] = ACTIONS(5270),
    [anon_sym_RBRACE] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(5270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3591),
    [sym__automatic_semicolon] = ACTIONS(5270),
  },
  [2054] = {
    [sym__call_signature] = STATE(2175),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5300),
    [sym_comment] = ACTIONS(3),
  },
  [2055] = {
    [aux_sym_object_type_repeat1] = STATE(2055),
    [anon_sym_COMMA] = ACTIONS(5302),
    [anon_sym_RBRACE] = ACTIONS(5305),
    [anon_sym_SEMI] = ACTIONS(5302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5305),
    [sym__automatic_semicolon] = ACTIONS(5302),
  },
  [2056] = {
    [sym__call_signature] = STATE(2626),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5307),
    [sym_comment] = ACTIONS(3),
  },
  [2057] = {
    [sym_template_substitution] = STATE(2003),
    [aux_sym_template_string_repeat1] = STATE(2003),
    [sym_escape_sequence] = ACTIONS(5158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5309),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5162),
    [sym__template_chars] = ACTIONS(5158),
  },
  [2058] = {
    [anon_sym_LBRACE] = ACTIONS(5311),
    [anon_sym_COMMA] = ACTIONS(5311),
    [anon_sym_RBRACE] = ACTIONS(5311),
    [anon_sym_SEMI] = ACTIONS(5311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5311),
    [sym__automatic_semicolon] = ACTIONS(5311),
  },
  [2059] = {
    [aux_sym_object_type_repeat1] = STATE(2069),
    [anon_sym_COMMA] = ACTIONS(5313),
    [anon_sym_RBRACE] = ACTIONS(5315),
    [anon_sym_SEMI] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5315),
    [sym__automatic_semicolon] = ACTIONS(5313),
  },
  [2060] = {
    [sym__call_signature] = STATE(2688),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2061] = {
    [aux_sym_object_type_repeat1] = STATE(2055),
    [anon_sym_COMMA] = ACTIONS(5319),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_SEMI] = ACTIONS(5319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3575),
    [sym__automatic_semicolon] = ACTIONS(5319),
  },
  [2062] = {
    [sym__initializer] = STATE(2539),
    [sym_type_annotation] = STATE(2281),
    [anon_sym_EQ] = ACTIONS(5126),
    [anon_sym_COMMA] = ACTIONS(5321),
    [anon_sym_RPAREN] = ACTIONS(5321),
    [anon_sym_COLON] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
  },
  [2063] = {
    [sym__call_signature] = STATE(2558),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [sym_identifier] = ACTIONS(5323),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2064] = {
    [sym_nested_identifier] = STATE(464),
    [sym_string] = STATE(485),
    [sym__module] = STATE(579),
    [sym_identifier] = ACTIONS(5048),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
  },
  [2065] = {
    [sym_nested_identifier] = STATE(464),
    [sym_string] = STATE(485),
    [sym__module] = STATE(519),
    [sym_identifier] = ACTIONS(5048),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
  },
  [2066] = {
    [sym_switch_case] = STATE(1994),
    [sym_switch_default] = STATE(1994),
    [aux_sym_switch_body_repeat1] = STATE(1994),
    [anon_sym_default] = ACTIONS(5274),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [anon_sym_case] = ACTIONS(5278),
    [sym_comment] = ACTIONS(3),
  },
  [2067] = {
    [sym__call_signature] = STATE(1932),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
  },
  [2068] = {
    [sym_nested_identifier] = STATE(464),
    [sym_string] = STATE(485),
    [sym__module] = STATE(579),
    [sym_identifier] = ACTIONS(5048),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
  },
  [2069] = {
    [aux_sym_object_type_repeat1] = STATE(2055),
    [anon_sym_COMMA] = ACTIONS(5329),
    [anon_sym_RBRACE] = ACTIONS(3595),
    [anon_sym_SEMI] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3595),
    [sym__automatic_semicolon] = ACTIONS(5329),
  },
  [2070] = {
    [sym__call_signature] = STATE(2117),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(5331),
    [sym_comment] = ACTIONS(3),
  },
  [2071] = {
    [aux_sym_object_type_repeat1] = STATE(2046),
    [anon_sym_COMMA] = ACTIONS(5329),
    [anon_sym_RBRACE] = ACTIONS(3595),
    [anon_sym_SEMI] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3595),
    [sym__automatic_semicolon] = ACTIONS(5329),
  },
  [2072] = {
    [sym__initializer] = STATE(2455),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(5333),
    [anon_sym_SEMI] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5333),
  },
  [2073] = {
    [sym_statement_block] = STATE(1702),
    [anon_sym_LBRACE] = ACTIONS(5335),
    [anon_sym_COMMA] = ACTIONS(5076),
    [anon_sym_SEMI] = ACTIONS(5076),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5076),
  },
  [2074] = {
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RBRACE] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(2754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2754),
    [sym__automatic_semicolon] = ACTIONS(2754),
  },
  [2075] = {
    [anon_sym_EQ] = ACTIONS(5337),
    [anon_sym_COMMA] = ACTIONS(5337),
    [anon_sym_RPAREN] = ACTIONS(5337),
    [anon_sym_COLON] = ACTIONS(5337),
    [anon_sym_QMARK] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
  },
  [2076] = {
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [anon_sym_SEMI] = ACTIONS(2750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2750),
    [sym__automatic_semicolon] = ACTIONS(2750),
  },
  [2077] = {
    [anon_sym_COMMA] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(2906),
    [anon_sym_SEMI] = ACTIONS(2906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2906),
    [sym__automatic_semicolon] = ACTIONS(2906),
  },
  [2078] = {
    [anon_sym_COMMA] = ACTIONS(2914),
    [anon_sym_RBRACE] = ACTIONS(2914),
    [anon_sym_SEMI] = ACTIONS(2914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2914),
    [sym__automatic_semicolon] = ACTIONS(2914),
  },
  [2079] = {
    [sym__call_signature] = STATE(2697),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2080] = {
    [sym__call_signature] = STATE(2676),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2081] = {
    [anon_sym_EQ] = ACTIONS(5339),
    [anon_sym_COMMA] = ACTIONS(5339),
    [anon_sym_RPAREN] = ACTIONS(5339),
    [anon_sym_COLON] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5339),
    [sym_comment] = ACTIONS(3),
  },
  [2082] = {
    [sym__initializer] = STATE(2450),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(5341),
    [anon_sym_SEMI] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5341),
  },
  [2083] = {
    [sym__call_signature] = STATE(2678),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2084] = {
    [anon_sym_EQ] = ACTIONS(5343),
    [anon_sym_COMMA] = ACTIONS(5343),
    [anon_sym_RPAREN] = ACTIONS(5343),
    [anon_sym_COLON] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5343),
    [sym_comment] = ACTIONS(3),
  },
  [2085] = {
    [anon_sym_EQ] = ACTIONS(5345),
    [anon_sym_COMMA] = ACTIONS(5345),
    [anon_sym_RPAREN] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5345),
    [anon_sym_QMARK] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
  },
  [2086] = {
    [anon_sym_EQ] = ACTIONS(5347),
    [anon_sym_COMMA] = ACTIONS(5347),
    [anon_sym_RPAREN] = ACTIONS(5347),
    [anon_sym_COLON] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5347),
    [sym_comment] = ACTIONS(3),
  },
  [2087] = {
    [aux_sym_implements_clause_repeat1] = STATE(2519),
    [anon_sym_COMMA] = ACTIONS(5349),
    [anon_sym_RBRACK] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2088] = {
    [anon_sym_EQ] = ACTIONS(608),
    [anon_sym_COMMA] = ACTIONS(608),
    [anon_sym_RPAREN] = ACTIONS(608),
    [anon_sym_COLON] = ACTIONS(608),
    [anon_sym_QMARK] = ACTIONS(608),
    [sym_comment] = ACTIONS(3),
  },
  [2089] = {
    [anon_sym_COMMA] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2890),
    [sym__automatic_semicolon] = ACTIONS(2890),
  },
  [2090] = {
    [anon_sym_COMMA] = ACTIONS(2902),
    [anon_sym_RBRACE] = ACTIONS(2902),
    [anon_sym_SEMI] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2902),
    [sym__automatic_semicolon] = ACTIONS(2902),
  },
  [2091] = {
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_COMMA] = ACTIONS(5353),
    [anon_sym_RPAREN] = ACTIONS(5353),
    [anon_sym_COLON] = ACTIONS(5353),
    [anon_sym_QMARK] = ACTIONS(5353),
    [sym_comment] = ACTIONS(3),
  },
  [2092] = {
    [anon_sym_EQ] = ACTIONS(5355),
    [anon_sym_COMMA] = ACTIONS(5355),
    [anon_sym_RPAREN] = ACTIONS(5355),
    [anon_sym_COLON] = ACTIONS(5355),
    [anon_sym_QMARK] = ACTIONS(5355),
    [sym_comment] = ACTIONS(3),
  },
  [2093] = {
    [anon_sym_EQ] = ACTIONS(4476),
    [anon_sym_COMMA] = ACTIONS(4476),
    [anon_sym_RPAREN] = ACTIONS(4476),
    [anon_sym_COLON] = ACTIONS(4476),
    [anon_sym_QMARK] = ACTIONS(4476),
    [sym_comment] = ACTIONS(3),
  },
  [2094] = {
    [aux_sym_implements_clause_repeat1] = STATE(2512),
    [anon_sym_COMMA] = ACTIONS(5357),
    [anon_sym_GT] = ACTIONS(5359),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2095] = {
    [anon_sym_EQ] = ACTIONS(5361),
    [anon_sym_COMMA] = ACTIONS(5361),
    [anon_sym_RPAREN] = ACTIONS(5361),
    [anon_sym_COLON] = ACTIONS(5361),
    [anon_sym_QMARK] = ACTIONS(5361),
    [sym_comment] = ACTIONS(3),
  },
  [2096] = {
    [sym__initializer] = STATE(2435),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(5363),
    [anon_sym_SEMI] = ACTIONS(5363),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5363),
  },
  [2097] = {
    [anon_sym_EQ] = ACTIONS(4468),
    [anon_sym_COMMA] = ACTIONS(4468),
    [anon_sym_RPAREN] = ACTIONS(4468),
    [anon_sym_COLON] = ACTIONS(4468),
    [anon_sym_QMARK] = ACTIONS(4468),
    [sym_comment] = ACTIONS(3),
  },
  [2098] = {
    [anon_sym_COMMA] = ACTIONS(2692),
    [anon_sym_RBRACE] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2692),
    [sym__automatic_semicolon] = ACTIONS(2692),
  },
  [2099] = {
    [sym_object] = STATE(2809),
    [sym_array] = STATE(2814),
    [sym_identifier] = ACTIONS(5365),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(557),
    [sym_comment] = ACTIONS(3),
  },
  [2100] = {
    [anon_sym_COMMA] = ACTIONS(5100),
    [anon_sym_RBRACE] = ACTIONS(5100),
    [anon_sym_SEMI] = ACTIONS(5100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5100),
    [sym__automatic_semicolon] = ACTIONS(5100),
  },
  [2101] = {
    [sym__call_signature] = STATE(2584),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2102] = {
    [anon_sym_COMMA] = ACTIONS(5367),
    [anon_sym_RBRACE] = ACTIONS(5367),
    [anon_sym_SEMI] = ACTIONS(5367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5367),
    [sym__automatic_semicolon] = ACTIONS(5367),
  },
  [2103] = {
    [sym__call_signature] = STATE(2244),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2104] = {
    [anon_sym_COMMA] = ACTIONS(5369),
    [anon_sym_RBRACE] = ACTIONS(5369),
    [anon_sym_SEMI] = ACTIONS(5369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5369),
    [sym__automatic_semicolon] = ACTIONS(5369),
  },
  [2105] = {
    [sym_statement_block] = STATE(1692),
    [anon_sym_LBRACE] = ACTIONS(5335),
    [anon_sym_COMMA] = ACTIONS(5036),
    [anon_sym_SEMI] = ACTIONS(5036),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5036),
  },
  [2106] = {
    [anon_sym_COMMA] = ACTIONS(5088),
    [anon_sym_RBRACE] = ACTIONS(5088),
    [anon_sym_SEMI] = ACTIONS(5088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5088),
    [sym__automatic_semicolon] = ACTIONS(5088),
  },
  [2107] = {
    [anon_sym_COMMA] = ACTIONS(5371),
    [anon_sym_RBRACE] = ACTIONS(5371),
    [anon_sym_SEMI] = ACTIONS(5371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5371),
    [sym__automatic_semicolon] = ACTIONS(5371),
  },
  [2108] = {
    [aux_sym_implements_clause_repeat1] = STATE(2476),
    [anon_sym_COMMA] = ACTIONS(5349),
    [anon_sym_RBRACK] = ACTIONS(5373),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2109] = {
    [anon_sym_COMMA] = ACTIONS(5036),
    [anon_sym_RBRACE] = ACTIONS(5036),
    [anon_sym_SEMI] = ACTIONS(5036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5036),
    [sym__automatic_semicolon] = ACTIONS(5036),
  },
  [2110] = {
    [sym_statement_block] = STATE(1697),
    [anon_sym_LBRACE] = ACTIONS(5335),
    [anon_sym_COMMA] = ACTIONS(5056),
    [anon_sym_SEMI] = ACTIONS(5056),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5056),
  },
  [2111] = {
    [sym__call_signature] = STATE(2105),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2112] = {
    [sym_statement_block] = STATE(1698),
    [anon_sym_LBRACE] = ACTIONS(5335),
    [anon_sym_COMMA] = ACTIONS(5064),
    [anon_sym_SEMI] = ACTIONS(5064),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5064),
  },
  [2113] = {
    [sym__call_signature] = STATE(2324),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2114] = {
    [anon_sym_COMMA] = ACTIONS(5375),
    [anon_sym_RBRACE] = ACTIONS(5375),
    [anon_sym_SEMI] = ACTIONS(5375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5375),
    [sym__automatic_semicolon] = ACTIONS(5375),
  },
  [2115] = {
    [anon_sym_COMMA] = ACTIONS(5377),
    [anon_sym_RBRACE] = ACTIONS(5377),
    [anon_sym_SEMI] = ACTIONS(5377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5377),
    [sym__automatic_semicolon] = ACTIONS(5377),
  },
  [2116] = {
    [anon_sym_COMMA] = ACTIONS(5379),
    [anon_sym_RBRACE] = ACTIONS(5379),
    [anon_sym_SEMI] = ACTIONS(5379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5379),
    [sym__automatic_semicolon] = ACTIONS(5379),
  },
  [2117] = {
    [anon_sym_COMMA] = ACTIONS(5056),
    [anon_sym_RBRACE] = ACTIONS(5056),
    [anon_sym_SEMI] = ACTIONS(5056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5056),
    [sym__automatic_semicolon] = ACTIONS(5056),
  },
  [2118] = {
    [sym__call_signature] = STATE(2109),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2119] = {
    [sym_statement_block] = STATE(1703),
    [anon_sym_LBRACE] = ACTIONS(5335),
    [anon_sym_COMMA] = ACTIONS(5100),
    [anon_sym_SEMI] = ACTIONS(5100),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5100),
  },
  [2120] = {
    [sym__call_signature] = STATE(2266),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2121] = {
    [aux_sym_implements_clause_repeat1] = STATE(2364),
    [anon_sym_COMMA] = ACTIONS(5381),
    [anon_sym_GT] = ACTIONS(5383),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2122] = {
    [aux_sym_implements_clause_repeat1] = STATE(2380),
    [anon_sym_COMMA] = ACTIONS(5349),
    [anon_sym_RBRACK] = ACTIONS(5385),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2123] = {
    [sym__call_signature] = STATE(2681),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2124] = {
    [aux_sym_implements_clause_repeat1] = STATE(2466),
    [anon_sym_COMMA] = ACTIONS(5387),
    [anon_sym_GT] = ACTIONS(5389),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2125] = {
    [anon_sym_COMMA] = ACTIONS(5064),
    [anon_sym_RBRACE] = ACTIONS(5064),
    [anon_sym_SEMI] = ACTIONS(5064),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5064),
    [sym__automatic_semicolon] = ACTIONS(5064),
  },
  [2126] = {
    [sym_statement_block] = STATE(1704),
    [anon_sym_LBRACE] = ACTIONS(5335),
    [anon_sym_COMMA] = ACTIONS(5088),
    [anon_sym_SEMI] = ACTIONS(5088),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5088),
  },
  [2127] = {
    [sym__call_signature] = STATE(2613),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2128] = {
    [sym_type_arguments] = STATE(417),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(4874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4140),
  },
  [2129] = {
    [anon_sym_COMMA] = ACTIONS(2850),
    [anon_sym_RBRACE] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2850),
    [sym__automatic_semicolon] = ACTIONS(2850),
  },
  [2130] = {
    [sym__initializer] = STATE(2387),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(5391),
    [anon_sym_SEMI] = ACTIONS(5391),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5391),
  },
  [2131] = {
    [anon_sym_COMMA] = ACTIONS(2712),
    [anon_sym_RBRACE] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2712),
    [sym__automatic_semicolon] = ACTIONS(2712),
  },
  [2132] = {
    [sym_statement_block] = STATE(1693),
    [anon_sym_LBRACE] = ACTIONS(5335),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_SEMI] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5104),
  },
  [2133] = {
    [anon_sym_COMMA] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2858),
    [anon_sym_SEMI] = ACTIONS(2858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2858),
    [sym__automatic_semicolon] = ACTIONS(2858),
  },
  [2134] = {
    [anon_sym_COMMA] = ACTIONS(2716),
    [anon_sym_RBRACE] = ACTIONS(2716),
    [anon_sym_SEMI] = ACTIONS(2716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2716),
    [sym__automatic_semicolon] = ACTIONS(2716),
  },
  [2135] = {
    [anon_sym_COMMA] = ACTIONS(2870),
    [anon_sym_RBRACE] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2870),
    [sym__automatic_semicolon] = ACTIONS(2870),
  },
  [2136] = {
    [sym__call_signature] = STATE(2674),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2137] = {
    [sym__call_signature] = STATE(2348),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2138] = {
    [anon_sym_COMMA] = ACTIONS(1087),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1087),
    [sym__automatic_semicolon] = ACTIONS(1087),
  },
  [2139] = {
    [sym__call_signature] = STATE(2353),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2140] = {
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_SEMI] = ACTIONS(2770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2770),
    [sym__automatic_semicolon] = ACTIONS(2770),
  },
  [2141] = {
    [anon_sym_COMMA] = ACTIONS(2774),
    [anon_sym_RBRACE] = ACTIONS(2774),
    [anon_sym_SEMI] = ACTIONS(2774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2774),
    [sym__automatic_semicolon] = ACTIONS(2774),
  },
  [2142] = {
    [anon_sym_EQ] = ACTIONS(5393),
    [anon_sym_LBRACE] = ACTIONS(5393),
    [anon_sym_LPAREN] = ACTIONS(5393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5393),
    [anon_sym_extends] = ACTIONS(5393),
  },
  [2143] = {
    [sym__initializer] = STATE(2402),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(5395),
    [anon_sym_SEMI] = ACTIONS(5395),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5395),
  },
  [2144] = {
    [sym_statement_block] = STATE(1701),
    [anon_sym_LBRACE] = ACTIONS(5335),
    [anon_sym_COMMA] = ACTIONS(5106),
    [anon_sym_SEMI] = ACTIONS(5106),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5106),
  },
  [2145] = {
    [sym__call_signature] = STATE(2119),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2146] = {
    [sym__initializer] = STATE(2497),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(5397),
    [anon_sym_SEMI] = ACTIONS(5397),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5397),
  },
  [2147] = {
    [anon_sym_COMMA] = ACTIONS(2778),
    [anon_sym_RBRACE] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2778),
    [sym__automatic_semicolon] = ACTIONS(2778),
  },
  [2148] = {
    [anon_sym_EQ] = ACTIONS(5399),
    [anon_sym_LBRACE] = ACTIONS(5399),
    [anon_sym_LPAREN] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5399),
    [anon_sym_extends] = ACTIONS(5399),
  },
  [2149] = {
    [sym_extends_clause] = STATE(2368),
    [sym_object_type] = STATE(2253),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
  },
  [2150] = {
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_SEMI] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5104),
    [sym__automatic_semicolon] = ACTIONS(5104),
  },
  [2151] = {
    [anon_sym_COMMA] = ACTIONS(2782),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_SEMI] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2782),
    [sym__automatic_semicolon] = ACTIONS(2782),
  },
  [2152] = {
    [sym_decorator] = STATE(1762),
    [aux_sym_export_statement_repeat1] = STATE(2217),
    [anon_sym_export] = ACTIONS(5401),
    [anon_sym_class] = ACTIONS(5403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2153] = {
    [sym__import_export_specifier] = STATE(2692),
    [sym_identifier] = ACTIONS(5208),
    [anon_sym_RBRACE] = ACTIONS(5405),
    [anon_sym_type] = ACTIONS(5214),
    [anon_sym_typeof] = ACTIONS(5214),
    [sym_comment] = ACTIONS(3),
  },
  [2154] = {
    [sym__initializer] = STATE(2500),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_SEMI] = ACTIONS(5407),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5407),
  },
  [2155] = {
    [anon_sym_COMMA] = ACTIONS(5305),
    [anon_sym_RBRACE] = ACTIONS(5305),
    [anon_sym_SEMI] = ACTIONS(5305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5305),
    [sym__automatic_semicolon] = ACTIONS(5305),
  },
  [2156] = {
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [anon_sym_SEMI] = ACTIONS(5080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5080),
    [sym__automatic_semicolon] = ACTIONS(5080),
  },
  [2157] = {
    [sym_statement_block] = STATE(1699),
    [anon_sym_LBRACE] = ACTIONS(5335),
    [anon_sym_COMMA] = ACTIONS(5066),
    [anon_sym_SEMI] = ACTIONS(5066),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5066),
  },
  [2158] = {
    [sym__call_signature] = STATE(2358),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2159] = {
    [sym_decorator] = STATE(1762),
    [aux_sym_export_statement_repeat1] = STATE(2217),
    [anon_sym_export] = ACTIONS(5409),
    [anon_sym_class] = ACTIONS(5411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2160] = {
    [sym__call_signature] = STATE(2690),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2161] = {
    [sym__call_signature] = STATE(2703),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2162] = {
    [sym__call_signature] = STATE(2112),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2163] = {
    [sym__initializer] = STATE(2493),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(5413),
    [anon_sym_SEMI] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5413),
  },
  [2164] = {
    [sym_statement_block] = STATE(1687),
    [anon_sym_LBRACE] = ACTIONS(5335),
    [anon_sym_COMMA] = ACTIONS(5074),
    [anon_sym_SEMI] = ACTIONS(5074),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5074),
  },
  [2165] = {
    [sym__call_signature] = STATE(2478),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2166] = {
    [sym__call_signature] = STATE(2599),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2167] = {
    [anon_sym_COMMA] = ACTIONS(2846),
    [anon_sym_RBRACE] = ACTIONS(2846),
    [anon_sym_SEMI] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2846),
    [sym__automatic_semicolon] = ACTIONS(2846),
  },
  [2168] = {
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_RBRACE] = ACTIONS(1179),
    [anon_sym_SEMI] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1179),
    [sym__automatic_semicolon] = ACTIONS(1179),
  },
  [2169] = {
    [anon_sym_COMMA] = ACTIONS(1121),
    [anon_sym_RBRACE] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1121),
    [sym__automatic_semicolon] = ACTIONS(1121),
  },
  [2170] = {
    [aux_sym_implements_clause_repeat1] = STATE(2451),
    [anon_sym_LBRACE] = ACTIONS(5415),
    [anon_sym_COMMA] = ACTIONS(5349),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2171] = {
    [anon_sym_COMMA] = ACTIONS(5102),
    [anon_sym_RBRACE] = ACTIONS(5102),
    [anon_sym_SEMI] = ACTIONS(5102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5102),
    [sym__automatic_semicolon] = ACTIONS(5102),
  },
  [2172] = {
    [sym__call_signature] = STATE(2359),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2173] = {
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1135),
    [sym__automatic_semicolon] = ACTIONS(1135),
  },
  [2174] = {
    [anon_sym_COMMA] = ACTIONS(5417),
    [anon_sym_RBRACE] = ACTIONS(5417),
    [anon_sym_SEMI] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5417),
    [sym__automatic_semicolon] = ACTIONS(5417),
  },
  [2175] = {
    [anon_sym_COMMA] = ACTIONS(5106),
    [anon_sym_RBRACE] = ACTIONS(5106),
    [anon_sym_SEMI] = ACTIONS(5106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5106),
    [sym__automatic_semicolon] = ACTIONS(5106),
  },
  [2176] = {
    [anon_sym_COMMA] = ACTIONS(5419),
    [anon_sym_RBRACE] = ACTIONS(5419),
    [anon_sym_SEMI] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5419),
    [sym__automatic_semicolon] = ACTIONS(5419),
  },
  [2177] = {
    [sym__call_signature] = STATE(2100),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2178] = {
    [sym__call_signature] = STATE(2634),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2179] = {
    [sym__call_signature] = STATE(2308),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2180] = {
    [sym__call_signature] = STATE(2338),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2181] = {
    [anon_sym_COMMA] = ACTIONS(2862),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_SEMI] = ACTIONS(2862),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2862),
    [sym__automatic_semicolon] = ACTIONS(2862),
  },
  [2182] = {
    [anon_sym_COMMA] = ACTIONS(5066),
    [anon_sym_RBRACE] = ACTIONS(5066),
    [anon_sym_SEMI] = ACTIONS(5066),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5066),
    [sym__automatic_semicolon] = ACTIONS(5066),
  },
  [2183] = {
    [sym__call_signature] = STATE(2656),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2184] = {
    [sym__call_signature] = STATE(2658),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2185] = {
    [anon_sym_COMMA] = ACTIONS(2866),
    [anon_sym_RBRACE] = ACTIONS(2866),
    [anon_sym_SEMI] = ACTIONS(2866),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2866),
    [sym__automatic_semicolon] = ACTIONS(2866),
  },
  [2186] = {
    [aux_sym_implements_clause_repeat1] = STATE(2405),
    [anon_sym_COMMA] = ACTIONS(5349),
    [anon_sym_RBRACK] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2187] = {
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_RBRACE] = ACTIONS(2874),
    [anon_sym_SEMI] = ACTIONS(2874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2874),
    [sym__automatic_semicolon] = ACTIONS(2874),
  },
  [2188] = {
    [sym__call_signature] = STATE(2125),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2189] = {
    [sym__call_signature] = STATE(2672),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2190] = {
    [anon_sym_COMMA] = ACTIONS(5074),
    [anon_sym_RBRACE] = ACTIONS(5074),
    [anon_sym_SEMI] = ACTIONS(5074),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5074),
    [sym__automatic_semicolon] = ACTIONS(5074),
  },
  [2191] = {
    [anon_sym_COMMA] = ACTIONS(5423),
    [anon_sym_RBRACE] = ACTIONS(5423),
    [anon_sym_SEMI] = ACTIONS(5423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5423),
    [sym__automatic_semicolon] = ACTIONS(5423),
  },
  [2192] = {
    [anon_sym_COMMA] = ACTIONS(2652),
    [anon_sym_RBRACE] = ACTIONS(2652),
    [anon_sym_SEMI] = ACTIONS(2652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2652),
    [sym__automatic_semicolon] = ACTIONS(2652),
  },
  [2193] = {
    [sym__call_signature] = STATE(2683),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2194] = {
    [sym__call_signature] = STATE(2297),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2195] = {
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_SEMI] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5425),
    [sym__automatic_semicolon] = ACTIONS(5425),
  },
  [2196] = {
    [sym__call_signature] = STATE(1957),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2197] = {
    [anon_sym_COMMA] = ACTIONS(2882),
    [anon_sym_RBRACE] = ACTIONS(2882),
    [anon_sym_SEMI] = ACTIONS(2882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2882),
    [sym__automatic_semicolon] = ACTIONS(2882),
  },
  [2198] = {
    [anon_sym_EQ] = ACTIONS(5427),
    [anon_sym_COMMA] = ACTIONS(5427),
    [anon_sym_GT] = ACTIONS(5427),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2199] = {
    [anon_sym_COMMA] = ACTIONS(2802),
    [anon_sym_RBRACE] = ACTIONS(2802),
    [anon_sym_SEMI] = ACTIONS(2802),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2802),
    [sym__automatic_semicolon] = ACTIONS(2802),
  },
  [2200] = {
    [sym__call_signature] = STATE(1948),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2201] = {
    [anon_sym_COMMA] = ACTIONS(2790),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [anon_sym_SEMI] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2790),
    [sym__automatic_semicolon] = ACTIONS(2790),
  },
  [2202] = {
    [aux_sym_implements_clause_repeat1] = STATE(2202),
    [anon_sym_LBRACE] = ACTIONS(5252),
    [anon_sym_COMMA] = ACTIONS(5429),
    [anon_sym_RBRACK] = ACTIONS(5252),
    [anon_sym_GT] = ACTIONS(5252),
    [sym_comment] = ACTIONS(3),
  },
  [2203] = {
    [anon_sym_COMMA] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_SEMI] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2786),
    [sym__automatic_semicolon] = ACTIONS(2786),
  },
  [2204] = {
    [aux_sym_implements_clause_repeat1] = STATE(2391),
    [anon_sym_COMMA] = ACTIONS(5349),
    [anon_sym_RBRACK] = ACTIONS(5432),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2205] = {
    [sym__call_signature] = STATE(2529),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2206] = {
    [anon_sym_COMMA] = ACTIONS(2648),
    [anon_sym_RBRACE] = ACTIONS(2648),
    [anon_sym_SEMI] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2648),
    [sym__automatic_semicolon] = ACTIONS(2648),
  },
  [2207] = {
    [sym__call_signature] = STATE(1939),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2208] = {
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_SEMI] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1189),
    [sym__automatic_semicolon] = ACTIONS(1189),
  },
  [2209] = {
    [sym__call_signature] = STATE(1928),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2210] = {
    [sym__initializer] = STATE(2604),
    [aux_sym_enum_body_repeat1] = STATE(2464),
    [anon_sym_EQ] = ACTIONS(5126),
    [anon_sym_COMMA] = ACTIONS(5434),
    [anon_sym_RBRACE] = ACTIONS(5436),
    [sym_comment] = ACTIONS(3),
  },
  [2211] = {
    [sym__call_signature] = STATE(1912),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2212] = {
    [sym__call_signature] = STATE(2563),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2213] = {
    [sym__call_signature] = STATE(2713),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2214] = {
    [sym__import_export_specifier] = STATE(2692),
    [sym_identifier] = ACTIONS(5208),
    [anon_sym_RBRACE] = ACTIONS(5438),
    [anon_sym_type] = ACTIONS(5214),
    [anon_sym_typeof] = ACTIONS(5214),
    [sym_comment] = ACTIONS(3),
  },
  [2215] = {
    [anon_sym_EQ] = ACTIONS(5440),
    [anon_sym_LBRACE] = ACTIONS(5440),
    [anon_sym_LPAREN] = ACTIONS(5440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5440),
    [anon_sym_extends] = ACTIONS(5440),
  },
  [2216] = {
    [anon_sym_COMMA] = ACTIONS(2938),
    [anon_sym_RBRACE] = ACTIONS(2938),
    [anon_sym_SEMI] = ACTIONS(2938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2938),
    [sym__automatic_semicolon] = ACTIONS(2938),
  },
  [2217] = {
    [sym_decorator] = STATE(1762),
    [aux_sym_export_statement_repeat1] = STATE(2217),
    [anon_sym_export] = ACTIONS(4791),
    [anon_sym_class] = ACTIONS(4791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(5442),
  },
  [2218] = {
    [sym_type_arguments] = STATE(1558),
    [anon_sym_LBRACE] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(5282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4140),
  },
  [2219] = {
    [anon_sym_COMMA] = ACTIONS(1211),
    [anon_sym_RBRACE] = ACTIONS(1211),
    [anon_sym_SEMI] = ACTIONS(1211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1211),
    [sym__automatic_semicolon] = ACTIONS(5445),
  },
  [2220] = {
    [sym__call_signature] = STATE(2645),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2221] = {
    [anon_sym_COMMA] = ACTIONS(2878),
    [anon_sym_RBRACE] = ACTIONS(2878),
    [anon_sym_SEMI] = ACTIONS(2878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2878),
    [sym__automatic_semicolon] = ACTIONS(2878),
  },
  [2222] = {
    [anon_sym_COMMA] = ACTIONS(2930),
    [anon_sym_RBRACE] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2930),
    [sym__automatic_semicolon] = ACTIONS(2930),
  },
  [2223] = {
    [anon_sym_COMMA] = ACTIONS(2660),
    [anon_sym_RBRACE] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(2660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2660),
    [sym__automatic_semicolon] = ACTIONS(2660),
  },
  [2224] = {
    [aux_sym_implements_clause_repeat1] = STATE(2375),
    [anon_sym_COMMA] = ACTIONS(5447),
    [anon_sym_GT] = ACTIONS(5449),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2225] = {
    [anon_sym_EQ] = ACTIONS(3633),
    [anon_sym_LPAREN] = ACTIONS(4406),
    [anon_sym_COLON] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4406),
    [anon_sym_QMARK] = ACTIONS(4406),
    [sym_comment] = ACTIONS(3),
  },
  [2226] = {
    [anon_sym_COMMA] = ACTIONS(2664),
    [anon_sym_RBRACE] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2664),
    [sym__automatic_semicolon] = ACTIONS(2664),
  },
  [2227] = {
    [sym__call_signature] = STATE(2616),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2228] = {
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_SEMI] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1233),
    [sym__automatic_semicolon] = ACTIONS(1233),
  },
  [2229] = {
    [sym_statement_block] = STATE(1689),
    [anon_sym_LBRACE] = ACTIONS(5335),
    [anon_sym_COMMA] = ACTIONS(5102),
    [anon_sym_SEMI] = ACTIONS(5102),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5102),
  },
  [2230] = {
    [sym__call_signature] = STATE(2343),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2231] = {
    [sym__initializer] = STATE(2440),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(5451),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5451),
  },
  [2232] = {
    [sym__call_signature] = STATE(2431),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2233] = {
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_SEMI] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1145),
    [sym__automatic_semicolon] = ACTIONS(1145),
  },
  [2234] = {
    [sym__initializer] = STATE(2419),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(5453),
    [anon_sym_SEMI] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5453),
  },
  [2235] = {
    [anon_sym_COMMA] = ACTIONS(1101),
    [anon_sym_RBRACE] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1101),
    [sym__automatic_semicolon] = ACTIONS(1101),
  },
  [2236] = {
    [anon_sym_COMMA] = ACTIONS(2918),
    [anon_sym_RBRACE] = ACTIONS(2918),
    [anon_sym_SEMI] = ACTIONS(2918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2918),
    [sym__automatic_semicolon] = ACTIONS(2918),
  },
  [2237] = {
    [sym__call_signature] = STATE(2531),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2238] = {
    [sym__call_signature] = STATE(2629),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2239] = {
    [anon_sym_COMMA] = ACTIONS(5455),
    [anon_sym_RBRACE] = ACTIONS(5455),
    [anon_sym_SEMI] = ACTIONS(5455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5455),
    [sym__automatic_semicolon] = ACTIONS(5455),
  },
  [2240] = {
    [sym__call_signature] = STATE(2636),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2241] = {
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_SEMI] = ACTIONS(1159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1159),
    [sym__automatic_semicolon] = ACTIONS(5457),
  },
  [2242] = {
    [anon_sym_COMMA] = ACTIONS(1169),
    [anon_sym_RBRACE] = ACTIONS(1169),
    [anon_sym_SEMI] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1169),
    [sym__automatic_semicolon] = ACTIONS(5459),
  },
  [2243] = {
    [sym__call_signature] = STATE(2637),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2244] = {
    [anon_sym_COMMA] = ACTIONS(5086),
    [anon_sym_RBRACE] = ACTIONS(5086),
    [anon_sym_SEMI] = ACTIONS(5086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5086),
    [sym__automatic_semicolon] = ACTIONS(5086),
  },
  [2245] = {
    [sym__call_signature] = STATE(2190),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2246] = {
    [sym__call_signature] = STATE(2716),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2247] = {
    [sym__call_signature] = STATE(2298),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2248] = {
    [anon_sym_COMMA] = ACTIONS(5076),
    [anon_sym_RBRACE] = ACTIONS(5076),
    [anon_sym_SEMI] = ACTIONS(5076),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5076),
    [sym__automatic_semicolon] = ACTIONS(5076),
  },
  [2249] = {
    [anon_sym_COMMA] = ACTIONS(2886),
    [anon_sym_RBRACE] = ACTIONS(2886),
    [anon_sym_SEMI] = ACTIONS(2886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2886),
    [sym__automatic_semicolon] = ACTIONS(2886),
  },
  [2250] = {
    [sym__call_signature] = STATE(2609),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2251] = {
    [anon_sym_COMMA] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1221),
    [sym__automatic_semicolon] = ACTIONS(5461),
  },
  [2252] = {
    [sym__call_signature] = STATE(2654),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2253] = {
    [anon_sym_COMMA] = ACTIONS(2838),
    [anon_sym_RBRACE] = ACTIONS(2838),
    [anon_sym_SEMI] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2838),
    [sym__automatic_semicolon] = ACTIONS(2838),
  },
  [2254] = {
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_COMMA] = ACTIONS(2340),
    [anon_sym_LT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2340),
  },
  [2255] = {
    [sym__call_signature] = STATE(2585),
    [sym_formal_parameters] = STATE(2340),
    [sym_type_parameters] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2256] = {
    [aux_sym_implements_clause_repeat1] = STATE(2427),
    [anon_sym_COMMA] = ACTIONS(5463),
    [anon_sym_GT] = ACTIONS(5465),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2257] = {
    [sym_extends_clause] = STATE(2501),
    [sym_object_type] = STATE(560),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [2258] = {
    [anon_sym_COMMA] = ACTIONS(2834),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_SEMI] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2834),
    [sym__automatic_semicolon] = ACTIONS(2834),
  },
  [2259] = {
    [sym__import_export_specifier] = STATE(2718),
    [sym_identifier] = ACTIONS(5208),
    [anon_sym_RBRACE] = ACTIONS(5467),
    [anon_sym_type] = ACTIONS(5214),
    [anon_sym_typeof] = ACTIONS(5214),
    [sym_comment] = ACTIONS(3),
  },
  [2260] = {
    [sym__initializer] = STATE(2407),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_COMMA] = ACTIONS(5469),
    [anon_sym_SEMI] = ACTIONS(5469),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5469),
  },
  [2261] = {
    [sym__initializer] = STATE(2604),
    [aux_sym_enum_body_repeat1] = STATE(2463),
    [anon_sym_EQ] = ACTIONS(5126),
    [anon_sym_COMMA] = ACTIONS(5471),
    [anon_sym_RBRACE] = ACTIONS(5473),
    [sym_comment] = ACTIONS(3),
  },
  [2262] = {
    [anon_sym_COMMA] = ACTIONS(2826),
    [anon_sym_RBRACE] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2826),
    [sym__automatic_semicolon] = ACTIONS(2826),
  },
  [2263] = {
    [anon_sym_COMMA] = ACTIONS(5475),
    [anon_sym_RBRACE] = ACTIONS(5475),
    [anon_sym_SEMI] = ACTIONS(5475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5475),
    [sym__automatic_semicolon] = ACTIONS(5475),
  },
  [2264] = {
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_SEMI] = ACTIONS(2814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2814),
    [sym__automatic_semicolon] = ACTIONS(2814),
  },
  [2265] = {
    [anon_sym_COMMA] = ACTIONS(5477),
    [anon_sym_RBRACE] = ACTIONS(5477),
    [anon_sym_SEMI] = ACTIONS(5477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5477),
    [sym__automatic_semicolon] = ACTIONS(5477),
  },
  [2266] = {
    [sym_statement_block] = STATE(1705),
    [anon_sym_LBRACE] = ACTIONS(5335),
    [anon_sym_COMMA] = ACTIONS(5086),
    [anon_sym_SEMI] = ACTIONS(5086),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5086),
  },
  [2267] = {
    [sym__import_export_specifier] = STATE(2718),
    [sym_identifier] = ACTIONS(5208),
    [anon_sym_RBRACE] = ACTIONS(5479),
    [anon_sym_type] = ACTIONS(5214),
    [anon_sym_typeof] = ACTIONS(5214),
    [sym_comment] = ACTIONS(3),
  },
  [2268] = {
    [sym__call_signature] = STATE(2164),
    [sym_formal_parameters] = STATE(1904),
    [sym_type_parameters] = STATE(2610),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2269] = {
    [sym__from_clause] = STATE(2691),
    [anon_sym_from] = ACTIONS(5481),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5483),
  },
  [2270] = {
    [anon_sym_SEMI] = ACTIONS(5485),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(5487),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5485),
  },
  [2271] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2316),
    [anon_sym_COMMA] = ACTIONS(5489),
    [anon_sym_SEMI] = ACTIONS(5491),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5491),
  },
  [2272] = {
    [sym__import_export_specifier] = STATE(2692),
    [sym_identifier] = ACTIONS(5208),
    [anon_sym_type] = ACTIONS(5214),
    [anon_sym_typeof] = ACTIONS(5214),
    [sym_comment] = ACTIONS(3),
  },
  [2273] = {
    [aux_sym_string_repeat2] = STATE(2315),
    [anon_sym_SQUOTE] = ACTIONS(5493),
    [aux_sym_string_token2] = ACTIONS(5495),
    [sym_escape_sequence] = ACTIONS(5497),
    [sym_comment] = ACTIONS(5499),
  },
  [2274] = {
    [aux_sym_string_repeat1] = STATE(2317),
    [anon_sym_DQUOTE] = ACTIONS(5493),
    [aux_sym_string_token1] = ACTIONS(5501),
    [sym_escape_sequence] = ACTIONS(5503),
    [sym_comment] = ACTIONS(5499),
  },
  [2275] = {
    [aux_sym_string_repeat1] = STATE(2317),
    [anon_sym_DQUOTE] = ACTIONS(5505),
    [aux_sym_string_token1] = ACTIONS(5501),
    [sym_escape_sequence] = ACTIONS(5503),
    [sym_comment] = ACTIONS(5499),
  },
  [2276] = {
    [aux_sym_string_repeat2] = STATE(2315),
    [anon_sym_SQUOTE] = ACTIONS(5505),
    [aux_sym_string_token2] = ACTIONS(5495),
    [sym_escape_sequence] = ACTIONS(5497),
    [sym_comment] = ACTIONS(5499),
  },
  [2277] = {
    [sym_decorator] = STATE(1762),
    [aux_sym_export_statement_repeat1] = STATE(2217),
    [anon_sym_class] = ACTIONS(5507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2278] = {
    [sym_decorator] = STATE(1762),
    [aux_sym_export_statement_repeat1] = STATE(2217),
    [anon_sym_class] = ACTIONS(5509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2279] = {
    [sym_formal_parameters] = STATE(2830),
    [sym_type_parameters] = STATE(2619),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2280] = {
    [sym_formal_parameters] = STATE(2791),
    [sym_type_parameters] = STATE(2685),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2281] = {
    [sym__initializer] = STATE(2659),
    [anon_sym_EQ] = ACTIONS(5126),
    [anon_sym_COMMA] = ACTIONS(5511),
    [anon_sym_RPAREN] = ACTIONS(5511),
    [sym_comment] = ACTIONS(3),
  },
  [2282] = {
    [sym_template_string] = STATE(1044),
    [sym_arguments] = STATE(1044),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(577),
  },
  [2283] = {
    [sym__initializer] = STATE(2571),
    [anon_sym_EQ] = ACTIONS(5126),
    [anon_sym_COMMA] = ACTIONS(5513),
    [anon_sym_RPAREN] = ACTIONS(5513),
    [sym_comment] = ACTIONS(3),
  },
  [2284] = {
    [aux_sym_extends_clause_repeat1] = STATE(2339),
    [anon_sym_LBRACE] = ACTIONS(5515),
    [anon_sym_COMMA] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5517),
  },
  [2285] = {
    [aux_sym_string_repeat2] = STATE(2273),
    [anon_sym_SQUOTE] = ACTIONS(5519),
    [aux_sym_string_token2] = ACTIONS(5521),
    [sym_escape_sequence] = ACTIONS(5523),
    [sym_comment] = ACTIONS(5499),
  },
  [2286] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2316),
    [anon_sym_COMMA] = ACTIONS(5489),
    [anon_sym_SEMI] = ACTIONS(5525),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5525),
  },
  [2287] = {
    [aux_sym_extends_clause_repeat1] = STATE(2339),
    [anon_sym_LBRACE] = ACTIONS(5527),
    [anon_sym_COMMA] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5529),
  },
  [2288] = {
    [aux_sym_string_repeat2] = STATE(2315),
    [anon_sym_SQUOTE] = ACTIONS(5531),
    [aux_sym_string_token2] = ACTIONS(5495),
    [sym_escape_sequence] = ACTIONS(5497),
    [sym_comment] = ACTIONS(5499),
  },
  [2289] = {
    [aux_sym_string_repeat1] = STATE(2317),
    [anon_sym_DQUOTE] = ACTIONS(5531),
    [aux_sym_string_token1] = ACTIONS(5501),
    [sym_escape_sequence] = ACTIONS(5503),
    [sym_comment] = ACTIONS(5499),
  },
  [2290] = {
    [aux_sym_extends_clause_repeat1] = STATE(2284),
    [anon_sym_LBRACE] = ACTIONS(3793),
    [anon_sym_COMMA] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3823),
  },
  [2291] = {
    [sym_namespace_import] = STATE(2898),
    [sym_named_imports] = STATE(2898),
    [anon_sym_STAR] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(3561),
    [sym_comment] = ACTIONS(3),
  },
  [2292] = {
    [aux_sym_string_repeat1] = STATE(2322),
    [anon_sym_DQUOTE] = ACTIONS(5533),
    [aux_sym_string_token1] = ACTIONS(5535),
    [sym_escape_sequence] = ACTIONS(5537),
    [sym_comment] = ACTIONS(5499),
  },
  [2293] = {
    [aux_sym_string_repeat1] = STATE(2336),
    [anon_sym_DQUOTE] = ACTIONS(5539),
    [aux_sym_string_token1] = ACTIONS(5541),
    [sym_escape_sequence] = ACTIONS(5543),
    [sym_comment] = ACTIONS(5499),
  },
  [2294] = {
    [aux_sym_string_repeat2] = STATE(2337),
    [anon_sym_SQUOTE] = ACTIONS(5539),
    [aux_sym_string_token2] = ACTIONS(5545),
    [sym_escape_sequence] = ACTIONS(5547),
    [sym_comment] = ACTIONS(5499),
  },
  [2295] = {
    [sym_escape_sequence] = ACTIONS(5549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5549),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5549),
    [sym__template_chars] = ACTIONS(5549),
  },
  [2296] = {
    [aux_sym_string_repeat2] = STATE(2288),
    [anon_sym_SQUOTE] = ACTIONS(5551),
    [aux_sym_string_token2] = ACTIONS(5553),
    [sym_escape_sequence] = ACTIONS(5555),
    [sym_comment] = ACTIONS(5499),
  },
  [2297] = {
    [sym_statement_block] = STATE(121),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5557),
  },
  [2298] = {
    [sym_statement_block] = STATE(484),
    [anon_sym_LBRACE] = ACTIONS(5559),
    [anon_sym_SEMI] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5557),
  },
  [2299] = {
    [aux_sym_string_repeat1] = STATE(2289),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [aux_sym_string_token1] = ACTIONS(5561),
    [sym_escape_sequence] = ACTIONS(5563),
    [sym_comment] = ACTIONS(5499),
  },
  [2300] = {
    [aux_sym_extends_clause_repeat1] = STATE(2313),
    [anon_sym_LBRACE] = ACTIONS(5517),
    [anon_sym_COMMA] = ACTIONS(3426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5517),
  },
  [2301] = {
    [aux_sym_array_repeat1] = STATE(2301),
    [anon_sym_COMMA] = ACTIONS(5565),
    [anon_sym_RPAREN] = ACTIONS(4154),
    [anon_sym_RBRACK] = ACTIONS(4154),
    [sym_comment] = ACTIONS(3),
  },
  [2302] = {
    [sym__import_export_specifier] = STATE(2718),
    [sym_identifier] = ACTIONS(5208),
    [anon_sym_type] = ACTIONS(5214),
    [anon_sym_typeof] = ACTIONS(5214),
    [sym_comment] = ACTIONS(3),
  },
  [2303] = {
    [aux_sym_extends_clause_repeat1] = STATE(2313),
    [anon_sym_LBRACE] = ACTIONS(5529),
    [anon_sym_COMMA] = ACTIONS(3426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5529),
  },
  [2304] = {
    [sym_decorator] = STATE(1762),
    [aux_sym_export_statement_repeat1] = STATE(2217),
    [anon_sym_class] = ACTIONS(5568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2305] = {
    [aux_sym_string_repeat2] = STATE(2323),
    [anon_sym_SQUOTE] = ACTIONS(5533),
    [aux_sym_string_token2] = ACTIONS(5570),
    [sym_escape_sequence] = ACTIONS(5572),
    [sym_comment] = ACTIONS(5499),
  },
  [2306] = {
    [sym_formal_parameters] = STATE(1972),
    [sym_type_parameters] = STATE(2586),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2307] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2316),
    [anon_sym_COMMA] = ACTIONS(5489),
    [anon_sym_SEMI] = ACTIONS(5574),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5574),
  },
  [2308] = {
    [sym_statement_block] = STATE(487),
    [anon_sym_LBRACE] = ACTIONS(5559),
    [anon_sym_SEMI] = ACTIONS(5576),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5576),
  },
  [2309] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2316),
    [anon_sym_COMMA] = ACTIONS(5489),
    [anon_sym_SEMI] = ACTIONS(5578),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5578),
  },
  [2310] = {
    [sym_formal_parameters] = STATE(2909),
    [sym_type_parameters] = STATE(2643),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2311] = {
    [aux_sym_string_repeat2] = STATE(2315),
    [anon_sym_SQUOTE] = ACTIONS(5580),
    [aux_sym_string_token2] = ACTIONS(5495),
    [sym_escape_sequence] = ACTIONS(5497),
    [sym_comment] = ACTIONS(5499),
  },
  [2312] = {
    [aux_sym_string_repeat1] = STATE(2317),
    [anon_sym_DQUOTE] = ACTIONS(5580),
    [aux_sym_string_token1] = ACTIONS(5501),
    [sym_escape_sequence] = ACTIONS(5503),
    [sym_comment] = ACTIONS(5499),
  },
  [2313] = {
    [aux_sym_extends_clause_repeat1] = STATE(2313),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4140),
  },
  [2314] = {
    [anon_sym_SEMI] = ACTIONS(5585),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(5487),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5585),
  },
  [2315] = {
    [aux_sym_string_repeat2] = STATE(2315),
    [anon_sym_SQUOTE] = ACTIONS(5587),
    [aux_sym_string_token2] = ACTIONS(5589),
    [sym_escape_sequence] = ACTIONS(5592),
    [sym_comment] = ACTIONS(5499),
  },
  [2316] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2316),
    [anon_sym_COMMA] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5598),
  },
  [2317] = {
    [aux_sym_string_repeat1] = STATE(2317),
    [anon_sym_DQUOTE] = ACTIONS(5600),
    [aux_sym_string_token1] = ACTIONS(5602),
    [sym_escape_sequence] = ACTIONS(5605),
    [sym_comment] = ACTIONS(5499),
  },
  [2318] = {
    [sym_decorator] = STATE(1762),
    [aux_sym_export_statement_repeat1] = STATE(2217),
    [anon_sym_export] = ACTIONS(5608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2319] = {
    [aux_sym_string_repeat2] = STATE(2311),
    [anon_sym_SQUOTE] = ACTIONS(5610),
    [aux_sym_string_token2] = ACTIONS(5612),
    [sym_escape_sequence] = ACTIONS(5614),
    [sym_comment] = ACTIONS(5499),
  },
  [2320] = {
    [aux_sym_string_repeat1] = STATE(2312),
    [anon_sym_DQUOTE] = ACTIONS(5610),
    [aux_sym_string_token1] = ACTIONS(5616),
    [sym_escape_sequence] = ACTIONS(5618),
    [sym_comment] = ACTIONS(5499),
  },
  [2321] = {
    [sym_type_annotation] = STATE(2551),
    [anon_sym_COMMA] = ACTIONS(5620),
    [anon_sym_RPAREN] = ACTIONS(5620),
    [anon_sym_COLON] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
  },
  [2322] = {
    [aux_sym_string_repeat1] = STATE(2317),
    [anon_sym_DQUOTE] = ACTIONS(5622),
    [aux_sym_string_token1] = ACTIONS(5501),
    [sym_escape_sequence] = ACTIONS(5503),
    [sym_comment] = ACTIONS(5499),
  },
  [2323] = {
    [aux_sym_string_repeat2] = STATE(2315),
    [anon_sym_SQUOTE] = ACTIONS(5622),
    [aux_sym_string_token2] = ACTIONS(5495),
    [sym_escape_sequence] = ACTIONS(5497),
    [sym_comment] = ACTIONS(5499),
  },
  [2324] = {
    [sym_statement_block] = STATE(1306),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_SEMI] = ACTIONS(5576),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5576),
  },
  [2325] = {
    [anon_sym_else] = ACTIONS(2574),
    [anon_sym_while] = ACTIONS(2574),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2326] = {
    [sym_default_type] = STATE(2620),
    [anon_sym_EQ] = ACTIONS(4902),
    [anon_sym_COMMA] = ACTIONS(5624),
    [anon_sym_GT] = ACTIONS(5624),
    [sym_comment] = ACTIONS(3),
  },
  [2327] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2271),
    [anon_sym_COMMA] = ACTIONS(5489),
    [anon_sym_SEMI] = ACTIONS(5626),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5626),
  },
  [2328] = {
    [sym_template_string] = STATE(1416),
    [sym_arguments] = STATE(1416),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
  },
  [2329] = {
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_RPAREN] = ACTIONS(3761),
    [anon_sym_COLON] = ACTIONS(3761),
    [anon_sym_RBRACK] = ACTIONS(3761),
    [sym_comment] = ACTIONS(3),
  },
  [2330] = {
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(5487),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5628),
  },
  [2331] = {
    [sym_decorator] = STATE(1762),
    [aux_sym_export_statement_repeat1] = STATE(2217),
    [anon_sym_class] = ACTIONS(5630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2332] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2286),
    [anon_sym_COMMA] = ACTIONS(5489),
    [anon_sym_SEMI] = ACTIONS(5632),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5632),
  },
  [2333] = {
    [sym_type_annotation] = STATE(2726),
    [anon_sym_LBRACE] = ACTIONS(5028),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(5028),
    [sym_comment] = ACTIONS(3),
  },
  [2334] = {
    [sym_decorator] = STATE(1762),
    [aux_sym_export_statement_repeat1] = STATE(2217),
    [anon_sym_class] = ACTIONS(5634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2335] = {
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_EQ_GT] = ACTIONS(5636),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
  },
  [2336] = {
    [aux_sym_string_repeat1] = STATE(2317),
    [anon_sym_DQUOTE] = ACTIONS(5638),
    [aux_sym_string_token1] = ACTIONS(5501),
    [sym_escape_sequence] = ACTIONS(5503),
    [sym_comment] = ACTIONS(5499),
  },
  [2337] = {
    [aux_sym_string_repeat2] = STATE(2315),
    [anon_sym_SQUOTE] = ACTIONS(5638),
    [aux_sym_string_token2] = ACTIONS(5495),
    [sym_escape_sequence] = ACTIONS(5497),
    [sym_comment] = ACTIONS(5499),
  },
  [2338] = {
    [sym_statement_block] = STATE(2241),
    [anon_sym_LBRACE] = ACTIONS(5032),
    [anon_sym_SEMI] = ACTIONS(5640),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5640),
  },
  [2339] = {
    [aux_sym_extends_clause_repeat1] = STATE(2339),
    [anon_sym_LBRACE] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(5642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4140),
  },
  [2340] = {
    [sym_type_annotation] = STATE(2695),
    [anon_sym_LBRACE] = ACTIONS(5030),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
  },
  [2341] = {
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_EQ_GT] = ACTIONS(4763),
    [anon_sym_QMARK] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
  },
  [2342] = {
    [sym_template_string] = STATE(1567),
    [sym_arguments] = STATE(1567),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
  },
  [2343] = {
    [sym_statement_block] = STATE(127),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(5576),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5576),
  },
  [2344] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2309),
    [anon_sym_COMMA] = ACTIONS(5489),
    [anon_sym_SEMI] = ACTIONS(5645),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5645),
  },
  [2345] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2307),
    [anon_sym_COMMA] = ACTIONS(5489),
    [anon_sym_SEMI] = ACTIONS(5647),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5647),
  },
  [2346] = {
    [sym_formal_parameters] = STATE(2928),
    [sym_type_parameters] = STATE(2591),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2347] = {
    [aux_sym_string_repeat2] = STATE(2276),
    [anon_sym_SQUOTE] = ACTIONS(5649),
    [aux_sym_string_token2] = ACTIONS(5651),
    [sym_escape_sequence] = ACTIONS(5653),
    [sym_comment] = ACTIONS(5499),
  },
  [2348] = {
    [sym_statement_block] = STATE(484),
    [anon_sym_LBRACE] = ACTIONS(5032),
    [anon_sym_SEMI] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5557),
  },
  [2349] = {
    [sym_formal_parameters] = STATE(2854),
    [sym_type_parameters] = STATE(2606),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2350] = {
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_GT] = ACTIONS(5655),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2351] = {
    [sym__initializer] = STATE(2604),
    [anon_sym_EQ] = ACTIONS(5126),
    [anon_sym_COMMA] = ACTIONS(5657),
    [anon_sym_RBRACE] = ACTIONS(5657),
    [sym_comment] = ACTIONS(3),
  },
  [2352] = {
    [sym_formal_parameters] = STATE(2765),
    [sym_type_parameters] = STATE(2601),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2353] = {
    [sym_statement_block] = STATE(487),
    [anon_sym_LBRACE] = ACTIONS(5032),
    [anon_sym_SEMI] = ACTIONS(5576),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5576),
  },
  [2354] = {
    [sym__from_clause] = STATE(2546),
    [anon_sym_from] = ACTIONS(5481),
    [anon_sym_SEMI] = ACTIONS(5659),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5659),
  },
  [2355] = {
    [aux_sym_extends_clause_repeat1] = STATE(2300),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_COMMA] = ACTIONS(3426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(3823),
  },
  [2356] = {
    [sym_decorator] = STATE(1762),
    [aux_sym_export_statement_repeat1] = STATE(2217),
    [anon_sym_class] = ACTIONS(5661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2357] = {
    [aux_sym_string_repeat1] = STATE(2274),
    [anon_sym_DQUOTE] = ACTIONS(5519),
    [aux_sym_string_token1] = ACTIONS(5663),
    [sym_escape_sequence] = ACTIONS(5665),
    [sym_comment] = ACTIONS(5499),
  },
  [2358] = {
    [sym_statement_block] = STATE(2219),
    [anon_sym_LBRACE] = ACTIONS(5032),
    [anon_sym_SEMI] = ACTIONS(5667),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5667),
  },
  [2359] = {
    [sym_statement_block] = STATE(1336),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_SEMI] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5557),
  },
  [2360] = {
    [sym_formal_parameters] = STATE(2820),
    [sym_type_parameters] = STATE(2596),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2361] = {
    [aux_sym_string_repeat1] = STATE(2275),
    [anon_sym_DQUOTE] = ACTIONS(5649),
    [aux_sym_string_token1] = ACTIONS(5669),
    [sym_escape_sequence] = ACTIONS(5671),
    [sym_comment] = ACTIONS(5499),
  },
  [2362] = {
    [anon_sym_SEMI] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(5487),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5673),
  },
  [2363] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2461),
    [anon_sym_COMMA] = ACTIONS(5675),
    [anon_sym_RPAREN] = ACTIONS(5677),
    [sym_comment] = ACTIONS(3),
  },
  [2364] = {
    [aux_sym_implements_clause_repeat1] = STATE(2202),
    [anon_sym_COMMA] = ACTIONS(5679),
    [anon_sym_GT] = ACTIONS(3305),
    [sym_comment] = ACTIONS(3),
  },
  [2365] = {
    [aux_sym_object_repeat1] = STATE(2448),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5681),
    [sym_comment] = ACTIONS(3),
  },
  [2366] = {
    [aux_sym_named_imports_repeat1] = STATE(2366),
    [anon_sym_COMMA] = ACTIONS(5683),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [sym_comment] = ACTIONS(3),
  },
  [2367] = {
    [sym_string] = STATE(2905),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
  },
  [2368] = {
    [sym_object_type] = STATE(2187),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
  },
  [2369] = {
    [aux_sym_array_repeat1] = STATE(2301),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RBRACK] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
  },
  [2370] = {
    [anon_sym_RBRACK] = ACTIONS(5690),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2371] = {
    [sym_type_parameters] = STATE(2843),
    [anon_sym_EQ] = ACTIONS(5692),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2372] = {
    [anon_sym_RPAREN] = ACTIONS(5694),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2373] = {
    [aux_sym_array_repeat1] = STATE(2301),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [sym_comment] = ACTIONS(3),
  },
  [2374] = {
    [aux_sym_object_repeat1] = STATE(2442),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
  },
  [2375] = {
    [aux_sym_implements_clause_repeat1] = STATE(2202),
    [anon_sym_COMMA] = ACTIONS(5700),
    [anon_sym_GT] = ACTIONS(3347),
    [sym_comment] = ACTIONS(3),
  },
  [2376] = {
    [anon_sym_from] = ACTIONS(5702),
    [anon_sym_SEMI] = ACTIONS(5702),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5702),
  },
  [2377] = {
    [anon_sym_as] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5706),
    [anon_sym_RBRACE] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
  },
  [2378] = {
    [sym_type_parameter] = STATE(2652),
    [sym_identifier] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5710),
    [sym_comment] = ACTIONS(3),
  },
  [2379] = {
    [anon_sym_RBRACK] = ACTIONS(5712),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2380] = {
    [aux_sym_implements_clause_repeat1] = STATE(2202),
    [anon_sym_COMMA] = ACTIONS(5349),
    [anon_sym_RBRACK] = ACTIONS(5714),
    [sym_comment] = ACTIONS(3),
  },
  [2381] = {
    [aux_sym_array_repeat1] = STATE(2395),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RPAREN] = ACTIONS(4253),
    [sym_comment] = ACTIONS(3),
  },
  [2382] = {
    [aux_sym_array_repeat1] = STATE(2301),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RPAREN] = ACTIONS(4253),
    [sym_comment] = ACTIONS(3),
  },
  [2383] = {
    [aux_sym_export_clause_repeat1] = STATE(2510),
    [anon_sym_COMMA] = ACTIONS(5716),
    [anon_sym_RBRACE] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
  },
  [2384] = {
    [sym_type_annotation] = STATE(2726),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(5720),
    [sym_comment] = ACTIONS(3),
  },
  [2385] = {
    [anon_sym_LBRACE] = ACTIONS(5148),
    [anon_sym_COLON] = ACTIONS(5148),
    [anon_sym_EQ_GT] = ACTIONS(5148),
    [sym_comment] = ACTIONS(3),
  },
  [2386] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2498),
    [anon_sym_COMMA] = ACTIONS(5723),
    [anon_sym_RPAREN] = ACTIONS(4653),
    [sym_comment] = ACTIONS(3),
  },
  [2387] = {
    [anon_sym_COMMA] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5725),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5725),
  },
  [2388] = {
    [anon_sym_COMMA] = ACTIONS(5727),
    [anon_sym_SEMI] = ACTIONS(5727),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5727),
  },
  [2389] = {
    [aux_sym_enum_body_repeat1] = STATE(2463),
    [anon_sym_COMMA] = ACTIONS(5471),
    [anon_sym_RBRACE] = ACTIONS(5473),
    [sym_comment] = ACTIONS(3),
  },
  [2390] = {
    [aux_sym_array_repeat1] = STATE(2494),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RPAREN] = ACTIONS(4202),
    [sym_comment] = ACTIONS(3),
  },
  [2391] = {
    [aux_sym_implements_clause_repeat1] = STATE(2202),
    [anon_sym_COMMA] = ACTIONS(5349),
    [anon_sym_RBRACK] = ACTIONS(5729),
    [sym_comment] = ACTIONS(3),
  },
  [2392] = {
    [aux_sym_object_repeat1] = STATE(2448),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5731),
    [sym_comment] = ACTIONS(3),
  },
  [2393] = {
    [anon_sym_SEMI] = ACTIONS(5733),
    [anon_sym_DOT] = ACTIONS(5034),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5733),
  },
  [2394] = {
    [anon_sym_RBRACK] = ACTIONS(5735),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2395] = {
    [aux_sym_array_repeat1] = STATE(2301),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RPAREN] = ACTIONS(5737),
    [sym_comment] = ACTIONS(3),
  },
  [2396] = {
    [aux_sym_object_repeat1] = STATE(2469),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5739),
    [sym_comment] = ACTIONS(3),
  },
  [2397] = {
    [anon_sym_from] = ACTIONS(5741),
    [anon_sym_SEMI] = ACTIONS(5741),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5741),
  },
  [2398] = {
    [aux_sym_object_repeat1] = STATE(2448),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5739),
    [sym_comment] = ACTIONS(3),
  },
  [2399] = {
    [aux_sym_object_repeat1] = STATE(2448),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5743),
    [sym_comment] = ACTIONS(3),
  },
  [2400] = {
    [anon_sym_COMMA] = ACTIONS(5745),
    [anon_sym_SEMI] = ACTIONS(5745),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5745),
  },
  [2401] = {
    [sym_type_annotation] = STATE(2695),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(5747),
    [sym_comment] = ACTIONS(3),
  },
  [2402] = {
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5750),
  },
  [2403] = {
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5752),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5752),
  },
  [2404] = {
    [anon_sym_LBRACE] = ACTIONS(5754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5393),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5393),
  },
  [2405] = {
    [aux_sym_implements_clause_repeat1] = STATE(2202),
    [anon_sym_COMMA] = ACTIONS(5349),
    [anon_sym_RBRACK] = ACTIONS(5756),
    [sym_comment] = ACTIONS(3),
  },
  [2406] = {
    [anon_sym_COMMA] = ACTIONS(5758),
    [anon_sym_SEMI] = ACTIONS(5758),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5758),
  },
  [2407] = {
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_SEMI] = ACTIONS(5760),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5760),
  },
  [2408] = {
    [anon_sym_COMMA] = ACTIONS(5762),
    [anon_sym_SEMI] = ACTIONS(5762),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5762),
  },
  [2409] = {
    [anon_sym_COMMA] = ACTIONS(5764),
    [anon_sym_SEMI] = ACTIONS(5764),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5764),
  },
  [2410] = {
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_COMMA] = ACTIONS(5768),
    [anon_sym_from] = ACTIONS(5770),
    [sym_comment] = ACTIONS(3),
  },
  [2411] = {
    [anon_sym_COMMA] = ACTIONS(5772),
    [anon_sym_SEMI] = ACTIONS(5772),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5772),
  },
  [2412] = {
    [sym_string] = STATE(2732),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
  },
  [2413] = {
    [aux_sym_named_imports_repeat1] = STATE(2366),
    [anon_sym_COMMA] = ACTIONS(5774),
    [anon_sym_RBRACE] = ACTIONS(5405),
    [sym_comment] = ACTIONS(3),
  },
  [2414] = {
    [anon_sym_COMMA] = ACTIONS(5776),
    [anon_sym_SEMI] = ACTIONS(5776),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5776),
  },
  [2415] = {
    [anon_sym_LBRACE] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4140),
  },
  [2416] = {
    [anon_sym_COMMA] = ACTIONS(4711),
    [anon_sym_SEMI] = ACTIONS(4711),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4711),
  },
  [2417] = {
    [sym_object_type] = STATE(2258),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
  },
  [2418] = {
    [sym_type_parameters] = STATE(2893),
    [anon_sym_EQ] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [2419] = {
    [anon_sym_COMMA] = ACTIONS(5780),
    [anon_sym_SEMI] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5780),
  },
  [2420] = {
    [anon_sym_COMMA] = ACTIONS(5782),
    [anon_sym_SEMI] = ACTIONS(5782),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5782),
  },
  [2421] = {
    [aux_sym_array_repeat1] = STATE(2301),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RPAREN] = ACTIONS(4132),
    [sym_comment] = ACTIONS(3),
  },
  [2422] = {
    [anon_sym_COMMA] = ACTIONS(5784),
    [anon_sym_SEMI] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5784),
  },
  [2423] = {
    [aux_sym_type_parameters_repeat1] = STATE(2438),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_GT] = ACTIONS(5788),
    [sym_comment] = ACTIONS(3),
  },
  [2424] = {
    [aux_sym_array_repeat1] = STATE(2373),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RPAREN] = ACTIONS(4132),
    [sym_comment] = ACTIONS(3),
  },
  [2425] = {
    [sym_type_parameter] = STATE(2652),
    [sym_identifier] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5788),
    [sym_comment] = ACTIONS(3),
  },
  [2426] = {
    [anon_sym_LBRACE] = ACTIONS(5790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5399),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5399),
  },
  [2427] = {
    [aux_sym_implements_clause_repeat1] = STATE(2202),
    [anon_sym_COMMA] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(3345),
    [sym_comment] = ACTIONS(3),
  },
  [2428] = {
    [aux_sym_enum_body_repeat1] = STATE(2428),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_RBRACE] = ACTIONS(5657),
    [sym_comment] = ACTIONS(3),
  },
  [2429] = {
    [anon_sym_LBRACE] = ACTIONS(3725),
    [anon_sym_COLON] = ACTIONS(3725),
    [anon_sym_EQ_GT] = ACTIONS(3725),
    [sym_comment] = ACTIONS(3),
  },
  [2430] = {
    [anon_sym_SEMI] = ACTIONS(5797),
    [anon_sym_DOT] = ACTIONS(5034),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5797),
  },
  [2431] = {
    [anon_sym_COMMA] = ACTIONS(5799),
    [anon_sym_SEMI] = ACTIONS(5799),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5799),
  },
  [2432] = {
    [sym_type_parameter] = STATE(2652),
    [sym_identifier] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5801),
    [sym_comment] = ACTIONS(3),
  },
  [2433] = {
    [aux_sym_type_parameters_repeat1] = STATE(2436),
    [anon_sym_COMMA] = ACTIONS(5803),
    [anon_sym_GT] = ACTIONS(5805),
    [sym_comment] = ACTIONS(3),
  },
  [2434] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_nested_type_identifier] = STATE(1876),
    [sym_identifier] = ACTIONS(5807),
    [sym_comment] = ACTIONS(3),
  },
  [2435] = {
    [anon_sym_COMMA] = ACTIONS(5809),
    [anon_sym_SEMI] = ACTIONS(5809),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5809),
  },
  [2436] = {
    [aux_sym_type_parameters_repeat1] = STATE(2438),
    [anon_sym_COMMA] = ACTIONS(5811),
    [anon_sym_GT] = ACTIONS(5813),
    [sym_comment] = ACTIONS(3),
  },
  [2437] = {
    [anon_sym_RPAREN] = ACTIONS(5815),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2438] = {
    [aux_sym_type_parameters_repeat1] = STATE(2438),
    [anon_sym_COMMA] = ACTIONS(5817),
    [anon_sym_GT] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
  },
  [2439] = {
    [aux_sym_array_repeat1] = STATE(2301),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RBRACK] = ACTIONS(4156),
    [sym_comment] = ACTIONS(3),
  },
  [2440] = {
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_SEMI] = ACTIONS(5822),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5822),
  },
  [2441] = {
    [sym_type_parameter] = STATE(2652),
    [sym_identifier] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5813),
    [sym_comment] = ACTIONS(3),
  },
  [2442] = {
    [aux_sym_object_repeat1] = STATE(2448),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5824),
    [sym_comment] = ACTIONS(3),
  },
  [2443] = {
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4140),
  },
  [2444] = {
    [aux_sym_array_repeat1] = STATE(2369),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RBRACK] = ACTIONS(4156),
    [sym_comment] = ACTIONS(3),
  },
  [2445] = {
    [anon_sym_COMMA] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5598),
  },
  [2446] = {
    [aux_sym_enum_body_repeat1] = STATE(2464),
    [anon_sym_COMMA] = ACTIONS(5434),
    [anon_sym_RBRACE] = ACTIONS(5436),
    [sym_comment] = ACTIONS(3),
  },
  [2447] = {
    [sym_nested_identifier] = STATE(2841),
    [sym_nested_type_identifier] = STATE(1113),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(3),
  },
  [2448] = {
    [aux_sym_object_repeat1] = STATE(2448),
    [anon_sym_COMMA] = ACTIONS(5828),
    [anon_sym_RBRACE] = ACTIONS(5831),
    [sym_comment] = ACTIONS(3),
  },
  [2449] = {
    [anon_sym_COMMA] = ACTIONS(5833),
    [anon_sym_SEMI] = ACTIONS(5833),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5833),
  },
  [2450] = {
    [anon_sym_COMMA] = ACTIONS(5835),
    [anon_sym_SEMI] = ACTIONS(5835),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5835),
  },
  [2451] = {
    [aux_sym_implements_clause_repeat1] = STATE(2202),
    [anon_sym_LBRACE] = ACTIONS(5837),
    [anon_sym_COMMA] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2452] = {
    [anon_sym_COMMA] = ACTIONS(5839),
    [anon_sym_SEMI] = ACTIONS(5839),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5839),
  },
  [2453] = {
    [aux_sym_object_repeat1] = STATE(2448),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5841),
    [sym_comment] = ACTIONS(3),
  },
  [2454] = {
    [anon_sym_RPAREN] = ACTIONS(5843),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2455] = {
    [anon_sym_COMMA] = ACTIONS(5845),
    [anon_sym_SEMI] = ACTIONS(5845),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5845),
  },
  [2456] = {
    [aux_sym_array_repeat1] = STATE(2301),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RBRACK] = ACTIONS(5847),
    [sym_comment] = ACTIONS(3),
  },
  [2457] = {
    [sym_nested_identifier] = STATE(2853),
    [sym_nested_type_identifier] = STATE(1384),
    [sym_identifier] = ACTIONS(5849),
    [sym_comment] = ACTIONS(3),
  },
  [2458] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2386),
    [anon_sym_COMMA] = ACTIONS(5851),
    [anon_sym_RPAREN] = ACTIONS(4657),
    [sym_comment] = ACTIONS(3),
  },
  [2459] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2517),
    [anon_sym_COMMA] = ACTIONS(5853),
    [anon_sym_RPAREN] = ACTIONS(5855),
    [sym_comment] = ACTIONS(3),
  },
  [2460] = {
    [anon_sym_RPAREN] = ACTIONS(5857),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2461] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2498),
    [anon_sym_COMMA] = ACTIONS(5851),
    [anon_sym_RPAREN] = ACTIONS(4657),
    [sym_comment] = ACTIONS(3),
  },
  [2462] = {
    [aux_sym_object_repeat1] = STATE(2365),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5841),
    [sym_comment] = ACTIONS(3),
  },
  [2463] = {
    [aux_sym_enum_body_repeat1] = STATE(2428),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RBRACE] = ACTIONS(4796),
    [sym_comment] = ACTIONS(3),
  },
  [2464] = {
    [aux_sym_enum_body_repeat1] = STATE(2428),
    [anon_sym_COMMA] = ACTIONS(5861),
    [anon_sym_RBRACE] = ACTIONS(4806),
    [sym_comment] = ACTIONS(3),
  },
  [2465] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2498),
    [anon_sym_COMMA] = ACTIONS(5863),
    [anon_sym_RPAREN] = ACTIONS(4655),
    [sym_comment] = ACTIONS(3),
  },
  [2466] = {
    [aux_sym_implements_clause_repeat1] = STATE(2202),
    [anon_sym_COMMA] = ACTIONS(5865),
    [anon_sym_GT] = ACTIONS(3315),
    [sym_comment] = ACTIONS(3),
  },
  [2467] = {
    [sym_type_annotation] = STATE(2726),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(5867),
    [sym_comment] = ACTIONS(3),
  },
  [2468] = {
    [anon_sym_LBRACE] = ACTIONS(5098),
    [anon_sym_COLON] = ACTIONS(5098),
    [anon_sym_EQ_GT] = ACTIONS(5098),
    [sym_comment] = ACTIONS(3),
  },
  [2469] = {
    [aux_sym_object_repeat1] = STATE(2448),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5870),
    [sym_comment] = ACTIONS(3),
  },
  [2470] = {
    [anon_sym_LBRACE] = ACTIONS(5872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5440),
  },
  [2471] = {
    [aux_sym_array_repeat1] = STATE(2481),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RPAREN] = ACTIONS(4121),
    [sym_comment] = ACTIONS(3),
  },
  [2472] = {
    [aux_sym_array_repeat1] = STATE(2301),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RPAREN] = ACTIONS(4121),
    [sym_comment] = ACTIONS(3),
  },
  [2473] = {
    [sym_implements_clause] = STATE(2771),
    [anon_sym_LBRACE] = ACTIONS(5874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5010),
  },
  [2474] = {
    [aux_sym_array_repeat1] = STATE(2301),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RPAREN] = ACTIONS(4202),
    [sym_comment] = ACTIONS(3),
  },
  [2475] = {
    [anon_sym_from] = ACTIONS(5876),
    [anon_sym_SEMI] = ACTIONS(5876),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5876),
  },
  [2476] = {
    [aux_sym_implements_clause_repeat1] = STATE(2202),
    [anon_sym_COMMA] = ACTIONS(5349),
    [anon_sym_RBRACK] = ACTIONS(5878),
    [sym_comment] = ACTIONS(3),
  },
  [2477] = {
    [anon_sym_RBRACK] = ACTIONS(5880),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2478] = {
    [anon_sym_COMMA] = ACTIONS(5882),
    [anon_sym_SEMI] = ACTIONS(5882),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5882),
  },
  [2479] = {
    [anon_sym_RBRACK] = ACTIONS(5884),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2480] = {
    [aux_sym_named_imports_repeat1] = STATE(2413),
    [anon_sym_COMMA] = ACTIONS(5886),
    [anon_sym_RBRACE] = ACTIONS(5888),
    [sym_comment] = ACTIONS(3),
  },
  [2481] = {
    [aux_sym_array_repeat1] = STATE(2301),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RPAREN] = ACTIONS(5890),
    [sym_comment] = ACTIONS(3),
  },
  [2482] = {
    [aux_sym_type_parameters_repeat1] = STATE(2423),
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_GT] = ACTIONS(5894),
    [sym_comment] = ACTIONS(3),
  },
  [2483] = {
    [anon_sym_EQ] = ACTIONS(5896),
    [anon_sym_COMMA] = ACTIONS(5768),
    [anon_sym_from] = ACTIONS(5770),
    [sym_comment] = ACTIONS(3),
  },
  [2484] = {
    [aux_sym_object_repeat1] = STATE(2448),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
  },
  [2485] = {
    [aux_sym_array_repeat1] = STATE(2301),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RBRACK] = ACTIONS(5900),
    [sym_comment] = ACTIONS(3),
  },
  [2486] = {
    [anon_sym_COMMA] = ACTIONS(4154),
    [anon_sym_RPAREN] = ACTIONS(4154),
    [anon_sym_RBRACK] = ACTIONS(4154),
    [sym_comment] = ACTIONS(3),
  },
  [2487] = {
    [sym_nested_identifier] = STATE(2430),
    [sym_identifier] = ACTIONS(5902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_require] = ACTIONS(5904),
  },
  [2488] = {
    [sym_statement_block] = STATE(502),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_LPAREN] = ACTIONS(5906),
    [sym_comment] = ACTIONS(3),
  },
  [2489] = {
    [sym_type_annotation] = STATE(2726),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [sym_comment] = ACTIONS(3),
  },
  [2490] = {
    [sym_type_annotation] = STATE(2695),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(5911),
    [sym_comment] = ACTIONS(3),
  },
  [2491] = {
    [anon_sym_LBRACE] = ACTIONS(5068),
    [anon_sym_COLON] = ACTIONS(5068),
    [anon_sym_EQ_GT] = ACTIONS(5068),
    [sym_comment] = ACTIONS(3),
  },
  [2492] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2465),
    [anon_sym_COMMA] = ACTIONS(5914),
    [anon_sym_RPAREN] = ACTIONS(4647),
    [sym_comment] = ACTIONS(3),
  },
  [2493] = {
    [anon_sym_COMMA] = ACTIONS(5916),
    [anon_sym_SEMI] = ACTIONS(5916),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5916),
  },
  [2494] = {
    [aux_sym_array_repeat1] = STATE(2301),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RPAREN] = ACTIONS(5918),
    [sym_comment] = ACTIONS(3),
  },
  [2495] = {
    [anon_sym_COMMA] = ACTIONS(5920),
    [anon_sym_SEMI] = ACTIONS(5920),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5920),
  },
  [2496] = {
    [sym_nested_identifier] = STATE(2855),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_identifier] = ACTIONS(5922),
    [sym_comment] = ACTIONS(3),
  },
  [2497] = {
    [anon_sym_COMMA] = ACTIONS(5924),
    [anon_sym_SEMI] = ACTIONS(5924),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5924),
  },
  [2498] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2498),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_RPAREN] = ACTIONS(5929),
    [sym_comment] = ACTIONS(3),
  },
  [2499] = {
    [sym_object_type] = STATE(559),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [2500] = {
    [anon_sym_COMMA] = ACTIONS(5931),
    [anon_sym_SEMI] = ACTIONS(5931),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5931),
  },
  [2501] = {
    [sym_object_type] = STATE(569),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [2502] = {
    [aux_sym_export_clause_repeat1] = STATE(2502),
    [anon_sym_COMMA] = ACTIONS(5933),
    [anon_sym_RBRACE] = ACTIONS(5936),
    [sym_comment] = ACTIONS(3),
  },
  [2503] = {
    [anon_sym_COMMA] = ACTIONS(5938),
    [anon_sym_SEMI] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5938),
  },
  [2504] = {
    [aux_sym_array_repeat1] = STATE(2301),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RBRACK] = ACTIONS(4184),
    [sym_comment] = ACTIONS(3),
  },
  [2505] = {
    [aux_sym_array_repeat1] = STATE(2456),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RBRACK] = ACTIONS(4184),
    [sym_comment] = ACTIONS(3),
  },
  [2506] = {
    [anon_sym_RPAREN] = ACTIONS(5940),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2507] = {
    [sym_identifier] = ACTIONS(5942),
    [anon_sym_SEMI] = ACTIONS(5944),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5944),
  },
  [2508] = {
    [sym_nested_identifier] = STATE(2744),
    [sym_nested_type_identifier] = STATE(432),
    [sym_identifier] = ACTIONS(5946),
    [sym_comment] = ACTIONS(3),
  },
  [2509] = {
    [anon_sym_from] = ACTIONS(5948),
    [anon_sym_SEMI] = ACTIONS(5948),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5948),
  },
  [2510] = {
    [aux_sym_export_clause_repeat1] = STATE(2502),
    [anon_sym_COMMA] = ACTIONS(5950),
    [anon_sym_RBRACE] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
  },
  [2511] = {
    [anon_sym_from] = ACTIONS(5952),
    [anon_sym_SEMI] = ACTIONS(5952),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5952),
  },
  [2512] = {
    [aux_sym_implements_clause_repeat1] = STATE(2202),
    [anon_sym_COMMA] = ACTIONS(5954),
    [anon_sym_GT] = ACTIONS(3341),
    [sym_comment] = ACTIONS(3),
  },
  [2513] = {
    [sym_identifier] = ACTIONS(5956),
    [anon_sym_SEMI] = ACTIONS(5958),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5958),
  },
  [2514] = {
    [sym_type_annotation] = STATE(2695),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(5960),
    [sym_comment] = ACTIONS(3),
  },
  [2515] = {
    [sym_type_annotation] = STATE(2726),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(5963),
    [sym_comment] = ACTIONS(3),
  },
  [2516] = {
    [aux_sym_object_repeat1] = STATE(2448),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
  },
  [2517] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2498),
    [anon_sym_COMMA] = ACTIONS(5914),
    [anon_sym_RPAREN] = ACTIONS(4647),
    [sym_comment] = ACTIONS(3),
  },
  [2518] = {
    [aux_sym_array_repeat1] = STATE(2301),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RBRACK] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
  },
  [2519] = {
    [aux_sym_implements_clause_repeat1] = STATE(2202),
    [anon_sym_COMMA] = ACTIONS(5349),
    [anon_sym_RBRACK] = ACTIONS(5966),
    [sym_comment] = ACTIONS(3),
  },
  [2520] = {
    [aux_sym_array_repeat1] = STATE(2485),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_RBRACK] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
  },
  [2521] = {
    [anon_sym_LBRACE] = ACTIONS(5092),
    [anon_sym_COLON] = ACTIONS(5092),
    [anon_sym_EQ_GT] = ACTIONS(5092),
    [sym_comment] = ACTIONS(3),
  },
  [2522] = {
    [anon_sym_RBRACK] = ACTIONS(5968),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_PIPE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2523] = {
    [sym_type_annotation] = STATE(2695),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_EQ_GT] = ACTIONS(5970),
    [sym_comment] = ACTIONS(3),
  },
  [2524] = {
    [sym__for_header] = STATE(40),
    [anon_sym_LPAREN] = ACTIONS(5973),
    [anon_sym_await] = ACTIONS(5975),
    [sym_comment] = ACTIONS(3),
  },
  [2525] = {
    [sym__for_header] = STATE(32),
    [anon_sym_LPAREN] = ACTIONS(5977),
    [anon_sym_await] = ACTIONS(5979),
    [sym_comment] = ACTIONS(3),
  },
  [2526] = {
    [anon_sym_COMMA] = ACTIONS(5981),
    [anon_sym_SEMI] = ACTIONS(5981),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5981),
  },
  [2527] = {
    [anon_sym_as] = ACTIONS(5983),
    [anon_sym_COMMA] = ACTIONS(5985),
    [anon_sym_RBRACE] = ACTIONS(5985),
    [sym_comment] = ACTIONS(3),
  },
  [2528] = {
    [anon_sym_COMMA] = ACTIONS(5987),
    [anon_sym_RPAREN] = ACTIONS(5987),
    [sym_comment] = ACTIONS(3),
  },
  [2529] = {
    [sym_statement_block] = STATE(122),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [sym_comment] = ACTIONS(3),
  },
  [2530] = {
    [sym_identifier] = ACTIONS(5989),
    [anon_sym_STAR] = ACTIONS(5991),
    [sym_comment] = ACTIONS(3),
  },
  [2531] = {
    [sym_statement_block] = STATE(2696),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2532] = {
    [sym_identifier] = ACTIONS(5993),
    [anon_sym_STAR] = ACTIONS(5995),
    [sym_comment] = ACTIONS(3),
  },
  [2533] = {
    [anon_sym_COMMA] = ACTIONS(4757),
    [anon_sym_RBRACE] = ACTIONS(4757),
    [sym_comment] = ACTIONS(3),
  },
  [2534] = {
    [sym_statement_block] = STATE(2700),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2535] = {
    [sym_parenthesized_expression] = STATE(35),
    [anon_sym_LPAREN] = ACTIONS(5997),
    [sym_comment] = ACTIONS(3),
  },
  [2536] = {
    [sym_parenthesized_expression] = STATE(2664),
    [anon_sym_LPAREN] = ACTIONS(5997),
    [sym_comment] = ACTIONS(3),
  },
  [2537] = {
    [sym_statement_block] = STATE(1027),
    [anon_sym_LBRACE] = ACTIONS(3690),
    [sym_comment] = ACTIONS(3),
  },
  [2538] = {
    [sym_class_body] = STATE(1487),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2539] = {
    [anon_sym_COMMA] = ACTIONS(5999),
    [anon_sym_RPAREN] = ACTIONS(5999),
    [sym_comment] = ACTIONS(3),
  },
  [2540] = {
    [sym_parenthesized_expression] = STATE(49),
    [anon_sym_LPAREN] = ACTIONS(5997),
    [sym_comment] = ACTIONS(3),
  },
  [2541] = {
    [sym_statement_block] = STATE(452),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2542] = {
    [sym_parenthesized_expression] = STATE(43),
    [anon_sym_LPAREN] = ACTIONS(5997),
    [sym_comment] = ACTIONS(3),
  },
  [2543] = {
    [sym_statement_block] = STATE(2129),
    [anon_sym_LBRACE] = ACTIONS(5032),
    [sym_comment] = ACTIONS(3),
  },
  [2544] = {
    [sym_enum_body] = STATE(2135),
    [anon_sym_LBRACE] = ACTIONS(6001),
    [sym_comment] = ACTIONS(3),
  },
  [2545] = {
    [anon_sym_SEMI] = ACTIONS(6003),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6003),
  },
  [2546] = {
    [anon_sym_SEMI] = ACTIONS(3460),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3460),
  },
  [2547] = {
    [sym_nested_identifier] = STATE(1373),
    [sym_identifier] = ACTIONS(6005),
    [sym_comment] = ACTIONS(3),
  },
  [2548] = {
    [anon_sym_COMMA] = ACTIONS(6007),
    [anon_sym_RPAREN] = ACTIONS(6007),
    [sym_comment] = ACTIONS(3),
  },
  [2549] = {
    [anon_sym_SEMI] = ACTIONS(6009),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6009),
  },
  [2550] = {
    [sym_enum_body] = STATE(2226),
    [anon_sym_LBRACE] = ACTIONS(6001),
    [sym_comment] = ACTIONS(3),
  },
  [2551] = {
    [anon_sym_COMMA] = ACTIONS(6011),
    [anon_sym_RPAREN] = ACTIONS(6011),
    [sym_comment] = ACTIONS(3),
  },
  [2552] = {
    [sym_enum_body] = STATE(509),
    [anon_sym_LBRACE] = ACTIONS(6013),
    [sym_comment] = ACTIONS(3),
  },
  [2553] = {
    [anon_sym_COMMA] = ACTIONS(4715),
    [anon_sym_RBRACE] = ACTIONS(4715),
    [sym_comment] = ACTIONS(3),
  },
  [2554] = {
    [sym_statement_block] = STATE(2633),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2555] = {
    [sym_class_body] = STATE(1295),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2556] = {
    [sym_class_body] = STATE(1079),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
  },
  [2557] = {
    [sym_statement_block] = STATE(1082),
    [anon_sym_LBRACE] = ACTIONS(3690),
    [sym_comment] = ACTIONS(3),
  },
  [2558] = {
    [sym_statement_block] = STATE(1092),
    [anon_sym_LBRACE] = ACTIONS(3690),
    [sym_comment] = ACTIONS(3),
  },
  [2559] = {
    [anon_sym_COMMA] = ACTIONS(4727),
    [anon_sym_RBRACE] = ACTIONS(4727),
    [sym_comment] = ACTIONS(3),
  },
  [2560] = {
    [sym_parenthesized_expression] = STATE(34),
    [anon_sym_LPAREN] = ACTIONS(5997),
    [sym_comment] = ACTIONS(3),
  },
  [2561] = {
    [sym_parenthesized_expression] = STATE(33),
    [anon_sym_LPAREN] = ACTIONS(5997),
    [sym_comment] = ACTIONS(3),
  },
  [2562] = {
    [sym_parenthesized_expression] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(5997),
    [sym_comment] = ACTIONS(3),
  },
  [2563] = {
    [sym_statement_block] = STATE(2553),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2564] = {
    [sym_class_body] = STATE(540),
    [anon_sym_LBRACE] = ACTIONS(5020),
    [sym_comment] = ACTIONS(3),
  },
  [2565] = {
    [anon_sym_COMMA] = ACTIONS(4731),
    [anon_sym_RBRACE] = ACTIONS(4731),
    [sym_comment] = ACTIONS(3),
  },
  [2566] = {
    [anon_sym_COMMA] = ACTIONS(4753),
    [anon_sym_RBRACE] = ACTIONS(4753),
    [sym_comment] = ACTIONS(3),
  },
  [2567] = {
    [sym_identifier] = ACTIONS(6015),
    [anon_sym_STAR] = ACTIONS(6017),
    [sym_comment] = ACTIONS(3),
  },
  [2568] = {
    [anon_sym_SEMI] = ACTIONS(6019),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6019),
  },
  [2569] = {
    [sym_class_body] = STATE(498),
    [anon_sym_LBRACE] = ACTIONS(5016),
    [sym_comment] = ACTIONS(3),
  },
  [2570] = {
    [anon_sym_SEMI] = ACTIONS(4196),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4196),
  },
  [2571] = {
    [anon_sym_COMMA] = ACTIONS(6021),
    [anon_sym_RPAREN] = ACTIONS(6021),
    [sym_comment] = ACTIONS(3),
  },
  [2572] = {
    [sym_identifier] = ACTIONS(6023),
    [anon_sym_STAR] = ACTIONS(6025),
    [sym_comment] = ACTIONS(3),
  },
  [2573] = {
    [sym__from_clause] = STATE(2546),
    [anon_sym_from] = ACTIONS(5481),
    [sym_comment] = ACTIONS(3),
  },
  [2574] = {
    [sym_formal_parameters] = STATE(2489),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2575] = {
    [sym_nested_identifier] = STATE(1566),
    [sym_identifier] = ACTIONS(6027),
    [sym_comment] = ACTIONS(3),
  },
  [2576] = {
    [sym_formal_parameters] = STATE(2333),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2577] = {
    [sym_parenthesized_expression] = STATE(2549),
    [anon_sym_LPAREN] = ACTIONS(6029),
    [sym_comment] = ACTIONS(3),
  },
  [2578] = {
    [anon_sym_SEMI] = ACTIONS(6031),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6031),
  },
  [2579] = {
    [sym_statement_block] = STATE(499),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2580] = {
    [sym_statement_block] = STATE(501),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2581] = {
    [sym__from_clause] = STATE(2568),
    [anon_sym_from] = ACTIONS(5481),
    [sym_comment] = ACTIONS(3),
  },
  [2582] = {
    [sym_statement_block] = STATE(490),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2583] = {
    [sym_statement_block] = STATE(527),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2584] = {
    [sym_statement_block] = STATE(1426),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [sym_comment] = ACTIONS(3),
  },
  [2585] = {
    [sym_statement_block] = STATE(496),
    [anon_sym_LBRACE] = ACTIONS(5559),
    [sym_comment] = ACTIONS(3),
  },
  [2586] = {
    [sym_formal_parameters] = STATE(1945),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
  },
  [2587] = {
    [sym__from_clause] = STATE(2691),
    [anon_sym_from] = ACTIONS(5481),
    [sym_comment] = ACTIONS(3),
  },
  [2588] = {
    [sym_class_body] = STATE(1099),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
  },
  [2589] = {
    [anon_sym_SEMI] = ACTIONS(6033),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6033),
  },
  [2590] = {
    [sym_class_body] = STATE(504),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2591] = {
    [sym_formal_parameters] = STATE(2925),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2592] = {
    [sym_formal_parameters] = STATE(2926),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2593] = {
    [anon_sym_COMMA] = ACTIONS(6035),
    [anon_sym_RBRACE] = ACTIONS(6035),
    [sym_comment] = ACTIONS(3),
  },
  [2594] = {
    [sym__for_header] = STATE(37),
    [anon_sym_LPAREN] = ACTIONS(6037),
    [sym_comment] = ACTIONS(3),
  },
  [2595] = {
    [sym_class_body] = STATE(1104),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
  },
  [2596] = {
    [sym_formal_parameters] = STATE(2943),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2597] = {
    [sym_class_body] = STATE(110),
    [anon_sym_LBRACE] = ACTIONS(5014),
    [sym_comment] = ACTIONS(3),
  },
  [2598] = {
    [sym_formal_parameters] = STATE(2946),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2599] = {
    [sym_statement_block] = STATE(1109),
    [anon_sym_LBRACE] = ACTIONS(3690),
    [sym_comment] = ACTIONS(3),
  },
  [2600] = {
    [sym_type_parameter] = STATE(2433),
    [sym_identifier] = ACTIONS(5708),
    [sym_comment] = ACTIONS(3),
  },
  [2601] = {
    [sym_formal_parameters] = STATE(2767),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2602] = {
    [sym_formal_parameters] = STATE(2766),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2603] = {
    [sym_formal_parameters] = STATE(2907),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2604] = {
    [anon_sym_COMMA] = ACTIONS(6039),
    [anon_sym_RBRACE] = ACTIONS(6039),
    [sym_comment] = ACTIONS(3),
  },
  [2605] = {
    [sym_identifier] = ACTIONS(6041),
    [anon_sym_STAR] = ACTIONS(6043),
    [sym_comment] = ACTIONS(3),
  },
  [2606] = {
    [sym_formal_parameters] = STATE(2863),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2607] = {
    [sym_class_body] = STATE(1421),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2608] = {
    [sym_formal_parameters] = STATE(2857),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2609] = {
    [sym_statement_block] = STATE(128),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [sym_comment] = ACTIONS(3),
  },
  [2610] = {
    [sym_formal_parameters] = STATE(1903),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
  },
  [2611] = {
    [anon_sym_COMMA] = ACTIONS(4705),
    [anon_sym_RBRACE] = ACTIONS(4705),
    [sym_comment] = ACTIONS(3),
  },
  [2612] = {
    [sym_statement_block] = STATE(2611),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2613] = {
    [sym_statement_block] = STATE(2708),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2614] = {
    [sym_nested_identifier] = STATE(1061),
    [sym_identifier] = ACTIONS(6045),
    [sym_comment] = ACTIONS(3),
  },
  [2615] = {
    [sym_class_body] = STATE(1330),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2616] = {
    [sym_statement_block] = STATE(1486),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [sym_comment] = ACTIONS(3),
  },
  [2617] = {
    [sym_statement_block] = STATE(2559),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2618] = {
    [sym_statement_block] = STATE(1118),
    [anon_sym_LBRACE] = ACTIONS(3690),
    [sym_comment] = ACTIONS(3),
  },
  [2619] = {
    [sym_formal_parameters] = STATE(2848),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2620] = {
    [anon_sym_COMMA] = ACTIONS(6047),
    [anon_sym_GT] = ACTIONS(6047),
    [sym_comment] = ACTIONS(3),
  },
  [2621] = {
    [anon_sym_COMMA] = ACTIONS(5624),
    [anon_sym_GT] = ACTIONS(5624),
    [sym_comment] = ACTIONS(3),
  },
  [2622] = {
    [sym_class_body] = STATE(1021),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
  },
  [2623] = {
    [sym_type_parameter] = STATE(2652),
    [sym_identifier] = ACTIONS(5708),
    [sym_comment] = ACTIONS(3),
  },
  [2624] = {
    [sym_class_body] = STATE(112),
    [anon_sym_LBRACE] = ACTIONS(5014),
    [sym_comment] = ACTIONS(3),
  },
  [2625] = {
    [sym_class_body] = STATE(1596),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
  },
  [2626] = {
    [sym_statement_block] = STATE(2736),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2627] = {
    [anon_sym_COMMA] = ACTIONS(5831),
    [anon_sym_RBRACE] = ACTIONS(5831),
    [sym_comment] = ACTIONS(3),
  },
  [2628] = {
    [sym_class_body] = STATE(2197),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2629] = {
    [sym_statement_block] = STATE(1598),
    [anon_sym_LBRACE] = ACTIONS(6049),
    [sym_comment] = ACTIONS(3),
  },
  [2630] = {
    [sym_class_body] = STATE(2138),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2631] = {
    [sym_formal_parameters] = STATE(2384),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2632] = {
    [sym_class_body] = STATE(1358),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2633] = {
    [anon_sym_COMMA] = ACTIONS(4735),
    [anon_sym_RBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(3),
  },
  [2634] = {
    [sym_statement_block] = STATE(1357),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [sym_comment] = ACTIONS(3),
  },
  [2635] = {
    [sym_class_body] = STATE(1601),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
  },
  [2636] = {
    [sym_statement_block] = STATE(1602),
    [anon_sym_LBRACE] = ACTIONS(6049),
    [sym_comment] = ACTIONS(3),
  },
  [2637] = {
    [sym_statement_block] = STATE(1603),
    [anon_sym_LBRACE] = ACTIONS(6049),
    [sym_comment] = ACTIONS(3),
  },
  [2638] = {
    [sym_class_body] = STATE(1604),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
  },
  [2639] = {
    [sym_type_annotation] = STATE(2102),
    [anon_sym_COLON] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
  },
  [2640] = {
    [anon_sym_else] = ACTIONS(6051),
    [anon_sym_while] = ACTIONS(2728),
    [sym_comment] = ACTIONS(3),
  },
  [2641] = {
    [sym_class_body] = STATE(2169),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2642] = {
    [sym_class_body] = STATE(2173),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2643] = {
    [sym_formal_parameters] = STATE(2836),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2644] = {
    [sym_class_body] = STATE(1605),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
  },
  [2645] = {
    [sym_statement_block] = STATE(2565),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2646] = {
    [sym_statement_block] = STATE(1609),
    [anon_sym_LBRACE] = ACTIONS(6049),
    [sym_comment] = ACTIONS(3),
  },
  [2647] = {
    [anon_sym_COMMA] = ACTIONS(4695),
    [anon_sym_RBRACE] = ACTIONS(4695),
    [sym_comment] = ACTIONS(3),
  },
  [2648] = {
    [sym_class_body] = STATE(495),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2649] = {
    [sym__from_clause] = STATE(2578),
    [anon_sym_from] = ACTIONS(5481),
    [sym_comment] = ACTIONS(3),
  },
  [2650] = {
    [anon_sym_SEMI] = ACTIONS(6053),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6053),
  },
  [2651] = {
    [sym_class_body] = STATE(489),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2652] = {
    [anon_sym_COMMA] = ACTIONS(5820),
    [anon_sym_GT] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
  },
  [2653] = {
    [sym_class_body] = STATE(1129),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
  },
  [2654] = {
    [sym_statement_block] = STATE(1611),
    [anon_sym_LBRACE] = ACTIONS(6049),
    [sym_comment] = ACTIONS(3),
  },
  [2655] = {
    [sym_nested_identifier] = STATE(2393),
    [sym_identifier] = ACTIONS(6055),
    [sym_comment] = ACTIONS(3),
  },
  [2656] = {
    [sym_statement_block] = STATE(1128),
    [anon_sym_LBRACE] = ACTIONS(3690),
    [sym_comment] = ACTIONS(3),
  },
  [2657] = {
    [sym_class_body] = STATE(1613),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
  },
  [2658] = {
    [sym_statement_block] = STATE(1127),
    [anon_sym_LBRACE] = ACTIONS(3690),
    [sym_comment] = ACTIONS(3),
  },
  [2659] = {
    [anon_sym_COMMA] = ACTIONS(6057),
    [anon_sym_RPAREN] = ACTIONS(6057),
    [sym_comment] = ACTIONS(3),
  },
  [2660] = {
    [sym_class_body] = STATE(2235),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2661] = {
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [sym_comment] = ACTIONS(3),
  },
  [2662] = {
    [sym_identifier] = ACTIONS(6061),
    [anon_sym_STAR] = ACTIONS(6063),
    [sym_comment] = ACTIONS(3),
  },
  [2663] = {
    [sym_class_body] = STATE(1615),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
  },
  [2664] = {
    [sym_switch_body] = STATE(533),
    [anon_sym_LBRACE] = ACTIONS(6065),
    [sym_comment] = ACTIONS(3),
  },
  [2665] = {
    [sym__for_header] = STATE(48),
    [anon_sym_LPAREN] = ACTIONS(6037),
    [sym_comment] = ACTIONS(3),
  },
  [2666] = {
    [sym_class_body] = STATE(1126),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
  },
  [2667] = {
    [sym_class_body] = STATE(118),
    [anon_sym_LBRACE] = ACTIONS(5014),
    [sym_comment] = ACTIONS(3),
  },
  [2668] = {
    [sym_class_body] = STATE(1388),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2669] = {
    [sym_class_body] = STATE(571),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
  },
  [2670] = {
    [sym_statement_block] = STATE(1618),
    [anon_sym_LBRACE] = ACTIONS(6049),
    [sym_comment] = ACTIONS(3),
  },
  [2671] = {
    [sym_statement_block] = STATE(1622),
    [anon_sym_LBRACE] = ACTIONS(6049),
    [sym_comment] = ACTIONS(3),
  },
  [2672] = {
    [sym_statement_block] = STATE(1352),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [sym_comment] = ACTIONS(3),
  },
  [2673] = {
    [sym_class_body] = STATE(1599),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
  },
  [2674] = {
    [sym_statement_block] = STATE(481),
    [anon_sym_LBRACE] = ACTIONS(5032),
    [sym_comment] = ACTIONS(3),
  },
  [2675] = {
    [sym_class_body] = STATE(2141),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2676] = {
    [sym_statement_block] = STATE(2251),
    [anon_sym_LBRACE] = ACTIONS(5032),
    [sym_comment] = ACTIONS(3),
  },
  [2677] = {
    [sym_class_body] = STATE(1339),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2678] = {
    [sym_statement_block] = STATE(2242),
    [anon_sym_LBRACE] = ACTIONS(5032),
    [sym_comment] = ACTIONS(3),
  },
  [2679] = {
    [sym_class_body] = STATE(498),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2680] = {
    [sym_class_body] = STATE(540),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
  },
  [2681] = {
    [sym_statement_block] = STATE(496),
    [anon_sym_LBRACE] = ACTIONS(5032),
    [sym_comment] = ACTIONS(3),
  },
  [2682] = {
    [sym_statement_block] = STATE(1390),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [sym_comment] = ACTIONS(3),
  },
  [2683] = {
    [sym_statement_block] = STATE(1121),
    [anon_sym_LBRACE] = ACTIONS(3690),
    [sym_comment] = ACTIONS(3),
  },
  [2684] = {
    [sym_class_body] = STATE(1120),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
  },
  [2685] = {
    [sym_formal_parameters] = STATE(2815),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2686] = {
    [sym_class_body] = STATE(571),
    [anon_sym_LBRACE] = ACTIONS(5020),
    [sym_comment] = ACTIONS(3),
  },
  [2687] = {
    [anon_sym_COMMA] = ACTIONS(5657),
    [anon_sym_RBRACE] = ACTIONS(5657),
    [sym_comment] = ACTIONS(3),
  },
  [2688] = {
    [sym_statement_block] = STATE(1396),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [sym_comment] = ACTIONS(3),
  },
  [2689] = {
    [sym_statement_block] = STATE(1445),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [sym_comment] = ACTIONS(3),
  },
  [2690] = {
    [sym_statement_block] = STATE(1455),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [sym_comment] = ACTIONS(3),
  },
  [2691] = {
    [anon_sym_SEMI] = ACTIONS(3456),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3456),
  },
  [2692] = {
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_RBRACE] = ACTIONS(6067),
    [sym_comment] = ACTIONS(3),
  },
  [2693] = {
    [sym_class_body] = STATE(1456),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2694] = {
    [sym_statement_block] = STATE(1511),
    [anon_sym_LBRACE] = ACTIONS(6049),
    [sym_comment] = ACTIONS(3),
  },
  [2695] = {
    [anon_sym_LBRACE] = ACTIONS(5218),
    [anon_sym_EQ_GT] = ACTIONS(5218),
    [sym_comment] = ACTIONS(3),
  },
  [2696] = {
    [anon_sym_COMMA] = ACTIONS(4761),
    [anon_sym_RBRACE] = ACTIONS(4761),
    [sym_comment] = ACTIONS(3),
  },
  [2697] = {
    [sym_statement_block] = STATE(2647),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2698] = {
    [sym_enum_body] = STATE(568),
    [anon_sym_LBRACE] = ACTIONS(6013),
    [sym_comment] = ACTIONS(3),
  },
  [2699] = {
    [sym_statement_block] = STATE(563),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2700] = {
    [anon_sym_COMMA] = ACTIONS(4749),
    [anon_sym_RBRACE] = ACTIONS(4749),
    [sym_comment] = ACTIONS(3),
  },
  [2701] = {
    [sym_class_body] = STATE(1130),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
  },
  [2702] = {
    [sym_class_body] = STATE(1505),
    [anon_sym_LBRACE] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
  },
  [2703] = {
    [sym_statement_block] = STATE(1454),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [sym_comment] = ACTIONS(3),
  },
  [2704] = {
    [anon_sym_SEMI] = ACTIONS(6069),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6069),
  },
  [2705] = {
    [sym_nested_identifier] = STATE(1832),
    [sym_identifier] = ACTIONS(6071),
    [sym_comment] = ACTIONS(3),
  },
  [2706] = {
    [sym_statement_block] = STATE(1429),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [sym_comment] = ACTIONS(3),
  },
  [2707] = {
    [sym_class_body] = STATE(1453),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2708] = {
    [anon_sym_COMMA] = ACTIONS(4719),
    [anon_sym_RBRACE] = ACTIONS(4719),
    [sym_comment] = ACTIONS(3),
  },
  [2709] = {
    [sym_type_annotation] = STATE(2195),
    [anon_sym_COLON] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
  },
  [2710] = {
    [sym_statement_block] = STATE(2533),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2711] = {
    [sym_type_annotation] = STATE(2191),
    [anon_sym_COLON] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
  },
  [2712] = {
    [sym_class_body] = STATE(1431),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2713] = {
    [sym_statement_block] = STATE(2566),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
  },
  [2714] = {
    [sym_formal_parameters] = STATE(2826),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2715] = {
    [sym_class_body] = STATE(489),
    [anon_sym_LBRACE] = ACTIONS(5016),
    [sym_comment] = ACTIONS(3),
  },
  [2716] = {
    [sym_statement_block] = STATE(481),
    [anon_sym_LBRACE] = ACTIONS(5559),
    [sym_comment] = ACTIONS(3),
  },
  [2717] = {
    [sym_class_body] = STATE(495),
    [anon_sym_LBRACE] = ACTIONS(5016),
    [sym_comment] = ACTIONS(3),
  },
  [2718] = {
    [anon_sym_COMMA] = ACTIONS(6073),
    [anon_sym_RBRACE] = ACTIONS(6073),
    [sym_comment] = ACTIONS(3),
  },
  [2719] = {
    [anon_sym_SEMI] = ACTIONS(3761),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3761),
  },
  [2720] = {
    [anon_sym_COMMA] = ACTIONS(6075),
    [anon_sym_RBRACE] = ACTIONS(6075),
    [sym_comment] = ACTIONS(3),
  },
  [2721] = {
    [sym_formal_parameters] = STATE(2515),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2722] = {
    [sym_class_body] = STATE(1476),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2723] = {
    [sym_class_body] = STATE(116),
    [anon_sym_LBRACE] = ACTIONS(5014),
    [sym_comment] = ACTIONS(3),
  },
  [2724] = {
    [sym_type_parameter] = STATE(2482),
    [sym_identifier] = ACTIONS(5708),
    [sym_comment] = ACTIONS(3),
  },
  [2725] = {
    [sym_nested_identifier] = STATE(410),
    [sym_identifier] = ACTIONS(6077),
    [sym_comment] = ACTIONS(3),
  },
  [2726] = {
    [anon_sym_LBRACE] = ACTIONS(5311),
    [anon_sym_EQ_GT] = ACTIONS(5311),
    [sym_comment] = ACTIONS(3),
  },
  [2727] = {
    [sym_formal_parameters] = STATE(2467),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2728] = {
    [anon_sym_SEMI] = ACTIONS(4200),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4200),
  },
  [2729] = {
    [sym_class_body] = STATE(1408),
    [anon_sym_LBRACE] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2730] = {
    [anon_sym_SEMI] = ACTIONS(4198),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4198),
  },
  [2731] = {
    [anon_sym_SEMI] = ACTIONS(6079),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6079),
  },
  [2732] = {
    [anon_sym_SEMI] = ACTIONS(6081),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6081),
  },
  [2733] = {
    [anon_sym_SEMI] = ACTIONS(6083),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6083),
  },
  [2734] = {
    [anon_sym_SEMI] = ACTIONS(6085),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6085),
  },
  [2735] = {
    [sym_formal_parameters] = STATE(2798),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [2736] = {
    [anon_sym_COMMA] = ACTIONS(4745),
    [anon_sym_RBRACE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(3),
  },
  [2737] = {
    [sym_nested_identifier] = STATE(2430),
    [sym_identifier] = ACTIONS(6087),
    [sym_comment] = ACTIONS(3),
  },
  [2738] = {
    [sym_class_body] = STATE(504),
    [anon_sym_LBRACE] = ACTIONS(5016),
    [sym_comment] = ACTIONS(3),
  },
  [2739] = {
    [anon_sym_COLON] = ACTIONS(4401),
    [sym_comment] = ACTIONS(3),
  },
  [2740] = {
    [anon_sym_RPAREN] = ACTIONS(6089),
    [sym_comment] = ACTIONS(3),
  },
  [2741] = {
    [anon_sym_EQ_GT] = ACTIONS(6091),
    [sym_comment] = ACTIONS(3),
  },
  [2742] = {
    [sym_identifier] = ACTIONS(6093),
    [sym_comment] = ACTIONS(3),
  },
  [2743] = {
    [anon_sym_EQ_GT] = ACTIONS(6095),
    [sym_comment] = ACTIONS(3),
  },
  [2744] = {
    [anon_sym_DOT] = ACTIONS(4876),
    [sym_comment] = ACTIONS(3),
  },
  [2745] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_target] = ACTIONS(6097),
  },
  [2746] = {
    [anon_sym_EQ_GT] = ACTIONS(6099),
    [sym_comment] = ACTIONS(3),
  },
  [2747] = {
    [anon_sym_EQ_GT] = ACTIONS(6101),
    [sym_comment] = ACTIONS(3),
  },
  [2748] = {
    [anon_sym_RPAREN] = ACTIONS(4058),
    [sym_comment] = ACTIONS(3),
  },
  [2749] = {
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(6103),
  },
  [2750] = {
    [sym_identifier] = ACTIONS(6105),
    [sym_comment] = ACTIONS(3),
  },
  [2751] = {
    [anon_sym_EQ_GT] = ACTIONS(6107),
    [sym_comment] = ACTIONS(3),
  },
  [2752] = {
    [anon_sym_EQ_GT] = ACTIONS(5636),
    [sym_comment] = ACTIONS(3),
  },
  [2753] = {
    [anon_sym_RBRACE] = ACTIONS(4417),
    [sym_comment] = ACTIONS(3),
  },
  [2754] = {
    [anon_sym_from] = ACTIONS(6109),
    [sym_comment] = ACTIONS(3),
  },
  [2755] = {
    [anon_sym_EQ_GT] = ACTIONS(4763),
    [sym_comment] = ACTIONS(3),
  },
  [2756] = {
    [anon_sym_EQ_GT] = ACTIONS(6111),
    [sym_comment] = ACTIONS(3),
  },
  [2757] = {
    [anon_sym_EQ_GT] = ACTIONS(6113),
    [sym_comment] = ACTIONS(3),
  },
  [2758] = {
    [anon_sym_EQ_GT] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
  },
  [2759] = {
    [anon_sym_EQ_GT] = ACTIONS(6117),
    [sym_comment] = ACTIONS(3),
  },
  [2760] = {
    [anon_sym_EQ_GT] = ACTIONS(6119),
    [sym_comment] = ACTIONS(3),
  },
  [2761] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_target] = ACTIONS(6121),
  },
  [2762] = {
    [anon_sym_LBRACE] = ACTIONS(5874),
    [sym_comment] = ACTIONS(3),
  },
  [2763] = {
    [sym_identifier] = ACTIONS(6123),
    [sym_comment] = ACTIONS(3),
  },
  [2764] = {
    [anon_sym_EQ_GT] = ACTIONS(6125),
    [sym_comment] = ACTIONS(3),
  },
  [2765] = {
    [anon_sym_EQ_GT] = ACTIONS(6127),
    [sym_comment] = ACTIONS(3),
  },
  [2766] = {
    [anon_sym_EQ_GT] = ACTIONS(6129),
    [sym_comment] = ACTIONS(3),
  },
  [2767] = {
    [anon_sym_EQ_GT] = ACTIONS(6131),
    [sym_comment] = ACTIONS(3),
  },
  [2768] = {
    [sym_identifier] = ACTIONS(6133),
    [sym_comment] = ACTIONS(3),
  },
  [2769] = {
    [sym_comment] = ACTIONS(5499),
    [sym_regex_pattern] = ACTIONS(6135),
  },
  [2770] = {
    [sym_identifier] = ACTIONS(6137),
    [sym_comment] = ACTIONS(3),
  },
  [2771] = {
    [anon_sym_LBRACE] = ACTIONS(6139),
    [sym_comment] = ACTIONS(3),
  },
  [2772] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH2] = ACTIONS(6141),
  },
  [2773] = {
    [anon_sym_RBRACK] = ACTIONS(4391),
    [sym_comment] = ACTIONS(3),
  },
  [2774] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH2] = ACTIONS(6143),
  },
  [2775] = {
    [anon_sym_while] = ACTIONS(6145),
    [sym_comment] = ACTIONS(3),
  },
  [2776] = {
    [sym_identifier] = ACTIONS(6147),
    [sym_comment] = ACTIONS(3),
  },
  [2777] = {
    [anon_sym_DOT] = ACTIONS(4880),
    [sym_comment] = ACTIONS(3),
  },
  [2778] = {
    [anon_sym_EQ_GT] = ACTIONS(6149),
    [sym_comment] = ACTIONS(3),
  },
  [2779] = {
    [sym_identifier] = ACTIONS(6151),
    [sym_comment] = ACTIONS(3),
  },
  [2780] = {
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(6153),
  },
  [2781] = {
    [sym_identifier] = ACTIONS(6155),
    [sym_comment] = ACTIONS(3),
  },
  [2782] = {
    [sym_identifier] = ACTIONS(6157),
    [sym_comment] = ACTIONS(3),
  },
  [2783] = {
    [sym_identifier] = ACTIONS(6159),
    [sym_comment] = ACTIONS(3),
  },
  [2784] = {
    [anon_sym_COLON] = ACTIONS(6161),
    [sym_comment] = ACTIONS(3),
  },
  [2785] = {
    [sym_identifier] = ACTIONS(6163),
    [sym_comment] = ACTIONS(3),
  },
  [2786] = {
    [sym_identifier] = ACTIONS(6165),
    [sym_comment] = ACTIONS(3),
  },
  [2787] = {
    [anon_sym_RBRACE] = ACTIONS(6167),
    [sym_comment] = ACTIONS(3),
  },
  [2788] = {
    [sym_identifier] = ACTIONS(6169),
    [sym_comment] = ACTIONS(3),
  },
  [2789] = {
    [anon_sym_RPAREN] = ACTIONS(6171),
    [sym_comment] = ACTIONS(3),
  },
  [2790] = {
    [anon_sym_RPAREN] = ACTIONS(4397),
    [sym_comment] = ACTIONS(3),
  },
  [2791] = {
    [anon_sym_EQ_GT] = ACTIONS(6173),
    [sym_comment] = ACTIONS(3),
  },
  [2792] = {
    [sym_identifier] = ACTIONS(6175),
    [sym_comment] = ACTIONS(3),
  },
  [2793] = {
    [anon_sym_RPAREN] = ACTIONS(4276),
    [sym_comment] = ACTIONS(3),
  },
  [2794] = {
    [anon_sym_RPAREN] = ACTIONS(4411),
    [sym_comment] = ACTIONS(3),
  },
  [2795] = {
    [sym_identifier] = ACTIONS(6177),
    [sym_comment] = ACTIONS(3),
  },
  [2796] = {
    [anon_sym_RPAREN] = ACTIONS(4056),
    [sym_comment] = ACTIONS(3),
  },
  [2797] = {
    [sym_identifier] = ACTIONS(6179),
    [sym_comment] = ACTIONS(3),
  },
  [2798] = {
    [anon_sym_EQ_GT] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
  },
  [2799] = {
    [anon_sym_RPAREN] = ACTIONS(4387),
    [sym_comment] = ACTIONS(3),
  },
  [2800] = {
    [sym_identifier] = ACTIONS(6183),
    [sym_comment] = ACTIONS(3),
  },
  [2801] = {
    [sym_identifier] = ACTIONS(6185),
    [sym_comment] = ACTIONS(3),
  },
  [2802] = {
    [anon_sym_RBRACK] = ACTIONS(4346),
    [sym_comment] = ACTIONS(3),
  },
  [2803] = {
    [anon_sym_RPAREN] = ACTIONS(4367),
    [sym_comment] = ACTIONS(3),
  },
  [2804] = {
    [anon_sym_RPAREN] = ACTIONS(4350),
    [sym_comment] = ACTIONS(3),
  },
  [2805] = {
    [sym_identifier] = ACTIONS(6187),
    [sym_comment] = ACTIONS(3),
  },
  [2806] = {
    [anon_sym_EQ] = ACTIONS(6189),
    [sym_comment] = ACTIONS(3),
  },
  [2807] = {
    [sym_identifier] = ACTIONS(6191),
    [sym_comment] = ACTIONS(3),
  },
  [2808] = {
    [anon_sym_RPAREN] = ACTIONS(6193),
    [sym_comment] = ACTIONS(3),
  },
  [2809] = {
    [anon_sym_RPAREN] = ACTIONS(6195),
    [sym_comment] = ACTIONS(3),
  },
  [2810] = {
    [sym_identifier] = ACTIONS(6197),
    [sym_comment] = ACTIONS(3),
  },
  [2811] = {
    [sym_identifier] = ACTIONS(6199),
    [sym_comment] = ACTIONS(3),
  },
  [2812] = {
    [anon_sym_from] = ACTIONS(5770),
    [sym_comment] = ACTIONS(3),
  },
  [2813] = {
    [sym_identifier] = ACTIONS(6201),
    [sym_comment] = ACTIONS(3),
  },
  [2814] = {
    [anon_sym_RPAREN] = ACTIONS(6203),
    [sym_comment] = ACTIONS(3),
  },
  [2815] = {
    [anon_sym_EQ_GT] = ACTIONS(6205),
    [sym_comment] = ACTIONS(3),
  },
  [2816] = {
    [sym_identifier] = ACTIONS(6207),
    [sym_comment] = ACTIONS(3),
  },
  [2817] = {
    [anon_sym_as] = ACTIONS(6209),
    [sym_comment] = ACTIONS(3),
  },
  [2818] = {
    [anon_sym_COLON] = ACTIONS(6211),
    [sym_comment] = ACTIONS(3),
  },
  [2819] = {
    [sym_identifier] = ACTIONS(6213),
    [sym_comment] = ACTIONS(3),
  },
  [2820] = {
    [anon_sym_EQ_GT] = ACTIONS(6215),
    [sym_comment] = ACTIONS(3),
  },
  [2821] = {
    [sym_identifier] = ACTIONS(6217),
    [sym_comment] = ACTIONS(3),
  },
  [2822] = {
    [anon_sym_COLON] = ACTIONS(6219),
    [sym_comment] = ACTIONS(3),
  },
  [2823] = {
    [sym_identifier] = ACTIONS(6221),
    [sym_comment] = ACTIONS(3),
  },
  [2824] = {
    [anon_sym_EQ] = ACTIONS(6223),
    [sym_comment] = ACTIONS(3),
  },
  [2825] = {
    [anon_sym_EQ] = ACTIONS(6225),
    [sym_comment] = ACTIONS(3),
  },
  [2826] = {
    [anon_sym_EQ_GT] = ACTIONS(6227),
    [sym_comment] = ACTIONS(3),
  },
  [2827] = {
    [sym_identifier] = ACTIONS(6229),
    [sym_comment] = ACTIONS(3),
  },
  [2828] = {
    [sym_identifier] = ACTIONS(6231),
    [sym_comment] = ACTIONS(3),
  },
  [2829] = {
    [sym_identifier] = ACTIONS(6233),
    [sym_comment] = ACTIONS(3),
  },
  [2830] = {
    [anon_sym_EQ_GT] = ACTIONS(6235),
    [sym_comment] = ACTIONS(3),
  },
  [2831] = {
    [anon_sym_RPAREN] = ACTIONS(3965),
    [sym_comment] = ACTIONS(3),
  },
  [2832] = {
    [anon_sym_EQ_GT] = ACTIONS(6237),
    [sym_comment] = ACTIONS(3),
  },
  [2833] = {
    [anon_sym_EQ_GT] = ACTIONS(6239),
    [sym_comment] = ACTIONS(3),
  },
  [2834] = {
    [anon_sym_EQ_GT] = ACTIONS(6241),
    [sym_comment] = ACTIONS(3),
  },
  [2835] = {
    [anon_sym_EQ_GT] = ACTIONS(6243),
    [sym_comment] = ACTIONS(3),
  },
  [2836] = {
    [anon_sym_EQ_GT] = ACTIONS(6245),
    [sym_comment] = ACTIONS(3),
  },
  [2837] = {
    [sym_comment] = ACTIONS(5499),
    [sym_regex_pattern] = ACTIONS(6247),
  },
  [2838] = {
    [anon_sym_EQ_GT] = ACTIONS(6249),
    [sym_comment] = ACTIONS(3),
  },
  [2839] = {
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(6251),
  },
  [2840] = {
    [anon_sym_EQ_GT] = ACTIONS(6253),
    [sym_comment] = ACTIONS(3),
  },
  [2841] = {
    [anon_sym_DOT] = ACTIONS(4022),
    [sym_comment] = ACTIONS(3),
  },
  [2842] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH2] = ACTIONS(6255),
  },
  [2843] = {
    [anon_sym_EQ] = ACTIONS(6257),
    [sym_comment] = ACTIONS(3),
  },
  [2844] = {
    [sym_identifier] = ACTIONS(6259),
    [sym_comment] = ACTIONS(3),
  },
  [2845] = {
    [sym_identifier] = ACTIONS(6261),
    [sym_comment] = ACTIONS(3),
  },
  [2846] = {
    [sym_identifier] = ACTIONS(6263),
    [sym_comment] = ACTIONS(3),
  },
  [2847] = {
    [anon_sym_function] = ACTIONS(6265),
    [sym_comment] = ACTIONS(3),
  },
  [2848] = {
    [anon_sym_EQ_GT] = ACTIONS(6267),
    [sym_comment] = ACTIONS(3),
  },
  [2849] = {
    [anon_sym_DOT] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
  },
  [2850] = {
    [sym_identifier] = ACTIONS(6271),
    [sym_comment] = ACTIONS(3),
  },
  [2851] = {
    [sym_identifier] = ACTIONS(6273),
    [sym_comment] = ACTIONS(3),
  },
  [2852] = {
    [sym_identifier] = ACTIONS(6275),
    [sym_comment] = ACTIONS(3),
  },
  [2853] = {
    [anon_sym_DOT] = ACTIONS(4128),
    [sym_comment] = ACTIONS(3),
  },
  [2854] = {
    [anon_sym_EQ_GT] = ACTIONS(6277),
    [sym_comment] = ACTIONS(3),
  },
  [2855] = {
    [anon_sym_DOT] = ACTIONS(4342),
    [sym_comment] = ACTIONS(3),
  },
  [2856] = {
    [sym_identifier] = ACTIONS(6279),
    [sym_comment] = ACTIONS(3),
  },
  [2857] = {
    [anon_sym_EQ_GT] = ACTIONS(6281),
    [sym_comment] = ACTIONS(3),
  },
  [2858] = {
    [sym_identifier] = ACTIONS(6283),
    [sym_comment] = ACTIONS(3),
  },
  [2859] = {
    [anon_sym_RBRACK] = ACTIONS(6285),
    [sym_comment] = ACTIONS(3),
  },
  [2860] = {
    [sym_identifier] = ACTIONS(6287),
    [sym_comment] = ACTIONS(3),
  },
  [2861] = {
    [sym_identifier] = ACTIONS(6289),
    [sym_comment] = ACTIONS(3),
  },
  [2862] = {
    [sym_identifier] = ACTIONS(6291),
    [sym_comment] = ACTIONS(3),
  },
  [2863] = {
    [anon_sym_EQ_GT] = ACTIONS(6293),
    [sym_comment] = ACTIONS(3),
  },
  [2864] = {
    [sym_identifier] = ACTIONS(6295),
    [sym_comment] = ACTIONS(3),
  },
  [2865] = {
    [sym_identifier] = ACTIONS(6297),
    [sym_comment] = ACTIONS(3),
  },
  [2866] = {
    [anon_sym_namespace] = ACTIONS(6299),
    [sym_comment] = ACTIONS(3),
  },
  [2867] = {
    [anon_sym_RBRACK] = ACTIONS(6301),
    [sym_comment] = ACTIONS(3),
  },
  [2868] = {
    [anon_sym_RBRACE] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
  },
  [2869] = {
    [anon_sym_from] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
  },
  [2870] = {
    [anon_sym_class] = ACTIONS(6307),
    [sym_comment] = ACTIONS(3),
  },
  [2871] = {
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(3),
  },
  [2872] = {
    [anon_sym_from] = ACTIONS(6311),
    [sym_comment] = ACTIONS(3),
  },
  [2873] = {
    [anon_sym_from] = ACTIONS(6313),
    [sym_comment] = ACTIONS(3),
  },
  [2874] = {
    [anon_sym_EQ_GT] = ACTIONS(6315),
    [sym_comment] = ACTIONS(3),
  },
  [2875] = {
    [anon_sym_RBRACK] = ACTIONS(6317),
    [sym_comment] = ACTIONS(3),
  },
  [2876] = {
    [sym_identifier] = ACTIONS(6319),
    [sym_comment] = ACTIONS(3),
  },
  [2877] = {
    [anon_sym_namespace] = ACTIONS(6321),
    [sym_comment] = ACTIONS(3),
  },
  [2878] = {
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(6323),
  },
  [2879] = {
    [anon_sym_from] = ACTIONS(6325),
    [sym_comment] = ACTIONS(3),
  },
  [2880] = {
    [sym_identifier] = ACTIONS(6327),
    [sym_comment] = ACTIONS(3),
  },
  [2881] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH2] = ACTIONS(6329),
  },
  [2882] = {
    [anon_sym_EQ_GT] = ACTIONS(6331),
    [sym_comment] = ACTIONS(3),
  },
  [2883] = {
    [anon_sym_RBRACK] = ACTIONS(4415),
    [sym_comment] = ACTIONS(3),
  },
  [2884] = {
    [anon_sym_EQ_GT] = ACTIONS(6333),
    [sym_comment] = ACTIONS(3),
  },
  [2885] = {
    [anon_sym_EQ_GT] = ACTIONS(6335),
    [sym_comment] = ACTIONS(3),
  },
  [2886] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_require] = ACTIONS(6337),
  },
  [2887] = {
    [sym_identifier] = ACTIONS(6339),
    [sym_comment] = ACTIONS(3),
  },
  [2888] = {
    [sym_identifier] = ACTIONS(6341),
    [sym_comment] = ACTIONS(3),
  },
  [2889] = {
    [anon_sym_EQ_GT] = ACTIONS(6343),
    [sym_comment] = ACTIONS(3),
  },
  [2890] = {
    [anon_sym_EQ] = ACTIONS(6345),
    [sym_comment] = ACTIONS(3),
  },
  [2891] = {
    [anon_sym_RPAREN] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
  },
  [2892] = {
    [anon_sym_LPAREN] = ACTIONS(6347),
    [sym_comment] = ACTIONS(3),
  },
  [2893] = {
    [anon_sym_EQ] = ACTIONS(6349),
    [sym_comment] = ACTIONS(3),
  },
  [2894] = {
    [anon_sym_EQ_GT] = ACTIONS(6351),
    [sym_comment] = ACTIONS(3),
  },
  [2895] = {
    [sym_identifier] = ACTIONS(6353),
    [sym_comment] = ACTIONS(3),
  },
  [2896] = {
    [sym_identifier] = ACTIONS(6355),
    [sym_comment] = ACTIONS(3),
  },
  [2897] = {
    [sym_comment] = ACTIONS(5499),
    [sym_regex_pattern] = ACTIONS(6357),
  },
  [2898] = {
    [anon_sym_from] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
  },
  [2899] = {
    [anon_sym_RPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(3),
  },
  [2900] = {
    [ts_builtin_sym_end] = ACTIONS(6361),
    [sym_comment] = ACTIONS(3),
  },
  [2901] = {
    [sym_identifier] = ACTIONS(6363),
    [sym_comment] = ACTIONS(3),
  },
  [2902] = {
    [sym_identifier] = ACTIONS(6365),
    [sym_comment] = ACTIONS(3),
  },
  [2903] = {
    [anon_sym_class] = ACTIONS(6367),
    [sym_comment] = ACTIONS(3),
  },
  [2904] = {
    [anon_sym_RPAREN] = ACTIONS(4360),
    [sym_comment] = ACTIONS(3),
  },
  [2905] = {
    [anon_sym_RPAREN] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
  },
  [2906] = {
    [sym_identifier] = ACTIONS(6371),
    [sym_comment] = ACTIONS(3),
  },
  [2907] = {
    [anon_sym_EQ_GT] = ACTIONS(6373),
    [sym_comment] = ACTIONS(3),
  },
  [2908] = {
    [sym_identifier] = ACTIONS(6375),
    [sym_comment] = ACTIONS(3),
  },
  [2909] = {
    [anon_sym_EQ_GT] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
  },
  [2910] = {
    [anon_sym_COLON] = ACTIONS(6379),
    [sym_comment] = ACTIONS(3),
  },
  [2911] = {
    [anon_sym_EQ_GT] = ACTIONS(6381),
    [sym_comment] = ACTIONS(3),
  },
  [2912] = {
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(6383),
  },
  [2913] = {
    [anon_sym_RPAREN] = ACTIONS(6385),
    [sym_comment] = ACTIONS(3),
  },
  [2914] = {
    [sym_identifier] = ACTIONS(6387),
    [sym_comment] = ACTIONS(3),
  },
  [2915] = {
    [sym_identifier] = ACTIONS(6389),
    [sym_comment] = ACTIONS(3),
  },
  [2916] = {
    [sym_identifier] = ACTIONS(6391),
    [sym_comment] = ACTIONS(3),
  },
  [2917] = {
    [sym_identifier] = ACTIONS(6393),
    [sym_comment] = ACTIONS(3),
  },
  [2918] = {
    [sym_identifier] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
  },
  [2919] = {
    [anon_sym_from] = ACTIONS(6397),
    [sym_comment] = ACTIONS(3),
  },
  [2920] = {
    [sym_identifier] = ACTIONS(6399),
    [sym_comment] = ACTIONS(3),
  },
  [2921] = {
    [sym_identifier] = ACTIONS(6401),
    [sym_comment] = ACTIONS(3),
  },
  [2922] = {
    [sym_identifier] = ACTIONS(6403),
    [sym_comment] = ACTIONS(3),
  },
  [2923] = {
    [sym_identifier] = ACTIONS(6405),
    [sym_comment] = ACTIONS(3),
  },
  [2924] = {
    [sym_comment] = ACTIONS(5499),
    [sym_regex_pattern] = ACTIONS(6407),
  },
  [2925] = {
    [anon_sym_EQ_GT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(3),
  },
  [2926] = {
    [anon_sym_EQ_GT] = ACTIONS(6411),
    [sym_comment] = ACTIONS(3),
  },
  [2927] = {
    [sym_identifier] = ACTIONS(6413),
    [sym_comment] = ACTIONS(3),
  },
  [2928] = {
    [anon_sym_EQ_GT] = ACTIONS(6415),
    [sym_comment] = ACTIONS(3),
  },
  [2929] = {
    [sym_identifier] = ACTIONS(6417),
    [sym_comment] = ACTIONS(3),
  },
  [2930] = {
    [anon_sym_EQ_GT] = ACTIONS(6419),
    [sym_comment] = ACTIONS(3),
  },
  [2931] = {
    [anon_sym_RPAREN] = ACTIONS(6421),
    [sym_comment] = ACTIONS(3),
  },
  [2932] = {
    [sym_identifier] = ACTIONS(6423),
    [sym_comment] = ACTIONS(3),
  },
  [2933] = {
    [anon_sym_RPAREN] = ACTIONS(3896),
    [sym_comment] = ACTIONS(3),
  },
  [2934] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_target] = ACTIONS(6425),
  },
  [2935] = {
    [sym_identifier] = ACTIONS(6427),
    [sym_comment] = ACTIONS(3),
  },
  [2936] = {
    [anon_sym_EQ_GT] = ACTIONS(6429),
    [sym_comment] = ACTIONS(3),
  },
  [2937] = {
    [anon_sym_RPAREN] = ACTIONS(4385),
    [sym_comment] = ACTIONS(3),
  },
  [2938] = {
    [sym_identifier] = ACTIONS(6431),
    [sym_comment] = ACTIONS(3),
  },
  [2939] = {
    [anon_sym_class] = ACTIONS(6433),
    [sym_comment] = ACTIONS(3),
  },
  [2940] = {
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(3),
  },
  [2941] = {
    [sym_identifier] = ACTIONS(6437),
    [sym_comment] = ACTIONS(3),
  },
  [2942] = {
    [anon_sym_function] = ACTIONS(6439),
    [sym_comment] = ACTIONS(3),
  },
  [2943] = {
    [anon_sym_EQ_GT] = ACTIONS(6441),
    [sym_comment] = ACTIONS(3),
  },
  [2944] = {
    [anon_sym_EQ_GT] = ACTIONS(6443),
    [sym_comment] = ACTIONS(3),
  },
  [2945] = {
    [anon_sym_EQ_GT] = ACTIONS(6445),
    [sym_comment] = ACTIONS(3),
  },
  [2946] = {
    [anon_sym_EQ_GT] = ACTIONS(6447),
    [sym_comment] = ACTIONS(3),
  },
  [2947] = {
    [sym_identifier] = ACTIONS(6449),
    [sym_comment] = ACTIONS(3),
  },
  [2948] = {
    [sym_identifier] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
  },
  [2949] = {
    [sym_identifier] = ACTIONS(6453),
    [sym_comment] = ACTIONS(3),
  },
  [2950] = {
    [sym_identifier] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
  },
  [2951] = {
    [anon_sym_function] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [7] = {.count = 1, .reusable = false}, SHIFT(818),
  [9] = {.count = 1, .reusable = true}, SHIFT(28),
  [11] = {.count = 1, .reusable = false}, SHIFT(162),
  [13] = {.count = 1, .reusable = false}, SHIFT(622),
  [15] = {.count = 1, .reusable = true}, SHIFT(4),
  [17] = {.count = 1, .reusable = false}, SHIFT(786),
  [19] = {.count = 1, .reusable = false}, SHIFT(391),
  [21] = {.count = 1, .reusable = false}, SHIFT(901),
  [23] = {.count = 1, .reusable = false}, SHIFT(1995),
  [25] = {.count = 1, .reusable = false}, SHIFT(2024),
  [27] = {.count = 1, .reusable = false}, SHIFT(1947),
  [29] = {.count = 1, .reusable = false}, SHIFT(2535),
  [31] = {.count = 1, .reusable = false}, SHIFT(2536),
  [33] = {.count = 1, .reusable = false}, SHIFT(2524),
  [35] = {.count = 1, .reusable = true}, SHIFT(133),
  [37] = {.count = 1, .reusable = false}, SHIFT(260),
  [39] = {.count = 1, .reusable = false}, SHIFT(2540),
  [41] = {.count = 1, .reusable = false}, SHIFT(45),
  [43] = {.count = 1, .reusable = false}, SHIFT(2541),
  [45] = {.count = 1, .reusable = false}, SHIFT(2542),
  [47] = {.count = 1, .reusable = false}, SHIFT(2513),
  [49] = {.count = 1, .reusable = false}, SHIFT(2507),
  [51] = {.count = 1, .reusable = false}, SHIFT(2545),
  [53] = {.count = 1, .reusable = false}, SHIFT(156),
  [55] = {.count = 1, .reusable = false}, SHIFT(198),
  [57] = {.count = 1, .reusable = true}, SHIFT(475),
  [59] = {.count = 1, .reusable = false}, SHIFT(99),
  [61] = {.count = 1, .reusable = true}, SHIFT(142),
  [63] = {.count = 1, .reusable = true}, SHIFT(677),
  [65] = {.count = 1, .reusable = false}, SHIFT(2924),
  [67] = {.count = 1, .reusable = false}, SHIFT(1836),
  [69] = {.count = 1, .reusable = false}, SHIFT(482),
  [71] = {.count = 1, .reusable = false}, SHIFT(1937),
  [73] = {.count = 1, .reusable = false}, SHIFT(180),
  [75] = {.count = 1, .reusable = false}, SHIFT(302),
  [77] = {.count = 1, .reusable = true}, SHIFT(304),
  [79] = {.count = 1, .reusable = false}, SHIFT(61),
  [81] = {.count = 1, .reusable = true}, SHIFT(305),
  [83] = {.count = 1, .reusable = true}, SHIFT(2292),
  [85] = {.count = 1, .reusable = true}, SHIFT(2305),
  [87] = {.count = 1, .reusable = true}, SHIFT(2048),
  [89] = {.count = 1, .reusable = true}, SHIFT(1202),
  [91] = {.count = 1, .reusable = false}, SHIFT(1202),
  [93] = {.count = 1, .reusable = false}, SHIFT(1011),
  [95] = {.count = 1, .reusable = true}, SHIFT(1782),
  [97] = {.count = 1, .reusable = false}, SHIFT(817),
  [99] = {.count = 1, .reusable = false}, SHIFT(2903),
  [101] = {.count = 1, .reusable = false}, SHIFT(326),
  [103] = {.count = 1, .reusable = false}, SHIFT(627),
  [105] = {.count = 1, .reusable = false}, SHIFT(2902),
  [107] = {.count = 1, .reusable = false}, SHIFT(2901),
  [109] = {.count = 1, .reusable = false}, SHIFT(681),
  [111] = {.count = 1, .reusable = false}, SHIFT(152),
  [113] = {.count = 1, .reusable = true}, SHIFT(1755),
  [115] = {.count = 1, .reusable = false}, SHIFT(605),
  [117] = {.count = 1, .reusable = true}, SHIFT(1235),
  [119] = {.count = 1, .reusable = true}, SHIFT(1302),
  [121] = {.count = 1, .reusable = false}, SHIFT(645),
  [123] = {.count = 1, .reusable = true}, SHIFT(141),
  [125] = {.count = 1, .reusable = false}, SHIFT(419),
  [127] = {.count = 1, .reusable = true}, SHIFT(394),
  [129] = {.count = 1, .reusable = false}, SHIFT(53),
  [131] = {.count = 1, .reusable = true}, SHIFT(1439),
  [133] = {.count = 1, .reusable = false}, SHIFT(443),
  [135] = {.count = 1, .reusable = false}, SHIFT(447),
  [137] = {.count = 1, .reusable = false}, SHIFT(164),
  [139] = {.count = 1, .reusable = false}, SHIFT(460),
  [141] = {.count = 1, .reusable = false}, SHIFT(611),
  [143] = {.count = 1, .reusable = false}, SHIFT(665),
  [145] = {.count = 1, .reusable = false}, SHIFT(1744),
  [147] = {.count = 1, .reusable = true}, SHIFT(1216),
  [149] = {.count = 1, .reusable = true}, SHIFT(105),
  [151] = {.count = 1, .reusable = false}, SHIFT(659),
  [153] = {.count = 1, .reusable = false}, SHIFT(150),
  [155] = {.count = 1, .reusable = false}, SHIFT(610),
  [157] = {.count = 1, .reusable = true}, SHIFT(936),
  [159] = {.count = 1, .reusable = false}, SHIFT(654),
  [161] = {.count = 1, .reusable = false}, SHIFT(412),
  [163] = {.count = 1, .reusable = false}, SHIFT(51),
  [165] = {.count = 1, .reusable = false}, SHIFT(442),
  [167] = {.count = 1, .reusable = false}, SHIFT(445),
  [169] = {.count = 1, .reusable = false}, SHIFT(161),
  [171] = {.count = 1, .reusable = false}, SHIFT(459),
  [173] = {.count = 1, .reusable = false}, SHIFT(606),
  [175] = {.count = 1, .reusable = false}, SHIFT(675),
  [177] = {.count = 1, .reusable = false}, SHIFT(682),
  [179] = {.count = 1, .reusable = false}, SHIFT(148),
  [181] = {.count = 1, .reusable = false}, SHIFT(608),
  [183] = {.count = 1, .reusable = true}, SHIFT(1261),
  [185] = {.count = 1, .reusable = false}, SHIFT(653),
  [187] = {.count = 1, .reusable = false}, SHIFT(415),
  [189] = {.count = 1, .reusable = false}, SHIFT(50),
  [191] = {.count = 1, .reusable = false}, SHIFT(444),
  [193] = {.count = 1, .reusable = false}, SHIFT(448),
  [195] = {.count = 1, .reusable = false}, SHIFT(160),
  [197] = {.count = 1, .reusable = false}, SHIFT(458),
  [199] = {.count = 1, .reusable = false}, SHIFT(607),
  [201] = {.count = 1, .reusable = false}, SHIFT(660),
  [203] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [205] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(818),
  [208] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(162),
  [211] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [213] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(622),
  [216] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [219] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(786),
  [222] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(391),
  [225] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(901),
  [228] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1995),
  [231] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2024),
  [234] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1947),
  [237] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2535),
  [240] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2536),
  [243] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2524),
  [246] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(133),
  [249] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(260),
  [252] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2540),
  [255] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(45),
  [258] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2541),
  [261] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2542),
  [264] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2513),
  [267] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2507),
  [270] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2545),
  [273] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(156),
  [276] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(198),
  [279] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(475),
  [282] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(99),
  [285] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(142),
  [288] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(677),
  [291] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2924),
  [294] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1836),
  [297] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(482),
  [300] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1937),
  [303] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(180),
  [306] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(302),
  [309] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(304),
  [312] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(61),
  [315] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(305),
  [318] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2292),
  [321] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2305),
  [324] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2048),
  [327] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1202),
  [330] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1202),
  [333] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1011),
  [336] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1782),
  [339] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(817),
  [342] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2903),
  [345] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(326),
  [348] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(627),
  [351] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2902),
  [354] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2901),
  [357] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 4, .production_id = 76),
  [359] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 4, .production_id = 76),
  [361] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 3),
  [363] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 3),
  [365] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 2),
  [367] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 2),
  [369] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 3, .production_id = 76),
  [371] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 3, .production_id = 76),
  [373] = {.count = 1, .reusable = true}, SHIFT(1978),
  [375] = {.count = 1, .reusable = true}, SHIFT(1694),
  [377] = {.count = 1, .reusable = true}, SHIFT(115),
  [379] = {.count = 1, .reusable = true}, SHIFT(1017),
  [381] = {.count = 1, .reusable = true}, SHIFT(1374),
  [383] = {.count = 1, .reusable = true}, SHIFT(1695),
  [385] = {.count = 1, .reusable = true}, REDUCE(sym_program, 2),
  [387] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [389] = {.count = 1, .reusable = true}, SHIFT(491),
  [391] = {.count = 1, .reusable = true}, SHIFT(1398),
  [393] = {.count = 1, .reusable = true}, SHIFT(1147),
  [395] = {.count = 1, .reusable = true}, SHIFT(981),
  [397] = {.count = 1, .reusable = true}, SHIFT(129),
  [399] = {.count = 1, .reusable = true}, SHIFT(477),
  [401] = {.count = 1, .reusable = true}, SHIFT(456),
  [403] = {.count = 1, .reusable = true}, SHIFT(989),
  [405] = {.count = 1, .reusable = true}, SHIFT(450),
  [407] = {.count = 1, .reusable = false}, SHIFT(807),
  [409] = {.count = 1, .reusable = false}, SHIFT(159),
  [411] = {.count = 1, .reusable = false}, SHIFT(624),
  [413] = {.count = 1, .reusable = true}, SHIFT(3),
  [415] = {.count = 1, .reusable = false}, SHIFT(758),
  [417] = {.count = 1, .reusable = false}, SHIFT(2560),
  [419] = {.count = 1, .reusable = false}, SHIFT(2525),
  [421] = {.count = 1, .reusable = false}, SHIFT(2561),
  [423] = {.count = 1, .reusable = false}, SHIFT(2562),
  [425] = {.count = 1, .reusable = false}, SHIFT(1852),
  [427] = {.count = 1, .reusable = false}, SHIFT(494),
  [429] = {.count = 1, .reusable = false}, SHIFT(1968),
  [431] = {.count = 1, .reusable = false}, SHIFT(62),
  [433] = {.count = 1, .reusable = false}, SHIFT(804),
  [435] = {.count = 1, .reusable = false}, SHIFT(2939),
  [437] = {.count = 1, .reusable = false}, SHIFT(378),
  [439] = {.count = 1, .reusable = false}, SHIFT(620),
  [441] = {.count = 1, .reusable = false}, SHIFT(801),
  [443] = {.count = 1, .reusable = false}, SHIFT(800),
  [445] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1),
  [447] = {.count = 1, .reusable = false}, SHIFT(324),
  [449] = {.count = 1, .reusable = false}, SHIFT(618),
  [451] = {.count = 1, .reusable = true}, SHIFT(1067),
  [453] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1),
  [455] = {.count = 1, .reusable = true}, SHIFT(1450),
  [457] = {.count = 1, .reusable = false}, SHIFT(1447),
  [459] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(36),
  [462] = {.count = 1, .reusable = false}, SHIFT(677),
  [464] = {.count = 1, .reusable = false}, SHIFT(2852),
  [466] = {.count = 1, .reusable = false}, SHIFT(1850),
  [468] = {.count = 1, .reusable = false}, SHIFT(478),
  [470] = {.count = 1, .reusable = false}, SHIFT(1983),
  [472] = {.count = 1, .reusable = true}, SHIFT(199),
  [474] = {.count = 1, .reusable = true}, SHIFT(375),
  [476] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [479] = {.count = 1, .reusable = false}, SHIFT(304),
  [481] = {.count = 1, .reusable = false}, SHIFT(59),
  [483] = {.count = 1, .reusable = true}, SHIFT(1097),
  [485] = {.count = 1, .reusable = false}, SHIFT(1097),
  [487] = {.count = 1, .reusable = true}, SHIFT(935),
  [489] = {.count = 1, .reusable = false}, SHIFT(861),
  [491] = {.count = 1, .reusable = false}, SHIFT(857),
  [493] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [495] = {.count = 1, .reusable = false}, SHIFT(286),
  [497] = {.count = 1, .reusable = false}, SHIFT(638),
  [499] = {.count = 1, .reusable = true}, SHIFT(1020),
  [501] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [503] = {.count = 1, .reusable = false}, SHIFT(316),
  [505] = {.count = 1, .reusable = false}, SHIFT(1029),
  [507] = {.count = 1, .reusable = false}, SHIFT(319),
  [509] = {.count = 1, .reusable = false}, SHIFT(101),
  [511] = {.count = 1, .reusable = false}, SHIFT(2844),
  [513] = {.count = 1, .reusable = false}, SHIFT(1873),
  [515] = {.count = 1, .reusable = false}, SHIFT(591),
  [517] = {.count = 1, .reusable = false}, SHIFT(1914),
  [519] = {.count = 1, .reusable = true}, SHIFT(196),
  [521] = {.count = 1, .reusable = false}, SHIFT(189),
  [523] = {.count = 1, .reusable = true}, SHIFT(288),
  [525] = {.count = 1, .reusable = true}, SHIFT(301),
  [527] = {.count = 1, .reusable = false}, SHIFT(77),
  [529] = {.count = 1, .reusable = true}, SHIFT(2293),
  [531] = {.count = 1, .reusable = true}, SHIFT(2294),
  [533] = {.count = 1, .reusable = true}, SHIFT(1245),
  [535] = {.count = 1, .reusable = false}, SHIFT(1245),
  [537] = {.count = 1, .reusable = false}, SHIFT(925),
  [539] = {.count = 1, .reusable = true}, SHIFT(1024),
  [541] = {.count = 1, .reusable = false}, SHIFT(763),
  [543] = {.count = 1, .reusable = false}, SHIFT(783),
  [545] = {.count = 1, .reusable = false}, SHIFT(360),
  [547] = {.count = 1, .reusable = false}, SHIFT(613),
  [549] = {.count = 1, .reusable = false}, SHIFT(381),
  [551] = {.count = 1, .reusable = true}, SHIFT(135),
  [553] = {.count = 1, .reusable = false}, SHIFT(385),
  [555] = {.count = 1, .reusable = false}, SHIFT(95),
  [557] = {.count = 1, .reusable = true}, SHIFT(147),
  [559] = {.count = 1, .reusable = false}, SHIFT(2897),
  [561] = {.count = 1, .reusable = false}, SHIFT(465),
  [563] = {.count = 1, .reusable = false}, SHIFT(211),
  [565] = {.count = 1, .reusable = true}, SHIFT(369),
  [567] = {.count = 1, .reusable = false}, SHIFT(390),
  [569] = {.count = 1, .reusable = false}, SHIFT(389),
  [571] = {.count = 1, .reusable = true}, SHIFT(389),
  [573] = {.count = 1, .reusable = false}, SHIFT(54),
  [575] = {.count = 1, .reusable = true}, SHIFT(382),
  [577] = {.count = 1, .reusable = true}, SHIFT(2020),
  [579] = {.count = 1, .reusable = true}, SHIFT(982),
  [581] = {.count = 1, .reusable = false}, SHIFT(982),
  [583] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [586] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [589] = {.count = 1, .reusable = true}, REDUCE(sym_predefined_type, 1),
  [591] = {.count = 1, .reusable = false}, SHIFT(387),
  [593] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(190),
  [596] = {.count = 1, .reusable = false}, SHIFT(190),
  [598] = {.count = 1, .reusable = true}, SHIFT(36),
  [600] = {.count = 1, .reusable = true}, SHIFT(38),
  [602] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 1), SHIFT(360),
  [605] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [608] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1),
  [610] = {.count = 1, .reusable = false}, SHIFT(869),
  [612] = {.count = 1, .reusable = false}, SHIFT(856),
  [614] = {.count = 1, .reusable = false}, SHIFT(371),
  [616] = {.count = 1, .reusable = false}, SHIFT(637),
  [618] = {.count = 1, .reusable = false}, SHIFT(359),
  [620] = {.count = 1, .reusable = false}, SHIFT(358),
  [622] = {.count = 1, .reusable = false}, SHIFT(103),
  [624] = {.count = 1, .reusable = false}, SHIFT(592),
  [626] = {.count = 1, .reusable = true}, SHIFT(242),
  [628] = {.count = 1, .reusable = false}, SHIFT(202),
  [630] = {.count = 1, .reusable = true}, SHIFT(372),
  [632] = {.count = 1, .reusable = false}, SHIFT(355),
  [634] = {.count = 1, .reusable = false}, SHIFT(354),
  [636] = {.count = 1, .reusable = true}, SHIFT(354),
  [638] = {.count = 1, .reusable = false}, SHIFT(75),
  [640] = {.count = 1, .reusable = true}, SHIFT(345),
  [642] = {.count = 1, .reusable = true}, SHIFT(1253),
  [644] = {.count = 1, .reusable = false}, SHIFT(1253),
  [646] = {.count = 1, .reusable = true}, SHIFT(1952),
  [648] = {.count = 1, .reusable = true}, SHIFT(201),
  [650] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [654] = {.count = 1, .reusable = true}, SHIFT(169),
  [656] = {.count = 1, .reusable = false}, SHIFT(307),
  [658] = {.count = 1, .reusable = false}, SHIFT(301),
  [660] = {.count = 1, .reusable = true}, SHIFT(297),
  [662] = {.count = 1, .reusable = false}, SHIFT(2846),
  [664] = {.count = 1, .reusable = true}, SHIFT(229),
  [666] = {.count = 1, .reusable = false}, SHIFT(827),
  [668] = {.count = 1, .reusable = false}, SHIFT(829),
  [670] = {.count = 1, .reusable = false}, SHIFT(366),
  [672] = {.count = 1, .reusable = false}, SHIFT(635),
  [674] = {.count = 1, .reusable = false}, SHIFT(1119),
  [676] = {.count = 1, .reusable = false}, SHIFT(299),
  [678] = {.count = 1, .reusable = false}, SHIFT(1616),
  [680] = {.count = 1, .reusable = true}, SHIFT(131),
  [682] = {.count = 1, .reusable = false}, SHIFT(298),
  [684] = {.count = 1, .reusable = false}, SHIFT(100),
  [686] = {.count = 1, .reusable = true}, SHIFT(137),
  [688] = {.count = 1, .reusable = false}, SHIFT(2837),
  [690] = {.count = 1, .reusable = false}, SHIFT(1859),
  [692] = {.count = 1, .reusable = false}, SHIFT(550),
  [694] = {.count = 1, .reusable = false}, SHIFT(1979),
  [696] = {.count = 1, .reusable = false}, SHIFT(177),
  [698] = {.count = 1, .reusable = true}, SHIFT(367),
  [700] = {.count = 1, .reusable = false}, SHIFT(265),
  [702] = {.count = 1, .reusable = false}, SHIFT(373),
  [704] = {.count = 1, .reusable = true}, SHIFT(373),
  [706] = {.count = 1, .reusable = false}, SHIFT(73),
  [708] = {.count = 1, .reusable = true}, SHIFT(370),
  [710] = {.count = 1, .reusable = true}, SHIFT(2357),
  [712] = {.count = 1, .reusable = true}, SHIFT(2285),
  [714] = {.count = 1, .reusable = true}, SHIFT(2018),
  [716] = {.count = 1, .reusable = true}, SHIFT(1179),
  [718] = {.count = 1, .reusable = false}, SHIFT(1179),
  [720] = {.count = 1, .reusable = false}, SHIFT(1161),
  [722] = {.count = 1, .reusable = false}, SHIFT(843),
  [724] = {.count = 1, .reusable = false}, SHIFT(834),
  [726] = {.count = 1, .reusable = false}, SHIFT(365),
  [728] = {.count = 1, .reusable = false}, SHIFT(633),
  [730] = {.count = 1, .reusable = false}, SHIFT(388),
  [732] = {.count = 1, .reusable = false}, SHIFT(386),
  [734] = {.count = 1, .reusable = false}, SHIFT(102),
  [736] = {.count = 1, .reusable = false}, SHIFT(2769),
  [738] = {.count = 1, .reusable = false}, SHIFT(580),
  [740] = {.count = 1, .reusable = false}, SHIFT(188),
  [742] = {.count = 1, .reusable = true}, SHIFT(364),
  [744] = {.count = 1, .reusable = false}, SHIFT(294),
  [746] = {.count = 1, .reusable = false}, SHIFT(293),
  [748] = {.count = 1, .reusable = true}, SHIFT(293),
  [750] = {.count = 1, .reusable = false}, SHIFT(78),
  [752] = {.count = 1, .reusable = true}, SHIFT(292),
  [754] = {.count = 1, .reusable = true}, SHIFT(1153),
  [756] = {.count = 1, .reusable = false}, SHIFT(1153),
  [758] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(200),
  [761] = {.count = 1, .reusable = false}, SHIFT(200),
  [763] = {.count = 1, .reusable = false}, SHIFT(731),
  [765] = {.count = 1, .reusable = false}, SHIFT(846),
  [767] = {.count = 1, .reusable = true}, SHIFT(430),
  [769] = {.count = 1, .reusable = false}, SHIFT(634),
  [771] = {.count = 1, .reusable = false}, SHIFT(617),
  [773] = {.count = 1, .reusable = false}, SHIFT(224),
  [775] = {.count = 1, .reusable = true}, SHIFT(85),
  [777] = {.count = 1, .reusable = true}, SHIFT(2429),
  [779] = {.count = 1, .reusable = true}, SHIFT(87),
  [781] = {.count = 1, .reusable = false}, SHIFT(546),
  [783] = {.count = 1, .reusable = false}, SHIFT(243),
  [785] = {.count = 1, .reusable = true}, SHIFT(2801),
  [787] = {.count = 1, .reusable = true}, SHIFT(973),
  [789] = {.count = 1, .reusable = true}, SHIFT(716),
  [791] = {.count = 1, .reusable = true}, SHIFT(714),
  [793] = {.count = 1, .reusable = false}, SHIFT(272),
  [795] = {.count = 1, .reusable = false}, SHIFT(69),
  [797] = {.count = 1, .reusable = true}, SHIFT(1554),
  [799] = {.count = 1, .reusable = false}, SHIFT(1399),
  [801] = {.count = 1, .reusable = false}, SHIFT(1554),
  [803] = {.count = 1, .reusable = false}, SHIFT(1033),
  [805] = {.count = 1, .reusable = true}, SHIFT(1781),
  [807] = {.count = 1, .reusable = false}, SHIFT(590),
  [809] = {.count = 1, .reusable = false}, SHIFT(851),
  [811] = {.count = 1, .reusable = false}, SHIFT(1779),
  [813] = {.count = 1, .reusable = false}, SHIFT(2508),
  [815] = {.count = 1, .reusable = true}, SHIFT(889),
  [817] = {.count = 1, .reusable = false}, SHIFT(1108),
  [819] = {.count = 1, .reusable = false}, SHIFT(1114),
  [821] = {.count = 1, .reusable = false}, SHIFT(803),
  [823] = {.count = 1, .reusable = false}, SHIFT(621),
  [825] = {.count = 1, .reusable = true}, SHIFT(146),
  [827] = {.count = 1, .reusable = false}, SHIFT(174),
  [829] = {.count = 1, .reusable = true}, SHIFT(941),
  [831] = {.count = 1, .reusable = false}, SHIFT(312),
  [833] = {.count = 1, .reusable = false}, SHIFT(74),
  [835] = {.count = 1, .reusable = true}, SHIFT(1632),
  [837] = {.count = 1, .reusable = false}, SHIFT(1631),
  [839] = {.count = 1, .reusable = false}, SHIFT(1632),
  [841] = {.count = 1, .reusable = false}, SHIFT(1189),
  [843] = {.count = 1, .reusable = false}, SHIFT(863),
  [845] = {.count = 1, .reusable = true}, SHIFT(1461),
  [847] = {.count = 1, .reusable = false}, SHIFT(1168),
  [849] = {.count = 1, .reusable = true}, SHIFT(1057),
  [851] = {.count = 1, .reusable = false}, SHIFT(1224),
  [853] = {.count = 1, .reusable = false}, SHIFT(693),
  [855] = {.count = 1, .reusable = false}, SHIFT(623),
  [857] = {.count = 1, .reusable = false}, SHIFT(193),
  [859] = {.count = 1, .reusable = true}, SHIFT(84),
  [861] = {.count = 1, .reusable = true}, SHIFT(90),
  [863] = {.count = 1, .reusable = false}, SHIFT(195),
  [865] = {.count = 1, .reusable = false}, SHIFT(310),
  [867] = {.count = 1, .reusable = false}, SHIFT(65),
  [869] = {.count = 1, .reusable = true}, SHIFT(1529),
  [871] = {.count = 1, .reusable = false}, SHIFT(1553),
  [873] = {.count = 1, .reusable = false}, SHIFT(1529),
  [875] = {.count = 1, .reusable = false}, SHIFT(1343),
  [877] = {.count = 1, .reusable = false}, SHIFT(825),
  [879] = {.count = 1, .reusable = false}, SHIFT(774),
  [881] = {.count = 1, .reusable = false}, SHIFT(615),
  [883] = {.count = 1, .reusable = false}, SHIFT(240),
  [885] = {.count = 1, .reusable = true}, SHIFT(83),
  [887] = {.count = 1, .reusable = true}, SHIFT(89),
  [889] = {.count = 1, .reusable = false}, SHIFT(197),
  [891] = {.count = 1, .reusable = false}, SHIFT(253),
  [893] = {.count = 1, .reusable = false}, SHIFT(80),
  [895] = {.count = 1, .reusable = true}, SHIFT(1507),
  [897] = {.count = 1, .reusable = false}, SHIFT(1509),
  [899] = {.count = 1, .reusable = false}, SHIFT(1507),
  [901] = {.count = 1, .reusable = false}, SHIFT(1164),
  [903] = {.count = 1, .reusable = false}, SHIFT(852),
  [905] = {.count = 1, .reusable = false}, SHIFT(646),
  [907] = {.count = 1, .reusable = false}, SHIFT(614),
  [909] = {.count = 1, .reusable = false}, SHIFT(244),
  [911] = {.count = 1, .reusable = false}, SHIFT(399),
  [913] = {.count = 1, .reusable = false}, SHIFT(56),
  [915] = {.count = 1, .reusable = true}, SHIFT(1054),
  [917] = {.count = 1, .reusable = false}, SHIFT(1056),
  [919] = {.count = 1, .reusable = false}, SHIFT(1054),
  [921] = {.count = 1, .reusable = false}, SHIFT(978),
  [923] = {.count = 1, .reusable = false}, SHIFT(785),
  [925] = {.count = 1, .reusable = false}, SHIFT(676),
  [927] = {.count = 1, .reusable = false}, SHIFT(181),
  [929] = {.count = 1, .reusable = false}, SHIFT(206),
  [931] = {.count = 1, .reusable = false}, SHIFT(306),
  [933] = {.count = 1, .reusable = false}, SHIFT(60),
  [935] = {.count = 1, .reusable = true}, SHIFT(1413),
  [937] = {.count = 1, .reusable = false}, SHIFT(1412),
  [939] = {.count = 1, .reusable = false}, SHIFT(1413),
  [941] = {.count = 1, .reusable = false}, SHIFT(1018),
  [943] = {.count = 1, .reusable = false}, SHIFT(812),
  [945] = {.count = 1, .reusable = false}, SHIFT(333),
  [947] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 1),
  [949] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 1),
  [951] = {.count = 1, .reusable = true}, SHIFT(952),
  [953] = {.count = 1, .reusable = false}, SHIFT(952),
  [955] = {.count = 1, .reusable = false}, SHIFT(754),
  [957] = {.count = 1, .reusable = false}, SHIFT(218),
  [959] = {.count = 1, .reusable = false}, SHIFT(217),
  [961] = {.count = 1, .reusable = false}, SHIFT(271),
  [963] = {.count = 1, .reusable = false}, SHIFT(70),
  [965] = {.count = 1, .reusable = true}, SHIFT(1589),
  [967] = {.count = 1, .reusable = false}, SHIFT(1588),
  [969] = {.count = 1, .reusable = false}, SHIFT(1589),
  [971] = {.count = 1, .reusable = false}, SHIFT(1258),
  [973] = {.count = 1, .reusable = false}, SHIFT(837),
  [975] = {.count = 1, .reusable = false}, SHIFT(648),
  [977] = {.count = 1, .reusable = true}, SHIFT(1854),
  [979] = {.count = 1, .reusable = false}, SHIFT(619),
  [981] = {.count = 1, .reusable = false}, SHIFT(216),
  [983] = {.count = 1, .reusable = true}, SHIFT(86),
  [985] = {.count = 1, .reusable = true}, SHIFT(88),
  [987] = {.count = 1, .reusable = false}, SHIFT(175),
  [989] = {.count = 1, .reusable = true}, SHIFT(991),
  [991] = {.count = 1, .reusable = true}, SHIFT(735),
  [993] = {.count = 1, .reusable = true}, SHIFT(728),
  [995] = {.count = 1, .reusable = false}, SHIFT(383),
  [997] = {.count = 1, .reusable = false}, SHIFT(57),
  [999] = {.count = 1, .reusable = true}, SHIFT(1269),
  [1001] = {.count = 1, .reusable = false}, SHIFT(1265),
  [1003] = {.count = 1, .reusable = false}, SHIFT(1269),
  [1005] = {.count = 1, .reusable = false}, SHIFT(1360),
  [1007] = {.count = 1, .reusable = false}, SHIFT(784),
  [1009] = {.count = 1, .reusable = false}, SHIFT(2434),
  [1011] = {.count = 1, .reusable = true}, SHIFT(885),
  [1013] = {.count = 1, .reusable = false}, SHIFT(696),
  [1015] = {.count = 1, .reusable = false}, SHIFT(235),
  [1017] = {.count = 1, .reusable = false}, SHIFT(241),
  [1019] = {.count = 1, .reusable = false}, SHIFT(401),
  [1021] = {.count = 1, .reusable = false}, SHIFT(79),
  [1023] = {.count = 1, .reusable = false}, SHIFT(1142),
  [1025] = {.count = 1, .reusable = false}, SHIFT(849),
  [1027] = {.count = 1, .reusable = false}, SHIFT(328),
  [1029] = {.count = 1, .reusable = true}, SHIFT(1058),
  [1031] = {.count = 1, .reusable = false}, SHIFT(1058),
  [1033] = {.count = 1, .reusable = false}, SHIFT(353),
  [1035] = {.count = 1, .reusable = true}, SHIFT(1185),
  [1037] = {.count = 1, .reusable = false}, SHIFT(1185),
  [1039] = {.count = 1, .reusable = false}, SHIFT(262),
  [1041] = {.count = 1, .reusable = true}, SHIFT(1267),
  [1043] = {.count = 1, .reusable = false}, SHIFT(1267),
  [1045] = {.count = 1, .reusable = false}, SHIFT(384),
  [1047] = {.count = 1, .reusable = true}, SHIFT(1156),
  [1049] = {.count = 1, .reusable = false}, SHIFT(1156),
  [1051] = {.count = 1, .reusable = false}, SHIFT(362),
  [1053] = {.count = 1, .reusable = true}, SHIFT(1249),
  [1055] = {.count = 1, .reusable = false}, SHIFT(1249),
  [1057] = {.count = 1, .reusable = true}, REDUCE(sym_nested_identifier, 3),
  [1059] = {.count = 1, .reusable = false}, REDUCE(sym_nested_identifier, 3),
  [1061] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 2),
  [1063] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 2),
  [1065] = {.count = 1, .reusable = false}, REDUCE(sym_object, 2),
  [1067] = {.count = 1, .reusable = true}, REDUCE(sym_object, 2),
  [1069] = {.count = 1, .reusable = true}, SHIFT(461),
  [1071] = {.count = 1, .reusable = true}, REDUCE(sym__module, 1, .production_id = 5),
  [1073] = {.count = 1, .reusable = false}, REDUCE(sym__module, 1, .production_id = 5),
  [1075] = {.count = 1, .reusable = true}, SHIFT(14),
  [1077] = {.count = 1, .reusable = true}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1079] = {.count = 1, .reusable = false}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1081] = {.count = 1, .reusable = true}, REDUCE(sym__module, 2, .production_id = 27),
  [1083] = {.count = 1, .reusable = false}, REDUCE(sym__module, 2, .production_id = 27),
  [1085] = {.count = 1, .reusable = false}, SHIFT(2811),
  [1087] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [1089] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [1091] = {.count = 1, .reusable = false}, REDUCE(sym_class, 6, .production_id = 150),
  [1093] = {.count = 1, .reusable = true}, REDUCE(sym_class, 6, .production_id = 150),
  [1095] = {.count = 1, .reusable = true}, SHIFT(524),
  [1097] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [1099] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [1101] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 90),
  [1103] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 90),
  [1105] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 90),
  [1107] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 90),
  [1109] = {.count = 1, .reusable = true}, SHIFT(575),
  [1111] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1113] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1115] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 4),
  [1117] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 4),
  [1119] = {.count = 1, .reusable = true}, SHIFT(125),
  [1121] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 127),
  [1123] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 127),
  [1125] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 127),
  [1127] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 127),
  [1129] = {.count = 1, .reusable = true}, SHIFT(538),
  [1131] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 2),
  [1133] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 2),
  [1135] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 119),
  [1137] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 119),
  [1139] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 119),
  [1141] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 119),
  [1143] = {.count = 1, .reusable = true}, SHIFT(545),
  [1145] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 91),
  [1147] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 91),
  [1149] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 91),
  [1151] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 91),
  [1153] = {.count = 1, .reusable = true}, SHIFT(574),
  [1155] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 3),
  [1157] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 3),
  [1159] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 122),
  [1161] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 122),
  [1163] = {.count = 1, .reusable = false}, REDUCE(sym_function, 5, .production_id = 122),
  [1165] = {.count = 1, .reusable = true}, REDUCE(sym_function, 5, .production_id = 122),
  [1167] = {.count = 1, .reusable = true}, SHIFT(542),
  [1169] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 5, .production_id = 122),
  [1171] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 5, .production_id = 122),
  [1173] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 122),
  [1175] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 122),
  [1177] = {.count = 1, .reusable = true}, SHIFT(541),
  [1179] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 128),
  [1181] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 128),
  [1183] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 128),
  [1185] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 128),
  [1187] = {.count = 1, .reusable = true}, SHIFT(537),
  [1189] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 3, .production_id = 49),
  [1191] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 3, .production_id = 49),
  [1193] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 49),
  [1195] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 49),
  [1197] = {.count = 1, .reusable = true}, SHIFT(547),
  [1199] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 3),
  [1201] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 3),
  [1203] = {.count = 1, .reusable = true}, REDUCE(sym__declaration, 1),
  [1205] = {.count = 1, .reusable = false}, REDUCE(sym__declaration, 1),
  [1207] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [1209] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [1211] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 4, .production_id = 98),
  [1213] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 4, .production_id = 98),
  [1215] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 98),
  [1217] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 98),
  [1219] = {.count = 1, .reusable = true}, SHIFT(505),
  [1221] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 147),
  [1223] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 147),
  [1225] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 6, .production_id = 147),
  [1227] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 6, .production_id = 147),
  [1229] = {.count = 1, .reusable = true}, SHIFT(526),
  [1231] = {.count = 1, .reusable = true}, SHIFT(114),
  [1233] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 101),
  [1235] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 101),
  [1237] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 101),
  [1239] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 101),
  [1241] = {.count = 1, .reusable = true}, SHIFT(564),
  [1243] = {.count = 1, .reusable = false}, SHIFT(833),
  [1245] = {.count = 1, .reusable = false}, SHIFT(64),
  [1247] = {.count = 1, .reusable = true}, SHIFT(1033),
  [1249] = {.count = 1, .reusable = false}, SHIFT(1458),
  [1251] = {.count = 1, .reusable = false}, SHIFT(796),
  [1253] = {.count = 1, .reusable = false}, SHIFT(797),
  [1255] = {.count = 1, .reusable = false}, SHIFT(626),
  [1257] = {.count = 1, .reusable = false}, SHIFT(214),
  [1259] = {.count = 1, .reusable = false}, SHIFT(215),
  [1261] = {.count = 1, .reusable = false}, SHIFT(503),
  [1263] = {.count = 1, .reusable = false}, SHIFT(58),
  [1265] = {.count = 1, .reusable = true}, SHIFT(1108),
  [1267] = {.count = 1, .reusable = true}, SHIFT(1114),
  [1269] = {.count = 1, .reusable = false}, SHIFT(826),
  [1271] = {.count = 1, .reusable = false}, SHIFT(838),
  [1273] = {.count = 1, .reusable = false}, SHIFT(629),
  [1275] = {.count = 1, .reusable = false}, SHIFT(511),
  [1277] = {.count = 1, .reusable = false}, SHIFT(66),
  [1279] = {.count = 1, .reusable = true}, SHIFT(1175),
  [1281] = {.count = 1, .reusable = false}, SHIFT(1175),
  [1283] = {.count = 1, .reusable = true}, SHIFT(1168),
  [1285] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 1),
  [1287] = {.count = 1, .reusable = true}, SHIFT(1350),
  [1289] = {.count = 1, .reusable = false}, SHIFT(1350),
  [1291] = {.count = 1, .reusable = true}, SHIFT(1176),
  [1293] = {.count = 1, .reusable = false}, SHIFT(1176),
  [1295] = {.count = 1, .reusable = true}, SHIFT(1591),
  [1297] = {.count = 1, .reusable = true}, SHIFT(1139),
  [1299] = {.count = 1, .reusable = false}, SHIFT(1139),
  [1301] = {.count = 1, .reusable = true}, SHIFT(1218),
  [1303] = {.count = 1, .reusable = false}, SHIFT(1218),
  [1305] = {.count = 1, .reusable = true}, SHIFT(1224),
  [1307] = {.count = 1, .reusable = true}, SHIFT(929),
  [1309] = {.count = 1, .reusable = true}, SHIFT(1146),
  [1311] = {.count = 1, .reusable = false}, SHIFT(1146),
  [1313] = {.count = 1, .reusable = true}, SHIFT(1417),
  [1315] = {.count = 1, .reusable = true}, SHIFT(1210),
  [1317] = {.count = 1, .reusable = false}, SHIFT(1210),
  [1319] = {.count = 1, .reusable = true}, SHIFT(1682),
  [1321] = {.count = 1, .reusable = true}, SHIFT(1229),
  [1323] = {.count = 1, .reusable = false}, SHIFT(1229),
  [1325] = {.count = 1, .reusable = true}, SHIFT(1166),
  [1327] = {.count = 1, .reusable = false}, SHIFT(1166),
  [1329] = {.count = 1, .reusable = true}, SHIFT(1189),
  [1331] = {.count = 1, .reusable = false}, SHIFT(2587),
  [1333] = {.count = 1, .reusable = true}, SHIFT(356),
  [1335] = {.count = 1, .reusable = false}, SHIFT(318),
  [1337] = {.count = 1, .reusable = false}, SHIFT(2866),
  [1339] = {.count = 1, .reusable = true}, SHIFT(1992),
  [1341] = {.count = 1, .reusable = true}, SHIFT(2005),
  [1343] = {.count = 1, .reusable = true}, SHIFT(2862),
  [1345] = {.count = 1, .reusable = true}, SHIFT(2861),
  [1347] = {.count = 1, .reusable = true}, SHIFT(1995),
  [1349] = {.count = 1, .reusable = true}, SHIFT(2024),
  [1351] = {.count = 1, .reusable = true}, SHIFT(1947),
  [1353] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1356] = {.count = 1, .reusable = true}, SHIFT(2852),
  [1358] = {.count = 1, .reusable = true}, SHIFT(2851),
  [1360] = {.count = 1, .reusable = true}, SHIFT(2847),
  [1362] = {.count = 1, .reusable = true}, SHIFT(2605),
  [1364] = {.count = 1, .reusable = true}, SHIFT(2903),
  [1366] = {.count = 1, .reusable = true}, SHIFT(1673),
  [1368] = {.count = 1, .reusable = true}, SHIFT(2068),
  [1370] = {.count = 1, .reusable = true}, SHIFT(2902),
  [1372] = {.count = 1, .reusable = true}, SHIFT(2901),
  [1374] = {.count = 1, .reusable = false}, SHIFT(732),
  [1376] = {.count = 1, .reusable = true}, SHIFT(1119),
  [1378] = {.count = 1, .reusable = true}, SHIFT(997),
  [1380] = {.count = 1, .reusable = false}, SHIFT(997),
  [1382] = {.count = 1, .reusable = false}, SHIFT(755),
  [1384] = {.count = 1, .reusable = true}, SHIFT(1026),
  [1386] = {.count = 1, .reusable = false}, SHIFT(1026),
  [1388] = {.count = 1, .reusable = false}, SHIFT(802),
  [1390] = {.count = 1, .reusable = true}, SHIFT(1150),
  [1392] = {.count = 1, .reusable = false}, SHIFT(1150),
  [1394] = {.count = 1, .reusable = true}, SHIFT(561),
  [1396] = {.count = 1, .reusable = true}, SHIFT(1208),
  [1398] = {.count = 1, .reusable = false}, SHIFT(1208),
  [1400] = {.count = 1, .reusable = false}, SHIFT(824),
  [1402] = {.count = 1, .reusable = true}, SHIFT(1186),
  [1404] = {.count = 1, .reusable = false}, SHIFT(1186),
  [1406] = {.count = 1, .reusable = false}, SHIFT(886),
  [1408] = {.count = 1, .reusable = false}, SHIFT(882),
  [1410] = {.count = 1, .reusable = false}, SHIFT(657),
  [1412] = {.count = 1, .reusable = false}, SHIFT(380),
  [1414] = {.count = 1, .reusable = false}, SHIFT(593),
  [1416] = {.count = 1, .reusable = false}, SHIFT(82),
  [1418] = {.count = 1, .reusable = true}, SHIFT(1597),
  [1420] = {.count = 1, .reusable = false}, SHIFT(1597),
  [1422] = {.count = 1, .reusable = false}, SHIFT(357),
  [1424] = {.count = 1, .reusable = true}, SHIFT(2065),
  [1426] = {.count = 1, .reusable = true}, SHIFT(2876),
  [1428] = {.count = 1, .reusable = true}, SHIFT(2951),
  [1430] = {.count = 1, .reusable = true}, SHIFT(2532),
  [1432] = {.count = 1, .reusable = true}, SHIFT(2939),
  [1434] = {.count = 1, .reusable = true}, SHIFT(1674),
  [1436] = {.count = 1, .reusable = true}, SHIFT(2064),
  [1438] = {.count = 1, .reusable = true}, SHIFT(1974),
  [1440] = {.count = 1, .reusable = true}, SHIFT(2699),
  [1442] = {.count = 1, .reusable = true}, SHIFT(44),
  [1444] = {.count = 1, .reusable = true}, SHIFT(1298),
  [1446] = {.count = 1, .reusable = false}, SHIFT(1298),
  [1448] = {.count = 1, .reusable = true}, SHIFT(31),
  [1450] = {.count = 1, .reusable = true}, SHIFT(1319),
  [1452] = {.count = 1, .reusable = false}, SHIFT(1319),
  [1454] = {.count = 1, .reusable = true}, SHIFT(1293),
  [1456] = {.count = 1, .reusable = false}, SHIFT(1293),
  [1458] = {.count = 1, .reusable = true}, SHIFT(2),
  [1460] = {.count = 1, .reusable = true}, SHIFT(1042),
  [1462] = {.count = 1, .reusable = false}, SHIFT(1042),
  [1464] = {.count = 1, .reusable = true}, SHIFT(5),
  [1466] = {.count = 1, .reusable = true}, SHIFT(1345),
  [1468] = {.count = 1, .reusable = false}, SHIFT(1345),
  [1470] = {.count = 1, .reusable = true}, SHIFT(962),
  [1472] = {.count = 1, .reusable = false}, SHIFT(962),
  [1474] = {.count = 1, .reusable = true}, SHIFT(1263),
  [1476] = {.count = 1, .reusable = false}, SHIFT(1263),
  [1478] = {.count = 1, .reusable = true}, SHIFT(957),
  [1480] = {.count = 1, .reusable = false}, SHIFT(957),
  [1482] = {.count = 1, .reusable = true}, SHIFT(1337),
  [1484] = {.count = 1, .reusable = false}, SHIFT(1337),
  [1486] = {.count = 1, .reusable = false}, SHIFT(873),
  [1488] = {.count = 1, .reusable = false}, SHIFT(673),
  [1490] = {.count = 1, .reusable = false}, SHIFT(663),
  [1492] = {.count = 1, .reusable = false}, SHIFT(609),
  [1494] = {.count = 1, .reusable = false}, SHIFT(2934),
  [1496] = {.count = 1, .reusable = false}, SHIFT(462),
  [1498] = {.count = 1, .reusable = false}, SHIFT(52),
  [1500] = {.count = 1, .reusable = true}, SHIFT(984),
  [1502] = {.count = 1, .reusable = false}, SHIFT(984),
  [1504] = {.count = 1, .reusable = true}, SHIFT(985),
  [1506] = {.count = 1, .reusable = false}, SHIFT(985),
  [1508] = {.count = 1, .reusable = false}, SHIFT(816),
  [1510] = {.count = 1, .reusable = false}, SHIFT(815),
  [1512] = {.count = 1, .reusable = false}, SHIFT(628),
  [1514] = {.count = 1, .reusable = false}, SHIFT(2761),
  [1516] = {.count = 1, .reusable = false}, SHIFT(479),
  [1518] = {.count = 1, .reusable = false}, SHIFT(71),
  [1520] = {.count = 1, .reusable = true}, SHIFT(1459),
  [1522] = {.count = 1, .reusable = false}, SHIFT(1459),
  [1524] = {.count = 1, .reusable = false}, SHIFT(1492),
  [1526] = {.count = 1, .reusable = true}, SHIFT(1340),
  [1528] = {.count = 1, .reusable = false}, SHIFT(1340),
  [1530] = {.count = 1, .reusable = true}, SHIFT(6),
  [1532] = {.count = 1, .reusable = true}, SHIFT(1234),
  [1534] = {.count = 1, .reusable = false}, SHIFT(1234),
  [1536] = {.count = 1, .reusable = false}, SHIFT(767),
  [1538] = {.count = 1, .reusable = false}, SHIFT(724),
  [1540] = {.count = 1, .reusable = false}, SHIFT(612),
  [1542] = {.count = 1, .reusable = false}, SHIFT(2745),
  [1544] = {.count = 1, .reusable = false}, SHIFT(466),
  [1546] = {.count = 1, .reusable = false}, SHIFT(55),
  [1548] = {.count = 1, .reusable = true}, SHIFT(1349),
  [1550] = {.count = 1, .reusable = false}, SHIFT(1349),
  [1552] = {.count = 1, .reusable = false}, SHIFT(1569),
  [1554] = {.count = 1, .reusable = false}, SHIFT(809),
  [1556] = {.count = 1, .reusable = true}, SHIFT(1354),
  [1558] = {.count = 1, .reusable = false}, SHIFT(1354),
  [1560] = {.count = 1, .reusable = true}, SHIFT(1172),
  [1562] = {.count = 1, .reusable = false}, SHIFT(1172),
  [1564] = {.count = 1, .reusable = true}, SHIFT(979),
  [1566] = {.count = 1, .reusable = false}, SHIFT(979),
  [1568] = {.count = 1, .reusable = true}, SHIFT(1327),
  [1570] = {.count = 1, .reusable = false}, SHIFT(1327),
  [1572] = {.count = 1, .reusable = true}, SHIFT(1317),
  [1574] = {.count = 1, .reusable = false}, SHIFT(1317),
  [1576] = {.count = 1, .reusable = true}, SHIFT(1323),
  [1578] = {.count = 1, .reusable = false}, SHIFT(1323),
  [1580] = {.count = 1, .reusable = false}, SHIFT(820),
  [1582] = {.count = 1, .reusable = false}, SHIFT(823),
  [1584] = {.count = 1, .reusable = false}, SHIFT(616),
  [1586] = {.count = 1, .reusable = false}, SHIFT(500),
  [1588] = {.count = 1, .reusable = false}, SHIFT(68),
  [1590] = {.count = 1, .reusable = false}, SHIFT(839),
  [1592] = {.count = 1, .reusable = false}, SHIFT(850),
  [1594] = {.count = 1, .reusable = false}, SHIFT(630),
  [1596] = {.count = 1, .reusable = false}, SHIFT(530),
  [1598] = {.count = 1, .reusable = false}, SHIFT(72),
  [1600] = {.count = 1, .reusable = true}, SHIFT(1309),
  [1602] = {.count = 1, .reusable = false}, SHIFT(1309),
  [1604] = {.count = 1, .reusable = true}, SHIFT(1316),
  [1606] = {.count = 1, .reusable = false}, SHIFT(1316),
  [1608] = {.count = 1, .reusable = true}, SHIFT(1242),
  [1610] = {.count = 1, .reusable = false}, SHIFT(1242),
  [1612] = {.count = 1, .reusable = false}, SHIFT(832),
  [1614] = {.count = 1, .reusable = true}, SHIFT(1019),
  [1616] = {.count = 1, .reusable = false}, SHIFT(1019),
  [1618] = {.count = 1, .reusable = false}, SHIFT(844),
  [1620] = {.count = 1, .reusable = false}, SHIFT(836),
  [1622] = {.count = 1, .reusable = false}, SHIFT(631),
  [1624] = {.count = 1, .reusable = false}, SHIFT(552),
  [1626] = {.count = 1, .reusable = false}, SHIFT(67),
  [1628] = {.count = 1, .reusable = true}, SHIFT(948),
  [1630] = {.count = 1, .reusable = false}, SHIFT(948),
  [1632] = {.count = 1, .reusable = true}, SHIFT(1209),
  [1634] = {.count = 1, .reusable = false}, SHIFT(1209),
  [1636] = {.count = 1, .reusable = true}, SHIFT(1089),
  [1638] = {.count = 1, .reusable = false}, SHIFT(1089),
  [1640] = {.count = 1, .reusable = true}, SHIFT(1281),
  [1642] = {.count = 1, .reusable = false}, SHIFT(1281),
  [1644] = {.count = 1, .reusable = true}, SHIFT(1200),
  [1646] = {.count = 1, .reusable = false}, SHIFT(1200),
  [1648] = {.count = 1, .reusable = true}, SHIFT(1051),
  [1650] = {.count = 1, .reusable = false}, SHIFT(1051),
  [1652] = {.count = 1, .reusable = true}, SHIFT(1266),
  [1654] = {.count = 1, .reusable = false}, SHIFT(1266),
  [1656] = {.count = 1, .reusable = true}, SHIFT(967),
  [1658] = {.count = 1, .reusable = false}, SHIFT(967),
  [1660] = {.count = 1, .reusable = true}, SHIFT(1199),
  [1662] = {.count = 1, .reusable = false}, SHIFT(1199),
  [1664] = {.count = 1, .reusable = true}, SHIFT(1305),
  [1666] = {.count = 1, .reusable = false}, SHIFT(1305),
  [1668] = {.count = 1, .reusable = false}, SHIFT(876),
  [1670] = {.count = 1, .reusable = false}, SHIFT(868),
  [1672] = {.count = 1, .reusable = false}, SHIFT(636),
  [1674] = {.count = 1, .reusable = false}, SHIFT(589),
  [1676] = {.count = 1, .reusable = false}, SHIFT(76),
  [1678] = {.count = 1, .reusable = true}, SHIFT(1364),
  [1680] = {.count = 1, .reusable = false}, SHIFT(1364),
  [1682] = {.count = 1, .reusable = true}, SHIFT(1286),
  [1684] = {.count = 1, .reusable = false}, SHIFT(1286),
  [1686] = {.count = 1, .reusable = true}, SHIFT(1315),
  [1688] = {.count = 1, .reusable = false}, SHIFT(1315),
  [1690] = {.count = 1, .reusable = true}, SHIFT(1272),
  [1692] = {.count = 1, .reusable = false}, SHIFT(1272),
  [1694] = {.count = 1, .reusable = false}, SHIFT(640),
  [1696] = {.count = 1, .reusable = false}, SHIFT(888),
  [1698] = {.count = 1, .reusable = false}, SHIFT(643),
  [1700] = {.count = 1, .reusable = false}, SHIFT(594),
  [1702] = {.count = 1, .reusable = false}, SHIFT(81),
  [1704] = {.count = 1, .reusable = false}, SHIFT(759),
  [1706] = {.count = 1, .reusable = false}, SHIFT(853),
  [1708] = {.count = 1, .reusable = true}, SHIFT(1207),
  [1710] = {.count = 1, .reusable = false}, SHIFT(1207),
  [1712] = {.count = 1, .reusable = true}, SHIFT(1193),
  [1714] = {.count = 1, .reusable = false}, SHIFT(1193),
  [1716] = {.count = 1, .reusable = true}, SHIFT(1226),
  [1718] = {.count = 1, .reusable = false}, SHIFT(1226),
  [1720] = {.count = 1, .reusable = true}, SHIFT(1134),
  [1722] = {.count = 1, .reusable = false}, SHIFT(1134),
  [1724] = {.count = 1, .reusable = true}, SHIFT(1043),
  [1726] = {.count = 1, .reusable = false}, SHIFT(1043),
  [1728] = {.count = 1, .reusable = false}, SHIFT(854),
  [1730] = {.count = 1, .reusable = true}, SHIFT(1212),
  [1732] = {.count = 1, .reusable = false}, SHIFT(1212),
  [1734] = {.count = 1, .reusable = true}, SHIFT(1304),
  [1736] = {.count = 1, .reusable = false}, SHIFT(1304),
  [1738] = {.count = 1, .reusable = true}, SHIFT(1341),
  [1740] = {.count = 1, .reusable = false}, SHIFT(1341),
  [1742] = {.count = 1, .reusable = true}, SHIFT(956),
  [1744] = {.count = 1, .reusable = false}, SHIFT(956),
  [1746] = {.count = 1, .reusable = true}, SHIFT(1227),
  [1748] = {.count = 1, .reusable = false}, SHIFT(1227),
  [1750] = {.count = 1, .reusable = true}, SHIFT(1251),
  [1752] = {.count = 1, .reusable = false}, SHIFT(1251),
  [1754] = {.count = 1, .reusable = true}, SHIFT(1036),
  [1756] = {.count = 1, .reusable = false}, SHIFT(1036),
  [1758] = {.count = 1, .reusable = true}, SHIFT(1259),
  [1760] = {.count = 1, .reusable = false}, SHIFT(1259),
  [1762] = {.count = 1, .reusable = true}, SHIFT(1297),
  [1764] = {.count = 1, .reusable = false}, SHIFT(1297),
  [1766] = {.count = 1, .reusable = true}, SHIFT(1301),
  [1768] = {.count = 1, .reusable = false}, SHIFT(1301),
  [1770] = {.count = 1, .reusable = false}, SHIFT(845),
  [1772] = {.count = 1, .reusable = true}, SHIFT(1228),
  [1774] = {.count = 1, .reusable = false}, SHIFT(1228),
  [1776] = {.count = 1, .reusable = true}, SHIFT(1117),
  [1778] = {.count = 1, .reusable = false}, SHIFT(1117),
  [1780] = {.count = 1, .reusable = true}, SHIFT(1236),
  [1782] = {.count = 1, .reusable = false}, SHIFT(1236),
  [1784] = {.count = 1, .reusable = true}, SHIFT(1238),
  [1786] = {.count = 1, .reusable = false}, SHIFT(1238),
  [1788] = {.count = 1, .reusable = false}, SHIFT(828),
  [1790] = {.count = 1, .reusable = true}, SHIFT(1313),
  [1792] = {.count = 1, .reusable = false}, SHIFT(1313),
  [1794] = {.count = 1, .reusable = false}, SHIFT(773),
  [1796] = {.count = 1, .reusable = true}, SHIFT(1111),
  [1798] = {.count = 1, .reusable = false}, SHIFT(1111),
  [1800] = {.count = 1, .reusable = true}, SHIFT(1311),
  [1802] = {.count = 1, .reusable = false}, SHIFT(1311),
  [1804] = {.count = 1, .reusable = true}, SHIFT(1260),
  [1806] = {.count = 1, .reusable = false}, SHIFT(1260),
  [1808] = {.count = 1, .reusable = true}, SHIFT(1257),
  [1810] = {.count = 1, .reusable = false}, SHIFT(1257),
  [1812] = {.count = 1, .reusable = true}, SHIFT(1247),
  [1814] = {.count = 1, .reusable = false}, SHIFT(1247),
  [1816] = {.count = 1, .reusable = true}, SHIFT(1258),
  [1818] = {.count = 1, .reusable = true}, SHIFT(1419),
  [1820] = {.count = 1, .reusable = false}, SHIFT(1419),
  [1822] = {.count = 1, .reusable = true}, SHIFT(1248),
  [1824] = {.count = 1, .reusable = false}, SHIFT(1248),
  [1826] = {.count = 1, .reusable = true}, SHIFT(1517),
  [1828] = {.count = 1, .reusable = false}, SHIFT(1220),
  [1830] = {.count = 1, .reusable = true}, SHIFT(1271),
  [1832] = {.count = 1, .reusable = false}, SHIFT(1271),
  [1834] = {.count = 1, .reusable = true}, SHIFT(1273),
  [1836] = {.count = 1, .reusable = false}, SHIFT(1273),
  [1838] = {.count = 1, .reusable = true}, SHIFT(1204),
  [1840] = {.count = 1, .reusable = false}, SHIFT(1204),
  [1842] = {.count = 1, .reusable = true}, SHIFT(1124),
  [1844] = {.count = 1, .reusable = false}, SHIFT(1124),
  [1846] = {.count = 1, .reusable = true}, SHIFT(958),
  [1848] = {.count = 1, .reusable = false}, SHIFT(958),
  [1850] = {.count = 1, .reusable = true}, SHIFT(959),
  [1852] = {.count = 1, .reusable = false}, SHIFT(959),
  [1854] = {.count = 1, .reusable = true}, SHIFT(1095),
  [1856] = {.count = 1, .reusable = false}, SHIFT(1095),
  [1858] = {.count = 1, .reusable = false}, SHIFT(822),
  [1860] = {.count = 1, .reusable = true}, SHIFT(1329),
  [1862] = {.count = 1, .reusable = false}, SHIFT(1329),
  [1864] = {.count = 1, .reusable = true}, SHIFT(1277),
  [1866] = {.count = 1, .reusable = false}, SHIFT(1277),
  [1868] = {.count = 1, .reusable = true}, SHIFT(1140),
  [1870] = {.count = 1, .reusable = false}, SHIFT(1140),
  [1872] = {.count = 1, .reusable = true}, SHIFT(963),
  [1874] = {.count = 1, .reusable = false}, SHIFT(963),
  [1876] = {.count = 1, .reusable = true}, SHIFT(1220),
  [1878] = {.count = 1, .reusable = true}, SHIFT(964),
  [1880] = {.count = 1, .reusable = false}, SHIFT(964),
  [1882] = {.count = 1, .reusable = true}, SHIFT(1324),
  [1884] = {.count = 1, .reusable = false}, SHIFT(1324),
  [1886] = {.count = 1, .reusable = true}, SHIFT(1294),
  [1888] = {.count = 1, .reusable = false}, SHIFT(1294),
  [1890] = {.count = 1, .reusable = true}, SHIFT(966),
  [1892] = {.count = 1, .reusable = false}, SHIFT(966),
  [1894] = {.count = 1, .reusable = true}, SHIFT(1030),
  [1896] = {.count = 1, .reusable = false}, SHIFT(1030),
  [1898] = {.count = 1, .reusable = true}, SHIFT(1096),
  [1900] = {.count = 1, .reusable = false}, SHIFT(1279),
  [1902] = {.count = 1, .reusable = true}, SHIFT(1585),
  [1904] = {.count = 1, .reusable = false}, SHIFT(976),
  [1906] = {.count = 1, .reusable = true}, SHIFT(1018),
  [1908] = {.count = 1, .reusable = true}, SHIFT(1274),
  [1910] = {.count = 1, .reusable = false}, SHIFT(1274),
  [1912] = {.count = 1, .reusable = true}, SHIFT(1411),
  [1914] = {.count = 1, .reusable = false}, SHIFT(1411),
  [1916] = {.count = 1, .reusable = true}, SHIFT(1133),
  [1918] = {.count = 1, .reusable = false}, SHIFT(1133),
  [1920] = {.count = 1, .reusable = true}, SHIFT(1094),
  [1922] = {.count = 1, .reusable = false}, SHIFT(1094),
  [1924] = {.count = 1, .reusable = true}, SHIFT(1073),
  [1926] = {.count = 1, .reusable = false}, SHIFT(1073),
  [1928] = {.count = 1, .reusable = true}, SHIFT(1015),
  [1930] = {.count = 1, .reusable = false}, SHIFT(1015),
  [1932] = {.count = 1, .reusable = true}, SHIFT(1190),
  [1934] = {.count = 1, .reusable = false}, SHIFT(1190),
  [1936] = {.count = 1, .reusable = true}, SHIFT(1136),
  [1938] = {.count = 1, .reusable = false}, SHIFT(1136),
  [1940] = {.count = 1, .reusable = true}, SHIFT(1064),
  [1942] = {.count = 1, .reusable = false}, SHIFT(1064),
  [1944] = {.count = 1, .reusable = true}, SHIFT(1063),
  [1946] = {.count = 1, .reusable = false}, SHIFT(1063),
  [1948] = {.count = 1, .reusable = true}, SHIFT(1148),
  [1950] = {.count = 1, .reusable = false}, SHIFT(1148),
  [1952] = {.count = 1, .reusable = true}, SHIFT(1195),
  [1954] = {.count = 1, .reusable = false}, SHIFT(1195),
  [1956] = {.count = 1, .reusable = true}, SHIFT(1292),
  [1958] = {.count = 1, .reusable = false}, SHIFT(1292),
  [1960] = {.count = 1, .reusable = true}, SHIFT(969),
  [1962] = {.count = 1, .reusable = false}, SHIFT(969),
  [1964] = {.count = 1, .reusable = true}, SHIFT(1283),
  [1966] = {.count = 1, .reusable = false}, SHIFT(1283),
  [1968] = {.count = 1, .reusable = true}, SHIFT(1157),
  [1970] = {.count = 1, .reusable = false}, SHIFT(1157),
  [1972] = {.count = 1, .reusable = true}, SHIFT(923),
  [1974] = {.count = 1, .reusable = false}, SHIFT(923),
  [1976] = {.count = 1, .reusable = true}, SHIFT(1173),
  [1978] = {.count = 1, .reusable = false}, SHIFT(1173),
  [1980] = {.count = 1, .reusable = true}, SHIFT(1178),
  [1982] = {.count = 1, .reusable = false}, SHIFT(1178),
  [1984] = {.count = 1, .reusable = true}, SHIFT(1174),
  [1986] = {.count = 1, .reusable = false}, SHIFT(1174),
  [1988] = {.count = 1, .reusable = true}, SHIFT(1198),
  [1990] = {.count = 1, .reusable = false}, SHIFT(1198),
  [1992] = {.count = 1, .reusable = true}, SHIFT(978),
  [1994] = {.count = 1, .reusable = true}, SHIFT(965),
  [1996] = {.count = 1, .reusable = false}, SHIFT(965),
  [1998] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2000] = {.count = 1, .reusable = false}, SHIFT(1181),
  [2002] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2004] = {.count = 1, .reusable = false}, SHIFT(1299),
  [2006] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2008] = {.count = 1, .reusable = false}, SHIFT(1291),
  [2010] = {.count = 1, .reusable = true}, SHIFT(1006),
  [2012] = {.count = 1, .reusable = false}, SHIFT(1006),
  [2014] = {.count = 1, .reusable = true}, SHIFT(1158),
  [2016] = {.count = 1, .reusable = false}, SHIFT(1158),
  [2018] = {.count = 1, .reusable = true}, SHIFT(1005),
  [2020] = {.count = 1, .reusable = false}, SHIFT(1005),
  [2022] = {.count = 1, .reusable = true}, SHIFT(1004),
  [2024] = {.count = 1, .reusable = false}, SHIFT(1004),
  [2026] = {.count = 1, .reusable = true}, SHIFT(1405),
  [2028] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2030] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2032] = {.count = 1, .reusable = false}, SHIFT(1270),
  [2034] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2036] = {.count = 1, .reusable = false}, SHIFT(1308),
  [2038] = {.count = 1, .reusable = false}, SHIFT(1252),
  [2040] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2042] = {.count = 1, .reusable = false}, SHIFT(1159),
  [2044] = {.count = 1, .reusable = true}, SHIFT(1623),
  [2046] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2048] = {.count = 1, .reusable = false}, SHIFT(1163),
  [2050] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2052] = {.count = 1, .reusable = false}, SHIFT(1035),
  [2054] = {.count = 1, .reusable = true}, SHIFT(980),
  [2056] = {.count = 1, .reusable = false}, SHIFT(980),
  [2058] = {.count = 1, .reusable = true}, SHIFT(983),
  [2060] = {.count = 1, .reusable = false}, SHIFT(983),
  [2062] = {.count = 1, .reusable = false}, SHIFT(814),
  [2064] = {.count = 1, .reusable = true}, SHIFT(1000),
  [2066] = {.count = 1, .reusable = false}, SHIFT(1000),
  [2068] = {.count = 1, .reusable = true}, SHIFT(1320),
  [2070] = {.count = 1, .reusable = false}, SHIFT(1320),
  [2072] = {.count = 1, .reusable = true}, SHIFT(1164),
  [2074] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2076] = {.count = 1, .reusable = false}, SHIFT(1167),
  [2078] = {.count = 1, .reusable = true}, SHIFT(1376),
  [2080] = {.count = 1, .reusable = false}, SHIFT(1376),
  [2082] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2084] = {.count = 1, .reusable = false}, SHIFT(1169),
  [2086] = {.count = 1, .reusable = true}, SHIFT(986),
  [2088] = {.count = 1, .reusable = false}, SHIFT(986),
  [2090] = {.count = 1, .reusable = true}, SHIFT(1007),
  [2092] = {.count = 1, .reusable = false}, SHIFT(1007),
  [2094] = {.count = 1, .reusable = true}, SHIFT(1353),
  [2096] = {.count = 1, .reusable = false}, SHIFT(1353),
  [2098] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2100] = {.count = 1, .reusable = false}, SHIFT(1351),
  [2102] = {.count = 1, .reusable = true}, SHIFT(1348),
  [2104] = {.count = 1, .reusable = false}, SHIFT(1348),
  [2106] = {.count = 1, .reusable = true}, SHIFT(1347),
  [2108] = {.count = 1, .reusable = false}, SHIFT(1347),
  [2110] = {.count = 1, .reusable = true}, SHIFT(990),
  [2112] = {.count = 1, .reusable = false}, SHIFT(990),
  [2114] = {.count = 1, .reusable = true}, SHIFT(1087),
  [2116] = {.count = 1, .reusable = false}, SHIFT(1087),
  [2118] = {.count = 1, .reusable = true}, SHIFT(1346),
  [2120] = {.count = 1, .reusable = false}, SHIFT(1346),
  [2122] = {.count = 1, .reusable = true}, SHIFT(1344),
  [2124] = {.count = 1, .reusable = false}, SHIFT(1344),
  [2126] = {.count = 1, .reusable = true}, SHIFT(1477),
  [2128] = {.count = 1, .reusable = false}, SHIFT(1477),
  [2130] = {.count = 1, .reusable = true}, SHIFT(1343),
  [2132] = {.count = 1, .reusable = true}, SHIFT(1002),
  [2134] = {.count = 1, .reusable = false}, SHIFT(1002),
  [2136] = {.count = 1, .reusable = true}, SHIFT(1342),
  [2138] = {.count = 1, .reusable = false}, SHIFT(1342),
  [2140] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2142] = {.count = 1, .reusable = false}, SHIFT(1177),
  [2144] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2146] = {.count = 1, .reusable = false}, SHIFT(1338),
  [2148] = {.count = 1, .reusable = true}, SHIFT(999),
  [2150] = {.count = 1, .reusable = false}, SHIFT(999),
  [2152] = {.count = 1, .reusable = true}, SHIFT(1028),
  [2154] = {.count = 1, .reusable = false}, SHIFT(1028),
  [2156] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2158] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2160] = {.count = 1, .reusable = false}, SHIFT(1335),
  [2162] = {.count = 1, .reusable = false}, SHIFT(808),
  [2164] = {.count = 1, .reusable = true}, SHIFT(1062),
  [2166] = {.count = 1, .reusable = false}, SHIFT(1062),
  [2168] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2170] = {.count = 1, .reusable = false}, SHIFT(1331),
  [2172] = {.count = 1, .reusable = true}, SHIFT(1332),
  [2174] = {.count = 1, .reusable = false}, SHIFT(1332),
  [2176] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2178] = {.count = 1, .reusable = false}, SHIFT(1188),
  [2180] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2182] = {.count = 1, .reusable = false}, SHIFT(1256),
  [2184] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2186] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2188] = {.count = 1, .reusable = false}, SHIFT(1300),
  [2190] = {.count = 1, .reusable = true}, SHIFT(1090),
  [2192] = {.count = 1, .reusable = false}, SHIFT(1090),
  [2194] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2196] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2198] = {.count = 1, .reusable = true}, SHIFT(968),
  [2200] = {.count = 1, .reusable = false}, SHIFT(968),
  [2202] = {.count = 1, .reusable = true}, SHIFT(1432),
  [2204] = {.count = 1, .reusable = false}, SHIFT(1432),
  [2206] = {.count = 1, .reusable = true}, SHIFT(1326),
  [2208] = {.count = 1, .reusable = false}, SHIFT(1326),
  [2210] = {.count = 1, .reusable = true}, SHIFT(1485),
  [2212] = {.count = 1, .reusable = false}, SHIFT(1485),
  [2214] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2216] = {.count = 1, .reusable = false}, SHIFT(1143),
  [2218] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2220] = {.count = 1, .reusable = false}, SHIFT(1144),
  [2222] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2224] = {.count = 1, .reusable = false}, SHIFT(1239),
  [2226] = {.count = 1, .reusable = true}, SHIFT(1217),
  [2228] = {.count = 1, .reusable = false}, SHIFT(1217),
  [2230] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2232] = {.count = 1, .reusable = false}, SHIFT(1240),
  [2234] = {.count = 1, .reusable = true}, SHIFT(971),
  [2236] = {.count = 1, .reusable = false}, SHIFT(971),
  [2238] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2240] = {.count = 1, .reusable = false}, SHIFT(1222),
  [2242] = {.count = 1, .reusable = true}, SHIFT(1312),
  [2244] = {.count = 1, .reusable = false}, SHIFT(1312),
  [2246] = {.count = 1, .reusable = true}, SHIFT(1314),
  [2248] = {.count = 1, .reusable = false}, SHIFT(1314),
  [2250] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2252] = {.count = 1, .reusable = false}, SHIFT(1221),
  [2254] = {.count = 1, .reusable = true}, SHIFT(1325),
  [2256] = {.count = 1, .reusable = false}, SHIFT(1325),
  [2258] = {.count = 1, .reusable = true}, SHIFT(1085),
  [2260] = {.count = 1, .reusable = false}, SHIFT(1085),
  [2262] = {.count = 1, .reusable = true}, SHIFT(1437),
  [2264] = {.count = 1, .reusable = false}, SHIFT(1437),
  [2266] = {.count = 1, .reusable = true}, SHIFT(1154),
  [2268] = {.count = 1, .reusable = false}, SHIFT(1154),
  [2270] = {.count = 1, .reusable = true}, SHIFT(1915),
  [2272] = {.count = 1, .reusable = false}, SHIFT(884),
  [2274] = {.count = 1, .reusable = true}, SHIFT(1246),
  [2276] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2278] = {.count = 1, .reusable = false}, SHIFT(1225),
  [2280] = {.count = 1, .reusable = true}, SHIFT(949),
  [2282] = {.count = 1, .reusable = false}, SHIFT(949),
  [2284] = {.count = 1, .reusable = true}, SHIFT(1155),
  [2286] = {.count = 1, .reusable = false}, SHIFT(1155),
  [2288] = {.count = 1, .reusable = true}, SHIFT(974),
  [2290] = {.count = 1, .reusable = false}, SHIFT(974),
  [2292] = {.count = 1, .reusable = true}, SHIFT(976),
  [2294] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2296] = {.count = 1, .reusable = false}, SHIFT(1191),
  [2298] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2300] = {.count = 1, .reusable = false}, SHIFT(1206),
  [2302] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2304] = {.count = 1, .reusable = false}, SHIFT(1171),
  [2306] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2308] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2310] = {.count = 1, .reusable = false}, SHIFT(1241),
  [2312] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2314] = {.count = 1, .reusable = false}, SHIFT(1149),
  [2316] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2318] = {.count = 1, .reusable = false}, SHIFT(1184),
  [2320] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2322] = {.count = 1, .reusable = false}, SHIFT(1211),
  [2324] = {.count = 1, .reusable = true}, SHIFT(987),
  [2326] = {.count = 1, .reusable = false}, SHIFT(987),
  [2328] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2330] = {.count = 1, .reusable = false}, SHIFT(1203),
  [2332] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2334] = {.count = 1, .reusable = false}, SHIFT(1237),
  [2336] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2338] = {.count = 1, .reusable = false}, SHIFT(1205),
  [2340] = {.count = 1, .reusable = true}, REDUCE(sym_nested_type_identifier, 3, .production_id = 88),
  [2342] = {.count = 1, .reusable = false}, REDUCE(sym_nested_type_identifier, 3, .production_id = 88),
  [2344] = {.count = 1, .reusable = true}, REDUCE(sym_type_query, 2),
  [2346] = {.count = 1, .reusable = false}, REDUCE(sym_type_query, 2),
  [2348] = {.count = 1, .reusable = false}, SHIFT(2920),
  [2350] = {.count = 1, .reusable = false}, SHIFT(2335),
  [2352] = {.count = 1, .reusable = false}, SHIFT(2341),
  [2354] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1772),
  [2357] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1648),
  [2361] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(322),
  [2364] = {.count = 3, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2724),
  [2368] = {.count = 1, .reusable = false}, SHIFT(1971),
  [2370] = {.count = 1, .reusable = true}, SHIFT(2320),
  [2372] = {.count = 1, .reusable = true}, SHIFT(2319),
  [2374] = {.count = 1, .reusable = true}, SHIFT(2056),
  [2376] = {.count = 1, .reusable = false}, SHIFT(1707),
  [2378] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [2380] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [2382] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2, .production_id = 47),
  [2384] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2, .production_id = 47),
  [2386] = {.count = 1, .reusable = false}, SHIFT(2827),
  [2388] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 4),
  [2390] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 4),
  [2392] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2),
  [2394] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2),
  [2396] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 3),
  [2398] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 3),
  [2400] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 5),
  [2402] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 5),
  [2404] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 3),
  [2406] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 3),
  [2408] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 3),
  [2410] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 3),
  [2412] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 2),
  [2414] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 2),
  [2416] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 4),
  [2418] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 4),
  [2420] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 4),
  [2422] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 4),
  [2424] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1),
  [2426] = {.count = 1, .reusable = false}, REDUCE(sym__type, 1),
  [2428] = {.count = 1, .reusable = true}, SHIFT(672),
  [2430] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 2),
  [2432] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 2),
  [2434] = {.count = 1, .reusable = true}, REDUCE(sym_flow_maybe_type, 2),
  [2436] = {.count = 1, .reusable = false}, REDUCE(sym_flow_maybe_type, 2),
  [2438] = {.count = 1, .reusable = true}, REDUCE(sym_literal_type, 1),
  [2440] = {.count = 1, .reusable = false}, REDUCE(sym_literal_type, 1),
  [2442] = {.count = 1, .reusable = true}, REDUCE(sym_existential_type, 1),
  [2444] = {.count = 1, .reusable = false}, REDUCE(sym_existential_type, 1),
  [2446] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 6),
  [2448] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 6),
  [2450] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2),
  [2452] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2),
  [2454] = {.count = 1, .reusable = true}, REDUCE(sym_lookup_type, 4),
  [2456] = {.count = 1, .reusable = false}, REDUCE(sym_lookup_type, 4),
  [2458] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 5),
  [2460] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 5),
  [2462] = {.count = 1, .reusable = true}, REDUCE(sym__number, 2),
  [2464] = {.count = 1, .reusable = false}, REDUCE(sym__number, 2),
  [2466] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 3),
  [2468] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 3),
  [2470] = {.count = 1, .reusable = false}, REDUCE(sym_predefined_type, 1),
  [2472] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 3),
  [2474] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 3),
  [2476] = {.count = 1, .reusable = true}, REDUCE(sym_array_type, 3),
  [2478] = {.count = 1, .reusable = false}, REDUCE(sym_array_type, 3),
  [2480] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_type, 3),
  [2482] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_type, 3),
  [2484] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 2),
  [2486] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 2),
  [2488] = {.count = 1, .reusable = false}, SHIFT(2052),
  [2490] = {.count = 1, .reusable = false}, SHIFT(1706),
  [2492] = {.count = 1, .reusable = false}, SHIFT(1711),
  [2494] = {.count = 1, .reusable = false}, SHIFT(1750),
  [2496] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [2498] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [2500] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(743),
  [2503] = {.count = 1, .reusable = false}, SHIFT(792),
  [2505] = {.count = 1, .reusable = false}, SHIFT(1814),
  [2507] = {.count = 1, .reusable = false}, SHIFT(2088),
  [2509] = {.count = 1, .reusable = false}, SHIFT(625),
  [2511] = {.count = 1, .reusable = false}, SHIFT(2725),
  [2513] = {.count = 1, .reusable = true}, SHIFT(455),
  [2515] = {.count = 1, .reusable = true}, SHIFT(2724),
  [2517] = {.count = 1, .reusable = false}, SHIFT(2279),
  [2519] = {.count = 1, .reusable = true}, SHIFT(2749),
  [2521] = {.count = 1, .reusable = false}, SHIFT(1902),
  [2523] = {.count = 1, .reusable = true}, SHIFT(429),
  [2525] = {.count = 1, .reusable = false}, SHIFT(1899),
  [2527] = {.count = 1, .reusable = false}, SHIFT(429),
  [2529] = {.count = 1, .reusable = false}, SHIFT(1728),
  [2531] = {.count = 1, .reusable = true}, SHIFT(457),
  [2533] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [2535] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [2537] = {.count = 1, .reusable = false}, SHIFT(2488),
  [2539] = {.count = 1, .reusable = false}, SHIFT(2583),
  [2541] = {.count = 1, .reusable = false}, REDUCE(sym_accessibility_modifier, 1),
  [2543] = {.count = 1, .reusable = true}, REDUCE(sym_accessibility_modifier, 1),
  [2545] = {.count = 1, .reusable = false}, SHIFT(2944),
  [2547] = {.count = 1, .reusable = false}, SHIFT(2945),
  [2549] = {.count = 1, .reusable = true}, SHIFT(2844),
  [2551] = {.count = 1, .reusable = false}, SHIFT(1913),
  [2553] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1),
  [2555] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1),
  [2557] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(743),
  [2560] = {.count = 1, .reusable = true}, SHIFT(27),
  [2562] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1648),
  [2565] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(2724),
  [2568] = {.count = 1, .reusable = false}, SHIFT(2752),
  [2570] = {.count = 1, .reusable = false}, SHIFT(2755),
  [2572] = {.count = 1, .reusable = false}, SHIFT(1922),
  [2574] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 6, .production_id = 149),
  [2576] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 6, .production_id = 149),
  [2578] = {.count = 1, .reusable = true}, SHIFT(778),
  [2580] = {.count = 1, .reusable = true}, SHIFT(777),
  [2582] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 42),
  [2584] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 42),
  [2586] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 5),
  [2588] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 5),
  [2590] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 4),
  [2592] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 4),
  [2594] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 4),
  [2596] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 4),
  [2598] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 3),
  [2600] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 3),
  [2602] = {.count = 1, .reusable = true}, REDUCE(sym_type_predicate, 3),
  [2604] = {.count = 1, .reusable = false}, REDUCE(sym_type_predicate, 3),
  [2606] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [2608] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [2610] = {.count = 1, .reusable = true}, SHIFT(474),
  [2612] = {.count = 1, .reusable = false}, SHIFT(2746),
  [2614] = {.count = 1, .reusable = false}, SHIFT(2747),
  [2616] = {.count = 1, .reusable = true}, SHIFT(2846),
  [2618] = {.count = 1, .reusable = false}, SHIFT(1973),
  [2620] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 159),
  [2622] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 159),
  [2624] = {.count = 1, .reusable = true}, SHIFT(483),
  [2626] = {.count = 1, .reusable = false}, SHIFT(1976),
  [2628] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [2630] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [2632] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 157),
  [2634] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 157),
  [2636] = {.count = 1, .reusable = false}, SHIFT(2759),
  [2638] = {.count = 1, .reusable = false}, SHIFT(2758),
  [2640] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 158),
  [2642] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 158),
  [2644] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [2646] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [2648] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 98),
  [2650] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 98),
  [2652] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 124),
  [2654] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 124),
  [2656] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 4),
  [2658] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 4),
  [2660] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 4),
  [2662] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 4),
  [2664] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 4, .production_id = 80),
  [2666] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 4, .production_id = 80),
  [2668] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 2),
  [2670] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 2),
  [2672] = {.count = 1, .reusable = true}, REDUCE(sym_throw_statement, 3),
  [2674] = {.count = 1, .reusable = false}, REDUCE(sym_throw_statement, 3),
  [2676] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [2678] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [2680] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 3, .production_id = 45),
  [2682] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 3, .production_id = 45),
  [2684] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 3, .production_id = 45),
  [2686] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 3, .production_id = 45),
  [2688] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 4, .production_id = 81),
  [2690] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 4, .production_id = 81),
  [2692] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2694] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2696] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 3, .production_id = 44),
  [2698] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 3, .production_id = 44),
  [2700] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2702] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2704] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3, .production_id = 41),
  [2706] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3, .production_id = 41),
  [2708] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 7, .production_id = 150),
  [2710] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 7, .production_id = 150),
  [2712] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 5),
  [2714] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 5),
  [2716] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 7, .production_id = 147),
  [2718] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 7, .production_id = 147),
  [2720] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2722] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2724] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4, .production_id = 86),
  [2726] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4, .production_id = 86),
  [2728] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 3, .production_id = 35),
  [2730] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 3, .production_id = 35),
  [2732] = {.count = 1, .reusable = false}, SHIFT(39),
  [2734] = {.count = 1, .reusable = false}, SHIFT(2834),
  [2736] = {.count = 1, .reusable = false}, SHIFT(2833),
  [2738] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 3, .production_id = 37),
  [2740] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 3, .production_id = 37),
  [2742] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7, .production_id = 156),
  [2744] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7, .production_id = 156),
  [2746] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 3, .production_id = 36),
  [2748] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 3, .production_id = 36),
  [2750] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 3),
  [2752] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 3),
  [2754] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 3),
  [2756] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 3),
  [2758] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 3),
  [2760] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 3),
  [2762] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 128),
  [2764] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 128),
  [2766] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 127),
  [2768] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 127),
  [2770] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 4),
  [2772] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 4),
  [2774] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 148),
  [2776] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 148),
  [2778] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 122),
  [2780] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 122),
  [2782] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 6, .production_id = 122),
  [2784] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 6, .production_id = 122),
  [2786] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 69),
  [2788] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 69),
  [2790] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 68),
  [2792] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 68),
  [2794] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 119),
  [2796] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 119),
  [2798] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 49),
  [2800] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 49),
  [2802] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3, .production_id = 66),
  [2804] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3, .production_id = 66),
  [2806] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [2808] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [2810] = {.count = 1, .reusable = false}, SHIFT(2884),
  [2812] = {.count = 1, .reusable = false}, SHIFT(2882),
  [2814] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 4, .production_id = 97),
  [2816] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 4, .production_id = 97),
  [2818] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [2820] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [2822] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6, .production_id = 135),
  [2824] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6, .production_id = 135),
  [2826] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 100),
  [2828] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 100),
  [2830] = {.count = 1, .reusable = true}, REDUCE(sym_debugger_statement, 2),
  [2832] = {.count = 1, .reusable = false}, REDUCE(sym_debugger_statement, 2),
  [2834] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 90),
  [2836] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 90),
  [2838] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 91),
  [2840] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 91),
  [2842] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [2844] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [2846] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 6, .production_id = 132),
  [2848] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 6, .production_id = 132),
  [2850] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 3),
  [2852] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 3),
  [2854] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 101),
  [2856] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 101),
  [2858] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 3, .production_id = 49),
  [2860] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 3, .production_id = 49),
  [2862] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5, .production_id = 126),
  [2864] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5, .production_id = 126),
  [2866] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 3),
  [2868] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 3),
  [2870] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 3, .production_id = 60),
  [2872] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 3, .production_id = 60),
  [2874] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 5, .production_id = 119),
  [2876] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 5, .production_id = 119),
  [2878] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 4),
  [2880] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 4),
  [2882] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 123),
  [2884] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 123),
  [2886] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 2),
  [2888] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 2),
  [2890] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 5, .production_id = 121),
  [2892] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 5, .production_id = 121),
  [2894] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [2896] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [2898] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 90),
  [2900] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 90),
  [2902] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3),
  [2904] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3),
  [2906] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 2),
  [2908] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 2),
  [2910] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 5, .production_id = 112),
  [2912] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 5, .production_id = 112),
  [2914] = {.count = 1, .reusable = true}, REDUCE(sym_module, 2, .production_id = 6),
  [2916] = {.count = 1, .reusable = false}, REDUCE(sym_module, 2, .production_id = 6),
  [2918] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5),
  [2920] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5),
  [2922] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 3),
  [2924] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 3),
  [2926] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 108),
  [2928] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 108),
  [2930] = {.count = 1, .reusable = true}, REDUCE(sym_import_alias, 5),
  [2932] = {.count = 1, .reusable = false}, REDUCE(sym_import_alias, 5),
  [2934] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 5, .production_id = 107),
  [2936] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 5, .production_id = 107),
  [2938] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 5, .production_id = 106),
  [2940] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 5, .production_id = 106),
  [2942] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [2944] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [2946] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 152),
  [2948] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 152),
  [2950] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2952] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2954] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 133),
  [2956] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 133),
  [2958] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 134),
  [2960] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 134),
  [2962] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 136),
  [2964] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 136),
  [2966] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 137),
  [2968] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 137),
  [2970] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 4),
  [2972] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 4),
  [2974] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 155),
  [2976] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 155),
  [2978] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 153),
  [2980] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 153),
  [2982] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 154),
  [2984] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 154),
  [2986] = {.count = 1, .reusable = false}, SHIFT(109),
  [2988] = {.count = 1, .reusable = true}, SHIFT(2361),
  [2990] = {.count = 1, .reusable = true}, SHIFT(2347),
  [2992] = {.count = 1, .reusable = false}, SHIFT(464),
  [2994] = {.count = 1, .reusable = false}, SHIFT(951),
  [2996] = {.count = 1, .reusable = true}, SHIFT(143),
  [2998] = {.count = 1, .reusable = true}, SHIFT(144),
  [3000] = {.count = 1, .reusable = false}, SHIFT(1827),
  [3002] = {.count = 1, .reusable = false}, SHIFT(883),
  [3004] = {.count = 1, .reusable = true}, SHIFT(1764),
  [3006] = {.count = 1, .reusable = true}, SHIFT(642),
  [3008] = {.count = 1, .reusable = true}, SHIFT(972),
  [3010] = {.count = 1, .reusable = true}, SHIFT(1639),
  [3012] = {.count = 1, .reusable = true}, SHIFT(922),
  [3014] = {.count = 1, .reusable = true}, SHIFT(136),
  [3016] = {.count = 1, .reusable = false}, SHIFT(1289),
  [3018] = {.count = 1, .reusable = false}, SHIFT(2306),
  [3020] = {.count = 1, .reusable = true}, SHIFT(2299),
  [3022] = {.count = 1, .reusable = true}, SHIFT(2296),
  [3024] = {.count = 1, .reusable = true}, SHIFT(1795),
  [3026] = {.count = 1, .reusable = false}, SHIFT(1197),
  [3028] = {.count = 1, .reusable = false}, SHIFT(1366),
  [3030] = {.count = 1, .reusable = false}, SHIFT(1495),
  [3032] = {.count = 1, .reusable = false}, SHIFT(1746),
  [3034] = {.count = 1, .reusable = true}, SHIFT(441),
  [3036] = {.count = 1, .reusable = false}, SHIFT(1831),
  [3038] = {.count = 1, .reusable = false}, SHIFT(887),
  [3040] = {.count = 1, .reusable = true}, SHIFT(1370),
  [3042] = {.count = 1, .reusable = false}, SHIFT(1355),
  [3044] = {.count = 1, .reusable = false}, SHIFT(1145),
  [3046] = {.count = 1, .reusable = false}, SHIFT(1475),
  [3048] = {.count = 1, .reusable = false}, SHIFT(1501),
  [3050] = {.count = 1, .reusable = true}, SHIFT(1393),
  [3052] = {.count = 1, .reusable = false}, SHIFT(994),
  [3054] = {.count = 1, .reusable = true}, SHIFT(639),
  [3056] = {.count = 1, .reusable = true}, SHIFT(1214),
  [3058] = {.count = 1, .reusable = true}, SHIFT(919),
  [3060] = {.count = 1, .reusable = true}, SHIFT(1855),
  [3062] = {.count = 1, .reusable = true}, SHIFT(1587),
  [3064] = {.count = 1, .reusable = false}, SHIFT(1826),
  [3066] = {.count = 1, .reusable = false}, SHIFT(893),
  [3068] = {.count = 1, .reusable = true}, SHIFT(1284),
  [3070] = {.count = 1, .reusable = false}, SHIFT(1356),
  [3072] = {.count = 1, .reusable = false}, SHIFT(1137),
  [3074] = {.count = 1, .reusable = false}, SHIFT(1368),
  [3076] = {.count = 1, .reusable = false}, SHIFT(1583),
  [3078] = {.count = 1, .reusable = true}, SHIFT(1905),
  [3080] = {.count = 1, .reusable = true}, SHIFT(140),
  [3082] = {.count = 1, .reusable = false}, SHIFT(1407),
  [3084] = {.count = 1, .reusable = false}, SHIFT(1845),
  [3086] = {.count = 1, .reusable = false}, SHIFT(898),
  [3088] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 1),
  [3090] = {.count = 1, .reusable = false}, SHIFT(1433),
  [3092] = {.count = 1, .reusable = false}, SHIFT(1254),
  [3094] = {.count = 1, .reusable = false}, SHIFT(1620),
  [3096] = {.count = 1, .reusable = false}, SHIFT(1652),
  [3098] = {.count = 1, .reusable = false}, SHIFT(295),
  [3100] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [3102] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(166),
  [3105] = {.count = 1, .reusable = true}, SHIFT(166),
  [3107] = {.count = 1, .reusable = true}, SHIFT(695),
  [3109] = {.count = 1, .reusable = true}, SHIFT(2932),
  [3111] = {.count = 1, .reusable = true}, SHIFT(212),
  [3113] = {.count = 1, .reusable = true}, SHIFT(254),
  [3115] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 56),
  [3117] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 56),
  [3119] = {.count = 1, .reusable = false}, SHIFT(1244),
  [3121] = {.count = 1, .reusable = true}, SHIFT(1047),
  [3123] = {.count = 1, .reusable = false}, SHIFT(890),
  [3125] = {.count = 1, .reusable = false}, SHIFT(2614),
  [3127] = {.count = 1, .reusable = true}, SHIFT(454),
  [3129] = {.count = 1, .reusable = true}, SHIFT(795),
  [3131] = {.count = 1, .reusable = false}, SHIFT(2352),
  [3133] = {.count = 1, .reusable = true}, SHIFT(970),
  [3135] = {.count = 1, .reusable = true}, SHIFT(687),
  [3137] = {.count = 1, .reusable = true}, SHIFT(699),
  [3139] = {.count = 1, .reusable = true}, SHIFT(2839),
  [3141] = {.count = 1, .reusable = false}, SHIFT(1049),
  [3143] = {.count = 1, .reusable = true}, SHIFT(1050),
  [3145] = {.count = 1, .reusable = false}, SHIFT(1052),
  [3147] = {.count = 1, .reusable = false}, SHIFT(1050),
  [3149] = {.count = 1, .reusable = false}, SHIFT(2447),
  [3151] = {.count = 1, .reusable = true}, SHIFT(890),
  [3153] = {.count = 1, .reusable = false}, SHIFT(2371),
  [3155] = {.count = 1, .reusable = false}, SHIFT(325),
  [3157] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3160] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(743),
  [3163] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3166] = {.count = 1, .reusable = true}, SHIFT(2816),
  [3168] = {.count = 1, .reusable = true}, SHIFT(176),
  [3170] = {.count = 1, .reusable = true}, SHIFT(317),
  [3172] = {.count = 1, .reusable = true}, SHIFT(722),
  [3174] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4, .production_id = 99),
  [3176] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4, .production_id = 99),
  [3178] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(770),
  [3181] = {.count = 1, .reusable = true}, SHIFT(2914),
  [3183] = {.count = 1, .reusable = true}, SHIFT(751),
  [3185] = {.count = 1, .reusable = false}, SHIFT(1262),
  [3187] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3189] = {.count = 1, .reusable = false}, SHIFT(892),
  [3191] = {.count = 1, .reusable = false}, SHIFT(2575),
  [3193] = {.count = 1, .reusable = true}, SHIFT(453),
  [3195] = {.count = 1, .reusable = true}, SHIFT(793),
  [3197] = {.count = 1, .reusable = false}, SHIFT(2346),
  [3199] = {.count = 1, .reusable = true}, SHIFT(960),
  [3201] = {.count = 1, .reusable = true}, SHIFT(705),
  [3203] = {.count = 1, .reusable = true}, SHIFT(713),
  [3205] = {.count = 1, .reusable = true}, SHIFT(2878),
  [3207] = {.count = 1, .reusable = false}, SHIFT(1574),
  [3209] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3211] = {.count = 1, .reusable = false}, SHIFT(1571),
  [3213] = {.count = 1, .reusable = false}, SHIFT(1572),
  [3215] = {.count = 1, .reusable = false}, SHIFT(2496),
  [3217] = {.count = 1, .reusable = true}, SHIFT(892),
  [3219] = {.count = 1, .reusable = false}, SHIFT(1141),
  [3221] = {.count = 1, .reusable = true}, SHIFT(1400),
  [3223] = {.count = 1, .reusable = false}, SHIFT(891),
  [3225] = {.count = 1, .reusable = false}, SHIFT(2547),
  [3227] = {.count = 1, .reusable = true}, SHIFT(449),
  [3229] = {.count = 1, .reusable = true}, SHIFT(766),
  [3231] = {.count = 1, .reusable = false}, SHIFT(2310),
  [3233] = {.count = 1, .reusable = true}, SHIFT(992),
  [3235] = {.count = 1, .reusable = true}, SHIFT(742),
  [3237] = {.count = 1, .reusable = true}, SHIFT(741),
  [3239] = {.count = 1, .reusable = true}, SHIFT(2912),
  [3241] = {.count = 1, .reusable = false}, SHIFT(1371),
  [3243] = {.count = 1, .reusable = true}, SHIFT(1375),
  [3245] = {.count = 1, .reusable = false}, SHIFT(1372),
  [3247] = {.count = 1, .reusable = false}, SHIFT(1375),
  [3249] = {.count = 1, .reusable = false}, SHIFT(2457),
  [3251] = {.count = 1, .reusable = true}, SHIFT(891),
  [3253] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 25),
  [3255] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 25),
  [3257] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3259] = {.count = 1, .reusable = false}, SHIFT(255),
  [3261] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3263] = {.count = 1, .reusable = false}, SHIFT(1069),
  [3265] = {.count = 1, .reusable = false}, SHIFT(2349),
  [3267] = {.count = 1, .reusable = true}, SHIFT(954),
  [3269] = {.count = 1, .reusable = true}, SHIFT(707),
  [3271] = {.count = 1, .reusable = true}, SHIFT(710),
  [3273] = {.count = 1, .reusable = false}, SHIFT(340),
  [3275] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3278] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3281] = {.count = 1, .reusable = true}, SHIFT(2763),
  [3283] = {.count = 1, .reusable = true}, SHIFT(237),
  [3285] = {.count = 1, .reusable = true}, SHIFT(245),
  [3287] = {.count = 1, .reusable = false}, SHIFT(1783),
  [3289] = {.count = 1, .reusable = false}, SHIFT(889),
  [3291] = {.count = 1, .reusable = true}, SHIFT(721),
  [3293] = {.count = 1, .reusable = true}, SHIFT(1544),
  [3295] = {.count = 1, .reusable = false}, SHIFT(437),
  [3297] = {.count = 1, .reusable = false}, SHIFT(426),
  [3299] = {.count = 1, .reusable = true}, SHIFT(1482),
  [3301] = {.count = 1, .reusable = true}, SHIFT(1541),
  [3303] = {.count = 1, .reusable = true}, SHIFT(1362),
  [3305] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3307] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 56),
  [3310] = {.count = 2, .reusable = false}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 56),
  [3313] = {.count = 1, .reusable = true}, SHIFT(1093),
  [3315] = {.count = 1, .reusable = true}, SHIFT(1102),
  [3317] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 3),
  [3319] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 3),
  [3321] = {.count = 1, .reusable = true}, SHIFT(439),
  [3323] = {.count = 1, .reusable = true}, SHIFT(1075),
  [3325] = {.count = 1, .reusable = false}, SHIFT(257),
  [3327] = {.count = 1, .reusable = true}, SHIFT(2829),
  [3329] = {.count = 1, .reusable = false}, SHIFT(1790),
  [3331] = {.count = 1, .reusable = true}, SHIFT(1834),
  [3333] = {.count = 2, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 56), REDUCE(sym_nested_type_identifier, 3, .production_id = 88),
  [3336] = {.count = 2, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 56), REDUCE(sym_nested_type_identifier, 3, .production_id = 88),
  [3339] = {.count = 1, .reusable = true}, SHIFT(420),
  [3341] = {.count = 1, .reusable = true}, SHIFT(1547),
  [3343] = {.count = 1, .reusable = true}, SHIFT(1849),
  [3345] = {.count = 1, .reusable = true}, SHIFT(416),
  [3347] = {.count = 1, .reusable = true}, SHIFT(1844),
  [3349] = {.count = 1, .reusable = false}, SHIFT(1786),
  [3351] = {.count = 1, .reusable = false}, SHIFT(885),
  [3353] = {.count = 1, .reusable = false}, SHIFT(2705),
  [3355] = {.count = 1, .reusable = true}, SHIFT(451),
  [3357] = {.count = 1, .reusable = true}, SHIFT(756),
  [3359] = {.count = 1, .reusable = false}, SHIFT(2280),
  [3361] = {.count = 1, .reusable = true}, SHIFT(2780),
  [3363] = {.count = 1, .reusable = false}, SHIFT(1863),
  [3365] = {.count = 1, .reusable = true}, SHIFT(1856),
  [3367] = {.count = 1, .reusable = false}, SHIFT(1870),
  [3369] = {.count = 1, .reusable = false}, SHIFT(1856),
  [3371] = {.count = 1, .reusable = false}, SHIFT(446),
  [3373] = {.count = 1, .reusable = false}, SHIFT(2360),
  [3375] = {.count = 1, .reusable = true}, SHIFT(975),
  [3377] = {.count = 1, .reusable = true}, SHIFT(720),
  [3379] = {.count = 1, .reusable = true}, SHIFT(719),
  [3381] = {.count = 1, .reusable = false}, SHIFT(349),
  [3383] = {.count = 1, .reusable = true}, SHIFT(2916),
  [3385] = {.count = 1, .reusable = true}, SHIFT(173),
  [3387] = {.count = 1, .reusable = true}, SHIFT(343),
  [3389] = {.count = 1, .reusable = false}, SHIFT(392),
  [3391] = {.count = 1, .reusable = true}, SHIFT(225),
  [3393] = {.count = 1, .reusable = true}, SHIFT(393),
  [3395] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1), SHIFT(325),
  [3398] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [3401] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3405] = {.count = 1, .reusable = true}, SHIFT(2918),
  [3407] = {.count = 1, .reusable = false}, SHIFT(342),
  [3409] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2, .production_id = 47),
  [3411] = {.count = 1, .reusable = true}, SHIFT(155),
  [3413] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(723),
  [3416] = {.count = 1, .reusable = true}, SHIFT(2923),
  [3418] = {.count = 1, .reusable = true}, SHIFT(183),
  [3420] = {.count = 1, .reusable = true}, SHIFT(323),
  [3422] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2, .production_id = 47),
  [3424] = {.count = 1, .reusable = true}, SHIFT(2938),
  [3426] = {.count = 1, .reusable = true}, SHIFT(157),
  [3428] = {.count = 1, .reusable = true}, SHIFT(2797),
  [3430] = {.count = 1, .reusable = true}, SHIFT(2917),
  [3432] = {.count = 1, .reusable = true}, SHIFT(2795),
  [3434] = {.count = 1, .reusable = true}, SHIFT(2906),
  [3436] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(192),
  [3439] = {.count = 1, .reusable = true}, SHIFT(192),
  [3441] = {.count = 1, .reusable = true}, SHIFT(190),
  [3443] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 47),
  [3445] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 47),
  [3447] = {.count = 1, .reusable = true}, SHIFT(2864),
  [3449] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2),
  [3452] = {.count = 1, .reusable = true}, SHIFT(729),
  [3454] = {.count = 1, .reusable = true}, SHIFT(2858),
  [3456] = {.count = 1, .reusable = true}, SHIFT(544),
  [3458] = {.count = 1, .reusable = true}, SHIFT(2768),
  [3460] = {.count = 1, .reusable = true}, SHIFT(2201),
  [3462] = {.count = 1, .reusable = false}, SHIFT(704),
  [3464] = {.count = 1, .reusable = true}, SHIFT(1951),
  [3466] = {.count = 1, .reusable = true}, SHIFT(2915),
  [3468] = {.count = 1, .reusable = true}, SHIFT(2921),
  [3470] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1),
  [3472] = {.count = 1, .reusable = true}, SHIFT(2871),
  [3474] = {.count = 1, .reusable = true}, SHIFT(2935),
  [3476] = {.count = 1, .reusable = true}, SHIFT(2823),
  [3478] = {.count = 1, .reusable = true}, SHIFT(2573),
  [3480] = {.count = 1, .reusable = true}, SHIFT(246),
  [3482] = {.count = 1, .reusable = true}, SHIFT(261),
  [3484] = {.count = 1, .reusable = false}, SHIFT(2877),
  [3486] = {.count = 1, .reusable = true}, SHIFT(2023),
  [3488] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7),
  [3490] = {.count = 1, .reusable = true}, SHIFT(2940),
  [3492] = {.count = 1, .reusable = true}, SHIFT(2941),
  [3494] = {.count = 1, .reusable = true}, SHIFT(2014),
  [3496] = {.count = 1, .reusable = true}, SHIFT(2009),
  [3498] = {.count = 1, .reusable = true}, SHIFT(1969),
  [3500] = {.count = 1, .reusable = true}, SHIFT(2770),
  [3502] = {.count = 1, .reusable = true}, SHIFT(2942),
  [3504] = {.count = 1, .reusable = true}, SHIFT(2572),
  [3506] = {.count = 1, .reusable = true}, SHIFT(2870),
  [3508] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3510] = {.count = 1, .reusable = true}, SHIFT(2027),
  [3512] = {.count = 1, .reusable = true}, SHIFT(2887),
  [3514] = {.count = 1, .reusable = true}, SHIFT(2880),
  [3516] = {.count = 1, .reusable = false}, SHIFT(1828),
  [3518] = {.count = 1, .reusable = false}, SHIFT(897),
  [3520] = {.count = 1, .reusable = true}, SHIFT(1766),
  [3522] = {.count = 1, .reusable = true}, SHIFT(209),
  [3524] = {.count = 1, .reusable = false}, SHIFT(1499),
  [3526] = {.count = 1, .reusable = true}, SHIFT(1796),
  [3528] = {.count = 1, .reusable = false}, SHIFT(1452),
  [3530] = {.count = 1, .reusable = false}, SHIFT(1634),
  [3532] = {.count = 1, .reusable = false}, SHIFT(1451),
  [3534] = {.count = 1, .reusable = false}, SHIFT(1747),
  [3536] = {.count = 1, .reusable = true}, SHIFT(200),
  [3538] = {.count = 1, .reusable = true}, SHIFT(917),
  [3540] = {.count = 1, .reusable = true}, SHIFT(1060),
  [3542] = {.count = 1, .reusable = true}, SHIFT(921),
  [3544] = {.count = 1, .reusable = true}, SHIFT(1243),
  [3546] = {.count = 1, .reusable = true}, SHIFT(920),
  [3548] = {.count = 1, .reusable = true}, SHIFT(1568),
  [3550] = {.count = 1, .reusable = true}, SHIFT(2922),
  [3552] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 28),
  [3555] = {.count = 1, .reusable = false}, SHIFT(2410),
  [3557] = {.count = 1, .reusable = false}, SHIFT(2817),
  [3559] = {.count = 1, .reusable = false}, REDUCE(sym_import, 1),
  [3561] = {.count = 1, .reusable = true}, SHIFT(2015),
  [3563] = {.count = 1, .reusable = true}, REDUCE(sym_import, 1),
  [3565] = {.count = 1, .reusable = false}, SHIFT(1843),
  [3567] = {.count = 1, .reusable = true}, SHIFT(431),
  [3569] = {.count = 1, .reusable = true}, SHIFT(1851),
  [3571] = {.count = 1, .reusable = true}, SHIFT(434),
  [3573] = {.count = 1, .reusable = true}, SHIFT(1065),
  [3575] = {.count = 1, .reusable = true}, SHIFT(1862),
  [3577] = {.count = 1, .reusable = true}, SHIFT(1328),
  [3579] = {.count = 1, .reusable = true}, SHIFT(1068),
  [3581] = {.count = 1, .reusable = true}, SHIFT(1303),
  [3583] = {.count = 1, .reusable = true}, SHIFT(1860),
  [3585] = {.count = 1, .reusable = true}, SHIFT(1081),
  [3587] = {.count = 1, .reusable = true}, SHIFT(1538),
  [3589] = {.count = 1, .reusable = true}, SHIFT(1539),
  [3591] = {.count = 1, .reusable = true}, SHIFT(425),
  [3593] = {.count = 1, .reusable = true}, SHIFT(1334),
  [3595] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3597] = {.count = 1, .reusable = false}, REDUCE(sym_type_assertion, 2),
  [3599] = {.count = 1, .reusable = true}, REDUCE(sym_type_assertion, 2),
  [3601] = {.count = 1, .reusable = false}, SHIFT(743),
  [3603] = {.count = 1, .reusable = true}, SHIFT(178),
  [3605] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 4),
  [3607] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 4),
  [3609] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 2),
  [3611] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 2),
  [3613] = {.count = 1, .reusable = false}, SHIFT(267),
  [3615] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3),
  [3617] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3),
  [3619] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3, .production_id = 28),
  [3621] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3, .production_id = 28),
  [3623] = {.count = 1, .reusable = true}, SHIFT(1059),
  [3625] = {.count = 1, .reusable = false}, SHIFT(268),
  [3627] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [3629] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [3631] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [3633] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [3635] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4, .production_id = 28),
  [3637] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4, .production_id = 28),
  [3639] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4),
  [3641] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4),
  [3643] = {.count = 1, .reusable = false}, REDUCE(sym_array, 4),
  [3645] = {.count = 1, .reusable = true}, REDUCE(sym_array, 4),
  [3647] = {.count = 1, .reusable = false}, SHIFT(280),
  [3649] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 10),
  [3651] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(208),
  [3654] = {.count = 1, .reusable = true}, SHIFT(208),
  [3656] = {.count = 1, .reusable = false}, SHIFT(315),
  [3658] = {.count = 1, .reusable = true}, SHIFT(655),
  [3660] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 26),
  [3662] = {.count = 1, .reusable = false}, SHIFT(296),
  [3664] = {.count = 1, .reusable = false}, SHIFT(93),
  [3666] = {.count = 1, .reusable = true}, SHIFT(337),
  [3668] = {.count = 1, .reusable = true}, SHIFT(287),
  [3670] = {.count = 1, .reusable = true}, SHIFT(269),
  [3672] = {.count = 1, .reusable = true}, SHIFT(315),
  [3674] = {.count = 1, .reusable = false}, SHIFT(287),
  [3676] = {.count = 1, .reusable = false}, SHIFT(269),
  [3678] = {.count = 1, .reusable = false}, SHIFT(266),
  [3680] = {.count = 1, .reusable = true}, SHIFT(264),
  [3682] = {.count = 1, .reusable = true}, SHIFT(296),
  [3684] = {.count = 1, .reusable = false}, SHIFT(1009),
  [3686] = {.count = 1, .reusable = true}, SHIFT(1008),
  [3688] = {.count = 1, .reusable = true}, REDUCE(sym_await_expression, 2),
  [3690] = {.count = 1, .reusable = true}, SHIFT(24),
  [3692] = {.count = 1, .reusable = true}, SHIFT(2845),
  [3694] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 2),
  [3696] = {.count = 1, .reusable = false}, SHIFT(285),
  [3698] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 9),
  [3700] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(233),
  [3703] = {.count = 1, .reusable = true}, SHIFT(233),
  [3705] = {.count = 1, .reusable = true}, SHIFT(706),
  [3707] = {.count = 1, .reusable = false}, SHIFT(1078),
  [3709] = {.count = 1, .reusable = true}, SHIFT(138),
  [3711] = {.count = 1, .reusable = true}, SHIFT(671),
  [3713] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 64),
  [3715] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 93),
  [3717] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 63),
  [3719] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [3721] = {.count = 1, .reusable = true}, SHIFT(727),
  [3723] = {.count = 1, .reusable = false}, SHIFT(1565),
  [3725] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 2),
  [3727] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 95),
  [3729] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61),
  [3731] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3, .production_id = 61),
  [3733] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(93),
  [3736] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3738] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3740] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 96),
  [3742] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [3744] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 23),
  [3746] = {.count = 1, .reusable = true}, SHIFT(794),
  [3748] = {.count = 1, .reusable = false}, SHIFT(428),
  [3750] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3752] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3754] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(93),
  [3757] = {.count = 1, .reusable = true}, SHIFT(842),
  [3759] = {.count = 1, .reusable = true}, SHIFT(184),
  [3761] = {.count = 1, .reusable = true}, REDUCE(sym_sequence_expression, 3, .production_id = 55),
  [3763] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 55),
  [3765] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 57),
  [3767] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 55),
  [3769] = {.count = 1, .reusable = true}, REDUCE(sym_ternary_expression, 5, .production_id = 125),
  [3771] = {.count = 1, .reusable = true}, SHIFT(878),
  [3773] = {.count = 1, .reusable = true}, SHIFT(1132),
  [3775] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 3),
  [3777] = {.count = 1, .reusable = true}, SHIFT(700),
  [3779] = {.count = 1, .reusable = false}, SHIFT(1864),
  [3781] = {.count = 1, .reusable = true}, SHIFT(690),
  [3783] = {.count = 1, .reusable = false}, SHIFT(1377),
  [3785] = {.count = 1, .reusable = true}, SHIFT(23),
  [3787] = {.count = 1, .reusable = true}, SHIFT(2850),
  [3789] = {.count = 1, .reusable = false}, SHIFT(321),
  [3791] = {.count = 1, .reusable = true}, SHIFT(649),
  [3793] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2),
  [3795] = {.count = 1, .reusable = false}, SHIFT(320),
  [3797] = {.count = 1, .reusable = true}, SHIFT(171),
  [3799] = {.count = 1, .reusable = false}, SHIFT(92),
  [3801] = {.count = 1, .reusable = true}, SHIFT(361),
  [3803] = {.count = 1, .reusable = true}, SHIFT(313),
  [3805] = {.count = 1, .reusable = true}, SHIFT(311),
  [3807] = {.count = 1, .reusable = true}, SHIFT(321),
  [3809] = {.count = 1, .reusable = false}, SHIFT(313),
  [3811] = {.count = 1, .reusable = false}, SHIFT(311),
  [3813] = {.count = 1, .reusable = false}, SHIFT(303),
  [3815] = {.count = 1, .reusable = true}, SHIFT(289),
  [3817] = {.count = 1, .reusable = true}, SHIFT(320),
  [3819] = {.count = 1, .reusable = false}, SHIFT(1504),
  [3821] = {.count = 1, .reusable = true}, SHIFT(1502),
  [3823] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2),
  [3825] = {.count = 1, .reusable = false}, SHIFT(270),
  [3827] = {.count = 1, .reusable = true}, SHIFT(650),
  [3829] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 62), REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [3832] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 62),
  [3834] = {.count = 1, .reusable = false}, SHIFT(273),
  [3836] = {.count = 1, .reusable = true}, SHIFT(226),
  [3838] = {.count = 1, .reusable = false}, SHIFT(94),
  [3840] = {.count = 1, .reusable = true}, SHIFT(275),
  [3842] = {.count = 1, .reusable = true}, SHIFT(276),
  [3844] = {.count = 1, .reusable = true}, SHIFT(277),
  [3846] = {.count = 1, .reusable = true}, SHIFT(270),
  [3848] = {.count = 1, .reusable = false}, SHIFT(276),
  [3850] = {.count = 1, .reusable = false}, SHIFT(277),
  [3852] = {.count = 1, .reusable = false}, SHIFT(278),
  [3854] = {.count = 1, .reusable = true}, SHIFT(279),
  [3856] = {.count = 1, .reusable = true}, SHIFT(273),
  [3858] = {.count = 1, .reusable = false}, SHIFT(1479),
  [3860] = {.count = 1, .reusable = true}, SHIFT(1478),
  [3862] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 72), REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [3865] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 72),
  [3867] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 26),
  [3869] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 72), REDUCE(sym_assignment_expression, 3, .production_id = 55),
  [3872] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(94),
  [3875] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [3877] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [3879] = {.count = 1, .reusable = false}, REDUCE(sym_non_null_expression, 2),
  [3881] = {.count = 1, .reusable = true}, REDUCE(sym_non_null_expression, 2),
  [3883] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2, .production_id = 17),
  [3885] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2, .production_id = 17),
  [3887] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 2),
  [3889] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 2),
  [3891] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(94),
  [3894] = {.count = 1, .reusable = true}, SHIFT(998),
  [3896] = {.count = 1, .reusable = true}, SHIFT(596),
  [3898] = {.count = 1, .reusable = false}, SHIFT(1900),
  [3900] = {.count = 1, .reusable = true}, SHIFT(939),
  [3902] = {.count = 1, .reusable = true}, SHIFT(139),
  [3904] = {.count = 1, .reusable = false}, SHIFT(1646),
  [3906] = {.count = 1, .reusable = true}, SHIFT(1980),
  [3908] = {.count = 1, .reusable = false}, SHIFT(1528),
  [3910] = {.count = 1, .reusable = false}, SHIFT(1667),
  [3912] = {.count = 1, .reusable = false}, SHIFT(1677),
  [3914] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 50),
  [3916] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 50),
  [3918] = {.count = 1, .reusable = false}, REDUCE(sym_class, 2, .production_id = 13),
  [3920] = {.count = 1, .reusable = true}, REDUCE(sym_class, 2, .production_id = 13),
  [3922] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 51),
  [3924] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 51),
  [3926] = {.count = 1, .reusable = false}, SHIFT(395),
  [3928] = {.count = 1, .reusable = true}, SHIFT(644),
  [3930] = {.count = 1, .reusable = false}, SHIFT(396),
  [3932] = {.count = 1, .reusable = false}, SHIFT(98),
  [3934] = {.count = 1, .reusable = true}, SHIFT(376),
  [3936] = {.count = 1, .reusable = true}, SHIFT(398),
  [3938] = {.count = 1, .reusable = true}, SHIFT(400),
  [3940] = {.count = 1, .reusable = true}, SHIFT(395),
  [3942] = {.count = 1, .reusable = false}, SHIFT(398),
  [3944] = {.count = 1, .reusable = false}, SHIFT(400),
  [3946] = {.count = 1, .reusable = false}, SHIFT(404),
  [3948] = {.count = 1, .reusable = true}, SHIFT(406),
  [3950] = {.count = 1, .reusable = true}, SHIFT(396),
  [3952] = {.count = 1, .reusable = false}, REDUCE(sym_function, 3, .production_id = 52),
  [3954] = {.count = 1, .reusable = true}, REDUCE(sym_function, 3, .production_id = 52),
  [3956] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 63), REDUCE(sym_assignment_expression, 3, .production_id = 63),
  [3959] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 63),
  [3961] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 53),
  [3963] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 53),
  [3965] = {.count = 1, .reusable = true}, SHIFT(875),
  [3967] = {.count = 1, .reusable = false}, REDUCE(sym_meta_property, 3),
  [3969] = {.count = 1, .reusable = true}, REDUCE(sym_meta_property, 3),
  [3971] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 54),
  [3973] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 54),
  [3975] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 3),
  [3977] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 3),
  [3979] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 57),
  [3981] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 3, .production_id = 58),
  [3983] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 3, .production_id = 58),
  [3985] = {.count = 1, .reusable = false}, REDUCE(sym_as_expression, 3),
  [3987] = {.count = 1, .reusable = true}, REDUCE(sym_as_expression, 3),
  [3989] = {.count = 1, .reusable = true}, SHIFT(669),
  [3991] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3994] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3997] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [4000] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [4003] = {.count = 1, .reusable = true}, REDUCE(sym_spread_element, 2),
  [4005] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 64),
  [4007] = {.count = 1, .reusable = false}, SHIFT(1907),
  [4009] = {.count = 1, .reusable = true}, SHIFT(1040),
  [4011] = {.count = 1, .reusable = false}, SHIFT(1625),
  [4013] = {.count = 1, .reusable = false}, SHIFT(1608),
  [4015] = {.count = 1, .reusable = false}, SHIFT(1660),
  [4017] = {.count = 1, .reusable = false}, SHIFT(1671),
  [4019] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(723),
  [4022] = {.count = 1, .reusable = true}, SHIFT(2856),
  [4024] = {.count = 1, .reusable = true}, SHIFT(740),
  [4026] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 4, .production_id = 89),
  [4028] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 4, .production_id = 89),
  [4030] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 92),
  [4032] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 92),
  [4034] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 93),
  [4036] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 94),
  [4038] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 94),
  [4040] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 95),
  [4042] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 96),
  [4044] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 4, .production_id = 94),
  [4046] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 4, .production_id = 94),
  [4048] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 102),
  [4050] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 102),
  [4052] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 103),
  [4054] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 103),
  [4056] = {.count = 1, .reusable = true}, SHIFT(813),
  [4058] = {.count = 1, .reusable = true}, SHIFT(658),
  [4060] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 88),
  [4063] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 120),
  [4065] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 120),
  [4067] = {.count = 1, .reusable = false}, SHIFT(1901),
  [4069] = {.count = 1, .reusable = true}, SHIFT(1448),
  [4071] = {.count = 1, .reusable = false}, SHIFT(1655),
  [4073] = {.count = 1, .reusable = false}, SHIFT(1497),
  [4075] = {.count = 1, .reusable = false}, SHIFT(1664),
  [4077] = {.count = 1, .reusable = false}, SHIFT(1669),
  [4079] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 129),
  [4081] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 129),
  [4083] = {.count = 1, .reusable = true}, SHIFT(1771),
  [4085] = {.count = 1, .reusable = true}, SHIFT(556),
  [4087] = {.count = 1, .reusable = false}, SHIFT(1573),
  [4089] = {.count = 1, .reusable = true}, SHIFT(1787),
  [4091] = {.count = 1, .reusable = false}, SHIFT(1440),
  [4093] = {.count = 1, .reusable = false}, SHIFT(1725),
  [4095] = {.count = 1, .reusable = false}, SHIFT(1629),
  [4097] = {.count = 1, .reusable = false}, SHIFT(1740),
  [4099] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 63),
  [4101] = {.count = 1, .reusable = true}, SHIFT(1769),
  [4103] = {.count = 1, .reusable = true}, SHIFT(346),
  [4105] = {.count = 1, .reusable = true}, SHIFT(327),
  [4107] = {.count = 1, .reusable = false}, SHIFT(1582),
  [4109] = {.count = 1, .reusable = true}, SHIFT(1797),
  [4111] = {.count = 1, .reusable = false}, SHIFT(1649),
  [4113] = {.count = 1, .reusable = false}, SHIFT(1752),
  [4115] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3, .production_id = 48),
  [4117] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3, .production_id = 48),
  [4119] = {.count = 1, .reusable = false}, SHIFT(1076),
  [4121] = {.count = 1, .reusable = true}, SHIFT(1586),
  [4123] = {.count = 1, .reusable = false}, REDUCE(sym_ternary_expression, 5, .production_id = 125),
  [4125] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(715),
  [4128] = {.count = 1, .reusable = true}, SHIFT(2908),
  [4130] = {.count = 1, .reusable = true}, SHIFT(787),
  [4132] = {.count = 1, .reusable = true}, SHIFT(931),
  [4134] = {.count = 1, .reusable = true}, SHIFT(1070),
  [4136] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [4138] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [4140] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [4142] = {.count = 1, .reusable = true}, SHIFT(946),
  [4144] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(98),
  [4147] = {.count = 1, .reusable = true}, REDUCE(sym__initializer, 2, .production_id = 76),
  [4149] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(92),
  [4152] = {.count = 1, .reusable = true}, SHIFT(488),
  [4154] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2),
  [4156] = {.count = 1, .reusable = true}, SHIFT(1444),
  [4158] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 55),
  [4160] = {.count = 1, .reusable = true}, SHIFT(117),
  [4162] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(98),
  [4165] = {.count = 1, .reusable = true}, SHIFT(1866),
  [4167] = {.count = 1, .reusable = true}, SHIFT(2225),
  [4169] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 55),
  [4171] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(92),
  [4174] = {.count = 1, .reusable = false}, REDUCE(sym_await_expression, 2),
  [4176] = {.count = 1, .reusable = true}, SHIFT(1031),
  [4178] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 2),
  [4180] = {.count = 1, .reusable = true}, SHIFT(937),
  [4182] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 3),
  [4184] = {.count = 1, .reusable = true}, SHIFT(942),
  [4186] = {.count = 1, .reusable = true}, SHIFT(480),
  [4188] = {.count = 1, .reusable = true}, SHIFT(548),
  [4190] = {.count = 1, .reusable = true}, SHIFT(1535),
  [4192] = {.count = 1, .reusable = true}, SHIFT(207),
  [4194] = {.count = 1, .reusable = true}, SHIFT(1522),
  [4196] = {.count = 1, .reusable = true}, SHIFT(497),
  [4198] = {.count = 1, .reusable = true}, SHIFT(514),
  [4200] = {.count = 1, .reusable = true}, SHIFT(513),
  [4202] = {.count = 1, .reusable = true}, SHIFT(1397),
  [4204] = {.count = 1, .reusable = true}, SHIFT(1072),
  [4206] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 23),
  [4208] = {.count = 1, .reusable = true}, SHIFT(1318),
  [4210] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1828),
  [4213] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1771),
  [4216] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4218] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(209),
  [4221] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1573),
  [4224] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2299),
  [4227] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2296),
  [4230] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1787),
  [4233] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1781),
  [4236] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1440),
  [4239] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1725),
  [4242] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1629),
  [4245] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1451),
  [4248] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1740),
  [4251] = {.count = 1, .reusable = true}, SHIFT(1003),
  [4253] = {.count = 1, .reusable = true}, SHIFT(1683),
  [4255] = {.count = 1, .reusable = false}, SHIFT(258),
  [4257] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(723),
  [4260] = {.count = 1, .reusable = false}, SHIFT(259),
  [4262] = {.count = 1, .reusable = true}, SHIFT(120),
  [4264] = {.count = 1, .reusable = false}, SHIFT(1919),
  [4266] = {.count = 1, .reusable = false}, SHIFT(1661),
  [4268] = {.count = 1, .reusable = false}, SHIFT(1637),
  [4270] = {.count = 1, .reusable = false}, SHIFT(1672),
  [4272] = {.count = 1, .reusable = false}, SHIFT(1684),
  [4274] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [4276] = {.count = 1, .reusable = true}, SHIFT(598),
  [4278] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(726),
  [4281] = {.count = 1, .reusable = true}, SHIFT(701),
  [4283] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(96),
  [4286] = {.count = 1, .reusable = false}, SHIFT(252),
  [4288] = {.count = 1, .reusable = false}, SHIFT(250),
  [4290] = {.count = 1, .reusable = false}, SHIFT(96),
  [4292] = {.count = 1, .reusable = true}, SHIFT(252),
  [4294] = {.count = 1, .reusable = false}, SHIFT(247),
  [4296] = {.count = 1, .reusable = true}, SHIFT(374),
  [4298] = {.count = 1, .reusable = true}, SHIFT(250),
  [4300] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(96),
  [4303] = {.count = 1, .reusable = false}, SHIFT(341),
  [4305] = {.count = 1, .reusable = false}, SHIFT(338),
  [4307] = {.count = 1, .reusable = false}, SHIFT(91),
  [4309] = {.count = 1, .reusable = true}, SHIFT(251),
  [4311] = {.count = 1, .reusable = true}, SHIFT(336),
  [4313] = {.count = 1, .reusable = true}, SHIFT(335),
  [4315] = {.count = 1, .reusable = true}, SHIFT(341),
  [4317] = {.count = 1, .reusable = false}, SHIFT(336),
  [4319] = {.count = 1, .reusable = false}, SHIFT(335),
  [4321] = {.count = 1, .reusable = false}, SHIFT(332),
  [4323] = {.count = 1, .reusable = true}, SHIFT(331),
  [4325] = {.count = 1, .reusable = true}, SHIFT(338),
  [4327] = {.count = 1, .reusable = true}, SHIFT(363),
  [4329] = {.count = 1, .reusable = true}, SHIFT(249),
  [4331] = {.count = 1, .reusable = true}, SHIFT(248),
  [4333] = {.count = 1, .reusable = false}, SHIFT(249),
  [4335] = {.count = 1, .reusable = false}, SHIFT(248),
  [4337] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(91),
  [4340] = {.count = 1, .reusable = true}, SHIFT(1512),
  [4342] = {.count = 1, .reusable = true}, SHIFT(2927),
  [4344] = {.count = 1, .reusable = true}, SHIFT(791),
  [4346] = {.count = 1, .reusable = true}, SHIFT(877),
  [4348] = {.count = 1, .reusable = true}, SHIFT(566),
  [4350] = {.count = 1, .reusable = true}, SHIFT(600),
  [4352] = {.count = 1, .reusable = false}, SHIFT(747),
  [4354] = {.count = 1, .reusable = false}, SHIFT(748),
  [4356] = {.count = 1, .reusable = false}, SHIFT(283),
  [4358] = {.count = 1, .reusable = false}, SHIFT(282),
  [4360] = {.count = 1, .reusable = true}, SHIFT(595),
  [4362] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(210),
  [4365] = {.count = 1, .reusable = true}, SHIFT(210),
  [4367] = {.count = 1, .reusable = true}, SHIFT(599),
  [4369] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(213),
  [4372] = {.count = 1, .reusable = true}, SHIFT(213),
  [4374] = {.count = 1, .reusable = true}, SHIFT(322),
  [4376] = {.count = 1, .reusable = true}, SHIFT(2041),
  [4378] = {.count = 1, .reusable = false}, SHIFT(1717),
  [4380] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(715),
  [4383] = {.count = 1, .reusable = true}, SHIFT(603),
  [4385] = {.count = 1, .reusable = true}, SHIFT(604),
  [4387] = {.count = 1, .reusable = true}, SHIFT(42),
  [4389] = {.count = 1, .reusable = true}, SHIFT(543),
  [4391] = {.count = 1, .reusable = true}, SHIFT(821),
  [4393] = {.count = 1, .reusable = true}, SHIFT(602),
  [4395] = {.count = 1, .reusable = true}, SHIFT(2181),
  [4397] = {.count = 1, .reusable = true}, SHIFT(597),
  [4399] = {.count = 1, .reusable = true}, SHIFT(2203),
  [4401] = {.count = 1, .reusable = true}, SHIFT(11),
  [4403] = {.count = 2, .reusable = true}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4406] = {.count = 1, .reusable = true}, REDUCE(sym_computed_property_name, 3),
  [4408] = {.count = 2, .reusable = false}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4411] = {.count = 1, .reusable = true}, SHIFT(47),
  [4413] = {.count = 1, .reusable = false}, SHIFT(1369),
  [4415] = {.count = 1, .reusable = true}, SHIFT(647),
  [4417] = {.count = 1, .reusable = true}, SHIFT(2295),
  [4419] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(91),
  [4422] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .production_id = 73),
  [4424] = {.count = 1, .reusable = true}, SHIFT(1825),
  [4426] = {.count = 1, .reusable = true}, SHIFT(1761),
  [4428] = {.count = 1, .reusable = false}, SHIFT(1606),
  [4430] = {.count = 1, .reusable = true}, SHIFT(1798),
  [4432] = {.count = 1, .reusable = false}, SHIFT(1644),
  [4434] = {.count = 1, .reusable = false}, SHIFT(1748),
  [4436] = {.count = 1, .reusable = true}, SHIFT(666),
  [4438] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4440] = {.count = 1, .reusable = true}, SHIFT(1757),
  [4442] = {.count = 1, .reusable = false}, SHIFT(1584),
  [4444] = {.count = 1, .reusable = true}, SHIFT(1788),
  [4446] = {.count = 1, .reusable = false}, SHIFT(1640),
  [4448] = {.count = 1, .reusable = false}, SHIFT(1751),
  [4450] = {.count = 1, .reusable = false}, SHIFT(402),
  [4452] = {.count = 1, .reusable = false}, SHIFT(405),
  [4454] = {.count = 1, .reusable = true}, SHIFT(1508),
  [4456] = {.count = 1, .reusable = false}, REDUCE(sym__parameter_name, 1),
  [4458] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [4462] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 12), SHIFT(258),
  [4465] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4468] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4470] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 11), SHIFT(259),
  [4473] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [4476] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 11),
  [4478] = {.count = 1, .reusable = false}, SHIFT(1595),
  [4480] = {.count = 1, .reusable = false}, SHIFT(16),
  [4482] = {.count = 1, .reusable = true}, SHIFT(2929),
  [4484] = {.count = 1, .reusable = true}, SHIFT(314),
  [4486] = {.count = 1, .reusable = true}, SHIFT(300),
  [4488] = {.count = 1, .reusable = true}, SHIFT(263),
  [4490] = {.count = 1, .reusable = true}, SHIFT(1775),
  [4492] = {.count = 1, .reusable = false}, SHIFT(1580),
  [4494] = {.count = 1, .reusable = true}, SHIFT(1801),
  [4496] = {.count = 1, .reusable = false}, SHIFT(1650),
  [4498] = {.count = 1, .reusable = false}, SHIFT(1742),
  [4500] = {.count = 1, .reusable = true}, SHIFT(397),
  [4502] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [4505] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1),
  [4507] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [4510] = {.count = 1, .reusable = true}, SHIFT(1756),
  [4512] = {.count = 1, .reusable = false}, SHIFT(1555),
  [4514] = {.count = 1, .reusable = true}, SHIFT(1789),
  [4516] = {.count = 1, .reusable = false}, SHIFT(1638),
  [4518] = {.count = 1, .reusable = false}, SHIFT(1743),
  [4520] = {.count = 1, .reusable = false}, SHIFT(344),
  [4522] = {.count = 1, .reusable = false}, SHIFT(347),
  [4524] = {.count = 1, .reusable = true}, SHIFT(1773),
  [4526] = {.count = 1, .reusable = false}, SHIFT(1498),
  [4528] = {.count = 1, .reusable = true}, SHIFT(1802),
  [4530] = {.count = 1, .reusable = false}, SHIFT(1624),
  [4532] = {.count = 1, .reusable = false}, SHIFT(1749),
  [4534] = {.count = 1, .reusable = false}, SHIFT(281),
  [4536] = {.count = 1, .reusable = false}, SHIFT(284),
  [4538] = {.count = 1, .reusable = false}, SHIFT(709),
  [4540] = {.count = 1, .reusable = false}, SHIFT(691),
  [4542] = {.count = 1, .reusable = true}, SHIFT(403),
  [4544] = {.count = 1, .reusable = true}, SHIFT(274),
  [4546] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(726),
  [4549] = {.count = 1, .reusable = false}, SHIFT(703),
  [4551] = {.count = 1, .reusable = false}, SHIFT(708),
  [4553] = {.count = 1, .reusable = true}, SHIFT(1772),
  [4555] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4557] = {.count = 1, .reusable = false}, SHIFT(1719),
  [4559] = {.count = 1, .reusable = true}, SHIFT(2054),
  [4561] = {.count = 1, .reusable = false}, SHIFT(1710),
  [4563] = {.count = 1, .reusable = false}, SHIFT(789),
  [4565] = {.count = 1, .reusable = false}, SHIFT(788),
  [4567] = {.count = 1, .reusable = true}, SHIFT(2045),
  [4569] = {.count = 1, .reusable = false}, SHIFT(1722),
  [4571] = {.count = 1, .reusable = true}, SHIFT(1767),
  [4573] = {.count = 1, .reusable = true}, SHIFT(2037),
  [4575] = {.count = 1, .reusable = false}, SHIFT(1718),
  [4577] = {.count = 1, .reusable = true}, SHIFT(661),
  [4579] = {.count = 1, .reusable = true}, SHIFT(2002),
  [4581] = {.count = 1, .reusable = false}, SHIFT(1723),
  [4583] = {.count = 1, .reusable = true}, SHIFT(1776),
  [4585] = {.count = 1, .reusable = true}, SHIFT(2067),
  [4587] = {.count = 1, .reusable = false}, SHIFT(1709),
  [4589] = {.count = 1, .reusable = true}, SHIFT(1777),
  [4591] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4593] = {.count = 1, .reusable = false}, SHIFT(1712),
  [4595] = {.count = 1, .reusable = true}, SHIFT(2036),
  [4597] = {.count = 1, .reusable = false}, SHIFT(1713),
  [4599] = {.count = 1, .reusable = true}, SHIFT(1765),
  [4601] = {.count = 1, .reusable = true}, SHIFT(1998),
  [4603] = {.count = 1, .reusable = false}, SHIFT(1720),
  [4605] = {.count = 1, .reusable = false}, SHIFT(329),
  [4607] = {.count = 1, .reusable = false}, SHIFT(330),
  [4609] = {.count = 1, .reusable = true}, SHIFT(1770),
  [4611] = {.count = 1, .reusable = true}, SHIFT(2049),
  [4613] = {.count = 1, .reusable = false}, SHIFT(1714),
  [4615] = {.count = 1, .reusable = true}, SHIFT(1763),
  [4617] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4619] = {.count = 1, .reusable = false}, SHIFT(1721),
  [4621] = {.count = 1, .reusable = false}, SHIFT(1975),
  [4623] = {.count = 1, .reusable = true}, SHIFT(2491),
  [4625] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2, .production_id = 18),
  [4627] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2, .production_id = 18),
  [4629] = {.count = 1, .reusable = true}, SHIFT(145),
  [4631] = {.count = 1, .reusable = false}, SHIFT(2779),
  [4633] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2),
  [4635] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2),
  [4637] = {.count = 1, .reusable = false}, SHIFT(2781),
  [4639] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 28),
  [4641] = {.count = 1, .reusable = true}, SHIFT(1929),
  [4643] = {.count = 1, .reusable = true}, SHIFT(1934),
  [4645] = {.count = 1, .reusable = false}, SHIFT(1853),
  [4647] = {.count = 1, .reusable = true}, SHIFT(2468),
  [4649] = {.count = 1, .reusable = true}, SHIFT(1993),
  [4651] = {.count = 1, .reusable = true}, SHIFT(2038),
  [4653] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4655] = {.count = 1, .reusable = true}, SHIFT(2385),
  [4657] = {.count = 1, .reusable = true}, SHIFT(1955),
  [4659] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 56),
  [4661] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 56),
  [4663] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 25),
  [4665] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 25),
  [4667] = {.count = 1, .reusable = true}, SHIFT(1954),
  [4669] = {.count = 1, .reusable = true}, SHIFT(2543),
  [4671] = {.count = 1, .reusable = true}, SHIFT(308),
  [4673] = {.count = 1, .reusable = true}, SHIFT(309),
  [4675] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 59),
  [4677] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 59),
  [4679] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 17),
  [4681] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 17),
  [4683] = {.count = 1, .reusable = true}, SHIFT(1758),
  [4685] = {.count = 1, .reusable = false}, SHIFT(1688),
  [4687] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4689] = {.count = 1, .reusable = false}, SHIFT(1708),
  [4691] = {.count = 1, .reusable = false}, SHIFT(1741),
  [4693] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 168),
  [4695] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 168),
  [4697] = {.count = 1, .reusable = true}, SHIFT(1753),
  [4699] = {.count = 1, .reusable = true}, SHIFT(2004),
  [4701] = {.count = 1, .reusable = false}, SHIFT(1724),
  [4703] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 3, .production_id = 74),
  [4705] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 3, .production_id = 74),
  [4707] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4709] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4711] = {.count = 1, .reusable = true}, SHIFT(1739),
  [4713] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 9, .production_id = 181),
  [4715] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 9, .production_id = 181),
  [4717] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 105),
  [4719] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 105),
  [4721] = {.count = 1, .reusable = true}, SHIFT(1691),
  [4723] = {.count = 1, .reusable = true}, SHIFT(1696),
  [4725] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 177),
  [4727] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 177),
  [4729] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 176),
  [4731] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 176),
  [4733] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 169),
  [4735] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 169),
  [4737] = {.count = 1, .reusable = true}, SHIFT(1754),
  [4739] = {.count = 1, .reusable = true}, SHIFT(2021),
  [4741] = {.count = 1, .reusable = false}, SHIFT(1715),
  [4743] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 98),
  [4745] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 98),
  [4747] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 147),
  [4749] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 147),
  [4751] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 131),
  [4753] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 131),
  [4755] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 122),
  [4757] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 122),
  [4759] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 151),
  [4761] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 151),
  [4763] = {.count = 1, .reusable = true}, SHIFT(231),
  [4765] = {.count = 1, .reusable = true}, SHIFT(2026),
  [4767] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4769] = {.count = 1, .reusable = false}, SHIFT(1381),
  [4771] = {.count = 1, .reusable = false}, SHIFT(1736),
  [4773] = {.count = 1, .reusable = false}, SHIFT(1735),
  [4775] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4777] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4779] = {.count = 1, .reusable = true}, SHIFT(1759),
  [4781] = {.count = 1, .reusable = true}, SHIFT(1792),
  [4783] = {.count = 1, .reusable = false}, SHIFT(1645),
  [4785] = {.count = 1, .reusable = false}, SHIFT(1760),
  [4787] = {.count = 1, .reusable = false}, SHIFT(1686),
  [4789] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22),
  [4791] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22),
  [4793] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22), SHIFT_REPEAT(1781),
  [4796] = {.count = 1, .reusable = true}, SHIFT(539),
  [4798] = {.count = 1, .reusable = true}, SHIFT(2351),
  [4800] = {.count = 1, .reusable = true}, SHIFT(2249),
  [4802] = {.count = 1, .reusable = true}, SHIFT(2210),
  [4804] = {.count = 1, .reusable = true}, SHIFT(525),
  [4806] = {.count = 1, .reusable = true}, SHIFT(2140),
  [4808] = {.count = 1, .reusable = false}, SHIFT(1365),
  [4810] = {.count = 1, .reusable = true}, SHIFT(572),
  [4812] = {.count = 1, .reusable = true}, SHIFT(2261),
  [4814] = {.count = 1, .reusable = false}, SHIFT(1768),
  [4816] = {.count = 1, .reusable = true}, SHIFT(1774),
  [4818] = {.count = 1, .reusable = true}, SHIFT(1793),
  [4820] = {.count = 1, .reusable = false}, SHIFT(1647),
  [4822] = {.count = 1, .reusable = false}, SHIFT(1434),
  [4824] = {.count = 1, .reusable = true}, SHIFT(2131),
  [4826] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4828] = {.count = 1, .reusable = false}, SHIFT(1700),
  [4830] = {.count = 1, .reusable = false}, SHIFT(1578),
  [4832] = {.count = 1, .reusable = true}, SHIFT(1799),
  [4834] = {.count = 1, .reusable = false}, SHIFT(1651),
  [4836] = {.count = 1, .reusable = false}, SHIFT(1607),
  [4838] = {.count = 1, .reusable = true}, SHIFT(1800),
  [4840] = {.count = 1, .reusable = false}, SHIFT(1636),
  [4842] = {.count = 1, .reusable = false}, SHIFT(1557),
  [4844] = {.count = 1, .reusable = true}, SHIFT(1791),
  [4846] = {.count = 1, .reusable = false}, SHIFT(1635),
  [4848] = {.count = 1, .reusable = true}, SHIFT(1892),
  [4850] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [4852] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [4854] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4856] = {.count = 1, .reusable = false}, SHIFT(2081),
  [4858] = {.count = 1, .reusable = false}, SHIFT(2075),
  [4860] = {.count = 1, .reusable = false}, SHIFT(1780),
  [4862] = {.count = 1, .reusable = false}, SHIFT(2092),
  [4864] = {.count = 1, .reusable = false}, SHIFT(2095),
  [4866] = {.count = 1, .reusable = false}, SHIFT(1633),
  [4868] = {.count = 1, .reusable = false}, SHIFT(1630),
  [4870] = {.count = 1, .reusable = false}, SHIFT(2013),
  [4872] = {.count = 1, .reusable = false}, SHIFT(2029),
  [4874] = {.count = 1, .reusable = true}, SHIFT(743),
  [4876] = {.count = 1, .reusable = true}, SHIFT(2827),
  [4878] = {.count = 1, .reusable = true}, SHIFT(770),
  [4880] = {.count = 1, .reusable = true}, SHIFT(2792),
  [4882] = {.count = 1, .reusable = true}, SHIFT(377),
  [4884] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [4886] = {.count = 1, .reusable = true}, SHIFT(1811),
  [4888] = {.count = 1, .reusable = true}, SHIFT(1977),
  [4890] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 113),
  [4892] = {.count = 1, .reusable = true}, SHIFT(1808),
  [4894] = {.count = 1, .reusable = true}, SHIFT(1918),
  [4896] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 70),
  [4898] = {.count = 1, .reusable = true}, SHIFT(1812),
  [4900] = {.count = 1, .reusable = true}, SHIFT(1981),
  [4902] = {.count = 1, .reusable = true}, SHIFT(760),
  [4904] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14), REDUCE(sym_type_parameter, 1, .production_id = 14),
  [4907] = {.count = 1, .reusable = true}, SHIFT(694),
  [4909] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 142),
  [4911] = {.count = 1, .reusable = true}, SHIFT(1817),
  [4913] = {.count = 1, .reusable = true}, SHIFT(1941),
  [4915] = {.count = 1, .reusable = true}, SHIFT(1803),
  [4917] = {.count = 1, .reusable = true}, SHIFT(1816),
  [4919] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [4921] = {.count = 1, .reusable = true}, SHIFT(97),
  [4923] = {.count = 1, .reusable = true}, SHIFT(1823),
  [4925] = {.count = 1, .reusable = true}, SHIFT(1824),
  [4927] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 70),
  [4929] = {.count = 1, .reusable = true}, SHIFT(1818),
  [4931] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 113),
  [4933] = {.count = 1, .reusable = true}, SHIFT(1809),
  [4935] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 142),
  [4937] = {.count = 1, .reusable = true}, SHIFT(1804),
  [4939] = {.count = 1, .reusable = true}, SHIFT(1810),
  [4941] = {.count = 1, .reusable = true}, SHIFT(1820),
  [4943] = {.count = 1, .reusable = true}, SHIFT(1805),
  [4945] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 70),
  [4947] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 142),
  [4949] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 70),
  [4951] = {.count = 1, .reusable = true}, SHIFT(730),
  [4953] = {.count = 1, .reusable = true}, SHIFT(733),
  [4955] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 113),
  [4957] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 113),
  [4959] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [4961] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [4964] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 142),
  [4966] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [4968] = {.count = 1, .reusable = true}, SHIFT(2895),
  [4970] = {.count = 1, .reusable = false}, SHIFT(1894),
  [4972] = {.count = 1, .reusable = true}, SHIFT(1196),
  [4974] = {.count = 1, .reusable = false}, SHIFT(737),
  [4976] = {.count = 1, .reusable = false}, SHIFT(154),
  [4978] = {.count = 1, .reusable = false}, SHIFT(1896),
  [4980] = {.count = 1, .reusable = true}, SHIFT(1213),
  [4982] = {.count = 1, .reusable = true}, SHIFT(745),
  [4984] = {.count = 1, .reusable = false}, SHIFT(772),
  [4986] = {.count = 1, .reusable = true}, SHIFT(2483),
  [4988] = {.count = 1, .reusable = true}, SHIFT(2817),
  [4990] = {.count = 1, .reusable = false}, SHIFT(1881),
  [4992] = {.count = 1, .reusable = false}, SHIFT(1882),
  [4994] = {.count = 1, .reusable = false}, SHIFT(1884),
  [4996] = {.count = 1, .reusable = false}, SHIFT(1897),
  [4998] = {.count = 1, .reusable = true}, SHIFT(1187),
  [5000] = {.count = 1, .reusable = false}, SHIFT(1883),
  [5002] = {.count = 1, .reusable = false}, SHIFT(1893),
  [5004] = {.count = 1, .reusable = true}, SHIFT(684),
  [5006] = {.count = 1, .reusable = false}, SHIFT(1878),
  [5008] = {.count = 1, .reusable = false}, SHIFT(1887),
  [5010] = {.count = 1, .reusable = true}, SHIFT(737),
  [5012] = {.count = 1, .reusable = true}, SHIFT(154),
  [5014] = {.count = 1, .reusable = true}, SHIFT(1170),
  [5016] = {.count = 1, .reusable = true}, SHIFT(1192),
  [5018] = {.count = 1, .reusable = true}, REDUCE(sym_type_annotation, 2),
  [5020] = {.count = 1, .reusable = true}, SHIFT(1135),
  [5022] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [5025] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [5028] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21),
  [5030] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [5032] = {.count = 1, .reusable = true}, SHIFT(15),
  [5034] = {.count = 1, .reusable = true}, SHIFT(2811),
  [5036] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 8, .production_id = 182),
  [5038] = {.count = 1, .reusable = true}, SHIFT(2183),
  [5040] = {.count = 1, .reusable = true}, SHIFT(2047),
  [5042] = {.count = 1, .reusable = true}, SHIFT(1648),
  [5044] = {.count = 1, .reusable = true}, SHIFT(2166),
  [5046] = {.count = 1, .reusable = true}, SHIFT(2063),
  [5048] = {.count = 1, .reusable = true}, SHIFT(464),
  [5050] = {.count = 1, .reusable = true}, SHIFT(2813),
  [5052] = {.count = 1, .reusable = true}, SHIFT(2600),
  [5054] = {.count = 1, .reusable = true}, SHIFT(153),
  [5056] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 179),
  [5058] = {.count = 1, .reusable = true}, SHIFT(2161),
  [5060] = {.count = 1, .reusable = true}, SHIFT(2050),
  [5062] = {.count = 1, .reusable = false}, REDUCE(sym_type_annotation, 2),
  [5064] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 178),
  [5066] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 171),
  [5068] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 6, .production_id = 138),
  [5070] = {.count = 1, .reusable = true}, SHIFT(2230),
  [5072] = {.count = 1, .reusable = true}, SHIFT(1997),
  [5074] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 170),
  [5076] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 161),
  [5078] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 1, .production_id = 14),
  [5080] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 3),
  [5082] = {.count = 1, .reusable = false}, SHIFT(1930),
  [5084] = {.count = 1, .reusable = false}, SHIFT(2805),
  [5086] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 160),
  [5088] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 121),
  [5090] = {.count = 1, .reusable = true}, SHIFT(437),
  [5092] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3),
  [5094] = {.count = 1, .reusable = true}, SHIFT(1906),
  [5096] = {.count = 1, .reusable = true}, SHIFT(2788),
  [5098] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4),
  [5100] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 139),
  [5102] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 2, .production_id = 87),
  [5104] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 115),
  [5106] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 97),
  [5108] = {.count = 1, .reusable = true}, SHIFT(2113),
  [5110] = {.count = 1, .reusable = true}, SHIFT(2001),
  [5112] = {.count = 1, .reusable = false}, SHIFT(2860),
  [5114] = {.count = 1, .reusable = true}, SHIFT(2194),
  [5116] = {.count = 1, .reusable = true}, SHIFT(2000),
  [5118] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 2),
  [5120] = {.count = 1, .reusable = true}, SHIFT(2243),
  [5122] = {.count = 1, .reusable = true}, SHIFT(2043),
  [5124] = {.count = 1, .reusable = true}, SHIFT(2742),
  [5126] = {.count = 1, .reusable = true}, SHIFT(256),
  [5128] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1),
  [5130] = {.count = 1, .reusable = true}, SHIFT(2062),
  [5132] = {.count = 1, .reusable = true}, SHIFT(2172),
  [5134] = {.count = 1, .reusable = true}, SHIFT(2008),
  [5136] = {.count = 1, .reusable = true}, SHIFT(2252),
  [5138] = {.count = 1, .reusable = true}, SHIFT(2012),
  [5140] = {.count = 1, .reusable = true}, SHIFT(348),
  [5142] = {.count = 1, .reusable = true}, SHIFT(2127),
  [5144] = {.count = 1, .reusable = true}, SHIFT(2101),
  [5146] = {.count = 1, .reusable = true}, SHIFT(2060),
  [5148] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 5, .production_id = 110),
  [5150] = {.count = 1, .reusable = true}, SHIFT(2188),
  [5152] = {.count = 1, .reusable = true}, SHIFT(907),
  [5154] = {.count = 1, .reusable = true}, SHIFT(1282),
  [5156] = {.count = 1, .reusable = true}, SHIFT(2212),
  [5158] = {.count = 1, .reusable = true}, SHIFT(2003),
  [5160] = {.count = 1, .reusable = true}, SHIFT(1420),
  [5162] = {.count = 1, .reusable = true}, SHIFT(227),
  [5164] = {.count = 1, .reusable = true}, SHIFT(2111),
  [5166] = {.count = 1, .reusable = true}, SHIFT(1534),
  [5168] = {.count = 1, .reusable = true}, SHIFT(2165),
  [5170] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(2910),
  [5173] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [5175] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(186),
  [5178] = {.count = 1, .reusable = true}, SHIFT(1930),
  [5180] = {.count = 1, .reusable = true}, SHIFT(910),
  [5182] = {.count = 1, .reusable = true}, SHIFT(1837),
  [5184] = {.count = 1, .reusable = true}, SHIFT(2205),
  [5186] = {.count = 1, .reusable = true}, SHIFT(2268),
  [5188] = {.count = 1, .reusable = true}, SHIFT(911),
  [5190] = {.count = 1, .reusable = true}, SHIFT(996),
  [5192] = {.count = 1, .reusable = true}, SHIFT(2250),
  [5194] = {.count = 1, .reusable = true}, SHIFT(2178),
  [5196] = {.count = 1, .reusable = true}, SHIFT(2145),
  [5198] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(2003),
  [5201] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2),
  [5203] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(227),
  [5206] = {.count = 1, .reusable = true}, SHIFT(2079),
  [5208] = {.count = 1, .reusable = false}, SHIFT(2377),
  [5210] = {.count = 1, .reusable = true}, SHIFT(2787),
  [5212] = {.count = 1, .reusable = true}, SHIFT(2376),
  [5214] = {.count = 1, .reusable = false}, SHIFT(2800),
  [5216] = {.count = 1, .reusable = true}, SHIFT(915),
  [5218] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 20),
  [5220] = {.count = 1, .reusable = true}, SHIFT(2189),
  [5222] = {.count = 1, .reusable = true}, SHIFT(2237),
  [5224] = {.count = 1, .reusable = true}, SHIFT(2240),
  [5226] = {.count = 1, .reusable = true}, SHIFT(2781),
  [5228] = {.count = 1, .reusable = true}, SHIFT(2868),
  [5230] = {.count = 1, .reusable = true}, SHIFT(2869),
  [5232] = {.count = 1, .reusable = true}, SHIFT(906),
  [5234] = {.count = 1, .reusable = true}, SHIFT(914),
  [5236] = {.count = 1, .reusable = true}, SHIFT(438),
  [5238] = {.count = 1, .reusable = true}, SHIFT(1991),
  [5240] = {.count = 1, .reusable = true}, SHIFT(1510),
  [5242] = {.count = 1, .reusable = true}, SHIFT(2057),
  [5244] = {.count = 1, .reusable = true}, SHIFT(1013),
  [5246] = {.count = 1, .reusable = true}, SHIFT(2220),
  [5248] = {.count = 1, .reusable = true}, SHIFT(909),
  [5250] = {.count = 1, .reusable = true}, SHIFT(2211),
  [5252] = {.count = 1, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [5254] = {.count = 1, .reusable = true}, SHIFT(2779),
  [5256] = {.count = 1, .reusable = true}, SHIFT(902),
  [5258] = {.count = 1, .reusable = true}, SHIFT(908),
  [5260] = {.count = 1, .reusable = true}, SHIFT(2103),
  [5262] = {.count = 1, .reusable = true}, SHIFT(2207),
  [5264] = {.count = 1, .reusable = true}, SHIFT(2200),
  [5266] = {.count = 1, .reusable = true}, SHIFT(2162),
  [5268] = {.count = 1, .reusable = true}, SHIFT(2232),
  [5270] = {.count = 1, .reusable = true}, SHIFT(904),
  [5272] = {.count = 1, .reusable = true}, SHIFT(2196),
  [5274] = {.count = 1, .reusable = true}, SHIFT(2910),
  [5276] = {.count = 1, .reusable = true}, SHIFT(512),
  [5278] = {.count = 1, .reusable = true}, SHIFT(186),
  [5280] = {.count = 1, .reusable = true}, SHIFT(2238),
  [5282] = {.count = 1, .reusable = true}, SHIFT(723),
  [5284] = {.count = 1, .reusable = true}, SHIFT(2120),
  [5286] = {.count = 1, .reusable = true}, SHIFT(912),
  [5288] = {.count = 1, .reusable = true}, SHIFT(2193),
  [5290] = {.count = 1, .reusable = true}, SHIFT(1989),
  [5292] = {.count = 1, .reusable = true}, SHIFT(1489),
  [5294] = {.count = 1, .reusable = true}, SHIFT(2245),
  [5296] = {.count = 1, .reusable = true}, SHIFT(2227),
  [5298] = {.count = 1, .reusable = true}, SHIFT(905),
  [5300] = {.count = 1, .reusable = true}, SHIFT(2177),
  [5302] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(918),
  [5305] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2),
  [5307] = {.count = 1, .reusable = true}, SHIFT(2213),
  [5309] = {.count = 1, .reusable = true}, SHIFT(1039),
  [5311] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 3, .production_id = 65),
  [5313] = {.count = 1, .reusable = true}, SHIFT(916),
  [5315] = {.count = 1, .reusable = true}, SHIFT(1552),
  [5317] = {.count = 1, .reusable = true}, SHIFT(2160),
  [5319] = {.count = 1, .reusable = true}, SHIFT(903),
  [5321] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2),
  [5323] = {.count = 1, .reusable = true}, SHIFT(2184),
  [5325] = {.count = 1, .reusable = true}, SHIFT(582),
  [5327] = {.count = 1, .reusable = true}, SHIFT(2209),
  [5329] = {.count = 1, .reusable = true}, SHIFT(913),
  [5331] = {.count = 1, .reusable = true}, SHIFT(2118),
  [5333] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 34),
  [5335] = {.count = 1, .reusable = true}, SHIFT(17),
  [5337] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 18),
  [5339] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2),
  [5341] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 32),
  [5343] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 38),
  [5345] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 39),
  [5347] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 84),
  [5349] = {.count = 1, .reusable = true}, SHIFT(749),
  [5351] = {.count = 1, .reusable = true}, SHIFT(1550),
  [5353] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 83),
  [5355] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3),
  [5357] = {.count = 1, .reusable = true}, SHIFT(683),
  [5359] = {.count = 1, .reusable = true}, SHIFT(1556),
  [5361] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 82),
  [5363] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 30),
  [5365] = {.count = 1, .reusable = true}, SHIFT(2808),
  [5367] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 4),
  [5369] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 114),
  [5371] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 4),
  [5373] = {.count = 1, .reusable = true}, SHIFT(1122),
  [5375] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 140),
  [5377] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 141),
  [5379] = {.count = 1, .reusable = true}, REDUCE(sym_call_signature, 1, .production_id = 46),
  [5381] = {.count = 1, .reusable = true}, SHIFT(667),
  [5383] = {.count = 1, .reusable = true}, SHIFT(1387),
  [5385] = {.count = 1, .reusable = true}, SHIFT(1467),
  [5387] = {.count = 1, .reusable = true}, SHIFT(670),
  [5389] = {.count = 1, .reusable = true}, SHIFT(1105),
  [5391] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 116),
  [5393] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 3),
  [5395] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 114),
  [5397] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 172),
  [5399] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 5),
  [5401] = {.count = 1, .reusable = true}, SHIFT(1675),
  [5403] = {.count = 1, .reusable = true}, SHIFT(1847),
  [5405] = {.count = 1, .reusable = true}, SHIFT(2754),
  [5407] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 140),
  [5409] = {.count = 1, .reusable = true}, SHIFT(1678),
  [5411] = {.count = 1, .reusable = true}, SHIFT(1871),
  [5413] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 141),
  [5415] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 2),
  [5417] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 30),
  [5419] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 6, .production_id = 172),
  [5421] = {.count = 1, .reusable = true}, SHIFT(421),
  [5423] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6),
  [5425] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6, .production_id = 18),
  [5427] = {.count = 1, .reusable = true}, REDUCE(sym_constraint, 2),
  [5429] = {.count = 2, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(749),
  [5432] = {.count = 1, .reusable = true}, SHIFT(1839),
  [5434] = {.count = 1, .reusable = true}, SHIFT(1732),
  [5436] = {.count = 1, .reusable = true}, SHIFT(2185),
  [5438] = {.count = 1, .reusable = true}, SHIFT(2919),
  [5440] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 4),
  [5442] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22), SHIFT_REPEAT(1782),
  [5445] = {.count = 1, .reusable = true}, SHIFT(2206),
  [5447] = {.count = 1, .reusable = true}, SHIFT(686),
  [5449] = {.count = 1, .reusable = true}, SHIFT(1841),
  [5451] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 30),
  [5453] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 163),
  [5455] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 116),
  [5457] = {.count = 1, .reusable = true}, SHIFT(2151),
  [5459] = {.count = 1, .reusable = true}, SHIFT(2147),
  [5461] = {.count = 1, .reusable = true}, SHIFT(2134),
  [5463] = {.count = 1, .reusable = true}, SHIFT(685),
  [5465] = {.count = 1, .reusable = true}, SHIFT(418),
  [5467] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5469] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 162),
  [5471] = {.count = 1, .reusable = true}, SHIFT(1729),
  [5473] = {.count = 1, .reusable = true}, SHIFT(567),
  [5475] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 162),
  [5477] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 163),
  [5479] = {.count = 1, .reusable = true}, SHIFT(2509),
  [5481] = {.count = 1, .reusable = true}, SHIFT(2412),
  [5483] = {.count = 1, .reusable = true}, SHIFT(576),
  [5485] = {.count = 1, .reusable = true}, SHIFT(586),
  [5487] = {.count = 1, .reusable = true}, SHIFT(772),
  [5489] = {.count = 1, .reusable = true}, SHIFT(2039),
  [5491] = {.count = 1, .reusable = true}, SHIFT(508),
  [5493] = {.count = 1, .reusable = false}, SHIFT(1533),
  [5495] = {.count = 1, .reusable = true}, SHIFT(2315),
  [5497] = {.count = 1, .reusable = false}, SHIFT(2315),
  [5499] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [5501] = {.count = 1, .reusable = true}, SHIFT(2317),
  [5503] = {.count = 1, .reusable = false}, SHIFT(2317),
  [5505] = {.count = 1, .reusable = false}, SHIFT(113),
  [5507] = {.count = 1, .reusable = true}, SHIFT(2782),
  [5509] = {.count = 1, .reusable = true}, SHIFT(1835),
  [5511] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3),
  [5513] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2),
  [5515] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3),
  [5517] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3),
  [5519] = {.count = 1, .reusable = false}, SHIFT(1537),
  [5521] = {.count = 1, .reusable = true}, SHIFT(2273),
  [5523] = {.count = 1, .reusable = false}, SHIFT(2273),
  [5525] = {.count = 1, .reusable = true}, SHIFT(570),
  [5527] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3, .production_id = 47),
  [5529] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3, .production_id = 47),
  [5531] = {.count = 1, .reusable = false}, SHIFT(1785),
  [5533] = {.count = 1, .reusable = false}, SHIFT(938),
  [5535] = {.count = 1, .reusable = true}, SHIFT(2322),
  [5537] = {.count = 1, .reusable = false}, SHIFT(2322),
  [5539] = {.count = 1, .reusable = false}, SHIFT(928),
  [5541] = {.count = 1, .reusable = true}, SHIFT(2336),
  [5543] = {.count = 1, .reusable = false}, SHIFT(2336),
  [5545] = {.count = 1, .reusable = true}, SHIFT(2337),
  [5547] = {.count = 1, .reusable = false}, SHIFT(2337),
  [5549] = {.count = 1, .reusable = true}, REDUCE(sym_template_substitution, 3),
  [5551] = {.count = 1, .reusable = false}, SHIFT(1784),
  [5553] = {.count = 1, .reusable = true}, SHIFT(2288),
  [5555] = {.count = 1, .reusable = false}, SHIFT(2288),
  [5557] = {.count = 1, .reusable = true}, SHIFT(573),
  [5559] = {.count = 1, .reusable = true}, SHIFT(26),
  [5561] = {.count = 1, .reusable = true}, SHIFT(2289),
  [5563] = {.count = 1, .reusable = false}, SHIFT(2289),
  [5565] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(146),
  [5568] = {.count = 1, .reusable = true}, SHIFT(1853),
  [5570] = {.count = 1, .reusable = true}, SHIFT(2323),
  [5572] = {.count = 1, .reusable = false}, SHIFT(2323),
  [5574] = {.count = 1, .reusable = true}, SHIFT(2221),
  [5576] = {.count = 1, .reusable = true}, SHIFT(553),
  [5578] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5580] = {.count = 1, .reusable = false}, SHIFT(408),
  [5582] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(157),
  [5585] = {.count = 1, .reusable = true}, SHIFT(562),
  [5587] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2),
  [5589] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2315),
  [5592] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2315),
  [5595] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2039),
  [5598] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [5600] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [5602] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2317),
  [5605] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2317),
  [5608] = {.count = 1, .reusable = true}, SHIFT(1676),
  [5610] = {.count = 1, .reusable = false}, SHIFT(407),
  [5612] = {.count = 1, .reusable = true}, SHIFT(2311),
  [5614] = {.count = 1, .reusable = false}, SHIFT(2311),
  [5616] = {.count = 1, .reusable = true}, SHIFT(2312),
  [5618] = {.count = 1, .reusable = false}, SHIFT(2312),
  [5620] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 2),
  [5622] = {.count = 1, .reusable = false}, SHIFT(934),
  [5624] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 2, .production_id = 14),
  [5626] = {.count = 1, .reusable = true}, SHIFT(534),
  [5628] = {.count = 1, .reusable = true}, SHIFT(2167),
  [5630] = {.count = 1, .reusable = true}, SHIFT(2807),
  [5632] = {.count = 1, .reusable = true}, SHIFT(535),
  [5634] = {.count = 1, .reusable = true}, SHIFT(1857),
  [5636] = {.count = 1, .reusable = true}, SHIFT(167),
  [5638] = {.count = 1, .reusable = false}, SHIFT(926),
  [5640] = {.count = 1, .reusable = true}, SHIFT(2089),
  [5642] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(155),
  [5645] = {.count = 1, .reusable = true}, SHIFT(2076),
  [5647] = {.count = 1, .reusable = true}, SHIFT(2074),
  [5649] = {.count = 1, .reusable = false}, SHIFT(111),
  [5651] = {.count = 1, .reusable = true}, SHIFT(2276),
  [5653] = {.count = 1, .reusable = false}, SHIFT(2276),
  [5655] = {.count = 1, .reusable = true}, REDUCE(sym_default_type, 2),
  [5657] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [5659] = {.count = 1, .reusable = true}, SHIFT(2090),
  [5661] = {.count = 1, .reusable = true}, SHIFT(2810),
  [5663] = {.count = 1, .reusable = true}, SHIFT(2274),
  [5665] = {.count = 1, .reusable = false}, SHIFT(2274),
  [5667] = {.count = 1, .reusable = true}, SHIFT(2264),
  [5669] = {.count = 1, .reusable = true}, SHIFT(2275),
  [5671] = {.count = 1, .reusable = false}, SHIFT(2275),
  [5673] = {.count = 1, .reusable = true}, SHIFT(2216),
  [5675] = {.count = 1, .reusable = true}, SHIFT(1658),
  [5677] = {.count = 1, .reusable = true}, SHIFT(1953),
  [5679] = {.count = 1, .reusable = true}, SHIFT(662),
  [5681] = {.count = 1, .reusable = true}, SHIFT(1436),
  [5683] = {.count = 2, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(2272),
  [5686] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [5688] = {.count = 1, .reusable = true}, SHIFT(1435),
  [5690] = {.count = 1, .reusable = true}, SHIFT(433),
  [5692] = {.count = 1, .reusable = true}, SHIFT(712),
  [5694] = {.count = 1, .reusable = true}, SHIFT(1838),
  [5696] = {.count = 1, .reusable = true}, SHIFT(927),
  [5698] = {.count = 1, .reusable = true}, SHIFT(1053),
  [5700] = {.count = 1, .reusable = true}, SHIFT(678),
  [5702] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 2),
  [5704] = {.count = 1, .reusable = true}, SHIFT(2776),
  [5706] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [5708] = {.count = 1, .reusable = true}, SHIFT(1944),
  [5710] = {.count = 1, .reusable = true}, SHIFT(2426),
  [5712] = {.count = 1, .reusable = true}, SHIFT(1481),
  [5714] = {.count = 1, .reusable = true}, SHIFT(1484),
  [5716] = {.count = 1, .reusable = true}, SHIFT(2267),
  [5718] = {.count = 1, .reusable = true}, SHIFT(2511),
  [5720] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(697),
  [5723] = {.count = 1, .reusable = true}, SHIFT(1641),
  [5725] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 146),
  [5727] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 139),
  [5729] = {.count = 1, .reusable = true}, SHIFT(1875),
  [5731] = {.count = 1, .reusable = true}, SHIFT(1014),
  [5733] = {.count = 1, .reusable = true}, SHIFT(2222),
  [5735] = {.count = 1, .reusable = true}, SHIFT(1833),
  [5737] = {.count = 1, .reusable = true}, SHIFT(1679),
  [5739] = {.count = 1, .reusable = true}, SHIFT(933),
  [5741] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3),
  [5743] = {.count = 1, .reusable = true}, SHIFT(1438),
  [5745] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 121),
  [5747] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(746),
  [5750] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 145),
  [5752] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 164),
  [5754] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 3),
  [5756] = {.count = 1, .reusable = true}, SHIFT(424),
  [5758] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 144),
  [5760] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 173),
  [5762] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 174),
  [5764] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 143),
  [5766] = {.count = 1, .reusable = true}, SHIFT(2487),
  [5768] = {.count = 1, .reusable = true}, SHIFT(2291),
  [5770] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 1),
  [5772] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 161),
  [5774] = {.count = 1, .reusable = true}, SHIFT(2214),
  [5776] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 118),
  [5778] = {.count = 1, .reusable = true}, SHIFT(757),
  [5780] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 175),
  [5782] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 117),
  [5784] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 3, .production_id = 97),
  [5786] = {.count = 1, .reusable = true}, SHIFT(2432),
  [5788] = {.count = 1, .reusable = true}, SHIFT(2215),
  [5790] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 5),
  [5792] = {.count = 1, .reusable = true}, SHIFT(680),
  [5794] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(1745),
  [5797] = {.count = 1, .reusable = true}, SHIFT(584),
  [5799] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 6, .production_id = 170),
  [5801] = {.count = 1, .reusable = true}, SHIFT(2148),
  [5803] = {.count = 1, .reusable = true}, SHIFT(2441),
  [5805] = {.count = 1, .reusable = true}, SHIFT(2404),
  [5807] = {.count = 1, .reusable = true}, SHIFT(1829),
  [5809] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 77),
  [5811] = {.count = 1, .reusable = true}, SHIFT(2378),
  [5813] = {.count = 1, .reusable = true}, SHIFT(2470),
  [5815] = {.count = 1, .reusable = true}, SHIFT(440),
  [5817] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(2623),
  [5820] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [5822] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 77),
  [5824] = {.count = 1, .reusable = true}, SHIFT(1012),
  [5826] = {.count = 1, .reusable = true}, SHIFT(1110),
  [5828] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(1235),
  [5831] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2),
  [5833] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 29),
  [5835] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 78),
  [5837] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 3),
  [5839] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 167),
  [5841] = {.count = 1, .reusable = true}, SHIFT(1449),
  [5843] = {.count = 1, .reusable = true}, SHIFT(1466),
  [5845] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 79),
  [5847] = {.count = 1, .reusable = true}, SHIFT(945),
  [5849] = {.count = 1, .reusable = true}, SHIFT(1383),
  [5851] = {.count = 1, .reusable = true}, SHIFT(1653),
  [5853] = {.count = 1, .reusable = true}, SHIFT(1643),
  [5855] = {.count = 1, .reusable = true}, SHIFT(2521),
  [5857] = {.count = 1, .reusable = true}, SHIFT(1123),
  [5859] = {.count = 1, .reusable = true}, SHIFT(1731),
  [5861] = {.count = 1, .reusable = true}, SHIFT(1738),
  [5863] = {.count = 1, .reusable = true}, SHIFT(1626),
  [5865] = {.count = 1, .reusable = true}, SHIFT(674),
  [5867] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(739),
  [5870] = {.count = 1, .reusable = true}, SHIFT(944),
  [5872] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 4),
  [5874] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 1),
  [5876] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 5, .production_id = 71),
  [5878] = {.count = 1, .reusable = true}, SHIFT(1077),
  [5880] = {.count = 1, .reusable = true}, REDUCE(sym_mapped_type_clause, 3, .production_id = 14),
  [5882] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 160),
  [5884] = {.count = 1, .reusable = true}, SHIFT(1074),
  [5886] = {.count = 1, .reusable = true}, SHIFT(2153),
  [5888] = {.count = 1, .reusable = true}, SHIFT(2879),
  [5890] = {.count = 1, .reusable = true}, SHIFT(1579),
  [5892] = {.count = 1, .reusable = true}, SHIFT(2425),
  [5894] = {.count = 1, .reusable = true}, SHIFT(2142),
  [5896] = {.count = 1, .reusable = true}, SHIFT(2886),
  [5898] = {.count = 1, .reusable = true}, SHIFT(943),
  [5900] = {.count = 1, .reusable = true}, SHIFT(1016),
  [5902] = {.count = 1, .reusable = false}, SHIFT(2430),
  [5904] = {.count = 1, .reusable = false}, SHIFT(2892),
  [5906] = {.count = 1, .reusable = true}, SHIFT(2099),
  [5908] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(689),
  [5911] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(736),
  [5914] = {.count = 1, .reusable = true}, SHIFT(1657),
  [5916] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 166),
  [5918] = {.count = 1, .reusable = true}, SHIFT(1446),
  [5920] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 29),
  [5922] = {.count = 1, .reusable = true}, SHIFT(1560),
  [5924] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 7, .production_id = 180),
  [5926] = {.count = 2, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(1668),
  [5929] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 22),
  [5931] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 165),
  [5933] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(2302),
  [5936] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [5938] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 31),
  [5940] = {.count = 1, .reusable = true}, SHIFT(1551),
  [5942] = {.count = 1, .reusable = true}, SHIFT(2731),
  [5944] = {.count = 1, .reusable = true}, SHIFT(554),
  [5946] = {.count = 1, .reusable = true}, SHIFT(414),
  [5948] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 4, .production_id = 71),
  [5950] = {.count = 1, .reusable = true}, SHIFT(2259),
  [5952] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3, .production_id = 71),
  [5954] = {.count = 1, .reusable = true}, SHIFT(664),
  [5956] = {.count = 1, .reusable = true}, SHIFT(2734),
  [5958] = {.count = 1, .reusable = true}, SHIFT(551),
  [5960] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(725),
  [5963] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(768),
  [5966] = {.count = 1, .reusable = true}, SHIFT(1542),
  [5968] = {.count = 1, .reusable = true}, SHIFT(1540),
  [5970] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(752),
  [5973] = {.count = 1, .reusable = true}, SHIFT(132),
  [5975] = {.count = 1, .reusable = true}, SHIFT(2665),
  [5977] = {.count = 1, .reusable = true}, SHIFT(134),
  [5979] = {.count = 1, .reusable = true}, SHIFT(2594),
  [5981] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 33),
  [5983] = {.count = 1, .reusable = true}, SHIFT(2750),
  [5985] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 2, .production_id = 70),
  [5987] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .production_id = 40),
  [5989] = {.count = 1, .reusable = true}, SHIFT(2137),
  [5991] = {.count = 1, .reusable = true}, SHIFT(2948),
  [5993] = {.count = 1, .reusable = true}, SHIFT(2139),
  [5995] = {.count = 1, .reusable = true}, SHIFT(2947),
  [5997] = {.count = 1, .reusable = true}, SHIFT(194),
  [5999] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 85),
  [6001] = {.count = 1, .reusable = true}, SHIFT(1730),
  [6003] = {.count = 1, .reusable = true}, SHIFT(558),
  [6005] = {.count = 1, .reusable = true}, SHIFT(1373),
  [6007] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [6009] = {.count = 1, .reusable = true}, SHIFT(578),
  [6011] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 3),
  [6013] = {.count = 1, .reusable = true}, SHIFT(1734),
  [6015] = {.count = 1, .reusable = true}, SHIFT(2180),
  [6017] = {.count = 1, .reusable = true}, SHIFT(2950),
  [6019] = {.count = 1, .reusable = true}, SHIFT(585),
  [6021] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 85),
  [6023] = {.count = 1, .reusable = true}, SHIFT(2158),
  [6025] = {.count = 1, .reusable = true}, SHIFT(2949),
  [6027] = {.count = 1, .reusable = true}, SHIFT(1566),
  [6029] = {.count = 1, .reusable = true}, SHIFT(168),
  [6031] = {.count = 1, .reusable = true}, SHIFT(507),
  [6033] = {.count = 1, .reusable = true}, SHIFT(2236),
  [6035] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 4, .production_id = 130),
  [6037] = {.count = 1, .reusable = true}, SHIFT(158),
  [6039] = {.count = 1, .reusable = true}, REDUCE(sym_enum_assignment, 2, .production_id = 40),
  [6041] = {.count = 1, .reusable = true}, SHIFT(2179),
  [6043] = {.count = 1, .reusable = true}, SHIFT(2786),
  [6045] = {.count = 1, .reusable = true}, SHIFT(1061),
  [6047] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 3, .production_id = 14),
  [6049] = {.count = 1, .reusable = true}, SHIFT(16),
  [6051] = {.count = 1, .reusable = true}, SHIFT(41),
  [6053] = {.count = 1, .reusable = true}, SHIFT(536),
  [6055] = {.count = 1, .reusable = true}, SHIFT(2393),
  [6057] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 111),
  [6059] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 3, .production_id = 109),
  [6061] = {.count = 1, .reusable = true}, SHIFT(2247),
  [6063] = {.count = 1, .reusable = true}, SHIFT(2783),
  [6065] = {.count = 1, .reusable = true}, SHIFT(2042),
  [6067] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 75),
  [6069] = {.count = 1, .reusable = true}, REDUCE(sym_import_require_clause, 6),
  [6071] = {.count = 1, .reusable = true}, SHIFT(1832),
  [6073] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 71),
  [6075] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 3, .production_id = 104),
  [6077] = {.count = 1, .reusable = true}, SHIFT(410),
  [6079] = {.count = 1, .reusable = true}, SHIFT(515),
  [6081] = {.count = 1, .reusable = true}, REDUCE(sym__from_clause, 2, .production_id = 67),
  [6083] = {.count = 1, .reusable = true}, SHIFT(581),
  [6085] = {.count = 1, .reusable = true}, SHIFT(517),
  [6087] = {.count = 1, .reusable = true}, SHIFT(2430),
  [6089] = {.count = 1, .reusable = true}, SHIFT(880),
  [6091] = {.count = 1, .reusable = true}, SHIFT(179),
  [6093] = {.count = 1, .reusable = true}, SHIFT(2784),
  [6095] = {.count = 1, .reusable = true}, SHIFT(725),
  [6097] = {.count = 1, .reusable = true}, SHIFT(1425),
  [6099] = {.count = 1, .reusable = true}, SHIFT(238),
  [6101] = {.count = 1, .reusable = true}, SHIFT(236),
  [6103] = {.count = 1, .reusable = true}, SHIFT(435),
  [6105] = {.count = 1, .reusable = true}, SHIFT(2593),
  [6107] = {.count = 1, .reusable = true}, SHIFT(223),
  [6109] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 4, .production_id = 75),
  [6111] = {.count = 1, .reusable = true}, SHIFT(239),
  [6113] = {.count = 1, .reusable = true}, SHIFT(222),
  [6115] = {.count = 1, .reusable = true}, SHIFT(221),
  [6117] = {.count = 1, .reusable = true}, SHIFT(220),
  [6119] = {.count = 1, .reusable = true}, SHIFT(219),
  [6121] = {.count = 1, .reusable = true}, SHIFT(1526),
  [6123] = {.count = 1, .reusable = true}, SHIFT(806),
  [6125] = {.count = 1, .reusable = true}, SHIFT(702),
  [6127] = {.count = 1, .reusable = true}, SHIFT(711),
  [6129] = {.count = 1, .reusable = true}, SHIFT(717),
  [6131] = {.count = 1, .reusable = true}, SHIFT(718),
  [6133] = {.count = 1, .reusable = true}, SHIFT(872),
  [6135] = {.count = 1, .reusable = false}, SHIFT(2774),
  [6137] = {.count = 1, .reusable = true}, SHIFT(1895),
  [6139] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 2),
  [6141] = {.count = 1, .reusable = false}, SHIFT(1321),
  [6143] = {.count = 1, .reusable = false}, SHIFT(1443),
  [6145] = {.count = 1, .reusable = true}, SHIFT(2577),
  [6147] = {.count = 1, .reusable = true}, SHIFT(2720),
  [6149] = {.count = 1, .reusable = true}, SHIFT(746),
  [6151] = {.count = 1, .reusable = true}, SHIFT(1665),
  [6153] = {.count = 1, .reusable = true}, SHIFT(1868),
  [6155] = {.count = 1, .reusable = true}, SHIFT(1659),
  [6157] = {.count = 1, .reusable = true}, SHIFT(1890),
  [6159] = {.count = 1, .reusable = true}, SHIFT(2255),
  [6161] = {.count = 1, .reusable = true}, SHIFT(692),
  [6163] = {.count = 1, .reusable = true}, SHIFT(1898),
  [6165] = {.count = 1, .reusable = true}, SHIFT(2246),
  [6167] = {.count = 1, .reusable = true}, SHIFT(2397),
  [6169] = {.count = 1, .reusable = true}, SHIFT(2818),
  [6171] = {.count = 1, .reusable = true}, SHIFT(656),
  [6173] = {.count = 1, .reusable = true}, SHIFT(736),
  [6175] = {.count = 1, .reusable = true}, SHIFT(1806),
  [6177] = {.count = 1, .reusable = true}, SHIFT(668),
  [6179] = {.count = 1, .reusable = true}, SHIFT(870),
  [6181] = {.count = 1, .reusable = true}, SHIFT(689),
  [6183] = {.count = 1, .reusable = true}, SHIFT(2527),
  [6185] = {.count = 1, .reusable = true}, SHIFT(2321),
  [6187] = {.count = 1, .reusable = true}, SHIFT(2552),
  [6189] = {.count = 1, .reusable = true}, SHIFT(2737),
  [6191] = {.count = 1, .reusable = true}, SHIFT(1880),
  [6193] = {.count = 1, .reusable = true}, SHIFT(2579),
  [6195] = {.count = 1, .reusable = true}, SHIFT(2580),
  [6197] = {.count = 1, .reusable = true}, SHIFT(1886),
  [6199] = {.count = 1, .reusable = true}, SHIFT(104),
  [6201] = {.count = 1, .reusable = true}, SHIFT(2822),
  [6203] = {.count = 1, .reusable = true}, SHIFT(2582),
  [6205] = {.count = 1, .reusable = true}, SHIFT(697),
  [6207] = {.count = 1, .reusable = true}, SHIFT(679),
  [6209] = {.count = 1, .reusable = true}, SHIFT(2865),
  [6211] = {.count = 1, .reusable = true}, SHIFT(698),
  [6213] = {.count = 1, .reusable = true}, SHIFT(2254),
  [6215] = {.count = 1, .reusable = true}, SHIFT(734),
  [6217] = {.count = 1, .reusable = true}, SHIFT(2589),
  [6219] = {.count = 1, .reusable = true}, SHIFT(688),
  [6221] = {.count = 1, .reusable = true}, SHIFT(895),
  [6223] = {.count = 1, .reusable = true}, SHIFT(351),
  [6225] = {.count = 1, .reusable = true}, SHIFT(352),
  [6227] = {.count = 1, .reusable = true}, SHIFT(768),
  [6229] = {.count = 1, .reusable = true}, SHIFT(409),
  [6231] = {.count = 1, .reusable = true}, SHIFT(1889),
  [6233] = {.count = 1, .reusable = true}, SHIFT(847),
  [6235] = {.count = 1, .reusable = true}, SHIFT(752),
  [6237] = {.count = 1, .reusable = true}, SHIFT(230),
  [6239] = {.count = 1, .reusable = true}, SHIFT(232),
  [6241] = {.count = 1, .reusable = true}, SHIFT(204),
  [6243] = {.count = 1, .reusable = true}, SHIFT(234),
  [6245] = {.count = 1, .reusable = true}, SHIFT(769),
  [6247] = {.count = 1, .reusable = false}, SHIFT(2842),
  [6249] = {.count = 1, .reusable = true}, SHIFT(228),
  [6251] = {.count = 1, .reusable = true}, SHIFT(1098),
  [6253] = {.count = 1, .reusable = true}, SHIFT(744),
  [6255] = {.count = 1, .reusable = false}, SHIFT(1404),
  [6257] = {.count = 1, .reusable = true}, SHIFT(761),
  [6259] = {.count = 1, .reusable = true}, SHIFT(651),
  [6261] = {.count = 1, .reusable = true}, SHIFT(1131),
  [6263] = {.count = 1, .reusable = true}, SHIFT(855),
  [6265] = {.count = 1, .reusable = true}, SHIFT(2662),
  [6267] = {.count = 1, .reusable = true}, SHIFT(739),
  [6269] = {.count = 1, .reusable = true}, SHIFT(2819),
  [6271] = {.count = 1, .reusable = true}, SHIFT(1086),
  [6273] = {.count = 1, .reusable = true}, SHIFT(1891),
  [6275] = {.count = 1, .reusable = true}, SHIFT(811),
  [6277] = {.count = 1, .reusable = true}, SHIFT(765),
  [6279] = {.count = 1, .reusable = true}, SHIFT(1116),
  [6281] = {.count = 1, .reusable = true}, SHIFT(776),
  [6283] = {.count = 1, .reusable = true}, SHIFT(848),
  [6285] = {.count = 1, .reusable = true}, SHIFT(2711),
  [6287] = {.count = 1, .reusable = true}, SHIFT(2550),
  [6289] = {.count = 1, .reusable = true}, SHIFT(2806),
  [6291] = {.count = 1, .reusable = true}, SHIFT(2371),
  [6293] = {.count = 1, .reusable = true}, SHIFT(738),
  [6295] = {.count = 1, .reusable = true}, SHIFT(894),
  [6297] = {.count = 1, .reusable = true}, SHIFT(2872),
  [6299] = {.count = 1, .reusable = true}, SHIFT(2896),
  [6301] = {.count = 1, .reusable = true}, SHIFT(2709),
  [6303] = {.count = 1, .reusable = true}, SHIFT(2873),
  [6305] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 2),
  [6307] = {.count = 1, .reusable = true}, SHIFT(2828),
  [6309] = {.count = 1, .reusable = true}, SHIFT(858),
  [6311] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_import, 3),
  [6313] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3),
  [6315] = {.count = 1, .reusable = true}, SHIFT(182),
  [6317] = {.count = 1, .reusable = true}, SHIFT(2639),
  [6319] = {.count = 1, .reusable = true}, SHIFT(1885),
  [6321] = {.count = 1, .reusable = true}, SHIFT(2821),
  [6323] = {.count = 1, .reusable = true}, SHIFT(1562),
  [6325] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3, .production_id = 75),
  [6327] = {.count = 1, .reusable = true}, SHIFT(2544),
  [6329] = {.count = 1, .reusable = false}, SHIFT(1138),
  [6331] = {.count = 1, .reusable = true}, SHIFT(185),
  [6333] = {.count = 1, .reusable = true}, SHIFT(187),
  [6335] = {.count = 1, .reusable = true}, SHIFT(191),
  [6337] = {.count = 1, .reusable = true}, SHIFT(2892),
  [6339] = {.count = 1, .reusable = true}, SHIFT(1916),
  [6341] = {.count = 1, .reusable = true}, SHIFT(1877),
  [6343] = {.count = 1, .reusable = true}, SHIFT(780),
  [6345] = {.count = 1, .reusable = true}, SHIFT(2655),
  [6347] = {.count = 1, .reusable = true}, SHIFT(2367),
  [6349] = {.count = 1, .reusable = true}, SHIFT(775),
  [6351] = {.count = 1, .reusable = true}, SHIFT(203),
  [6353] = {.count = 1, .reusable = true}, SHIFT(1830),
  [6355] = {.count = 1, .reusable = true}, SHIFT(2733),
  [6357] = {.count = 1, .reusable = false}, SHIFT(2881),
  [6359] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 3),
  [6361] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [6363] = {.count = 1, .reusable = true}, SHIFT(2698),
  [6365] = {.count = 1, .reusable = true}, SHIFT(1956),
  [6367] = {.count = 1, .reusable = true}, SHIFT(2785),
  [6369] = {.count = 1, .reusable = true}, SHIFT(2704),
  [6371] = {.count = 1, .reusable = true}, SHIFT(879),
  [6373] = {.count = 1, .reusable = true}, SHIFT(762),
  [6375] = {.count = 1, .reusable = true}, SHIFT(1469),
  [6377] = {.count = 1, .reusable = true}, SHIFT(771),
  [6379] = {.count = 1, .reusable = true}, SHIFT(10),
  [6381] = {.count = 1, .reusable = true}, SHIFT(750),
  [6383] = {.count = 1, .reusable = true}, SHIFT(1380),
  [6385] = {.count = 1, .reusable = true}, SHIFT(601),
  [6387] = {.count = 1, .reusable = true}, SHIFT(810),
  [6389] = {.count = 1, .reusable = true}, SHIFT(867),
  [6391] = {.count = 1, .reusable = true}, SHIFT(874),
  [6393] = {.count = 1, .reusable = true}, SHIFT(799),
  [6395] = {.count = 1, .reusable = true}, SHIFT(871),
  [6397] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 5, .production_id = 75),
  [6399] = {.count = 1, .reusable = true}, SHIFT(411),
  [6401] = {.count = 1, .reusable = true}, SHIFT(859),
  [6403] = {.count = 1, .reusable = true}, SHIFT(2546),
  [6405] = {.count = 1, .reusable = true}, SHIFT(865),
  [6407] = {.count = 1, .reusable = false}, SHIFT(2772),
  [6409] = {.count = 1, .reusable = true}, SHIFT(779),
  [6411] = {.count = 1, .reusable = true}, SHIFT(781),
  [6413] = {.count = 1, .reusable = true}, SHIFT(1525),
  [6415] = {.count = 1, .reusable = true}, SHIFT(782),
  [6417] = {.count = 1, .reusable = true}, SHIFT(1527),
  [6419] = {.count = 1, .reusable = true}, SHIFT(790),
  [6421] = {.count = 1, .reusable = true}, SHIFT(819),
  [6423] = {.count = 1, .reusable = true}, SHIFT(641),
  [6425] = {.count = 1, .reusable = true}, SHIFT(1034),
  [6427] = {.count = 1, .reusable = true}, SHIFT(864),
  [6429] = {.count = 1, .reusable = true}, SHIFT(205),
  [6431] = {.count = 1, .reusable = true}, SHIFT(866),
  [6433] = {.count = 1, .reusable = true}, SHIFT(2888),
  [6435] = {.count = 1, .reusable = true}, SHIFT(2418),
  [6437] = {.count = 1, .reusable = true}, SHIFT(2890),
  [6439] = {.count = 1, .reusable = true}, SHIFT(2567),
  [6441] = {.count = 1, .reusable = true}, SHIFT(764),
  [6443] = {.count = 1, .reusable = true}, SHIFT(170),
  [6445] = {.count = 1, .reusable = true}, SHIFT(172),
  [6447] = {.count = 1, .reusable = true}, SHIFT(753),
  [6449] = {.count = 1, .reusable = true}, SHIFT(2136),
  [6451] = {.count = 1, .reusable = true}, SHIFT(2123),
  [6453] = {.count = 1, .reusable = true}, SHIFT(2083),
  [6455] = {.count = 1, .reusable = true}, SHIFT(2080),
  [6457] = {.count = 1, .reusable = true}, SHIFT(2530),
};

void *tree_sitter_typescript_external_scanner_create(void);
void tree_sitter_typescript_external_scanner_destroy(void *);
bool tree_sitter_typescript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_typescript_external_scanner_serialize(void *, char *);
void tree_sitter_typescript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_typescript(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_typescript_external_scanner_create,
      tree_sitter_typescript_external_scanner_destroy,
      tree_sitter_typescript_external_scanner_scan,
      tree_sitter_typescript_external_scanner_serialize,
      tree_sitter_typescript_external_scanner_deserialize,
    },
  };
  return &language;
}
